define(["require","exports","vs/base/common/functional","vs/base/common/iterator"],function(P,i,h,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.disposeOnReturn=i.ImmortalReference=i.AsyncReferenceCollection=i.ReferenceCollection=i.SafeDisposable=i.RefCountedDisposable=i.MutableDisposable=i.Disposable=i.DisposableStore=i.toDisposable=i.combinedDisposable=i.dispose=i.isDisposable=i.MultiDisposeError=i.markAsSingleton=i.setDisposableTracker=void 0;const m=!1;let n=null;function p(s){n=s}if(i.setDisposableTracker=p,m){const s="__is_disposable_tracked__";p(new class{trackDisposable(e){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{e[s]||console.log(t)},3e3)}setParent(e,t){if(e&&e!==u.None)try{e[s]=!0}catch{}}markAsDisposed(e){if(e&&e!==u.None)try{e[s]=!0}catch{}}markAsSingleton(e){}})}function a(s){return n?.trackDisposable(s),s}function c(s){n?.markAsDisposed(s)}function l(s,e){n?.setParent(s,e)}function S(s,e){if(!!n)for(const t of s)n.setParent(t,e)}function k(s){return n?.markAsSingleton(s),s}i.markAsSingleton=k;class b extends Error{constructor(e){super(`Encountered errors while disposing of store. Errors: [${e.join(", ")}]`);this.errors=e}}i.MultiDisposeError=b;function A(s){return typeof s.dispose=="function"&&s.dispose.length===0}i.isDisposable=A;function f(s){if(_.Iterable.is(s)){let e=[];for(const t of s)if(t)try{t.dispose()}catch(o){e.push(o)}if(e.length===1)throw e[0];if(e.length>1)throw new b(e);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}i.dispose=f;function R(...s){const e=D(()=>f(s));return S(s,e),e}i.combinedDisposable=R;function D(s){const e=a({dispose:(0,h.once)(()=>{c(e),s()})});return e}i.toDisposable=D;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1,a(this)}dispose(){this._isDisposed||(c(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(e){if(!e)return e;if(e===this)throw new Error("Cannot register a disposable on itself!");return l(e,this),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(e),e}}i.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new r,a(this),l(this._store,this)}dispose(){c(this),this._store.dispose()}_register(e){if(e===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(e)}}i.Disposable=u,u.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,a(this)}get value(){return this._isDisposed?void 0:this._value}set value(e){this._isDisposed||e===this._value||(this._value?.dispose(),e&&l(e,this),this._value=e)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,c(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const e=this._value;return this._value=void 0,e&&l(e,null),e}}i.MutableDisposable=w;class y{constructor(e){this._disposable=e,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}i.RefCountedDisposable=y;class E{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,a(this)}set(e){let t=e;return this.unset=()=>t=void 0,this.isset=()=>t!==void 0,this.dispose=()=>{t&&(t(),t=void 0,c(this))},this}}i.SafeDisposable=E;class C{constructor(){this.references=new Map}acquire(e,...t){let o=this.references.get(e);o||(o={counter:0,object:this.createReferencedObject(e,...t)},this.references.set(e,o));const{object:d}=o,I=(0,h.once)(()=>{--o.counter==0&&(this.destroyReferencedObject(e,o.object),this.references.delete(e))});return o.counter++,{object:d,dispose:I}}}i.ReferenceCollection=C;class j{constructor(e){this.referenceCollection=e}async acquire(e,...t){const o=this.referenceCollection.acquire(e,...t);try{return{object:await o.object,dispose:()=>o.dispose()}}catch(d){throw o.dispose(),d}}}i.AsyncReferenceCollection=j;class v{constructor(e){this.object=e}dispose(){}}i.ImmortalReference=v;function O(s){const e=new r;try{s(e)}finally{e.dispose()}}i.disposeOnReturn=O});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/base/common/lifecycle.js.map
