define(["require","exports","vs/base/common/buffer","vs/base/common/event","vs/base/common/lifecycle","vs/base/parts/ipc/common/ipc"],function(U,r,u,f,g,B){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.PersistentProtocol=r.BufferedEmitter=r.Client=r.Protocol=r.ProtocolConstants=r.ChunkStream=r.SocketCloseEventType=r.SocketDiagnostics=r.SocketDiagnosticsEventType=void 0;var D;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(D||(r.SocketDiagnosticsEventType=D={}));var p;(function(t){t.enableDiagnostics=!1,t.records=[];const e=new WeakMap;let s=0;function i(a,o){if(!e.has(a)){const k=String(++s);e.set(a,k)}return e.get(a)}function n(a,o,k,l){if(!t.enableDiagnostics)return;const T=i(a,o);if(l instanceof u.VSBuffer||l instanceof Uint8Array||l instanceof ArrayBuffer||ArrayBuffer.isView(l)){const N=u.VSBuffer.alloc(l.byteLength);N.set(l),t.records.push({timestamp:Date.now(),id:T,label:o,type:k,buff:N})}else t.records.push({timestamp:Date.now(),id:T,label:o,type:k,data:l})}t.traceSocketEvent=n})(p||(r.SocketDiagnostics=p={}));var I;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I||(r.SocketCloseEventType=I={}));let m=null;function _(){return m||(m=u.VSBuffer.alloc(0)),m}class S{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(e){this._chunks.push(e),this._totalLength+=e.byteLength}read(e){return this._read(e,!0)}peek(e){return this._read(e,!1)}_read(e,s){if(e===0)return _();if(e>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===e){const o=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=e),o}if(this._chunks[0].byteLength>e){const o=this._chunks[0].slice(0,e);return s&&(this._chunks[0]=this._chunks[0].slice(e),this._totalLength-=e),o}let i=u.VSBuffer.alloc(e),n=0,a=0;for(;e>0;){const o=this._chunks[a];if(o.byteLength>e){const k=o.slice(0,e);i.set(k,n),n+=e,s&&(this._chunks[a]=o.slice(e),this._totalLength-=e),e-=e}else i.set(o,n),n+=o.byteLength,s?(this._chunks.shift(),this._totalLength-=o.byteLength):a++,e-=o.byteLength}return i}}r.ChunkStream=S;var W;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(W||(W={}));function M(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var A;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(A||(r.ProtocolConstants=A={}));class c{constructor(e,s,i,n){this.type=e,this.id=s,this.ack=i,this.data=n,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends g.Disposable{constructor(e){super();this._onMessage=this._register(new f.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=e,this._isDisposed=!1,this._incomingData=new S,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(e){if(!(!e||e.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:M(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const i=this._state.messageType,n=this._state.id,a=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new c(i,n,a,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class b{constructor(e){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=e,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(e){if(this._isDisposed)return;e.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=u.VSBuffer.alloc(13);s.writeUInt8(e.type,0),s.writeUInt32BE(e.id,1),s.writeUInt32BE(e.ack,5),s.writeUInt32BE(e.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:M(e.type),id:e.id,ack:e.ack,messageSize:e.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",e.data),this._writeSoon(s,e.data)}_bufferAdd(e,s){const i=this._totalLength===0;return this._data.push(e,s),this._totalLength+=e.byteLength+s.byteLength,i}_bufferTake(){const e=u.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,e}_writeSoon(e,s){this._bufferAdd(e,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const e=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:e.byteLength}),this._socket.write(e)}}class L extends g.Disposable{constructor(e){super();this._onMessage=new f.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new f.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=e,this._socketWriter=this._register(new b(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(e){this._socketWriter.write(new c(1,0,0,e))}}r.Protocol=L;class R extends B.IPCClient{static fromSocket(e,s){return new R(new L(e),s)}get onDidDispose(){return this.protocol.onDidDispose}constructor(e,s,i=null){super(e,s,i);this.protocol=e}dispose(){super.dispose();const e=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),e.end()}}r.Client=R;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new f.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(e){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(e):this._emitter.fire(e):this._bufferedMessages.push(e)}flushBuffer(){this._bufferedMessages=[]}}r.BufferedEmitter=d;class H{constructor(e){this.data=e,this.next=null}}class C{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let e=[],s=0,i=this._first;for(;i;)e[s++]=i.data,i=i.next;return e}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(e){const s=new H(e);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class h{static getInstance(){return h._INSTANCE||(h._INSTANCE=new h),h._INSTANCE}constructor(){this.lastRuns=[];const e=Date.now();for(let s=0;s<h._HISTORY_LENGTH;s++)this.lastRuns[s]=e-1e3*s;setInterval(()=>{for(let s=h._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}load(){const e=Date.now(),s=(1+h._HISTORY_LENGTH)*1e3;let i=0;for(let n=0;n<h._HISTORY_LENGTH;n++)e-this.lastRuns[n]<=s&&i++;return 1-i/h._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}h._HISTORY_LENGTH=10,h._INSTANCE=null;class z{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(e,s=null,i=h.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=i,this._isReconnecting=!1,this._outgoingUnackMsg=new C,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=e,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(n=>this._onSocketClose.fire(n))),s&&this._socketReader.acceptChunk(s)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,g.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const e=new c(5,0,0,_());this._socketWriter.write(e),this._socketWriter.flush()}sendPause(){const e=new c(7,0,0,_());this._socketWriter.write(e)}sendResume(){const e=new c(8,0,0,_());this._socketWriter.write(e)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(e,s){this._isReconnecting=!0,this._socketDisposables=(0,g.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=e,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(i=>this._receiveMessage(i))),this._socketDisposables.push(this._socket.onClose(i=>this._onSocketClose.fire(i))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const e=new c(3,0,this._incomingAckId,_());this._socketWriter.write(e);const s=this._outgoingUnackMsg.toArray();for(let i=0,n=s.length;i<n;i++)this._socketWriter.write(s[i]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(e){if(e.ack>this._outgoingAckId){this._outgoingAckId=e.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=e.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(e.type){case 0:break;case 1:{if(e.id>this._incomingMsgId)if(e.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new c(6,0,0,_())))}else this._incomingMsgId=e.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(e.data);break}case 2:{this._onControlMessage.fire(e.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let i=0,n=s.length;i<n;i++)this._socketWriter.write(s[i]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(e){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const i=new c(1,s,this._incomingAckId,e);this._outgoingUnackMsg.push(i),this._isReconnecting||(this._socketWriter.write(i),this._recvAckCheck())}sendControl(e){const s=new c(2,0,0,e);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const e=Date.now()-this._incomingMsgLastTime;if(e>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-e+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const e=this._outgoingUnackMsg.peek(),s=Date.now()-e.writtenTime,i=Date.now()-this._socketReader.lastReadTime,n=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&i>=2e4&&n>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const a=Math.max(2e4-s,2e4-i,2e4-n,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},a)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const e=new c(3,0,this._incomingAckId,_());this._socketWriter.write(e)}}r.PersistentProtocol=z});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/base/parts/ipc/common/ipc.net.js.map
