define(["require","exports","crypto","net","os","vs/base/common/buffer","vs/base/common/errors","vs/base/common/event","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/platform","vs/base/common/uuid","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","zlib"],function(H,a,b,I,p,c,f,h,_,u,v,U,y,k,w){"use strict";Object.defineProperty(a,"__esModule",{value:!0}),a.connect=a.serve=a.Server=a.createStaticIPCHandle=a.createRandomIPCHandle=a.XDG_RUNTIME_DIR=a.WebSocketNodeSocket=a.NodeSocket=void 0;class m{traceSocketEvent(e,t){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,e,t)}constructor(e,t=""){this.debugLabel=t,this.socket=e,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=s=>{if(this.traceSocketEvent("error",{code:s?.code,message:s?.message}),s){if(s.code==="EPIPE")return;(0,f.onUnexpectedError)(s)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(e){const t=s=>{this.traceSocketEvent("read",s),e(c.VSBuffer.wrap(s))};return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(e){const t=s=>{this.traceSocketEvent("close",{hadError:s}),e({type:0,hadError:s,error:void 0})};return this.socket.on("close",t),{dispose:()=>this.socket.off("close",t)}}onEnd(e){const t=()=>{this.traceSocketEvent("nodeEndReceived"),e()};return this.socket.on("end",t),{dispose:()=>this.socket.off("end",t)}}write(e){if(!this.socket.destroyed)try{this.traceSocketEvent("write",e),this.socket.write(e.buffer,t=>{if(t){if(t.code==="EPIPE")return;(0,f.onUnexpectedError)(t)}})}catch(t){if(t.code==="EPIPE")return;(0,f.onUnexpectedError)(t)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((e,t)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),e();return}const s=()=>{this.socket.off("close",s),this.socket.off("end",s),this.socket.off("error",s),this.socket.off("timeout",s),this.socket.off("drain",s),this.traceSocketEvent("nodeDrainEnd"),e()};this.socket.on("close",s),this.socket.on("end",s),this.socket.on("error",s),this.socket.on("timeout",s),this.socket.on("drain",s)})}}a.NodeSocket=m;var E;(function(n){n[n.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var S;(function(n){n[n.PeekHeader=1]="PeekHeader",n[n.ReadHeader=2]="ReadHeader",n[n.ReadBody=3]="ReadBody",n[n.Fin=4]="Fin"})(S||(S={}));class P extends _.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(e,t){this.socket.traceSocketEvent(e,t)}constructor(e,t,s,i){super();this._onData=this._register(new h.Emitter),this._onClose=this._register(new h.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=e,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:t,inflateBytesLength:s?.byteLength||0,recordInflateBytes:i}),this._flowManager=this._register(new L(this,t,s,i,this._onData,(r,o)=>this._write(r,o))),this._register(this._flowManager.onError(r=>{console.error(r),(0,f.onUnexpectedError)(r),this._onClose.fire({type:0,hadError:!0,error:r})})),this._incomingData=new k.ChunkStream,this._register(this.socket.onData(r=>this._acceptChunk(r))),this._register(this.socket.onClose(r=>this._onClose.fire(r)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(e){return this._onData.event(e)}onClose(e){return this._onClose.event(e)}onEnd(e){return this.socket.onEnd(e)}write(e){this._flowManager.writeMessage(e)}_write(e,t){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",e);let s=2;e.byteLength<126?s+=0:e.byteLength<2**16?s+=2:s+=8;const i=c.VSBuffer.alloc(s);if(t?i.writeUInt8(194,0):i.writeUInt8(130,0),e.byteLength<126)i.writeUInt8(e.byteLength,1);else if(e.byteLength<2**16){i.writeUInt8(126,1);let r=1;i.writeUInt8(e.byteLength>>>8&255,++r),i.writeUInt8(e.byteLength>>>0&255,++r)}else{i.writeUInt8(127,1);let r=1;i.writeUInt8(0,++r),i.writeUInt8(0,++r),i.writeUInt8(0,++r),i.writeUInt8(0,++r),i.writeUInt8(e.byteLength>>>24&255,++r),i.writeUInt8(e.byteLength>>>16&255,++r),i.writeUInt8(e.byteLength>>>8&255,++r),i.writeUInt8(e.byteLength>>>0&255,++r)}this.socket.write(c.VSBuffer.concat([i,e]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(e){if(e.byteLength!==0){for(this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const t=this._incomingData.peek(this._state.readLen),s=t.readUInt8(0),i=(s&128)>>>7,r=(s&64)>>>6,o=t.readUInt8(1),d=(o&128)>>>7,l=o&127;this._state.state=2,this._state.readLen=2+(d?4:0)+(l===126?2:0)+(l===127?8:0),this._state.fin=i,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(r)),this._state.firstFrameOfMessage=Boolean(i),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const t=this._incomingData.read(this._state.readLen),s=t.readUInt8(1),i=(s&128)>>>7;let r=s&127,o=1;r===126?r=t.readUInt8(++o)*2**8+t.readUInt8(++o):r===127&&(r=t.readUInt8(++o)*0+t.readUInt8(++o)*0+t.readUInt8(++o)*0+t.readUInt8(++o)*0+t.readUInt8(++o)*2**24+t.readUInt8(++o)*2**16+t.readUInt8(++o)*2**8+t.readUInt8(++o));let d=0;i&&(d=t.readUInt8(++o)*2**24+t.readUInt8(++o)*2**16+t.readUInt8(++o)*2**8+t.readUInt8(++o)),this._state.state=3,this._state.readLen=r,this._state.mask=d,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const t=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",t),M(t,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",t),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(t,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}a.WebSocketNodeSocket=P;class L extends _.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:c.VSBuffer.alloc(0)}constructor(e,t,s,i,r,o){super();this._tracer=e,this._onData=r,this._writeFn=o,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new h.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,t?(this._zlibInflateStream=this._register(new B(this._tracer,i,s,{windowBits:15})),this._zlibDeflateStream=this._register(new z(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(d=>this._onError.fire(d))),this._register(this._zlibDeflateStream.onError(d=>this._onError.fire(d)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(e){this._writeQueue.push(e),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const e=this._writeQueue.shift();if(this._zlibDeflateStream){const t=await this._deflateMessage(this._zlibDeflateStream,e);this._writeFn(t,!0)}else this._writeFn(e,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(e,t){return new Promise((s,i)=>{e.write(t),e.flush(r=>s(r))})}acceptFrame(e,t,s){this._readQueue.push({data:e,isCompressed:t,isLastFrameOfMessage:s}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const e=this._readQueue.shift();if(this._zlibInflateStream&&e.isCompressed){const t=await this._inflateFrame(this._zlibInflateStream,e.data,e.isLastFrameOfMessage);this._onData.fire(t)}else this._onData.fire(e.data)}this._isProcessingReadQueue=!1}}_inflateFrame(e,t,s){return new Promise((i,r)=>{e.write(t),s&&e.write(c.VSBuffer.fromByteArray([0,0,255,255])),e.flush(o=>i(o))})}}class B extends _.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?c.VSBuffer.concat(this._recordedInflateBytes):c.VSBuffer.alloc(0)}constructor(e,t,s,i){super();this._tracer=e,this._recordInflateBytes=t,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=w.createInflateRaw(i),this._zlibInflate.on("error",r=>{this._tracer.traceSocketEvent("zlibInflateError",{message:r?.message,code:r?.code}),this._onError.fire(r)}),this._zlibInflate.on("data",r=>{this._tracer.traceSocketEvent("zlibInflateData",r),this._pendingInflateData.push(c.VSBuffer.wrap(r))}),s&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",s.buffer),this._zlibInflate.write(s.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(e){this._recordInflateBytes&&this._recordedInflateBytes.push(e.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",e),this._zlibInflate.write(e.buffer)}flush(e){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const t=c.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,e(t)})}}class z extends _.Disposable{constructor(e,t){super();this._tracer=e,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=w.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",s=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:s?.message,code:s?.code}),this._onError.fire(s)}),this._zlibDeflate.on("data",s=>{this._tracer.traceSocketEvent("zlibDeflateData",s),this._pendingDeflateData.push(c.VSBuffer.wrap(s))})}write(e){this._tracer.traceSocketEvent("zlibDeflateWrite",e.buffer),this._zlibDeflate.write(e.buffer)}flush(e){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let t=c.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,t=t.slice(0,t.byteLength-4),e(t)})}}function M(n,e){if(e===0)return;let t=n.byteLength>>>2;for(let l=0;l<t;l++){const W=n.readUInt32BE(l*4);n.writeUInt32BE(W^e,l*4)}let s=t*4,i=n.byteLength-s;const r=e>>>24&255,o=e>>>16&255,d=e>>>8&255;i>=1&&n.writeUInt8(n.readUInt8(s)^r,s),i>=2&&n.writeUInt8(n.readUInt8(s+1)^o,s+1),i>=3&&n.writeUInt8(n.readUInt8(s+2)^d,s+2)}a.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const C={[2]:107,[1]:103};function Q(){const n=(0,U.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${n}-sock`;let e;return a.XDG_RUNTIME_DIR?e=(0,u.join)(a.XDG_RUNTIME_DIR,`vscode-ipc-${n}.sock`):e=(0,u.join)((0,p.tmpdir)(),`vscode-ipc-${n}.sock`),D(e),e}a.createRandomIPCHandle=Q;function R(n,e,t){const s=(0,b.createHash)("md5").update(n).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${s}-${t}-${e}-sock`;let i;return a.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?i=(0,u.join)(a.XDG_RUNTIME_DIR,`vscode-${s.substr(0,8)}-${t}-${e}.sock`):i=(0,u.join)(n,`${t}-${e}.sock`),D(i),i}a.createStaticIPCHandle=R;function D(n){const e=C[v.platform];typeof e=="number"&&n.length>=e&&console.warn(`WARNING: IPC handle "${n}" is longer than ${e} chars, try a shorter --user-data-dir`)}class g extends y.IPCServer{static toClientConnectionEvent(e){const t=h.Event.fromNodeEventEmitter(e,"connection");return h.Event.map(t,s=>({protocol:new k.Protocol(new m(s,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(s,"close"))}))}constructor(e){super(g.toClientConnectionEvent(e));this.server=e}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}a.Server=g;function F(n){return new Promise((e,t)=>{const s=(0,I.createServer)();s.on("error",t),s.listen(n,()=>{s.removeListener("error",t),e(new g(s))})})}a.serve=F;function N(n,e){return new Promise((t,s)=>{const i=(0,I.createConnection)(n,()=>{i.removeListener("error",s),t(k.Client.fromSocket(new m(i,`ipc-client${e}`),e))});i.once("error",s)})}a.connect=N});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/base/parts/ipc/node/ipc.net.js.map
