define(["require","exports","vs/base/common/async","vs/base/common/event","vs/base/common/map","vs/base/common/path","vs/base/node/pfs"],function(m,g,d,T,E,$,u){"use strict";Object.defineProperty(g,"__esModule",{value:!0}),g.SQLiteStorageDatabase=void 0;class h{get onDidChangeItemsExternal(){return T.Event.None}constructor(e,r=Object.create(null)){this.path=e,this.options=r,this.name=(0,$.basename)(this.path),this.logger=new l(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const e=await this.whenConnected,r=new Map;return(await this.all(e,"SELECT * FROM ItemTable")).forEach(n=>r.set(n.key,n.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${r.size} rows`),r}async updateItems(e){const r=await this.whenConnected;return this.doUpdateItems(r,e)}doUpdateItems(e,r){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${r.insert?(0,E.mapToString)(r.insert):"0"}), delete(${r.delete?(0,E.setToString)(r.delete):"0"})`),this.transaction(e,()=>{const s=r.insert,n=r.delete;if(s&&s.size>0){const t=[];t.push([]);let i=0;s.forEach((o,a)=>{let c=t[i];c.length>h.MAX_HOST_PARAMETERS&&(i++,c=[],t.push(c)),c.push(a,o)}),t.forEach(o=>{this.prepare(e,`INSERT INTO ItemTable VALUES ${new Array(o.length/2).fill("(?,?)").join(",")}`,a=>a.run(o),()=>{const a=[];let c=0;return s.forEach((f,p)=>{a.push(p),c+=f.length}),`Keys: ${a.join(", ")} Length: ${c}`})})}if(n&&n.size){const t=[];t.push([]);let i=0;n.forEach(o=>{let a=t[i];a.length>h.MAX_HOST_PARAMETERS&&(i++,a=[],t.push(a)),a.push(o)}),t.forEach(o=>{this.prepare(e,`DELETE FROM ItemTable WHERE key IN (${new Array(o.length).fill("?").join(",")})`,a=>a.run(o),()=>{const a=[];return n.forEach(c=>{a.push(c)}),`Keys: ${a.join(", ")}`})})}})}async close(e){this.logger.trace(`[storage ${this.name}] close()`);const r=await this.whenConnected;return this.doClose(r,e)}doClose(e,r){return new Promise((s,n)=>{e.db.close(t=>(t&&this.handleSQLiteError(e,`[storage ${this.name}] close(): ${t}`),this.path===h.IN_MEMORY_PATH?s():!e.isErroneous&&!e.isInMemory?this.backup().then(s,i=>(this.logger.error(`[storage ${this.name}] backup(): ${i}`),s())):typeof r=="function"?u.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(i=>{const o=()=>this.doClose(i,void 0);return this.doUpdateItems(i,{insert:r()}).then(()=>o(),a=>(o(),Promise.reject(a)))})).then(s,n):n(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const e=this.toBackupPath(this.path);return u.Promises.copy(this.path,e,{preserveSymlinks:!1})}toBackupPath(e){return`${e}.backup`}async checkIntegrity(e){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${e})`);const r=await this.whenConnected,s=await this.get(r,e?"PRAGMA integrity_check":"PRAGMA quick_check"),n=e?s.integrity_check:s.quick_check;return r.isErroneous?`${n} (last error: ${r.lastError})`:r.isInMemory?`${n} (in-memory!)`:n}async connect(e,r=!0){this.logger.trace(`[storage ${this.name}] open(${e}, retryOnBusy: ${r})`);try{return await this.doConnect(e)}catch(s){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${s}`),s.code==="SQLITE_BUSY"&&r)return await(0,d.timeout)(h.BUSY_OPEN_TIMEOUT),this.connect(e,!1);try{await u.Promises.unlink(e);try{await u.Promises.rename(this.toBackupPath(e),e)}catch{}return await this.doConnect(e)}catch(n){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${n}`),this.doConnect(h.IN_MEMORY_PATH)}}}handleSQLiteError(e,r){e.isErroneous=!0,e.lastError=r,this.logger.error(r)}doConnect(e){return new Promise((r,s)=>{new Promise((n,t)=>{m(["@vscode/sqlite3"],n,t)}).then(n=>{const t={db:new(this.logger.isTracing?n.verbose().Database:n.Database)(e,i=>i?t.db?t.db.close(()=>s(i)):s(i):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>r(t),o=>t.db.close(()=>s(o)))),isInMemory:e===h.IN_MEMORY_PATH};t.db.on("error",i=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${i}`)),this.logger.isTracing&&t.db.on("trace",i=>this.logger.trace(`[storage ${this.name}] Trace (event): ${i}`))},s)})}exec(e,r){return new Promise((s,n)=>{e.db.exec(r,t=>t?(this.handleSQLiteError(e,`[storage ${this.name}] exec(): ${t}`),n(t)):s())})}get(e,r){return new Promise((s,n)=>{e.db.get(r,(t,i)=>t?(this.handleSQLiteError(e,`[storage ${this.name}] get(): ${t}`),n(t)):s(i))})}all(e,r){return new Promise((s,n)=>{e.db.all(r,(t,i)=>t?(this.handleSQLiteError(e,`[storage ${this.name}] all(): ${t}`),n(t)):s(i))})}transaction(e,r){return new Promise((s,n)=>{e.db.serialize(()=>{e.db.run("BEGIN TRANSACTION"),r(),e.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(e,`[storage ${this.name}] transaction(): ${t}`),n(t)):s())})})}prepare(e,r,s,n){const t=e.db.prepare(r),i=o=>{this.handleSQLiteError(e,`[storage ${this.name}] prepare(): ${o} (${r}). Details: ${n()}`)};t.on("error",i),s(t),t.finalize(o=>{o&&i(o),t.removeListener("error",i)})}}g.SQLiteStorageDatabase=h,h.IN_MEMORY_PATH=":memory:",h.BUSY_OPEN_TIMEOUT=2e3,h.MAX_HOST_PARAMETERS=256;class l{constructor(e){e&&typeof e.logTrace=="function"&&process.env[l.VSCODE_TRACE_STORAGE]&&(this.logTrace=e.logTrace),e&&typeof e.logError=="function"&&(this.logError=e.logError)}get isTracing(){return!!this.logTrace}trace(e){this.logTrace&&this.logTrace(e)}error(e){this.logError&&this.logError(e)}}l.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/base/parts/storage/node/storage.js.map
