/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/base/common/types","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/decorators","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/jsonFormatter","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/notification/common/notification","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/severity","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/languagePacks/common/languagePacks","vs/platform/native/electron-sandbox/native","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/normalization","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/common/actions","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensionsGallery/common/extensionsGalleryConfigService","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/node/zip","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/linkedText","vs/base/common/mime","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/extensionsGallery/common/extensionsGalleryConfig","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/workbench/services/notification/common/notificationService","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionsGallery/common/extensionsGalleryConfig","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/workbench/common/notifications","vs/workbench/services/notification/common/notificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","string_decoder","util","minimist","assert","path","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],se=function(J){for(var e=[],R=0,i=J.length;R<i;R++)e[R]=re[J[R]];return e};define(re[110],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function R(i,k){if(!i)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=R}),define(re[49],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function R(A){return A?A.replace(/\$\((.*?)\)/g,(P,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=R;class i{constructor(P,b,E){this.id=P,this.definition=b,this.description=E,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function k(A,P){const b=["codicon","codicon-"+A];return P&&b.push("codicon-modifier-"+P),b}e.getClassNamesArray=k;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(I){if(I instanceof i)return["codicon","codicon-"+I.id];const h=P.exec(I.id);if(!h)return b(i.error);let[,y,v]=h;const p=["codicon","codicon-"+y];return v&&p.push("codicon-modifier-"+v.substr(1)),p}A.asClassNameArray=b;function E(I){return b(I).join(" ")}A.asClassName=E;function D(I){return"."+b(I).join(".")}A.asCSSSelector=D})(L||(e.CSSIcon=L={}))}),define(re[74],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const R=Object.prototype.hasOwnProperty;function i(D){const I=[];for(let h in D)R.call(D,h)&&I.push(D[h]);return I}e.values=i;function k(D,I){for(let h in D)if(R.call(D,h)&&I({key:h,value:D[h]},function(){delete D[h]})===!1)return}e.forEach=k;function L(D,I){const h=Object.create(null);for(const y of D){const v=I(y);let p=h[v];p||(p=h[v]=[]),p.push(y)}return h}e.groupBy=L;function A(D){const I=Object.create(null);return D&&D.forEach((h,y)=>{I[y]=h}),I}e.fromMap=A;function P(D,I){const h=[],y=[];for(let v of D)I.has(v)||h.push(v);for(let v of I)D.has(v)||y.push(v);return{removed:h,added:y}}e.diffSets=P;function b(D,I){const h=[],y=[];for(let[v,p]of D)I.has(v)||h.push(p);for(let[v,p]of I)D.has(v)||y.push(p);return{removed:h,added:y}}e.diffMaps=b;class E{constructor(){this.map=new Map}add(I,h){let y=this.map.get(I);y||(y=new Set,this.map.set(I,y)),y.add(h)}delete(I,h){const y=this.map.get(I);!y||(y.delete(h),y.size===0&&this.map.delete(I))}forEach(I,h){const y=this.map.get(I);!y||y.forEach(h)}}e.SetMap=E}),define(re[45],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(A){return(P,b,E)=>{let D=null,I=null;if(typeof E.value=="function"?(D="value",I=E.value):typeof E.get=="function"&&(D="get",I=E.get),!I)throw new Error("not supported");E[D]=A(I,b)}}e.createDecorator=R;function i(A,P,b){let E=null,D=null;if(typeof b.value=="function"?(E="value",D=b.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(E="get",D=b.get),!D)throw new Error("not supported");const I=`$memoize$${P}`;b[E]=function(...h){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,h)}),this[I]}}e.memoize=i;function k(A,P,b){return R((E,D)=>{const I=`$debounce$${D}`,h=`$debounce$result$${D}`;return function(...y){this[h]||(this[h]=b?b():void 0),clearTimeout(this[I]),P&&(this[h]=P(this[h],...y),y=[this[h]]),this[I]=setTimeout(()=>{E.apply(this,y),this[h]=b?b():void 0},A)}})}e.debounce=k;function L(A,P,b){return R((E,D)=>{const I=`$throttle$timer$${D}`,h=`$throttle$result$${D}`,y=`$throttle$lastRun$${D}`,v=`$throttle$pending$${D}`;return function(...p){if(this[h]||(this[h]=b?b():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[h]=P(this[h],...p)),this[v])return;const d=this[y]+A;d<=Date.now()?(this[y]=Date.now(),E.apply(this,[this[h]]),this[h]=b?b():void 0):(this[v]=!0,this[I]=setTimeout(()=>{this[v]=!1,this[y]=Date.now(),E.apply(this,[this[h]]),this[h]=b?b():void 0},d-Date.now()))}})}e.throttle=L}),define(re[7],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=R,e.errorHandler=new R;function i(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=i;function k(l){b(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=k;function L(l){b(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=L;function A(l){if(l instanceof Error){let{name:t,message:r}=l;const n=l.stacktrace||l.stack;return{$isError:!0,name:t,message:r,stack:n}}return l}e.transformErrorForSerialization=A;const P="Canceled";function b(l){return l instanceof E?!0:l instanceof Error&&l.name===P&&l.message===P}e.isCancellationError=b;class E extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=E;function D(){const l=new Error(P);return l.name=l.message,l}e.canceled=D;function I(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=I;function h(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=h;function y(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function v(l){const t=new Error(`${l} has been disposed`);return t.name="DISPOSED",t}e.disposed=v;function p(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=p;class d extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=d;class g extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=g;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;class w extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(t){if(t&&t instanceof w)return t;if(t&&t instanceof Error){const r=new w;return r.name=t.name,r.message=t.message,r.stack=t.stack,r}return new w(t)}}e.ErrorNoTelemetry=w;class f extends Error{constructor(t){super(t||"An unexpected bug occurred.");Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(re[16],se([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(N,x=0){return N[N.length-(1+x)]}e.tail=i;function k(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=k;function L(N,x,Y=(ne,oe)=>ne===oe){if(N===x)return!0;if(!N||!x||N.length!==x.length)return!1;for(let ne=0,oe=N.length;ne<oe;ne++)if(!Y(N[ne],x[ne]))return!1;return!0}e.equals=L;function A(N,x,Y){return P(N.length,ne=>Y(N[ne],x))}e.binarySearch=A;function P(N,x){let Y=0,ne=N-1;for(;Y<=ne;){const oe=(Y+ne)/2|0,de=x(oe);if(de<0)Y=oe+1;else if(de>0)ne=oe-1;else return oe}return-(Y+1)}e.binarySearch2=P;function b(N,x){let Y=0,ne=N.length;if(ne===0)return 0;for(;Y<ne;){const oe=Math.floor((Y+ne)/2);x(N[oe])?ne=oe:Y=oe+1}return Y}e.findFirstInSorted=b;function E(N,x,Y){if(N=N|0,N>=x.length)throw new TypeError("invalid index");let ne=x[Math.floor(x.length*Math.random())],oe=[],de=[],me=[];for(let Ee of x){const Se=Y(Ee,ne);Se<0?oe.push(Ee):Se>0?de.push(Ee):me.push(Ee)}return N<oe.length?E(N,oe,Y):N<oe.length+me.length?me[0]:E(N-(oe.length+me.length),de,Y)}e.quickSelect=E;function D(N,x){const Y=[];let ne;for(const oe of N.slice(0).sort(x))!ne||x(ne[0],oe)!==0?(ne=[oe],Y.push(ne)):ne.push(oe);return Y}e.groupBy=D;function I(N,x,Y){const ne=[];function oe(Ee,Se,ve){if(Se===0&&ve.length===0)return;const we=ne[ne.length-1];we&&we.start+we.deleteCount===Ee?(we.deleteCount+=Se,we.toInsert.push(...ve)):ne.push({start:Ee,deleteCount:Se,toInsert:ve})}let de=0,me=0;for(;;){if(de===N.length){oe(de,0,x.slice(me));break}if(me===x.length){oe(de,N.length-de,[]);break}const Ee=N[de],Se=x[me],ve=Y(Ee,Se);ve===0?(de+=1,me+=1):ve<0?(oe(de,1,[]),de+=1):ve>0&&(oe(de,0,[Se]),me+=1)}return ne}e.sortedDiff=I;function h(N,x,Y){const ne=I(N,x,Y),oe=[],de=[];for(const me of ne)oe.push(...N.slice(me.start,me.start+me.deleteCount)),de.push(...me.toInsert);return{removed:oe,added:de}}e.delta=h;function y(N,x,Y){if(Y===0)return[];const ne=N.slice(0,Y).sort(x);return p(N,x,ne,Y,N.length),ne}e.top=y;function v(N,x,Y,ne,oe){return Y===0?Promise.resolve([]):new Promise((de,me)=>{(async()=>{const Ee=N.length,Se=N.slice(0,Y).sort(x);for(let ve=Y,we=Math.min(Y+ne,Ee);ve<Ee;ve=we,we=Math.min(we+ne,Ee)){if(ve>Y&&await new Promise(De=>setTimeout(De)),oe&&oe.isCancellationRequested)throw new R.CancellationError;p(N,x,Se,ve,we)}return Se})().then(de,me)})}e.topAsync=v;function p(N,x,Y,ne,oe){for(const de=Y.length;ne<oe;ne++){const me=N[ne];if(x(me,Y[de-1])<0){Y.pop();const Ee=b(Y,Se=>x(me,Se)<0);Y.splice(Ee,0,me)}}}function d(N){return N.filter(x=>!!x)}e.coalesce=d;function g(N){let x=0;for(let Y=0;Y<N.length;Y++)N[Y]&&(N[x]=N[Y],x+=1);N.length=x}e.coalesceInPlace=g;function S(N,x,Y){N.splice(Y,0,N.splice(x,1)[0])}e.move=S;function w(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=w;function f(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=f;function l(N,x=Y=>Y){const Y=new Set;return N.filter(ne=>{const oe=x(ne);return Y.has(oe)?!1:(Y.add(oe),!0)})}e.distinct=l;function t(N){const x=new Set;return Y=>{const ne=N(Y);return x.has(ne)?!1:(x.add(ne),!0)}}e.uniqueFilter=t;function r(N,x){const Y=n(N,x);if(Y!==-1)return N[Y]}e.findLast=r;function n(N,x){for(let Y=N.length-1;Y>=0;Y--){const ne=N[Y];if(x(ne))return Y}return-1}e.lastIndex=n;function a(N,x){return N.length>0?N[0]:x}e.firstOrDefault=a;function c(N,x){return N.length>0?N[N.length-1]:x}e.lastOrDefault=c;function o(N,x,Y=(ne,oe)=>ne===oe){let ne=0;for(let oe=0,de=Math.min(N.length,x.length);oe<de&&Y(N[oe],x[oe]);oe++)ne++;return ne}e.commonPrefixLength=o;function s(N){return[].concat(...N)}e.flatten=s;function u(N,x){let Y=typeof x=="number"?N:0;typeof x=="number"?Y=N:(Y=0,x=N);const ne=[];if(Y<=x)for(let oe=Y;oe<x;oe++)ne.push(oe);else for(let oe=Y;oe>x;oe--)ne.push(oe);return ne}e.range=u;function m(N,x,Y){return N.reduce((ne,oe)=>(ne[x(oe)]=Y?Y(oe):oe,ne),Object.create(null))}e.index=m;function C(N,x){return N.push(x),()=>M(N,x)}e.insert=C;function M(N,x){const Y=N.indexOf(x);if(Y>-1)return N.splice(Y,1),x}e.remove=M;function T(N,x,Y){const ne=N.slice(0,x),oe=N.slice(x);return ne.concat(Y,oe)}e.arrayInsert=T;function F(N,x){let Y;if(typeof x=="number"){let ne=x;Y=()=>{const oe=Math.sin(ne++)*179426549;return oe-Math.floor(oe)}}else Y=Math.random;for(let ne=N.length-1;ne>0;ne-=1){const oe=Math.floor(Y()*(ne+1)),de=N[ne];N[ne]=N[oe],N[oe]=de}}e.shuffle=F;function _(N,x){const Y=N.indexOf(x);Y>-1&&(N.splice(Y,1),N.unshift(x))}e.pushToStart=_;function U(N,x){const Y=N.indexOf(x);Y>-1&&(N.splice(Y,1),N.push(x))}e.pushToEnd=U;function O(N,x){for(const Y of x)N.push(Y)}e.pushMany=O;function $(N,x){return Array.isArray(N)?N.map(x):x(N)}e.mapArrayOrNot=$;function V(N){return Array.isArray(N)?N:[N]}e.asArray=V;function te(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=te;function H(N,x){for(const Y of N){const ne=x(Y);if(ne!==void 0)return ne}}e.mapFind=H;function z(N,x,Y){const ne=j(N,x),oe=N.length,de=Y.length;N.length=oe+de;for(let me=oe-1;me>=ne;me--)N[me+de]=N[me];for(let me=0;me<de;me++)N[me+ne]=Y[me]}e.insertInto=z;function q(N,x,Y,ne){const oe=j(N,x),de=N.splice(oe,Y);return z(N,oe,ne),de}e.splice=q;function j(N,x){return x<0?Math.max(x+N.length,0):Math.min(x,N.length)}var Q;(function(N){function x(oe){return oe<0}N.isLessThan=x;function Y(oe){return oe>0}N.isGreaterThan=Y;function ne(oe){return oe===0}N.isNeitherLessOrGreaterThan=ne,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(Q||(e.CompareResult=Q={}));function G(N,x){return(Y,ne)=>x(N(Y),N(ne))}e.compareBy=G;const X=(N,x)=>N-x;e.numberComparator=X;function Z(N,x){if(N.length===0)return;let Y=N[0];for(let ne=1;ne<N.length;ne++){const oe=N[ne];x(oe,Y)>0&&(Y=oe)}return Y}e.findMaxBy=Z;function W(N,x){if(N.length===0)return;let Y=N[0];for(let ne=1;ne<N.length;ne++){const oe=N[ne];x(oe,Y)>=0&&(Y=oe)}return Y}e.findLastMaxBy=W;function ee(N,x){return Z(N,(Y,ne)=>-x(Y,ne))}e.findMinBy=ee;class B{constructor(x){this.items=x,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(x){let Y=this.firstIdx;for(;Y<this.items.length&&x(this.items[Y]);)Y++;const ne=Y===this.firstIdx?null:this.items.slice(this.firstIdx,Y);return this.firstIdx=Y,ne}takeFromEndWhile(x){let Y=this.lastIdx;for(;Y>=0&&x(this.items[Y]);)Y--;const ne=Y===this.lastIdx?null:this.items.slice(Y+1,this.lastIdx+1);return this.lastIdx=Y,ne}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const x=this.items[this.firstIdx];return this.firstIdx++,x}removeLast(){const x=this.items[this.lastIdx];return this.lastIdx--,x}takeCount(x){const Y=this.items.slice(this.firstIdx,this.firstIdx+x);return this.firstIdx+=x,Y}}e.ArrayQueue=B}),define(re[75],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(i){const k=this;let L=!1,A;return function(){return L||(L=!0,A=i.apply(k,arguments)),A}}e.once=R}),define(re[50],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(i){function k(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}i.is=k;const L=Object.freeze([]);function A(){return L}i.empty=A;function*P(r){yield r}i.single=P;function b(r){return r||L}i.from=b;function E(r){return!r||r[Symbol.iterator]().next().done===!0}i.isEmpty=E;function D(r){return r[Symbol.iterator]().next().value}i.first=D;function I(r,n){for(const a of r)if(n(a))return!0;return!1}i.some=I;function h(r,n){for(const a of r)if(n(a))return a}i.find=h;function*y(r,n){for(const a of r)n(a)&&(yield a)}i.filter=y;function*v(r,n){let a=0;for(const c of r)yield n(c,a++)}i.map=v;function*p(...r){for(const n of r)for(const a of n)yield a}i.concat=p;function*d(r){for(const n of r)for(const a of n)yield a}i.concatNested=d;function g(r,n,a){let c=a;for(const o of r)c=n(c,o);return c}i.reduce=g;function S(r,n){let a=0;for(const c of r)n(c,a++)}i.forEach=S;function*w(r,n,a=r.length){for(n<0&&(n+=r.length),a<0?a+=r.length:a>r.length&&(a=r.length);n<a;n++)yield r[n]}i.slice=w;function f(r,n=Number.POSITIVE_INFINITY){const a=[];if(n===0)return[a,r];const c=r[Symbol.iterator]();for(let o=0;o<n;o++){const s=c.next();if(s.done)return[a,i.empty()];a.push(s.value)}return[a,{[Symbol.iterator](){return c}}]}i.consume=f;function l(r){return f(r)[0]}i.collect=l;function t(r,n,a=(c,o)=>c===o){const c=r[Symbol.iterator](),o=n[Symbol.iterator]();for(;;){const s=c.next(),u=o.next();if(s.done!==u.done)return!1;if(s.done)return!0;if(!a(s.value,u.value))return!1}}i.equals=t})(R||(e.Iterable=R={}))}),define(re[33],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(R||(e.ScanError=R={}));var i;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(i||(e.SyntaxKind=i={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(t,r=!1){let n=0,a=t.length,c="",o=0,s=16,u=0;function m(O){let $=0,V=0;for(;$<O;){const te=t.charCodeAt(n);if(te>=48&&te<=57)V=V*16+te-48;else if(te>=65&&te<=70)V=V*16+te-65+10;else if(te>=97&&te<=102)V=V*16+te-97+10;else break;n++,$++}return $<O&&(V=-1),V}function C(O){n=O,c="",o=0,s=16,u=0}function M(){const O=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&E(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&E(t.charCodeAt(n)))for(n++;n<t.length&&E(t.charCodeAt(n));)n++;else return u=3,t.substring(O,n);let $=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&E(t.charCodeAt(n))){for(n++;n<t.length&&E(t.charCodeAt(n));)n++;$=n}else u=3;return t.substring(O,$)}function T(){let O="",$=n;for(;;){if(n>=a){O+=t.substring($,n),u=2;break}const V=t.charCodeAt(n);if(V===34){O+=t.substring($,n),n++;break}if(V===92){if(O+=t.substring($,n),n++,n>=a){u=2;break}switch(t.charCodeAt(n++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const H=m(4);H>=0?O+=String.fromCharCode(H):u=4;break}default:u=5}$=n;continue}if(V>=0&&V<=31)if(b(V)){O+=t.substring($,n),u=2;break}else u=6;n++}return O}function F(){if(c="",u=0,o=n,n>=a)return o=a,s=17;let O=t.charCodeAt(n);if(P(O)){do n++,c+=String.fromCharCode(O),O=t.charCodeAt(n);while(P(O));return s=15}if(b(O))return n++,c+=String.fromCharCode(O),O===13&&t.charCodeAt(n)===10&&(n++,c+=`
`),s=14;switch(O){case 123:return n++,s=1;case 125:return n++,s=2;case 91:return n++,s=3;case 93:return n++,s=4;case 58:return n++,s=6;case 44:return n++,s=5;case 34:return n++,c=T(),s=10;case 47:{const $=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<a&&!b(t.charCodeAt(n));)n++;return c=t.substring($,n),s=12}if(t.charCodeAt(n+1)===42){n+=2;const V=a-1;let te=!1;for(;n<V;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,te=!0;break}n++}return te||(n++,u=1),c=t.substring($,n),s=13}return c+=String.fromCharCode(O),n++,s=16}case 45:if(c+=String.fromCharCode(O),n++,n===a||!E(t.charCodeAt(n)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=M(),s=11;default:for(;n<a&&_(O);)n++,O=t.charCodeAt(n);if(o!==n){switch(c=t.substring(o,n),c){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return c+=String.fromCharCode(O),n++,s=16}}function _(O){if(P(O)||b(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let O;do O=F();while(O>=12&&O<=15);return O}return{setPosition:C,getPosition:()=>n,scan:r?U:F,getToken:()=>s,getTokenValue:()=>c,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>u}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var D;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(D||(D={}));function I(t,r){const n=[],a=new Object;let c;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function u(m,C,M,T){o.value=m,o.offset=C,o.length=M,o.type=T,o.colonOffset=void 0,c=o}try{w(t,{onObjectBegin:(m,C)=>{if(r<=m)throw a;c=void 0,s=r>m,n.push("")},onObjectProperty:(m,C,M)=>{if(r<C||(u(m,C,M,"property"),n[n.length-1]=m,r<=C+M))throw a},onObjectEnd:(m,C)=>{if(r<=m)throw a;c=void 0,n.pop()},onArrayBegin:(m,C)=>{if(r<=m)throw a;c=void 0,n.push(0)},onArrayEnd:(m,C)=>{if(r<=m)throw a;c=void 0,n.pop()},onLiteralValue:(m,C,M)=>{if(r<C||(u(m,C,M,l(m)),r<=C+M))throw a},onSeparator:(m,C,M)=>{if(r<=C)throw a;if(m===":"&&c&&c.type==="property")c.colonOffset=C,s=!1,c=void 0;else if(m===","){const T=n[n.length-1];typeof T=="number"?n[n.length-1]=T+1:(s=!0,n[n.length-1]=""),c=void 0}}})}catch(m){if(m!==a)throw m}return{path:n,previousNode:c,isAtPropertyKey:s,matches:m=>{let C=0;for(let M=0;C<m.length&&M<n.length;M++)if(m[C]===n[M]||m[C]==="*")C++;else if(m[C]!=="**")return!1;return C===m.length}}}e.getLocation=I;function h(t,r=[],n=L.DEFAULT){let a=null,c=[];const o=[];function s(m){Array.isArray(c)?c.push(m):a!==null&&(c[a]=m)}return w(t,{onObjectBegin:()=>{const m={};s(m),o.push(c),c=m,a=null},onObjectProperty:m=>{a=m},onObjectEnd:()=>{c=o.pop()},onArrayBegin:()=>{const m=[];s(m),o.push(c),c=m,a=null},onArrayEnd:()=>{c=o.pop()},onLiteralValue:s,onError:(m,C,M)=>{r.push({error:m,offset:C,length:M})}},n),c[0]}e.parse=h;function y(t,r=[],n=L.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(m){a.type==="property"&&(a.length=m-a.offset,a=a.parent)}function o(m){return a.children.push(m),m}w(t,{onObjectBegin:m=>{a=o({type:"object",offset:m,length:-1,parent:a,children:[]})},onObjectProperty:(m,C,M)=>{a=o({type:"property",offset:C,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:m,offset:C,length:M,parent:a})},onObjectEnd:(m,C)=>{a.length=m+C-a.offset,a=a.parent,c(m+C)},onArrayBegin:(m,C)=>{a=o({type:"array",offset:m,length:-1,parent:a,children:[]})},onArrayEnd:(m,C)=>{a.length=m+C-a.offset,a=a.parent,c(m+C)},onLiteralValue:(m,C,M)=>{o({type:l(m),offset:C,length:M,parent:a,value:m}),c(C+M)},onSeparator:(m,C,M)=>{a.type==="property"&&(m===":"?a.colonOffset=C:m===","&&c(C))},onError:(m,C,M)=>{r.push({error:m,offset:C,length:M})}},n);const u=a.children[0];return u&&delete u.parent,u}e.parseTree=y;function v(t,r){if(!t)return;let n=t;for(let a of r)if(typeof a=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let c=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===a){n=o.children[1],c=!0;break}if(!c)return}else{const c=a;if(n.type!=="array"||c<0||!Array.isArray(n.children)||c>=n.children.length)return;n=n.children[c]}return n}e.findNodeAtLocation=v;function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}e.getNodePath=p;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const r=Object.create(null);for(let n of t.children){const a=n.children[1];a&&(r[n.children[0].value]=d(a))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=d;function g(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}e.contains=g;function S(t,r,n=!1){if(g(t,r,n)){const a=t.children;if(Array.isArray(a))for(let c=0;c<a.length&&a[c].offset<=r;c++){const o=S(a[c],r,n);if(o)return o}return t}}e.findNodeAtOffset=S;function w(t,r,n=L.DEFAULT){const a=A(t,!1);function c(X){return X?()=>X(a.getTokenOffset(),a.getTokenLength()):()=>!0}function o(X){return X?Z=>X(Z,a.getTokenOffset(),a.getTokenLength()):()=>!0}const s=c(r.onObjectBegin),u=o(r.onObjectProperty),m=c(r.onObjectEnd),C=c(r.onArrayBegin),M=c(r.onArrayEnd),T=o(r.onLiteralValue),F=o(r.onSeparator),_=c(r.onComment),U=o(r.onError),O=n&&n.disallowComments,$=n&&n.allowTrailingComma;function V(){for(;;){const X=a.scan();switch(a.getTokenError()){case 4:te(14);break;case 5:te(15);break;case 3:te(13);break;case 1:O||te(11);break;case 2:te(12);break;case 6:te(16);break}switch(X){case 12:case 13:O?te(10):_();break;case 16:te(1);break;case 15:case 14:break;default:return X}}}function te(X,Z=[],W=[]){if(U(X),Z.length+W.length>0){let ee=a.getToken();for(;ee!==17;){if(Z.indexOf(ee)!==-1){V();break}else if(W.indexOf(ee)!==-1)break;ee=V()}}}function H(X){const Z=a.getTokenValue();return X?T(Z):u(Z),V(),!0}function z(){switch(a.getToken()){case 11:{let X=0;try{X=JSON.parse(a.getTokenValue()),typeof X!="number"&&(te(2),X=0)}catch{te(2)}T(X);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return V(),!0}function q(){return a.getToken()!==10?(te(3,[],[2,5]),!1):(H(!1),a.getToken()===6?(F(":"),V(),G()||te(4,[],[2,5])):te(5,[],[2,5]),!0)}function j(){s(),V();let X=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(X||te(4,[],[]),F(","),V(),a.getToken()===2&&$)break}else X&&te(6,[],[]);q()||te(4,[],[2,5]),X=!0}return m(),a.getToken()!==2?te(7,[2],[]):V(),!0}function Q(){C(),V();let X=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(X||te(4,[],[]),F(","),V(),a.getToken()===4&&$)break}else X&&te(6,[],[]);G()||te(4,[],[4,5]),X=!0}return M(),a.getToken()!==4?te(8,[4],[]):V(),!0}function G(){switch(a.getToken()){case 3:return Q();case 1:return j();case 10:return H(!0);default:return z()}}return V(),a.getToken()===17?n.allowEmptyContent?!0:(te(4,[],[]),!1):G()?(a.getToken()!==17&&te(9,[],[]),!0):(te(4,[],[]),!1)}e.visit=w;function f(t,r){let n=A(t),a=[],c,o=0,s;do switch(s=n.getPosition(),c=n.scan(),c){case 12:case 13:case 17:o!==s&&a.push(t.substring(o,s)),r!==void 0&&a.push(n.getTokenValue().replace(/[^\r\n]/g,r)),o=n.getPosition();break}while(c!==17);return a.join("")}e.stripComments=f;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(re[51],se([0,1,33]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(E,D,I){let h,y,v,p,d;if(D){for(p=D.offset,d=p+D.length,v=p;v>0&&!b(E,v-1);)v--;let s=d;for(;s<E.length&&!b(E,s);)s++;y=E.substring(v,s),h=A(y,I)}else y=E,h=0,v=0,p=0,d=E.length;const g=P(I,E);let S=!1,w=0,f;I.insertSpaces?f=L(" ",I.tabSize||4):f="	";const l=(0,R.createScanner)(y,!1);let t=!1;function r(){return g+L(f,h+w)}function n(){let s=l.scan();for(S=!1;s===15||s===14;)S=S||s===14,s=l.scan();return t=s===16||l.getTokenError()!==0,s}const a=[];function c(s,u,m){!t&&u<d&&m>p&&E.substring(u,m)!==s&&a.push({offset:u,length:m-u,content:s})}let o=n();if(o!==17){const s=l.getTokenOffset()+v,u=L(f,h);c(u,v,s)}for(;o!==17;){let s=l.getTokenOffset()+l.getTokenLength()+v,u=n(),m="";for(;!S&&(u===12||u===13);){const M=l.getTokenOffset()+v;c(" ",s,M),s=l.getTokenOffset()+l.getTokenLength()+v,m=u===12?r():"",u=n()}if(u===2)o!==1&&(w--,m=r());else if(u===4)o!==3&&(w--,m=r());else{switch(o){case 3:case 1:w++,m=r();break;case 5:case 12:m=r();break;case 13:S?m=r():m=" ";break;case 6:m=" ";break;case 10:if(u===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?m=" ":u!==5&&u!==17&&(t=!0);break;case 16:t=!0;break}S&&(u===12||u===13)&&(m=r())}const C=l.getTokenOffset()+v;c(m,s,C),o=u}return a}e.format=i;function k(E,D){const I=JSON.stringify(E,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?I.replace(/\r\n|\r|\n/g,D.eol):I}e.toFormattedString=k;function L(E,D){let I="";for(let h=0;h<D;h++)I+=E;return I}function A(E,D){let I=0,h=0;const y=D.tabSize||4;for(;I<E.length;){const v=E.charAt(I);if(v===" ")h++;else if(v==="	")h+=y;else break;I++}return Math.floor(h/y)}function P(E,D){for(let I=0;I<D.length;I++){const h=D.charAt(I);if(h==="\r")return I+1<D.length&&D.charAt(I+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=P;function b(E,D){return`\r
`.indexOf(E.charAt(D))!==-1}e.isEOL=b}),define(re[76],se([0,1,33,51]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(E,D,I){return L(E,D,void 0,I)}e.removeProperty=k;function L(E,D,I,h,y){const v=D.slice(),p=[],d=(0,R.parseTree)(E,p);let g,S;for(;v.length>0&&(S=v.pop(),g=(0,R.findNodeAtLocation)(d,v),g===void 0&&I!==void 0);)typeof S=="string"?I={[S]:I}:I=[I];if(g)if(g.type==="object"&&typeof S=="string"&&Array.isArray(g.children)){const w=(0,R.findNodeAtLocation)(g,[S]);if(w!==void 0)if(I===void 0){if(!w.parent)throw new Error("Malformed AST");const f=g.children.indexOf(w.parent);let l,t=w.parent.offset+w.parent.length;if(f>0){const r=g.children[f-1];l=r.offset+r.length}else l=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return A(E,{offset:l,length:t-l,content:""},h)}else return A(E,{offset:w.offset,length:w.length,content:JSON.stringify(I)},h);else{if(I===void 0)return[];const f=`${JSON.stringify(S)}: ${JSON.stringify(I)}`,l=y?y(g.children.map(r=>r.children[0].value)):g.children.length;let t;if(l>0){const r=g.children[l-1];t={offset:r.offset+r.length,length:0,content:","+f}}else g.children.length===0?t={offset:g.offset+1,length:0,content:f}:t={offset:g.offset+1,length:0,content:f+","};return A(E,t,h)}}else if(g.type==="array"&&typeof S=="number"&&Array.isArray(g.children))if(I!==void 0){const w=`${JSON.stringify(I)}`;let f;if(g.children.length===0||S===0)f={offset:g.offset+1,length:0,content:g.children.length===0?w:w+","};else{const l=S===-1||S>g.children.length?g.children.length:S,t=g.children[l-1];f={offset:t.offset+t.length,length:0,content:","+w}}return A(E,f,h)}else{const w=S,f=g.children[w];let l;if(g.children.length===1)l={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===w){const t=g.children[w-1],r=t.offset+t.length,n=g.offset+g.length;l={offset:r,length:n-2-r,content:""}}else l={offset:f.offset,length:g.children[w+1].offset-f.offset,content:""};return A(E,l,h)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${g.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(E,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(I)},h)}}e.setProperty=L;function A(E,D,I){let h=P(E,D),y=D.offset,v=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;y>0&&!(0,i.isEOL)(h,y-1);)y--;for(;v<h.length&&!(0,i.isEOL)(h,v);)v++}const p=(0,i.format)(h,{offset:y,length:v-y},I);for(let g=p.length-1;g>=0;g--){const S=p[g];h=P(h,S),y=Math.min(y,S.offset),v=Math.max(v,S.offset+S.length),v+=S.content.length-S.length}const d=E.length-(h.length-v)-y;return[{offset:y,length:d,content:h.substring(y,v)}]}e.withFormatting=A;function P(E,D){return E.substring(0,D.offset)+D.content+E.substring(D.offset+D.length)}e.applyEdit=P;function b(E,D){let I=D.slice(0).sort((y,v)=>{const p=y.offset-v.offset;return p===0?y.length-v.length:p}),h=E.length;for(let y=I.length-1;y>=0;y--){let v=I[y];if(v.offset+v.length<=h)E=P(E,v);else throw new Error("Overlapping edit");h=v.offset}return E}e.applyEdits=b}),define(re[111],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class R{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new R(()=>k(this.getValue()))}}e.Lazy=R}),define(re[2],se([0,1,75,50]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let L=null;function A(c){L=c}if(e.setDisposableTracker=A,k){const c="__is_disposable_tracked__";A(new class{trackDisposable(o){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(s)},3e3)}setParent(o,s){if(o&&o!==S.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==S.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function P(c){return L?.trackDisposable(c),c}function b(c){L?.markAsDisposed(c)}function E(c,o){L?.setParent(c,o)}function D(c,o){if(!!L)for(const s of c)L.setParent(s,o)}function I(c){return L?.markAsSingleton(c),c}e.markAsSingleton=I;class h extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=h;function y(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=y;function v(c){if(i.Iterable.is(c)){let o=[];for(const s of c)if(s)try{s.dispose()}catch(u){o.push(u)}if(o.length===1)throw o[0];if(o.length>1)throw new h(o);return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=v;function p(...c){const o=d(()=>v(c));return D(c,o),o}e.combinedDisposable=p;function d(c){const o=P({dispose:(0,R.once)(()=>{b(o),c()})});return o}e.toDisposable=d;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{v(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return E(o,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new g,P(this),E(this._store,this)}dispose(){b(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&E(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&E(o,null),o}}e.MutableDisposable=w;class f{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(o){let s=o;return this.unset=()=>s=void 0,this.isset=()=>s!==void 0,this.dispose=()=>{s&&(s(),s=void 0,b(this))},this}}e.SafeDisposable=l;class t{constructor(){this.references=new Map}acquire(o,...s){let u=this.references.get(o);u||(u={counter:0,object:this.createReferencedObject(o,...s)},this.references.set(o,u));const{object:m}=u,C=(0,R.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(o,u.object),this.references.delete(o))});return u.counter++,{object:m,dispose:C}}}e.ReferenceCollection=t;class r{constructor(o){this.referenceCollection=o}async acquire(o,...s){const u=this.referenceCollection.acquire(o,...s);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(m){throw u.dispose(),m}}}e.AsyncReferenceCollection=r;class n{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=n;function a(c){const o=new g;try{c(o)}finally{o.dispose()}}e.disposeOnReturn=a}),define(re[112],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(L){this.element=L,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class i{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let L=this._first;for(;L!==R.Undefined;){const A=L.next;L.prev=R.Undefined,L.next=R.Undefined,L=A}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,A){const P=new R(L);if(this._first===R.Undefined)this._first=P,this._last=P;else if(A){const E=this._last;this._last=P,P.prev=E,E.next=P}else{const E=this._first;this._first=P,P.next=E,E.prev=P}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(P))}}shift(){if(this._first!==R.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==R.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==R.Undefined&&L.next!==R.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===R.Undefined&&L.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):L.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):L.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==R.Undefined;)yield L.element,L=L.next}}e.LinkedList=i});var fe=this&&this.__decorate||function(J,e,R,i){var k=arguments.length,L=k<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,R):i,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(J,e,R,i);else for(var P=J.length-1;P>=0;P--)(A=J[P])&&(L=(k<3?A(L):k>3?A(e,R,L):A(e,R))||L);return k>3&&L&&Object.defineProperty(e,R,L),L};define(re[113],se([0,1,45]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLinkedText=e.LinkedText=void 0;class i{constructor(P){this.nodes=P}toString(){return this.nodes.map(P=>typeof P=="string"?P:P.label).join("")}}e.LinkedText=i,fe([R.memoize],i.prototype,"toString",null);const k=/\[([^\]]+)\]\(((?:https?:\/\/|command:|file:)[^\)\s]+)(?: ("|')([^\3]+)(\3))?\)/gi;function L(A){const P=[];let b=0,E;for(;E=k.exec(A);){E.index-b>0&&P.push(A.substring(b,E.index));const[,D,I,,h]=E;h?P.push({label:D,href:I,title:h}):P.push({label:D,href:I}),b=E.index+E[0].length}return b<A.length&&P.push(A.substring(b)),new i(P)}e.parseLinkedText=L}),function(){function J(k){const L=[];typeof k=="number"&&L.push("code/timeOrigin",k);function A(b){L.push(b,Date.now())}function P(){const b=[];for(let E=0;E<L.length;E+=2)b.push({name:L[E],startTime:L[E+1]});return b}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(k+A.startTime)});return L}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function R(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=R(i))}(),define(re[4],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const R="en";let i=!1,k=!1,L=!1,A=!1,P=!1,b=!1,E=!1,D=!1,I=!1,h,y=R,v,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const g=typeof d?.versions?.electron=="string",S=g&&d?.type==="renderer";if(typeof navigator=="object"&&!S)p=navigator.userAgent,i=p.indexOf("Windows")>=0,k=p.indexOf("Macintosh")>=0,D=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=p.indexOf("Linux")>=0,b=!0,h=navigator.language,y=h;else if(typeof d=="object"){i=d.platform==="win32",k=d.platform==="darwin",L=d.platform==="linux",A=L&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,E=g,I=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=R,y=R;const o=d.env.VSCODE_NLS_CONFIG;if(o)try{const s=JSON.parse(o),u=s.availableLanguages["*"];h=s.locale,y=u||R,v=s._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var w;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(w||(e.Platform=w={}));function f(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=f;let l=0;k?l=1:i?l=3:L&&(l=2),e.isWindows=i,e.isMacintosh=k,e.isLinux=L,e.isLinuxSnap=A,e.isNative=P,e.isElectron=E,e.isWeb=b,e.isWebWorker=b&&typeof e.globals.importScripts=="function",e.isIOS=D,e.isCI=I,e.platform=l,e.userAgent=p,e.language=y;var t;(function(o){function s(){return e.language}o.value=s;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=u;function m(){return e.language==="en"}o.isDefault=m})(t||(e.Language=t={})),e.locale=h,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){let o=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let m=0,C=o.length;m<C;m++){const M=o[m];if(M.id===u.data.vscodeScheduleAsyncWork){o.splice(m,1),M.callback();return}}});let s=0;return u=>{const m=++s;o.push({id:m,callback:u}),e.globals.postMessage({vscodeScheduleAsyncWork:m},"*")}}return o=>setTimeout(o)})();var r;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=k||D?2:i?1:3;let n=!0,a=!1;function c(){if(!a){a=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,n=new Uint16Array(o.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[34],se([0,1,4]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const k=R.globals.vscode.process;i={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(re[12],se([0,1,34]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,k=97,L=90,A=122,P=46,b=47,E=92,D=58,I=63;class h extends Error{constructor(f,l,t){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const n=f.indexOf(".")!==-1?"property":"argument";let a=`The "${f}" ${n} ${r} of type ${l}`;a+=`. Received type ${typeof t}`;super(a);this.code="ERR_INVALID_ARG_TYPE"}}function y(w,f){if(typeof w!="string")throw new h(f,"string",w)}function v(w){return w===b||w===E}function p(w){return w===b}function d(w){return w>=i&&w<=L||w>=k&&w<=A}function g(w,f,l,t){let r="",n=0,a=-1,c=0,o=0;for(let s=0;s<=w.length;++s){if(s<w.length)o=w.charCodeAt(s);else{if(t(o))break;o=b}if(t(o)){if(!(a===s-1||c===1))if(c===2){if(r.length<2||n!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const u=r.lastIndexOf(l);u===-1?(r="",n=0):(r=r.slice(0,u),n=r.length-1-r.lastIndexOf(l)),a=s,c=0;continue}else if(r.length!==0){r="",n=0,a=s,c=0;continue}}f&&(r+=r.length>0?`${l}..`:"..",n=2)}else r.length>0?r+=`${l}${w.slice(a+1,s)}`:r=w.slice(a+1,s),n=s-a-1;a=s,c=0}else o===P&&c!==-1?++c:c=-1}return r}function S(w,f){if(f===null||typeof f!="object")throw new h("pathObject","Object",f);const l=f.dir||f.root,t=f.base||`${f.name||""}${f.ext||""}`;return l?l===f.root?`${l}${t}`:`${l}${w}${t}`:t}e.win32={resolve(...w){let f="",l="",t=!1;for(let r=w.length-1;r>=-1;r--){let n;if(r>=0){if(n=w[r],y(n,"path"),n.length===0)continue}else f.length===0?n=R.cwd():(n=R.env[`=${f}`]||R.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==f.toLowerCase()&&n.charCodeAt(2)===E)&&(n=`${f}\\`));const a=n.length;let c=0,o="",s=!1;const u=n.charCodeAt(0);if(a===1)v(u)&&(c=1,s=!0);else if(v(u))if(s=!0,v(n.charCodeAt(1))){let m=2,C=m;for(;m<a&&!v(n.charCodeAt(m));)m++;if(m<a&&m!==C){const M=n.slice(C,m);for(C=m;m<a&&v(n.charCodeAt(m));)m++;if(m<a&&m!==C){for(C=m;m<a&&!v(n.charCodeAt(m));)m++;(m===a||m!==C)&&(o=`\\\\${M}\\${n.slice(C,m)}`,c=m)}}}else c=1;else d(u)&&n.charCodeAt(1)===D&&(o=n.slice(0,2),c=2,a>2&&v(n.charCodeAt(2))&&(s=!0,c=3));if(o.length>0)if(f.length>0){if(o.toLowerCase()!==f.toLowerCase())continue}else f=o;if(t){if(f.length>0)break}else if(l=`${n.slice(c)}\\${l}`,t=s,s&&f.length>0)break}return l=g(l,!t,"\\",v),t?`${f}\\${l}`:`${f}${l}`||"."},normalize(w){y(w,"path");const f=w.length;if(f===0)return".";let l=0,t,r=!1;const n=w.charCodeAt(0);if(f===1)return p(n)?"\\":w;if(v(n))if(r=!0,v(w.charCodeAt(1))){let c=2,o=c;for(;c<f&&!v(w.charCodeAt(c));)c++;if(c<f&&c!==o){const s=w.slice(o,c);for(o=c;c<f&&v(w.charCodeAt(c));)c++;if(c<f&&c!==o){for(o=c;c<f&&!v(w.charCodeAt(c));)c++;if(c===f)return`\\\\${s}\\${w.slice(o)}\\`;c!==o&&(t=`\\\\${s}\\${w.slice(o,c)}`,l=c)}}}else l=1;else d(n)&&w.charCodeAt(1)===D&&(t=w.slice(0,2),l=2,f>2&&v(w.charCodeAt(2))&&(r=!0,l=3));let a=l<f?g(w.slice(l),!r,"\\",v):"";return a.length===0&&!r&&(a="."),a.length>0&&v(w.charCodeAt(f-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(w){y(w,"path");const f=w.length;if(f===0)return!1;const l=w.charCodeAt(0);return v(l)||f>2&&d(l)&&w.charCodeAt(1)===D&&v(w.charCodeAt(2))},join(...w){if(w.length===0)return".";let f,l;for(let n=0;n<w.length;++n){const a=w[n];y(a,"path"),a.length>0&&(f===void 0?f=l=a:f+=`\\${a}`)}if(f===void 0)return".";let t=!0,r=0;if(typeof l=="string"&&v(l.charCodeAt(0))){++r;const n=l.length;n>1&&v(l.charCodeAt(1))&&(++r,n>2&&(v(l.charCodeAt(2))?++r:t=!1))}if(t){for(;r<f.length&&v(f.charCodeAt(r));)r++;r>=2&&(f=`\\${f.slice(r)}`)}return e.win32.normalize(f)},relative(w,f){if(y(w,"from"),y(f,"to"),w===f)return"";const l=e.win32.resolve(w),t=e.win32.resolve(f);if(l===t||(w=l.toLowerCase(),f=t.toLowerCase(),w===f))return"";let r=0;for(;r<w.length&&w.charCodeAt(r)===E;)r++;let n=w.length;for(;n-1>r&&w.charCodeAt(n-1)===E;)n--;const a=n-r;let c=0;for(;c<f.length&&f.charCodeAt(c)===E;)c++;let o=f.length;for(;o-1>c&&f.charCodeAt(o-1)===E;)o--;const s=o-c,u=a<s?a:s;let m=-1,C=0;for(;C<u;C++){const T=w.charCodeAt(r+C);if(T!==f.charCodeAt(c+C))break;T===E&&(m=C)}if(C!==u){if(m===-1)return t}else{if(s>u){if(f.charCodeAt(c+C)===E)return t.slice(c+C+1);if(C===2)return t.slice(c+C)}a>u&&(w.charCodeAt(r+C)===E?m=C:C===2&&(m=3)),m===-1&&(m=0)}let M="";for(C=r+m+1;C<=n;++C)(C===n||w.charCodeAt(C)===E)&&(M+=M.length===0?"..":"\\..");return c+=m,M.length>0?`${M}${t.slice(c,o)}`:(t.charCodeAt(c)===E&&++c,t.slice(c,o))},toNamespacedPath(w){if(typeof w!="string")return w;if(w.length===0)return"";const f=e.win32.resolve(w);if(f.length<=2)return w;if(f.charCodeAt(0)===E){if(f.charCodeAt(1)===E){const l=f.charCodeAt(2);if(l!==I&&l!==P)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(d(f.charCodeAt(0))&&f.charCodeAt(1)===D&&f.charCodeAt(2)===E)return`\\\\?\\${f}`;return w},dirname(w){y(w,"path");const f=w.length;if(f===0)return".";let l=-1,t=0;const r=w.charCodeAt(0);if(f===1)return v(r)?w:".";if(v(r)){if(l=t=1,v(w.charCodeAt(1))){let c=2,o=c;for(;c<f&&!v(w.charCodeAt(c));)c++;if(c<f&&c!==o){for(o=c;c<f&&v(w.charCodeAt(c));)c++;if(c<f&&c!==o){for(o=c;c<f&&!v(w.charCodeAt(c));)c++;if(c===f)return w;c!==o&&(l=t=c+1)}}}}else d(r)&&w.charCodeAt(1)===D&&(l=f>2&&v(w.charCodeAt(2))?3:2,t=l);let n=-1,a=!0;for(let c=f-1;c>=t;--c)if(v(w.charCodeAt(c))){if(!a){n=c;break}}else a=!1;if(n===-1){if(l===-1)return".";n=l}return w.slice(0,n)},basename(w,f){f!==void 0&&y(f,"ext"),y(w,"path");let l=0,t=-1,r=!0,n;if(w.length>=2&&d(w.charCodeAt(0))&&w.charCodeAt(1)===D&&(l=2),f!==void 0&&f.length>0&&f.length<=w.length){if(f===w)return"";let a=f.length-1,c=-1;for(n=w.length-1;n>=l;--n){const o=w.charCodeAt(n);if(v(o)){if(!r){l=n+1;break}}else c===-1&&(r=!1,c=n+1),a>=0&&(o===f.charCodeAt(a)?--a==-1&&(t=n):(a=-1,t=c))}return l===t?t=c:t===-1&&(t=w.length),w.slice(l,t)}for(n=w.length-1;n>=l;--n)if(v(w.charCodeAt(n))){if(!r){l=n+1;break}}else t===-1&&(r=!1,t=n+1);return t===-1?"":w.slice(l,t)},extname(w){y(w,"path");let f=0,l=-1,t=0,r=-1,n=!0,a=0;w.length>=2&&w.charCodeAt(1)===D&&d(w.charCodeAt(0))&&(f=t=2);for(let c=w.length-1;c>=f;--c){const o=w.charCodeAt(c);if(v(o)){if(!n){t=c+1;break}continue}r===-1&&(n=!1,r=c+1),o===P?l===-1?l=c:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||r===-1||a===0||a===1&&l===r-1&&l===t+1?"":w.slice(l,r)},format:S.bind(null,"\\"),parse(w){y(w,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return f;const l=w.length;let t=0,r=w.charCodeAt(0);if(l===1)return v(r)?(f.root=f.dir=w,f):(f.base=f.name=w,f);if(v(r)){if(t=1,v(w.charCodeAt(1))){let m=2,C=m;for(;m<l&&!v(w.charCodeAt(m));)m++;if(m<l&&m!==C){for(C=m;m<l&&v(w.charCodeAt(m));)m++;if(m<l&&m!==C){for(C=m;m<l&&!v(w.charCodeAt(m));)m++;m===l?t=m:m!==C&&(t=m+1)}}}}else if(d(r)&&w.charCodeAt(1)===D){if(l<=2)return f.root=f.dir=w,f;if(t=2,v(w.charCodeAt(2))){if(l===3)return f.root=f.dir=w,f;t=3}}t>0&&(f.root=w.slice(0,t));let n=-1,a=t,c=-1,o=!0,s=w.length-1,u=0;for(;s>=t;--s){if(r=w.charCodeAt(s),v(r)){if(!o){a=s+1;break}continue}c===-1&&(o=!1,c=s+1),r===P?n===-1?n=s:u!==1&&(u=1):n!==-1&&(u=-1)}return c!==-1&&(n===-1||u===0||u===1&&n===c-1&&n===a+1?f.base=f.name=w.slice(a,c):(f.name=w.slice(a,n),f.base=w.slice(a,c),f.ext=w.slice(n,c))),a>0&&a!==t?f.dir=w.slice(0,a-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...w){let f="",l=!1;for(let t=w.length-1;t>=-1&&!l;t--){const r=t>=0?w[t]:R.cwd();y(r,"path"),r.length!==0&&(f=`${r}/${f}`,l=r.charCodeAt(0)===b)}return f=g(f,!l,"/",p),l?`/${f}`:f.length>0?f:"."},normalize(w){if(y(w,"path"),w.length===0)return".";const f=w.charCodeAt(0)===b,l=w.charCodeAt(w.length-1)===b;return w=g(w,!f,"/",p),w.length===0?f?"/":l?"./":".":(l&&(w+="/"),f?`/${w}`:w)},isAbsolute(w){return y(w,"path"),w.length>0&&w.charCodeAt(0)===b},join(...w){if(w.length===0)return".";let f;for(let l=0;l<w.length;++l){const t=w[l];y(t,"path"),t.length>0&&(f===void 0?f=t:f+=`/${t}`)}return f===void 0?".":e.posix.normalize(f)},relative(w,f){if(y(w,"from"),y(f,"to"),w===f||(w=e.posix.resolve(w),f=e.posix.resolve(f),w===f))return"";const l=1,t=w.length,r=t-l,n=1,a=f.length-n,c=r<a?r:a;let o=-1,s=0;for(;s<c;s++){const m=w.charCodeAt(l+s);if(m!==f.charCodeAt(n+s))break;m===b&&(o=s)}if(s===c)if(a>c){if(f.charCodeAt(n+s)===b)return f.slice(n+s+1);if(s===0)return f.slice(n+s)}else r>c&&(w.charCodeAt(l+s)===b?o=s:s===0&&(o=0));let u="";for(s=l+o+1;s<=t;++s)(s===t||w.charCodeAt(s)===b)&&(u+=u.length===0?"..":"/..");return`${u}${f.slice(n+o)}`},toNamespacedPath(w){return w},dirname(w){if(y(w,"path"),w.length===0)return".";const f=w.charCodeAt(0)===b;let l=-1,t=!0;for(let r=w.length-1;r>=1;--r)if(w.charCodeAt(r)===b){if(!t){l=r;break}}else t=!1;return l===-1?f?"/":".":f&&l===1?"//":w.slice(0,l)},basename(w,f){f!==void 0&&y(f,"ext"),y(w,"path");let l=0,t=-1,r=!0,n;if(f!==void 0&&f.length>0&&f.length<=w.length){if(f===w)return"";let a=f.length-1,c=-1;for(n=w.length-1;n>=0;--n){const o=w.charCodeAt(n);if(o===b){if(!r){l=n+1;break}}else c===-1&&(r=!1,c=n+1),a>=0&&(o===f.charCodeAt(a)?--a==-1&&(t=n):(a=-1,t=c))}return l===t?t=c:t===-1&&(t=w.length),w.slice(l,t)}for(n=w.length-1;n>=0;--n)if(w.charCodeAt(n)===b){if(!r){l=n+1;break}}else t===-1&&(r=!1,t=n+1);return t===-1?"":w.slice(l,t)},extname(w){y(w,"path");let f=-1,l=0,t=-1,r=!0,n=0;for(let a=w.length-1;a>=0;--a){const c=w.charCodeAt(a);if(c===b){if(!r){l=a+1;break}continue}t===-1&&(r=!1,t=a+1),c===P?f===-1?f=a:n!==1&&(n=1):f!==-1&&(n=-1)}return f===-1||t===-1||n===0||n===1&&f===t-1&&f===l+1?"":w.slice(f,t)},format:S.bind(null,"/"),parse(w){y(w,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return f;const l=w.charCodeAt(0)===b;let t;l?(f.root="/",t=1):t=0;let r=-1,n=0,a=-1,c=!0,o=w.length-1,s=0;for(;o>=t;--o){const u=w.charCodeAt(o);if(u===b){if(!c){n=o+1;break}continue}a===-1&&(c=!1,a=o+1),u===P?r===-1?r=o:s!==1&&(s=1):r!==-1&&(s=-1)}if(a!==-1){const u=n===0&&l?1:n;r===-1||s===0||s===1&&r===a-1&&r===n+1?f.base=f.name=w.slice(u,a):(f.name=w.slice(u,r),f.base=w.slice(u,a),f.ext=w.slice(r,a))}return n>0?f.dir=w.slice(0,n-1):l&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(re[114],se([0,1,12]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var i;(function(I){I.text="text/plain",I.binary="application/octet-stream",I.unknown="application/unknown",I.markdown="text/markdown",I.latex="text/latex",I.uriList="text/uri-list"})(i||(e.Mimes=i={}));const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const h=(0,R.extname)(I),y=k[h.toLowerCase()];return y!==void 0?y:P(I)}e.getMediaOrTextMime=A;function P(I){const h=(0,R.extname)(I);return L[h.toLowerCase()]}e.getMediaMime=P;function b(I){for(const h in L)if(L[h]===I)return h}e.getExtensionForMimeType=b;const E=/^(.+)\/(.+?)(;.+)?$/;function D(I,h){const y=E.exec(I);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:h?void 0:I}e.normalizeMimeType=D}),define(re[77],se([0,1,4]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(i||(e.Source=i={}));var k;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function L(P,...b){const E=b.reduce((h,y)=>(h[y]=!0,h),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(h=>!E[h]).forEach(h=>{for(let y=0;y<D.length;y++)if(h.search(D[y])!==-1){delete P[h];break}})}e.sanitizeProcessEnvironment=L;function A(P){!P||(delete P.DEBUG,R.isMacintosh&&delete P.DYLD_LIBRARY_PATH,R.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var i in R)(typeof exports=="object"?exports:J)[i]=R[i]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function R(i){if(e[i])return e[i].exports;var k=e[i]={i,l:!1,exports:{}};return J[i].call(k.exports,k,k.exports,R),k.l=!0,k.exports}return R.m=J,R.c=e,R.d=function(i,k,L){R.o(i,k)||Object.defineProperty(i,k,{enumerable:!0,get:L})},R.r=function(i){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},R.t=function(i,k){if(1&k&&(i=R(i)),8&k||4&k&&typeof i=="object"&&i&&i.__esModule)return i;var L=Object.create(null);if(R.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:i}),2&k&&typeof i!="string")for(var A in i)R.d(L,A,function(P){return i[P]}.bind(null,A));return L},R.n=function(i){var k=i&&i.__esModule?function(){return i.default}:function(){return i};return R.d(k,"a",k),k},R.o=function(i,k){return Object.prototype.hasOwnProperty.call(i,k)},R.p="",R(R.s=0)}([function(J,e,R){(function(i){var k;e=J.exports=W,k=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],b=e.src=[],E=0,D=E++;b[D]="0|[1-9]\\d*";var I=E++;b[I]="[0-9]+";var h=E++;b[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=E++;b[y]="("+b[D]+")\\.("+b[D]+")\\.("+b[D]+")";var v=E++;b[v]="("+b[I]+")\\.("+b[I]+")\\.("+b[I]+")";var p=E++;b[p]="(?:"+b[D]+"|"+b[h]+")";var d=E++;b[d]="(?:"+b[I]+"|"+b[h]+")";var g=E++;b[g]="(?:-("+b[p]+"(?:\\."+b[p]+")*))";var S=E++;b[S]="(?:-?("+b[d]+"(?:\\."+b[d]+")*))";var w=E++;b[w]="[0-9A-Za-z-]+";var f=E++;b[f]="(?:\\+("+b[w]+"(?:\\."+b[w]+")*))";var l=E++,t="v?"+b[y]+b[g]+"?"+b[f]+"?";b[l]="^"+t+"$";var r="[v=\\s]*"+b[v]+b[S]+"?"+b[f]+"?",n=E++;b[n]="^"+r+"$";var a=E++;b[a]="((?:<|>)?=?)";var c=E++;b[c]=b[I]+"|x|X|\\*";var o=E++;b[o]=b[D]+"|x|X|\\*";var s=E++;b[s]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[g]+")?"+b[f]+"?)?)?";var u=E++;b[u]="[v=\\s]*("+b[c]+")(?:\\.("+b[c]+")(?:\\.("+b[c]+")(?:"+b[S]+")?"+b[f]+"?)?)?";var m=E++;b[m]="^"+b[a]+"\\s*"+b[s]+"$";var C=E++;b[C]="^"+b[a]+"\\s*"+b[u]+"$";var M=E++;b[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=E++;b[T]="(?:~>?)";var F=E++;b[F]="(\\s*)"+b[T]+"\\s+",P[F]=new RegExp(b[F],"g");var _=E++;b[_]="^"+b[T]+b[s]+"$";var U=E++;b[U]="^"+b[T]+b[u]+"$";var O=E++;b[O]="(?:\\^)";var $=E++;b[$]="(\\s*)"+b[O]+"\\s+",P[$]=new RegExp(b[$],"g");var V=E++;b[V]="^"+b[O]+b[s]+"$";var te=E++;b[te]="^"+b[O]+b[u]+"$";var H=E++;b[H]="^"+b[a]+"\\s*("+r+")$|^$";var z=E++;b[z]="^"+b[a]+"\\s*("+t+")$|^$";var q=E++;b[q]="(\\s*)"+b[a]+"\\s*("+r+"|"+b[s]+")",P[q]=new RegExp(b[q],"g");var j=E++;b[j]="^\\s*("+b[s]+")\\s+-\\s+("+b[s]+")\\s*$";var Q=E++;b[Q]="^\\s*("+b[u]+")\\s+-\\s+("+b[u]+")\\s*$";var G=E++;b[G]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)k(X,b[X]),P[X]||(P[X]=new RegExp(b[X]));function Z(ae,le){if(ae instanceof W)return ae;if(typeof ae!="string"||ae.length>L||!(le?P[n]:P[l]).test(ae))return null;try{return new W(ae,le)}catch{return null}}function W(ae,le){if(ae instanceof W){if(ae.loose===le)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof W))return new W(ae,le);k("SemVer",ae,le),this.loose=le;var ue=ae.trim().match(le?P[n]:P[l]);if(!ue)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Ie=+Ce;if(Ie>=0&&Ie<A)return Ie}return Ce}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=Z,e.valid=function(ae,le){var ue=Z(ae,le);return ue?ue.version:null},e.clean=function(ae,le){var ue=Z(ae.trim().replace(/^[=v]+/,""),le);return ue?ue.version:null},e.SemVer=W,W.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},W.prototype.toString=function(){return this.version},W.prototype.compare=function(ae){return k("SemVer.compare",this.version,this.loose,ae),ae instanceof W||(ae=new W(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},W.prototype.compareMain=function(ae){return ae instanceof W||(ae=new W(ae,this.loose)),B(this.major,ae.major)||B(this.minor,ae.minor)||B(this.patch,ae.patch)},W.prototype.comparePre=function(ae){if(ae instanceof W||(ae=new W(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var le=0;do{var ue=this.prerelease[le],Ce=ae.prerelease[le];if(k("prerelease compare",le,ue,Ce),ue===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ue===void 0)return-1;if(ue!==Ce)return B(ue,Ce)}while(++le)},W.prototype.inc=function(ae,le){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,le,ue,Ce){typeof ue=="string"&&(Ce=ue,ue=void 0);try{return new W(ae,ue).inc(le,Ce).version}catch{return null}},e.diff=function(ae,le){if(ne(ae,le))return null;var ue=Z(ae),Ce=Z(le);if(ue.prerelease.length||Ce.prerelease.length){for(var Ie in ue)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ue[Ie]!==Ce[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ue)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ue[Ie]!==Ce[Ie])return Ie},e.compareIdentifiers=B;var ee=/^[0-9]+$/;function B(ae,le){var ue=ee.test(ae),Ce=ee.test(le);return ue&&Ce&&(ae=+ae,le=+le),ue&&!Ce?-1:Ce&&!ue?1:ae<le?-1:ae>le?1:0}function N(ae,le,ue){return new W(ae,ue).compare(new W(le,ue))}function x(ae,le,ue){return N(ae,le,ue)>0}function Y(ae,le,ue){return N(ae,le,ue)<0}function ne(ae,le,ue){return N(ae,le,ue)===0}function oe(ae,le,ue){return N(ae,le,ue)!==0}function de(ae,le,ue){return N(ae,le,ue)>=0}function me(ae,le,ue){return N(ae,le,ue)<=0}function Ee(ae,le,ue,Ce){var Ie;switch(le){case"===":typeof ae=="object"&&(ae=ae.version),typeof ue=="object"&&(ue=ue.version),Ie=ae===ue;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof ue=="object"&&(ue=ue.version),Ie=ae!==ue;break;case"":case"=":case"==":Ie=ne(ae,ue,Ce);break;case"!=":Ie=oe(ae,ue,Ce);break;case">":Ie=x(ae,ue,Ce);break;case">=":Ie=de(ae,ue,Ce);break;case"<":Ie=Y(ae,ue,Ce);break;case"<=":Ie=me(ae,ue,Ce);break;default:throw new TypeError("Invalid operator: "+le)}return Ie}function Se(ae,le){if(ae instanceof Se){if(ae.loose===le)return ae;ae=ae.value}if(!(this instanceof Se))return new Se(ae,le);k("comparator",ae,le),this.loose=le,this.parse(ae),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(ae,le){return B(le,ae)},e.major=function(ae,le){return new W(ae,le).major},e.minor=function(ae,le){return new W(ae,le).minor},e.patch=function(ae,le){return new W(ae,le).patch},e.compare=N,e.compareLoose=function(ae,le){return N(ae,le,!0)},e.rcompare=function(ae,le,ue){return N(le,ae,ue)},e.sort=function(ae,le){return ae.sort(function(ue,Ce){return e.compare(ue,Ce,le)})},e.rsort=function(ae,le){return ae.sort(function(ue,Ce){return e.rcompare(ue,Ce,le)})},e.gt=x,e.lt=Y,e.eq=ne,e.neq=oe,e.gte=de,e.lte=me,e.cmp=Ee,e.Comparator=Se;var ve={};function we(ae,le){if(ae instanceof we)return ae.loose===le?ae:new we(ae.raw,le);if(ae instanceof Se)return new we(ae.value,le);if(!(this instanceof we))return new we(ae,le);if(this.loose=le,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function De(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ae(ae,le,ue,Ce,Ie,Ne,Le,Fe,Te,Me,ie,ce,he){return((le=De(ue)?"":De(Ce)?">="+ue+".0.0":De(Ie)?">="+ue+"."+Ce+".0":">="+le)+" "+(Fe=De(Te)?"":De(Me)?"<"+(+Te+1)+".0.0":De(ie)?"<"+Te+"."+(+Me+1)+".0":ce?"<="+Te+"."+Me+"."+ie+"-"+ce:"<="+Fe)).trim()}function Oe(ae,le){for(var ue=0;ue<ae.length;ue++)if(!ae[ue].test(le))return!1;if(le.prerelease.length){for(ue=0;ue<ae.length;ue++)if(k(ae[ue].semver),ae[ue].semver!==ve&&ae[ue].semver.prerelease.length>0){var Ce=ae[ue].semver;if(Ce.major===le.major&&Ce.minor===le.minor&&Ce.patch===le.patch)return!0}return!1}return!0}function We(ae,le,ue){try{le=new we(le,ue)}catch{return!1}return le.test(ae)}function Ke(ae,le,ue,Ce){var Ie,Ne,Le,Fe,Te;switch(ae=new W(ae,Ce),le=new we(le,Ce),ue){case">":Ie=x,Ne=me,Le=Y,Fe=">",Te=">=";break;case"<":Ie=Y,Ne=de,Le=x,Fe="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(We(ae,le,Ce))return!1;for(var Me=0;Me<le.set.length;++Me){var ie=le.set[Me],ce=null,he=null;if(ie.forEach(function(ge){ge.semver===ve&&(ge=new Se(">=0.0.0")),ce=ce||ge,he=he||ge,Ie(ge.semver,ce.semver,Ce)?ce=ge:Le(ge.semver,he.semver,Ce)&&(he=ge)}),ce.operator===Fe||ce.operator===Te||(!he.operator||he.operator===Fe)&&Ne(ae,he.semver)||he.operator===Te&&Le(ae,he.semver))return!1}return!0}Se.prototype.parse=function(ae){var le=this.loose?P[H]:P[z],ue=ae.match(le);if(!ue)throw new TypeError("Invalid comparator: "+ae);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new W(ue[2],this.loose):this.semver=ve},Se.prototype.toString=function(){return this.value},Se.prototype.test=function(ae){return k("Comparator.test",ae,this.loose),this.semver===ve||(typeof ae=="string"&&(ae=new W(ae,this.loose)),Ee(ae,this.operator,this.semver,this.loose))},Se.prototype.intersects=function(ae,le){if(!(ae instanceof Se))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new we(ae.value,le),We(this.value,ue,le);if(ae.operator==="")return ue=new we(this.value,le),We(ae.semver,ue,le);var Ce=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Ne=this.semver.version===ae.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Fe=Ee(this.semver,"<",ae.semver,le)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Te=Ee(this.semver,">",ae.semver,le)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Ce||Ie||Ne&&Le||Fe||Te},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(ae){var le=this.loose;ae=ae.trim(),k("range",ae,le);var ue=le?P[Q]:P[j];ae=ae.replace(ue,Ae),k("hyphen replace",ae),ae=ae.replace(P[q],"$1$2$3"),k("comparator trim",ae,P[q]),ae=(ae=(ae=ae.replace(P[F],"$1~")).replace(P[$],"$1^")).split(/\s+/).join(" ");var Ce=le?P[H]:P[z],Ie=ae.split(" ").map(function(Ne){return function(Le,Fe){return k("comp",Le),Le=function(Te,Me){return Te.trim().split(/\s+/).map(function(ie){return function(ce,he){k("caret",ce,he);var ge=he?P[te]:P[V];return ce.replace(ge,function(be,pe,Pe,ke,_e){var Re;return k("caret",ce,be,pe,Pe,ke,_e),De(pe)?Re="":De(Pe)?Re=">="+pe+".0.0 <"+(+pe+1)+".0.0":De(ke)?Re=pe==="0"?">="+pe+"."+Pe+".0 <"+pe+"."+(+Pe+1)+".0":">="+pe+"."+Pe+".0 <"+(+pe+1)+".0.0":_e?(k("replaceCaret pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),Re=pe==="0"?Pe==="0"?">="+pe+"."+Pe+"."+ke+_e+" <"+pe+"."+Pe+"."+(+ke+1):">="+pe+"."+Pe+"."+ke+_e+" <"+pe+"."+(+Pe+1)+".0":">="+pe+"."+Pe+"."+ke+_e+" <"+(+pe+1)+".0.0"):(k("no pr"),Re=pe==="0"?Pe==="0"?">="+pe+"."+Pe+"."+ke+" <"+pe+"."+Pe+"."+(+ke+1):">="+pe+"."+Pe+"."+ke+" <"+pe+"."+(+Pe+1)+".0":">="+pe+"."+Pe+"."+ke+" <"+(+pe+1)+".0.0"),k("caret return",Re),Re})}(ie,Me)}).join(" ")}(Le,Fe),k("caret",Le),Le=function(Te,Me){return Te.trim().split(/\s+/).map(function(ie){return function(ce,he){var ge=he?P[U]:P[_];return ce.replace(ge,function(be,pe,Pe,ke,_e){var Re;return k("tilde",ce,be,pe,Pe,ke,_e),De(pe)?Re="":De(Pe)?Re=">="+pe+".0.0 <"+(+pe+1)+".0.0":De(ke)?Re=">="+pe+"."+Pe+".0 <"+pe+"."+(+Pe+1)+".0":_e?(k("replaceTilde pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),Re=">="+pe+"."+Pe+"."+ke+_e+" <"+pe+"."+(+Pe+1)+".0"):Re=">="+pe+"."+Pe+"."+ke+" <"+pe+"."+(+Pe+1)+".0",k("tilde return",Re),Re})}(ie,Me)}).join(" ")}(Le,Fe),k("tildes",Le),Le=function(Te,Me){return k("replaceXRanges",Te,Me),Te.split(/\s+/).map(function(ie){return function(ce,he){ce=ce.trim();var ge=he?P[C]:P[m];return ce.replace(ge,function(be,pe,Pe,ke,_e,Re){k("xRange",ce,be,pe,Pe,ke,_e,Re);var $e=De(Pe),ze=$e||De(ke),je=ze||De(_e);return pe==="="&&je&&(pe=""),$e?be=pe===">"||pe==="<"?"<0.0.0":"*":pe&&je?(ze&&(ke=0),je&&(_e=0),pe===">"?(pe=">=",ze?(Pe=+Pe+1,ke=0,_e=0):je&&(ke=+ke+1,_e=0)):pe==="<="&&(pe="<",ze?Pe=+Pe+1:ke=+ke+1),be=pe+Pe+"."+ke+"."+_e):ze?be=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":je&&(be=">="+Pe+"."+ke+".0 <"+Pe+"."+(+ke+1)+".0"),k("xRange return",be),be})}(ie,Me)}).join(" ")}(Le,Fe),k("xrange",Le),Le=function(Te,Me){return k("replaceStars",Te,Me),Te.trim().replace(P[G],"")}(Le,Fe),k("stars",Le),Le}(Ne,le)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Ne){return!!Ne.match(Ce)})),Ie=Ie.map(function(Ne){return new Se(Ne,le)})},we.prototype.intersects=function(ae,le){if(!(ae instanceof we))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(Ce){return ae.set.some(function(Ie){return Ie.every(function(Ne){return Ce.intersects(Ne,le)})})})})},e.toComparators=function(ae,le){return new we(ae,le).set.map(function(ue){return ue.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},we.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new W(ae,this.loose));for(var le=0;le<this.set.length;le++)if(Oe(this.set[le],ae))return!0;return!1},e.satisfies=We,e.maxSatisfying=function(ae,le,ue){var Ce=null,Ie=null;try{var Ne=new we(le,ue)}catch{return null}return ae.forEach(function(Le){Ne.test(Le)&&(Ce&&Ie.compare(Le)!==-1||(Ie=new W(Ce=Le,ue)))}),Ce},e.minSatisfying=function(ae,le,ue){var Ce=null,Ie=null;try{var Ne=new we(le,ue)}catch{return null}return ae.forEach(function(Le){Ne.test(Le)&&(Ce&&Ie.compare(Le)!==1||(Ie=new W(Ce=Le,ue)))}),Ce},e.validRange=function(ae,le){try{return new we(ae,le).range||"*"}catch{return null}},e.ltr=function(ae,le,ue){return Ke(ae,le,"<",ue)},e.gtr=function(ae,le,ue){return Ke(ae,le,">",ue)},e.outside=Ke,e.prerelease=function(ae,le){var ue=Z(ae,le);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(ae,le,ue){return ae=new we(ae,ue),le=new we(le,ue),ae.intersects(le)},e.coerce=function(ae){if(ae instanceof W)return ae;if(typeof ae!="string")return null;var le=ae.match(P[M]);return le==null?null:Z((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,R(1))},function(J,e){var R,i,k=J.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(d){if(R===setTimeout)return setTimeout(d,0);if((R===L||!R)&&setTimeout)return R=setTimeout,setTimeout(d,0);try{return R(d,0)}catch{try{return R.call(null,d,0)}catch{return R.call(this,d,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:L}catch{R=L}try{i=typeof clearTimeout=="function"?clearTimeout:A}catch{i=A}})();var b,E=[],D=!1,I=-1;function h(){D&&b&&(D=!1,b.length?E=b.concat(E):I=-1,E.length&&y())}function y(){if(!D){var d=P(h);D=!0;for(var g=E.length;g;){for(b=E,E=[];++I<g;)b&&b[I].run();I=-1,g=E.length}b=null,D=!1,function(S){if(i===clearTimeout)return clearTimeout(S);if((i===A||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(S);try{i(S)}catch{try{return i.call(null,S)}catch{return i.call(this,S)}}}(d)}}function v(d,g){this.fun=d,this.array=g}function p(){}k.nextTick=function(d){var g=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)g[S-1]=arguments[S];E.push(new v(d,g)),E.length!==1||D||P(y)},v.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=p,k.addListener=p,k.once=p,k.off=p,k.removeListener=p,k.removeAllListeners=p,k.emit=p,k.prependListener=p,k.prependOnceListener=p,k.listeners=function(d){return[]},k.binding=function(d){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(d){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(re[115],se([0,1]),function(J,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(P,b,E){this.level=P,this.key=b,this.value=E,this.forward=[]}}const k=void 0;class L{constructor(P,b=2**16){this.comparator=P,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new i(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new i(this._maxLevel,k,k)}has(P){return Boolean(L._search(this,P,this.comparator))}get(P){return L._search(this,P,this.comparator)?.value}set(P,b){return L._insert(this,P,b,this.comparator)&&(this._size+=1),this}delete(P){const b=L._delete(this,P,this.comparator);return b&&(this._size-=1),b}forEach(P,b){let E=this._header.forward[0];for(;E;)P.call(b,E.value,E.key,this),E=E.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",b=this._header.forward[0];for(;b;)P+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return P}static _search(P,b,E){let D=P._header;for(let I=P._level-1;I>=0;I--)for(;D.forward[I]&&E(D.forward[I].key,b)<0;)D=D.forward[I];if(D=D.forward[0],D&&E(D.key,b)===0)return D}static _insert(P,b,E,D){let I=[],h=P._header;for(let y=P._level-1;y>=0;y--){for(;h.forward[y]&&D(h.forward[y].key,b)<0;)h=h.forward[y];I[y]=h}if(h=h.forward[0],h&&D(h.key,b)===0)return h.value=E,!1;{let y=L._randomLevel(P);if(y>P._level){for(let v=P._level;v<y;v++)I[v]=P._header;P._level=y}h=new i(y,b,E);for(let v=0;v<y;v++)h.forward[v]=I[v].forward[v],I[v].forward[v]=h;return!0}}static _randomLevel(P,b=.5){let E=1;for(;Math.random()<b&&E<P._maxLevel;)E+=1;return E}static _delete(P,b,E){let D=[],I=P._header;for(let h=P._level-1;h>=0;h--){for(;I.forward[h]&&E(I.forward[h].key,b)<0;)I=I.forward[h];D[h]=I}if(I=I.forward[0],!I||E(I.key,b)!==0)return!1;for(let h=0;h<P._level&&D[h].forward[h]===I;h++)D[h].forward[h]=I.forward[h];for(;P._level>0&&P._header.forward[P._level-1]===k;)P._level-=1;return!0}}e.SkipList=L}),define(re[116],se([0,1,4]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=R.globals.performance&&typeof R.globals.performance.now=="function";class k{static create(A=!0){return new k(A)}constructor(A){this._highResolution=i&&A,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=k}),define(re[3],se([0,1,7,75,2,112,116]),function(J,e,R,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let P=!1,b=!1;var E;(function(o){o.None=()=>k.Disposable.None;function s(Z){if(b){const{onListenerDidAdd:W}=Z,ee=v.create();let B=0;Z.onListenerDidAdd=()=>{++B==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),W?.()}}}function u(Z){return(W,ee=null,B)=>{let N=!1,x;return x=Z(Y=>{if(!N)return x?x.dispose():N=!0,W.call(ee,Y)},null,B),N&&x.dispose(),x}}o.once=u;function m(Z,W,ee){return U((B,N=null,x)=>Z(Y=>B.call(N,W(Y)),null,x),ee)}o.map=m;function C(Z,W,ee){return U((B,N=null,x)=>Z(Y=>{W(Y),B.call(N,Y)},null,x),ee)}o.forEach=C;function M(Z,W,ee){return U((B,N=null,x)=>Z(Y=>W(Y)&&B.call(N,Y),null,x),ee)}o.filter=M;function T(Z){return Z}o.signal=T;function F(...Z){return(W,ee=null,B)=>(0,k.combinedDisposable)(...Z.map(N=>N(x=>W.call(ee,x),null,B)))}o.any=F;function _(Z,W,ee,B){let N=ee;return m(Z,x=>(N=W(N,x),N),B)}o.reduce=_;function U(Z,W){let ee;const B={onFirstListenerAdd(){ee=Z(N.fire,N)},onLastListenerRemove(){ee.dispose()}};W||s(B);const N=new d(B);return W&&W.add(N),N.event}function O(Z,W,ee=100,B=!1,N,x){let Y,ne,oe,de=0;const me={leakWarningThreshold:N,onFirstListenerAdd(){Y=Z(Se=>{de++,ne=W(ne,Se),B&&!oe&&(Ee.fire(ne),ne=void 0),clearTimeout(oe),oe=setTimeout(()=>{const ve=ne;ne=void 0,oe=void 0,(!B||de>1)&&Ee.fire(ve),de=0},ee)})},onLastListenerRemove(){Y.dispose()}};x||s(me);const Ee=new d(me);return x&&x.add(Ee),Ee.event}o.debounce=O;function $(Z,W=(B,N)=>B===N,ee){let B=!0,N;return M(Z,x=>{const Y=B||!W(x,N);return B=!1,N=x,Y},ee)}o.latch=$;function V(Z,W,ee){return[o.filter(Z,W,ee),o.filter(Z,B=>!W(B),ee)]}o.split=V;function te(Z,W=!1,ee=[]){let B=ee.slice(),N=Z(ne=>{B?B.push(ne):Y.fire(ne)});const x=()=>{B&&B.forEach(ne=>Y.fire(ne)),B=null},Y=new d({onFirstListenerAdd(){N||(N=Z(ne=>Y.fire(ne)))},onFirstListenerDidAdd(){B&&(W?setTimeout(x):x())},onLastListenerRemove(){N&&N.dispose(),N=null}});return Y.event}o.buffer=te;class H{constructor(W){this.event=W}map(W){return new H(m(this.event,W))}forEach(W){return new H(C(this.event,W))}filter(W){return new H(M(this.event,W))}reduce(W,ee){return new H(_(this.event,W,ee))}latch(){return new H($(this.event))}debounce(W,ee=100,B=!1,N){return new H(O(this.event,W,ee,B,N))}on(W,ee,B){return this.event(W,ee,B)}once(W,ee,B){return u(this.event)(W,ee,B)}}function z(Z){return new H(Z)}o.chain=z;function q(Z,W,ee=B=>B){const B=(...ne)=>Y.fire(ee(...ne)),N=()=>Z.on(W,B),x=()=>Z.removeListener(W,B),Y=new d({onFirstListenerAdd:N,onLastListenerRemove:x});return Y.event}o.fromNodeEventEmitter=q;function j(Z,W,ee=B=>B){const B=(...ne)=>Y.fire(ee(...ne)),N=()=>Z.addEventListener(W,B),x=()=>Z.removeEventListener(W,B),Y=new d({onFirstListenerAdd:N,onLastListenerRemove:x});return Y.event}o.fromDOMEventEmitter=j;function Q(Z){return new Promise(W=>u(Z)(W))}o.toPromise=Q;function G(Z,W){return W(void 0),Z(ee=>W(ee))}o.runAndSubscribe=G;function X(Z,W){let ee=null;function B(x){ee?.dispose(),ee=new k.DisposableStore,W(x,ee)}B(void 0);const N=Z(x=>B(x));return(0,k.toDisposable)(()=>{N.dispose(),ee?.dispose()})}o.runAndSubscribeWithStore=X})(E||(e.Event=E={}));class D{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${D._idPool++}`}start(s){this._stopWatch=new A.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let I=-1;function h(o){const s=I;return I=o,{dispose(){I=s}}}e.setGlobalLeakWarningThreshold=h;class y{constructor(s,u=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s,u){let m=I;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),m<=0||u<m)return;this._stacks||(this._stacks=new Map);const C=this._stacks.get(s.value)||0;if(this._stacks.set(s.value,C+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let M,T=0;for(const[F,_]of this._stacks)(!M||T<_)&&(M=F,T=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${T}):`),console.warn(M)}return()=>{const M=this._stacks.get(s.value)||0;this._stacks.set(s.value,M-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(s,u,m){this.callback=s,this.callbackThis=u,this.stack=m,this.subscription=new k.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class d{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=I>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const s=Array.from(this._listeners);queueMicrotask(()=>{for(const u of s)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(s,u,m)=>{this._listeners||(this._listeners=new L.LinkedList);const C=this._listeners.isEmpty();C&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let M,T;this._leakageMon&&this._listeners.size>=30&&(T=v.create(),M=this._leakageMon.check(T,this._listeners.size+1)),P&&(T=T??v.create());const F=new p(s,u,T),_=this._listeners.push(F);C&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,u);const U=F.subscription.set(()=>{M&&M(),this._disposed||(_(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return m instanceof k.DisposableStore?m.add(U):Array.isArray(m)&&m.push(U),U}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S);for(let u of this._listeners)this._deliveryQueue.push(this,u,s);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=d;class g{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(s,u,m){this._queue.push(new w(s,u,m))}clear(s){const u=new L.LinkedList;for(const m of this._queue)m.emitter!==s&&u.push(m);this._queue=u}deliver(){for(;this._queue.size>0;){const s=this._queue.shift();try{s.listener.invoke(s.event)}catch(u){(0,R.onUnexpectedError)(u)}}}}e.EventDeliveryQueue=g;class S extends g{clear(s){this._queue.clear()}}class w{constructor(s,u,m){this.emitter=s,this.listener=u,this.event=m}}class f extends d{async fireAsync(s,u,m){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const C of this._listeners)this._asyncDeliveryQueue.push([C,s]);for(;this._asyncDeliveryQueue.size>0&&!u.isCancellationRequested;){const[C,M]=this._asyncDeliveryQueue.shift(),T=[],F={...M,token:u,waitUntil:_=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");m&&(_=m(_,C.callback)),T.push(_)}};try{C.invoke(F)}catch(_){(0,R.onUnexpectedError)(_);continue}Object.freeze(T),await Promise.allSettled(T).then(_=>{for(const U of _)U.status==="rejected"&&(0,R.onUnexpectedError)(U.reason)})}}}}e.AsyncEmitter=f;class l extends d{constructor(s){super(s);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=l;class t extends l{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=t;class r extends d{constructor(s){super(s);this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(u=>super.fire(u)),this._queuedEvents=[]})}}e.MicrotaskEmitter=r;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const u={event:s,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const m=()=>{this.hasListeners&&this.unhook(u);const C=this.events.indexOf(u);this.events.splice(C,1)};return(0,k.toDisposable)((0,i.once)(m))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(u=>this.emitter.fire(u))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class a{constructor(){this.buffers=[]}wrapEvent(s){return(u,m,C)=>s(M=>{const T=this.buffers[this.buffers.length-1];T?T.push(()=>u.call(m,M)):u.call(m,M)},void 0,C)}bufferEvents(s){const u=[];this.buffers.push(u);const m=s();return this.buffers.pop(),u.forEach(C=>C()),m}}e.EventBufferer=a;class c{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=k.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(re[23],se([0,1,3]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(P,b){const E=setTimeout(P.bind(b),0);return{dispose(){clearTimeout(E)}}});var k;(function(P){function b(E){return E===P.None||E===P.Cancelled||E instanceof L?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}P.isCancellationToken=b,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(k||(e.CancellationToken=k={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=k.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(re[117],se([0,1,23]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new R.CancellationTokenSource,b=this.task(P.token);return this.result={promise:b,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=i;class k{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const b=JSON.stringify(P);return this.lastArgKey!==b&&(this.lastArgKey=b,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=k;class L{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const b=this.fn(P);return this._map.set(P,b),b}}e.CachedFunction=L}),define(re[78],se([0,1,3,2]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=A=>({onDidChange:R.Event.None,value:A});e.staticObservableValue=k;class L extends i.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super();this._value=P,this.changeEmitter=this._register(new R.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=L}),define(re[40],se([0,1,7,2]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const l=f;return l?typeof l.read=="function":!1}e.isReadable=k;function L(f){const l=f;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=L;function A(f){const l=f;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=A;function P(f,l){return new b(f,l)}e.newWriteableStream=P;class b{constructor(l,t){this.reducer=l,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(t=>t(l))}emitError(l){this.listeners.error.length===0?(0,R.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(t=>t(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,t){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(l,t){if(this.state.destroyed)return;let r;switch(l){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const n=r.indexOf(t);n>=0&&r.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(f,l){const t=[];let r;for(;(r=f.read())!==null;)t.push(r);return l(t)}e.consumeReadable=E;function D(f,l,t){const r=[];let n;for(;(n=f.read())!==null&&r.length<t;)r.push(n);return n===null&&r.length>0?l(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n!="undefined"){const a=n;return n=void 0,a}return f.read()}}}e.peekReadable=D;function I(f,l){return new Promise((t,r)=>{const n=[];h(f,{onData:a=>{l&&n.push(a)},onError:a=>{l?r(a):t(void 0)},onEnd:()=>{t(l?l(n):void 0)}})})}e.consumeStream=I;function h(f,l){let t=!1;return f.on("error",r=>{t||l.onError(r)}),f.on("end",()=>{t||l.onEnd()}),f.on("data",r=>{t||l.onData(r)}),(0,i.toDisposable)(()=>t=!0)}e.listenStream=h;function y(f,l){return new Promise((t,r)=>{const n=new i.DisposableStore,a=[],c=u=>{if(a.push(u),a.length>l)return n.dispose(),f.pause(),t({stream:f,buffer:a,ended:!1})},o=u=>r(u),s=()=>t({stream:f,buffer:a,ended:!0});n.add((0,i.toDisposable)(()=>f.removeListener("error",o))),f.on("error",o),n.add((0,i.toDisposable)(()=>f.removeListener("end",s))),f.on("end",s),n.add((0,i.toDisposable)(()=>f.removeListener("data",c))),f.on("data",c)})}e.peekStream=y;function v(f,l){const t=P(l);return t.end(f),t}e.toStream=v;function p(){const f=P(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=p;function d(f){let l=!1;return{read:()=>l?null:(l=!0,f)}}e.toReadable=d;function g(f,l,t){const r=P(t);return h(f,{onData:n=>r.write(l.data(n)),onError:n=>r.error(l.error?l.error(n):n),onEnd:()=>r.end()}),r}e.transform=g;function S(f,l,t){let r=!1;return{read:()=>{const n=l.read();return r?n:(r=!0,n!==null?t([f,n]):f)}}}e.prefixedReadable=S;function w(f,l,t){let r=!1;const n=P(t);return h(l,{onData:a=>r?n.write(a):(r=!0,n.write(t([f,a]))),onError:a=>n.error(a),onEnd:()=>{r||(r=!0,n.write(f)),n.end()}}),n}e.prefixedStream=w}),define(re[18],se([0,1,40]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let k,L;class A{static alloc(u){return i?new A(Buffer.allocUnsafe(u)):new A(new Uint8Array(u))}static wrap(u){return i&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new A(u)}static fromString(u,m){return!(m?.dontUseNodeBuffer||!1)&&i?new A(Buffer.from(u)):(k||(k=new TextEncoder),new A(k.encode(u)))}static fromByteArray(u){const m=A.alloc(u.length);for(let C=0,M=u.length;C<M;C++)m.buffer[C]=u[C];return m}static concat(u,m){if(typeof m=="undefined"){m=0;for(let T=0,F=u.length;T<F;T++)m+=u[T].byteLength}const C=A.alloc(m);let M=0;for(let T=0,F=u.length;T<F;T++){const _=u[T];C.set(_,M),M+=_.byteLength}return C}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=A.alloc(this.byteLength);return u.set(this),u}toString(){return i?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(u,m){return new A(this.buffer.subarray(u,m))}set(u,m){if(u instanceof A)this.buffer.set(u.buffer,m);else if(u instanceof Uint8Array)this.buffer.set(u,m);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),m);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return E(this.buffer,u)}writeUInt32BE(u,m){D(this.buffer,u,m)}readUInt32LE(u){return I(this.buffer,u)}writeUInt32LE(u,m){h(this.buffer,u,m)}readUInt8(u){return y(this.buffer,u)}writeUInt8(u,m){v(this.buffer,u,m)}}e.VSBuffer=A;function P(s,u){return s[u+0]<<0>>>0|s[u+1]<<8>>>0}e.readUInt16LE=P;function b(s,u,m){s[m+0]=u&255,u=u>>>8,s[m+1]=u&255}e.writeUInt16LE=b;function E(s,u){return s[u]*2**24+s[u+1]*2**16+s[u+2]*2**8+s[u+3]}e.readUInt32BE=E;function D(s,u,m){s[m+3]=u,u=u>>>8,s[m+2]=u,u=u>>>8,s[m+1]=u,u=u>>>8,s[m]=u}e.writeUInt32BE=D;function I(s,u){return s[u+0]<<0>>>0|s[u+1]<<8>>>0|s[u+2]<<16>>>0|s[u+3]<<24>>>0}e.readUInt32LE=I;function h(s,u,m){s[m+0]=u&255,u=u>>>8,s[m+1]=u&255,u=u>>>8,s[m+2]=u&255,u=u>>>8,s[m+3]=u&255}e.writeUInt32LE=h;function y(s,u){return s[u]}e.readUInt8=y;function v(s,u,m){s[m]=u}e.writeUInt8=v;function p(s){return R.consumeReadable(s,u=>A.concat(u))}e.readableToBuffer=p;function d(s){return R.toReadable(s)}e.bufferToReadable=d;function g(s){return R.consumeStream(s,u=>A.concat(u))}e.streamToBuffer=g;async function S(s){return s.ended?A.concat(s.buffer):A.concat([...s.buffer,await g(s.stream)])}e.bufferedStreamToBuffer=S;function w(s){return R.toStream(s,u=>A.concat(u))}e.bufferToStream=w;function f(s){return R.transform(s,{data:u=>typeof u=="string"?A.fromString(u):A.wrap(u)},u=>A.concat(u))}e.streamToBufferReadableStream=f;function l(s){return R.newWriteableStream(u=>A.concat(u),s)}e.newWriteableBufferStream=l;function t(s,u){return R.prefixedReadable(s,u,m=>A.concat(m))}e.prefixedBufferReadable=t;function r(s,u){return R.prefixedStream(s,u,m=>A.concat(m))}e.prefixedBufferStream=r;function n(s){let u=0,m=0,C=0;const M=new Uint8Array(Math.floor(s.length/4*3)),T=_=>{switch(m){case 3:M[C++]=u|_,m=0;break;case 2:M[C++]=u|_>>>2,u=_<<6,m=3;break;case 1:M[C++]=u|_>>>4,u=_<<4,m=2;break;default:u=_<<2,m=1}};for(let _=0;_<s.length;_++){const U=s.charCodeAt(_);if(U>=65&&U<=90)T(U-65);else if(U>=97&&U<=122)T(U-97+26);else if(U>=48&&U<=57)T(U-48+52);else if(U===43||U===45)T(62);else if(U===47||U===95)T(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${s[_]}`)}}const F=C;for(;m>0;)T(0);return A.wrap(M).slice(0,F)}e.decodeBase64=n;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:s},u=!0,m=!1){const C=m?c:a;let M="";const T=s.byteLength%3;let F=0;for(;F<s.byteLength-T;F+=3){const _=s[F+0],U=s[F+1],O=s[F+2];M+=C[_>>>2],M+=C[(_<<4|U>>>4)&63],M+=C[(U<<2|O>>>6)&63],M+=C[O&63]}if(T===1){const _=s[F+0];M+=C[_>>>2],M+=C[_<<4&63],u&&(M+="==")}else if(T===2){const _=s[F+0],U=s[F+1];M+=C[_>>>2],M+=C[(_<<4|U>>>4)&63],M+=C[U<<2&63],u&&(M+="=")}return M}e.encodeBase64=o}),define(re[26],se([0,1,117,111]),function(J,e,R,i){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=L;const A=/{(\d+)}/g;function P(ie,...ce){return ce.length===0?ie:ie.replace(A,function(he,ge){const be=parseInt(ge,10);return isNaN(be)||be<0||be>=ce.length?he:ce[be]})}e.format=P;const b=/{([^}]+)}/g;function E(ie,ce){return ie.replace(b,(he,ge)=>ce[ge]??he)}e.format2=E;function D(ie){return ie.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=D;function I(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function h(ie,ce){let he=0;const ge=ce.charCodeAt(0);for(let be=ie.length-1;be>=0;be--)ie.charCodeAt(be)===ge&&he++;return he}e.count=h;function y(ie,ce,he="\u2026"){return ie.length<=ce?ie:`${ie.substr(0,ce)}${he}`}e.truncate=y;function v(ie,ce=" "){const he=p(ie,ce);return d(he,ce)}e.trim=v;function p(ie,ce){if(!ie||!ce)return ie;const he=ce.length;if(he===0||ie.length===0)return ie;let ge=0;for(;ie.indexOf(ce,ge)===ge;)ge=ge+he;return ie.substring(ge)}e.ltrim=p;function d(ie,ce){if(!ie||!ce)return ie;const he=ce.length,ge=ie.length;if(he===0||ge===0)return ie;let be=ge,pe=-1;for(;pe=ie.lastIndexOf(ce,be-1),!(pe===-1||pe+he!==be);){if(pe===0)return"";be=pe}return ie.substring(0,be)}e.rtrim=d;function g(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function S(ie){return ie.replace(/\*/g,"")}e.stripWildcards=S;function w(ie,ce,he={}){if(!ie)throw new Error("Cannot create regex from empty string");ce||(ie=I(ie)),he.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let ge="";return he.global&&(ge+="g"),he.matchCase||(ge+="i"),he.multiline&&(ge+="m"),he.unicode&&(ge+="u"),new RegExp(ie,ge)}e.createRegExp=w;function f(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function l(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function t(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=t;function r(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=r;function n(ie){for(let ce=0,he=ie.length;ce<he;ce++){const ge=ie.charCodeAt(ce);if(ge!==32&&ge!==9)return ce}return-1}e.firstNonWhitespaceIndex=n;function a(ie,ce=0,he=ie.length){for(let ge=ce;ge<he;ge++){const be=ie.charCodeAt(ge);if(be!==32&&be!==9)return ie.substring(ce,ge)}return ie.substring(ce,he)}e.getLeadingWhitespace=a;function c(ie,ce=ie.length-1){for(let he=ce;he>=0;he--){const ge=ie.charCodeAt(he);if(ge!==32&&ge!==9)return he}return-1}e.lastNonWhitespaceIndex=c;function o(ie,ce,he){let ge=[],be=0;for(const pe of ie.matchAll(ce)){if(ge.push(ie.slice(be,pe.index)),pe.index===void 0)throw new Error("match.index should be defined");be=pe.index+pe[0].length,ge.push(he(pe[0],...pe.slice(1),pe.index,ie,pe.groups))}return ge.push(ie.slice(be)),Promise.all(ge).then(pe=>pe.join(""))}e.replaceAsync=o;function s(ie,ce){return ie<ce?-1:ie>ce?1:0}e.compare=s;function u(ie,ce,he=0,ge=ie.length,be=0,pe=ce.length){for(;he<ge&&be<pe;he++,be++){let _e=ie.charCodeAt(he),Re=ce.charCodeAt(be);if(_e<Re)return-1;if(_e>Re)return 1}const Pe=ge-he,ke=pe-be;return Pe<ke?-1:Pe>ke?1:0}e.compareSubstring=u;function m(ie,ce){return C(ie,ce,0,ie.length,0,ce.length)}e.compareIgnoreCase=m;function C(ie,ce,he=0,ge=ie.length,be=0,pe=ce.length){for(;he<ge&&be<pe;he++,be++){let _e=ie.charCodeAt(he),Re=ce.charCodeAt(be);if(_e===Re)continue;if(_e>=128||Re>=128)return u(ie.toLowerCase(),ce.toLowerCase(),he,ge,be,pe);M(_e)&&(_e-=32),M(Re)&&(Re-=32);const $e=_e-Re;if($e!==0)return $e}const Pe=ge-he,ke=pe-be;return Pe<ke?-1:Pe>ke?1:0}e.compareSubstringIgnoreCase=C;function M(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=M;function T(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=T;function F(ie,ce){return ie.length===ce.length&&C(ie,ce)===0}e.equalsIgnoreCase=F;function _(ie,ce){const he=ce.length;return ce.length>ie.length?!1:C(ie,ce,0,he)===0}e.startsWithIgnoreCase=_;function U(ie,ce){let he,ge=Math.min(ie.length,ce.length);for(he=0;he<ge;he++)if(ie.charCodeAt(he)!==ce.charCodeAt(he))return he;return ge}e.commonPrefixLength=U;function O(ie,ce){let he,ge=Math.min(ie.length,ce.length);const be=ie.length-1,pe=ce.length-1;for(he=0;he<ge;he++)if(ie.charCodeAt(be-he)!==ce.charCodeAt(pe-he))return he;return ge}e.commonSuffixLength=O;function $(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=$;function V(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=V;function te(ie,ce){return(ie-55296<<10)+(ce-56320)+65536}e.computeCodePoint=te;function H(ie,ce,he){const ge=ie.charCodeAt(he);if($(ge)&&he+1<ce){const be=ie.charCodeAt(he+1);if(V(be))return te(ge,be)}return ge}e.getNextCodePoint=H;function z(ie,ce){const he=ie.charCodeAt(ce-1);if(V(he)&&ce>1){const ge=ie.charCodeAt(ce-2);if($(ge))return te(ge,he)}return he}class q{get offset(){return this._offset}constructor(ce,he=0){this._str=ce,this._len=ce.length,this._offset=he}setOffset(ce){this._offset=ce}prevCodePoint(){const ce=z(this._str,this._offset);return this._offset-=ce>=65536?2:1,ce}nextCodePoint(){const ce=H(this._str,this._len,this._offset);return this._offset+=ce>=65536?2:1,ce}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class j{get offset(){return this._iterator.offset}constructor(ce,he=0){this._iterator=new q(ce,he)}nextGraphemeLength(){const ce=ue.getInstance(),he=this._iterator,ge=he.offset;let be=ce.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const pe=he.offset,Pe=ce.getGraphemeBreakType(he.nextCodePoint());if(ae(be,Pe)){he.setOffset(pe);break}be=Pe}return he.offset-ge}prevGraphemeLength(){const ce=ue.getInstance(),he=this._iterator,ge=he.offset;let be=ce.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const pe=he.offset,Pe=ce.getGraphemeBreakType(he.prevCodePoint());if(ae(Pe,be)){he.setOffset(pe);break}be=Pe}return ge-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=j;function Q(ie,ce){return new j(ie,ce).nextGraphemeLength()}e.nextCharLength=Q;function G(ie,ce){return new j(ie,ce).prevGraphemeLength()}e.prevCharLength=G;function X(ie,ce){ce>0&&V(ie.charCodeAt(ce))&&ce--;const he=ce+Q(ie,ce);return[he-G(ie,he),he]}e.getCharContainingOffset=X;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(ie){return Z.test(ie)}e.containsRTL=W;const ee=/^[\t\n\r\x20-\x7E]*$/;function B(ie){return ee.test(ie)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=N;function x(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=x;function Y(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=Y;function ne(ie,ce){if(ie.length<ce)return ie;const he=/\b/g;let ge=0;for(;he.test(ie)&&!(ie.length-he.lastIndex<ce);)ge=he.lastIndex,he.lastIndex+=1;return ie.substring(ge).replace(/^\s/,"")}e.lcut=ne;const oe=/\x1B\x5B[12]?K/g,de=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function Ee(ie){return ie&&(ie=ie.replace(oe,""),ie=ie.replace(de,""),ie=ie.replace(me,"")),ie}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Se(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Se;function ve(ie){return Se(ie)?ie.substr(1):ie}e.stripUTF8BOM=ve;function we(ie,ce){if(!ie||!ce||ie.length<ce.length)return!1;const he=ce.length,ge=ie.toLowerCase();let be=0,pe=-1;for(;be<he;){const Pe=ge.indexOf(ce[be],pe+1);if(Pe<0)return!1;pe=Pe,be++}return!0}e.fuzzyContains=we;function De(ie,ce=!1){return ie?(ce&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=De;function Ae(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=Ae;function Oe(ie,ce=1){if(ce===0)return"";let he=-1;do he=ie.indexOf(`
`,he+1),ce--;while(ce>0&&he>=0);return he===-1?ie:(ie[he-1]==="\r"&&he--,ie.substr(0,he))}e.getNLines=Oe;function We(ie){const ce=90-65+1;return ie=ie%(2*ce),ie<ce?String.fromCharCode(97+ie):String.fromCharCode(65+ie-ce)}e.singleLetterHash=We;function Ke(ie){return ue.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=Ke;function ae(ie,ce){return ie===0?ce!==5&&ce!==7:ie===2&&ce===3?!1:ie===4||ie===2||ie===3||ce===4||ce===2||ce===3?!0:!(ie===8&&(ce===8||ce===9||ce===11||ce===12)||(ie===11||ie===9)&&(ce===9||ce===10)||(ie===12||ie===10)&&ce===10||ce===5||ce===13||ce===7||ie===1||ie===13&&ce===14||ie===6&&ce===6)}var le;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class ue{static getInstance(){return ue._INSTANCE||(ue._INSTANCE=new ue),ue._INSTANCE}constructor(){this._data=Ce()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const he=this._data,ge=he.length/3;let be=1;for(;be<=ge;)if(ce<he[3*be])be=2*be;else if(ce>he[3*be+1])be=2*be+1;else return he[3*be+2];return 0}}ue._INSTANCE=null;function Ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ie(ie,ce){if(ie===0)return 0;const he=Ne(ie,ce);if(he!==void 0)return he;const ge=new q(ce,ie);return ge.prevCodePoint(),ge.offset}e.getLeftDeleteOffset=Ie;function Ne(ie,ce){const he=new q(ce,ie);let ge=he.prevCodePoint();for(;Le(ge)||ge===65039||ge===8419;){if(he.offset===0)return;ge=he.prevCodePoint()}if(!Y(ge))return;let be=he.offset;return be>0&&he.prevCodePoint()===8205&&(be=he.offset),be}function Le(ie){return 127995<=ie&&ie<=127999}var Fe;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class Te{static getInstance(ce){return k.cache.get(Array.from(ce))}static getLocales(){return k._locales.getValue()}constructor(ce){this.confusableDictionary=ce}isAmbiguous(ce){return this.confusableDictionary.has(ce)}getPrimaryConfusable(ce){return this.confusableDictionary.get(ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Te,k=Te,Te.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Te.cache=new R.LRUCachedFunction(ie=>{function ce(Re){const $e=new Map;for(let ze=0;ze<Re.length;ze+=2)$e.set(Re[ze],Re[ze+1]);return $e}function he(Re,$e){const ze=new Map(Re);for(const[je,Ze]of $e)ze.set(je,Ze);return ze}function ge(Re,$e){if(!Re)return $e;const ze=new Map;for(const[je,Ze]of Re)$e.has(je)&&ze.set(je,Ze);return ze}const be=k.ambiguousCharacterData.getValue();let pe=ie.filter(Re=>!Re.startsWith("_")&&Re in be);pe.length===0&&(pe=["_default"]);let Pe;for(const Re of pe){const $e=ce(be[Re]);Pe=ge(Pe,$e)}const ke=ce(be._common),_e=he(ke,Pe);return new k(_e)}),Te._locales=new i.Lazy(()=>Object.keys(k.ambiguousCharacterData.getValue()).filter(ie=>!ie.startsWith("_")));class Me{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Me.getRawData())),this._data}static isInvisibleCharacter(ce){return Me.getData().has(ce)}static get codePoints(){return Me.getData()}}e.InvisibleCharacters=Me,Me._data=void 0}),define(re[79],se([0,1,26]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(g){return k(g,0)}e.hash=i;function k(g,S){switch(typeof g){case"object":return g===null?L(349,S):Array.isArray(g)?b(g,S):E(g,S);case"string":return P(g,S);case"boolean":return A(g,S);case"number":return L(g,S);case"undefined":return L(937,S);default:return L(617,S)}}e.doHash=k;function L(g,S){return(S<<5)-S+g|0}e.numberHash=L;function A(g,S){return L(g?433:863,S)}function P(g,S){S=L(149417,S);for(let w=0,f=g.length;w<f;w++)S=L(g.charCodeAt(w),S);return S}e.stringHash=P;function b(g,S){return S=L(104579,S),g.reduce((w,f)=>k(f,w),S)}function E(g,S){return S=L(181387,S),Object.keys(g).sort().reduce((w,f)=>(w=P(f,w),k(g[f],w)),S)}class D{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=k(S,this._value),this._value}}e.Hasher=D;var I;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function h(g,S,w=32){const f=w-S,l=~((1<<f)-1);return(g<<S|(l&g)>>>f)>>>0}function y(g,S=0,w=g.byteLength,f=0){for(let l=0;l<w;l++)g[S+l]=f}function v(g,S,w="0"){for(;g.length<S;)g=w+g;return g}function p(g,S=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(w=>w.toString(16).padStart(2,"0")).join(""):v((g>>>0).toString(16),S/4)}e.toHexString=p;class d{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const w=S.length;if(w===0)return;const f=this._buff;let l=this._buffLen,t=this._leftoverHighSurrogate,r,n;for(t!==0?(r=t,n=-1,t=0):(r=S.charCodeAt(0),n=0);;){let a=r;if(R.isHighSurrogate(r))if(n+1<w){const c=S.charCodeAt(n+1);R.isLowSurrogate(c)?(n++,a=R.computeCodePoint(r,c)):a=65533}else{t=r;break}else R.isLowSurrogate(r)&&(a=65533);if(l=this._push(f,l,a),n++,n<w)r=S.charCodeAt(n);else break}this._buffLen=l,this._leftoverHighSurrogate=t}_push(S,w,f){return f<128?S[w++]=f:f<2048?(S[w++]=192|(f&1984)>>>6,S[w++]=128|(f&63)>>>0):f<65536?(S[w++]=224|(f&61440)>>>12,S[w++]=128|(f&4032)>>>6,S[w++]=128|(f&63)>>>0):(S[w++]=240|(f&1835008)>>>18,S[w++]=128|(f&258048)>>>12,S[w++]=128|(f&4032)>>>6,S[w++]=128|(f&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=d._bigBlock32,w=this._buffDV;for(let s=0;s<64;s+=4)S.setUint32(s,w.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)S.setUint32(s,h(S.getUint32(s-12,!1)^S.getUint32(s-32,!1)^S.getUint32(s-56,!1)^S.getUint32(s-64,!1),1),!1);let f=this._h0,l=this._h1,t=this._h2,r=this._h3,n=this._h4,a,c,o;for(let s=0;s<80;s++)s<20?(a=l&t|~l&r,c=1518500249):s<40?(a=l^t^r,c=1859775393):s<60?(a=l&t|l&r|t&r,c=2400959708):(a=l^t^r,c=3395469782),o=h(f,5)+a+n+c+S.getUint32(s*4,!1)&4294967295,n=r,r=t,t=h(l,30),l=f,f=o;this._h0=this._h0+f&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=d,d._bigBlock32=new DataView(new ArrayBuffer(320))});var Ge=this&&this.__classPrivateFieldGet||function(J,e,R,i){if(R==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return R==="m"?i:R==="a"?i.call(J):i?i.value:e.get(J)},pt=this&&this.__classPrivateFieldSet||function(J,e,R,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(J,R):k?k.value=R:e.set(J,R),R};define(re[39],se([0,1,16,26]),function(J,e,R,i){"use strict";var k,L,A,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(c,o,s){let u=c.get(o);return u===void 0&&(u=s,c.set(o,u)),u}e.getOrSet=b;function E(c){const o=[];return c.forEach((s,u)=>{o.push(`${u} => ${s}`)}),`Map(${c.size}) {${o.join(", ")}}`}e.mapToString=E;function D(c){const o=[];return c.forEach(s=>{o.push(s)}),`Set(${c.size}) {${o.join(", ")}}`}e.setToString=D;class I{constructor(){this._value="",this._pos=0}reset(o){return this._value=o,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(o){const s=o.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=I;class h{constructor(o=!0){this._caseSensitive=o}reset(o){return this._value=o,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(o)this._from++;else break;else o=!1;return this}cmp(o){return this._caseSensitive?(0,i.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=h;class y{constructor(o=!0,s=!0){this._splitOnBackslash=o,this._caseSensitive=s}reset(o){this._from=0,this._to=0,this._value=o,this._valueLen=o.length;for(let s=o.length-1;s>=0;s--,this._valueLen--){const u=this._value.charCodeAt(s);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let o=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(o)this._from++;else break;else o=!1}return this}cmp(o){return this._caseSensitive?(0,i.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var v;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(v||(v={}));class p{constructor(o,s){this._ignorePathCasing=o,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(o){return this._value=o,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(o)),this._pathIterator.reset(o.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(o)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(o){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(o,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(o,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(o);if(this._states[this._stateIdx]===4)return(0,i.compare)(o,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(o,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(g||(g={}));class S{static forUris(o=()=>!1,s=()=>!1){return new S(new p(o,s))}static forPaths(o=!1){return new S(new y(void 0,!o))}static forStrings(){return new S(new I)}static forConfigKeys(){return new S(new h)}constructor(o){this._iter=o}clear(){this._root=void 0}fill(o,s){if(s){const u=s.slice(0);(0,R.shuffle)(u);for(let m of u)this.set(m,o)}else{const u=o.slice(0);(0,R.shuffle)(u);for(let m of u)this.set(m[0],m[1])}}set(o,s){const u=this._iter.reset(o);let m;this._root||(this._root=new d,this._root.segment=u.value());const C=[];for(m=this._root;;){const T=u.cmp(m.segment);if(T>0)m.left||(m.left=new d,m.left.segment=u.value()),C.push([-1,m]),m=m.left;else if(T<0)m.right||(m.right=new d,m.right.segment=u.value()),C.push([1,m]),m=m.right;else if(u.hasNext())u.next(),m.mid||(m.mid=new d,m.mid.segment=u.value()),C.push([0,m]),m=m.mid;else break}const M=m.value;m.value=s,m.key=o;for(let T=C.length-1;T>=0;T--){const F=C[T][1];F.updateHeight();const _=F.balanceFactor();if(_<-1||_>1){const U=C[T][0],O=C[T+1][0];if(U===1&&O===1)C[T][1]=F.rotateLeft();else if(U===-1&&O===-1)C[T][1]=F.rotateRight();else if(U===1&&O===-1)F.right=C[T+1][1]=C[T+1][1].rotateRight(),C[T][1]=F.rotateLeft();else if(U===-1&&O===1)F.left=C[T+1][1]=C[T+1][1].rotateLeft(),C[T][1]=F.rotateRight();else throw new Error;if(T>0)switch(C[T-1][0]){case-1:C[T-1][1].left=C[T][1];break;case 1:C[T-1][1].right=C[T][1];break;case 0:C[T-1][1].mid=C[T][1];break}else this._root=C[0][1]}}return M}get(o){return this._getNode(o)?.value}_getNode(o){const s=this._iter.reset(o);let u=this._root;for(;u;){const m=s.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(o){const s=this._getNode(o);return!(s?.value===void 0&&s?.mid===void 0)}delete(o){return this._delete(o,!1)}deleteSuperstr(o){return this._delete(o,!0)}_delete(o,s){const u=this._iter.reset(o),m=[];let C=this._root;for(;C;){const M=u.cmp(C.segment);if(M>0)m.push([-1,C]),C=C.left;else if(M<0)m.push([1,C]),C=C.right;else if(u.hasNext())u.next(),m.push([0,C]),C=C.mid;else break}if(!!C){if(s?(C.left=void 0,C.mid=void 0,C.right=void 0,C.height=1):(C.key=void 0,C.value=void 0),!C.mid&&!C.value)if(C.left&&C.right){const M=this._min(C.right),{key:T,value:F,segment:_}=M;this._delete(M.key,!1),C.key=T,C.value=F,C.segment=_}else{const M=C.left??C.right;if(m.length>0){const[T,F]=m[m.length-1];switch(T){case-1:F.left=M;break;case 0:F.mid=M;break;case 1:F.right=M;break}}else this._root=M}for(let M=m.length-1;M>=0;M--){const T=m[M][1];T.updateHeight();const F=T.balanceFactor();if(F>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),m[M][1]=T.rotateLeft()):F<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),m[M][1]=T.rotateRight()),M>0)switch(m[M-1][0]){case-1:m[M-1][1].left=m[M][1];break;case 1:m[M-1][1].right=m[M][1];break;case 0:m[M-1][1].mid=m[M][1];break}else this._root=m[0][1]}}}_min(o){for(;o.left;)o=o.left;return o}findSubstr(o){const s=this._iter.reset(o);let u=this._root,m;for(;u;){const C=s.cmp(u.segment);if(C>0)u=u.left;else if(C<0)u=u.right;else if(s.hasNext())s.next(),m=u.value||m,u=u.mid;else break}return u&&u.value||m}findSuperstr(o){const s=this._iter.reset(o);let u=this._root;for(;u;){const m=s.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(o){for(const[s,u]of this)o(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(o){!o||(o.left&&(yield*this._entries(o.left)),o.value&&(yield[o.key,o.value]),o.mid&&(yield*this._entries(o.mid)),o.right&&(yield*this._entries(o.right)))}_isBalanced(){const o=s=>{if(!s)return!0;const u=s.balanceFactor();return u<-1||u>1?!1:o(s.left)&&o(s.right)};return o(this._root)}}e.TernarySearchTree=S;class w{constructor(o,s){this.uri=o,this.value=s}}class f{constructor(o,s){this[k]="ResourceMap",o instanceof f?(this.map=new Map(o.map),this.toKey=s??f.defaultToKey):(this.map=new Map,this.toKey=o??f.defaultToKey)}set(o,s){return this.map.set(this.toKey(o),new w(o,s)),this}get(o){return this.map.get(this.toKey(o))?.value}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,s){typeof s!="undefined"&&(o=o.bind(s));for(let[u,m]of this.map)o(m.value,m.uri,this)}*values(){for(let o of this.map.values())yield o.value}*keys(){for(let o of this.map.values())yield o.uri}*entries(){for(let o of this.map.values())yield[o.uri,o.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let[,o]of this.map)yield[o.uri,o.value]}}e.ResourceMap=f,f.defaultToKey=c=>c.toString();class l{constructor(o,s){this[L]="ResourceSet",!o||typeof o=="function"?this._map=new f(o):(this._map=new f(s),o.forEach(this.add,this))}get size(){return this._map.size}add(o){return this._map.set(o,o),this}clear(){this._map.clear()}delete(o){return this._map.delete(o)}forEach(o,s){this._map.forEach((u,m)=>o.call(s,m,m,this))}has(o){return this._map.has(o)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var t;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(t||(e.Touch=t={}));class r{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(o){return this._map.has(o)}get(o,s=0){const u=this._map.get(o);if(!!u)return s!==0&&this.touch(u,s),u.value}set(o,s,u=0){let m=this._map.get(o);if(m)m.value=s,u!==0&&this.touch(m,u);else{switch(m={key:o,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(o,m),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const s=this._map.get(o);if(!!s)return this._map.delete(o),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}forEach(o,s){const u=this._state;let m=this._head;for(;m;){if(s?o.bind(s)(m.value,m.key,this):o(m.value,m.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const o=this,s=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(o._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const C={value:u.key,done:!1};return u=u.next,C}else return{value:void 0,done:!0}}};return m}values(){const o=this,s=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(o._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const C={value:u.value,done:!1};return u=u.next,C}else return{value:void 0,done:!0}}};return m}entries(){const o=this,s=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(o._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const C={value:[u.key,u.value],done:!1};return u=u.next,C}else return{value:void 0,done:!0}}};return m}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(o>=this.size)return;if(o===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>o;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const s=o.next,u=o.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}o.next=void 0,o.previous=void 0,this._state++}touch(o,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(o===this._head)return;const u=o.next,m=o.previous;o===this._tail?(m.next=void 0,this._tail=m):(u.previous=m,m.next=u),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(s===2){if(o===this._tail)return;const u=o.next,m=o.previous;o===this._head?(u.previous=void 0,this._head=u):(u.previous=m,m.next=u),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((s,u)=>{o.push([u,s])}),o}fromJSON(o){this.clear();for(const[s,u]of o)this.set(s,u)}}e.LinkedMap=r;class n extends r{constructor(o,s=1){super();this._limit=o,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,s=2){return super.get(o,s)}peek(o){return super.get(o,0)}set(o,s){return super.set(o,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class a{get size(){return Ge(this,P,"f").size}constructor(o){P.set(this,void 0),pt(this,P,o,"f")}forEach(o,s){Ge(this,P,"f").forEach(o,s)}get(o){return Ge(this,P,"f").get(o)}has(o){return Ge(this,P,"f").has(o)}entries(){return Ge(this,P,"f").entries()}keys(){return Ge(this,P,"f").keys()}values(){return Ge(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Ge(this,P,"f").entries()}}e.ReadonlyMapView=a}),define(re[80],se([0,1,39]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new R.LRUCache(1e4);function k(E){return b(E,"NFC",i)}e.normalizeNFC=k;const L=new R.LRUCache(1e4);function A(E){return b(E,"NFD",L)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function b(E,D,I){if(!E)return E;const h=I.get(E);if(h)return h;let y;return P.test(E)?y=E.normalize(D):y=E,I.set(E,y),y}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(D){return A(D).replace(E,"")}}()}),define(re[59],se([0,1,26]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(i||(i={})),function(k){const L="error",A="warning",P="warn",b="info",E="ignore";function D(h){return h?R.equalsIgnoreCase(L,h)?k.Error:R.equalsIgnoreCase(A,h)||R.equalsIgnoreCase(P,h)?k.Warning:R.equalsIgnoreCase(b,h)?k.Info:k.Ignore:k.Ignore}k.fromValue=D;function I(h){switch(h){case k.Error:return L;case k.Warning:return A;case k.Info:return b;default:return E}}k.toString=I}(i||(i={})),e.default=i}),define(re[13],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function R(s){return Array.isArray(s)}e.isArray=R;function i(s){return typeof s=="string"}e.isString=i;function k(s){return Array.isArray(s)&&s.every(u=>i(u))}e.isStringArray=k;function L(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=L;function A(s){return typeof s=="object"&&(s instanceof Uint8Array||s instanceof Uint16Array||s instanceof Uint32Array||s instanceof Float32Array||s instanceof Float64Array||s instanceof Int8Array||s instanceof Int16Array||s instanceof Int32Array||s instanceof BigInt64Array||s instanceof BigUint64Array||s instanceof Uint8ClampedArray)}e.isTypedArray=A;function P(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=P;function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=b;function E(s){return s===!0||s===!1}e.isBoolean=E;function D(s){return typeof s=="undefined"}e.isUndefined=D;function I(s){return!h(s)}e.isDefined=I;function h(s){return D(s)||s===null}e.isUndefinedOrNull=h;function y(s,u){if(!s)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=y;function v(s){if(h(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=v;function p(...s){const u=[];for(let m=0;m<s.length;m++){const C=s[m];if(h(C))throw new Error(`Assertion Failed: argument at index ${m} is undefined or null`);u.push(C)}return u}e.assertAllDefined=p;const d=Object.prototype.hasOwnProperty;function g(s){if(!L(s))return!1;for(let u in s)if(d.call(s,u))return!1;return!0}e.isEmptyObject=g;function S(s){return typeof s=="function"}e.isFunction=S;function w(...s){return s.length>0&&s.every(S)}e.areFunctions=w;function f(s,u){const m=Math.min(s.length,u.length);for(let C=0;C<m;C++)l(s[C],u[C])}e.validateConstraints=f;function l(s,u){if(i(u)){if(typeof s!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(S(u)){try{if(s instanceof u)return}catch{}if(!h(s)&&s.constructor===u||u.length===1&&u.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function t(s){let u=[],m=Object.getPrototypeOf(s);for(;Object.prototype!==m;)u=u.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return u}e.getAllPropertyNames=t;function r(s){const u=[];for(const m of t(s))typeof s[m]=="function"&&u.push(m);return u}e.getAllMethodNames=r;function n(s,u){const m=M=>function(){const T=Array.prototype.slice.call(arguments,0);return u(M,T)};let C={};for(const M of s)C[M]=m(M);return C}e.createProxyObject=n;function a(s){return s===null?void 0:s}e.withNullAsUndefined=a;function c(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=c;function o(s,u="Unreachable"){throw new Error(u)}e.assertNever=o}),define(re[41],se([0,1,12,4,26,13]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(c){return c===47||c===92}e.isPathSeparator=A;function P(c){return c.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function b(c){return c.indexOf("/")===-1&&(c=P(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=b;function E(c,o=R.posix.sep){if(!c)return"";const s=c.length,u=c.charCodeAt(0);if(A(u)){if(A(c.charCodeAt(1))&&!A(c.charCodeAt(2))){let C=3;const M=C;for(;C<s&&!A(c.charCodeAt(C));C++);if(M!==C&&!A(c.charCodeAt(C+1))){for(C+=1;C<s;C++)if(A(c.charCodeAt(C)))return c.slice(0,C+1).replace(/[\\/]/g,o)}}return o}else if(g(u)&&c.charCodeAt(1)===58)return A(c.charCodeAt(2))?c.slice(0,2)+o:c.slice(0,2);let m=c.indexOf("://");if(m!==-1){for(m+=3;m<s;m++)if(A(c.charCodeAt(m)))return c.slice(0,m+1)}return""}e.getRoot=E;function D(c){if(!i.isWindows||!c||c.length<5)return!1;let o=c.charCodeAt(0);if(o!==92||(o=c.charCodeAt(1),o!==92))return!1;let s=2;const u=s;for(;s<c.length&&(o=c.charCodeAt(s),o!==92);s++);return!(u===s||(o=c.charCodeAt(s+1),isNaN(o)||o===92))}e.isUNC=D;const I=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(c,o=i.isWindows){const s=o?I:h;return!(!c||c.length===0||/^\s+$/.test(c)||(s.lastIndex=0,s.test(c))||o&&y.test(c)||c==="."||c===".."||o&&c[c.length-1]==="."||o&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=v;function p(c,o,s){const u=c===o;return!s||u?u:!c||!o?!1:(0,k.equalsIgnoreCase)(c,o)}e.isEqual=p;function d(c,o,s,u=R.sep){if(c===o)return!0;if(!c||!o||o.length>c.length)return!1;if(s){if(!(0,k.startsWithIgnoreCase)(c,o))return!1;if(o.length===c.length)return!0;let C=o.length;return o.charAt(o.length-1)===u&&C--,c.charAt(C)===u}return o.charAt(o.length-1)!==u&&(o+=u),c.indexOf(o)===0}e.isEqualOrParent=d;function g(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=g;function S(c,o){return i.isWindows&&c.endsWith(":")&&(c+=R.sep),(0,R.isAbsolute)(c)||(c=(0,R.join)(o,c)),c=(0,R.normalize)(c),i.isWindows?(c=(0,k.rtrim)(c,R.sep),c.endsWith(":")&&(c+=R.sep)):(c=(0,k.rtrim)(c,R.sep),c||(c=R.sep)),c}e.sanitizeFilePath=S;function w(c){const o=(0,R.normalize)(c);return i.isWindows?c.length>3?!1:f(o)&&(c.length===2||o.charCodeAt(2)===92):o===R.posix.sep}e.isRootOrDriveLetter=w;function f(c,o=i.isWindows){return o?g(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function l(c){return f(c)?c[0]:void 0}e.getDriveLetter=l;function t(c,o,s){return o.length>c.length?-1:c===o?0:(s&&(c=c.toLowerCase(),o=o.toLowerCase()),c.indexOf(o))}e.indexOfPath=t;function r(c){const o=c.split(":");let s,u,m;for(const C of o){const M=Number(C);(0,L.isNumber)(M)?u===void 0?u=M:m===void 0&&(m=M):s=s?[s,C].join(":"):C}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:u!==void 0?u:void 0,column:m!==void 0?m:u!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(c,o,s=8){let u="";for(let C=0;C<s;C++)u+=n.charAt(Math.floor(Math.random()*n.length));let m;return o?m=`${o}-${u}`:m=u,c?(0,R.join)(c,m):m}e.randomPath=a}),define(re[28],se([0,1,13]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const d=Array.isArray(p)?[]:{};return Object.keys(p).forEach(g=>{p[g]&&typeof p[g]=="object"?d[g]=i(p[g]):d[g]=p[g]}),d}e.deepClone=i;function k(p){if(!p||typeof p!="object")return p;const d=[p];for(;d.length>0;){const g=d.shift();Object.freeze(g);for(const S in g)if(L.call(g,S)){const w=g[S];typeof w=="object"&&!Object.isFrozen(w)&&!(0,R.isTypedArray)(w)&&d.push(w)}}return p}e.deepFreeze=k;const L=Object.prototype.hasOwnProperty;function A(p,d){return P(p,d,new Set)}e.cloneAndChange=A;function P(p,d,g){if((0,R.isUndefinedOrNull)(p))return p;const S=d(p);if(typeof S!="undefined")return S;if((0,R.isArray)(p)){const w=[];for(const f of p)w.push(P(f,d,g));return w}if((0,R.isObject)(p)){if(g.has(p))throw new Error("Cannot clone recursive data-structure");g.add(p);const w={};for(let f in p)L.call(p,f)&&(w[f]=P(p[f],d,g));return g.delete(p),w}return p}function b(p,d,g=!0){return(0,R.isObject)(p)?((0,R.isObject)(d)&&Object.keys(d).forEach(S=>{S in p?g&&((0,R.isObject)(p[S])&&(0,R.isObject)(d[S])?b(p[S],d[S],g):p[S]=d[S]):p[S]=d[S]}),p):d}e.mixin=b;function E(p,d){if(p===d)return!0;if(p==null||d===null||d===void 0||typeof p!=typeof d||typeof p!="object"||Array.isArray(p)!==Array.isArray(d))return!1;let g,S;if(Array.isArray(p)){if(p.length!==d.length)return!1;for(g=0;g<p.length;g++)if(!E(p[g],d[g]))return!1}else{const w=[];for(S in p)w.push(S);w.sort();const f=[];for(S in d)f.push(S);if(f.sort(),!E(w,f))return!1;for(g=0;g<w.length;g++)if(!E(p[w[g]],d[w[g]]))return!1}return!0}e.equals=E;function D(p){const d=new Set;return JSON.stringify(p,(g,S)=>{if((0,R.isObject)(S)||Array.isArray(S)){if(d.has(S))return"[Circular]";d.add(S)}return S})}e.safeStringify=D;function I(p,d,g){const S=d(p);return typeof S=="undefined"?g:S}e.getOrDefault=I;function h(p,d){const g=Object.create(null);return!p||!d||Object.keys(d).forEach(w=>{const f=p[w],l=d[w];E(f,l)||(g[w]=l)}),g}e.distinct=h;function y(p,d){const g=d.toLowerCase(),S=Object.keys(p).find(w=>w.toLowerCase()===g);return S?p[S]:p[d]}e.getCaseInsensitive=y;function v(p,d){const g=Object.create(null);for(const[S,w]of Object.entries(p))d(S,w)&&(g[S]=w);return g}e.filter=v}),define(re[8],se([0,1,12,4]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function P(n,a){if(!n.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!L.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(n,a){return!n&&!a?"file":n}function E(n,a){switch(n){case"https":case"http":case"file":a?a[0]!==I&&(a=I+a):a=I;break}return a}const D="",I="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(a){return a instanceof y?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,c,o,s,u,m=!1){typeof a=="object"?(this.scheme=a.scheme||D,this.authority=a.authority||D,this.path=a.path||D,this.query=a.query||D,this.fragment=a.fragment||D):(this.scheme=b(a,m),this.authority=c||D,this.path=E(this.scheme,o||D),this.query=s||D,this.fragment=u||D,P(this,m))}get fsPath(){return w(this,!1)}with(a){if(!a)return this;let{scheme:c,authority:o,path:s,query:u,fragment:m}=a;return c===void 0?c=this.scheme:c===null&&(c=D),o===void 0?o=this.authority:o===null&&(o=D),s===void 0?s=this.path:s===null&&(s=D),u===void 0?u=this.query:u===null&&(u=D),m===void 0?m=this.fragment:m===null&&(m=D),c===this.scheme&&o===this.authority&&s===this.path&&u===this.query&&m===this.fragment?this:new p(c,o,s,u,m)}static parse(a,c=!1){const o=h.exec(a);return o?new p(o[2]||D,r(o[4]||D),r(o[5]||D),r(o[7]||D),r(o[9]||D),c):new p(D,D,D,D,D)}static file(a){let c=D;if(i.isWindows&&(a=a.replace(/\\/g,I)),a[0]===I&&a[1]===I){const o=a.indexOf(I,2);o===-1?(c=a.substring(2),a=I):(c=a.substring(2,o),a=a.substring(o)||I)}return new p("file",c,a,D,D)}static from(a){const c=new p(a.scheme,a.authority,a.path,a.query,a.fragment);return P(c,!0),c}static joinPath(a,...c){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return i.isWindows&&a.scheme==="file"?o=y.file(R.win32.join(w(a,!0),...c)).path:o=R.posix.join(a.path,...c),a.with({path:o})}toString(a=!1){return f(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof y)return a;{const c=new p(a);return c._formatted=a.external,c._fsPath=a._sep===v?a.fsPath:null,c}}else return a}}e.URI=y;const v=i.isWindows?1:void 0;class p extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(a=!1){return a?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=v),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(n,a){let c,o=-1;for(let s=0;s<n.length;s++){const u=n.charCodeAt(s);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||a&&u===47)o!==-1&&(c+=encodeURIComponent(n.substring(o,s)),o=-1),c!==void 0&&(c+=n.charAt(s));else{c===void 0&&(c=n.substr(0,s));const m=d[u];m!==void 0?(o!==-1&&(c+=encodeURIComponent(n.substring(o,s)),o=-1),c+=m):o===-1&&(o=s)}}return o!==-1&&(c+=encodeURIComponent(n.substring(o))),c!==void 0?c:n}function S(n){let a;for(let c=0;c<n.length;c++){const o=n.charCodeAt(c);o===35||o===63?(a===void 0&&(a=n.substr(0,c)),a+=d[o]):a!==void 0&&(a+=n[c])}return a!==void 0?a:n}function w(n,a){let c;return n.authority&&n.path.length>1&&n.scheme==="file"?c=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?a?c=n.path.substr(1):c=n.path[1].toLowerCase()+n.path.substr(2):c=n.path,i.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=w;function f(n,a){const c=a?S:g;let o="",{scheme:s,authority:u,path:m,query:C,fragment:M}=n;if(s&&(o+=s,o+=":"),(u||s==="file")&&(o+=I,o+=I),u){let T=u.indexOf("@");if(T!==-1){const F=u.substr(0,T);u=u.substr(T+1),T=F.indexOf(":"),T===-1?o+=c(F,!1):(o+=c(F.substr(0,T),!1),o+=":",o+=c(F.substr(T+1),!1)),o+="@"}u=u.toLowerCase(),T=u.indexOf(":"),T===-1?o+=c(u,!1):(o+=c(u.substr(0,T),!1),o+=u.substr(T))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const T=m.charCodeAt(1);T>=65&&T<=90&&(m=`/${String.fromCharCode(T+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const T=m.charCodeAt(0);T>=65&&T<=90&&(m=`${String.fromCharCode(T+32)}:${m.substr(2)}`)}o+=c(m,!0)}return C&&(o+="?",o+=c(C,!1)),M&&(o+="#",o+=a?M:g(M,!1)),o}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(t)?n.replace(t,a=>l(a)):n}}),define(re[118],se([0,1,8]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(E){const D=E;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=i;function k(E){const D=[];let I;try{const h=JSON.parse(E.arguments),y=h[h.length-1];y&&y.__$stack&&(h.pop(),I=y.__$stack),D.push(...h)}catch{D.push("Unable to log remote console arguments",E.arguments)}return{args:D,stack:I}}e.parse=k;function L(E){if(typeof E!="string")return L(k(E).stack);const D=E;if(D){const I=A(D),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(h&&h.length===4)return{uri:R.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}e.getFirstFrame=L;function A(E){if(!E)return E;const D=E.indexOf(`
`);return D===-1?E:E.substring(0,D)}function P(E,D){const{args:I,stack:h}=k(E),y=typeof I[0]=="string"&&I.length===1;let v=A(h);v&&(v=`(${v.trim()})`);let p=[];if(typeof I[0]=="string"?v&&y?p=[`%c[${D}] %c${I[0]} %c${v}`,b("blue"),b(""),b("grey")]:p=[`%c[${D}] %c${I[0]}`,b("blue"),b(""),...I.slice(1)]:p=[`%c[${D}]%`,b("blue"),...I],v&&!y&&p.push(v),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,p)}e.log=P;function b(E){return`color: ${E}`}}),define(re[81],se([0,1,18,26,8]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(E){return JSON.stringify(E,P)}e.stringify=L;function A(E){let D=JSON.parse(E);return D=b(D),D}e.parse=A;function P(E,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,i.regExpFlags)(D)}:D}function b(E,D=0){if(!E||D>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return k.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 14:return new Date(E.source)}if(E instanceof R.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let I=0;I<E.length;++I)E[I]=b(E[I],D+1);else for(const I in E)Object.hasOwnProperty.call(E,I)&&(E[I]=b(E[I],D+1))}return E}e.revive=b}),define(re[19],se([0,1,4,8]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(k||(e.Schemas=k={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${k.vscodeRemoteResource}`}set(b,E,D){this._hosts[b]=E,this._ports[b]=D}setConnectionToken(b,E){this._connectionTokens[b]=E}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const E=b.authority;let D=this._hosts[E];D&&D.indexOf(":")!==-1&&(D=`[${D}]`);const I=this._ports[E],h=this._connectionTokens[E];let y=`path=${encodeURIComponent(b.path)}`;return typeof h=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(h)}`),i.URI.from({scheme:R.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${D}:${I}`,path:this._remoteResourcesPath,query:y})}}e.RemoteAuthorities=new L;class A{asBrowserUri(b,E){const D=this.toUri(b,E);return D.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(D):D.scheme===k.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${k.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?D.with({scheme:k.vscodeFileResource,authority:D.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):D}asFileUri(b,E){const D=this.toUri(b,E);return D.scheme===k.vscodeFileResource?D.with({scheme:k.file,authority:D.authority!==A.FALLBACK_AUTHORITY?D.authority:null,query:null,fragment:null}):D}toUri(b,E){return i.URI.isUri(b)?b:i.URI.parse(E.toUrl(b))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(re[20],se([0,1,41,19,12,4,26,8]),function(J,e,R,i,k,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(y){return(0,P.uriToFsPath)(y,!0)}e.originalFSPath=b;class E{constructor(v){this._ignorePathCasing=v}compare(v,p,d=!1){return v===p?0:(0,A.compare)(this.getComparisonKey(v,d),this.getComparisonKey(p,d))}isEqual(v,p,d=!1){return v===p?!0:!v||!p?!1:this.getComparisonKey(v,d)===this.getComparisonKey(p,d)}getComparisonKey(v,p=!1){return v.with({path:this._ignorePathCasing(v)?v.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(v){return this._ignorePathCasing(v)}isEqualOrParent(v,p,d=!1){if(v.scheme===p.scheme){if(v.scheme===i.Schemas.file)return R.isEqualOrParent(b(v),b(p),this._ignorePathCasing(v))&&v.query===p.query&&(d||v.fragment===p.fragment);if((0,e.isEqualAuthority)(v.authority,p.authority))return R.isEqualOrParent(v.path,p.path,this._ignorePathCasing(v),"/")&&v.query===p.query&&(d||v.fragment===p.fragment)}return!1}joinPath(v,...p){return P.URI.joinPath(v,...p)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return k.posix.basename(v.path)}extname(v){return k.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let p;return v.scheme===i.Schemas.file?p=P.URI.file(k.dirname(b(v))).path:(p=k.posix.dirname(v.path),v.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),p="/")),v.with({path:p})}normalizePath(v){if(!v.path.length)return v;let p;return v.scheme===i.Schemas.file?p=P.URI.file(k.normalize(b(v))).path:p=k.posix.normalize(v.path),v.with({path:p})}relativePath(v,p){if(v.scheme!==p.scheme||!(0,e.isEqualAuthority)(v.authority,p.authority))return;if(v.scheme===i.Schemas.file){const S=k.relative(b(v),b(p));return L.isWindows?R.toSlashes(S):S}let d=v.path||"/",g=p.path||"/";if(this._ignorePathCasing(v)){let S=0;for(const w=Math.min(d.length,g.length);S<w&&!(d.charCodeAt(S)!==g.charCodeAt(S)&&d.charAt(S).toLowerCase()!==g.charAt(S).toLowerCase());S++);d=g.substr(0,S)+d.substr(S)}return k.posix.relative(d,g)}resolvePath(v,p){if(v.scheme===i.Schemas.file){const d=P.URI.file(k.resolve(b(v),p));return v.with({authority:d.authority,path:d.path})}return p=R.toPosixPath(p),v.with({path:k.posix.resolve(v.path,p)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,p){return v===p||v!==void 0&&p!==void 0&&(0,A.equalsIgnoreCase)(v,p)}hasTrailingPathSeparator(v,p=k.sep){if(v.scheme===i.Schemas.file){const d=b(v);return d.length>R.getRoot(d).length&&d[d.length-1]===p}else{const d=v.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,p=k.sep){return(0,e.hasTrailingPathSeparator)(v,p)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,p=k.sep){let d=!1;if(v.scheme===i.Schemas.file){const g=b(v);d=g!==void 0&&g.length===R.getRoot(g).length&&g[g.length-1]===p}else{p="/";const g=v.path;d=g.length===1&&g.charCodeAt(g.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(v,p)?v.with({path:v.path+"/"}):v}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(y=>y.scheme===i.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new E(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(y,v){const p=[];for(let d=0;d<y.length;d++){const g=v(y[d]);y.some((S,w)=>w===d?!1:(0,e.isEqualOrParent)(g,v(S)))||p.push(y[d])}return p}e.distinctParents=D;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function v(p){const d=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(w=>{const[f,l]=w.split(":");f&&l&&d.set(f,l)});const S=p.path.substring(0,p.path.indexOf(";"));return S&&d.set(y.META_DATA_MIME,S),d}y.parseMetaData=v})(I||(e.DataUri=I={}));function h(y,v,p){if(v){let d=y.path;return d&&d[0]!==k.posix.sep&&(d=k.posix.sep+d),y.with({scheme:p,authority:v,path:d})}return y.with({scheme:p})}e.toLocalResource=h}),define(re[6],se([0,1,23,7,3,2,20,4]),function(J,e,R,i,k,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=b;function E(Z){const W=new R.CancellationTokenSource,ee=Z(W.token),B=new Promise((N,x)=>{const Y=W.token.onCancellationRequested(()=>{Y.dispose(),W.dispose(),x(new i.CancellationError)});Promise.resolve(ee).then(ne=>{Y.dispose(),W.dispose(),N(ne)},ne=>{Y.dispose(),W.dispose(),x(ne)})});return new class{cancel(){W.cancel()}then(N,x){return B.then(N,x)}catch(N){return this.then(void 0,N)}finally(N){return B.finally(N)}}}e.createCancelablePromise=E;function D(Z,W,ee){return new Promise((B,N)=>{const x=W.onCancellationRequested(()=>{x.dispose(),B(ee)});Z.then(B,N).finally(()=>x.dispose())})}e.raceCancellation=D;function I(Z,W){return new Promise((ee,B)=>{const N=W.onCancellationRequested(()=>{N.dispose(),B(new i.CancellationError)});Z.then(ee,B).finally(()=>N.dispose())})}e.raceCancellationError=I;async function h(Z){let W=-1;const ee=Z.map((N,x)=>N.then(Y=>(W=x,Y))),B=await Promise.race(ee);return Z.forEach((N,x)=>{x!==W&&N.cancel()}),B}e.raceCancellablePromises=h;function y(Z,W,ee){let B;const N=setTimeout(()=>{B?.(void 0),ee?.()},W);return Promise.race([Z.finally(()=>clearTimeout(N)),new Promise(x=>B=x)])}e.raceTimeout=y;function v(Z){return new Promise((W,ee)=>{const B=Z();b(B)?B.then(W,ee):W(B)})}e.asPromise=v;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const ee=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(ee,ee).then(B)})}return new Promise((ee,B)=>{this.queuedPromise.then(ee,B)})}return this.activePromise=W(),new Promise((ee,B)=>{this.activePromise.then(N=>{this.activePromise=null,ee(N)},N=>{this.activePromise=null,B(N)})})}}e.Throttler=p;class d{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=d;class g{constructor(){this.promiseMap=new Map}queue(W,ee){const N=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.promiseMap.get(W)===N&&this.promiseMap.delete(W)});return this.promiseMap.set(W,N),N}}e.SequencerByKey=g;const S=(Z,W)=>{let ee=!0;const B=setTimeout(()=>{ee=!1,W()},Z);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(B),ee=!1}}},w=Z=>{let W=!0;return queueMicrotask(()=>{W&&(W=!1,Z())}),{isTriggered:()=>W,dispose:()=>{W=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(W){this.defaultDelay=W,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,ee=this.defaultDelay){this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,x)=>{this.doResolve=N,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}}));const B=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ee===e.MicrotaskDelay?w(B):S(ee,B),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class l{constructor(W){this.delayer=new f(W),this.throttler=new p}trigger(W,ee){return this.delayer.trigger(()=>this.throttler.queue(W),ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class t{constructor(){this._isOpen=!1,this._promise=new Promise((W,ee)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=t;class r extends t{constructor(W){super();this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function n(Z,W){return W?new Promise((ee,B)=>{const N=setTimeout(()=>{x.dispose(),ee()},Z),x=W.onCancellationRequested(()=>{clearTimeout(N),x.dispose(),B(new i.CancellationError)})}):E(ee=>n(Z,ee))}e.timeout=n;function a(Z,W=0){const ee=setTimeout(Z,W);return(0,L.toDisposable)(()=>clearTimeout(ee))}e.disposableTimeout=a;function c(Z){const W=[];let ee=0;const B=Z.length;function N(){return ee<B?Z[ee++]():null}function x(Y){Y!=null&&W.push(Y);const ne=N();return ne?ne.then(x):Promise.resolve(W)}return Promise.resolve(null).then(x)}e.sequence=c;function o(Z,W=B=>!!B,ee=null){let B=0;const N=Z.length,x=()=>{if(B>=N)return Promise.resolve(ee);const Y=Z[B++];return Promise.resolve(Y()).then(oe=>W(oe)?Promise.resolve(oe):x())};return x()}e.first=o;function s(Z,W=B=>!!B,ee=null){if(Z.length===0)return Promise.resolve(ee);let B=Z.length;const N=()=>{B=-1;for(const x of Z)x.cancel?.()};return new Promise((x,Y)=>{for(const ne of Z)ne.then(oe=>{--B>=0&&W(oe)?(N(),x(oe)):B===0&&x(ee)}).catch(oe=>{--B>=0&&(N(),Y(oe))})})}e.firstParallel=s;class u{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(W){return this._size++,new Promise((ee,B)=>{this.outstandingPromises.push({factory:W,c:ee,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const ee=W.factory();ee.then(W.c,W.e),ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=u;class m extends u{constructor(){super(1)}}e.Queue=m;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const W=new z;return this.drainers.add(W),W.p}isDrained(){for(const[,W]of this.queues)if(W.size>0)return!1;return!0}queueFor(W,ee=A.extUri){const B=ee.getComparisonKey(W);let N=this.queues.get(B);return N||(N=new m,k.Event.once(N.onDrained)(()=>{N?.dispose(),this.queues.delete(B),this.onDidQueueDrain()}),this.queues.set(B,N)),N}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const W of this.drainers)W.complete();this.drainers.clear()}dispose(){for(const[,W]of this.queues)W.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class M{constructor(W,ee){this._token=-1,typeof W=="function"&&typeof ee=="number"&&this.setIfNotSet(W,ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},ee)}setIfNotSet(W,ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},ee))}}e.TimeoutTimer=M;class T{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,ee){this.cancel(),this._token=setInterval(()=>{W()},ee)}}e.IntervalTimer=T;class F{constructor(W,ee){this.timeoutToken=-1,this.runner=W,this.timeout=ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class _{constructor(W,ee){ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=_;class U extends F{constructor(W,ee){super(W,ee);this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner&&this.runner(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class O extends L.Disposable{constructor(W,ee){super();this.options=W,this.handler=ee,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.options.maxBufferedWork)return!1}else if(this.pending+W.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...W),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Z=>{(0,P.setTimeout0)(()=>{if(W)return;const ee=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.runWhenIdle=(Z,W)=>{const ee=requestIdleCallback(Z,typeof W=="number"?{timeout:W}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(ee))}}}}();class ${constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(ee){this._error=ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function V(Z,W,ee){let B;for(let N=0;N<ee;N++)try{return await Z()}catch(x){B=x,await n(W)}throw B}e.retry=V;class te{hasPending(W){return this._pending?typeof W=="number"?this._pending.taskId===W:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(W,ee,B){return this._pending={taskId:W,cancel:()=>B?.(),promise:ee},ee.then(()=>this.donePending(W),()=>this.donePending(W)),ee}donePending(W){this._pending&&W===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const W=this._next;this._next=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this._next)this._next.run=W;else{let ee,B;const N=new Promise((x,Y)=>{ee=x,B=Y});this._next={run:W,promise:N,promiseResolve:ee,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=te;class H{constructor(W,ee=()=>Date.now()){this.interval=W,this.nowFn=ee,this.lastIncrementTime=0,this.value=0}increment(){const W=this.nowFn();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class z{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((W,ee)=>{this.completeCallback=W,this.errorCallback=ee})}complete(W){return new Promise(ee=>{this.completeCallback(W),this.resolved=!0,ee()})}error(W){return new Promise(ee=>{this.errorCallback(W),this.rejected=!0,ee()})}cancel(){new Promise(W=>{this.errorCallback(new i.CancellationError),this.rejected=!0,W()})}}e.DeferredPromise=z;var q;(function(Z){async function W(B){let N;const x=await Promise.all(B.map(Y=>Y.then(ne=>ne,ne=>{N||(N=ne)})));if(typeof N!="undefined")throw N;return x}Z.settled=W;function ee(B){return new Promise(async(N,x)=>{try{await B(N,x)}catch(Y){x(Y)}})}Z.withAsyncBody=ee})(q||(e.Promises=q={}));var j;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(j||(j={}));class Q{static fromArray(W){return new Q(ee=>{ee.emitMany(W)})}static fromPromise(W){return new Q(async ee=>{ee.emitMany(await W)})}static fromPromises(W){return new Q(async ee=>{await Promise.all(W.map(async B=>ee.emitOne(await B)))})}static merge(W){return new Q(async ee=>{await Promise.all(W.map(async B=>{for await(const N of B)ee.emitOne(N)}))})}constructor(W){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const ee={emitOne:B=>this.emitOne(B),emitMany:B=>this.emitMany(B),reject:B=>this.reject(B)};try{await Promise.resolve(W(ee)),this.resolve()}catch(B){this.reject(B)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let W=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(W<this._results.length)return{done:!1,value:this._results[W++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(W,ee){return new Q(async B=>{for await(const N of W)B.emitOne(ee(N))})}map(W){return Q.map(this,W)}static filter(W,ee){return new Q(async B=>{for await(const N of W)ee(N)&&B.emitOne(N)})}filter(W){return Q.filter(this,W)}static coalesce(W){return Q.filter(W,ee=>!!ee)}coalesce(){return Q.coalesce(this)}static async toPromise(W){const ee=[];for await(const B of W)ee.push(B);return ee}toPromise(){return Q.toPromise(this)}emitOne(W){this._state===0&&(this._results.push(W),this._onStateChanged.fire())}emitMany(W){this._state===0&&(this._results=this._results.concat(W),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(W){this._state===0&&(this._state=2,this._error=W,this._onStateChanged.fire())}}e.AsyncIterableObject=Q,Q.EMPTY=Q.fromArray([]);class G extends Q{constructor(W,ee){super(ee);this._source=W}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=G;function X(Z){const W=new R.CancellationTokenSource,ee=Z(W.token);return new G(W,async B=>{const N=W.token.onCancellationRequested(()=>{N.dispose(),W.dispose(),B.reject(new i.CancellationError)});try{for await(const x of ee){if(W.token.isCancellationRequested)return;B.emitOne(x)}N.dispose(),W.dispose()}catch(x){N.dispose(),W.dispose(),B.reject(x)}})}e.createCancelableAsyncIterable=X}),define(re[82],se([0,1,16,6,41,39,12,4,26]),function(J,e,R,i,k,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const D="[/\\\\]",I="[^/\\\\]",h=/\//g;function y(z,q){switch(z){case 0:return"";case 1:return`${I}*?`;default:return`(?:${D}|${I}+${D}${q?`|${D}${I}+`:""})*?`}}function v(z,q){if(!z)return[];const j=[];let Q=!1,G=!1,X="";for(const Z of z){switch(Z){case q:if(!Q&&!G){j.push(X),X="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":G=!0;break;case"]":G=!1;break}X+=Z}return X&&j.push(X),j}e.splitGlobAware=v;function p(z){if(!z)return"";let q="";const j=v(z,e.GLOB_SPLIT);if(j.every(Q=>Q===e.GLOBSTAR))q=".*";else{let Q=!1;j.forEach((G,X)=>{if(G===e.GLOBSTAR){if(Q)return;q+=y(2,X===j.length-1)}else{let Z=!1,W="",ee=!1,B="";for(const N of G){if(N!=="}"&&Z){W+=N;continue}if(ee&&(N!=="]"||!B)){let x;N==="-"?x=N:(N==="^"||N==="!")&&!B?x="^":N===e.GLOB_SPLIT?x="":x=(0,b.escapeRegExpCharacters)(N),B+=x;continue}switch(N){case"{":Z=!0;continue;case"[":ee=!0;continue;case"}":{q+=`(?:${v(W,",").map(ne=>p(ne)).join("|")})`,Z=!1,W="";break}case"]":{q+="["+B+"]",ee=!1,B="";break}case"?":q+=I;continue;case"*":q+=y(1);continue;default:q+=(0,b.escapeRegExpCharacters)(N)}}X<j.length-1&&(j[X+1]!==e.GLOBSTAR||X+2<j.length)&&(q+=D)}Q=G===e.GLOBSTAR})}return q}const d=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),r=function(){return!1},n=function(){return null};function a(z,q){if(!z)return n;let j;typeof z!="string"?j=z.pattern:j=z,j=j.trim();const Q=`${j}_${!!q.trimForExclusions}`;let G=t.get(Q);if(G)return c(G,z);let X;return d.test(j)?G=s(j.substr(4),j):(X=g.exec(o(j,q)))?G=u(X[1],j):(q.trimForExclusions?w:S).test(j)?G=m(j,q):(X=f.exec(o(j,q)))?G=C(X[1].substr(1),j,!0):(X=l.exec(o(j,q)))?G=C(X[1],j,!1):G=M(j),t.set(Q,G),c(G,z)}function c(z,q){if(typeof q=="string")return z;const j=function(Q,G){return(0,k.isEqualOrParent)(Q,q.base,!P.isLinux)?z(Q.substr(q.base.length+1),G):null};return j.allBasenames=z.allBasenames,j.allPaths=z.allPaths,j.basenames=z.basenames,j.patterns=z.patterns,j}function o(z,q){return q.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function s(z,q){return function(j,Q){return typeof j=="string"&&j.endsWith(z)?q:null}}function u(z,q){const j=`/${z}`,Q=`\\${z}`,G=function(Z,W){return typeof Z!="string"?null:W?W===z?q:null:Z===z||Z.endsWith(j)||Z.endsWith(Q)?q:null},X=[z];return G.basenames=X,G.patterns=[q],G.allBasenames=X,G}function m(z,q){const j=te(z.slice(1,-1).split(",").map(W=>a(W,q)).filter(W=>W!==n),z),Q=j.length;if(!Q)return n;if(Q===1)return j[0];const G=function(W,ee){for(let B=0,N=j.length;B<N;B++)if(j[B](W,ee))return z;return null},X=j.find(W=>!!W.allBasenames);X&&(G.allBasenames=X.allBasenames);const Z=j.reduce((W,ee)=>ee.allPaths?W.concat(ee.allPaths):W,[]);return Z.length&&(G.allPaths=Z),G}function C(z,q,j){const Q=A.sep===A.posix.sep,G=Q?z:z.replace(h,A.sep),X=A.sep+G,Z=A.posix.sep+z;let W;return j?W=function(ee,B){return typeof ee=="string"&&(ee===G||ee.endsWith(X)||!Q&&(ee===z||ee.endsWith(Z)))?q:null}:W=function(ee,B){return typeof ee=="string"&&(ee===G||!Q&&ee===z)?q:null},W.allPaths=[(j?"*/":"./")+z],W}function M(z){try{const q=new RegExp(`^${p(z)}$`);return function(j){return q.lastIndex=0,typeof j=="string"&&q.test(j)?z:null}}catch{return n}}function T(z,q,j){return!z||typeof q!="string"?!1:F(z)(q,void 0,j)}e.match=T;function F(z,q={}){if(!z)return r;if(typeof z=="string"||_(z)){const j=a(z,q);if(j===n)return r;const Q=function(G,X){return!!j(G,X)};return j.allBasenames&&(Q.allBasenames=j.allBasenames),j.allPaths&&(Q.allPaths=j.allPaths),Q}return $(z,q)}e.parse=F;function _(z){const q=z;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=_;function U(z){return z.allBasenames||[]}e.getBasenameTerms=U;function O(z){return z.allPaths||[]}e.getPathTerms=O;function $(z,q){const j=te(Object.getOwnPropertyNames(z).map(W=>V(W,z[W],q)).filter(W=>W!==n)),Q=j.length;if(!Q)return n;if(!j.some(W=>!!W.requiresSiblings)){if(Q===1)return j[0];const W=function(N,x){let Y;for(let ne=0,oe=j.length;ne<oe;ne++){const de=j[ne](N,x);if(typeof de=="string")return de;(0,i.isThenable)(de)&&(Y||(Y=[]),Y.push(de))}return Y?(async()=>{for(const ne of Y){const oe=await ne;if(typeof oe=="string")return oe}return null})():null},ee=j.find(N=>!!N.allBasenames);ee&&(W.allBasenames=ee.allBasenames);const B=j.reduce((N,x)=>x.allPaths?N.concat(x.allPaths):N,[]);return B.length&&(W.allPaths=B),W}const G=function(W,ee,B){let N,x;for(let Y=0,ne=j.length;Y<ne;Y++){const oe=j[Y];oe.requiresSiblings&&B&&(ee||(ee=(0,A.basename)(W)),N||(N=ee.substr(0,ee.length-(0,A.extname)(W).length)));const de=oe(W,ee,N,B);if(typeof de=="string")return de;(0,i.isThenable)(de)&&(x||(x=[]),x.push(de))}return x?(async()=>{for(const Y of x){const ne=await Y;if(typeof ne=="string")return ne}return null})():null},X=j.find(W=>!!W.allBasenames);X&&(G.allBasenames=X.allBasenames);const Z=j.reduce((W,ee)=>ee.allPaths?W.concat(ee.allPaths):W,[]);return Z.length&&(G.allPaths=Z),G}function V(z,q,j){if(q===!1)return n;const Q=a(z,j);if(Q===n)return n;if(typeof q=="boolean")return Q;if(q){const G=q.when;if(typeof G=="string"){const X=(Z,W,ee,B)=>{if(!B||!Q(Z,W))return null;const N=G.replace("$(basename)",ee),x=B(N);return(0,i.isThenable)(x)?x.then(Y=>Y?z:null):x?z:null};return X.requiresSiblings=!0,X}}return Q}function te(z,q){const j=z.filter(W=>!!W.basenames);if(j.length<2)return z;const Q=j.reduce((W,ee)=>{const B=ee.basenames;return B?W.concat(B):W},[]);let G;if(q){G=[];for(let W=0,ee=Q.length;W<ee;W++)G.push(q)}else G=j.reduce((W,ee)=>{const B=ee.patterns;return B?W.concat(B):W},[]);const X=function(W,ee){if(typeof W!="string")return null;if(!ee){let N;for(N=W.length;N>0;N--){const x=W.charCodeAt(N-1);if(x===47||x===92)break}ee=W.substr(N)}const B=Q.indexOf(ee);return B!==-1?G[B]:null};X.basenames=Q,X.patterns=G,X.allBasenames=Q;const Z=z.filter(W=>!W.basenames);return Z.push(X),Z}function H(z,q){return(0,R.equals)(z,q,(j,Q)=>typeof j=="string"&&typeof Q=="string"?j===Q:typeof j!="string"&&typeof Q!="string"?j.base===Q.base&&j.pattern===Q.pattern:!1)}e.patternsEquals=H}),define(re[119],se([0,1,8]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(D){return D.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const h=this._uriTransformer.transformIncoming(I);return h===I?I:i(R.URI.from(h))}transformOutgoing(I){const h=this._uriTransformer.transformOutgoing(I);return h===I?I:i(R.URI.from(h))}transformOutgoingURI(I){const h=this._uriTransformer.transformOutgoing(I);return h===I?I:R.URI.from(h)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function L(D,I,h){if(!D||h>200)return null;if(typeof D=="object"){if(D instanceof R.URI)return I.transformOutgoing(D);for(let y in D)if(Object.hasOwnProperty.call(D,y)){const v=L(D[y],I,h+1);v!==null&&(D[y]=v)}}return null}function A(D,I){const h=L(D,I,0);return h===null?D:h}e.transformOutgoingURIs=A;function P(D,I,h,y){if(!D||y>200)return null;if(typeof D=="object"){if(D.$mid===1)return h?R.URI.revive(I.transformIncoming(D)):I.transformIncoming(D);for(let v in D)if(Object.hasOwnProperty.call(D,v)){const p=P(D[v],I,h,y+1);p!==null&&(D[v]=p)}}return null}function b(D,I){const h=P(D,I,!1,0);return h===null?D:h}e.transformIncomingURIs=b;function E(D,I){const h=P(D,I,!0,0);return h===null?D:h}e.transformAndReviveIncomingURIs=E}),define(re[30],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(k){return R.test(k)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(P){for(let b=0;b<P.length;b++)P[b]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){k(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let b=0,E="";return E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+="-",E+=A[L[b++]],E+=A[L[b++]],E+="-",E+=A[L[b++]],E+=A[L[b++]],E+="-",E+=A[L[b++]],E+=A[L[b++]],E+="-",E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E}}()}),define(re[120],se([0,1,269]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(L="utf8"){this.stringDecoder=new R.StringDecoder(L),this.remaining=null}write(L){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(P.length<1)return A;let b=0,E,D=b;for(;D<P.length;)if(E=P.charCodeAt(D),E===13||E===10){if(A.push(P.substring(b,D)),D++,D<P.length){const I=E;E=P.charCodeAt(D),(I===13&&E===10||I===10&&E===13)&&D++}b=D}else D++;return this.remaining=b<P.length?P.substr(b):null,A}end(){return this.remaining}}e.LineDecoder=i}),define(re[121],se([0,1,35]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const P=A.replace(/\-/g,":").toLowerCase();return!i.has(P)}function L(){const A=(0,R.networkInterfaces)();for(let P in A){const b=A[P];if(b){for(const{mac:E}of b)if(k(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(re[122],se([0,1,35,7,39,30,121]),function(J,e,R,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(D){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(D)}value(){if(this._value===void 0){let D=0,I=0;const h=(0,R.networkInterfaces)();for(let y in h){const v=h[y];if(v)for(const{mac:p,internal:d}of v)d||(I+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(D+=1))}this._value=I>0?D/I:0}return this._value}};let P;async function b(){return P||(P=(async()=>await E()||L.generateUuid())()),P}e.getMachineId=b;async function E(){try{const D=await new Promise((h,y)=>{J(["crypto"],h,y)}),I=(0,A.getMac)();return D.createHash("sha256").update(I,"utf8").digest("hex")}catch(D){i.onUnexpectedError(D);return}}}),define(re[27],se([0,1,52,35,270,6,41,80,12,4,20,8]),function(J,e,R,i,k,L,A,P,b,E,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var h;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(h||(e.RimRafMode=h={}));async function y(O,$=h.UNLINK){if((0,A.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return $===h.UNLINK?p(O):v(O)}async function v(O){try{const $=(0,A.randomPath)((0,i.tmpdir)());try{await R.promises.rename(O,$)}catch{return p(O)}p($).catch(V=>{})}catch($){if($.code!=="ENOENT")throw $}}async function p(O){return(0,k.promisify)(R.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function d(O){if((0,A.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function g(O,$){return f(await($?S(O):(0,k.promisify)(R.readdir)(O)))}async function S(O){try{return await(0,k.promisify)(R.readdir)(O,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const $=[],V=await g(O);for(const te of V){let H=!1,z=!1,q=!1;try{const j=await e.Promises.lstat((0,b.join)(O,te));H=j.isFile(),z=j.isDirectory(),q=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}$.push({name:te,isFile:()=>H,isDirectory:()=>z,isSymbolicLink:()=>q})}return $}function w(O){return f(R.readdirSync(O))}e.readdirSync=w;function f(O){return O.map($=>typeof $=="string"?E.isMacintosh?(0,P.normalizeNFC)($):$:($.name=E.isMacintosh?(0,P.normalizeNFC)($.name):$.name,$))}async function l(O){const $=await g(O),V=[];for(const te of $)await r.existsDirectory((0,b.join)(O,te))&&V.push(te);return V}function t(O,$=1e3){return new Promise(V=>{let te=!1;const H=setInterval(()=>{te||(te=!0,R.access(O,z=>{te=!1,z&&(clearInterval(H),V(void 0))}))},$)})}e.whenDeleted=t;var r;(function(O){async function $(H){let z;try{if(z=await e.Promises.lstat(H),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(E.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw j}throw q}}O.stat=$;async function V(H){try{const{stat:z,symbolicLink:q}=await O.stat(H);return z.isFile()&&q?.dangling!==!0}catch{}return!1}O.existsFile=V;async function te(H){try{const{stat:z,symbolicLink:q}=await O.stat(H);return z.isDirectory()&&q?.dangling!==!0}catch{}return!1}O.existsDirectory=te})(r||(e.SymlinkSupport=r={}));const n=new L.ResourceQueue;function a(O,$,V){return n.queueFor(I.URI.file(O),D.extUriBiasedIgnorePathCase).queue(()=>{const te=u(V);return new Promise((H,z)=>o(O,$,te,q=>q?z(q):H()))})}let c=!0;function o(O,$,V,te){if(!c)return R.writeFile(O,$,{mode:V.mode,flag:V.flag},te);R.open(O,V.flag,V.mode,(H,z)=>{if(H)return te(H);R.writeFile(z,$,q=>{if(q)return R.close(z,()=>te(q));R.fdatasync(z,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),c=!1),R.close(z,Q=>te(Q))))})})}function s(O,$,V){const te=u(V);if(!c)return R.writeFileSync(O,$,{mode:te.mode,flag:te.flag});const H=R.openSync(O,te.flag,te.mode);try{R.writeFileSync(H,$);try{R.fdatasyncSync(H)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),c=!1}}finally{R.closeSync(H)}}e.writeFileSync=s;function u(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function m(O,$){if(O!==$)try{await e.Promises.rename(O,$)}catch(V){if(O.toLowerCase()!==$.toLowerCase()&&V.code==="EXDEV"||O.endsWith("."))await C(O,$,{preserveSymlinks:!1}),await y(O,h.MOVE);else throw V}}async function C(O,$,V){return T(O,$,{root:{source:O,target:$},options:V,handledSourcePaths:new Set})}const M=511;async function T(O,$,V){if(V.handledSourcePaths.has(O))return;V.handledSourcePaths.add(O);const{stat:te,symbolicLink:H}=await r.stat(O);if(H){if(V.options.preserveSymlinks)try{return await U(O,$,V)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(H.dangling)return}return te.isDirectory()?F(O,$,te.mode&M,V):_(O,$,te.mode&M)}async function F(O,$,V,te){await e.Promises.mkdir($,{recursive:!0,mode:V});const H=await g(O);for(const z of H)await T((0,b.join)(O,z),(0,b.join)($,z),te)}async function _(O,$,V){await e.Promises.copyFile(O,$),await e.Promises.chmod($,V)}async function U(O,$,V){let te=await e.Promises.readlink(O);(0,A.isEqualOrParent)(te,V.root.source,!E.isLinux)&&(te=(0,b.join)(V.root.target,te.substr(V.root.source.length+1))),await e.Promises.symlink(te,$)}e.Promises=new class{get access(){return(0,k.promisify)(R.access)}get stat(){return(0,k.promisify)(R.stat)}get lstat(){return(0,k.promisify)(R.lstat)}get utimes(){return(0,k.promisify)(R.utimes)}get read(){return(O,$,V,te,H)=>new Promise((z,q)=>{R.read(O,$,V,te,H,(j,Q,G)=>j?q(j):z({bytesRead:Q,buffer:G}))})}get readFile(){return(0,k.promisify)(R.readFile)}get write(){return(O,$,V,te,H)=>new Promise((z,q)=>{R.write(O,$,V,te,H,(j,Q,G)=>j?q(j):z({bytesWritten:Q,buffer:G}))})}get appendFile(){return(0,k.promisify)(R.appendFile)}get fdatasync(){return(0,k.promisify)(R.fdatasync)}get truncate(){return(0,k.promisify)(R.truncate)}get rename(){return(0,k.promisify)(R.rename)}get copyFile(){return(0,k.promisify)(R.copyFile)}get open(){return(0,k.promisify)(R.open)}get close(){return(0,k.promisify)(R.close)}get symlink(){return(0,k.promisify)(R.symlink)}get readlink(){return(0,k.promisify)(R.readlink)}get chmod(){return(0,k.promisify)(R.chmod)}get mkdir(){return(0,k.promisify)(R.mkdir)}get unlink(){return(0,k.promisify)(R.unlink)}get rmdir(){return(0,k.promisify)(R.rmdir)}get realpath(){return(0,k.promisify)(R.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return l}get writeFile(){return a}get rm(){return y}get move(){return m}get copy(){return C}}}),define(re[123],se([0,1,52,12,4,26,27]),function(J,e,R,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(h){if(k.isLinux)return h;const y=(0,i.dirname)(h);if(h===y)return h;const v=((0,i.basename)(h)||h).toLowerCase();try{const d=(0,A.readdirSync)(y).filter(g=>g.toLowerCase()===v);if(d.length===1){const g=P(y);if(g)return(0,i.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(v);if(g>=0){const S=P(y);if(S)return(0,i.join)(S,d[g])}}}catch{}return null}e.realcaseSync=P;async function b(h){if(k.isLinux)return h;const y=(0,i.dirname)(h);if(h===y)return h;const v=((0,i.basename)(h)||h).toLowerCase();try{const d=(await A.Promises.readdir(y)).filter(g=>g.toLowerCase()===v);if(d.length===1){const g=await b(y);if(g)return(0,i.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(v);if(g>=0){const S=await b(y);if(S)return(0,i.join)(S,d[g])}}}catch{}return null}e.realcase=b;async function E(h){try{return await A.Promises.realpath(h)}catch{const v=I(h);return await A.Promises.access(v,R.constants.R_OK),v}}e.realpath=E;function D(h){try{return R.realpathSync(h)}catch{const v=I(h);return R.accessSync(v,R.constants.R_OK),v}}e.realpathSync=D;function I(h){return(0,L.rtrim)((0,i.normalize)(h),i.sep)}}),define(re[124],se([0,1,60]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(P,b,E,D=1){let I=!1;return new Promise(h=>{const y=setTimeout(()=>{if(!I)return I=!0,h(0)},E);k(P,b,D,v=>{if(!I)return I=!0,clearTimeout(y),h(v)})})}e.findFreePort=i;function k(P,b,E,D){if(b===0)return D(0);const I=new R.Socket;I.once("connect",()=>(A(I),k(P+E,b-1,E,D))),I.once("data",()=>{}),I.once("error",h=>(A(I),h.code!=="ECONNREFUSED"?k(P+E,b-1,E,D):D(P))),I.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(P,b,E){let D=!1,I,h=1;const y=R.createServer({pauseOnConnect:!0});function v(p,d){D||(D=!0,y.removeAllListeners(),y.close(),I&&clearTimeout(I),d(p))}return new Promise(p=>{I=setTimeout(()=>{v(0,p)},E),y.on("listening",()=>{v(P,p)}),y.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&h<b?(P++,h++,y.listen(P,"127.0.0.1")):v(0,p)}),y.on("close",()=>{v(0,p)}),y.listen(P,"127.0.0.1")})}e.findFreePortFaster=L;function A(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(b){console.error(b)}}}),define(re[83],se([0,1,35,12,27]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var b;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(b||(b={}));let E;switch(process.arch){case"ia32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class I{constructor(l,t,r){this.exePath=l,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:f=!1}={}){return f?E===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:f=!1,findPreview:l=!1}={}){const t=h({useAlternateBitness:f});if(!t)return null;const r=i.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let n=-1,a=null;for(const s of await k.Promises.readdir(r)){let u=-1;if(l){const C=s.indexOf("-");if(C<0)continue;const M=s.substring(0,C);if(!L.test(M)||s.substring(C+1)!=="preview")continue;u=parseInt(M,10)}else{if(!L.test(s))continue;u=parseInt(s,10)}if(u<=n)continue;const m=i.join(r,s,"pwsh.exe");!await k.SymlinkSupport.existsFile(m)||(a=m,n=u)}if(!a)return null;const c=t.includes("x86")?" (x86)":"",o=l?" Preview":"";return new I(a,`PowerShell${o}${c}`,!0)}async function v({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const l=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=f?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(l))if(t.test(n)){const a=i.join(l,n,"pwsh.exe");return new I(a,r)}return null}function p(){const f=i.join(R.homedir(),".dotnet","tools","pwsh.exe");return new I(f,".NET Core PowerShell Global Tool")}function d(){const f=i.join(process.env.windir,E===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(f,"Windows PowerShell",!0)}async function*g(){let f=await y();f&&(yield f),f=await y({useAlternateBitness:!0}),f&&(yield f),f=await v(),f&&(yield f),f=p(),f&&(yield f),f=await y({findPreview:!0}),f&&(yield f),f=await v({findPreview:!0}),f&&(yield f),f=await y({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=d(),f&&(yield f)}async function*S(){for await(const f of g())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=S;async function w(){for await(const f of S())return f;return null}e.getFirstAvailablePowerShellInstallation=w}),define(re[125],se([0,1,46,19]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(A){return new Promise((P,b)=>{let E;const D=new Map;function I(y,v,p,d,g){const S=D.get(v);if(y===A||S){const w={name:h(p),cmd:p,pid:y,ppid:v,load:d,mem:g};D.set(y,w),y===A&&(E=w),S&&(S.children||(S.children=[]),S.children.push(w),S.children.length>1&&(S.children=S.children.sort((f,l)=>f.pid-l.pid)))}}function h(y){const v=/--vscode-window-kind=shared-process/,p=/--vscode-window-kind=issue-reporter/,d=/--vscode-window-kind=process-explorer/,g=/--utility-sub-type=network/,S=/--crashes-directory/,w=/\\pipe\\winpty-control/,f=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(S.exec(y))return"electron-crash-reporter";if(w.exec(y))return"winpty-process";if(f.exec(y))return"console-window-host (Windows internal process)";let t=l.exec(y);if(t&&t.length===2)return t[1]==="renderer"?v.exec(y)?"shared-process":p.exec(y)?"issue-reporter":d.exec(y)?"process-explorer":"window":t[1]==="utility"&&g.exec(y)?"utility-network-service":t[1];const r=/[a-zA-Z-]+\.js/g;let n="";do t=r.exec(y),t&&(n+=t+" ");while(t);return n&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${n}`:y}if(process.platform==="win32"){const y=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substr(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substr(5):v;new Promise((v,p)=>{J(["windows-process-tree"],v,p)}).then(v=>{v.getProcessList(A,p=>{if(!p){b(new Error(`Root process ${A} not found`));return}v.getProcessCpuUsage(p,d=>{const g=new Map;d.forEach(S=>{const w=y(S.commandLine||"");g.set(S.pid,{name:h(w),cmd:w,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),E=g.get(A),E?(g.forEach(S=>{const w=g.get(S.ppid);w&&(w.children||(w.children=[]),w.children.push(S))}),g.forEach(S=>{S.children&&(S.children=S.children.sort((w,f)=>w.pid-f.pid))}),P(E)):b(new Error(`Root process ${A} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{let y=function(){let v=[E];const p=[];for(;v.length;){const g=v.shift();g&&(p.push(g.pid),g.children&&(v=v.concat(g.children)))}let d=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);d+=" "+p.join(" "),(0,R.exec)(d,{},(g,S,w)=>{if(g||w)b(g||new Error(w.toString()));else{const f=S.toString().split(`
`);for(let l=0;l<p.length;l++){const t=D.get(p[l]);t.load=parseFloat(f[l])}if(!E){b(new Error(`Root process ${A} not found`));return}P(E)}})};(0,R.exec)("which ps",{},(v,p,d)=>{if(v||d)if(process.platform!=="linux")b(v||new Error(d.toString()));else{const g=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,R.exec)(g,{},(S,w,f)=>{S||f?b(S||new Error(f.toString())):(L(w,I),y())})}else{const g=p.toString().trim(),S="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${g} ${S}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(w,f,l)=>{w||l&&!l.includes("screen size is bogus")?b(w||new Error(l.toString())):(L(f,I),process.platform==="linux"?y():E?P(E):b(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=k;function L(A,P){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=A.toString().split(`
`);for(const D of E){const I=b.exec(D.trim());I&&I.length===6&&P(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(re[37],se([0,1,16,6,18,23,45,7,3,2,81,26,13]),function(J,e,R,i,k,L,A,P,b,E,D,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(y||(e.RequestType=y={}));function v(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(p||(e.ResponseType=p={}));function d(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(g||(g={}));class S{constructor(q){this.buffer=q,this.pos=0}read(q){const j=this.buffer.slice(this.pos,this.pos+q);return this.pos+=j.byteLength,j}}class w{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var f;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(f||(f={}));function l(z){const q=k.VSBuffer.alloc(4);return q.writeUInt32BE(z,0),q}function t(z){return z.read(4).readUInt32BE(0)}function r(z){const q=k.VSBuffer.alloc(1);return q.writeUInt8(z,0),q}const n={Undefined:r(f.Undefined),String:r(f.String),Buffer:r(f.Buffer),VSBuffer:r(f.VSBuffer),Array:r(f.Array),Object:r(f.Object)},a=typeof Buffer!="undefined";function c(z,q){if(typeof q=="undefined")z.write(n.Undefined);else if(typeof q=="string"){const j=k.VSBuffer.fromString(q);z.write(n.String),z.write(l(j.byteLength)),z.write(j)}else if(a&&Buffer.isBuffer(q)){const j=k.VSBuffer.wrap(q);z.write(n.Buffer),z.write(l(j.byteLength)),z.write(j)}else if(q instanceof k.VSBuffer)z.write(n.VSBuffer),z.write(l(q.byteLength)),z.write(q);else if(Array.isArray(q)){z.write(n.Array),z.write(l(q.length));for(const j of q)c(z,j)}else{const j=k.VSBuffer.fromString(JSON.stringify(q));z.write(n.Object),z.write(l(j.byteLength)),z.write(j)}}function o(z){switch(z.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return z.read(t(z)).toString();case f.Buffer:return z.read(t(z)).buffer;case f.VSBuffer:return z.read(t(z));case f.Array:{const j=t(z),Q=[];for(let G=0;G<j;G++)Q.push(o(z));return Q}case f.Object:return JSON.parse(z.read(t(z)).toString())}}class s{constructor(q,j,Q=null,G=1e3){this.protocol=q,this.ctx=j,this.logger=Q,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(q,j){this.channels.set(q,j),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const j=this.send([q.type]);this.logger?.logOutgoing(j,0,1,d(q.type));return}case 201:case 202:case 204:case 203:{const j=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(j,q.id,1,d(q.type),q.data);return}}}send(q,j=void 0){const Q=new w;return c(Q,q),c(Q,j),this.sendBuffer(Q.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const j=new S(q),Q=o(j),G=o(j),X=Q[0];switch(X){case 100:return this.logger?.logIncoming(q.byteLength,Q[1],1,`${v(X)}: ${Q[2]}.${Q[3]}`,G),this.onPromise({type:X,id:Q[1],channelName:Q[2],name:Q[3],arg:G});case 102:return this.logger?.logIncoming(q.byteLength,Q[1],1,`${v(X)}: ${Q[2]}.${Q[3]}`,G),this.onEventListen({type:X,id:Q[1],channelName:Q[2],name:Q[3],arg:G});case 101:return this.logger?.logIncoming(q.byteLength,Q[1],1,`${v(X)}`),this.disposeActiveRequest({type:X,id:Q[1]});case 103:return this.logger?.logIncoming(q.byteLength,Q[1],1,`${v(X)}`),this.disposeActiveRequest({type:X,id:Q[1]})}}onPromise(q){const j=this.channels.get(q.channelName);if(!j){this.collectPendingRequest(q);return}const Q=new L.CancellationTokenSource;let G;try{G=j.call(this.ctx,q.name,q.arg,Q.token)}catch(W){G=Promise.reject(W)}const X=q.id;G.then(W=>{this.sendResponse({id:X,data:W,type:201}),this.activeRequests.delete(q.id)},W=>{W instanceof Error?this.sendResponse({id:X,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.sendResponse({id:X,data:W,type:203}),this.activeRequests.delete(q.id)});const Z=(0,E.toDisposable)(()=>Q.cancel());this.activeRequests.set(q.id,Z)}onEventListen(q){const j=this.channels.get(q.channelName);if(!j){this.collectPendingRequest(q);return}const Q=q.id,X=j.listen(this.ctx,q.name,q.arg)(Z=>this.sendResponse({id:Q,data:Z,type:204}));this.activeRequests.set(q.id,X)}disposeActiveRequest(q){const j=this.activeRequests.get(q.id);j&&(j.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let j=this.pendingRequests.get(q.channelName);j||(j=[],this.pendingRequests.set(q.channelName,j));const Q=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:q,timeoutTimer:Q})}flushPendingRequests(q){const j=this.pendingRequests.get(q);if(j){for(const Q of j)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.onPromise(Q.request);break;case 102:this.onEventListen(Q.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=s;var u;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(u||(e.RequestInitiator=u={}));class m{constructor(q,j=null){this.protocol=q,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Q=>this.onBuffer(Q)),this.logger=j}getChannel(q){const j=this;return{call(Q,G,X){return j.isDisposed?Promise.reject(P.canceled()):j.requestPromise(q,Q,G,X)},listen(Q,G){return j.isDisposed?b.Event.None:j.requestEvent(q,Q,G)}}}requestPromise(q,j,Q,G=L.CancellationToken.None){const X=this.lastRequestId++,W={id:X,type:100,channelName:q,name:j,arg:Q};if(G.isCancellationRequested)return Promise.reject(P.canceled());let ee;return new Promise((N,x)=>{if(G.isCancellationRequested)return x(P.canceled());const Y=()=>{const me=Ee=>{switch(Ee.type){case 201:this.handlers.delete(X),N(Ee.data);break;case 202:{this.handlers.delete(X);const Se=new Error(Ee.data.message);Se.stack=Ee.data.stack,Se.name=Ee.data.name,x(Se);break}case 203:this.handlers.delete(X),x(Ee.data);break}};this.handlers.set(X,me),this.sendRequest(W)};let ne=null;this.state===g.Idle?Y():(ne=(0,i.createCancelablePromise)(me=>this.whenInitialized()),ne.then(()=>{ne=null,Y()}));const oe=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:X,type:101}),x(P.canceled())},de=G.onCancellationRequested(oe);ee=(0,E.combinedDisposable)((0,E.toDisposable)(oe),de),this.activeRequests.add(ee)}).finally(()=>{this.activeRequests.delete(ee)})}requestEvent(q,j,Q){const G=this.lastRequestId++,Z={id:G,type:102,channelName:q,name:j,arg:Q};let W=null;const ee=new b.Emitter({onFirstListenerAdd:()=>{W=(0,i.createCancelablePromise)(N=>this.whenInitialized()),W.then(()=>{W=null,this.activeRequests.add(ee),this.sendRequest(Z)})},onLastListenerRemove:()=>{W?(W.cancel(),W=null):(this.activeRequests.delete(ee),this.sendRequest({id:G,type:103}))}}),B=N=>ee.fire(N.data);return this.handlers.set(G,B),ee.event}sendRequest(q){switch(q.type){case 100:case 102:{const j=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(j,q.id,0,`${v(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const j=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(j,q.id,0,v(q.type));return}}}send(q,j=void 0){const Q=new w;return c(Q,q),c(Q,j),this.sendBuffer(Q.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const j=new S(q),Q=o(j),G=o(j),X=Q[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,d(X)),this.onResponse({type:Q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,Q[1],0,d(X),G),this.onResponse({type:Q[0],id:Q[1],data:G})}}onResponse(q){if(q.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(q.id);j&&j(q)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=m,fe([A.memoize],m.prototype,"onDidInitializePromise",null);class C{get connections(){const q=[];return this._connections.forEach(j=>q.push(j)),q}constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:j,onDidClientDisconnect:Q})=>{b.Event.once(j.onMessage)(X=>{const Z=new S(X),W=o(Z),ee=new s(j,W),B=new m(j);this.channels.forEach((x,Y)=>ee.registerChannel(Y,x));const N={channelServer:ee,channelClient:B,ctx:W};this._connections.add(N),this._onDidAddConnection.fire(N),Q(()=>{ee.dispose(),B.dispose(),this._connections.delete(N),this._onDidRemoveConnection.fire(N)})})})}getChannel(q,j){const Q=this;return{call(G,X,Z){let W;if((0,h.isFunction)(j)){let B=(0,R.getRandomElement)(Q.connections.filter(j));W=B?Promise.resolve(B):b.Event.toPromise(b.Event.filter(Q.onDidAddConnection,j))}else W=j.routeCall(Q,G,X);const ee=W.then(B=>B.channelClient.getChannel(q));return T(ee).call(G,X,Z)},listen(G,X){if((0,h.isFunction)(j))return Q.getMulticastEvent(q,j,G,X);const Z=j.routeEvent(Q,G,X).then(W=>W.channelClient.getChannel(q));return T(Z).listen(G,X)}}}getMulticastEvent(q,j,Q,G){const X=this;let Z=new E.DisposableStore;const W=new b.Emitter({onFirstListenerAdd:()=>{Z=new E.DisposableStore;const ee=new b.EventMultiplexer,B=new Map,N=Y=>{const oe=Y.channelClient.getChannel(q).listen(Q,G),de=ee.add(oe);B.set(Y,de)},x=Y=>{const ne=B.get(Y);!ne||(ne.dispose(),B.delete(Y))};X.connections.filter(j).forEach(N),b.Event.filter(X.onDidAddConnection,j)(N,void 0,Z),X.onDidRemoveConnection(x,void 0,Z),ee.event(W.fire,W,Z),Z.add(ee)},onLastListenerRemove:()=>{Z.dispose()}});return W.event}registerChannel(q,j){this.channels.set(q,j),this._connections.forEach(Q=>{Q.channelServer.registerChannel(q,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class M{constructor(q,j,Q=null){const G=new w;c(G,j),q.send(G.buffer),this.channelClient=new m(q,Q),this.channelServer=new s(q,j,Q)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,j){this.channelServer.registerChannel(q,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=M;function T(z){return{call(q,j,Q){return z.then(G=>G.call(q,j,Q))},listen(q,j){const Q=new b.Relay;return z.then(G=>Q.input=G.listen(q,j)),Q.event}}}e.getDelayedChannel=T;function F(z){let q=!1;return{call(j,Q,G){return q?z.call(j,Q,G):(0,i.timeout)(0).then(()=>q=!0).then(()=>z.call(j,Q,G))},listen(j,Q){if(q)return z.listen(j,Q);const G=new b.Relay;return(0,i.timeout)(0).then(()=>q=!0).then(()=>G.input=z.listen(j,Q)),G.event}}}e.getNextTickChannel=F;class _{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const j of q.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await b.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=_;var U;(function(z){function q(X,Z){const W=X,ee=Z&&Z.disableMarshalling,B=new Map;for(const N in W)Q(N)&&B.set(N,b.Event.buffer(W[N],!0));return new class{listen(N,x,Y){const ne=B.get(x);if(ne)return ne;if(G(x)){const oe=W[x];if(typeof oe=="function")return oe.call(W,Y)}throw new Error(`Event not found: ${x}`)}call(N,x,Y){const ne=W[x];if(typeof ne=="function"){if(!ee&&Array.isArray(Y))for(let oe=0;oe<Y.length;oe++)Y[oe]=(0,D.revive)(Y[oe]);return ne.apply(W,Y)}throw new Error(`Method not found: ${x}`)}}}z.fromService=q;function j(X,Z){const W=Z&&Z.disableMarshalling;return new Proxy({},{get(ee,B){if(typeof B=="string")return Z?.properties?.has(B)?Z.properties.get(B):G(B)?function(N){return X.listen(B,N)}:Q(B)?X.listen(B):async function(...N){let x;Z&&!(0,h.isUndefinedOrNull)(Z.context)?x=[Z.context,...N]:x=N;const Y=await X.call(B,x);return W?Y:(0,D.revive)(Y)};throw new Error(`Property not found: ${String(B)}`)}})}z.toService=j;function Q(X){return X[0]==="o"&&X[1]==="n"&&I.isUpperAsciiLetter(X.charCodeAt(2))}function G(X){return/^onDynamic/.test(X)&&I.isUpperAsciiLetter(X.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let q=z.toString();if(q!=="[object Object]")return q}return z}function V(z){return Array.isArray(z)?z.map($):$(z)}function te(z,q,j,Q,G,X,Z){Z=V(Z);const W=O[G],ee=W[Q%W.length];let B=[`%c[${z}]%c[${String(q).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${ee}`];/\($/.test(X)?(B=B.concat(Z),B.push(")")):B.push(Z),console.log.apply(console,B)}e.logWithColors=te;class H{constructor(q,j){this._outgoingPrefix=q,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,j,Q,G,X){this._totalOutgoing+=q,te(this._outgoingPrefix,this._totalOutgoing,q,j,Q,G,X)}logIncoming(q,j,Q,G,X){this._totalIncoming+=q,te(this._incomingPrefix,this._totalIncoming,q,j,Q,G,X)}}e.IPCLogger=H}),define(re[126],se([0,1,18,3,37]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(b){this.port=b,this.onMessage=i.Event.fromDOMEventEmitter(this.port,"message",E=>R.VSBuffer.wrap(E.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class A extends k.IPCClient{constructor(b,E){const D=new L(b);super(D,E);this.protocol=D}dispose(){this.protocol.disconnect()}}e.Client=A}),define(re[84],se([0,1,18,3,2,37]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var P;(function(a){a.enableDiagnostics=!1,a.records=[];const c=new WeakMap;let o=0;function s(m,C){if(!c.has(m)){const M=String(++o);c.set(m,M)}return c.get(m)}function u(m,C,M,T){if(!a.enableDiagnostics)return;const F=s(m,C);if(T instanceof R.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const _=R.VSBuffer.alloc(T.byteLength);_.set(T),a.records.push({timestamp:Date.now(),id:F,label:C,type:M,buff:_})}else a.records.push({timestamp:Date.now(),id:F,label:C,type:M,data:T})}a.traceSocketEvent=u})(P||(e.SocketDiagnostics=P={}));var b;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let E=null;function D(){return E||(E=R.VSBuffer.alloc(0)),E}class I{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(c){this._chunks.push(c),this._totalLength+=c.byteLength}read(c){return this._read(c,!0)}peek(c){return this._read(c,!1)}_read(c,o){if(c===0)return D();if(c>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===c){const C=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=c),C}if(this._chunks[0].byteLength>c){const C=this._chunks[0].slice(0,c);return o&&(this._chunks[0]=this._chunks[0].slice(c),this._totalLength-=c),C}let s=R.VSBuffer.alloc(c),u=0,m=0;for(;c>0;){const C=this._chunks[m];if(C.byteLength>c){const M=C.slice(0,c);s.set(M,u),u+=c,o&&(this._chunks[m]=C.slice(c),this._totalLength-=c),c-=c}else s.set(C,u),u+=C.byteLength,o?(this._chunks.shift(),this._totalLength-=C.byteLength):m++,c-=C.byteLength}return s}}e.ChunkStream=I;var h;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume"})(h||(h={}));function y(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var v;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v||(e.ProtocolConstants=v={}));class p{constructor(c,o,s,u){this.type=c,this.id=o,this.ack=s,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends k.Disposable{constructor(c){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=c,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const s=this._state.messageType,u=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new p(s,u,m,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(c){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=c,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(c){if(this._isDisposed)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=R.VSBuffer.alloc(13);o.writeUInt8(c.type,0),o.writeUInt32BE(c.id,1),o.writeUInt32BE(c.ack,5),o.writeUInt32BE(c.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",c.data),this._writeSoon(o,c.data)}_bufferAdd(c,o){const s=this._totalLength===0;return this._data.push(c,o),this._totalLength+=c.byteLength+o.byteLength,s}_bufferTake(){const c=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,c}_writeSoon(c,o){this._bufferAdd(c,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const c=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this._socket.write(c)}}class S extends k.Disposable{constructor(c){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=c,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(c){this._socketWriter.write(new p(1,0,0,c))}}e.Protocol=S;class w extends L.IPCClient{static fromSocket(c,o){return new w(new S(c),o)}get onDidDispose(){return this.protocol.onDidDispose}constructor(c,o,s=null){super(c,o,s);this.protocol=c}dispose(){super.dispose();const c=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),c.end()}}e.Client=w;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(c){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(c):this._emitter.fire(c):this._bufferedMessages.push(c)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class l{constructor(c){this.data=c,this.next=null}}class t{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let c=[],o=0,s=this._first;for(;s;)c[o++]=s.data,s=s.next;return c}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(c){const o=new l(c);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class r{static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const c=Date.now();for(let o=0;o<r._HISTORY_LENGTH;o++)this.lastRuns[o]=c-1e3*o;setInterval(()=>{for(let o=r._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}load(){const c=Date.now(),o=(1+r._HISTORY_LENGTH)*1e3;let s=0;for(let u=0;u<r._HISTORY_LENGTH;u++)c-this.lastRuns[u]<=o&&s++;return 1-s/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(c,o=null,s=r.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=s,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=c,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),o&&this._socketReader.acceptChunk(o)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const c=new p(5,0,0,D());this._socketWriter.write(c),this._socketWriter.flush()}sendPause(){const c=new p(7,0,0,D());this._socketWriter.write(c)}sendResume(){const c=new p(8,0,0,D());this._socketWriter.write(c)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(c,o){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=c,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(s=>this._onSocketClose.fire(s))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const c=new p(3,0,this._incomingAckId,D());this._socketWriter.write(c);const o=this._outgoingUnackMsg.toArray();for(let s=0,u=o.length;s<u;s++)this._socketWriter.write(o[s]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(c){if(c.ack>this._outgoingAckId){this._outgoingAckId=c.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=c.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this._incomingMsgId)if(c.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new p(6,0,0,D())))}else this._incomingMsgId=c.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(c.data);break}case 2:{this._onControlMessage.fire(c.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let s=0,u=o.length;s<u;s++)this._socketWriter.write(o[s]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(c){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const s=new p(1,o,this._incomingAckId,c);this._outgoingUnackMsg.push(s),this._isReconnecting||(this._socketWriter.write(s),this._recvAckCheck())}sendControl(c){const o=new p(2,0,0,c);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const c=Date.now()-this._incomingMsgLastTime;if(c>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-c+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const c=this._outgoingUnackMsg.peek(),o=Date.now()-c.writtenTime,s=Date.now()-this._socketReader.lastReadTime,u=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&s>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const m=Math.max(2e4-o,2e4-s,2e4-u,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},m)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const c=new p(3,0,this._incomingAckId,D());this._socketWriter.write(c)}}e.PersistentProtocol=n}),define(re[127],se([0,1,85,3,37,126]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends k.IPCServer{static getOnDidClientConnect(){const b=i.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(E,D)=>D);return i.Event.map(b,E=>{const{port1:D,port2:I}=new MessageChannel,y={protocol:new L.Protocol(D),onDidClientDisconnect:i.Event.fromDOMEventEmitter(D,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[I]),y})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(re[128],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const R="Offline";function i(L){return L instanceof k?!0:L instanceof Error&&L.name===R&&L.message===R}e.isOfflineError=i;class k extends Error{constructor(){super(R);this.name=this.message}}e.OfflineError=k}),define(re[129],se([0,1,18,7,128]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(b,E){if(!navigator.onLine)throw new k.OfflineError;b.proxyAuthorization&&(b.headers={...b.headers||{},"Proxy-Authorization":b.proxyAuthorization});const D=new XMLHttpRequest;return new Promise((I,h)=>{D.open(b.type||"GET",b.url||"",!0,b.user,b.password),A(D,b),D.responseType="arraybuffer",D.onerror=y=>h(new Error(D.statusText&&"XHR failed: "+D.statusText||"XHR failed")),D.onload=y=>{I({res:{statusCode:D.status,headers:P(D)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(D.response)))})},D.ontimeout=y=>h(new Error(`XHR timeout: ${b.timeout}ms`)),b.timeout&&(D.timeout=b.timeout),D.send(b.data),E.onCancellationRequested(()=>{D.abort(),h((0,i.canceled)())})})}e.request=L;function A(b,E){if(E.headers){e:for(let D in E.headers){switch(D){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}b.setRequestHeader(D,E.headers[D])}}}function P(b){const E=Object.create(null);for(const D of b.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(D){const I=D.indexOf(":");E[D.substr(0,I).trim().toLowerCase()]=D.substr(I+1).trim()}return E}}),define(re[86],se([0,1,6,3,2,13]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A||(e.StorageHint=A={}));function P(I){const h=I;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var b;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(b||(e.StorageState=b={}));class E extends k.Disposable{constructor(h,y=Object.create(null)){super();this.database=h,this.options=y,this._onDidChangeStorage=this._register(new i.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((y,v)=>this.accept(v,y)),h.deleted?.forEach(y=>this.accept(y,void 0))}accept(h,y){if(this.state===b.Closed)return;let v=!1;(0,L.isUndefinedOrNull)(y)?v=this.cache.delete(h):this.cache.get(h)!==y&&(this.cache.set(h,y),v=!0),v&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,y){const v=this.cache.get(h);return(0,L.isUndefinedOrNull)(v)?y:v}getBoolean(h,y){const v=this.get(h);return(0,L.isUndefinedOrNull)(v)?y:v==="true"}getNumber(h,y){const v=this.get(h);return(0,L.isUndefinedOrNull)(v)?y:parseInt(v,10)}async set(h,y){if(this.state===b.Closed)return;if((0,L.isUndefinedOrNull)(y))return this.delete(h);const v=String(y);if(this.cache.get(h)!==v)return this.cache.set(h,v),this.pendingInserts.set(h,v),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===b.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class D{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((y,v)=>this.items.set(v,y)),h.delete&&h.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=D}),define(re[130],se([10,11]),function(J,e){return J.create("vs/base/common/actions",e)}),define(re[87],se([0,1,3,2,130]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class L extends i.Disposable{constructor(h,y="",v="",p=!0,d){super();this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=h,this._label=y,this._cssClass=v,this._enabled=p,this._actionCallback=d}get id(){return this._id}get label(){return this._label}set label(h){this._setLabel(h)}_setLabel(h){this._label!==h&&(this._label=h,this._onDidChange.fire({label:h}))}get tooltip(){return this._tooltip||""}set tooltip(h){this._setTooltip(h)}_setTooltip(h){this._tooltip!==h&&(this._tooltip=h,this._onDidChange.fire({tooltip:h}))}get class(){return this._cssClass}set class(h){this._setClass(h)}_setClass(h){this._cssClass!==h&&(this._cssClass=h,this._onDidChange.fire({class:h}))}get enabled(){return this._enabled}set enabled(h){this._setEnabled(h)}_setEnabled(h){this._enabled!==h&&(this._enabled=h,this._onDidChange.fire({enabled:h}))}get checked(){return this._checked}set checked(h){this._setChecked(h)}_setChecked(h){this._checked!==h&&(this._checked=h,this._onDidChange.fire({checked:h}))}async run(h,y){this._actionCallback&&await this._actionCallback(h)}}e.Action=L;class A extends i.Disposable{constructor(){super(...arguments);this._onBeforeRun=this._register(new R.Emitter),this.onBeforeRun=this._onBeforeRun.event,this._onDidRun=this._register(new R.Emitter),this.onDidRun=this._onDidRun.event}async run(h,y){if(!h.enabled)return;this._onBeforeRun.fire({action:h});let v;try{await this.runAction(h,y)}catch(p){v=p}this._onDidRun.fire({action:h,error:v})}async runAction(h,y){await h.run(y)}}e.ActionRunner=A;class P extends L{static join(...h){let y=[];for(const v of h)v.length&&(y.length?y=[...y,new P,...v]:y=v);return y}constructor(h){super(P.ID,h,h?"separator text":"separator");this.checked=!1,this.enabled=!1}}e.Separator=P,P.ID="vs.actions.separator";class b{get actions(){return this._actions}constructor(h,y,v,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=y,this.class=p,this._actions=v}dispose(){}async run(){}}e.SubmenuAction=b;class E extends L{constructor(){super(E.ID,k.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=E,E.ID="vs.actions.empty";function D(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label,dispose:()=>{}}}e.toAction=D}),define(re[131],se([10,11]),function(J,e){return J.create("vs/base/common/date",e)}),define(re[61],se([0,1,131]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,k=i*60,L=k*24,A=L*7,P=L*30,b=L*365;function E(I,h,y){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,R.localize)(0,null,E(new Date().getTime()+v*1e3,!1));if(v<30)return(0,R.localize)(1,null);let p;return v<i?(p=v,h?p===1?y?(0,R.localize)(2,null,p):(0,R.localize)(3,null,p):y?(0,R.localize)(4,null,p):(0,R.localize)(5,null,p):p===1?y?(0,R.localize)(6,null,p):(0,R.localize)(7,null,p):y?(0,R.localize)(8,null,p):(0,R.localize)(9,null,p)):v<k?(p=Math.floor(v/i),h?p===1?y?(0,R.localize)(10,null,p):(0,R.localize)(11,null,p):y?(0,R.localize)(12,null,p):(0,R.localize)(13,null,p):p===1?y?(0,R.localize)(14,null,p):(0,R.localize)(15,null,p):y?(0,R.localize)(16,null,p):(0,R.localize)(17,null,p)):v<L?(p=Math.floor(v/k),h?p===1?y?(0,R.localize)(18,null,p):(0,R.localize)(19,null,p):y?(0,R.localize)(20,null,p):(0,R.localize)(21,null,p):p===1?y?(0,R.localize)(22,null,p):(0,R.localize)(23,null,p):y?(0,R.localize)(24,null,p):(0,R.localize)(25,null,p)):v<A?(p=Math.floor(v/L),h?p===1?(0,R.localize)(26,null,p):(0,R.localize)(27,null,p):p===1?(0,R.localize)(28,null,p):(0,R.localize)(29,null,p)):v<P?(p=Math.floor(v/A),h?p===1?y?(0,R.localize)(30,null,p):(0,R.localize)(31,null,p):y?(0,R.localize)(32,null,p):(0,R.localize)(33,null,p):p===1?y?(0,R.localize)(34,null,p):(0,R.localize)(35,null,p):y?(0,R.localize)(36,null,p):(0,R.localize)(37,null,p)):v<b?(p=Math.floor(v/P),h?p===1?y?(0,R.localize)(38,null,p):(0,R.localize)(39,null,p):y?(0,R.localize)(40,null,p):(0,R.localize)(41,null,p):p===1?y?(0,R.localize)(42,null,p):(0,R.localize)(43,null,p):y?(0,R.localize)(44,null,p):(0,R.localize)(45,null,p)):(p=Math.floor(v/b),h?p===1?y?(0,R.localize)(46,null,p):(0,R.localize)(47,null,p):y?(0,R.localize)(48,null,p):(0,R.localize)(49,null,p):p===1?y?(0,R.localize)(50,null,p):(0,R.localize)(51,null,p):y?(0,R.localize)(52,null,p):(0,R.localize)(53,null,p))}e.fromNow=E;function D(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(re[132],se([10,11]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(re[36],se([0,1,16,13,132]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(I,h){return h&&(I.stack||I.stacktrace)?k.localize(0,null,P(I),A(I.stack)||A(I.stacktrace)):P(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function P(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?k.localize(1,null,I.message):I.message||k.localize(2,null)}function b(I=null,h=!1){if(!I)return k.localize(3,null);if(Array.isArray(I)){const y=R.coalesce(I),v=b(y[0],h);return y.length>1?k.localize(4,null,v,y.length):v}if(i.isString(I))return I;if(I.detail){const y=I.detail;if(y.error)return L(y.error,h);if(y.exception)return L(y.exception,h)}return I.stack?L(I,h):I.message?I.message:k.localize(5,null)}e.toErrorMessage=b;function E(I){const h=I;return h instanceof Error&&Array.isArray(h.actions)}e.isErrorWithActions=E;function D(I,h){let y;return typeof I=="string"?y=new Error(I):y=I,y.actions=h,y}e.createErrorWithActions=D}),define(re[133],se([10,11]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(re[134],se([0,1,133]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function i(k){switch(k){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}e.getParseErrorMessage=i}),define(re[135],se([10,11]),function(J,e){return J.create("vs/base/node/processes",e)}),define(re[88],se([0,1,46,41,19,28,12,4,34,77,13,120,27,135]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function v(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(l,t){if(P.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};t&&(r.cwd=t);const n=R.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],r);return new Promise(a=>{n.once("error",c=>{a({success:!1,error:c})}),n.once("exit",(c,o)=>{a(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?v(r.status):1})}else if(P.isLinux||P.isMacintosh)try{const r=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(n=>{R.execFile(r,[l.pid.toString()],{encoding:"utf8",shell:!0},(a,c,o)=>{n(a?{success:!1,error:a}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function d(l=b.env){return l.comspec||"cmd.exe"}e.getWindowsShell=d;class g{constructor(t,r,n,a){if(r!==void 0&&n!==void 0&&a!==void 0)this.cmd=t,this.args=r,this.shell=n,this.options=a;else{const c=t;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(b.env).forEach(o=>{c[o]=b.env[o]}),Object.keys(this.options.env).forEach(o=>{c[o]=this.options.env[o]}),this.options.env=c}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const r=t.lastIndexOf(A.sep);return r!==-1&&(t=t.substring(r+1)),g.WellKnowCommands[t]?t:"other"}start(t){return P.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(b.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(r=>{let n,a;const c=new Promise((o,s)=>{n=o,a=s});if(r){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=R.exec(o,this.options,(s,u,m)=>{this.childProcess=null;const C=s;C&&C.killed?a({killed:this.terminateRequested,stdout:u.toString(),stderr:m.toString()}):this.handleExec(n,t,s,u,m)})}else{let o=null;const s=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,n,t,a);const m={terminated:this.terminateRequested};D.isNumber(u)&&(m.cmdCode=u),n(m)};if(this.shell&&P.isWindows){const u=L.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let m=!1,C=!1;const M=[];let T=this.ensureQuotes(this.cmd);M.push(T.value),m=T.quoted,this.args&&this.args.forEach(_=>{T=this.ensureQuotes(_),M.push(T.value),C=C&&T.quoted});const F=["/s","/c"];m?C?F.push('"'+M.join(" ")+'"'):M.length>1?F.push('"'+M[0]+'" '+M.slice(1).join(" ")):F.push('"'+M[0]+'"'):F.push(M.join(" ")),o=R.spawn(d(),F,u)}else this.cmd&&(o=R.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(D.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",u=>{this.childProcess=null,a({terminated:this.terminateRequested,error:u})}),o.pid&&(this.childProcess.on("close",s),this.handleSpawn(o,n,t,a,!0)))}return c})}handleClose(t,r,n,a){}ensureQuotes(t){return g.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,p(t,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!P.isWindows)return t(!1);const r=R.spawn(d(),["/s","/c"]);r.on("error",n=>t(!0)),r.on("exit",n=>t(!1))})}}e.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;class S extends g{constructor(t,r,n,a){super(t,r,n,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,r,n,a,c){[a,c].forEach((o,s)=>{const u=new I.LineDecoder;u.write(o).forEach(M=>{r({line:M,source:s===0?0:1})});const C=u.end();C&&r({line:C,source:s===0?0:1})}),t({terminated:this.terminateRequested,error:n})}handleSpawn(t,r,n,a,c){const o=new I.LineDecoder,s=new I.LineDecoder;t.stdout.on("data",u=>{o.write(u).forEach(C=>n({line:C,source:0}))}),t.stderr.on("data",u=>{s.write(u).forEach(C=>n({line:C,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=s}handleClose(t,r,n,a){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&n({line:c,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&n({line:o,source:1})}}e.LineProcess=S;function w(l){let t=[],r=!1;const n=function(a){if(r){t.push(a);return}(!l.send(a,o=>{if(o&&console.error(o),r=!1,t.length>0){const s=t.slice(0);t=[],s.forEach(u=>n(u))}})||P.isWindows)&&(r=!0)};return{send:n}}e.createQueuedSender=w;var f;(function(l){async function t(r,n,a){if(A.isAbsolute(r))return r;if(n===void 0&&(n=b.cwd()),A.dirname(r)!=="."||(a===void 0&&D.isString(b.env.PATH)&&(a=b.env.PATH.split(A.delimiter)),a===void 0||a.length===0))return A.join(n,r);async function o(s){if(await h.Promises.exists(s)){let u;try{u=await h.Promises.stat(s)}catch(m){m.message.startsWith("EACCES")&&(u=await h.Promises.lstat(s))}return u?!u.isDirectory():!1}return!1}for(let s of a){let u;if(A.isAbsolute(s)?u=A.join(s,r):u=A.join(n,s,r),await o(u))return u;let m=u+".com";if(await o(m)||(m=u+".exe",await o(m)))return m}return A.join(n,r)}l.findExecutable=t})(f||(e.win32=f={}))}),define(re[136],se([0,1,35,4,83,88]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(y,v){return y===1?i.isWindows?I():L.getWindowsShell(v):E(y,v)}e.getSystemShell=A;function P(y,v){return y===1?i.isWindows?h(v):L.getWindowsShell(v):E(y,v)}e.getSystemShellSync=P;let b=null;function E(y,v){if(i.isLinux&&y===2||i.isMacintosh&&y===3)return"/bin/bash";if(!b){let p;if(i.isWindows)p="/bin/bash";else{if(p=v.SHELL,!p)try{p=(0,R.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}b=p}return b}let D=null;async function I(){return D||(D=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),D}function h(y){if(D)return D;const v=i.isWindows&&parseFloat((0,R.release)())>=10,p=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${y.windir}\\${p?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return v?d:L.getWindowsShell(y)}}),define(re[62],se([0,1,46,6,18,23,118,7,3,2,28,88,77,37]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class v extends y.ChannelServer{constructor(g){super({send:S=>{try{process.send&&process.send(S.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",S=>k.VSBuffer.wrap(Buffer.from(S,"base64")))},g);process.once("disconnect",()=>this.dispose())}}e.Server=v;class p{constructor(g,S){this.modulePath=g,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new i.Delayer(w),this.child=null,this._client=null}getChannel(g){const S=this;return{call(w,f,l){return S.requestPromise(g,w,f,l)},listen(w,f){return S.requestEvent(g,w,f)}}}requestPromise(g,S,w,f=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(g),t=(0,i.createCancelablePromise)(a=>l.call(S,w,a)),r=f.onCancellationRequested(()=>t.cancel()),n=(0,E.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{r.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(g,S,w){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let f;const l=new b.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(g).listen(S,w)(l.fire,l),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),(0,h.removeDangerousEnvVariables)(S.env),this.child=(0,R.fork)(this.modulePath,g,S);const w=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,A.isRemoteConsoleLog)(c)){(0,A.log)(c,`IPC Library: ${this.options.serverName}`);return}w.fire(k.VSBuffer.wrap(Buffer.from(c,"base64")))});const l=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&l.send(c.buffer.toString("base64")),r=w.event,n={send:t,onMessage:r};this._client=new y.ChannelClient(n);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,o)=>{process.removeListener("exit",a),this.activeRequests.forEach(s=>(0,E.dispose)(s)),this.activeRequests.clear(),c!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:o})})}return this._client}getCachedChannel(g){let S=this.channels.get(g);return S||(S=this.client.getChannel(g),this.channels.set(g,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(re[137],se([10,11]),function(J,e){return J.create("vs/base/node/zip",e)}),define(re[138],se([10,11]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[139],se([10,11]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(re[140],se([10,11]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(re[141],se([10,11]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[142],se([10,11]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[143],se([10,11]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[144],se([10,11]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(re[145],se([10,11]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[146],se([10,11]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[147],se([10,11]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[148],se([10,11]),function(J,e){return J.create("vs/platform/extensionsGallery/common/extensionsGalleryConfig",e)}),define(re[149],se([10,11]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(re[150],se([10,11]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(re[151],se([10,11]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(re[152],se([10,11]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[153],se([10,11]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[154],se([10,11]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(re[155],se([10,11]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(re[156],se([10,11]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[157],se([10,11]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[158],se([10,11]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[159],se([10,11]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[160],se([10,11]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[161],se([10,11]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[162],se([10,11]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[163],se([10,11]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[164],se([10,11]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[165],se([10,11]),function(J,e){return J.create("vs/workbench/services/notification/common/notificationService",e)}),define(re[89],se([0,1,61,45,19,12,34,20,8]),function(J,e,R,i,k,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{get appRoot(){return(0,L.dirname)(k.FileAccess.asFileUri("",J).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(b.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=A.env.VSCODE_PORTABLE;return p?b.URI.file((0,L.join)(p,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,L.resolve)(p):(0,L.normalize)((0,L.join)(k.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const p=this.args["extensions-download-dir"];return p?(0,L.resolve)(p):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,L.resolve)(p);const d=A.env.VSCODE_EXTENSIONS;if(d)return d;const g=A.env.VSCODE_PORTABLE;return g?(0,L.join)(g,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(d=>/^[^:/?#]+?:\/\//.test(d)?b.URI.parse(d):b.URI.file((0,L.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?b.URI.parse(p):b.URI.file((0,L.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return b.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=A.env.VSCODE_PORTABLE;return p?b.URI.file((0,L.join)(p,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}constructor(p,d,g){this._args=p,this.paths=d,this.productService=g}}e.AbstractNativeEnvironmentService=E,fe([i.memoize],E.prototype,"appRoot",null),fe([i.memoize],E.prototype,"userHome",null),fe([i.memoize],E.prototype,"userDataPath",null),fe([i.memoize],E.prototype,"appSettingsHome",null),fe([i.memoize],E.prototype,"tmpDir",null),fe([i.memoize],E.prototype,"cacheHome",null),fe([i.memoize],E.prototype,"userRoamingDataHome",null),fe([i.memoize],E.prototype,"settingsResource",null),fe([i.memoize],E.prototype,"userDataSyncHome",null),fe([i.memoize],E.prototype,"userDataSyncLogResource",null),fe([i.memoize],E.prototype,"sync",null),fe([i.memoize],E.prototype,"machineSettingsResource",null),fe([i.memoize],E.prototype,"globalStorageHome",null),fe([i.memoize],E.prototype,"workspaceStorageHome",null),fe([i.memoize],E.prototype,"localHistoryHome",null),fe([i.memoize],E.prototype,"keybindingsResource",null),fe([i.memoize],E.prototype,"keyboardLayoutResource",null),fe([i.memoize],E.prototype,"argvResource",null),fe([i.memoize],E.prototype,"snippetsHome",null),fe([i.memoize],E.prototype,"isExtensionDevelopment",null),fe([i.memoize],E.prototype,"untitledWorkspacesHome",null),fe([i.memoize],E.prototype,"installSourcePath",null),fe([i.memoize],E.prototype,"builtinExtensionsPath",null),fe([i.memoize],E.prototype,"extensionsPath",null),fe([i.memoize],E.prototype,"extensionDevelopmentLocationURI",null),fe([i.memoize],E.prototype,"extensionDevelopmentKind",null),fe([i.memoize],E.prototype,"extensionTestsLocationURI",null),fe([i.memoize],E.prototype,"debugExtensionHost",null),fe([i.memoize],E.prototype,"serviceMachineIdResource",null),fe([i.memoize],E.prototype,"telemetryLogResource",null),fe([i.memoize],E.prototype,"disableWorkspaceTrust",null),fe([i.memoize],E.prototype,"policyFile",null);function D(v,p){return y(v["inspect-extensions"],v["inspect-brk-extensions"],5870,p,v.debugId,v.extensionEnvironment)}e.parseExtensionHostPort=D;function I(v,p){return y(v["inspect-search"],v["inspect-brk-search"],5876,p,v.extensionEnvironment)}e.parseSearchPort=I;function h(v,p){return y(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,p,v.extensionEnvironment)}e.parsePtyHostPort=h;function y(v,p,d,g,S,w){const l=Number(p||v)||(g?null:d),t=l?Boolean(!!p):!1;let r;if(w)try{r=JSON.parse(w)}catch{}return{port:l,break:t,debugId:S,env:r}}}),define(re[166],se([0,1,271,4,139]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(18,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(28,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(v,p,d=A){const g={},S=["_"],w=[];for(let r in p){const n=p[r];n.alias&&(g[r]=n.alias),n.type==="string"||n.type==="string[]"?(S.push(r),n.deprecates&&S.push(...n.deprecates)):n.type==="boolean"&&(w.push(r),n.deprecates&&w.push(...n.deprecates))}const f=R(v,{string:S,boolean:w,alias:g}),l={},t=f;l._=f._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in p){const n=p[r];n.alias&&delete t[n.alias];let a=t[r];if(n.deprecates)for(const c of n.deprecates)t.hasOwnProperty(c)&&(a||(a=t[c],a&&d.onDeprecatedOption(c,n.deprecationMessage||(0,k.localize)(33,null,r))),delete t[c]);if(typeof a!="undefined"){if(n.type==="string[]"){if(Array.isArray(a)||(a=[a]),!n.allowEmptyValue){const c=a.filter(o=>o.length>0);c.length!==a.length&&(d.onEmptyValue(r),a=c.length>0?c:void 0)}}else n.type==="string"&&(Array.isArray(a)?(a=a.pop(),d.onMultipleValues(r,a)):!a&&!n.allowEmptyValue&&(d.onEmptyValue(r),a=void 0));l[r]=a,n.deprecationMessage&&d.onDeprecatedOption(r,n.deprecationMessage)}delete t[r]}for(let r in t)d.onUnknownOption(r);return l}e.parseArgs=P;function b(v,p){let d="";return p.args&&(Array.isArray(p.args)?d=` <${p.args.join("> <")}>`:d=` <${p.args}>`),p.alias?`-${p.alias} --${v}${d}`:`--${v}${d}`}function E(v,p){let d=0,g=[];for(const l in v){const t=v[l],r=b(l,t);d=Math.max(d,r.length),g.push([r,t.description])}let S=d+2+1;if(p-S<25)return g.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let w=p-S-1,f=[];for(const l of g){let t=l[0],r=I(l[1],w),n=D(S-t.length-2);f.push("  "+t+n+r[0]);for(let a=1;a<r.length;a++)f.push(D(S)+r[a])}return f}e.formatOptions=E;function D(v){return" ".repeat(v)}function I(v,p){let d=[];for(;v.length;){let g=v.length<p?v.length:v.lastIndexOf(" ",p),S=v.slice(0,g).trim();v=v.slice(g),d.push(S)}return d}function h(v,p,d,g,S){const w=process.stdout.isTTY&&process.stdout.columns||80,f=S?.noInputFiles!==!0?`[${(0,k.localize)(34,null)}...]`:"",l=[`${v} ${d}`];l.push(""),l.push(`${(0,k.localize)(35,null)}: ${p} [${(0,k.localize)(36,null)}]${f}`),l.push(""),S?.noPipe!==!0&&(i.isWindows?l.push((0,k.localize)(37,null,p)):l.push((0,k.localize)(38,null,p)),l.push(""));const t={};for(const r in g){const n=g[r];if(n.description&&n.cat){let a=t[n.cat];a||(t[n.cat]=a={}),a[r]=n}}for(let r in t){const n=r;let a=t[n];a&&(l.push(L[n]),l.push(...E(a,w)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=h;function y(v,p){return`${v||(0,k.localize)(39,null)}
${p||(0,k.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=y}),define(re[167],se([0,1,272,140,166]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function A(h,y){const v={onUnknownOption:d=>{console.warn((0,i.localize)(0,null,d))},onMultipleValues:(d,g)=>{console.warn((0,i.localize)(1,null,d,g))},onEmptyValue:d=>{console.warn((0,i.localize)(2,null,d))},onDeprecatedOption:(d,g)=>{console.warn((0,i.localize)(3,null,d,g))}},p=(0,k.parseArgs)(h,k.OPTIONS,y?v:void 0);return p.goto&&p._.forEach(d=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,i.localize)(4,null))),p["max-memory"]&&R(parseInt(p["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),p}function P(h){const y=h.findIndex(v=>!/^-/.test(v));if(y>-1)return[...h.slice(0,y),...h.slice(y+1)]}function b(h){let[,...y]=h;process.env.VSCODE_DEV&&(y=P(y)||[]);const v=!I(process.env);return A(y,v)}e.parseMainProcessArgv=b;function E(h){const[,,...y]=h;return A(y,!0)}e.parseCLIProcessArgv=E;function D(h,...y){const v=h.indexOf("--");return v===-1?h.push(...y):h.splice(v,0,...y),h}e.addArg=D;function I(h){return h.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),function(){"use strict";function J(e,R,i,k){function L(P){const b=A(P),E=[b];return e.isAbsolute(b)||E.unshift(k),e.resolve(...E)}function A(P){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,i);const D=P["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(I,"AppData","Roaming")}break;case"darwin":E=e.join(R.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,i)}return{getUserDataPath:L}}if(typeof define=="function")define(re[168],se([0,273,35,19,20,34]),function(e,R,i,k,L,A){const P=L.dirname(k.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(L.joinPath(P,"package.json").fsPath);return J(R,i,b.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),i=require("os");module.exports=J(R,i,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[169],se([0,1,35,89,168]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends i.AbstractNativeEnvironmentService{constructor(P,b){super(P,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,k.getUserDataPath)(P)},b)}}e.NativeEnvironmentService=L}),define(re[170],se([0,1,8]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(d){const g=d.match(A);return g?g[1]:null}function D(d){if(d.indexOf("://")===-1){const g=d.match(i);return g?E(g[2]):null}try{const g=R.URI.parse(d);if(g.authority)return E(g.authority)}catch{}return null}function I(d,g){const S=new Set;let w;for(;w=P.exec(d);){const l=D(w[1]);l&&S.add(l)}const f=new Set(g);return Array.from(S).map(l=>f.has(l)?l:l.replace(b,"a"))}e.getDomainsOfRemotes=I;function h(d){const g=d.match(L);return g?g[2]:null}function y(d,g,S){return d&&g?(S&&g.endsWith(".git")&&(g=g.substr(0,g.length-4)),g.indexOf("/")===0?`${d}${g}`:`${d}/${g}`):null}function v(d,g){if(d.indexOf("://")===-1){const S=d.match(k);if(S)return y(S[2],S[3],g)}try{const S=R.URI.parse(d);if(S.authority)return y(h(S.authority),S.path,g)}catch{}return null}function p(d,g=!1){const S=[];let w;for(;w=P.exec(d);){const f=v(w[1],g);f&&S.push(f)}return S}e.getRemotes=p}),define(re[171],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,A,P,b){return this.channel.call("promptImportantExtensionsInstallNotification",[L,A,P,b])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class i{constructor(L){this.service=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(re[63],se([0,1,20,59,147,53]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function b(g){return g=g.trim(),g==="*"||A.test(g)}e.isValidVersionStr=b;function E(g){if(!b(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=g.match(A);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=E;function D(g){if(!g)return null;let S=g.majorBase,w=g.majorMustEqual,f=g.minorBase,l=g.minorMustEqual,t=g.patchBase,r=g.patchMustEqual;g.hasCaret&&(S===0||(l=!1),r=!1);let n=0;if(g.preRelease){const a=P.exec(g.preRelease);if(a){const[,c,o,s]=a;n=Date.UTC(Number(c),Number(o)-1,Number(s))}}return{majorBase:S,majorMustEqual:w,minorBase:f,minorMustEqual:l,patchBase:t,patchMustEqual:r,isMinimum:g.hasGreaterEquals,notBefore:n}}e.normalizeVersion=D;function I(g,S,w){let f;typeof g=="string"?f=D(E(g)):f=g;let l;S instanceof Date?l=S.getTime():typeof S=="string"&&(l=new Date(S).getTime());let t;if(typeof w=="string"?t=D(E(w)):t=w,!f||!t)return!1;let r=f.majorBase,n=f.minorBase,a=f.patchBase,c=t.majorBase,o=t.minorBase,s=t.patchBase,u=t.notBefore,m=t.majorMustEqual,C=t.minorMustEqual,M=t.patchMustEqual;return t.isMinimum?r>c?!0:r<c?!1:n>o?!0:n<o||l&&l<u?!1:a>=s:(r===1&&c===0&&(!m||!C||!M)&&(c=1,o=0,s=0,m=!0,C=!1,M=!1),r<c?!1:r>c?!m:n<o?!1:n>o?!C:a<s?!1:a>s?!M:!(l&&l<u))}e.isValidVersion=I;function h(g,S,w,f,l){const t=[];if(typeof f.publisher!="undefined"&&typeof f.publisher!="string")return t.push([i.default.Error,k.localize(0,null)]),t;if(typeof f.name!="string")return t.push([i.default.Error,k.localize(1,null,"name")]),t;if(typeof f.version!="string")return t.push([i.default.Error,k.localize(2,null,"version")]),t;if(!f.engines)return t.push([i.default.Error,k.localize(3,null,"engines")]),t;if(typeof f.engines.vscode!="string")return t.push([i.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof f.extensionDependencies!="undefined"&&!d(f.extensionDependencies))return t.push([i.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof f.activationEvents!="undefined"){if(!d(f.activationEvents))return t.push([i.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof f.main=="undefined"&&typeof f.browser=="undefined")return t.push([i.default.Error,k.localize(7,null,"activationEvents","main")]),t}if(typeof f.extensionKind!="undefined"&&typeof f.main=="undefined"&&t.push([i.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main!="undefined"){if(typeof f.main!="string")return t.push([i.default.Error,k.localize(9,null,"main")]),t;{const a=(0,R.joinPath)(w,f.main);(0,R.isEqualOrParent)(a,w)||t.push([i.default.Warning,k.localize(10,null,a.path,w.path)])}if(typeof f.activationEvents=="undefined")return t.push([i.default.Error,k.localize(11,null,"activationEvents","main")]),t}if(typeof f.browser!="undefined"){if(typeof f.browser!="string")return t.push([i.default.Error,k.localize(12,null,"browser")]),t;{const a=(0,R.joinPath)(w,f.browser);(0,R.isEqualOrParent)(a,w)||t.push([i.default.Warning,k.localize(13,null,a.path,w.path)])}if(typeof f.activationEvents=="undefined")return t.push([i.default.Error,k.localize(14,null,"activationEvents","browser")]),t}if(!L.valid(f.version))return t.push([i.default.Error,k.localize(15,null)]),t;const r=[];if(!y(g,S,f,l,r))for(const a of r)t.push([i.default.Error,a]);return t}e.validateExtensionManifest=h;function y(g,S,w,f,l){return f||typeof w.main=="undefined"&&typeof w.browser=="undefined"?!0:p(g,S,w.engines.vscode,l)}e.isValidExtensionVersion=y;function v(g,S,w){return g==="*"||p(S,w,g)}e.isEngineValid=v;function p(g,S,w,f=[]){let l=D(E(w));if(!l)return f.push(k.localize(16,null,w)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return f.push(k.localize(17,null,w)),!1}else if(!l.majorMustEqual)return f.push(k.localize(18,null,w)),!1;return I(g,S,l)?!0:(f.push(k.localize(19,null,g,w)),!1)}function d(g){if(!Array.isArray(g))return!1;for(let S=0,w=g.length;S<w;S++)if(typeof g[S]!="string")return!1;return!0}}),define(re[47],se([0,1,18,30]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(L,A,P){let b=P&&P.get("storage.serviceMachineId",0)||null;if(b)return b;try{const D=(await A.readFile(L.serviceMachineIdResource)).value.toString();b=(0,i.isUUID)(D)?D:null}catch{b=null}if(!b){b=(0,i.generateUuid)();try{await A.writeFile(L.serviceMachineIdResource,R.VSBuffer.fromString(b))}catch{}}return P&&P.store("storage.serviceMachineId",b,0,1),b}e.getServiceMachineId=k}),define(re[54],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(k,L=[],A=!1){this.ctor=k,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=R}),define(re[64],se([0,1,54]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function k(A,P,b){P instanceof R.SyncDescriptor||(P=new R.SyncDescriptor(P,[],b)),i.push([A,P])}e.registerSingleton=k;function L(){return i}e.getSingletonServiceDescriptors=L}),define(re[172],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=R;class i{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let A of this._nodes.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const P=this.lookupOrInsertNode(L),b=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),b),b.incoming.set(this._hashFn(L),P)}removeNode(L){const A=this._hashFn(L);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(L){const A=this._hashFn(L);let P=this._nodes.get(A);return P||(P=new R(L),this._nodes.set(A,P)),P}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[A,P]of this._nodes)L.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,A]of this._nodes){const P=new Set([L]),b=this._findCycle(A,P);if(b)return b}}_findCycle(L,A){for(let[P,b]of L.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const E=this._findCycle(b,A);if(E)return E;A.delete(P)}}}e.Graph=i}),define(re[5],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(R||(e._util=R={})),e.IInstantiationService=k("instantiationService");function i(A,P,b){P[R.DI_TARGET]===P?P[R.DI_DEPENDENCIES].push({id:A,index:b}):(P[R.DI_DEPENDENCIES]=[{id:A,index:b}],P[R.DI_TARGET]=P)}function k(A){if(R.serviceIds.has(A))return R.serviceIds.get(A);const P=function(b,E,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(P,b,D)};return P.toString=()=>A,R.serviceIds.set(A,P),P}e.createDecorator=k;function L(A){return A}e.refineServiceDecorator=L}),define(re[173],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(re[17],se([0,1,13,8,5]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function L(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof i.URI)}e.isConfigurationOverrides=L;function A(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||R.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=A;var P;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function b(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function E(g,S){const w=Object.create(null);for(let f in g)D(w,f,g[f],S);return w}e.toValuesTree=E;function D(g,S,w,f){const l=S.split("."),t=l.pop();let r=g;for(let n=0;n<l.length;n++){let a=l[n],c=r[a];switch(typeof c){case"undefined":c=r[a]=Object.create(null);break;case"object":break;default:f(`Ignoring ${S} as ${l.slice(0,n+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[t]=w}catch{f(`Ignoring ${S} as ${l.join(".")} is ${JSON.stringify(r)}`)}else f(`Ignoring ${S} as ${l.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=D;function I(g,S){const w=S.split(".");h(g,w)}e.removeFromValueTree=I;function h(g,S){const w=S.shift();if(S.length===0){delete g[w];return}if(Object.keys(g).indexOf(w)!==-1){const f=g[w];typeof f=="object"&&!Array.isArray(f)&&(h(f,S),Object.keys(f).length===0&&delete g[w])}}function y(g,S,w){function f(r,n){let a=r;for(const c of n){if(typeof a!="object"||a===null)return;a=a[c]}return a}const l=S.split("."),t=f(g,l);return typeof t=="undefined"?w:t}e.getConfigurationValue=y;function v(g,S,w){Object.keys(S).forEach(f=>{f!=="__proto__"&&(f in g?R.isObject(g[f])&&R.isObject(S[f])?v(g[f],S[f],w):w&&(g[f]=S[f]):g[f]=S[f])})}e.merge=v;function p(g,S,w){const f=g.inspect(S),l=g.inspect(w);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:f.defaultValue}e.getMigratedSettingValue=p;function d(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(re[174],se([0,1,4,26,5]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",R.isMacintosh),L.set("isLinux",R.isLinux),L.set("isWindows",R.isWindows),L.set("isWeb",R.isWeb),L.set("isMacNative",R.isMacintosh&&!R.isWeb),L.set("isEdge",R.isEdge),L.set("isFirefox",R.isFirefox),L.set("isChrome",R.isChrome),L.set("isSafari",R.isSafari);const A=Object.prototype.hasOwnProperty;var P;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));class b{static false(){return I.INSTANCE}static true(){return h.INSTANCE}static has(_){return y.create(_)}static equals(_,U){return v.create(_,U)}static notEquals(_,U){return g.create(_,U)}static regex(_,U){return n.create(_,U)}static in(_,U){return p.create(_,U)}static not(_){return S.create(_)}static and(..._){return o.create(_,null)}static or(..._){return s.create(_,null,!0)}static greater(_,U){return f.create(_,U)}static greaterEquals(_,U){return l.create(_,U)}static smaller(_,U){return t.create(_,U)}static smallerEquals(_,U){return r.create(_,U)}static deserialize(_,U=!1){if(!!_)return this._deserializeOrExpression(_,U)}static _deserializeOrExpression(_,U){let O=_.split("||");return s.create(O.map($=>this._deserializeAndExpression($,U)),null,!0)}static _deserializeAndExpression(_,U){let O=_.split("&&");return o.create(O.map($=>this._deserializeOne($,U)),null)}static _deserializeOne(_,U){if(_=_.trim(),_.indexOf("!=")>=0){let O=_.split("!=");return g.create(O[0].trim(),this._deserializeValue(O[1],U))}if(_.indexOf("==")>=0){let O=_.split("==");return v.create(O[0].trim(),this._deserializeValue(O[1],U))}if(_.indexOf("=~")>=0){let O=_.split("=~");return n.create(O[0].trim(),this._deserializeRegexValue(O[1],U))}if(_.indexOf(" in ")>=0){let O=_.split(" in ");return p.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const O=_.split(">=");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const O=_.split(">");return f.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const O=_.split("<=");return r.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const O=_.split("<");return t.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(_)?S.create(_.substr(1).trim()):y.create(_)}static _deserializeValue(_,U){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let O=/^'([^']*)'$/.exec(_);return O?O[1].trim():_}static _deserializeRegexValue(_,U){if((0,i.isFalsyOrWhitespace)(_)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=_.indexOf("/"),$=_.lastIndexOf("/");if(O===$||O<0){if(U)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let V=_.slice(O+1,$),te=_[$+1]==="i"?"i":"";try{return new RegExp(V,te)}catch(H){if(U)throw new Error(`bad regexp-value '${_}', parse error: ${H}`);return console.warn(`bad regexp-value '${_}', parse error: ${H}`),null}}}e.ContextKeyExpr=b;function E(F,_){const U=F?F.substituteConstants():void 0,O=_?_.substituteConstants():void 0;return!U&&!O?!0:!U||!O?!1:U.equals(O)}e.expressionsAreEqualWithConstantSubstitution=E;function D(F,_){return F.cmp(_)}class I{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class h{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class y{static create(_,U=null){const O=L.get(_);return typeof O=="boolean"?O?h.INSTANCE:I.INSTANCE:new y(_,U)}constructor(_,U){this.key=_,this.negated=U,this.type=2}cmp(_){return _.type!==this.type?this.type-_.type:m(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=L.get(this.key);return typeof _=="boolean"?_?h.INSTANCE:I.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class v{static create(_,U,O=null){if(typeof U=="boolean")return U?y.create(_,O):S.create(_,O);const $=L.get(_);return typeof $=="boolean"?U===($?"true":"false")?h.INSTANCE:I.INSTANCE:new v(_,U,O)}constructor(_,U,O){this.key=_,this.value=U,this.negated=O,this.type=4}cmp(_){return _.type!==this.type?this.type-_.type:C(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=L.get(this.key);if(typeof _=="boolean"){const U=_?"true":"false";return this.value===U?h.INSTANCE:I.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=v;class p{static create(_,U){return new p(_,U)}constructor(_,U){this.key=_,this.valueKey=U,this.type=10,this.negated=null}cmp(_){return _.type!==this.type?this.type-_.type:C(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const U=_.getValue(this.valueKey),O=_.getValue(this.key);return Array.isArray(U)?U.includes(O):typeof O=="string"&&typeof U=="object"&&U!==null?A.call(U,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyInExpr=p;class d{static create(_){return new d(_)}constructor(_){this._actual=_,this.type=11}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new d(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=d;class g{static create(_,U,O=null){if(typeof U=="boolean")return U?S.create(_,O):y.create(_,O);const $=L.get(_);return typeof $=="boolean"?U===($?"true":"false")?I.INSTANCE:h.INSTANCE:new g(_,U,O)}constructor(_,U,O){this.key=_,this.value=U,this.negated=O,this.type=5}cmp(_){return _.type!==this.type?this.type-_.type:C(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=L.get(this.key);if(typeof _=="boolean"){const U=_?"true":"false";return this.value===U?I.INSTANCE:h.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class S{static create(_,U=null){const O=L.get(_);return typeof O=="boolean"?O?I.INSTANCE:h.INSTANCE:new S(_,U)}constructor(_,U){this.key=_,this.negated=U,this.type=3}cmp(_){return _.type!==this.type?this.type-_.type:m(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=L.get(this.key);return typeof _=="boolean"?_?I.INSTANCE:h.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=S;function w(F,_){if(typeof F=="string"){const U=parseFloat(F);isNaN(U)||(F=U)}return typeof F=="string"||typeof F=="number"?_(F):I.INSTANCE}class f{static create(_,U,O=null){return w(U,$=>new f(_,$,O))}constructor(_,U,O){this.key=_,this.value=U,this.negated=O,this.type=12}cmp(_){return _.type!==this.type?this.type-_.type:C(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class l{static create(_,U,O=null){return w(U,$=>new l(_,$,O))}constructor(_,U,O){this.key=_,this.value=U,this.negated=O,this.type=13}cmp(_){return _.type!==this.type?this.type-_.type:C(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class t{static create(_,U,O=null){return w(U,$=>new t(_,$,O))}constructor(_,U,O){this.key=_,this.value=U,this.negated=O,this.type=14}cmp(_){return _.type!==this.type?this.type-_.type:C(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class r{static create(_,U,O=null){return w(U,$=>new r(_,$,O))}constructor(_,U,O){this.key=_,this.value=U,this.negated=O,this.type=15}cmp(_){return _.type!==this.type?this.type-_.type:C(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class n{static create(_,U){return new n(_,U)}constructor(_,U){this.key=_,this.regexp=U,this.type=7,this.negated=null}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const U=this.regexp?this.regexp.source:"",O=_.regexp?_.regexp.source:"";return U<O?-1:U>O?1:0}equals(_){if(_.type===this.type){const U=this.regexp?this.regexp.source:"",O=_.regexp?_.regexp.source:"";return this.key===_.key&&U===O}return!1}substituteConstants(){return this}evaluate(_){let U=_.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=a.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class a{static create(_){return new a(_)}constructor(_){this._actual=_,this.type=8}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new a(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;function c(F){let _=null;for(let U=0,O=F.length;U<O;U++){const $=F[U].substituteConstants();if(F[U]!==$&&_===null){_=[];for(let V=0;V<U;V++)_[V]=F[V]}_!==null&&(_[U]=$)}return _===null?F:_}class o{static create(_,U){return o._normalizeArr(_,U)}constructor(_,U){this.expr=_,this.negated=U,this.type=6}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let U=0,O=this.expr.length;U<O;U++){const $=D(this.expr[U],_.expr[U]);if($!==0)return $}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let U=0,O=this.expr.length;U<O;U++)if(!this.expr[U].equals(_.expr[U]))return!1;return!0}return!1}substituteConstants(){const _=c(this.expr);return _===this.expr?this:o.create(_,this.negated)}evaluate(_){for(let U=0,O=this.expr.length;U<O;U++)if(!this.expr[U].evaluate(_))return!1;return!0}static _normalizeArr(_,U){const O=[];let $=!1;for(const V of _)if(!!V){if(V.type===1){$=!0;continue}if(V.type===0)return I.INSTANCE;if(V.type===6){O.push(...V.expr);continue}O.push(V)}if(O.length===0&&$)return h.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(D);for(let V=1;V<O.length;V++)O[V-1].equals(O[V])&&(O.splice(V,1),V--);if(O.length===1)return O[0];for(;O.length>1;){const V=O[O.length-1];if(V.type!==9)break;O.pop();const te=O.pop(),H=O.length===0,z=s.create(V.expr.map(q=>o.create([q,te],null)),null,H);z&&(O.push(z),O.sort(D))}return O.length===1?O[0]:new o(O,U)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let U of this.expr)_.push(...U.keys());return _}map(_){return new o(this.expr.map(U=>U.map(_)),null)}negate(){if(!this.negated){const _=[];for(let U of this.expr)_.push(U.negate());this.negated=s.create(_,this,!0)}return this.negated}}class s{static create(_,U,O){return s._normalizeArr(_,U,O)}constructor(_,U){this.expr=_,this.negated=U,this.type=9}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let U=0,O=this.expr.length;U<O;U++){const $=D(this.expr[U],_.expr[U]);if($!==0)return $}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let U=0,O=this.expr.length;U<O;U++)if(!this.expr[U].equals(_.expr[U]))return!1;return!0}return!1}substituteConstants(){const _=c(this.expr);return _===this.expr?this:s.create(_,this.negated,!1)}evaluate(_){for(let U=0,O=this.expr.length;U<O;U++)if(this.expr[U].evaluate(_))return!0;return!1}static _normalizeArr(_,U,O){let $=[],V=!1;if(_){for(let te=0,H=_.length;te<H;te++){const z=_[te];if(!!z){if(z.type===0){V=!0;continue}if(z.type===1)return h.INSTANCE;if(z.type===9){$=$.concat(z.expr);continue}$.push(z)}}if($.length===0&&V)return I.INSTANCE;$.sort(D)}if($.length!==0){if($.length===1)return $[0];for(let te=1;te<$.length;te++)$[te-1].equals($[te])&&($.splice(te,1),te--);if($.length===1)return $[0];if(O){for(let te=0;te<$.length;te++)for(let H=te+1;H<$.length;H++)M($[te],$[H])&&($.splice(H,1),H--);if($.length===1)return $[0]}return new s($,U)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let U of this.expr)_.push(...U.keys());return _}map(_){return new s(this.expr.map(U=>U.map(_)),null)}negate(){if(!this.negated){let _=[];for(let U of this.expr)_.push(U.negate());for(;_.length>1;){const U=_.shift(),O=_.shift(),$=[];for(const te of T(U))for(const H of T(O))$.push(o.create([te,H],null));const V=_.length===0;_.unshift(s.create($,null,V))}this.negated=_[0]}return this.negated}}class u extends y{static all(){return u._info.values()}constructor(_,U,O){super(_,null);this._defaultValue=U,typeof O=="object"?u._info.push({...O,key:_}):O!==!0&&u._info.push({key:_,description:O,type:U!=null?typeof U:void 0})}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return v.create(this.key,_)}notEqualsTo(_){return g.create(this.key,_)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(F,_){return F<_?-1:F>_?1:0}function C(F,_,U,O){return F<U?-1:F>U?1:_<O?-1:_>O?1:0}function M(F,_){if(_.type===6&&F.type!==9&&F.type!==6){for(const $ of _.expr)if(F.equals($))return!0}const U=F.negate(),O=T(U).concat(T(_));O.sort(D);for(let $=0;$<O.length;$++){const te=O[$].negate();for(let H=$+1;H<O.length;H++){const z=O[H];if(te.equals(z))return!0}}return!1}e.implies=M;function T(F){return F.type===9?F.expr:[F]}}),define(re[90],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function i(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=i;class k{async getPerformanceInfo(A,P){return{}}async getSystemInfo(A,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,P){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=k}),define(re[91],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(re[14],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(re[29],se([0,1,142,5]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function L(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function A(g,S){switch(g){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function P(g,S){return S==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function b(g,S,w){return P(S,w)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===w?!0:E(w).includes(g)}e.isTargetPlatformCompatible=b;function E(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function D(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=D;var I;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var h;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(h||(e.SortOrder=h={}));var y;(function(g){g.Install="install",g.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var v;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var p;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));class d extends Error{constructor(S,w){super(S);this.code=w,this.name=w}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,i.createDecorator)("IExtensionManagementCLIService")}),define(re[175],se([0,1,3,2,28,8,119,29]),function(J,e,R,i,k,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(p,d){return L.URI.revive(d?d.transformIncoming(p):p)}function E(p,d){return d?d.transformOutgoingURI(p):p}function D(p,d){d=d||A.DefaultURITransformer;const g=p.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...p,manifest:void 0},d),manifest:g}}function I(p,d){return d?(0,k.cloneAndChange)(p,g=>g instanceof L.URI?d.transformOutgoingURI(g):void 0):p}class h{constructor(d,g){this.service=d,this.getUriTransformer=g,this.onInstallExtension=R.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,g){const S=this.getUriTransformer(d);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,w=>w.map(f=>({...f,local:f.local?I(f.local,S):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,g,S){const w=this.getUriTransformer(d);switch(g){case"zip":return this.service.zip(D(S[0],w)).then(f=>E(f,w));case"unzip":return this.service.unzip(b(S[0],w));case"install":return this.service.install(b(S[0],w),S[1]);case"getManifest":return this.service.getManifest(b(S[0],w));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(S[0]);case"installFromGallery":return this.service.installFromGallery(S[0],S[1]);case"uninstall":return this.service.uninstall(D(S[0],w),S[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(D(S[0],w));case"getInstalled":return this.service.getInstalled(S[0]).then(f=>f.map(l=>I(l,w)));case"updateMetadata":return this.service.updateMetadata(D(S[0],w),S[1]).then(f=>I(f,w));case"updateExtensionScope":return this.service.updateExtensionScope(D(S[0],w),S[1]).then(f=>I(f,w));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=h;class y extends i.Disposable{constructor(d){super();this.channel=d,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?L.URI.revive(g.source):g.source}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(S=>({...S,local:S.local?D(S.local,null):S.local,source:this.isUriComponents(S.source)?L.URI.revive(S.source):S.source}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire(g))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire(g)))}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const g=await this.getTargetPlatform();return d.allTargetPlatforms.some(S=>(0,P.isTargetPlatformCompatible)(S,d.allTargetPlatforms,g))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(g=>L.URI.revive(g)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,g){return Promise.resolve(this.channel.call("install",[d,g])).then(S=>D(S,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,g){return Promise.resolve(this.channel.call("installFromGallery",[d,g])).then(S=>D(S,null))}uninstall(d,g){return Promise.resolve(this.channel.call("uninstall",[d,g]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null){return Promise.resolve(this.channel.call("getInstalled",[d])).then(g=>g.map(S=>D(S,null)))}updateMetadata(d,g){return Promise.resolve(this.channel.call("updateMetadata",[d,g])).then(S=>D(S,null))}updateExtensionScope(d,g){return Promise.resolve(this.channel.call("updateExtensionScope",[d,g])).then(S=>D(S,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=y;class v{constructor(d){this.service=d}listen(d,g){throw new Error("Invalid listen")}call(d,g,S){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(S[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=v}),define(re[92],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(i||(e.RecommendationSource=i={}));function k(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var L;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[93],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionsGalleryConfigService=void 0,e.IExtensionsGalleryConfigService=(0,R.createDecorator)("extensionsGalleryConfigService")}),define(re[15],se([0,1,7,39,12,26,13,8,150,5]),function(J,e,R,i,k,L,A,P,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function D(H){return H.create===!0}e.isFileOpenForWriteOptions=D;var I;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(I||(e.FileType=I={}));var h;(function(H){H[H.Readonly=1]="Readonly"})(h||(e.FilePermission=h={}));var y;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function v(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=v;function p(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=p;function d(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=d;function g(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function S(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=S;function w(H){return v(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var f;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(f||(e.FileSystemProviderErrorCode=f={}));class l extends Error{constructor(z,q){super(z);this.code=q}}e.FileSystemProviderError=l;function t(H,z){const q=new l(H.toString(),z);return n(q,z),q}e.createFileSystemProviderError=t;function r(H){return H||t((0,b.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=r;function n(H,z){return H.name=z?`${z} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=n;function a(H){if(!H)return f.Unknown;if(H instanceof l)return H.code;const z=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!z)return f.Unknown;switch(z[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=a;function c(H){if(H instanceof M)return H.fileOperationResult;switch(a(H)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var o;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(o||(e.FileOperation=o={}));class s{constructor(z,q,j){this.resource=z,this.operation=q,this.target=j}isOperation(z){return this.operation===z}}e.FileOperationEvent=s;var u;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(u||(e.FileChangeType=u={}));class m{constructor(z,q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=z;const j=new Map;for(const Q of z){const G=j.get(Q.type);switch(G?G.push([Q.resource,Q]):j.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,G]of j)switch(Q){case 1:this.added=i.TernarySearchTree.forUris(()=>q),this.added.fill(G);break;case 0:this.updated=i.TernarySearchTree.forUris(()=>q),this.updated.fill(G);break;case 2:this.deleted=i.TernarySearchTree.forUris(()=>q),this.deleted.fill(G);break}}contains(z,...q){return this.doContains(z,{includeChildren:!1},...q)}affects(z,...q){return this.doContains(z,{includeChildren:!0},...q)}doContains(z,q,...j){if(!z)return!1;const Q=j.length>0;return!!((!Q||j.includes(1))&&(this.added?.get(z)||q.includeChildren&&this.added?.findSuperstr(z))||(!Q||j.includes(0))&&(this.updated?.get(z)||q.includeChildren&&this.updated?.findSuperstr(z))||(!Q||j.includes(2))&&(this.deleted?.findSubstr(z)||q.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=m;function C(H,z,q){return!H||!z||H===z||z.length>H.length?!1:(z.charAt(z.length-1)!==k.sep&&(z+=k.sep),q?(0,L.startsWithIgnoreCase)(H,z):H.indexOf(z)===0)}e.isParent=C;class M extends R.ErrorNoTelemetry{constructor(z,q,j){super(z);this.fileOperationResult=q,this.options=j}}e.FileOperationError=M;class T extends M{constructor(z,q,j){super(z,2,j);this.stat=q}}e.NotModifiedSinceFileOperationError=T;var F;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F||(e.FileOperationResult=F={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(_||(e.FileKind=_={})),e.ETAG_DISABLED="";function U(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=U;async function O(H,z){if(!z.hasProvider(P.URI.from({scheme:H.scheme})))return new Promise(q=>{const j=z.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===H.scheme&&Q.added&&(j.dispose(),q())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(z){return(0,A.isNumber)(z)||(z=0),z<$.KB?(0,b.localize)(1,null,z.toFixed(0)):z<$.MB?(0,b.localize)(2,null,(z/$.KB).toFixed(2)):z<$.GB?(0,b.localize)(3,null,(z/$.MB).toFixed(2)):z<$.TB?(0,b.localize)(4,null,(z/$.GB).toFixed(2)):(0,b.localize)(5,null,(z/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var V;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(V||(e.Arch=V={}));function te(H){return{maxFileSize:H===0?300*$.MB:16*$.GB,maxHeapSize:H===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=te});var K=this&&this.__param||function(J,e){return function(R,i){e(R,i,J)}};define(re[176],se([0,1,94,40,15]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(P){this.fileService=P}async checksum(P){const b=(await this.fileService.readFileStream(P)).value;return new Promise((E,D)=>{const I=(0,R.createHash)("md5");(0,i.listenStream)(b,{onData:h=>I.update(h.buffer),onError:h=>D(h),onEnd:()=>E(I.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=L,e.ChecksumService=L=fe([K(0,k.IFileService)],L)}),define(re[177],se([0,1,18,36,7,3,2,40,8,30,15]),function(J,e,R,i,k,L,A,P,b,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends A.Disposable{constructor(y,v){super();this.channel=y,this.extraCapabilities=v,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,v){const{buffer:p}=await this.channel.call("readFile",[y,v]);return p}readFileStream(y,v,p){const d=(0,P.newWriteableStream)(S=>R.VSBuffer.concat(S.map(w=>R.VSBuffer.wrap(w))).buffer),g=this.channel.listen("readFileStream",[y,v])(S=>{if(S instanceof R.VSBuffer)d.write(S.buffer);else{if(S==="end")d.end();else{let w=S;w instanceof Error||(w=(0,D.createFileSystemProviderError)((0,i.toErrorMessage)(w),D.FileSystemProviderErrorCode.Unknown)),d.error(w),d.end()}g.dispose()}});return p.onCancellationRequested(()=>{d.error((0,k.canceled)()),d.end(),g.dispose()}),d}writeFile(y,v,p){return this.channel.call("writeFile",[y,R.VSBuffer.wrap(v),p])}open(y,v){return this.channel.call("open",[y,v])}close(y){return this.channel.call("close",[y])}async read(y,v,p,d,g){const[S,w]=await this.channel.call("read",[y,v,g]);return p.set(S.buffer.slice(0,w),d),w}write(y,v,p,d,g){return this.channel.call("write",[y,v,R.VSBuffer.wrap(p),d,g])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,v){return this.channel.call("delete",[y,v])}rename(y,v,p){return this.channel.call("rename",[y,v,p])}copy(y,v,p){return this.channel.call("copy",[y,v,p])}cloneFile(y,v){return this.channel.call("cloneFile",[y,v])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const v=y;this._onDidChange.fire(v.map(p=>({resource:b.URI.revive(p.resource),type:p.type})))}else{const v=y;this._onDidWatchError.fire(v)}}))}watch(y,v){const p=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,p,y,v]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,p]))}}e.DiskFileSystemProviderClient=I}),define(re[95],se([0,1,18,7,151,15]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(D,I,h,y,v,p){let d;try{await P(D,I,h,y,v,p)}catch(g){d=g}finally{d&&v.errorTransformer&&(d=v.errorTransformer(d)),typeof d!="undefined"&&h.error(d),h.end()}}e.readFileIntoStream=A;async function P(D,I,h,y,v,p){b(p);const d=await D.open(I,{create:!1});try{b(p);let g=0,S=0,w=v&&typeof v.length=="number"?v.length:void 0,f=R.VSBuffer.alloc(Math.min(v.bufferSize,typeof w=="number"?w:v.bufferSize)),l=v&&typeof v.position=="number"?v.position:0,t=0;do S=await D.read(d,l,f.buffer,t,f.byteLength-t),l+=S,t+=S,g+=S,typeof w=="number"&&(w-=S),t===f.byteLength&&(await h.write(y(f)),f=R.VSBuffer.alloc(Math.min(v.bufferSize,typeof w=="number"?w:v.bufferSize)),t=0);while(S>0&&(typeof w!="number"||w>0)&&b(p)&&E(g,v));if(t>0){let r=t;typeof w=="number"&&(r=Math.min(t,w)),h.write(y(f.slice(0,r)))}}catch(g){throw(0,L.ensureFileSystemProviderError)(g)}finally{await D.close(d)}}function b(D){if(D.isCancellationRequested)throw(0,i.canceled)();return!0}function E(D,I){if(I?.limits){if(typeof I.limits.memory=="number"&&D>I.limits.memory)throw(0,L.createFileSystemProviderError)((0,k.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&D>I.limits.size)throw(0,L.createFileSystemProviderError)((0,k.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[55],se([0,1,82,2,12,4,8,15]),function(J,e,R,i,k,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function b(d){return d.recursive===!0}e.isRecursiveWatchRequest=b;class E extends i.Disposable{constructor(g,S,w,f){super();this.onFileChanges=g,this.onLogMessage=S,this.verboseLogging=w,this.options=f,this.watcherDisposables=this._register(new i.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new i.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(S=>this.onFileChanges(S))),g.add(this.watcher.onDidLogMessage(S=>this.onLogMessage(S))),g.add(this.watcher.onDidError(S=>this.onError(S)))}onError(g){this.options.restartOnError?this.restartCounter<E.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=E,E.MAX_RESTARTS=5;class D extends E{constructor(g,S,w){super(g,S,w,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=D;class I extends E{constructor(g,S,w){super(g,S,w,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function h(d){return d.map(g=>({type:g.type,resource:A.URI.file(g.path)}))}e.toFileChanges=h;function y(d){const g=new p;for(const S of d)g.processEvent(S);return g.coalesce()}e.coalesceEvents=y;function v(d,g){const S=[];for(const w of g){let f=w;typeof f=="string"&&!f.startsWith(R.GLOBSTAR)&&!(0,k.isAbsolute)(f)&&(f={base:d,pattern:f}),S.push((0,R.parse)(f))}return S}e.parseWatcherPatterns=v;class p{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return L.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const S=this.mapPathToChange.get(this.toKey(g));let w=!1;if(S){const f=S.type,l=g.type;S.path!==g.path&&(g.type===2||g.type===1)?w=!0:f===1&&l===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(S)):f===2&&l===1?S.type=0:f===1&&l===0||(S.type=l)}else w=!0;w&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],S=[];return Array.from(this.coalesced).filter(w=>w.type!==2?(g.push(w),!1):!0).sort((w,f)=>w.path.length-f.path.length).filter(w=>S.some(f=>(0,P.isParent)(w.path,f,!L.isLinux))?!1:(S.push(w.path),!0)).concat(g)}}}),define(re[178],se([0,1,52,6,23,41,2,80,12,4,123,27,55]),function(J,e,R,i,k,L,A,P,b,E,D,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends A.Disposable{constructor(d,g,S,w){super();this.request=d,this.onDidFilesChange=g,this.onLogMessage=S,this.verboseLogging=w,this.throttledFileChangesWorker=new i.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new i.ThrottledDelayer(y.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,h.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,h.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const d=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const g=await I.Promises.stat(d);this._register(await this.doWatch(d,g.isDirectory()))}catch(d){d.code!=="ENOENT"?this.error(d):this.trace(d)}}async normalizePath(d){let g=d.path;try{g=await I.Promises.realpath(d.path),d.path===g&&(g=await(0,D.realcase)(d.path)??d.path),d.path!==g&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${g})`)}catch{}return g}async doWatch(d,g){if(E.isMacintosh&&(0,L.isEqualOrParent)(d,"/Volumes/",!0))return this.error(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const S=new k.CancellationTokenSource(this.cts.token);let w=new A.DisposableStore;try{const f=(0,b.basename)(d),l=(0,R.watch)(d);w.add((0,A.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${d}'`);const t=new Set;if(g)try{for(const n of await I.Promises.readdir(d))t.add(n)}catch(n){this.error(n)}const r=new Map;w.add((0,A.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),l.on("error",(n,a)=>{this.error(`Failed to watch ${d} for changes using fs.watch() (${n}, ${a})`),this.dispose()}),l.on("change",(n,a)=>{if(S.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${a}`);let c="";if(a&&(c=a.toString(),E.isMacintosh&&(c=(0,P.normalizeNFC)(c))),!(!c||n!=="change"&&n!=="rename"))if(g)if(n==="rename"){r.get(c)?.dispose();const o=setTimeout(async()=>{if(r.delete(c),c===f&&!await I.Promises.exists(d)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.existsChildStrictCase((0,b.join)(d,c));if(S.token.isCancellationRequested)return;let u;s?t.has(c)?u=0:(u=1,t.add(c)):(t.delete(c),u=2),this.onFileChange({path:(0,b.join)(this.request.path,c),type:u})},y.FILE_DELETE_HANDLER_DELAY);r.set(c,(0,A.toDisposable)(()=>clearTimeout(o)))}else{let o;t.has(c)?o=0:(o=1,t.add(c)),this.onFileChange({path:(0,b.join)(this.request.path,c),type:o})}else if(n==="rename"||c!==f){const o=setTimeout(async()=>{const s=await I.Promises.exists(d);S.token.isCancellationRequested||(s?(this.onFileChange({path:this.request.path,type:0},!0),w.add(await this.doWatch(d,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);w.clear(),w.add((0,A.toDisposable)(()=>clearTimeout(o)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await I.Promises.exists(d)&&!S.token.isCancellationRequested&&this.error(`Failed to watch ${d} for changes using fs.watch() (${f.toString()})`)}return(0,A.toDisposable)(()=>{S.dispose(!0),w.dispose()})}async onFileChange(d,g=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),!g&&this.excludes.some(S=>S(d.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${d.path}`):!g&&this.includes&&this.includes.length>0&&!this.includes.some(S=>S(d.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${d.path}`):this.fileChangesBuffer.push(d);try{await this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,h.coalesceEvents)(S);if(w.length>0){if(this.verboseLogging)for(const l of w)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(w)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${w.length}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(d){if(E.isLinux)return I.Promises.exists(d);try{const g=(0,b.basename)(d);return(await I.Promises.readdir((0,b.dirname)(d))).some(w=>w===g)}catch(g){return this.trace(g),!1}}setVerboseLogging(d){this.verboseLogging=d}error(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}warn(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}trace(d){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.FILE_DELETE_HANDLER_DELAY=100,y.FILE_CHANGES_HANDLER_DELAY=50;async function v(p,d,g,S,w=512){const f=await I.Promises.open(p,"r"),l=Buffer.allocUnsafe(w),t=new k.CancellationTokenSource(S);let r,n=!1;const a={path:p,excludes:[],recursive:!1},c=new y(a,o=>{(async()=>{for(const{type:s}of o)if(s===0){if(n)return;n=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:u}=await I.Promises.read(f,l,0,w,null);if(!u||t.token.isCancellationRequested)break;d(l.slice(0,u))}}catch(u){r=new Error(u),t.dispose(!0)}finally{n=!1}}})()});return await c.ready,g(),new Promise((o,s)=>{t.token.onCancellationRequested(async()=>{c.dispose();try{await I.Promises.close(f)}catch(u){r=new Error(u)}r?s(r):o()})})}e.watchFileContents=v}),define(re[179],se([0,1,3,82,2,4,178]),function(J,e,R,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends k.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const D=this.normalizeRequests(E),I=D.filter(y=>{const v=this.watchers.get(y.path);return v?!(0,i.patternsEquals)(v.request.excludes,y.excludes)||!(0,i.patternsEquals)(v.request.includes,y.includes):!0}),h=Array.from(this.watchers.values()).filter(({request:y})=>!D.find(v=>v.path===y.path&&(0,i.patternsEquals)(v.excludes,y.excludes)&&(0,i.patternsEquals)(v.includes,y.includes))).map(({request:y})=>y.path);I.length&&this.trace(`Request to start watching: ${I.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?y.includes:"<all>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const y of h)this.stopWatching(y);for(const y of I)this.startWatching(y)}startWatching(E){const D=new A.NodeJSFileWatcherLibrary(E,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),I={request:E,instance:D};this.watchers.set(E.path,I)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const D=this.watchers.get(E);D&&(this.watchers.delete(E),D.instance.dispose())}normalizeRequests(E){const D=new Map;for(const I of E){const h=L.isLinux?I.path:I.path.toLowerCase();D.set(h,I)}return Array.from(D.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,D]of this.watchers)D.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,D){return D?`[File Watcher (node.js)] ${E} (path: ${D.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=P}),define(re[180],se([0,1,55,179]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends R.AbstractNonRecursiveWatcherClient{constructor(A,P,b){super(A,P,b);this.init()}createWatcher(){return new i.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(re[181],se([0,1,19,37,62,55]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends L.AbstractUniversalWatcherClient{constructor(b,E,D){super(b,E,D);this.init()}createWatcher(b){const E=b.add(new k.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(E.onDidProcessExit(({code:D,signal:I})=>this.onError(`terminated by itself with code ${D}, signal: ${I}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(re[96],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...k){this._entries=new Map;for(let[L,A]of k)this.set(L,A)}set(k,L){const A=this._entries.get(k);return this._entries.set(k,L),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=R}),define(re[182],se([0,1,6,7,54,172,5,96]),function(J,e,R,i,k,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class E extends Error{constructor(v){super("cyclic dependency between services");this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class D{constructor(v=new P.ServiceCollection,p=!1,d){this._activeInstantiations=new Set,this._services=v,this._strict=p,this._parent=d,this._services.set(A.IInstantiationService,this)}createChild(v){return new D(v,this._strict,this)}invokeFunction(v,...p){let d=h.traceInvocation(v),g=!1;try{return v({get:w=>{if(g)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(w,d);if(!f)throw new Error(`[invokeFunction] unknown service '${w}'`);return f}},...p)}finally{g=!0,d.stop()}}createInstance(v,...p){let d,g;return v instanceof k.SyncDescriptor?(d=h.traceCreation(v.ctor),g=this._createInstance(v.ctor,v.staticArguments.concat(p),d)):(d=h.traceCreation(v),g=this._createInstance(v,p,d)),d.stop(),g}_createInstance(v,p=[],d){let g=A._util.getServiceDependencies(v).sort((f,l)=>f.index-l.index),S=[];for(const f of g){let l=this._getOrCreateServiceInstance(f.id,d);l||this._throwIfStrict(`[createInstance] ${v.name} depends on UNKNOWN service ${f.id}.`,!1),S.push(l)}let w=g.length>0?g[0].index:p.length;if(p.length!==w){console.trace(`[createInstance] First service dependency of ${v.name} at position ${w+1} conflicts with ${p.length} static arguments`);let f=w-p.length;f>0?p=p.concat(new Array(f)):p=p.slice(0,w)}return new v(...[...p,...S])}_setServiceInstance(v,p){if(this._services.get(v)instanceof k.SyncDescriptor)this._services.set(v,p);else if(this._parent)this._parent._setServiceInstance(v,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){let p=this._services.get(v);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):p}_getOrCreateServiceInstance(v,p){let d=this._getServiceInstanceOrDescriptor(v);return d instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,d,p.branch(v,!0)):(p.branch(v,!1),d)}_safeCreateAndCacheServiceInstance(v,p,d){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,p,d)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,p,d){const g=new L.Graph(f=>f.id.toString());let S=0;const w=[{id:v,desc:p,_trace:d}];for(;w.length;){const f=w.pop();if(g.lookupOrInsertNode(f),S++>1e3)throw new E(g);for(let l of A._util.getServiceDependencies(f.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(l.id);if(t||this._throwIfStrict(`[createInstance] ${v} depends on ${l.id} which is NOT registered.`,!0),t instanceof k.SyncDescriptor){const r={id:l.id,desc:t,_trace:f._trace.branch(l.id,!0)};g.insertEdge(f,r),w.push(r)}}}for(;;){const f=g.roots();if(f.length===0){if(!g.isEmpty())throw new E(g);break}for(const{data:l}of f){if(this._getServiceInstanceOrDescriptor(l.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,r)}g.removeNode(l)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,p,d=[],g,S){if(this._services.get(v)instanceof k.SyncDescriptor)return this._createServiceInstance(p,d,g,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,p,d,g,S);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(v,p=[],d,g){if(d){const S=new R.IdleValue(()=>this._createInstance(v,p,g));return new Proxy(Object.create(null),{get(w,f){if(f in w)return w[f];let l=S.value,t=l[f];return typeof t!="function"||(t=t.bind(l),w[f]=t),t},set(w,f,l){return S.value[f]=l,!0}})}else return this._createInstance(v,p,g)}_throwIfStrict(v,p){if(p&&console.warn(p),this._strict)throw new Error(v)}}e.InstantiationService=D;var I;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(I||(I={}));class h{static traceInvocation(v){return b?new h(2,v.name||v.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(v){return b?new h(1,v.name):h._None}constructor(v,p){this.type=v,this.name=p,this._start=Date.now(),this._dep=[]}branch(v,p){let d=new h(3,v.toString());return this._dep.push([v,p,d]),d}stop(){let v=Date.now()-this._start;h._totals+=v;let p=!1;function d(S,w){let f=[],l=new Array(S+1).join("	");for(const[t,r,n]of w._dep)if(r&&n){p=!0,f.push(`${l}CREATES -> ${t}`);let a=d(S+1,n);a&&f.push(a)}else f.push(`${l}uses -> ${t}`);return f.join(`
`)}let g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(v>2||p)&&console.log(g.join(`
`))}}e.Trace=h,h._None=new class extends h{constructor(){super(0,null)}stop(){}branch(){return this}},h._totals=0}),define(re[183],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(k,L){this.server=k,this.router=L}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,L){this.server.registerChannel(k,L)}}e.MessagePortMainProcessService=R}),define(re[184],se([0,1,37,54,64,5]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(y,v,p){const d=p.getChannel(y);return P(v)?new v.channelClientCtor(d):R.ProxyChannel.toService(d,v?.proxyOptions)}}function P(h){return!!h?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let b=class extends A{constructor(y,v,p){super(y,v,p)}};b=fe([K(2,e.IMainProcessService)],b);function E(h,y,v){(0,k.registerSingleton)(h,new i.SyncDescriptor(b,[y,v],v?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let D=class extends A{constructor(y,v,p){super(y,v,p)}};D=fe([K(2,e.ISharedProcessService)],D);function I(h,y,v){(0,k.registerSingleton)(h,new i.SyncDescriptor(D,[y,v],v?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=I}),define(re[65],se([0,1,23,2,4,153,29,5]),function(J,e,R,i,k,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let b=class extends i.Disposable{constructor(D){super();this.extensionGalleryService=D}async getAvailableLanguages(){const D=new R.CancellationTokenSource;setTimeout(()=>D.cancel(),1e3);let I;try{I=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},D.token)}catch{return[]}const y=I.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some(p=>p.startsWith("lp-"))).map(v=>{const p=v.properties.localizedLanguages?.[0],d=v.tags.find(S=>S.startsWith("lp-")).split("lp-")[1];return{...this.createQuickPickItem({locale:d,label:p}),extensionId:v.identifier.id,galleryExtension:v}});return y.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),y}createQuickPickItem(D){const I=D.label??D.locale;let h=D.locale!==D.label?D.locale:void 0;return D.locale.toLowerCase()===k.language.toLowerCase()&&(h||(h=""),h+=(0,L.localize)(0,null)),{id:D.locale,label:I,description:h}}};e.LanguagePackBaseService=b,e.LanguagePackBaseService=b=fe([K(0,A.IExtensionGalleryService)],b)}),define(re[185],se([0,1,2,65]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends R.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=k,e.LocalizationsUpdater=k=fe([K(0,i.ILanguagePackService)],k)}),define(re[9],se([0,1,36,3,2,4,5]),function(J,e,R,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function P(){return new Date().toISOString()}var b;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(b||(e.LogLevel=b={})),e.DEFAULT_LOG_LEVEL=b.Info;function E(r,n,a){switch(n){case b.Trace:r.trace(a);break;case b.Debug:r.debug(a);break;case b.Info:r.info(a);break;case b.Warning:r.warn(a);break;case b.Error:r.error(a);break;case b.Critical:r.critical(a);break;default:throw new Error("Invalid log level")}}e.log=E;function D(r){let n="";for(let a=0;a<r.length;a++){let c=r[a];if(typeof c=="object")try{c=JSON.stringify(c)}catch{}n+=(a>0?" ":"")+c}return n}e.format=D;class I extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class h extends I{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...a){this.checkLogLevel(b.Trace)&&this.log(b.Trace,D([n,...a]))}debug(n,...a){this.checkLogLevel(b.Debug)&&this.log(b.Debug,D([n,...a]))}info(n,...a){this.checkLogLevel(b.Info)&&this.log(b.Info,D([n,...a]))}warn(n,...a){this.checkLogLevel(b.Warning)&&this.log(b.Warning,D([n,...a]))}error(n,...a){if(this.checkLogLevel(b.Error))if(n instanceof Error){const c=Array.prototype.slice.call(arguments);c[0]=n.stack,this.log(b.Error,D(c))}else this.log(b.Error,D([n,...a]))}critical(n,...a){this.checkLogLevel(b.Critical)&&this.log(b.Critical,D([n,...a]))}flush(){}}e.AbstractMessageLogger=h;class y extends I{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!L.isWindows}trace(n,...a){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...a):console.log(`[main ${P()}]`,n,...a))}debug(n,...a){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...a):console.log(`[main ${P()}]`,n,...a))}info(n,...a){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...a):console.log(`[main ${P()}]`,n,...a))}warn(n,...a){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,n,...a):console.warn(`[main ${P()}]`,n,...a))}error(n,...a){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,n,...a):console.error(`[main ${P()}]`,n,...a))}critical(n,...a){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,n,...a):console.error(`[main ${P()}]`,n,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class v extends I{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...a){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",n,...a)}debug(n,...a){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...a)}info(n,...a){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",n,...a)}warn(n,...a){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",n,...a)}error(n,...a){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",n,...a)}critical(n,...a){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...a)}dispose(){}flush(){}}e.ConsoleLogger=v;class p extends I{constructor(n,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(a)}trace(n,...a){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(n),...a])}debug(n,...a){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(n),...a])}info(n,...a){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(n),...a])}warn(n,...a){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(n),...a])}error(n,...a){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(n),...a])}critical(n,...a){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(n),...a])}extractMessage(n){return typeof n=="string"?n:(0,R.toErrorMessage)(n,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class d extends I{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const a of this.logServices)a.setLevel(n);super.setLevel(n)}trace(n,...a){for(const c of this.logServices)c.trace(n,...a)}debug(n,...a){for(const c of this.logServices)c.debug(n,...a)}info(n,...a){for(const c of this.logServices)c.info(n,...a)}warn(n,...a){for(const c of this.logServices)c.warn(n,...a)}error(n,...a){for(const c of this.logServices)c.error(n,...a)}critical(n,...a){for(const c of this.logServices)c.critical(n,...a)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=d;class g extends k.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...a){this.logger.trace(n,...a)}debug(n,...a){this.logger.debug(n,...a)}info(n,...a){this.logger.info(n,...a)}warn(n,...a){this.logger.warn(n,...a)}error(n,...a){this.logger.error(n,...a)}critical(n,...a){this.logger.critical(n,...a)}flush(){this.logger.flush()}}e.LogService=g;class S extends k.Disposable{constructor(n,a){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(c=>{this.logLevel=c,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(c))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,a){let c=this.loggers.get(n.toString());return c||(c=this.doCreateLogger(n,a?.always?b.Trace:this.logLevel,a),this.loggers.set(n.toString(),c),a?.always||this.logLevelChangeableLoggers.push(c)),c}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class w{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(n){}getLevel(){return b.Info}trace(n,...a){}debug(n,...a){}info(n,...a){}warn(n,...a){}error(n,...a){}critical(n,...a){}dispose(){}flush(){}}e.NullLogService=w;function f(r){if(r.verbose)return b.Trace;if(typeof r.logLevel=="string"){const n=l(r.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function l(r){switch(r){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=l;function t(r){switch(r){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=t}),define(re[186],se([0,1,6,7,2,12,27,14,9]),function(J,e,R,i,k,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends k.Disposable{constructor(I,h){super();this.environmentService=I,this.logService=h,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const I=(0,L.basename)(this.environmentService.logsPath),h=(0,L.dirname)(this.environmentService.logsPath),p=(await A.Promises.readdir(h)).filter(g=>/^\d{8}T\d{6}$/.test(g)).sort().filter(g=>g!==I),d=p.slice(0,Math.max(0,p.length-9));d.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(g=>A.Promises.rm((0,L.join)(h,g)))))}catch(I){(0,i.onUnexpectedError)(I)}}};e.LogsDataCleaner=E,e.LogsDataCleaner=E=fe([K(0,P.IEnvironmentService),K(1,b.ILogService)],E)}),define(re[187],se([0,1,6,7,2,12,27,14,9]),function(J,e,R,i,k,L,A,P,b){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let D=E=class extends k.Disposable{constructor(h,y,v){super();this.backupWorkspacesPath=h,this.environmentService=y,this.logService=v,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const h=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),v=JSON.parse(h).emptyWorkspaceInfos.map(d=>d.backupFolder),p=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(p.map(async d=>{d.length===E.NON_EMPTY_WORKSPACE_ID_LENGTH||d===E.EXTENSION_DEV_EMPTY_WINDOW_ID||v.indexOf(d)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${d}.`),await A.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,d)))}))}catch(h){(0,i.onUnexpectedError)(h)}}};e.StorageDataCleaner=D,D.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,D.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",e.StorageDataCleaner=D=E=fe([K(1,P.INativeEnvironmentService),K(2,b.ILogService)],D)}),define(re[188],se([0,1,46,6,36,3,2,19,12,27,14,9]),function(J,e,R,i,k,L,A,P,b,E,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let h=class extends A.Disposable{constructor(v,p){super();this.environmentService=v,this.logService=p,this.processesLimiter=new i.Limiter(5)}async postUninstall(v){const p=this.parseScript(v,"uninstall");return p&&(this.logService.info(v.identifier.id,v.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(p.script,"uninstall",p.args,!0,v).then(()=>this.logService.info(v.identifier.id,v.manifest.version,"Finished running post uninstall script"),d=>this.logService.error(v.identifier.id,v.manifest.version,`Failed to run post uninstall script: ${d}`)))),E.Promises.rm(this.getExtensionStoragePath(v)).then(void 0,d=>this.logService.error("Error while removing extension storage path",d))}parseScript(v,p){const d=`vscode:${p}`;if(v.location.scheme===P.Schemas.file&&v.manifest&&v.manifest.scripts&&typeof v.manifest.scripts[d]=="string"){const g=v.manifest.scripts[d].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(v.identifier.id,v.manifest.version,`${d} should be a node script`),null):{script:(0,b.join)(v.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(v,p,d,g,S){return new Promise((w,f)=>{const l=this.start(v,p,d,S);let t;const r=n=>{t&&(clearTimeout(t),t=null),n?f(n):w(void 0)};l.on("error",n=>{r((0,k.toErrorMessage)(n)||"Unknown")}),l.on("exit",(n,a)=>{r(n?`post-${p} process exited with code ${n}`:void 0)}),g&&(t=setTimeout(()=>{t=null,l.kill(),f("timed out")},5e3))})}start(v,p,d,g){const S={silent:!0,execArgv:void 0},w=(0,R.fork)(v,[`--type=extension-post-${p}`,...d],S);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const f=L.Event.fromNodeEventEmitter(w.stdout,"data"),l=L.Event.fromNodeEventEmitter(w.stderr,"data");f(n=>this.logService.info(g.identifier.id,g.manifest.version,`post-${p}`,n)),l(n=>this.logService.error(g.identifier.id,g.manifest.version,`post-${p}`,n));const t=L.Event.any(L.Event.map(f,n=>({data:`%c${n}`,format:[""]})),L.Event.map(l,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(t,(n,a)=>n?{data:n.data+a.data,format:[...n.format,...a.format]}:{data:a.data,format:a.format},100)(n=>{console.group(g.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),w}getExtensionStoragePath(v){return(0,b.join)(this.environmentService.globalStorageHome.fsPath,v.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=h,e.ExtensionsLifecycle=h=fe([K(0,D.IEnvironmentService),K(1,I.ILogService)],h)}),define(re[189],se([0,1,16,6,7,3,2,12,55,9]),function(J,e,R,i,k,L,A,P,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class D extends A.Disposable{constructor(h,y){super();this.logService=h,this.options=y,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new i.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}watch(h,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,y):this.watchNonRecursive(h,y)}watchUniversal(h,y){const v={path:this.toFilePath(h),excludes:y.excludes,includes:y.includes,recursive:y.recursive},p=(0,R.insert)(this.universalPathsToWatch,v);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{p(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,k.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,b.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const y of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const y of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(y)&&h.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,y){const v={path:this.toFilePath(h),excludes:y.excludes,includes:y.includes,recursive:!1},p=(0,R.insert)(this.nonRecursivePathsToWatch,v);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{p(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,k.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,b.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,P.normalize)(h.fsPath)}}e.AbstractDiskFileSystemProvider=D}),define(re[190],se([0,1,16,6,18,23,3,79,50,2,39,19,191,20,40,149,15,95,9]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends E.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new i.ResourceQueue)}registerProvider(l,t){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${l}`);const r=new E.DisposableStore;return this.provider.set(l,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:t}),r.add(t.onDidChangeFile(n=>this._onDidFilesChange.fire(new d.FileChangesEvent(n,!this.isPathCaseSensitive(t))))),typeof t.onDidWatchError=="function"&&r.add(t.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),r.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:l}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:t}),this.provider.delete(l),(0,E.dispose)(r)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(r){t.push(r)}}),!this.provider.has(l)&&await i.Promises.settled(t)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,t){const r=this.provider.get(l.scheme);return!!(r&&r.capabilities&t)}listCapabilities(){return b.Iterable.map(this.provider,([l,t])=>({scheme:l,capabilities:t.capabilities}))}async withProvider(l){if(!(0,y.isAbsolutePath)(l))throw new d.FileOperationError((0,p.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const t=this.provider.get(l.scheme);if(!t){const r=new Error;throw r.name="ENOPRO",r.message=(0,p.localize)(1,null,l.toString()),r}return t}async withReadProvider(l){const t=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(t)||(0,d.hasReadWriteCapability)(t)||(0,d.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const t=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(t)||(0,d.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,t){try{return await this.doResolveFile(l,t)}catch(r){throw(0,d.toFileSystemProviderErrorCode)(r)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,p.localize)(2,null,this.resourceForError(l)),1):(0,d.ensureFileSystemProviderError)(r)}}async doResolveFile(l,t){const r=await this.withProvider(l),n=this.isPathCaseSensitive(r),a=t?.resolveTo,c=t?.resolveSingleChildDescendants,o=t?.resolveMetadata,s=await r.stat(l);let u;return this.toFileStat(r,l,s,void 0,!!o,(m,C)=>(u||(u=D.TernarySearchTree.forUris(()=>!n),u.set(l,!0),a&&u.fill(!0,a)),u.get(m.resource)||u.findSuperstr(m.resource.with({query:null,fragment:null}))?!0:m.isDirectory&&c?C===1:!1))}async toFileStat(l,t,r,n,a,c){const{providerExtUri:o}=this.getExtUri(l),s={resource:t,name:o.basename(t),isFile:(r.type&d.FileType.File)!=0,isDirectory:(r.type&d.FileType.Directory)!=0,isSymbolicLink:(r.type&d.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&d.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,d.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(s.isDirectory&&c(s,n)){try{const u=await l.readdir(t),m=await i.Promises.settled(u.map(async([C,M])=>{try{const T=o.joinPath(t,C),F=a?await l.stat(T):{type:M};return await this.toFileStat(l,T,F,u.length,a,c)}catch(T){return this.logService.trace(T),null}}));s.children=(0,R.coalesce)(m)}catch(u){this.logService.trace(u),s.children=[]}return s}return s}async resolveAll(l){return i.Promises.settled(l.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(l){const t=await this.withProvider(l),r=await t.stat(l);return this.toFileStat(t,l,r,void 0,!0,()=>!1)}async exists(l){const t=await this.withProvider(l);try{return!!await t.stat(l)}catch{return!1}}async canCreateFile(l,t){try{await this.doValidateCreateFile(l,t)}catch(r){return r}return!0}async doValidateCreateFile(l,t){if(!t?.overwrite&&await this.exists(l))throw new d.FileOperationError((0,p.localize)(3,null,this.resourceForError(l)),3,t)}async createFile(l,t=k.VSBuffer.fromString(""),r){await this.doValidateCreateFile(l,r);const n=await this.writeFile(l,t);return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,n)),n}async writeFile(l,t,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:a}=this.getExtUri(n);try{await this.validateWriteFile(n,l,r)||await this.mkdirp(n,a.dirname(l));let o;if((0,d.hasReadWriteCapability)(n)&&!(t instanceof k.VSBuffer))if((0,v.isReadableStream)(t)){const s=await(0,v.peekStream)(t,3);s.ended?o=k.VSBuffer.concat(s.buffer):o=s}else o=(0,v.peekReadable)(t,s=>k.VSBuffer.concat(s),3);else o=t;!(0,d.hasOpenReadWriteCloseCapability)(n)||(0,d.hasReadWriteCapability)(n)&&o instanceof k.VSBuffer?await this.doWriteUnbuffered(n,l,r,o):await this.doWriteBuffered(n,l,r,o instanceof k.VSBuffer?(0,k.bufferToReadable)(o):o),this._onDidRunOperation.fire(new d.FileOperationEvent(l,4))}catch(c){throw new d.FileOperationError((0,p.localize)(4,null,this.resourceForError(l),(0,d.ensureFileSystemProviderError)(c).toString()),(0,d.toFileOperationResult)(c),r)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,t,r){if(!!r?.unlock&&!(l.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(t)));let a;try{a=await l.stat(t)}catch{return}if((a.type&d.FileType.Directory)!=0)throw new d.FileOperationError((0,p.localize)(6,null,this.resourceForError(t)),0,r);if(this.throwIfFileIsReadonly(t,a),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==d.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&r.mtime<a.mtime&&r.etag!==(0,d.etag)({mtime:r.mtime,size:a.size}))throw new d.FileOperationError((0,p.localize)(7,null),3,r);return a}async readFile(l,t,r){const n=await this.withReadProvider(l);return t?.atomic?this.doReadFileAtomic(n,l,t,r):this.doReadFile(n,l,t,r)}async doReadFileAtomic(l,t,r,n){return new Promise((a,c)=>{this.writeQueue.queueFor(t,this.getExtUri(l).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(l,t,r,n);a(o)}catch(o){c(o)}})})}async doReadFile(l,t,r,n){const a=await this.doReadFileStream(l,t,{...r,preferUnbuffered:!0},n);return{...a,value:await(0,k.streamToBuffer)(a.value)}}async readFileStream(l,t,r){const n=await this.withReadProvider(l);return this.doReadFileStream(n,l,t,r)}async doReadFileStream(l,t,r,n){const a=new L.CancellationTokenSource(n),c=this.validateReadFile(t,r).then(s=>s,s=>{throw a.cancel(),s});let o;try{return typeof r?.etag=="string"&&r.etag!==d.ETAG_DISABLED&&await c,r?.atomic&&(0,d.hasFileAtomicReadCapability)(l)||!((0,d.hasOpenReadWriteCloseCapability)(l)||(0,d.hasFileReadStreamCapability)(l))||(0,d.hasReadWriteCapability)(l)&&r?.preferUnbuffered?o=this.readFileUnbuffered(l,t,r):(0,d.hasFileReadStreamCapability)(l)?o=this.readFileStreamed(l,t,a.token,r):o=this.readFileBuffered(l,t,a.token,r),{...await c,value:o}}catch(s){o&&await(0,v.consumeStream)(o);const u=(0,p.localize)(8,null,this.resourceForError(t),(0,d.ensureFileSystemProviderError)(s).toString());throw s instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(u,s.stat,r):new d.FileOperationError(u,(0,d.toFileOperationResult)(s),r)}}readFileStreamed(l,t,r,n=Object.create(null)){const a=l.readFileStream(t,n,r);return(0,v.transform)(a,{data:c=>c instanceof k.VSBuffer?c:k.VSBuffer.wrap(c),error:c=>new d.FileOperationError((0,p.localize)(9,null,this.resourceForError(t),(0,d.ensureFileSystemProviderError)(c).toString()),(0,d.toFileOperationResult)(c),n)},c=>k.VSBuffer.concat(c))}readFileBuffered(l,t,r,n=Object.create(null)){const a=(0,k.newWriteableBufferStream)();return(0,g.readFileIntoStream)(l,t,a,c=>c,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:c=>new d.FileOperationError((0,p.localize)(10,null,this.resourceForError(t),(0,d.ensureFileSystemProviderError)(c).toString()),(0,d.toFileOperationResult)(c),n)},r),a}readFileUnbuffered(l,t,r){const n=(0,v.newWriteableStream)(a=>k.VSBuffer.concat(a));return(async()=>{try{let a;r?.atomic&&(0,d.hasFileAtomicReadCapability)(l)?a=await l.readFile(t,{atomic:!0}):a=await l.readFile(t),typeof r?.position=="number"&&(a=a.slice(r.position)),typeof r?.length=="number"&&(a=a.slice(0,r.length)),this.validateReadFileLimits(t,a.byteLength,r),n.end(k.VSBuffer.wrap(a))}catch(a){n.error(a),n.end()}})(),n}async validateReadFile(l,t){const r=await this.resolve(l,{resolveMetadata:!0});if(r.isDirectory)throw new d.FileOperationError((0,p.localize)(11,null,this.resourceForError(l)),0,t);if(typeof t?.etag=="string"&&t.etag!==d.ETAG_DISABLED&&t.etag===r.etag)throw new d.NotModifiedSinceFileOperationError((0,p.localize)(12,null),r,t);return this.validateReadFileLimits(l,r.size,t),r}validateReadFileLimits(l,t,r){if(r?.limits){let n;if(typeof r.limits.memory=="number"&&t>r.limits.memory&&(n=9),typeof r.limits.size=="number"&&t>r.limits.size&&(n=7),typeof n=="number")throw new d.FileOperationError((0,p.localize)(13,null,this.resourceForError(l)),n)}}async canMove(l,t,r){return this.doCanMoveCopy(l,t,"move",r)}async canCopy(l,t,r){return this.doCanMoveCopy(l,t,"copy",r)}async doCanMoveCopy(l,t,r,n){if(l.toString()!==t.toString())try{const a=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(a,l,c,t,r,n)}catch(a){return a}return!0}async move(l,t,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),c=await this.doMoveCopy(n,l,a,t,"move",!!r),o=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,c==="move"?2:3,o)),o}async copy(l,t,r){const n=await this.withReadProvider(l),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),c=await this.doMoveCopy(n,l,a,t,"copy",!!r),o=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,c==="copy"?3:2,o)),o}async doMoveCopy(l,t,r,n,a,c){if(t.toString()===n.toString())return a;const{exists:o,isSameResourceWithDifferentPathCase:s}=await this.doValidateMoveCopy(l,t,r,n,a,c);if(o&&!s&&c&&await this.del(n,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(n)),a==="copy"){if(l===r&&(0,d.hasFileFolderCopyCapability)(l))await l.copy(t,n,{overwrite:c});else{const u=await this.resolve(t);u.isDirectory?await this.doCopyFolder(l,u,r,n):await this.doCopyFile(l,t,r,n)}return a}else return l===r?(await l.rename(t,n,{overwrite:c}),a):(await this.doMoveCopy(l,t,r,n,"copy",c),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(l,t,r,n){if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(l,t,r,n);if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(l,t,r,n);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(l,t,r,n);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasReadWriteCapability)(r))return this.doPipeUnbuffered(l,t,r,n)}async doCopyFolder(l,t,r,n){await r.mkdir(n),Array.isArray(t.children)&&await i.Promises.settled(t.children.map(async a=>{const c=this.getExtUri(r).providerExtUri.joinPath(n,a.name);return a.isDirectory?this.doCopyFolder(l,await this.resolve(a.resource),r,c):this.doCopyFile(l,a.resource,r,c)}))}async doValidateMoveCopy(l,t,r,n,a,c){let o=!1;if(l===r){const{providerExtUri:u,isPathCaseSensitive:m}=this.getExtUri(l);if(m||(o=u.isEqual(t,n)),o&&a==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(t),this.resourceForError(n)));if(!o&&u.isEqualOrParent(n,t))throw new Error((0,p.localize)(15,null,this.resourceForError(t),this.resourceForError(n)))}const s=await this.exists(n);if(s&&!o){if(!c)throw new d.FileOperationError((0,p.localize)(16,null,this.resourceForError(t),this.resourceForError(n)),4);if(l===r){const{providerExtUri:u}=this.getExtUri(l);if(u.isEqualOrParent(t,n))throw new Error((0,p.localize)(17,null,this.resourceForError(t),this.resourceForError(n)))}}return{exists:s,isSameResourceWithDifferentPathCase:o}}getExtUri(l){const t=this.isPathCaseSensitive(l);return{providerExtUri:t?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(t,l);const r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,r)),r}async mkdirp(l,t){const r=[],{providerExtUri:n}=this.getExtUri(l);for(;!n.isEqual(t,n.dirname(t));)try{if(((await l.stat(t)).type&d.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(t)));break}catch(a){if((0,d.toFileSystemProviderErrorCode)(a)!==d.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(n.basename(t)),t=n.dirname(t)}for(let a=r.length-1;a>=0;a--){t=n.joinPath(t,r[a]);try{await l.mkdir(t)}catch(c){if((0,d.toFileSystemProviderErrorCode)(c)!==d.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(l,t){try{await this.doValidateDelete(l,t)}catch(r){return r}return!0}async doValidateDelete(l,t){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!t?.useTrash&&!(r.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(l)));let a;try{a=await r.stat(l)}catch{}if(a)this.throwIfFileIsReadonly(l,a);else throw new d.FileOperationError((0,p.localize)(20,null,this.resourceForError(l)),1);if(!!!t?.recursive){const o=await this.resolve(l);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(l)))}return r}async del(l,t){const r=await this.doValidateDelete(l,t),n=!!t?.useTrash,a=!!t?.recursive;await r.delete(l,{recursive:a,useTrash:n}),this._onDidRunOperation.fire(new d.FileOperationEvent(l,1))}async cloneFile(l,t){const r=await this.withProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(r===n&&this.getExtUri(r).providerExtUri.isEqual(l,t))return;if(r===n&&(0,d.hasFileCloneCapability)(r))return r.cloneFile(l,t);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(t));const a=this.writeQueue.queueFor(l,this.getExtUri(r).providerExtUri);return r===n&&(0,d.hasFileFolderCopyCapability)(r)?a.queue(()=>r.copy(l,t,{overwrite:!0})):a.queue(()=>this.doCopyFile(r,l,n,t))}watch(l,t={recursive:!1,excludes:[]}){const r=new E.DisposableStore;let n=!1,a=()=>{n=!0};return r.add((0,E.toDisposable)(()=>a())),(async()=>{try{const c=await this.doWatch(l,t);n?(0,E.dispose)(c):a=()=>(0,E.dispose)(c)}catch(c){this.logService.error(c)}})(),r}async doWatch(l,t){const r=await this.withProvider(l),n=(0,P.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(l),t]);let a=this.activeWatchers.get(n);return a||(a={count:0,disposable:r.watch(l,t)},this.activeWatchers.set(n,a)),a.count+=1,(0,E.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,E.dispose)(a.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,E.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,t,r,n){return this.writeQueue.queueFor(t,this.getExtUri(l).providerExtUri).queue(async()=>{const a=await l.open(t,{create:!0,unlock:r?.unlock??!1});try{(0,v.isReadableStream)(n)||(0,v.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(l,a,n):await this.doWriteReadableBufferedQueued(l,a,n)}catch(c){throw(0,d.ensureFileSystemProviderError)(c)}finally{await l.close(a)}})}async doWriteStreamBufferedQueued(l,t,r){let n=0,a;if((0,v.isReadableBufferedStream)(r)){if(r.buffer.length>0){const c=k.VSBuffer.concat(r.buffer);await this.doWriteBuffer(l,t,c,c.byteLength,n,0),n+=c.byteLength}if(r.ended)return;a=r.stream}else a=r;return new Promise((c,o)=>{(0,v.listenStream)(a,{onData:async s=>{a.pause();try{await this.doWriteBuffer(l,t,s,s.byteLength,n,0)}catch(u){return o(u)}n+=s.byteLength,setTimeout(()=>a.resume())},onError:s=>o(s),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(l,t,r){let n=0,a;for(;(a=r.read())!==null;)await this.doWriteBuffer(l,t,a,a.byteLength,n,0),n+=a.byteLength}async doWriteBuffer(l,t,r,n,a,c){let o=0;for(;o<n;)o+=await l.write(t,a+o,r.buffer,c+o,n-o)}async doWriteUnbuffered(l,t,r,n){return this.writeQueue.queueFor(t,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,t,r,n))}async doWriteUnbufferedQueued(l,t,r,n){let a;n instanceof k.VSBuffer?a=n:(0,v.isReadableStream)(n)?a=await(0,k.streamToBuffer)(n):(0,v.isReadableBufferedStream)(n)?a=await(0,k.bufferedStreamToBuffer)(n):a=(0,k.readableToBuffer)(n),await l.writeFile(t,a.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(l,t,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,t,r,n))}async doPipeBufferedQueued(l,t,r,n){let a,c;try{a=await l.open(t,{create:!1}),c=await r.open(n,{create:!0,unlock:!1});const o=k.VSBuffer.alloc(this.BUFFER_SIZE);let s=0,u=0,m=0;do m=await l.read(a,s,o.buffer,u,o.byteLength-u),await this.doWriteBuffer(r,c,o,m,s,u),s+=m,u+=m,u===o.byteLength&&(u=0);while(m>0)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await i.Promises.settled([typeof a=="number"?l.close(a):Promise.resolve(),typeof c=="number"?r.close(c):Promise.resolve()])}}async doPipeUnbuffered(l,t,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,t,r,n))}async doPipeUnbufferedQueued(l,t,r,n){return r.writeFile(n,await l.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,t,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,t,r,n))}async doPipeUnbufferedToBufferedQueued(l,t,r,n){const a=await r.open(n,{create:!0,unlock:!1});try{const c=await l.readFile(t);await this.doWriteBuffer(r,a,k.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,d.ensureFileSystemProviderError)(c)}finally{await r.close(a)}}async doPipeBufferedToUnbuffered(l,t,r,n){const a=await(0,k.streamToBuffer)(this.readFileBuffered(l,t,L.CancellationToken.None));await this.doWriteUnbuffered(r,n,void 0,a)}throwIfFileSystemIsReadonly(l,t){if(l.capabilities&2048)throw new d.FileOperationError((0,p.localize)(22,null,this.resourceForError(t)),6);return l}throwIfFileIsReadonly(l,t){if((t.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,p.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===I.Schemas.file?l.fsPath:l.toString(!0)}};e.FileService=w,e.FileService=w=fe([K(0,S.ILogService)],w)}),define(re[192],se([0,1,52,274,6,39,18,3,41,2,12,4,20,40,27,152,15,95,189,36,181,180]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g,S,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(R)}catch(r){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(r)}`)}})();class t extends S.AbstractDiskFileSystemProvider{constructor(n,a){super(n,a);this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new L.ResourceMap(c=>h.extUriBiasedIgnorePathCase.getComparisonKey(c)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:a,symbolicLink:c}=await v.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(a,c),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(n){try{const a=await v.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),c=[];return await Promise.all(a.map(async o=>{try{let s;o.isSymbolicLink()?s=(await this.stat((0,h.joinPath)(n,o.name))).type:s=this.toType(o),c.push([o.name,s])}catch(s){this.logService.trace(s)}})),c}catch(a){throw this.toFileSystemProviderError(a)}}toType(n,a){let c;return a?.dangling?c=d.FileType.Unknown:n.isFile()?c=d.FileType.File:n.isDirectory()?c=d.FileType.Directory:c=d.FileType.Unknown,a&&(c|=d.FileType.SymbolicLink),c}async createResourceLock(n){const a=this.toFilePath(n);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let c;for(;c=this.resourceLocks.get(n);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await c.wait();const o=new k.Barrier;return this.resourceLocks.set(n,o),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.resourceLocks.get(n)===o&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.resourceLocks.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),o.open()})}async readFile(n,a){let c;try{a?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),c=await this.createResourceLock(n));const o=this.toFilePath(n);return await v.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{c?.dispose()}}readFileStream(n,a,c){const o=(0,y.newWriteableStream)(s=>A.VSBuffer.concat(s.map(u=>A.VSBuffer.wrap(u))).buffer);return(0,g.readFileIntoStream)(this,n,o,s=>s.buffer,{...a,bufferSize:256*1024},c),o}async writeFile(n,a,c){let o;try{const s=this.toFilePath(n);if(!c.create||!c.overwrite){if(await v.Promises.exists(s)){if(!c.overwrite)throw(0,d.createFileSystemProviderError)((0,p.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,d.createFileSystemProviderError)((0,p.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:c.unlock}),await this.write(o,0,a,0,a.byteLength)}catch(s){throw await this.toFileSystemProviderWriteError(n,s)}finally{typeof o=="number"&&await this.close(o)}}async open(n,a){const c=this.toFilePath(n);let o;(0,d.isFileOpenForWriteOptions)(a)&&(o=await this.createResourceLock(n));let s;try{if((0,d.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:m}=await v.SymlinkSupport.stat(c);m.mode&128||await v.Promises.chmod(c,m.mode|128)}catch(m){this.logService.trace(m)}let u;if((0,d.isFileOpenForWriteOptions)(a)){if(I.isWindows)try{await v.Promises.truncate(c,0),u="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}u||(u="w")}else u="r";s=await v.Promises.open(c,u)}catch(u){throw o?.dispose(),(0,d.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(n,u):this.toFileSystemProviderError(u)}if(this.mapHandleToPos.set(s,0),(0,d.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(s,n),o){const u=this.mapHandleToLock.get(s);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${c})`),this.mapHandleToLock.set(s,o),u&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${c})`),u.dispose())}return s}async close(n){const a=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await v.Promises.fdatasync(n)}catch(c){this.canFlush=!1,this.logService.error(c)}return await v.Promises.close(n)}catch(c){throw this.toFileSystemProviderError(c)}finally{a&&(this.mapHandleToLock.get(n)===a&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),a.dispose())}}async read(n,a,c,o,s){const u=this.normalizePos(n,a);let m=null;try{m=(await v.Promises.read(n,c,o,s,u)).bytesRead}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(n,u,m)}return m}normalizePos(n,a){return a===this.mapHandleToPos.get(n)?null:a}updatePos(n,a,c){const o=this.mapHandleToPos.get(n);typeof o=="number"&&(typeof a=="number"||(typeof c=="number"?this.mapHandleToPos.set(n,o+c):this.mapHandleToPos.delete(n)))}async write(n,a,c,o,s){return(0,k.retry)(()=>this.doWrite(n,a,c,o,s),100,3)}async doWrite(n,a,c,o,s){const u=this.normalizePos(n,a);let m=null;try{m=(await v.Promises.write(n,c,o,s,u)).bytesWritten}catch(C){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),C)}finally{this.updatePos(n,u,m)}return m}async mkdir(n){try{await v.Promises.mkdir(this.toFilePath(n))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(n,a){try{const c=this.toFilePath(n);a.recursive?await v.Promises.rm(c,v.RimRafMode.MOVE):await v.Promises.unlink(c)}catch(c){throw this.toFileSystemProviderError(c)}}async rename(n,a,c){const o=this.toFilePath(n),s=this.toFilePath(a);if(o!==s)try{await this.validateTargetDeleted(n,a,"move",c.overwrite),await v.Promises.move(o,s)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(2,null,(0,D.basename)(o),(0,D.basename)((0,D.dirname)(s)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(n,a,c){const o=this.toFilePath(n),s=this.toFilePath(a);if(o!==s)try{await this.validateTargetDeleted(n,a,"copy",c.overwrite),await v.Promises.copy(o,s,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(3,null,(0,D.basename)(o),(0,D.basename)((0,D.dirname)(s)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(n,a,c,o){const s=this.toFilePath(n),u=this.toFilePath(a);let m=!1;if(!!(this.capabilities&1024)||(m=(0,b.isEqual)(s,u,!0)),m&&c==="copy")throw(0,d.createFileSystemProviderError)((0,p.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!m&&await v.Promises.exists(u)){if(!o)throw(0,d.createFileSystemProviderError)((0,p.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(n,a){return this.doCloneFile(n,a,!1)}async doCloneFile(n,a,c){const o=this.toFilePath(n),s=this.toFilePath(a),u=!!(this.capabilities&1024);if((0,b.isEqual)(o,s,!u))return;const m=new E.DisposableStore;try{const[C,M]=await Promise.all([this.createResourceLock(n),this.createResourceLock(a)]);m.add(C),m.add(M),c&&await v.Promises.mkdir((0,D.dirname)(s),{recursive:!0}),await v.Promises.copyFile(o,s)}catch(C){if(C.code==="ENOENT"&&!c)return this.doCloneFile(n,a,!0);throw this.toFileSystemProviderError(C)}finally{m.dispose()}}createUniversalWatcher(n,a,c){return new f.UniversalWatcherClient(o=>n(o),o=>a(o),c)}createNonRecursiveWatcher(n,a,c){return new l.NodeJSWatcherClient(o=>n(o),o=>a(o),c)}toFileSystemProviderError(n){if(n instanceof d.FileSystemProviderError)return n;let a;switch(n.code){case"ENOENT":a=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=d.FileSystemProviderErrorCode.NoPermissions;break;default:a=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(n,a)}async toFileSystemProviderWriteError(n,a){let c=this.toFileSystemProviderError(a);if(n&&c.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await v.SymlinkSupport.stat(this.toFilePath(n));o.mode&128||(c=(0,d.createFileSystemProviderError)(a,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return c}}e.DiskFileSystemProvider=t}),define(re[97],se([0,1,3,8,9]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(h){this.service=h,this.onDidChangeLogLevel=R.Event.buffer(h.onDidChangeLogLevel,!0)}listen(h,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(h,y,v){switch(y){case"setLevel":return this.service.setLevel(v)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=L;class A{constructor(h){this.channel=h}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(h){A.setLevel(this.channel,h)}static setLevel(h,y){return h.call("setLevel",y)}}e.LogLevelChannelClient=A;class P{constructor(h){this.loggerService=h,this.loggers=new Map}listen(h,y){throw new Error(`Event not found: ${y}`)}async call(h,y,v){switch(y){case"createLogger":this.createLogger(i.URI.revive(v[0]),v[1]);return;case"log":return this.log(i.URI.revive(v[0]),v[1]);case"consoleLog":return this.consoleLog(v[0],v[1])}throw new Error(`Call not found: ${y}`)}createLogger(h,y){this.loggers.set(h.toString(),this.loggerService.createLogger(h,y))}consoleLog(h,y){let v=console.log;switch(h){case k.LogLevel.Error:v=console.error;break;case k.LogLevel.Warning:v=console.warn;break;case k.LogLevel.Info:v=console.info;break}v.call(console,...y)}log(h,y){const v=this.loggers.get(h.toString());if(!v)throw new Error("Create the logger before logging");for(const[p,d]of y)(0,k.log)(v,p,d)}}e.LoggerChannel=P;class b extends k.AbstractLoggerService{constructor(h,y,v){super(h,y);this.channel=v}createConsoleMainLogger(){return new k.AdapterLogger({log:(h,y)=>{this.channel.call("consoleLog",[h,y])}})}doCreateLogger(h,y,v){return new E(this.channel,h,y,v)}}e.LoggerChannelClient=b;class E extends k.AbstractMessageLogger{constructor(h,y,v,p){super(p?.always);this.channel=h,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(v),this.channel.call("createLogger",[y,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(h,y){const v=[[h,y]];this.isLoggerCreated?this.doLog(v):this.buffer.push(...v)}doLog(h){this.channel.call("log",[this.file,h])}}class D extends k.LogService{constructor(h,y){super(y);this.parent=h,this._register(h.onDidChangeLogLevel(v=>y.setLevel(v)))}setLevel(h){super.setLevel(h),this.parent.setLevel(h)}}e.FollowerLogService=D}),define(re[66],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(re[56],se([0,1,3,59,5]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=i.default,e.INotificationService=(0,k.createDecorator)("notificationService");var L;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.GLOBAL=1]="GLOBAL"})(L||(e.NeverShowAgainScope=L={}));var A;(function(E){E[E.OFF=0]="OFF",E[E.SILENT=1]="SILENT",E[E.ERROR=2]="ERROR"})(A||(e.NotificationsFilter=A={}));class P{constructor(){this.progress=new b,this.onDidClose=R.Event.None,this.onDidChangeVisibility=R.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.NoOpNotification=P;class b{infinite(){}done(){}total(D){}worked(D){}}e.NoOpProgress=b}),define(re[193],se([0,1,148,3,17,56,45]),function(J,e,R,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsGalleryConfigService=void 0;let P=class{constructor(E,D){this.configurationService=E,this.notificationService=D,this._serviceUrl="",this._itemUrl="",this._onConfigChange=new i.Emitter,this.onConfigChange=this._onConfigChange.event,this.preExtensionsGalleryConfig=this.configurationService.getValue("extensionsGallery"),this.updateURL(this.preExtensionsGalleryConfig),this.configurationService.onDidChangeConfiguration(()=>this.configure(this.configurationService.getValue("extensionsGallery")),this)}get serviceUrl(){return this._serviceUrl}get itemUrl(){return this._itemUrl}updateURL(E){E&&(this._serviceUrl=E.serviceUrl,this._itemUrl=E.itemUrl)}configure(E){JSON.stringify(this.preExtensionsGalleryConfig)===JSON.stringify(E)||(this.preExtensionsGalleryConfig=E,this.updateURL(E),this._onConfigChange.fire(this._serviceUrl?this._serviceUrl:""),this.showMessage())}showMessage(){this.notificationService.info((0,R.localize)(0,null))}};e.ExtensionsGalleryConfigService=P,fe([(0,A.debounce)(2e3)],P.prototype,"showMessage",null),e.ExtensionsGalleryConfigService=P=fe([K(0,k.IConfigurationService),K(1,L.INotificationService)],P)}),define(re[57],se([0,1,3,50,2,5]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class A extends k.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(E){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...E,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(E),i.Iterable.reduce(this.policies.entries(),(I,[h,y])=>({...I,[h]:y}),{})}getPolicyValue(E){return this.policies.get(E)}serialize(){return i.Iterable.reduce(Object.entries(this.policyDefinitions),(E,[D,I])=>({...E,[D]:{definition:I,value:this.policies.get(D)}}),{})}}e.AbstractPolicyService=A;class P{constructor(){this.onDidChange=R.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(re[194],se([0,1,3,2,57]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(b){this.service=b,this.disposables=new i.DisposableStore}listen(b,E){switch(E){case"onDidChange":return R.Event.map(this.service.onDidChange,D=>D.reduce((I,h)=>({...I,[h]:this.service.getPolicyValue(h)??null}),{}),this.disposables)}throw new Error(`Event not found: ${E}`)}call(b,E,D){switch(E){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(D)}throw new Error(`Call not found: ${E}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class A extends k.AbstractPolicyService{constructor(b,E){super();this.channel=E;for(const D in b){const{definition:I,value:h}=b[D];this.policyDefinitions[D]=I,h!==void 0&&this.policies.set(D,h)}this.channel.listen("onDidChange")(D=>{for(const I in D){const h=D[I];h===null?this.policies.delete(I):this.policies.set(I,h)}this._onDidChange.fire(Object.keys(D))})}async initializePolicies(b){const E=await this.channel.call("registerPolicyDefinitions",b);for(const D in E)this.policies.set(D,E[D])}}e.PolicyChannelClient=A}),define(re[98],se([0,1,19,4,34,20]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const P=i.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const P=(0,L.dirname)(R.FileAccess.asFileUri("",J));A=J.__$__nodeRequire((0,L.joinPath)(P,"product.json").fsPath);const b=J.__$__nodeRequire((0,L.joinPath)(P,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{IDEVersion:b.IDEVersion,version:b.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.67.0-dev",nameShort:"Kylin-Code Dev",nameLong:"Kylin-Code Dev",applicationName:"kylin-code",dataFolderName:".kylin-code",urlProtocol:"kylin-code",reportIssueUrl:"https://gitee.com/openkylin/kylin-code/issues",licenseName:"MIT",licenseUrl:"https://gitee.com/openkylin/kylin-code/blob/master/LICENSE.txt"});e.default=A}),define(re[24],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[195],se([0,1,6,7,2,12,27,9,24]),function(J,e,R,i,k,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends k.Disposable{constructor(I,h,y){super();this.productService=h,this.logService=y,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,I&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(I)},30*1e3)).schedule()}async cleanUpCodeCaches(I){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const h=Date.now(),y=(0,L.dirname)(I),v=(0,L.basename)(I),p=await A.Promises.readdir(y);await Promise.all(p.map(async d=>{if(d===v)return;const g=(0,L.join)(y,d),S=await A.Promises.stat(g);if(S.isDirectory()&&h-S.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${d}.`),A.Promises.rm(g)}))}catch(h){(0,i.onUnexpectedError)(h)}}};e.CodeCacheCleaner=E,e.CodeCacheCleaner=E=fe([K(1,b.IProductService),K(2,P.ILogService)],E)}),define(re[196],se([0,1,6,7,2,12,27,14,9,24]),function(J,e,R,i,k,L,A,P,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let D=class extends k.Disposable{constructor(h,y,v){super();this.environmentService=h,this.logService=y,this.productService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const h=Object.create(null),y=JSON.parse(await A.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let S of Object.keys(y)){const w=y[S];h[`${w.hash}.${S}`]=!0}const v=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(v))return;const d=await A.Promises.readdir(v);for(const S of d){if(h[S]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${S}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${S}`),await A.Promises.rm((0,L.join)(v,S))}const g=Date.now();for(const S of Object.keys(h)){const w=(0,L.join)(v,S),f=await A.Promises.readdir(w);for(const l of f){if(l==="tcf.json")continue;const t=(0,L.join)(w,l),r=await A.Promises.stat(t);r.isDirectory()&&g-r.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(S,l)}`),await A.Promises.rm(t))}}}catch(h){(0,i.onUnexpectedError)(h)}}};e.LanguagePackCachedDataCleaner=D,e.LanguagePackCachedDataCleaner=D=fe([K(0,P.INativeEnvironmentService),K(1,b.ILogService),K(2,E.IProductService)],D)}),define(re[197],se([0,1,12,5]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var k;(function(L){function A(P,b="noAbsolutePaths"){for(const E of P.nodes)E.callFrame&&E.callFrame.url&&((0,R.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(E.callFrame.url))&&(E.callFrame.url=(0,R.join)(b,(0,R.basename)(E.callFrame.url)));return P}L.rewriteAbsolutePaths=A})(k||(e.Utils=k={}))}),define(re[198],se([0,1,30]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this._sessions=new Map}async startProfiling(L){const P=await(await new Promise((E,D)=>{J(["v8-inspect-profiler"],E,D)})).startProfiling({port:L.port,checkForPaused:!0}),b=(0,R.generateUuid)();return this._sessions.set(b,P),b}async stopProfiling(L){const A=this._sessions.get(L);if(!A)throw new Error(`UNKNOWN session '${L}'`);const P=await A.stop();return this._sessions.delete(L),P.profile}}e.InspectProfilingService=i}),define(re[38],se([0,1,110,13]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,P){R.ok(i.isString(A)),R.ok(i.isObject(P)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(re[99],se([0,1,3,38]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,E){this.schemasById[k(b)]=E,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new L;i.Registry.add(e.Extensions.JSONContribution,A)}),define(re[42],se([0,1,16,3,13,138,17,99,38]),function(J,e,R,i,k,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D||(e.ConfigurationScope=D={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=b.Registry.as(P.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const n=this.doRegisterConfigurations(t,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(t){const r=this.doDeregisterConfigurations(t);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:t,remove:r}){const n=[];n.push(...this.doDeregisterConfigurations(r)),n.push(...this.doRegisterConfigurations(t,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,R.distinct)(n)})}registerDefaultConfigurations(t){const r=[],n=[];for(const{overrides:a,source:c}of t)for(const o in a)if(r.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s=this.configurationDefaultsOverrides.get(o),u=s?.valuesSources??new Map;if(c)for(const T of Object.keys(a[o]))u.set(T,c);const m={...s?.value||{},...a[o]};this.configurationDefaultsOverrides.set(o,{source:c,value:m,valuesSources:u});const C=(0,A.getLanguageTagSettingPlainKey)(o),M={type:"object",default:m,description:L.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:k.isString(c)?void 0:c,defaultValueSource:c};n.push(...p(o)),this.configurationProperties[o]=M,this.defaultLanguageConfigurationOverridesNode.properties[o]=M}else{this.configurationDefaultsOverrides.set(o,{value:a[o],source:c});const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const r=[];for(const{overrides:n,source:a}of t)for(const c in n){const o=this.configurationDefaultsOverrides.get(c),s=k.isString(a)?a:a?.id,u=k.isString(o?.source)?o?.source:o?.source?.id;if(s===u)if(r.push(c),this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const m=this.configurationProperties[c];m&&(this.updatePropertyDefaultValue(c,m),this.updateSchema(c,m))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const r of t)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,r){const n=[];return t.forEach(a=>{n.push(...this.validateAndRegisterProperties(a,r,a.extensionInfo,a.restrictedProperties)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),n}doDeregisterConfigurations(t){const r=[],n=a=>{if(a.properties)for(const c in a.properties){r.push(c);const o=this.configurationProperties[c];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[c],this.removeFromSchema(c,a.properties[c])}a.allOf&&a.allOf.forEach(c=>n(c))};for(const a of t){n(a);const c=this.configurationContributors.indexOf(a);c!==-1&&this.configurationContributors.splice(c,1)}return r}validateAndRegisterProperties(t,r=!0,n,a,c=3){c=k.isUndefinedOrNull(t.scope)?c:t.scope;let o=[],s=t.properties;if(s)for(let m in s){const C=s[m];if(r&&w(m,C)){delete s[m];continue}if(C.source=n,C.defaultDefaultValue=s[m].default,this.updatePropertyDefaultValue(m,C),e.OVERRIDE_PROPERTY_REGEX.test(m)?C.scope=void 0:(C.scope=k.isUndefinedOrNull(C.scope)?c:C.scope,C.restricted=k.isUndefinedOrNull(C.restricted)?!!a?.includes(m):C.restricted),s[m].hasOwnProperty("included")&&!s[m].included){this.excludedConfigurationProperties[m]=s[m],delete s[m];continue}else this.configurationProperties[m]=s[m],s[m].policy?.name&&this.policyConfigurations.set(s[m].policy.name,m);!s[m].deprecationMessage&&s[m].markdownDeprecationMessage&&(s[m].deprecationMessage=s[m].markdownDeprecationMessage),o.push(m)}let u=t.allOf;if(u)for(let m of u)o.push(...this.validateAndRegisterProperties(m,r,n,a,c));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const r=n=>{let a=n.properties;if(a)for(const o in a)this.updateSchema(o,a[o]);let c=n.allOf;c&&c.forEach(r)};r(t)}updateSchema(t,r){switch(e.allSettings.properties[t]=r,r.scope){case 1:e.applicationSettings.properties[t]=r;break;case 2:e.machineSettings.properties[t]=r;break;case 6:e.machineOverridableSettings.properties[t]=r;break;case 3:e.windowSettings.properties[t]=r;break;case 4:e.resourceSettings.properties[t]=r;break;case 5:e.resourceSettings.properties[t]=r,this.resourceLanguageSettingsSchema.properties[t]=r;break}}removeFromSchema(t,r){switch(delete e.allSettings.properties[t],r.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const r=`[${t}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,n),e.allSettings.properties[r]=n,e.applicationSettings.properties[r]=n,e.machineSettings.properties[r]=n,e.machineOverridableSettings.properties[r]=n,e.windowSettings.properties[r]=n,e.resourceSettings.properties[r]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,r){const n=this.configurationDefaultsOverrides.get(t);let a=n?.value,c=n?.source;k.isUndefined(a)&&(a=r.defaultDefaultValue,c=void 0),k.isUndefined(a)&&(a=g(r.type)),r.default=a,r.defaultValueSource=c}}const y="\\[([^\\]]+)\\]",v=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(l){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let r=v.exec(l);for(;r?.length;){const n=r[1].trim();n&&t.push(n),r=v.exec(l)}}return(0,R.distinct)(t)}e.overrideIdentifiersFromKey=p;function d(l){return l.reduce((t,r)=>`${t}[${r}]`,"")}e.keyFromOverrideIdentifiers=d;function g(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const S=new h;b.Registry.add(e.Extensions.Configuration,S);function w(l,t){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?L.localize(7,null,l):S.getConfigurationProperties()[l]!==void 0?L.localize(8,null,l):t.policy?.name&&S.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,l,t.policy?.name,S.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.validateProperty=w;function f(){const l=[],t=S.getConfigurationProperties();for(const r of Object.keys(t))l.push([r,t[r].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=f}),define(re[67],se([0,1,16,3,33,2,39,28,13,8,17,42,38]),function(J,e,R,i,k,L,A,P,b,E,D,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(r={},n=[],a=[]){this._contents=r,this._keys=n,this._overrides=a,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,D.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,n){const a=this.getContentsForOverrideIdentifer(n);return a?r?(0,D.getConfigurationValue)(a,r):a:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const a of this.overrides)a.identifiers.includes(r)&&n.push(...a.keys);return R.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return R.distinct(r)}override(r){let n=this.overrideConfigurations.get(r);return n||(n=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,n)),n}merge(...r){const n=P.deepClone(this.contents),a=P.deepClone(this.overrides),c=[...this.keys];for(const o of r){this.mergeContents(n,o.contents);for(const s of o.overrides){const[u]=a.filter(m=>R.equals(m.identifiers,s.identifiers));u?(this.mergeContents(u.contents,s.contents),u.keys.push(...s.keys),u.keys=R.distinct(u.keys)):a.push(P.deepClone(s))}for(const s of o.keys)c.indexOf(s)===-1&&c.push(s)}return new y(n,c,a)}freeze(){return this.frozen=!0,this}clone(){return new y(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(r){const n=this.getContentsForOverrideIdentifer(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let a={};for(const c of R.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[c],s=n[c];s&&(typeof o=="object"&&typeof s=="object"?(o=P.deepClone(o),this.mergeContents(o,s)):o=s),a[c]=o}return new y(a,this.keys,this.overrides)}mergeContents(r,n){for(const a of Object.keys(n)){if(a in r&&b.isObject(r[a])&&b.isObject(n[a])){this.mergeContents(r[a],n[a]);continue}r[a]=P.deepClone(n[a])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?P.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let n=null,a=null;const c=o=>{o&&(a?this.mergeContents(a,o):a=P.deepClone(o))};for(const o of this.overrides)R.equals(o.identifiers,[r])?n=o.contents:o.identifiers.includes(r)&&c(o.contents);return c(n),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.addKey(r),(0,D.addToValueTree)(this.contents,r,n,a=>{throw new Error(a)})}removeValue(r){this.removeKey(r)&&(0,D.removeFromValueTree)(this.contents,r)}addKey(r){let n=this.keys.length;for(let a=0;a<n;a++)r.indexOf(this.keys[a])===0&&(n=a);this.keys.splice(n,1,r)}removeKey(r){let n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=y;class v{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,n){if(!b.isUndefinedOrNull(r)){const a=this.doParseContent(r);this.parseRaw(a,n)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,n){this._raw=r;const{contents:a,keys:c,overrides:o,restricted:s}=this.doParseRaw(r,n);this._configurationModel=new y(a,c,o),this._restrictedConfigurations=s||[]}doParseContent(r){let n={},a=null,c=[],o=[],s=[];function u(C){Array.isArray(c)?c.push(C):a!==null&&(c[a]=C)}let m={onObjectBegin:()=>{let C={};u(C),o.push(c),c=C,a=null},onObjectProperty:C=>{a=C},onObjectEnd:()=>{c=o.pop()},onArrayBegin:()=>{let C=[];u(C),o.push(c),c=C,a=null},onArrayEnd:()=>{c=o.pop()},onLiteralValue:u,onError:(C,M,T)=>{s.push({error:C,offset:M,length:T})}};if(r)try{k.visit(r,m),n=c[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return n}doParseRaw(r,n){const a=h.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),c=this.filter(r,a,!0,n);r=c.raw;const o=(0,D.toValuesTree)(r,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),s=Object.keys(r),u=this.toOverrides(r,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:o,keys:s,overrides:u,restricted:c.restricted}}filter(r,n,a,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:r,restricted:[]};const o={},s=[];for(let u in r)if(I.OVERRIDE_PROPERTY_REGEX.test(u)&&a){const m=this.filter(r[u],n,!1,c);o[u]=m.raw,s.push(...m.restricted)}else{const m=n[u],C=m?typeof m.scope!="undefined"?m.scope:3:void 0;m?.restricted&&s.push(u),(C===void 0||c.scopes===void 0||c.scopes.includes(C))&&(c.skipRestricted&&m?.restricted||(o[u]=r[u]))}return{raw:o,restricted:s}}toOverrides(r,n){const a=[];for(const c of Object.keys(r))if(I.OVERRIDE_PROPERTY_REGEX.test(c)){const o={};for(const s in r[c])o[s]=r[c][s];a.push({identifiers:(0,I.overrideIdentifiersFromKey)(c),keys:Object.keys(o),contents:(0,D.toValuesTree)(o,n)})}return a}}e.ConfigurationModelParser=v;class p extends L.Disposable{constructor(r,n,a,c){super();this.userSettingsResource=r,this.scopes=n,this.fileService=c,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.any(i.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),i.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&a.isEqual(o.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class d{constructor(r,n,a,c=new y,o=new y,s=new A.ResourceMap,u=new y,m=new A.ResourceMap,C=!0){this._defaultConfiguration=r,this._policyConfiguration=n,this._localUserConfiguration=a,this._remoteUserConfiguration=c,this._workspaceConfiguration=o,this._folderConfigurations=s,this._memoryConfiguration=u,this._memoryConfigurationByResource=m,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(r,n,a){return this.getConsolidatedConfigurationModel(r,n,a).getValue(r)}updateValue(r,n,a={}){let c;a.resource?(c=this._memoryConfigurationByResource.get(a.resource),c||(c=new y,this._memoryConfigurationByResource.set(a.resource,c))):c=this._memoryConfiguration,n===void 0?c.removeValue(r):c.setValue(r,n),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,n,a){const c=this.getConsolidatedConfigurationModel(r,n,a),o=this.getFolderConfigurationModelForResource(n.resource,a),s=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,u=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),m=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(r),C=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),M=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),T=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),F=a?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,_=o?n.overrideIdentifier?o.freeze().override(n.overrideIdentifier).getValue(r):o.freeze().getValue(r):void 0,U=n.overrideIdentifier?s.override(n.overrideIdentifier).getValue(r):s.getValue(r),O=c.getValue(r),$=R.distinct(c.overrides.map(V=>V.identifiers).flat()).filter(V=>c.getOverrideValue(r,V)!==void 0);return{defaultValue:u,policyValue:m,userValue:C,userLocalValue:M,userRemoteValue:T,workspaceValue:F,workspaceFolderValue:_,memoryValue:U,value:O,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,policy:m!==void 0?{value:m}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userLocal:M!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:o?.freeze().getValue(r),override:n.overrideIdentifier?o?.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:s.getValue(r),override:n.overrideIdentifier?s.getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:$.length?$:void 0}}keys(r){const n=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,n){this._folderConfigurations.set(r,n),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const a=[];if(!n){const{added:c,updated:o,removed:s}=f(this._defaultConfiguration,r);n=[...c,...o,...s]}for(const c of n)for(const o of(0,I.overrideIdentifiersFromKey)(c)){const s=this._defaultConfiguration.getKeysForOverrideIdentifier(o),u=r.getKeysForOverrideIdentifier(o),m=[...u.filter(C=>s.indexOf(C)===-1),...s.filter(C=>u.indexOf(C)===-1),...s.filter(C=>!P.equals(this._defaultConfiguration.override(o).getValue(C),r.override(o).getValue(C)))];a.push([o,m])}return this.updateDefaultConfiguration(r),{keys:n,overrides:a}}compareAndUpdatePolicyConfiguration(r){const{added:n,updated:a,removed:c}=f(this._policyConfiguration,r),o=[...n,...a,...c];return o.length&&this.updatePolicyConfiguration(r),{keys:o,overrides:[]}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:a,removed:c,overrides:o}=f(this.localUserConfiguration,r),s=[...n,...a,...c];return s.length&&this.updateLocalUserConfiguration(r),{keys:s,overrides:o}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:a,removed:c,overrides:o}=f(this.remoteUserConfiguration,r);let s=[...n,...a,...c];return s.length&&this.updateRemoteUserConfiguration(r),{keys:s,overrides:o}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:a,removed:c,overrides:o}=f(this.workspaceConfiguration,r);let s=[...n,...a,...c];return s.length&&this.updateWorkspaceConfiguration(r),{keys:s,overrides:o}}compareAndUpdateFolderConfiguration(r,n){const a=this.folderConfigurations.get(r),{added:c,updated:o,removed:s,overrides:u}=f(a,n);let m=[...c,...o,...s];return(m.length||!a)&&this.updateFolderConfiguration(r,n),{keys:m,overrides:u}}compareAndDeleteFolderConfiguration(r){const n=this.folderConfigurations.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:a,updated:c,removed:o,overrides:s}=f(n,void 0);return{keys:[...a,...c,...o],overrides:s}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,n,a){let c=this.getConsolidatedConfigurationModelForResource(n,a);return n.overrideIdentifier&&(c=c.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(c=c.merge(this._policyConfiguration)),c}getConsolidatedConfigurationModelForResource({resource:r},n){let a=this.getWorkspaceConsolidatedConfiguration();if(n&&r){const c=n.getFolder(r);c&&(a=this.getFolderConsolidatedConfiguration(c.uri)||a);const o=this._memoryConfigurationByResource.get(r);o&&(a=a.merge(o))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let n=this._foldersConsolidatedConfigurations.get(r);if(!n){const a=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(r);c?(n=a.merge(c),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(r,n)):n=a}return n}getFolderConfigurationModelForResource(r,n){if(n&&r){const a=n.getFolder(r);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,n)=>{const{contents:a,overrides:c,keys:o}=this._folderConfigurations.get(n);return r.push([n,{contents:a,overrides:c,keys:o}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(a=>r.add(a))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(r).forEach(c=>n.add(c))),[...n.values()]}static parse(r){const n=this.parseConfigurationModel(r.defaults),a=this.parseConfigurationModel(r.policy),c=this.parseConfigurationModel(r.user),o=this.parseConfigurationModel(r.workspace),s=r.folders.reduce((u,m)=>(u.set(E.URI.revive(m[0]),this.parseConfigurationModel(m[1])),u),new A.ResourceMap);return new d(n,a,c,new y,o,s,new y,new A.ResourceMap,!1)}static parseConfigurationModel(r){return new y(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=d;function g(...t){if(t.length===0)return{keys:[],overrides:[]};if(t.length===1)return t[0];const r=new Set,n=new Map;for(const c of t)c.keys.forEach(o=>r.add(o)),c.overrides.forEach(([o,s])=>{const u=(0,A.getOrSet)(n,o,new Set);s.forEach(m=>u.add(m))});const a=[];return n.forEach((c,o)=>a.push([o,[...c.values()]])),{keys:[...r.values()],overrides:a}}e.mergeChanges=g;class S{constructor(r,n,a,c){this.change=r,this.previous=n,this.currentConfiguraiton=a,this.currentWorkspace=c,this._previousConfiguration=void 0;const o=new Set;r.keys.forEach(u=>o.add(u)),r.overrides.forEach(([,u])=>u.forEach(m=>o.add(m))),this.affectedKeys=[...o.values()];const s=new y;this.affectedKeys.forEach(u=>s.setValue(u,{})),this.affectedKeysTree=s.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(n){const a=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(r,n,this.currentWorkspace);return!P.equals(a,c)}return!0}return!1}doesAffectedKeysTreeContains(r,n){let a=(0,D.toValuesTree)({[n]:!0},()=>{}),c;for(;typeof a=="object"&&(c=Object.keys(a)[0]);){if(r=r[c],!r)return!1;a=a[c]}return!0}}e.ConfigurationChangeEvent=S;class w extends S{constructor(r,n,a,c){super({keys:r.allKeys(),overrides:[]},void 0,r,n);this.source=a,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=w;function f(t,r){const{added:n,removed:a,updated:c}=l(r,t),o=[],s=t?.getAllOverrideIdentifiers()||[],u=r?.getAllOverrideIdentifiers()||[];if(r){const m=u.filter(C=>!s.includes(C));for(const C of m)o.push([C,r.getKeysForOverrideIdentifier(C)])}if(t){const m=s.filter(C=>!u.includes(C));for(const C of m)o.push([C,t.getKeysForOverrideIdentifier(C)])}if(r&&t){for(const m of s)if(u.includes(m)){const C=l({contents:t.getOverrideValue(void 0,m)||{},keys:t.getKeysForOverrideIdentifier(m)},{contents:r.getOverrideValue(void 0,m)||{},keys:r.getKeysForOverrideIdentifier(m)});o.push([m,[...C.added,...C.removed,...C.updated]])}}return{added:n,removed:a,updated:c,overrides:o}}function l(t,r){const n=t?r?t.keys.filter(o=>r.keys.indexOf(o)===-1):[...t.keys]:[],a=r?t?r.keys.filter(o=>t.keys.indexOf(o)===-1):[...r.keys]:[],c=[];if(t&&r){for(const o of r.keys)if(t.keys.indexOf(o)!==-1){const s=(0,D.getConfigurationValue)(r.contents,o),u=(0,D.getConfigurationValue)(t.contents,o);P.equals(s,u)||c.push(o)}}return{added:n,removed:a,updated:c}}}),define(re[199],se([0,1,16,3,2,28,13,17,67,42,9,57,38]),function(J,e,R,i,k,L,A,P,b,E,D,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class y extends k.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new v(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(h.Registry.as(E.Extensions.Configuration).onDidUpdateConfiguration(({properties:S,defaultsOverrides:w})=>this.onDidUpdateConfiguration(S,w))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(S,w){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:S})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=y;class v extends b.ConfigurationModel{constructor(S={}){const w=h.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(w),l=Object.create(null),t=[];for(const r in w){const n=S[r],a=n!==void 0?n:w[r].default;(0,P.addToValueTree)(l,r,a,c=>console.error(`Conflict in default settings: ${c}`))}for(const r of Object.keys(l))E.OVERRIDE_PROPERTY_REGEX.test(r)&&t.push({identifiers:(0,E.overrideIdentifiersFromKey)(r),keys:Object.keys(l[r]),contents:(0,P.toValuesTree)(l[r],n=>console.error(`Conflict in default settings file: ${n}`))});super(l,f,t)}}e.DefaultConfigurationModel=v;class p{constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=new b.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=p;let d=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(S,w,f){super();this.defaultConfiguration=S,this.policyService=w,this.logService=f,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new b.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(S=>this.onDidChangePolicies(S))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:S})=>this.update(await this.registerPolicyDefinitions(S),!0))),this._configurationModel}async registerPolicyDefinitions(S){const w={},f=[],l=h.Registry.as(E.Extensions.Configuration).getConfigurationProperties();for(const t of S){const r=l[t];if(!r){f.push(t);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}f.push(t),w[r.policy.name]={type:r.type}}}return(0,A.isEmptyObject)(w)||await this.policyService.registerPolicyDefinitions(w),f}onDidChangePolicies(S){const w=h.Registry.as(E.Extensions.Configuration).getPolicyConfigurations(),f=(0,R.coalesce)(S.map(l=>w.get(l)));this.update(f,!0)}update(S,w){const f=h.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),l=[],t=this._configurationModel.isEmpty();for(const r of S){const n=f[r]?.policy?.name;if(n){const a=this.policyService.getPolicyValue(n);(t?a!==void 0:!(0,L.equals)(this._configurationModel.getValue(r),a))&&l.push([r,a])}else this._configurationModel.getValue(r)!==void 0&&l.push([r,void 0])}if(l.length){const r=this._configurationModel;this._configurationModel=new b.ConfigurationModel;for(const n of r.keys)this._configurationModel.setValue(n,r.getValue(n));for(const[n,a]of l)a===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,a);w&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=d,e.PolicyConfiguration=d=fe([K(1,I.IPolicyService),K(2,D.ILogService)],d)}),define(re[200],se([0,1,6,3,2,20,17,67,199,57]),function(J,e,R,i,k,L,A,P,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends k.Disposable{constructor(h,y,v,p){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new b.DefaultConfiguration),this.policyConfiguration=v instanceof E.NullPolicyService?new b.NullPolicyConfiguration:this._register(new b.PolicyConfiguration(this.defaultConfiguration,v,p)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,y)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:d,properties:g})=>this.onDidDefaultConfigurationChange(d,g))),this._register(this.policyConfiguration.onDidChangeConfiguration(d=>this.onDidPolicyConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[h,y,v]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(h,y,v)}getConfigurationData(){return this.configuration.toData()}getValue(h,y){const v=typeof h=="string"?h:void 0,p=(0,A.isConfigurationOverrides)(h)?h:(0,A.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(v,p,void 0)}updateValue(h,y,v,p){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const y=this.configuration.toData(),v=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(v,y,1)}onDidDefaultConfigurationChange(h,y){const v=this.configuration.toData(),p=this.configuration.compareAndUpdateDefaultConfiguration(h,y);this.trigger(p,v,6)}onDidPolicyConfigurationChange(h){const y=this.configuration.toData(),v=this.configuration.compareAndUpdatePolicyConfiguration(h);this.trigger(v,y,6)}trigger(h,y,v){const p=new P.ConfigurationChangeEvent(h,{data:y},this.configuration);p.source=v,p.sourceConfig=this.getTargetConfiguration(v),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(re[201],se([0,1,7,5]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k||(e.RemoteAuthorityResolverErrorCode=k={}));class L extends R.ErrorNoTelemetry{static isTemporarilyNotAvailable(P){return P instanceof L&&P._code===k.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof L&&P._code===k.NoResolverFound}static isHandled(P){return P instanceof L&&P.isHandled}constructor(P,b=k.Unknown,E){super(P);this._message=P,this._code=b,this._detail=E,this.isHandled=b===k.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L}),define(re[100],se([0,1,19]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(A){return A.scheme===R.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=i;function k(A){if(!A)return;const P=A.indexOf("+");return P<0?A:A.substr(0,P)}e.getRemoteName=k;function L(A){return`/${A.quality??"oss"}-${A.commit??"dev"}`}e.getRemoteServerRootPath=L}),define(re[68],se([0,1,26,5,100]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=L;function A(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(P||(e.ExtensionType=P={}));var b;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class E{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,p){if(typeof v=="undefined"||v===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof v=="string"||typeof p=="string"){let d=typeof v=="string"?v:v.value,g=typeof p=="string"?p:p.value;return R.equalsIgnoreCase(d,g)}return v._lower===p._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=E;function D(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function I(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function h(y,v){if(v){const p=`onResolveRemoteAuthority:${(0,k.getRemoteName)(v)}`;return y.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[31],se([0,1,26,29,68,4,8,7,34]),function(J,e,R,i,k,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function E(n,a){return n.uuid&&a.uuid?n.uuid===a.uuid:n.id===a.id?!0:(0,R.compareIgnoreCase)(n.id,a.id)===0}e.areSameExtensions=E;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{static create(a){const c=a.manifest?a.manifest.version:a.version,o=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new I(a.identifier,c,o)}static parse(a){const c=D.exec(a);return c&&c[1]&&c[2]?new I({id:c[1]},c[2],c[4]||void 0):null}constructor(a,c,o="undefined"){this.version=c,this.targetPlatform=o,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof I?E(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=I;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(n){const a=h.exec(n);return a&&a[1]?[p(a[1]),a[2]]:[p(n),void 0]}e.getIdAndVersion=y;function v(n,a){return`${n}.${a}`}e.getExtensionId=v;function p(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=p;function d(n,a){return p(v(n,a))}e.getGalleryExtensionId=d;function g(n,a){const c=[],o=s=>{for(const u of c)if(u.some(m=>E(a(m),a(s))))return u;return null};for(const s of n){const u=o(s);u?u.push(s):c.push([s])}return c}e.groupByExtension=g;function S(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function w(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),...n.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(n){const a=new Set;if(n.malicious)for(const c of n.malicious)a.add(c.id);return a}e.getMaliciousExtensionsSet=f;function l(n,a){const c=[],o=a.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const s=o.shift();if(s&&c.every(u=>!E(u.identifier,{id:s}))){const u=n.filter(m=>E(m.identifier,{id:s}));u.length===1&&(c.push(u[0]),o.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=l;async function t(n,a){if(!L.isLinux)return!1;let c;try{c=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){a.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(s))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function r(n,a){const c=await t(n,a),o=(0,i.getTargetPlatform)(c?"alpine":L.platform,b.arch);return a.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=r}),define(re[69],se([0,1,16,6,28,18,7,33,134,2,19,12,4,20,53,59,13,8,143,14,31,68,63,15,5,9,24,3,81]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g,S,w,f,l,t,r,n,a,c,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var u;(function(U){function O($,V){if($===V)return!0;let te=Object.keys($),H=new Set;for(let z of Object.keys(V))H.add(z);if(te.length!==H.size)return!1;for(let z of te){if($[z]!==V[z])return!1;H.delete(z)}return H.size===0}U.equals=O})(u||(e.Translations=u={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let m=class extends E.Disposable{constructor(O,$,V,te,H,z,q,j){super();this.systemExtensionsLocation=O,this.userExtensionsLocation=$,this.extensionsControlLocation=V,this.cacheLocation=te,this.fileService=H,this.logService=z,this.environmentService=q,this.productService=j,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.systemExtensionsCachedScanner=this._register(new T((0,y.joinPath)(this.cacheLocation,l.BUILTIN_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new T((0,y.joinPath)(this.cacheLocation,l.USER_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.extensionsScanner=this._register(new M(this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(O){const[$,V]=await Promise.all([this.scanSystemExtensions(O),this.scanUserExtensions(O)]),te=await this.scanExtensionsUnderDevelopment(O,[...$,...V]);return this.dedupExtensions([...$,...V,...te],await this.getTargetPlatform(),!0)}async scanSystemExtensions(O){const $=[];$.push(this.scanDefaultSystemExtensions(!!O.useCache,O.language)),$.push(this.scanDevSystemExtensions(O.language,!!O.checkControlFile));const[V,te]=await Promise.all($);return this.applyScanOptions([...V,...te],O,!1)}async scanUserExtensions(O){this.logService.trace("Started scanning user extensions");const $=await this.createExtensionScannerInput(this.userExtensionsLocation,1,!O.includeUninstalled,O.language);let te=await(O.useCache&&!$.devMode&&$.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions($);return te=await this.applyScanOptions(te,O,!0),this.logService.trace("Scanned user extensions:",te.length),te}async scanExtensionsUnderDevelopment(O,$){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(te=>te.scheme===D.Schemas.file).map(async te=>{const H=await this.createExtensionScannerInput(te,1,!0,O.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(H)).map(q=>(q.type=$.find(j=>(0,f.areSameExtensions)(j.identifier,q.identifier))?.type??q.type,this.extensionsScanner.validate(q,H)))}))).flat();return this.applyScanOptions(V,O,!0)}return[]}async scanExistingExtension(O,$,V){const te=await this.createExtensionScannerInput(O,$,!0,V.language),H=await this.extensionsScanner.scanExtension(te);return!H||!V.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(O,$,V){const te=await this.createExtensionScannerInput(O,$,!0,V.language),H=await this.extensionsScanner.scanOneOrMultipleExtensions(te);return this.applyScanOptions(H,V,!0)}async updateMetadata(O,$){const V=(0,y.joinPath)(O,"package.json"),te=(await this.fileService.readFile(V)).value.toString(),H=JSON.parse(te);$.isMachineScoped=$.isMachineScoped||void 0,$.isBuiltin=$.isBuiltin||void 0,$.installedTimestamp=$.installedTimestamp||void 0,H.__metadata={...H.__metadata,...$},await this.fileService.writeFile((0,y.joinPath)(O,"package.json"),L.VSBuffer.fromString(JSON.stringify(H,null,"	")))}async applyScanOptions(O,$,V){return $.includeAllVersions||(O=this.dedupExtensions(O,await this.getTargetPlatform(),V)),$.includeInvalid||(O=O.filter(te=>te.isValid)),O.sort((te,H)=>{const z=I.basename(te.location.fsPath),q=I.basename(H.location.fsPath);return z<q?-1:z>q?1:0})}dedupExtensions(O,$,V){const te=new Map;for(const H of O){const z=l.ExtensionIdentifier.toKey(H.identifier.id),q=te.get(z);if(q){if(q.isValid&&!H.isValid)continue;if(q.isValid===H.isValid){if(V&&v.gt(q.manifest.version,H.manifest.version)){this.logService.debug(`Skipping extension ${H.location.path} with lower version ${H.manifest.version}.`);continue}if(v.eq(q.manifest.version,H.manifest.version)&&q.targetPlatform===$){this.logService.debug(`Skipping extension ${H.location.path} from different target platform ${H.targetPlatform}`);continue}}q.type===0?this.logService.debug(`Overwriting system extension ${q.location.path} with ${H.location.path}.`):this.logService.warn(`Overwriting user extension ${q.location.path} with ${H.location.path}.`)}te.set(z,H)}return[...te.values()]}async scanDefaultSystemExtensions(O,$){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,0,!0,$),H=await(O&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",H.length),H}async scanDevSystemExtensions(O,$){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const te=$?await this.getBuiltInExtensionControl():{},H=[],z=g.URI.file(I.normalize(I.join(D.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions")));for(const j of V){const Q=te[j.name]||"marketplace";switch(Q){case"disabled":break;case"marketplace":H.push((0,y.joinPath)(z,j.name));break;default:H.push(g.URI.file(Q));break}}const q=await Promise.all(H.map(async j=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(j,0,!0,O))));return this.logService.trace("Scanned dev system extensions:",q.length),(0,R.coalesce)(q)}async getBuiltInExtensionControl(){try{const O=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(O.value.toString())}catch{return{}}}async createExtensionScannerInput(O,$,V,te,H=!0){const z=await this.getTranslations(te??h.language);let q;try{const j=await this.fileService.stat(O);typeof j.mtime=="number"&&(q=j.mtime)}catch{}return new C(O,q,$,V,H,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,te,z)}};e.AbstractExtensionsScannerService=m,e.AbstractExtensionsScannerService=m=fe([K(4,r.IFileService),K(5,a.ILogService),K(6,w.IEnvironmentService),K(7,c.IProductService)],m);class C{constructor(O,$,V,te,H,z,q,j,Q,G,X){this.location=O,this.mtime=$,this.type=V,this.excludeObsolete=te,this.validate=H,this.productVersion=z,this.productDate=q,this.productCommit=j,this.devMode=Q,this.language=G,this.translations=X}static createNlsConfiguration(O){return{language:O.language,pseudo:O.language==="pseudo",devMode:O.devMode,translations:O.translations}}static equals(O,$){return(0,y.isEqual)(O.location,$.location)&&O.mtime===$.mtime&&O.type===$.type&&O.excludeObsolete===$.excludeObsolete&&O.validate===$.validate&&O.productVersion===$.productVersion&&O.productDate===$.productDate&&O.productCommit===$.productCommit&&O.devMode===$.devMode&&O.language===$.language&&u.equals(O.translations,$.translations)}}class M extends E.Disposable{constructor(O,$){super();this.fileService=O,this.logService=$}async scanExtensions(O){const $=await this.fileService.resolve(O.location);if($.children){let V={};if(O.excludeObsolete&&O.type===1)try{const H=(await this.fileService.readFile((0,y.joinPath)(O.location,".obsolete"))).value.toString();V=JSON.parse(H)}catch{}const te=await Promise.all($.children.map(async H=>{if(!H.isDirectory||O.type===1&&(0,y.basename)(H.resource).indexOf(".")===0)return null;const z=new C(H.resource,O.mtime,O.type,O.excludeObsolete,O.validate,O.productVersion,O.productDate,O.productCommit,O.devMode,O.language,O.translations),q=await this.scanExtension(z);return q&&!V[f.ExtensionKey.create(q).toString()]?q:null}));return(0,R.coalesce)(te)}return[]}async scanOneOrMultipleExtensions(O){try{if(await this.fileService.exists((0,y.joinPath)(O.location,"package.json"))){const $=await this.scanExtension(O);return $?[$]:[]}else return await this.scanExtensions(O)}catch($){return this.logService.error(`Error scanning extensions at ${O.location.path}:`,(0,A.getErrorMessage)($)),[]}}async scanExtension(O){try{let $=await this.scanExtensionManifest(O.location);if($){$.publisher||($.publisher=l.UNDEFINED_PUBLISHER);const V=$.__metadata;delete $.__metadata;const te=(0,f.getGalleryExtensionId)($.publisher,$.name),H=V?.id?{id:te,uuid:V.id}:{id:te},z=V?.isSystem?0:O.type,q=z===0||!!V?.isBuiltin;$=await this.translateManifest(O.location,$,C.createNlsConfiguration(O));const j={type:z,identifier:H,manifest:$,location:O.location,isBuiltin:q,targetPlatform:V?.targetPlatform??"undefined",metadata:V,isValid:!0,validations:[]};return O.validate?this.validate(j,O):j}}catch($){O.type!==0&&this.logService.error($)}return null}validate(O,$){let V=!0;const te=(0,t.validateExtensionManifest)($.productVersion,$.productDate,$.location,O.manifest,O.isBuiltin);for(const[H,z]of te)H===p.default.Error&&(V=!1,this.logService.error(this.formatMessage($.location,z)));return O.isValid=V,O.validations=te,O}async scanExtensionManifest(O){const $=(0,y.joinPath)(O,"package.json");let V;try{V=(await this.fileService.readFile($)).value.toString()}catch(H){return(0,r.toFileOperationResult)(H)!==1&&this.logService.error(this.formatMessage(O,(0,S.localize)(0,null,$.path,H.message))),null}let te;try{te=JSON.parse(V)}catch{const z=[];(0,P.parse)(V,z);for(const q of z)this.logService.error(this.formatMessage(O,(0,S.localize)(1,null,$.path,q.offset,q.length,(0,b.getParseErrorMessage)(q.error))));return null}return(0,P.getNodeType)(te)!=="object"?(this.logService.error(this.formatMessage(O,(0,S.localize)(2,null,$.path))),null):te}async translateManifest(O,$,V){const te=await this.getLocalizedMessages(O,$,V);if(te)try{const H=[],z=await this.resolveOriginalMessageBundle(te.default,H);if(H.length>0)return H.forEach(j=>{this.logService.error(this.formatMessage(O,(0,S.localize)(3,null,te.default?.path,(0,b.getParseErrorMessage)(j.error))))}),$;if((0,P.getNodeType)(te)!=="object")return this.logService.error(this.formatMessage(O,(0,S.localize)(4,null,te.default?.path))),$;const q=te.values||Object.create(null);this.replaceNLStrings(V.pseudo,$,q,z,O)}catch{}return $}async getLocalizedMessages(O,$,V){const te=(0,y.joinPath)(O,"package.nls.json"),H=(Q,G)=>{G.forEach(X=>{this.logService.error(this.formatMessage(O,(0,S.localize)(5,null,Q?.path,(0,b.getParseErrorMessage)(X.error))))})},z=Q=>{this.logService.error(this.formatMessage(O,(0,S.localize)(6,null,Q?.path)))},q=`${$.publisher}.${$.name}`,j=V.translations[q];if(j)try{const Q=g.URI.file(j),G=(await this.fileService.readFile(Q)).value.toString();let X=[],Z=(0,P.parse)(G,X);return X.length>0?(H(Q,X),{values:void 0,default:te}):(0,P.getNodeType)(Z)!=="object"?(z(Q),{values:void 0,default:te}):{values:Z.contents?Z.contents.package:void 0,default:te}}catch{return{values:void 0,default:te}}else{if(!await this.fileService.exists(te))return;let G;try{G=await this.findMessageBundles(O,V)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const X=(await this.fileService.readFile(G.localized)).value.toString();let Z=[],W=(0,P.parse)(X,Z);return Z.length>0?(H(G.localized,Z),{values:void 0,default:G.original}):(0,P.getNodeType)(W)!=="object"?(z(G.localized),{values:void 0,default:G.original}):{values:W,default:G.original}}catch{return{values:void 0,default:G.original}}}}async resolveOriginalMessageBundle(O,$){if(O)try{const V=(await this.fileService.readFile(O)).value.toString();return(0,P.parse)(V,$)}catch{return null}else return null}findMessageBundles(O,$){return new Promise((V,te)=>{const H=z=>{let q=(0,y.joinPath)(O,`package.nls.${z}.json`);this.fileService.exists(q).then(j=>{j&&V({localized:q,original:(0,y.joinPath)(O,"package.nls.json")});let Q=z.lastIndexOf("-");Q===-1?V({localized:(0,y.joinPath)(O,"package.nls.json"),original:null}):(z=z.substring(0,Q),H(z))})};if($.devMode||$.pseudo||!$.language)return V({localized:(0,y.joinPath)(O,"package.nls.json"),original:null});H($.language)})}replaceNLStrings(O,$,V,te,H){const z=(q,j,Q)=>{const G=q[j];if((0,d.isString)(G)){const X=G,Z=X.length;if(Z>1&&X[0]==="%"&&X[Z-1]==="%"){const W=X.substr(1,Z-2);let ee=V[W];ee===void 0&&te&&(ee=te[W]);let B=typeof ee=="string"?ee:typeof ee?.message=="string"?ee.message:void 0;B!==void 0?(O&&(B="\uFF3B"+B.replace(/[aouei]/g,"$&$&")+"\uFF3D"),q[j]=Q&&(j==="title"||j==="category")&&te?{value:B,original:te[W]}:B):this.logService.warn(this.formatMessage(H,(0,S.localize)(7,null,W)))}}else if((0,d.isObject)(G))for(let X in G)G.hasOwnProperty(X)&&(X==="commands"?z(G,X,!0):z(G,X,Q));else if((0,d.isArray)(G))for(let X=0;X<G.length;X++)z(G,X,Q)};for(let q in $)$.hasOwnProperty(q)&&z($,q)}formatMessage(O,$){return`[${O.path}]: ${$}`}}class T extends M{constructor(O,$,V){super($,V);this.cacheFile=O,this.cacheValidatorThrottler=this._register(new i.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(O){const $=await this.readExtensionCache();if(this.input=O,$&&$.input&&C.equals($.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),$.result.map(te=>(te.location=g.URI.revive(te.location),te));const V=await super.scanExtensions(O);return await this.writeExtensionCache({input:O,result:V}),V}async readExtensionCache(){try{const O=await this.fileService.readFile(this.cacheFile),$=JSON.parse(O.value.toString());return{result:$.result,input:(0,s.revive)($.input)}}catch(O){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(O))}return null}async writeExtensionCache(O){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(O)))}catch($){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)($))}}async validateCache(){if(!this.input)return;const O=await this.readExtensionCache();if(!O)return;const $=O.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(V,$))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(te){this.logService.error(te)}}}function F(U,O){const $=(0,f.getExtensionId)(U.manifest.publisher,U.manifest.name);return{id:$,identifier:new l.ExtensionIdentifier($),isBuiltin:U.type===0,isUserBuiltin:U.type===1&&U.isBuiltin,isUnderDevelopment:O,extensionLocation:U.location,uuid:U.identifier.uuid,targetPlatform:U.targetPlatform,...U.manifest}}e.toExtensionDescription=F;class _ extends m{constructor(O,$,V,te,H,z,q,j){super(O,$,(0,y.joinPath)(V,".kylin-code-dev","extensions","control.json"),(0,y.joinPath)(te,l.MANIFEST_CACHE_FOLDER),H,z,q,j);this.translationsPromise=(async()=>{if(h.translationsConfigFile)try{const Q=await this.fileService.readFile(g.URI.file(h.translationsConfigFile));return JSON.parse(Q.value.toString())}catch{}return Object.create(null)})()}getTranslations(O){return this.translationsPromise}}e.NativeExtensionsScannerService=_}),define(re[202],se([0,1,23,31]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function k(L,A,P,b,E){try{const D=await L.getExtensionsControlManifest();if(!D.deprecated)return;const I=await L.getInstalled(1);for(const[h,y]of Object.entries(D.deprecated)){if(!y?.extension)continue;const{id:v,autoMigrate:p,preRelease:d}=y.extension;if(!p)continue;const g=I.find(w=>(0,i.areSameExtensions)(w.identifier,{id:h}));if(!g)continue;const S=(await A.getExtensions([{id:v,preRelease:d}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!S){E.info(`Skipping migrating '${g.identifier.id}' extension because, the comaptible target '${v}' extension is not found`);continue}try{E.info(`Migrating '${g.identifier.id}' extension to '${v}' extension...`);const w=!b.getDisabledExtensions().some(l=>(0,i.areSameExtensions)(l,g.identifier));await L.uninstall(g),E.info(`Uninstalled the unsupported extension '${g.identifier.id}'`);let f=I.find(l=>(0,i.areSameExtensions)(l.identifier,{id:v}));(!f||!f.isPreReleaseVersion&&w)&&(f=await L.installFromGallery(S,{installPreReleaseVersion:!0,isMachineScoped:g.isMachineScoped,operation:4}),E.info(`Installed the pre-release extension '${f.identifier.id}'`),w||(await b.disableExtension(f.identifier),E.info(`Disabled the pre-release extension '${f.identifier.id}' because the unsupported extension '${g.identifier.id}' is disabled`)),p.storage&&(P.addToMigrationList((0,i.getExtensionId)(g.manifest.publisher,g.manifest.name),(0,i.getExtensionId)(f.manifest.publisher,f.manifest.name)),E.info("Added pre-release extension to the storage migration list"))),E.info(`Migrated '${g.identifier.id}' extension to '${v}' extension.`)}catch(w){E.error(w)}}}catch(D){E.error(D)}}e.migrateUnsupportedExtensions=k}),define(re[203],se([0,1,6,7,2,4,20,53,8,30,27,14,29,31,15,9]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let d=class extends k.Disposable{constructor(S,w,f,l){super();this.fileService=w,this.extensionGalleryService=f,this.logService=l,this.extensionsDownloadDir=b.URI.file(S.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(S,w){await this.cleanUpPromise;const f=this.getName(S),l=(0,A.joinPath)(this.extensionsDownloadDir,f);if(!await this.fileService.exists(l)){const t=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(S,t,w);try{await this.rename(t,l,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(t)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",S.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,t.path),r}}return l}async delete(S){await this.cleanUpPromise,await this.fileService.del(S)}async rename(S,w,f){try{await D.Promises.rename(S.fsPath,w.fsPath)}catch(l){if(L.isWindows&&l&&l.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${S} to ${w} with 'EPERM' error. Trying again...`),this.rename(S,w,f);throw l}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const S=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(S.children){const w=[],f=[];for(const r of S.children){const n=y.ExtensionKey.parse(r.name);n&&f.push([n,r])}const l=(0,y.groupByExtension)(f,([r])=>r),t=[];for(const r of l)r.sort((n,a)=>P.rcompare(n[0].version,a[0].version)),w.push(...r.slice(1).map(n=>n[1].resource)),t.push(r[0][1]);t.sort((r,n)=>r.mtime-n.mtime),w.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(r=>r.resource)),await R.Promises.settled(w.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(S){this.logService.error(S)}}getName(S){return this.cache?y.ExtensionKey.create(S).toString().toLowerCase():(0,E.generateUuid)()}};e.ExtensionsDownloader=d,e.ExtensionsDownloader=d=fe([K(0,I.INativeEnvironmentService),K(1,v.IFileService),K(2,h.IExtensionGalleryService),K(3,p.ILogService)],d)}),define(re[204],se([0,1,2,12,27,68]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends R.Disposable{constructor(b,E){super();this.environmentService=b,this.extensionsManifestCache=(0,i.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(D=>this.onDidInstallExtensions(D))),this._register(E.onDidUninstallExtension(D=>this.onDidUnInstallExtension(D)))}onDidInstallExtensions(b){b.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(re[205],se([0,1,8,14,69,15,9,24]),function(J,e,R,i,k,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends k.NativeExtensionsScannerService{constructor(D,I,h,y){super(R.URI.file(h.builtinExtensionsPath),R.URI.file(h.extensionsPath),h.userHome,R.URI.file(h.userDataPath),D,I,h,y)}};e.ExtensionsScannerService=b,e.ExtensionsScannerService=b=fe([K(0,L.IFileService),K(1,A.ILogService),K(2,i.INativeEnvironmentService),K(3,P.IProductService)],b)}),define(re[206],se([0,1,94,16,6,2,19,12,27,14,29,31,9,65]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let v=class extends y.LanguagePackBaseService{constructor(S,w,f,l){super(f);this.extensionManagementService=S,this.logService=l,this.cache=this._register(new p(w,l)),this.extensionManagementService.registerParticipant({postInstall:async t=>this.postInstallExtension(t),postUninstall:async t=>this.postUninstallExtension(t)})}async getInstalledLanguages(){const S=await this.cache.getLanguagePacks(),w=Object.keys(S).map(f=>{const l=S[f];return{...this.createQuickPickItem({locale:f,label:l.label}),extensionId:l.extensions[0].extensionIdentifier.id}});return w.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),w}async postInstallExtension(S){S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",S.identifier.id),await this.update())}async postUninstallExtension(S){const w=await this.cache.getLanguagePacks();Object.keys(w).some(f=>w[f]&&w[f].extensions.some(l=>(0,I.areSameExtensions)(l.extensionIdentifier,S.identifier)))&&(this.logService.info("Removing language packs from the extension",S.identifier.id),await this.update())}async update(){const[S,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(w);return!(0,i.equals)(Object.keys(S),Object.keys(f))}};e.NativeLanguagePackService=v,e.NativeLanguagePackService=v=fe([K(0,D.IExtensionManagementService),K(1,E.INativeEnvironmentService),K(2,D.IExtensionGalleryService),K(3,h.ILogService)],v);let p=class extends L.Disposable{constructor(S,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(S.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(S){return this.withLanguagePacks(w=>{Object.keys(w).forEach(f=>delete w[f]),this.createLanguagePacksFromExtensions(w,...S)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(S,...w){for(const f of w)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(S,f);Object.keys(S).forEach(f=>this.updateHash(S[f]))}createLanguagePacksFromExtension(S,w){const f=w.identifier,l=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const t of l)if(w.location.scheme===A.Schemas.file&&d(t)){let r=S[t.languageId];r||(r={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},S[t.languageId]=r);let n=r.extensions.filter(a=>(0,I.areSameExtensions)(a.extensionIdentifier,f))[0];n?n.version=w.manifest.version:r.extensions.push({extensionIdentifier:f,version:w.manifest.version});for(const a of t.translations)r.translations[a.id]=(0,P.join)(w.location.fsPath,a.path)}}updateHash(S){if(S){const w=(0,R.createHash)("md5");for(const f of S.extensions)w.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);S.hash=w.digest("hex")}}withLanguagePacks(S=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(w=S(f),f)).then(f=>{for(const t of Object.keys(f))f[t]||delete f[t];this.languagePacks=f,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),b.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>w,f=>this.logService.error(f))})}};p=fe([K(0,E.INativeEnvironmentService),K(1,h.ILogService)],p);function d(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const S of g.translations)if(typeof S.id!="string"||typeof S.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(re[207],se([0,1,6,18,23,7,3,2,30,84,201,100]),function(J,e,R,i,k,L,A,P,b,E,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const h=30*1e3;var y;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function v(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function p(G){const X=new k.CancellationTokenSource;return setTimeout(()=>X.cancel(),G),X.token}function d(G,X){if(G.isCancellationRequested||X.isCancellationRequested)return k.CancellationToken.Cancelled;const Z=new k.CancellationTokenSource;return G.onCancellationRequested(()=>Z.cancel()),X.onCancellationRequested(()=>Z.cancel()),Z.token}class g{get didTimeout(){return this._state==="timedout"}constructor(X){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((Z,W)=>{this._resolvePromise=Z,this._rejectPromise=W}),X.isCancellationRequested?this._timeout():this._disposables.add(X.onCancellationRequested(()=>this._timeout()))}registerDisposable(X){this._state==="pending"?this._disposables.add(X):X.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const X=new Error("Time limit reached");return X.code="ETIMEDOUT",X.syscall="connect",X}resolve(X){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(X))}reject(X){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(X))}}function S(G,X){const Z=new g(X);return Z.registerDisposable(G.onControlMessage(W=>{const ee=JSON.parse(W.toString()),B=H(ee);B?Z.reject(B):Z.resolve(ee)})),Z.promise}function w(G,X,Z,W,ee,B,N,x){const Y=new g(x);return X.connect(Z,W,ee,B,N,(ne,oe)=>{Y.didTimeout?(ne&&G.error(ne),oe?.dispose()):ne||!oe?Y.reject(ne):Y.resolve(oe)}),Y.promise}function f(G,X){const Z=new g(X);return G.then(W=>{Z.didTimeout||Z.resolve(W)},W=>{Z.didTimeout||Z.reject(W)}),Z.promise}async function l(G,X,Z,W){const ee=j(G,X);G.logService.trace(`${ee} 1/6. invoking socketFactory.connect().`);let B;try{B=await w(G.logService,G.socketFactory,G.host,G.port,(0,I.getRemoteServerRootPath)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,`renderer-${v(X)}-${G.reconnectionToken}`,W)}catch(oe){throw G.logService.error(`${ee} socketFactory.connect() failed or timed out. Error:`),G.logService.error(oe),oe}G.logService.trace(`${ee} 2/6. socketFactory.connect() was successful.`);let N,x;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(B,null),N=G.reconnectionProtocol,x=!1):(N=new E.PersistentProtocol(B,null),x=!0),G.logService.trace(`${ee} 3/6. sending AuthRequest control message.`);const Y=await f(G.signService.createNewMessage((0,b.generateUuid)()),W),ne={type:"auth",auth:G.connectionToken||"00000000000000000000",data:Y.data};N.sendControl(i.VSBuffer.fromString(JSON.stringify(ne)));try{const oe=await S(N,d(W,p(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(G.logService.trace(`${ee} 4/6. received SignRequest control message.`),!await f(G.signService.validate(Y,oe.signedData),W)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const me=await f(G.signService.sign(oe.data),W),Ee={type:"connectionType",commit:G.commit,signedData:me,desiredConnectionType:X};return Z&&(Ee.args=Z),G.logService.trace(`${ee} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(i.VSBuffer.fromString(JSON.stringify(Ee))),{protocol:N,ownsProtocol:x}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(G.logService.error(`${ee} the handshake timed out. Error:`),G.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${ee} received error control message when negotiating connection. Error:`),G.logService.error(oe)),x&&te(N),oe}}async function t(G,X,Z,W){const ee=Date.now(),B=j(G,X),{protocol:N,ownsProtocol:x}=await l(G,X,Z,W),Y=new g(W);return Y.registerDisposable(N.onControlMessage(ne=>{const oe=JSON.parse(ne.toString()),de=H(oe);de?(G.logService.error(`${B} received error control message when negotiating connection. Error:`),G.logService.error(de),x&&te(N),Y.reject(de)):(G.reconnectionProtocol&&G.reconnectionProtocol.endAcceptReconnection(),G.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${Q(ee)}!`),Y.resolve({protocol:N,firstMessage:oe}))})),Y.promise}async function r(G,X){const{protocol:Z}=await t(G,1,void 0,X);return{protocol:Z}}async function n(G,X,Z){const{protocol:W,firstMessage:ee}=await t(G,2,X,Z),B=ee&&ee.debugPort;return{protocol:W,debugPort:B}}async function a(G,X,Z){const W=Date.now(),ee=j(G,3),{protocol:B}=await l(G,3,X,Z);return G.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${Q(W)}!`),B}async function c(G,X,Z){const{host:W,port:ee,connectionToken:B}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,host:W,port:ee,connectionToken:B,reconnectionToken:X,reconnectionProtocol:Z,socketFactory:G.socketFactory,signService:G.signService,logService:G.logService}}async function o(G,X,Z){try{const W=(0,b.generateUuid)(),ee=await c(G,W,null),{protocol:B}=await r(ee,k.CancellationToken.None);return new $(G,X,Z,W,B)}catch(W){throw G.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),G.logService.error(W),O.triggerPermanentFailure(0,0,D.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentManagement=o;async function s(G,X){try{const Z=(0,b.generateUuid)(),W=await c(G,Z,null),{protocol:ee,debugPort:B}=await n(W,X,k.CancellationToken.None);return new V(G,X,Z,ee,B)}catch(Z){throw G.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),G.logService.error(Z),O.triggerPermanentFailure(0,0,D.RemoteAuthorityResolverError.isHandled(Z)),Z}}e.connectRemoteAgentExtensionHost=s;async function u(G,X,Z){const W=await c(G,(0,b.generateUuid)(),null);return await a(W,{host:X,port:Z},k.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function m(G){return(0,R.createCancelablePromise)(X=>new Promise((Z,W)=>{const ee=setTimeout(Z,G*1e3);X.onCancellationRequested(()=>{clearTimeout(ee),Z()})}))}var C;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(C||(e.PersistentConnectionEventType=C={}));class M{constructor(X,Z){this.reconnectionToken=X,this.millisSinceLastIncomingData=Z,this.type=0}}e.ConnectionLostEvent=M;class T{constructor(X,Z,W,ee){this.reconnectionToken=X,this.millisSinceLastIncomingData=Z,this.durationSeconds=W,this.cancellableTimer=ee,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=T;class F{constructor(X,Z,W){this.reconnectionToken=X,this.millisSinceLastIncomingData=Z,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=F;class _{constructor(X,Z,W){this.reconnectionToken=X,this.millisSinceLastIncomingData=Z,this.attempt=W,this.type=4}}e.ConnectionGainEvent=_;class U{constructor(X,Z,W,ee){this.reconnectionToken=X,this.millisSinceLastIncomingData=Z,this.attempt=W,this.handled=ee,this.type=3}}e.ReconnectionPermanentFailureEvent=U;class O extends P.Disposable{static triggerPermanentFailure(X,Z,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=X,this._permanentFailureAttempt=Z,this._permanentFailureHandled=W,this._instances.forEach(ee=>ee._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(X=>X._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(X=>X._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||O._permanentFailure}constructor(X,Z,W,ee,B){super();this._connectionType=X,this._options=Z,this.reconnectionToken=W,this.protocol=ee,this._reconnectionFailureIsFatal=B,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new _(this.reconnectionToken,0,0)),this._register(ee.onSocketClose(N=>{const x=q(this._connectionType,this.reconnectionToken,!0);N?N.type===0?(this._options.logService.info(`${x} received socket close event (hadError: ${N.hadError}).`),N.error&&this._options.logService.error(N.error)):(this._options.logService.info(`${x} received socket close event (wasClean: ${N.wasClean}, code: ${N.code}, reason: ${N.reason}).`),N.event&&this._options.logService.error(N.event)):this._options.logService.info(`${x} received socket close event.`),this._beginReconnecting()})),this._register(ee.onSocketTimeout(()=>{const N=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${N} received socket timeout event.`),this._beginReconnecting()})),O._instances.push(this),this._register((0,P.toDisposable)(()=>{const N=O._instances.indexOf(this);N>=0&&O._instances.splice(N,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(O._permanentFailureMillisSinceLastIncomingData,O._permanentFailureAttempt,O._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const X=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${X} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Z=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const ee=W<Z.length?Z[W]:Z[Z.length-1];try{if(ee>0){const N=m(ee);this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee,N)),this._options.logService.info(`${X} waiting for ${ee} seconds before reconnecting...`);try{await N}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${X} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${X} resolving connection...`);const B=await c(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${X} connecting to ${B.host}:${B.port}...`),await this._reconnect(B,p(h)),this._options.logService.info(`${X} reconnected!`),this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${X} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${X} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(D.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this._options.logService.info(`${X} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this._options.logService.info(`${X} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((0,L.isCancellationError)(B)){this._options.logService.info(`${X} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if(B instanceof D.RemoteAuthorityResolverError){this._options.logService.error(`${X} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,D.RemoteAuthorityResolverError.isHandled(B));break}this._options.logService.error(`${X} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(X,Z,W){this._reconnectionFailureIsFatal?O.triggerPermanentFailure(X,Z,W):this._gotoPermanentFailure(X,Z,W)}_gotoPermanentFailure(X,Z,W){this._onDidStateChange.fire(new U(this.reconnectionToken,X,Z,W)),te(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=O,O._permanentFailure=!1,O._permanentFailureMillisSinceLastIncomingData=0,O._permanentFailureAttempt=0,O._permanentFailureHandled=!1,O._instances=[];class $ extends O{constructor(X,Z,W,ee,B){super(1,X,ee,B,!0);this.client=this._register(new E.Client(B,{remoteAuthority:Z,clientId:W},X.ipcLogger))}async _reconnect(X,Z){await r(X,Z)}}e.ManagementPersistentConnection=$;class V extends O{constructor(X,Z,W,ee,B){super(2,X,W,ee,!1);this._startArguments=Z,this.debugPort=B}async _reconnect(X,Z){await n(X,this._startArguments,Z)}}e.ExtensionHostPersistentConnection=V;function te(G){try{G.acceptDisconnect();const X=G.getSocket();G.dispose(),X.dispose()}catch(X){(0,L.onUnexpectedError)(X)}}function H(G){if(G&&G.type==="error"){const X=new Error(`Connection error: ${G.reason}`);return X.code="VSCODE_CONNECTION_ERROR",X}return null}function z(G,X){for(;G.length<X;)G+=" ";return G}function q(G,X,Z){return`[remote-connection][${z(v(G),13)}][${X.substr(0,5)}\u2026][${Z?"reconnect":"initial"}]`}function j(G,X){return`${q(X,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.host}:${G.port}]`}function Q(G){return`${Date.now()-G} ms`}}),define(re[208],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[209],se([0,1,129,17,9]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(P,b){this.configurationService=P,this.logService=b}async request(P,b){this.logService.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const E=await(0,R.request)(P,b);return this.logService.trace("RequestService#request (browser) - success",P.url),E}catch(E){throw this.logService.error("RequestService#request (browser) - error",P.url,E),E}}async resolveProxy(P){}};e.RequestService=L,e.RequestService=L=fe([K(0,i.IConfigurationService),K(1,k.ILogService)],L)}),define(re[43],se([0,1,18,154,42,5,38]),function(J,e,R,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=P;function b(p){return p.res.statusCode===204}async function E(p){return b(p)?null:(await(0,R.streamToBuffer)(p.stream)).toString()}e.asText=E;async function D(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);return E(p)}e.asTextOrError=D;async function I(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);if(b(p))return null;const g=(await(0,R.streamToBuffer)(p.stream)).toString();try{return JSON.parse(g)}catch(S){throw S.message+=`:
`+g,S}}e.asJson=I;function h(p){v(p)}e.updateProxyConfigurationsScope=h;let y;function v(p){const d=A.Registry.as(k.Extensions.Configuration),g=y;y={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[y],remove:g?[g]:[]})}v(2)}),define(re[210],se([0,1,23,19,15,43]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(b,E){this.requestService=b,this.fileService=E}async download(b,E,D=R.CancellationToken.None){if(b.scheme===i.Schemas.file||b.scheme===i.Schemas.vscodeRemote){await this.fileService.copy(b,E);return}const I={type:"GET",url:b.toString()},h=await this.requestService.request(I,D);if(h.res.statusCode===200)await this.fileService.writeFile(E,h.stream);else{const y=await(0,L.asTextOrError)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${y}`)}}};e.DownloadService=A,e.DownloadService=A=fe([K(0,L.IRequestService),K(1,k.IFileService)],A)}),define(re[211],se([0,1,16,23,74,2,20,170,15,9,24,43]),function(J,e,R,i,k,L,A,P,b,E,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let h=class extends L.Disposable{constructor(v,p,d,g){super();this.fileService=v,this.productService=p,this.requestService=d,this.logService=g,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:S})=>this.allConfigBasedTips.set(S.configPath,S))}getConfigBasedTips(v){return this.getValidConfigBasedTips(v)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(v){const p=[];for(const[d,g]of this.allConfigBasedTips)if(!(g.configScheme&&g.configScheme!==v.scheme))try{const S=await this.fileService.readFile((0,A.joinPath)(v,d)),w=new Map;(0,k.forEach)(g.recommendations,({key:l,value:t})=>{if((0,R.isNonEmptyArray)(t.remotes))for(const r of t.remotes)w.set(r,{extensionId:l,extensionName:t.name,configName:g.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack,whenNotInstalled:t.whenNotInstalled});else p.push({extensionId:l,extensionName:t.name,configName:g.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack,whenNotInstalled:t.whenNotInstalled})});const f=(0,P.getDomainsOfRemotes)(S.value.toString(),[...w.keys()]);for(const l of f){const t=w.get(l);t&&p.push(t)}}catch{}return p}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const v=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},i.CancellationToken.None);if(v.res.statusCode!==200)return[];const p=await(0,I.asJson)(v);return p?p.workspaceRecommendations||[]:[]}catch(v){return this.logService.error(v),[]}}};e.ExtensionTipsService=h,e.ExtensionTipsService=h=fe([K(0,b.IFileService),K(1,D.IProductService),K(2,I.IRequestService),K(3,E.ILogService)],h)}),define(re[101],se([0,1,79,5]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function k(L){return(0,R.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=k,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(re[212],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(R||(e.SharedProcessWorkerMessages=R={}))}),define(re[213],se([0,1,85,6,23,3,2,19,30,9,101,212]),function(J,e,R,i,k,L,A,P,b,E,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let h=class{constructor(p){this.logService=p,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(p){const d=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${d})`);const g=(0,D.hash)(p);this.processeDisposables.has(g)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${d})`),this.doDisposeWorker(p));const S=new k.CancellationTokenSource;let w,f,l;this.processeDisposables.set(g,a=>{S.dispose(!0),w?.terminate(p,k.CancellationToken.None),f?.close(),l?.close(),this.processeDisposables.delete(g);const c=this.processResolvers.get(g);c&&(this.processResolvers.delete(g),c({reason:a}))}),w=await this.getOrCreateWebWorker(p);const t=new Promise(a=>{this.processResolvers.set(g,a)});if(S.token.isCancellationRequested)return t;const{port1:r,port2:n}=new MessageChannel;return f=r,l=n,await w.spawn(p,l,S.token),S.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${d})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",p,[f])),t}getOrCreateWebWorker(p){let d=this.workers.get(p.process.moduleId);if(!d){this.logService.trace(`SharedProcess: creating new web worker (${p.process.moduleId})`);const g=new y(p.process.type,this.logService);d=g.init(),g.onDidProcessSelfTerminate(({configuration:S,reason:w})=>{this.doDisposeWorker(S,w)}),this.workers.set(p.process.moduleId,d)}return d}async disposeWorker(p){return this.doDisposeWorker(p)}doDisposeWorker(p,d){const g=this.processeDisposables.get((0,D.hash)(p));g&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),g(d))}};e.SharedProcessWorkerService=h,e.SharedProcessWorkerService=h=fe([K(0,E.ILogService)],h);class y extends A.Disposable{constructor(p,d){super();this.type=p,this.logService=d,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const p=new i.DeferredPromise,d=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return d.onerror=g=>{this.logService.error(`SharedProcess: worker error (${this.type})`,g.message)},d.onmessageerror=g=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,g)},d.onmessage=g=>{const{id:S,message:w,configuration:f,nonce:l}=g.data;switch(S){case I.SharedProcessWorkerMessages.Ready:p.complete(d);break;case I.SharedProcessWorkerMessages.Ack:if(l){const t=this.mapMessageNonceToPendingMessageResolve.get(l);t&&(this.mapMessageNonceToPendingMessageResolve.delete(l),t())}break;case I.SharedProcessWorkerMessages.SelfTerminated:f&&w&&this._onDidProcessSelfTerminate.fire({configuration:f,reason:JSON.parse(w)});break;case I.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,w);break;case I.SharedProcessWorkerMessages.Info:w&&this.logService.info(w);break;case I.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,w);break;case I.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,w);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,g)}},d.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),p.p}async send(p,d,g){const S=await this.workerReady;if(!d.isCancellationRequested)return new Promise(w=>{const f=(0,b.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(f,w);const l={...p,nonce:f};g?S.postMessage(l,[g]):S.postMessage(l),d.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(f)&&w()})})}spawn(p,d,g){const S={id:I.SharedProcessWorkerMessages.Spawn,configuration:p,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",J).fsPath}};return this.send(S,g,d)}terminate(p,d){const g={id:I.SharedProcessWorkerMessages.Terminate,configuration:p};return this.send(g,d)}}}),define(re[214],se([0,1,45,19,169]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends k.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.vscodeUserData})}}e.SharedProcessEnvironmentService=L,fe([R.memoize],L.prototype,"userRoamingDataHome",null)}),define(re[215],se([0,1,46,12,155,23,36,7,4,30,136,167,6]),function(J,e,R,i,k,L,A,P,b,E,D,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let v;async function p(g,S,w){return S["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(w)&&!S["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(w)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=h.Promises.withAsyncBody(async(f,l)=>{const t=new L.CancellationTokenSource,r=setTimeout(()=>{t.dispose(!0),l(new Error((0,k.localize)(0,null)))},y);try{f(await d(g,t.token))}catch(n){!(0,P.isCancellationError)(n)&&!t.token.isCancellationRequested?l(new Error((0,k.localize)(1,null,(0,A.toErrorMessage)(n)))):f({})}finally{clearTimeout(r),t.dispose()}})),v)}e.getResolvedShellEnv=p;async function d(g,S){const w=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",w);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",f);const l=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(l+"(.*)"+l),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};g.trace("getUnixShellEnvironment#env",r);const n=await(0,D.getSystemShell)(b.OS,r);return g.trace("getUnixShellEnvironment#shell",n),new Promise((a,c)=>{if(S.isCancellationRequested)return c((0,P.canceled)());const o=(0,i.basename)(n);let s,u;const m=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(s=`& '${process.execPath}' ${m} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,u=["-Login","-Command"]):(s=`'${process.execPath}' ${m} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,o==="tcsh"?u=["-ic"]:u=["-ilc"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),s);const C=(0,R.spawn)(n,[...u,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});S.onCancellationRequested(()=>(C.kill(),c((0,P.canceled)()))),C.on("error",F=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(F)),c(F)});const M=[];C.stdout.on("data",F=>M.push(F));const T=[];C.stderr.on("data",F=>T.push(F)),C.on("close",(F,_)=>{const U=Buffer.concat(M).toString("utf8");g.trace("getUnixShellEnvironment#raw",U);const O=Buffer.concat(T).toString("utf8");if(O.trim()&&g.trace("getUnixShellEnvironment#stderr",O),F||_)return c(new Error((0,k.localize)(2,null,F,_)));const $=t.exec(U),V=$?$[1]:"{}";try{const te=JSON.parse(V);w?te.ELECTRON_RUN_AS_NODE=w:delete te.ELECTRON_RUN_AS_NODE,f?te.ELECTRON_NO_ATTACH_CONSOLE=f:delete te.ELECTRON_NO_ATTACH_CONSOLE,delete te.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",te),a(te)}catch(te){g.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(te)),c(te)}})})}}),define(re[102],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[216],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.validators=new Map}vsda(){return new Promise((k,L)=>J(["vsda"],k,L))}async createNewMessage(k){try{const L=await this.vsda(),A=new L.validator;if(A){const P=String(R._nextId++);return this.validators.set(P,A),{id:P,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,L){if(!k.id)return!0;const A=this.validators.get(k.id);if(!A)return!1;this.validators.delete(k.id);try{return A.validate(L)==="ok"}catch{return!1}}async sign(k){try{const L=await this.vsda(),A=new L.signer;if(A)return A.sign(k)}catch{}return k}}e.SignService=R,R._nextId=1}),define(re[21],se([0,1,6,3,2,191,13,86,5]),function(J,e,R,i,k,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var D;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(D||(e.WillSaveStateReason=D={}));var I;(function(d){d[d.GLOBAL=0]="GLOBAL",d[d.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var h;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));class y extends k.Disposable{constructor(g={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new i.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new i.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new i.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,S){S===E?(g===0?this._globalKeyTargets=void 0:g===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:g})):this._onDidChangeValue.fire({scope:g,key:S,target:this.getKeyTargets(g)[S]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,S,w){return this.getStorage(S)?.get(g,w)}getBoolean(g,S,w){return this.getStorage(S)?.getBoolean(g,w)}getNumber(g,S,w){return this.getStorage(S)?.getNumber(g,w)}store(g,S,w,f){if((0,A.isUndefinedOrNull)(S)){this.remove(g,w);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,w,f),this.getStorage(w)?.set(g,S)})}remove(g,S){this.withPausedEmitters(()=>{this.updateKeyTarget(g,S,void 0),this.getStorage(S)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,S){const w=[],f=this.getKeyTargets(g);for(const l of Object.keys(f))f[l]===S&&w.push(l);return w}updateKeyTarget(g,S,w){const f=this.getKeyTargets(S);typeof w=="number"?f[g]!==w&&(f[g]=w,this.getStorage(S)?.set(E,JSON.stringify(f))):typeof f[g]=="number"&&(delete f[g],this.getStorage(S)?.set(E,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(g){return g===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(g){const S=this.get(E,g);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=D.NONE){this._onWillSaveState.fire({reason:g});const S=this.getStorage(0),w=this.getStorage(1);switch(g){case D.NONE:await R.Promises.settled([S?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await R.Promises.settled([S?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve()]);break}}async logStorage(){const g=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return p(g,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class v extends y{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.globalStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g)))}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(g){}}e.InMemoryStorageService=v;async function p(d,g,S,w){const f=o=>{try{return JSON.parse(o)}catch{return o}},l=new Map,t=new Map;d.forEach((o,s)=>{l.set(s,o),t.set(s,f(o))});const r=new Map,n=new Map;g.forEach((o,s)=>{r.set(s,o),n.set(s,f(o))}),console.group(`Storage: Global (path: ${S})`);let a=[];l.forEach((o,s)=>{a.push({key:s,value:o})}),console.table(a),console.groupEnd(),console.log(t),console.group(`Storage: Workspace (path: ${w})`);let c=[];r.forEach((o,s)=>{c.push({key:s,value:o})}),console.table(c),console.groupEnd(),console.log(n)}e.logStorage=p}),define(re[217],se([0,1,3,2,13,29,31,21]),function(J,e,R,i,k,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends i.Disposable{constructor(I,h){super();this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(I)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"}))),this._register(h.onDidInstallExtensions(y=>y.forEach(({local:v,operation:p})=>{v&&p===4&&this._removeFromDisabledExtensions(v.identifier)})))}async enableExtension(I,h){return this._removeFromDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:h}),!0):!1}async disableExtension(I,h){return this._addToDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:h}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(I){let h=this.getDisabledExtensions();return h.every(y=>!(0,A.areSameExtensions)(y,I))?(h.push(I),this._setDisabledExtensions(h),!0):!1}_removeFromDisabledExtensions(I){let h=this.getDisabledExtensions();for(let y=0;y<h.length;y++){const v=h[y];if((0,A.areSameExtensions)(v,I))return h.splice(y,1),this._setDisabledExtensions(h),!0}return!1}_setDisabledExtensions(I){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,I)}_getExtensions(I){return this.storageManger.get(I,0)}_setExtensions(I,h){this.storageManger.set(I,h,0)}};e.GlobalExtensionEnablementService=b,e.GlobalExtensionEnablementService=b=fe([K(0,P.IStorageService),K(1,L.IExtensionManagementService)],b);class E extends i.Disposable{constructor(I){super();this.storageService=I,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(I.onDidChangeValue(h=>this.onDidStorageChange(h)))}get(I,h){let y;return h===0?((0,k.isUndefinedOrNull)(this.storage[I])&&(this.storage[I]=this._get(I,h)),y=this.storage[I]):y=this._get(I,h),JSON.parse(y)}set(I,h,y){let v=JSON.stringify(h.map(({id:d,uuid:g})=>({id:d,uuid:g})));this._get(I,y)!==v&&(y===0&&(h.length?this.storage[I]=v:delete this.storage[I]),this._set(I,h.length?v:void 0,y))}onDidStorageChange(I){if(I.scope===0&&!(0,k.isUndefinedOrNull)(this.storage[I.key])&&this._get(I.key,I.scope)!==this.storage[I.key]){const y=this.get(I.key,I.scope);delete this.storage[I.key];const v=this.get(I.key,I.scope),p=y.filter(g=>!v.some(S=>(0,A.areSameExtensions)(g,S))),d=v.filter(g=>!y.some(S=>(0,A.areSameExtensions)(S,g)));(p.length||d.length)&&this._onDidChange.fire([...p,...d])}}_get(I,h){return this.storageService.get(I,h,"[]")}_set(I,h,y){h?this.storageService.store(I,h,y,1):this.storageService.remove(I,y)}}e.StorageManager=E}),define(re[70],se([0,1,5,3,2,21,31,24,16,9,13]),function(J,e,R,i,k,L,A,P,b,E,D){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,R.createDecorator)("IExtensionStorageService");const h=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let y=I=class extends k.Disposable{static toKey(p){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(p.id)}@${p.version}`}static fromKey(p){const d=h.exec(p);if(d&&d[1])return{id:d[1],version:d[2]}}static async removeOutdatedExtensionVersions(p,d){const g=await p.getInstalled(),S=[];for(const[w,f]of I.readAllExtensionsWithKeysForSync(d)){const l=g.find(t=>(0,A.areSameExtensions)(t.identifier,{id:w}))?.manifest.version;for(const t of f)l!==t&&S.push(I.toKey({id:w,version:t}))}for(const w of S)d.remove(w,0)}static readAllExtensionsWithKeysForSync(p){const d=new Map,g=p.keys(0,1);for(const S of g){const w=I.fromKey(S);if(w){let f=d.get(w.id.toLowerCase());f||d.set(w.id.toLowerCase(),f=[]),f.push(w.version)}}return d}constructor(p,d,g){super();this.storageService=p,this.productService=d,this.logService=g,this._onDidChangeExtensionStorageToSync=this._register(new i.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=I.readAllExtensionsWithKeysForSync(p),this._register(this.storageService.onDidChangeValue(S=>this.onDidChangeStorageValue(S)))}onDidChangeStorageValue(p){if(p.scope!==0)return;if(this.extensionsWithKeysForSync.has(p.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const d=I.fromKey(p.key);if(d){if(this.storageService.get(p.key,0)===void 0)this.extensionsWithKeysForSync.delete(d.id.toLowerCase());else{let g=this.extensionsWithKeysForSync.get(d.id.toLowerCase());g||this.extensionsWithKeysForSync.set(d.id.toLowerCase(),g=[]),g.push(d.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(p){if((0,D.isString)(p))return p;const d=p.manifest?p.manifest.publisher:p.publisher,g=p.manifest?p.manifest.name:p.name;return(0,A.getExtensionId)(d,g)}getExtensionState(p,d){const g=this.getExtensionId(p),S=this.storageService.get(g,d?0:1);if(S)try{return JSON.parse(S)}catch(w){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${d}): ${w}`)}}setExtensionState(p,d,g){const S=this.getExtensionId(p);d===void 0?this.storageService.remove(S,g?0:1):this.storageService.store(S,JSON.stringify(d),g?0:1,1)}setKeysForSync(p,d){this.storageService.store(I.toKey(p),JSON.stringify(d),0,1)}getKeysForSync(p){const d=this.productService.extensionSyncedKeys?.[p.id.toLowerCase()],g=this.storageService.get(I.toKey(p),0),S=g?JSON.parse(g):void 0;return S&&d?(0,b.distinct)([...S,...d]):S||d}addToMigrationList(p,d){if(p!==d){const g=this.migrationList.filter(S=>!S.includes(p)&&!S.includes(d));g.push([p,d]),this.migrationList=g}}getSourceExtensionToMigrate(p){const d=this.migrationList.find(([,g])=>p===g);return d?d[0]:void 0}get migrationList(){const p=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const d=JSON.parse(p);if((0,D.isArray)(d))return d}catch{}return[]}set migrationList(p){p.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(p),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};e.ExtensionStorageService=y,e.ExtensionStorageService=y=I=fe([K(0,L.IStorageService),K(1,P.IProductService),K(2,E.ILogService)],y)}),define(re[218],se([0,1,2,29,70,202,9,21]),function(J,e,R,i,k,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let b=class extends R.Disposable{constructor(D,I,h,y,v,p){super();D.removeDeprecatedExtensions(),(0,L.migrateUnsupportedExtensions)(D,I,h,y,p),k.ExtensionStorageService.removeOutdatedExtensionVersions(D,v)}};e.ExtensionsCleaner=b,e.ExtensionsCleaner=b=fe([K(0,i.IExtensionManagementService),K(1,i.IExtensionGalleryService),K(2,k.IExtensionStorageService),K(3,i.IGlobalExtensionEnablementService),K(4,P.IStorageService),K(5,A.ILogService)],b)}),define(re[219],se([0,1,3,2]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class k extends i.Disposable{constructor(E,D){super();this.channel=E,this.workspace=D}async getItems(){const E={workspace:this.workspace},D=await this.channel.call("getItems",E);return new Map(D)}updateItems(E){const D={workspace:this.workspace};return E.insert&&(D.insert=Array.from(E.insert.entries())),E.delete&&(D.delete=Array.from(E.delete.values())),this.channel.call("updateItems",D)}}class L extends k{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class A extends k{constructor(E,D){super(E,D);this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}class P extends i.Disposable{get globalStorage(){return this._globalStorage||(this._globalStorage=new L(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}constructor(E,D){super();this.channel=E,this.workspace=D,this._globalStorage=void 0,this._workspaceStorage=void 0}}e.StorageDatabaseChannelClient=P}),define(re[220],se([0,1,6,2,20,86,21,219]),function(J,e,R,i,k,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends A.AbstractStorageService{constructor(D,I,h){super();this.mainProcessService=I,this.environmentService=h,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new i.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(D)}createGlobalStorage(){const D=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),I=new L.Storage(D.globalStorage);return this._register(I.onDidChangeStorage(h=>this.emitDidChangeValue(0,h))),I}createWorkspaceStorage(D){const I=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),D);if(I.workspaceStorage){const h=new L.Storage(I.workspaceStorage);return this.workspaceStorageDisposable.value=h.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)),this.workspaceStorageId=D?.id,h}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await R.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(D){const I=this.workspaceStorage,h=I?.items??new Map;I&&(await I.close(),I.dispose()),this.workspaceStorage=this.createWorkspaceStorage(D),await this.workspaceStorage.init();for(const[y,v]of h)this.workspaceStorage.set(y,v)}}e.NativeStorageService=b}),define(re[221],se([0,1,4,34,8,30]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(E){if(R.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function P(E,D,I,h,y,v,p,d,g,S){const w=Object.create(null);w["common.machineId"]=p,w.sessionID=(0,L.generateUuid)()+Date.now(),w.commitHash=y,w.version=v,w["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,R.PlatformToString)(R.platform),w["common.nodePlatform"]=i.platform,w["common.nodeArch"]=h,w["common.product"]=S||"desktop";const f=b(d||[]);f&&(w["common.msftInternal"]=f);let l=0;const t=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),R.isLinuxSnap&&(w["common.snap"]="true");const r=A(I);r&&(w["common.platformDetail"]=r);try{const n=await E.readFile(k.URI.file(g));w["common.source"]=n.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=P;function b(E){const D=i.env.USERDNSDOMAIN;if(!D)return!1;const I=D.toLowerCase();return E.some(h=>I===h)}e.verifyMicrosoftInternalDomain=b}),define(re[22],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(i||(e.TelemetryLevel=i={}));var k;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(re[222],se([0,1,35,50,6,33,19,12,4,8,122,27,125,90,15,24,22]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const g=new Map;async function S(r,n){const a=`${r}::${n.join(":")}`,c=g.get(a);if(c)return c;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],s=new Map,u=new Map,m=2e4;function C(T,F,_,U){const O=F.substring(T.length+1);return k.Promises.withAsyncBody(async $=>{let V;try{V=await I.Promises.readdir(F,{withFileTypes:!0})}catch{$();return}if(U.count>=m){U.count+=V.length,U.maxReached=!0,$();return}let te=V.length;if(te===0){$();return}let H=V;U.count+V.length>m&&(U.maxReached=!0,te=m-U.count,H=V.slice(0,te)),U.count+=V.length;for(const z of H)if(z.isDirectory()){if(_.includes(z.name)||await C(T,(0,P.join)(F,z.name),_,U),--te==0){$();return}}else{const q=z.name.lastIndexOf(".");if(q>=0){const j=z.name.substring(q+1);j&&s.set(j,(s.get(j)??0)+1)}for(const j of o)j.relativePathPattern?.test(O)!==!1&&j.filePattern.test(z.name)&&u.set(j.tag,(u.get(j.tag)??0)+1);if(--te==0){$();return}}})}const M=k.Promises.withAsyncBody(async T=>{const F={count:0,maxReached:!1};await C(r,r,n,F);const _=await l(r);T({configFiles:w(u),fileTypes:w(s),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:_})});return g.set(a,M),M}e.collectWorkspaceStats=S;function w(r){return[...i.Iterable.map(r.entries(),([n,a])=>({name:n,count:a}))].sort((n,a)=>a.count-n.count)}function f(){const r={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(D.virtualMachineHint.value()*100)}%`},n=R.cpus();return n&&n.length>0&&(r.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),r}e.getMachineInfo=f;async function l(r){try{const n=new Map,a=(0,P.join)(r,".vscode","launch.json"),c=await I.Promises.readFile(a),o=[],s=(0,L.parse)(c.toString(),o);if(o.length)return console.log(`Unable to parse ${a}`),[];if((0,L.getNodeType)(s)==="object"&&s.configurations)for(const u of s.configurations){const m=u.type;m&&(n.has(m)?n.set(m,n.get(m)+1):n.set(m,1))}return w(n)}catch{return[]}}e.collectLaunchConfigs=l;let t=class{constructor(n,a){this.telemetryService=n,this.productService=a}formatMachineInfo(n){const a=[];return a.push(`OS Version:       ${n.os}`),a.push(`CPUs:             ${n.cpus}`),a.push(`Memory (System):  ${n.memory}`),a.push(`VM:               ${n.vmHint}`),a.join(`
`)}formatEnvironment(n){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const c=R.cpus();return c&&c.length>0&&a.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),a.push(`Memory (System):  ${(R.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||a.push(`Load (avg):       ${R.loadavg().map(o=>Math.round(o)).join(", ")}`),a.push(`VM:               ${Math.round(D.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${n.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(n,a){return Promise.all([(0,h.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async c=>{let[o,s]=c,u=this.formatProcessList(n,o);return a.forEach(m=>{if((0,y.isRemoteDiagnosticError)(m))u+=`
${m.errorMessage}`,s+=`
${m.errorMessage}`;else if(u+=`

Remote: ${m.hostName}`,m.processes&&(u+=`
${this.formatProcessList(n,m.processes)}`),m.workspaceMetadata){s+=`
|  Remote: ${m.hostName}`;for(const C of Object.keys(m.workspaceMetadata)){const M=m.workspaceMetadata[C];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),s+=`|    Folder (${C}): ${T}`,s+=this.formatWorkspaceStats(M)}}}),{processInfo:u,workspaceInfo:s}})}async getSystemInfo(n,a){const{memory:c,vmHint:o,os:s,cpus:u}=f(),m={os:s,memory:c,cpus:u,vmHint:o,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:a};return b.isWindows||(m.load=`${R.loadavg().map(C=>Math.round(C)).join(", ")}`),b.isLinux&&(m.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(m)}async getDiagnostics(n,a){const c=[];return(0,h.listProcesses)(n.mainPID).then(async o=>(c.push(""),c.push(this.formatEnvironment(n)),c.push(""),c.push(this.formatProcessList(n,o)),n.windows.some(s=>s.folderURIs&&s.folderURIs.length>0&&!s.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.formatWorkspaceMetadata(n))),a.forEach(s=>{if((0,y.isRemoteDiagnosticError)(s))c.push(`
${s.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${s.hostName}`),c.push(this.formatMachineInfo(s.machineInfo)),s.processes&&c.push(this.formatProcessList(n,s.processes)),s.workspaceMetadata)for(const u of Object.keys(s.workspaceMetadata)){const m=s.workspaceMetadata[u];let C=`${m.fileCount} files`;m.maxFilesReached&&(C=`more than ${C}`),c.push(`Folder (${u}): ${C}`),c.push(this.formatWorkspaceStats(m))}}),c.push(""),c.push(""),c.join(`
`)))}formatWorkspaceStats(n){const a=[],c=60;let o=0;const s=(M,T)=>{const F=` ${M}(${T})`;o+F.length>c?(a.push(u),u="|                 ",o=u.length):o+=F.length,u+=F};let u="|      File types:";const m=10;let C=n.fileTypes.length>m?m:n.fileTypes.length;for(let M=0;M<C;M++){const T=n.fileTypes[M];s(T.name,T.count)}if(a.push(u),n.configFiles.length>=0&&(u="|      Conf files:",o=0,n.configFiles.forEach(M=>{s(M.name,M.count)}),a.push(u)),n.launchConfigFiles.length>0){let M="|      Launch Configs:";n.launchConfigFiles.forEach(T=>{M+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),a.push(M)}return a.join(`
`)}expandGPUFeatures(n){const a=Math.max(...Object.keys(n).map(c=>c.length));return Object.keys(n).map(c=>`${c}:  ${" ".repeat(a-c.length)}  ${n[c]}`).join(`
                  `)}formatWorkspaceMetadata(n){const a=[],c=[];return n.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(a.push(`|  Window (${o.title})`),o.folderURIs.forEach(s=>{const u=E.URI.revive(s);if(u.scheme===A.Schemas.file){const m=u.fsPath;c.push(S(m,["node_modules",".git"]).then(C=>{let M=`${C.fileCount} files`;C.maxFilesReached&&(M=`more than ${M}`),a.push(`|    Folder (${(0,P.basename)(m)}): ${M}`),a.push(this.formatWorkspaceStats(C))}).catch(C=>{a.push(`|      Error: Unable to collect workspace stats for folder ${m} (${C.toString()})`)}))}else a.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(o=>a.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(n,a){const c=new Map;n.windows.forEach(s=>c.set(s.pid,s.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(n.mainPID,c,o,a,0),o.join(`
`)}formatProcessItem(n,a,c,o,s){const u=s===0;let m;u?m=o.pid===n?`${this.productService.applicationName} main`:"remote agent":(m=`${"  ".repeat(s)} ${o.name}`,o.name==="window"&&(m=`${m} (${a.get(o.pid)})`));const C=process.platform==="win32"?o.mem:R.totalmem()*(o.mem/100);c.push(`${o.load.toFixed(0).padStart(5," ")}	${(C/v.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${m}`),Array.isArray(o.children)&&o.children.forEach(M=>this.formatProcessItem(n,a,c,M,s+1))}async getWorkspaceFileExtensions(n){const a=new Set;for(const{uri:c}of n.folders){const o=E.URI.revive(c);if(o.scheme!==A.Schemas.file)continue;const s=o.fsPath;try{(await S(s,["node_modules",".git"])).fileTypes.forEach(m=>a.add(m.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(n){for(const{uri:a}of n.folders){const c=E.URI.revive(a);if(c.scheme!==A.Schemas.file)continue;const o=c.fsPath;try{const s=await S(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),s.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:u.name,count:u.count})}),s.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:u.name,count:u.count})}),s.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};e.DiagnosticsService=t,e.DiagnosticsService=t=fe([K(0,d.ITelemetryService),K(1,p.IProductService)],t)}),define(re[223],se([0,1,16,6,23,7,3,2,4,8,141,29,31,9,24,22]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let d=class extends P.Disposable{constructor(t,r,n,a){super();this.galleryService=t,this.telemetryService=r,this.logService=n,this.productService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(c=>c.cancel()),this.uninstallingExtensions.forEach(c=>c.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(n=>(0,I.isTargetPlatformCompatible)(n,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new I.ExtensionManagementError(D.localize(0,null),I.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,r)}catch(n){throw w(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(t),error:n}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(n),S(n)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.unininstallExtension(t,r)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(D.localize(1,null));const r=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:r,compatible:!0},k.CancellationToken.None);if(!n)throw new Error(D.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,n){if(!E.URI.isUri(r)){let u=this.installingExtensions.get(h.ExtensionKey.create(r).toString());if(u)return this.logService.info("Extensions is already requested to install",r.identifier.id),u.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],c=[],o=this.createInstallExtensionTask(t,r,n);E.URI.isUri(r)||this.installingExtensions.set(h.ExtensionKey.create(r).toString(),o),this._onInstallExtension.fire({identifier:o.identifier,source:r}),this.logService.info("Installing extension:",o.identifier.id),a.push({task:o,manifest:t});let s=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",o.identifier.id);else try{const m=await this.getAllDepsAndPackExtensionsToInstall(o.identifier,t,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:C,manifest:M}of m){s=s||!!M.extensionDependencies?.some(F=>(0,h.areSameExtensions)({id:F},o.identifier));const T=h.ExtensionKey.create(C).toString();if(this.installingExtensions.has(T))this.logService.info("Extension is already requested to install",C.identifier.id);else{const F=this.createInstallExtensionTask(M,C,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(T,F),this._onInstallExtension.fire({identifier:F.identifier,source:C}),this.logService.info("Installing extension:",F.identifier.id),a.push({task:F,manifest:M})}}}catch(m){if(E.URI.isUri(o.source))(0,R.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",o.identifier.id,m.message),(0,R.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",o.identifier.id,m.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",o.identifier.id),m}const u=a.reduce((m,{task:C,manifest:M})=>(m.set(C.identifier.id.toLowerCase(),{task:C,manifest:M}),m),new Map);for(;u.size;){let m;const C=[...u.values()].filter(({manifest:M})=>!M.extensionDependencies?.some(T=>u.has(T.toLowerCase())));C.length?m=u.size===1?C:C.filter(({task:M})=>!(M===o&&!s)):(this.logService.info("Found extensions with circular dependencies",C.map(({task:M})=>M.identifier.id)),m=[...u.values()]),await this.joinAllSettled(m.map(async({task:M})=>{const T=new Date().getTime();try{const F=await M.run();if(await this.joinAllSettled(this.participants.map(_=>_.postInstall(F,M.source,n,k.CancellationToken.None))),!E.URI.isUri(M.source)){const _=M.operation===3;if(w(this.telemetryService,_?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(M.source),duration:new Date().getTime()-T,durationSinceUpdate:_?void 0:new Date().getTime()-M.source.lastUpdated}),b.isWeb&&M.operation!==3)try{await this.galleryService.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,"install")}catch{}}c.push({local:F,identifier:M.identifier,operation:M.operation,source:M.source})}catch(F){throw E.URI.isUri(M.source)||w(this.telemetryService,M.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(M.source),duration:new Date().getTime()-T,error:F}),this.logService.error("Error while installing the extension:",M.identifier.id),F}finally{u.delete(M.identifier.id.toLowerCase())}}))}return c.forEach(({identifier:m})=>this.logService.info("Extension installed successfully:",m.id)),this._onDidInstallExtensions.fire(c),c.filter(({identifier:m})=>(0,h.areSameExtensions)(m,o.identifier))[0].local}catch(u){if(a.forEach(({task:m})=>m.cancel()),c.length)try{const m=await Promise.allSettled(c.map(({local:C})=>this.createUninstallExtensionTask(C,{versionOnly:!0}).run()));for(let C=0;C<m.length;C++){const M=m[C],{identifier:T}=c[C];M.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",T.id):this.logService.warn("Rollback: Error while uninstalling extension",T.id,(0,L.getErrorMessage)(M.reason))}}catch(m){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(m),c.map(({identifier:C})=>C.id))}throw this._onDidInstallExtensions.fire(a.map(({task:m})=>({identifier:m.identifier,operation:2,source:m.source}))),u}finally{for(const{task:u}of a)if(!E.URI.isUri(u.source)){const m=h.ExtensionKey.create(u.source).toString();this.installingExtensions.delete(m)||this.logService.warn("Installation task is not found in the cache",m)}}}async joinAllSettled(t){const r=[],n=[],a=await Promise.allSettled(t);for(const c of a)c.status==="fulfilled"?r.push(c.value):n.push(c.reason);if(n.length)throw g(n);return r}async getAllDepsAndPackExtensionsToInstall(t,r,n,a){if(!this.galleryService.isEnabled())return[];let c=await this.getInstalled();const o=[t,...c.map(m=>m.identifier)],s=[],u=async(m,C)=>{const M=C.extensionDependencies||[],T=[...M];if(C.extensionPack){const F=n?c.find(_=>(0,h.areSameExtensions)(_.identifier,m)):void 0;for(const _ of C.extensionPack)F&&F.manifest.extensionPack&&F.manifest.extensionPack.some(U=>(0,h.areSameExtensions)({id:U},{id:_}))||T.every(U=>!(0,h.areSameExtensions)({id:U},{id:_}))&&T.push(_)}if(T.length){const F=[...o,...s.map(U=>U.gallery.identifier)],_=T.filter(U=>F.every(O=>!(0,h.areSameExtensions)(O,{id:U})));if(_.length){const U=await this.galleryService.getExtensions(_.map(O=>({id:O,preRelease:a})),k.CancellationToken.None);for(const O of U){if(F.find(te=>(0,h.areSameExtensions)(te,O.identifier)))continue;const $=M.some(te=>(0,h.areSameExtensions)({id:te},O.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(O,!1,a)}catch(te){if(te instanceof I.ExtensionManagementError&&te.code===I.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!$){this.logService.info("Skipping the packed extension as it cannot be installed",O.identifier.id);continue}else throw te}s.push({gallery:V.extension,manifest:V.manifest}),await u(V.extension.identifier,V.manifest)}}}};return await u(t,r),c=await this.getInstalled(),s.filter(m=>!c.some(C=>(0,h.areSameExtensions)(C.identifier,m.gallery.identifier)))}async checkAndGetCompatibleVersion(t,r,n){const a=await this.getExtensionsControlManifest();if((0,h.getMaliciousExtensionsSet)(a).has(t.identifier.id))throw new I.ExtensionManagementError(D.localize(3,null,t.identifier.id),I.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const s=await this.getTargetPlatform();throw new I.ExtensionManagementError(D.localize(4,null,t.identifier.id,this.productService.nameLong,(0,I.TargetPlatformToString)(s)),I.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const c=await this.getCompatibleVersion(t,r,n);if(c){if(n&&!r&&t.hasPreReleaseVersion&&!c.properties.isPreReleaseVersion)throw new I.ExtensionManagementError(D.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),I.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],k.CancellationToken.None))[0]?new I.ExtensionManagementError(D.localize(6,null,t.identifier.id),I.ExtensionManagementErrorCode.ReleaseVersionNotFound):new I.ExtensionManagementError(D.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),I.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",c.identifier.id);const o=await this.galleryService.getManifest(c,k.CancellationToken.None);if(o===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,I.ExtensionManagementErrorCode.Invalid);if(o.version!==c.version)throw new I.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,I.ExtensionManagementErrorCode.Invalid);return{extension:c,manifest:o}}async getCompatibleVersion(t,r,n){const a=await this.getTargetPlatform();let c=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==n&&(c=(await this.galleryService.getExtensions([{...t.identifier,preRelease:n}],{targetPlatform:a,compatible:!0},k.CancellationToken.None))[0]||null),!c&&await this.galleryService.isExtensionCompatible(t,n,a)&&(c=t),c||(r?c=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:a,compatible:!0},k.CancellationToken.None))[0]||null:c=await this.galleryService.getCompatibleExtension(t,n,a)),c}async unininstallExtension(t,r){const n=this.uninstallingExtensions.get(t.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),n.waitUntilTaskIsFinished();const a=(u,m)=>{const C=this.createUninstallExtensionTask(u,m);return this.uninstallingExtensions.set(C.extension.identifier.id.toLowerCase(),C),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),C},c=(u,m)=>{m?this.logService.error("Failed to uninstall extension:",u.identifier.id,m.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),w(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(u),error:m}),this._onDidUninstallExtension.fire({identifier:u.identifier,error:m?.code})},o=[],s=[];try{o.push(a(t,{remove:!0}));const u=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",t.identifier.id);else{const m=this.getAllPackExtensionsToUninstall(t,u);for(const C of m)this.uninstallingExtensions.has(C.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",C.identifier.id):o.push(a(C,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",t.identifier.id):this.checkForDependents(o.map(m=>m.extension),u,t),await this.joinAllSettled(o.map(async m=>{try{if(await m.run(),await this.joinAllSettled(this.participants.map(C=>C.postUninstall(m.extension,r,k.CancellationToken.None))),m.extension.identifier.uuid)try{await this.galleryService.reportStatistic(m.extension.manifest.publisher,m.extension.manifest.name,m.extension.manifest.version,"uninstall")}catch{}c(m.extension)}catch(C){const M=C instanceof I.ExtensionManagementError?C:new I.ExtensionManagementError((0,L.getErrorMessage)(C),I.ExtensionManagementErrorCode.Internal);throw c(m.extension,M),M}finally{s.push(m)}}))}catch(u){const m=u instanceof I.ExtensionManagementError?u:new I.ExtensionManagementError((0,L.getErrorMessage)(u),I.ExtensionManagementErrorCode.Internal);for(const C of o){try{C.cancel()}catch{}s.includes(C)||c(C.extension,m)}throw m}finally{for(const u of o)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(t,r,n){for(const a of t){const c=this.getDependents(a,r);if(c.length){const o=c.filter(s=>!t.some(u=>(0,h.areSameExtensions)(u.identifier,s.identifier)));if(o.length)throw new Error(this.getDependentsErrorMessage(a,o,n))}}}getDependentsErrorMessage(t,r,n){return n===t?r.length===1?D.localize(8,null,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?D.localize(9,null,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):D.localize(10,null,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?D.localize(11,null,n.manifest.displayName||n.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?D.localize(12,null,n.manifest.displayName||n.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):D.localize(13,null,n.manifest.displayName||n.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,n=[]){if(n.indexOf(t)!==-1)return[];n.push(t);const a=t.manifest.extensionPack?t.manifest.extensionPack:[];if(a.length){const c=r.filter(s=>!s.isBuiltin&&a.some(u=>(0,h.areSameExtensions)({id:u},s.identifier))),o=[];for(const s of c)o.push(...this.getAllPackExtensionsToUninstall(s,r,n));return[...c,...o]}return[]}getDependents(t,r){return r.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(a=>(0,h.areSameExtensions)({id:a},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=d,e.AbstractExtensionManagementService=d=fe([K(0,I.IExtensionGalleryService),K(1,p.ITelemetryService),K(2,y.ILogService),K(3,v.IProductService)],d);function g(l){const t=Array.isArray(l)?l:[l];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,n)=>new Error(`${r.message}${r.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}e.joinErrors=g;function S(l){if(l instanceof I.ExtensionManagementError)return l;const t=new I.ExtensionManagementError(l.message,I.ExtensionManagementErrorCode.Internal);return t.stack=l.stack,t}function w(l,t,{extensionData:r,duration:n,error:a,durationSinceUpdate:c}){const o=a?a instanceof I.ExtensionManagementError?a.code:I.ExtensionManagementErrorCode.Internal:void 0;l.publicLog(t,{...r,success:!a,duration:n,errorcode:o,durationSinceUpdate:c})}e.reportTelemetry=w;class f{constructor(){this.barrier=new i.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(t=>new Promise((r,n)=>{const a=t.onCancellationRequested(()=>{a.dispose(),n(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=f}),define(re[224],se([0,1,16,6,74,3,12,4,34,8,144,14,29,31,211,92,15,9,66,24,43,21,22]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g,S,w,f,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",n="extensionTips/lastPromptedMediumImpExeTime";let a=class extends v.ExtensionTipsService{constructor(o,s,u,m,C,M,T,F,_,U){super(T,F,_,U);this.environmentService=o,this.telemetryService=s,this.extensionManagementService=u,this.storageService=m,this.nativeHostService=C,this.extensionRecommendationNotificationService=M,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,F.exeBasedExtensionTips&&(0,k.forEach)(F.exeBasedExtensionTips,({key:O,value:$})=>{const V=[],te=[],H=[];(0,k.forEach)($.recommendations,({key:z,value:q})=>{q.important?$.important?V.push({extensionId:z,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):te.push({extensionId:z,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):H.push({extensionId:z,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),V.length&&this.highImportanceExecutableTips.set(O,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:V}),te.length&&this.mediumImportanceExecutableTips.set(O,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:te}),H.length&&this.allOtherExecutableTips.set(O,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H})}),(0,i.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...s]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(s,u)}groupImportantTipsByExe(o,s){const u=new Map;o.forEach(F=>u.set(F.extensionId.toLowerCase(),F));const{installed:m,uninstalled:C}=this.groupByInstalled([...u.keys()],s);for(const F of m){const _=u.get(F);_&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:F,exeName:_.exeName})}for(const F of C){const _=u.get(F);_&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:F,exeName:_.exeName})}const M=this.getPromptedExecutableTips(),T=new Map;for(const F of C){const _=u.get(F);if(_&&(!M[_.exeName]||!M[_.exeName].includes(_.extensionId))){let U=T.get(_.exeName);U||(U=[],T.set(_.exeName,U)),U.push(_)}}return T}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,s]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(s).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(s[0].exeName,s);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const m=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(m(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const m=this._register((0,i.disposableTimeout)(()=>{m.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),s=Date.now()-o,u=7*24*60*60*1e3;if(s<u){const M=this._register((0,i.disposableTimeout)(()=>{M.dispose(),this.promptMediumImportanceExeBasedTip()},u-s));return}const[m,C]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(C).then(M=>{switch(M){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(m),this.addToRecommendedExecutables(C[0].exeName,C);const T=this._register((0,i.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},u));break}case"ignored":this.mediumImportanceTipsByExe.delete(m),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const T=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(T(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const T=this._register((0,i.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(o){const s=await this.extensionManagementService.getInstalled(1),u=o.filter(C=>!C.whenNotInstalled||C.whenNotInstalled.every(M=>s.every(T=>!(0,y.areSameExtensions)(T.identifier,{id:M})))).map(({extensionId:C})=>C.toLowerCase()),m=(0,D.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(u,m,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(n,0);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(n,o,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(o,s){const u=this.getPromptedExecutableTips();u[o]=s.map(({extensionId:m})=>m.toLowerCase()),this.storageService.store(r,JSON.stringify(u),0,0)}groupByInstalled(o,s){const u=[],m=[],C=s.reduce((M,T)=>(M.add(T.identifier.id.toLowerCase()),M),new Set);return o.forEach(M=>{C.has(M.toLowerCase())?u.push(M):m.push(M)}),{installed:u,uninstalled:m}}async getValidExecutableBasedExtensionTips(o){const s=[],u=new Map;for(const m of o.keys()){const C=o.get(m);if(!C||!(0,R.isNonEmptyArray)(C.recommendations))continue;const M=[];P.isWindows?C.windowsPath&&M.push(C.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(M.push((0,A.join)("/usr/local/bin",m)),M.push((0,A.join)("/usr/bin",m)),M.push((0,A.join)(this.environmentService.userHome.fsPath,m)));for(const T of M){let F=u.get(T);if(F===void 0&&(F=await this.fileService.exists(E.URI.file(T)),u.set(T,F)),F)for(const{extensionId:_,extensionName:U,isExtensionPack:O,whenNotInstalled:$}of C.recommendations)s.push({extensionId:_,extensionName:U,isExtensionPack:O,exeName:m,exeFriendlyName:C.exeFriendlyName,windowsPath:C.windowsPath,whenNotInstalled:$})}}return s}};e.ExtensionTipsService=a,e.ExtensionTipsService=a=fe([K(0,I.INativeEnvironmentService),K(1,t.ITelemetryService),K(2,h.IExtensionManagementService),K(3,l.IStorageService),K(4,S.INativeHostService),K(5,p.IExtensionRecommendationNotificationService),K(6,d.IFileService),K(7,w.IProductService),K(8,f.IRequestService),K(9,g.ILogService)],a)}),define(re[103],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(L){this.appenders=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,{eventName:P,data:b}){return this.appenders.forEach(E=>E.log(P,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class i{constructor(L){this.channel=L}log(L,A){return this.channel.call("log",{eventName:L,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(re[48],se([0,1,28,78,13,17,22]),function(J,e,R,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,i.staticObservableValue)(0)}publicLog(f,l){return Promise.resolve(void 0)}publicLog2(f,l){return this.publicLog(f,l)}publicLogError(f,l){return Promise.resolve(void 0)}publicLogError2(f,l){return this.publicLogError(f,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class b{async publicLog(f,l,t){}async publicLogError(f,l,t){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(w,f){return f.onDidChangeConfiguration(l=>{l.source!==6&&w.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(l.source),configurationKeys:d(l.sourceConfig)})})}e.configurationTelemetry=E;function D(w,f){return!(f.disableTelemetry||!w.enableTelemetry||f.extensionTestsLocationURI)}e.supportsTelemetry=D;function I(w){const f=w.getValue(A.TELEMETRY_SETTING_ID),l=w.getValue("telemetry.enableCrashReporter");if(w.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function h(w){const f=Object.create(null),l=Object.create(null),t=Object.create(null);p(w,t);for(let r in t){r=r.length>150?r.substr(r.length-149):r;const n=t[r];typeof n=="number"?l[r]=n:typeof n=="boolean"?l[r]=n?1:0:typeof n=="string"?(n.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${n.length}`),f[r]=n.substring(0,8191)):typeof n!="undefined"&&n!==null&&(f[r]=n)}return{properties:f,measurements:l}}e.validateTelemetryData=h;const y=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function v(w){if(!w)return"none";for(const f of y)if(w.startsWith(`${f}+`))return f;return"other"}e.cleanRemoteAuthority=v;function p(w,f,l=0,t){if(!!w)for(let r of Object.getOwnPropertyNames(w)){const n=w[r],a=t?t+r:r;Array.isArray(n)?f[a]=(0,R.safeStringify)(n):n instanceof Date?f[a]=n.toISOString():(0,k.isObject)(n)?l<2?p(n,f,l+1,a+"."):f[a]=(0,R.safeStringify)(n):f[a]=n}}function d(w){if(!w)return[];const f=[];return g(f,"",w),f}function g(w,f,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(t=>g(w,f?`${f}.${t}`:t,l[t])):w.push(f)}function S(w){return[w.appRoot,w.extensionsPath,w.userHome.fsPath,w.tmpDir.fsPath,w.userDataPath]}e.getPiiPathsFromEnvironment=S}),define(re[225],se([0,1,47,48]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(L,A,P,b,E,D){const I={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${A.nameShort})`},h=await(0,R.getServiceMachineId)(P,E,D);return(0,i.supportsTelemetry)(A,P)&&(0,i.getTelemetryLevel)(b)===3&&(I["X-Market-User-Id"]=h),I}e.resolveMarketplaceHeaders=k}),define(re[226],se([0,1,16,23,7,28,4,34,13,8,17,14,29,31,63,15,9,24,43,225,21,22,93]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g,S,w,f,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const r=A.isWeb?"web":(0,h.getTargetPlatform)(A.platform,P.arch);var n;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished",B[B.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function a(...B){return String(B.reduce((N,x)=>N|x,0))}var c;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(c||(c={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},m={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class C{constructor(N=m){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,x=this.state.pageSize){return new C({...this.state,pageNumber:N,pageSize:x})}withFilter(N,...x){const Y=[...this.state.criteria,...x.length?x.map(ne=>({filterType:N,value:ne})):[{filterType:N}]];return new C({...this.state,criteria:Y})}withSortBy(N){return new C({...this.state,sortBy:N})}withSortOrder(N){return new C({...this.state,sortOrder:N})}withFlags(...N){return new C({...this.state,flags:N.reduce((x,Y)=>x|Y,0)})}withAssetTypes(...N){return new C({...this.state,assetTypes:N})}withSource(N){return new C({...this.state,source:N})}get raw(){const{criteria:N,pageNumber:x,pageSize:Y,sortBy:ne,sortOrder:oe,flags:de,assetTypes:me}=this.state;return{filters:[{criteria:N,pageNumber:x,pageSize:Y,sortBy:ne,sortOrder:oe}],assetTypes:me,flags:de}}get searchText(){const N=this.state.criteria.filter(x=>x.filterType===c.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function M(B,N){const x=(B||[]).filter(Y=>Y.statisticName===N)[0];return x?x.value:0}function T(B){const N="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(Y=>Y.assetType.indexOf(N)===0).reduce((Y,ne)=>{const oe=U(B,ne.assetType);return oe&&Y.push([ne.assetType.substring(N.length),oe]),Y},[])}function F(B){if(B.properties){const N=B.properties.filter(ne=>ne.key===o.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Y=N.filter(ne=>x.test(ne.value))[0];return Y?{uri:Y.value,fallbackUri:Y.value}:null}return U(B,o.Repository)}function _(B){return{uri:`${B.fallbackAssetUri}/${o.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${o.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function U(B,N){return B.files.filter(Y=>Y.assetType===N)[0]?{uri:`${B.assetUri}/${N}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${N}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}:null}function O(B,N){const x=B.properties?B.properties.filter(ne=>ne.key===N):[],Y=x.length>0&&x[0].value;return Y?Y.split(",").map(ne=>(0,y.adoptToGalleryExtensionId)(ne)):[]}function $(B){const N=B.properties?B.properties.filter(x=>x.key===s.Engine):[];return N.length>0&&N[0].value||""}function V(B){const N=B.properties?B.properties.filter(x=>x.key===s.PreRelease):[];return N.length>0&&N[0].value==="true"}function te(B){const N=B.properties?B.properties.filter(Y=>Y.key===s.LocalizedLanguages):[],x=N.length>0&&N[0].value||"";return x?x.split(","):[]}function H(B){return B.properties?.find(N=>N.key===s.SponsorLink)?.value}function z(B){return B.indexOf("preview")!==-1}function q(B){return B.targetPlatform?(0,h.toTargetPlatform)(B.targetPlatform):"undefined"}function j(B){const N=(0,R.distinct)(B.versions.map(q)),x=!!B.tags?.includes(h.WEB_EXTENSION_TAG),Y=N.indexOf("web");return x?Y===-1&&N.push("web"):Y!==-1&&N.splice(Y,1),N}function Q(B,N){const x=(0,h.getFallbackTargetPlarforms)(N);for(let Y=0;Y<B.length;Y++){const ne=B[Y];if(ne.version===B[Y-1]?.version){let oe=Y;const de=q(ne);if(de===N)for(;oe>0&&B[oe-1].version===ne.version;)oe--;else if(x.includes(de))for(;oe>0&&B[oe-1].version===ne.version&&q(B[oe-1])!==N;)oe--;oe!==Y&&(B.splice(Y,1),B.splice(oe,0,ne))}}return B}e.sortExtensionVersions=Q;function G(B,N,x){B.telemetryData={index:N,querySource:x}}function X(B,N,x){const Y=B.versions[0],ne={manifest:U(N,o.Manifest),readme:U(N,o.Details),changelog:U(N,o.Changelog),license:U(N,o.License),repository:F(N),download:_(N),icon:U(N,o.Icon),coreTranslations:T(N)};return{identifier:{id:(0,y.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:N.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,publisherDomain:B.publisher.domain?{link:B.publisher.domain,verified:!!B.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(Y),description:B.shortDescription||"",installCount:M(B.statistics,"install"),rating:M(B.statistics,"averagerating"),ratingCount:M(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:x,assets:ne,properties:{dependencies:O(N,s.Dependency),extensionPack:O(N,s.ExtensionPack),engine:$(N),localizedLanguages:te(N),targetPlatform:q(N),isPreReleaseVersion:V(N)},hasPreReleaseVersion:V(Y),hasReleaseVersion:!0,preview:z(B.flags)}}let Z=class{constructor(N,x,Y,ne,oe,de,me,Ee,Se){this.requestService=x,this.logService=Y,this.environmentService=ne,this.telemetryService=oe,this.fileService=de,this.productService=me,this.configurationService=Ee,this.extensionsGalleryConfigService=Se;const ve=me.extensionsGallery;Se&&Se.serviceUrl?this.extensionsGalleryUrl=Se.serviceUrl:this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsGalleryConfigService.onConfigChange(this.onUpdateConfigChange,this),this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=(0,w.resolveMarketplaceHeaders)(me.version,me,this.environmentService,this.configurationService,this.fileService,N)}onUpdateConfigChange(N){if(this.logService.info("wpl onUpdateConfigChange serverURL:"+N),N)this.extensionsGalleryUrl=N;else{const x=this.productService.extensionsGallery;this.extensionsGalleryUrl=x&&x.serviceUrl}}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,x,Y){const ne=i.CancellationToken.isCancellationToken(x)?{}:x,oe=i.CancellationToken.isCancellationToken(x)?x:Y,de=[],me=[],Ee=[],Se=[];let ve=!0;for(const Ae of N){Ae.uuid?me.push(Ae.uuid):de.push(Ae.id);const Oe=!!(Ae.version||Ae.preRelease);Ee.push({id:Ae.id,uuid:Ae.uuid,includePreRelease:Oe}),Ae.version&&Se.push({id:Ae.id,uuid:Ae.uuid,version:Ae.version}),ve=ve&&!!Ae.hasPreRelease&&!Oe}if(!me.length&&!de.length)return[];let we=new C().withPage(1,N.length);me.length&&(we=we.withFilter(c.ExtensionId,...me)),de.length&&(we=we.withFilter(c.ExtensionName,...de)),(ne.queryAllVersions||ve)&&(we=we.withFlags(we.flags,n.IncludeVersions)),ne.source&&(we=we.withSource(ne.source));const{extensions:De}=await this.queryGalleryExtensions(we,{targetPlatform:ne.targetPlatform??r,includePreRelease:Ee,versions:Se,compatible:!!ne.compatible},oe);return ne.source&&De.forEach((Ae,Oe)=>G(Ae,Oe,ne.source)),De}async getCompatibleExtension(N,x,Y){if((0,h.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,Y))return null;if(await this.isExtensionCompatible(N,x,Y))return N;const ne=new C().withFlags(n.IncludeVersions).withPage(1,1).withFilter(c.ExtensionId,N.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(ne,{targetPlatform:Y,compatible:!0,includePreRelease:x},i.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(N,x,Y){if(!(0,h.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,Y)||!x&&N.properties.isPreReleaseVersion)return!1;let ne=N.properties.engine;if(!ne){const oe=await this.getManifest(N,i.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");ne=oe.engines.vscode}return(0,v.isEngineValid)(ne,this.productService.version,this.productService.date)}async isValidVersion(N,x,Y,ne,oe){if(!(0,h.isTargetPlatformCompatible)(q(N),ne,oe)||x!=="any"&&V(N)!==(x==="prerelease"))return!1;if(Y)try{const de=await this.getEngine(N);if(!(0,v.isEngineValid)(de,this.productService.version,this.productService.date))return!1}catch(de){return this.logService.error(`Error while getting the engine for the version ${N.version}.`,(0,k.getErrorMessage)(de)),!1}return!0}async query(N,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Y=N.text||"";const ne=(0,L.getOrDefault)(N,ve=>ve.pageSize,50);let oe=new C().withPage(1,ne);Y?(Y=Y.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,we,De)=>(oe=oe.withFilter(c.Category,De||we),"")),Y=Y.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,we,De)=>(oe=oe.withFilter(c.Tag,De||we),"")),Y=Y.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(c.Featured),"")),Y=Y.trim(),Y&&(Y=Y.length<200?Y:Y.substring(0,200),oe=oe.withFilter(c.SearchText,Y)),oe=oe.withSortBy(0)):N.ids?oe=oe.withFilter(c.ExtensionId,...N.ids):N.names?oe=oe.withFilter(c.ExtensionName,...N.names):oe=oe.withSortBy(4),typeof N.sortBy=="number"&&(oe=oe.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(oe=oe.withSortOrder(N.sortOrder)),N.source&&(oe=oe.withSource(N.source));const de=async(ve,we)=>{const{extensions:De,total:Ae}=await this.queryGalleryExtensions(ve,{targetPlatform:r,compatible:!1,includePreRelease:!!N.includePreRelease},we);return De.forEach((Oe,We)=>G(Oe,(ve.pageNumber-1)*ve.pageSize+We,N.source)),{extensions:De,total:Ae}},{extensions:me,total:Ee}=await de(oe,x),Se=async(ve,we)=>{if(we.isCancellationRequested)throw new k.CancellationError;const{extensions:De}=await de(oe.withPage(ve+1),we);return De};return{firstPage:me,total:Ee,pageSize:oe.pageSize,getPage:Se}}async queryGalleryExtensions(N,x,Y){const ne=N.flags;!!(N.flags&n.IncludeLatestVersionOnly)&&!!(N.flags&n.IncludeVersions)&&(N=N.withFlags(N.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(N.flags&n.IncludeLatestVersionOnly)&&!(N.flags&n.IncludeVersions)&&(N=N.withFlags(N.flags,n.IncludeLatestVersionOnly)),x.versions?.length&&(N=N.withFlags(N.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),N=N.withFlags(N.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:oe,total:de}=await this.queryRawGalleryExtensions(N,Y);if(!(N.flags&n.IncludeLatestVersionOnly)){const ve=[];for(const we of oe){const De=await this.toGalleryExtensionWithCriteria(we,x);De&&ve.push(De)}return{extensions:ve,total:de}}const Ee=[],Se=new Map;for(let ve=0;ve<oe.length;ve++){const we=oe[ve],De={id:(0,y.getGalleryExtensionId)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ae=(0,b.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(We=>(0,y.areSameExtensions)(We,De))?.includePreRelease;if(x.compatible&&(0,h.isNotWebExtensionInWebTargetPlatform)(j(we),x.targetPlatform))continue;const Oe=await this.toGalleryExtensionWithCriteria(we,x);!Oe||Oe.properties.isPreReleaseVersion&&(!Ae||!Oe.hasReleaseVersion)||!Oe.properties.isPreReleaseVersion&&Oe.properties.targetPlatform!==x.targetPlatform&&Oe.hasPreReleaseVersion?Se.set(we.extensionId,ve):Ee.push([ve,Oe])}if(Se.size){const ve=new Date().getTime(),we=new C().withFlags(ne&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,Se.size).withFilter(c.ExtensionId,...Se.keys()),{extensions:De}=await this.queryGalleryExtensions(we,x,Y);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ve,count:Se.size});for(const Ae of De){const Oe=Se.get(Ae.identifier.uuid);Ee.push([Oe,Ae])}}return{extensions:Ee.sort((ve,we)=>ve[0]-we[0]).map(([,ve])=>ve),total:de}}async toGalleryExtensionWithCriteria(N,x){const Y={id:(0,y.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},ne=x.versions?.find(Ee=>(0,y.areSameExtensions)(Ee,Y))?.version,oe=(0,b.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(Ee=>(0,y.areSameExtensions)(Ee,Y))?.includePreRelease,de=j(N),me=Q(N.versions,x.targetPlatform);if(x.compatible&&(0,h.isNotWebExtensionInWebTargetPlatform)(de,x.targetPlatform))return null;for(let Ee=0;Ee<me.length;Ee++){const Se=me[Ee];if(!(ne&&Se.version!==ne)){if(await this.isValidVersion(Se,oe?"any":"release",x.compatible,de,x.targetPlatform))return X(N,Se,de);if(ne&&Se.version===ne)return null}}return ne||x.compatible?null:X(N,N.versions[0],de)}async queryRawGalleryExtensions(N,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,n.ExcludeNonValidated).withFilter(c.Target,"Microsoft.VisualStudio.Code").withFilter(c.ExcludeWithFlags,a(n.Unpublished));const Y=await this.commonHeadersPromise,ne=JSON.stringify(N.raw),oe={...Y,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ne.length)},de=new Date().getTime();let me,Ee,Se=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ne,headers:oe},x),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:Se};const ve=await(0,S.asJson)(me);if(ve){const we=ve.results[0],De=we.extensions,Ae=we.resultMetadata&&we.resultMetadata.filter(Oe=>Oe.metadataType==="ResultCount")[0];return Se=Ae&&Ae.metadataItems.filter(Oe=>Oe.name==="TotalCount")[0].count||0,{galleryExtensions:De,total:Se}}return{galleryExtensions:[],total:Se}}catch(ve){throw Ee=ve,ve}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(ne.length),duration:new Date().getTime()-de,success:!!me&&(0,S.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:Ee?(0,k.isCancellationError)(Ee)?"canceled":(0,k.getErrorMessage)(Ee).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic(N,x,Y,ne){if(!this.isEnabled())return;const oe=A.isWeb?this.api(`/itemName/${N}.${x}/version/${Y}/statType/${ne==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${x}/${Y}/stats?statType=${ne}`),de=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:oe,headers:Ee},i.CancellationToken.None)}catch{}}async download(N,x,Y){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const ne=(0,y.getGalleryExtensionTelemetryData)(N),oe=new Date().getTime(),de=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ne,duration:ve}),me=Y===2?"install":Y===3?"update":"",Ee=me?{uri:`${N.assets.download.uri}${E.URI.parse(N.assets.download.uri).query?"&":"?"}${me}=true`,fallbackUri:`${N.assets.download.fallbackUri}${E.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${me}=true`}:N.assets.download,Se=await this.getAsset(Ee);await this.fileService.writeFile(x,Se.stream),de(new Date().getTime()-oe)}async getReadme(N,x){if(N.assets.readme){const Y=await this.getAsset(N.assets.readme,{},x);return await(0,S.asTextOrError)(Y)||""}return""}async getManifest(N,x){if(N.assets.manifest){const Y=await this.getAsset(N.assets.manifest,{},x),ne=await(0,S.asTextOrError)(Y);return ne?JSON.parse(ne):null}return null}async getManifestFromRawExtensionVersion(N,x){const Y=U(N,o.Manifest);if(!Y)throw new Error("Manifest was not found");const ne={"Accept-Encoding":"gzip"},oe=await this.getAsset(Y,{headers:ne});return await(0,S.asJson)(oe)}async getCoreTranslation(N,x){const Y=N.assets.coreTranslations.filter(ne=>ne[0]===x.toUpperCase())[0];if(Y){const ne=await this.getAsset(Y[1]),oe=await(0,S.asTextOrError)(ne);return oe?JSON.parse(oe):null}return null}async getChangelog(N,x){if(N.assets.changelog){const Y=await this.getAsset(N.assets.changelog,{},x);return await(0,S.asTextOrError)(Y)||""}return""}async getAllCompatibleVersions(N,x,Y){let ne=new C().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?ne=ne.withFilter(c.ExtensionId,N.identifier.uuid):ne=ne.withFilter(c.ExtensionName,N.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(ne,i.CancellationToken.None);if(!oe.length)return[];const de=j(oe[0]);if((0,h.isNotWebExtensionInWebTargetPlatform)(de,Y))return[];const me=[];await Promise.all(oe[0].versions.map(async ve=>{try{await this.isValidVersion(ve,x?"any":"release",!0,de,Y)&&me.push(ve)}catch{}}));const Ee=[],Se=new Set;for(const ve of Q(me,Y))Se.has(ve.version)||(Se.add(ve.version),Ee.push({version:ve.version,date:ve.lastUpdated,isPreReleaseVersion:V(ve)}));return Ee}async getAsset(N,x={},Y=i.CancellationToken.None){const ne=await this.commonHeadersPromise,oe={type:"GET"},de={...ne,...x.headers||{}};x={...x,...oe,headers:de};const me=N.uri,Ee=N.fallbackUri,Se={...x,url:me};try{const ve=await this.requestService.request(Se,Y);if(ve.res.statusCode===200)return ve;const we=await(0,S.asTextOrError)(ve);throw new Error(`Expected 200, got back ${ve.res.statusCode} instead.

${we}`)}catch(ve){if((0,k.isCancellationError)(ve))throw ve;const we=(0,k.getErrorMessage)(ve);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:me,message:we});const De={...x,url:Ee};return this.requestService.request(De,Y)}}async getEngine(N){let x=$(N);if(!x){const Y=await this.getManifestFromRawExtensionVersion(N,i.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");x=Y.engines.vscode}return x}async getExtensionsControlManifest1(N){const x=[],Y={},ne=[];if(N){for(const oe of N.malicious)x.push({id:oe});if(N.migrateToPreRelease)for(const[oe,de]of Object.entries(N.migrateToPreRelease))(!de.engine||(0,v.isEngineValid)(de.engine,this.productService.version,this.productService.date))&&(Y[oe.toLowerCase()]={disallowInstall:!0,extension:{id:de.id,displayName:de.displayName,autoMigrate:{storage:!!de.migrateStorage},preRelease:!0}});if(N.deprecated)for(const[oe,de]of Object.entries(N.deprecated))de&&(Y[oe.toLowerCase()]=(0,b.isBoolean)(de)?{}:de);if(N.search)for(const oe of N.search)ne.push(oe)}return{malicious:x,deprecated:Y,search:ne}}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl){let Y=this.productService.extensionsControlManifest;return this.getExtensionsControlManifest1(Y)}const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,S.asJson)(N);return this.getExtensionsControlManifest1(x)}};Z=fe([K(1,S.IRequestService),K(2,d.ILogService),K(3,I.IEnvironmentService),K(4,l.ITelemetryService),K(5,p.IFileService),K(6,g.IProductService),K(7,D.IConfigurationService),K(8,t.IExtensionsGalleryConfigService)],Z);let W=class extends Z{constructor(N,x,Y,ne,oe,de,me,Ee,Se){super(N,x,Y,ne,oe,de,me,Ee,Se)}};e.ExtensionGalleryService=W,e.ExtensionGalleryService=W=fe([K(0,f.IStorageService),K(1,S.IRequestService),K(2,d.ILogService),K(3,I.IEnvironmentService),K(4,l.ITelemetryService),K(5,p.IFileService),K(6,g.IProductService),K(7,D.IConfigurationService),K(8,t.IExtensionsGalleryConfigService)],W);let ee=class extends Z{constructor(N,x,Y,ne,oe,de,me,Ee){super(void 0,N,x,Y,ne,oe,de,me,Ee)}};e.ExtensionGalleryServiceWithNoStorageService=ee,e.ExtensionGalleryServiceWithNoStorageService=ee=fe([K(0,S.IRequestService),K(1,d.ILogService),K(2,I.IEnvironmentService),K(3,l.ITelemetryService),K(4,p.IFileService),K(5,g.IProductService),K(6,D.IConfigurationService),K(7,t.IExtensionsGalleryConfigService)],ee)}),define(re[104],se([0,1,2,14,9,48]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends R.Disposable{constructor(b,E,D=""){super();this.prefix=D;const I=b.getLogger(E.telemetryLogResource);I?this.logger=this._register(I):(this.logger=this._register(b.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,E){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,L.validateTelemetryData)(E))}};e.TelemetryLogAppender=A,e.TelemetryLogAppender=A=fe([K(0,k.ILoggerService),K(1,i.IEnvironmentService)],A)}),define(re[105],se([0,1,2,28,78,4,26,156,17,42,98,24,38,22,48]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(S,w,f){this._configurationService=w,this._productService=f,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties||Promise.resolve({}),this._piiPaths=S.piiPaths||[],this._sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(S,w){this._experimentProperties[S]=w}_updateTelemetryLevel(){let S=(0,v.getTelemetryLevel)(this._configurationService);const w=this._productService.enabledTelemetryLevels;if(w){this._sendErrorTelemetry=this.sendErrorTelemetry?w.error:!1;const f=w.usage?3:w.error?2:0;S=Math.min(S,f)}this.telemetryLevel.value=S}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const S=await this._commonProperties;let w=S.sessionID,f=S["common.machineId"],l=S["common.firstSessionDate"],t=S["common.msftInternal"];return{sessionId:w,machineId:f,firstSessionDate:l,msftInternal:t}}dispose(){this._disposables.dispose()}_log(S,w,f,l){return this.telemetryLevel.value<w?Promise.resolve(void 0):this._commonProperties.then(t=>{f=(0,i.mixin)(f,t),f=(0,i.mixin)(f,this._experimentProperties),f=(0,i.cloneAndChange)(f,r=>{if(typeof r=="string")return this._cleanupInfo(r,l)}),this._appenders.forEach(r=>r.log(S,f))},t=>{console.error(t)})}publicLog(S,w,f){return this._log(S,3,w,f)}publicLog2(S,w,f){return this.publicLog(S,w,f)}publicLogError(S,w){return this._sendErrorTelemetry?this._log(S,2,w,!0):Promise.resolve(void 0)}publicLogError2(S,w){return this.publicLogError(S,w)}_anonymizeFilePaths(S){let w=S;const f=[];for(let n of this._cleanupPatterns)for(;;){const a=n.exec(S);if(!a)break;f.push([a.index,n.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,t=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(w="";;){const n=t.exec(S);if(!n)break;!l.test(n[0])&&f.every(([a,c])=>n.index<a||n.index>=c)&&(w+=S.substring(r,n.index)+"<REDACTED: user-file-path>",r=t.lastIndex)}return r<S.length&&(w+=S.substr(r)),w}_removePropertiesWithPossibleUserInfo(S){if(!S)return S;const w=S.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const l of f)if(l.regex.test(w))return`<REDACTED: ${l.label}>`;return S}_cleanupInfo(S,w){let f=S;w&&(f=this._anonymizeFilePaths(f));for(let l of this._cleanupPatterns)f=f.replace(l,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};e.TelemetryService=p,p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=p=fe([K(1,b.IConfigurationService),K(2,I.IProductService)],p);function d(){const g=(0,P.localize)(0,null,D.default.nameLong),S=D.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",D.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=L.isWeb?"":(0,P.localize)(3,null),f=(0,P.localize)(4,null),l=(0,P.localize)(5,null),t=(0,P.localize)(6,null),r=(0,P.localize)(7,null),n=`
|       | ${f} | ${l} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,P.localize)(8,null);return`
${g} ${S} ${w}

&nbsp;

${r}
${n}

&nbsp;

${a}
`}h.Registry.as(E.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:d(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),h.Registry.as(E.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:D.default.privacyStatementUrl?(0,P.localize)(16,null,D.default.nameLong,D.default.privacyStatementUrl):(0,P.localize)(15,null,D.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[227],se([0,1,7,28,48]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(P){const b=await new Promise((D,I)=>{J(["applicationinsights"],D,I)});let E;return b.defaultClient?(E=new b.TelemetryClient(P),E.channel.setUseDiskRetryCaching(!0)):(b.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),E=b.defaultClient),P.indexOf("AIF-")===0&&(E.config.endpointUrl="https://0.0.0.0/collect/v1"),E}class A{constructor(b,E,D){this._eventPrefix=b,this._defaultData=E,this._defaultData||(this._defaultData=Object.create(null)),typeof D=="function"?this._aiClient=D():this._aiClient=D,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(E=>{b(E)},E=>{(0,R.onUnexpectedError)(E),console.error(E)})}}log(b,E){if(!!this._aiClient){E=(0,i.mixin)(E,this._defaultData),E=(0,k.validateTelemetryData)(E);try{this._withAIClient(D=>D.trackEvent({name:this._eventPrefix+"/"+b,properties:E.properties,measurements:E.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(E=>{try{E.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(re[228],se([0,1,19,62,17,14,9,24,22,103,104,105]),function(J,e,R,i,k,L,A,P,b,E,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let h=class{constructor(v,p,d,g,S){this.configurationService=v,this.telemetryService=p,this.loggerService=d,this.environmentService=g,this.productService=S,this.customTelemetryServices=new Map}async getCustomTelemetryService(v){if(!this.customTelemetryServices.has(v.id)){const{machineId:p,sessionId:d}=await this.telemetryService.getTelemetryInfo(),g=Object.create(null);g["common.vscodemachineid"]=p,g["common.vscodesessionid"]=d;const S=[v.id,JSON.stringify(g),v.aiKey],f=new i.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:S,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new E.TelemetryAppenderClient(f),new D.TelemetryLogAppender(this.loggerService,this.environmentService,`[${v.id}] `)];this.customTelemetryServices.set(v.id,new I.TelemetryService({appenders:l,sendErrorTelemetry:v.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(v.id)}async publicLog(v,p,d){await(await this.getCustomTelemetryService(v)).publicLog(p,d)}async publicLogError(v,p,d){await(await this.getCustomTelemetryService(v)).publicLogError(p,d)}};e.CustomEndpointTelemetryService=h,e.CustomEndpointTelemetryService=h=fe([K(0,k.IConfigurationService),K(1,b.ITelemetryService),K(2,A.ILoggerService),K(3,L.IEnvironmentService),K(4,P.IProductService)],h)}),define(re[229],se([0,1,6,23,3,2,9]),function(J,e,R,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends L.Disposable{constructor(E,D){super();this._logService=D,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new k.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((D,I)=>{const h=++this._lastRequestId;this._pendingRequests.set(h,D),this._onCreateRequest.fire({requestId:h,...E});const y=new i.CancellationTokenSource;(0,R.timeout)(this._timeout,y.token).then(()=>I(`Request ${h} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(h,[(0,L.toDisposable)(()=>y.cancel())])})}acceptReply(E,D){const I=this._pendingRequests.get(E);I?(this._pendingRequests.delete(E),(0,L.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),I(D)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};e.RequestStore=P,e.RequestStore=P=fe([K(1,A.ILogService)],P)}),define(re[106],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(i||(e.TerminalSettingPrefix=i={}));var k;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",d.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",d.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",d.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",d.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",d.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",d.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(k||(e.TerminalSettingId=k={}));var L;(function(d){d.PowerShell="pwsh",d.Bash="bash",d.Fish="fish",d.Sh="sh",d.Csh="csh",d.Ksh="ksh",d.Zsh="zsh"})(L||(e.PosixShellType=L={}));var A;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(A||(e.WindowsShellType=A={}));var P;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(P||(e.TitleEventSource=P={}));var b;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(b||(e.TerminalIpcChannels=b={})),e.IPtyService=(0,R.createDecorator)("ptyService");var E;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions",d.FailedShellIntegrationActivation="failedShellIntegrationActivation"})(E||(e.ProcessPropertyType=E={}));var D;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(D||(e.HeartbeatConstants=D={}));var I;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(I||(e.TerminalLocation=I={}));var h;(function(d){d.TerminalView="view",d.Editor="editor"})(h||(e.TerminalLocationString=h={}));var y;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var v;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(v||(e.FlowControlConstants=v={}));var p;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(p||(e.ProfileSource=p={}))}),define(re[230],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(re[231],se([0,1,35,19,28,12,4,34,26,13,27]),function(J,e,R,i,k,L,A,P,b,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function I(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let l=0;return f&&f.length===4&&(l=parseInt(f[3])),l}e.getWindowsBuildNumber=I;async function h(f,l,t,r=P.env,n=D.Promises.exists){if(L.isAbsolute(f))return await n(f)?f:void 0;if(l===void 0&&(l=P.cwd()),L.dirname(f)!=="."){const s=L.join(l,f);return await n(s)?s:void 0}const c=(0,k.getCaseInsensitive)(r,"PATH");if(t===void 0&&(0,E.isString)(c)&&(t=c.split(L.delimiter)),t===void 0||t.length===0){const s=L.join(l,f);return await n(s)?s:void 0}for(let s of t){let u;if(L.isAbsolute(s)?u=L.join(s,f):u=L.join(l,s,f),await n(u))return u;if(A.isWindows){let m=u+".com";if(await n(m)||(m=u+".exe",await n(m)))return m}}const o=L.join(l,f);return await n(o)?o:void 0}e.findExecutable=h;function y(f,l,t){if(!l.enabled||!f.executable||f.isFeatureTerminal||f.hideFromUser)return;const r=f.args,n=P.platform==="win32"?L.basename(f.executable).toLowerCase():L.basename(f.executable),a=L.dirname(i.FileAccess.asFileUri("",J).fsPath);let c;if(A.isWindows){if(n==="pwsh.exe")return!r||S(r)?c=e.shellIntegrationArgs.get(v.WindowsPwsh):g(r)&&(c=e.shellIntegrationArgs.get(v.WindowsPwshLogin)),c?(c&&(c=[...c],c[c.length-1]=(0,b.format)(c[c.length-1],a,"")),{newArgs:c}):void 0;t.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}const o={};switch(n){case"bash":return!r||r.length===0?c=e.shellIntegrationArgs.get(v.Bash):w(r)&&(o.VSCODE_SHELL_LOGIN="1",c=e.shellIntegrationArgs.get(v.Bash)),c?(c=[...c],c[c.length-1]=(0,b.format)(c[c.length-1],a),{newArgs:c,envMixin:o}):void 0;case"pwsh":return!r||S(r)?c=e.shellIntegrationArgs.get(v.Pwsh):g(r)&&(c=e.shellIntegrationArgs.get(v.PwshLogin)),c?(c=[...c],c[c.length-1]=(0,b.format)(c[c.length-1],a,""),{newArgs:c}):void 0;case"zsh":{if(!r||r.length===0?c=e.shellIntegrationArgs.get(v.Zsh):w(r)?c=e.shellIntegrationArgs.get(v.ZshLogin):(r===e.shellIntegrationArgs.get(v.Zsh)||r===e.shellIntegrationArgs.get(v.ZshLogin))&&(c=r),!c)return;c=[...c],c[c.length-1]=(0,b.format)(c[c.length-1],a);const s=L.join(R.tmpdir(),"vscode-zsh");o.ZDOTDIR=s;const u=[];return u.push({source:L.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.join(s,".zshrc")}),u.push({source:L.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.join(s,".zprofile")}),u.push({source:L.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.join(s,".zshenv")}),u.push({source:L.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.join(s,".zlogin")}),{newArgs:c,envMixin:o,filesToCopy:u}}}t.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}e.getShellIntegrationInjection=y;var v;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(v||(e.ShellIntegrationExecutable=v={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(v.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(v.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(v.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(v.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(v.Zsh,["-i"]),e.shellIntegrationArgs.set(v.ZshLogin,["-il"]),e.shellIntegrationArgs.set(v.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const p=["-login","-l"],d=["-nol","-nologo"];function g(f){return typeof f=="string"?p.includes(f.toLowerCase()):f.length===1&&p.includes(f[0].toLowerCase())||f.length===2&&(p.includes(f[0].toLowerCase())||p.includes(f[1].toLowerCase()))&&(d.includes(f[0].toLowerCase())||d.includes(f[1].toLowerCase()))}function S(f){return typeof f=="string"?d.includes(f.toLowerCase()):f.length===0||f?.length===1&&d.includes(f[0].toLowerCase())}function w(f){return f==="string"&&p.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&p.includes(f[0].toLowerCase())}}),define(re[232],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var R;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(R||(e.ColorScheme=R={}));function i(L){return L===R.HIGH_CONTRAST_DARK||L===R.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function k(L){return L===R.DARK||L===R.HIGH_CONTRAST_DARK}e.isDark=k}),define(re[107],se([0,1,49,3,2,5,38,232]),function(J,e,R,i,k,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var b;(function(d){function g(S){return S&&typeof S=="object"&&typeof S.id=="string"}d.isThemeColor=g})(b||(e.ThemeColor=b={}));function E(d){return{id:d}}e.themeColorFromId=E;var D;(function(d){function g(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||b.isThemeColor(a.color))}d.isThemeIcon=g;const S=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function w(a){const c=S.exec(a);if(!c)return;let[,o]=c;return{id:o}}d.fromString=w;function f(a){return{id:a}}d.fromId=f;function l(a,c){let o=a.id;const s=o.lastIndexOf("~");return s!==-1&&(o=o.substring(0,s)),c&&(o=`${o}~${c}`),{id:o}}d.modify=l;function t(a){const c=a.id.lastIndexOf("~");if(c!==-1)return a.id.substring(c+1)}d.getModifier=t;function r(a,c){return a.id===c.id&&a.color?.id===c.color?.id}d.isEqual=r;function n(a,c){return{id:a.id,color:c?E(c):void 0}}d.asThemeIcon=n,d.asClassNameArray=R.CSSIcon.asClassNameArray,d.asClassName=R.CSSIcon.asClassName,d.asCSSSelector=R.CSSIcon.asCSSSelector})(D||(e.ThemeIcon=D={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function I(d){switch(d){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,k.toDisposable)(()=>{const S=this.themingParticipants.indexOf(g);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new h;A.Registry.add(e.Extensions.ThemingContribution,y);function v(d){return y.onColorThemeChange(d)}e.registerThemingParticipant=v;class p extends k.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,S){let w=this.theme.getColor(g);return w&&S&&(w=S(w,this.theme)),w?w.toString():null}}e.Themable=p}),define(re[233],se([0,1,49,8,158,107]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(h,y){const v=[{name:null,description:(0,k.localize)(0,null)}];return v.push(...h.map(p=>({name:p.profileName,description:P(p)}))),y&&v.push(...y.map(p=>({name:p.title,description:b(p)}))),{values:v.map(p=>p.name),markdownDescriptions:v.map(p=>p.description)}}e.createProfileSchemaEnums=A;function P(h){let y=`$(${L.ThemeIcon.isThemeIcon(h.icon)?h.icon.id:h.icon?h.icon:R.Codicon.terminal.id}) ${h.profileName}
- path: ${h.path}`;return h.args&&(typeof h.args=="string"?y+=`
- args: "${h.args}"`:y+=`
- args: [${h.args.length===0?"":`'${h.args.join("','")}'`}]`),h.overrideName!==void 0&&(y+=`
- overrideName: ${h.overrideName}`),h.color&&(y+=`
- color: ${h.color}`),h.env&&(y+=`
- env: ${JSON.stringify(h.env)}`),y}function b(h){return`$(${L.ThemeIcon.isThemeIcon(h.icon)?h.icon.id:h.icon?h.icon:R.Codicon.terminal.id}) ${h.title}
- extensionIdentifier: ${h.extensionIdentifier}`}function E(h,y){if(!h&&!y)return!0;if(typeof h=="string"&&typeof y=="string")return h===y;if(Array.isArray(h)&&Array.isArray(y)){if(h.length!==y.length)return!1;for(let v=0;v<h.length;v++)if(h[v]!==y[v])return!1;return!0}return!1}e.terminalProfileArgsMatch=E;function D(h,y){if(!h&&!y)return!0;if(!h||!y)return!1;if(L.ThemeIcon.isThemeIcon(h)&&L.ThemeIcon.isThemeIcon(y))return h.id===y.id&&h.color===y.color;if(typeof h=="object"&&h&&"light"in h&&"dark"in h&&typeof y=="object"&&y&&"light"in y&&"dark"in y){const v=h,p=y;if((i.URI.isUri(v.light)||I(v.light))&&(i.URI.isUri(v.dark)||I(v.dark))&&(i.URI.isUri(p.light)||I(p.light))&&(i.URI.isUri(p.dark)||I(p.dark)))return v.light.path===p.light.path&&v.dark.path===p.dark.path}if(i.URI.isUri(h)&&i.URI.isUri(y)||I(h)||I(y)){const v=h,p=y;return v.path===p.path&&v.scheme===p.scheme}return!1}e.terminalIconsEqual=D;function I(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}e.isUriComponents=I}),define(re[234],se([0,1,49,157,42,38,233]),function(J,e,R,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),type:"string",enum:Array.from(R.Codicon.getAll(),f=>f.id),markdownEnumDescriptions:Array.from(R.Codicon.getAll(),f=>`$(${f.id})`)},color:{description:(0,i.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},E={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...P}},D=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),I=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),h=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),v=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),p=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),d={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:D},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:D},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:h},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...P}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...P}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...P}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){L.Registry.as(k.Extensions.Configuration).registerConfiguration(d),w()}e.registerTerminalPlatformConfiguration=g;let S;function w(f,l){const t=L.Registry.as(k.Extensions.Configuration);let r;f&&(r=(0,A.createProfileSchemaEnums)(f?.profiles,l));const n=S;S={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?r?.values:void 0,markdownEnumDescriptions:f?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?r?.values:void 0,markdownEnumDescriptions:f?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?r?.values:void 0,markdownEnumDescriptions:f?.os===1?r?.markdownDescriptions:void 0}}},t.updateConfigurations({add:[S],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=w}),define(re[235],se([0,1,46,49,12,4,27,83,231,107]),function(J,e,R,i,k,L,A,P,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let D,I=!0;function h(r,n,a,c,o=process.env,s,u,m,C){return s=s||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},L.isWindows?y(a,s,o,u,c.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:c.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:c.getValue("terminal.integrated.defaultProfile.windows"),C,m):f(s,u,a,r&&typeof r=="object"?{...r}:c.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:c.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),C,m,o)}e.detectAvailableProfiles=h;async function y(r,n,a,c,o,s,u,m,C){const M=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),T=`${process.env.windir}\\${M?"Sysnative":"System32"}`;let F=!1;(0,b.getWindowsBuildNumber)()>=16299&&(F=!0),await d(m);const _=new Map;r&&(_.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Windows PowerShell",{path:`${T}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),_.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),_.set("Command Prompt",{path:`${T}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),l(s,_);const U=await v(_.entries(),u,n,a,c,C);if(r||!r&&o)try{const O=await S(`${T}\\${F?"wsl":"bash"}.exe`,u);for(const $ of O)(!s||!($.profileName in s))&&U.push($)}catch{I&&(c?.info("WSL is not installed, so could not detect WSL profiles"),I=!1)}return U}async function v(r,n,a,c=process.env,o,s){const u=[];for(const[m,C]of r){if(C===null)continue;let M,T,F;if("source"in C){const O=D?.get(C.source);if(!O)continue;M=O.paths,T=C.args||O.args,C.icon?F=p(C.icon):O.icon&&(F=O.icon)}else M=Array.isArray(C.path)?C.path:[C.path],T=L.isWindows||Array.isArray(C.args)?C.args:void 0,F=p(C.icon);const _=await s?.(M)||M.slice(),U=await t(m,n,_,a,c,T,C.env,C.overrideName,C.isAutoDetected,o);U?(U.isAutoDetected=C.isAutoDetected,U.icon=F,U.color=C.color,u.push(U)):o?.trace("profile not validated",m,M)}return u}function p(r){return typeof r=="string"?{id:r}:r}async function d(r){D&&!r||(D=new Map,D.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),D.set("PowerShell",{profileName:"PowerShell",paths:r||await g(),icon:E.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function g(){const r=[];for await(const n of(0,P.enumeratePowerShellInstallations)())r.push(n.exePath);return r}async function S(r,n){const a=[],c=await new Promise((u,m)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(C,M)=>{if(C)return m("Problem occurred when getting wsl distros");u(M)})});if(!c)return[];const o=new RegExp(/[\r?\n]/),s=c.split(o).filter(u=>u.trim().length>0&&u!=="");for(const u of s){if(u===""||u.startsWith("docker-desktop"))continue;const m=`${u} (WSL)`,C={profileName:m,path:r,args:["-d",`${u}`],isDefault:m===n,icon:w(u),isAutoDetected:!1};a.push(C)}return a}function w(r){return r.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):r.includes("Debian")?E.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function f(r,n,a,c,o,s,u,m){const C=new Map;if(a){const M=(await r.readFile("/etc/shells")).toString(),T=s||M.split(`
`).filter(_=>_.trim().indexOf("#")!==0&&_.trim().length>0),F=new Map;for(const _ of T){let U=(0,k.basename)(_),O=F.get(U)||0;O++,O>1&&(U=`${U} (${O})`),F.set(U,O),C.set(U,{path:_,isAutoDetected:!0})}}return l(c,C),await v(C.entries(),o,r,m,n,u)}function l(r,n){if(!!r)for(const[a,c]of Object.entries(r))c===null||!("path"in c)&&!("source"in c)?n.delete(a):(c.icon=c.icon||n.get(a)?.icon,n.set(a,c))}async function t(r,n,a,c,o,s,u,m,C,M){if(a.length===0)return Promise.resolve(void 0);const T=a.shift();if(T==="")return t(r,n,a,c,o,s,u,m,C);const F={profileName:r,path:T,args:s,env:u,overrideName:m,isAutoDetected:C,isDefault:r===n};if((0,k.basename)(T)===T){const U=o.PATH?o.PATH.split(k.delimiter):void 0,O=await(0,b.findExecutable)(T,void 0,U,void 0,c.existsFile);return O?(F.path=O,F.isFromPath=!0,F):t(r,n,a,c,o,s)}return await c.existsFile((0,k.normalize)(T))?F:t(r,n,a,c,o,s,u,m,C)}}),define(re[236],se([0,1,3,2,19,4,37,62,17,14,89,215,9,97,229,106,234,235]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var S;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(S||(S={}));let w=0,f=class extends i.Disposable{constructor(t,r,n,a){super();this._reconnectConstants=t,this._configurationService=r,this._environmentService=n,this._logService=a,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,(0,d.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,i.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new v.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,I.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(t){return this._logService.error("ptyHost was unable to resolve shell environment",t),{}}}_startPtyHost(){const t={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:w,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,D.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?t.debugBrk=r.port:!r.break&&r.port&&(t.debug=r.port));const n=new P.Client(k.FileAccess.asFileUri("bootstrap-fork",J).fsPath,t);this._onPtyHostStart.fire(),A.ProxyChannel.toService(n.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(s=>{this._onPtyHostExit.fire(s.code),this._isDisposed||(this._restartCount<=S.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const c=n.getChannel(p.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(c,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(c,this._logService.getLevel())}));const o=A.ProxyChannel.toService(n.getChannel(p.TerminalIpcChannels.PtyHost));return this._register(o.onProcessData(s=>this._onProcessData.fire(s))),this._register(o.onProcessReady(s=>this._onProcessReady.fire(s))),this._register(o.onProcessExit(s=>this._onProcessExit.fire(s))),this._register(o.onDidChangeProperty(s=>this._onDidChangeProperty.fire(s))),this._register(o.onProcessReplay(s=>this._onProcessReplay.fire(s))),this._register(o.onProcessOrphanQuestion(s=>this._onProcessOrphanQuestion.fire(s))),this._register(o.onDidRequestDetach(s=>this._onDidRequestDetach.fire(s))),[n,o]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(t,r,n,a,c,o,s,u,m,C,M){const T=setTimeout(()=>this._handleUnresponsiveCreateProcess(),p.HeartbeatConstants.CreateProcessTimeout),F=await this._proxy.createProcess(t,r,n,a,c,o,s,u,m,C,M);return clearTimeout(T),w=Math.max(w,F),F}updateTitle(t,r,n){return this._proxy.updateTitle(t,r,n)}updateIcon(t,r,n){return this._proxy.updateIcon(t,r,n)}attachToProcess(t){return this._proxy.attachToProcess(t)}detachFromProcess(t){return this._proxy.detachFromProcess(t)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(t){return this._proxy.start(t)}shutdown(t,r){return this._proxy.shutdown(t,r)}input(t,r){return this._proxy.input(t,r)}processBinary(t,r){return this._proxy.processBinary(t,r)}resize(t,r,n){return this._proxy.resize(t,r,n)}acknowledgeDataEvent(t,r){return this._proxy.acknowledgeDataEvent(t,r)}setUnicodeVersion(t,r){return this._proxy.setUnicodeVersion(t,r)}getInitialCwd(t){return this._proxy.getInitialCwd(t)}getCwd(t){return this._proxy.getCwd(t)}getLatency(t){return this._proxy.getLatency(t)}orphanQuestionReply(t){return this._proxy.orphanQuestionReply(t)}installAutoReply(t,r){return this._proxy.installAutoReply(t,r)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(t){return this._proxy.uninstallAutoReply(t)}getDefaultSystemShell(t){return this._proxy.getDefaultSystemShell(t)}async getProfiles(t,r,n,a=!1){const c=await this._shellEnv;return(0,g.detectAvailableProfiles)(r,n,a,this._configurationService,c,void 0,this._logService,this._resolveVariables.bind(this,t))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(t){return this._proxy.getWslPath(t)}setTerminalLayoutInfo(t){return this._proxy.setTerminalLayoutInfo(t)}async getTerminalLayoutInfo(t){return await this._proxy.getTerminalLayoutInfo(t)}async requestDetachInstance(t,r){return this._proxy.requestDetachInstance(t,r)}async acceptDetachInstanceReply(t,r){return this._proxy.acceptDetachInstanceReply(t,r)}async serializeTerminalState(t){return this._proxy.serializeTerminalState(t)}async reviveTerminalProcesses(t,r){return this._proxy.reviveTerminalProcesses(t,r)}async refreshProperty(t,r){return this._proxy.refreshProperty(t,r)}async updateProperty(t,r,n){return this._proxy.updateProperty(t,r,n)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(t,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:t,originalText:r})}async acceptPtyHostResolvedVariables(t,r){this._resolveVariablesRequestStore.acceptReply(t,r)}};e.PtyHostService=f,e.PtyHostService=f=fe([K(1,b.IConfigurationService),K(2,E.IEnvironmentService),K(3,h.ILogService)],f)}),define(re[71],se([0,1,3,4,5,9]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var A;(function(v){v.Http="http",v.Https="https"})(A||(e.TunnelProtocol=A={}));var P;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(P||(e.TunnelPrivacyId=P={}));var b;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function E(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=D,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=I;function h(v,p){return p?p!==1&&v<1024:!i.isWindows&&v<1024}e.isPortPrivileged=h;let y=class{constructor(p){this.logService=p,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p){return this._tunnelProvider=p,p?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(p){this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],d=Array.from(this._tunnels.values());for(let g of d){const S=Array.from(g.values());for(let w of S){const f=await w.value;f&&p.push(f)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:d}of p.values())await d.then(g=>g?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,d,g,S,w=!1,f,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${g} on local port ${S}.`),!p)return;if(d||(d="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.retainOrCreateTunnel(p,d,g,S,w,f,l);return t?t.then(r=>{if(!r){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(r);return(r.tunnelRemoteHost!==d||r.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const d=this._tunnels.get(p.tunnelRemoteHost);if(d){const g=d.get(p.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,g))}}}}async tryDisposeTunnel(p,d,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${d}.`);const S=g.value.then(async w=>{w&&(await w.dispose(!0),this._onTunnelClosed.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(d),S}}async closeTunnel(p,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${d} `);const g=this._tunnels.get(p);if(g&&g.has(d)){const S=g.get(d);S.refcount=0,await this.tryDisposeTunnel(p,d,S)}}addTunnelToMap(p,d,g){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(d,{refcount:1,value:g})}async removeEmptyTunnelFromMap(p,d){const g=this._tunnels.get(p);g&&(await g.get(d)||g.delete(d),g.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,d){let g=[p];D(p)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):I(p)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const S=g.map(w=>this._tunnels.get(w));for(const w of S){const f=w?.get(d);if(f)return f}}canTunnel(p){return!!E(p)}createWithProvider(p,d,g,S,w,f,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${g} on local port ${S}.`);const t=g;this._factoryInProgress.add(t);const n={elevationRequired:w?h(S===void 0?g:S):!1},a={remoteAddress:{host:d,port:g},localAddressPort:S,privacy:f,public:f?f!==P.Private:void 0,protocol:l},c=p.forwardPort(a,n);return c?(this.addTunnelToMap(d,g,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(t)})):this._factoryInProgress.delete(t),c}};e.AbstractTunnelService=y,e.AbstractTunnelService=y=fe([K(0,L.ILogService)],y)}),define(re[237],se([0,1,9,71,2,7,6]),function(J,e,R,i,k,L,A){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class b extends k.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let E=P=class extends k.Disposable{constructor(I,h){super();this._tunnelService=I,this._logService=h,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++P._lastId)}}async startTunnel(I,h,y,v,p,d){const g=new b,S=await Promise.resolve(this._tunnelService.openTunnel(I,g,y,v,p,d));if(!S)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${y}:${v} (remote).`),g.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(h))throw this._disposedTunnels.delete(h),g.dispose(),await S.dispose(),(0,L.canceled)();return g.setTunnel(S),this._tunnels.set(h,g),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${h}: ${S.localAddress} (local) to ${y}:${v} (remote).`),{tunnelLocalPort:S.tunnelLocalPort,localAddress:S.localAddress}}async setAddress(I,h){const y=this._tunnels.get(I);!y||y.setAddress(h)}async destroyTunnel(I){const h=this._tunnels.get(I);if(h){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await h.dispose();return}this._disposedTunnels.add(I)}};e.SharedProcessTunnelService=E,E._lastId=0,e.SharedProcessTunnelService=E=P=fe([K(0,i.ISharedTunnelsService),K(1,R.ILogService)],E)}),define(re[32],se([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(re[238],se([0,1,3,2,8,14,31,15,9,32]),function(J,e,R,i,k,L,A,P,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let D=class extends i.Disposable{constructor(h,y,v,p,d){super();this.extensionsManagementService=h,this.logService=p,this.uriIdentityService=d,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(S=>{this.installedExtensions=S.map(w=>w.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(S=>this.onInstallExtension(S))),this._register(h.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(h.onDidUninstallExtension(S=>this.onDidUninstallExtension(S)));const g=k.URI.file(v.extensionsPath);this._register(y.watch(g)),this._register(R.Event.filter(y.onDidFilesChange,S=>S.rawChanges.some(w=>this.doesChangeAffects(w,g)))(()=>this.onDidChange()))}doesChangeAffects(h,y){return h.type!==1&&h.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),y)?!1:this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(h.resource).startsWith(".")}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const y of h)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(y=>!(0,A.areSameExtensions)(y,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,A.areSameExtensions)(y,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(),y=h.filter(p=>[...this.installingExtensions,...this.installedExtensions].some(d=>(0,A.areSameExtensions)(d,p.identifier))?!1:p.installedTimestamp&&p.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",p.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",p.identifier.id),!1)),v=this.installedExtensions.filter(p=>this.installingExtensions.some(d=>(0,A.areSameExtensions)(d,p))?!1:h.every(d=>!(0,A.areSameExtensions)(d.identifier,p))?(this.logService.info("Detected extension removed from another source",p.id),!0):!1);this.installedExtensions=h.map(p=>p.identifier),(y.length||v.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:v})}}};e.ExtensionsWatcher=D,e.ExtensionsWatcher=D=fe([K(1,P.IFileService),K(2,L.INativeEnvironmentService),K(3,b.ILogService),K(4,E.IUriIdentityService)],D)}),define(re[239],se([0,1,32,64,15,20,115,3,2]),function(J,e,R,i,k,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(h){this.uri=h,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let D=class{constructor(h){this._fileService=h,this._dispooables=new b.DisposableStore,this._limit=2**16;const y=new Map,v=p=>{let d=y.get(p.scheme);return d===void 0&&(d=h.hasProvider(p)&&!this._fileService.hasCapability(p,1024),y.set(p.scheme,d)),d};this._dispooables.add(P.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(p=>{y.delete(p.scheme)})),this.extUri=new L.ExtUri(v),this._canonicalUris=new A.SkipList((p,d)=>this.extUri.compare(p,d,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,L.normalizePath)(h));let y=this._canonicalUris.get(h);return y?y.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new E(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((v,p)=>v[1].touch<p[1].touch?1:v[1].touch>p[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let v=0;v<y;v++)this._canonicalUris.set(h[v][0],h[v][1].touch())}};e.UriIdentityService=D,e.UriIdentityService=D=fe([K(0,k.IFileService)],D),(0,i.registerSingleton)(R.IUriIdentityService,D,!0)}),define(re[240],se([0,1,3,2,40,39,18]),function(J,e,R,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends i.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&~4}constructor(E,D,I,h){super();this.fileSystemScheme=E,this.fileSystemProvider=D,this.userDataScheme=I,this.logService=h,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=L.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(y=>this.handleFileChanges(y)))}watch(E,D){this.watchResources.set(E,E);const I=this.fileSystemProvider.watch(this.toFileSystemResource(E),D);return(0,i.toDisposable)(()=>{this.watchResources.delete(E),I.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,D,I){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(D),I)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,D,I){const h=(0,k.newWriteableStream)(y=>A.VSBuffer.concat(y.map(v=>A.VSBuffer.wrap(v))).buffer);return(async()=>{try{const y=await this.readFile(E);h.end(y)}catch(y){h.error(y),h.end()}})(),h}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,D,I){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),D,I)}delete(E,D){return this.fileSystemProvider.delete(this.toFileSystemResource(E),D)}handleFileChanges(E){const D=[];for(const I of E){if(I.resource.scheme!==this.fileSystemScheme)continue;const h=this.toUserDataResource(I.resource);this.watchResources.findSubstr(h)&&D.push({resource:h,type:I.type})}D.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(D))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(re[58],se([0,1,76]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(A,P,b,E){const D=(0,R.setProperty)(A,P,b,E)[0];return D&&(A=A.substring(0,D.offset)+D.content+A.substring(D.offset+D.length)),A}e.edit=i;function k(A,P,b){let E=b;for(;E>=0;){if(A.charAt(E)===P.charAt(P.length-1)&&P.length===1)return E+1;if(E--,P.length===2&&E>=0&&A.charAt(E)===P.charAt(0))return E+2}return 0}e.getLineStartOffset=k;function L(A,P,b){let E=b;for(;E>=0;)if(A.charAt(E)===P.charAt(P.length-1)&&P.length===1||(E++,P.length===2&&E>=0&&A.charAt(E)===P.charAt(1)))return E;return A.length-1}e.getLineEndOffset=L}),define(re[241],se([0,1,28,53,13]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(h,y,v,p,d){const g=[],S=[],w=[];if(!y){const T=h.filter(({identifier:F})=>d.every(_=>_.toLowerCase()!==F.id.toLowerCase()));return{local:{added:g,removed:S,updated:w},remote:T.length>0?{added:T,updated:[],removed:[],all:T}:null}}h=h.map(D),y=y.map(D),v=v?v.map(D):null;const f=new Map,l=T=>{T.uuid&&f.set(T.id.toLowerCase(),T.uuid)};h.forEach(({identifier:T})=>l(T)),y.forEach(({identifier:T})=>l(T)),v&&v.forEach(({identifier:T})=>l(T));const t=T=>{const F=T.identifier.uuid||f.get(T.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${T.identifier.id.toLowerCase()}`},r=(T,F)=>(T.set(t(F),F),T),n=h.reduce(r,new Map),a=y.reduce(r,new Map),c=y.reduce((T,F)=>{const _=t(F);F=(0,R.deepClone)(F);const U=n.get(_);return U&&(U.installed&&(F.installed=!0),F.version||(F.version=U.version)),r(T,F)},new Map),o=v?v.reduce(r,new Map):null,s=p.reduce(r,new Map),u=d.reduce((T,F)=>{const _=f.get(F.toLowerCase());return T.add(_?`uuid:${_}`:`id:${F.toLowerCase()}`)},new Set),m=A(n,a,u);if(m.added.size>0||m.removed.size>0||m.updated.size>0){const T=A(o,n,u),F=A(o,a,u),_=(U,O)=>{const $=n.get(U);if($){const V=a.get(U),te=O?V:$;return{...te,version:V.version&&(!$.installed||i.gt(V.version,$.version))?V.version:$.version,state:P($,V,o?.get(U)),preRelease:(0,k.isUndefined)(te.preRelease)?$.preRelease:$.installed?te.preRelease:V.preRelease}}};for(const U of F.removed.values()){const O=n.get(U);O&&S.push(O.identifier)}for(const U of F.added.values())if(T.added.has(U)){if(m.updated.has(U)){const O=_(U,!0);O&&(w.push(I(O,U)),c.set(U,O))}}else{const O=a.get(U);O.installed&&g.push(I(O,U))}for(const U of F.updated.values()){const O=_(U,!0);O&&(w.push(I(O,U)),c.set(U,O))}for(const U of T.added.values())F.added.has(U)||c.set(U,n.get(U));for(const U of T.updated.values())if(!F.removed.has(U)&&!F.updated.has(U)){const O=_(U,!1);O&&(c.get(U)?.installed&&(O.installed=!0),c.set(U,O))}for(const U of T.removed.values())!s.has(U)&&!F.updated.has(U)&&o?.get(U)?.installed&&c.delete(U)}const C=[],M=A(a,c,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(M.added.size>0||M.updated.size>0||M.removed.size>0)&&c.forEach((T,F)=>C.push(I(T,F))),{local:{added:g,removed:S,updated:w},remote:C.length?{added:[...M.added].map(T=>c.get(T)),updated:[...M.updated].map(T=>c.get(T)),removed:[...M.removed].map(T=>a.get(T)),all:C}:null}}e.merge=L;function A(h,y,v,{checkInstalledProperty:p,checkVersionProperty:d}={checkInstalledProperty:!1,checkVersionProperty:!1}){const g=h?[...h.keys()].filter(t=>!v.has(t)):[],S=[...y.keys()].filter(t=>!v.has(t)),w=S.filter(t=>g.indexOf(t)===-1).reduce((t,r)=>(t.add(r),t),new Set),f=g.filter(t=>S.indexOf(t)===-1).reduce((t,r)=>(t.add(r),t),new Set),l=new Set;for(const t of g){if(f.has(t))continue;const r=h.get(t),n=y.get(t);(!n||r.disabled!==n.disabled||r.installed&&n.installed&&r.preRelease!==n.preRelease||!E(r.state,n.state)||d&&r.version!==n.version||p&&r.installed!==n.installed)&&l.add(t)}return{added:w,removed:f,updated:l}}function P(h,y,v){const p=h.state,d=y.state,g=v?.state;if(!y.version||p&&i.gt(h.version,y.version))return p;if(d&&i.gt(y.version,h.version)||!p)return d;if(!d)return p;const S=(0,R.deepClone)(p),w=g?b(g,d):{added:Object.keys(d).reduce((l,t)=>(l.add(t),l),new Set),removed:new Set,updated:new Set},f=g?b(g,p):{added:Object.keys(p).reduce((l,t)=>(l.add(t),l),new Set),removed:new Set,updated:new Set};for(const l of[...w.added.values(),...w.updated.values()])S[l]=d[l];for(const l of w.removed.values())f.updated.has(l)||delete S[l];return S}function b(h,y){const v=Object.keys(h),p=Object.keys(y),d=p.filter(w=>v.indexOf(w)===-1).reduce((w,f)=>(w.add(f),w),new Set),g=v.filter(w=>p.indexOf(w)===-1).reduce((w,f)=>(w.add(f),w),new Set),S=new Set;for(const w of v){if(g.has(w))continue;const f=h[w],l=y[w];(0,R.equals)(f,l)||S.add(w)}return{added:d,removed:g,updated:S}}function E(h={},y={}){const{added:v,removed:p,updated:d}=b(h,y);return v.size===0&&p.size===0&&d.size===0}function D(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function I(h,y){const v={identifier:{id:h.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0},preRelease:!!h.preRelease};return h.version&&(v.version=h.version),h.disabled&&(v.disabled=!0),h.installed&&(v.installed=!0),h.state&&(v.state=h.state),v}}),define(re[108],se([0,1,16,17,5]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return E=E.filter(D=>D!==P&&D!==`-${P}`),b&&E.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(P,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return E=E.filter(D=>D!==P&&D!==`-${P}`),b&&E.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(P){const b=P.filter(h=>h.isMachineScoped).map(h=>h.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(h=>h.toLowerCase()),D=[],I=[];if(Array.isArray(E))for(const h of E)h.startsWith("-")?I.push(h.substring(1)):D.push(h);return(0,R.distinct)([...b,...D].filter(h=>I.indexOf(h)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};e.IgnoredExtensionsManagementService=L,e.IgnoredExtensionsManagementService=L=fe([K(0,i.IConfigurationService)],L)}),define(re[242],se([0,1,16,33,28,174,58]),function(J,e,R,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(f){return(0,i.parse)(f)||[]}e.parseKeybindings=P;async function b(f,l,t,r,n){const a=P(f),c=P(l),o=t?P(t):null,s=[...a,...c,...o||[]].map(V=>V.key),u=await n.resolveUserBindings(s);let m=D(a,c,o,u);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:f,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};const C=h(a),M=h(c),T=o?h(o):null,F=v(C,M,u),_=T?v(T,C,u):{added:[...C.keys()].reduce((V,te)=>(V.add(te),V),new Set),removed:new Set,updated:new Set},U=T?v(T,M,u):{added:[...M.keys()].reduce((V,te)=>(V.add(te),V),new Set),removed:new Set,updated:new Set},O=E(F,_,U);let $=f;for(const V of O.removed.values())O.conflicts.has(V)||($=S($,V,r));for(const V of O.added.values()){if(O.conflicts.has(V))continue;const te=M.get(V);if(te.some(H=>H.command!==`-${V}`&&m.conflicts.has(u[H.key]))){O.conflicts.add(V);continue}$=g($,te,r)}for(const V of O.updated.values()){if(O.conflicts.has(V))continue;const te=M.get(V);if(te.some(H=>H.command!==`-${V}`&&m.conflicts.has(u[H.key]))){O.conflicts.add(V);continue}$=w($,V,te,r)}return{mergeContent:$,hasChanges:!0,hasConflicts:O.conflicts.size>0}}e.merge=b;function E(f,l,t){const r=new Set,n=new Set,a=new Set,c=new Set;for(const o of l.removed.values())t.updated.has(o)&&c.add(o);for(const o of t.removed.values())c.has(o)||(l.updated.has(o)?c.add(o):n.add(o));for(const o of l.added.values())c.has(o)||t.added.has(o)&&f.updated.has(o)&&c.add(o);for(const o of t.added.values())c.has(o)||(l.added.has(o)?f.updated.has(o)&&c.add(o):r.add(o));for(const o of l.updated.values())c.has(o)||t.updated.has(o)&&f.updated.has(o)&&c.add(o);for(const o of t.updated.values())c.has(o)||(l.updated.has(o)?f.updated.has(o)&&c.add(o):a.add(o));return{added:r,removed:n,updated:a,conflicts:c}}function D(f,l,t,r){const n=new Set,a=I(f,r),c=I(l,r),o=t?I(t,r):null,s=y(a,c);if(s.added.size===0&&s.removed.size===0&&s.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const u=o?y(o,a):{added:[...a.keys()].reduce((_,U)=>(_.add(U),_),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const m=o?y(o,c):{added:[...c.keys()].reduce((_,U)=>(_.add(U),_),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:C,removed:M,updated:T,conflicts:F}=E(s,u,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:C,removed:M,updated:T,conflicts:F}}function I(f,l){const t=new Map;for(const r of f){const n=l[r.key];let a=t.get(n);a||(a=[],t.set(n,a)),a.push(r)}return t}function h(f){const l=new Map;for(const t of f){const r=t.command[0]==="-"?t.command.substring(1):t.command;let n=l.get(r);n||(n=[],l.set(r,n)),n.push(t)}return l}function y(f,l){const t=[...f.keys()],r=[...l.keys()],n=r.filter(o=>t.indexOf(o)===-1).reduce((o,s)=>(o.add(s),o),new Set),a=t.filter(o=>r.indexOf(o)===-1).reduce((o,s)=>(o.add(s),o),new Set),c=new Set;for(const o of t){if(a.has(o))continue;const s=f.get(o).map(m=>({...m,key:o})),u=l.get(o).map(m=>({...m,key:o}));(0,R.equals)(s,u,(m,C)=>d(m,C))||c.add(o)}return{added:n,removed:a,updated:c}}function v(f,l,t){const r=[...f.keys()],n=[...l.keys()],a=n.filter(s=>r.indexOf(s)===-1).reduce((s,u)=>(s.add(u),s),new Set),c=r.filter(s=>n.indexOf(s)===-1).reduce((s,u)=>(s.add(u),s),new Set),o=new Set;for(const s of r){if(c.has(s))continue;const u=f.get(s).map(C=>({...C,key:t[C.key]})),m=l.get(s).map(C=>({...C,key:t[C.key]}));p(u,m)||o.add(s)}return{added:a,removed:c,updated:o}}function p(f,l){return!(!(0,R.equals)(f.filter(({command:t})=>t[0]!=="-"),l.filter(({command:t})=>t[0]!=="-"),(t,r)=>d(t,r))||!(0,R.equals)(f.filter(({command:t})=>t[0]==="-"),l.filter(({command:t})=>t[0]==="-"),(t,r)=>d(t,r)))}function d(f,l){if(f.command!==l.command||f.key!==l.key)return!1;const t=L.ContextKeyExpr.deserialize(f.when),r=L.ContextKeyExpr.deserialize(l.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!k.equals(f.args,l.args))}function g(f,l,t){for(const r of l)f=A.edit(f,[-1],r,t);return f}function S(f,l,t){const r=P(f);for(let n=r.length-1;n>=0;n--)(r[n].command===l||r[n].command===`-${l}`)&&(f=A.edit(f,[n],void 0,t));return f}function w(f,l,t,r){const n=P(f),a=n.findIndex(c=>c.command===l||c.command===`-${l}`);for(let c=n.length-1;c>=0;c--)(n[c].command===l||n[c].command===`-${l}`)&&(f=A.edit(f,[c],void 0,r));for(let c=t.length-1;c>=0;c--)f=A.edit(f,[a],t[c],r);return f}}),define(re[243],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(L,A,P){const b={},E={},D=new Set;if(!A)return{local:{added:b,updated:E,removed:[...D.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const I=i(L,A);if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{local:{added:b,updated:E,removed:[...D.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const h=i(P,L),y=i(P,A),v={},p={},d=new Set,g=new Set;for(const S of h.removed.values())y.updated.has(S)?b[S]=A[S]:d.add(S);for(const S of y.removed.values())g.has(S)||(h.updated.has(S)?g.add(S):D.add(S));for(const S of h.updated.values())g.has(S)||(y.updated.has(S)?I.updated.has(S)&&g.add(S):p[S]=L[S]);for(const S of y.updated.values())g.has(S)||(h.updated.has(S)?I.updated.has(S)&&g.add(S):L[S]!==void 0&&(E[S]=A[S]));for(const S of h.added.values())g.has(S)||(y.added.has(S)?I.updated.has(S)&&g.add(S):v[S]=L[S]);for(const S of y.added.values())g.has(S)||(h.added.has(S)?I.updated.has(S)&&g.add(S):b[S]=A[S]);return{local:{added:b,removed:[...D.values()],updated:E},remote:{added:v,removed:[...d.values()],updated:p},conflicts:[...g.values()]}}e.merge=R;function i(L,A){const P=L?Object.keys(L):[],b=A?Object.keys(A):[],E=b.filter(h=>P.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),D=P.filter(h=>b.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),I=new Set;for(const h of P){if(D.has(h))continue;const y=L[h],v=A[h];y!==v&&I.add(h)}return{added:E,removed:D,updated:I}}function k(L,A){const{added:P,removed:b,updated:E}=i(L,A);return P.size===0&&b.size===0&&E.size===0}e.areSame=k}),define(re[25],se([0,1,16,20,13,163,42,29,5,99,38]),function(J,e,R,i,k,L,A,P,b,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const o=D.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(s=>!!o[s].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function h(){const o=D.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(o).filter(C=>!!o[C].ignoreSync),u=Object.keys(o).filter(C=>o[C].scope===2||o[C].scope===6),m=I();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...s,...u,...m])}e.getDefaultIgnoredSettings=h,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function y(){const o="vscode://schemas/ignoredSettings",s=D.Registry.as(A.Extensions.Configuration);s.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const u=D.Registry.as(E.Extensions.JSONContribution),m=()=>{const C=I(),M=h().filter(U=>U!==e.CONFIGURATION_SYNC_STORE_KEY),T=Object.keys(A.allSettings.properties).filter(U=>M.indexOf(U)===-1),F=M.filter(U=>C.indexOf(U)===-1),_={items:{type:"string",enum:[...T,...F.map(U=>`-${U}`)]}};u.registerSchema(o,_)};return s.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=y;function v(o){return o&&(0,k.isObject)(o)&&(0,k.isString)(o.id)&&(0,k.isArray)(o.scopes)}e.isAuthenticationProvider=v;var p;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState"})(p||(e.SyncResource=p={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function d(o,s,u){return u.joinPath(s.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=d,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function g(o){const s={};return s[e.HEADER_EXECUTION_ID]=o,s}e.createSyncHeaders=g;var S;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(S||(e.UserDataSyncErrorCode=S={}));class w extends Error{constructor(s,u,m,C){super(s);this.code=u,this.resource=m,this.operationId=C,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=w;class f extends w{constructor(s,u,m,C,M){super(s,m,void 0,M);this.url=u,this.serverCode=C}}e.UserDataSyncStoreError=f;class l extends w{constructor(s,u){super(s,u)}}e.UserDataAutoSyncError=l,function(o){function s(u){if(u instanceof o)return u;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(u.name);if(m&&m[1]){const C=m[2]==="unknown"?void 0:m[2],M=m[3]==="unknown"?void 0:m[3];return new o(u.message,m[1],C,M)}return new o(u.message,"Unknown")}o.toUserDataSyncError=s}(w||(e.UserDataSyncError=w={}));var t;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var r;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(r||(e.Change=r={}));var n;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(n||(e.MergeState=n={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function a(o){return`sync.enable.${o}`}e.getEnablementKey=a,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function c(o,s){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:s.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(u=>(0,i.isEqualOrParent)(o,(0,i.joinPath)(s.userDataSyncHome,u,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=c}),define(re[44],se([0,1,16,6,18,23,3,33,2,26,13,8,159,17,14,15,9,47,21,22,32,25]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g,S,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function t(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=t;let r=class extends b.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}constructor(s,u,m,C,M,T,F,_,U,O,$){super();this.resource=s,this.fileService=u,this.environmentService=m,this.userDataSyncStoreService=M,this.userDataSyncBackupStoreService=T,this.userDataSyncEnablementService=F,this.telemetryService=_,this.logService=U,this.configurationService=O,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new i.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,E.uppercaseFirstLetter)(this.resource),this.extUri=$.extUri,this.syncFolder=this.extUri.joinPath(m.userDataSyncHome,s),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(s,m,this.extUri),this.currentMachineIdPromise=(0,g.getServiceMachineId)(m,u,C)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const s=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(s.remoteUserData,s.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const s=await this.getLastSyncUserData();(s?await this.hasRemoteChanged(s):!0)&&this._onDidChangeLocal.fire()}}setStatus(s){this._status!==s&&(this._status=s,this._onDidChangStatus.fire(s))}async sync(s,u={}){await this._sync(s,!0,this.getUserDataSyncConfiguration(),u)}async preview(s,u,m={}){return this._sync(s,!1,u,m)}async apply(s,u={}){try{this.syncHeaders={...u};const m=await this.doApply(s);return this.setStatus(m),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(s,u,m,C){try{if(this.syncHeaders={...C},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let M="idle";try{const T=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(s,T);return M=await this.performSync(F,T,u,m),M==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(M)}}finally{this.syncHeaders={}}}async replace(s){const u=await this.resolveContent(s);if(!u)return!1;const m=this.parseSyncData(u);if(!m)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const C=await this.getLastSyncUserData(),M=await this.getLatestRemoteUserData(null,C),T=await this.isRemoteDataFromCurrentMachine(M),F=await this.generateSyncPreview({ref:M.ref,syncData:m},C,T,this.getUserDataSyncConfiguration(),L.CancellationToken.None),_=[];for(const U of F){const O=await this.getAcceptResult(U,U.remoteResource,void 0,L.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(U,U.previewResource,U.remoteContent,L.CancellationToken.None);_.push([U,{...O,remoteChange:$!==0?$:2}])}await this.applyResult(M,C,_,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(s){const u=await this.currentMachineIdPromise;return!!s.syncData?.machineId&&s.syncData.machineId===u}async getLatestRemoteUserData(s,u){if(u){const m=s&&s.latest?s.latest[this.resource]:void 0;if(u.ref===m||m===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(s,u,m,C){if(s.syncData&&s.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,h.localize)(0,null,this.resource,this.version,s.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(s,u,m,C)}catch(M){if(M instanceof l.UserDataSyncError)switch(M.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(s,u,m,C);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),s=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(s,u,m,C)}throw M}}async doSync(s,u,m,C){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,i.createCancelablePromise)(T=>this.doGenerateSyncResourcePreview(s,u,m,C,T)));const M=await this.syncPreviewPromise;return this.updateConflicts(M.resourcePreviews),M.resourcePreviews.some(({mergeState:T})=>T==="conflict")?"hasConflicts":m?await this.doApply(!1):"syncing"}catch(M){throw this.syncPreviewPromise=null,M}}async merge(s){return await this.updateSyncResourcePreview(s,async u=>{const m=await this.getMergeResult(u,L.CancellationToken.None);await this.fileService.writeFile(u.previewResource,k.VSBuffer.fromString(m?.content||""));const C=m&&!m.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,L.CancellationToken.None):void 0;return u.acceptResult=C,u.mergeState=m.hasConflicts?"conflict":C?"accepted":"preview",u.localChange=C?C.localChange:m.localChange,u.remoteChange=C?C.remoteChange:m.remoteChange,u}),this.syncPreviewPromise}async accept(s,u){return await this.updateSyncResourcePreview(s,async m=>{const C=await this.getAcceptResult(m,s,u,L.CancellationToken.None);return m.acceptResult=C,m.mergeState="accepted",m.localChange=C.localChange,m.remoteChange=C.remoteChange,m}),this.syncPreviewPromise}async discard(s){return await this.updateSyncResourcePreview(s,async u=>{const m=await this.getMergeResult(u,L.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,k.VSBuffer.fromString(m.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=m.localChange,u.remoteChange=m.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(s,u){if(!this.syncPreviewPromise)return;let m=await this.syncPreviewPromise;const C=m.resourcePreviews.findIndex(({localResource:M,remoteResource:T,previewResource:F})=>this.extUri.isEqual(M,s)||this.extUri.isEqual(T,s)||this.extUri.isEqual(F,s));C!==-1&&(this.syncPreviewPromise=(0,i.createCancelablePromise)(async M=>{const T=[...m.resourcePreviews];return T[C]=await u(T[C]),{...m,resourcePreviews:T}}),m=await this.syncPreviewPromise,this.updateConflicts(m.resourcePreviews),m.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(s){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:m})=>m==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:m})=>m!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(m=>[m,m.acceptResult]),s),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(s){const u=s.filter(({mergeState:m})=>m==="conflict");(0,R.equals)(this._conflicts,u,(m,C)=>this.extUri.isEqual(m.previewResource,C.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){const s=await this.getLastSyncUserData();return!!s&&s.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:m})=>({created:u,uri:this.toRemoteBackupResource(m)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:m})=>({created:u,uri:this.toLocalBackupResource(m)}))}toRemoteBackupResource(s){return I.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${s}`})}toLocalBackupResource(s){return I.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${s}`})}async getMachineId({uri:s}){const u=this.extUri.basename(s);if(this.extUri.isEqual(s,this.toRemoteBackupResource(u))){const{content:m}=await this.getUserData(u);if(m)return this.parseSyncData(m)?.machineId}}async resolveContent(s){const u=this.extUri.basename(s);if(this.extUri.isEqual(s,this.toRemoteBackupResource(u))){const{content:m}=await this.getUserData(u);return m}return this.extUri.isEqual(s,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(s){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const m of u.resourcePreviews){if(this.extUri.isEqual(m.acceptedResource,s))return m.acceptResult?m.acceptResult.content:null;if(this.extUri.isEqual(m.remoteResource,s))return m.remoteContent;if(this.extUri.isEqual(m.localResource,s))return m.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(s,u,m,C,M){const T=await this.isRemoteDataFromCurrentMachine(s),F=await this.generateSyncPreview(s,u,T,C,M),_=[];for(const U of F){const O=U.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(U.localChange===0&&U.remoteChange===0)_.push({...U,acceptedResource:O,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const $=m?await this.getMergeResult(U,M):void 0;if(M.isCancellationRequested)break;await this.fileService.writeFile(U.previewResource,k.VSBuffer.fromString($?.content||""));const V=$&&!$.hasConflicts?await this.getAcceptResult(U,U.previewResource,void 0,M):void 0;_.push({...U,acceptResult:V,mergeState:$?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:$?$.localChange:U.localChange,remoteChange:V?V.remoteChange:$?$.remoteChange:U.remoteChange})}}return{remoteUserData:s,lastSyncUserData:u,resourcePreviews:_,isLastSyncFromCurrentMachine:T}}async getLastSyncUserData(){try{const s=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(s.value.toString()),m=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&m&&u.version!==m,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${m}.`),await this.resetLocal(),null;const C=u;if(C.content===null)return{ref:u.ref,syncData:null};const M=JSON.parse(C.content);if(t(M))return{...u,syncData:M,content:void 0}}catch(s){s instanceof p.FileOperationError&&s.fileOperationResult===1||this.logService.error(s)}return null}async updateLastSyncUserData(s,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const m=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),C={ref:s.ref,content:s.syncData?JSON.stringify(s.syncData):null,version:m,...u};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(C)))}async getRemoteUserData(s){const{ref:u,content:m}=await this.getUserData(s);let C=null;return m!==null&&(C=this.parseSyncData(m)),{ref:u,syncData:C}}parseSyncData(s){try{const u=JSON.parse(s);if(t(u))return u}catch(u){this.logService.error(u)}throw new l.UserDataSyncError((0,h.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(s){if((0,D.isString)(s)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,s);return{ref:s,content:u}}else{const u=s?{ref:s.ref,content:s.syncData?JSON.stringify(s.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(s,u){const m=await this.currentMachineIdPromise,C={version:this.version,machineId:m,content:s};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(C),u,this.syncHeaders),{ref:u,syncData:C}}async backupLocal(s){const u={version:this.version,content:s};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=r,e.AbstractSynchroniser=r=fe([K(1,p.IFileService),K(2,v.IEnvironmentService),K(3,S.IStorageService),K(4,l.IUserDataSyncStoreService),K(5,l.IUserDataSyncBackupStoreService),K(6,l.IUserDataSyncEnablementService),K(7,w.ITelemetryService),K(8,l.IUserDataSyncLogService),K(9,y.IConfigurationService),K(10,f.IUriIdentityService)],r);let n=class extends r{constructor(s,u,m,C,M,T,F,_,U,O,$,V){super(u,m,C,M,T,F,_,U,O,$,V);this.file=s,this._register(this.fileService.watch(this.extUri.dirname(s))),this._register(this.fileService.onDidFilesChange(te=>this.onFileChanges(te)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(s,u,m){try{u?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(s),m?void 0:u):await this.fileService.createFile(this.file,k.VSBuffer.fromString(s),{overwrite:m})}catch(C){throw C instanceof p.FileOperationError&&C.fileOperationResult===1||C instanceof p.FileOperationError&&C.fileOperationResult===3?new l.UserDataSyncError(C.message,"LocalPreconditionFailed"):C}}onFileChanges(s){!s.contains(this.file)||this.triggerLocalChange()}};e.AbstractFileSynchroniser=n,e.AbstractFileSynchroniser=n=fe([K(2,p.IFileService),K(3,v.IEnvironmentService),K(4,S.IStorageService),K(5,l.IUserDataSyncStoreService),K(6,l.IUserDataSyncBackupStoreService),K(7,l.IUserDataSyncEnablementService),K(8,w.ITelemetryService),K(9,l.IUserDataSyncLogService),K(10,y.IConfigurationService),K(11,f.IUriIdentityService)],n);let a=class extends n{constructor(s,u,m,C,M,T,F,_,U,O,$,V,te){super(s,u,m,C,M,T,F,_,U,O,V,te);this.userDataSyncUtilService=$,this._formattingOptions=void 0}hasErrors(s,u){const m=[],C=(0,P.parse)(s,m,{allowEmptyContent:!0,allowTrailingComma:!0});return m.length>0||!(0,D.isUndefined)(C)&&u!==Array.isArray(C)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=a,e.AbstractJsonFileSynchroniser=a=fe([K(2,p.IFileService),K(3,v.IEnvironmentService),K(4,S.IStorageService),K(5,l.IUserDataSyncStoreService),K(6,l.IUserDataSyncBackupStoreService),K(7,l.IUserDataSyncEnablementService),K(8,w.ITelemetryService),K(9,l.IUserDataSyncLogService),K(10,l.IUserDataSyncUtilService),K(11,y.IConfigurationService),K(12,f.IUriIdentityService)],a);let c=class{constructor(s,u,m,C,M){this.resource=s,this.environmentService=u,this.logService=m,this.fileService=C,this.extUri=M.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,u,this.extUri)}async initialize({ref:s,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const m=this.parseSyncData(u);if(!!m)try{await this.doInitialize({ref:s,syncData:m})}catch(C){this.logService.error(C)}}parseSyncData(s){try{const u=JSON.parse(s);if(t(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(s,u={}){const m={ref:s.ref,content:s.syncData?JSON.stringify(s.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(m)))}};e.AbstractInitializer=c,e.AbstractInitializer=c=fe([K(1,v.IEnvironmentService),K(2,d.ILogService),K(3,p.IFileService),K(4,f.IUriIdentityService)],c)}),define(re[244],se([0,1,6,23,7,3,51,26,8,17,14,29,31,70,15,9,21,22,32,44,241,108,25]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g,S,w,f,l,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function n(o,s){const u=JSON.parse(o.content);if(o.version===1||o.version===2){const m=(await s.getInstalled(0)).filter(C=>C.isBuiltin);for(const C of u)o.version===1&&(C.enabled===!1&&(C.disabled=!0),delete C.enabled),o.version===2&&m.every(M=>!(0,h.areSameExtensions)(M.identifier,C.identifier))&&(C.installed=!0)}return u}let a=r=class extends w.AbstractSynchroniser{constructor(s,u,m,C,M,T,F,_,U,O,$,V,te,H,z){super("extensions",u,s,m,C,M,V,te,U,$,z);this.extensionManagementService=T,this.extensionEnablementService=F,this.ignoredExtensionsManagementService=_,this.extensionGalleryService=O,this.extensionStorageService=H,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,q=>q.some(({local:j})=>!!j)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,q=>!q.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(s,u){const m=s.syncData?await n(s.syncData,this.extensionManagementService):null,C=u?.skippedExtensions||[],M=u?.syncData?await n(u.syncData,this.extensionManagementService):null,T=await this.extensionManagementService.getInstalled(void 0),F=this.getLocalExtensions(T),_=this.ignoredExtensionsManagementService.getIgnoredExtensions(T);m?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:U,remote:O}=(0,f.merge)(F,m,M,C,_),$={local:U,remote:O,content:this.getPreviewContent(F,U.added,U.updated,U.removed),localChange:U.added.length>0||U.removed.length>0||U.updated.length>0?2:0,remoteChange:O!==null?2:0};return[{skippedExtensions:C,localResource:this.localResource,localContent:this.stringify(F,!1),localExtensions:F,remoteResource:this.remoteResource,remoteContent:m?this.stringify(m,!1):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const u=s.syncData?await n(s.syncData,this.extensionManagementService):null,m=await this.extensionManagementService.getInstalled(void 0),C=this.getLocalExtensions(m),M=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),{remote:T}=(0,f.merge)(C,u,u,s.skippedExtensions||[],M);return T!==null}getPreviewContent(s,u,m,C){const M=[...u,...m],T=new Set,F=_=>{T.add(_.id.toLowerCase()),_.uuid&&T.add(_.uuid)};M.forEach(({identifier:_})=>F(_)),C.forEach(F);for(const _ of s)T.has(_.identifier.id.toLowerCase())||_.identifier.uuid&&T.has(_.identifier.uuid)||M.push(_);return this.stringify(M,!1)}async getMergeResult(s,u){return{...s.previewResult,hasConflicts:!1}}async getAcceptResult(s,u,m,C){if(this.extUri.isEqual(u,this.localResource))return this.acceptLocal(s);if(this.extUri.isEqual(u,this.remoteResource))return this.acceptRemote(s);if(this.extUri.isEqual(u,this.previewResource))return s.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async acceptLocal(s){const u=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),C=(0,f.merge)(s.localExtensions,null,null,s.skippedExtensions,m),{local:M,remote:T}=C;return{content:s.localContent,local:M,remote:T,localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:T!==null?2:0}}async acceptRemote(s){const u=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),C=s.remoteContent?JSON.parse(s.remoteContent):null;if(C!==null){const M=(0,f.merge)(s.localExtensions,C,s.localExtensions,[],m),{local:T,remote:F}=M;return{content:s.remoteContent,local:T,remote:F,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:s.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(s,u,m,C){let{skippedExtensions:M,localExtensions:T}=m[0][0],{local:F,remote:_,localChange:U,remoteChange:O}=m[0][1];if(U===0&&O===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),U!==0&&(await this.backupLocal(JSON.stringify(T)),M=await this.updateLocalExtensions(F.added,F.removed,F.updated,M)),_){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const $=JSON.stringify(_.all);s=await this.updateRemoteUserData($,C?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${_.added.length?` Added: ${JSON.stringify(_.added.map(V=>V.identifier.id))}.`:""}${_.updated.length?` Updated: ${JSON.stringify(_.updated.map(V=>V.identifier.id))}.`:""}${_.removed.length?` Removed: ${JSON.stringify(_.removed.map(V=>V.identifier.id))}.`:""}`)}u?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(s,{skippedExtensions:M}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${M.length?` Skipped: ${JSON.stringify(M.map($=>$.identifier.id))}.`:""}`))}async getAssociatedResources({uri:s}){return[{resource:this.extUri.joinPath(s,"extensions.json"),comparableResource:r.EXTENSIONS_DATA_URI}]}async resolveContent(s){if(this.extUri.isEqual(s,r.EXTENSIONS_DATA_URI)){const m=await this.extensionManagementService.getInstalled(),C=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),M=this.getLocalExtensions(m).filter(T=>!C.some(F=>(0,h.areSameExtensions)({id:F},T.identifier)));return this.stringify(M,!0)}if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)){const m=await this.resolvePreviewContent(s);return m&&this.stringify(JSON.parse(m),!0)}let u=await super.resolveContent(s);if(u)return u;if(u=await super.resolveContent(this.extUri.dirname(s)),u){const m=this.parseSyncData(u);if(m)switch(this.extUri.basename(s)){case"extensions.json":return this.stringify(this.parseExtensions(m),!0)}}return null}stringify(s,u){return s.sort((m,C)=>!m.identifier.uuid&&C.identifier.uuid?-1:m.identifier.uuid&&!C.identifier.uuid?1:(0,P.compare)(m.identifier.id,C.identifier.id)),u?(0,A.toFormattedString)(s,{}):JSON.stringify(s)}async hasLocalData(){try{const s=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(s).some(m=>m.installed||m.disabled))return!0}catch{}return!1}async updateLocalExtensions(s,u,m,C){const M=[],T=[],F=await this.extensionManagementService.getInstalled();if(u.length){const U=F.filter(({identifier:O,isBuiltin:$})=>!$&&u.some(V=>(0,h.areSameExtensions)(O,V)));await R.Promises.settled(U.map(async O=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,O.identifier.id),await this.extensionManagementService.uninstall(O,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,O.identifier.id),M.push(O.identifier)}))}(s.length||m.length)&&await R.Promises.settled([...s,...m].map(async U=>{const O=F.find(V=>(0,h.areSameExtensions)(V.identifier,U.identifier));if(O&&O.isBuiltin){U.state&&O.manifest.version===U.version&&this.updateExtensionState(U.state,O,O.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(te=>(0,h.areSameExtensions)(te,U.identifier))!==!!U.disabled&&(U.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,U.identifier.id),await this.extensionEnablementService.disableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,U.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,U.identifier.id),await this.extensionEnablementService.enableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,U.identifier.id))),M.push(U.identifier);return}const $=(await this.extensionGalleryService.getExtensions([{...U.identifier,preRelease:U.preRelease}],i.CancellationToken.None))[0];if(U.state&&(O?O.manifest.version===U.version:!!$)&&this.updateExtensionState(U.state,O||$,O?.manifest.version),$)try{this.extensionEnablementService.getDisabledExtensions().some(te=>(0,h.areSameExtensions)(te,U.identifier))!==!!U.disabled&&(U.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,U.identifier.id,$.version),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,U.identifier.id,$.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,U.identifier.id,$.version),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,U.identifier.id,$.version))),(!O||O.preRelease!==U.preRelease)&&(await this.extensionManagementService.canInstall($)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,U.identifier.id,$.version),await this.extensionManagementService.installFromGallery($,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:U.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,U.identifier.id,$.version),M.push($.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,$.displayName||$.identifier.id),T.push(U)))}catch(V){T.push(U),V instanceof I.ExtensionManagementError&&[I.ExtensionManagementErrorCode.Incompatible,I.ExtensionManagementErrorCode.IncompatiblePreRelease,I.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(V.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,$.displayName||$.identifier.id):(this.logService.error(V),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,$.displayName||$.identifier.id))}else T.push(U),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,U.identifier.id)}));const _=[];for(const U of C)M.some(O=>(0,h.areSameExtensions)(O,U.identifier))||_.push(U);for(const U of T)_.some(O=>(0,h.areSameExtensions)(O.identifier,U.identifier))||_.push(U);return _}updateExtensionState(s,u,m){const C=this.extensionStorageService.getExtensionState(u,!0)||{},M=m?this.extensionStorageService.getKeysForSync({id:u.identifier.id,version:m}):void 0;M?M.forEach(T=>{C[T]=s[T]}):Object.keys(s).forEach(T=>C[T]=s[T]),this.extensionStorageService.setExtensionState(u,C,!0)}parseExtensions(s){return JSON.parse(s.content)}getLocalExtensions(s){const u=this.extensionEnablementService.getDisabledExtensions();return s.map(m=>{const{identifier:C,isBuiltin:M,manifest:T,preRelease:F}=m,_={identifier:C,preRelease:F,version:T.version};u.some(U=>(0,h.areSameExtensions)(U,C))&&(_.disabled=!0),M||(_.installed=!0);try{const U=this.extensionStorageService.getKeysForSync({id:C.id,version:T.version});if(U){const O=this.extensionStorageService.getExtensionState(m,!0)||{};_.state=Object.keys(O).reduce(($,V)=>(U.includes(V)&&($[V]=O[V]),$),{})}}catch(U){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,k.getErrorMessage)(U))}return _})}};e.ExtensionsSynchroniser=a,a.EXTENSIONS_DATA_URI=b.URI.from({scheme:t.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),e.ExtensionsSynchroniser=a=r=fe([K(0,D.IEnvironmentService),K(1,v.IFileService),K(2,d.IStorageService),K(3,t.IUserDataSyncStoreService),K(4,t.IUserDataSyncBackupStoreService),K(5,I.IExtensionManagementService),K(6,I.IGlobalExtensionEnablementService),K(7,l.IIgnoredExtensionsManagementService),K(8,t.IUserDataSyncLogService),K(9,I.IExtensionGalleryService),K(10,E.IConfigurationService),K(11,t.IUserDataSyncEnablementService),K(12,g.ITelemetryService),K(13,y.IExtensionStorageService),K(14,S.IUriIdentityService)],a);let c=class extends w.AbstractInitializer{constructor(s,u,m,C,M,T){super("extensions",C,M,m,T);this.extensionManagementService=s,this.ignoredExtensionsManagementService=u}async parseExtensions(s){return s.syncData?await n(s.syncData,this.extensionManagementService):null}generatePreview(s,u){const m=[],C=[],M=[];for(const T of s){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(T.identifier.id))continue;const F=u.find(_=>(0,h.areSameExtensions)(_.identifier,T.identifier));F?(m.push(F),T.disabled&&M.push(T.identifier)):T.installed&&(C.push({...T.identifier,preRelease:!!T.preRelease}),T.disabled&&M.push(T.identifier))}return{installedExtensions:m,newExtensions:C,disabledExtensions:M,remoteExtensions:s}}};e.AbstractExtensionsInitializer=c,e.AbstractExtensionsInitializer=c=fe([K(0,I.IExtensionManagementService),K(1,l.IIgnoredExtensionsManagementService),K(2,v.IFileService),K(3,D.IEnvironmentService),K(4,p.ILogService),K(5,S.IUriIdentityService)],c)}),define(re[245],se([0,1,28,25]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(P,b,E,D,I){if(!b)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const h=L(P,b);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const y=E?L(E,b):{added:Object.keys(b).reduce((S,w)=>(S.add(w),S),new Set),removed:new Set,updated:new Set},v=E?L(E,P):{added:Object.keys(P).reduce((S,w)=>(S.add(w),S),new Set),removed:new Set,updated:new Set},p={added:{},removed:[],updated:{}},d=R.deepClone(b),g=!E;for(const S of v.added.values())S!==i.SYNC_SERVICE_URL_TYPE&&g&&y.added.has(S)||(d[S]=P[S]);for(const S of v.updated.values())d[S]=P[S];for(const S of v.removed.values())D.unregistered.includes(S)||delete d[S];for(const S of y.added.values()){const w=b[S];if(D.machine.includes(S)){I.info(`GlobalState: Skipped adding ${S} in local storage because it is declared as machine scoped.`);continue}if(E&&v.added.has(S))continue;const f=P[S];f&&f.value===w.value||S===i.SYNC_SERVICE_URL_TYPE&&g&&v.added.has(S)||(f?p.updated[S]=w:p.added[S]=w)}for(const S of y.updated.values()){const w=b[S];if(D.machine.includes(S)){I.info(`GlobalState: Skipped updating ${S} in local storage because it is declared as machine scoped.`);continue}if(v.updated.has(S)||v.removed.has(S))continue;const f=P[S];f&&f.value===w.value||(p.updated[S]=w)}for(const S of y.removed.values()){if(D.machine.includes(S)){I.trace(`GlobalState: Skipped removing ${S} in local storage because it is declared as machine scoped.`);continue}v.updated.has(S)||v.removed.has(S)||p.removed.push(S)}return{local:p,remote:A(d,b)?null:d}}e.merge=k;function L(P,b){const E=Object.keys(P),D=Object.keys(b),I=D.filter(v=>E.indexOf(v)===-1).reduce((v,p)=>(v.add(p),v),new Set),h=E.filter(v=>D.indexOf(v)===-1).reduce((v,p)=>(v.add(p),v),new Set),y=new Set;for(const v of E){if(h.has(v))continue;const p=P[v],d=b[v];R.equals(p,d)||y.add(v)}return{added:I,removed:h,updated:y}}function A(P,b){const{added:E,removed:D,updated:I}=L(P,b);return E.size===0&&D.size===0&&I.size===0}}),define(re[246],se([0,1,18,7,3,33,51,4,8,30,17,14,15,9,47,21,22,32,44,58,245,25]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g,S,w,f,l){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",n=["locale"];function a(m,C){const M=m.storage?Object.keys(m.storage).sort():[],T={};return M.forEach(F=>T[F]=m.storage[F]),m.storage=T,C?(0,A.toFormattedString)(m,{}):JSON.stringify(m)}const c=1;let o=t=class extends S.AbstractSynchroniser{constructor(C,M,T,F,_,U,O,$,V,te){super("globalState",C,_,V,M,T,U,O,F,$,te);this.storageService=V,this.version=c,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(C.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(C.onDidFilesChange,H=>H.contains(this.environmentService.argvResource)),k.Event.filter(V.onDidChangeValue,H=>H.scope===0&&H.target!==void 0?H.target===0:V.keys(0,0).includes(H.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(C,M,T){const F=C.syncData?JSON.parse(C.syncData.content):null;M=M===null&&T?C:M;const _=M&&M.syncData?JSON.parse(M.syncData.content):null,U=await this.getLocalGlobalState();F?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const O=this.getStorageKeys(_),{local:$,remote:V}=(0,f.merge)(U.storage,F?F.storage:null,_?_.storage:null,O,this.logService),te={content:null,local:$,remote:V,localChange:Object.keys($.added).length>0||Object.keys($.updated).length>0||$.removed.length>0?2:0,remoteChange:V!==null?2:0};return[{localResource:this.localResource,localContent:a(U,!1),localUserData:U,remoteResource:this.remoteResource,remoteContent:F?a(F,!1):null,previewResource:this.previewResource,previewResult:te,localChange:te.localChange,remoteChange:te.remoteChange,acceptedResource:this.acceptedResource,storageKeys:O}]}async hasRemoteChanged(C){const M=C.syncData?JSON.parse(C.syncData.content):null;if(M===null)return!0;const T=await this.getLocalGlobalState(),F=this.getStorageKeys(M),{remote:_}=(0,f.merge)(T.storage,M.storage,M.storage,F,this.logService);return _!==null}async getMergeResult(C,M){return{...C.previewResult,hasConflicts:!1}}async getAcceptResult(C,M,T,F){if(this.extUri.isEqual(M,this.localResource))return this.acceptLocal(C);if(this.extUri.isEqual(M,this.remoteResource))return this.acceptRemote(C);if(this.extUri.isEqual(M,this.previewResource))return C.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async acceptLocal(C){return{content:C.localContent,local:{added:{},removed:[],updated:{}},remote:C.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(C){if(C.remoteContent!==null){const M=JSON.parse(C.remoteContent),{local:T,remote:F}=(0,f.merge)(C.localUserData.storage,M.storage,null,C.storageKeys,this.logService);return{content:C.remoteContent,local:T,remote:F,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:C.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(C,M,T,F){let{localUserData:_}=T[0][0],{local:U,remote:O,localChange:$,remoteChange:V}=T[0][1];if($===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),$!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(_)),await this.writeLocalGlobalState(U),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),V!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const te=JSON.stringify({storage:O});C=await this.updateRemoteUserData(te,F?null:C.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}M?.ref!==C.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(C),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:C}){return[{resource:this.extUri.joinPath(C,"globalState.json"),comparableResource:t.GLOBAL_STATE_DATA_URI}]}async resolveContent(C){if(this.extUri.isEqual(C,t.GLOBAL_STATE_DATA_URI)){const T=await this.getLocalGlobalState();return a(T,!0)}if(this.extUri.isEqual(this.remoteResource,C)||this.extUri.isEqual(this.localResource,C)||this.extUri.isEqual(this.acceptedResource,C)){const T=await this.resolvePreviewContent(C);return T&&a(JSON.parse(T),!0)}let M=await super.resolveContent(C);if(M)return M;if(M=await super.resolveContent(this.extUri.dirname(C)),M){const T=this.parseSyncData(M);if(T)switch(this.extUri.basename(C)){case"globalState.json":return a(JSON.parse(T.content),!0)}}return null}async hasLocalData(){try{const{storage:C}=await this.getLocalGlobalState();if(Object.keys(C).length>1||C[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const C={},M=await this.getLocalArgvContent(),T=(0,L.parse)(M);for(const F of n)T[F]!==void 0&&(C[`${r}${F}`]={version:1,value:T[F]});for(const F of this.storageService.keys(0,0)){const _=this.storageService.get(F,0);_&&(C[F]={version:1,value:_})}return{storage:C}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const C=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),C.value.toString()}catch(C){this.logService.debug((0,i.getErrorMessage)(C))}return"{}"}async writeLocalGlobalState({added:C,removed:M,updated:T}){const F={},_={},U=($,V)=>{for(const te of $){if(te.startsWith(r)){F[te.substring(r.length)]=V?V[te].value:void 0;continue}if(V){const H=V[te];H.value!==String(this.storageService.get(te,0))&&(_[te]=H.value)}else this.storageService.get(te,0)!==void 0&&(_[te]=void 0)}};if(U(Object.keys(C),C),U(Object.keys(T),T),U(M),Object.keys(F).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(F),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(_).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const $ of Object.keys(_))this.storageService.store($,_[$],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(_))}}async updateArgv(C){const M=await this.getLocalArgvContent();let T=M;for(const F of Object.keys(C))T=(0,w.edit)(T,[F],C[F],{});M!==T&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(T)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(C){const M=this.storageService.keys(0,0),T=this.storageService.keys(0,1),F=[...M,...T],_=C?.storage?Object.keys(C.storage).filter(U=>!U.startsWith(r)&&!F.includes(U)&&this.storageService.get(U,0)!==void 0):[];if(!P.isWeb){const U=[...l.ALL_SYNC_RESOURCES.map(O=>(0,l.getEnablementKey)(O)),l.SYNC_SERVICE_URL_TYPE];_.push(...U),T.push(...U)}return{user:M,machine:T,unregistered:_}}};e.GlobalStateSynchroniser=o,o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),e.GlobalStateSynchroniser=o=t=fe([K(0,h.IFileService),K(1,l.IUserDataSyncStoreService),K(2,l.IUserDataSyncBackupStoreService),K(3,l.IUserDataSyncLogService),K(4,I.IEnvironmentService),K(5,l.IUserDataSyncEnablementService),K(6,d.ITelemetryService),K(7,D.IConfigurationService),K(8,p.IStorageService),K(9,g.IUriIdentityService)],o);let s=class extends S.AbstractInitializer{constructor(C,M,T,F,_){super("globalState",T,F,M,_);this.storageService=C}async doInitialize(C){const M=C.syncData?JSON.parse(C.syncData.content):null;if(!M){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const T={},F={};for(const _ of Object.keys(M.storage))_.startsWith(r)?T[_.substring(r.length)]=M.storage[_].value:this.storageService.get(_,0)===void 0&&(F[_]=M.storage[_].value);if(Object.keys(T).length){let _="{}";try{_=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const U of Object.keys(T))_=(0,w.edit)(_,[U],T[U],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(_))}if(Object.keys(F).length)for(const _ of Object.keys(F))this.storageService.store(_,F[_],0,0)}};e.GlobalStateInitializer=s,e.GlobalStateInitializer=s=fe([K(0,p.IStorageService),K(1,h.IFileService),K(2,I.IEnvironmentService),K(3,l.IUserDataSyncLogService),K(4,g.IUriIdentityService)],s);let u=class{constructor(C,M,T,F,_){this.userDataSyncStoreClient=C,this.storageService=M,this.environmentService=T,this.fileService=F,this.logService=_}getSyncStoreType(C){return this.parseGlobalState(C)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(C){const M=(0,l.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(C,M)}catch(T){if(T instanceof l.UserDataSyncError)switch(T.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(C,M)}throw T}}async doSync(C,M){const T=await this.userDataSyncStoreClient.read("globalState",null,M),F=this.parseGlobalState(T)||{storage:{}};F.storage[l.SYNC_SERVICE_URL_TYPE]={value:C,version:c};const _=await(0,v.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),U={version:c,machineId:_,content:a(F,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(U),T.ref,M)}parseGlobalState({content:C}){if(!C)return null;const M=JSON.parse(C);if((0,S.isSyncData)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=u,e.UserDataSyncStoreTypeSynchronizer=u=fe([K(1,p.IStorageService),K(2,I.IEnvironmentService),K(3,h.IFileService),K(4,y.ILogService)],u)}),define(re[247],se([0,1,16,18,3,33,4,13,160,17,14,15,21,22,32,44,242,25]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function S(l,t,r){try{const n=JSON.parse(l);if(!t)return(0,P.isUndefined)(n.all)?null:n.all;switch(A.OS){case 2:return(0,P.isUndefined)(n.mac)?null:n.mac;case 3:return(0,P.isUndefined)(n.linux)?null:n.linux;case 1:return(0,P.isUndefined)(n.windows)?null:n.windows}}catch(n){return r.error(n),null}}e.getKeybindingsContentFromSyncContent=S;let w=class extends p.AbstractJsonFileSynchroniser{constructor(t,r,n,a,c,o,s,u,m,C,M){super(s.keybindingsResource,"keybindings",o,s,u,t,r,c,C,n,m,a,M);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.filter(a.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(t,r,n,a){const c=t.syncData?S(t.syncData.content,a.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;r=r===null&&n?t:r;const o=r?this.getKeybindingsContentFromLastSyncUserData(r):null,s=await this.getLocalFileContent(),u=await this.getFormattingOptions();let m=null,C=!1,M=!1,T=!1;if(c){let _=s?s.value.toString():"[]";if(_=_||"[]",this.hasErrors(_,!0))throw new g.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==_||o!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const U=await(0,d.merge)(_,c,o,u,this.userDataSyncUtilService);U.hasChanges&&(m=U.mergeContent,T=U.hasConflicts,C=T||U.mergeContent!==_,M=T||U.mergeContent!==c)}}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),m=s.value.toString(),M=!0);const F={content:m,localChange:C?s?2:1:0,remoteChange:M?2:0,hasConflicts:T};return[{fileContent:s,localResource:this.localResource,localContent:s?s.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(t){const r=this.getKeybindingsContentFromLastSyncUserData(t);if(r===null)return!0;const n=await this.getLocalFileContent(),a=n?n.value.toString():"",c=await this.getFormattingOptions(),o=await(0,d.merge)(a||"[]",r,r,c,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==r}async getMergeResult(t,r){return t.previewResult}async getAcceptResult(t,r,n,a){if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?t.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,n,a){const{fileContent:c}=n[0][0];let{content:o,localChange:s,remoteChange:u}=n[0][1];if(s===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o,!0)))throw new g.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(s!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),c&&await this.backupLocal(this.toSyncContent(c.value.toString())),await this.updateLocalFileContent(o||"[]",c,a),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const m=this.toSyncContent(o||"[]",t.syncData?.content);t=await this.updateRemoteUserData(m,a?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(t,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=(0,L.parse)(t.value.toString());if((0,R.isNonEmptyArray)(r))return!0}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"keybindings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const n=this.parseSyncData(r);if(n)switch(this.extUri.basename(t)){case"keybindings.json":return S(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(t){return!t.syncData||t.platformSpecific!==void 0&&t.platformSpecific!==this.syncKeybindingsPerPlatform()?null:S(t.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(t,r){let n={};try{n=JSON.parse(r||"{}")}catch(a){this.logService.error(a)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=t,A.OS){case 2:n.mac=t;break;case 3:n.linux=t;break;case 1:n.windows=t;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};e.KeybindingsSynchroniser=w,e.KeybindingsSynchroniser=w=fe([K(0,g.IUserDataSyncStoreService),K(1,g.IUserDataSyncBackupStoreService),K(2,g.IUserDataSyncLogService),K(3,E.IConfigurationService),K(4,g.IUserDataSyncEnablementService),K(5,I.IFileService),K(6,D.IEnvironmentService),K(7,h.IStorageService),K(8,g.IUserDataSyncUtilService),K(9,y.ITelemetryService),K(10,v.IUriIdentityService)],w);let f=class extends p.AbstractInitializer{constructor(t,r,n,a){super("keybindings",r,n,t,a)}async doInitialize(t){const r=t.syncData?this.getKeybindingsContentFromSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,i.VSBuffer.fromString(r)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource),r=(0,L.parse)(t.value.toString());return!(0,R.isNonEmptyArray)(r)}catch(t){return t.fileOperationResult===1}}getKeybindingsContentFromSyncContent(t){try{return S(t,!0,this.logService)}catch(r){return this.logService.error(r),null}}};e.KeybindingsInitializer=f,e.KeybindingsInitializer=f=fe([K(0,I.IFileService),K(1,D.IEnvironmentService),K(2,g.IUserDataSyncLogService),K(3,v.IUriIdentityService)],f)}),define(re[248],se([0,1,16,33,76,51,28,58,25]),function(J,e,R,i,k,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function E(s,u,m){let C=[];m?C=I(m):C=D(u);const M=[],T=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(C))for(const F of C)F.startsWith("-")?T.push(F.substring(1)):M.push(F);return(0,R.distinct)([...s,...M].filter(F=>T.indexOf(F)===-1))}e.getIgnoredSettings=E;function D(s){let u=s.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=s.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:s.getValue("settingsSync.ignoredSettings")||[]}function I(s){const u=(0,i.parse)(s);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function h(s,u){const m=(0,i.parse)(s)||{};let C="{}";for(const M of Object.keys(m)){const T=(0,k.setProperty)(C,[M],m[M],u);C=(0,k.applyEdits)(C,T)}return C}e.removeComments=h;function y(s,u,m,C){if(m.length){const M=o(u),T=(0,i.parse)(u)||{},F=(0,i.parse)(s);if(!F)return s;const _=[];for(const U of m){const O=T[U],$=F[U];O===void 0?s=P.edit(s,[U],void 0,C):$!==void 0?s=P.edit(s,[U],O,C):_.push(t(U,M))}_.sort((U,O)=>U.startOffset-O.startOffset),_.forEach(U=>s=S(U.setting.key,u,s,C))}return s}e.updateIgnoredSettings=y;function v(s,u,m,C,M,T){const F=y(s,u,C,T),_=m!==F,U=m!==u;if(!_&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(_&&!U)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(U&&!_)return{conflictsSettings:[],localContent:y(u,s,C,T),remoteContent:null,hasConflicts:!1};if(m===null&&d(s)){const N=p(s,u,C)?null:y(u,s,C,T);return{conflictsSettings:[],localContent:N,remoteContent:null,hasConflicts:!1}}let O=s,$=u;const V=(0,i.parse)(s),te=(0,i.parse)(u),H=m?(0,i.parse)(m):null,z=C.reduce((N,x)=>(N.add(x),N),new Set),q=g(V,te,z),j=g(H,V,z),Q=g(H,te,z),G=new Map,X=new Set,Z=N=>{X.add(N);const x=M.filter(({key:Y})=>Y===N)[0];x?(O=P.edit(O,[N],x.value,T),$=P.edit($,[N],x.value,T)):G.set(N,{key:N,localValue:V[N],remoteValue:te[N]})};for(const N of j.removed.values())Q.updated.has(N)?Z(N):$=P.edit($,[N],void 0,T);for(const N of Q.removed.values())X.has(N)||(j.updated.has(N)?Z(N):O=P.edit(O,[N],void 0,T));for(const N of j.updated.values())X.has(N)||(Q.updated.has(N)?q.updated.has(N)&&Z(N):$=P.edit($,[N],V[N],T));for(const N of Q.updated.values())X.has(N)||(j.updated.has(N)?q.updated.has(N)&&Z(N):O=P.edit(O,[N],te[N],T));for(const N of j.added.values())X.has(N)||(Q.added.has(N)?q.updated.has(N)&&Z(N):$=S(N,O,$,T));for(const N of Q.added.values())X.has(N)||(j.added.has(N)?q.updated.has(N)&&Z(N):O=S(N,$,O,T));const W=G.size>0||!p(O,$,C),ee=W||!p(O,s,[]),B=W||!p($,u,[]);return{localContent:ee?O:null,remoteContent:B?$:null,conflictsSettings:[...G.values()],hasConflicts:W}}e.merge=v;function p(s,u,m){if(s===u)return!0;const C=(0,i.parse)(s),M=(0,i.parse)(u),T=m.reduce((U,O)=>(U.add(O),U),new Set),F=o(s).filter(U=>!(U.setting&&T.has(U.setting.key))),_=o(u).filter(U=>!(U.setting&&T.has(U.setting.key)));if(F.length!==_.length)return!1;for(let U=0;U<F.length;U++){const O=F[U],$=_[U];if(O.setting&&$.setting){if(O.setting.key!==$.setting.key||!A.equals(C[O.setting.key],M[O.setting.key]))return!1}else if(!O.setting&&!$.setting){if(O.value!==$.value)return!1}else return!1}return!0}e.areSame=p;function d(s){return s?o(s).length===0:!0}e.isEmpty=d;function g(s,u,m){const C=s?Object.keys(s).filter(U=>!m.has(U)):[],M=Object.keys(u).filter(U=>!m.has(U)),T=M.filter(U=>C.indexOf(U)===-1).reduce((U,O)=>(U.add(O),U),new Set),F=C.filter(U=>M.indexOf(U)===-1).reduce((U,O)=>(U.add(O),U),new Set),_=new Set;if(s)for(const U of C){if(F.has(U))continue;const O=s[U],$=u[U];A.equals(O,$)||_.add(U)}return{added:T,removed:F,updated:_}}function S(s,u,m,C){const M=(0,i.parse)(u),T=o(u),F=o(m),_=w(s,T,F);return f(m,s,M[s],_,F,C)}e.addSetting=S;function w(s,u,m){const C=u.findIndex(T=>T.setting?.key===s),M=u[C-1];if(M){if(M.setting){const F=t(M.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!0}}else{const F=r(C,u);if(F){const _=t(F.setting.key,m);if(_){const U=n(m.indexOf(_),m),O=a(u,F,u[C]);if(U){const $=a(m,_,U),V=c(O,$);return V?{index:m.indexOf(V),insertAfter:!0}:{index:m.indexOf(U),insertAfter:!1}}else{const $=a(m,_,m[m.length-1]),V=c(O,$);return V?{index:m.indexOf(V),insertAfter:!0}:{index:m.length-1,insertAfter:!0}}}}}const T=u[C+1];if(T)if(T.setting){const F=t(T.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!1}}else{const F=n(C,u);if(F){const _=t(F.setting.key,m);if(_){const U=r(m.indexOf(_),m),O=a(u,u[C],F);if(U){const $=a(m,U,_),V=c(O.reverse(),$.reverse());return V?{index:m.indexOf(V),insertAfter:!1}:{index:m.indexOf(U),insertAfter:!0}}else{const $=a(m,m[0],_),V=c(O.reverse(),$.reverse());return V?{index:m.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:m.length-1,insertAfter:!0}}function f(s,u,m,C,M,T){let F;return C.index===-1?F=(0,k.setProperty)(s,[u],m,T):F=l(s,u,m,C,M,T).map(_=>(0,k.withFormatting)(s,_,T)[0]),(0,k.applyEdits)(s,F)}function l(s,u,m,C,M,T){const F=`${JSON.stringify(u)}: ${JSON.stringify(m)}`,_=(0,L.getEOL)(T,s),U=M[C.index];if(C.insertAfter){const O=[];if(U.setting)O.push({offset:U.endOffset,length:0,content:","+F});else{const $=n(C.index,M),V=r(C.index,M),te=V?.setting?.commaOffset;V&&te===void 0&&O.push({offset:V.endOffset,length:0,content:","});const H=te!==void 0&&te>U.endOffset;O.push({offset:H?te+1:U.endOffset,length:0,content:$?_+F+",":_+F})}return O}else{if(U.setting)return[{offset:U.startOffset,length:0,content:F+","}];const O=(M[C.index-1]&&!M[C.index-1].setting?_:"")+F+(n(C.index,M)?",":"")+_;return[{offset:U.startOffset,length:0,content:O}]}}function t(s,u){return u.filter(m=>m.setting?.key===s)[0]}function r(s,u){for(let m=s-1;m>=0;m--)if(u[m].setting)return u[m]}function n(s,u){for(let m=s+1;m<u.length;m++)if(u[m].setting)return u[m]}function a(s,u,m){const C=s.indexOf(u),M=s.indexOf(m);return s.filter((T,F)=>C<F&&F<M)}function c(s,u){if(s.length&&u.length){let m=0;for(;m<u.length&&m<s.length;m++)if(s[m].value!==u[m].value)return u[m-1];return u[m-1]}}function o(s){const u=[];let m=-1,C,M;const T={onObjectBegin:F=>{m++},onObjectProperty:(F,_,U)=>{m===0&&(C=_,M=F)},onObjectEnd:(F,_)=>{m--,m===0&&u.push({startOffset:C,endOffset:F+_,value:s.substring(C,F+_),setting:{key:M,commaOffset:void 0}})},onArrayBegin:(F,_)=>{m++},onArrayEnd:(F,_)=>{m--,m===0&&u.push({startOffset:C,endOffset:F+_,value:s.substring(C,F+_),setting:{key:M,commaOffset:void 0}})},onLiteralValue:(F,_,U)=>{m===0&&u.push({startOffset:C,endOffset:_+U,value:s.substring(C,_+U),setting:{key:M,commaOffset:void 0}})},onSeparator:(F,_,U)=>{if(m===0&&F===","){let O=u.length-1;for(;O>=0&&!u[O].setting;O--);const $=u[O];$&&u.splice(O,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:_}})}},onComment:(F,_)=>{m===0&&u.push({startOffset:F,endOffset:F+_,value:s.substring(F,F+_)})}};return(0,i.visit)(s,T),u}}),define(re[249],se([0,1,18,3,161,17,67,14,29,15,21,22,32,44,58,248,25]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(l){return l&&l.settings&&typeof l.settings=="string"&&Object.keys(l).length===1}function S(l){const t=JSON.parse(l);return g(t)?t:{settings:l}}e.parseSettingsSyncContent=S;let w=class extends y.AbstractJsonFileSynchroniser{constructor(t,r,n,a,c,o,s,u,m,C,M,T){super(r.settingsResource,"settings",t,r,n,a,c,m,C,o,s,u,T);this.extensionManagementService=M,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const r=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(t,r),a=this.getSettingsSyncContent(n),c=new A.ConfigurationModelParser(d.USER_DATA_SYNC_CONFIGURATION_SCOPE);return a?.settings&&c.parse(a.settings),c.configurationModel.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,r,n){const a=await this.getLocalFileContent(),c=await this.getFormattingOptions(),o=this.getSettingsSyncContent(t);r=r===null&&n?t:r;const s=r?this.getSettingsSyncContent(r):null,u=await this.getIgnoredSettings();let m=null,C=!1,M=!1,T=!1;if(o){let _=a?a.value.toString().trim():"{}";_=_||"{}",this.validateContent(_),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const U=(0,p.merge)(_,o.settings,s?s.settings:null,u,[],c);m=U.localContent||U.remoteContent,C=U.localContent!==null,M=U.remoteContent!==null,T=U.hasConflicts}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),m=a.value.toString().trim()||"{}",this.validateContent(m),M=!0);const F={content:m,localChange:C?2:0,remoteChange:M?2:0,hasConflicts:T};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(t){const r=this.getSettingsSyncContent(t);if(r===null)return!0;const n=await this.getLocalFileContent(),a=n?n.value.toString().trim():"",c=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,p.merge)(a||"{}",r.settings,r.settings,c,[],o).remoteContent!==null}async getMergeResult(t,r){const n=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,p.updateIgnoredSettings)(t.previewResult.content,"{}",a,n):null}}async getAcceptResult(t,r,n,a){const c=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,p.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",o,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,p.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,p.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",o,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,n,a){const{fileContent:c}=n[0][0];let{content:o,localChange:s,remoteChange:u}=n[0][1];if(s===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),s!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(o,c,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),u!==0){const m=await this.getFormattingOptions(),C=this.getSettingsSyncContent(t),M=await this.getIgnoredSettings(o);o=(0,p.updateIgnoredSettings)(o,C?C.settings:"{}",M,m),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),a?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),n=(0,v.edit)(t.value.toString(),[d.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,p.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const n=this.parseSyncData(r);if(n){const a=this.parseSettingsSyncContent(n.content);if(a)switch(this.extUri.basename(t)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const n=await this.getFormattingOptions(),a=await this.getIgnoredSettings();r=(0,p.updateIgnoredSettings)(r,"{}",a,n)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return S(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=i.Event.any(i.Event.filter(this.extensionManagementService.onDidInstallExtensions,a=>a.some(({local:c})=>!!c)),i.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,p.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t,!1))throw new d.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=w,e.SettingsSynchroniser=w=fe([K(0,E.IFileService),K(1,P.IEnvironmentService),K(2,D.IStorageService),K(3,d.IUserDataSyncStoreService),K(4,d.IUserDataSyncBackupStoreService),K(5,d.IUserDataSyncLogService),K(6,d.IUserDataSyncUtilService),K(7,L.IConfigurationService),K(8,d.IUserDataSyncEnablementService),K(9,I.ITelemetryService),K(10,b.IExtensionManagementService),K(11,h.IUriIdentityService)],w);let f=class extends y.AbstractInitializer{constructor(t,r,n,a){super("settings",r,n,t,a)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,p.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return S(t)}catch(r){this.logService.error(r)}return null}};e.SettingsInitializer=f,e.SettingsInitializer=f=fe([K(0,E.IFileService),K(1,P.IEnvironmentService),K(2,d.IUserDataSyncLogService),K(3,h.IUriIdentityService)],f)}),define(re[250],se([0,1,18,3,28,17,14,15,21,22,32,44,243,25]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let v=class extends I.AbstractSynchroniser{constructor(g,S,w,f,l,t,r,n,a,c){super("snippets",S,g,w,f,l,n,a,t,r,c);this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(i.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,S,w){const f=await this.getSnippetsFileContents(),l=this.toSnippetsContents(f),t=g.syncData?this.parseSnippets(g.syncData):null;S=S===null&&w?g:S;const r=S&&S.syncData?this.parseSnippets(S.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,h.merge)(l,t,r);return this.getResourcePreviews(n,f,t||{})}async hasRemoteChanged(g){const S=g.syncData?this.parseSnippets(g.syncData):null;if(S===null)return!0;const w=await this.getSnippetsFileContents(),f=this.toSnippetsContents(w),l=(0,h.merge)(f,S,S);return Object.keys(l.remote.added).length>0||Object.keys(l.remote.updated).length>0||l.remote.removed.length>0||l.conflicts.length>0}async getMergeResult(g,S){return g.previewResult}async getAcceptResult(g,S,w,f){if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder))return w===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:w,localChange:w===null?g.fileContent!==null?3:0:2,remoteChange:w===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${S.toString()}`)}async applyResult(g,S,w,f){const l=w.map(([t,r])=>({...t,acceptResult:r}));l.every(({localChange:t,remoteChange:r})=>t===0&&r===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:t})=>t!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,f)),l.some(({remoteChange:t})=>t!==0)&&(g=await this.updateRemoteSnippets(l,g,f)),S?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:t}of l)try{await this.fileService.del(t)}catch{}}getResourcePreviews(g,S,w){const f=new Map;for(const l of Object.keys(g.local.added)){const t={content:g.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};f.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.local.updated)){const t={content:g.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};f.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[l],localContent:S[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0};f.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[l],localContent:S[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.added)){const t={content:g.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};f.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[l],localContent:S[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.updated)){const t={content:g.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};f.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[l],localContent:S[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};f.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.conflicts){const t={content:S[l]?S[l].value.toString():null,hasConflicts:!0,localChange:S[l]?2:1,remoteChange:w[l]?2:1};f.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[l]||null,localContent:S[l]?S[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(S))if(!f.has(l)){const t={content:S[l]?S[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};f.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[l]||null,localContent:S[l]?S[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...f.values()]}async getAssociatedResources({uri:g}){let S=await super.resolveContent(g);if(S){const w=this.parseSyncData(S);if(w){const f=this.parseSnippets(w),l=[];for(const t of Object.keys(f)){const r=this.extUri.joinPath(g,t),n=this.extUri.joinPath(this.snippetsFolder,t),a=await this.fileService.exists(n);l.push({resource:r,comparableResource:a?n:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let S=await super.resolveContent(g);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(g)),S){const w=this.parseSyncData(S);if(w)return this.parseSnippets(w)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const S={};for(const w of g)w.fileContent&&(S[this.extUri.basename(w.localResource)]=w.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(S)))}async updateLocalSnippets(g,S){for(const{fileContent:w,acceptResult:f,localResource:l,remoteResource:t,localChange:r}of g)if(r!==0){const n=t?this.extUri.basename(t):this.extUri.basename(l),a=this.extUri.joinPath(this.snippetsFolder,n);r===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(a)),await this.fileService.del(a),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(a))):r===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(a)),await this.fileService.createFile(a,R.VSBuffer.fromString(f.content),{overwrite:S}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(a))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(a)),await this.fileService.writeFile(a,R.VSBuffer.fromString(f.content),S?void 0:w),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(a)))}}async updateRemoteSnippets(g,S,w){const f=S.syncData?this.parseSnippets(S.syncData):{},l=(0,k.deepClone)(f);for(const{acceptResult:t,localResource:r,remoteResource:n,remoteChange:a}of g)if(a!==0){const c=r?this.extUri.basename(r):this.extUri.basename(n);a===3?delete l[c]:l[c]=t.content}return(0,h.areSame)(f,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),S=await this.updateRemoteUserData(JSON.stringify(l),w?null:S.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),S}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const S={};for(const w of Object.keys(g))S[w]=g[w].value.toString();return S}async getSnippetsFileContents(){const g={};let S;try{S=await this.fileService.resolve(this.snippetsFolder)}catch(w){if(w instanceof P.FileOperationError&&w.fileOperationResult===1)return g;throw w}for(const w of S.children||[]){const f=w.resource,l=this.extUri.extname(f);if(l===".json"||l===".code-snippets"){const t=this.extUri.relativePath(this.snippetsFolder,f),r=await this.fileService.readFile(f);g[t]=r}}return g}};e.SnippetsSynchroniser=v,e.SnippetsSynchroniser=v=fe([K(0,A.IEnvironmentService),K(1,P.IFileService),K(2,b.IStorageService),K(3,y.IUserDataSyncStoreService),K(4,y.IUserDataSyncBackupStoreService),K(5,y.IUserDataSyncLogService),K(6,L.IConfigurationService),K(7,y.IUserDataSyncEnablementService),K(8,E.ITelemetryService),K(9,D.IUriIdentityService)],v);let p=class extends I.AbstractInitializer{constructor(g,S,w,f){super("snippets",S,w,g,f)}async doInitialize(g){const S=g.syncData?JSON.parse(g.syncData.content):null;if(!S){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const f of Object.keys(S)){const l=S[f];if(l){const t=this.extUri.joinPath(this.environmentService.snippetsHome,f);await this.fileService.createFile(t,R.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(t))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};e.SnippetsInitializer=p,e.SnippetsInitializer=p=fe([K(0,P.IFileService),K(1,A.IEnvironmentService),K(2,y.IUserDataSyncLogService),K(3,D.IUriIdentityService)],p)}),define(re[251],se([0,1,18,17,14,15,21,22,32,44,25]),function(J,e,R,i,k,L,A,P,b,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function I(p,d){try{return JSON.parse(p).tasks}catch(g){return d.error(g),null}}e.getTasksContentFromSyncContent=I;let h=class extends E.AbstractFileSynchroniser{constructor(d,g,S,w,f,l,t,r,n,a){super(a.extUri.joinPath(a.extUri.dirname(t.settingsResource),"tasks.json"),"tasks",l,t,r,d,g,f,n,S,w,a);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.localResource=this.previewResource.with({scheme:D.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:D.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:D.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(d,g,S,w){const f=d.syncData?I(d.syncData.content,this.logService):null;g=g===null&&S?d:g;const l=g?.syncData?I(g.syncData.content,this.logService):null,t=await this.getLocalFileContent();let r=null,n=!1,a=!1,c=!1;if(f){const s=t?t.value.toString():null;if(!l||l!==s||l!==f){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const u=v(s,f,l);r=u.content,c=u.hasConflicts,n=u.hasLocalChanged,a=u.hasRemoteChanged}}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),r=t.value.toString(),a=!0);const o={content:r,localChange:n?t?2:1:0,remoteChange:a?2:0,hasConflicts:c};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:o.localChange,remoteResource:this.remoteResource,remoteContent:f,remoteChange:o.remoteChange,previewResource:this.previewResource,previewResult:o,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(d){const g=d?.syncData?I(d.syncData.content,this.logService):null;if(g===null)return!0;const S=await this.getLocalFileContent(),w=S?S.value.toString():null,f=v(w,g,g);return f.hasLocalChanged||f.hasRemoteChanged}async getMergeResult(d,g){return d.previewResult}async getAcceptResult(d,g,S,w){if(this.extUri.isEqual(g,this.localResource))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:d.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return S===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:S,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(d,g,S,w){const{fileContent:f}=S[0][0];let{content:l,localChange:t,remoteChange:r}=S[0][1];if(t===0&&r===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),t!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),f&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(f.value.toString()))),await this.updateLocalFileContent(l||"{}",f,w),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),r!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const n=JSON.stringify(this.toTasksSyncContent(l||"{}"));d=await this.updateRemoteUserData(n,w?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:d}){const g=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(d,"tasks.json"),comparableResource:g}]}async resolveContent(d){if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let g=await super.resolveContent(d);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(d)),g){const S=this.parseSyncData(g);if(S)switch(this.extUri.basename(d)){case"tasks.json":return I(S.content,this.logService)}}return null}toTasksSyncContent(d){return{tasks:d}}};e.TasksSynchroniser=h,e.TasksSynchroniser=h=fe([K(0,D.IUserDataSyncStoreService),K(1,D.IUserDataSyncBackupStoreService),K(2,D.IUserDataSyncLogService),K(3,i.IConfigurationService),K(4,D.IUserDataSyncEnablementService),K(5,L.IFileService),K(6,k.IEnvironmentService),K(7,A.IStorageService),K(8,P.ITelemetryService),K(9,b.IUriIdentityService)],h);let y=class extends E.AbstractInitializer{constructor(d,g,S,w){super("tasks",g,S,d,w);this.uriIdentityService=w,this.tasksResource=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(this.environmentService.settingsResource),"tasks.json")}async doInitialize(d){const g=d.syncData?I(d.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,R.VSBuffer.fromString(g)),await this.updateLastSyncUserData(d)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=y,e.TasksInitializer=y=fe([K(0,L.IFileService),K(1,k.IEnvironmentService),K(2,D.IUserDataSyncLogService),K(3,b.IUriIdentityService)],y);function v(p,d,g){if(p===null&&d===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(p===d)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const S=g!==p,w=g!==d;return!S&&!w?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:S&&!w?{content:p,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:w&&!S?{content:d,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:p,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[72],se([0,1,3,2,5,25]),function(J,e,R,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,k.createDecorator)("IUserDataSyncAccountService");let A=class extends i.Disposable{get account(){return this._account}constructor(b,E){super();this.userDataSyncStoreService=b,this.logService=E,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};e.UserDataSyncAccountService=A,e.UserDataSyncAccountService=A=fe([K(0,L.IUserDataSyncStoreService),K(1,L.IUserDataSyncLogService)],A)}),define(re[252],se([0,1,6,18,61,2,20,17,14,15,25]),function(J,e,R,i,k,L,A,P,b,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let I=class extends L.Disposable{constructor(y,v,p,d){super();this.environmentService=y,this.fileService=v,this.configurationService=p,this.logService=d,D.ALL_SYNC_RESOURCES.forEach(g=>this.cleanUpBackup(g))}async getAllRefs(y){const v=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),p=await this.fileService.resolve(v);return p.children?p.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.getCreationTime(g)})):[]}async resolveContent(y,v){if(!v){const p=await this.getAllRefs(y);p.length&&(v=p[p.length-1].ref)}if(v){const p=(0,A.joinPath)(this.environmentService.userDataSyncHome,y,v);return(await this.fileService.readFile(p)).value.toString()}return null}async backup(y,v){const p=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),d=(0,A.joinPath)(p,`${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(d,i.VSBuffer.fromString(v))}catch(g){this.logService.error(g)}try{this.cleanUpBackup(y)}catch{}}async cleanUpBackup(y){const v=(0,A.joinPath)(this.environmentService.userDataSyncHome,y);try{try{if(!await this.fileService.exists(v))return}catch{return}const p=await this.fileService.resolve(v);if(p.children){const d=p.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort(),g=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let S=d.filter(f=>Date.now()-this.getCreationTime(f)>g);const w=d.length-S.length;w<10&&(S=S.slice(10-w)),await R.Promises.settled(S.map(async f=>{this.logService.info("Deleting from backup",f.resource.path),await this.fileService.del(f.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(y){return y.ctime||new Date(parseInt(y.name.substring(0,4)),parseInt(y.name.substring(4,6))-1,parseInt(y.name.substring(6,8)),parseInt(y.name.substring(9,11)),parseInt(y.name.substring(11,13)),parseInt(y.name.substring(13,15))).getTime()}};e.UserDataSyncBackupStoreService=I,e.UserDataSyncBackupStoreService=I=fe([K(0,b.IEnvironmentService),K(1,E.IFileService),K(2,P.IConfigurationService),K(3,D.IUserDataSyncLogService)],I)}),define(re[253],se([0,1,3,2,4,14,21,22,25]),function(J,e,R,i,k,L,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let D=class extends i.Disposable{constructor(h,y,v,p){super();this.storageService=h,this.telemetryService=y,this.environmentService=v,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(h.onDidChangeValue(d=>this.onDidStorageChange(d)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(h){h&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:h}),this.storageService.store(E,h,0,1))}isResourceEnabled(h){return this.storageService.getBoolean((0,b.getEnablementKey)(h),0,!0)}setResourceEnablement(h,y){if(this.isResourceEnabled(h)!==y){const v=(0,b.getEnablementKey)(h);this.storeResourceEnablement(v,y)}}getResourceSyncStateVersion(h){}storeResourceEnablement(h,y){this.storageService.store(h,y,0,k.isWeb?0:1)}onDidStorageChange(h){if(h.scope!==0)return;if(E===h.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const y=b.ALL_SYNC_RESOURCES.filter(v=>(0,b.getEnablementKey)(v)===h.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}};e.UserDataSyncEnablementService=D,e.UserDataSyncEnablementService=D=fe([K(0,A.IStorageService),K(1,P.ITelemetryService),K(2,L.IEnvironmentService),K(3,b.IUserDataSyncStoreManagementService)],D)}),define(re[254],se([0,1,2,8]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(h){this.service=h}listen(h,y){switch(y){case"onError":return this.service.onError}throw new Error(`Event not found: ${y}`)}call(h,y,v){switch(y){case"triggerSync":return this.service.triggerSync(v[0],v[1],v[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(v[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class L{constructor(h){this.service=h}listen(h,y){throw new Error(`Event not found: ${y}`)}call(h,y,v){switch(y){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(v[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(i.URI.revive(v[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class A{constructor(h){this.channel=h}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(h){return this.channel.call("resolveUserKeybindings",[h])}async resolveFormattingOptions(h){return this.channel.call("resolveFormattingOptions",[h])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(h){this.service=h}listen(h,y){switch(y){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${y}`)}async call(h,y,v){switch(y){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(v[0],v[1]);case"setEnablements":return this.service.setEnablements(v)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class b{constructor(h){this.service=h}listen(h,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(h,y,v){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(v)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class E{constructor(h){this.service=h}listen(h,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(h,y,v){switch(y){case"switch":return this.service.switch(v[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class D extends R.Disposable{constructor(h){super();this.channel=h,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(h){return this.channel.call("switch",[h])}async getPreviousUserDataSyncStore(){const h=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(h)}revive(h){return{url:i.URI.revive(h.url),type:h.type,defaultUrl:i.URI.revive(h.defaultUrl),insidersUrl:i.URI.revive(h.insidersUrl),stableUrl:i.URI.revive(h.stableUrl),canSwitch:h.canSwitch,authenticationProviders:h.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=D}),define(re[255],se([0,1,14,9]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends i.AbstractLogger{constructor(A,P){super();this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};e.UserDataSyncLogService=k,e.UserDataSyncLogService=k=fe([K(0,i.ILoggerService),K(1,R.IEnvironmentService)],k)}),define(re[73],se([0,1,3,2,4,26,164,14,15,5,24,47,21,25]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const p="sync.currentMachineName",d="Safari",g="Chrome",S="Edge",w="Firefox",f="Android";function l(n){switch(n){case d:case g:case S:case w:case f:case(0,k.PlatformToString)(0):return!0}return!1}e.isWebPlatform=l;function t(){return k.isSafari?d:k.isChrome?g:k.isEdge?S:k.isFirefox?w:k.isAndroid?f:(0,k.PlatformToString)(k.isWeb?0:k.platform)}let r=v=class extends i.Disposable{constructor(a,c,o,s,u,m){super();this.storageService=o,this.userDataSyncStoreService=s,this.logService=u,this.productService=m,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,I.getServiceMachineId)(a,c,o)}async getMachines(a){const c=await this.currentMachineIdPromise;return(await this.readMachinesData(a)).machines.map(s=>({...s,isCurrent:s.id===c}))}async addCurrentMachine(a){const c=await this.currentMachineIdPromise,o=await this.readMachinesData(a);o.machines.some(({id:s})=>s===c)||(o.machines.push({id:c,name:this.computeCurrentMachineName(o.machines),platform:t()}),await this.writeMachinesData(o))}async removeCurrentMachine(a){const c=await this.currentMachineIdPromise,o=await this.readMachinesData(a),s=o.machines.filter(({id:u})=>u!==c);s.length!==o.machines.length&&(o.machines=s,await this.writeMachinesData(o))}async renameMachine(a,c,o){const s=await this.readMachinesData(o),u=s.machines.find(({id:m})=>m===a);if(u){u.name=c,await this.writeMachinesData(s);const m=await this.currentMachineIdPromise;a===m&&this.storageService.store(p,c,0,1)}}async setEnablements(a){const c=await this.readMachinesData();for(const[o,s]of a){const u=c.machines.find(m=>m.id===o);u&&(u.disabled=s?void 0:!0)}await this.writeMachinesData(c)}computeCurrentMachineName(a){const c=this.storageService.get(p,0);if(c)return c;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${t()} (${this.productService.nameShort})`,s=new RegExp(`${(0,L.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let u=0;for(const m of a){const C=s.exec(m.name),M=C?parseInt(C[1]):0;u=M>u?M:u}return`${o} #${u+1}`}async readMachinesData(a){this.userData=await this.readUserData(a);const c=this.parse(this.userData);if(c.version!==v.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return c}async writeMachinesData(a){const c=JSON.stringify(a),o=await this.userDataSyncStoreService.write(v.RESOURCE,c,this.userData?.ref||null);this.userData={ref:o,content:c},this._onDidChange.fire()}async readUserData(a){if(this.userData){const c=a&&a.latest?a.latest[v.RESOURCE]:void 0;if(this.userData.ref===c)return this.userData;if(c===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(v.RESOURCE,this.userData)}parse(a){if(a.content!==null)try{return JSON.parse(a.content)}catch(c){this.logService.error(c)}return{version:v.VERSION,machines:[]}}};e.UserDataSyncMachinesService=r,r.VERSION=1,r.RESOURCE="machines",e.UserDataSyncMachinesService=r=v=fe([K(0,P.IEnvironmentService),K(1,b.IFileService),K(2,h.IStorageService),K(3,y.IUserDataSyncStoreService),K(4,y.IUserDataSyncLogService),K(5,D.IProductService)],r)}),define(re[256],se([0,1,6,61,36,7,3,2,4,20,8,162,24,21,22,25,72,73]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const S="sync.disableMachineEventually",w="sync.sessionId",f="sync.storeUrl",l="sync.productQuality";let t=class extends P.Disposable{get syncUrl(){const a=this.storageService.get(f,0);return a?D.URI.parse(a):void 0}set syncUrl(a){a?this.storageService.store(f,a.toString(),0,1):this.storageService.remove(f,0)}get productQuality(){return this.storageService.get(l,0)}set productQuality(a){a?this.storageService.store(l,a,0,1):this.storageService.remove(l,0)}constructor(a,c,o,s,u,m,C,M,T,F){super();this.userDataSyncStoreManagementService=c,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=s,this.userDataSyncService=u,this.logService=m,this.userDataSyncAccountService=C,this.telemetryService=M,this.userDataSyncMachinesService=T,this.storageService=F,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new R.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=c.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=a.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(c.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,c.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=c.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(C.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(u.onDidChangeLocal(_=>this.triggerSync([_],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,_])=>_)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:a,message:c}=this.isAutoSyncEnabled();a?this.autoSync.value===void 0&&(this.autoSync.value=new r(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(c&&this.logService.info(c),this.autoSync.clear()):c&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(c))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(a,c,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(w,0),a?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(s){if(c)this.logService.error(s),this.updateEnablement(!1);else throw s}}updateEnablement(a){this.userDataSyncEnablementService.isEnabled()!==a&&(this.userDataSyncEnablementService.setEnablement(a),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(a){if(!a){this.successiveFailures=0;return}const c=p.UserDataSyncError.toUserDataSyncError(a);c instanceof p.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:c.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),c.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):c.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):c.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):c.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):c.code==="UpgradeRequired"||c.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):c.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${c.resource} content with newer version than of client. Requires client upgrade.`)):c.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${c.resource} content with older version than of client. Requires server reset.`)):c.code==="ServiceChanged"||c.code==="DefaultServiceChanged"?b.isWeb&&c.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(c),this.successiveFailures++),this._onError.fire(c)}async disableMachineEventually(){this.storageService.store(S,!0,0,1),await(0,R.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(S,0,!1)}stopDisableMachineEventually(){this.storageService.remove(S,0)}async triggerSync(a,c,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(c&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...a),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=t,e.UserDataAutoSyncService=t=fe([K(0,h.IProductService),K(1,p.IUserDataSyncStoreManagementService),K(2,p.IUserDataSyncStoreService),K(3,p.IUserDataSyncEnablementService),K(4,p.IUserDataSyncService),K(5,p.IUserDataSyncLogService),K(6,d.IUserDataSyncAccountService),K(7,v.ITelemetryService),K(8,g.IUserDataSyncMachinesService),K(9,y.IStorageService)],t);class r extends P.Disposable{constructor(a,c,o,s,u,m,C,M){super();this.lastSyncUrl=a,this.interval=c,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=s,this.userDataSyncService=u,this.userDataSyncMachinesService=m,this.logService=C,this.storageService=M,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(r.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(r.INTERVAL_SYNCING,!1),this.interval)}sync(a,c){const o=(0,R.createCancelablePromise)(async s=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,L.isCancellationError)(u))return}return this.doSync(a,c,s)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const a=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),c=this.userDataSyncStoreManagementService.userDataSyncStore;return!!c&&!!a&&(!(0,E.isEqual)(c.defaultUrl,a.defaultUrl)||!(0,E.isEqual)(c.insidersUrl,a.insidersUrl)||!(0,E.isEqual)(c.stableUrl,a.stableUrl))}async doSync(a,c,o){this.logService.info(`Auto Sync: Triggered by ${a}`),this._onDidStartSync.fire();let s;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,c),o.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,I.localize)(0,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,I.localize)(1,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,I.localize)(2,null),"TurnedOff");const u=this.storageService.get(w,0);if(u&&this.manifest&&u!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,I.localize)(3,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,I.localize)(4,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,I.localize)(5,null),"SessionExpired");const m=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(o.isCancellationRequested)return;const C=m.find(M=>M.isCurrent);if(C?.disabled)throw new p.UserDataAutoSyncError((0,I.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(M){throw new p.UserDataAutoSyncError((0,k.toErrorMessage)(M),M instanceof p.UserDataSyncError?M.code:"Unknown")}if(this.manifest&&this.manifest.session!==u&&this.storageService.store(w,this.manifest.session,0,1),o.isCancellationRequested)return;C||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(u){this.logService.error(u),s=u}this._onDidFinishSync.fire(s)}register(a){return super._register(a)}}r.INTERVAL_SYNCING="Interval"}),define(re[257],se([0,1,16,6,36,3,2,20,13,30,17,29,5,21,22,244,246,247,249,250,251,25]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g,S,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const t="sync.lastSyncTime";let r=class extends A.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(s,u,m,C,M,T,F,_){super();this.userDataSyncStoreService=s,this.userDataSyncStoreManagementService=u,this.instantiationService=m,this.configurationService=C,this.logService=M,this.telemetryService=T,this.storageService=F,this.userDataSyncEnablementService=_,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(t,0,void 0)}async createSyncTask(s,u){this.checkEnablement();const m=(0,E.generateUuid)();try{const _=(0,l.createSyncHeaders)(m);u&&(_["Cache-Control"]="no-cache"),s=await this.userDataSyncStoreService.manifest(s,_)}catch(_){const U=l.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(U,m),U}let C=!1;const M=this,T=this.getEnabledSynchronizers();let F;return{manifest:s,async run(){if(C)throw new Error("Can run a task only once");return F=(0,i.createCancelablePromise)(_=>M.sync(T,s,m,_)),F.finally(()=>F=void 0)},async stop(){if(F&&F.cancel(),M.status!=="idle")return M.stop(T)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new l.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const s=(0,E.generateUuid)(),u=(0,l.createSyncHeaders)(s);let m;try{m=await this.userDataSyncStoreService.manifest(null,u)}catch(T){const F=l.UserDataSyncError.toUserDataSyncError(T);throw this.reportUserDataSyncError(F,s),F}await this.resetLocal();const C=this.getEnabledSynchronizers(),M=async()=>{await this.stop(C),await this.resetLocal()};return new n(s,m,u,C,M,this.configurationService,this.logService)}async sync(s,u,m,C){if(C.isCancellationRequested||!s.length)return;const M=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const T=(0,l.createSyncHeaders)(m);for(const F of s){if(C.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(F.resource))return;try{await F.sync(u,T)}catch(_){let U=!1;if(_ instanceof l.UserDataSyncError)switch(_.code){case"TooLarge":_=new l.UserDataSyncError(_.message,_.code,F.resource),U=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":U=!0;break}const O=l.UserDataSyncError.toUserDataSyncError(_);if(this.reportUserDataSyncError(O,m),U)throw O;this.logService.error(_),this.logService.error(`${F.resource}: ${(0,k.toErrorMessage)(_)}`),this._syncErrors.push([F.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-M}ms`),this.updateLastSyncTime()}catch(T){const F=l.UserDataSyncError.toUserDataSyncError(T);throw this.reportUserDataSyncError(F,m),F}finally{this.updateStatus(s),this._onSyncErrors.fire(this._syncErrors)}}async stop(s){if(this.status!=="idle")for(const u of s)try{u.status!=="idle"&&await u.stop()}catch(m){this.logService.error(m)}}async replace(s){this.checkEnablement(),await this.performSynchronizerAction(async u=>{if(await u.replace(s))return!0})}async accept(s,u,m,C){this.checkEnablement(),await this.performSynchronizerAction(async M=>{if(M.resource===s)return await M.accept(u,m),C&&await M.apply(!1,(0,l.createSyncHeaders)((0,E.generateUuid)())),!0})}async resolveContent(s){return this.performSynchronizerAction(async u=>{const m=await u.resolveContent(s);if(m)return m})}async getRemoteSyncResourceHandles(s){return await this.performSynchronizerAction(async m=>{if(m.resource===s)return m.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(s){return await this.performSynchronizerAction(async m=>{if(m.resource===s)return m.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(s,u){return await this.performSynchronizerAction(async C=>{if(C.resource===s)return C.getAssociatedResources(u)})||[]}async getMachineId(s,u){return await this.performSynchronizerAction(async C=>{if(C.resource===s)return await C.getMachineId(u)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async u=>{if(u.resource!=="globalState"&&await u.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async u=>{if(await u.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(s){this.logService.error(s)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(t,0),this.synchronizers.value){for(const s of this.synchronizers.value.enabled)try{await s.resetLocal()}catch(u){this.logService.error(`${s.resource}: ${(0,k.toErrorMessage)(u)}`),this.logService.error(u)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(s){const u=new A.DisposableStore;try{const m=this.synchronizers.value||u.add(this.instantiationService.createInstance(a,()=>{},()=>{},()=>{})),C=[...m.enabled,...m.disabled.map(M=>u.add(m.createSynchronizer(M)))];for(const M of C){const T=await s(M);if(!(0,b.isUndefined)(T))return T}return null}finally{u.dispose()}}setStatus(s){const u=this._status;this._status!==s&&(this._status=s,this._onDidChangeStatus.fire(s),u==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(s){this.updateConflicts(s);const u=this.computeStatus(s);this.setStatus(u)}updateConflicts(s){const u=this.computeConflicts(s);(0,R.equals)(this._conflicts,u,([m,C],[M,T])=>m===m&&(0,R.equals)(C,T,(F,_)=>(0,P.isEqual)(F.previewResource,_.previewResource)))||(this._conflicts=this.computeConflicts(s),this._onDidChangeConflicts.fire(u))}computeConflicts(s){return s.filter(u=>u.status==="hasConflicts").map(u=>[u.resource,u.conflicts.map(c)])}computeStatus(s){return this.userDataSyncStoreManagementService.userDataSyncStore?s.some(u=>u.status==="hasConflicts")?"hasConflicts":s.some(u=>u.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(t,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(s,u){this.telemetryService.publicLog2("sync/error",{code:s.code,serverCode:s instanceof l.UserDataSyncStoreError?String(s.serverCode):void 0,url:s instanceof l.UserDataSyncStoreError?s.url:void 0,resource:s.resource,executionId:u,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(a,s=>this.updateStatus(s),s=>this.updateConflicts(s),s=>this._onDidChangeLocal.fire(s))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=r,e.UserDataSyncService=r=fe([K(0,l.IUserDataSyncStoreService),K(1,l.IUserDataSyncStoreManagementService),K(2,h.IInstantiationService),K(3,D.IConfigurationService),K(4,l.IUserDataSyncLogService),K(5,v.ITelemetryService),K(6,y.IStorageService),K(7,l.IUserDataSyncEnablementService)],r);class n extends A.Disposable{get status(){return this.synchronisers.some(s=>s.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(s=>s.status==="syncing")?"syncing":"idle"}constructor(s,u,m,C,M,T,F){super();this.id=s,this.manifest=u,this.syncHeaders=m,this.synchronisers=C,this.onStop=M,this.configurationService=T,this.logService=F,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,i.createCancelablePromise)(s=>this.getPreviews(s))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(s){throw this.logService.error(s),s}}async accept(s,u){try{return await this.performAction(s,m=>m.accept(s,u))}catch(m){throw this.logService.error(m),m}}async merge(s){try{return s?await this.performAction(s,u=>u.merge(s)):await this.mergeAll()}catch(u){throw this.logService.error(u),u}}async discard(s){try{return await this.performAction(s,u=>u.discard(s))}catch(u){throw this.logService.error(u),u}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const s=[];for(const[,u]of this.previews)for(const m of u.resourcePreviews)m.mergeState==="conflict"&&s.push(m.previewResource);for(const u of s)await this.discard(u);return this.previews}catch(s){throw this.logService.error(s),s}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const s=[];for(const[u,m]of this.previews){this.synchronizingResources.push([u,m.resourcePreviews.map(T=>T.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const C=this.synchronisers.find(T=>T.resource===u);for(const T of m.resourcePreviews)(T.localChange!==0||T.remoteChange!==0)&&T.mergeState==="preview"&&await C.merge(T.previewResource);const M=await C.apply(!1,this.syncHeaders);M&&s.push(this.toSyncResourcePreview(C.resource,M)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(T=>T[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}catch(s){throw this.logService.error(s),s}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,u]of this.previews){this.synchronizingResources.push([s,u.resourcePreviews.map(C=>C.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const m=this.synchronisers.find(C=>C.resource===s);for(const C of u.resourcePreviews)await m.accept(C.remoteResource);await m.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(C=>C[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,u]of this.previews){this.synchronizingResources.push([s,u.resourcePreviews.map(C=>C.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const m=this.synchronisers.find(C=>C.resource===s);for(const C of u.resourcePreviews)await m.accept(C.localResource);await m.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(C=>C[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async stop(){await this.onStop(),this.reset()}async performAction(s,u){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const m=this.previews.findIndex(([,$])=>$.resourcePreviews.some(({localResource:V,previewResource:te,remoteResource:H})=>(0,P.isEqual)(s,V)||(0,P.isEqual)(s,te)||(0,P.isEqual)(s,H)));if(m===-1)return this.previews;const[C,M]=this.previews[m],T=M.resourcePreviews.find(({localResource:$,remoteResource:V,previewResource:te})=>(0,P.isEqual)($,s)||(0,P.isEqual)(V,s)||(0,P.isEqual)(te,s));if(!T)return this.previews;let F=this.synchronizingResources.find($=>$[0]===C);F||(F=[C,[]],this.synchronizingResources.push(F)),F[1].some($=>(0,P.isEqual)($,T.localResource))||(F[1].push(T.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const _=this.synchronisers.find($=>$.resource===this.previews[m][0]),U=await u(_);U?this.previews.splice(m,1,this.toSyncResourcePreview(_.resource,U)):this.previews.splice(m,1);const O=this.synchronizingResources.findIndex($=>$[0]===C);return this.synchronizingResources[O][1].splice(F[1].findIndex($=>(0,P.isEqual)($,T.localResource)),1),F[1].length||(this.synchronizingResources.splice(O,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const s=[];for(const[u,m]of this.previews){this.synchronizingResources.push([u,m.resourcePreviews.map(T=>T.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const C=this.synchronisers.find(T=>T.resource===u);let M=m;for(const T of m.resourcePreviews)(T.localChange!==0||T.remoteChange!==0)&&T.mergeState==="preview"&&(M=await C.merge(T.previewResource));M&&s.push(this.toSyncResourcePreview(C.resource,M)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(T=>T[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}async getPreviews(s){const u=[],m=await this.getUserDataSyncConfiguration();for(const C of this.synchronisers){if(s.isCancellationRequested)return[];const M=await C.preview(this.manifest,m,this.syncHeaders);M&&u.push(this.toSyncResourcePreview(C.resource,M))}return u}async getUserDataSyncConfiguration(){const s=this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE),u=this.synchronisers.find(m=>m instanceof S.SettingsSynchroniser);if(u){const m=await u.getRemoteUserDataSyncConfiguration(this.manifest);return{...s,...m}}return s}toSyncResourcePreview(s,u){return[s,{isLastSyncFromCurrentMachine:u.isLastSyncFromCurrentMachine,resourcePreviews:u.resourcePreviews.map(c)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let a=class extends A.Disposable{get enabled(){return this._enabled.sort((s,u)=>s[1]-u[1]).map(([s])=>s)}get disabled(){return l.ALL_SYNC_RESOURCES.filter(s=>!this.userDataSyncEnablementService.isResourceEnabled(s))}constructor(s,u,m,C,M,T,F){super();this.onDidChangeStatus=s,this.onDidChangeConflicts=u,this.onDidChangeLocal=m,this.userDataSyncEnablementService=C,this.instantiationService=M,this.extensionGalleryService=T,this.logService=F,this._enabled=[],this._register(C.onDidChangeResourceEnablement(([_,U])=>this.onDidChangeResourceEnablement(_,U))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,_])=>_.dispose())));for(const _ of l.ALL_SYNC_RESOURCES)C.isResourceEnabled(_)&&this.registerSynchronizer(_)}onDidChangeResourceEnablement(s,u){u?this.registerSynchronizer(s):this.deRegisterSynchronizer(s)}registerSynchronizer(s){if(this._enabled.some(([M])=>M.resource===s))return;if(s==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const u=new A.DisposableStore,m=u.add(this.createSynchronizer(s));u.add(m.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),u.add(m.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),u.add(m.onDidChangeLocal(()=>this.onDidChangeLocal(s)));const C=this.getOrder(s);this._enabled.push([m,C,u])}deRegisterSynchronizer(s){const u=this._enabled.findIndex(([m])=>m.resource===s);if(u!==-1){const m=this._enabled.splice(u,1);for(const[C,,M]of m){if(C.status!=="idle"){const T=C.conflicts.length>0;C.stop(),T&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}M.dispose()}}}createSynchronizer(s){switch(s){case"settings":return this.instantiationService.createInstance(S.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(g.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(w.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(f.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(d.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(p.ExtensionsSynchroniser)}}getOrder(s){switch(s){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};a=fe([K(3,l.IUserDataSyncEnablementService),K(4,h.IInstantiationService),K(5,I.IExtensionGalleryService),K(6,l.IUserDataSyncLogService)],a);function c(o){return{localResource:o.localResource,previewResource:o.previewResource,remoteResource:o.remoteResource,acceptedResource:o.acceptedResource,localChange:o.localChange,remoteChange:o.remoteChange,mergeState:o.mergeState}}}),define(re[258],se([0,1,3,2,13,8,25]),function(J,e,R,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(I,h){this.service=I,this.logService=h,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(I,h){switch(h){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${h}`)}async call(I,h,y){try{return await this._call(I,h,y)}catch(v){throw this.logService.error(v),v}}async _call(I,h,y){switch(h){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(y[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(y[0],L.URI.revive(y[1]),y[2],y[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(y[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(y[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(y[0]);case"getAssociatedResources":return this.service.getAssociatedResources(y[0],{created:y[1].created,uri:L.URI.revive(y[1].uri)});case"getMachineId":return this.service.getMachineId(y[0],{created:y[1].created,uri:L.URI.revive(y[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(h.startsWith("manualSync/")){const v=h.substring("manualSync/".length),p=y[0],d=this.getManualSyncTask(p);switch(y=y.slice(1),v){case"preview":return d.preview();case"accept":return d.accept(L.URI.revive(y[0]),y[1]);case"merge":return d.merge(L.URI.revive(y[0]));case"discard":return d.discard(L.URI.revive(y[0]));case"discardConflicts":return d.discardConflicts();case"apply":return d.apply();case"pull":return d.pull();case"push":return d.push();case"stop":return d.stop();case"_getStatus":return d.status;case"dispose":return this.disposeManualSyncTask(d)}}throw new Error("Invalid call")}getManualSyncTask(I){const h=this.manualSyncTasks.get(this.createKey(I));if(!h)throw new Error(`Manual sync taks not found: ${I}`);return h.manualSyncTask}async createManualSyncTask(){const I=new i.DisposableStore,h=I.add(await this.service.createManualSyncTask());return I.add(h.onSynchronizeResources(y=>this.onManualSynchronizeResources.fire({manualSyncTaskId:h.id,data:y}))),this.manualSyncTasks.set(this.createKey(h.id),{manualSyncTask:h,disposables:I}),{id:h.id,manifest:h.manifest,status:h.status}}disposeManualSyncTask(I){I.dispose();const h=this.createKey(I.id);this.manualSyncTasks.get(h)?.disposables.dispose(),this.manualSyncTasks.delete(h)}createKey(I){return`manualSyncTask-${I}`}}e.UserDataSyncChannel=P;class b extends i.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(I){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(h,y,v){return I.call(h,y,v).then(null,p=>{throw A.UserDataSyncError.toUserDataSyncError(p)})},listen(h,y){return I.listen(h,y)}},this.channel.call("_getInitialData").then(([h,y,v])=>{this.updateStatus(h),this.updateConflicts(y),v&&this.updateLastSyncTime(v),this._register(this.channel.listen("onDidChangeStatus")(p=>this.updateStatus(p))),this._register(this.channel.listen("onDidChangeLastSyncTime")(p=>this.updateLastSyncTime(p)))}),this._register(this.channel.listen("onDidChangeConflicts")(h=>this.updateConflicts(h))),this._register(this.channel.listen("onSyncErrors")(h=>this._onSyncErrors.fire(h.map(([y,v])=>[y,A.UserDataSyncError.toUserDataSyncError(v)]))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:I,manifest:h,status:y}=await this.channel.call("createManualSyncTask"),v=this,p=new E(I,h,y,{async call(d,g,S){return v.channel.call(`manualSync/${d}`,[I,...(0,k.isArray)(g)?g:[g]],S)},listen(d,g){return R.Event.map(R.Event.filter(v.channel.listen(`manualSync/${d}`,g),S=>!p.isDiposed()&&S.manualSyncTaskId===I),S=>S.data)}});return p}replace(I){return this.channel.call("replace",[I])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(I,h,y,v){return this.channel.call("accept",[I,h,y,v])}resolveContent(I){return this.channel.call("resolveContent",[I])}async getLocalSyncResourceHandles(I){return(await this.channel.call("getLocalSyncResourceHandles",[I])).map(({created:y,uri:v})=>({created:y,uri:L.URI.revive(v)}))}async getRemoteSyncResourceHandles(I){return(await this.channel.call("getRemoteSyncResourceHandles",[I])).map(({created:y,uri:v})=>({created:y,uri:L.URI.revive(v)}))}async getAssociatedResources(I,h){return(await this.channel.call("getAssociatedResources",[I,h])).map(({resource:v,comparableResource:p})=>({resource:L.URI.revive(v),comparableResource:L.URI.revive(p)}))}async getMachineId(I,h){return this.channel.call("getMachineId",[I,h])}async updateStatus(I){this._status=I,this._onDidChangeStatus.fire(I)}async updateConflicts(I){this._conflicts=I.map(([h,y])=>[h,y.map(v=>({...v,localResource:L.URI.revive(v.localResource),remoteResource:L.URI.revive(v.remoteResource),previewResource:L.URI.revive(v.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(I){this._lastSyncTime!==I&&(this._lastSyncTime=I,this._onDidChangeLastSyncTime.fire(I))}}e.UserDataSyncChannelClient=b;class E extends i.Disposable{get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}constructor(I,h,y,v){super();this.id=I,this.manifest=h,this._disposed=!1,this._status=y;const p=this;this.channel={async call(d,g,S){try{const w=await v.call(d,g,S);return p.isDiposed()||(p._status=await v.call("_getStatus")),w}catch(w){throw A.UserDataSyncError.toUserDataSyncError(w)}},listen(d,g){return v.listen(d,g)}}}async preview(){const I=await this.channel.call("preview");return this.deserializePreviews(I)}async accept(I,h){const y=await this.channel.call("accept",[I,h]);return this.deserializePreviews(y)}async merge(I){const h=await this.channel.call("merge",[I]);return this.deserializePreviews(h)}async discard(I){const h=await this.channel.call("discard",[I]);return this.deserializePreviews(h)}async discardConflicts(){const I=await this.channel.call("discardConflicts");return this.deserializePreviews(I)}async apply(){const I=await this.channel.call("apply");return this.deserializePreviews(I)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(I){return I.map(([h,y])=>[h,{isLastSyncFromCurrentMachine:y.isLastSyncFromCurrentMachine,resourcePreviews:y.resourcePreviews.map(v=>({...v,localResource:L.URI.revive(v.localResource),remoteResource:L.URI.revive(v.remoteResource),previewResource:L.URI.revive(v.previewResource),acceptedResource:L.URI.revive(v.acceptedResource)}))}])}}}),define(re[259],se([0,1,6,23,7,3,2,114,4,20,13,8,30,17,14,15,24,43,47,21,25]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g,S,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",n="sync.machine-session-id",a=100,c=1e3*60*5;let o=class extends A.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(f.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(T){this.storageService.store(f.SYNC_SERVICE_URL_TYPE,T,0,b.isWeb?0:1)}constructor(T,F,_){super();this.productService=T,this.configurationService=F,this.storageService=_,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(_.onDidChangeValue,U=>U.key===f.SYNC_SERVICE_URL_TYPE&&U.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[f.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(f.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(T,F){T=b.isWeb&&T?.web?{...T,...T.web}:T;const _={...T||{},...F||{}};if(_&&(0,D.isString)(_.url)&&(0,D.isObject)(_.authenticationProviders)&&Object.keys(_.authenticationProviders).every(U=>(0,D.isArray)(_.authenticationProviders[U].scopes))){const U=_,O=!!U.canSwitch&&!F?.url,$=U.url===U.insidersUrl?"insiders":"stable",V=(O?this.userDataSyncStoreType:void 0)||$,te=F?.url||(V==="insiders"?U.insidersUrl:V==="stable"?U.stableUrl:U.url);return{url:I.URI.parse(te),type:V,defaultType:$,defaultUrl:I.URI.parse(U.url),stableUrl:I.URI.parse(U.stableUrl),insidersUrl:I.URI.parse(U.insidersUrl),canSwitch:O,authenticationProviders:Object.keys(U.authenticationProviders).reduce((H,z)=>(H.push({id:z,scopes:U.authenticationProviders[z].scopes}),H),[])}}}};e.AbstractUserDataSyncStoreManagementService=o,e.AbstractUserDataSyncStoreManagementService=o=fe([K(0,d.IProductService),K(1,y.IConfigurationService),K(2,w.IStorageService)],o);let s=class extends o{constructor(T,F,_){super(T,F,_);const U=this.storageService.get(l,0);U&&(this.previousConfigurationSyncStore=JSON.parse(U));const O=this.productService[f.CONFIGURATION_SYNC_STORE_KEY];O?this.storageService.store(l,JSON.stringify(O),0,1):this.storageService.remove(l,0)}async switch(T){T!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=T,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=s,e.UserDataSyncStoreManagementService=s=fe([K(0,d.IProductService),K(1,y.IConfigurationService),K(2,w.IStorageService)],s);let u=class extends A.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(T,F,_,U,O,$,V){super();this.requestService=_,this.logService=U,this.storageService=V,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(T),this.commonHeadersPromise=(0,S.getServiceMachineId)(O,$,V).then(te=>{const H={"X-Client-Name":`${F.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(H["X-Client-Commit"]=F.commit),H}),this.session=new C(a,c,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(T,F){this.authToken={token:T,type:F}}updateUserDataSyncStoreUrl(T){this.userDataSyncStoreUrl=T?(0,E.joinPath)(T,"v1"):void 0}initDonotMakeRequestsUntil(){const T=this.storageService.getNumber(t,0);T&&Date.now()<T&&this.setDonotMakeRequestsUntil(new Date(T))}setDonotMakeRequestsUntil(T){this._donotMakeRequestsUntil?.getTime()!==T?.getTime()&&(this._donotMakeRequestsUntil=T,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(F=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(T){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",T),_={},U=await this.request(F.toString(),{type:"GET",headers:_},[],i.CancellationToken.None);return(await(0,g.asJson)(U)||[]).map(({url:$,created:V})=>({ref:(0,E.relativePath)(F,F.with({path:$})),created:V*1e3}))}async resolveContent(T,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",T,F).toString(),U={};U["Cache-Control"]="no-cache";const O=await this.request(_,{type:"GET",headers:U},[],i.CancellationToken.None);return await(0,g.asTextOrError)(O)}async delete(T){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",T).toString(),_={};await this.request(F,{type:"DELETE",headers:_},[],i.CancellationToken.None)}async read(T,F,_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",T,"latest").toString();_={..._},_["Cache-Control"]="no-cache",F&&(_["If-None-Match"]=F.ref);const O=await this.request(U,{type:"GET",headers:_},[304],i.CancellationToken.None);let $=null;if(O.res.statusCode===304&&($=F),$===null){const V=O.res.headers.etag;if(!V)throw new f.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",O.res.statusCode,O.res.headers[f.HEADER_OPERATION_ID]);const te=await(0,g.asTextOrError)(O);if(!te&&O.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",U,"EmptyResponse",O.res.statusCode,O.res.headers[f.HEADER_OPERATION_ID]);$={ref:V,content:te}}return $}async write(T,F,_,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",T).toString();U={...U},U["Content-Type"]=P.Mimes.text,_&&(U["If-Match"]=_);const $=await this.request(O,{type:"POST",data:F,headers:U},[],i.CancellationToken.None),V=$.res.headers.etag;if(!V)throw new f.UserDataSyncStoreError("Server did not return the ref",O,"NoRef",$.res.statusCode,$.res.headers[f.HEADER_OPERATION_ID]);return V}async manifest(T,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",T&&(F["If-None-Match"]=T.ref);const U=await this.request(_,{type:"GET",headers:F},[304],i.CancellationToken.None);let O=null;if(U.res.statusCode===304&&(O=T),!O){const V=U.res.headers.etag;if(!V)throw new f.UserDataSyncStoreError("Server did not return the ref",_,"NoRef",U.res.statusCode,U.res.headers[f.HEADER_OPERATION_ID]);const te=await(0,g.asTextOrError)(U);if(!te&&U.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",_,"EmptyResponse",U.res.statusCode,U.res.headers[f.HEADER_OPERATION_ID]);te&&(O={...JSON.parse(te),ref:V})}const $=this.storageService.get(r,0);return $&&O&&$!==O.session&&this.clearSession(),O===null&&$&&this.clearSession(),O&&this.storageService.store(r,O.session,0,1),O}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const T=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":P.Mimes.text};await this.request(T,{type:"DELETE",headers:F},[],i.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(n,0)}async request(T,F,_,U){if(!this.authToken)throw new f.UserDataSyncStoreError("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new f.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const O=await this.commonHeadersPromise;F.headers={...F.headers||{},...O,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:T,type:F.type,headers:{...F.headers,authorization:void 0}});let $;try{$=await this.session.request(T,F,U)}catch(z){if(!(z instanceof f.UserDataSyncStoreError)){let q="RequestFailed";const j=(0,k.getErrorMessage)(z).toLowerCase();j.includes("xhr timeout")?q="RequestTimeout":j.includes("protocol")&&j.includes("not supported")?q="RequestProtocolNotSupported":j.includes("request path contains unescaped characters")?q="RequestPathNotEscaped":j.includes("headers must be an object")?q="RequestHeadersNotObject":(0,k.isCancellationError)(z)&&(q="RequestCanceled"),z=new f.UserDataSyncStoreError(`Connection refused for the request '${T}'.`,T,q,void 0,void 0)}throw this.logService.info("Request failed",T),z}const V=$.res.headers[f.HEADER_OPERATION_ID],te={url:T,status:$.res.statusCode,"execution-id":F.headers[f.HEADER_EXECUTION_ID],"operation-id":V},H=(0,g.isSuccess)($)||$.res.statusCode&&_.indexOf($.res.statusCode)!==-1;if(H?this.logService.trace("Request succeeded",te):this.logService.info("Request failed",te),$.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new f.UserDataSyncStoreError(`Request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",$.res.statusCode,V);if(this._onTokenSucceed.fire(),$.res.statusCode===409)throw new f.UserDataSyncStoreError(`${F.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",$.res.statusCode,V);if($.res.statusCode===410)throw new f.UserDataSyncStoreError(`${F.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",$.res.statusCode,V);if($.res.statusCode===412)throw new f.UserDataSyncStoreError(`${F.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",$.res.statusCode,V);if($.res.statusCode===413)throw new f.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",$.res.statusCode,V);if($.res.statusCode===426)throw new f.UserDataSyncStoreError(`${F.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",$.res.statusCode,V);if($.res.statusCode===429){const z=$.res.headers["retry-after"];throw z?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(z)*1e3)),new f.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",$.res.statusCode,V)):new f.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",$.res.statusCode,V)}if(!H)throw new f.UserDataSyncStoreError("Server returned "+$.res.statusCode,T,"Unknown",$.res.statusCode,V);return $}addSessionHeaders(T){let F=this.storageService.get(n,0);F===void 0&&(F=(0,h.generateUuid)(),this.storageService.store(n,F,0,1)),T["X-Machine-Session-Id"]=F;const _=this.storageService.get(r,0);_!==void 0&&(T["X-User-Session-Id"]=_)}};e.UserDataSyncStoreClient=u,e.UserDataSyncStoreClient=u=fe([K(1,d.IProductService),K(2,g.IRequestService),K(3,f.IUserDataSyncLogService),K(4,v.IEnvironmentService),K(5,p.IFileService),K(6,w.IStorageService)],u);let m=class extends u{constructor(T,F,_,U,O,$,V){super(T.userDataSyncStore?.url,F,_,U,O,$,V);this._register(T.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(T.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=m,e.UserDataSyncStoreService=m=fe([K(0,f.IUserDataSyncStoreManagementService),K(1,d.IProductService),K(2,g.IRequestService),K(3,f.IUserDataSyncLogService),K(4,v.IEnvironmentService),K(5,p.IFileService),K(6,w.IStorageService)],m);class C{constructor(T,F,_,U){this.limit=T,this.interval=F,this.requestService=_,this.logService=U,this.requests=[],this.startTime=void 0}request(T,F,_){if(this.isExpired()&&this.reset(),F.url=T,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new f.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(T),this.requestService.request(F,_)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=C}),define(re[260],se([0,1,3,66,24,21,22,256,25,72,73]),function(J,e,R,i,k,L,A,P,b,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let I=class extends P.UserDataAutoSyncService{constructor(y,v,p,d,g,S,w,f,l,t,r){super(y,v,p,d,g,w,f,l,t,r);this._register(R.Event.debounce(R.Event.any(R.Event.map(S.onDidFocusWindow,()=>"windowFocus"),R.Event.map(S.onDidOpenWindow,()=>"windowOpen")),(n,a)=>n?[...n,a]:[a],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.UserDataAutoSyncService=I,e.UserDataAutoSyncService=I=fe([K(0,k.IProductService),K(1,b.IUserDataSyncStoreManagementService),K(2,b.IUserDataSyncStoreService),K(3,b.IUserDataSyncEnablementService),K(4,b.IUserDataSyncService),K(5,i.INativeHostService),K(6,b.IUserDataSyncLogService),K(7,E.IUserDataSyncAccountService),K(8,A.ITelemetryService),K(9,D.IUserDataSyncMachinesService),K(10,L.IStorageService)],I)}),define(re[261],se([0,1,6,3,2]),function(J,e,R,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends k.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:b,getActiveWindowId:E}){super();this.disposables=this._register(new k.DisposableStore),i.Event.latch(i.Event.any(P,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>E()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(re[262],se([0,1,56,36,3,2,7,87,16,113]),function(J,e,R,i,k,L,A,P,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChoiceAction=e.NotificationViewItem=e.NotificationViewItemProgress=e.NotificationViewItemContentChangeKind=e.isNotificationViewItem=e.NotificationsModel=e.NotificationHandle=e.StatusMessageChangeType=e.NotificationChangeType=void 0;var D;(function(f){f[f.ADD=0]="ADD",f[f.CHANGE=1]="CHANGE",f[f.EXPAND_COLLAPSE=2]="EXPAND_COLLAPSE",f[f.REMOVE=3]="REMOVE"})(D||(e.NotificationChangeType=D={}));var I;(function(f){f[f.ADD=0]="ADD",f[f.REMOVE=1]="REMOVE"})(I||(e.StatusMessageChangeType=I={}));class h extends L.Disposable{constructor(l,t){super();this.item=l,this.onClose=t,this._onDidClose=this._register(new k.Emitter),this.onDidClose=this._onDidClose.event,this._onDidChangeVisibility=this._register(new k.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this.registerListeners()}registerListeners(){this._register(this.item.onDidChangeVisibility(l=>this._onDidChangeVisibility.fire(l))),k.Event.once(this.item.onDidClose)(()=>{this._onDidClose.fire(),this.dispose()})}get progress(){return this.item.progress}updateSeverity(l){this.item.updateSeverity(l)}updateMessage(l){this.item.updateMessage(l)}updateActions(l){this.item.updateActions(l)}close(){this.onClose(this.item),this.dispose()}}e.NotificationHandle=h;class y extends L.Disposable{constructor(){super(...arguments);this._onDidChangeNotification=this._register(new k.Emitter),this.onDidChangeNotification=this._onDidChangeNotification.event,this._onDidChangeStatusMessage=this._register(new k.Emitter),this.onDidChangeStatusMessage=this._onDidChangeStatusMessage.event,this._onDidChangeFilter=this._register(new k.Emitter),this.onDidChangeFilter=this._onDidChangeFilter.event,this._notifications=[],this.filter=R.NotificationsFilter.OFF}get notifications(){return this._notifications}get statusMessage(){return this._statusMessage}setFilter(l){this.filter=l,this._onDidChangeFilter.fire(l)}addNotification(l){const t=this.createViewItem(l);if(!t)return y.NO_OP_NOTIFICATION;const r=this.findNotification(t);return r&&r.close(),this._notifications.splice(0,0,t),this._onDidChangeNotification.fire({item:t,index:0,kind:0}),new h(t,n=>this.onClose(n))}onClose(l){const t=this.findNotification(l);t&&t!==l?t.close():l.close()}findNotification(l){return this._notifications.find(t=>t.equals(l))}createViewItem(l){const t=g.create(l,this.filter);if(!t)return;const r=(c,o)=>{const s=this._notifications.indexOf(t);s>=0&&this._onDidChangeNotification.fire({item:t,index:s,kind:c,detail:o})},n=t.onDidChangeExpansion(()=>r(2)),a=t.onDidChangeContent(c=>r(1,c.kind));return k.Event.once(t.onDidClose)(()=>{n.dispose(),a.dispose();const c=this._notifications.indexOf(t);c>=0&&(this._notifications.splice(c,1),this._onDidChangeNotification.fire({item:t,index:c,kind:3}))}),t}showStatusMessage(l,t){const r=w.create(l,t);return r?(this._statusMessage=r,this._onDidChangeStatusMessage.fire({kind:0,item:r}),(0,L.toDisposable)(()=>{this._statusMessage===r&&(this._statusMessage=void 0,this._onDidChangeStatusMessage.fire({kind:1,item:r}))})):L.Disposable.None}}e.NotificationsModel=y,y.NO_OP_NOTIFICATION=new R.NoOpNotification;function v(f){return f instanceof g}e.isNotificationViewItem=v;var p;(function(f){f[f.SEVERITY=0]="SEVERITY",f[f.MESSAGE=1]="MESSAGE",f[f.ACTIONS=2]="ACTIONS",f[f.PROGRESS=3]="PROGRESS"})(p||(e.NotificationViewItemContentChangeKind=p={}));class d extends L.Disposable{constructor(){super();this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._state=Object.create(null)}get state(){return this._state}infinite(){this._state.infinite||(this._state.infinite=!0,this._state.total=void 0,this._state.worked=void 0,this._state.done=void 0,this._onDidChange.fire())}done(){this._state.done||(this._state.done=!0,this._state.infinite=void 0,this._state.total=void 0,this._state.worked=void 0,this._onDidChange.fire())}total(l){this._state.total!==l&&(this._state.total=l,this._state.infinite=void 0,this._state.done=void 0,this._onDidChange.fire())}worked(l){typeof this._state.worked=="number"?this._state.worked+=l:this._state.worked=l,this._state.infinite=void 0,this._state.done=void 0,this._onDidChange.fire()}}e.NotificationViewItemProgress=d;class g extends L.Disposable{static create(l,t=R.NotificationsFilter.OFF){if(!l||!l.message||(0,A.isCancellationError)(l.message))return;let r;typeof l.severity=="number"?r=l.severity:r=R.Severity.Info;const n=g.parseNotificationMessage(l.message);if(!n)return;let a;return l.actions?a=l.actions:(0,i.isErrorWithActions)(l.message)&&(a={primary:l.message.actions}),new g(l.id,r,l.sticky,l.silent||t===R.NotificationsFilter.SILENT||t===R.NotificationsFilter.ERROR&&l.severity!==R.Severity.Error,n,l.source,l.progress,a)}static parseNotificationMessage(l){let t;if(l instanceof Error?t=(0,i.toErrorMessage)(l,!1):typeof l=="string"&&(t=l),!t)return;const r=t;t.length>g.MAX_MESSAGE_LENGTH&&(t=`${t.substr(0,g.MAX_MESSAGE_LENGTH)}...`),t=t.replace(/(\r\n|\n|\r)/gm," ").trim();const n=(0,E.parseLinkedText)(t);return{raw:r,linkedText:n,original:l}}constructor(l,t,r,n,a,c,o,s){super();this.id=l,this._severity=t,this._sticky=r,this._silent=n,this._message=a,this._source=c,this._visible=!1,this._onDidChangeExpansion=this._register(new k.Emitter),this.onDidChangeExpansion=this._onDidChangeExpansion.event,this._onDidClose=this._register(new k.Emitter),this.onDidClose=this._onDidClose.event,this._onDidChangeContent=this._register(new k.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._onDidChangeVisibility=this._register(new k.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,o&&this.setProgress(o),this.setActions(s)}setProgress(l){l.infinite?this.progress.infinite():l.total&&(this.progress.total(l.total),l.worked&&this.progress.worked(l.worked))}setActions(l={primary:[],secondary:[]}){this._actions={primary:Array.isArray(l.primary)?l.primary:[],secondary:Array.isArray(l.secondary)?l.secondary:[]},this._expanded=l.primary&&l.primary.length>0}get canCollapse(){return!this.hasActions}get expanded(){return!!this._expanded}get severity(){return this._severity}get sticky(){if(this._sticky)return!0;const l=this.hasActions;return!!(l&&this._severity===R.Severity.Error||!l&&this._expanded||this._progress&&!this._progress.state.done)}get silent(){return!!this._silent}get hasActions(){return!this._actions||!this._actions.primary?!1:this._actions.primary.length>0}get hasProgress(){return!!this._progress}get progress(){return this._progress||(this._progress=this._register(new d),this._register(this._progress.onDidChange(()=>this._onDidChangeContent.fire({kind:3})))),this._progress}get message(){return this._message}get source(){return typeof this._source=="string"?this._source:this._source?this._source.label:void 0}get sourceId(){return this._source&&typeof this._source!="string"&&"id"in this._source?this._source.id:void 0}get actions(){return this._actions}get visible(){return this._visible}updateSeverity(l){l!==this._severity&&(this._severity=l,this._onDidChangeContent.fire({kind:0}))}updateMessage(l){const t=g.parseNotificationMessage(l);!t||t.raw===this._message.raw||(this._message=t,this._onDidChangeContent.fire({kind:1}))}updateActions(l){this.setActions(l),this._onDidChangeContent.fire({kind:2})}updateVisibility(l){this._visible!==l&&(this._visible=l,this._onDidChangeVisibility.fire(l))}expand(){this._expanded||!this.canCollapse||(this._expanded=!0,this._onDidChangeExpansion.fire())}collapse(l){!this._expanded||!this.canCollapse||(this._expanded=!1,l||this._onDidChangeExpansion.fire())}toggle(){this._expanded?this.collapse():this.expand()}close(){this._onDidClose.fire(),this.dispose()}equals(l){if(this.hasProgress||l.hasProgress)return!1;if(typeof this.id=="string"||typeof l.id=="string")return this.id===l.id;if(typeof this._source=="object"){if(this._source.label!==l.source||this._source.id!==l.sourceId)return!1}else if(this._source!==l.source)return!1;if(this._message.raw!==l.message.raw)return!1;const t=this._actions&&this._actions.primary||[],r=l.actions&&l.actions.primary||[];return(0,b.equals)(t,r,(n,a)=>n.id+n.label===a.id+a.label)}}e.NotificationViewItem=g,g.MAX_MESSAGE_LENGTH=1e3;class S extends P.Action{constructor(l,t){super(l,t.label,void 0,!0,async()=>{t.run(),this._onDidRun.fire()});this._onDidRun=this._register(new k.Emitter),this.onDidRun=this._onDidRun.event,this._keepOpen=!!t.keepOpen,this._menu=!t.isSecondary&&t.menu?t.menu.map((r,n)=>new S(`${l}.${n}`,r)):void 0}get menu(){return this._menu}get keepOpen(){return this._keepOpen}}e.ChoiceAction=S;class w{static create(l,t){if(!l||(0,A.isCancellationError)(l))return;let r;if(l instanceof Error?r=(0,i.toErrorMessage)(l,!1):typeof l=="string"&&(r=l),!!r)return{message:r,options:t}}}}),define(re[263],se([0,1,165,56,262,2,3,64,87,21]),function(J,e,R,i,k,L,A,P,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotificationService=void 0;let D=class extends L.Disposable{constructor(h){super();this.storageService=h,this.model=this._register(new k.NotificationsModel),this._onDidAddNotification=this._register(new A.Emitter),this.onDidAddNotification=this._onDidAddNotification.event,this._onDidRemoveNotification=this._register(new A.Emitter),this.onDidRemoveNotification=this._onDidRemoveNotification.event,this.registerListeners()}registerListeners(){this._register(this.model.onDidChangeNotification(h=>{switch(h.kind){case 0:case 3:{const y={message:h.item.message.original,severity:h.item.severity,source:typeof h.item.sourceId=="string"&&typeof h.item.source=="string"?{id:h.item.sourceId,label:h.item.source}:h.item.source,silent:h.item.silent};h.kind===0&&this._onDidAddNotification.fire(y),h.kind===3&&this._onDidRemoveNotification.fire(y);break}}}))}setFilter(h){this.model.setFilter(h)}info(h){if(Array.isArray(h)){h.forEach(y=>this.info(y));return}this.model.addNotification({severity:i.Severity.Info,message:h})}warn(h){if(Array.isArray(h)){h.forEach(y=>this.warn(y));return}this.model.addNotification({severity:i.Severity.Warning,message:h})}error(h){if(Array.isArray(h)){h.forEach(y=>this.error(y));return}this.model.addNotification({severity:i.Severity.Error,message:h})}notify(h){const y=new L.DisposableStore;let v;if(h.neverShowAgain){const p=h.neverShowAgain.scope===i.NeverShowAgainScope.WORKSPACE?1:0,d=h.neverShowAgain.id;if(this.storageService.getBoolean(d,p))return new i.NoOpNotification;const g=y.add(new b.Action("workbench.notification.neverShowAgain",(0,R.localize)(0,null),void 0,!0,async()=>{v.close(),this.storageService.store(d,!0,p,0)})),S={primary:h.actions?.primary||[],secondary:h.actions?.secondary||[]};h.neverShowAgain.isSecondary?S.secondary=[...S.secondary,g]:S.primary=[g,...S.primary],h.actions=S}return v=this.model.addNotification(h),A.Event.once(v.onDidClose)(()=>y.dispose()),v}prompt(h,y,v,p){const d=new L.DisposableStore;if(p?.neverShowAgain){const t=p.neverShowAgain.scope===i.NeverShowAgainScope.WORKSPACE?1:0,r=p.neverShowAgain.id;if(this.storageService.getBoolean(r,t))return new i.NoOpNotification;const n={label:(0,R.localize)(1,null),run:()=>this.storageService.store(r,!0,t,0),isSecondary:p.neverShowAgain.isSecondary};p.neverShowAgain.isSecondary?v=[...v,n]:v=[n,...v]}let g=!1,S;const w=[],f=[];v.forEach((t,r)=>{const n=new k.ChoiceAction(`workbench.dialog.choice.${r}`,t);t.isSecondary?f.push(n):w.push(n),d.add(n.onDidRun(()=>{g=!0,t.keepOpen||S.close()})),d.add(n)});const l={primary:w,secondary:f};return S=this.notify({severity:h,message:y,actions:l,sticky:p?.sticky,silent:p?.silent}),A.Event.once(S.onDidClose)(()=>{d.dispose(),p&&typeof p.onCancel=="function"&&!g&&p.onCancel()}),S}status(h,y){return this.model.showStatusMessage(h,y)}};e.NotificationService=D,e.NotificationService=D=fe([K(0,E.IStorageService)],D),(0,P.registerSingleton)(i.INotificationService,D,!0)}),define(re[109],se([0,1,52,6,12,13,27,137,275,276]),function(J,e,R,i,k,L,A,P,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class D extends Error{constructor(t,r){let n=r.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=r}}e.ExtractError=D;function I(l){const t=l.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,n)=>r+n,t&61440)}function h(l){if(l instanceof D)return l;let t;return/end of central directory record signature not found/.test(l.message)&&(t="CorruptZip"),new D(t,l)}function y(l,t,r,n,a,c){const o=k.dirname(t),s=k.join(n,o);if(!s.startsWith(n))return Promise.reject(new Error(P.localize(0,null,t)));const u=k.join(n,t);let m;return c.onCancellationRequested(()=>{m&&m.destroy()}),Promise.resolve(A.Promises.mkdir(s,{recursive:!0})).then(()=>new Promise((C,M)=>{if(!c.isCancellationRequested)try{m=(0,R.createWriteStream)(u,{mode:r}),m.once("close",()=>C()),m.once("error",M),l.once("error",M),l.pipe(m)}catch(T){M(T)}}))}function v(l,t,r,n){let a=(0,i.createCancelablePromise)(()=>Promise.resolve()),c=0;return n.onCancellationRequested(()=>{a.cancel(),l.close()}),new Promise((o,s)=>{const u=new i.Sequencer,m=C=>{C.isCancellationRequested||(c++,l.readEntry())};l.once("error",s),l.once("close",()=>a.then(()=>{n.isCancellationRequested||l.entryCount===c?o():s(new D("Incomplete",new Error(P.localize(1,null,c,l.entryCount))))},s)),l.readEntry(),l.on("entry",C=>{if(n.isCancellationRequested)return;if(!r.sourcePathRegex.test(C.fileName)){m(n);return}const M=C.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(M)){const _=k.join(t,M);a=(0,i.createCancelablePromise)(U=>A.Promises.mkdir(_,{recursive:!0}).then(()=>m(U)).then(void 0,s));return}const T=d(l,C),F=I(C);a=(0,i.createCancelablePromise)(_=>u.queue(()=>T.then(U=>y(U,M,F,t,r,_).then(()=>m(_)))).then(null,s))})})}function p(l,t=!1){return new Promise((r,n)=>{(0,b.open)(l,t?{lazyEntries:!0}:void 0,(a,c)=>{a?n(h(a)):r((0,L.assertIsDefined)(c))})})}function d(l,t){return new Promise((r,n)=>{l.openReadStream(t,(a,c)=>{a?n(h(a)):r((0,L.assertIsDefined)(c))})})}function g(l,t){return new Promise((r,n)=>{const a=new E.ZipFile;t.forEach(o=>{o.contents?a.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&a.addFile(o.localPath,o.path)}),a.end();const c=(0,R.createWriteStream)(l);a.outputStream.pipe(c),a.outputStream.once("error",n),c.once("error",n),c.once("finish",()=>r(l))})}e.zip=g;function S(l,t,r={},n){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let c=p(l,!0);return r.overwrite&&(c=c.then(o=>A.Promises.rm(t).then(()=>o))),c.then(o=>v(o,t,{sourcePathRegex:a},n))}e.extract=S;function w(l,t){return p(l).then(r=>new Promise((n,a)=>{r.on("entry",c=>{c.fileName===t&&d(r,c).then(o=>n(o),o=>a(o))}),r.once("close",()=>a(new Error(P.localize(2,null,t))))}))}function f(l,t){return w(l,t).then(r=>new Promise((n,a)=>{const c=[];r.once("error",a),r.on("data",o=>c.push(o)),r.on("end",()=>n(Buffer.concat(c)))}))}e.buffer=f}),define(re[264],se([0,1,109,146]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(L){return(0,R.buffer)(L,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=k}),define(re[265],se([0,1,6,36,7,2,19,12,4,20,53,13,8,30,27,109,145,91,14,223,29,31,69,203,188,264,204,238,63,15,5,9,24,22,32]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g,S,w,f,l,t,r,n,a,c,o,s,u,m,C,M,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let _=class extends w.AbstractExtensionManagementService{constructor(z,q,j,Q,G,X,Z,W,ee){super(z,q,j,W);this.environmentService=Q,this.downloadService=G,this.fileService=Z;const B=this._register(X.createInstance(n.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(U,x=>B.postUninstall(x))),this.manifestCache=this._register(new c.ExtensionsManifestCache(Q,this)),this.extensionsDownloader=this._register(X.createInstance(r.ExtensionsDownloader));const N=this._register(new o.ExtensionsWatcher(this,Z,Q,j,ee));this._register(N.onDidChangeExtensionsByAnotherSource(({added:x,removed:Y})=>{x.length&&this._onDidInstallExtensions.fire(x.map(ne=>({identifier:ne.identifier,operation:1,local:ne}))),Y.forEach(ne=>this._onDidUninstallExtension.fire({identifier:ne}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(z){this.logService.trace("ExtensionManagementService#zip",z.identifier.id);const q=await this.collectFiles(z),j=await(0,p.zip)((0,E.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)()).fsPath,q);return h.URI.file(j)}async unzip(z){return this.logService.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const q=await this.downloadVsix(z),j=P.resolve(q.fsPath);return(0,a.getManifest)(j)}getInstalled(z=null){return this.extensionsScanner.scanExtensions(z)}async install(z,q={}){this.logService.trace("ExtensionManagementService#install",z.toString());const j=await this.downloadVsix(z),Q=await(0,a.getManifest)(P.resolve(j.fsPath));if(Q.engines&&Q.engines.vscode&&!(0,s.isEngineValid)(Q.engines.vscode,this.productService.version,this.productService.date))throw new Error(d.localize(0,null,(0,l.getGalleryExtensionId)(Q.publisher,Q.name),this.productService.version));return this.installExtension(Q,j,q)}async updateMetadata(z,q){this.logService.trace("ExtensionManagementService#updateMetadata",z.identifier.id);const j={...q};return q.isPreReleaseVersion&&(j.preRelease=!0),z=await this.extensionsScanner.updateMetadata(z,j),this.manifestCache.invalidate(),z}async updateExtensionScope(z,q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",z.identifier.id),z=await this.extensionsScanner.updateMetadata(z,{isMachineScoped:q}),this.manifestCache.invalidate(),z}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(z){if(z.scheme===A.Schemas.file)return z;const q=(0,E.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)());return await this.downloadService.download(z,q),q}createInstallExtensionTask(z,q,j){return h.URI.isUri(q)?new V(z,q,j,this.galleryService,this.extensionsScanner,this.logService):new $(q,j,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(z,q){return new te(z,q,this.extensionsScanner)}async collectFiles(z){const q=async Q=>{let G=await v.Promises.readdir(Q);G=G.map(W=>P.join(Q,W));const X=await Promise.all(G.map(W=>v.Promises.stat(W)));let Z=Promise.resolve([]);return X.forEach((W,ee)=>{const B=G[ee];W.isFile()&&(Z=Z.then(N=>[...N,B])),W.isDirectory()&&(Z=Z.then(N=>q(B).then(x=>[...N,...x])))}),Z};return(await q(z.location.fsPath)).map(Q=>({path:`extension/${P.relative(z.location.fsPath,Q)}`,localPath:Q}))}};e.ExtensionManagementService=_,e.ExtensionManagementService=_=fe([K(0,f.IExtensionGalleryService),K(1,T.ITelemetryService),K(2,C.ILogService),K(3,S.INativeEnvironmentService),K(4,g.IDownloadService),K(5,m.IInstantiationService),K(6,u.IFileService),K(7,M.IProductService),K(8,F.IUriIdentityService)],_);let U=class extends L.Disposable{constructor(z,q,j,Q){super();this.beforeRemovingExtension=z,this.fileService=q,this.extensionsScannerService=j,this.logService=Q,this.uninstalledPath=(0,E.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(z){const q={includeInvalid:!0};let j=[];return z===null||z===0?j.push(...await this.extensionsScannerService.scanAllExtensions(q)):z===1&&j.push(...await this.extensionsScannerService.scanUserExtensions(q)),j=z!==null?j.filter(Q=>Q.type===z):j,Promise.all(j.map(Q=>this.toLocalExtension(Q)))}async scanUserExtensions(z){const q=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!z,includeInvalid:!0});return Promise.all(q.map(j=>this.toLocalExtension(j)))}async extractUserExtension(z,q,j,Q){const G=z.toString(),X=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),Z=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,G);try{await v.Promises.rm(Z)}catch{throw new f.ExtensionManagementError(d.localize(1,null,Z,z.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(z,q,X,Q),await this.extensionsScannerService.updateMetadata(h.URI.file(X),{...j,installedTimestamp:Date.now()});try{await this.rename(z,X,Z,Date.now()+2*60*1e3),this.logService.info("Renamed to",Z)}catch(W){try{await v.Promises.rm(X)}catch{}if(W.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",z.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(W)}. Deleted from extracted location`,X),W}return this.scanLocalExtension(h.URI.file(Z),1)}async updateMetadata(z,q){return await this.extensionsScannerService.updateMetadata(z.location,q),this.scanLocalExtension(z.location,z.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...z){const q=z.map(j=>l.ExtensionKey.create(j));await this.withUninstalledExtensions(j=>{q.forEach(Q=>j[Q.toString()]=!0)})}async setInstalled(z){await this.withUninstalledExtensions(Q=>delete Q[z.toString()]);const j=(await this.scanUserExtensions(!0)).find(Q=>l.ExtensionKey.create(Q).equals(z))||null;return j?this.updateMetadata(j,{installedTimestamp:Date.now()}):null}async removeExtension(z,q){this.logService.trace(`Deleting ${q} extension from disk`,z.identifier.id,z.location.fsPath),await v.Promises.rm(z.location.fsPath),this.logService.info("Deleted from disk",z.identifier.id,z.location.fsPath)}async removeUninstalledExtension(z){await this.removeExtension(z,"uninstalled"),await this.withUninstalledExtensions(q=>delete q[l.ExtensionKey.create(z).toString()])}async withUninstalledExtensions(z){return this.uninstalledFileLimiter.queue(async()=>{let q;try{q=await v.Promises.readFile(this.uninstalledPath,"utf8")}catch(Q){if(Q.code!=="ENOENT")throw Q}let j={};if(q)try{j=JSON.parse(q)}catch{}return z&&(z(j),Object.keys(j).length?await v.Promises.writeFile(this.uninstalledPath,JSON.stringify(j)):await v.Promises.rm(this.uninstalledPath)),j})}async extractAtLocation(z,q,j,Q){this.logService.trace(`Started extracting the extension from ${q} to ${j}`);try{await v.Promises.rm(j)}catch(G){throw new f.ExtensionManagementError(this.joinErrors(G).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,p.extract)(q,j,{sourcePath:"extension",overwrite:!0},Q),this.logService.info(`Extracted extension to ${j}:`,z.id)}catch(G){try{await v.Promises.rm(j)}catch{}let X=f.ExtensionManagementErrorCode.Extract;throw G instanceof p.ExtractError&&(G.type==="CorruptZip"?X=f.ExtensionManagementErrorCode.CorruptZip:G.type==="Incomplete"&&(X=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(G.message,X)}}async rename(z,q,j,Q){try{await v.Promises.rename(q,j)}catch(G){if(b.isWindows&&G&&G.code==="EPERM"&&Date.now()<Q)return this.logService.info(`Failed renaming ${q} to ${j} with 'EPERM' error. Trying again...`,z.id),this.rename(z,q,j,Q);throw new f.ExtensionManagementError(G.message||d.localize(2,null,q,j),G.code||f.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(z,q){const j=await this.extensionsScannerService.scanExistingExtension(z,q,{includeInvalid:!0});if(j)return this.toLocalExtension(j);throw new Error(d.localize(3,null,z.path))}async toLocalExtension(z){const q=await this.fileService.resolve(z.location);let j,Q;return q.children&&(j=q.children.find(({name:G})=>/^readme(\.txt|\.md|)$/i.test(G))?.resource,Q=q.children.find(({name:G})=>/^changelog(\.txt|\.md|)$/i.test(G))?.resource),{identifier:z.identifier,type:z.type,isBuiltin:z.isBuiltin||!!z.metadata?.isBuiltin,location:z.location,manifest:z.manifest,targetPlatform:z.targetPlatform,validations:z.validations,isValid:z.isValid,readmeUrl:j,changelogUrl:Q,publisherDisplayName:z.metadata?.publisherDisplayName||null,publisherId:z.metadata?.publisherId||null,isMachineScoped:!!z.metadata?.isMachineScoped,isPreReleaseVersion:!!z.metadata?.isPreReleaseVersion,preRelease:!!z.metadata?.preRelease,installedTimestamp:z.metadata?.installedTimestamp,updated:!!z.metadata?.updated}}async removeUninstalledExtensions(){const z=await this.getUninstalledExtensions(),q=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),j=new Set;for(const X of q)z[l.ExtensionKey.create(X).toString()]||j.add(X.identifier.id.toLowerCase());const Q=(0,l.groupByExtension)(q,X=>X.identifier);await R.Promises.settled(Q.map(async X=>{const Z=X.sort((W,ee)=>D.rcompare(W.manifest.version,ee.manifest.version))[0];j.has(Z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Z))}));const G=q.filter(X=>z[l.ExtensionKey.create(X).toString()]);await R.Promises.settled(G.map(X=>this.removeUninstalledExtension(X)))}async removeOutdatedExtensions(){const z=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=[],j=await this.extensionsScannerService.getTargetPlatform(),Q=(0,l.groupByExtension)(z,G=>G.identifier);q.push(...Q.map(G=>G.sort((X,Z)=>{const W=D.rcompare(X.manifest.version,Z.manifest.version);return W!==0?W:X.targetPlatform===j?-1:1}).slice(1)).flat()),await R.Promises.settled(q.map(G=>this.removeExtension(G,"outdated")))}joinErrors(z){const q=Array.isArray(z)?z:[z];return q.length===1?q[0]instanceof Error?q[0]:new Error(q[0]):q.reduce((j,Q)=>new Error(`${j.message}${j.message?",":""}${Q instanceof Error?Q.message:Q}`),new Error(""))}};U=fe([K(1,u.IFileService),K(2,t.IExtensionsScannerService),K(3,C.ILogService)],U);class O extends w.AbstractExtensionTask{get operation(){return(0,I.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(z,q,j,Q,G){super();this.identifier=z,this.source=q,this.options=j,this.extensionsScanner=Q,this.logService=G,this._operation=2}async installExtension(z,q){try{const j=await this.unsetUninstalledAndGetLocal(z.key);if(j)return z.metadata?this.extensionsScanner.updateMetadata(j,z.metadata):j}catch{throw b.isMacintosh?new f.ExtensionManagementError(d.localize(4,null),f.ExtensionManagementErrorCode.Internal):new f.ExtensionManagementError(d.localize(5,null),f.ExtensionManagementErrorCode.Internal)}return this.extract(z,q)}async unsetUninstalledAndGetLocal(z){if(!await this.isUninstalled(z))return null;this.logService.trace("Removing the extension from uninstalled list:",z.id);const j=await this.extensionsScanner.setInstalled(z);return this.logService.info("Removed the extension from uninstalled list:",z.id),j}async isUninstalled(z){return!!(await this.extensionsScanner.getUninstalledExtensions())[z.toString()]}async extract({zipPath:z,key:q,metadata:j},Q){let G=await this.extensionsScanner.extractUserExtension(q,z,j,Q);return this.logService.info("Extracting completed.",q.id),G}}class $ extends O{constructor(z,q,j,Q,G){super(z.identifier,z,q,Q,G);this.gallery=z,this.extensionsDownloader=j}async doRun(z){const j=(await this.extensionsScanner.scanExtensions(null)).find(G=>(0,l.areSameExtensions)(G.identifier,this.gallery.identifier));j&&(this._operation=3);const Q=await this.downloadInstallableExtension(this.gallery,this._operation);Q.metadata.isMachineScoped=this.options.isMachineScoped||j?.isMachineScoped,Q.metadata.isBuiltin=this.options.isBuiltin||j?.isBuiltin,Q.metadata.isSystem=j?.type===0?!0:void 0,Q.metadata.updated=!!j,Q.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,Q.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,I.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:j?.preRelease);try{const G=await this.installExtension(Q,z);return j&&(j.targetPlatform!==G.targetPlatform||D.neq(j.manifest.version,G.manifest.version))&&await this.extensionsScanner.setUninstalled(j),G}catch(G){throw await this.deleteDownloadedVSIX(Q.zipPath),G}}async deleteDownloadedVSIX(z){try{await this.extensionsDownloader.delete(h.URI.file(z))}catch(q){this.logService.warn("Error while deleting the downloaded vsix",z.toString(),(0,k.getErrorMessage)(q))}}async downloadInstallableExtension(z,q){const j={id:z.identifier.uuid,publisherId:z.publisherId,publisherDisplayName:z.publisherDisplayName,targetPlatform:z.properties.targetPlatform};let Q;try{this.logService.trace("Started downloading extension:",z.identifier.id),Q=(await this.extensionsDownloader.downloadExtension(z,q)).fsPath,this.logService.info("Downloaded extension:",z.identifier.id,Q)}catch(G){throw new f.ExtensionManagementError((0,w.joinErrors)(G).message,f.ExtensionManagementErrorCode.Download)}try{return await(0,a.getManifest)(Q),{zipPath:Q,key:l.ExtensionKey.create(z),metadata:j}}catch(G){throw await this.deleteDownloadedVSIX(Q),new f.ExtensionManagementError((0,w.joinErrors)(G).message,f.ExtensionManagementErrorCode.Invalid)}}}class V extends O{constructor(z,q,j,Q,G,X){super({id:(0,l.getGalleryExtensionId)(z.publisher,z.name)},q,j,G,X);this.manifest=z,this.location=q,this.galleryService=Q}async doRun(z){const q=new l.ExtensionKey(this.identifier,this.manifest.version),Q=(await this.extensionsScanner.scanExtensions(1)).find(X=>(0,l.areSameExtensions)(this.identifier,X.identifier)),G=await this.getMetadata(this.identifier.id,this.manifest.version,z);if(G.isMachineScoped=this.options.isMachineScoped||Q?.isMachineScoped,G.isBuiltin=this.options.isBuiltin||Q?.isBuiltin,Q)if(this._operation=3,q.equals(new l.ExtensionKey(Q.identifier,Q.manifest.version)))try{await this.extensionsScanner.removeExtension(Q,"existing")}catch{throw new Error(d.localize(6,null,this.manifest.displayName||this.manifest.name))}else D.gt(Q.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(Q);else{const X=await this.unsetUninstalledAndGetLocal(q);if(X)try{await this.extensionsScanner.removeExtension(X,"existing")}catch{throw new Error(d.localize(7,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:P.resolve(this.location.fsPath),key:q,metadata:G},z)}async getMetadata(z,q,j){try{let[Q]=await this.galleryService.getExtensions([{id:z,version:q}],j);if(Q||([Q]=await this.galleryService.getExtensions([{id:z}],j)),Q)return{id:Q.identifier.uuid,publisherDisplayName:Q.publisherDisplayName,publisherId:Q.publisherId,isPreReleaseVersion:Q.properties.isPreReleaseVersion,preRelease:Q.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class te extends w.AbstractExtensionTask{constructor(z,q,j){super();this.extension=z,this.options=q,this.extensionsScanner=j}async doRun(z){const q=[],j=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const Q=l.ExtensionKey.create(this.extension);q.push(...j.filter(G=>Q.equals(l.ExtensionKey.create(G))))}else q.push(...j.filter(Q=>(0,l.areSameExtensions)(Q.identifier,this.extension.identifier)));if(!q.length)throw new Error(d.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...q),this.options.remove)for(const Q of q)try{z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(Q)}catch(G){throw new Error(d.localize(9,null,(0,i.toErrorMessage)(G)))}}}}),define(re[266],se([0,1,94,60,35,18,7,3,2,12,4,30,37,84,277]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{traceSocketEvent(C,M){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,M)}constructor(C,M=""){this.debugLabel=M,this.socket=C,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=T=>{if(this.traceSocketEvent("error",{code:T?.code,message:T?.message}),T){if(T.code==="EPIPE")return;(0,A.onUnexpectedError)(T)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(C){const M=T=>{this.traceSocketEvent("read",T),C(L.VSBuffer.wrap(T))};return this.socket.on("data",M),{dispose:()=>this.socket.off("data",M)}}onClose(C){const M=T=>{this.traceSocketEvent("close",{hadError:T}),C({type:0,hadError:T,error:void 0})};return this.socket.on("close",M),{dispose:()=>this.socket.off("close",M)}}onEnd(C){const M=()=>{this.traceSocketEvent("nodeEndReceived"),C()};return this.socket.on("end",M),{dispose:()=>this.socket.off("end",M)}}write(C){if(!this.socket.destroyed)try{this.traceSocketEvent("write",C),this.socket.write(C.buffer,M=>{if(M){if(M.code==="EPIPE")return;(0,A.onUnexpectedError)(M)}})}catch(M){if(M.code==="EPIPE")return;(0,A.onUnexpectedError)(M)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((C,M)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),C();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent("nodeDrainEnd"),C()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=p;var d;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var g;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(g||(g={}));class S extends b.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(C,M){this.socket.traceSocketEvent(C,M)}constructor(C,M,T,F){super();this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=C,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:M,inflateBytesLength:T?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new w(this,M,T,F,this._onData,(_,U)=>this._write(_,U))),this._register(this._flowManager.onError(_=>{console.error(_),(0,A.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this._onData.event(C)}onClose(C){return this._onClose.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){this._flowManager.writeMessage(C)}_write(C,M){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",C);let T=2;C.byteLength<126?T+=0:C.byteLength<2**16?T+=2:T+=8;const F=L.VSBuffer.alloc(T);if(M?F.writeUInt8(194,0):F.writeUInt8(130,0),C.byteLength<126)F.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){F.writeUInt8(126,1);let _=1;F.writeUInt8(C.byteLength>>>8&255,++_),F.writeUInt8(C.byteLength>>>0&255,++_)}else{F.writeUInt8(127,1);let _=1;F.writeUInt8(0,++_),F.writeUInt8(0,++_),F.writeUInt8(0,++_),F.writeUInt8(0,++_),F.writeUInt8(C.byteLength>>>24&255,++_),F.writeUInt8(C.byteLength>>>16&255,++_),F.writeUInt8(C.byteLength>>>8&255,++_),F.writeUInt8(C.byteLength>>>0&255,++_)}this.socket.write(L.VSBuffer.concat([F,C]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(C){if(C.byteLength!==0){for(this._incomingData.acceptChunk(C);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const M=this._incomingData.peek(this._state.readLen),T=M.readUInt8(0),F=(T&128)>>>7,_=(T&64)>>>6,U=M.readUInt8(1),O=(U&128)>>>7,$=U&127;this._state.state=2,this._state.readLen=2+(O?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(F),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const M=this._incomingData.read(this._state.readLen),T=M.readUInt8(1),F=(T&128)>>>7;let _=T&127,U=1;_===126?_=M.readUInt8(++U)*2**8+M.readUInt8(++U):_===127&&(_=M.readUInt8(++U)*0+M.readUInt8(++U)*0+M.readUInt8(++U)*0+M.readUInt8(++U)*0+M.readUInt8(++U)*2**24+M.readUInt8(++U)*2**16+M.readUInt8(++U)*2**8+M.readUInt8(++U));let O=0;F&&(O=M.readUInt8(++U)*2**24+M.readUInt8(++U)*2**16+M.readUInt8(++U)*2**8+M.readUInt8(++U)),this._state.state=3,this._state.readLen=_,this._state.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const M=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",M),t(M,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",M),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(M,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class w extends b.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(C,M,T,F,_,U){super();this._tracer=C,this._onData=_,this._writeFn=U,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,M?(this._zlibInflateStream=this._register(new f(this._tracer,F,T,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(O=>this._onError.fire(O))),this._register(this._zlibDeflateStream.onError(O=>this._onError.fire(O)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(C){this._writeQueue.push(C),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const C=this._writeQueue.shift();if(this._zlibDeflateStream){const M=await this._deflateMessage(this._zlibDeflateStream,C);this._writeFn(M,!0)}else this._writeFn(C,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(C,M){return new Promise((T,F)=>{C.write(M),C.flush(_=>T(_))})}acceptFrame(C,M,T){this._readQueue.push({data:C,isCompressed:M,isLastFrameOfMessage:T}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const C=this._readQueue.shift();if(this._zlibInflateStream&&C.isCompressed){const M=await this._inflateFrame(this._zlibInflateStream,C.data,C.isLastFrameOfMessage);this._onData.fire(M)}else this._onData.fire(C.data)}this._isProcessingReadQueue=!1}}_inflateFrame(C,M,T){return new Promise((F,_)=>{C.write(M),T&&C.write(L.VSBuffer.fromByteArray([0,0,255,255])),C.flush(U=>F(U))})}}class f extends b.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}constructor(C,M,T,F){super();this._tracer=C,this._recordInflateBytes=M,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=v.createInflateRaw(F),this._zlibInflate.on("error",_=>{this._tracer.traceSocketEvent("zlibInflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibInflate.on("data",_=>{this._tracer.traceSocketEvent("zlibInflateData",_),this._pendingInflateData.push(L.VSBuffer.wrap(_))}),T&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",T.buffer),this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(C){this._recordInflateBytes&&this._recordedInflateBytes.push(C.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",C),this._zlibInflate.write(C.buffer)}flush(C){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const M=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,C(M)})}}class l extends b.Disposable{constructor(C,M){super();this._tracer=C,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=v.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibDeflate.on("data",T=>{this._tracer.traceSocketEvent("zlibDeflateData",T),this._pendingDeflateData.push(L.VSBuffer.wrap(T))})}write(C){this._tracer.traceSocketEvent("zlibDeflateWrite",C.buffer),this._zlibDeflate.write(C.buffer)}flush(C){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let M=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,M=M.slice(0,M.byteLength-4),C(M)})}}function t(m,C){if(C===0)return;let M=m.byteLength>>>2;for(let $=0;$<M;$++){const V=m.readUInt32BE($*4);m.writeUInt32BE(V^C,$*4)}let T=M*4,F=m.byteLength-T;const _=C>>>24&255,U=C>>>16&255,O=C>>>8&255;F>=1&&m.writeUInt8(m.readUInt8(T)^_,T),F>=2&&m.writeUInt8(m.readUInt8(T+1)^U,T+1),F>=3&&m.writeUInt8(m.readUInt8(T+2)^O,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function n(){const m=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let C;return e.XDG_RUNTIME_DIR?C=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):C=(0,E.join)((0,k.tmpdir)(),`vscode-ipc-${m}.sock`),c(C),C}e.createRandomIPCHandle=n;function a(m,C,M){const T=(0,R.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${M}-${C}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${M}-${C}.sock`):F=(0,E.join)(m,`${M}-${C}.sock`),c(F),F}e.createStaticIPCHandle=a;function c(m){const C=r[D.platform];typeof C=="number"&&m.length>=C&&console.warn(`WARNING: IPC handle "${m}" is longer than ${C} chars, try a shorter --user-data-dir`)}class o extends h.IPCServer{static toClientConnectionEvent(C){const M=P.Event.fromNodeEventEmitter(C,"connection");return P.Event.map(M,T=>({protocol:new y.Protocol(new p(T,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(T,"close"))}))}constructor(C){super(o.toClientConnectionEvent(C));this.server=C}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function s(m){return new Promise((C,M)=>{const T=(0,i.createServer)();T.on("error",M),T.listen(m,()=>{T.removeListener("error",M),C(new o(T))})})}e.serve=s;function u(m,C){return new Promise((M,T)=>{const F=(0,i.createConnection)(m,()=>{F.removeListener("error",T),M(y.Client.fromSocket(new p(F,`ipc-client${C}`),C))});F.once("error",T)})}e.connect=u}),define(re[267],se([0,1,60,266]),function(J,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,L,A,P,b,E){const D=h=>E(h,void 0),I=R.createConnection({host:k,port:L},()=>{I.removeListener("error",D);const h=Buffer.alloc(16);for(let d=0;d<16;d++)h[d]=Math.round(Math.random()*256);const y=h.toString("base64"),v=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${L}${A}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];I.write(v.join(`\r
`)+`\r
\r
`);const p=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",p),E(void 0,new i.NodeSocket(I,b)))};I.on("data",p)});I.setNoDelay(!0),I.once("error",D)}}}),define(re[268],se([0,1,60,124,267,6,2,17,9,24,207,71,102]),function(J,e,R,i,k,L,A,P,b,E,D,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(S,w,f,l,t){let r;for(let n=3;n&&(r&&r.dispose(),r=await new v(S,w,f,l,t).waitForReady(),!(t&&i.BROWSER_RESTRICTED_PORTS[t]||!i.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));n--);return r}class v extends A.Disposable{constructor(w,f,l,t,r){super();this.defaultTunnelHost=f,this.suggestedLocalPort=r,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=w,this._server=R.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let w=await(0,i.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(w,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(w=0,this._server.listen(w,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(w){w.pause();const f=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,D.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),t=l.getSocket().socket,r=l.readEntireBuffer();l.dispose(),r.byteLength>0&&w.write(r.buffer),w.on("end",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),t.end()}),w.on("close",()=>t.end()),w.on("error",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),t.destroy()}),t.on("end",()=>w.end()),t.on("close",()=>w.end()),t.on("error",()=>{w.destroy()}),w.pipe(t),t.pipe(w),w.localAddress&&this._socketsDispose.set(w.localAddress,()=>{w.end(),t.end()})}}let p=class extends I.AbstractTunnelService{constructor(w,f,l,t,r){super(f);this.socketFactory=w,this.signService=l,this.productService=t,this.configurationService=r}get defaultTunnelHost(){const w=this.configurationService.getValue("remote.localPortHost");return!w||w==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(w,f,l,t,r,n,a){const c=this.getTunnelFromMap(f,l);if(c)return++c.refcount,c.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,l,t,r,n,a);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${l} on local port ${t}.`);const o={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:w,signService:this.signService,logService:this.logService,ipcLogger:null},s=y(o,this.defaultTunnelHost,f,l,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,l,s),s}}};e.BaseTunnelService=p,e.BaseTunnelService=p=fe([K(1,b.ILogService),K(2,h.ISignService),K(3,E.IProductService),K(4,P.IConfigurationService)],p);let d=class extends p{constructor(w,f,l,t){super(k.nodeSocketFactory,w,f,l,t)}};e.TunnelService=d,e.TunnelService=d=fe([K(0,b.ILogService),K(1,h.ISignService),K(2,E.IProductService),K(3,P.IConfigurationService)],d);let g=class extends A.Disposable{constructor(w,f,l,t){super();this.logService=w,this.productService=f,this.signService=l,this.configurationService=t,this._tunnelServices=new Map}async openTunnel(w,f,l,t,r,n,a,c){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${t} on local port ${r}.`),!this._tunnelServices.has(w)){const o=new d(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(w,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(w))})}return this._tunnelServices.get(w).openTunnel(f,l,t,r,n,a,c)}};e.SharedTunnelsService=g,e.SharedTunnelsService=g=fe([K(0,b.ILogService),K(1,E.IProductService),K(2,h.ISignService),K(3,P.IConfigurationService)],g)}),define(re[278],se([0,1,85,35,36,7,2,19,20,8,37,127,195,218,196,185,186,187,173,176,17,200,90,222,91,210,14,214,217,226,29,175,224,265,92,171,15,190,192,54,5,182,96,183,184,65,206,9,97,66,98,24,209,43,21,220,221,22,103,104,105,48,227,228,106,230,236,70,108,25,72,252,254,255,73,253,257,258,259,260,261,102,216,71,268,208,237,101,213,32,239,4,240,177,198,197,69,205,194,57,93,193,263,56]),function(J,e,R,i,k,L,A,P,b,E,D,I,h,y,v,p,d,g,S,w,f,l,t,r,n,a,c,o,s,u,m,C,M,T,F,_,U,O,$,V,te,H,z,q,j,Q,G,X,Z,W,ee,B,N,x,Y,ne,oe,de,me,Ee,Se,ve,we,De,Ae,Oe,We,Ke,ae,le,ue,Ce,Ie,Ne,Le,Fe,Te,Me,ie,ce,he,ge,be,pe,Pe,ke,_e,Re,$e,ze,je,Ze,St,ht,yt,dt,wt,Et,bt,ft,Ct,Pt,It,Dt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Rt extends A.Disposable{constructor(ye){super();this.configuration=ye,this.server=this._register(new I.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Ue="vscode:electron-main->shared-process=disposeWorker",qe=(xe,Qe)=>this.onDisposeWorker(Qe);R.ipcRenderer.on(Ue,qe),this._register((0,A.toDisposable)(()=>R.ipcRenderer.removeListener(Ue,qe)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,le.registerConfiguration)(),ye.invokeFunction(Ue=>{const qe=Ue.get(X.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(qe)}),this._register((0,A.combinedDisposable)(ye.createInstance(h.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(v.LanguagePackCachedDataCleaner),ye.createInstance(g.StorageDataCleaner,this.configuration.backupWorkspacesPath),ye.createInstance(d.LogsDataCleaner),ye.createInstance(p.LocalizationsUpdater),ye.createInstance(y.ExtensionsCleaner)))}async initServices(){const ye=new z.ServiceCollection,Ue={_serviceBrand:void 0,...ee.default};ye.set(B.IProductService,Ue);const qe=new D.StaticRouter(He=>He==="main"),xe=new q.MessagePortMainProcessService(this.server,qe);ye.set(j.IMainProcessService,xe);const Qe=this.configuration.policiesData?new bt.PolicyChannelClient(this.configuration.policiesData,xe.getChannel("policy")):new ft.NullPolicyService;ye.set(ft.IPolicyService,Qe);const Be=new o.SharedProcessEnvironmentService(this.configuration.args,Ue);ye.set(c.INativeEnvironmentService,Be);const it=new Z.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Xe=new Z.LoggerChannelClient(this.configuration.logLevel,it.onDidChangeLogLevel,xe.getChannel("logger"));ye.set(X.ILoggerService,Xe);const st=this._register(new X.MultiplexLogService([this._register(new X.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,b.joinPath)(E.URI.file(Be.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new Z.FollowerLogService(it,st));ye.set(X.ILogService,Ve),this.sharedProcessWorkerService=new $e.SharedProcessWorkerService(Ve),ye.set(Re.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ye=this._register(new O.FileService(Ve));ye.set(U.IFileService,Ye);const ot=this._register(new $.DiskFileSystemProvider(Ve));Ye.registerProvider(P.Schemas.file,ot);const at=this._register(new St.FileUserDataProvider(P.Schemas.file,this._register(new ht.DiskFileSystemProviderClient(xe.getChannel(ht.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Ze.isLinux})),P.Schemas.vscodeUserData,Ve));Ye.registerProvider(P.Schemas.vscodeUserData,at);const Je=this._register(new l.ConfigurationService(Be.settingsResource,Ye,Qe,Ve));ye.set(f.IConfigurationService,Je);const et=new ne.NativeStorageService(void 0,xe,Be);ye.set(Y.IStorageService,et),this._register((0,A.toDisposable)(()=>et.flush())),await Promise.all([Je.initialize(),et.initialize()]),ye.set(ze.IUriIdentityService,new je.UriIdentityService(Ye)),ye.set(x.IRequestService,new V.SyncDescriptor(N.RequestService)),ye.set(S.IChecksumService,new V.SyncDescriptor(w.ChecksumService)),ye.set(dt.IV8InspectProfilingService,new V.SyncDescriptor(yt.InspectProfilingService));const nt=D.ProxyChannel.toService(xe.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(W.INativeHostService,nt),ye.set(n.IDownloadService,new V.SyncDescriptor(a.DownloadService));const ct=this._register(new he.ActiveWindowManager(nt)),lt=new D.StaticRouter(He=>ct.getActiveClientId().then(ut=>He===ut));ye.set(F.IExtensionRecommendationNotificationService,new _.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",lt)));let rt;const tt=[];if((0,ve.supportsTelemetry)(Ue,Be)){const He=new Ee.TelemetryLogAppender(Xe,Be);tt.push(He);const{installSourcePath:ut}=Be;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const vt=new we.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey);this._register((0,A.toDisposable)(()=>vt.flush())),tt.push(vt)}rt=new Se.TelemetryService({appenders:tt,commonProperties:(0,oe.resolveCommonProperties)(Ye,(0,i.release)(),(0,i.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,ut),sendErrorTelemetry:!0,piiPaths:(0,ve.getPiiPathsFromEnvironment)(Be)},Je,Ue)}else{rt=ve.NullTelemetryService;const He=ve.NullAppender;tt.push(He)}this.server.registerChannel("telemetryAppender",new me.TelemetryAppenderChannel(tt)),ye.set(de.ITelemetryService,rt);const Lt=new De.CustomEndpointTelemetryService(Je,rt,Xe,Be,Ue);ye.set(de.ICustomEndpointTelemetryService,Lt),ye.set(wt.IExtensionsScannerService,new V.SyncDescriptor(Et.ExtensionsScannerService)),ye.set(m.IExtensionManagementService,new V.SyncDescriptor(T.ExtensionManagementService)),ye.set(Dt.INotificationService,new V.SyncDescriptor(It.NotificationService)),ye.set(Ct.IExtensionsGalleryConfigService,new V.SyncDescriptor(Pt.ExtensionsGalleryConfigService)),ye.set(m.IExtensionGalleryService,new V.SyncDescriptor(u.ExtensionGalleryService)),ye.set(m.IExtensionTipsService,new V.SyncDescriptor(M.ExtensionTipsService)),ye.set(Q.ILanguagePackService,new V.SyncDescriptor(G.NativeLanguagePackService)),ye.set(t.IDiagnosticsService,new V.SyncDescriptor(r.DiagnosticsService)),ye.set(ue.IUserDataSyncAccountService,new V.SyncDescriptor(ue.UserDataSyncAccountService)),ye.set(le.IUserDataSyncLogService,new V.SyncDescriptor(Ne.UserDataSyncLogService)),ye.set(le.IUserDataSyncUtilService,new Ie.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ye.set(m.IGlobalExtensionEnablementService,new V.SyncDescriptor(s.GlobalExtensionEnablementService)),ye.set(ae.IIgnoredExtensionsManagementService,new V.SyncDescriptor(ae.IgnoredExtensionsManagementService)),ye.set(Ke.IExtensionStorageService,new V.SyncDescriptor(Ke.ExtensionStorageService)),ye.set(le.IUserDataSyncStoreManagementService,new V.SyncDescriptor(ie.UserDataSyncStoreManagementService)),ye.set(le.IUserDataSyncStoreService,new V.SyncDescriptor(ie.UserDataSyncStoreService)),ye.set(Le.IUserDataSyncMachinesService,new V.SyncDescriptor(Le.UserDataSyncMachinesService)),ye.set(le.IUserDataSyncBackupStoreService,new V.SyncDescriptor(Ce.UserDataSyncBackupStoreService)),ye.set(le.IUserDataSyncEnablementService,new V.SyncDescriptor(Fe.UserDataSyncEnablementService)),ye.set(le.IUserDataSyncService,new V.SyncDescriptor(Te.UserDataSyncService));const mt=new We.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Je.getValue("terminal.integrated.persistentSessionScrollback")??100},Je,Be,Ve);return mt.initialize(),ye.set(Oe.ILocalPtyService,this._register(mt)),ye.set(ge.ISignService,new V.SyncDescriptor(be.SignService)),ye.set(pe.ISharedTunnelsService,new V.SyncDescriptor(Pe.SharedTunnelsService)),ye.set(ke.ISharedProcessTunnelService,new V.SyncDescriptor(_e.SharedProcessTunnelService)),new H.InstantiationService(ye)}initChannels(ye){const Ue=new C.ExtensionManagementChannel(ye.get(m.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const qe=D.ProxyChannel.fromService(ye.get(Q.ILanguagePackService));this.server.registerChannel("languagePacks",qe);const xe=D.ProxyChannel.fromService(ye.get(t.IDiagnosticsService));this.server.registerChannel("diagnostics",xe);const Qe=new C.ExtensionTipsChannel(ye.get(m.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Qe);const Be=D.ProxyChannel.fromService(ye.get(S.IChecksumService));this.server.registerChannel("checksum",Be);const it=D.ProxyChannel.fromService(ye.get(dt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",it);const Xe=new Ie.UserDataSyncMachinesServiceChannel(ye.get(Le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Xe);const st=D.ProxyChannel.fromService(ye.get(de.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",st);const Ve=new Ie.UserDataSyncAccountServiceChannel(ye.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const Ye=new Ie.UserDataSyncStoreManagementServiceChannel(ye.get(le.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ye);const ot=new Me.UserDataSyncChannel(ye.get(le.IUserDataSyncService),ye.get(X.ILogService));this.server.registerChannel("userDataSync",ot);const at=this._register(ye.get(te.IInstantiationService).createInstance(ce.UserDataAutoSyncService)),Je=new Ie.UserDataAutoSyncChannel(at);this.server.registerChannel("userDataAutoSync",Je);const et=ye.get(Oe.ILocalPtyService),nt=D.ProxyChannel.fromService(et);this.server.registerChannel(Ae.TerminalIpcChannels.LocalPty,nt);const ct=D.ProxyChannel.fromService(ye.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ct);const lt=D.ProxyChannel.fromService(ye.get(Re.ISharedProcessWorkerService));this.server.registerChannel(Re.ipcSharedProcessWorkerChannelName,lt)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Ue=>{(0,L.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Ue=>{const qe=(0,k.toErrorMessage)(Ue,!0);!qe||ye.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function kt(gt){const ye=new Rt(gt);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=kt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
