define(["require","exports","electron","fs","vs/base/common/uri","vs/base/common/arrays","vs/base/common/async","vs/base/common/errorMessage","vs/base/common/errors","vs/base/common/extpath","vs/base/common/functional","vs/base/common/labels","vs/base/common/network","vs/base/common/path","vs/base/common/performance","vs/base/common/platform","vs/base/common/process","vs/base/common/strings","vs/base/node/pfs","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/node/ipc.net","vs/code/electron-main/app","vs/nls!vs/code/electron-main/main","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/environment/electron-main/environmentMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/wait","vs/platform/files/common/files","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/instantiationService","vs/platform/instantiation/common/serviceCollection","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/log/common/bufferLog","vs/platform/log/common/log","vs/platform/log/node/loggerService","vs/platform/log/node/spdlogLog","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/protocol/electron-main/protocol","vs/platform/protocol/electron-main/protocolMainService","vs/platform/tunnel/common/tunnel","vs/platform/tunnel/node/tunnelService","vs/platform/request/common/request","vs/platform/request/electron-main/requestMainService","vs/platform/sign/common/sign","vs/platform/sign/node/signService","vs/platform/state/electron-main/state","vs/platform/state/electron-main/stateMainService","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/policy/common/policy","vs/platform/policy/node/nativePolicyService","vs/platform/policy/common/filePolicyService","vs/base/common/lifecycle","vs/platform/update/common/update.config.contribution"],function(T,O,L,z,q,y,V,A,w,I,k,C,B,b,F,u,U,h,E,M,D,j,g,G,$,K,x,W,X,R,J,Q,p,Y,Z,P,_,f,ee,te,oe,ne,ie,re,se,ae,ce,le,me,ue,de,ve,ge,H,N,fe,pe,Se){"use strict";Object.defineProperty(O,"__esModule",{value:!0});class we{main(){try{this.startup()}catch(e){console.error(e.message),L.app.exit(1)}}async startup(){(0,w.setUnexpectedErrorHandler)(r=>console.error(r));const[e,t,o,n,i,d,s,a]=this.createServices();try{try{await this.initServices(o,n,i,d)}catch(r){throw this.handleStartupDataDirError(o,a.nameLong,r),r}await e.invokeFunction(async r=>{const c=r.get(f.ILogService),l=r.get(P.ILifecycleMainService),S=r.get(R.IFileService),m=await this.claimInstance(c,o,l,e,a,!0);return E.Promises.writeFile(o.mainLockfile,String(process.pid)).catch(v=>{c.warn(`Error writing main lockfile: ${v.stack}`)}),s.logger=new te.SpdLogLogger("main",(0,b.join)(o.logsPath,"main.log"),!0,!1,s.getLevel()),(0,k.once)(l.onWillShutdown)(v=>{S.dispose(),i.dispose(),v.join(E.Promises.unlink(o.mainLockfile).catch(()=>{}))}),e.createInstance(j.CodeApplication,m,t).startup()})}catch(r){e.invokeFunction(this.quit,r)}}createServices(){const e=new Z.ServiceCollection,t=new Se.DisposableStore;process.once("exit",()=>t.dispose());const o={_serviceBrand:void 0,...oe.default};e.set(ne.IProductService,o);const n=new x.EnvironmentMainService(this.resolveArgs(),o),i=this.patchEnvironment(n);e.set(x.IEnvironmentMainService,n);const d=new _.BufferLogService,s=t.add(new f.MultiplexLogService([new f.ConsoleMainLogger((0,f.getLogLevel)(n)),d]));e.set(f.ILogService,s);const a=new J.FileService(s);e.set(R.IFileService,a);const r=new Q.DiskFileSystemProvider(s);a.registerProvider(B.Schemas.file,r),e.set(f.ILoggerService,new ee.LoggerService(s,a));const c=u.isWindows&&o.win32RegValueName?t.add(new fe.NativePolicyService(o.win32RegValueName)):n.policyFile?t.add(new pe.FilePolicyService(n.policyFile,a,s)):new N.NullPolicyService;e.set(N.IPolicyService,c);const l=new $.ConfigurationService(n.settingsResource,a,c,s);e.set(G.IConfigurationService,l),e.set(P.ILifecycleMainService,new p.SyncDescriptor(P.LifecycleMainService));const S=new ve.StateMainService(n,s,a);return e.set(de.IStateMainService,S),e.set(ce.IRequestService,new p.SyncDescriptor(le.RequestMainService)),e.set(H.IThemeMainService,new p.SyncDescriptor(H.ThemeMainService)),e.set(me.ISignService,new p.SyncDescriptor(ue.SignService)),e.set(se.ITunnelService,new p.SyncDescriptor(ae.TunnelService)),e.set(ie.IProtocolMainService,new p.SyncDescriptor(re.ProtocolMainService)),[new Y.InstantiationService(e,!0),i,n,c,l,S,d,o]}patchEnvironment(e){const t={VSCODE_IPC_HOOK:e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(o=>{const n=process.env[o];typeof n=="string"&&(t[o]=n)}),Object.assign(process.env,t),t}initServices(e,t,o,n){return V.Promises.settled([Promise.all([e.extensionsPath,e.codeCachePath,e.logsPath,e.globalStorageHome.fsPath,e.workspaceStorageHome.fsPath,e.localHistoryHome.fsPath,e.backupHome].map(i=>i?E.Promises.mkdir(i,{recursive:!0}):void 0)),o.initialize(),n.init()])}async claimInstance(e,t,o,n,i,d){let s;try{(0,F.mark)("code/willStartMainServer"),s=await(0,D.serve)(t.mainIPCHandle),(0,F.mark)("code/didStartMainServer"),(0,k.once)(o.onWillShutdown)(()=>s.dispose())}catch(a){if(a.code!=="EADDRINUSE")throw this.handleStartupDataDirError(t,i.nameLong,a),a;let r;try{r=await(0,D.connect)(t.mainIPCHandle,"main")}catch(m){if(!d||u.isWindows||m.code!=="ECONNREFUSED")throw m.code==="EPERM"&&this.showStartupWarningDialog((0,g.localize)(0,null,i.nameShort),(0,g.localize)(1,null),i.nameLong),m;try{(0,z.unlinkSync)(t.mainIPCHandle)}catch(v){throw e.warn("Could not delete obsolete instance handle",v),v}return this.claimInstance(e,t,o,n,i,!1)}if(t.extensionTestsLocationURI&&!t.debugExtensionHost.break){const m="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw e.error(m),r.dispose(),new Error(m)}let c;!t.args.wait&&!t.args.status&&(c=setTimeout(()=>{this.showStartupWarningDialog((0,g.localize)(2,null,i.nameShort),(0,g.localize)(3,null),i.nameLong)},1e4));const l=M.ProxyChannel.toService(r.getChannel("launch"),{disableMarshalling:!0}),S=M.ProxyChannel.toService(r.getChannel("diagnostics"),{disableMarshalling:!0});if(t.args.status)return n.invokeFunction(async()=>{const m=new K.DiagnosticsService(ge.NullTelemetryService,i),v=await l.getMainProcessInfo(),he=await S.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Pe=await m.getDiagnostics(v,he);throw console.log(Pe),new w.ExpectedError});throw u.isWindows&&await this.windowsAllowSetForegroundWindow(l,e),e.trace("Sending env to running instance..."),await l.start(t.args,process.env),r.dispose(),c&&clearTimeout(c),new w.ExpectedError("Sent env to running instance. Terminating...")}if(t.args.status)throw e.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new w.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),s}handleStartupDataDirError(e,t,o){if(o.code==="EACCES"||o.code==="EPERM"){const n=(0,y.coalesce)([e.userDataPath,e.extensionsPath,D.XDG_RUNTIME_DIR]).map(i=>(0,C.getPathLabel)(q.URI.file(i),{os:u.OS,tildify:e}));this.showStartupWarningDialog((0,g.localize)(4,null),(0,g.localize)(5,null,(0,A.toErrorMessage)(o),n.join(`
`)),t)}}showStartupWarningDialog(e,t,o){L.dialog.showMessageBoxSync({title:o,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,g.localize)(6,null))],message:e,detail:t,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(e,t){if(u.isWindows){const o=await e.getMainProcessId();t.trace("Sending some foreground love to the running instance:",o);try{(await new Promise((n,i)=>{T(["windows-foreground-love"],n,i)})).allowSetForegroundWindow(o)}catch(n){t.error(n)}}}quit(e,t){const o=e.get(f.ILogService),n=e.get(P.ILifecycleMainService);let i=0;t&&(t.isExpected?t.message&&o.trace(t.message):(i=1,t.stack?o.error(t.stack):o.error(`Startup error: ${t.toString()}`))),n.kill(i)}resolveArgs(){const e=this.validatePaths((0,W.parseMainProcessArgv)(process.argv));if(e.wait&&!e.waitMarkerFilePath){const t=(0,X.createWaitMarkerFile)(e.verbose);t&&((0,W.addArg)(process.argv,"--waitMarkerFilePath",t),e.waitMarkerFilePath=t)}return e}validatePaths(e){if(e["open-url"]&&(e._urls=e._,e._=[]),!e.remote){const t=this.doValidatePaths(e._,e.goto);e._=t}return e}doValidatePaths(e,t){const o=(0,U.cwd)(),n=e.map(s=>{let a=String(s),r;t&&(r=(0,I.parseLineAndColumnAware)(a),a=r.path),a&&(a=this.preparePath(o,a));const c=(0,I.sanitizeFilePath)(a,o),l=(0,b.basename)(c);return l&&!(0,I.isValidBasename)(l)?null:t&&r?(r.path=c,this.toPath(r)):c}),i=u.isWindows||u.isMacintosh,d=(0,y.distinct)(n,s=>s&&i?s.toLowerCase():s||"");return(0,y.coalesce)(d)}preparePath(e,t){return u.isWindows&&(t=(0,h.rtrim)(t,'"')),t=(0,h.trim)((0,h.trim)(t," "),"	"),u.isWindows&&(t=(0,b.resolve)(e,t),t=(0,h.rtrim)(t,".")),t}toPath(e){const t=[e.path];return typeof e.line=="number"&&t.push(String(e.line)),typeof e.column=="number"&&t.push(String(e.column)),t.join(":")}}new we().main()});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/code/electron-main/main.js.map
