/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/types","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/path","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/resources","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/decorators","vs/base/common/stream","vs/base/common/severity","child_process","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/request/common/request","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/marshalling","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/download/common/download","vs/platform/extensionsGallery/common/extensionsGalleryConfigService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/base/common/map","vs/platform/configuration/common/configurationModels","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/extensionsGallery/common/extensionsGalleryConfig","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/extensionsGallery/common/extensionsGalleryConfig","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","graceful-fs","crypto","vs/platform/environment/node/argvHelper","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(W){for(var i=[],C=0,I=W.length;C<I;C++)i[C]=Q[W[C]];return i};define(Q[65],Z([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function C(I,P){if(!I)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}i.ok=C}),define(Q[40],Z([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function C(O){return(v,a,h)=>{let D=null,L=null;if(typeof h.value=="function"?(D="value",L=h.value):typeof h.get=="function"&&(D="get",L=h.get),!L)throw new Error("not supported");h[D]=O(L,a)}}i.createDecorator=C;function I(O,v,a){let h=null,D=null;if(typeof a.value=="function"?(h="value",D=a.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(h="get",D=a.get),!D)throw new Error("not supported");const L=`$memoize$${v}`;a[h]=function(...g){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,g)}),this[L]}}i.memoize=I;function P(O,v,a){return C((h,D)=>{const L=`$debounce$${D}`,g=`$debounce$result$${D}`;return function(...y){this[g]||(this[g]=a?a():void 0),clearTimeout(this[L]),v&&(this[g]=v(this[g],...y),y=[this[g]]),this[L]=setTimeout(()=>{h.apply(this,y),this[g]=a?a():void 0},O)}})}i.debounce=P;function R(O,v,a){return C((h,D)=>{const L=`$throttle$timer$${D}`,g=`$throttle$result$${D}`,y=`$throttle$lastRun$${D}`,w=`$throttle$pending$${D}`;return function(...d){if(this[g]||(this[g]=a?a():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),v&&(this[g]=v(this[g],...d)),this[w])return;const S=this[y]+O;S<=Date.now()?(this[y]=Date.now(),h.apply(this,[this[g]]),this[g]=a?a():void 0):(this[w]=!0,this[L]=setTimeout(()=>{this[w]=!1,this[y]=Date.now(),h.apply(this,[this[g]]),this[g]=a?a():void 0},S-Date.now()))}})}i.throttle=R}),define(Q[48],Z([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var C;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(C||(i.ScanError=C={}));var I;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(I||(i.SyntaxKind=I={}));var P;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(P||(i.ParseErrorCode=P={}));var R;(function(e){e.DEFAULT={allowTrailingComma:!0}})(R||(i.ParseOptions=R={}));function O(e,n=!1){let t=0,r=e.length,o="",u=0,m=16,p=0;function b(N){let j=0,q=0;for(;j<N;){const _=e.charCodeAt(t);if(_>=48&&_<=57)q=q*16+_-48;else if(_>=65&&_<=70)q=q*16+_-65+10;else if(_>=97&&_<=102)q=q*16+_-97+10;else break;t++,j++}return j<N&&(q=-1),q}function A(N){t=N,o="",u=0,m=16,p=0}function z(){const N=t;if(e.charCodeAt(t)===48)t++;else for(t++;t<e.length&&h(e.charCodeAt(t));)t++;if(t<e.length&&e.charCodeAt(t)===46)if(t++,t<e.length&&h(e.charCodeAt(t)))for(t++;t<e.length&&h(e.charCodeAt(t));)t++;else return p=3,e.substring(N,t);let j=t;if(t<e.length&&(e.charCodeAt(t)===69||e.charCodeAt(t)===101))if(t++,(t<e.length&&e.charCodeAt(t)===43||e.charCodeAt(t)===45)&&t++,t<e.length&&h(e.charCodeAt(t))){for(t++;t<e.length&&h(e.charCodeAt(t));)t++;j=t}else p=3;return e.substring(N,j)}function te(){let N="",j=t;for(;;){if(t>=r){N+=e.substring(j,t),p=2;break}const q=e.charCodeAt(t);if(q===34){N+=e.substring(j,t),t++;break}if(q===92){if(N+=e.substring(j,t),t++,t>=r){p=2;break}switch(e.charCodeAt(t++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const ne=b(4);ne>=0?N+=String.fromCharCode(ne):p=4;break}default:p=5}j=t;continue}if(q>=0&&q<=31)if(a(q)){N+=e.substring(j,t),p=2;break}else p=6;t++}return N}function J(){if(o="",p=0,u=t,t>=r)return u=r,m=17;let N=e.charCodeAt(t);if(v(N)){do t++,o+=String.fromCharCode(N),N=e.charCodeAt(t);while(v(N));return m=15}if(a(N))return t++,o+=String.fromCharCode(N),N===13&&e.charCodeAt(t)===10&&(t++,o+=`
`),m=14;switch(N){case 123:return t++,m=1;case 125:return t++,m=2;case 91:return t++,m=3;case 93:return t++,m=4;case 58:return t++,m=6;case 44:return t++,m=5;case 34:return t++,o=te(),m=10;case 47:{const j=t-1;if(e.charCodeAt(t+1)===47){for(t+=2;t<r&&!a(e.charCodeAt(t));)t++;return o=e.substring(j,t),m=12}if(e.charCodeAt(t+1)===42){t+=2;const q=r-1;let _=!1;for(;t<q;){if(e.charCodeAt(t)===42&&e.charCodeAt(t+1)===47){t+=2,_=!0;break}t++}return _||(t++,p=1),o=e.substring(j,t),m=13}return o+=String.fromCharCode(N),t++,m=16}case 45:if(o+=String.fromCharCode(N),t++,t===r||!h(e.charCodeAt(t)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=z(),m=11;default:for(;t<r&&oe(N);)t++,N=e.charCodeAt(t);if(u!==t){switch(o=e.substring(u,t),o){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return o+=String.fromCharCode(N),t++,m=16}}function oe(N){if(v(N)||a(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let N;do N=J();while(N>=12&&N<=15);return N}return{setPosition:A,getPosition:()=>t,scan:n?re:J,getToken:()=>m,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>t-u,getTokenError:()=>p}}i.createScanner=O;function v(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function a(e){return e===10||e===13||e===8232||e===8233}function h(e){return e>=48&&e<=57}var D;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(D||(D={}));function L(e,n){const t=[],r=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function p(b,A,z,te){u.value=b,u.offset=A,u.length=z,u.type=te,u.colonOffset=void 0,o=u}try{E(e,{onObjectBegin:(b,A)=>{if(n<=b)throw r;o=void 0,m=n>b,t.push("")},onObjectProperty:(b,A,z)=>{if(n<A||(p(b,A,z,"property"),t[t.length-1]=b,n<=A+z))throw r},onObjectEnd:(b,A)=>{if(n<=b)throw r;o=void 0,t.pop()},onArrayBegin:(b,A)=>{if(n<=b)throw r;o=void 0,t.push(0)},onArrayEnd:(b,A)=>{if(n<=b)throw r;o=void 0,t.pop()},onLiteralValue:(b,A,z)=>{if(n<A||(p(b,A,z,s(b)),n<=A+z))throw r},onSeparator:(b,A,z)=>{if(n<=A)throw r;if(b===":"&&o&&o.type==="property")o.colonOffset=A,m=!1,o=void 0;else if(b===","){const te=t[t.length-1];typeof te=="number"?t[t.length-1]=te+1:(m=!0,t[t.length-1]=""),o=void 0}}})}catch(b){if(b!==r)throw b}return{path:t,previousNode:o,isAtPropertyKey:m,matches:b=>{let A=0;for(let z=0;A<b.length&&z<t.length;z++)if(b[A]===t[z]||b[A]==="*")A++;else if(b[A]!=="**")return!1;return A===b.length}}}i.getLocation=L;function g(e,n=[],t=R.DEFAULT){let r=null,o=[];const u=[];function m(b){Array.isArray(o)?o.push(b):r!==null&&(o[r]=b)}return E(e,{onObjectBegin:()=>{const b={};m(b),u.push(o),o=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const b=[];m(b),u.push(o),o=b,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:m,onError:(b,A,z)=>{n.push({error:b,offset:A,length:z})}},t),o[0]}i.parse=g;function y(e,n=[],t=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(b){r.type==="property"&&(r.length=b-r.offset,r=r.parent)}function u(b){return r.children.push(b),b}E(e,{onObjectBegin:b=>{r=u({type:"object",offset:b,length:-1,parent:r,children:[]})},onObjectProperty:(b,A,z)=>{r=u({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:b,offset:A,length:z,parent:r})},onObjectEnd:(b,A)=>{r.length=b+A-r.offset,r=r.parent,o(b+A)},onArrayBegin:(b,A)=>{r=u({type:"array",offset:b,length:-1,parent:r,children:[]})},onArrayEnd:(b,A)=>{r.length=b+A-r.offset,r=r.parent,o(b+A)},onLiteralValue:(b,A,z)=>{u({type:s(b),offset:A,length:z,parent:r,value:b}),o(A+z)},onSeparator:(b,A,z)=>{r.type==="property"&&(b===":"?r.colonOffset=A:b===","&&o(A))},onError:(b,A,z)=>{n.push({error:b,offset:A,length:z})}},t);const p=r.children[0];return p&&delete p.parent,p}i.parseTree=y;function w(e,n){if(!e)return;let t=e;for(let r of n)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const u of t.children)if(Array.isArray(u.children)&&u.children[0].value===r){t=u.children[1],o=!0;break}if(!o)return}else{const o=r;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}i.findNodeAtLocation=w;function d(e){if(!e.parent||!e.parent.children)return[];const n=d(e.parent);if(e.parent.type==="property"){const t=e.parent.children[0].value;n.push(t)}else if(e.parent.type==="array"){const t=e.parent.children.indexOf(e);t!==-1&&n.push(t)}return n}i.getNodePath=d;function S(e){switch(e.type){case"array":return e.children.map(S);case"object":{const n=Object.create(null);for(let t of e.children){const r=t.children[1];r&&(n[t.children[0].value]=S(r))}return n}case"null":case"string":case"number":case"boolean":return e.value;default:return}}i.getNodeValue=S;function l(e,n,t=!1){return n>=e.offset&&n<e.offset+e.length||t&&n===e.offset+e.length}i.contains=l;function f(e,n,t=!1){if(l(e,n,t)){const r=e.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const u=f(r[o],n,t);if(u)return u}return e}}i.findNodeAtOffset=f;function E(e,n,t=R.DEFAULT){const r=O(e,!1);function o(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function u(B){return B?ae=>B(ae,r.getTokenOffset(),r.getTokenLength()):()=>!0}const m=o(n.onObjectBegin),p=u(n.onObjectProperty),b=o(n.onObjectEnd),A=o(n.onArrayBegin),z=o(n.onArrayEnd),te=u(n.onLiteralValue),J=u(n.onSeparator),oe=o(n.onComment),re=u(n.onError),N=t&&t.disallowComments,j=t&&t.allowTrailingComma;function q(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:_(14);break;case 5:_(15);break;case 3:_(13);break;case 1:N||_(11);break;case 2:_(12);break;case 6:_(16);break}switch(B){case 12:case 13:N?_(10):oe();break;case 16:_(1);break;case 15:case 14:break;default:return B}}}function _(B,ae=[],Y=[]){if(re(B),ae.length+Y.length>0){let ve=r.getToken();for(;ve!==17;){if(ae.indexOf(ve)!==-1){q();break}else if(Y.indexOf(ve)!==-1)break;ve=q()}}}function ne(B){const ae=r.getTokenValue();return B?te(ae):p(ae),q(),!0}function k(){switch(r.getToken()){case 11:{let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(_(2),B=0)}catch{_(2)}te(B);break}case 7:te(null);break;case 8:te(!0);break;case 9:te(!1);break;default:return!1}return q(),!0}function T(){return r.getToken()!==10?(_(3,[],[2,5]),!1):(ne(!1),r.getToken()===6?(J(":"),q(),$()||_(4,[],[2,5])):_(5,[],[2,5]),!0)}function F(){m(),q();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||_(4,[],[]),J(","),q(),r.getToken()===2&&j)break}else B&&_(6,[],[]);T()||_(4,[],[2,5]),B=!0}return b(),r.getToken()!==2?_(7,[2],[]):q(),!0}function x(){A(),q();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||_(4,[],[]),J(","),q(),r.getToken()===4&&j)break}else B&&_(6,[],[]);$()||_(4,[],[4,5]),B=!0}return z(),r.getToken()!==4?_(8,[4],[]):q(),!0}function $(){switch(r.getToken()){case 3:return x();case 1:return F();case 10:return ne(!0);default:return k()}}return q(),r.getToken()===17?t.allowEmptyContent?!0:(_(4,[],[]),!1):$()?(r.getToken()!==17&&_(9,[],[]),!0):(_(4,[],[]),!1)}i.visit=E;function c(e,n){let t=O(e),r=[],o,u=0,m;do switch(m=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:u!==m&&r.push(e.substring(u,m)),n!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,n)),u=t.getPosition();break}while(o!==17);return r.join("")}i.stripComments=c;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=s}),function(){function W(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function O(a){R.push(a,Date.now())}function v(){const a=[];for(let h=0;h<R.length;h+=2)a.push({name:R[h],startTime:R[h+1]});return a}return{mark:O,getMarks:v}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?W():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const O of performance.getEntriesByType("mark"))R.push({name:O.name,startTime:Math.round(P+O.startTime)});return R}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return W(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),W()}function C(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=i()),P.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=C(I))}(),define(Q[49],Z([0,1,8]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.removeDangerousEnvVariables=i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var I;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(I||(i.Source=I={}));var P;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(P||(i.TerminateResponseCode=P={}));function R(v,...a){const h=a.reduce((g,y)=>(g[y]=!0,g),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(g=>!h[g]).forEach(g=>{for(let y=0;y<D.length;y++)if(g.search(D[y])!==-1){delete v[g];break}})}i.sanitizeProcessEnvironment=R;function O(v){!v||(delete v.DEBUG,C.isMacintosh&&delete v.DYLD_LIBRARY_PATH,C.isLinux&&delete v.LD_PRELOAD)}i.removeDangerousEnvVariables=O}),function(W,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var C=i();for(var I in C)(typeof exports=="object"?exports:W)[I]=C[I]}}(typeof self!="undefined"?self:this,function(){return function(W){var i={};function C(I){if(i[I])return i[I].exports;var P=i[I]={i:I,l:!1,exports:{}};return W[I].call(P.exports,P,P.exports,C),P.l=!0,P.exports}return C.m=W,C.c=i,C.d=function(I,P,R){C.o(I,P)||Object.defineProperty(I,P,{enumerable:!0,get:R})},C.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},C.t=function(I,P){if(1&P&&(I=C(I)),8&P||4&P&&typeof I=="object"&&I&&I.__esModule)return I;var R=Object.create(null);if(C.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:I}),2&P&&typeof I!="string")for(var O in I)C.d(R,O,function(v){return I[v]}.bind(null,O));return R},C.n=function(I){var P=I&&I.__esModule?function(){return I.default}:function(){return I};return C.d(P,"a",P),P},C.o=function(I,P){return Object.prototype.hasOwnProperty.call(I,P)},C.p="",C(C.s=0)}([function(W,i,C){(function(I){var P;i=W.exports=Y,P=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var R=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,v=i.re=[],a=i.src=[],h=0,D=h++;a[D]="0|[1-9]\\d*";var L=h++;a[L]="[0-9]+";var g=h++;a[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=h++;a[y]="("+a[D]+")\\.("+a[D]+")\\.("+a[D]+")";var w=h++;a[w]="("+a[L]+")\\.("+a[L]+")\\.("+a[L]+")";var d=h++;a[d]="(?:"+a[D]+"|"+a[g]+")";var S=h++;a[S]="(?:"+a[L]+"|"+a[g]+")";var l=h++;a[l]="(?:-("+a[d]+"(?:\\."+a[d]+")*))";var f=h++;a[f]="(?:-?("+a[S]+"(?:\\."+a[S]+")*))";var E=h++;a[E]="[0-9A-Za-z-]+";var c=h++;a[c]="(?:\\+("+a[E]+"(?:\\."+a[E]+")*))";var s=h++,e="v?"+a[y]+a[l]+"?"+a[c]+"?";a[s]="^"+e+"$";var n="[v=\\s]*"+a[w]+a[f]+"?"+a[c]+"?",t=h++;a[t]="^"+n+"$";var r=h++;a[r]="((?:<|>)?=?)";var o=h++;a[o]=a[L]+"|x|X|\\*";var u=h++;a[u]=a[D]+"|x|X|\\*";var m=h++;a[m]="[v=\\s]*("+a[u]+")(?:\\.("+a[u]+")(?:\\.("+a[u]+")(?:"+a[l]+")?"+a[c]+"?)?)?";var p=h++;a[p]="[v=\\s]*("+a[o]+")(?:\\.("+a[o]+")(?:\\.("+a[o]+")(?:"+a[f]+")?"+a[c]+"?)?)?";var b=h++;a[b]="^"+a[r]+"\\s*"+a[m]+"$";var A=h++;a[A]="^"+a[r]+"\\s*"+a[p]+"$";var z=h++;a[z]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var te=h++;a[te]="(?:~>?)";var J=h++;a[J]="(\\s*)"+a[te]+"\\s+",v[J]=new RegExp(a[J],"g");var oe=h++;a[oe]="^"+a[te]+a[m]+"$";var re=h++;a[re]="^"+a[te]+a[p]+"$";var N=h++;a[N]="(?:\\^)";var j=h++;a[j]="(\\s*)"+a[N]+"\\s+",v[j]=new RegExp(a[j],"g");var q=h++;a[q]="^"+a[N]+a[m]+"$";var _=h++;a[_]="^"+a[N]+a[p]+"$";var ne=h++;a[ne]="^"+a[r]+"\\s*("+n+")$|^$";var k=h++;a[k]="^"+a[r]+"\\s*("+e+")$|^$";var T=h++;a[T]="(\\s*)"+a[r]+"\\s*("+n+"|"+a[m]+")",v[T]=new RegExp(a[T],"g");var F=h++;a[F]="^\\s*("+a[m]+")\\s+-\\s+("+a[m]+")\\s*$";var x=h++;a[x]="^\\s*("+a[p]+")\\s+-\\s+("+a[p]+")\\s*$";var $=h++;a[$]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)P(B,a[B]),v[B]||(v[B]=new RegExp(a[B]));function ae(U,H){if(U instanceof Y)return U;if(typeof U!="string"||U.length>R||!(H?v[t]:v[s]).test(U))return null;try{return new Y(U,H)}catch{return null}}function Y(U,H){if(U instanceof Y){if(U.loose===H)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Y))return new Y(U,H);P("SemVer",U,H),this.loose=H;var X=U.trim().match(H?v[t]:v[s]);if(!X)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var pe=+de;if(pe>=0&&pe<O)return pe}return de}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}i.parse=ae,i.valid=function(U,H){var X=ae(U,H);return X?X.version:null},i.clean=function(U,H){var X=ae(U.trim().replace(/^[=v]+/,""),H);return X?X.version:null},i.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(U){return P("SemVer.compare",this.version,this.loose,U),U instanceof Y||(U=new Y(U,this.loose)),this.compareMain(U)||this.comparePre(U)},Y.prototype.compareMain=function(U){return U instanceof Y||(U=new Y(U,this.loose)),V(this.major,U.major)||V(this.minor,U.minor)||V(this.patch,U.patch)},Y.prototype.comparePre=function(U){if(U instanceof Y||(U=new Y(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var H=0;do{var X=this.prerelease[H],de=U.prerelease[H];if(P("prerelease compare",H,X,de),X===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(X===void 0)return-1;if(X!==de)return V(X,de)}while(++H)},Y.prototype.inc=function(U,H){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},i.inc=function(U,H,X,de){typeof X=="string"&&(de=X,X=void 0);try{return new Y(U,X).inc(H,de).version}catch{return null}},i.diff=function(U,H){if(ee(U,H))return null;var X=ae(U),de=ae(H);if(X.prerelease.length||de.prerelease.length){for(var pe in X)if((pe==="major"||pe==="minor"||pe==="patch")&&X[pe]!==de[pe])return"pre"+pe;return"prerelease"}for(var pe in X)if((pe==="major"||pe==="minor"||pe==="patch")&&X[pe]!==de[pe])return pe},i.compareIdentifiers=V;var ve=/^[0-9]+$/;function V(U,H){var X=ve.test(U),de=ve.test(H);return X&&de&&(U=+U,H=+H),X&&!de?-1:de&&!X?1:U<H?-1:U>H?1:0}function M(U,H,X){return new Y(U,X).compare(new Y(H,X))}function G(U,H,X){return M(U,H,X)>0}function K(U,H,X){return M(U,H,X)<0}function ee(U,H,X){return M(U,H,X)===0}function ie(U,H,X){return M(U,H,X)!==0}function se(U,H,X){return M(U,H,X)>=0}function ce(U,H,X){return M(U,H,X)<=0}function ue(U,H,X,de){var pe;switch(H){case"===":typeof U=="object"&&(U=U.version),typeof X=="object"&&(X=X.version),pe=U===X;break;case"!==":typeof U=="object"&&(U=U.version),typeof X=="object"&&(X=X.version),pe=U!==X;break;case"":case"=":case"==":pe=ee(U,X,de);break;case"!=":pe=ie(U,X,de);break;case">":pe=G(U,X,de);break;case">=":pe=se(U,X,de);break;case"<":pe=K(U,X,de);break;case"<=":pe=ce(U,X,de);break;default:throw new TypeError("Invalid operator: "+H)}return pe}function ge(U,H){if(U instanceof ge){if(U.loose===H)return U;U=U.value}if(!(this instanceof ge))return new ge(U,H);P("comparator",U,H),this.loose=H,this.parse(U),this.semver===he?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}i.rcompareIdentifiers=function(U,H){return V(H,U)},i.major=function(U,H){return new Y(U,H).major},i.minor=function(U,H){return new Y(U,H).minor},i.patch=function(U,H){return new Y(U,H).patch},i.compare=M,i.compareLoose=function(U,H){return M(U,H,!0)},i.rcompare=function(U,H,X){return M(H,U,X)},i.sort=function(U,H){return U.sort(function(X,de){return i.compare(X,de,H)})},i.rsort=function(U,H){return U.sort(function(X,de){return i.rcompare(X,de,H)})},i.gt=G,i.lt=K,i.eq=ee,i.neq=ie,i.gte=se,i.lte=ce,i.cmp=ue,i.Comparator=ge;var he={};function fe(U,H){if(U instanceof fe)return U.loose===H?U:new fe(U.raw,H);if(U instanceof ge)return new fe(U.value,H);if(!(this instanceof fe))return new fe(U,H);if(this.loose=H,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function ye(U){return!U||U.toLowerCase()==="x"||U==="*"}function be(U,H,X,de,pe,Le,we,Ae,De,ke,Ue,Re,Oe){return((H=ye(X)?"":ye(de)?">="+X+".0.0":ye(pe)?">="+X+"."+de+".0":">="+H)+" "+(Ae=ye(De)?"":ye(ke)?"<"+(+De+1)+".0.0":ye(Ue)?"<"+De+"."+(+ke+1)+".0":Re?"<="+De+"."+ke+"."+Ue+"-"+Re:"<="+Ae)).trim()}function Ie(U,H){for(var X=0;X<U.length;X++)if(!U[X].test(H))return!1;if(H.prerelease.length){for(X=0;X<U.length;X++)if(P(U[X].semver),U[X].semver!==he&&U[X].semver.prerelease.length>0){var de=U[X].semver;if(de.major===H.major&&de.minor===H.minor&&de.patch===H.patch)return!0}return!1}return!0}function Ne(U,H,X){try{H=new fe(H,X)}catch{return!1}return H.test(U)}function xe(U,H,X,de){var pe,Le,we,Ae,De;switch(U=new Y(U,de),H=new fe(H,de),X){case">":pe=G,Le=ce,we=K,Ae=">",De=">=";break;case"<":pe=K,Le=se,we=G,Ae="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(U,H,de))return!1;for(var ke=0;ke<H.set.length;++ke){var Ue=H.set[ke],Re=null,Oe=null;if(Ue.forEach(function(Fe){Fe.semver===he&&(Fe=new ge(">=0.0.0")),Re=Re||Fe,Oe=Oe||Fe,pe(Fe.semver,Re.semver,de)?Re=Fe:we(Fe.semver,Oe.semver,de)&&(Oe=Fe)}),Re.operator===Ae||Re.operator===De||(!Oe.operator||Oe.operator===Ae)&&Le(U,Oe.semver)||Oe.operator===De&&we(U,Oe.semver))return!1}return!0}ge.prototype.parse=function(U){var H=this.loose?v[ne]:v[k],X=U.match(H);if(!X)throw new TypeError("Invalid comparator: "+U);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new Y(X[2],this.loose):this.semver=he},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(U){return P("Comparator.test",U,this.loose),this.semver===he||(typeof U=="string"&&(U=new Y(U,this.loose)),ue(U,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(U,H){if(!(U instanceof ge))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new fe(U.value,H),Ne(this.value,X,H);if(U.operator==="")return X=new fe(this.value,H),Ne(U.semver,X,H);var de=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),Le=this.semver.version===U.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Ae=ue(this.semver,"<",U.semver,H)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),De=ue(this.semver,">",U.semver,H)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return de||pe||Le&&we||Ae||De},i.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(U){var H=this.loose;U=U.trim(),P("range",U,H);var X=H?v[x]:v[F];U=U.replace(X,be),P("hyphen replace",U),U=U.replace(v[T],"$1$2$3"),P("comparator trim",U,v[T]),U=(U=(U=U.replace(v[J],"$1~")).replace(v[j],"$1^")).split(/\s+/).join(" ");var de=H?v[ne]:v[k],pe=U.split(" ").map(function(Le){return function(we,Ae){return P("comp",we),we=function(De,ke){return De.trim().split(/\s+/).map(function(Ue){return function(Re,Oe){P("caret",Re,Oe);var Fe=Oe?v[_]:v[q];return Re.replace(Fe,function(Me,Ee,Se,Pe,Ce){var Te;return P("caret",Re,Me,Ee,Se,Pe,Ce),ye(Ee)?Te="":ye(Se)?Te=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ye(Pe)?Te=Ee==="0"?">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+".0 <"+(+Ee+1)+".0.0":Ce?(P("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),Te=Ee==="0"?Se==="0"?">="+Ee+"."+Se+"."+Pe+Ce+" <"+Ee+"."+Se+"."+(+Pe+1):">="+Ee+"."+Se+"."+Pe+Ce+" <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+"."+Pe+Ce+" <"+(+Ee+1)+".0.0"):(P("no pr"),Te=Ee==="0"?Se==="0"?">="+Ee+"."+Se+"."+Pe+" <"+Ee+"."+Se+"."+(+Pe+1):">="+Ee+"."+Se+"."+Pe+" <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+"."+Pe+" <"+(+Ee+1)+".0.0"),P("caret return",Te),Te})}(Ue,ke)}).join(" ")}(we,Ae),P("caret",we),we=function(De,ke){return De.trim().split(/\s+/).map(function(Ue){return function(Re,Oe){var Fe=Oe?v[re]:v[oe];return Re.replace(Fe,function(Me,Ee,Se,Pe,Ce){var Te;return P("tilde",Re,Me,Ee,Se,Pe,Ce),ye(Ee)?Te="":ye(Se)?Te=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ye(Pe)?Te=">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0":Ce?(P("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),Te=">="+Ee+"."+Se+"."+Pe+Ce+" <"+Ee+"."+(+Se+1)+".0"):Te=">="+Ee+"."+Se+"."+Pe+" <"+Ee+"."+(+Se+1)+".0",P("tilde return",Te),Te})}(Ue,ke)}).join(" ")}(we,Ae),P("tildes",we),we=function(De,ke){return P("replaceXRanges",De,ke),De.split(/\s+/).map(function(Ue){return function(Re,Oe){Re=Re.trim();var Fe=Oe?v[A]:v[b];return Re.replace(Fe,function(Me,Ee,Se,Pe,Ce,Te){P("xRange",Re,Me,Ee,Se,Pe,Ce,Te);var je=ye(Se),ze=je||ye(Pe),Ve=ze||ye(Ce);return Ee==="="&&Ve&&(Ee=""),je?Me=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Ve?(ze&&(Pe=0),Ve&&(Ce=0),Ee===">"?(Ee=">=",ze?(Se=+Se+1,Pe=0,Ce=0):Ve&&(Pe=+Pe+1,Ce=0)):Ee==="<="&&(Ee="<",ze?Se=+Se+1:Pe=+Pe+1),Me=Ee+Se+"."+Pe+"."+Ce):ze?Me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ve&&(Me=">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0"),P("xRange return",Me),Me})}(Ue,ke)}).join(" ")}(we,Ae),P("xrange",we),we=function(De,ke){return P("replaceStars",De,ke),De.trim().replace(v[$],"")}(we,Ae),P("stars",we),we}(Le,H)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Le){return!!Le.match(de)})),pe=pe.map(function(Le){return new ge(Le,H)})},fe.prototype.intersects=function(U,H){if(!(U instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(de){return U.set.some(function(pe){return pe.every(function(Le){return de.intersects(Le,H)})})})})},i.toComparators=function(U,H){return new fe(U,H).set.map(function(X){return X.map(function(de){return de.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new Y(U,this.loose));for(var H=0;H<this.set.length;H++)if(Ie(this.set[H],U))return!0;return!1},i.satisfies=Ne,i.maxSatisfying=function(U,H,X){var de=null,pe=null;try{var Le=new fe(H,X)}catch{return null}return U.forEach(function(we){Le.test(we)&&(de&&pe.compare(we)!==-1||(pe=new Y(de=we,X)))}),de},i.minSatisfying=function(U,H,X){var de=null,pe=null;try{var Le=new fe(H,X)}catch{return null}return U.forEach(function(we){Le.test(we)&&(de&&pe.compare(we)!==1||(pe=new Y(de=we,X)))}),de},i.validRange=function(U,H){try{return new fe(U,H).range||"*"}catch{return null}},i.ltr=function(U,H,X){return xe(U,H,"<",X)},i.gtr=function(U,H,X){return xe(U,H,">",X)},i.outside=xe,i.prerelease=function(U,H){var X=ae(U,H);return X&&X.prerelease.length?X.prerelease:null},i.intersects=function(U,H,X){return U=new fe(U,X),H=new fe(H,X),U.intersects(H)},i.coerce=function(U){if(U instanceof Y)return U;if(typeof U!="string")return null;var H=U.match(v[z]);return H==null?null:ae((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,C(1))},function(W,i){var C,I,P=W.exports={};function R(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function v(S){if(C===setTimeout)return setTimeout(S,0);if((C===R||!C)&&setTimeout)return C=setTimeout,setTimeout(S,0);try{return C(S,0)}catch{try{return C.call(null,S,0)}catch{return C.call(this,S,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:R}catch{C=R}try{I=typeof clearTimeout=="function"?clearTimeout:O}catch{I=O}})();var a,h=[],D=!1,L=-1;function g(){D&&a&&(D=!1,a.length?h=a.concat(h):L=-1,h.length&&y())}function y(){if(!D){var S=v(g);D=!0;for(var l=h.length;l;){for(a=h,h=[];++L<l;)a&&a[L].run();L=-1,l=h.length}a=null,D=!1,function(f){if(I===clearTimeout)return clearTimeout(f);if((I===O||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(f);try{I(f)}catch{try{return I.call(null,f)}catch{return I.call(this,f)}}}(S)}}function w(S,l){this.fun=S,this.array=l}function d(){}P.nextTick=function(S){var l=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)l[f-1]=arguments[f];h.push(new w(S,l)),h.length!==1||D||v(y)},w.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=d,P.addListener=d,P.once=d,P.off=d,P.removeListener=d,P.removeAllListeners=d,P.emit=d,P.prependListener=d,P.prependOnceListener=d,P.listeners=function(S){return[]},P.binding=function(S){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(S){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Q[66],Z([0,1]),function(W,i){"use strict";var C;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class I{constructor(v,a,h){this.level=v,this.key=a,this.value=h,this.forward=[]}}const P=void 0;class R{constructor(v,a=2**16){this.comparator=v,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(a)|0),this._header=new I(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new I(this._maxLevel,P,P)}has(v){return Boolean(R._search(this,v,this.comparator))}get(v){return R._search(this,v,this.comparator)?.value}set(v,a){return R._insert(this,v,a,this.comparator)&&(this._size+=1),this}delete(v){const a=R._delete(this,v,this.comparator);return a&&(this._size-=1),a}forEach(v,a){let h=this._header.forward[0];for(;h;)v.call(a,h.value,h.key,this),h=h.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let v=this._header.forward[0];for(;v;)yield[v.key,v.value],v=v.forward[0]}*keys(){let v=this._header.forward[0];for(;v;)yield v.key,v=v.forward[0]}*values(){let v=this._header.forward[0];for(;v;)yield v.value,v=v.forward[0]}toString(){let v="[SkipList]:",a=this._header.forward[0];for(;a;)v+=`node(${a.key}, ${a.value}, lvl:${a.level})`,a=a.forward[0];return v}static _search(v,a,h){let D=v._header;for(let L=v._level-1;L>=0;L--)for(;D.forward[L]&&h(D.forward[L].key,a)<0;)D=D.forward[L];if(D=D.forward[0],D&&h(D.key,a)===0)return D}static _insert(v,a,h,D){let L=[],g=v._header;for(let y=v._level-1;y>=0;y--){for(;g.forward[y]&&D(g.forward[y].key,a)<0;)g=g.forward[y];L[y]=g}if(g=g.forward[0],g&&D(g.key,a)===0)return g.value=h,!1;{let y=R._randomLevel(v);if(y>v._level){for(let w=v._level;w<y;w++)L[w]=v._header;v._level=y}g=new I(y,a,h);for(let w=0;w<y;w++)g.forward[w]=L[w].forward[w],L[w].forward[w]=g;return!0}}static _randomLevel(v,a=.5){let h=1;for(;Math.random()<a&&h<v._maxLevel;)h+=1;return h}static _delete(v,a,h){let D=[],L=v._header;for(let g=v._level-1;g>=0;g--){for(;L.forward[g]&&h(L.forward[g].key,a)<0;)L=L.forward[g];D[g]=L}if(L=L.forward[0],!L||h(L.key,a)!==0)return!1;for(let g=0;g<v._level&&D[g].forward[g]===L;g++)D[g].forward[g]=L.forward[g];for(;v._level>0&&v._header.forward[v._level-1]===P;)v._level-=1;return!0}}i.SkipList=R}),define(Q[50],Z([0,1,3,2]),function(W,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MutableObservableValue=i.staticObservableValue=void 0;const P=O=>({onDidChange:C.Event.None,value:O});i.staticObservableValue=P;class R extends I.Disposable{get value(){return this._value}set value(v){v!==this._value&&(this._value=v,this.changeEmitter.fire(v))}constructor(v){super();this._value=v,this.changeEmitter=this._register(new C.Emitter),this.onDidChange=this.changeEmitter.event}}i.MutableObservableValue=R}),define(Q[41],Z([0,1,10,2]),function(W,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=i.isReadable=void 0;function P(c){const s=c;return s?typeof s.read=="function":!1}i.isReadable=P;function R(c){const s=c;return s?[s.on,s.pause,s.resume,s.destroy].every(e=>typeof e=="function"):!1}i.isReadableStream=R;function O(c){const s=c;return s?R(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=O;function v(c,s){return new a(c,s)}i.newWriteableStream=v;class a{constructor(s,e){this.reducer=s,this.options=e,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(e=>e(s))}emitError(s){this.listeners.error.length===0?(0,C.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(e=>e(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,e){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(e),this.resume();break;case"end":this.listeners.end.push(e),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(e),this.state.flowing&&this.flowErrors();break}}removeListener(s,e){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const t=n.indexOf(e);t>=0&&n.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const e=[...this.pendingWritePromises];this.pendingWritePromises.length=0,e.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(c,s){const e=[];let n;for(;(n=c.read())!==null;)e.push(n);return s(e)}i.consumeReadable=h;function D(c,s,e){const n=[];let t;for(;(t=c.read())!==null&&n.length<e;)n.push(t);return t===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof t!="undefined"){const r=t;return t=void 0,r}return c.read()}}}i.peekReadable=D;function L(c,s){return new Promise((e,n)=>{const t=[];g(c,{onData:r=>{s&&t.push(r)},onError:r=>{s?n(r):e(void 0)},onEnd:()=>{e(s?s(t):void 0)}})})}i.consumeStream=L;function g(c,s){let e=!1;return c.on("error",n=>{e||s.onError(n)}),c.on("end",()=>{e||s.onEnd()}),c.on("data",n=>{e||s.onData(n)}),(0,I.toDisposable)(()=>e=!0)}i.listenStream=g;function y(c,s){return new Promise((e,n)=>{const t=new I.DisposableStore,r=[],o=p=>{if(r.push(p),r.length>s)return t.dispose(),c.pause(),e({stream:c,buffer:r,ended:!1})},u=p=>n(p),m=()=>e({stream:c,buffer:r,ended:!0});t.add((0,I.toDisposable)(()=>c.removeListener("error",u))),c.on("error",u),t.add((0,I.toDisposable)(()=>c.removeListener("end",m))),c.on("end",m),t.add((0,I.toDisposable)(()=>c.removeListener("data",o))),c.on("data",o)})}i.peekStream=y;function w(c,s){const e=v(s);return e.end(c),e}i.toStream=w;function d(){const c=v(()=>{throw new Error("not supported")});return c.end(),c}i.emptyStream=d;function S(c){let s=!1;return{read:()=>s?null:(s=!0,c)}}i.toReadable=S;function l(c,s,e){const n=v(e);return g(c,{onData:t=>n.write(s.data(t)),onError:t=>n.error(s.error?s.error(t):t),onEnd:()=>n.end()}),n}i.transform=l;function f(c,s,e){let n=!1;return{read:()=>{const t=s.read();return n?t:(n=!0,t!==null?e([c,t]):c)}}}i.prefixedReadable=f;function E(c,s,e){let n=!1;const t=v(e);return g(s,{onData:r=>n?t.write(r):(n=!0,t.write(e([c,r]))),onError:r=>t.error(r),onEnd:()=>{n||(n=!0,t.write(c)),t.end()}}),t}i.prefixedStream=E}),define(Q[16],Z([0,1,41]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const I=typeof Buffer!="undefined";let P,R;class O{static alloc(p){return I?new O(Buffer.allocUnsafe(p)):new O(new Uint8Array(p))}static wrap(p){return I&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new O(p)}static fromString(p,b){return!(b?.dontUseNodeBuffer||!1)&&I?new O(Buffer.from(p)):(P||(P=new TextEncoder),new O(P.encode(p)))}static fromByteArray(p){const b=O.alloc(p.length);for(let A=0,z=p.length;A<z;A++)b.buffer[A]=p[A];return b}static concat(p,b){if(typeof b=="undefined"){b=0;for(let te=0,J=p.length;te<J;te++)b+=p[te].byteLength}const A=O.alloc(b);let z=0;for(let te=0,J=p.length;te<J;te++){const oe=p[te];A.set(oe,z),z+=oe.byteLength}return A}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=O.alloc(this.byteLength);return p.set(this),p}toString(){return I?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(p,b){return new O(this.buffer.subarray(p,b))}set(p,b){if(p instanceof O)this.buffer.set(p.buffer,b);else if(p instanceof Uint8Array)this.buffer.set(p,b);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),b);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return h(this.buffer,p)}writeUInt32BE(p,b){D(this.buffer,p,b)}readUInt32LE(p){return L(this.buffer,p)}writeUInt32LE(p,b){g(this.buffer,p,b)}readUInt8(p){return y(this.buffer,p)}writeUInt8(p,b){w(this.buffer,p,b)}}i.VSBuffer=O;function v(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0}i.readUInt16LE=v;function a(m,p,b){m[b+0]=p&255,p=p>>>8,m[b+1]=p&255}i.writeUInt16LE=a;function h(m,p){return m[p]*2**24+m[p+1]*2**16+m[p+2]*2**8+m[p+3]}i.readUInt32BE=h;function D(m,p,b){m[b+3]=p,p=p>>>8,m[b+2]=p,p=p>>>8,m[b+1]=p,p=p>>>8,m[b]=p}i.writeUInt32BE=D;function L(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0|m[p+2]<<16>>>0|m[p+3]<<24>>>0}i.readUInt32LE=L;function g(m,p,b){m[b+0]=p&255,p=p>>>8,m[b+1]=p&255,p=p>>>8,m[b+2]=p&255,p=p>>>8,m[b+3]=p&255}i.writeUInt32LE=g;function y(m,p){return m[p]}i.readUInt8=y;function w(m,p,b){m[b]=p}i.writeUInt8=w;function d(m){return C.consumeReadable(m,p=>O.concat(p))}i.readableToBuffer=d;function S(m){return C.toReadable(m)}i.bufferToReadable=S;function l(m){return C.consumeStream(m,p=>O.concat(p))}i.streamToBuffer=l;async function f(m){return m.ended?O.concat(m.buffer):O.concat([...m.buffer,await l(m.stream)])}i.bufferedStreamToBuffer=f;function E(m){return C.toStream(m,p=>O.concat(p))}i.bufferToStream=E;function c(m){return C.transform(m,{data:p=>typeof p=="string"?O.fromString(p):O.wrap(p)},p=>O.concat(p))}i.streamToBufferReadableStream=c;function s(m){return C.newWriteableStream(p=>O.concat(p),m)}i.newWriteableBufferStream=s;function e(m,p){return C.prefixedReadable(m,p,b=>O.concat(b))}i.prefixedBufferReadable=e;function n(m,p){return C.prefixedStream(m,p,b=>O.concat(b))}i.prefixedBufferStream=n;function t(m){let p=0,b=0,A=0;const z=new Uint8Array(Math.floor(m.length/4*3)),te=oe=>{switch(b){case 3:z[A++]=p|oe,b=0;break;case 2:z[A++]=p|oe>>>2,p=oe<<6,b=3;break;case 1:z[A++]=p|oe>>>4,p=oe<<4,b=2;break;default:p=oe<<2,b=1}};for(let oe=0;oe<m.length;oe++){const re=m.charCodeAt(oe);if(re>=65&&re<=90)te(re-65);else if(re>=97&&re<=122)te(re-97+26);else if(re>=48&&re<=57)te(re-48+52);else if(re===43||re===45)te(62);else if(re===47||re===95)te(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${m[oe]}`)}}const J=A;for(;b>0;)te(0);return O.wrap(z).slice(0,J)}i.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:m},p=!0,b=!1){const A=b?o:r;let z="";const te=m.byteLength%3;let J=0;for(;J<m.byteLength-te;J+=3){const oe=m[J+0],re=m[J+1],N=m[J+2];z+=A[oe>>>2],z+=A[(oe<<4|re>>>4)&63],z+=A[(re<<2|N>>>6)&63],z+=A[N&63]}if(te===1){const oe=m[J+0];z+=A[oe>>>2],z+=A[oe<<4&63],p&&(z+="==")}else if(te===2){const oe=m[J+0],re=m[J+1];z+=A[oe>>>2],z+=A[(oe<<4|re>>>4)&63],z+=A[re<<2&63],p&&(z+="=")}return z}i.encodeBase64=u}),define(Q[67],Z([0,1,26]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function I(l){return P(l,0)}i.hash=I;function P(l,f){switch(typeof l){case"object":return l===null?R(349,f):Array.isArray(l)?a(l,f):h(l,f);case"string":return v(l,f);case"boolean":return O(l,f);case"number":return R(l,f);case"undefined":return R(937,f);default:return R(617,f)}}i.doHash=P;function R(l,f){return(f<<5)-f+l|0}i.numberHash=R;function O(l,f){return R(l?433:863,f)}function v(l,f){f=R(149417,f);for(let E=0,c=l.length;E<c;E++)f=R(l.charCodeAt(E),f);return f}i.stringHash=v;function a(l,f){return f=R(104579,f),l.reduce((E,c)=>P(c,E),f)}function h(l,f){return f=R(181387,f),Object.keys(l).sort().reduce((E,c)=>(E=v(c,E),P(l[c],E)),f)}class D{constructor(){this._value=0}get value(){return this._value}hash(f){return this._value=P(f,this._value),this._value}}i.Hasher=D;var L;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function g(l,f,E=32){const c=E-f,s=~((1<<c)-1);return(l<<f|(s&l)>>>c)>>>0}function y(l,f=0,E=l.byteLength,c=0){for(let s=0;s<E;s++)l[f+s]=c}function w(l,f,E="0"){for(;l.length<f;)l=E+l;return l}function d(l,f=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(E=>E.toString(16).padStart(2,"0")).join(""):w((l>>>0).toString(16),f/4)}i.toHexString=d;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const E=f.length;if(E===0)return;const c=this._buff;let s=this._buffLen,e=this._leftoverHighSurrogate,n,t;for(e!==0?(n=e,t=-1,e=0):(n=f.charCodeAt(0),t=0);;){let r=n;if(C.isHighSurrogate(n))if(t+1<E){const o=f.charCodeAt(t+1);C.isLowSurrogate(o)?(t++,r=C.computeCodePoint(n,o)):r=65533}else{e=n;break}else C.isLowSurrogate(n)&&(r=65533);if(s=this._push(c,s,r),t++,t<E)n=f.charCodeAt(t);else break}this._buffLen=s,this._leftoverHighSurrogate=e}_push(f,E,c){return c<128?f[E++]=c:c<2048?(f[E++]=192|(c&1984)>>>6,f[E++]=128|(c&63)>>>0):c<65536?(f[E++]=224|(c&61440)>>>12,f[E++]=128|(c&4032)>>>6,f[E++]=128|(c&63)>>>0):(f[E++]=240|(c&1835008)>>>18,f[E++]=128|(c&258048)>>>12,f[E++]=128|(c&4032)>>>6,f[E++]=128|(c&63)>>>0),E>=64&&(this._step(),E-=64,this._totalLen+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),E}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=S._bigBlock32,E=this._buffDV;for(let m=0;m<64;m+=4)f.setUint32(m,E.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)f.setUint32(m,g(f.getUint32(m-12,!1)^f.getUint32(m-32,!1)^f.getUint32(m-56,!1)^f.getUint32(m-64,!1),1),!1);let c=this._h0,s=this._h1,e=this._h2,n=this._h3,t=this._h4,r,o,u;for(let m=0;m<80;m++)m<20?(r=s&e|~s&n,o=1518500249):m<40?(r=s^e^n,o=1859775393):m<60?(r=s&e|s&n|e&n,o=2400959708):(r=s^e^n,o=3395469782),u=g(c,5)+r+t+o+f.getUint32(m*4,!1)&4294967295,t=n,n=e,e=g(s,30),s=c,c=u;this._h0=this._h0+c&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+e&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+t&4294967295}}i.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[42],Z([0,1,26]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0});var I;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(I||(I={})),function(P){const R="error",O="warning",v="warn",a="info",h="ignore";function D(g){return g?C.equalsIgnoreCase(R,g)?P.Error:C.equalsIgnoreCase(O,g)||C.equalsIgnoreCase(v,g)?P.Warning:C.equalsIgnoreCase(a,g)?P.Info:P.Ignore:P.Ignore}P.fromValue=D;function L(g){switch(g){case P.Error:return R;case P.Warning:return O;case P.Info:return a;default:return h}}P.toString=L}(I||(I={})),i.default=I}),define(Q[22],Z([0,1,7]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function I(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const S=Array.isArray(d)?[]:{};return Object.keys(d).forEach(l=>{d[l]&&typeof d[l]=="object"?S[l]=I(d[l]):S[l]=d[l]}),S}i.deepClone=I;function P(d){if(!d||typeof d!="object")return d;const S=[d];for(;S.length>0;){const l=S.shift();Object.freeze(l);for(const f in l)if(R.call(l,f)){const E=l[f];typeof E=="object"&&!Object.isFrozen(E)&&!(0,C.isTypedArray)(E)&&S.push(E)}}return d}i.deepFreeze=P;const R=Object.prototype.hasOwnProperty;function O(d,S){return v(d,S,new Set)}i.cloneAndChange=O;function v(d,S,l){if((0,C.isUndefinedOrNull)(d))return d;const f=S(d);if(typeof f!="undefined")return f;if((0,C.isArray)(d)){const E=[];for(const c of d)E.push(v(c,S,l));return E}if((0,C.isObject)(d)){if(l.has(d))throw new Error("Cannot clone recursive data-structure");l.add(d);const E={};for(let c in d)R.call(d,c)&&(E[c]=v(d[c],S,l));return l.delete(d),E}return d}function a(d,S,l=!0){return(0,C.isObject)(d)?((0,C.isObject)(S)&&Object.keys(S).forEach(f=>{f in d?l&&((0,C.isObject)(d[f])&&(0,C.isObject)(S[f])?a(d[f],S[f],l):d[f]=S[f]):d[f]=S[f]}),d):S}i.mixin=a;function h(d,S){if(d===S)return!0;if(d==null||S===null||S===void 0||typeof d!=typeof S||typeof d!="object"||Array.isArray(d)!==Array.isArray(S))return!1;let l,f;if(Array.isArray(d)){if(d.length!==S.length)return!1;for(l=0;l<d.length;l++)if(!h(d[l],S[l]))return!1}else{const E=[];for(f in d)E.push(f);E.sort();const c=[];for(f in S)c.push(f);if(c.sort(),!h(E,c))return!1;for(l=0;l<E.length;l++)if(!h(d[E[l]],S[E[l]]))return!1}return!0}i.equals=h;function D(d){const S=new Set;return JSON.stringify(d,(l,f)=>{if((0,C.isObject)(f)||Array.isArray(f)){if(S.has(f))return"[Circular]";S.add(f)}return f})}i.safeStringify=D;function L(d,S,l){const f=S(d);return typeof f=="undefined"?l:f}i.getOrDefault=L;function g(d,S){const l=Object.create(null);return!d||!S||Object.keys(S).forEach(E=>{const c=d[E],s=S[E];h(c,s)||(l[E]=s)}),l}i.distinct=g;function y(d,S){const l=S.toLowerCase(),f=Object.keys(d).find(E=>E.toLowerCase()===l);return f?d[f]:d[S]}i.getCaseInsensitive=y;function w(d,S){const l=Object.create(null);for(const[f,E]of Object.entries(d))S(f,E)&&(l[f]=E);return l}i.filter=w}),define(Q[68],Z([0,1,11]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function I(h){const D=h;return D&&typeof D.type=="string"&&typeof D.severity=="string"}i.isRemoteConsoleLog=I;function P(h){const D=[];let L;try{const g=JSON.parse(h.arguments),y=g[g.length-1];y&&y.__$stack&&(g.pop(),L=y.__$stack),D.push(...g)}catch{D.push("Unable to log remote console arguments",h.arguments)}return{args:D,stack:L}}i.parse=P;function R(h){if(typeof h!="string")return R(P(h).stack);const D=h;if(D){const L=O(D),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(L||"");if(g&&g.length===4)return{uri:C.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}i.getFirstFrame=R;function O(h){if(!h)return h;const D=h.indexOf(`
`);return D===-1?h:h.substring(0,D)}function v(h,D){const{args:L,stack:g}=P(h),y=typeof L[0]=="string"&&L.length===1;let w=O(g);w&&(w=`(${w.trim()})`);let d=[];if(typeof L[0]=="string"?w&&y?d=[`%c[${D}] %c${L[0]} %c${w}`,a("blue"),a(""),a("grey")]:d=[`%c[${D}] %c${L[0]}`,a("blue"),a(""),...L.slice(1)]:d=[`%c[${D}]%`,a("blue"),...L],w&&!y&&d.push(w),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,d)}i.log=v;function a(h){return`color: ${h}`}}),define(Q[51],Z([0,1,16,26,11]),function(W,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.parse=i.stringify=void 0;function R(h){return JSON.stringify(h,v)}i.stringify=R;function O(h){let D=JSON.parse(h);return D=a(D),D}i.parse=O;function v(h,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,I.regExpFlags)(D)}:D}function a(h,D=0){if(!h||D>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return P.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 14:return new Date(h.source)}if(h instanceof C.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let L=0;L<h.length;++L)h[L]=a(h[L],D+1);else for(const L in h)Object.hasOwnProperty.call(h,L)&&(h[L]=a(h[L],D+1))}return h}i.revive=a}),define(Q[69],Z([0,1,17,52,14,13,8,18,26,11]),function(W,i,C,I,P,R,O,v,a,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function D(u,m){const{os:p,tildify:b,relative:A}=m;if(A){const J=L(u,A,p);if(typeof J=="string")return J}let z=u.fsPath;if(p===1&&!O.isWindows?z=z.replace(/\//g,"\\"):p!==1&&O.isWindows&&(z=z.replace(/\\/g,"/")),p!==1&&b?.userHome){let J=b.userHome.fsPath,oe;u.scheme!==b.userHome.scheme&&u.path.startsWith(R.posix.sep)?oe=b.userHome.with({path:u.path}).fsPath:oe=u.fsPath,z=d(oe,J,p)}return(p===1?R.win32:R.posix).normalize(y(z,p===1))}i.getPathLabel=D;function L(u,m,p){const b=p===1?R.win32:R.posix,A=p===3?v.extUri:v.extUriIgnorePathCase,z=m.getWorkspace(),te=(0,C.firstOrDefault)(z.folders);if(!te)return;u.scheme!==te.uri.scheme&&u.path.startsWith(R.posix.sep)&&(u=te.uri.with({path:u.path}));const J=m.getWorkspaceFolder(u);if(!J)return;let oe;if(A.isEqual(J.uri,u)?oe="":oe=A.relativePath(J.uri,u)??"",oe&&(oe=b.normalize(oe)),z.folders.length>1&&!m.noPrefix){const re=J.name?J.name:A.basenameOrAuthority(J.uri);oe=oe?`${re} \u2022 ${oe}`:re}return oe}function g(u){if(!u)return;typeof u=="string"&&(u=h.URI.file(u));const m=(0,v.basename)(u)||(u.scheme===P.Schemas.file?u.fsPath:u.path);return O.isWindows&&(0,I.isRootOrDriveLetter)(m)?y(m):m}i.getBaseLabel=g;function y(u,m=O.isWindows){return(0,I.hasDriveLetter)(u,m)?u.charAt(0).toUpperCase()+u.slice(1):u}i.normalizeDriveLetter=y;let w=Object.create(null);function d(u,m,p=O.OS){if(p===1||!u||!m)return u;let b=w.original===m?w.normalized:void 0;b||(b=m,O.isWindows&&(b=(0,I.toSlashes)(b)),b=`${(0,a.rtrim)(b,R.posix.sep)}${R.posix.sep}`,w={original:m,normalized:b});let A=u;return O.isWindows&&(A=(0,I.toSlashes)(A)),(p===3?A.startsWith(b):(0,a.startsWithIgnoreCase)(A,b))?`~/${A.substr(b.length)}`:u}i.tildify=d;function S(u,m){return u.replace(/^~($|\/|\\)/,`${m}$1`)}i.untildify=S;const l="\u2026",f="\\\\",E="~";function c(u,m=R.sep){const p=new Array(u.length);let b=!1;for(let A=0;A<u.length;A++){let z=u[A];if(z===""){p[A]=`.${m}`;continue}if(!z){p[A]=z;continue}b=!0;let te="",J=z;J.indexOf(f)===0?(te=J.substr(0,J.indexOf(f)+f.length),J=J.substr(J.indexOf(f)+f.length)):J.indexOf(m)===0?(te=J.substr(0,J.indexOf(m)+m.length),J=J.substr(J.indexOf(m)+m.length)):J.indexOf(E)===0&&(te=J.substr(0,J.indexOf(E)+E.length),J=J.substr(J.indexOf(E)+E.length));const oe=J.split(m);for(let re=1;b&&re<=oe.length;re++)for(let N=oe.length-re;b&&N>=0;N--){b=!1;let j=oe.slice(N,N+re).join(m);for(let q=0;!b&&q<u.length;q++)if(q!==A&&u[q]&&u[q].indexOf(j)>-1){const _=N+re===oe.length,ne=N>0&&u[q].indexOf(m)>-1?m+j:j,k=u[q].endsWith(ne);b=!_||k}if(!b){let q="";(oe[0].endsWith(":")||te!=="")&&(N===1&&(N=0,re++,j=oe[0]+m+j),N>0&&(q=oe[0]+m),q=te+q),N>0&&(q=q+l+m),q=q+j,N+re<oe.length&&(q=q+m+l),p[A]=q}}b&&(p[A]=z)}return p}i.shorten=c;var s;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function e(u,m=Object.create(null)){const p=[];let b=!1,A="";for(const z of u)if(z==="$"||b&&z==="{")A&&p.push({value:A,type:s.TEXT}),A="",b=!0;else if(z==="}"&&b){const te=m[A];if(typeof te=="string")te.length&&p.push({value:te,type:s.VARIABLE});else if(te){const J=p[p.length-1];(!J||J.type!==s.SEPARATOR)&&p.push({value:te.label,type:s.SEPARATOR})}A="",b=!1}else A+=z;return A&&!b&&p.push({value:A,type:s.TEXT}),p.filter((z,te)=>{if(z.type===s.SEPARATOR){const J=p[te-1],oe=p[te+1];return[J,oe].every(re=>re&&(re.type===s.VARIABLE||re.type===s.TEXT)&&re.value.length>0)}return!0}).map(z=>z.value).join("")}i.template=e;function n(u,m){return O.isMacintosh||m?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):u.replace(/&&|&/g,p=>p==="&"?"&&":"&")}i.mnemonicMenuLabel=n;function t(u,m){return O.isMacintosh||m?u.replace(/\(&&\w\)|&&/g,""):O.isWindows?u.replace(/&&|&/g,p=>p==="&"?"&&":"&"):u.replace(/&&/g,"_")}i.mnemonicButtonLabel=t;function r(u){return u.replace(/&/g,"&&")}i.unmnemonicLabel=r;function o(u){const m=u.indexOf("/")!==-1?R.posix:R.win32,p=m.basename(u),b=m.dirname(u);return p.length?{name:p,parentPath:b}:{name:b,parentPath:""}}i.splitName=o}),define(Q[32],Z([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(P){return C.test(P)}i.isUUID=I,i.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(v){for(let a=0;a<v.length;a++)v[a]=Math.floor(Math.random()*256);return v};const R=new Uint8Array(16),O=[];for(let v=0;v<256;v++)O.push(v.toString(16).padStart(2,"0"));return function(){P(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let a=0,h="";return h+=O[R[a++]],h+=O[R[a++]],h+=O[R[a++]],h+=O[R[a++]],h+="-",h+=O[R[a++]],h+=O[R[a++]],h+="-",h+=O[R[a++]],h+=O[R[a++]],h+="-",h+=O[R[a++]],h+=O[R[a++]],h+="-",h+=O[R[a++]],h+=O[R[a++]],h+=O[R[a++]],h+=O[R[a++]],h+=O[R[a++]],h+=O[R[a++]],h}}()}),define(Q[70],Z([0,1,146]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class I{constructor(R="utf8"){this.stringDecoder=new C.StringDecoder(R),this.remaining=null}write(R){const O=[],v=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(v.length<1)return O;let a=0,h,D=a;for(;D<v.length;)if(h=v.charCodeAt(D),h===13||h===10){if(O.push(v.substring(a,D)),D++,D<v.length){const L=h;h=v.charCodeAt(D),(L===13&&h===10||L===10&&h===13)&&D++}a=D}else D++;return this.remaining=a<v.length?v.substr(a):null,O}end(){return this.remaining}}i.LineDecoder=I}),define(Q[71],Z([0,1,34,13,19]),function(W,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,O=/^Microsoft.PowerShell_.*/,v=/^Microsoft.PowerShellPreview_.*/;var a;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(a||(a={}));let h;switch(process.arch){case"ia32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class L{constructor(s,e,n){this.exePath=s,this.displayName=e,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:c=!1}={}){return c?h===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:c=!1,findPreview:s=!1}={}){const e=g({useAlternateBitness:c});if(!e)return null;const n=I.join(e,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(n))return null;let t=-1,r=null;for(const m of await P.Promises.readdir(n)){let p=-1;if(s){const A=m.indexOf("-");if(A<0)continue;const z=m.substring(0,A);if(!R.test(z)||m.substring(A+1)!=="preview")continue;p=parseInt(z,10)}else{if(!R.test(m))continue;p=parseInt(m,10)}if(p<=t)continue;const b=I.join(n,m,"pwsh.exe");!await P.SymlinkSupport.existsFile(b)||(r=b,t=p)}if(!r)return null;const o=e.includes("x86")?" (x86)":"",u=s?" Preview":"";return new L(r,`PowerShell${u}${o}`,!0)}async function w({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const s=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:n}=c?{pwshMsixDirRegex:v,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const t of await P.Promises.readdir(s))if(e.test(t)){const r=I.join(s,t,"pwsh.exe");return new L(r,n)}return null}function d(){const c=I.join(C.homedir(),".dotnet","tools","pwsh.exe");return new L(c,".NET Core PowerShell Global Tool")}function S(){const c=I.join(process.env.windir,h===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new L(c,"Windows PowerShell",!0)}async function*l(){let c=await y();c&&(yield c),c=await y({useAlternateBitness:!0}),c&&(yield c),c=await w(),c&&(yield c),c=d(),c&&(yield c),c=await y({findPreview:!0}),c&&(yield c),c=await w({findPreview:!0}),c&&(yield c),c=await y({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=S(),c&&(yield c)}async function*f(){for await(const c of l())await c.exists()&&(yield c)}i.enumeratePowerShellInstallations=f;async function E(){for await(const c of f())return c;return null}i.getFirstAvailablePowerShellInstallation=E});var me=this&&this.__decorate||function(W,i,C,I){var P=arguments.length,R=P<3?i:I===null?I=Object.getOwnPropertyDescriptor(i,C):I,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(W,i,C,I);else for(var v=W.length-1;v>=0;v--)(O=W[v])&&(R=(P<3?O(R):P>3?O(i,C,R):O(i,C))||R);return P>3&&R&&Object.defineProperty(i,C,R),R};define(Q[53],Z([0,1,17,4,16,24,40,10,3,2,51,26,7]),function(W,i,C,I,P,R,O,v,a,h,D,L,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var y;(function(k){k[k.Promise=100]="Promise",k[k.PromiseCancel=101]="PromiseCancel",k[k.EventListen=102]="EventListen",k[k.EventDispose=103]="EventDispose"})(y||(i.RequestType=y={}));function w(k){switch(k){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(k){k[k.Initialize=200]="Initialize",k[k.PromiseSuccess=201]="PromiseSuccess",k[k.PromiseError=202]="PromiseError",k[k.PromiseErrorObj=203]="PromiseErrorObj",k[k.EventFire=204]="EventFire"})(d||(i.ResponseType=d={}));function S(k){switch(k){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(k){k[k.Uninitialized=0]="Uninitialized",k[k.Idle=1]="Idle"})(l||(l={}));class f{constructor(T){this.buffer=T,this.pos=0}read(T){const F=this.buffer.slice(this.pos,this.pos+T);return this.pos+=F.byteLength,F}}class E{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}var c;(function(k){k[k.Undefined=0]="Undefined",k[k.String=1]="String",k[k.Buffer=2]="Buffer",k[k.VSBuffer=3]="VSBuffer",k[k.Array=4]="Array",k[k.Object=5]="Object"})(c||(c={}));function s(k){const T=P.VSBuffer.alloc(4);return T.writeUInt32BE(k,0),T}function e(k){return k.read(4).readUInt32BE(0)}function n(k){const T=P.VSBuffer.alloc(1);return T.writeUInt8(k,0),T}const t={Undefined:n(c.Undefined),String:n(c.String),Buffer:n(c.Buffer),VSBuffer:n(c.VSBuffer),Array:n(c.Array),Object:n(c.Object)},r=typeof Buffer!="undefined";function o(k,T){if(typeof T=="undefined")k.write(t.Undefined);else if(typeof T=="string"){const F=P.VSBuffer.fromString(T);k.write(t.String),k.write(s(F.byteLength)),k.write(F)}else if(r&&Buffer.isBuffer(T)){const F=P.VSBuffer.wrap(T);k.write(t.Buffer),k.write(s(F.byteLength)),k.write(F)}else if(T instanceof P.VSBuffer)k.write(t.VSBuffer),k.write(s(T.byteLength)),k.write(T);else if(Array.isArray(T)){k.write(t.Array),k.write(s(T.length));for(const F of T)o(k,F)}else{const F=P.VSBuffer.fromString(JSON.stringify(T));k.write(t.Object),k.write(s(F.byteLength)),k.write(F)}}function u(k){switch(k.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return k.read(e(k)).toString();case c.Buffer:return k.read(e(k)).buffer;case c.VSBuffer:return k.read(e(k));case c.Array:{const F=e(k),x=[];for(let $=0;$<F;$++)x.push(u(k));return x}case c.Object:return JSON.parse(k.read(e(k)).toString())}}class m{constructor(T,F,x=null,$=1e3){this.protocol=T,this.ctx=F,this.logger=x,this.timeoutDelay=$,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(T,F){this.channels.set(T,F),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const F=this.send([T.type]);this.logger?.logOutgoing(F,0,1,S(T.type));return}case 201:case 202:case 204:case 203:{const F=this.send([T.type,T.id],T.data);this.logger?.logOutgoing(F,T.id,1,S(T.type),T.data);return}}}send(T,F=void 0){const x=new E;return o(x,T),o(x,F),this.sendBuffer(x.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onRawMessage(T){const F=new f(T),x=u(F),$=u(F),B=x[0];switch(B){case 100:return this.logger?.logIncoming(T.byteLength,x[1],1,`${w(B)}: ${x[2]}.${x[3]}`,$),this.onPromise({type:B,id:x[1],channelName:x[2],name:x[3],arg:$});case 102:return this.logger?.logIncoming(T.byteLength,x[1],1,`${w(B)}: ${x[2]}.${x[3]}`,$),this.onEventListen({type:B,id:x[1],channelName:x[2],name:x[3],arg:$});case 101:return this.logger?.logIncoming(T.byteLength,x[1],1,`${w(B)}`),this.disposeActiveRequest({type:B,id:x[1]});case 103:return this.logger?.logIncoming(T.byteLength,x[1],1,`${w(B)}`),this.disposeActiveRequest({type:B,id:x[1]})}}onPromise(T){const F=this.channels.get(T.channelName);if(!F){this.collectPendingRequest(T);return}const x=new R.CancellationTokenSource;let $;try{$=F.call(this.ctx,T.name,T.arg,x.token)}catch(Y){$=Promise.reject(Y)}const B=T.id;$.then(Y=>{this.sendResponse({id:B,data:Y,type:201}),this.activeRequests.delete(T.id)},Y=>{Y instanceof Error?this.sendResponse({id:B,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:B,data:Y,type:203}),this.activeRequests.delete(T.id)});const ae=(0,h.toDisposable)(()=>x.cancel());this.activeRequests.set(T.id,ae)}onEventListen(T){const F=this.channels.get(T.channelName);if(!F){this.collectPendingRequest(T);return}const x=T.id,B=F.listen(this.ctx,T.name,T.arg)(ae=>this.sendResponse({id:x,data:ae,type:204}));this.activeRequests.set(T.id,B)}disposeActiveRequest(T){const F=this.activeRequests.get(T.id);F&&(F.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let F=this.pendingRequests.get(T.channelName);F||(F=[],this.pendingRequests.set(T.channelName,F));const x=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);F.push({request:T,timeoutTimer:x})}flushPendingRequests(T){const F=this.pendingRequests.get(T);if(F){for(const x of F)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.onPromise(x.request);break;case 102:this.onEventListen(x.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelServer=m;var p;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(p||(i.RequestInitiator=p={}));class b{constructor(T,F=null){this.protocol=T,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new a.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(x=>this.onBuffer(x)),this.logger=F}getChannel(T){const F=this;return{call(x,$,B){return F.isDisposed?Promise.reject(v.canceled()):F.requestPromise(T,x,$,B)},listen(x,$){return F.isDisposed?a.Event.None:F.requestEvent(T,x,$)}}}requestPromise(T,F,x,$=R.CancellationToken.None){const B=this.lastRequestId++,Y={id:B,type:100,channelName:T,name:F,arg:x};if($.isCancellationRequested)return Promise.reject(v.canceled());let ve;return new Promise((M,G)=>{if($.isCancellationRequested)return G(v.canceled());const K=()=>{const ce=ue=>{switch(ue.type){case 201:this.handlers.delete(B),M(ue.data);break;case 202:{this.handlers.delete(B);const ge=new Error(ue.data.message);ge.stack=ue.data.stack,ge.name=ue.data.name,G(ge);break}case 203:this.handlers.delete(B),G(ue.data);break}};this.handlers.set(B,ce),this.sendRequest(Y)};let ee=null;this.state===l.Idle?K():(ee=(0,I.createCancelablePromise)(ce=>this.whenInitialized()),ee.then(()=>{ee=null,K()}));const ie=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:B,type:101}),G(v.canceled())},se=$.onCancellationRequested(ie);ve=(0,h.combinedDisposable)((0,h.toDisposable)(ie),se),this.activeRequests.add(ve)}).finally(()=>{this.activeRequests.delete(ve)})}requestEvent(T,F,x){const $=this.lastRequestId++,ae={id:$,type:102,channelName:T,name:F,arg:x};let Y=null;const ve=new a.Emitter({onFirstListenerAdd:()=>{Y=(0,I.createCancelablePromise)(M=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(ve),this.sendRequest(ae)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(ve),this.sendRequest({id:$,type:103}))}}),V=M=>ve.fire(M.data);return this.handlers.set($,V),ve.event}sendRequest(T){switch(T.type){case 100:case 102:{const F=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger&&this.logger.logOutgoing(F,T.id,0,`${w(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const F=this.send([T.type,T.id]);this.logger&&this.logger.logOutgoing(F,T.id,0,w(T.type));return}}}send(T,F=void 0){const x=new E;return o(x,T),o(x,F),this.sendBuffer(x.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onBuffer(T){const F=new f(T),x=u(F),$=u(F),B=x[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(T.byteLength,0,0,S(B)),this.onResponse({type:x[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(T.byteLength,x[1],0,S(B),$),this.onResponse({type:x[0],id:x[1],data:$})}}onResponse(T){if(T.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}const F=this.handlers.get(T.id);F&&F(T)}get onDidInitializePromise(){return a.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelClient=b,me([O.memoize],b.prototype,"onDidInitializePromise",null);class A{get connections(){const T=[];return this._connections.forEach(F=>T.push(F)),T}constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new a.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new a.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:F,onDidClientDisconnect:x})=>{a.Event.once(F.onMessage)(B=>{const ae=new f(B),Y=u(ae),ve=new m(F,Y),V=new b(F);this.channels.forEach((G,K)=>ve.registerChannel(K,G));const M={channelServer:ve,channelClient:V,ctx:Y};this._connections.add(M),this._onDidAddConnection.fire(M),x(()=>{ve.dispose(),V.dispose(),this._connections.delete(M),this._onDidRemoveConnection.fire(M)})})})}getChannel(T,F){const x=this;return{call($,B,ae){let Y;if((0,g.isFunction)(F)){let V=(0,C.getRandomElement)(x.connections.filter(F));Y=V?Promise.resolve(V):a.Event.toPromise(a.Event.filter(x.onDidAddConnection,F))}else Y=F.routeCall(x,$,B);const ve=Y.then(V=>V.channelClient.getChannel(T));return te(ve).call($,B,ae)},listen($,B){if((0,g.isFunction)(F))return x.getMulticastEvent(T,F,$,B);const ae=F.routeEvent(x,$,B).then(Y=>Y.channelClient.getChannel(T));return te(ae).listen($,B)}}}getMulticastEvent(T,F,x,$){const B=this;let ae=new h.DisposableStore;const Y=new a.Emitter({onFirstListenerAdd:()=>{ae=new h.DisposableStore;const ve=new a.EventMultiplexer,V=new Map,M=K=>{const ie=K.channelClient.getChannel(T).listen(x,$),se=ve.add(ie);V.set(K,se)},G=K=>{const ee=V.get(K);!ee||(ee.dispose(),V.delete(K))};B.connections.filter(F).forEach(M),a.Event.filter(B.onDidAddConnection,F)(M,void 0,ae),B.onDidRemoveConnection(G,void 0,ae),ve.event(Y.fire,Y,ae),ae.add(ve)},onLastListenerRemove:()=>{ae.dispose()}});return Y.event}registerChannel(T,F){this.channels.set(T,F),this._connections.forEach(x=>{x.channelServer.registerChannel(T,F)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=A;class z{constructor(T,F,x=null){const $=new E;o($,F),T.send($.buffer),this.channelClient=new b(T,x),this.channelServer=new m(T,F,x)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,F){this.channelServer.registerChannel(T,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=z;function te(k){return{call(T,F,x){return k.then($=>$.call(T,F,x))},listen(T,F){const x=new a.Relay;return k.then($=>x.input=$.listen(T,F)),x.event}}}i.getDelayedChannel=te;function J(k){let T=!1;return{call(F,x,$){return T?k.call(F,x,$):(0,I.timeout)(0).then(()=>T=!0).then(()=>k.call(F,x,$))},listen(F,x){if(T)return k.listen(F,x);const $=new a.Relay;return(0,I.timeout)(0).then(()=>T=!0).then(()=>$.input=k.listen(F,x)),$.event}}}i.getNextTickChannel=J;class oe{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const F of T.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await a.Event.toPromise(T.onDidAddConnection),await this.route(T)}}i.StaticRouter=oe;var re;(function(k){function T(B,ae){const Y=B,ve=ae&&ae.disableMarshalling,V=new Map;for(const M in Y)x(M)&&V.set(M,a.Event.buffer(Y[M],!0));return new class{listen(M,G,K){const ee=V.get(G);if(ee)return ee;if($(G)){const ie=Y[G];if(typeof ie=="function")return ie.call(Y,K)}throw new Error(`Event not found: ${G}`)}call(M,G,K){const ee=Y[G];if(typeof ee=="function"){if(!ve&&Array.isArray(K))for(let ie=0;ie<K.length;ie++)K[ie]=(0,D.revive)(K[ie]);return ee.apply(Y,K)}throw new Error(`Method not found: ${G}`)}}}k.fromService=T;function F(B,ae){const Y=ae&&ae.disableMarshalling;return new Proxy({},{get(ve,V){if(typeof V=="string")return ae?.properties?.has(V)?ae.properties.get(V):$(V)?function(M){return B.listen(V,M)}:x(V)?B.listen(V):async function(...M){let G;ae&&!(0,g.isUndefinedOrNull)(ae.context)?G=[ae.context,...M]:G=M;const K=await B.call(V,G);return Y?K:(0,D.revive)(K)};throw new Error(`Property not found: ${String(V)}`)}})}k.toService=F;function x(B){return B[0]==="o"&&B[1]==="n"&&L.isUpperAsciiLetter(B.charCodeAt(2))}function $(B){return/^onDynamic/.test(B)&&L.isUpperAsciiLetter(B.charCodeAt(9))}})(re||(i.ProxyChannel=re={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(k){if(Array.isArray(k))return k;if(k&&typeof k=="object"&&typeof k.toString=="function"){let T=k.toString();if(T!=="[object Object]")return T}return k}function q(k){return Array.isArray(k)?k.map(j):j(k)}function _(k,T,F,x,$,B,ae){ae=q(ae);const Y=N[$],ve=Y[x%Y.length];let V=[`%c[${k}]%c[${String(T).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${ve}`];/\($/.test(B)?(V=V.concat(ae),V.push(")")):V.push(ae),console.log.apply(console,V)}i.logWithColors=_;class ne{constructor(T,F){this._outgoingPrefix=T,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,F,x,$,B){this._totalOutgoing+=T,_(this._outgoingPrefix,this._totalOutgoing,T,F,x,$,B)}logIncoming(T,F,x,$,B){this._totalIncoming+=T,_(this._incomingPrefix,this._totalIncoming,T,F,x,$,B)}}i.IPCLogger=ne}),define(Q[72],Z([0,1,4,3,2,7]),function(W,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.StorageState=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var O;(function(L){L[L.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(O||(i.StorageHint=O={}));function v(L){const g=L;return g?.changed instanceof Map||g?.deleted instanceof Set}i.isStorageItemsChangeEvent=v;var a;(function(L){L[L.None=0]="None",L[L.Initialized=1]="Initialized",L[L.Closed=2]="Closed"})(a||(i.StorageState=a={}));class h extends P.Disposable{constructor(g,y=Object.create(null)){super();this.database=g,this.options=y,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((y,w)=>this.accept(w,y)),g.deleted?.forEach(y=>this.accept(y,void 0))}accept(g,y){if(this.state===a.Closed)return;let w=!1;(0,R.isUndefinedOrNull)(y)?w=this.cache.delete(g):this.cache.get(g)!==y&&(this.cache.set(g,y),w=!0),w&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,y){const w=this.cache.get(g);return(0,R.isUndefinedOrNull)(w)?y:w}getBoolean(g,y){const w=this.get(g);return(0,R.isUndefinedOrNull)(w)?y:w==="true"}getNumber(g,y){const w=this.get(g);return(0,R.isUndefinedOrNull)(w)?y:parseInt(w,10)}async set(g,y){if(this.state===a.Closed)return;if((0,R.isUndefinedOrNull)(y))return this.delete(g);const w=String(y);if(this.cache.get(g)!==w)return this.cache.set(g,w),this.pendingInserts.set(g,w),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async delete(g){if(!(this.state===a.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(!!this.hasPending)return this.doFlush(g)}async doFlush(g){return this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=h,h.DEFAULT_FLUSH_DELAY=100;class D{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((y,w)=>this.items.set(w,y)),g.delete&&g.delete.forEach(y=>this.items.delete(y))}async close(){}}i.InMemoryStorageDatabase=D}),define(Q[73],Z([5,6]),function(W,i){return W.create("vs/base/common/date",i)}),define(Q[74],Z([0,1,73]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const I=60,P=I*60,R=P*24,O=R*7,v=R*30,a=R*365;function h(L,g,y){typeof L!="number"&&(L=L.getTime());const w=Math.round((new Date().getTime()-L)/1e3);if(w<-30)return(0,C.localize)(0,null,h(new Date().getTime()+w*1e3,!1));if(w<30)return(0,C.localize)(1,null);let d;return w<I?(d=w,g?d===1?y?(0,C.localize)(2,null,d):(0,C.localize)(3,null,d):y?(0,C.localize)(4,null,d):(0,C.localize)(5,null,d):d===1?y?(0,C.localize)(6,null,d):(0,C.localize)(7,null,d):y?(0,C.localize)(8,null,d):(0,C.localize)(9,null,d)):w<P?(d=Math.floor(w/I),g?d===1?y?(0,C.localize)(10,null,d):(0,C.localize)(11,null,d):y?(0,C.localize)(12,null,d):(0,C.localize)(13,null,d):d===1?y?(0,C.localize)(14,null,d):(0,C.localize)(15,null,d):y?(0,C.localize)(16,null,d):(0,C.localize)(17,null,d)):w<R?(d=Math.floor(w/P),g?d===1?y?(0,C.localize)(18,null,d):(0,C.localize)(19,null,d):y?(0,C.localize)(20,null,d):(0,C.localize)(21,null,d):d===1?y?(0,C.localize)(22,null,d):(0,C.localize)(23,null,d):y?(0,C.localize)(24,null,d):(0,C.localize)(25,null,d)):w<O?(d=Math.floor(w/R),g?d===1?(0,C.localize)(26,null,d):(0,C.localize)(27,null,d):d===1?(0,C.localize)(28,null,d):(0,C.localize)(29,null,d)):w<v?(d=Math.floor(w/O),g?d===1?y?(0,C.localize)(30,null,d):(0,C.localize)(31,null,d):y?(0,C.localize)(32,null,d):(0,C.localize)(33,null,d):d===1?y?(0,C.localize)(34,null,d):(0,C.localize)(35,null,d):y?(0,C.localize)(36,null,d):(0,C.localize)(37,null,d)):w<a?(d=Math.floor(w/v),g?d===1?y?(0,C.localize)(38,null,d):(0,C.localize)(39,null,d):y?(0,C.localize)(40,null,d):(0,C.localize)(41,null,d):d===1?y?(0,C.localize)(42,null,d):(0,C.localize)(43,null,d):y?(0,C.localize)(44,null,d):(0,C.localize)(45,null,d)):(d=Math.floor(w/a),g?d===1?y?(0,C.localize)(46,null,d):(0,C.localize)(47,null,d):y?(0,C.localize)(48,null,d):(0,C.localize)(49,null,d):d===1?y?(0,C.localize)(50,null,d):(0,C.localize)(51,null,d):y?(0,C.localize)(52,null,d):(0,C.localize)(53,null,d))}i.fromNow=h;function D(L){return L.getFullYear()+"-"+String(L.getMonth()+1).padStart(2,"0")+"-"+String(L.getDate()).padStart(2,"0")+"T"+String(L.getHours()).padStart(2,"0")+":"+String(L.getMinutes()).padStart(2,"0")+":"+String(L.getSeconds()).padStart(2,"0")+"."+(L.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=D}),define(Q[75],Z([5,6]),function(W,i){return W.create("vs/base/common/errorMessage",i)}),define(Q[28],Z([0,1,17,7,75]),function(W,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createErrorWithActions=i.isErrorWithActions=i.toErrorMessage=void 0;function R(L,g){return g&&(L.stack||L.stacktrace)?P.localize(0,null,v(L),O(L.stack)||O(L.stacktrace)):v(L)}function O(L){return Array.isArray(L)?L.join(`
`):L}function v(L){return typeof L.code=="string"&&typeof L.errno=="number"&&typeof L.syscall=="string"?P.localize(1,null,L.message):L.message||P.localize(2,null)}function a(L=null,g=!1){if(!L)return P.localize(3,null);if(Array.isArray(L)){const y=C.coalesce(L),w=a(y[0],g);return y.length>1?P.localize(4,null,w,y.length):w}if(I.isString(L))return L;if(L.detail){const y=L.detail;if(y.error)return R(y.error,g);if(y.exception)return R(y.exception,g)}return L.stack?R(L,g):L.message?L.message:P.localize(5,null)}i.toErrorMessage=a;function h(L){const g=L;return g instanceof Error&&Array.isArray(g.actions)}i.isErrorWithActions=h;function D(L,g){let y;return typeof L=="string"?y=new Error(L):y=L,y.actions=g,y}i.createErrorWithActions=D}),define(Q[76],Z([5,6]),function(W,i){return W.create("vs/base/common/jsonErrorMessages",i)}),define(Q[77],Z([0,1,76]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getParseErrorMessage=void 0;function I(P){switch(P){case 1:return(0,C.localize)(0,null);case 2:return(0,C.localize)(1,null);case 3:return(0,C.localize)(2,null);case 4:return(0,C.localize)(3,null);case 5:return(0,C.localize)(4,null);case 6:return(0,C.localize)(5,null);case 7:return(0,C.localize)(6,null);case 8:return(0,C.localize)(7,null);case 9:return(0,C.localize)(8,null);default:return""}}i.getParseErrorMessage=I}),define(Q[78],Z([5,6]),function(W,i){return W.create("vs/base/node/processes",i)}),define(Q[54],Z([0,1,43,52,14,22,13,8,29,49,7,70,19,78]),function(W,i,C,I,P,R,O,v,a,h,D,L,g,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return h.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return h.TerminateResponseCode}});function w(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(s,e){if(v.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};e&&(n.cwd=e);const t=C.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],n);return new Promise(r=>{t.once("error",o=>{r({success:!1,error:o})}),t.once("exit",(o,u)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?w(n.status):1})}else if(v.isLinux||v.isMacintosh)try{const n=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",W).fsPath;return new Promise(t=>{C.execFile(n,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,o,u)=>{t(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function S(s=a.env){return s.comspec||"cmd.exe"}i.getWindowsShell=S;class l{constructor(e,n,t,r){if(n!==void 0&&t!==void 0&&r!==void 0)this.cmd=e,this.args=n,this.shell=t,this.options=r;else{const o=e;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(a.env).forEach(u=>{o[u]=a.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const n=e.lastIndexOf(O.sep);return n!==-1&&(e=e.substring(n+1)),l.WellKnowCommands[e]?e:"other"}start(e){return v.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(a.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(n=>{let t,r;const o=new Promise((u,m)=>{t=u,r=m});if(n){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=C.exec(u,this.options,(m,p,b)=>{this.childProcess=null;const A=m;A&&A.killed?r({killed:this.terminateRequested,stdout:p.toString(),stderr:b.toString()}):this.handleExec(t,e,m,p,b)})}else{let u=null;const m=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,t,e,r);const b={terminated:this.terminateRequested};D.isNumber(p)&&(b.cmdCode=p),t(b)};if(this.shell&&v.isWindows){const p=R.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let b=!1,A=!1;const z=[];let te=this.ensureQuotes(this.cmd);z.push(te.value),b=te.quoted,this.args&&this.args.forEach(oe=>{te=this.ensureQuotes(oe),z.push(te.value),A=A&&te.quoted});const J=["/s","/c"];b?A?J.push('"'+z.join(" ")+'"'):z.length>1?J.push('"'+z[0]+'" '+z.slice(1).join(" ")):J.push('"'+z[0]+'"'):J.push(z.join(" ")),u=C.spawn(S(),J,p)}else this.cmd&&(u=C.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(D.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",p=>{this.childProcess=null,r({terminated:this.terminateRequested,error:p})}),u.pid&&(this.childProcess.on("close",m),this.handleSpawn(u,t,e,r,!0)))}return o})}handleClose(e,n,t,r){}ensureQuotes(e){return l.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,d(e,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!v.isWindows)return e(!1);const n=C.spawn(S(),["/s","/c"]);n.on("error",t=>e(!0)),n.on("exit",t=>e(!1))})}}i.AbstractProcess=l,l.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},l.regexp=/^[^"].* .*[^"]/;class f extends l{constructor(e,n,t,r){super(e,n,t,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,n,t,r,o){[r,o].forEach((u,m)=>{const p=new L.LineDecoder;p.write(u).forEach(z=>{n({line:z,source:m===0?0:1})});const A=p.end();A&&n({line:A,source:m===0?0:1})}),e({terminated:this.terminateRequested,error:t})}handleSpawn(e,n,t,r,o){const u=new L.LineDecoder,m=new L.LineDecoder;e.stdout.on("data",p=>{u.write(p).forEach(A=>t({line:A,source:0}))}),e.stderr.on("data",p=>{m.write(p).forEach(A=>t({line:A,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=m}handleClose(e,n,t,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&t({line:u,source:1})}}i.LineProcess=f;function E(s){let e=[],n=!1;const t=function(r){if(n){e.push(r);return}(!s.send(r,u=>{if(u&&console.error(u),n=!1,e.length>0){const m=e.slice(0);e=[],m.forEach(p=>t(p))}})||v.isWindows)&&(n=!0)};return{send:t}}i.createQueuedSender=E;var c;(function(s){async function e(n,t,r){if(O.isAbsolute(n))return n;if(t===void 0&&(t=a.cwd()),O.dirname(n)!=="."||(r===void 0&&D.isString(a.env.PATH)&&(r=a.env.PATH.split(O.delimiter)),r===void 0||r.length===0))return O.join(t,n);async function u(m){if(await g.Promises.exists(m)){let p;try{p=await g.Promises.stat(m)}catch(b){b.message.startsWith("EACCES")&&(p=await g.Promises.lstat(m))}return p?!p.isDirectory():!1}return!1}for(let m of r){let p;if(O.isAbsolute(m)?p=O.join(m,n):p=O.join(t,m,n),await u(p))return p;let b=p+".com";if(await u(b)||(b=p+".exe",await u(b)))return b}return O.join(t,n)}s.findExecutable=e})(c||(i.win32=c={}))}),define(Q[79],Z([0,1,34,8,71,54]),function(W,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function O(y,w){return y===1?I.isWindows?L():R.getWindowsShell(w):h(y,w)}i.getSystemShell=O;function v(y,w){return y===1?I.isWindows?g(w):R.getWindowsShell(w):h(y,w)}i.getSystemShellSync=v;let a=null;function h(y,w){if(I.isLinux&&y===2||I.isMacintosh&&y===3)return"/bin/bash";if(!a){let d;if(I.isWindows)d="/bin/bash";else{if(d=w.SHELL,!d)try{d=(0,C.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}a=d}return a}let D=null;async function L(){return D||(D=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),D}function g(y){if(D)return D;const w=I.isWindows&&parseFloat((0,C.release)())>=10,d=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${y.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return w?S:R.getWindowsShell(y)}}),define(Q[80],Z([0,1,43,4,16,24,68,10,3,2,22,54,49,53]),function(W,i,C,I,P,R,O,v,a,h,D,L,g,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class w extends y.ChannelServer{constructor(l){super({send:f=>{try{process.send&&process.send(f.buffer.toString("base64"))}catch{}},onMessage:a.Event.fromNodeEventEmitter(process,"message",f=>P.VSBuffer.wrap(Buffer.from(f,"base64")))},l);process.once("disconnect",()=>this.dispose())}}i.Server=w;class d{constructor(l,f){this.modulePath=l,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new a.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new I.Delayer(E),this.child=null,this._client=null}getChannel(l){const f=this;return{call(E,c,s){return f.requestPromise(l,E,c,s)},listen(E,c){return f.requestEvent(l,E,c)}}}requestPromise(l,f,E,c=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(v.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(l),e=(0,I.createCancelablePromise)(r=>s.call(f,E,r)),n=c.onCancellationRequested(()=>e.cancel()),t=(0,h.toDisposable)(()=>e.cancel());return this.activeRequests.add(t),e.finally(()=>{n.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(l,f,E){if(!this.disposeDelayer)return a.Event.None;this.disposeDelayer.cancel();let c;const s=new a.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(l).listen(f,E)(s.fire,s),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,g.removeDangerousEnvVariables)(f.env),this.child=(0,C.fork)(this.modulePath,l,f);const E=new a.Emitter;a.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,O.isRemoteConsoleLog)(o)){(0,O.log)(o,`IPC Library: ${this.options.serverName}`);return}E.fire(P.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,L.createQueuedSender)(this.child):this.child,e=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),n=E.event,t={send:e,onMessage:n};this._client=new y.ChannelClient(t);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,u)=>{process.removeListener("exit",r),this.activeRequests.forEach(m=>(0,h.dispose)(m)),this.activeRequests.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+u),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:u})})}return this._client}getCachedChannel(l){let f=this.channels.get(l);return f||(f=this.client.getChannel(l),this.channels.set(l,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=d}),define(Q[81],Z([5,6]),function(W,i){return W.create("vs/base/node/zip",i)}),define(Q[82],Z([5,6]),function(W,i){return W.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Q[83],Z([5,6]),function(W,i){return W.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Q[84],Z([5,6]),function(W,i){return W.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Q[85],Z([5,6]),function(W,i){return W.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(Q[86],Z([5,6]),function(W,i){return W.create("vs/platform/extensionManagement/common/extensionsScannerService",i)}),define(Q[87],Z([5,6]),function(W,i){return W.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Q[88],Z([5,6]),function(W,i){return W.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Q[89],Z([5,6]),function(W,i){return W.create("vs/platform/extensions/common/extensionValidator",i)}),define(Q[90],Z([5,6]),function(W,i){return W.create("vs/platform/extensionsGallery/common/extensionsGalleryConfig",i)}),define(Q[91],Z([5,6]),function(W,i){return W.create("vs/platform/files/common/fileService",i)}),define(Q[92],Z([5,6]),function(W,i){return W.create("vs/platform/files/common/io",i)}),define(Q[93],Z([5,6]),function(W,i){return W.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Q[94],Z([5,6]),function(W,i){return W.create("vs/platform/languagePacks/common/languagePacks",i)}),define(Q[95],Z([5,6]),function(W,i){return W.create("vs/platform/request/common/request",i)}),define(Q[96],Z([5,6]),function(W,i){return W.create("vs/platform/shell/node/shellEnv",i)}),define(Q[97],Z([5,6]),function(W,i){return W.create("vs/platform/telemetry/common/telemetryService",i)}),define(Q[98],Z([0,1,74,40,14,13,29,18,11]),function(W,i,C,I,P,R,O,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class h{get appRoot(){return(0,R.dirname)(P.FileAccess.asFileUri("",W).fsPath)}get userHome(){return a.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return a.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return a.URI.file(this.paths.tmpDir)}get cacheHome(){return a.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,v.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,v.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return a.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,v.joinPath)(a.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,v.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,v.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,v.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,v.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,v.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=O.env.VSCODE_PORTABLE;return d?a.URI.file((0,R.join)(d,"argv.json")):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,v.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return a.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,R.resolve)(d):(0,R.normalize)((0,R.join)(P.FileAccess.asFileUri("",W).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,R.resolve)(d):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,R.resolve)(d);const S=O.env.VSCODE_EXTENSIONS;if(S)return S;const l=O.env.VSCODE_PORTABLE;return l?(0,R.join)(l,"extensions"):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(S=>/^[^:/?#]+?:\/\//.test(S)?a.URI.parse(S):a.URI.file((0,R.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?a.URI.parse(d):a.URI.file((0,R.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,v.joinPath)(a.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return a.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=O.env.VSCODE_PORTABLE;return d?a.URI.file((0,R.join)(d,"policy.json")):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}constructor(d,S,l){this._args=d,this.paths=S,this.productService=l}}i.AbstractNativeEnvironmentService=h,me([I.memoize],h.prototype,"appRoot",null),me([I.memoize],h.prototype,"userHome",null),me([I.memoize],h.prototype,"userDataPath",null),me([I.memoize],h.prototype,"appSettingsHome",null),me([I.memoize],h.prototype,"tmpDir",null),me([I.memoize],h.prototype,"cacheHome",null),me([I.memoize],h.prototype,"userRoamingDataHome",null),me([I.memoize],h.prototype,"settingsResource",null),me([I.memoize],h.prototype,"userDataSyncHome",null),me([I.memoize],h.prototype,"userDataSyncLogResource",null),me([I.memoize],h.prototype,"sync",null),me([I.memoize],h.prototype,"machineSettingsResource",null),me([I.memoize],h.prototype,"globalStorageHome",null),me([I.memoize],h.prototype,"workspaceStorageHome",null),me([I.memoize],h.prototype,"localHistoryHome",null),me([I.memoize],h.prototype,"keybindingsResource",null),me([I.memoize],h.prototype,"keyboardLayoutResource",null),me([I.memoize],h.prototype,"argvResource",null),me([I.memoize],h.prototype,"snippetsHome",null),me([I.memoize],h.prototype,"isExtensionDevelopment",null),me([I.memoize],h.prototype,"untitledWorkspacesHome",null),me([I.memoize],h.prototype,"installSourcePath",null),me([I.memoize],h.prototype,"builtinExtensionsPath",null),me([I.memoize],h.prototype,"extensionsPath",null),me([I.memoize],h.prototype,"extensionDevelopmentLocationURI",null),me([I.memoize],h.prototype,"extensionDevelopmentKind",null),me([I.memoize],h.prototype,"extensionTestsLocationURI",null),me([I.memoize],h.prototype,"debugExtensionHost",null),me([I.memoize],h.prototype,"serviceMachineIdResource",null),me([I.memoize],h.prototype,"telemetryLogResource",null),me([I.memoize],h.prototype,"disableWorkspaceTrust",null),me([I.memoize],h.prototype,"policyFile",null);function D(w,d){return y(w["inspect-extensions"],w["inspect-brk-extensions"],5870,d,w.debugId,w.extensionEnvironment)}i.parseExtensionHostPort=D;function L(w,d){return y(w["inspect-search"],w["inspect-brk-search"],5876,d,w.extensionEnvironment)}i.parseSearchPort=L;function g(w,d){return y(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,d,w.extensionEnvironment)}i.parsePtyHostPort=g;function y(w,d,S,l,f,E){const s=Number(d||w)||(l?null:S),e=s?Boolean(!!d):!1;let n;if(E)try{n=JSON.parse(E)}catch{}return{port:s,break:e,debugId:f,env:n}}}),function(){"use strict";function W(i,C,I,P){function R(v){const a=O(v),h=[a];return i.isAbsolute(a)||h.unshift(P),i.resolve(...h)}function O(v){const a=process.env.VSCODE_PORTABLE;if(a)return i.join(a,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return i.join(h,I);const D=v["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const L=process.env.USERPROFILE;if(typeof L!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=i.join(L,"AppData","Roaming")}break;case"darwin":h=i.join(C.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||i.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(h,I)}return{getUserDataPath:R}}if(typeof define=="function")define(Q[99],Z([0,147,34,14,18,29]),function(i,C,I,P,R,O){const v=R.dirname(P.FileAccess.asFileUri("",i)),a=i.__$__nodeRequire(R.joinPath(v,"package.json").fsPath);return W(C,I,a.name,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),C=require("path"),I=require("os");module.exports=W(C,I,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[100],Z([0,1,34,98,99]),function(W,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class R extends I.AbstractNativeEnvironmentService{constructor(v,a){super(v,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,P.getUserDataPath)(v)},a)}}i.NativeEnvironmentService=R}),define(Q[44],Z([0,1,18,42,89,35]),function(W,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.validateExtensionManifest=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function a(l){return l=l.trim(),l==="*"||O.test(l)}i.isValidVersionStr=a;function h(l){if(!a(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=l.match(O);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}i.parseVersion=h;function D(l){if(!l)return null;let f=l.majorBase,E=l.majorMustEqual,c=l.minorBase,s=l.minorMustEqual,e=l.patchBase,n=l.patchMustEqual;l.hasCaret&&(f===0||(s=!1),n=!1);let t=0;if(l.preRelease){const r=v.exec(l.preRelease);if(r){const[,o,u,m]=r;t=Date.UTC(Number(o),Number(u)-1,Number(m))}}return{majorBase:f,majorMustEqual:E,minorBase:c,minorMustEqual:s,patchBase:e,patchMustEqual:n,isMinimum:l.hasGreaterEquals,notBefore:t}}i.normalizeVersion=D;function L(l,f,E){let c;typeof l=="string"?c=D(h(l)):c=l;let s;f instanceof Date?s=f.getTime():typeof f=="string"&&(s=new Date(f).getTime());let e;if(typeof E=="string"?e=D(h(E)):e=E,!c||!e)return!1;let n=c.majorBase,t=c.minorBase,r=c.patchBase,o=e.majorBase,u=e.minorBase,m=e.patchBase,p=e.notBefore,b=e.majorMustEqual,A=e.minorMustEqual,z=e.patchMustEqual;return e.isMinimum?n>o?!0:n<o?!1:t>u?!0:t<u||s&&s<p?!1:r>=m:(n===1&&o===0&&(!b||!A||!z)&&(o=1,u=0,m=0,b=!0,A=!1,z=!1),n<o?!1:n>o?!b:t<u?!1:t>u?!A:r<m?!1:r>m?!z:!(s&&s<p))}i.isValidVersion=L;function g(l,f,E,c,s){const e=[];if(typeof c.publisher!="undefined"&&typeof c.publisher!="string")return e.push([I.default.Error,P.localize(0,null)]),e;if(typeof c.name!="string")return e.push([I.default.Error,P.localize(1,null,"name")]),e;if(typeof c.version!="string")return e.push([I.default.Error,P.localize(2,null,"version")]),e;if(!c.engines)return e.push([I.default.Error,P.localize(3,null,"engines")]),e;if(typeof c.engines.vscode!="string")return e.push([I.default.Error,P.localize(4,null,"engines.vscode")]),e;if(typeof c.extensionDependencies!="undefined"&&!S(c.extensionDependencies))return e.push([I.default.Error,P.localize(5,null,"extensionDependencies")]),e;if(typeof c.activationEvents!="undefined"){if(!S(c.activationEvents))return e.push([I.default.Error,P.localize(6,null,"activationEvents")]),e;if(typeof c.main=="undefined"&&typeof c.browser=="undefined")return e.push([I.default.Error,P.localize(7,null,"activationEvents","main")]),e}if(typeof c.extensionKind!="undefined"&&typeof c.main=="undefined"&&e.push([I.default.Warning,P.localize(8,null,"extensionKind")]),typeof c.main!="undefined"){if(typeof c.main!="string")return e.push([I.default.Error,P.localize(9,null,"main")]),e;{const r=(0,C.joinPath)(E,c.main);(0,C.isEqualOrParent)(r,E)||e.push([I.default.Warning,P.localize(10,null,r.path,E.path)])}if(typeof c.activationEvents=="undefined")return e.push([I.default.Error,P.localize(11,null,"activationEvents","main")]),e}if(typeof c.browser!="undefined"){if(typeof c.browser!="string")return e.push([I.default.Error,P.localize(12,null,"browser")]),e;{const r=(0,C.joinPath)(E,c.browser);(0,C.isEqualOrParent)(r,E)||e.push([I.default.Warning,P.localize(13,null,r.path,E.path)])}if(typeof c.activationEvents=="undefined")return e.push([I.default.Error,P.localize(14,null,"activationEvents","browser")]),e}if(!R.valid(c.version))return e.push([I.default.Error,P.localize(15,null)]),e;const n=[];if(!y(l,f,c,s,n))for(const r of n)e.push([I.default.Error,r]);return e}i.validateExtensionManifest=g;function y(l,f,E,c,s){return c||typeof E.main=="undefined"&&typeof E.browser=="undefined"?!0:d(l,f,E.engines.vscode,s)}i.isValidExtensionVersion=y;function w(l,f,E){return l==="*"||d(f,E,l)}i.isEngineValid=w;function d(l,f,E,c=[]){let s=D(h(E));if(!s)return c.push(P.localize(16,null,E)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return c.push(P.localize(17,null,E)),!1}else if(!s.majorMustEqual)return c.push(P.localize(18,null,E)),!1;return L(l,f,s)?!0:(c.push(P.localize(19,null,l,E)),!1)}function S(l){if(!Array.isArray(l))return!1;for(let f=0,E=l.length;f<E;f++)if(typeof l[f]!="string")return!1;return!0}}),define(Q[101],Z([0,1,16,32]),function(W,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function P(R,O,v){let a=v&&v.get("storage.serviceMachineId",0)||null;if(a)return a;try{const D=(await O.readFile(R.serviceMachineIdResource)).value.toString();a=(0,I.isUUID)(D)?D:null}catch{a=null}if(!a){a=(0,I.generateUuid)();try{await O.writeFile(R.serviceMachineIdResource,C.VSBuffer.fromString(a))}catch{}}return v&&v.store("storage.serviceMachineId",a,0,1),a}i.getServiceMachineId=P}),define(Q[45],Z([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class C{constructor(P,R=[],O=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=O}}i.SyncDescriptor=C}),define(Q[102],Z([0,1,45]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const I=[];function P(O,v,a){v instanceof C.SyncDescriptor||(v=new C.SyncDescriptor(v,[],a)),I.push([O,v])}i.registerSingleton=P;function R(){return I}i.getSingletonServiceDescriptors=R}),define(Q[103],Z([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class C{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}i.Node=C;class I{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let O of this._nodes.values())O.outgoing.size===0&&R.push(O);return R}insertEdge(R,O){const v=this.lookupOrInsertNode(R),a=this.lookupOrInsertNode(O);v.outgoing.set(this._hashFn(O),a),a.incoming.set(this._hashFn(R),v)}removeNode(R){const O=this._hashFn(R);this._nodes.delete(O);for(let v of this._nodes.values())v.outgoing.delete(O),v.incoming.delete(O)}lookupOrInsertNode(R){const O=this._hashFn(R);let v=this._nodes.get(O);return v||(v=new C(R),this._nodes.set(O,v)),v}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[O,v]of this._nodes)R.push(`${O}, (incoming)[${[...v.incoming.keys()].join(", ")}], (outgoing)[${[...v.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,O]of this._nodes){const v=new Set([R]),a=this._findCycle(O,v);if(a)return a}}_findCycle(R,O){for(let[v,a]of R.outgoing){if(O.has(v))return[...O,v].join(" -> ");O.add(v);const h=this._findCycle(a,O);if(h)return h;O.delete(v)}}}i.Graph=I}),define(Q[20],Z([0,1,7,11,9]),function(W,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getLanguageTagSettingPlainKey=i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,P.createDecorator)("configurationService");function R(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof I.URI)}i.isConfigurationOverrides=R;function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||C.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof I.URI)}i.isConfigurationUpdateOverrides=O;var v;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(v||(i.ConfigurationTarget=v={}));function a(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=a;function h(l,f){const E=Object.create(null);for(let c in l)D(E,c,l[c],f);return E}i.toValuesTree=h;function D(l,f,E,c){const s=f.split("."),e=s.pop();let n=l;for(let t=0;t<s.length;t++){let r=s[t],o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:c(`Ignoring ${f} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[e]=E}catch{c(`Ignoring ${f} as ${s.join(".")} is ${JSON.stringify(n)}`)}else c(`Ignoring ${f} as ${s.join(".")} is ${JSON.stringify(n)}`)}i.addToValueTree=D;function L(l,f){const E=f.split(".");g(l,E)}i.removeFromValueTree=L;function g(l,f){const E=f.shift();if(f.length===0){delete l[E];return}if(Object.keys(l).indexOf(E)!==-1){const c=l[E];typeof c=="object"&&!Array.isArray(c)&&(g(c,f),Object.keys(c).length===0&&delete l[E])}}function y(l,f,E){function c(n,t){let r=n;for(const o of t){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=f.split("."),e=c(l,s);return typeof e=="undefined"?E:e}i.getConfigurationValue=y;function w(l,f,E){Object.keys(f).forEach(c=>{c!=="__proto__"&&(c in l?C.isObject(l[c])&&C.isObject(f[c])?w(l[c],f[c],E):E&&(l[c]=f[c]):l[c]=f[c])})}i.merge=w;function d(l,f,E){const c=l.inspect(f),s=l.inspect(E);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:c.defaultValue}i.getMigratedSettingValue=d;function S(l){return l.replace(/[\[\]]/g,"")}i.getLanguageTagSettingPlainKey=S}),define(Q[55],Z([0,1,9]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,C.createDecorator)("downloadService")}),define(Q[21],Z([0,1,9]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,C.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,C.refineServiceDecorator)(i.IEnvironmentService)}),define(Q[23],Z([0,1,84,9]),function(W,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";function P(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=P;function R(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=R;function O(l,f){switch(l){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=O;function v(l,f){return f==="web"&&!l.includes("web")}i.isNotWebExtensionInWebTargetPlatform=v;function a(l,f,E){return v(f,E)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===E?!0:h(E).includes(l)}i.isTargetPlatformCompatible=a;function h(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=h;function D(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}i.isIExtensionIdentifier=D;var L;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(L||(i.SortBy=L={}));var g;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(g||(i.SortOrder=g={}));var y;(function(l){l.Install="install",l.Uninstall="uninstall"})(y||(i.StatisticType=y={}));var w;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(w||(i.InstallOperation=w={})),i.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var d;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal"})(d||(i.ExtensionManagementErrorCode=d={}));class S extends Error{constructor(f,E){super(f);this.code=E,this.name=E}}i.ExtensionManagementError=S,i.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),i.ExtensionsLabel=(0,C.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,C.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(Q[56],Z([0,1,9]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionsGalleryConfigService=void 0,i.IExtensionsGalleryConfigService=(0,C.createDecorator)("extensionsGalleryConfigService")}),define(Q[57],Z([0,1,16,10,92,15]),function(W,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function O(D,L,g,y,w,d){let S;try{await v(D,L,g,y,w,d)}catch(l){S=l}finally{S&&w.errorTransformer&&(S=w.errorTransformer(S)),typeof S!="undefined"&&g.error(S),g.end()}}i.readFileIntoStream=O;async function v(D,L,g,y,w,d){a(d);const S=await D.open(L,{create:!1});try{a(d);let l=0,f=0,E=w&&typeof w.length=="number"?w.length:void 0,c=C.VSBuffer.alloc(Math.min(w.bufferSize,typeof E=="number"?E:w.bufferSize)),s=w&&typeof w.position=="number"?w.position:0,e=0;do f=await D.read(S,s,c.buffer,e,c.byteLength-e),s+=f,e+=f,l+=f,typeof E=="number"&&(E-=f),e===c.byteLength&&(await g.write(y(c)),c=C.VSBuffer.alloc(Math.min(w.bufferSize,typeof E=="number"?E:w.bufferSize)),e=0);while(f>0&&(typeof E!="number"||E>0)&&a(d)&&h(l,w));if(e>0){let n=e;typeof E=="number"&&(n=Math.min(e,E)),g.write(y(c.slice(0,n)))}}catch(l){throw(0,R.ensureFileSystemProviderError)(l)}finally{await D.close(S)}}function a(D){if(D.isCancellationRequested)throw(0,I.canceled)();return!0}function h(D,L){if(L?.limits){if(typeof L.limits.memory=="number"&&D>L.limits.memory)throw(0,R.createFileSystemProviderError)((0,P.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof L.limits.size=="number"&&D>L.limits.size)throw(0,R.createFileSystemProviderError)((0,P.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[104],Z([0,1,3,148,2,8,149]),function(W,i,C,I,P,R,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class v extends P.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new C.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=C.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(h){const D=this.normalizeRequests(h),L=D.filter(y=>{const w=this.watchers.get(y.path);return w?!(0,I.patternsEquals)(w.request.excludes,y.excludes)||!(0,I.patternsEquals)(w.request.includes,y.includes):!0}),g=Array.from(this.watchers.values()).filter(({request:y})=>!D.find(w=>w.path===y.path&&(0,I.patternsEquals)(w.excludes,y.excludes)&&(0,I.patternsEquals)(w.includes,y.includes))).map(({request:y})=>y.path);L.length&&this.trace(`Request to start watching: ${L.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?y.includes:"<all>"})`).join(",")}`),g.length&&this.trace(`Request to stop watching: ${g.join(",")}`);for(const y of g)this.stopWatching(y);for(const y of L)this.startWatching(y)}startWatching(h){const D=new O.NodeJSFileWatcherLibrary(h,g=>this._onDidChangeFile.fire(g),g=>this._onDidLogMessage.fire(g),this.verboseLogging),L={request:h,instance:D};this.watchers.set(h.path,L)}async stop(){for(const[h]of this.watchers)this.stopWatching(h);this.watchers.clear()}stopWatching(h){const D=this.watchers.get(h);D&&(this.watchers.delete(h),D.instance.dispose())}normalizeRequests(h){const D=new Map;for(const L of h){const g=R.isLinux?L.path:L.path.toLowerCase();D.set(g,L)}return Array.from(D.values())}async setVerboseLogging(h){this.verboseLogging=h;for(const[,D]of this.watchers)D.instance.setVerboseLogging(h)}trace(h){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(h)})}toMessage(h,D){return D?`[File Watcher (node.js)] ${h} (path: ${D.request.path})`:`[File Watcher (node.js)] ${h}`}}i.NodeJSWatcher=v}),define(Q[105],Z([0,1,58,104]),function(W,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class P extends C.AbstractNonRecursiveWatcherClient{constructor(O,v,a){super(O,v,a);this.init()}createWatcher(){return new I.NodeJSWatcher}}i.NodeJSWatcherClient=P}),define(Q[106],Z([0,1,14,53,80,58]),function(W,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class O extends R.AbstractUniversalWatcherClient{constructor(a,h,D){super(a,h,D);this.init()}createWatcher(a){const h=a.add(new P.Client(C.FileAccess.asFileUri("bootstrap-fork",W).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return a.add(h.onDidProcessExit(({code:D,signal:L})=>this.onError(`terminated by itself with code ${D}, signal: ${L}`))),I.ProxyChannel.toService((0,I.getNextTickChannel)(h.getChannel("watcher")))}}i.UniversalWatcherClient=O}),define(Q[59],Z([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class C{constructor(...P){this._entries=new Map;for(let[R,O]of P)this.set(R,O)}set(P,R){const O=this._entries.get(P);return this._entries.set(P,R),O}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}i.ServiceCollection=C}),define(Q[107],Z([0,1,4,10,45,103,9,59]),function(W,i,C,I,P,R,O,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const a=!1;class h extends Error{constructor(w){super("cyclic dependency between services");this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class D{constructor(w=new v.ServiceCollection,d=!1,S){this._activeInstantiations=new Set,this._services=w,this._strict=d,this._parent=S,this._services.set(O.IInstantiationService,this)}createChild(w){return new D(w,this._strict,this)}invokeFunction(w,...d){let S=g.traceInvocation(w),l=!1;try{return w({get:E=>{if(l)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(E,S);if(!c)throw new Error(`[invokeFunction] unknown service '${E}'`);return c}},...d)}finally{l=!0,S.stop()}}createInstance(w,...d){let S,l;return w instanceof P.SyncDescriptor?(S=g.traceCreation(w.ctor),l=this._createInstance(w.ctor,w.staticArguments.concat(d),S)):(S=g.traceCreation(w),l=this._createInstance(w,d,S)),S.stop(),l}_createInstance(w,d=[],S){let l=O._util.getServiceDependencies(w).sort((c,s)=>c.index-s.index),f=[];for(const c of l){let s=this._getOrCreateServiceInstance(c.id,S);s||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${c.id}.`,!1),f.push(s)}let E=l.length>0?l[0].index:d.length;if(d.length!==E){console.trace(`[createInstance] First service dependency of ${w.name} at position ${E+1} conflicts with ${d.length} static arguments`);let c=E-d.length;c>0?d=d.concat(new Array(c)):d=d.slice(0,E)}return new w(...[...d,...f])}_setServiceInstance(w,d){if(this._services.get(w)instanceof P.SyncDescriptor)this._services.set(w,d);else if(this._parent)this._parent._setServiceInstance(w,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){let d=this._services.get(w);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):d}_getOrCreateServiceInstance(w,d){let S=this._getServiceInstanceOrDescriptor(w);return S instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,S,d.branch(w,!0)):(d.branch(w,!1),S)}_safeCreateAndCacheServiceInstance(w,d,S){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,d,S)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,d,S){const l=new R.Graph(c=>c.id.toString());let f=0;const E=[{id:w,desc:d,_trace:S}];for(;E.length;){const c=E.pop();if(l.lookupOrInsertNode(c),f++>1e3)throw new h(l);for(let s of O._util.getServiceDependencies(c.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(e||this._throwIfStrict(`[createInstance] ${w} depends on ${s.id} which is NOT registered.`,!0),e instanceof P.SyncDescriptor){const n={id:s.id,desc:e,_trace:c._trace.branch(s.id,!0)};l.insertEdge(c,n),E.push(n)}}}for(;;){const c=l.roots();if(c.length===0){if(!l.isEmpty())throw new h(l);break}for(const{data:s}of c){if(this._getServiceInstanceOrDescriptor(s.id)instanceof P.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}l.removeNode(s)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,d,S=[],l,f){if(this._services.get(w)instanceof P.SyncDescriptor)return this._createServiceInstance(d,S,l,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,d,S,l,f);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(w,d=[],S,l){if(S){const f=new C.IdleValue(()=>this._createInstance(w,d,l));return new Proxy(Object.create(null),{get(E,c){if(c in E)return E[c];let s=f.value,e=s[c];return typeof e!="function"||(e=e.bind(s),E[c]=e),e},set(E,c,s){return f.value[c]=s,!0}})}else return this._createInstance(w,d,l)}_throwIfStrict(w,d){if(d&&console.warn(d),this._strict)throw new Error(w)}}i.InstantiationService=D;var L;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(L||(L={}));class g{static traceInvocation(w){return a?new g(2,w.name||w.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(w){return a?new g(1,w.name):g._None}constructor(w,d){this.type=w,this.name=d,this._start=Date.now(),this._dep=[]}branch(w,d){let S=new g(3,w.toString());return this._dep.push([w,d,S]),S}stop(){let w=Date.now()-this._start;g._totals+=w;let d=!1;function S(f,E){let c=[],s=new Array(f+1).join("	");for(const[e,n,t]of E._dep)if(n&&t){d=!0,c.push(`${s}CREATES -> ${e}`);let r=S(f+1,t);r&&c.push(r)}else c.push(`${s}uses -> ${e}`);return c.join(`
`)}let l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(w>2||d)&&console.log(l.join(`
`))}}i.Trace=g,g._None=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g._totals=0});var le=this&&this.__param||function(W,i){return function(C,I){i(C,I,W)}};define(Q[60],Z([0,1,24,2,8,94,23,9]),function(W,i,C,I,P,R,O,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LanguagePackBaseService=i.ILanguagePackService=void 0,i.ILanguagePackService=(0,v.createDecorator)("languagePackService");let a=class extends I.Disposable{constructor(D){super();this.extensionGalleryService=D}async getAvailableLanguages(){const D=new C.CancellationTokenSource;setTimeout(()=>D.cancel(),1e3);let L;try{L=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},D.token)}catch{return[]}const y=L.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some(d=>d.startsWith("lp-"))).map(w=>{const d=w.properties.localizedLanguages?.[0],S=w.tags.find(f=>f.startsWith("lp-")).split("lp-")[1];return{...this.createQuickPickItem({locale:S,label:d}),extensionId:w.identifier.id,galleryExtension:w}});return y.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),y}createQuickPickItem(D){const L=D.label??D.locale;let g=D.locale!==D.label?D.locale:void 0;return D.locale.toLowerCase()===P.language.toLowerCase()&&(g||(g=""),g+=(0,R.localize)(0,null)),{id:D.locale,label:L,description:g}}};i.LanguagePackBaseService=a,i.LanguagePackBaseService=a=me([le(0,O.IExtensionGalleryService)],a)}),define(Q[12],Z([0,1,28,3,2,8,9]),function(W,i,C,I,P,R,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,O.createDecorator)("logService"),i.ILoggerService=(0,O.createDecorator)("loggerService");function v(){return new Date().toISOString()}var a;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(a||(i.LogLevel=a={})),i.DEFAULT_LOG_LEVEL=a.Info;function h(n,t,r){switch(t){case a.Trace:n.trace(r);break;case a.Debug:n.debug(r);break;case a.Info:n.info(r);break;case a.Warning:n.warn(r);break;case a.Error:n.error(r);break;case a.Critical:n.critical(r);break;default:throw new Error("Invalid log level")}}i.log=h;function D(n){let t="";for(let r=0;r<n.length;r++){let o=n[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(r>0?" ":"")+o}return t}i.format=D;class L extends P.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=L;class g extends L{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(a.Trace)&&this.log(a.Trace,D([t,...r]))}debug(t,...r){this.checkLogLevel(a.Debug)&&this.log(a.Debug,D([t,...r]))}info(t,...r){this.checkLogLevel(a.Info)&&this.log(a.Info,D([t,...r]))}warn(t,...r){this.checkLogLevel(a.Warning)&&this.log(a.Warning,D([t,...r]))}error(t,...r){if(this.checkLogLevel(a.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(a.Error,D(o))}else this.log(a.Error,D([t,...r]))}critical(t,...r){this.checkLogLevel(a.Critical)&&this.log(a.Critical,D([t,...r]))}flush(){}}i.AbstractMessageLogger=g;class y extends L{constructor(t=i.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!R.isWindows}trace(t,...r){this.getLevel()<=a.Trace&&(this.useColors?console.log(`[90m[main ${v()}][0m`,t,...r):console.log(`[main ${v()}]`,t,...r))}debug(t,...r){this.getLevel()<=a.Debug&&(this.useColors?console.log(`[90m[main ${v()}][0m`,t,...r):console.log(`[main ${v()}]`,t,...r))}info(t,...r){this.getLevel()<=a.Info&&(this.useColors?console.log(`[90m[main ${v()}][0m`,t,...r):console.log(`[main ${v()}]`,t,...r))}warn(t,...r){this.getLevel()<=a.Warning&&(this.useColors?console.warn(`[93m[main ${v()}][0m`,t,...r):console.warn(`[main ${v()}]`,t,...r))}error(t,...r){this.getLevel()<=a.Error&&(this.useColors?console.error(`[91m[main ${v()}][0m`,t,...r):console.error(`[main ${v()}]`,t,...r))}critical(t,...r){this.getLevel()<=a.Critical&&(this.useColors?console.error(`[90m[main ${v()}][0m`,t,...r):console.error(`[main ${v()}]`,t,...r))}dispose(){}flush(){}}i.ConsoleMainLogger=y;class w extends L{constructor(t=i.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=a.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=a.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=a.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=a.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=a.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=a.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}i.ConsoleLogger=w;class d extends L{constructor(t,r=i.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=a.Trace&&this.adapter.log(a.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=a.Debug&&this.adapter.log(a.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=a.Info&&this.adapter.log(a.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=a.Warning&&this.adapter.log(a.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=a.Error&&this.adapter.log(a.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=a.Critical&&this.adapter.log(a.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,C.toErrorMessage)(t,this.getLevel()<=a.Trace)}dispose(){}flush(){}}i.AdapterLogger=d;class S extends L{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const o of this.logServices)o.trace(t,...r)}debug(t,...r){for(const o of this.logServices)o.debug(t,...r)}info(t,...r){for(const o of this.logServices)o.info(t,...r)}warn(t,...r){for(const o of this.logServices)o.warn(t,...r)}error(t,...r){for(const o of this.logServices)o.error(t,...r)}critical(t,...r){for(const o of this.logServices)o.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}i.MultiplexLogService=S;class l extends P.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}i.LogService=l;class f extends P.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,r?.always?a.Trace:this.logLevel,r),this.loggers.set(t.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=f;class E{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(t){}getLevel(){return a.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}i.NullLogService=E;function c(n){if(n.verbose)return a.Trace;if(typeof n.logLevel=="string"){const t=s(n.logLevel.toLowerCase());if(t!==void 0)return t}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=c;function s(n){switch(n){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Critical;case"off":return a.Off}}i.parseLogLevel=s;function e(n){switch(n){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Critical:return"critical";case a.Off:return"off"}}i.LogLevelToString=e}),define(Q[108],Z([0,1,43,4,28,3,2,14,13,19,21,12]),function(W,i,C,I,P,R,O,v,a,h,D,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let g=class extends O.Disposable{constructor(w,d){super();this.environmentService=w,this.logService=d,this.processesLimiter=new I.Limiter(5)}async postUninstall(w){const d=this.parseScript(w,"uninstall");return d&&(this.logService.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(d.script,"uninstall",d.args,!0,w).then(()=>this.logService.info(w.identifier.id,w.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(w.identifier.id,w.manifest.version,`Failed to run post uninstall script: ${S}`)))),h.Promises.rm(this.getExtensionStoragePath(w)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(w,d){const S=`vscode:${d}`;if(w.location.scheme===v.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[S]=="string"){const l=w.manifest.scripts[S].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(w.identifier.id,w.manifest.version,`${S} should be a node script`),null):{script:(0,a.join)(w.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(w,d,S,l,f){return new Promise((E,c)=>{const s=this.start(w,d,S,f);let e;const n=t=>{e&&(clearTimeout(e),e=null),t?c(t):E(void 0)};s.on("error",t=>{n((0,P.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,r)=>{n(t?`post-${d} process exited with code ${t}`:void 0)}),l&&(e=setTimeout(()=>{e=null,s.kill(),c("timed out")},5e3))})}start(w,d,S,l){const f={silent:!0,execArgv:void 0},E=(0,C.fork)(w,[`--type=extension-post-${d}`,...S],f);E.stdout.setEncoding("utf8"),E.stderr.setEncoding("utf8");const c=R.Event.fromNodeEventEmitter(E.stdout,"data"),s=R.Event.fromNodeEventEmitter(E.stderr,"data");c(t=>this.logService.info(l.identifier.id,l.manifest.version,`post-${d}`,t)),s(t=>this.logService.error(l.identifier.id,l.manifest.version,`post-${d}`,t));const e=R.Event.any(R.Event.map(c,t=>({data:`%c${t}`,format:[""]})),R.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return R.Event.debounce(e,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),E}getExtensionStoragePath(w){return(0,a.join)(this.environmentService.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};i.ExtensionsLifecycle=g,i.ExtensionsLifecycle=g=me([le(0,D.IEnvironmentService),le(1,L.ILogService)],g)}),define(Q[109],Z([0,1,17,4,10,3,2,13,58,12]),function(W,i,C,I,P,R,O,v,a,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class D extends O.Disposable{constructor(g,y){super();this.logService=g,this.options=y,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new I.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}watch(g,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,y):this.watchNonRecursive(g,y)}watchUniversal(g,y){const w={path:this.toFilePath(g),excludes:y.excludes,includes:y.includes,recursive:y.recursive},d=(0,C.insert)(this.universalPathsToWatch,w);return this.refreshUniversalWatchers(),(0,O.toDisposable)(()=>{d(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,P.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,a.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const y of this.universalPathsToWatch)(0,a.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const y of this.universalPathsToWatch)(0,a.isRecursiveWatchRequest)(y)&&g.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(g,y){const w={path:this.toFilePath(g),excludes:y.excludes,includes:y.includes,recursive:!1},d=(0,C.insert)(this.nonRecursivePathsToWatch,w);return this.refreshNonRecursiveWatchers(),(0,O.toDisposable)(()=>{d(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,P.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,a.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,v.normalize)(g.fsPath)}}i.AbstractDiskFileSystemProvider=D}),define(Q[110],Z([0,1,17,4,16,24,3,67,61,2,62,14,111,18,41,91,15,57,12]),function(W,i,C,I,P,R,O,v,a,h,D,L,g,y,w,d,S,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let E=class extends h.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(s,e){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${s}`);const n=new h.DisposableStore;return this.provider.set(s,e),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:e}),n.add(e.onDidChangeFile(t=>this._onDidFilesChange.fire(new S.FileChangesEvent(t,!this.isPathCaseSensitive(e))))),typeof e.onDidWatchError=="function"&&n.add(e.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),n.add(e.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:e,scheme:s}))),(0,h.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:e}),this.provider.delete(s),(0,h.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const e=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){e.push(n)}}),!this.provider.has(s)&&await I.Promises.settled(e)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,e){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&e)}listCapabilities(){return a.Iterable.map(this.provider,([s,e])=>({scheme:s,capabilities:e.capabilities}))}async withProvider(s){if(!(0,y.isAbsolutePath)(s))throw new S.FileOperationError((0,d.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const e=this.provider.get(s.scheme);if(!e){const n=new Error;throw n.name="ENOPRO",n.message=(0,d.localize)(1,null,s.toString()),n}return e}async withReadProvider(s){const e=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(e)||(0,S.hasReadWriteCapability)(e)||(0,S.hasFileReadStreamCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const e=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(e)||(0,S.hasReadWriteCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,e){try{return await this.doResolveFile(s,e)}catch(n){throw(0,S.toFileSystemProviderErrorCode)(n)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,d.localize)(2,null,this.resourceForError(s)),1):(0,S.ensureFileSystemProviderError)(n)}}async doResolveFile(s,e){const n=await this.withProvider(s),t=this.isPathCaseSensitive(n),r=e?.resolveTo,o=e?.resolveSingleChildDescendants,u=e?.resolveMetadata,m=await n.stat(s);let p;return this.toFileStat(n,s,m,void 0,!!u,(b,A)=>(p||(p=D.TernarySearchTree.forUris(()=>!t),p.set(s,!0),r&&p.fill(!0,r)),p.get(b.resource)||p.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&o?A===1:!1))}async toFileStat(s,e,n,t,r,o){const{providerExtUri:u}=this.getExtUri(s),m={resource:e,name:u.basename(e),isFile:(n.type&S.FileType.File)!=0,isDirectory:(n.type&S.FileType.Directory)!=0,isSymbolicLink:(n.type&S.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&S.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,S.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(m.isDirectory&&o(m,t)){try{const p=await s.readdir(e),b=await I.Promises.settled(p.map(async([A,z])=>{try{const te=u.joinPath(e,A),J=r?await s.stat(te):{type:z};return await this.toFileStat(s,te,J,p.length,r,o)}catch(te){return this.logService.trace(te),null}}));m.children=(0,C.coalesce)(b)}catch(p){this.logService.trace(p),m.children=[]}return m}return m}async resolveAll(s){return I.Promises.settled(s.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const e=await this.withProvider(s),n=await e.stat(s);return this.toFileStat(e,s,n,void 0,!0,()=>!1)}async exists(s){const e=await this.withProvider(s);try{return!!await e.stat(s)}catch{return!1}}async canCreateFile(s,e){try{await this.doValidateCreateFile(s,e)}catch(n){return n}return!0}async doValidateCreateFile(s,e){if(!e?.overwrite&&await this.exists(s))throw new S.FileOperationError((0,d.localize)(3,null,this.resourceForError(s)),3,e)}async createFile(s,e=P.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const t=await this.writeFile(s,e);return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,t)),t}async writeFile(s,e,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(t);try{await this.validateWriteFile(t,s,n)||await this.mkdirp(t,r.dirname(s));let u;if((0,S.hasReadWriteCapability)(t)&&!(e instanceof P.VSBuffer))if((0,w.isReadableStream)(e)){const m=await(0,w.peekStream)(e,3);m.ended?u=P.VSBuffer.concat(m.buffer):u=m}else u=(0,w.peekReadable)(e,m=>P.VSBuffer.concat(m),3);else u=e;!(0,S.hasOpenReadWriteCloseCapability)(t)||(0,S.hasReadWriteCapability)(t)&&u instanceof P.VSBuffer?await this.doWriteUnbuffered(t,s,n,u):await this.doWriteBuffered(t,s,n,u instanceof P.VSBuffer?(0,P.bufferToReadable)(u):u),this._onDidRunOperation.fire(new S.FileOperationEvent(s,4))}catch(o){throw new S.FileOperationError((0,d.localize)(4,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,e,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(e)));let r;try{r=await s.stat(e)}catch{return}if((r.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,d.localize)(6,null,this.resourceForError(e)),0,n);if(this.throwIfFileIsReadonly(e,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==S.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,S.etag)({mtime:n.mtime,size:r.size}))throw new S.FileOperationError((0,d.localize)(7,null),3,n);return r}async readFile(s,e,n){const t=await this.withReadProvider(s);return e?.atomic?this.doReadFileAtomic(t,s,e,n):this.doReadFile(t,s,e,n)}async doReadFileAtomic(s,e,n,t){return new Promise((r,o)=>{this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(s,e,n,t);r(u)}catch(u){o(u)}})})}async doReadFile(s,e,n,t){const r=await this.doReadFileStream(s,e,{...n,preferUnbuffered:!0},t);return{...r,value:await(0,P.streamToBuffer)(r.value)}}async readFileStream(s,e,n){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,e,n)}async doReadFileStream(s,e,n,t){const r=new R.CancellationTokenSource(t),o=this.validateReadFile(e,n).then(m=>m,m=>{throw r.cancel(),m});let u;try{return typeof n?.etag=="string"&&n.etag!==S.ETAG_DISABLED&&await o,n?.atomic&&(0,S.hasFileAtomicReadCapability)(s)||!((0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasFileReadStreamCapability)(s))||(0,S.hasReadWriteCapability)(s)&&n?.preferUnbuffered?u=this.readFileUnbuffered(s,e,n):(0,S.hasFileReadStreamCapability)(s)?u=this.readFileStreamed(s,e,r.token,n):u=this.readFileBuffered(s,e,r.token,n),{...await o,value:u}}catch(m){u&&await(0,w.consumeStream)(u);const p=(0,d.localize)(8,null,this.resourceForError(e),(0,S.ensureFileSystemProviderError)(m).toString());throw m instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(p,m.stat,n):new S.FileOperationError(p,(0,S.toFileOperationResult)(m),n)}}readFileStreamed(s,e,n,t=Object.create(null)){const r=s.readFileStream(e,t,n);return(0,w.transform)(r,{data:o=>o instanceof P.VSBuffer?o:P.VSBuffer.wrap(o),error:o=>new S.FileOperationError((0,d.localize)(9,null,this.resourceForError(e),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),t)},o=>P.VSBuffer.concat(o))}readFileBuffered(s,e,n,t=Object.create(null)){const r=(0,P.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,e,r,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new S.FileOperationError((0,d.localize)(10,null,this.resourceForError(e),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),t)},n),r}readFileUnbuffered(s,e,n){const t=(0,w.newWriteableStream)(r=>P.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,S.hasFileAtomicReadCapability)(s)?r=await s.readFile(e,{atomic:!0}):r=await s.readFile(e),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(e,r.byteLength,n),t.end(P.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(s,e){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new S.FileOperationError((0,d.localize)(11,null,this.resourceForError(s)),0,e);if(typeof e?.etag=="string"&&e.etag!==S.ETAG_DISABLED&&e.etag===n.etag)throw new S.NotModifiedSinceFileOperationError((0,d.localize)(12,null),n,e);return this.validateReadFileLimits(s,n.size,e),n}validateReadFileLimits(s,e,n){if(n?.limits){let t;if(typeof n.limits.memory=="number"&&e>n.limits.memory&&(t=9),typeof n.limits.size=="number"&&e>n.limits.size&&(t=7),typeof t=="number")throw new S.FileOperationError((0,d.localize)(13,null,this.resourceForError(s)),t)}}async canMove(s,e,n){return this.doCanMoveCopy(s,e,"move",n)}async canCopy(s,e,n){return this.doCanMoveCopy(s,e,"copy",n)}async doCanMoveCopy(s,e,n,t){if(s.toString()!==e.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);await this.doValidateMoveCopy(r,s,o,e,n,t)}catch(r){return r}return!0}async move(s,e,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,r,e,"move",!!n),u=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,o==="move"?2:3,u)),u}async copy(s,e,n){const t=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,r,e,"copy",!!n),u=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,o==="copy"?3:2,u)),u}async doMoveCopy(s,e,n,t,r,o){if(e.toString()===t.toString())return r;const{exists:u,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(s,e,n,t,r,o);if(u&&!m&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(t)),r==="copy"){if(s===n&&(0,S.hasFileFolderCopyCapability)(s))await s.copy(e,t,{overwrite:o});else{const p=await this.resolve(e);p.isDirectory?await this.doCopyFolder(s,p,n,t):await this.doCopyFile(s,e,n,t)}return r}else return s===n?(await s.rename(e,t,{overwrite:o}),r):(await this.doMoveCopy(s,e,n,t,"copy",o),await this.del(e,{recursive:!0}),"copy")}async doCopyFile(s,e,n,t){if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,e,n,t);if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,e,n,t);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,e,n,t);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,e,n,t)}async doCopyFolder(s,e,n,t){await n.mkdir(t),Array.isArray(e.children)&&await I.Promises.settled(e.children.map(async r=>{const o=this.getExtUri(n).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),n,o):this.doCopyFile(s,r.resource,n,o)}))}async doValidateMoveCopy(s,e,n,t,r,o){let u=!1;if(s===n){const{providerExtUri:p,isPathCaseSensitive:b}=this.getExtUri(s);if(b||(u=p.isEqual(e,t)),u&&r==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(e),this.resourceForError(t)));if(!u&&p.isEqualOrParent(t,e))throw new Error((0,d.localize)(15,null,this.resourceForError(e),this.resourceForError(t)))}const m=await this.exists(t);if(m&&!u){if(!o)throw new S.FileOperationError((0,d.localize)(16,null,this.resourceForError(e),this.resourceForError(t)),4);if(s===n){const{providerExtUri:p}=this.getExtUri(s);if(p.isEqualOrParent(e,t))throw new Error((0,d.localize)(17,null,this.resourceForError(e),this.resourceForError(t)))}}return{exists:m,isSameResourceWithDifferentPathCase:u}}getExtUri(s){const e=this.isPathCaseSensitive(s);return{providerExtUri:e?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:e}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(e,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,n)),n}async mkdirp(s,e){const n=[],{providerExtUri:t}=this.getExtUri(s);for(;!t.isEqual(e,t.dirname(e));)try{if(((await s.stat(e)).type&S.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(e)));break}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(t.basename(e)),e=t.dirname(e)}for(let r=n.length-1;r>=0;r--){e=t.joinPath(e,n[r]);try{await s.mkdir(e)}catch(o){if((0,S.toFileSystemProviderErrorCode)(o)!==S.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,e){try{await this.doValidateDelete(s,e)}catch(n){return n}return!0}async doValidateDelete(s,e){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!e?.useTrash&&!(n.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.throwIfFileIsReadonly(s,r);else throw new S.FileOperationError((0,d.localize)(20,null,this.resourceForError(s)),1);if(!!!e?.recursive){const u=await this.resolve(s);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(s)))}return n}async del(s,e){const n=await this.doValidateDelete(s,e),t=!!e?.useTrash,r=!!e?.recursive;await n.delete(s,{recursive:r,useTrash:t}),this._onDidRunOperation.fire(new S.FileOperationEvent(s,1))}async cloneFile(s,e){const n=await this.withProvider(s),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);if(n===t&&this.getExtUri(n).providerExtUri.isEqual(s,e))return;if(n===t&&(0,S.hasFileCloneCapability)(n))return n.cloneFile(s,e);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(e));const r=this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri);return n===t&&(0,S.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,e,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,s,t,e))}watch(s,e={recursive:!1,excludes:[]}){const n=new h.DisposableStore;let t=!1,r=()=>{t=!0};return n.add((0,h.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(s,e);t?(0,h.dispose)(o):r=()=>(0,h.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(s,e){const n=await this.withProvider(s),t=(0,v.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),e]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:n.watch(s,e)},this.activeWatchers.set(t,r)),r.count+=1,(0,h.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,h.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,h.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,e,n,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{const r=await s.open(e,{create:!0,unlock:n?.unlock??!1});try{(0,w.isReadableStream)(t)||(0,w.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(s,r,t):await this.doWriteReadableBufferedQueued(s,r,t)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,e,n){let t=0,r;if((0,w.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=P.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,e,o,o.byteLength,t,0),t+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,u)=>{(0,w.listenStream)(r,{onData:async m=>{r.pause();try{await this.doWriteBuffer(s,e,m,m.byteLength,t,0)}catch(p){return u(p)}t+=m.byteLength,setTimeout(()=>r.resume())},onError:m=>u(m),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,e,n){let t=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(s,e,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(s,e,n,t,r,o){let u=0;for(;u<t;)u+=await s.write(e,r+u,n.buffer,o+u,t-u)}async doWriteUnbuffered(s,e,n,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,e,n,t))}async doWriteUnbufferedQueued(s,e,n,t){let r;t instanceof P.VSBuffer?r=t:(0,w.isReadableStream)(t)?r=await(0,P.streamToBuffer)(t):(0,w.isReadableBufferedStream)(t)?r=await(0,P.bufferedStreamToBuffer)(t):r=(0,P.readableToBuffer)(t),await s.writeFile(e,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,e,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,e,n,t))}async doPipeBufferedQueued(s,e,n,t){let r,o;try{r=await s.open(e,{create:!1}),o=await n.open(t,{create:!0,unlock:!1});const u=P.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,p=0,b=0;do b=await s.read(r,m,u.buffer,p,u.byteLength-p),await this.doWriteBuffer(n,o,u,b,m,p),m+=b,p+=b,p===u.byteLength&&(p=0);while(b>0)}catch(u){throw(0,S.ensureFileSystemProviderError)(u)}finally{await I.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,e,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,e,n,t))}async doPipeUnbufferedQueued(s,e,n,t){return n.writeFile(t,await s.readFile(e),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,e,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,e,n,t))}async doPipeUnbufferedToBufferedQueued(s,e,n,t){const r=await n.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(e);await this.doWriteBuffer(n,r,P.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(s,e,n,t){const r=await(0,P.streamToBuffer)(this.readFileBuffered(s,e,R.CancellationToken.None));await this.doWriteUnbuffered(n,t,void 0,r)}throwIfFileSystemIsReadonly(s,e){if(s.capabilities&2048)throw new S.FileOperationError((0,d.localize)(22,null,this.resourceForError(e)),6);return s}throwIfFileIsReadonly(s,e){if((e.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,d.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===L.Schemas.file?s.fsPath:s.toString(!0)}};i.FileService=E,i.FileService=E=me([le(0,f.ILogService)],E)}),define(Q[112],Z([0,1,113,150,4,62,16,3,52,2,13,8,18,41,19,93,15,57,109,28,106,105]),function(W,i,C,I,P,R,O,v,a,h,D,L,g,y,w,d,S,l,f,E,c,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,I.gracefulify)(C)}catch(n){console.error(`Error enabling graceful-fs: ${(0,E.toErrorMessage)(n)}`)}})();class e extends f.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r);this.onDidChangeCapabilities=v.Event.None,this.resourceLocks=new R.ResourceMap(o=>g.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:r,symbolicLink:o}=await w.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(t){try{const r=await w.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async u=>{try{let m;u.isSymbolicLink()?m=(await this.stat((0,g.joinPath)(t,u.name))).type:m=this.toType(u),o.push([u.name,m])}catch(m){this.logService.trace(m)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(t,r){let o;return r?.dangling?o=S.FileType.Unknown:t.isFile()?o=S.FileType.File:t.isDirectory()?o=S.FileType.Directory:o=S.FileType.Unknown,r&&(o|=S.FileType.SymbolicLink),o}async createResourceLock(t){const r=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const u=new P.Barrier;return this.resourceLocks.set(t,u),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,h.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(t)===u&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),u.open()})}async readFile(t,r){let o;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const u=this.toFilePath(t);return await w.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{o?.dispose()}}readFileStream(t,r,o){const u=(0,y.newWriteableStream)(m=>O.VSBuffer.concat(m.map(p=>O.VSBuffer.wrap(p))).buffer);return(0,l.readFileIntoStream)(this,t,u,m=>m.buffer,{...r,bufferSize:256*1024},o),u}async writeFile(t,r,o){let u;try{const m=this.toFilePath(t);if(!o.create||!o.overwrite){if(await w.Promises.exists(m)){if(!o.overwrite)throw(0,S.createFileSystemProviderError)((0,d.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,S.createFileSystemProviderError)((0,d.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(u,0,r,0,r.byteLength)}catch(m){throw await this.toFileSystemProviderWriteError(t,m)}finally{typeof u=="number"&&await this.close(u)}}async open(t,r){const o=this.toFilePath(t);let u;(0,S.isFileOpenForWriteOptions)(r)&&(u=await this.createResourceLock(t));let m;try{if((0,S.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:b}=await w.SymlinkSupport.stat(o);b.mode&128||await w.Promises.chmod(o,b.mode|128)}catch(b){this.logService.trace(b)}let p;if((0,S.isFileOpenForWriteOptions)(r)){if(L.isWindows)try{await w.Promises.truncate(o,0),p="r+"}catch(b){b.code!=="ENOENT"&&this.logService.trace(b)}p||(p="w")}else p="r";m=await w.Promises.open(o,p)}catch(p){throw u?.dispose(),(0,S.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(t,p):this.toFileSystemProviderError(p)}if(this.mapHandleToPos.set(m,0),(0,S.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(m,t),u){const p=this.mapHandleToLock.get(m);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${m} (${o})`),this.mapHandleToLock.set(m,u),p&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${m} (${o})`),p.dispose())}return m}async close(t){const r=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&this.canFlush)try{await w.Promises.fdatasync(t)}catch(o){this.canFlush=!1,this.logService.error(o)}return await w.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(t)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,o,u,m){const p=this.normalizePos(t,r);let b=null;try{b=(await w.Promises.read(t,o,u,m,p)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(t,p,b)}return b}normalizePos(t,r){return r===this.mapHandleToPos.get(t)?null:r}updatePos(t,r,o){const u=this.mapHandleToPos.get(t);typeof u=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,u+o):this.mapHandleToPos.delete(t)))}async write(t,r,o,u,m){return(0,P.retry)(()=>this.doWrite(t,r,o,u,m),100,3)}async doWrite(t,r,o,u,m){const p=this.normalizePos(t,r);let b=null;try{b=(await w.Promises.write(t,o,u,m,p)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),A)}finally{this.updatePos(t,p,b)}return b}async mkdir(t){try{await w.Promises.mkdir(this.toFilePath(t))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(t,r){try{const o=this.toFilePath(t);r.recursive?await w.Promises.rm(o,w.RimRafMode.MOVE):await w.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,r,o){const u=this.toFilePath(t),m=this.toFilePath(r);if(u!==m)try{await this.validateTargetDeleted(t,r,"move",o.overwrite),await w.Promises.move(u,m)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,d.localize)(2,null,(0,D.basename)(u),(0,D.basename)((0,D.dirname)(m)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(t,r,o){const u=this.toFilePath(t),m=this.toFilePath(r);if(u!==m)try{await this.validateTargetDeleted(t,r,"copy",o.overwrite),await w.Promises.copy(u,m,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,d.localize)(3,null,(0,D.basename)(u),(0,D.basename)((0,D.dirname)(m)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(t,r,o,u){const m=this.toFilePath(t),p=this.toFilePath(r);let b=!1;if(!!(this.capabilities&1024)||(b=(0,a.isEqual)(m,p,!0)),b&&o==="copy")throw(0,S.createFileSystemProviderError)((0,d.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!b&&await w.Promises.exists(p)){if(!u)throw(0,S.createFileSystemProviderError)((0,d.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.doCloneFile(t,r,!1)}async doCloneFile(t,r,o){const u=this.toFilePath(t),m=this.toFilePath(r),p=!!(this.capabilities&1024);if((0,a.isEqual)(u,m,!p))return;const b=new h.DisposableStore;try{const[A,z]=await Promise.all([this.createResourceLock(t),this.createResourceLock(r)]);b.add(A),b.add(z),o&&await w.Promises.mkdir((0,D.dirname)(m),{recursive:!0}),await w.Promises.copyFile(u,m)}catch(A){if(A.code==="ENOENT"&&!o)return this.doCloneFile(t,r,!0);throw this.toFileSystemProviderError(A)}finally{b.dispose()}}createUniversalWatcher(t,r,o){return new c.UniversalWatcherClient(u=>t(u),u=>r(u),o)}createNonRecursiveWatcher(t,r,o){return new s.NodeJSWatcherClient(u=>t(u),u=>r(u),o)}toFileSystemProviderError(t){if(t instanceof S.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=S.FileSystemProviderErrorCode.NoPermissions;break;default:r=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(t,r)}async toFileSystemProviderWriteError(t,r){let o=this.toFileSystemProviderError(r);if(t&&o.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await w.SymlinkSupport.stat(this.toFilePath(t));u.mode&128||(o=(0,S.createFileSystemProviderError)(r,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return o}}i.DiskFileSystemProvider=e}),define(Q[114],Z([0,1,15,12]),function(W,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function P(v,a,h,D,L){try{const g=await new Promise((w,d)=>{W(["spdlog"],w,d)});g.setFlushOn(I.LogLevel.Trace);const y=await g.createAsyncRotatingLogger(v,a,h,D);return L&&y.clearFormatters(),y}catch(g){console.error(g)}return null}function R(v,a,h){switch(a){case I.LogLevel.Trace:v.trace(h);break;case I.LogLevel.Debug:v.debug(h);break;case I.LogLevel.Info:v.info(h);break;case I.LogLevel.Warning:v.warn(h);break;case I.LogLevel.Error:v.error(h);break;case I.LogLevel.Critical:v.critical(h);break;default:throw new Error("Invalid log level")}}class O extends I.AbstractMessageLogger{constructor(a,h,D,L,g){super();this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(a,h,D,L),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}async _createSpdLogLogger(a,h,D,L){const g=D?6:1,y=30/g*C.ByteSize.MB,w=await P(a,h,y,g,L);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:d,message:S}of this.buffer)R(this._logger,d,S);this.buffer=[]}}log(a,h){this._logger?R(this._logger,a,h):this.getLevel()<=a&&this.buffer.push({level:a,message:h})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=O}),define(Q[115],Z([0,1,3,42,9]),function(W,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NoOpProgress=i.NoOpNotification=i.NotificationsFilter=i.NeverShowAgainScope=i.INotificationService=i.Severity=void 0,i.Severity=I.default,i.INotificationService=(0,P.createDecorator)("notificationService");var R;(function(h){h[h.WORKSPACE=0]="WORKSPACE",h[h.GLOBAL=1]="GLOBAL"})(R||(i.NeverShowAgainScope=R={}));var O;(function(h){h[h.OFF=0]="OFF",h[h.SILENT=1]="SILENT",h[h.ERROR=2]="ERROR"})(O||(i.NotificationsFilter=O={}));class v{constructor(){this.progress=new a,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}i.NoOpNotification=v;class a{infinite(){}done(){}total(D){}worked(D){}}i.NoOpProgress=a}),define(Q[116],Z([0,1,90,3,20,115,40]),function(W,i,C,I,P,R,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsGalleryConfigService=void 0;let v=class{constructor(h,D){this.configurationService=h,this.notificationService=D,this._serviceUrl="",this._itemUrl="",this._onConfigChange=new I.Emitter,this.onConfigChange=this._onConfigChange.event,this.preExtensionsGalleryConfig=this.configurationService.getValue("extensionsGallery"),this.updateURL(this.preExtensionsGalleryConfig),this.configurationService.onDidChangeConfiguration(()=>this.configure(this.configurationService.getValue("extensionsGallery")),this)}get serviceUrl(){return this._serviceUrl}get itemUrl(){return this._itemUrl}updateURL(h){h&&(this._serviceUrl=h.serviceUrl,this._itemUrl=h.itemUrl)}configure(h){JSON.stringify(this.preExtensionsGalleryConfig)===JSON.stringify(h)||(this.preExtensionsGalleryConfig=h,this.updateURL(h),this._onConfigChange.fire(this._serviceUrl?this._serviceUrl:""),this.showMessage())}showMessage(){this.notificationService.info((0,C.localize)(0,null))}};i.ExtensionsGalleryConfigService=v,me([(0,O.debounce)(2e3)],v.prototype,"showMessage",null),i.ExtensionsGalleryConfigService=v=me([le(0,P.IConfigurationService),le(1,R.INotificationService)],v)}),define(Q[33],Z([0,1,3,61,2,9]),function(W,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NullPolicyService=i.AbstractPolicyService=i.IPolicyService=void 0,i.IPolicyService=(0,R.createDecorator)("policy");class O extends P.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(h){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...h,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(h),I.Iterable.reduce(this.policies.entries(),(L,[g,y])=>({...L,[g]:y}),{})}getPolicyValue(h){return this.policies.get(h)}serialize(){return I.Iterable.reduce(Object.entries(this.policyDefinitions),(h,[D,L])=>({...h,[D]:{definition:L,value:this.policies.get(D)}}),{})}}i.AbstractPolicyService=O;class v{constructor(){this.onDidChange=C.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}i.NullPolicyService=v}),define(Q[117],Z([0,1,4,3,61,7,15,12,33]),function(W,i,C,I,P,R,O,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FilePolicyService=void 0;function h(L,g){const y=[];for(const w of P.Iterable.concat(L.keys(),g.keys()))L.get(w)!==g.get(w)&&y.push(w);return y}let D=class extends a.AbstractPolicyService{constructor(g,y,w){super();this.file=g,this.fileService=y,this.logService=w,this.throttledDelayer=this._register(new C.ThrottledDelayer(500));const d=I.Event.filter(y.onDidFilesChange,S=>S.affects(g));this._register(y.watch(g)),this._register(d(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(g){await this.refresh()}async read(){const g=new Map;try{const y=await this.fileService.readFile(this.file),w=JSON.parse(y.value.toString());if(!(0,R.isObject)(w))throw new Error("Policy file isn't a JSON object");for(const d of Object.keys(w))this.policyDefinitions[d]&&g.set(d,w[d])}catch(y){y.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",y)}return g}async refresh(){const g=await this.read(),y=h(this.policies,g);this.policies=g,y.length>0&&this._onDidChange.fire(y)}};i.FilePolicyService=D,i.FilePolicyService=D=me([le(1,O.IFileService),le(2,v.ILogService)],D)}),define(Q[27],Z([0,1,9]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,C.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(Q[30],Z([0,1,65,7]),function(W,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class P{constructor(){this.data=new Map}add(O,v){C.ok(I.isString(O)),C.ok(I.isObject(v)),C.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,v)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}i.Registry=new P}),define(Q[118],Z([0,1,3,30]),function(W,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function P(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class R{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(a,h){this.schemasById[P(a)]=h,this._onDidChangeSchema.fire(a)}notifySchemaChanged(a){this._onDidChangeSchema.fire(a)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new R;I.Registry.add(i.Extensions.JSONContribution,O)}),define(Q[36],Z([0,1,17,3,7,82,20,118,30]),function(W,i,C,I,P,R,O,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var h;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(h||(i.EditPresentationTypes=h={})),i.Extensions={Configuration:"base.contributions.configuration"};var D;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D||(i.ConfigurationScope=D={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const L=a.Registry.as(v.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},L.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(e,n=!0){this.registerConfigurations([e],n)}registerConfigurations(e,n=!0){const t=this.doRegisterConfigurations(e,n);L.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(e){const n=this.doDeregisterConfigurations(e);L.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:e,remove:n}){const t=[];t.push(...this.doDeregisterConfigurations(n)),t.push(...this.doRegisterConfigurations(e,!1)),L.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,C.distinct)(t)})}registerDefaultConfigurations(e){const n=[],t=[];for(const{overrides:r,source:o}of e)for(const u in r)if(n.push(u),i.OVERRIDE_PROPERTY_REGEX.test(u)){const m=this.configurationDefaultsOverrides.get(u),p=m?.valuesSources??new Map;if(o)for(const te of Object.keys(r[u]))p.set(te,o);const b={...m?.value||{},...r[u]};this.configurationDefaultsOverrides.set(u,{source:o,value:b,valuesSources:p});const A=(0,O.getLanguageTagSettingPlainKey)(u),z={type:"object",default:b,description:R.localize(1,null,A),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:b,source:P.isString(o)?void 0:o,defaultValueSource:o};t.push(...d(u)),this.configurationProperties[u]=z,this.defaultLanguageConfigurationOverridesNode.properties[u]=z}else{this.configurationDefaultsOverrides.set(u,{value:r[u],source:o});const m=this.configurationProperties[u];m&&(this.updatePropertyDefaultValue(u,m),this.updateSchema(u,m))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(e){const n=[];for(const{overrides:t,source:r}of e)for(const o in t){const u=this.configurationDefaultsOverrides.get(o),m=P.isString(r)?r:r?.id,p=P.isString(u?.source)?u?.source:u?.source?.id;if(m===p)if(n.push(o),this.configurationDefaultsOverrides.delete(o),i.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const b=this.configurationProperties[o];b&&(this.updatePropertyDefaultValue(o,b),this.updateSchema(o,b))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const n of e)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(e,n){const t=[];return e.forEach(r=>{t.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),t}doDeregisterConfigurations(e){const n=[],t=r=>{if(r.properties)for(const o in r.properties){n.push(o);const u=this.configurationProperties[o];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf&&r.allOf.forEach(o=>t(o))};for(const r of e){t(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(e,n=!0,t,r,o=3){o=P.isUndefinedOrNull(e.scope)?o:e.scope;let u=[],m=e.properties;if(m)for(let b in m){const A=m[b];if(n&&E(b,A)){delete m[b];continue}if(A.source=t,A.defaultDefaultValue=m[b].default,this.updatePropertyDefaultValue(b,A),i.OVERRIDE_PROPERTY_REGEX.test(b)?A.scope=void 0:(A.scope=P.isUndefinedOrNull(A.scope)?o:A.scope,A.restricted=P.isUndefinedOrNull(A.restricted)?!!r?.includes(b):A.restricted),m[b].hasOwnProperty("included")&&!m[b].included){this.excludedConfigurationProperties[b]=m[b],delete m[b];continue}else this.configurationProperties[b]=m[b],m[b].policy?.name&&this.policyConfigurations.set(m[b].policy.name,b);!m[b].deprecationMessage&&m[b].markdownDeprecationMessage&&(m[b].deprecationMessage=m[b].markdownDeprecationMessage),u.push(b)}let p=e.allOf;if(p)for(let b of p)u.push(...this.validateAndRegisterProperties(b,n,t,r,o));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(e){const n=t=>{let r=t.properties;if(r)for(const u in r)this.updateSchema(u,r[u]);let o=t.allOf;o&&o.forEach(n)};n(e)}updateSchema(e,n){switch(i.allSettings.properties[e]=n,n.scope){case 1:i.applicationSettings.properties[e]=n;break;case 2:i.machineSettings.properties[e]=n;break;case 6:i.machineOverridableSettings.properties[e]=n;break;case 3:i.windowSettings.properties[e]=n;break;case 4:i.resourceSettings.properties[e]=n;break;case 5:i.resourceSettings.properties[e]=n,this.resourceLanguageSettingsSchema.properties[e]=n;break}}removeFromSchema(e,n){switch(delete i.allSettings.properties[e],n.scope){case 1:delete i.applicationSettings.properties[e];break;case 2:delete i.machineSettings.properties[e];break;case 6:delete i.machineOverridableSettings.properties[e];break;case 3:delete i.windowSettings.properties[e];break;case 4:case 5:delete i.resourceSettings.properties[e],delete this.resourceLanguageSettingsSchema.properties[e];break}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const n=`[${e}]`,t={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,t),i.allSettings.properties[n]=t,i.applicationSettings.properties[n]=t,i.machineSettings.properties[n]=t,i.machineOverridableSettings.properties[n]=t,i.windowSettings.properties[n]=t,i.resourceSettings.properties[n]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const e={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,n){const t=this.configurationDefaultsOverrides.get(e);let r=t?.value,o=t?.source;P.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),P.isUndefined(r)&&(r=l(n.type)),n.default=r,n.defaultValueSource=o}}const y="\\[([^\\]]+)\\]",w=new RegExp(y,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function d(s){const e=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let n=w.exec(s);for(;n?.length;){const t=n[1].trim();t&&e.push(t),n=w.exec(s)}}return(0,C.distinct)(e)}i.overrideIdentifiersFromKey=d;function S(s){return s.reduce((e,n)=>`${e}[${n}]`,"")}i.keyFromOverrideIdentifiers=S;function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=l;const f=new g;a.Registry.add(i.Extensions.Configuration,f);function E(s,e){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?R.localize(7,null,s):f.getConfigurationProperties()[s]!==void 0?R.localize(8,null,s):e.policy?.name&&f.getPolicyConfigurations().get(e.policy?.name)!==void 0?R.localize(9,null,s,e.policy?.name,f.getPolicyConfigurations().get(e.policy?.name)):null:R.localize(6,null)}i.validateProperty=E;function c(){const s=[],e=f.getConfigurationProperties();for(const n of Object.keys(e))s.push([n,e[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=c}),define(Q[63],Z([0,1,17,3,48,2,62,22,7,11,20,36,30]),function(W,i,C,I,P,R,O,v,a,h,D,L,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.ConfigurationModel=void 0;class y{constructor(n={},t=[],r=[]){this._contents=n,this._keys=t,this._overrides=r,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,D.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const r=this.getContentsForOverrideIdentifer(t);return r?n?(0,D.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const r of this.overrides)r.identifiers.includes(n)&&t.push(...r.keys);return C.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return C.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=v.deepClone(this.contents),r=v.deepClone(this.overrides),o=[...this.keys];for(const u of n){this.mergeContents(t,u.contents);for(const m of u.overrides){const[p]=r.filter(b=>C.equals(b.identifiers,m.identifiers));p?(this.mergeContents(p.contents,m.contents),p.keys.push(...m.keys),p.keys=C.distinct(p.keys)):r.push(v.deepClone(m))}for(const m of u.keys)o.indexOf(m)===-1&&o.push(m)}return new y(t,o,r)}freeze(){return this.frozen=!0,this}clone(){return new y(v.deepClone(this.contents),[...this.keys],v.deepClone(this.overrides))}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const o of C.distinct([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[o],m=t[o];m&&(typeof u=="object"&&typeof m=="object"?(u=v.deepClone(u),this.mergeContents(u,m)):u=m),r[o]=u}return new y(r,this.keys,this.overrides)}mergeContents(n,t){for(const r of Object.keys(t)){if(r in n&&a.isObject(n[r])&&a.isObject(t[r])){this.mergeContents(n[r],t[r]);continue}n[r]=v.deepClone(t[r])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?v.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,r=null;const o=u=>{u&&(r?this.mergeContents(r,u):r=v.deepClone(u))};for(const u of this.overrides)C.equals(u.identifiers,[n])?t=u.contents:u.identifiers.includes(n)&&o(u.contents);return o(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,D.addToValueTree)(this.contents,n,t,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,D.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let r=0;r<t;r++)n.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}i.ConfigurationModel=y;class w{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!a.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:r,keys:o,overrides:u,restricted:m}=this.doParseRaw(n,t);this._configurationModel=new y(r,o,u),this._restrictedConfigurations=m||[]}doParseContent(n){let t={},r=null,o=[],u=[],m=[];function p(A){Array.isArray(o)?o.push(A):r!==null&&(o[r]=A)}let b={onObjectBegin:()=>{let A={};p(A),u.push(o),o=A,r=null},onObjectProperty:A=>{r=A},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let A=[];p(A),u.push(o),o=A,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:p,onError:(A,z,te)=>{m.push({error:A,offset:z,length:te})}};if(n)try{P.visit(n,b),t=o[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return t}doParseRaw(n,t){const r=g.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,r,!0,t);n=o.raw;const u=(0,D.toValuesTree)(n,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),m=Object.keys(n),p=this.toOverrides(n,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:u,keys:m,overrides:p,restricted:o.restricted}}filter(n,t,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const u={},m=[];for(let p in n)if(L.OVERRIDE_PROPERTY_REGEX.test(p)&&r){const b=this.filter(n[p],t,!1,o);u[p]=b.raw,m.push(...b.restricted)}else{const b=t[p],A=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&m.push(p),(A===void 0||o.scopes===void 0||o.scopes.includes(A))&&(o.skipRestricted&&b?.restricted||(u[p]=n[p]))}return{raw:u,restricted:m}}toOverrides(n,t){const r=[];for(const o of Object.keys(n))if(L.OVERRIDE_PROPERTY_REGEX.test(o)){const u={};for(const m in n[o])u[m]=n[o][m];r.push({identifiers:(0,L.overrideIdentifiersFromKey)(o),keys:Object.keys(u),contents:(0,D.toValuesTree)(u,t)})}return r}}i.ConfigurationModelParser=w;class d extends R.Disposable{constructor(n,t,r,o){super();this.userSettingsResource=n,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&r.isEqual(u.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=d;class S{constructor(n,t,r,o=new y,u=new y,m=new O.ResourceMap,p=new y,b=new O.ResourceMap,A=!0){this._defaultConfiguration=n,this._policyConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=u,this._folderConfigurations=m,this._memoryConfiguration=p,this._memoryConfigurationByResource=b,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(n,t,r){return this.getConsolidatedConfigurationModel(n,t,r).getValue(n)}updateValue(n,t,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new y,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(n):o.setValue(n,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,r){const o=this.getConsolidatedConfigurationModel(n,t,r),u=this.getFolderConfigurationModelForResource(t.resource,r),m=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,p=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),b=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),A=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),z=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),te=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),J=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,oe=u?t.overrideIdentifier?u.freeze().override(t.overrideIdentifier).getValue(n):u.freeze().getValue(n):void 0,re=t.overrideIdentifier?m.override(t.overrideIdentifier).getValue(n):m.getValue(n),N=o.getValue(n),j=C.distinct(o.overrides.map(q=>q.identifiers).flat()).filter(q=>o.getOverrideValue(n,q)!==void 0);return{defaultValue:p,policyValue:b,userValue:A,userLocalValue:z,userRemoteValue:te,workspaceValue:J,workspaceFolderValue:oe,memoryValue:re,value:N,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,policy:b!==void 0?{value:b}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:z!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:te!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:J!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:oe!==void 0?{value:u?.freeze().getValue(n),override:t.overrideIdentifier?u?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:m.getValue(n),override:t.overrideIdentifier?m.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const r=[];if(!t){const{added:o,updated:u,removed:m}=c(this._defaultConfiguration,n);t=[...o,...u,...m]}for(const o of t)for(const u of(0,L.overrideIdentifiersFromKey)(o)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(u),p=n.getKeysForOverrideIdentifier(u),b=[...p.filter(A=>m.indexOf(A)===-1),...m.filter(A=>p.indexOf(A)===-1),...m.filter(A=>!v.equals(this._defaultConfiguration.override(u).getValue(A),n.override(u).getValue(A)))];r.push([u,b])}return this.updateDefaultConfiguration(n),{keys:t,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:r,removed:o}=c(this._policyConfiguration,n),u=[...t,...r,...o];return u.length&&this.updatePolicyConfiguration(n),{keys:u,overrides:[]}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=c(this.localUserConfiguration,n),m=[...t,...r,...o];return m.length&&this.updateLocalUserConfiguration(n),{keys:m,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=c(this.remoteUserConfiguration,n);let m=[...t,...r,...o];return m.length&&this.updateRemoteUserConfiguration(n),{keys:m,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=c(this.workspaceConfiguration,n);let m=[...t,...r,...o];return m.length&&this.updateWorkspaceConfiguration(n),{keys:m,overrides:u}}compareAndUpdateFolderConfiguration(n,t){const r=this.folderConfigurations.get(n),{added:o,updated:u,removed:m,overrides:p}=c(r,t);let b=[...o,...u,...m];return(b.length||!r)&&this.updateFolderConfiguration(n,t),{keys:b,overrides:p}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:u,overrides:m}=c(t,void 0);return{keys:[...r,...o,...u],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,t,r){let o=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:n},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const o=t.getFolder(n);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const u=this._memoryConfigurationByResource.get(n);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(t=r.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=r}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:r,overrides:o,keys:u}=this._folderConfigurations.get(t);return n.push([t,{contents:r,overrides:o,keys:u}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),o=this.parseConfigurationModel(n.user),u=this.parseConfigurationModel(n.workspace),m=n.folders.reduce((p,b)=>(p.set(h.URI.revive(b[0]),this.parseConfigurationModel(b[1])),p),new O.ResourceMap);return new S(t,r,o,new y,u,m,new y,new O.ResourceMap,!1)}static parseConfigurationModel(n){return new y(n.contents,n.keys,n.overrides).freeze()}}i.Configuration=S;function l(...e){if(e.length===0)return{keys:[],overrides:[]};if(e.length===1)return e[0];const n=new Set,t=new Map;for(const o of e)o.keys.forEach(u=>n.add(u)),o.overrides.forEach(([u,m])=>{const p=(0,O.getOrSet)(t,u,new Set);m.forEach(b=>p.add(b))});const r=[];return t.forEach((o,u)=>r.push([u,[...o.values()]])),{keys:[...n.values()],overrides:r}}i.mergeChanges=l;class f{constructor(n,t,r,o){this.change=n,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;n.keys.forEach(p=>u.add(p)),n.overrides.forEach(([,p])=>p.forEach(b=>u.add(b))),this.affectedKeys=[...u.values()];const m=new y;this.affectedKeys.forEach(p=>m.setValue(p,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!v.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let r=(0,D.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}i.ConfigurationChangeEvent=f;class E extends f{constructor(n,t,r,o){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=r,this.sourceConfig=o}}i.AllKeysConfigurationChangeEvent=E;function c(e,n){const{added:t,removed:r,updated:o}=s(n,e),u=[],m=e?.getAllOverrideIdentifiers()||[],p=n?.getAllOverrideIdentifiers()||[];if(n){const b=p.filter(A=>!m.includes(A));for(const A of b)u.push([A,n.getKeysForOverrideIdentifier(A)])}if(e){const b=m.filter(A=>!p.includes(A));for(const A of b)u.push([A,e.getKeysForOverrideIdentifier(A)])}if(n&&e){for(const b of m)if(p.includes(b)){const A=s({contents:e.getOverrideValue(void 0,b)||{},keys:e.getKeysForOverrideIdentifier(b)},{contents:n.getOverrideValue(void 0,b)||{},keys:n.getKeysForOverrideIdentifier(b)});u.push([b,[...A.added,...A.removed,...A.updated]])}}return{added:t,removed:r,updated:o,overrides:u}}function s(e,n){const t=e?n?e.keys.filter(u=>n.keys.indexOf(u)===-1):[...e.keys]:[],r=n?e?n.keys.filter(u=>e.keys.indexOf(u)===-1):[...n.keys]:[],o=[];if(e&&n){for(const u of n.keys)if(e.keys.indexOf(u)!==-1){const m=(0,D.getConfigurationValue)(n.contents,u),p=(0,D.getConfigurationValue)(e.contents,u);v.equals(m,p)||o.push(u)}}return{added:t,removed:r,updated:o}}}),define(Q[119],Z([0,1,17,3,2,22,7,20,63,36,12,33,30]),function(W,i,C,I,P,R,O,v,a,h,D,L,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PolicyConfiguration=i.NullPolicyConfiguration=i.DefaultConfigurationModel=i.DefaultConfiguration=void 0;class y extends P.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new w(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(g.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:E})=>this.onDidUpdateConfiguration(f,E))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(f,E){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:f})}getConfigurationDefaultOverrides(){return{}}}i.DefaultConfiguration=y;class w extends a.ConfigurationModel{constructor(f={}){const E=g.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(E),s=Object.create(null),e=[];for(const n in E){const t=f[n],r=t!==void 0?t:E[n].default;(0,v.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))h.OVERRIDE_PROPERTY_REGEX.test(n)&&e.push({identifiers:(0,h.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,v.toValuesTree)(s[n],t=>console.error(`Conflict in default settings file: ${t}`))});super(s,c,e)}}i.DefaultConfigurationModel=w;class d{constructor(){this.onDidChangeConfiguration=I.Event.None,this.configurationModel=new a.ConfigurationModel}async initialize(){return this.configurationModel}}i.NullPolicyConfiguration=d;let S=class extends P.Disposable{get configurationModel(){return this._configurationModel}constructor(f,E,c){super();this.defaultConfiguration=f,this.policyService=E,this.logService=c,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new a.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(f=>this.onDidChangePolicies(f))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:f})=>this.update(await this.registerPolicyDefinitions(f),!0))),this._configurationModel}async registerPolicyDefinitions(f){const E={},c=[],s=g.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const e of f){const n=s[e];if(!n){c.push(e);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}c.push(e),E[n.policy.name]={type:n.type}}}return(0,O.isEmptyObject)(E)||await this.policyService.registerPolicyDefinitions(E),c}onDidChangePolicies(f){const E=g.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),c=(0,C.coalesce)(f.map(s=>E.get(s)));this.update(c,!0)}update(f,E){const c=g.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),s=[],e=this._configurationModel.isEmpty();for(const n of f){const t=c[n]?.policy?.name;if(t){const r=this.policyService.getPolicyValue(t);(e?r!==void 0:!(0,R.equals)(this._configurationModel.getValue(n),r))&&s.push([n,r])}else this._configurationModel.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this._configurationModel;this._configurationModel=new a.ConfigurationModel;for(const t of n.keys)this._configurationModel.setValue(t,n.getValue(t));for(const[t,r]of s)r===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,r);E&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};i.PolicyConfiguration=S,i.PolicyConfiguration=S=me([le(1,L.IPolicyService),le(2,D.ILogService)],S)}),define(Q[120],Z([0,1,4,3,2,18,20,63,119,33]),function(W,i,C,I,P,R,O,v,a,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class D extends P.Disposable{constructor(g,y,w,d){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new a.DefaultConfiguration),this.policyConfiguration=w instanceof h.NullPolicyService?new a.NullPolicyConfiguration:this._register(new a.PolicyConfiguration(this.defaultConfiguration,w,d)),this.userConfiguration=this._register(new v.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,y)),this.configuration=new v.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new v.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:S,properties:l})=>this.onDidDefaultConfigurationChange(S,l))),this._register(this.policyConfiguration.onDidChangeConfiguration(S=>this.onDidPolicyConfigurationChange(S))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[g,y,w]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new v.Configuration(g,y,w)}getConfigurationData(){return this.configuration.toData()}getValue(g,y){const w=typeof g=="string"?g:void 0,d=(0,O.isConfigurationOverrides)(g)?g:(0,O.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(w,d,void 0)}updateValue(g,y,w,d){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const y=this.configuration.toData(),w=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(w,y,1)}onDidDefaultConfigurationChange(g,y){const w=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(g,y);this.trigger(d,w,6)}onDidPolicyConfigurationChange(g){const y=this.configuration.toData(),w=this.configuration.compareAndUpdatePolicyConfiguration(g);this.trigger(w,y,6)}trigger(g,y,w){const d=new v.ConfigurationChangeEvent(g,{data:y},this.configuration);d.source=w,d.sourceConfig=this.getTargetConfiguration(w),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=D}),define(Q[121],Z([0,1,14]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getRemoteServerRootPath=i.getRemoteName=i.getRemoteAuthority=void 0;function I(O){return O.scheme===C.Schemas.vscodeRemote?O.authority:void 0}i.getRemoteAuthority=I;function P(O){if(!O)return;const v=O.indexOf("+");return v<0?O:O.substr(0,v)}i.getRemoteName=P;function R(O){return`/${O.quality??"oss"}-${O.commit??"dev"}`}i.getRemoteServerRootPath=R}),define(Q[37],Z([0,1,26,9,121]),function(W,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.TargetPlatform=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}i.getWorkspaceSupportTypeMessage=R;function O(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}i.isIExtensionIdentifier=O,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var v;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(v||(i.ExtensionType=v={}));var a;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(a||(i.TargetPlatform=a={}));class h{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,d){if(typeof w=="undefined"||w===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof w=="string"||typeof d=="string"){let S=typeof w=="string"?w:w.value,l=typeof d=="string"?d:d.value;return C.equalsIgnoreCase(S,l)}return w._lower===d._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}i.ExtensionIdentifier=h;function D(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}i.isLanguagePackExtension=D;function L(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=L;function g(y,w){if(w){const d=`onResolveRemoteAuthority:${(0,P.getRemoteName)(w)}`;return y.activationEvents?.indexOf(d)!==-1}return!1}i.isResolverExtension=g,i.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[25],Z([0,1,26,23,37,8,11,10,29]),function(W,i,C,I,P,R,O,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeTargetPlatform=i.isAlpineLinux=i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.getIdAndVersion=i.ExtensionKey=i.areSameExtensions=void 0;function h(t,r){return t.uuid&&r.uuid?t.uuid===r.uuid:t.id===r.id?!0:(0,C.compareIgnoreCase)(t.id,r.id)===0}i.areSameExtensions=h;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class L{static create(r){const o=r.manifest?r.manifest.version:r.version,u=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new L(r.identifier,o,u)}static parse(r){const o=D.exec(r);return o&&o[1]&&o[2]?new L({id:o[1]},o[2],o[4]||void 0):null}constructor(r,o,u="undefined"){this.version=o,this.targetPlatform=u,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof L?h(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}i.ExtensionKey=L;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(t){const r=g.exec(t);return r&&r[1]?[d(r[1]),r[2]]:[d(t),void 0]}i.getIdAndVersion=y;function w(t,r){return`${t}.${r}`}i.getExtensionId=w;function d(t){return t.toLocaleLowerCase()}i.adoptToGalleryExtensionId=d;function S(t,r){return d(w(t,r))}i.getGalleryExtensionId=S;function l(t,r){const o=[],u=m=>{for(const p of o)if(p.some(b=>h(r(b),r(m))))return p;return null};for(const m of t){const p=u(m);p?p.push(m):o.push([m])}return o}i.groupByExtension=l;function f(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=f;function E(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}i.getGalleryExtensionTelemetryData=E,i.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function c(t){const r=new Set;if(t.malicious)for(const o of t.malicious)r.add(o.id);return r}i.getMaliciousExtensionsSet=c;function s(t,r){const o=[],u=r.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const m=u.shift();if(m&&o.every(p=>!h(p.identifier,{id:m}))){const p=t.filter(b=>h(b.identifier,{id:m}));p.length===1&&(o.push(p[0]),u.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}i.getExtensionDependencies=s;async function e(t,r){if(!R.isLinux)return!1;let o;try{o=(await t.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await t.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){r.debug("Error while getting the os-release file.",(0,v.getErrorMessage)(m))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}i.isAlpineLinux=e;async function n(t,r){const o=await e(t,r),u=(0,I.getTargetPlatform)(o?"alpine":R.platform,a.arch);return r.debug("ComputeTargetPlatform:",u),u}i.computeTargetPlatform=n}),define(Q[122],Z([0,1,24,10,69,14,35,11,85,23,25,37]),function(W,i,C,I,P,R,O,v,a,h,D,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=void 0;const g=S=>(0,a.localize)(0,null,S),y=(0,a.localize)(1,null,"ms-dotnettools.csharp");function w(S,l){return l?`${S.publisher}.${S.name}@${S.version}`:`${S.publisher}.${S.name}`}let d=class{constructor(l,f){this.extensionManagementService=l,this.extensionGalleryService=f}get location(){}async listExtensions(l,f,E=console){let c=await this.extensionManagementService.getInstalled(1);const s=L.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(f&&f!==""){if(s.indexOf(f.toLowerCase())<0){E.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}c=c.filter(n=>n.manifest.categories?n.manifest.categories.map(r=>r.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){E.log("Possible Categories: "),s.forEach(n=>{E.log(n)});return}this.location&&E.log((0,a.localize)(2,null,this.location)),c=c.sort((n,t)=>n.identifier.id.localeCompare(t.identifier.id));let e;for(let n of c)e!==n.identifier.id&&(e=n.identifier.id,E.log(w(n.manifest,l)))}async installExtensions(l,f,E,c,s=console){const e=[],n=[];l.length&&s.log(this.location?(0,a.localize)(3,null,this.location):(0,a.localize)(4,null));const t=await this.extensionManagementService.getInstalled(1),r=(p,b)=>{const A=t.find(z=>(0,D.areSameExtensions)(z.identifier,{id:p}));if(A){if(!c&&(!b||b==="prerelease"&&A.preRelease))return s.log((0,a.localize)(5,null,p,A.manifest.version,p)),!1;if(b&&A.manifest.version===b)return s.log((0,a.localize)(6,null,`${p}@${b}`)),!1}return!0},o=(p,b,A)=>{m.push({id:p,version:b!=="prerelease"?b:void 0,installOptions:{...E,isBuiltin:A,installPreReleaseVersion:b==="prerelease"||E.installPreReleaseVersion}})},u=[],m=[];for(const p of l)if(p instanceof v.URI)u.push(p);else{const[b,A]=(0,D.getIdAndVersion)(p);r(b,A)&&o(b,A,!1)}for(const p of f){const[b,A]=(0,D.getIdAndVersion)(p);r(b,A)&&o(b,A,!0)}if(u.length&&await Promise.all(u.map(async p=>{try{const b=await this.installVSIX(p,{...E,isBuiltin:!1},c,s);b&&n.push(b)}catch(b){s.error(b.message||b.stack||b),e.push(p.toString())}})),m.length){const p=await this.getGalleryExtensions(m);await Promise.all(m.map(async b=>{const A=p.get(b.id.toLowerCase());if(A)try{const z=await this.installFromGallery(b,A,t,c,s);z&&n.push(z)}catch(z){s.error(z.message||z.stack||z),e.push(b.id)}else s.error(`${g(b.version?`${b.id}@${b.version}`:b.id)}
${y}`),e.push(b.id)}))}if(e.length)throw new Error((0,a.localize)(7,null,e.join(", ")))}async installVSIX(l,f,E,c){const s=await this.extensionManagementService.getManifest(l);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,E,c))try{return await this.extensionManagementService.install(l,f),c.log((0,a.localize)(8,null,(0,P.getBaseLabel)(l))),s}catch(n){if((0,I.isCancellationError)(n))return c.log((0,a.localize)(9,null,(0,P.getBaseLabel)(l))),null;throw n}return null}async getGalleryExtensions(l){const f=new Map,E=l.some(s=>s.installOptions.installPreReleaseVersion),c=await this.extensionGalleryService.getExtensions(l.map(s=>({...s,preRelease:E})),C.CancellationToken.None);for(const s of c)f.set(s.identifier.id.toLowerCase(),s);return f}async installFromGallery({id:l,version:f,installOptions:E},c,s,e,n){const t=await this.extensionGalleryService.getManifest(c,C.CancellationToken.None);if(t&&!this.validateExtensionKind(t,n))return null;const r=s.find(o=>(0,D.areSameExtensions)(o.identifier,c.identifier));if(r){if(c.version===r.manifest.version)return n.log((0,a.localize)(10,null,f?`${l}@${f}`:l)),null;n.log((0,a.localize)(11,null,l,c.version))}try{return E.isBuiltin?n.log(f?(0,a.localize)(12,null,l,f):(0,a.localize)(13,null,l)):n.log(f?(0,a.localize)(14,null,l,f):(0,a.localize)(15,null,l)),await this.extensionManagementService.installFromGallery(c,{...E,installGivenVersion:!!f}),n.log((0,a.localize)(16,null,l,c.version)),t}catch(o){if((0,I.isCancellationError)(o))return n.log((0,a.localize)(17,null,l)),null;throw o}}validateExtensionKind(l,f){return!0}async validateVSIX(l,f,E){const c={id:(0,D.getGalleryExtensionId)(l.publisher,l.name)},e=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,D.areSameExtensions)(c,n.identifier)&&(0,O.gt)(n.manifest.version,l.version));return e&&!f?(E.log((0,a.localize)(18,null,e.identifier.id,e.manifest.version,l.version)),!1):this.validateExtensionKind(l,E)}async uninstallExtensions(l,f,E=console){const c=async e=>{if(e instanceof v.URI){const n=await this.extensionManagementService.getManifest(e);return w(n)}return e},s=[];for(const e of l){const n=await c(e),r=(await this.extensionManagementService.getInstalled()).filter(o=>(0,D.areSameExtensions)(o.identifier,{id:n}));if(!r.length)throw new Error(`${this.notInstalled(n)}
${y}`);if(r.some(o=>o.type===0)){E.log((0,a.localize)(19,null,n));return}if(!f&&r.some(o=>o.isBuiltin)){E.log((0,a.localize)(20,null,n));return}E.log((0,a.localize)(21,null,n));for(const o of r)await this.extensionManagementService.uninstall(o),s.push(o);this.location?E.log((0,a.localize)(22,null,n,this.location)):E.log((0,a.localize)(23,null,n))}}async locateExtension(l,f=console){const E=await this.extensionManagementService.getInstalled();l.forEach(c=>{E.forEach(s=>{if(s.identifier.id===c&&s.location.scheme===R.Schemas.file){f.log(s.location.fsPath);return}})})}notInstalled(l){return this.location?(0,a.localize)(24,null,l,this.location):(0,a.localize)(25,null,l)}};i.ExtensionManagementCLIService=d,i.ExtensionManagementCLIService=d=me([le(0,h.IExtensionManagementService),le(1,h.IExtensionGalleryService)],d)}),define(Q[46],Z([0,1,17,4,22,16,10,48,77,2,14,13,8,18,35,42,7,11,86,21,25,37,44,15,9,12,27,3,51]),function(W,i,C,I,P,R,O,v,a,h,D,L,g,y,w,d,S,l,f,E,c,s,e,n,t,r,o,u,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeExtensionsScannerService=i.toExtensionDescription=i.AbstractExtensionsScannerService=i.IExtensionsScannerService=i.Translations=void 0;var p;(function(re){function N(j,q){if(j===q)return!0;let _=Object.keys(j),ne=new Set;for(let k of Object.keys(q))ne.add(k);if(_.length!==ne.size)return!1;for(let k of _){if(j[k]!==q[k])return!1;ne.delete(k)}return ne.size===0}re.equals=N})(p||(i.Translations=p={})),i.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let b=class extends h.Disposable{constructor(N,j,q,_,ne,k,T,F){super();this.systemExtensionsLocation=N,this.userExtensionsLocation=j,this.extensionsControlLocation=q,this.cacheLocation=_,this.fileService=ne,this.logService=k,this.environmentService=T,this.productService=F,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.systemExtensionsCachedScanner=this._register(new te((0,y.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new te((0,y.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.extensionsScanner=this._register(new z(this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(N){const[j,q]=await Promise.all([this.scanSystemExtensions(N),this.scanUserExtensions(N)]),_=await this.scanExtensionsUnderDevelopment(N,[...j,...q]);return this.dedupExtensions([...j,...q,..._],await this.getTargetPlatform(),!0)}async scanSystemExtensions(N){const j=[];j.push(this.scanDefaultSystemExtensions(!!N.useCache,N.language)),j.push(this.scanDevSystemExtensions(N.language,!!N.checkControlFile));const[q,_]=await Promise.all(j);return this.applyScanOptions([...q,..._],N,!1)}async scanUserExtensions(N){this.logService.trace("Started scanning user extensions");const j=await this.createExtensionScannerInput(this.userExtensionsLocation,1,!N.includeUninstalled,N.language);let _=await(N.useCache&&!j.devMode&&j.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(j);return _=await this.applyScanOptions(_,N,!0),this.logService.trace("Scanned user extensions:",_.length),_}async scanExtensionsUnderDevelopment(N,j){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const q=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(_=>_.scheme===D.Schemas.file).map(async _=>{const ne=await this.createExtensionScannerInput(_,1,!0,N.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ne)).map(T=>(T.type=j.find(F=>(0,c.areSameExtensions)(F.identifier,T.identifier))?.type??T.type,this.extensionsScanner.validate(T,ne)))}))).flat();return this.applyScanOptions(q,N,!0)}return[]}async scanExistingExtension(N,j,q){const _=await this.createExtensionScannerInput(N,j,!0,q.language),ne=await this.extensionsScanner.scanExtension(_);return!ne||!q.includeInvalid&&!ne.isValid?null:ne}async scanOneOrMultipleExtensions(N,j,q){const _=await this.createExtensionScannerInput(N,j,!0,q.language),ne=await this.extensionsScanner.scanOneOrMultipleExtensions(_);return this.applyScanOptions(ne,q,!0)}async updateMetadata(N,j){const q=(0,y.joinPath)(N,"package.json"),_=(await this.fileService.readFile(q)).value.toString(),ne=JSON.parse(_);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,ne.__metadata={...ne.__metadata,...j},await this.fileService.writeFile((0,y.joinPath)(N,"package.json"),R.VSBuffer.fromString(JSON.stringify(ne,null,"	")))}async applyScanOptions(N,j,q){return j.includeAllVersions||(N=this.dedupExtensions(N,await this.getTargetPlatform(),q)),j.includeInvalid||(N=N.filter(_=>_.isValid)),N.sort((_,ne)=>{const k=L.basename(_.location.fsPath),T=L.basename(ne.location.fsPath);return k<T?-1:k>T?1:0})}dedupExtensions(N,j,q){const _=new Map;for(const ne of N){const k=s.ExtensionIdentifier.toKey(ne.identifier.id),T=_.get(k);if(T){if(T.isValid&&!ne.isValid)continue;if(T.isValid===ne.isValid){if(q&&w.gt(T.manifest.version,ne.manifest.version)){this.logService.debug(`Skipping extension ${ne.location.path} with lower version ${ne.manifest.version}.`);continue}if(w.eq(T.manifest.version,ne.manifest.version)&&T.targetPlatform===j){this.logService.debug(`Skipping extension ${ne.location.path} from different target platform ${ne.targetPlatform}`);continue}}T.type===0?this.logService.debug(`Overwriting system extension ${T.location.path} with ${ne.location.path}.`):this.logService.warn(`Overwriting user extension ${T.location.path} with ${ne.location.path}.`)}_.set(k,ne)}return[..._.values()]}async scanDefaultSystemExtensions(N,j){this.logService.trace("Started scanning system extensions");const q=await this.createExtensionScannerInput(this.systemExtensionsLocation,0,!0,j),ne=await(N&&!q.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(q);return this.logService.trace("Scanned system extensions:",ne.length),ne}async scanDevSystemExtensions(N,j){const q=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!q?.length)return[];this.logService.trace("Started scanning dev system extensions");const _=j?await this.getBuiltInExtensionControl():{},ne=[],k=l.URI.file(L.normalize(L.join(D.FileAccess.asFileUri("",W).fsPath,"..",".build","builtInExtensions")));for(const F of q){const x=_[F.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":ne.push((0,y.joinPath)(k,F.name));break;default:ne.push(l.URI.file(x));break}}const T=await Promise.all(ne.map(async F=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(F,0,!0,N))));return this.logService.trace("Scanned dev system extensions:",T.length),(0,C.coalesce)(T)}async getBuiltInExtensionControl(){try{const N=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(N.value.toString())}catch{return{}}}async createExtensionScannerInput(N,j,q,_,ne=!0){const k=await this.getTranslations(_??g.language);let T;try{const F=await this.fileService.stat(N);typeof F.mtime=="number"&&(T=F.mtime)}catch{}return new A(N,T,j,q,ne,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,_,k)}};i.AbstractExtensionsScannerService=b,i.AbstractExtensionsScannerService=b=me([le(4,n.IFileService),le(5,r.ILogService),le(6,E.IEnvironmentService),le(7,o.IProductService)],b);class A{constructor(N,j,q,_,ne,k,T,F,x,$,B){this.location=N,this.mtime=j,this.type=q,this.excludeObsolete=_,this.validate=ne,this.productVersion=k,this.productDate=T,this.productCommit=F,this.devMode=x,this.language=$,this.translations=B}static createNlsConfiguration(N){return{language:N.language,pseudo:N.language==="pseudo",devMode:N.devMode,translations:N.translations}}static equals(N,j){return(0,y.isEqual)(N.location,j.location)&&N.mtime===j.mtime&&N.type===j.type&&N.excludeObsolete===j.excludeObsolete&&N.validate===j.validate&&N.productVersion===j.productVersion&&N.productDate===j.productDate&&N.productCommit===j.productCommit&&N.devMode===j.devMode&&N.language===j.language&&p.equals(N.translations,j.translations)}}class z extends h.Disposable{constructor(N,j){super();this.fileService=N,this.logService=j}async scanExtensions(N){const j=await this.fileService.resolve(N.location);if(j.children){let q={};if(N.excludeObsolete&&N.type===1)try{const ne=(await this.fileService.readFile((0,y.joinPath)(N.location,".obsolete"))).value.toString();q=JSON.parse(ne)}catch{}const _=await Promise.all(j.children.map(async ne=>{if(!ne.isDirectory||N.type===1&&(0,y.basename)(ne.resource).indexOf(".")===0)return null;const k=new A(ne.resource,N.mtime,N.type,N.excludeObsolete,N.validate,N.productVersion,N.productDate,N.productCommit,N.devMode,N.language,N.translations),T=await this.scanExtension(k);return T&&!q[c.ExtensionKey.create(T).toString()]?T:null}));return(0,C.coalesce)(_)}return[]}async scanOneOrMultipleExtensions(N){try{if(await this.fileService.exists((0,y.joinPath)(N.location,"package.json"))){const j=await this.scanExtension(N);return j?[j]:[]}else return await this.scanExtensions(N)}catch(j){return this.logService.error(`Error scanning extensions at ${N.location.path}:`,(0,O.getErrorMessage)(j)),[]}}async scanExtension(N){try{let j=await this.scanExtensionManifest(N.location);if(j){j.publisher||(j.publisher=s.UNDEFINED_PUBLISHER);const q=j.__metadata;delete j.__metadata;const _=(0,c.getGalleryExtensionId)(j.publisher,j.name),ne=q?.id?{id:_,uuid:q.id}:{id:_},k=q?.isSystem?0:N.type,T=k===0||!!q?.isBuiltin;j=await this.translateManifest(N.location,j,A.createNlsConfiguration(N));const F={type:k,identifier:ne,manifest:j,location:N.location,isBuiltin:T,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return N.validate?this.validate(F,N):F}}catch(j){N.type!==0&&this.logService.error(j)}return null}validate(N,j){let q=!0;const _=(0,e.validateExtensionManifest)(j.productVersion,j.productDate,j.location,N.manifest,N.isBuiltin);for(const[ne,k]of _)ne===d.default.Error&&(q=!1,this.logService.error(this.formatMessage(j.location,k)));return N.isValid=q,N.validations=_,N}async scanExtensionManifest(N){const j=(0,y.joinPath)(N,"package.json");let q;try{q=(await this.fileService.readFile(j)).value.toString()}catch(ne){return(0,n.toFileOperationResult)(ne)!==1&&this.logService.error(this.formatMessage(N,(0,f.localize)(0,null,j.path,ne.message))),null}let _;try{_=JSON.parse(q)}catch{const k=[];(0,v.parse)(q,k);for(const T of k)this.logService.error(this.formatMessage(N,(0,f.localize)(1,null,j.path,T.offset,T.length,(0,a.getParseErrorMessage)(T.error))));return null}return(0,v.getNodeType)(_)!=="object"?(this.logService.error(this.formatMessage(N,(0,f.localize)(2,null,j.path))),null):_}async translateManifest(N,j,q){const _=await this.getLocalizedMessages(N,j,q);if(_)try{const ne=[],k=await this.resolveOriginalMessageBundle(_.default,ne);if(ne.length>0)return ne.forEach(F=>{this.logService.error(this.formatMessage(N,(0,f.localize)(3,null,_.default?.path,(0,a.getParseErrorMessage)(F.error))))}),j;if((0,v.getNodeType)(_)!=="object")return this.logService.error(this.formatMessage(N,(0,f.localize)(4,null,_.default?.path))),j;const T=_.values||Object.create(null);this.replaceNLStrings(q.pseudo,j,T,k,N)}catch{}return j}async getLocalizedMessages(N,j,q){const _=(0,y.joinPath)(N,"package.nls.json"),ne=(x,$)=>{$.forEach(B=>{this.logService.error(this.formatMessage(N,(0,f.localize)(5,null,x?.path,(0,a.getParseErrorMessage)(B.error))))})},k=x=>{this.logService.error(this.formatMessage(N,(0,f.localize)(6,null,x?.path)))},T=`${j.publisher}.${j.name}`,F=q.translations[T];if(F)try{const x=l.URI.file(F),$=(await this.fileService.readFile(x)).value.toString();let B=[],ae=(0,v.parse)($,B);return B.length>0?(ne(x,B),{values:void 0,default:_}):(0,v.getNodeType)(ae)!=="object"?(k(x),{values:void 0,default:_}):{values:ae.contents?ae.contents.package:void 0,default:_}}catch{return{values:void 0,default:_}}else{if(!await this.fileService.exists(_))return;let $;try{$=await this.findMessageBundles(N,q)}catch{return}if(!$.localized)return{values:void 0,default:$.original};try{const B=(await this.fileService.readFile($.localized)).value.toString();let ae=[],Y=(0,v.parse)(B,ae);return ae.length>0?(ne($.localized,ae),{values:void 0,default:$.original}):(0,v.getNodeType)(Y)!=="object"?(k($.localized),{values:void 0,default:$.original}):{values:Y,default:$.original}}catch{return{values:void 0,default:$.original}}}}async resolveOriginalMessageBundle(N,j){if(N)try{const q=(await this.fileService.readFile(N)).value.toString();return(0,v.parse)(q,j)}catch{return null}else return null}findMessageBundles(N,j){return new Promise((q,_)=>{const ne=k=>{let T=(0,y.joinPath)(N,`package.nls.${k}.json`);this.fileService.exists(T).then(F=>{F&&q({localized:T,original:(0,y.joinPath)(N,"package.nls.json")});let x=k.lastIndexOf("-");x===-1?q({localized:(0,y.joinPath)(N,"package.nls.json"),original:null}):(k=k.substring(0,x),ne(k))})};if(j.devMode||j.pseudo||!j.language)return q({localized:(0,y.joinPath)(N,"package.nls.json"),original:null});ne(j.language)})}replaceNLStrings(N,j,q,_,ne){const k=(T,F,x)=>{const $=T[F];if((0,S.isString)($)){const B=$,ae=B.length;if(ae>1&&B[0]==="%"&&B[ae-1]==="%"){const Y=B.substr(1,ae-2);let ve=q[Y];ve===void 0&&_&&(ve=_[Y]);let V=typeof ve=="string"?ve:typeof ve?.message=="string"?ve.message:void 0;V!==void 0?(N&&(V="\uFF3B"+V.replace(/[aouei]/g,"$&$&")+"\uFF3D"),T[F]=x&&(F==="title"||F==="category")&&_?{value:V,original:_[Y]}:V):this.logService.warn(this.formatMessage(ne,(0,f.localize)(7,null,Y)))}}else if((0,S.isObject)($))for(let B in $)$.hasOwnProperty(B)&&(B==="commands"?k($,B,!0):k($,B,x));else if((0,S.isArray)($))for(let B=0;B<$.length;B++)k($,B,x)};for(let T in j)j.hasOwnProperty(T)&&k(j,T)}formatMessage(N,j){return`[${N.path}]: ${j}`}}class te extends z{constructor(N,j,q){super(j,q);this.cacheFile=N,this.cacheValidatorThrottler=this._register(new I.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(N){const j=await this.readExtensionCache();if(this.input=N,j&&j.input&&A.equals(j.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),j.result.map(_=>(_.location=l.URI.revive(_.location),_));const q=await super.scanExtensions(N);return await this.writeExtensionCache({input:N,result:q}),q}async readExtensionCache(){try{const N=await this.fileService.readFile(this.cacheFile),j=JSON.parse(N.value.toString());return{result:j.result,input:(0,m.revive)(j.input)}}catch(N){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,O.getErrorMessage)(N))}return null}async writeExtensionCache(N){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(N)))}catch(j){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,O.getErrorMessage)(j))}}async validateCache(){if(!this.input)return;const N=await this.readExtensionCache();if(!N)return;const j=N.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!P.equals(q,j))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(_){this.logService.error(_)}}}function J(re,N){const j=(0,c.getExtensionId)(re.manifest.publisher,re.manifest.name);return{id:j,identifier:new s.ExtensionIdentifier(j),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:N,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}i.toExtensionDescription=J;class oe extends b{constructor(N,j,q,_,ne,k,T,F){super(N,j,(0,y.joinPath)(q,".kylin-code-dev","extensions","control.json"),(0,y.joinPath)(_,s.MANIFEST_CACHE_FOLDER),ne,k,T,F);this.translationsPromise=(async()=>{if(g.translationsConfigFile)try{const x=await this.fileService.readFile(l.URI.file(g.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}getTranslations(N){return this.translationsPromise}}i.NativeExtensionsScannerService=oe}),define(Q[123],Z([0,1,4,10,2,8,18,35,11,32,19,21,23,25,15,12]),function(W,i,C,I,P,R,O,v,a,h,D,L,g,y,w,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;let S=class extends P.Disposable{constructor(f,E,c,s){super();this.fileService=E,this.extensionGalleryService=c,this.logService=s,this.extensionsDownloadDir=a.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,E){await this.cleanUpPromise;const c=this.getName(f),s=(0,O.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(s)){const e=(0,O.joinPath)(this.extensionsDownloadDir,`.${(0,h.generateUuid)()}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(f,e,E);try{await this.rename(e,s,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(e)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,e.path),n}}return s}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,E,c){try{await D.Promises.rename(f.fsPath,E.fsPath)}catch(s){if(R.isWindows&&s&&s.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${f} to ${E} with 'EPERM' error. Trying again...`),this.rename(f,E,c);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const E=[],c=[];for(const n of f.children){const t=y.ExtensionKey.parse(n.name);t&&c.push([t,n])}const s=(0,y.groupByExtension)(c,([n])=>n),e=[];for(const n of s)n.sort((t,r)=>v.rcompare(t[0].version,r[0].version)),E.push(...n.slice(1).map(t=>t[1].resource)),e.push(n[0][1]);e.sort((n,t)=>n.mtime-t.mtime),E.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(n=>n.resource)),await C.Promises.settled(E.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?y.ExtensionKey.create(f).toString().toLowerCase():(0,h.generateUuid)()}};i.ExtensionsDownloader=S,i.ExtensionsDownloader=S=me([le(0,L.INativeEnvironmentService),le(1,w.IFileService),le(2,g.IExtensionGalleryService),le(3,d.ILogService)],S)}),define(Q[124],Z([0,1,2,13,19,37]),function(W,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class O extends C.Disposable{constructor(a,h){super();this.environmentService=a,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(h.onDidInstallExtensions(D=>this.onDidInstallExtensions(D))),this._register(h.onDidUninstallExtension(D=>this.onDidUnInstallExtension(D)))}onDidInstallExtensions(a){a.some(h=>!!h.local)&&this.invalidate()}onDidUnInstallExtension(a){a.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=O}),define(Q[125],Z([0,1,11,21,46,15,12,27]),function(W,i,C,I,P,R,O,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScannerService=void 0;let a=class extends P.NativeExtensionsScannerService{constructor(D,L,g,y){super(C.URI.file(g.builtinExtensionsPath),C.URI.file(g.extensionsPath),g.userHome,C.URI.file(g.userDataPath),D,L,g,y)}};i.ExtensionsScannerService=a,i.ExtensionsScannerService=a=me([le(0,R.IFileService),le(1,O.ILogService),le(2,I.INativeEnvironmentService),le(3,v.IProductService)],a)}),define(Q[126],Z([0,1,151,17,4,2,14,13,19,21,23,25,12,60]),function(W,i,C,I,P,R,O,v,a,h,D,L,g,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeLanguagePackService=void 0;let w=class extends y.LanguagePackBaseService{constructor(f,E,c,s){super(c);this.extensionManagementService=f,this.logService=s,this.cache=this._register(new d(E,s)),this.extensionManagementService.registerParticipant({postInstall:async e=>this.postInstallExtension(e),postUninstall:async e=>this.postUninstallExtension(e)})}async getInstalledLanguages(){const f=await this.cache.getLanguagePacks(),E=Object.keys(f).map(c=>{const s=f[c];return{...this.createQuickPickItem({locale:c,label:s.label}),extensionId:s.extensions[0].extensionIdentifier.id}});return E.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),E}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const E=await this.cache.getLanguagePacks();Object.keys(E).some(c=>E[c]&&E[c].extensions.some(s=>(0,L.areSameExtensions)(s.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,E]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),c=await this.cache.update(E);return!(0,I.equals)(Object.keys(f),Object.keys(c))}};i.NativeLanguagePackService=w,i.NativeLanguagePackService=w=me([le(0,D.IExtensionManagementService),le(1,h.INativeEnvironmentService),le(2,D.IExtensionGalleryService),le(3,g.ILogService)],w);let d=class extends R.Disposable{constructor(f,E){super();this.logService=E,this.languagePacks={},this.languagePacksFilePath=(0,v.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(E=>{Object.keys(E).forEach(c=>delete E[c]),this.createLanguagePacksFromExtensions(E,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...E){for(const c of E)c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,c);Object.keys(f).forEach(c=>this.updateHash(f[c]))}createLanguagePacksFromExtension(f,E){const c=E.identifier,s=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const e of s)if(E.location.scheme===O.Schemas.file&&S(e)){let n=f[e.languageId];n||(n={hash:"",extensions:[],translations:{},label:e.localizedLanguageName??e.languageName},f[e.languageId]=n);let t=n.extensions.filter(r=>(0,L.areSameExtensions)(r.extensionIdentifier,c))[0];t?t.version=E.manifest.version:n.extensions.push({extensionIdentifier:c,version:E.manifest.version});for(const r of e.translations)n.translations[r.id]=(0,v.join)(E.location.fsPath,r.path)}}updateHash(f){if(f){const E=(0,C.createHash)("md5");for(const c of f.extensions)E.update(c.extensionIdentifier.uuid||c.extensionIdentifier.id).update(c.version);f.hash=E.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let E=null;return a.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,c=>c.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(c)).then(c=>{try{return JSON.parse(c)}catch{return{}}}).then(c=>(E=f(c),c)).then(c=>{for(const e of Object.keys(c))c[e]||delete c[e];this.languagePacks=c,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),a.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>E,c=>this.logService.error(c))})}};d=me([le(0,h.INativeEnvironmentService),le(1,g.ILogService)],d);function S(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const f of l.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(Q[47],Z([0,1,16,95,36,9,30]),function(W,i,C,I,P,R,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asTextOrError=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,R.createDecorator)("requestService");function v(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}i.isSuccess=v;function a(d){return d.res.statusCode===204}async function h(d){return a(d)?null:(await(0,C.streamToBuffer)(d.stream)).toString()}i.asText=h;async function D(d){if(!v(d))throw new Error("Server returned "+d.res.statusCode);return h(d)}i.asTextOrError=D;async function L(d){if(!v(d))throw new Error("Server returned "+d.res.statusCode);if(a(d))return null;const l=(await(0,C.streamToBuffer)(d.stream)).toString();try{return JSON.parse(l)}catch(f){throw f.message+=`:
`+l,f}}i.asJson=L;function g(d){w(d)}i.updateProxyConfigurationsScope=g;let y;function w(d){const S=O.Registry.as(P.Extensions.Configuration),l=y;y={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[y],remove:l?[l]:[]})}w(2)}),define(Q[127],Z([0,1,24,14,15,47]),function(W,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let O=class{constructor(a,h){this.requestService=a,this.fileService=h}async download(a,h,D=C.CancellationToken.None){if(a.scheme===I.Schemas.file||a.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(a,h);return}const L={type:"GET",url:a.toString()},g=await this.requestService.request(L,D);if(g.res.statusCode===200)await this.fileService.writeFile(h,g.stream);else{const y=await(0,R.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${y}`)}}};i.DownloadService=O,i.DownloadService=O=me([le(0,R.IRequestService),le(1,P.IFileService)],O)}),define(Q[128],Z([0,1,129,7]),function(W,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function P(O,v){return O.protocol==="http:"?v.HTTP_PROXY||v.http_proxy||null:O.protocol==="https:"&&(v.HTTPS_PROXY||v.https_proxy||v.HTTP_PROXY||v.http_proxy)||null}async function R(O,v,a={}){const h=(0,C.parse)(O),D=a.proxyUrl||P(h,v);if(!D)return null;const L=(0,C.parse)(D);if(!/^https?:$/.test(L.protocol||""))return null;const g={host:L.hostname||"",port:L.port||(L.protocol==="https"?"443":"80"),auth:L.auth,rejectUnauthorized:(0,I.isBoolean)(a.strictSSL)?a.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((y,w)=>{W(["http-proxy-agent"],y,w)}))(g):new(await new Promise((y,w)=>{W(["https-proxy-agent"],y,w)}))(g)}i.getProxyAgent=R}),define(Q[130],Z([0,1,43,13,96,24,28,10,8,32,79,152,4]),function(W,i,C,I,P,R,O,v,a,h,D,L,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const y=1e4;let w;async function d(l,f,E){return f["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):a.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,L.isLaunchedFromCli)(E)&&!f["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,L.isLaunchedFromCli)(E)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=g.Promises.withAsyncBody(async(c,s)=>{const e=new R.CancellationTokenSource,n=setTimeout(()=>{e.dispose(!0),s(new Error((0,P.localize)(0,null)))},y);try{c(await S(l,e.token))}catch(t){!(0,v.isCancellationError)(t)&&!e.token.isCancellationRequested?s(new Error((0,P.localize)(1,null,(0,O.toErrorMessage)(t)))):c({})}finally{clearTimeout(n),e.dispose()}})),w)}i.getResolvedShellEnv=d;async function S(l,f){const E=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",E);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",c);const s=(0,h.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",n);const t=await(0,D.getSystemShell)(a.OS,n);return l.trace("getUnixShellEnvironment#shell",t),new Promise((r,o)=>{if(f.isCancellationRequested)return o((0,v.canceled)());const u=(0,I.basename)(t);let m,p;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(m=`& '${process.execPath}' ${b} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,p=["-Login","-Command"]):(m=`'${process.execPath}' ${b} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,u==="tcsh"?p=["-ic"]:p=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),m);const A=(0,C.spawn)(t,[...p,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});f.onCancellationRequested(()=>(A.kill(),o((0,v.canceled)()))),A.on("error",J=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(J)),o(J)});const z=[];A.stdout.on("data",J=>z.push(J));const te=[];A.stderr.on("data",J=>te.push(J)),A.on("close",(J,oe)=>{const re=Buffer.concat(z).toString("utf8");l.trace("getUnixShellEnvironment#raw",re);const N=Buffer.concat(te).toString("utf8");if(N.trim()&&l.trace("getUnixShellEnvironment#stderr",N),J||oe)return o(new Error((0,P.localize)(2,null,J,oe)));const j=e.exec(re),q=j?j[1]:"{}";try{const _=JSON.parse(q);E?_.ELECTRON_RUN_AS_NODE=E:delete _.ELECTRON_RUN_AS_NODE,c?_.ELECTRON_NO_ATTACH_CONSOLE=c:delete _.ELECTRON_NO_ATTACH_CONSOLE,delete _.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",_),r(_)}catch(_){l.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(_)),o(_)}})})}}),define(Q[131],Z([0,1,4,3,2,111,7,72,9]),function(W,i,C,I,P,R,O,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const h="__$__targetStorageMarker";i.IStorageService=(0,a.createDecorator)("storageService");var D;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(D||(i.WillSaveStateReason=D={}));var L;(function(S){S[S.GLOBAL=0]="GLOBAL",S[S.WORKSPACE=1]="WORKSPACE"})(L||(i.StorageScope=L={}));var g;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(g||(i.StorageTarget=g={}));class y extends P.Disposable{constructor(l={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=l,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(l,f){f===h?(l===0?this._globalKeyTargets=void 0:l===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:l})):this._onDidChangeValue.fire({scope:l,key:f,target:this.getKeyTargets(l)[f]})}emitWillSaveState(l){this._onWillSaveState.fire({reason:l})}get(l,f,E){return this.getStorage(f)?.get(l,E)}getBoolean(l,f,E){return this.getStorage(f)?.getBoolean(l,E)}getNumber(l,f,E){return this.getStorage(f)?.getNumber(l,E)}store(l,f,E,c){if((0,O.isUndefinedOrNull)(f)){this.remove(l,E);return}this.withPausedEmitters(()=>{this.updateKeyTarget(l,E,c),this.getStorage(E)?.set(l,f)})}remove(l,f){this.withPausedEmitters(()=>{this.updateKeyTarget(l,f,void 0),this.getStorage(f)?.delete(l)})}withPausedEmitters(l){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{l()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(l,f){const E=[],c=this.getKeyTargets(l);for(const s of Object.keys(c))c[s]===f&&E.push(s);return E}updateKeyTarget(l,f,E){const c=this.getKeyTargets(f);typeof E=="number"?c[l]!==E&&(c[l]=E,this.getStorage(f)?.set(h,JSON.stringify(c))):typeof c[l]=="number"&&(delete c[l],this.getStorage(f)?.set(h,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(l){return l===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(l){const f=this.get(h,l);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}isNew(l){return this.getBoolean(i.IS_NEW_KEY,l)===!0}async flush(l=D.NONE){this._onWillSaveState.fire({reason:l});const f=this.getStorage(0),E=this.getStorage(1);switch(l){case D.NONE:await C.Promises.settled([f?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await C.Promises.settled([f?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve()]);break}}async logStorage(){const l=this.getStorage(0)?.items??new Map,f=this.getStorage(1)?.items??new Map;return d(l,f,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class w extends y{constructor(){super();this.globalStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(l=>this.emitDidChangeValue(1,l))),this._register(this.globalStorage.onDidChangeStorage(l=>this.emitDidChangeValue(0,l)))}getStorage(l){return l===0?this.globalStorage:this.workspaceStorage}getLogDetails(l){return l===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(l){}}i.InMemoryStorageService=w;async function d(S,l,f,E){const c=u=>{try{return JSON.parse(u)}catch{return u}},s=new Map,e=new Map;S.forEach((u,m)=>{s.set(m,u),e.set(m,c(u))});const n=new Map,t=new Map;l.forEach((u,m)=>{n.set(m,u),t.set(m,c(u))}),console.group(`Storage: Global (path: ${f})`);let r=[];s.forEach((u,m)=>{r.push({key:m,value:u})}),console.table(r),console.groupEnd(),console.log(e),console.group(`Storage: Workspace (path: ${E})`);let o=[];n.forEach((u,m)=>{o.push({key:m,value:u})}),console.table(o),console.groupEnd(),console.log(t)}i.logStorage=d}),define(Q[132],Z([0,1,8,29,11,32]),function(W,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function O(h){if(C.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function v(h,D,L,g,y,w,d,S,l,f){const E=Object.create(null);E["common.machineId"]=d,E.sessionID=(0,R.generateUuid)()+Date.now(),E.commitHash=y,E.version=w,E["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,C.PlatformToString)(C.platform),E["common.nodePlatform"]=I.platform,E["common.nodeArch"]=g,E["common.product"]=f||"desktop";const c=a(S||[]);c&&(E["common.msftInternal"]=c);let s=0;const e=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),C.isLinuxSnap&&(E["common.snap"]="true");const n=O(L);n&&(E["common.platformDetail"]=n);try{const t=await h.readFile(P.URI.file(l));E["common.source"]=t.value.toString().slice(0,30)}catch{}return E}i.resolveCommonProperties=v;function a(h){const D=I.env.USERDNSDOMAIN;if(!D)return!1;const L=D.toLowerCase();return h.some(g=>L===g)}i.verifyMicrosoftInternalDomain=a}),define(Q[31],Z([0,1,9]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,C.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(I||(i.TelemetryLevel=I={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P||(i.TelemetryConfiguration=P={}))}),define(Q[133],Z([0,1,17,4,24,10,3,2,8,11,83,23,25,12,27,31]),function(W,i,C,I,P,R,O,v,a,h,D,L,g,y,w,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let S=class extends v.Disposable{constructor(e,n,t,r){super();this.galleryService=e,this.telemetryService=n,this.logService=t,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new O.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new O.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new O.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new O.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,v.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(e){const n=await this.getTargetPlatform();return e.allTargetPlatforms.some(t=>(0,L.isTargetPlatformCompatible)(t,e.allTargetPlatforms,n))}async installFromGallery(e,n={}){try{if(!this.galleryService.isEnabled())throw new L.ExtensionManagementError(D.localize(0,null),L.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(e,!!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,n)}catch(t){throw E(this.telemetryService,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(e),error:t}),this.logService.error("Failed to install extension.",e.identifier.id),this.logService.error(t),f(t)}}async uninstall(e,n={}){return this.logService.trace("ExtensionManagementService#uninstall",e.identifier.id),this.unininstallExtension(e,n)}async reinstallFromGallery(e){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",e.identifier.id),!this.galleryService.isEnabled())throw new Error(D.localize(1,null));const n=await this.getTargetPlatform(),[t]=await this.galleryService.getExtensions([{...e.identifier,preRelease:e.preRelease}],{targetPlatform:n,compatible:!0},P.CancellationToken.None);if(!t)throw new Error(D.localize(2,null));await this.createUninstallExtensionTask(e,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsControlManifest(){const e=new Date().getTime();return(!this.extensionsControlManifest||e-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=e),this.extensionsControlManifest}registerParticipant(e){this.participants.push(e)}async installExtension(e,n,t){if(!h.URI.isUri(n)){let p=this.installingExtensions.get(g.ExtensionKey.create(n).toString());if(p)return this.logService.info("Extensions is already requested to install",n.identifier.id),p.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],o=[],u=this.createInstallExtensionTask(e,n,t);h.URI.isUri(n)||this.installingExtensions.set(g.ExtensionKey.create(n).toString(),u),this._onInstallExtension.fire({identifier:u.identifier,source:n}),this.logService.info("Installing extension:",u.identifier.id),r.push({task:u,manifest:e});let m=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",u.identifier.id);else try{const b=await this.getAllDepsAndPackExtensionsToInstall(u.identifier,e,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:A,manifest:z}of b){m=m||!!z.extensionDependencies?.some(J=>(0,g.areSameExtensions)({id:J},u.identifier));const te=g.ExtensionKey.create(A).toString();if(this.installingExtensions.has(te))this.logService.info("Extension is already requested to install",A.identifier.id);else{const J=this.createInstallExtensionTask(z,A,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(te,J),this._onInstallExtension.fire({identifier:J.identifier,source:A}),this.logService.info("Installing extension:",J.identifier.id),r.push({task:J,manifest:z})}}}catch(b){if(h.URI.isUri(u.source))(0,C.isNonEmptyArray)(e.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",u.identifier.id,b.message),(0,C.isNonEmptyArray)(e.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",u.identifier.id,b.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",u.identifier.id),b}const p=r.reduce((b,{task:A,manifest:z})=>(b.set(A.identifier.id.toLowerCase(),{task:A,manifest:z}),b),new Map);for(;p.size;){let b;const A=[...p.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(te=>p.has(te.toLowerCase())));A.length?b=p.size===1?A:A.filter(({task:z})=>!(z===u&&!m)):(this.logService.info("Found extensions with circular dependencies",A.map(({task:z})=>z.identifier.id)),b=[...p.values()]),await this.joinAllSettled(b.map(async({task:z})=>{const te=new Date().getTime();try{const J=await z.run();if(await this.joinAllSettled(this.participants.map(oe=>oe.postInstall(J,z.source,t,P.CancellationToken.None))),!h.URI.isUri(z.source)){const oe=z.operation===3;if(E(this.telemetryService,oe?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(z.source),duration:new Date().getTime()-te,durationSinceUpdate:oe?void 0:new Date().getTime()-z.source.lastUpdated}),a.isWeb&&z.operation!==3)try{await this.galleryService.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,"install")}catch{}}o.push({local:J,identifier:z.identifier,operation:z.operation,source:z.source})}catch(J){throw h.URI.isUri(z.source)||E(this.telemetryService,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(z.source),duration:new Date().getTime()-te,error:J}),this.logService.error("Error while installing the extension:",z.identifier.id),J}finally{p.delete(z.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:b})=>this.logService.info("Extension installed successfully:",b.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:b})=>(0,g.areSameExtensions)(b,u.identifier))[0].local}catch(p){if(r.forEach(({task:b})=>b.cancel()),o.length)try{const b=await Promise.allSettled(o.map(({local:A})=>this.createUninstallExtensionTask(A,{versionOnly:!0}).run()));for(let A=0;A<b.length;A++){const z=b[A],{identifier:te}=o[A];z.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",te.id):this.logService.warn("Rollback: Error while uninstalling extension",te.id,(0,R.getErrorMessage)(z.reason))}}catch(b){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(b),o.map(({identifier:A})=>A.id))}throw this._onDidInstallExtensions.fire(r.map(({task:b})=>({identifier:b.identifier,operation:2,source:b.source}))),p}finally{for(const{task:p}of r)if(!h.URI.isUri(p.source)){const b=g.ExtensionKey.create(p.source).toString();this.installingExtensions.delete(b)||this.logService.warn("Installation task is not found in the cache",b)}}}async joinAllSettled(e){const n=[],t=[],r=await Promise.allSettled(e);for(const o of r)o.status==="fulfilled"?n.push(o.value):t.push(o.reason);if(t.length)throw l(t);return n}async getAllDepsAndPackExtensionsToInstall(e,n,t,r){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const u=[e,...o.map(b=>b.identifier)],m=[],p=async(b,A)=>{const z=A.extensionDependencies||[],te=[...z];if(A.extensionPack){const J=t?o.find(oe=>(0,g.areSameExtensions)(oe.identifier,b)):void 0;for(const oe of A.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(re=>(0,g.areSameExtensions)({id:re},{id:oe}))||te.every(re=>!(0,g.areSameExtensions)({id:re},{id:oe}))&&te.push(oe)}if(te.length){const J=[...u,...m.map(re=>re.gallery.identifier)],oe=te.filter(re=>J.every(N=>!(0,g.areSameExtensions)(N,{id:re})));if(oe.length){const re=await this.galleryService.getExtensions(oe.map(N=>({id:N,preRelease:r})),P.CancellationToken.None);for(const N of re){if(J.find(_=>(0,g.areSameExtensions)(_,N.identifier)))continue;const j=z.some(_=>(0,g.areSameExtensions)({id:_},N.identifier));let q;try{q=await this.checkAndGetCompatibleVersion(N,!1,r)}catch(_){if(_ instanceof L.ExtensionManagementError&&_.code===L.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!j){this.logService.info("Skipping the packed extension as it cannot be installed",N.identifier.id);continue}else throw _}m.push({gallery:q.extension,manifest:q.manifest}),await p(q.extension.identifier,q.manifest)}}}};return await p(e,n),o=await this.getInstalled(),m.filter(b=>!o.some(A=>(0,g.areSameExtensions)(A.identifier,b.gallery.identifier)))}async checkAndGetCompatibleVersion(e,n,t){const r=await this.getExtensionsControlManifest();if((0,g.getMaliciousExtensionsSet)(r).has(e.identifier.id))throw new L.ExtensionManagementError(D.localize(3,null,e.identifier.id),L.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(e)){const m=await this.getTargetPlatform();throw new L.ExtensionManagementError(D.localize(4,null,e.identifier.id,this.productService.nameLong,(0,L.TargetPlatformToString)(m)),L.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(e,n,t);if(o){if(t&&!n&&e.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new L.ExtensionManagementError(D.localize(5,null,e.identifier.id,this.productService.nameLong,this.productService.version),L.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!t&&e.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([e.identifier],P.CancellationToken.None))[0]?new L.ExtensionManagementError(D.localize(6,null,e.identifier.id),L.ExtensionManagementErrorCode.ReleaseVersionNotFound):new L.ExtensionManagementError(D.localize(7,null,e.identifier.id,this.productService.nameLong,this.productService.version),L.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const u=await this.galleryService.getManifest(o,P.CancellationToken.None);if(u===null)throw new L.ExtensionManagementError(`Missing manifest for extension ${e.identifier.id}`,L.ExtensionManagementErrorCode.Invalid);if(u.version!==o.version)throw new L.ExtensionManagementError(`Cannot install '${e.identifier.id}' extension because of version mismatch in Marketplace`,L.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:u}}async getCompatibleVersion(e,n,t){const r=await this.getTargetPlatform();let o=null;return!n&&e.hasPreReleaseVersion&&e.properties.isPreReleaseVersion!==t&&(o=(await this.galleryService.getExtensions([{...e.identifier,preRelease:t}],{targetPlatform:r,compatible:!0},P.CancellationToken.None))[0]||null),!o&&await this.galleryService.isExtensionCompatible(e,t,r)&&(o=e),o||(n?o=(await this.galleryService.getExtensions([{...e.identifier,version:e.version}],{targetPlatform:r,compatible:!0},P.CancellationToken.None))[0]||null:o=await this.galleryService.getCompatibleExtension(e,t,r)),o}async unininstallExtension(e,n){const t=this.uninstallingExtensions.get(e.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",e.identifier.id),t.waitUntilTaskIsFinished();const r=(p,b)=>{const A=this.createUninstallExtensionTask(p,b);return this.uninstallingExtensions.set(A.extension.identifier.id.toLowerCase(),A),this.logService.info("Uninstalling extension:",p.identifier.id),this._onUninstallExtension.fire(p.identifier),A},o=(p,b)=>{b?this.logService.error("Failed to uninstall extension:",p.identifier.id,b.message):this.logService.info("Successfully uninstalled extension:",p.identifier.id),E(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(p),error:b}),this._onDidUninstallExtension.fire({identifier:p.identifier,error:b?.code})},u=[],m=[];try{u.push(r(e,{remove:!0}));const p=await this.getInstalled(1);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",e.identifier.id);else{const b=this.getAllPackExtensionsToUninstall(e,p);for(const A of b)this.uninstallingExtensions.has(A.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",A.identifier.id):u.push(r(A,{}))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",e.identifier.id):this.checkForDependents(u.map(b=>b.extension),p,e),await this.joinAllSettled(u.map(async b=>{try{if(await b.run(),await this.joinAllSettled(this.participants.map(A=>A.postUninstall(b.extension,n,P.CancellationToken.None))),b.extension.identifier.uuid)try{await this.galleryService.reportStatistic(b.extension.manifest.publisher,b.extension.manifest.name,b.extension.manifest.version,"uninstall")}catch{}o(b.extension)}catch(A){const z=A instanceof L.ExtensionManagementError?A:new L.ExtensionManagementError((0,R.getErrorMessage)(A),L.ExtensionManagementErrorCode.Internal);throw o(b.extension,z),z}finally{m.push(b)}}))}catch(p){const b=p instanceof L.ExtensionManagementError?p:new L.ExtensionManagementError((0,R.getErrorMessage)(p),L.ExtensionManagementErrorCode.Internal);for(const A of u){try{A.cancel()}catch{}m.includes(A)||o(A.extension,b)}throw b}finally{for(const p of u)this.uninstallingExtensions.delete(p.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",p.extension.identifier.id)}}checkForDependents(e,n,t){for(const r of e){const o=this.getDependents(r,n);if(o.length){const u=o.filter(m=>!e.some(p=>(0,g.areSameExtensions)(p.identifier,m.identifier)));if(u.length)throw new Error(this.getDependentsErrorMessage(r,u,t))}}}getDependentsErrorMessage(e,n,t){return t===e?n.length===1?D.localize(8,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?D.localize(9,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):D.localize(10,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?D.localize(11,null,t.manifest.displayName||t.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?D.localize(12,null,t.manifest.displayName||t.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):D.localize(13,null,t.manifest.displayName||t.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(e,n,t=[]){if(t.indexOf(e)!==-1)return[];t.push(e);const r=e.manifest.extensionPack?e.manifest.extensionPack:[];if(r.length){const o=n.filter(m=>!m.isBuiltin&&r.some(p=>(0,g.areSameExtensions)({id:p},m.identifier))),u=[];for(const m of o)u.push(...this.getAllPackExtensionsToUninstall(m,n,t));return[...o,...u]}return[]}getDependents(e,n){return n.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(r=>(0,g.areSameExtensions)({id:r},e.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const e=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",e),e}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};i.AbstractExtensionManagementService=S,i.AbstractExtensionManagementService=S=me([le(0,L.IExtensionGalleryService),le(1,d.ITelemetryService),le(2,y.ILogService),le(3,w.IProductService)],S);function l(s){const e=Array.isArray(s)?s:[s];return e.length===1?e[0]instanceof Error?e[0]:new Error(e[0]):e.reduce((n,t)=>new Error(`${n.message}${n.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}i.joinErrors=l;function f(s){if(s instanceof L.ExtensionManagementError)return s;const e=new L.ExtensionManagementError(s.message,L.ExtensionManagementErrorCode.Internal);return e.stack=s.stack,e}function E(s,e,{extensionData:n,duration:t,error:r,durationSinceUpdate:o}){const u=r?r instanceof L.ExtensionManagementError?r.code:L.ExtensionManagementErrorCode.Internal:void 0;s.publicLog(e,{...n,success:!r,duration:t,errorcode:u,durationSinceUpdate:o})}i.reportTelemetry=E;class c{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(e=>this.doRun(e))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(e=>new Promise((n,t)=>{const r=e.onCancellationRequested(()=>{r.dispose(),t(new R.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=c}),define(Q[38],Z([0,1,22,50,7,20,31]),function(W,i,C,I,P,R,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getPiiPathsFromEnvironment=i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class v{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,I.staticObservableValue)(0)}publicLog(c,s){return Promise.resolve(void 0)}publicLog2(c,s){return this.publicLog(c,s)}publicLogError(c,s){return Promise.resolve(void 0)}publicLogError2(c,s){return this.publicLogError(c,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=v,i.NullTelemetryService=new v;class a{async publicLog(c,s,e){}async publicLogError(c,s,e){}}i.NullEndpointTelemetryService=a,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(E,c){return c.onDidChangeConfiguration(s=>{s.source!==6&&E.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(s.source),configurationKeys:S(s.sourceConfig)})})}i.configurationTelemetry=h;function D(E,c){return!(c.disableTelemetry||!E.enableTelemetry||c.extensionTestsLocationURI)}i.supportsTelemetry=D;function L(E){const c=E.getValue(O.TELEMETRY_SETTING_ID),s=E.getValue("telemetry.enableCrashReporter");if(E.getValue(O.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=L;function g(E){const c=Object.create(null),s=Object.create(null),e=Object.create(null);d(E,e);for(let n in e){n=n.length>150?n.substr(n.length-149):n;const t=e[n];typeof t=="number"?s[n]=t:typeof t=="boolean"?s[n]=t?1:0:typeof t=="string"?(t.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${t.length}`),c[n]=t.substring(0,8191)):typeof t!="undefined"&&t!==null&&(c[n]=t)}return{properties:c,measurements:s}}i.validateTelemetryData=g;const y=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function w(E){if(!E)return"none";for(const c of y)if(E.startsWith(`${c}+`))return c;return"other"}i.cleanRemoteAuthority=w;function d(E,c,s=0,e){if(!!E)for(let n of Object.getOwnPropertyNames(E)){const t=E[n],r=e?e+n:n;Array.isArray(t)?c[r]=(0,C.safeStringify)(t):t instanceof Date?c[r]=t.toISOString():(0,P.isObject)(t)?s<2?d(t,c,s+1,r+"."):c[r]=(0,C.safeStringify)(t):c[r]=t}}function S(E){if(!E)return[];const c=[];return l(c,"",E),c}function l(E,c,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(e=>l(E,c?`${c}.${e}`:e,s[e])):E.push(c)}function f(E){return[E.appRoot,E.extensionsPath,E.userHome.fsPath,E.tmpDir.fsPath,E.userDataPath]}i.getPiiPathsFromEnvironment=f}),define(Q[134],Z([0,1,101,38]),function(W,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function P(R,O,v,a,h,D){const L={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${O.nameShort})`},g=await(0,C.getServiceMachineId)(v,h,D);return(0,I.supportsTelemetry)(O,v)&&(0,I.getTelemetryLevel)(a)===3&&(L["X-Market-User-Id"]=g),L}i.resolveMarketplaceHeaders=P}),define(Q[135],Z([0,1,17,24,10,22,8,29,7,11,20,21,23,25,44,15,12,27,47,134,131,31,56]),function(W,i,C,I,P,R,O,v,a,h,D,L,g,y,w,d,S,l,f,E,c,s,e){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const n=O.isWeb?"web":(0,g.getTargetPlatform)(O.platform,v.arch);var t;(function(V){V[V.None=0]="None",V[V.IncludeVersions=1]="IncludeVersions",V[V.IncludeFiles=2]="IncludeFiles",V[V.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",V[V.IncludeSharedAccounts=8]="IncludeSharedAccounts",V[V.IncludeVersionProperties=16]="IncludeVersionProperties",V[V.ExcludeNonValidated=32]="ExcludeNonValidated",V[V.IncludeInstallationTargets=64]="IncludeInstallationTargets",V[V.IncludeAssetUri=128]="IncludeAssetUri",V[V.IncludeStatistics=256]="IncludeStatistics",V[V.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",V[V.Unpublished=4096]="Unpublished",V[V.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function r(...V){return String(V.reduce((M,G)=>M|G,0))}var o;(function(V){V[V.Tag=1]="Tag",V[V.ExtensionId=4]="ExtensionId",V[V.Category=5]="Category",V[V.ExtensionName=7]="ExtensionName",V[V.Target=8]="Target",V[V.Featured=9]="Featured",V[V.SearchText=10]="SearchText",V[V.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},b={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class A{constructor(M=b){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(M,G=this.state.pageSize){return new A({...this.state,pageNumber:M,pageSize:G})}withFilter(M,...G){const K=[...this.state.criteria,...G.length?G.map(ee=>({filterType:M,value:ee})):[{filterType:M}]];return new A({...this.state,criteria:K})}withSortBy(M){return new A({...this.state,sortBy:M})}withSortOrder(M){return new A({...this.state,sortOrder:M})}withFlags(...M){return new A({...this.state,flags:M.reduce((G,K)=>G|K,0)})}withAssetTypes(...M){return new A({...this.state,assetTypes:M})}withSource(M){return new A({...this.state,source:M})}get raw(){const{criteria:M,pageNumber:G,pageSize:K,sortBy:ee,sortOrder:ie,flags:se,assetTypes:ce}=this.state;return{filters:[{criteria:M,pageNumber:G,pageSize:K,sortBy:ee,sortOrder:ie}],assetTypes:ce,flags:se}}get searchText(){const M=this.state.criteria.filter(G=>G.filterType===o.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function z(V,M){const G=(V||[]).filter(K=>K.statisticName===M)[0];return G?G.value:0}function te(V){const M="Microsoft.VisualStudio.Code.Translation.";return V.files.filter(K=>K.assetType.indexOf(M)===0).reduce((K,ee)=>{const ie=re(V,ee.assetType);return ie&&K.push([ee.assetType.substring(M.length),ie]),K},[])}function J(V){if(V.properties){const M=V.properties.filter(ee=>ee.key===u.Repository),G=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),K=M.filter(ee=>G.test(ee.value))[0];return K?{uri:K.value,fallbackUri:K.value}:null}return re(V,u.Repository)}function oe(V){return{uri:`${V.fallbackAssetUri}/${u.VSIX}?redirect=true${V.targetPlatform?`&targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${u.VSIX}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}}function re(V,M){return V.files.filter(K=>K.assetType===M)[0]?{uri:`${V.assetUri}/${M}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${M}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}:null}function N(V,M){const G=V.properties?V.properties.filter(ee=>ee.key===M):[],K=G.length>0&&G[0].value;return K?K.split(",").map(ee=>(0,y.adoptToGalleryExtensionId)(ee)):[]}function j(V){const M=V.properties?V.properties.filter(G=>G.key===m.Engine):[];return M.length>0&&M[0].value||""}function q(V){const M=V.properties?V.properties.filter(G=>G.key===m.PreRelease):[];return M.length>0&&M[0].value==="true"}function _(V){const M=V.properties?V.properties.filter(K=>K.key===m.LocalizedLanguages):[],G=M.length>0&&M[0].value||"";return G?G.split(","):[]}function ne(V){return V.properties?.find(M=>M.key===m.SponsorLink)?.value}function k(V){return V.indexOf("preview")!==-1}function T(V){return V.targetPlatform?(0,g.toTargetPlatform)(V.targetPlatform):"undefined"}function F(V){const M=(0,C.distinct)(V.versions.map(T)),G=!!V.tags?.includes(g.WEB_EXTENSION_TAG),K=M.indexOf("web");return G?K===-1&&M.push("web"):K!==-1&&M.splice(K,1),M}function x(V,M){const G=(0,g.getFallbackTargetPlarforms)(M);for(let K=0;K<V.length;K++){const ee=V[K];if(ee.version===V[K-1]?.version){let ie=K;const se=T(ee);if(se===M)for(;ie>0&&V[ie-1].version===ee.version;)ie--;else if(G.includes(se))for(;ie>0&&V[ie-1].version===ee.version&&T(V[ie-1])!==M;)ie--;ie!==K&&(V.splice(K,1),V.splice(ie,0,ee))}}return V}i.sortExtensionVersions=x;function $(V,M,G){V.telemetryData={index:M,querySource:G}}function B(V,M,G){const K=V.versions[0],ee={manifest:re(M,u.Manifest),readme:re(M,u.Details),changelog:re(M,u.Changelog),license:re(M,u.License),repository:J(M),download:oe(M),icon:re(M,u.Icon),coreTranslations:te(M)};return{identifier:{id:(0,y.getGalleryExtensionId)(V.publisher.publisherName,V.extensionName),uuid:V.extensionId},name:V.extensionName,version:M.version,displayName:V.displayName,publisherId:V.publisher.publisherId,publisher:V.publisher.publisherName,publisherDisplayName:V.publisher.displayName,publisherDomain:V.publisher.domain?{link:V.publisher.domain,verified:!!V.publisher.isDomainVerified}:void 0,publisherSponsorLink:ne(K),description:V.shortDescription||"",installCount:z(V.statistics,"install"),rating:z(V.statistics,"averagerating"),ratingCount:z(V.statistics,"ratingcount"),categories:V.categories||[],tags:V.tags||[],releaseDate:Date.parse(V.releaseDate),lastUpdated:Date.parse(V.lastUpdated),allTargetPlatforms:G,assets:ee,properties:{dependencies:N(M,m.Dependency),extensionPack:N(M,m.ExtensionPack),engine:j(M),localizedLanguages:_(M),targetPlatform:T(M),isPreReleaseVersion:q(M)},hasPreReleaseVersion:q(K),hasReleaseVersion:!0,preview:k(V.flags)}}let ae=class{constructor(M,G,K,ee,ie,se,ce,ue,ge){this.requestService=G,this.logService=K,this.environmentService=ee,this.telemetryService=ie,this.fileService=se,this.productService=ce,this.configurationService=ue,this.extensionsGalleryConfigService=ge;const he=ce.extensionsGallery;ge&&ge.serviceUrl?this.extensionsGalleryUrl=ge.serviceUrl:this.extensionsGalleryUrl=he&&he.serviceUrl,this.extensionsGalleryConfigService.onConfigChange(this.onUpdateConfigChange,this),this.extensionsControlUrl=he&&he.controlUrl,this.commonHeadersPromise=(0,E.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,M)}onUpdateConfigChange(M){if(this.logService.info("wpl onUpdateConfigChange serverURL:"+M),M)this.extensionsGalleryUrl=M;else{const G=this.productService.extensionsGallery;this.extensionsGalleryUrl=G&&G.serviceUrl}}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,G,K){const ee=I.CancellationToken.isCancellationToken(G)?{}:G,ie=I.CancellationToken.isCancellationToken(G)?G:K,se=[],ce=[],ue=[],ge=[];let he=!0;for(const be of M){be.uuid?ce.push(be.uuid):se.push(be.id);const Ie=!!(be.version||be.preRelease);ue.push({id:be.id,uuid:be.uuid,includePreRelease:Ie}),be.version&&ge.push({id:be.id,uuid:be.uuid,version:be.version}),he=he&&!!be.hasPreRelease&&!Ie}if(!ce.length&&!se.length)return[];let fe=new A().withPage(1,M.length);ce.length&&(fe=fe.withFilter(o.ExtensionId,...ce)),se.length&&(fe=fe.withFilter(o.ExtensionName,...se)),(ee.queryAllVersions||he)&&(fe=fe.withFlags(fe.flags,t.IncludeVersions)),ee.source&&(fe=fe.withSource(ee.source));const{extensions:ye}=await this.queryGalleryExtensions(fe,{targetPlatform:ee.targetPlatform??n,includePreRelease:ue,versions:ge,compatible:!!ee.compatible},ie);return ee.source&&ye.forEach((be,Ie)=>$(be,Ie,ee.source)),ye}async getCompatibleExtension(M,G,K){if((0,g.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible(M,G,K))return M;const ee=new A().withFlags(t.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,M.identifier.uuid),{extensions:ie}=await this.queryGalleryExtensions(ee,{targetPlatform:K,compatible:!0,includePreRelease:G},I.CancellationToken.None);return ie[0]||null}async isExtensionCompatible(M,G,K){if(!(0,g.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,K)||!G&&M.properties.isPreReleaseVersion)return!1;let ee=M.properties.engine;if(!ee){const ie=await this.getManifest(M,I.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");ee=ie.engines.vscode}return(0,w.isEngineValid)(ee,this.productService.version,this.productService.date)}async isValidVersion(M,G,K,ee,ie){if(!(0,g.isTargetPlatformCompatible)(T(M),ee,ie)||G!=="any"&&q(M)!==(G==="prerelease"))return!1;if(K)try{const se=await this.getEngine(M);if(!(0,w.isEngineValid)(se,this.productService.version,this.productService.date))return!1}catch(se){return this.logService.error(`Error while getting the engine for the version ${M.version}.`,(0,P.getErrorMessage)(se)),!1}return!0}async query(M,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let K=M.text||"";const ee=(0,R.getOrDefault)(M,he=>he.pageSize,50);let ie=new A().withPage(1,ee);K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,fe,ye)=>(ie=ie.withFilter(o.Category,ye||fe),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,fe,ye)=>(ie=ie.withFilter(o.Tag,ye||fe),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(o.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),ie=ie.withFilter(o.SearchText,K)),ie=ie.withSortBy(0)):M.ids?ie=ie.withFilter(o.ExtensionId,...M.ids):M.names?ie=ie.withFilter(o.ExtensionName,...M.names):ie=ie.withSortBy(4),typeof M.sortBy=="number"&&(ie=ie.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(ie=ie.withSortOrder(M.sortOrder)),M.source&&(ie=ie.withSource(M.source));const se=async(he,fe)=>{const{extensions:ye,total:be}=await this.queryGalleryExtensions(he,{targetPlatform:n,compatible:!1,includePreRelease:!!M.includePreRelease},fe);return ye.forEach((Ie,Ne)=>$(Ie,(he.pageNumber-1)*he.pageSize+Ne,M.source)),{extensions:ye,total:be}},{extensions:ce,total:ue}=await se(ie,G),ge=async(he,fe)=>{if(fe.isCancellationRequested)throw new P.CancellationError;const{extensions:ye}=await se(ie.withPage(he+1),fe);return ye};return{firstPage:ce,total:ue,pageSize:ie.pageSize,getPage:ge}}async queryGalleryExtensions(M,G,K){const ee=M.flags;!!(M.flags&t.IncludeLatestVersionOnly)&&!!(M.flags&t.IncludeVersions)&&(M=M.withFlags(M.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(M.flags&t.IncludeLatestVersionOnly)&&!(M.flags&t.IncludeVersions)&&(M=M.withFlags(M.flags,t.IncludeLatestVersionOnly)),G.versions?.length&&(M=M.withFlags(M.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),M=M.withFlags(M.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ie,total:se}=await this.queryRawGalleryExtensions(M,K);if(!(M.flags&t.IncludeLatestVersionOnly)){const he=[];for(const fe of ie){const ye=await this.toGalleryExtensionWithCriteria(fe,G);ye&&he.push(ye)}return{extensions:he,total:se}}const ue=[],ge=new Map;for(let he=0;he<ie.length;he++){const fe=ie[he],ye={id:(0,y.getGalleryExtensionId)(fe.publisher.publisherName,fe.extensionName),uuid:fe.extensionId},be=(0,a.isBoolean)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(Ne=>(0,y.areSameExtensions)(Ne,ye))?.includePreRelease;if(G.compatible&&(0,g.isNotWebExtensionInWebTargetPlatform)(F(fe),G.targetPlatform))continue;const Ie=await this.toGalleryExtensionWithCriteria(fe,G);!Ie||Ie.properties.isPreReleaseVersion&&(!be||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==G.targetPlatform&&Ie.hasPreReleaseVersion?ge.set(fe.extensionId,he):ue.push([he,Ie])}if(ge.size){const he=new Date().getTime(),fe=new A().withFlags(ee&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(o.ExtensionId,...ge.keys()),{extensions:ye}=await this.queryGalleryExtensions(fe,G,K);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-he,count:ge.size});for(const be of ye){const Ie=ge.get(be.identifier.uuid);ue.push([Ie,be])}}return{extensions:ue.sort((he,fe)=>he[0]-fe[0]).map(([,he])=>he),total:se}}async toGalleryExtensionWithCriteria(M,G){const K={id:(0,y.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},ee=G.versions?.find(ue=>(0,y.areSameExtensions)(ue,K))?.version,ie=(0,a.isBoolean)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(ue=>(0,y.areSameExtensions)(ue,K))?.includePreRelease,se=F(M),ce=x(M.versions,G.targetPlatform);if(G.compatible&&(0,g.isNotWebExtensionInWebTargetPlatform)(se,G.targetPlatform))return null;for(let ue=0;ue<ce.length;ue++){const ge=ce[ue];if(!(ee&&ge.version!==ee)){if(await this.isValidVersion(ge,ie?"any":"release",G.compatible,se,G.targetPlatform))return B(M,ge,se);if(ee&&ge.version===ee)return null}}return ee||G.compatible?null:B(M,M.versions[0],se)}async queryRawGalleryExtensions(M,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,t.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,r(t.Unpublished));const K=await this.commonHeadersPromise,ee=JSON.stringify(M.raw),ie={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},se=new Date().getTime();let ce,ue,ge=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ee,headers:ie},G),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:ge};const he=await(0,f.asJson)(ce);if(he){const fe=he.results[0],ye=fe.extensions,be=fe.resultMetadata&&fe.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return ge=be&&be.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ge}}return{galleryExtensions:[],total:ge}}catch(he){throw ue=he,he}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(ee.length),duration:new Date().getTime()-se,success:!!ce&&(0,f.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:ue?(0,P.isCancellationError)(ue)?"canceled":(0,P.getErrorMessage)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ge)})}}async reportStatistic(M,G,K,ee){if(!this.isEnabled())return;const ie=O.isWeb?this.api(`/itemName/${M}.${G}/version/${K}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${G}/${K}/stats?statType=${ee}`),se=O.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:ie,headers:ue},I.CancellationToken.None)}catch{}}async download(M,G,K){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const ee=(0,y.getGalleryExtensionTelemetryData)(M),ie=new Date().getTime(),se=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ee,duration:he}),ce=K===2?"install":K===3?"update":"",ue=ce?{uri:`${M.assets.download.uri}${h.URI.parse(M.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${M.assets.download.fallbackUri}${h.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:M.assets.download,ge=await this.getAsset(ue);await this.fileService.writeFile(G,ge.stream),se(new Date().getTime()-ie)}async getReadme(M,G){if(M.assets.readme){const K=await this.getAsset(M.assets.readme,{},G);return await(0,f.asTextOrError)(K)||""}return""}async getManifest(M,G){if(M.assets.manifest){const K=await this.getAsset(M.assets.manifest,{},G),ee=await(0,f.asTextOrError)(K);return ee?JSON.parse(ee):null}return null}async getManifestFromRawExtensionVersion(M,G){const K=re(M,u.Manifest);if(!K)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},ie=await this.getAsset(K,{headers:ee});return await(0,f.asJson)(ie)}async getCoreTranslation(M,G){const K=M.assets.coreTranslations.filter(ee=>ee[0]===G.toUpperCase())[0];if(K){const ee=await this.getAsset(K[1]),ie=await(0,f.asTextOrError)(ee);return ie?JSON.parse(ie):null}return null}async getChangelog(M,G){if(M.assets.changelog){const K=await this.getAsset(M.assets.changelog,{},G);return await(0,f.asTextOrError)(K)||""}return""}async getAllCompatibleVersions(M,G,K){let ee=new A().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?ee=ee.withFilter(o.ExtensionId,M.identifier.uuid):ee=ee.withFilter(o.ExtensionName,M.identifier.id);const{galleryExtensions:ie}=await this.queryRawGalleryExtensions(ee,I.CancellationToken.None);if(!ie.length)return[];const se=F(ie[0]);if((0,g.isNotWebExtensionInWebTargetPlatform)(se,K))return[];const ce=[];await Promise.all(ie[0].versions.map(async he=>{try{await this.isValidVersion(he,G?"any":"release",!0,se,K)&&ce.push(he)}catch{}}));const ue=[],ge=new Set;for(const he of x(ce,K))ge.has(he.version)||(ge.add(he.version),ue.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:q(he)}));return ue}async getAsset(M,G={},K=I.CancellationToken.None){const ee=await this.commonHeadersPromise,ie={type:"GET"},se={...ee,...G.headers||{}};G={...G,...ie,headers:se};const ce=M.uri,ue=M.fallbackUri,ge={...G,url:ce};try{const he=await this.requestService.request(ge,K);if(he.res.statusCode===200)return he;const fe=await(0,f.asTextOrError)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${fe}`)}catch(he){if((0,P.isCancellationError)(he))throw he;const fe=(0,P.getErrorMessage)(he);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:fe});const ye={...G,url:ue};return this.requestService.request(ye,K)}}async getEngine(M){let G=j(M);if(!G){const K=await this.getManifestFromRawExtensionVersion(M,I.CancellationToken.None);if(!K)throw new Error("Manifest was not found");G=K.engines.vscode}return G}async getExtensionsControlManifest1(M){const G=[],K={},ee=[];if(M){for(const ie of M.malicious)G.push({id:ie});if(M.migrateToPreRelease)for(const[ie,se]of Object.entries(M.migrateToPreRelease))(!se.engine||(0,w.isEngineValid)(se.engine,this.productService.version,this.productService.date))&&(K[ie.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[ie,se]of Object.entries(M.deprecated))se&&(K[ie.toLowerCase()]=(0,a.isBoolean)(se)?{}:se);if(M.search)for(const ie of M.search)ee.push(ie)}return{malicious:G,deprecated:K,search:ee}}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl){let K=this.productService.extensionsControlManifest;return this.getExtensionsControlManifest1(K)}const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const G=await(0,f.asJson)(M);return this.getExtensionsControlManifest1(G)}};ae=me([le(1,f.IRequestService),le(2,S.ILogService),le(3,L.IEnvironmentService),le(4,s.ITelemetryService),le(5,d.IFileService),le(6,l.IProductService),le(7,D.IConfigurationService),le(8,e.IExtensionsGalleryConfigService)],ae);let Y=class extends ae{constructor(M,G,K,ee,ie,se,ce,ue,ge){super(M,G,K,ee,ie,se,ce,ue,ge)}};i.ExtensionGalleryService=Y,i.ExtensionGalleryService=Y=me([le(0,c.IStorageService),le(1,f.IRequestService),le(2,S.ILogService),le(3,L.IEnvironmentService),le(4,s.ITelemetryService),le(5,d.IFileService),le(6,l.IProductService),le(7,D.IConfigurationService),le(8,e.IExtensionsGalleryConfigService)],Y);let ve=class extends ae{constructor(M,G,K,ee,ie,se,ce,ue){super(void 0,M,G,K,ee,ie,se,ce,ue)}};i.ExtensionGalleryServiceWithNoStorageService=ve,i.ExtensionGalleryServiceWithNoStorageService=ve=me([le(0,f.IRequestService),le(1,S.ILogService),le(2,L.IEnvironmentService),le(3,s.ITelemetryService),le(4,d.IFileService),le(5,l.IProductService),le(6,D.IConfigurationService),le(7,e.IExtensionsGalleryConfigService)],ve)}),define(Q[136],Z([0,1,2,22,50,8,26,97,20,36,137,27,30,31,38]),function(W,i,C,I,P,R,O,v,a,h,D,L,g,y,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let d=class{constructor(f,E,c){this._configurationService=E,this._productService=c,this._experimentProperties={},this.telemetryLevel=new P.MutableObservableValue(3),this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(f,E){this._experimentProperties[f]=E}_updateTelemetryLevel(){let f=(0,w.getTelemetryLevel)(this._configurationService);const E=this._productService.enabledTelemetryLevels;if(E){this._sendErrorTelemetry=this.sendErrorTelemetry?E.error:!1;const c=E.usage?3:E.error?2:0;f=Math.min(f,c)}this.telemetryLevel.value=f}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const f=await this._commonProperties;let E=f.sessionID,c=f["common.machineId"],s=f["common.firstSessionDate"],e=f["common.msftInternal"];return{sessionId:E,machineId:c,firstSessionDate:s,msftInternal:e}}dispose(){this._disposables.dispose()}_log(f,E,c,s){return this.telemetryLevel.value<E?Promise.resolve(void 0):this._commonProperties.then(e=>{c=(0,I.mixin)(c,e),c=(0,I.mixin)(c,this._experimentProperties),c=(0,I.cloneAndChange)(c,n=>{if(typeof n=="string")return this._cleanupInfo(n,s)}),this._appenders.forEach(n=>n.log(f,c))},e=>{console.error(e)})}publicLog(f,E,c){return this._log(f,3,E,c)}publicLog2(f,E,c){return this.publicLog(f,E,c)}publicLogError(f,E){return this._sendErrorTelemetry?this._log(f,2,E,!0):Promise.resolve(void 0)}publicLogError2(f,E){return this.publicLogError(f,E)}_anonymizeFilePaths(f){let E=f;const c=[];for(let t of this._cleanupPatterns)for(;;){const r=t.exec(f);if(!r)break;c.push([r.index,t.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,e=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let n=0;for(E="";;){const t=e.exec(f);if(!t)break;!s.test(t[0])&&c.every(([r,o])=>t.index<r||t.index>=o)&&(E+=f.substring(n,t.index)+"<REDACTED: user-file-path>",n=e.lastIndex)}return n<f.length&&(E+=f.substr(n)),E}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const E=f.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const s of c)if(s.regex.test(E))return`<REDACTED: ${s.label}>`;return f}_cleanupInfo(f,E){let c=f;E&&(c=this._anonymizeFilePaths(c));for(let s of this._cleanupPatterns)c=c.replace(s,"");return c=this._removePropertiesWithPossibleUserInfo(c),c}};i.TelemetryService=d,d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",i.TelemetryService=d=me([le(1,a.IConfigurationService),le(2,L.IProductService)],d);function S(){const l=(0,v.localize)(0,null,D.default.nameLong),f=D.default.privacyStatementUrl?(0,v.localize)(2,null,"https://aka.ms/vscode-telemetry",D.default.privacyStatementUrl):(0,v.localize)(1,null,"https://aka.ms/vscode-telemetry"),E=R.isWeb?"":(0,v.localize)(3,null),c=(0,v.localize)(4,null),s=(0,v.localize)(5,null),e=(0,v.localize)(6,null),n=(0,v.localize)(7,null),t=`
|       | ${c} | ${s} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,v.localize)(8,null);return`
${l} ${f} ${E}

&nbsp;

${n}
${t}

&nbsp;

${r}
`}g.Registry.as(h.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,v.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,v.localize)(10,null),(0,v.localize)(11,null),(0,v.localize)(12,null),(0,v.localize)(13,null)],markdownDescription:S(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),g.Registry.as(h.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,v.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:D.default.privacyStatementUrl?(0,v.localize)(16,null,D.default.nameLong,D.default.privacyStatementUrl):(0,v.localize)(15,null,D.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,v.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[138],Z([0,1,10,22,38]),function(W,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function R(v){const a=await new Promise((D,L)=>{W(["applicationinsights"],D,L)});let h;return a.defaultClient?(h=new a.TelemetryClient(v),h.channel.setUseDiskRetryCaching(!0)):(a.setup(v).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),h=a.defaultClient),v.indexOf("AIF-")===0&&(h.config.endpointUrl="https://0.0.0.0/collect/v1"),h}class O{constructor(a,h,D){this._eventPrefix=a,this._defaultData=h,this._defaultData||(this._defaultData=Object.create(null)),typeof D=="function"?this._aiClient=D():this._aiClient=D,this._asyncAIClient=null}_withAIClient(a){if(!!this._aiClient){if(typeof this._aiClient!="string"){a(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(h=>{a(h)},h=>{(0,C.onUnexpectedError)(h),console.error(h)})}}log(a,h){if(!!this._aiClient){h=(0,I.mixin)(h,this._defaultData),h=(0,P.validateTelemetryData)(h);try{this._withAIClient(D=>D.trackEvent({name:this._eventPrefix+"/"+a,properties:h.properties,measurements:h.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(a=>{this._withAIClient(h=>{try{h.flush({callback:()=>{this._aiClient=void 0,a(void 0)}})}catch{}})}):Promise.resolve(void 0)}}i.AppInsightsAppender=O}),define(Q[139],Z([0,1,13,19]),function(W,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function P(R,O){const v=Object.create(null),a=(D,L)=>{const g=JSON.parse(D);v[L]=g};if(O){const D=[],L=await I.Promises.readdir(O);for(const y of L)try{(await I.Promises.stat((0,C.join)(O,y))).isDirectory()&&D.push(y)}catch{}const g=[];for(const y of D)(await I.Promises.readdir((0,C.join)(O,y))).filter(d=>d==="telemetry.json").length===1&&g.push(y);for(const y of g){const w=(await I.Promises.readFile((0,C.join)(O,y,"telemetry.json"))).toString();a(w,y)}}let h=(await I.Promises.readFile((0,C.join)(R,"telemetry-core.json"))).toString();return a(h,"vscode-core"),h=(await I.Promises.readFile((0,C.join)(R,"telemetry-extensions.json"))).toString(),a(h,"vscode-extensions"),JSON.stringify(v,null,4)}i.buildTelemetryMessage=P}),define(Q[39],Z([0,1,9]),function(W,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(Q[140],Z([0,1,3,2,11,21,25,15,12,39]),function(W,i,C,I,P,R,O,v,a,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let D=class extends I.Disposable{constructor(g,y,w,d,S){super();this.extensionsManagementService=g,this.logService=d,this.uriIdentityService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(f=>{this.installedExtensions=f.map(E=>E.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(f=>this.onInstallExtension(f))),this._register(g.onDidInstallExtensions(f=>this.onDidInstallExtensions(f))),this._register(g.onDidUninstallExtension(f=>this.onDidUninstallExtension(f)));const l=P.URI.file(w.extensionsPath);this._register(y.watch(l)),this._register(C.Event.filter(y.onDidFilesChange,f=>f.rawChanges.some(E=>this.doesChangeAffects(E,l)))(()=>this.onDidChange()))}doesChangeAffects(g,y){return g.type!==1&&g.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(g.resource),y)?!1:this.uriIdentityService.extUri.isEqual(g.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(g.resource).startsWith(".")}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const y of g)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(y=>!(0,O.areSameExtensions)(y,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,O.areSameExtensions)(y,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(),y=g.filter(d=>[...this.installingExtensions,...this.installedExtensions].some(S=>(0,O.areSameExtensions)(S,d.identifier))?!1:d.installedTimestamp&&d.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",d.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",d.identifier.id),!1)),w=this.installedExtensions.filter(d=>this.installingExtensions.some(S=>(0,O.areSameExtensions)(S,d))?!1:g.every(S=>!(0,O.areSameExtensions)(S.identifier,d))?(this.logService.info("Detected extension removed from another source",d.id),!0):!1);this.installedExtensions=g.map(d=>d.identifier),(y.length||w.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:w})}}};i.ExtensionsWatcher=D,i.ExtensionsWatcher=D=me([le(1,v.IFileService),le(2,R.INativeEnvironmentService),le(3,a.ILogService),le(4,h.IUriIdentityService)],D)}),define(Q[141],Z([0,1,39,102,15,18,66,3,2]),function(W,i,C,I,P,R,O,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class h{constructor(g){this.uri=g,this.time=h._clock++}touch(){return this.time=h._clock++,this}}h._clock=0;let D=class{constructor(g){this._fileService=g,this._dispooables=new a.DisposableStore,this._limit=2**16;const y=new Map,w=d=>{let S=y.get(d.scheme);return S===void 0&&(S=g.hasProvider(d)&&!this._fileService.hasCapability(d,1024),y.set(d.scheme,S)),S};this._dispooables.add(v.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(d=>{y.delete(d.scheme)})),this.extUri=new R.ExtUri(w),this._canonicalUris=new O.SkipList((d,S)=>this.extUri.compare(d,S,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,R.normalizePath)(g));let y=this._canonicalUris.get(g);return y?y.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new h(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((w,d)=>w[1].touch<d[1].touch?1:w[1].touch>d[1].touch?-1:0);h._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let w=0;w<y;w++)this._canonicalUris.set(g[w][0],g[w][1].touch())}};i.UriIdentityService=D,i.UriIdentityService=D=me([le(0,P.IFileService)],D),(0,I.registerSingleton)(C.IUriIdentityService,D,!0)}),define(Q[142],Z([0,1,33,4,153,2]),function(W,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativePolicyService=void 0;class O extends C.AbstractPolicyService{constructor(a){super();this.productName=a,this.throttler=new I.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(a){await this.throttler.queue(()=>new Promise((h,D)=>{try{this.watcher.value=(0,P.createWatcher)(this.productName,a,L=>{for(const g in L){const y=L[g];y===void 0?this.policies.delete(g):this.policies.set(g,y)}this._onDidChange.fire(Object.keys(L)),h()})}catch(L){D(L)}}))}}i.NativePolicyService=O}),define(Q[64],Z([0,1,113,4,13,7,19,81,154,155]),function(W,i,C,I,P,R,O,v,a,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class D extends Error{constructor(e,n){let t=n.message;switch(e){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t);this.type=e,this.cause=n}}i.ExtractError=D;function L(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,t)=>n+t,e&61440)}function g(s){if(s instanceof D)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new D(e,s)}function y(s,e,n,t,r,o){const u=P.dirname(e),m=P.join(t,u);if(!m.startsWith(t))return Promise.reject(new Error(v.localize(0,null,e)));const p=P.join(t,e);let b;return o.onCancellationRequested(()=>{b&&b.destroy()}),Promise.resolve(O.Promises.mkdir(m,{recursive:!0})).then(()=>new Promise((A,z)=>{if(!o.isCancellationRequested)try{b=(0,C.createWriteStream)(p,{mode:n}),b.once("close",()=>A()),b.once("error",z),s.once("error",z),s.pipe(b)}catch(te){z(te)}}))}function w(s,e,n,t){let r=(0,I.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((u,m)=>{const p=new I.Sequencer,b=A=>{A.isCancellationRequested||(o++,s.readEntry())};s.once("error",m),s.once("close",()=>r.then(()=>{t.isCancellationRequested||s.entryCount===o?u():m(new D("Incomplete",new Error(v.localize(1,null,o,s.entryCount))))},m)),s.readEntry(),s.on("entry",A=>{if(t.isCancellationRequested)return;if(!n.sourcePathRegex.test(A.fileName)){b(t);return}const z=A.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(z)){const oe=P.join(e,z);r=(0,I.createCancelablePromise)(re=>O.Promises.mkdir(oe,{recursive:!0}).then(()=>b(re)).then(void 0,m));return}const te=S(s,A),J=L(A);r=(0,I.createCancelablePromise)(oe=>p.queue(()=>te.then(re=>y(re,z,J,e,n,oe).then(()=>b(oe)))).then(null,m))})})}function d(s,e=!1){return new Promise((n,t)=>{(0,a.open)(s,e?{lazyEntries:!0}:void 0,(r,o)=>{r?t(g(r)):n((0,R.assertIsDefined)(o))})})}function S(s,e){return new Promise((n,t)=>{s.openReadStream(e,(r,o)=>{r?t(g(r)):n((0,R.assertIsDefined)(o))})})}function l(s,e){return new Promise((n,t)=>{const r=new h.ZipFile;e.forEach(u=>{u.contents?r.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&r.addFile(u.localPath,u.path)}),r.end();const o=(0,C.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>n(s))})}i.zip=l;function f(s,e,n={},t){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=d(s,!0);return n.overwrite&&(o=o.then(u=>O.Promises.rm(e).then(()=>u))),o.then(u=>w(u,e,{sourcePathRegex:r},t))}i.extract=f;function E(s,e){return d(s).then(n=>new Promise((t,r)=>{n.on("entry",o=>{o.fileName===e&&S(n,o).then(u=>t(u),u=>r(u))}),n.once("close",()=>r(new Error(v.localize(2,null,e))))}))}function c(s,e){return E(s,e).then(n=>new Promise((t,r)=>{const o=[];n.once("error",r),n.on("data",u=>o.push(u)),n.on("end",()=>t(Buffer.concat(o)))}))}i.buffer=c}),define(Q[143],Z([0,1,64,88]),function(W,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function P(R){return(0,C.buffer)(R,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,I.localize)(0,null))}})}i.getManifest=P}),define(Q[144],Z([0,1,4,28,10,2,14,13,8,18,35,7,11,32,19,64,87,55,21,133,23,25,46,123,108,143,124,140,44,15,9,12,27,31,39]),function(W,i,C,I,P,R,O,v,a,h,D,L,g,y,w,d,S,l,f,E,c,s,e,n,t,r,o,u,m,p,b,A,z,te,J){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let oe=class extends E.AbstractExtensionManagementService{constructor(k,T,F,x,$,B,ae,Y,ve){super(k,T,F,Y);this.environmentService=x,this.downloadService=$,this.fileService=ae;const V=this._register(B.createInstance(t.ExtensionsLifecycle));this.extensionsScanner=this._register(B.createInstance(re,G=>V.postUninstall(G))),this.manifestCache=this._register(new o.ExtensionsManifestCache(x,this)),this.extensionsDownloader=this._register(B.createInstance(n.ExtensionsDownloader));const M=this._register(new u.ExtensionsWatcher(this,ae,x,F,ve));this._register(M.onDidChangeExtensionsByAnotherSource(({added:G,removed:K})=>{G.length&&this._onDidInstallExtensions.fire(G.map(ee=>({identifier:ee.identifier,operation:1,local:ee}))),K.forEach(ee=>this._onDidUninstallExtension.fire({identifier:ee}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(k){this.logService.trace("ExtensionManagementService#zip",k.identifier.id);const T=await this.collectFiles(k),F=await(0,d.zip)((0,h.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)()).fsPath,T);return g.URI.file(F)}async unzip(k){return this.logService.trace("ExtensionManagementService#unzip",k.toString()),(await this.install(k)).identifier}async getManifest(k){const T=await this.downloadVsix(k),F=v.resolve(T.fsPath);return(0,r.getManifest)(F)}getInstalled(k=null){return this.extensionsScanner.scanExtensions(k)}async install(k,T={}){this.logService.trace("ExtensionManagementService#install",k.toString());const F=await this.downloadVsix(k),x=await(0,r.getManifest)(v.resolve(F.fsPath));if(x.engines&&x.engines.vscode&&!(0,m.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(S.localize(0,null,(0,s.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return this.installExtension(x,F,T)}async updateMetadata(k,T){this.logService.trace("ExtensionManagementService#updateMetadata",k.identifier.id);const F={...T};return T.isPreReleaseVersion&&(F.preRelease=!0),k=await this.extensionsScanner.updateMetadata(k,F),this.manifestCache.invalidate(),k}async updateExtensionScope(k,T){return this.logService.trace("ExtensionManagementService#updateExtensionScope",k.identifier.id),k=await this.extensionsScanner.updateMetadata(k,{isMachineScoped:T}),this.manifestCache.invalidate(),k}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(k){if(k.scheme===O.Schemas.file)return k;const T=(0,h.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)());return await this.downloadService.download(k,T),T}createInstallExtensionTask(k,T,F){return g.URI.isUri(T)?new q(k,T,F,this.galleryService,this.extensionsScanner,this.logService):new j(T,F,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(k,T){return new _(k,T,this.extensionsScanner)}async collectFiles(k){const T=async x=>{let $=await w.Promises.readdir(x);$=$.map(Y=>v.join(x,Y));const B=await Promise.all($.map(Y=>w.Promises.stat(Y)));let ae=Promise.resolve([]);return B.forEach((Y,ve)=>{const V=$[ve];Y.isFile()&&(ae=ae.then(M=>[...M,V])),Y.isDirectory()&&(ae=ae.then(M=>T(V).then(G=>[...M,...G])))}),ae};return(await T(k.location.fsPath)).map(x=>({path:`extension/${v.relative(k.location.fsPath,x)}`,localPath:x}))}};i.ExtensionManagementService=oe,i.ExtensionManagementService=oe=me([le(0,c.IExtensionGalleryService),le(1,te.ITelemetryService),le(2,A.ILogService),le(3,f.INativeEnvironmentService),le(4,l.IDownloadService),le(5,b.IInstantiationService),le(6,p.IFileService),le(7,z.IProductService),le(8,J.IUriIdentityService)],oe);let re=class extends R.Disposable{constructor(k,T,F,x){super();this.beforeRemovingExtension=k,this.fileService=T,this.extensionsScannerService=F,this.logService=x,this.uninstalledPath=(0,h.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new C.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(k){const T={includeInvalid:!0};let F=[];return k===null||k===0?F.push(...await this.extensionsScannerService.scanAllExtensions(T)):k===1&&F.push(...await this.extensionsScannerService.scanUserExtensions(T)),F=k!==null?F.filter(x=>x.type===k):F,Promise.all(F.map(x=>this.toLocalExtension(x)))}async scanUserExtensions(k){const T=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!k,includeInvalid:!0});return Promise.all(T.map(F=>this.toLocalExtension(F)))}async extractUserExtension(k,T,F,x){const $=k.toString(),B=v.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),ae=v.join(this.extensionsScannerService.userExtensionsLocation.fsPath,$);try{await w.Promises.rm(ae)}catch{throw new c.ExtensionManagementError(S.localize(1,null,ae,k.id),c.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(k,T,B,x),await this.extensionsScannerService.updateMetadata(g.URI.file(B),{...F,installedTimestamp:Date.now()});try{await this.rename(k,B,ae,Date.now()+2*60*1e3),this.logService.info("Renamed to",ae)}catch(Y){try{await w.Promises.rm(B)}catch{}if(Y.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",k.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(Y)}. Deleted from extracted location`,B),Y}return this.scanLocalExtension(g.URI.file(ae),1)}async updateMetadata(k,T){return await this.extensionsScannerService.updateMetadata(k.location,T),this.scanLocalExtension(k.location,k.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...k){const T=k.map(F=>s.ExtensionKey.create(F));await this.withUninstalledExtensions(F=>{T.forEach(x=>F[x.toString()]=!0)})}async setInstalled(k){await this.withUninstalledExtensions(x=>delete x[k.toString()]);const F=(await this.scanUserExtensions(!0)).find(x=>s.ExtensionKey.create(x).equals(k))||null;return F?this.updateMetadata(F,{installedTimestamp:Date.now()}):null}async removeExtension(k,T){this.logService.trace(`Deleting ${T} extension from disk`,k.identifier.id,k.location.fsPath),await w.Promises.rm(k.location.fsPath),this.logService.info("Deleted from disk",k.identifier.id,k.location.fsPath)}async removeUninstalledExtension(k){await this.removeExtension(k,"uninstalled"),await this.withUninstalledExtensions(T=>delete T[s.ExtensionKey.create(k).toString()])}async withUninstalledExtensions(k){return this.uninstalledFileLimiter.queue(async()=>{let T;try{T=await w.Promises.readFile(this.uninstalledPath,"utf8")}catch(x){if(x.code!=="ENOENT")throw x}let F={};if(T)try{F=JSON.parse(T)}catch{}return k&&(k(F),Object.keys(F).length?await w.Promises.writeFile(this.uninstalledPath,JSON.stringify(F)):await w.Promises.rm(this.uninstalledPath)),F})}async extractAtLocation(k,T,F,x){this.logService.trace(`Started extracting the extension from ${T} to ${F}`);try{await w.Promises.rm(F)}catch($){throw new c.ExtensionManagementError(this.joinErrors($).message,c.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(T,F,{sourcePath:"extension",overwrite:!0},x),this.logService.info(`Extracted extension to ${F}:`,k.id)}catch($){try{await w.Promises.rm(F)}catch{}let B=c.ExtensionManagementErrorCode.Extract;throw $ instanceof d.ExtractError&&($.type==="CorruptZip"?B=c.ExtensionManagementErrorCode.CorruptZip:$.type==="Incomplete"&&(B=c.ExtensionManagementErrorCode.IncompleteZip)),new c.ExtensionManagementError($.message,B)}}async rename(k,T,F,x){try{await w.Promises.rename(T,F)}catch($){if(a.isWindows&&$&&$.code==="EPERM"&&Date.now()<x)return this.logService.info(`Failed renaming ${T} to ${F} with 'EPERM' error. Trying again...`,k.id),this.rename(k,T,F,x);throw new c.ExtensionManagementError($.message||S.localize(2,null,T,F),$.code||c.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(k,T){const F=await this.extensionsScannerService.scanExistingExtension(k,T,{includeInvalid:!0});if(F)return this.toLocalExtension(F);throw new Error(S.localize(3,null,k.path))}async toLocalExtension(k){const T=await this.fileService.resolve(k.location);let F,x;return T.children&&(F=T.children.find(({name:$})=>/^readme(\.txt|\.md|)$/i.test($))?.resource,x=T.children.find(({name:$})=>/^changelog(\.txt|\.md|)$/i.test($))?.resource),{identifier:k.identifier,type:k.type,isBuiltin:k.isBuiltin||!!k.metadata?.isBuiltin,location:k.location,manifest:k.manifest,targetPlatform:k.targetPlatform,validations:k.validations,isValid:k.isValid,readmeUrl:F,changelogUrl:x,publisherDisplayName:k.metadata?.publisherDisplayName||null,publisherId:k.metadata?.publisherId||null,isMachineScoped:!!k.metadata?.isMachineScoped,isPreReleaseVersion:!!k.metadata?.isPreReleaseVersion,preRelease:!!k.metadata?.preRelease,installedTimestamp:k.metadata?.installedTimestamp,updated:!!k.metadata?.updated}}async removeUninstalledExtensions(){const k=await this.getUninstalledExtensions(),T=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),F=new Set;for(const B of T)k[s.ExtensionKey.create(B).toString()]||F.add(B.identifier.id.toLowerCase());const x=(0,s.groupByExtension)(T,B=>B.identifier);await C.Promises.settled(x.map(async B=>{const ae=B.sort((Y,ve)=>D.rcompare(Y.manifest.version,ve.manifest.version))[0];F.has(ae.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(ae))}));const $=T.filter(B=>k[s.ExtensionKey.create(B).toString()]);await C.Promises.settled($.map(B=>this.removeUninstalledExtension(B)))}async removeOutdatedExtensions(){const k=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=[],F=await this.extensionsScannerService.getTargetPlatform(),x=(0,s.groupByExtension)(k,$=>$.identifier);T.push(...x.map($=>$.sort((B,ae)=>{const Y=D.rcompare(B.manifest.version,ae.manifest.version);return Y!==0?Y:B.targetPlatform===F?-1:1}).slice(1)).flat()),await C.Promises.settled(T.map($=>this.removeExtension($,"outdated")))}joinErrors(k){const T=Array.isArray(k)?k:[k];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((F,x)=>new Error(`${F.message}${F.message?",":""}${x instanceof Error?x.message:x}`),new Error(""))}};re=me([le(1,p.IFileService),le(2,e.IExtensionsScannerService),le(3,A.ILogService)],re);class N extends E.AbstractExtensionTask{get operation(){return(0,L.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(k,T,F,x,$){super();this.identifier=k,this.source=T,this.options=F,this.extensionsScanner=x,this.logService=$,this._operation=2}async installExtension(k,T){try{const F=await this.unsetUninstalledAndGetLocal(k.key);if(F)return k.metadata?this.extensionsScanner.updateMetadata(F,k.metadata):F}catch{throw a.isMacintosh?new c.ExtensionManagementError(S.localize(4,null),c.ExtensionManagementErrorCode.Internal):new c.ExtensionManagementError(S.localize(5,null),c.ExtensionManagementErrorCode.Internal)}return this.extract(k,T)}async unsetUninstalledAndGetLocal(k){if(!await this.isUninstalled(k))return null;this.logService.trace("Removing the extension from uninstalled list:",k.id);const F=await this.extensionsScanner.setInstalled(k);return this.logService.info("Removed the extension from uninstalled list:",k.id),F}async isUninstalled(k){return!!(await this.extensionsScanner.getUninstalledExtensions())[k.toString()]}async extract({zipPath:k,key:T,metadata:F},x){let $=await this.extensionsScanner.extractUserExtension(T,k,F,x);return this.logService.info("Extracting completed.",T.id),$}}class j extends N{constructor(k,T,F,x,$){super(k.identifier,k,T,x,$);this.gallery=k,this.extensionsDownloader=F}async doRun(k){const F=(await this.extensionsScanner.scanExtensions(null)).find($=>(0,s.areSameExtensions)($.identifier,this.gallery.identifier));F&&(this._operation=3);const x=await this.downloadInstallableExtension(this.gallery,this._operation);x.metadata.isMachineScoped=this.options.isMachineScoped||F?.isMachineScoped,x.metadata.isBuiltin=this.options.isBuiltin||F?.isBuiltin,x.metadata.isSystem=F?.type===0?!0:void 0,x.metadata.updated=!!F,x.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,x.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,L.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:F?.preRelease);try{const $=await this.installExtension(x,k);return F&&(F.targetPlatform!==$.targetPlatform||D.neq(F.manifest.version,$.manifest.version))&&await this.extensionsScanner.setUninstalled(F),$}catch($){throw await this.deleteDownloadedVSIX(x.zipPath),$}}async deleteDownloadedVSIX(k){try{await this.extensionsDownloader.delete(g.URI.file(k))}catch(T){this.logService.warn("Error while deleting the downloaded vsix",k.toString(),(0,P.getErrorMessage)(T))}}async downloadInstallableExtension(k,T){const F={id:k.identifier.uuid,publisherId:k.publisherId,publisherDisplayName:k.publisherDisplayName,targetPlatform:k.properties.targetPlatform};let x;try{this.logService.trace("Started downloading extension:",k.identifier.id),x=(await this.extensionsDownloader.downloadExtension(k,T)).fsPath,this.logService.info("Downloaded extension:",k.identifier.id,x)}catch($){throw new c.ExtensionManagementError((0,E.joinErrors)($).message,c.ExtensionManagementErrorCode.Download)}try{return await(0,r.getManifest)(x),{zipPath:x,key:s.ExtensionKey.create(k),metadata:F}}catch($){throw await this.deleteDownloadedVSIX(x),new c.ExtensionManagementError((0,E.joinErrors)($).message,c.ExtensionManagementErrorCode.Invalid)}}}class q extends N{constructor(k,T,F,x,$,B){super({id:(0,s.getGalleryExtensionId)(k.publisher,k.name)},T,F,$,B);this.manifest=k,this.location=T,this.galleryService=x}async doRun(k){const T=new s.ExtensionKey(this.identifier,this.manifest.version),x=(await this.extensionsScanner.scanExtensions(1)).find(B=>(0,s.areSameExtensions)(this.identifier,B.identifier)),$=await this.getMetadata(this.identifier.id,this.manifest.version,k);if($.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,$.isBuiltin=this.options.isBuiltin||x?.isBuiltin,x)if(this._operation=3,T.equals(new s.ExtensionKey(x.identifier,x.manifest.version)))try{await this.extensionsScanner.removeExtension(x,"existing")}catch{throw new Error(S.localize(6,null,this.manifest.displayName||this.manifest.name))}else D.gt(x.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(x);else{const B=await this.unsetUninstalledAndGetLocal(T);if(B)try{await this.extensionsScanner.removeExtension(B,"existing")}catch{throw new Error(S.localize(7,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:v.resolve(this.location.fsPath),key:T,metadata:$},k)}async getMetadata(k,T,F){try{let[x]=await this.galleryService.getExtensions([{id:k,version:T}],F);if(x||([x]=await this.galleryService.getExtensions([{id:k}],F)),x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId,isPreReleaseVersion:x.properties.isPreReleaseVersion,preRelease:x.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class _ extends E.AbstractExtensionTask{constructor(k,T,F){super();this.extension=k,this.options=T,this.extensionsScanner=F}async doRun(k){const T=[],F=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const x=s.ExtensionKey.create(this.extension);T.push(...F.filter($=>x.equals(s.ExtensionKey.create($))))}else T.push(...F.filter(x=>(0,s.areSameExtensions)(x.identifier,this.extension.identifier)));if(!T.length)throw new Error(S.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...T),this.options.remove)for(const x of T)try{k.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(x)}catch($){throw new Error(S.localize(9,null,(0,I.toErrorMessage)($)))}}}}),define(Q[145],Z([0,1,129,4,16,10,2,7,20,21,130,12,128,156]),function(W,i,C,I,P,R,O,v,a,h,D,L,g,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let w=class extends O.Disposable{constructor(S,l,f){super();this.environmentService=l,this.logService=f,this.configure(S.getValue()),this._register(S.onDidChangeConfiguration(()=>this.configure(S.getValue()),this))}configure(S){this.proxyUrl=S.http&&S.http.proxy,this.strictSSL=!!(S.http&&S.http.proxyStrictSSL),this.authorization=S.http&&S.http.proxyAuthorization}async request(S,l){this.logService.trace("RequestService#request (node) - begin",S.url);const{proxyUrl:f,strictSSL:E}=this;let c;try{c=await(0,D.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...c},e=S.agent?S.agent:await(0,g.getProxyAgent)(S.url||"",s,{proxyUrl:f,strictSSL:E});S.agent=e,S.strictSSL=E,this.authorization&&(S.headers={...S.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(S,l);return this.logService.trace("RequestService#request (node) - success",S.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",S.url,n),n}}async getNodeRequest(S){return((0,C.parse)(S.url).protocol==="https:"?await new Promise((E,c)=>{W(["https"],E,c)}):await new Promise((E,c)=>{W(["http"],E,c)})).request}_request(S,l){return I.Promises.withAsyncBody(async(f,E)=>{let c;const s=(0,C.parse)(S.url),e=S.getRawRequest?S.getRawRequest(S):await this.getNodeRequest(S),n={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:S.type||"GET",headers:S.headers,agent:S.agent,rejectUnauthorized:(0,v.isBoolean)(S.strictSSL)?S.strictSSL:!0};S.user&&S.password&&(n.auth=S.user+":"+S.password),c=e(n,t=>{const r=(0,v.isNumber)(S.followRedirects)?S.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&r>0&&t.headers.location)this._request({...S,url:t.headers.location,followRedirects:r-1},l).then(f,E);else{let o=t;t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,y.createGunzip)())),f({res:t,stream:(0,P.streamToBufferReadableStream)(o)})}}),c.on("error",E),S.timeout&&c.setTimeout(S.timeout),S.data&&typeof S.data=="string"&&c.write(S.data),c.end(),l.onCancellationRequested(()=>{c.abort(),E((0,R.canceled)())})})}async resolveProxy(S){}};i.RequestService=w,i.RequestService=w=me([le(0,a.IConfigurationService),le(1,h.INativeEnvironmentService),le(2,L.ILogService)],w)}),define(Q[157],Z([0,1,34,4,16,28,10,2,14,13,8,29,18,11,19,20,120,55,127,21,100,135,23,122,46,144,125,116,56,15,110,112,45,107,59,60,126,12,114,117,33,142,137,27,47,145,132,31,136,38,138,139,39,141]),function(W,i,C,I,P,R,O,v,a,h,D,L,g,y,w,d,S,l,f,E,c,s,e,n,t,r,o,u,m,p,b,A,z,te,J,oe,re,N,j,q,_,ne,k,T,F,x,$,B,ae,Y,ve,V,M,G){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class K extends v.Disposable{constructor(se){super();this.argv=se,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[se,ce]=await this.initServices();return se.invokeFunction(async ue=>{const ge=ue.get(N.ILogService),he=ue.get(p.IFileService),fe=ue.get(E.INativeEnvironmentService),ye=ue.get(e.IExtensionManagementCLIService);ge.info("CLI main",this.argv),this.registerErrorHandler(ge),await this.doRun(fe,ye,he),await Promise.all(ce.map(be=>{(0,I.raceTimeout)(be.flush(),1e3)}))})}async initServices(){const se=new J.ServiceCollection,ce={_serviceBrand:void 0,...k.default};se.set(T.IProductService,ce);const ue=new c.NativeEnvironmentService(this.argv,ce);se.set(E.INativeEnvironmentService,ue),await Promise.all([ue.appSettingsHome.fsPath,ue.extensionsPath].map(U=>U?w.Promises.mkdir(U,{recursive:!0}):void 0));const ge=(0,N.getLogLevel)(ue),he=[];he.push(new j.SpdLogLogger("cli",(0,h.join)(ue.logsPath,"cli.log"),!0,!1,ge)),ge===N.LogLevel.Trace&&he.push(new N.ConsoleLogger(ge));const fe=this._register(new N.MultiplexLogService(he));se.set(N.ILogService,fe);const ye=this._register(new b.FileService(fe));se.set(p.IFileService,ye);const be=this._register(new A.DiskFileSystemProvider(fe));ye.registerProvider(a.Schemas.file,be);const Ie=D.isWindows&&ce.win32RegValueName?this._register(new ne.NativePolicyService(ce.win32RegValueName)):ue.policyFile?this._register(new q.FilePolicyService(ue.policyFile,ye,fe)):new _.NullPolicyService;se.set(_.IPolicyService,Ie);const Ne=this._register(new S.ConfigurationService(ue.settingsResource,ye,Ie,fe));se.set(d.IConfigurationService,Ne),await Ne.initialize(),se.set(M.IUriIdentityService,new G.UriIdentityService(ye)),se.set(F.IRequestService,new z.SyncDescriptor(x.RequestService)),se.set(l.IDownloadService,new z.SyncDescriptor(f.DownloadService)),se.set(m.IExtensionsGalleryConfigService,new z.SyncDescriptor(u.ExtensionsGalleryConfigService)),se.set(t.IExtensionsScannerService,new z.SyncDescriptor(o.ExtensionsScannerService)),se.set(e.IExtensionManagementService,new z.SyncDescriptor(r.ExtensionManagementService)),se.set(e.IExtensionGalleryService,new z.SyncDescriptor(s.ExtensionGalleryServiceWithNoStorageService)),se.set(e.IExtensionManagementCLIService,new z.SyncDescriptor(n.ExtensionManagementCLIService)),se.set(oe.ILanguagePackService,new z.SyncDescriptor(re.NativeLanguagePackService));const xe=[];if((0,Y.supportsTelemetry)(ce,ue)){ce.aiConfig&&ce.aiConfig.asimovKey&&xe.push(new ve.AppInsightsAppender("monacoworkbench",null,ce.aiConfig.asimovKey));const{installSourcePath:U}=ue,H={appenders:xe,sendErrorTelemetry:!1,commonProperties:(async()=>{let X;try{const de=await w.Promises.readFile((0,g.joinPath)(ue.globalStorageHome,"storage.json").fsPath);X=JSON.parse(de.toString())[B.machineIdKey]}catch(de){de.code!=="ENOENT"&&fe.error(de)}return(0,$.resolveCommonProperties)(ye,(0,C.release)(),(0,C.hostname)(),process.arch,ce.commit,ce.version,X,ce.msftInternalDomains,U)})(),piiPaths:(0,Y.getPiiPathsFromEnvironment)(ue)};se.set(B.ITelemetryService,new z.SyncDescriptor(ae.TelemetryService,[H]))}else se.set(B.ITelemetryService,Y.NullTelemetryService);return[new te.InstantiationService(se),xe]}registerErrorHandler(se){(0,O.setUnexpectedErrorHandler)(ce=>{const ue=(0,R.toErrorMessage)(ce,!0);!ue||se.error(`[uncaught exception in CLI]: ${ue}`)}),process.on("uncaughtException",ce=>(0,O.onUnexpectedError)(ce)),process.on("unhandledRejection",ce=>(0,O.onUnexpectedError)(ce))}async doRun(se,ce,ue){if(this.argv["install-source"])return this.setInstallSource(se,ue,this.argv["install-source"]);if(this.argv["list-extensions"])return ce.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const ge={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return ce.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],ge,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return ce.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return ce.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,V.buildTelemetryMessage)(se.appRoot,se.extensionsPath))}}asExtensionIdOrVSIX(se){return se.map(ce=>/\.vsix$/i.test(ce)?y.URI.file((0,h.isAbsolute)(ce)?ce:(0,h.join)((0,L.cwd)(),ce)):ce)}async setInstallSource(se,ce,ue){await ce.writeFile(y.URI.file(se.installSourcePath),P.VSBuffer.fromString(ue.slice(0,30)))}}async function ee(ie){const se=new K(ie);try{await se.run()}finally{se.dispose()}}i.main=ee})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/code/node/cliProcessMain.js.map
