var __decorate=this&&this.__decorate||function(d,a,p,c){var l=arguments.length,o=l<3?a:c===null?c=Object.getOwnPropertyDescriptor(a,p):c,u;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")o=Reflect.decorate(d,a,p,c);else for(var k=d.length-1;k>=0;k--)(u=d[k])&&(o=(l<3?u(o):l>3?u(a,p,o):u(a,p))||o);return l>3&&o&&Object.defineProperty(a,p,o),o},__param=this&&this.__param||function(d,a){return function(p,c){a(p,c,d)}};define(["require","exports","crypto","fs","vs/base/common/extpath","vs/base/common/network","vs/base/common/path","vs/base/common/platform","vs/base/common/resources","vs/base/common/uri","vs/base/node/pfs","vs/platform/backup/node/backup","vs/platform/configuration/common/configuration","vs/platform/environment/electron-main/environmentMainService","vs/platform/files/common/files","vs/platform/log/common/log","vs/platform/backup/common/backup","vs/platform/workspace/common/workspace"],function(d,a,p,c,l,o,u,k,g,m,n,S,B,v,y,b,W,P){"use strict";Object.defineProperty(a,"__esModule",{value:!0}),a.BackupMainService=void 0;let w=class{constructor(e,t,r){this.configurationService=t,this.logService=r,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=g.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(s,i)=>(0,l.isEqual)(s,i,!k.isLinux)},this.backupHome=e.backupHome,this.workspacesJsonPath=e.backupWorkspacesPath}async initialize(){let e;try{e=JSON.parse(await n.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{e=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(e.emptyWorkspaceInfos);let t=[];try{Array.isArray(e.rootURIWorkspaces)&&(t=e.rootURIWorkspaces.map(s=>({workspace:{id:s.id,configPath:m.URI.parse(s.configURIPath)},remoteAuthority:s.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(t);let r=[];try{Array.isArray(e.folderWorkspaceInfos)?r=e.folderWorkspaceInfos.map(s=>({folderUri:m.URI.parse(s.folderUri),remoteAuthority:s.remoteAuthority})):Array.isArray(e.folderURIWorkspaces)&&(r=e.folderURIWorkspaces.map(s=>({folderUri:m.URI.parse(s),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(r),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==y.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===y.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||y.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(e,t){this.workspaces.some(s=>e.workspace.id===s.workspace.id)||(this.workspaces.push(e),this.saveSync());const r=this.getBackupPath(e.workspace.id);return t&&this.moveBackupFolderSync(r,t),r}moveBackupFolderSync(e,t){if(c.existsSync(e)&&this.convertToEmptyWindowBackupSync(e),c.existsSync(t))try{c.renameSync(t,e)}catch(r){this.logService.error(`Backup: Could not move backup folder to new location: ${r.toString()}`)}}unregisterWorkspaceBackupSync(e){const t=e.id,r=this.workspaces.findIndex(s=>s.workspace.id===t);r!==-1&&(this.workspaces.splice(r,1),this.saveSync())}registerFolderBackupSync(e){return this.folders.some(t=>this.backupUriComparer.isEqual(e.folderUri,t.folderUri))||(this.folders.push(e),this.saveSync()),this.getBackupPath(this.getFolderHash(e))}unregisterFolderBackupSync(e){const t=this.folders.findIndex(r=>this.backupUriComparer.isEqual(e,r.folderUri));t!==-1&&(this.folders.splice(t,1),this.saveSync())}registerEmptyWindowBackupSync(e,t){const r=e||this.getRandomEmptyWindowId();return this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,r))||(this.emptyWindows.push({backupFolder:r,remoteAuthority:t}),this.saveSync()),this.getBackupPath(r)}unregisterEmptyWindowBackupSync(e){const t=this.emptyWindows.findIndex(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,e));t!==-1&&(this.emptyWindows.splice(t,1),this.saveSync())}getBackupPath(e){return(0,u.join)(this.backupHome,e)}async validateWorkspaces(e){if(!Array.isArray(e))return[];const t=new Set,r=[];for(let s of e){const i=s.workspace;if(!(0,P.isWorkspaceIdentifier)(i))return[];if(!t.has(i.id)){t.add(i.id);const h=this.getBackupPath(i.id);await this.doHasBackups(h)?i.configPath.scheme!==o.Schemas.file||await n.Promises.exists(i.configPath.fsPath)?r.push(s):await this.convertToEmptyWindowBackup(h):await this.deleteStaleBackup(h)}}return r}async validateFolders(e){if(!Array.isArray(e))return[];const t=[],r=new Set;for(let s of e){const i=s.folderUri,h=this.backupUriComparer.getComparisonKey(i);if(!r.has(h)){r.add(h);const f=this.getBackupPath(this.getFolderHash(s));await this.doHasBackups(f)?i.scheme!==o.Schemas.file||await n.Promises.exists(i.fsPath)?t.push(s):await this.convertToEmptyWindowBackup(f):await this.deleteStaleBackup(f)}}return t}async validateEmptyWorkspaces(e){if(!Array.isArray(e))return[];const t=[],r=new Set;for(let s of e){const i=s.backupFolder;if(typeof i!="string")return[];if(!r.has(i)){r.add(i);const h=this.getBackupPath(i);await this.doHasBackups(h)?t.push(s):await this.deleteStaleBackup(h)}}return t}async deleteStaleBackup(e){try{await n.Promises.exists(e)&&await n.Promises.rm(e,n.RimRafMode.MOVE)}catch(t){this.logService.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}async convertToEmptyWindowBackup(e){let t=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,t));)t=this.getRandomEmptyWindowId();const r=this.getBackupPath(t);try{await n.Promises.rename(e,r)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:t}),!0}convertToEmptyWindowBackupSync(e){let t=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,t));)t=this.getRandomEmptyWindowId();const r=this.getBackupPath(t);try{c.renameSync(e,r)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:t}),!0}async getDirtyWorkspaces(){const e=[];for(const t of this.workspaces)await this.hasBackups(t)&&e.push(t);for(const t of this.folders)await this.hasBackups(t)&&e.push(t);return e}hasBackups(e){let t;return(0,S.isEmptyWindowBackupInfo)(e)?t=e.backupFolder:(0,W.isFolderBackupInfo)(e)?t=this.getBackupPath(this.getFolderHash(e)):t=this.getBackupPath(e.workspace.id),this.doHasBackups(t)}async doHasBackups(e){try{const t=await n.Promises.readdir(e);for(const r of t)try{if((await n.Promises.readdir((0,u.join)(e,r))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,n.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(e){this.logService.error(`Backup: Could not save workspaces.json: ${e.toString()}`)}}async save(){try{await n.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(e){this.logService.error(`Backup: Could not save workspaces.json: ${e.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(e=>({id:e.workspace.id,configURIPath:e.workspace.configPath.toString(),remoteAuthority:e.remoteAuthority})),folderWorkspaceInfos:this.folders.map(e=>({folderUri:e.folderUri.toString(),remoteAuthority:e.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(e){const t=e.folderUri;let r;return t.scheme===o.Schemas.file?r=k.isLinux?t.fsPath:t.fsPath.toLowerCase():r=t.toString().toLowerCase(),(0,p.createHash)("md5").update(r).digest("hex")}};a.BackupMainService=w,a.BackupMainService=w=__decorate([__param(0,v.IEnvironmentMainService),__param(1,B.IConfigurationService),__param(2,b.ILogService)],w)});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/backup/electron-main/backupMainService.js.map
