define(["require","exports","vs/base/common/arrays","vs/base/common/event","vs/base/common/json","vs/base/common/lifecycle","vs/base/common/map","vs/base/common/objects","vs/base/common/types","vs/base/common/uri","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/platform/registry/common/platform"],function(q,l,h,y,U,K,p,c,w,A,g,v,S){"use strict";Object.defineProperty(l,"__esModule",{value:!0}),l.AllKeysConfigurationChangeEvent=l.ConfigurationChangeEvent=l.mergeChanges=l.Configuration=l.UserSettings=l.ConfigurationModelParser=l.ConfigurationModel=void 0;class f{constructor(e={},i=[],t=[]){this._contents=e,this._keys=i,this._overrides=t,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(e){return e?(0,g.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const t=this.getContentsForOverrideIdentifer(i);return t?e?(0,g.getConfigurationValue)(t,e):t:void 0}getKeysForOverrideIdentifier(e){const i=[];for(const t of this.overrides)t.identifiers.includes(e)&&i.push(...t.keys);return h.distinct(i)}getAllOverrideIdentifiers(){const e=[];for(const i of this.overrides)e.push(...i.identifiers);return h.distinct(e)}override(e){let i=this.overrideConfigurations.get(e);return i||(i=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,i)),i}merge(...e){const i=c.deepClone(this.contents),t=c.deepClone(this.overrides),r=[...this.keys];for(const o of e){this.mergeContents(i,o.contents);for(const n of o.overrides){const[s]=t.filter(a=>h.equals(a.identifiers,n.identifiers));s?(this.mergeContents(s.contents,n.contents),s.keys.push(...n.keys),s.keys=h.distinct(s.keys)):t.push(c.deepClone(n))}for(const n of o.keys)r.indexOf(n)===-1&&r.push(n)}return new f(i,r,t)}freeze(){return this.frozen=!0,this}clone(){return new f(c.deepClone(this.contents),[...this.keys],c.deepClone(this.overrides))}createOverrideConfigurationModel(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let t={};for(const r of h.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[r],n=i[r];n&&(typeof o=="object"&&typeof n=="object"?(o=c.deepClone(o),this.mergeContents(o,n)):o=n),t[r]=o}return new f(t,this.keys,this.overrides)}mergeContents(e,i){for(const t of Object.keys(i)){if(t in e&&w.isObject(e[t])&&w.isObject(i[t])){this.mergeContents(e[t],i[t]);continue}e[t]=c.deepClone(i[t])}}checkAndFreeze(e){return this.frozen&&!Object.isFrozen(e)?c.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let i=null,t=null;const r=o=>{o&&(t?this.mergeContents(t,o):t=c.deepClone(o))};for(const o of this.overrides)h.equals(o.identifiers,[e])?i=o.contents:o.identifiers.includes(e)&&r(o.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,g.addToValueTree)(this.contents,e,i,t=>{throw new Error(t)})}removeValue(e){this.removeKey(e)&&(0,g.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let t=0;t<i;t++)e.indexOf(this.keys[t])===0&&(i=t);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}l.ConfigurationModel=f;class V{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!w.isUndefinedOrNull(e)){const t=this.doParseContent(e);this.parseRaw(t,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:t,keys:r,overrides:o,restricted:n}=this.doParseRaw(e,i);this._configurationModel=new f(t,r,o),this._restrictedConfigurations=n||[]}doParseContent(e){let i={},t=null,r=[],o=[],n=[];function s(d){Array.isArray(r)?r.push(d):t!==null&&(r[t]=d)}let a={onObjectBegin:()=>{let d={};s(d),o.push(r),r=d,t=null},onObjectProperty:d=>{t=d},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{let d=[];s(d),o.push(r),r=d,t=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:s,onError:(d,m,k)=>{n.push({error:d,offset:m,length:k})}};if(e)try{U.visit(e,a),i=r[0]||{}}catch(d){console.error(`Error while parsing settings file ${this._name}: ${d}`),this._parseErrors=[d]}return i}doParseRaw(e,i){const t=S.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,t,!0,i);e=r.raw;const o=(0,g.toValuesTree)(e,a=>console.error(`Conflict in settings file ${this._name}: ${a}`)),n=Object.keys(e),s=this.toOverrides(e,a=>console.error(`Conflict in settings file ${this._name}: ${a}`));return{contents:o,keys:n,overrides:s,restricted:r.restricted}}filter(e,i,t,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const o={},n=[];for(let s in e)if(v.OVERRIDE_PROPERTY_REGEX.test(s)&&t){const a=this.filter(e[s],i,!1,r);o[s]=a.raw,n.push(...a.restricted)}else{const a=i[s],d=a?typeof a.scope!="undefined"?a.scope:3:void 0;a?.restricted&&n.push(s),(d===void 0||r.scopes===void 0||r.scopes.includes(d))&&(r.skipRestricted&&a?.restricted||(o[s]=e[s]))}return{raw:o,restricted:n}}toOverrides(e,i){const t=[];for(const r of Object.keys(e))if(v.OVERRIDE_PROPERTY_REGEX.test(r)){const o={};for(const n in e[r])o[n]=e[r][n];t.push({identifiers:(0,v.overrideIdentifiersFromKey)(r),keys:Object.keys(o),contents:(0,g.toValuesTree)(o,i)})}return t}}l.ConfigurationModelParser=V;class b extends K.Disposable{constructor(e,i,t,r){super();this.userSettingsResource=e,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new V(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.any(y.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),y.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,e)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}l.UserSettings=b;class _{constructor(e,i,t,r=new f,o=new f,n=new p.ResourceMap,s=new f,a=new p.ResourceMap,d=!0){this._defaultConfiguration=e,this._policyConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=n,this._memoryConfiguration=s,this._memoryConfigurationByResource=a,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new p.ResourceMap,this._userConfiguration=null}getValue(e,i,t){return this.getConsolidatedConfigurationModel(e,i,t).getValue(e)}updateValue(e,i,t={}){let r;t.resource?(r=this._memoryConfigurationByResource.get(t.resource),r||(r=new f,this._memoryConfigurationByResource.set(t.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(e):r.setValue(e,i),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,t){const r=this.getConsolidatedConfigurationModel(e,i,t),o=this.getFolderConfigurationModelForResource(i.resource,t),n=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,s=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),a=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(e),d=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),m=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),z=t?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,F=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(e):o.freeze().getValue(e):void 0,R=i.overrideIdentifier?n.override(i.overrideIdentifier).getValue(e):n.getValue(e),j=r.getValue(e),M=h.distinct(r.overrides.map(O=>O.identifiers).flat()).filter(O=>r.getOverrideValue(e,O)!==void 0);return{defaultValue:s,policyValue:a,userValue:d,userLocalValue:m,userRemoteValue:k,workspaceValue:z,workspaceFolderValue:F,memoryValue:R,value:j,default:s!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,policy:a!==void 0?{value:a}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:m!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:z!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:o?.freeze().getValue(e),override:i.overrideIdentifier?o?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:R!==void 0?{value:n.getValue(e),override:i.overrideIdentifier?n.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(e){this._policyConfiguration=e}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const t=[];if(!i){const{added:r,updated:o,removed:n}=C(this._defaultConfiguration,e);i=[...r,...o,...n]}for(const r of i)for(const o of(0,v.overrideIdentifiersFromKey)(r)){const n=this._defaultConfiguration.getKeysForOverrideIdentifier(o),s=e.getKeysForOverrideIdentifier(o),a=[...s.filter(d=>n.indexOf(d)===-1),...n.filter(d=>s.indexOf(d)===-1),...n.filter(d=>!c.equals(this._defaultConfiguration.override(o).getValue(d),e.override(o).getValue(d)))];t.push([o,a])}return this.updateDefaultConfiguration(e),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(e){const{added:i,updated:t,removed:r}=C(this._policyConfiguration,e),o=[...i,...t,...r];return o.length&&this.updatePolicyConfiguration(e),{keys:o,overrides:[]}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:t,removed:r,overrides:o}=C(this.localUserConfiguration,e),n=[...i,...t,...r];return n.length&&this.updateLocalUserConfiguration(e),{keys:n,overrides:o}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:t,removed:r,overrides:o}=C(this.remoteUserConfiguration,e);let n=[...i,...t,...r];return n.length&&this.updateRemoteUserConfiguration(e),{keys:n,overrides:o}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:t,removed:r,overrides:o}=C(this.workspaceConfiguration,e);let n=[...i,...t,...r];return n.length&&this.updateWorkspaceConfiguration(e),{keys:n,overrides:o}}compareAndUpdateFolderConfiguration(e,i){const t=this.folderConfigurations.get(e),{added:r,updated:o,removed:n,overrides:s}=C(t,i);let a=[...r,...o,...n];return(a.length||!t)&&this.updateFolderConfiguration(e,i),{keys:a,overrides:s}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:t,updated:r,removed:o,overrides:n}=C(i,void 0);return{keys:[...t,...r,...o],overrides:n}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(e,i,t){let r=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(e)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:e},i){let t=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const r=i.getFolder(e);r&&(t=this.getFolderConsolidatedConfiguration(r.uri)||t);const o=this._memoryConfigurationByResource.get(e);o&&(t=t.merge(o))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const t=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(i=t.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=t}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const t=i.getFolder(e);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:t,overrides:r,keys:o}=this._folderConfigurations.get(i);return e.push([i,{contents:t,overrides:r,keys:o}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(t=>e.add(t))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>i.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),t=this.parseConfigurationModel(e.policy),r=this.parseConfigurationModel(e.user),o=this.parseConfigurationModel(e.workspace),n=e.folders.reduce((s,a)=>(s.set(A.URI.revive(a[0]),this.parseConfigurationModel(a[1])),s),new p.ResourceMap);return new _(i,t,r,new f,o,n,new f,new p.ResourceMap,!1)}static parseConfigurationModel(e){return new f(e.contents,e.keys,e.overrides).freeze()}}l.Configuration=_;function P(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const e=new Set,i=new Map;for(const r of u)r.keys.forEach(o=>e.add(o)),r.overrides.forEach(([o,n])=>{const s=(0,p.getOrSet)(i,o,new Set);n.forEach(a=>s.add(a))});const t=[];return i.forEach((r,o)=>t.push([o,[...r.values()]])),{keys:[...e.values()],overrides:t}}l.mergeChanges=P;class I{constructor(e,i,t,r){this.change=e,this.previous=i,this.currentConfiguraiton=t,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;e.keys.forEach(s=>o.add(s)),e.overrides.forEach(([,s])=>s.forEach(a=>o.add(a))),this.affectedKeys=[...o.values()];const n=new f;this.affectedKeys.forEach(s=>n.setValue(s,{})),this.affectedKeysTree=n.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=_.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const t=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!c.equals(t,r)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let t=(0,g.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof t=="object"&&(r=Object.keys(t)[0]);){if(e=e[r],!e)return!1;t=t[r]}return!0}}l.ConfigurationChangeEvent=I;class D extends I{constructor(e,i,t,r){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=t,this.sourceConfig=r}}l.AllKeysConfigurationChangeEvent=D;function C(u,e){const{added:i,removed:t,updated:r}=E(e,u),o=[],n=u?.getAllOverrideIdentifiers()||[],s=e?.getAllOverrideIdentifiers()||[];if(e){const a=s.filter(d=>!n.includes(d));for(const d of a)o.push([d,e.getKeysForOverrideIdentifier(d)])}if(u){const a=n.filter(d=>!s.includes(d));for(const d of a)o.push([d,u.getKeysForOverrideIdentifier(d)])}if(e&&u){for(const a of n)if(s.includes(a)){const d=E({contents:u.getOverrideValue(void 0,a)||{},keys:u.getKeysForOverrideIdentifier(a)},{contents:e.getOverrideValue(void 0,a)||{},keys:e.getKeysForOverrideIdentifier(a)});o.push([a,[...d.added,...d.removed,...d.updated]])}}return{added:i,removed:t,updated:r,overrides:o}}function E(u,e){const i=u?e?u.keys.filter(o=>e.keys.indexOf(o)===-1):[...u.keys]:[],t=e?u?e.keys.filter(o=>u.keys.indexOf(o)===-1):[...e.keys]:[],r=[];if(u&&e){for(const o of e.keys)if(u.keys.indexOf(o)!==-1){const n=(0,g.getConfigurationValue)(e.contents,o),s=(0,g.getConfigurationValue)(u.contents,o);c.equals(n,s)||r.push(o)}}return{added:i,removed:t,updated:r}}});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/configuration/common/configurationModels.js.map
