define(["require","exports","vs/base/common/resources","vs/base/common/severity","vs/nls!vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver"],function(G,f,p,n,t,M){"use strict";Object.defineProperty(f,"__esModule",{value:!0}),f.isEngineValid=f.isValidExtensionVersion=f.validateExtensionManifest=f.isValidVersion=f.normalizeVersion=f.parseVersion=f.isValidVersionStr=void 0;const z=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,N=/^-(\d{4})(\d{2})(\d{2})$/;function j(a){return a=a.trim(),a==="*"||z.test(a)}f.isValidVersionStr=j;function h(a){if(!j(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let l=a.match(z);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}f.parseVersion=h;function B(a){if(!a)return null;let l=a.majorBase,u=a.majorMustEqual,r=a.minorBase,i=a.minorMustEqual,e=a.patchBase,s=a.patchMustEqual;a.hasCaret&&(l===0||(i=!1),s=!1);let d=0;if(a.preRelease){const o=N.exec(a.preRelease);if(o){const[,m,c,E]=o;d=Date.UTC(Number(m),Number(c)-1,Number(E))}}return{majorBase:l,majorMustEqual:u,minorBase:r,minorMustEqual:i,patchBase:e,patchMustEqual:s,isMinimum:a.hasGreaterEquals,notBefore:d}}f.normalizeVersion=B;function b(a,l,u){let r;typeof a=="string"?r=B(h(a)):r=a;let i;l instanceof Date?i=l.getTime():typeof l=="string"&&(i=new Date(l).getTime());let e;if(typeof u=="string"?e=B(h(u)):e=u,!r||!e)return!1;let s=r.majorBase,d=r.minorBase,o=r.patchBase,m=e.majorBase,c=e.minorBase,E=e.patchBase,R=e.notBefore,q=e.majorMustEqual,V=e.minorMustEqual,g=e.patchMustEqual;return e.isMinimum?s>m?!0:s<m?!1:d>c?!0:d<c||i&&i<R?!1:o>=E:(s===1&&m===0&&(!q||!V||!g)&&(m=1,c=0,E=0,q=!0,V=!1,g=!1),s<m?!1:s>m?!q:d<c?!1:d>c?!V:o<E?!1:o>E?!g:!(i&&i<R))}f.isValidVersion=b;function O(a,l,u,r,i){const e=[];if(typeof r.publisher!="undefined"&&typeof r.publisher!="string")return e.push([n.default.Error,t.localize(0,null)]),e;if(typeof r.name!="string")return e.push([n.default.Error,t.localize(1,null,"name")]),e;if(typeof r.version!="string")return e.push([n.default.Error,t.localize(2,null,"version")]),e;if(!r.engines)return e.push([n.default.Error,t.localize(3,null,"engines")]),e;if(typeof r.engines.vscode!="string")return e.push([n.default.Error,t.localize(4,null,"engines.vscode")]),e;if(typeof r.extensionDependencies!="undefined"&&!P(r.extensionDependencies))return e.push([n.default.Error,t.localize(5,null,"extensionDependencies")]),e;if(typeof r.activationEvents!="undefined"){if(!P(r.activationEvents))return e.push([n.default.Error,t.localize(6,null,"activationEvents")]),e;if(typeof r.main=="undefined"&&typeof r.browser=="undefined")return e.push([n.default.Error,t.localize(7,null,"activationEvents","main")]),e}if(typeof r.extensionKind!="undefined"&&typeof r.main=="undefined"&&e.push([n.default.Warning,t.localize(8,null,"extensionKind")]),typeof r.main!="undefined"){if(typeof r.main!="string")return e.push([n.default.Error,t.localize(9,null,"main")]),e;{const o=(0,p.joinPath)(u,r.main);(0,p.isEqualOrParent)(o,u)||e.push([n.default.Warning,t.localize(10,null,o.path,u.path)])}if(typeof r.activationEvents=="undefined")return e.push([n.default.Error,t.localize(11,null,"activationEvents","main")]),e}if(typeof r.browser!="undefined"){if(typeof r.browser!="string")return e.push([n.default.Error,t.localize(12,null,"browser")]),e;{const o=(0,p.joinPath)(u,r.browser);(0,p.isEqualOrParent)(o,u)||e.push([n.default.Warning,t.localize(13,null,o.path,u.path)])}if(typeof r.activationEvents=="undefined")return e.push([n.default.Error,t.localize(14,null,"activationEvents","browser")]),e}if(!M.valid(r.version))return e.push([n.default.Error,t.localize(15,null)]),e;const s=[];if(!y(a,l,r,i,s))for(const o of s)e.push([n.default.Error,o]);return e}f.validateExtensionManifest=O;function y(a,l,u,r,i){return r||typeof u.main=="undefined"&&typeof u.browser=="undefined"?!0:w(a,l,u.engines.vscode,i)}f.isValidExtensionVersion=y;function v(a,l,u){return a==="*"||w(l,u,a)}f.isEngineValid=v;function w(a,l,u,r=[]){let i=B(h(u));if(!i)return r.push(t.localize(16,null,u)),!1;if(i.majorBase===0){if(!i.majorMustEqual||!i.minorMustEqual)return r.push(t.localize(17,null,u)),!1}else if(!i.majorMustEqual)return r.push(t.localize(18,null,u)),!1;return b(a,l,i)?!0:(r.push(t.localize(19,null,a,u)),!1)}function P(a){if(!Array.isArray(a))return!1;for(let l=0,u=a.length;l<u;l++)if(typeof a[l]!="string")return!1;return!0}});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/extensions/common/extensionValidator.js.map
