define(["require","exports","assert","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService"],function(p,d,a,u,l){"use strict";Object.defineProperty(d,"__esModule",{value:!0});const c=Object.freeze({terminal:{explorerKind:"external",external:{windowsExec:"testWindowsShell",osxExec:"testOSXShell",linuxExec:"testLinuxShell"}}});suite("ExternalTerminalService",()=>{test("WinTerminalService - uses terminal from configuration",t=>{const e="cmd",n="path/to/workspace",i={spawn:(o,s,r)=>((0,a.strictEqual)(o,e,"shell should equal expected"),(0,a.strictEqual)(s[s.length-1],c.terminal.external.windowsExec),(0,a.strictEqual)(r.cwd,n),t(),{on:m=>m})};new l.WindowsExternalTerminalService().spawnTerminal(i,c.terminal.external,e,n)}),test("WinTerminalService - uses default terminal when configuration.terminal.external.windowsExec is undefined",t=>{const e="cmd",n="path/to/workspace",i={spawn:(o,s,r)=>((0,a.strictEqual)(s[s.length-1],l.WindowsExternalTerminalService.getDefaultTerminalWindows()),t(),{on:m=>m})};c.terminal.external.windowsExec=void 0,new l.WindowsExternalTerminalService().spawnTerminal(i,c.terminal.external,e,n)}),test("WinTerminalService - uses default terminal when configuration.terminal.external.windowsExec is undefined",t=>{const e="cmd",n="c:/foo",i={spawn:(o,s,r)=>((0,a.strictEqual)(r.cwd,"C:/foo","cwd should be uppercase regardless of the case that's passed in"),t(),{on:m=>m})};new l.WindowsExternalTerminalService().spawnTerminal(i,c.terminal.external,e,n)}),test("WinTerminalService - cmder should be spawned differently",t=>{const e="cmd",n="c:/foo",i={spawn:(o,s,r)=>((0,a.deepStrictEqual)(s,["C:/foo"]),(0,a.strictEqual)(r,void 0),t(),{on:m=>m})};new l.WindowsExternalTerminalService().spawnTerminal(i,{windowsExec:"cmder"},e,n)}),test("WinTerminalService - windows terminal should open workspace directory",t=>{const e="wt",n="c:/foo",i={spawn:(o,s,r)=>((0,a.strictEqual)(r.cwd,"C:/foo"),t(),{on:m=>m})};new l.WindowsExternalTerminalService().spawnTerminal(i,c.terminal.external,e,n)}),test("MacTerminalService - uses terminal from configuration",t=>{const e="path/to/workspace",n={spawn:(w,o,s)=>((0,a.strictEqual)(o[1],c.terminal.external.osxExec),t(),{on:r=>r})};new l.MacExternalTerminalService().spawnTerminal(n,c.terminal.external,e)}),test("MacTerminalService - uses default terminal when configuration.terminal.external.osxExec is undefined",t=>{const e="path/to/workspace",n={spawn:(w,o,s)=>((0,a.strictEqual)(o[1],u.DEFAULT_TERMINAL_OSX),t(),{on:r=>r})};new l.MacExternalTerminalService().spawnTerminal(n,{osxExec:void 0},e)}),test("LinuxTerminalService - uses terminal from configuration",t=>{const e="path/to/workspace",n={spawn:(w,o,s)=>((0,a.strictEqual)(w,c.terminal.external.linuxExec),(0,a.strictEqual)(s.cwd,e),t(),{on:r=>r})};new l.LinuxExternalTerminalService().spawnTerminal(n,c.terminal.external,e)}),test("LinuxTerminalService - uses default terminal when configuration.terminal.external.linuxExec is undefined",t=>{l.LinuxExternalTerminalService.getDefaultTerminalLinuxReady().then(e=>{const n="path/to/workspace",i={spawn:(o,s,r)=>((0,a.strictEqual)(o,e),t(),{on:m=>m})};c.terminal.external.linuxExec=void 0,new l.LinuxExternalTerminalService().spawnTerminal(i,c.terminal.external,n)})})})});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/externalTerminal/electron-main/externalTerminalService.test.js.map
