define(["require","exports","vs/nls!vs/platform/files/browser/htmlFileSystemProvider","vs/base/common/uri","vs/base/common/buffer","vs/base/common/event","vs/base/common/lifecycle","vs/base/common/network","vs/base/common/path","vs/base/common/platform","vs/base/common/resources","vs/base/common/stream","vs/platform/files/common/files","vs/platform/files/browser/webFileSystemAccess"],function(P,c,m,v,F,w,u,S,h,f,l,g,o,d){"use strict";Object.defineProperty(c,"__esModule",{value:!0}),c.HTMLFileSystemProvider=void 0;class E{get capabilities(){return this._capabilities||(this._capabilities=2|16,f.isLinux&&(this._capabilities|=1024)),this._capabilities}constructor(e,r,t){this.indexedDB=e,this.store=r,this.logService=t,this.onDidChangeCapabilities=w.Event.None,this.onDidChangeFile=w.Event.None,this.extUri=f.isLinux?l.extUri:l.extUriIgnorePathCase,this._files=new Map,this._directories=new Map}async stat(e){try{const r=await this.getHandle(e);if(!r)throw this.createFileSystemProviderError(e,"No such file or directory, stat",o.FileSystemProviderErrorCode.FileNotFound);if(d.WebFileSystemAccess.isFileSystemFileHandle(r)){const t=await r.getFile();return{type:o.FileType.File,mtime:t.lastModified,ctime:0,size:t.size}}return{type:o.FileType.Directory,mtime:0,ctime:0,size:0}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(e){try{const r=await this.getDirectoryHandle(e);if(!r)throw this.createFileSystemProviderError(e,"No such file or directory, readdir",o.FileSystemProviderErrorCode.FileNotFound);const t=[];for await(const[i,a]of r)t.push([i,d.WebFileSystemAccess.isFileSystemFileHandle(a)?o.FileType.File:o.FileType.Directory]);return t}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(e,r,t){const i=(0,g.newWriteableStream)(a=>F.VSBuffer.concat(a.map(s=>F.VSBuffer.wrap(s))).buffer,{highWaterMark:10});return(async()=>{try{const a=await this.getFileHandle(e);if(!a)throw this.createFileSystemProviderError(e,"No such file or directory, readFile",o.FileSystemProviderErrorCode.FileNotFound);const s=await a.getFile();if(typeof r.length=="number"||typeof r.position=="number"){let n=new Uint8Array(await s.arrayBuffer());typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),i.end(n)}else{const n=s.stream().getReader();let y=await n.read();for(;!y.done&&!(t.isCancellationRequested||(await i.write(y.value),t.isCancellationRequested));)y=await n.read();i.end(void 0)}}catch(a){i.error(this.toFileSystemProviderError(a)),i.end()}})(),i}async readFile(e){try{const r=await this.getFileHandle(e);if(!r)throw this.createFileSystemProviderError(e,"No such file or directory, readFile",o.FileSystemProviderErrorCode.FileNotFound);const t=await r.getFile();return new Uint8Array(await t.arrayBuffer())}catch(r){throw this.toFileSystemProviderError(r)}}async writeFile(e,r,t){try{let i=await this.getFileHandle(e);if(!t.create||!t.overwrite){if(i){if(!t.overwrite)throw this.createFileSystemProviderError(e,"File already exists, writeFile",o.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw this.createFileSystemProviderError(e,"No such file, writeFile",o.FileSystemProviderErrorCode.FileNotFound)}if(!i){const s=await this.getDirectoryHandle(this.extUri.dirname(e));if(!s)throw this.createFileSystemProviderError(e,"No such parent directory, writeFile",o.FileSystemProviderErrorCode.FileNotFound);if(i=await s.getFileHandle(this.extUri.basename(e),{create:!0}),!i)throw this.createFileSystemProviderError(e,"Unable to create file , writeFile",o.FileSystemProviderErrorCode.Unknown)}const a=await i.createWritable();await a.write(r),await a.close()}catch(i){throw this.toFileSystemProviderError(i)}}async mkdir(e){try{const r=await this.getDirectoryHandle(this.extUri.dirname(e));if(!r)throw this.createFileSystemProviderError(e,"No such parent directory, mkdir",o.FileSystemProviderErrorCode.FileNotFound);await r.getDirectoryHandle(this.extUri.basename(e),{create:!0})}catch(r){throw this.toFileSystemProviderError(r)}}async delete(e,r){try{const t=await this.getDirectoryHandle(this.extUri.dirname(e));if(!t)throw this.createFileSystemProviderError(e,"No such parent directory, delete",o.FileSystemProviderErrorCode.FileNotFound);return t.removeEntry(this.extUri.basename(e),{recursive:r.recursive})}catch(t){throw this.toFileSystemProviderError(t)}}async rename(e,r,t){try{if(this.extUri.isEqual(e,r))return;let i=await this.getFileHandle(e);if(i){const a=await i.getFile(),s=new Uint8Array(await a.arrayBuffer());await this.writeFile(r,s,{create:!0,overwrite:t.overwrite,unlock:!1}),await this.delete(e,{recursive:!1,useTrash:!1})}else throw this.createFileSystemProviderError(e,(0,m.localize)(0,null),o.FileSystemProviderErrorCode.Unavailable)}catch(i){throw this.toFileSystemProviderError(i)}}watch(e,r){return u.Disposable.None}registerFileHandle(e){return this.registerHandle(e,this._files)}registerDirectoryHandle(e){return this.registerHandle(e,this._directories)}get directories(){return this._directories.values()}async registerHandle(e,r){let t=`/${e.name}`;if(r.has(t)&&!await r.get(t)?.isSameEntry(e)){const i=(0,h.extname)(e.name),a=(0,h.basename)(e.name,i);let s=1;do t=`/${a}-${s++}${i}`;while(r.has(t)&&!await r.get(t)?.isSameEntry(e))}r.set(t,e);try{await this.indexedDB?.runInTransaction(this.store,"readwrite",i=>i.put(e,t))}catch(i){this.logService.error(i)}return v.URI.from({scheme:S.Schemas.file,path:t})}async getHandle(e){let r=await this.doGetHandle(e);if(!r){const t=await this.getDirectoryHandle(this.extUri.dirname(e));if(t){const i=l.extUri.basename(e);try{r=await t.getFileHandle(i)}catch{try{r=await t.getDirectoryHandle(i)}catch{}}}}return r}async getFileHandle(e){const r=await this.doGetHandle(e);if(r instanceof FileSystemFileHandle)return r;const t=await this.getDirectoryHandle(this.extUri.dirname(e));try{return await t?.getFileHandle(l.extUri.basename(e))}catch{return}}async getDirectoryHandle(e){const r=await this.doGetHandle(e);if(r instanceof FileSystemDirectoryHandle)return r;const t=this.extUri.dirname(e);if(this.extUri.isEqual(t,e))return;const i=await this.getDirectoryHandle(t);try{return await i?.getDirectoryHandle(l.extUri.basename(e))}catch{return}}async doGetHandle(e){if(this.extUri.dirname(e).path!=="/")return;const r=e.path.replace(/\/$/,""),t=this._files.get(r)??this._directories.get(r);if(t)return t;const i=await this.indexedDB?.runInTransaction(this.store,"readonly",a=>a.get(r));if(d.WebFileSystemAccess.isFileSystemHandle(i)){let a=await i.queryPermission()==="granted";try{a||(a=await i.requestPermission()==="granted")}catch(s){this.logService.error(s)}if(a)return d.WebFileSystemAccess.isFileSystemFileHandle(i)?this._files.set(r,i):d.WebFileSystemAccess.isFileSystemDirectoryHandle(i)&&this._directories.set(r,i),i}throw this.createFileSystemProviderError(e,"No file system handle registered",o.FileSystemProviderErrorCode.Unavailable)}toFileSystemProviderError(e){if(e instanceof o.FileSystemProviderError)return e;let r=o.FileSystemProviderErrorCode.Unknown;return e.name==="NotAllowedError"&&(e=new Error((0,m.localize)(1,null)),r=o.FileSystemProviderErrorCode.Unavailable),(0,o.createFileSystemProviderError)(e,r)}createFileSystemProviderError(e,r,t){return(0,o.createFileSystemProviderError)(new Error(`${r} (${(0,h.normalize)(e.path)})`),t)}}c.HTMLFileSystemProvider=E});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/files/browser/htmlFileSystemProvider.js.map
