define(["require","exports","vs/base/common/async","vs/base/common/buffer","vs/base/common/errors","vs/base/common/event","vs/base/common/lifecycle","vs/base/common/resources","vs/base/common/types","vs/base/common/uri","vs/nls!vs/platform/files/browser/indexedDBFileSystemProvider","vs/platform/files/common/files","vs/base/browser/indexedDB"],function(k,f,T,S,x,w,c,B,m,I,l,n,b){"use strict";Object.defineProperty(f,"__esModule",{value:!0}),f.IndexedDBFileSystemProvider=void 0;const D=(0,n.createFileSystemProviderError)((0,l.localize)(0,null),n.FileSystemProviderErrorCode.FileNotFound),N=(0,n.createFileSystemProviderError)((0,l.localize)(1,null),n.FileSystemProviderErrorCode.FileIsADirectory),C=(0,n.createFileSystemProviderError)((0,l.localize)(2,null),n.FileSystemProviderErrorCode.FileNotADirectory),R=(0,n.createFileSystemProviderError)((0,l.localize)(3,null),n.FileSystemProviderErrorCode.Unknown),o=v=>(0,n.createFileSystemProviderError)((0,l.localize)(4,null,v),n.FileSystemProviderErrorCode.Unknown);class y{constructor(e){this.entry=e,this.type=e.type}read(e){return this.doRead(e.split("/").filter(t=>t.length))}doRead(e){if(e.length===0)return this.entry;if(this.entry.type!==n.FileType.Directory)throw o("Internal error reading from IndexedDBFSNode -- expected directory at "+this.entry.path);const t=this.entry.children.get(e[0]);if(!!t)return t.doRead(e.slice(1))}delete(e){const t=e.split("/").filter(r=>r.length);if(t.length===0){if(this.entry.type!==n.FileType.Directory)throw o("Internal error deleting from IndexedDBFSNode. Expected root entry to be directory");this.entry.children.clear()}else return this.doDelete(t,e)}doDelete(e,t){if(e.length===0)throw o(`Internal error deleting from IndexedDBFSNode -- got no deletion path parts (encountered while deleting ${t})`);if(this.entry.type!==n.FileType.Directory)throw o("Internal error deleting from IndexedDBFSNode -- expected directory at "+this.entry.path);if(e.length===1)this.entry.children.delete(e[0]);else{const r=this.entry.children.get(e[0]);if(!r)throw o("Internal error deleting from IndexedDBFSNode -- expected entry at "+this.entry.path+"/"+r);r.doDelete(e.slice(1),t)}}add(e,t){this.doAdd(e.split("/").filter(r=>r.length),t,e)}doAdd(e,t,r){if(e.length===0)throw o(`Internal error creating IndexedDBFSNode -- adding empty path (encountered while adding ${r})`);if(this.entry.type!==n.FileType.Directory)throw o(`Internal error creating IndexedDBFSNode -- parent is not a directory (encountered while adding ${r})`);if(e.length===1){const i=e[0],s=this.entry.children.get(i);if(t.type==="dir"){if(s?.entry.type===n.FileType.File)throw o(`Internal error creating IndexedDBFSNode -- overwriting file with directory: ${this.entry.path}/${i} (encountered while adding ${r})`);this.entry.children.set(i,s??new y({type:n.FileType.Directory,path:this.entry.path+"/"+i,children:new Map}))}else{if(s?.entry.type===n.FileType.Directory)throw o(`Internal error creating IndexedDBFSNode -- overwriting directory with file: ${this.entry.path}/${i} (encountered while adding ${r})`);this.entry.children.set(i,new y({type:n.FileType.File,path:this.entry.path+"/"+i,size:t.size}))}}else if(e.length>1){const i=e[0];let s=this.entry.children.get(i);if(!s)s=new y({children:new Map,path:this.entry.path+"/"+i,type:n.FileType.Directory}),this.entry.children.set(i,s);else if(s.type===n.FileType.File)throw o(`Internal error creating IndexedDBFSNode -- overwriting file entry with directory: ${this.entry.path}/${i} (encountered while adding ${r})`);s.doAdd(e.slice(1),t,r)}}print(e=""){console.log(e+this.entry.path),this.entry.type===n.FileType.Directory&&this.entry.children.forEach(t=>t.print(e+" "))}}class $ extends c.Disposable{constructor(e){super();if(this.changesKey=e,this._onDidFileChanges=this._register(new w.Emitter),this.onDidFileChanges=this._onDidFileChanges.event,"BroadcastChannel"in window)try{this.broadcastChannel=new BroadcastChannel(e);const t=r=>{(0,m.isString)(r.data)&&this.onDidReceiveChanges(r.data)};this.broadcastChannel.addEventListener("message",t),this._register((0,c.toDisposable)(()=>{this.broadcastChannel&&(this.broadcastChannel.removeEventListener("message",t),this.broadcastChannel.close())}))}catch(t){console.warn("Error while creating broadcast channel. Falling back to localStorage.",(0,x.getErrorMessage)(t)),this.createStorageBroadcastChannel(e)}else this.createStorageBroadcastChannel(e)}createStorageBroadcastChannel(e){const t=r=>{r.key===e&&r.newValue&&this.onDidReceiveChanges(r.newValue)};window.addEventListener("storage",t),this._register((0,c.toDisposable)(()=>window.removeEventListener("storage",t)))}onDidReceiveChanges(e){try{const t=JSON.parse(e);this._onDidFileChanges.fire(t.map(r=>({type:r.type,resource:I.URI.revive(r.resource)})))}catch{}}postChanges(e){this.broadcastChannel?this.broadcastChannel.postMessage(JSON.stringify(e)):(window.localStorage.removeItem(this.changesKey),window.localStorage.setItem(this.changesKey,JSON.stringify(e)))}}class U extends c.Disposable{constructor(e,t,r,i){super();this.scheme=e,this.indexedDB=t,this.store=r,this.capabilities=2|1024,this.onDidChangeCapabilities=w.Event.None,this.extUri=new B.ExtUri(()=>!1),this._onDidChangeFile=this._register(new w.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onReportError=this._register(new w.Emitter),this.onReportError=this._onReportError.event,this.versions=new Map,this.fileWriteBatch=[],this.writeManyThrottler=new T.Throttler,i&&(this.changesBroadcastChannel=this._register(new $(`vscode.indexedDB.${e}.changes`)),this._register(this.changesBroadcastChannel.onDidFileChanges(s=>this._onDidChangeFile.fire(s))))}watch(e,t){return c.Disposable.None}async mkdir(e){try{if((await this.stat(e)).type===n.FileType.File)throw C}catch{}(await this.getFiletree()).add(e.path,{type:"dir"})}async stat(e){const t=(await this.getFiletree()).read(e.path);if(t?.type===n.FileType.File)return{type:n.FileType.File,ctime:0,mtime:this.versions.get(e.toString())||0,size:t.size??(await this.readFile(e)).byteLength};if(t?.type===n.FileType.Directory)return{type:n.FileType.Directory,ctime:0,mtime:0,size:0};throw D}async readdir(e){try{const t=(await this.getFiletree()).read(e.path);if(!t)return[];if(t.type!==n.FileType.Directory)throw C;return[...t.children.entries()].map(([r,i])=>[r,i.type])}catch(t){throw this.reportError("readDir",t),t}}async readFile(e){try{const t=await this.indexedDB.runInTransaction(this.store,"readonly",s=>s.get(e.path));if(t===void 0)throw D;const r=t instanceof Uint8Array?t:(0,m.isString)(t)?S.VSBuffer.fromString(t).buffer:void 0;if(r===void 0)throw o(`IndexedDB entry at "${e.path}" in unexpected format`);return(await this.getFiletree()).add(e.path,{type:"file",size:r.byteLength}),r}catch(t){throw this.reportError("readFile",t),t}}async writeFile(e,t,r){try{if((await this.stat(e).catch(()=>{}))?.type===n.FileType.Directory)throw N;await this.bulkWrite([[e,t]])}catch(i){throw this.reportError("writeFile",i),i}}async rename(e,t,r){const i=await this.getFiletree(),s=i.read(e.path);if(!s)throw D;const d=i.read(t.path);if(d){if(!r.overwrite)throw new n.FileSystemProviderError("file exists already",n.FileSystemProviderErrorCode.FileExists);if(d.type!==s.type)throw new n.FileSystemProviderError("Cannot rename files with different types",n.FileSystemProviderErrorCode.Unknown);await this.delete(t,{recursive:!0,useTrash:!1})}const p=a=>this.extUri.joinPath(t,this.extUri.relativePath(e,e.with({path:a}))||""),E=await this.tree(e),g=[];for(const a of E)a[1]===n.FileType.File?g.push(a):a[1]===n.FileType.Directory&&i.add(p(a[0]).path,{type:"dir"});if(g.length){const a=[],F=await this.indexedDB.runInTransaction(this.store,"readonly",h=>g.map(([u])=>h.get(u)));for(let h=0;h<g.length;h++){const u=F[h]instanceof Uint8Array?F[h]:(0,m.isString)(F[h])?S.VSBuffer.fromString(F[h]).buffer:void 0;u&&a.push([p(g[h][0]),u])}await this.bulkWrite(a)}await this.delete(e,{recursive:!0,useTrash:!1})}async delete(e,t){let r;try{r=await this.stat(e)}catch(s){if(s.code===n.FileSystemProviderErrorCode.FileNotFound)return;throw s}let i;if(t.recursive)i=(await this.tree(e)).map(([d])=>d);else{if(r.type===n.FileType.Directory&&(await this.readdir(e)).length)throw R;i=[e.path]}await this.deleteKeys(i),(await this.getFiletree()).delete(e.path),i.forEach(s=>this.versions.delete(s)),this.triggerChanges(i.map(s=>({resource:e.with({path:s}),type:2})))}async tree(e){const t=await this.stat(e),r=[[e.path,t.type]];if(t.type===n.FileType.Directory){const i=await this.readdir(e);for(const[s,d]of i){const p=this.extUri.joinPath(e,s);if(r.push([p.path,d]),d===n.FileType.Directory){const E=await this.tree(p);r.push(...E)}}}return r}triggerChanges(e){e.length&&(this._onDidChangeFile.fire(e),this.changesBroadcastChannel&&this.changesBroadcastChannel.postChanges(e))}getFiletree(){return this.cachedFiletree||(this.cachedFiletree=(async()=>{const e=new y({children:new Map,path:"",type:n.FileType.Directory});return(await this.indexedDB.runInTransaction(this.store,"readonly",i=>i.getAllKeys())).map(i=>i.toString()).forEach(i=>e.add(i,{type:"file"})),e})()),this.cachedFiletree}async bulkWrite(e){e.forEach(([r,i])=>this.fileWriteBatch.push({content:i,resource:r})),await this.writeManyThrottler.queue(()=>this.writeMany());const t=await this.getFiletree();for(const[r,i]of e)t.add(r.path,{type:"file",size:i.byteLength}),this.versions.set(r.toString(),(this.versions.get(r.toString())||0)+1);this.triggerChanges(e.map(([r])=>({resource:r,type:0})))}async writeMany(){if(this.fileWriteBatch.length){const e=this.fileWriteBatch.splice(0,this.fileWriteBatch.length);await this.indexedDB.runInTransaction(this.store,"readwrite",t=>e.map(r=>t.put(r.content,r.resource.path)))}}async deleteKeys(e){e.length&&await this.indexedDB.runInTransaction(this.store,"readwrite",t=>e.map(r=>t.delete(r)))}async reset(){await this.indexedDB.runInTransaction(this.store,"readwrite",e=>e.clear())}reportError(e,t){this._onReportError.fire({scheme:this.scheme,operation:e,code:t instanceof n.FileSystemProviderError||t instanceof b.DBClosedError?t.code:"unknown"})}}f.IndexedDBFileSystemProvider=U});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/files/browser/indexedDBFileSystemProvider.js.map
