define(["require","exports","vs/base/common/errors","vs/base/common/map","vs/base/common/path","vs/base/common/strings","vs/base/common/types","vs/base/common/uri","vs/nls!vs/platform/files/common/files","vs/platform/instantiation/common/instantiation"],function(q,i,R,l,F,y,M,S,c,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getPlatformLimits=i.Arch=i.ByteSize=i.FALLBACK_MAX_MEMORY_SIZE_MB=i.MIN_MAX_MEMORY_SIZE_MB=i.whenProviderRegistered=i.etag=i.ETAG_DISABLED=i.FileKind=i.FILES_EXCLUDE_CONFIG=i.FILES_ASSOCIATIONS_CONFIG=i.HotExitConfiguration=i.AutoSaveConfiguration=i.FileOperationResult=i.NotModifiedSinceFileOperationError=i.FileOperationError=i.isParent=i.FileChangesEvent=i.FileChangeType=i.FileOperationEvent=i.FileOperation=i.toFileOperationResult=i.toFileSystemProviderErrorCode=i.markAsFileSystemProviderError=i.ensureFileSystemProviderError=i.createFileSystemProviderError=i.FileSystemProviderError=i.FileSystemProviderErrorCode=i.hasFileAtomicReadCapability=i.hasFileReadStreamCapability=i.hasOpenReadWriteCloseCapability=i.hasFileCloneCapability=i.hasFileFolderCopyCapability=i.hasReadWriteCapability=i.FileSystemProviderCapabilities=i.FilePermission=i.FileType=i.isFileOpenForWriteOptions=i.IFileService=void 0,i.IFileService=(0,g.createDecorator)("fileService");function v(e){return e.create===!0}i.isFileOpenForWriteOptions=v;var f;(function(e){e[e.Unknown=0]="Unknown",e[e.File=1]="File",e[e.Directory=2]="Directory",e[e.SymbolicLink=64]="SymbolicLink"})(f||(i.FileType=f={}));var I;(function(e){e[e.Readonly=1]="Readonly"})(I||(i.FilePermission=I={}));var h;(function(e){e[e.None=0]="None",e[e.FileReadWrite=2]="FileReadWrite",e[e.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",e[e.FileReadStream=16]="FileReadStream",e[e.FileFolderCopy=8]="FileFolderCopy",e[e.PathCaseSensitive=1024]="PathCaseSensitive",e[e.Readonly=2048]="Readonly",e[e.Trash=4096]="Trash",e[e.FileWriteUnlock=8192]="FileWriteUnlock",e[e.FileAtomicRead=16384]="FileAtomicRead",e[e.FileClone=32768]="FileClone"})(h||(i.FileSystemProviderCapabilities=h={}));function L(e){return!!(e.capabilities&2)}i.hasReadWriteCapability=L;function W(e){return!!(e.capabilities&8)}i.hasFileFolderCopyCapability=W;function b(e){return!!(e.capabilities&32768)}i.hasFileCloneCapability=b;function w(e){return!!(e.capabilities&4)}i.hasOpenReadWriteCloseCapability=w;function U(e){return!!(e.capabilities&16)}i.hasFileReadStreamCapability=U;function k(e){return L(e)?!!(e.capabilities&16384):!1}i.hasFileAtomicReadCapability=k;var r;(function(e){e.FileExists="EntryExists",e.FileNotFound="EntryNotFound",e.FileNotADirectory="EntryNotADirectory",e.FileIsADirectory="EntryIsADirectory",e.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",e.FileTooLarge="EntryTooLarge",e.FileWriteLocked="EntryWriteLocked",e.NoPermissions="NoPermissions",e.Unavailable="Unavailable",e.Unknown="Unknown"})(r||(i.FileSystemProviderErrorCode=r={}));class s extends Error{constructor(n,t){super(n);this.code=t}}i.FileSystemProviderError=s;function _(e,n){const t=new s(e.toString(),n);return D(t,n),t}i.createFileSystemProviderError=_;function B(e){return e||_((0,c.localize)(0,null),r.Unknown)}i.ensureFileSystemProviderError=B;function D(e,n){return e.name=n?`${n} (FileSystemError)`:"FileSystemError",e}i.markAsFileSystemProviderError=D;function O(e){if(!e)return r.Unknown;if(e instanceof s)return e.code;const n=/^(.+) \(FileSystemError\)$/.exec(e.name);if(!n)return r.Unknown;switch(n[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileExceedsMemoryLimit:return r.FileExceedsMemoryLimit;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}i.toFileSystemProviderErrorCode=O;function P(e){if(e instanceof d)return e.fileOperationResult;switch(O(e)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 10;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileExceedsMemoryLimit:return 9;case r.FileTooLarge:return 7;default:return 11}}i.toFileOperationResult=P;var m;(function(e){e[e.CREATE=0]="CREATE",e[e.DELETE=1]="DELETE",e[e.MOVE=2]="MOVE",e[e.COPY=3]="COPY",e[e.WRITE=4]="WRITE"})(m||(i.FileOperation=m={}));class G{constructor(n,t,E){this.resource=n,this.operation=t,this.target=E}isOperation(n){return this.operation===n}}i.FileOperationEvent=G;var C;(function(e){e[e.UPDATED=0]="UPDATED",e[e.ADDED=1]="ADDED",e[e.DELETED=2]="DELETED"})(C||(i.FileChangeType=C={}));class Y{constructor(n,t){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=n;const E=new Map;for(const o of n){const u=E.get(o.type);switch(u?u.push([o.resource,o]):E.set(o.type,[[o.resource,o]]),o.type){case 1:this.rawAdded.push(o.resource);break;case 0:this.rawUpdated.push(o.resource);break;case 2:this.rawDeleted.push(o.resource);break}}for(const[o,u]of E)switch(o){case 1:this.added=l.TernarySearchTree.forUris(()=>t),this.added.fill(u);break;case 0:this.updated=l.TernarySearchTree.forUris(()=>t),this.updated.fill(u);break;case 2:this.deleted=l.TernarySearchTree.forUris(()=>t),this.deleted.fill(u);break}}contains(n,...t){return this.doContains(n,{includeChildren:!1},...t)}affects(n,...t){return this.doContains(n,{includeChildren:!0},...t)}doContains(n,t,...E){if(!n)return!1;const o=E.length>0;return!!((!o||E.includes(1))&&(this.added?.get(n)||t.includeChildren&&this.added?.findSuperstr(n))||(!o||E.includes(0))&&(this.updated?.get(n)||t.includeChildren&&this.updated?.findSuperstr(n))||(!o||E.includes(2))&&(this.deleted?.findSubstr(n)||t.includeChildren&&this.deleted?.findSuperstr(n)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}i.FileChangesEvent=Y;function H(e,n,t){return!e||!n||e===n||n.length>e.length?!1:(n.charAt(n.length-1)!==F.sep&&(n+=F.sep),t?(0,y.startsWithIgnoreCase)(e,n):e.indexOf(n)===0)}i.isParent=H;class d extends R.ErrorNoTelemetry{constructor(n,t,E){super(n);this.fileOperationResult=t,this.options=E}}i.FileOperationError=d;class X extends d{constructor(n,t,E){super(n,2,E);this.stat=t}}i.NotModifiedSinceFileOperationError=X;var A;(function(e){e[e.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",e[e.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",e[e.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",e[e.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",e[e.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",e[e.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",e[e.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",e[e.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",e[e.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",e[e.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",e[e.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",e[e.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A||(i.FileOperationResult=A={})),i.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},i.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},i.FILES_ASSOCIATIONS_CONFIG="files.associations",i.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(e){e[e.FILE=0]="FILE",e[e.FOLDER=1]="FOLDER",e[e.ROOT_FOLDER=2]="ROOT_FOLDER"})(N||(i.FileKind=N={})),i.ETAG_DISABLED="";function K(e){if(!(typeof e.size!="number"||typeof e.mtime!="number"))return e.mtime.toString(29)+e.size.toString(31)}i.etag=K;async function V(e,n){if(!n.hasProvider(S.URI.from({scheme:e.scheme})))return new Promise(t=>{const E=n.onDidChangeFileSystemProviderRegistrations(o=>{o.scheme===e.scheme&&o.added&&(E.dispose(),t())})})}i.whenProviderRegistered=V,i.MIN_MAX_MEMORY_SIZE_MB=2048,i.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class a{static formatSize(n){return(0,M.isNumber)(n)||(n=0),n<a.KB?(0,c.localize)(1,null,n.toFixed(0)):n<a.MB?(0,c.localize)(2,null,(n/a.KB).toFixed(2)):n<a.GB?(0,c.localize)(3,null,(n/a.MB).toFixed(2)):n<a.TB?(0,c.localize)(4,null,(n/a.GB).toFixed(2)):(0,c.localize)(5,null,(n/a.TB).toFixed(2))}}i.ByteSize=a,a.KB=1024,a.MB=a.KB*a.KB,a.GB=a.MB*a.KB,a.TB=a.GB*a.KB;var T;(function(e){e[e.IA32=0]="IA32",e[e.OTHER=1]="OTHER"})(T||(i.Arch=T={}));function Z(e){return{maxFileSize:e===0?300*a.MB:16*a.GB,maxHeapSize:e===0?700*a.MB:2*700*a.MB}}i.getPlatformLimits=Z});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/files/common/files.js.map
