define(["require","exports","fs","graceful-fs","vs/base/common/async","vs/base/common/map","vs/base/common/buffer","vs/base/common/event","vs/base/common/extpath","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/platform","vs/base/common/resources","vs/base/common/stream","vs/base/node/pfs","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/platform/files/common/files","vs/platform/files/common/io","vs/platform/files/common/diskFileSystemProvider","vs/base/common/errorMessage","vs/platform/files/node/watcher/watcherClient","vs/platform/files/node/watcher/nodejs/nodejsClient"],function(N,d,k,E,y,p,P,f,F,v,h,u,S,b,c,m,a,g,L,T,C,D){"use strict";Object.defineProperty(d,"__esModule",{value:!0}),d.DiskFileSystemProvider=void 0,(()=>{try{(0,E.gracefulify)(k)}catch(w){console.error(`Error enabling graceful-fs: ${(0,T.toErrorMessage)(w)}`)}})();class O extends L.AbstractDiskFileSystemProvider{constructor(e,r){super(e,r);this.onDidChangeCapabilities=f.Event.None,this.resourceLocks=new p.ResourceMap(t=>S.extUriBiasedIgnorePathCase.getComparisonKey(t)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,u.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:r,symbolicLink:t}=await c.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(r,t),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(e){try{const r=await c.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),t=[];return await Promise.all(r.map(async i=>{try{let o;i.isSymbolicLink()?o=(await this.stat((0,S.joinPath)(e,i.name))).type:o=this.toType(i),t.push([i.name,o])}catch(o){this.logService.trace(o)}})),t}catch(r){throw this.toFileSystemProviderError(r)}}toType(e,r){let t;return r?.dangling?t=a.FileType.Unknown:e.isFile()?t=a.FileType.File:e.isDirectory()?t=a.FileType.Directory:t=a.FileType.Unknown,r&&(t|=a.FileType.SymbolicLink),t}async createResourceLock(e){const r=this.toFilePath(e);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let t;for(;t=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await t.wait();const i=new y.Barrier;return this.resourceLocks.set(e,i),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,v.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(e)===i&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),i.open()})}async readFile(e,r){let t;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),t=await this.createResourceLock(e));const i=this.toFilePath(e);return await c.Promises.readFile(i)}catch(i){throw this.toFileSystemProviderError(i)}finally{t?.dispose()}}readFileStream(e,r,t){const i=(0,b.newWriteableStream)(o=>P.VSBuffer.concat(o.map(s=>P.VSBuffer.wrap(s))).buffer);return(0,g.readFileIntoStream)(this,e,i,o=>o.buffer,{...r,bufferSize:256*1024},t),i}async writeFile(e,r,t){let i;try{const o=this.toFilePath(e);if(!t.create||!t.overwrite){if(await c.Promises.exists(o)){if(!t.overwrite)throw(0,a.createFileSystemProviderError)((0,m.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,a.createFileSystemProviderError)((0,m.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(e,{create:!0,unlock:t.unlock}),await this.write(i,0,r,0,r.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(e,o)}finally{typeof i=="number"&&await this.close(i)}}async open(e,r){const t=this.toFilePath(e);let i;(0,a.isFileOpenForWriteOptions)(r)&&(i=await this.createResourceLock(e));let o;try{if((0,a.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:l}=await c.SymlinkSupport.stat(t);l.mode&128||await c.Promises.chmod(t,l.mode|128)}catch(l){this.logService.trace(l)}let s;if((0,a.isFileOpenForWriteOptions)(r)){if(u.isWindows)try{await c.Promises.truncate(t,0),s="r+"}catch(l){l.code!=="ENOENT"&&this.logService.trace(l)}s||(s="w")}else s="r";o=await c.Promises.open(t,s)}catch(s){throw i?.dispose(),(0,a.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(e,s):this.toFileSystemProviderError(s)}if(this.mapHandleToPos.set(o,0),(0,a.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(o,e),i){const s=this.mapHandleToLock.get(o);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${t})`),this.mapHandleToLock.set(o,i),s&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${t})`),s.dispose())}return o}async close(e){const r=this.mapHandleToLock.get(e);try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await c.Promises.fdatasync(e)}catch(t){this.canFlush=!1,this.logService.error(t)}return await c.Promises.close(e)}catch(t){throw this.toFileSystemProviderError(t)}finally{r&&(this.mapHandleToLock.get(e)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${e}`),this.mapHandleToLock.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${e}`),r.dispose())}}async read(e,r,t,i,o){const s=this.normalizePos(e,r);let l=null;try{l=(await c.Promises.read(e,t,i,o,s)).bytesRead}catch(n){throw this.toFileSystemProviderError(n)}finally{this.updatePos(e,s,l)}return l}normalizePos(e,r){return r===this.mapHandleToPos.get(e)?null:r}updatePos(e,r,t){const i=this.mapHandleToPos.get(e);typeof i=="number"&&(typeof r=="number"||(typeof t=="number"?this.mapHandleToPos.set(e,i+t):this.mapHandleToPos.delete(e)))}async write(e,r,t,i,o){return(0,y.retry)(()=>this.doWrite(e,r,t,i,o),100,3)}async doWrite(e,r,t,i,o){const s=this.normalizePos(e,r);let l=null;try{l=(await c.Promises.write(e,t,i,o,s)).bytesWritten}catch(n){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),n)}finally{this.updatePos(e,s,l)}return l}async mkdir(e){try{await c.Promises.mkdir(this.toFilePath(e))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(e,r){try{const t=this.toFilePath(e);r.recursive?await c.Promises.rm(t,c.RimRafMode.MOVE):await c.Promises.unlink(t)}catch(t){throw this.toFileSystemProviderError(t)}}async rename(e,r,t){const i=this.toFilePath(e),o=this.toFilePath(r);if(i!==o)try{await this.validateTargetDeleted(e,r,"move",t.overwrite),await c.Promises.move(i,o)}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,m.localize)(2,null,(0,h.basename)(i),(0,h.basename)((0,h.dirname)(o)),s.toString()))),this.toFileSystemProviderError(s)}}async copy(e,r,t){const i=this.toFilePath(e),o=this.toFilePath(r);if(i!==o)try{await this.validateTargetDeleted(e,r,"copy",t.overwrite),await c.Promises.copy(i,o,{preserveSymlinks:!0})}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,m.localize)(3,null,(0,h.basename)(i),(0,h.basename)((0,h.dirname)(o)),s.toString()))),this.toFileSystemProviderError(s)}}async validateTargetDeleted(e,r,t,i){const o=this.toFilePath(e),s=this.toFilePath(r);let l=!1;if(!!(this.capabilities&1024)||(l=(0,F.isEqual)(o,s,!0)),l&&t==="copy")throw(0,a.createFileSystemProviderError)((0,m.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!l&&await c.Promises.exists(s)){if(!i)throw(0,a.createFileSystemProviderError)((0,m.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(e,r){return this.doCloneFile(e,r,!1)}async doCloneFile(e,r,t){const i=this.toFilePath(e),o=this.toFilePath(r),s=!!(this.capabilities&1024);if((0,F.isEqual)(i,o,!s))return;const l=new v.DisposableStore;try{const[n,W]=await Promise.all([this.createResourceLock(e),this.createResourceLock(r)]);l.add(n),l.add(W),t&&await c.Promises.mkdir((0,h.dirname)(o),{recursive:!0}),await c.Promises.copyFile(i,o)}catch(n){if(n.code==="ENOENT"&&!t)return this.doCloneFile(e,r,!0);throw this.toFileSystemProviderError(n)}finally{l.dispose()}}createUniversalWatcher(e,r,t){return new C.UniversalWatcherClient(i=>e(i),i=>r(i),t)}createNonRecursiveWatcher(e,r,t){return new D.NodeJSWatcherClient(i=>e(i),i=>r(i),t)}toFileSystemProviderError(e){if(e instanceof a.FileSystemProviderError)return e;let r;switch(e.code){case"ENOENT":r=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=a.FileSystemProviderErrorCode.NoPermissions;break;default:r=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(e,r)}async toFileSystemProviderWriteError(e,r){let t=this.toFileSystemProviderError(r);if(e&&t.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:i}=await c.SymlinkSupport.stat(this.toFilePath(e));i.mode&128||(t=(0,a.createFileSystemProviderError)(r,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(i){this.logService.trace(i)}return t}}d.DiskFileSystemProvider=O});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/files/node/diskFileSystemProvider.js.map
