define(["require","exports","vs/base/common/event","vs/platform/files/node/diskFileSystemProvider","vs/base/common/lifecycle","vs/base/common/buffer","vs/base/common/stream","vs/base/common/cancellation"],function(F,c,h,l,o,u,m,f){"use strict";Object.defineProperty(c,"__esModule",{value:!0}),c.AbstractSessionFileWatcher=c.AbstractDiskFileSystemProviderChannel=void 0;class p extends o.Disposable{constructor(t,s){super();this.provider=t,this.logService=s,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(t,s,e){const r=this.getUriTransformer(t);switch(s){case"stat":return this.stat(r,e[0]);case"readdir":return this.readdir(r,e[0]);case"open":return this.open(r,e[0],e[1]);case"close":return this.close(e[0]);case"read":return this.read(e[0],e[1],e[2]);case"readFile":return this.readFile(r,e[0],e[1]);case"write":return this.write(e[0],e[1],e[2],e[3],e[4]);case"writeFile":return this.writeFile(r,e[0],e[1],e[2]);case"rename":return this.rename(r,e[0],e[1],e[2]);case"copy":return this.copy(r,e[0],e[1],e[2]);case"cloneFile":return this.cloneFile(r,e[0],e[1]);case"mkdir":return this.mkdir(r,e[0]);case"delete":return this.delete(r,e[0],e[1]);case"watch":return this.watch(r,e[0],e[1],e[2],e[3]);case"unwatch":return this.unwatch(e[0],e[1])}throw new Error(`IPC Command ${s} not found`)}listen(t,s,e){const r=this.getUriTransformer(t);switch(s){case"fileChange":return this.onFileChange(r,e[0]);case"readFileStream":return this.onReadFileStream(r,e[0],e[1])}throw new Error(`Unknown event ${s}`)}stat(t,s){const e=this.transformIncoming(t,s,!0);return this.provider.stat(e)}readdir(t,s){const e=this.transformIncoming(t,s);return this.provider.readdir(e)}async readFile(t,s,e){const r=this.transformIncoming(t,s,!0),i=await this.provider.readFile(r,e);return u.VSBuffer.wrap(i)}onReadFileStream(t,s,e){const r=this.transformIncoming(t,s,!0),i=new f.CancellationTokenSource,n=new h.Emitter({onLastListenerRemove:()=>{i.cancel()}}),d=this.provider.readFileStream(r,e,i.token);return(0,m.listenStream)(d,{onData:a=>n.fire(u.VSBuffer.wrap(a)),onError:a=>n.fire(a),onEnd:()=>{n.fire("end"),n.dispose(),i.dispose()}}),n.event}writeFile(t,s,e,r){const i=this.transformIncoming(t,s);return this.provider.writeFile(i,e.buffer,r)}open(t,s,e){const r=this.transformIncoming(t,s,!0);return this.provider.open(r,e)}close(t){return this.provider.close(t)}async read(t,s,e){const r=u.VSBuffer.alloc(e),i=0,n=await this.provider.read(t,s,r.buffer,i,e);return[r,n]}write(t,s,e,r,i){return this.provider.write(t,s,e.buffer,r,i)}mkdir(t,s){const e=this.transformIncoming(t,s);return this.provider.mkdir(e)}delete(t,s,e){const r=this.transformIncoming(t,s);return this.provider.delete(r,e)}rename(t,s,e,r){const i=this.transformIncoming(t,s),n=this.transformIncoming(t,e);return this.provider.rename(i,n,r)}copy(t,s,e,r){const i=this.transformIncoming(t,s),n=this.transformIncoming(t,e);return this.provider.copy(i,n,r)}cloneFile(t,s,e){const r=this.transformIncoming(t,s),i=this.transformIncoming(t,e);return this.provider.cloneFile(r,i)}onFileChange(t,s){const e=new h.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(s,this.createSessionFileWatcher(t,e))},onLastListenerRemove:()=>{(0,o.dispose)(this.sessionToWatcher.get(s)),this.sessionToWatcher.delete(s)}});return e.event}async watch(t,s,e,r,i){const n=this.sessionToWatcher.get(s);if(n){const d=this.transformIncoming(t,r),a=n.watch(e,d,i);this.watchRequests.set(s+e,a)}}async unwatch(t,s){const e=t+s,r=this.watchRequests.get(e);r&&((0,o.dispose)(r),this.watchRequests.delete(e))}dispose(){super.dispose();for(const[,t]of this.watchRequests)t.dispose();this.watchRequests.clear();for(const[,t]of this.sessionToWatcher)t.dispose();this.sessionToWatcher.clear()}}c.AbstractDiskFileSystemProviderChannel=p;class w extends o.Disposable{constructor(t,s,e,r){super();this.uriTransformer=t,this.logService=e,this.environmentService=r,this.watcherRequests=new Map,this.fileWatcher=this._register(new l.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(s)}registerListeners(t){const s=this._register(new h.Emitter);this._register(s.event(e=>{t.fire(e.map(r=>({resource:this.uriTransformer.transformOutgoingURI(r.resource),type:r.type})))})),this._register(this.fileWatcher.onDidChangeFile(e=>s.fire(e))),this._register(this.fileWatcher.onDidWatchError(e=>t.fire(e)))}getRecursiveWatcherOptions(t){}getExtraExcludes(t){}watch(t,s,e){const r=this.getExtraExcludes(this.environmentService);return Array.isArray(r)&&(e.excludes=[...e.excludes,...r]),this.watcherRequests.set(t,this.fileWatcher.watch(s,e)),(0,o.toDisposable)(()=>{(0,o.dispose)(this.watcherRequests.get(t)),this.watcherRequests.delete(t)})}dispose(){super.dispose();for(const[,t]of this.watcherRequests)t.dispose();this.watcherRequests.clear()}}c.AbstractSessionFileWatcher=w});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/files/node/diskFileSystemProviderServer.js.map
