define(["require","exports","fs","vs/base/common/async","vs/base/common/cancellation","vs/base/common/extpath","vs/base/common/lifecycle","vs/base/common/normalization","vs/base/common/path","vs/base/common/platform","vs/base/node/extpath","vs/base/node/pfs","vs/platform/files/common/watcher"],function(v,C,k,y,E,F,u,$,p,b,q,r,D){"use strict";Object.defineProperty(C,"__esModule",{value:!0}),C.watchFileContents=C.NodeJSFileWatcherLibrary=void 0;class f extends u.Disposable{constructor(e,t,a,s){super();this.request=e,this.onDidFilesChange=t,this.onLogMessage=a,this.verboseLogging=s,this.throttledFileChangesWorker=new y.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.onDidFilesChange(d)),this.fileChangesDelayer=this._register(new y.ThrottledDelayer(f.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,D.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,D.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new E.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const e=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const t=await r.Promises.stat(e);this._register(await this.doWatch(e,t.isDirectory()))}catch(e){e.code!=="ENOENT"?this.error(e):this.trace(e)}}async normalizePath(e){let t=e.path;try{t=await r.Promises.realpath(e.path),e.path===t&&(t=await(0,q.realcase)(e.path)??e.path),e.path!==t&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${e.path}, real: ${t})`)}catch{}return t}async doWatch(e,t){if(b.isMacintosh&&(0,F.isEqualOrParent)(e,"/Volumes/",!0))return this.error(`Refusing to watch ${e} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),u.Disposable.None;const a=new E.CancellationTokenSource(this.cts.token);let s=new u.DisposableStore;try{const d=(0,p.basename)(e),h=(0,k.watch)(e);s.add((0,u.toDisposable)(()=>{h.removeAllListeners(),h.close()})),this.trace(`Started watching: '${e}'`);const c=new Set;if(t)try{for(const o of await r.Promises.readdir(e))c.add(o)}catch(o){this.error(o)}const g=new Map;s.add((0,u.toDisposable)(()=>{for(const[,o]of g)o.dispose();g.clear()})),h.on("error",(o,m)=>{this.error(`Failed to watch ${e} for changes using fs.watch() (${o}, ${m})`),this.dispose()}),h.on("change",(o,m)=>{if(a.token.isCancellationRequested)return;this.trace(`[raw] ["${o}"] ${m}`);let i="";if(m&&(i=m.toString(),b.isMacintosh&&(i=(0,$.normalizeNFC)(i))),!(!i||o!=="change"&&o!=="rename"))if(t)if(o==="rename"){g.get(i)?.dispose();const l=setTimeout(async()=>{if(g.delete(i),i===d&&!await r.Promises.exists(e)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const w=await this.existsChildStrictCase((0,p.join)(e,i));if(a.token.isCancellationRequested)return;let n;w?c.has(i)?n=0:(n=1,c.add(i)):(c.delete(i),n=2),this.onFileChange({path:(0,p.join)(this.request.path,i),type:n})},f.FILE_DELETE_HANDLER_DELAY);g.set(i,(0,u.toDisposable)(()=>clearTimeout(l)))}else{let l;c.has(i)?l=0:(l=1,c.add(i)),this.onFileChange({path:(0,p.join)(this.request.path,i),type:l})}else if(o==="rename"||i!==d){const l=setTimeout(async()=>{const w=await r.Promises.exists(e);a.token.isCancellationRequested||(w?(this.onFileChange({path:this.request.path,type:0},!0),s.add(await this.doWatch(e,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},f.FILE_DELETE_HANDLER_DELAY);s.clear(),s.add((0,u.toDisposable)(()=>clearTimeout(l)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(d){await r.Promises.exists(e)&&!a.token.isCancellationRequested&&this.error(`Failed to watch ${e} for changes using fs.watch() (${d.toString()})`)}return(0,u.toDisposable)(()=>{a.dispose(!0),s.dispose()})}async onFileChange(e,t=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${e.type===1?"[ADDED]":e.type===2?"[DELETED]":"[CHANGED]"} ${e.path}`),!t&&this.excludes.some(a=>a(e.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${e.path}`):!t&&this.includes&&this.includes.length>0&&!this.includes.some(a=>a(e.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${e.path}`):this.fileChangesBuffer.push(e);try{await this.fileChangesDelayer.trigger(async()=>{const a=this.fileChangesBuffer;this.fileChangesBuffer=[];const s=(0,D.coalesceEvents)(a);if(s.length>0){if(this.verboseLogging)for(const h of s)this.trace(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);this.throttledFileChangesWorker.work(s)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${s[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(e){if(b.isLinux)return r.Promises.exists(e);try{const t=(0,p.basename)(e);return(await r.Promises.readdir((0,p.dirname)(e))).some(s=>s===t)}catch(t){return this.trace(t),!1}}setVerboseLogging(e){this.verboseLogging=e}error(e){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${e}`})}warn(e){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${e}`})}trace(e){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${e}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}C.NodeJSFileWatcherLibrary=f,f.FILE_DELETE_HANDLER_DELAY=100,f.FILE_CHANGES_HANDLER_DELAY=50;async function P(L,e,t,a,s=512){const d=await r.Promises.open(L,"r"),h=Buffer.allocUnsafe(s),c=new E.CancellationTokenSource(a);let g,o=!1;const m={path:L,excludes:[],recursive:!1},i=new f(m,l=>{(async()=>{for(const{type:w}of l)if(w===0){if(o)return;o=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:n}=await r.Promises.read(d,h,0,s,null);if(!n||c.token.isCancellationRequested)break;e(h.slice(0,n))}}catch(n){g=new Error(n),c.dispose(!0)}finally{o=!1}}})()});return await i.ready,t(),new Promise((l,w)=>{c.token.onCancellationRequested(async()=>{i.dispose();try{await r.Promises.close(d)}catch(n){g=new Error(n)}g?w(g):l()})})}C.watchFileContents=P});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/files/node/watcher/nodejs/nodejsWatcherLib.js.map
