define(["require","exports","vs/base/common/arrays","vs/base/common/async","vs/base/common/event","vs/base/common/lifecycle","vs/nls!vs/platform/keybinding/common/abstractKeybindingService"],function(C,c,f,a,u,_,g){"use strict";Object.defineProperty(c,"__esModule",{value:!0}),c.AbstractKeybindingService=void 0;const m=/^(cursor|delete)/;class y extends _.Disposable{get onDidUpdateKeybindings(){return this._onDidUpdateKeybindings?this._onDidUpdateKeybindings.event:u.Event.None}get inChordMode(){return!!this._currentChord}constructor(e,t,r,i,s){super();this._contextKeyService=e,this._commandService=t,this._telemetryService=r,this._notificationService=i,this._logService=s,this._onDidUpdateKeybindings=this._register(new u.Emitter),this._currentChord=null,this._currentChordChecker=new a.IntervalTimer,this._currentChordStatusMessage=null,this._ignoreSingleModifiers=o.EMPTY,this._currentSingleModifier=null,this._currentSingleModifierClearTimeout=new a.TimeoutTimer,this._logging=!1}dispose(){super.dispose()}getDefaultKeybindingsContent(){return""}toggleLogging(){return this._logging=!this._logging,this._logging}_log(e){this._logging&&this._logService.info(`[KeybindingService]: ${e}`)}getDefaultKeybindings(){return this._getResolver().getDefaultKeybindings()}getKeybindings(){return this._getResolver().getKeybindings()}customKeybindingsCount(){return 0}lookupKeybindings(e){return f.coalesce(this._getResolver().lookupKeybindings(e).map(t=>t.resolvedKeybinding))}lookupKeybinding(e,t){const r=this._getResolver().lookupPrimaryKeybinding(e,t||this._contextKeyService);if(!!r)return r.resolvedKeybinding}dispatchEvent(e,t){return this._dispatch(e,t)}softDispatch(e,t){const r=this.resolveKeyboardEvent(e);if(r.isChord())return console.warn("Unexpected keyboard event mapped to a chord"),null;const[i]=r.getDispatchParts();if(i===null)return null;const s=this._contextKeyService.getContext(t),d=this._currentChord?this._currentChord.keypress:null;return this._getResolver().resolve(s,d,i)}_enterChordMode(e,t){this._currentChord={keypress:e,label:t},this._currentChordStatusMessage=this._notificationService.status(g.localize(0,null,t));const r=Date.now();this._currentChordChecker.cancelAndSet(()=>{if(!this._documentHasFocus()){this._leaveChordMode();return}Date.now()-r>5e3&&this._leaveChordMode()},500)}_leaveChordMode(){this._currentChordStatusMessage&&(this._currentChordStatusMessage.dispose(),this._currentChordStatusMessage=null),this._currentChordChecker.cancel(),this._currentChord=null}dispatchByUserSettingsLabel(e,t){this._log(`/ Dispatching keybinding triggered via menu entry accelerator - ${e}`);const r=this.resolveUserBinding(e);r.length===0?this._log(`\\ Could not resolve - ${e}`):this._doDispatch(r[0],t,!1)}_dispatch(e,t){return this._doDispatch(this.resolveKeyboardEvent(e),t,!1)}_singleModifierDispatch(e,t){const r=this.resolveKeyboardEvent(e),[i]=r.getSingleModifierDispatchParts();if(i)return this._ignoreSingleModifiers.has(i)?(this._log(`+ Ignoring single modifier ${i} due to it being pressed together with other keys.`),this._ignoreSingleModifiers=o.EMPTY,this._currentSingleModifierClearTimeout.cancel(),this._currentSingleModifier=null,!1):(this._ignoreSingleModifiers=o.EMPTY,this._currentSingleModifier===null?(this._log(`+ Storing single modifier for possible chord ${i}.`),this._currentSingleModifier=i,this._currentSingleModifierClearTimeout.cancelAndSet(()=>{this._log("+ Clearing single modifier due to 300ms elapsed."),this._currentSingleModifier=null},300),!1):i===this._currentSingleModifier?(this._log(`/ Dispatching single modifier chord ${i} ${i}`),this._currentSingleModifierClearTimeout.cancel(),this._currentSingleModifier=null,this._doDispatch(r,t,!0)):(this._log(`+ Clearing single modifier due to modifier mismatch: ${this._currentSingleModifier} ${i}`),this._currentSingleModifierClearTimeout.cancel(),this._currentSingleModifier=null,!1));const[s]=r.getParts();return this._ignoreSingleModifiers=new o(s),this._currentSingleModifier!==null&&this._log("+ Clearing single modifier due to other key up."),this._currentSingleModifierClearTimeout.cancel(),this._currentSingleModifier=null,!1}_doDispatch(e,t,r=!1){let i=!1;if(e.isChord())return console.warn("Unexpected keyboard event mapped to a chord"),!1;let s=null,d=null;if(r){const[l]=e.getSingleModifierDispatchParts();s=l,d=l}else[s]=e.getDispatchParts(),d=this._currentChord?this._currentChord.keypress:null;if(s===null)return this._log("\\ Keyboard event cannot be dispatched in keydown phase."),i;const S=this._contextKeyService.getContext(t),h=e.getLabel(),n=this._getResolver().resolve(S,d,s);return this._logService.trace("KeybindingService#dispatch",h,n?.commandId),n&&n.enterChord?(i=!0,this._enterChordMode(s,h),i):(this._currentChord&&(!n||!n.commandId)&&(this._notificationService.status(g.localize(1,null,this._currentChord.label,h),{hideAfter:10*1e3}),i=!0),this._leaveChordMode(),n&&n.commandId&&(n.bubble||(i=!0),typeof n.commandArgs=="undefined"?this._commandService.executeCommand(n.commandId).then(void 0,l=>this._notificationService.warn(l)):this._commandService.executeCommand(n.commandId,n.commandArgs).then(void 0,l=>this._notificationService.warn(l)),m.test(n.commandId)||this._telemetryService.publicLog2("workbenchActionExecuted",{id:n.commandId,from:"keybinding"})),i)}mightProducePrintableCharacter(e){return e.ctrlKey||e.metaKey?!1:e.keyCode>=31&&e.keyCode<=56||e.keyCode>=21&&e.keyCode<=30}}c.AbstractKeybindingService=y;class o{constructor(e){this._ctrlKey=e?e.ctrlKey:!1,this._shiftKey=e?e.shiftKey:!1,this._altKey=e?e.altKey:!1,this._metaKey=e?e.metaKey:!1}has(e){switch(e){case"ctrl":return this._ctrlKey;case"shift":return this._shiftKey;case"alt":return this._altKey;case"meta":return this._metaKey}}}o.EMPTY=new o(null)});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/keybinding/common/abstractKeybindingService.js.map
