define(["require","exports","vs/base/common/errorMessage","vs/base/common/event","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation"],function(M,o,u,n,a,v,h){"use strict";Object.defineProperty(o,"__esModule",{value:!0}),o.LogLevelToString=o.parseLogLevel=o.getLogLevel=o.NullLogService=o.AbstractLoggerService=o.LogService=o.MultiplexLogService=o.AdapterLogger=o.ConsoleLogger=o.ConsoleMainLogger=o.AbstractMessageLogger=o.AbstractLogger=o.format=o.log=o.DEFAULT_LOG_LEVEL=o.LogLevel=o.ILoggerService=o.ILogService=void 0,o.ILogService=(0,h.createDecorator)("logService"),o.ILoggerService=(0,h.createDecorator)("loggerService");function l(){return new Date().toISOString()}var t;(function(i){i[i.Trace=0]="Trace",i[i.Debug=1]="Debug",i[i.Info=2]="Info",i[i.Warning=3]="Warning",i[i.Error=4]="Error",i[i.Critical=5]="Critical",i[i.Off=6]="Off"})(t||(o.LogLevel=t={})),o.DEFAULT_LOG_LEVEL=t.Info;function b(i,e,r){switch(e){case t.Trace:i.trace(r);break;case t.Debug:i.debug(r);break;case t.Info:i.info(r);break;case t.Warning:i.warn(r);break;case t.Error:i.error(r);break;case t.Critical:i.critical(r);break;default:throw new Error("Invalid log level")}}o.log=b;function g(i){let e="";for(let r=0;r<i.length;r++){let s=i[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}e+=(r>0?" ":"")+s}return e}o.format=g;class c extends a.Disposable{constructor(){super(...arguments);this.level=o.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}o.AbstractLogger=c;class d extends c{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...r){this.checkLogLevel(t.Trace)&&this.log(t.Trace,g([e,...r]))}debug(e,...r){this.checkLogLevel(t.Debug)&&this.log(t.Debug,g([e,...r]))}info(e,...r){this.checkLogLevel(t.Info)&&this.log(t.Info,g([e,...r]))}warn(e,...r){this.checkLogLevel(t.Warning)&&this.log(t.Warning,g([e,...r]))}error(e,...r){if(this.checkLogLevel(t.Error))if(e instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=e.stack,this.log(t.Error,g(s))}else this.log(t.Error,g([e,...r]))}critical(e,...r){this.checkLogLevel(t.Critical)&&this.log(t.Critical,g([e,...r]))}flush(){}}o.AbstractMessageLogger=d;class E extends c{constructor(e=o.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!v.isWindows}trace(e,...r){this.getLevel()<=t.Trace&&(this.useColors?console.log(`[90m[main ${l()}][0m`,e,...r):console.log(`[main ${l()}]`,e,...r))}debug(e,...r){this.getLevel()<=t.Debug&&(this.useColors?console.log(`[90m[main ${l()}][0m`,e,...r):console.log(`[main ${l()}]`,e,...r))}info(e,...r){this.getLevel()<=t.Info&&(this.useColors?console.log(`[90m[main ${l()}][0m`,e,...r):console.log(`[main ${l()}]`,e,...r))}warn(e,...r){this.getLevel()<=t.Warning&&(this.useColors?console.warn(`[93m[main ${l()}][0m`,e,...r):console.warn(`[main ${l()}]`,e,...r))}error(e,...r){this.getLevel()<=t.Error&&(this.useColors?console.error(`[91m[main ${l()}][0m`,e,...r):console.error(`[main ${l()}]`,e,...r))}critical(e,...r){this.getLevel()<=t.Critical&&(this.useColors?console.error(`[90m[main ${l()}][0m`,e,...r):console.error(`[main ${l()}]`,e,...r))}dispose(){}flush(){}}o.ConsoleMainLogger=E;class S extends c{constructor(e=o.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...r){this.getLevel()<=t.Trace&&console.log("%cTRACE","color: #888",e,...r)}debug(e,...r){this.getLevel()<=t.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...r)}info(e,...r){this.getLevel()<=t.Info&&console.log("%c INFO","color: #33f",e,...r)}warn(e,...r){this.getLevel()<=t.Warning&&console.log("%c WARN","color: #993",e,...r)}error(e,...r){this.getLevel()<=t.Error&&console.log("%c  ERR","color: #f33",e,...r)}critical(e,...r){this.getLevel()<=t.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...r)}dispose(){}flush(){}}o.ConsoleLogger=S;class C extends c{constructor(e,r=o.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(r)}trace(e,...r){this.getLevel()<=t.Trace&&this.adapter.log(t.Trace,[this.extractMessage(e),...r])}debug(e,...r){this.getLevel()<=t.Debug&&this.adapter.log(t.Debug,[this.extractMessage(e),...r])}info(e,...r){this.getLevel()<=t.Info&&this.adapter.log(t.Info,[this.extractMessage(e),...r])}warn(e,...r){this.getLevel()<=t.Warning&&this.adapter.log(t.Warning,[this.extractMessage(e),...r])}error(e,...r){this.getLevel()<=t.Error&&this.adapter.log(t.Error,[this.extractMessage(e),...r])}critical(e,...r){this.getLevel()<=t.Critical&&this.adapter.log(t.Critical,[this.extractMessage(e),...r])}extractMessage(e){return typeof e=="string"?e:(0,u.toErrorMessage)(e,this.getLevel()<=t.Trace)}dispose(){}flush(){}}o.AdapterLogger=C;class m extends c{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const r of this.logServices)r.setLevel(e);super.setLevel(e)}trace(e,...r){for(const s of this.logServices)s.trace(e,...r)}debug(e,...r){for(const s of this.logServices)s.debug(e,...r)}info(e,...r){for(const s of this.logServices)s.info(e,...r)}warn(e,...r){for(const s of this.logServices)s.warn(e,...r)}error(e,...r){for(const s of this.logServices)s.error(e,...r)}critical(e,...r){for(const s of this.logServices)s.critical(e,...r)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}o.MultiplexLogService=m;class D extends a.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...r){this.logger.trace(e,...r)}debug(e,...r){this.logger.debug(e,...r)}info(e,...r){this.logger.info(e,...r)}warn(e,...r){this.logger.warn(e,...r)}error(e,...r){this.logger.error(e,...r)}critical(e,...r){this.logger.critical(e,...r)}flush(){this.logger.flush()}}o.LogService=D;class w extends a.Disposable{constructor(e,r){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(f=>f.setLevel(s))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,r){let s=this.loggers.get(e.toString());return s||(s=this.doCreateLogger(e,r?.always?t.Trace:this.logLevel,r),this.loggers.set(e.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}o.AbstractLoggerService=w;class T{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(e){}getLevel(){return t.Info}trace(e,...r){}debug(e,...r){}info(e,...r){}warn(e,...r){}error(e,...r){}critical(e,...r){}dispose(){}flush(){}}o.NullLogService=T;function A(i){if(i.verbose)return t.Trace;if(typeof i.logLevel=="string"){const e=L(i.logLevel.toLowerCase());if(e!==void 0)return e}return o.DEFAULT_LOG_LEVEL}o.getLogLevel=A;function L(i){switch(i){case"trace":return t.Trace;case"debug":return t.Debug;case"info":return t.Info;case"warn":return t.Warning;case"error":return t.Error;case"critical":return t.Critical;case"off":return t.Off}}o.parseLogLevel=L;function I(i){switch(i){case t.Trace:return"trace";case t.Debug:return"debug";case t.Info:return"info";case t.Warning:return"warn";case t.Error:return"error";case t.Critical:return"critical";case t.Off:return"off"}}o.LogLevelToString=I});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/log/common/log.js.map
