define(["require","exports","vs/base/common/async","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/errors","vs/base/common/event","vs/base/common/lifecycle","vs/base/common/uuid","vs/base/parts/ipc/common/ipc.net","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts"],function(ce,s,x,C,m,P,B,w,v,F,d,Y){"use strict";Object.defineProperty(s,"__esModule",{value:!0}),s.ExtensionHostPersistentConnection=s.ManagementPersistentConnection=s.PersistentConnection=s.ReconnectionPermanentFailureEvent=s.ConnectionGainEvent=s.ReconnectionRunningEvent=s.ReconnectionWaitEvent=s.ConnectionLostEvent=s.PersistentConnectionEventType=s.connectRemoteAgentTunnel=s.connectRemoteAgentExtensionHost=s.connectRemoteAgentManagement=s.ConnectionType=void 0;const z=30*1e3;var b;(function(e){e[e.Management=1]="Management",e[e.ExtensionHost=2]="ExtensionHost",e[e.Tunnel=3]="Tunnel"})(b||(s.ConnectionType=b={}));function $(e){switch(e){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function D(e){const n=new m.CancellationTokenSource;return setTimeout(()=>n.cancel(),e),n.token}function K(e,n){if(e.isCancellationRequested||n.isCancellationRequested)return m.CancellationToken.Cancelled;const t=new m.CancellationTokenSource;return e.onCancellationRequested(()=>t.cancel()),n.onCancellationRequested(()=>t.cancel()),t.token}class _{get didTimeout(){return this._state==="timedout"}constructor(n){this._state="pending",this._disposables=new w.DisposableStore,this.promise=new Promise((t,o)=>{this._resolvePromise=t,this._rejectPromise=o}),n.isCancellationRequested?this._timeout():this._disposables.add(n.onCancellationRequested(()=>this._timeout()))}registerDisposable(n){this._state==="pending"?this._disposables.add(n):n.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const n=new Error("Time limit reached");return n.code="ETIMEDOUT",n.syscall="connect",n}resolve(n){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(n))}reject(n){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(n))}}function Q(e,n){const t=new _(n);return t.registerDisposable(e.onControlMessage(o=>{const r=JSON.parse(o.toString()),i=V(r);i?t.reject(i):t.resolve(r)})),t.promise}function X(e,n,t,o,r,i,c,g){const u=new _(g);return n.connect(t,o,r,i,c,(h,a)=>{u.didTimeout?(h&&e.error(h),a?.dispose()):h||!a?u.reject(h):u.resolve(a)}),u.promise}function E(e,n){const t=new _(n);return e.then(o=>{t.didTimeout||t.resolve(o)},o=>{t.didTimeout||t.reject(o)}),t.promise}async function A(e,n,t,o){const r=y(e,n);e.logService.trace(`${r} 1/6. invoking socketFactory.connect().`);let i;try{i=await X(e.logService,e.socketFactory,e.host,e.port,(0,Y.getRemoteServerRootPath)(e),`reconnectionToken=${e.reconnectionToken}&reconnection=${e.reconnectionProtocol?"true":"false"}`,`renderer-${$(n)}-${e.reconnectionToken}`,o)}catch(a){throw e.logService.error(`${r} socketFactory.connect() failed or timed out. Error:`),e.logService.error(a),a}e.logService.trace(`${r} 2/6. socketFactory.connect() was successful.`);let c,g;e.reconnectionProtocol?(e.reconnectionProtocol.beginAcceptReconnection(i,null),c=e.reconnectionProtocol,g=!1):(c=new F.PersistentProtocol(i,null),g=!0),e.logService.trace(`${r} 3/6. sending AuthRequest control message.`);const u=await E(e.signService.createNewMessage((0,v.generateUuid)()),o),h={type:"auth",auth:e.connectionToken||"00000000000000000000",data:u.data};c.sendControl(C.VSBuffer.fromString(JSON.stringify(h)));try{const a=await Q(c,K(o,D(1e4)));if(a.type!=="sign"||typeof a.data!="string"){const f=new Error("Unexpected handshake message");throw f.code="VSCODE_CONNECTION_ERROR",f}if(e.logService.trace(`${r} 4/6. received SignRequest control message.`),!await E(e.signService.validate(u,a.signedData),o)){const f=new Error("Refused to connect to unsupported server");throw f.code="VSCODE_CONNECTION_ERROR",f}const re=await E(e.signService.sign(a.data),o),J={type:"connectionType",commit:e.commit,signedData:re,desiredConnectionType:n};return t&&(J.args=t),e.logService.trace(`${r} 5/6. sending ConnectionTypeRequest control message.`),c.sendControl(C.VSBuffer.fromString(JSON.stringify(J))),{protocol:c,ownsProtocol:g}}catch(a){throw a&&a.code==="ETIMEDOUT"&&(e.logService.error(`${r} the handshake timed out. Error:`),e.logService.error(a)),a&&a.code==="VSCODE_CONNECTION_ERROR"&&(e.logService.error(`${r} received error control message when negotiating connection. Error:`),e.logService.error(a)),g&&k(c),a}}async function O(e,n,t,o){const r=Date.now(),i=y(e,n),{protocol:c,ownsProtocol:g}=await A(e,n,t,o),u=new _(o);return u.registerDisposable(c.onControlMessage(h=>{const a=JSON.parse(h.toString()),p=V(a);p?(e.logService.error(`${i} received error control message when negotiating connection. Error:`),e.logService.error(p),g&&k(c),u.reject(p)):(e.reconnectionProtocol&&e.reconnectionProtocol.endAcceptReconnection(),e.logService.trace(`${i} 6/6. handshake finished, connection is up and running after ${G(r)}!`),u.resolve({protocol:c,firstMessage:a}))})),u.promise}async function M(e,n){const{protocol:t}=await O(e,1,void 0,n);return{protocol:t}}async function N(e,n,t){const{protocol:o,firstMessage:r}=await O(e,2,n,t),i=r&&r.debugPort;return{protocol:o,debugPort:i}}async function Z(e,n,t){const o=Date.now(),r=y(e,3),{protocol:i}=await A(e,3,n,t);return e.logService.trace(`${r} 6/6. handshake finished, connection is up and running after ${G(o)}!`),i}async function S(e,n,t){const{host:o,port:r,connectionToken:i}=await e.addressProvider.getAddress();return{commit:e.commit,quality:e.quality,host:o,port:r,connectionToken:i,reconnectionToken:n,reconnectionProtocol:t,socketFactory:e.socketFactory,signService:e.signService,logService:e.logService}}async function ee(e,n,t){try{const o=(0,v.generateUuid)(),r=await S(e,o,null),{protocol:i}=await M(r,m.CancellationToken.None);return new U(e,n,t,o,i)}catch(o){throw e.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),e.logService.error(o),l.triggerPermanentFailure(0,0,d.RemoteAuthorityResolverError.isHandled(o)),o}}s.connectRemoteAgentManagement=ee;async function ne(e,n){try{const t=(0,v.generateUuid)(),o=await S(e,t,null),{protocol:r,debugPort:i}=await N(o,n,m.CancellationToken.None);return new j(e,n,t,r,i)}catch(t){throw e.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),e.logService.error(t),l.triggerPermanentFailure(0,0,d.RemoteAuthorityResolverError.isHandled(t)),t}}s.connectRemoteAgentExtensionHost=ne;async function te(e,n,t){const o=await S(e,(0,v.generateUuid)(),null);return await Z(o,{host:n,port:t},m.CancellationToken.None)}s.connectRemoteAgentTunnel=te;function oe(e){return(0,x.createCancelablePromise)(n=>new Promise((t,o)=>{const r=setTimeout(t,e*1e3);n.onCancellationRequested(()=>{clearTimeout(r),t()})}))}var I;(function(e){e[e.ConnectionLost=0]="ConnectionLost",e[e.ReconnectionWait=1]="ReconnectionWait",e[e.ReconnectionRunning=2]="ReconnectionRunning",e[e.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",e[e.ConnectionGain=4]="ConnectionGain"})(I||(s.PersistentConnectionEventType=I={}));class L{constructor(n,t){this.reconnectionToken=n,this.millisSinceLastIncomingData=t,this.type=0}}s.ConnectionLostEvent=L;class H{constructor(n,t,o,r){this.reconnectionToken=n,this.millisSinceLastIncomingData=t,this.durationSeconds=o,this.cancellableTimer=r,this.type=1}skipWait(){this.cancellableTimer.cancel()}}s.ReconnectionWaitEvent=H;class q{constructor(n,t,o){this.reconnectionToken=n,this.millisSinceLastIncomingData=t,this.attempt=o,this.type=2}}s.ReconnectionRunningEvent=q;class T{constructor(n,t,o){this.reconnectionToken=n,this.millisSinceLastIncomingData=t,this.attempt=o,this.type=4}}s.ConnectionGainEvent=T;class W{constructor(n,t,o,r){this.reconnectionToken=n,this.millisSinceLastIncomingData=t,this.attempt=o,this.handled=r,this.type=3}}s.ReconnectionPermanentFailureEvent=W;class l extends w.Disposable{static triggerPermanentFailure(n,t,o){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=n,this._permanentFailureAttempt=t,this._permanentFailureHandled=o,this._instances.forEach(r=>r._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(n=>n._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(n=>n._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||l._permanentFailure}constructor(n,t,o,r,i){super();this._connectionType=n,this._options=t,this.reconnectionToken=o,this.protocol=r,this._reconnectionFailureIsFatal=i,this._onDidStateChange=this._register(new B.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new T(this.reconnectionToken,0,0)),this._register(r.onSocketClose(c=>{const g=R(this._connectionType,this.reconnectionToken,!0);c?c.type===0?(this._options.logService.info(`${g} received socket close event (hadError: ${c.hadError}).`),c.error&&this._options.logService.error(c.error)):(this._options.logService.info(`${g} received socket close event (wasClean: ${c.wasClean}, code: ${c.code}, reason: ${c.reason}).`),c.event&&this._options.logService.error(c.event)):this._options.logService.info(`${g} received socket close event.`),this._beginReconnecting()})),this._register(r.onSocketTimeout(()=>{const c=R(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${c} received socket timeout event.`),this._beginReconnecting()})),l._instances.push(this),this._register((0,w.toDisposable)(()=>{const c=l._instances.indexOf(this);c>=0&&l._instances.splice(c,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(l._permanentFailureMillisSinceLastIncomingData,l._permanentFailureAttempt,l._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const n=R(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${n} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const t=[0,5,5,10,10,10,10,10,30];let o=-1;do{o++;const r=o<t.length?t[o]:t[t.length-1];try{if(r>0){const c=oe(r);this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),r,c)),this._options.logService.info(`${n} waiting for ${r} seconds before reconnecting...`);try{await c}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${n} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),o+1)),this._options.logService.info(`${n} resolving connection...`);const i=await S(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${n} connecting to ${i.host}:${i.port}...`),await this._reconnect(i,D(z)),this._options.logService.info(`${n} reconnected!`),this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),o+1));break}catch(i){if(i.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${n} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(i),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),o+1,!1);break}if(o>360){this._options.logService.error(`${n} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(i),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),o+1,!1);break}if(d.RemoteAuthorityResolverError.isTemporarilyNotAvailable(i)){this._options.logService.info(`${n} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(i);continue}if((i.code==="ETIMEDOUT"||i.code==="ENETUNREACH"||i.code==="ECONNREFUSED"||i.code==="ECONNRESET")&&i.syscall==="connect"){this._options.logService.info(`${n} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(i);continue}if((0,P.isCancellationError)(i)){this._options.logService.info(`${n} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(i);continue}if(i instanceof d.RemoteAuthorityResolverError){this._options.logService.error(`${n} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(i),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),o+1,d.RemoteAuthorityResolverError.isHandled(i));break}this._options.logService.error(`${n} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(i),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),o+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(n,t,o){this._reconnectionFailureIsFatal?l.triggerPermanentFailure(n,t,o):this._gotoPermanentFailure(n,t,o)}_gotoPermanentFailure(n,t,o){this._onDidStateChange.fire(new W(this.reconnectionToken,n,t,o)),k(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}s.PersistentConnection=l,l._permanentFailure=!1,l._permanentFailureMillisSinceLastIncomingData=0,l._permanentFailureAttempt=0,l._permanentFailureHandled=!1,l._instances=[];class U extends l{constructor(n,t,o,r,i){super(1,n,r,i,!0);this.client=this._register(new F.Client(i,{remoteAuthority:t,clientId:o},n.ipcLogger))}async _reconnect(n,t){await M(n,t)}}s.ManagementPersistentConnection=U;class j extends l{constructor(n,t,o,r,i){super(2,n,o,r,!1);this._startArguments=t,this.debugPort=i}async _reconnect(n,t){await N(n,this._startArguments,t)}}s.ExtensionHostPersistentConnection=j;function k(e){try{e.acceptDisconnect();const n=e.getSocket();e.dispose(),n.dispose()}catch(n){(0,P.onUnexpectedError)(n)}}function V(e){if(e&&e.type==="error"){const n=new Error(`Connection error: ${e.reason}`);return n.code="VSCODE_CONNECTION_ERROR",n}return null}function ie(e,n){for(;e.length<n;)e+=" ";return e}function R(e,n,t){return`[remote-connection][${ie($(e),13)}][${n.substr(0,5)}\u2026][${t?"reconnect":"initial"}]`}function y(e,n){return`${R(n,e.reconnectionToken,!!e.reconnectionProtocol)}[${e.host}:${e.port}]`}function G(e){return`${Date.now()-e} ms`}});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/remote/common/remoteAgentConnection.js.map
