define(["require","exports","child_process","console","vs/base/common/buffer","vs/base/common/console","vs/base/common/errorMessage","vs/base/common/event","vs/base/common/lifecycle","vs/base/common/objects","vs/base/common/types","vs/base/common/processes","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker"],function(T,l,v,M,u,b,g,h,m,P,w,k,E,n){"use strict";Object.defineProperty(l,"__esModule",{value:!0}),l.create=void 0;function y(){const t=new D;return d({id:n.SharedProcessWorkerMessages.Ready}),{onmessage:(e,r)=>t.onMessage(e,r)}}l.create=y;class D{constructor(){this.processes=new Map}onMessage(e,r){switch(e.id){case n.SharedProcessWorkerMessages.Spawn:r&&r[0]instanceof MessagePort&&e.environment&&this.spawn(r[0],e.configuration,e.environment);break;case n.SharedProcessWorkerMessages.Terminate:this.terminate(e.configuration);break;default:o.warn(`Unexpected shared process message '${e}'`)}e.nonce&&d({id:n.SharedProcessWorkerMessages.Ack,nonce:e.nonce})}spawn(e,r,a){try{this.terminate(r);const c=new $(e,r,a);c.spawn();const i=h.Event.once(c.onDidProcessSelfTerminate)(s=>{d({id:n.SharedProcessWorkerMessages.SelfTerminated,configuration:r,message:JSON.stringify(s)})}),f=(0,E.hash)(r);this.processes.set(f,(0,m.toDisposable)(()=>{i.dispose(),c.dispose(),this.processes.delete(f)}))}catch(c){o.error(`Unexpected error forking worker process: ${(0,g.toErrorMessage)(c)}`)}}terminate(e){const r=this.processes.get((0,E.hash)(e));r&&r.dispose()}}class $ extends m.Disposable{constructor(e,r,a){super();this.port=e,this.configuration=r,this.environment=a,this._onDidProcessSelfTerminate=this._register(new h.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.child=void 0}spawn(){o.trace("Forking worker process"),this.child=(0,v.fork)(this.environment.bootstrapPath,[`--type=${this.configuration.process.type}`],{env:this.getEnv()}),o.info(`Starting worker process with pid ${this.child.pid} (type: ${this.configuration.process.type}, window: ${this.configuration.reply.windowId}).`);const e=h.Event.fromNodeEventEmitter(this.child,"error");this._register(e(s=>o.warn(`Error from child process: ${(0,g.toErrorMessage)(s)}`)));const r=h.Event.fromNodeEventEmitter(this.child,"exit",(s,p)=>({code:s,signal:p}));this._register(r(({code:s,signal:p})=>{const S=`Worker process with pid ${this.child?.pid} terminated by itself with code ${s}, signal: ${p} (type: ${this.configuration.process.type}, window: ${this.configuration.reply.windowId})`;s!==0&&p!=="SIGTERM"?o.error(S):o.info(S),this.child=void 0,this._onDidProcessSelfTerminate.fire({code:(0,w.withNullAsUndefined)(s),signal:(0,w.withNullAsUndefined)(p)})}));const a=this._register(new h.Emitter),c=h.Event.fromNodeEventEmitter(this.child,"message",s=>s);this._register(c(s=>{(0,b.isRemoteConsoleLog)(s)?(0,M.log)(s,"SharedProcess worker"):a.fire(u.VSBuffer.wrap(Buffer.from(s,"base64")))}));const i=s=>{this.child?.connected?this.child.send(s.buffer.toString("base64")):o.warn("Unable to deliver message to disconnected child")},f=a.event;this._register(f(s=>this.port.postMessage(s.buffer))),this.port.onmessage=s=>i(u.VSBuffer.wrap(s.data)),this._register((0,m.toDisposable)(()=>this.port.onmessage=null))}getEnv(){const e={...(0,P.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:this.configuration.process.moduleId,VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_PARENT_PID:String(process.pid)};return(0,k.removeDangerousEnvVariables)(e),e}dispose(){super.dispose(),!!this.child&&(this.child.kill(),o.info(`Worker process with pid ${this.child?.pid} terminated normally (type: ${this.configuration.process.type}, window: ${this.configuration.reply.windowId}).`))}}var o;(function(t){function e(i){d({id:n.SharedProcessWorkerMessages.Error,message:i})}t.error=e;function r(i){d({id:n.SharedProcessWorkerMessages.Warn,message:i})}t.warn=r;function a(i){d({id:n.SharedProcessWorkerMessages.Info,message:i})}t.info=a;function c(i){d({id:n.SharedProcessWorkerMessages.Trace,message:i})}t.trace=c})(o||(o={}));function d(t){postMessage(t)}});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain.js.map
