define(["require","exports","vs/base/common/async","vs/base/common/event","vs/base/common/lifecycle","vs/base/common/performance","vs/base/common/types","vs/base/parts/storage/common/storage","vs/platform/instantiation/common/instantiation"],function(W,a,u,S,m,y,D,c,K){"use strict";Object.defineProperty(a,"__esModule",{value:!0}),a.logStorage=a.InMemoryStorageService=a.AbstractStorageService=a.StorageTarget=a.StorageScope=a.WillSaveStateReason=a.IStorageService=a.IS_NEW_KEY=void 0,a.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";a.IStorageService=(0,K.createDecorator)("storageService");var g;(function(r){r[r.NONE=0]="NONE",r[r.SHUTDOWN=1]="SHUTDOWN"})(g||(a.WillSaveStateReason=g={}));var w;(function(r){r[r.GLOBAL=0]="GLOBAL",r[r.WORKSPACE=1]="WORKSPACE"})(w||(a.StorageScope=w={}));var b;(function(r){r[r.USER=0]="USER",r[r.MACHINE=1]="MACHINE"})(b||(a.StorageTarget=b={}));class h extends m.Disposable{constructor(e={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super();this.options=e,this._onDidChangeValue=this._register(new S.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new S.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new S.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new u.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new m.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,u.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,m.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,y.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,y.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(e,t){t===d?(e===0?this._globalKeyTargets=void 0:e===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:e})):this._onDidChangeValue.fire({scope:e,key:t,target:this.getKeyTargets(e)[t]})}emitWillSaveState(e){this._onWillSaveState.fire({reason:e})}get(e,t,s){return this.getStorage(t)?.get(e,s)}getBoolean(e,t,s){return this.getStorage(t)?.getBoolean(e,s)}getNumber(e,t,s){return this.getStorage(t)?.getNumber(e,s)}store(e,t,s,i){if((0,D.isUndefinedOrNull)(t)){this.remove(e,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(e,s,i),this.getStorage(s)?.set(e,t)})}remove(e,t){this.withPausedEmitters(()=>{this.updateKeyTarget(e,t,void 0),this.getStorage(t)?.delete(e)})}withPausedEmitters(e){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{e()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(e,t){const s=[],i=this.getKeyTargets(e);for(const l of Object.keys(i))i[l]===t&&s.push(l);return s}updateKeyTarget(e,t,s){const i=this.getKeyTargets(t);typeof s=="number"?i[e]!==s&&(i[e]=s,this.getStorage(t)?.set(d,JSON.stringify(i))):typeof i[e]=="number"&&(delete i[e],this.getStorage(t)?.set(d,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(e){return e===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(e){const t=this.get(d,e);if(t)try{return JSON.parse(t)}catch{}return Object.create(null)}isNew(e){return this.getBoolean(a.IS_NEW_KEY,e)===!0}async flush(e=g.NONE){this._onWillSaveState.fire({reason:e});const t=this.getStorage(0),s=this.getStorage(1);switch(e){case g.NONE:await u.Promises.settled([t?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await u.Promises.settled([t?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async logStorage(){const e=this.getStorage(0)?.items??new Map,t=this.getStorage(1)?.items??new Map;return T(e,t,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}a.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends h{constructor(){super();this.globalStorage=this._register(new c.Storage(new c.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new c.Storage(new c.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(e=>this.emitDidChangeValue(1,e))),this._register(this.globalStorage.onDidChangeStorage(e=>this.emitDidChangeValue(0,e)))}getStorage(e){return e===0?this.globalStorage:this.workspaceStorage}getLogDetails(e){return e===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(e){}}a.InMemoryStorageService=p;async function T(r,e,t,s){const i=o=>{try{return JSON.parse(o)}catch{return o}},l=new Map,f=new Map;r.forEach((o,n)=>{l.set(n,o),f.set(n,i(o))});const _=new Map,I=new Map;e.forEach((o,n)=>{_.set(n,o),I.set(n,i(o))}),console.group(`Storage: Global (path: ${t})`);let E=[];l.forEach((o,n)=>{E.push({key:n,value:o})}),console.table(E),console.groupEnd(),console.log(f),console.group(`Storage: Workspace (path: ${s})`);let v=[];_.forEach((o,n)=>{v.push({key:n,value:o})}),console.table(v),console.groupEnd(),console.log(I)}a.logStorage=T});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/storage/common/storage.js.map
