define(["require","exports","vs/base/common/arrays","vs/base/common/async","vs/base/common/event","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/stopwatch","vs/base/common/uri","vs/base/node/pfs","vs/base/parts/storage/common/storage","vs/base/parts/storage/node/storage","vs/platform/log/common/log","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/workspace/common/workspace"],function(C,o,w,p,u,v,g,E,y,h,r,l,D,m,c,f){"use strict";Object.defineProperty(o,"__esModule",{value:!0}),o.InMemoryStorageMain=o.WorkspaceStorageMain=o.GlobalStorageMain=void 0;class n extends v.Disposable{get storage(){return this._storage}constructor(e,t){super();this.logService=e,this.fileService=t,this._onDidChangeStorage=this._register(new u.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new u.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new r.Storage(new r.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new p.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=r.StorageState.None}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===r.StorageState.None)try{const e=await this.doCreate();this._storage.dispose(),this._storage=e,this._register(e.onDidChangeStorage(s=>this._onDidChangeStorage.fire({key:s}))),await this.doInit(e);const t=e.getBoolean(m.IS_NEW_KEY);t===void 0?e.set(m.IS_NEW_KEY,!0):t&&e.set(m.IS_NEW_KEY,!1)}catch(e){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${e}`)}finally{this.state=r.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===D.LogLevel.Trace?e=>this.logService.trace(e):void 0,logError:e=>this.logService.error(e)}}doInit(e){return e.init()}get items(){return this._storage.items}get(e,t){return this._storage.get(e,t)}set(e,t){return this._storage.set(e,t)}delete(e){return this._storage.delete(e)}async close(){const e=new E.StopWatch(!1);await this.doClose(),e.stop(),e.elapsed()>n.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(e),this._onDidCloseStorage.fire()}async logSlowClose(e){if(!!this.path)try{const t=(0,w.top)(Array.from(this._storage.items.entries()).map(([i,S])=>({key:i,length:S.length})),(i,S)=>S.length-i.length,5).map(i=>`${i.key}:${i.length}`).join(", "),s=(await this.fileService.stat(y.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${e.elapsed()}ms, DB size: ${s}b, Large Keys: ${t}`)}catch(t){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=r.StorageState.Closed,await this._storage.close()}}n.LOG_SLOW_CLOSE_THRESHOLD=2e3;class d extends n{get path(){if(!this.options.useInMemoryStorage)return(0,g.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME)}constructor(e,t,s,i){super(t,i);this.options=e,this.environmentService=s}async doCreate(){return new r.Storage(new l.SQLiteStorageDatabase(this.path??l.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}async doInit(e){await super.doInit(e),this.updateTelemetryState(e)}updateTelemetryState(e){e.get(c.firstSessionDateStorageKey,void 0)===void 0&&e.set(c.firstSessionDateStorageKey,new Date().toUTCString());const s=e.get(c.currentSessionDateStorageKey,void 0),i=new Date().toUTCString();e.set(c.lastSessionDateStorageKey,typeof s=="undefined"?null:s),e.set(c.currentSessionDateStorageKey,i)}}o.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class a extends n{get path(){if(!this.options.useInMemoryStorage)return(0,g.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,a.WORKSPACE_STORAGE_NAME)}constructor(e,t,s,i,S){super(s,S);this.workspace=e,this.options=t,this.environmentService=i}async doCreate(){const{storageFilePath:e,wasCreated:t}=await this.prepareWorkspaceStorageFolder();return new r.Storage(new l.SQLiteStorageDatabase(e,{logging:this.createLoggingOptions()}),{hint:t?r.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:l.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const e=(0,g.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),t=(0,g.join)(e,a.WORKSPACE_STORAGE_NAME);return await h.Promises.exists(e)?{storageFilePath:t,wasCreated:!1}:(await h.Promises.mkdir(e,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(e),{storageFilePath:t,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(e){let t;if((0,f.isSingleFolderWorkspaceIdentifier)(this.workspace)?t={folder:this.workspace.uri.toString()}:(0,f.isWorkspaceIdentifier)(this.workspace)&&(t={workspace:this.workspace.configPath.toString()}),t)try{const s=(0,g.join)(e,a.WORKSPACE_META_NAME);await h.Promises.exists(s)||await h.Promises.writeFile(s,JSON.stringify(t,void 0,2))}catch(s){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}o.WorkspaceStorageMain=a,a.WORKSPACE_STORAGE_NAME="state.vscdb",a.WORKSPACE_META_NAME="workspace.json";class P extends n{get path(){}async doCreate(){return new r.Storage(new r.InMemoryStorageDatabase)}}o.InMemoryStorageMain=P});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/storage/electron-main/storageMain.js.map
