define(["require","exports","child_process","vs/base/common/async","vs/base/common/event","vs/base/common/lifecycle","vs/base/common/platform","vs/base/node/shell","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalEnvironment","xterm-headless","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProcess","vs/nls!vs/platform/terminal/node/ptyService","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/common/terminalAutoResponder","vs/base/common/errors","vs/platform/terminal/common/xterm/shellIntegrationAddon"],function(T,_,z,y,o,m,v,N,Q,R,O,x,$,b,k,B,A,L,q,M){"use strict";Object.defineProperty(_,"__esModule",{value:!0}),_.PersistentTerminalProcess=_.PtyService=void 0;let D,S;class W extends m.Disposable{constructor(e,t,s){super();this._lastPtyId=e,this._logService=t,this._reconnectConstants=s,this._ptys=new Map,this._workspaceLayoutInfos=new Map,this._revivedPtyIdMap=new Map,this._autoReplies=new Map,this._onHeartbeat=this._register(new o.Emitter),this.onHeartbeat=this._onHeartbeat.event,this._onProcessData=this._register(new o.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReplay=this._register(new o.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessReady=this._register(new o.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessExit=this._register(new o.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessOrphanQuestion=this._register(new o.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new o.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new o.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._register((0,m.toDisposable)(()=>{for(const i of this._ptys.values())i.shutdown(!0);this._ptys.clear()})),this._detachInstanceRequestStore=this._register(new Q.RequestStore(void 0,this._logService)),this._detachInstanceRequestStore.onCreateRequest(this._onDidRequestDetach.fire,this._onDidRequestDetach)}async refreshIgnoreProcessNames(e){A.ignoreProcessNames.length=0,A.ignoreProcessNames.push(...e)}async requestDetachInstance(e,t){return this._detachInstanceRequestStore.createRequest({workspaceId:e,instanceId:t})}async acceptDetachInstanceReply(e,t){let s;const i=this._ptys.get(t);i&&(s=await this._buildProcessDetails(t,i)),this._detachInstanceRequestStore.acceptReply(e,s)}async serializeTerminalState(e){const t=[];for(const[i,r]of this._ptys.entries())r.hasWrittenData&&e.indexOf(i)!==-1&&t.push(y.Promises.withAsyncBody(async c=>{c({id:i,shellLaunchConfig:r.shellLaunchConfig,processDetails:await this._buildProcessDetails(i,r),processLaunchConfig:r.processLaunchOptions,unicodeVersion:r.unicodeVersion,replayEvent:await r.serializeNormalBuffer(),timestamp:Date.now()})}));const s={version:1,state:await Promise.all(t)};return JSON.stringify(s)}async reviveTerminalProcesses(e,t){for(const s of e){const i=(0,B.localize)(0,null,new Date(s.timestamp).toLocaleDateString(t),new Date(s.timestamp).toLocaleTimeString(t)),r=await this.createProcess({...s.shellLaunchConfig,cwd:s.processDetails.cwd,color:s.processDetails.color,icon:s.processDetails.icon,name:s.processDetails.titleSource===R.TitleEventSource.Api?s.processDetails.title:void 0,initialText:s.replayEvent.events[0].data+`[0m

\r[1;48;5;252;38;5;234m `+i+` [K[0m
\r`},s.processDetails.cwd,s.replayEvent.events[0].cols,s.replayEvent.events[0].rows,s.unicodeVersion,s.processLaunchConfig.env,s.processLaunchConfig.executableEnv,s.processLaunchConfig.options,!0,s.processDetails.workspaceId,s.processDetails.workspaceName,!0);this._revivedPtyIdMap.set(s.id,{newId:r,state:s})}}async shutdownAll(){this.dispose()}async createProcess(e,t,s,i,r,c,u,P,f,d,I,w){if(e.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const a=++this._lastPtyId,p=new k.TerminalProcess(e,t,s,i,c,u,P,this._logService);p.onProcessData(n=>this._onProcessData.fire({id:a,event:n}));const g={env:c,executableEnv:u,options:P},h=new C(a,p,d,I,f,s,i,g,r,this._reconnectConstants,this._logService,w?e.initialText:void 0,e.icon,e.color,e.name,e.fixedDimensions);return p.onDidChangeProperty(n=>this._onDidChangeProperty.fire({id:a,property:n})),p.onProcessExit(n=>{h.dispose(),this._ptys.delete(a),this._onProcessExit.fire({id:a,event:n})}),h.onProcessReplay(n=>this._onProcessReplay.fire({id:a,event:n})),h.onProcessReady(n=>this._onProcessReady.fire({id:a,event:n})),h.onProcessOrphanQuestion(()=>this._onProcessOrphanQuestion.fire({id:a})),h.onDidChangeProperty(n=>this._onDidChangeProperty.fire({id:a,property:n})),h.onPersistentProcessReady(()=>{for(const n of this._autoReplies.entries())h.installAutoReply(n[0],n[1])}),this._ptys.set(a,h),a}async attachToProcess(e){try{this._throwIfNoPty(e).attach(),this._logService.trace(`Persistent process reconnection "${e}"`)}catch(t){this._logService.trace(`Persistent process reconnection "${e}" failed`,t.message)}}async updateTitle(e,t,s){this._throwIfNoPty(e).setTitle(t,s)}async updateIcon(e,t,s){this._throwIfNoPty(e).setIcon(t,s)}async refreshProperty(e,t){return this._throwIfNoPty(e).refreshProperty(t)}async updateProperty(e,t,s){return this._throwIfNoPty(e).updateProperty(t,s)}async detachFromProcess(e){return this._throwIfNoPty(e).detach()}async reduceConnectionGraceTime(){for(const e of this._ptys.values())e.reduceGraceTime()}async listProcesses(){const e=Array.from(this._ptys.entries()).filter(([i,r])=>r.shouldPersistTerminal);this._logService.info(`Listing ${e.length} persistent terminals, ${this._ptys.size} total terminals`);const t=e.map(async([i,r])=>this._buildProcessDetails(i,r));return(await Promise.all(t)).filter(i=>i.isOrphan)}async start(e){this._logService.trace("ptyService#start",e);const t=this._ptys.get(e);return t?t.start():{message:`Could not find pty with id "${e}"`}}async shutdown(e,t){return this._logService.trace("ptyService#shutDown",e,t),this._ptys.get(e)?.shutdown(t)}async input(e,t){return this._throwIfNoPty(e).input(t)}async processBinary(e,t){return this._throwIfNoPty(e).writeBinary(t)}async resize(e,t,s){return this._throwIfNoPty(e).resize(t,s)}async getInitialCwd(e){return this._throwIfNoPty(e).getInitialCwd()}async getCwd(e){return this._throwIfNoPty(e).getCwd()}async acknowledgeDataEvent(e,t){return this._throwIfNoPty(e).acknowledgeDataEvent(t)}async setUnicodeVersion(e,t){return this._throwIfNoPty(e).setUnicodeVersion(t)}async getLatency(e){return 0}async orphanQuestionReply(e){return this._throwIfNoPty(e).orphanQuestionReply()}async installAutoReply(e,t){this._autoReplies.set(e,t);for(const s of this._ptys.values())s.installAutoReply(e,t)}async uninstallAllAutoReplies(){for(const e of this._autoReplies.keys())for(const t of this._ptys.values())t.uninstallAutoReply(e)}async uninstallAutoReply(e){for(const t of this._ptys.values())t.uninstallAutoReply(e)}async getDefaultSystemShell(e=v.OS){return(0,N.getSystemShell)(e,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(e){return v.isWindows?(0,b.getWindowsBuildNumber)()<17063?e.replace(/\\/g,"/"):new Promise(t=>{(0,z.execFile)("bash.exe",["-c",`wslpath ${(0,x.escapeNonWindowsPath)(e)}`],{},(i,r,c)=>{t((0,x.escapeNonWindowsPath)(r.trim()))}).stdin.end()}):e}async setTerminalLayoutInfo(e){this._workspaceLayoutInfos.set(e.workspaceId,e)}async getTerminalLayoutInfo(e){const t=this._workspaceLayoutInfos.get(e.workspaceId);if(this._logService.trace("ptyService#getLayoutInfo",e),t){const i=(await Promise.all(t.tabs.map(async r=>this._expandTerminalTab(r)))).filter(r=>r.terminals.length>0);return this._logService.trace("ptyService#returnLayoutInfo",i),{tabs:i}}}async _expandTerminalTab(e){const s=(await Promise.all(e.terminals.map(i=>this._expandTerminalInstance(i)))).filter(i=>i.terminal!==null);return{isActive:e.isActive,activePersistentProcessId:e.activePersistentProcessId,terminals:s}}async _expandTerminalInstance(e){try{const t=this._revivedPtyIdMap.get(e.terminal)?.newId,s=t??e.terminal,i=this._throwIfNoPty(s);return{terminal:{...i&&await this._buildProcessDetails(e.terminal,i,t!==void 0),id:s},relativeSize:e.relativeSize}}catch(t){return this._logService.trace("Couldn't get layout info, a terminal was probably disconnected",t.message),{terminal:null,relativeSize:e.relativeSize}}}async _buildProcessDetails(e,t,s=!1){const[i,r]=await Promise.all([t.getCwd(),s?!0:t.isOrphaned()]);return{id:e,title:t.title,titleSource:t.titleSource,pid:t.pid,workspaceId:t.workspaceId,workspaceName:t.workspaceName,cwd:i,isOrphan:r,icon:t.icon,color:t.color,fixedDimensions:t.fixedDimensions}}_throwIfNoPty(e){const t=this._ptys.get(e);if(!t)throw new q.ErrorNoTelemetry("Could not find pty on pty host");return t}}_.PtyService=W;class C extends m.Disposable{get pid(){return this._pid}get shellLaunchConfig(){return this._terminalProcess.shellLaunchConfig}get hasWrittenData(){return this._hasWrittenData}get title(){return this._title||this._terminalProcess.currentTitle}get titleSource(){return this._titleSource}get icon(){return this._icon}get color(){return this._color}get fixedDimensions(){return this._fixedDimensions}setTitle(e,t){this._hasWrittenData=!0,this._title=e,this._titleSource=t}setIcon(e,t){this._hasWrittenData=!0,this._icon=e,this._color=t}_setFixedDimensions(e){this._fixedDimensions=e}constructor(e,t,s,i,r,c,u,P,f,d,I,w,a,p,g,h){super();this._persistentProcessId=e,this._terminalProcess=t,this.workspaceId=s,this.workspaceName=i,this.shouldPersistTerminal=r,this.processLaunchOptions=P,this.unicodeVersion=f,this._logService=I,this._icon=a,this._color=p,this._autoReplies=new Map,this._pendingCommands=new Map,this._isStarted=!1,this._hasWrittenData=!1,this._orphanRequestQueue=new y.Queue,this._onProcessReplay=this._register(new o.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessReady=this._register(new o.Emitter),this.onProcessReady=this._onProcessReady.event,this._onPersistentProcessReady=this._register(new o.Emitter),this.onPersistentProcessReady=this._onPersistentProcessReady.event,this._onProcessData=this._register(new o.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessOrphanQuestion=this._register(new o.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidChangeProperty=this._register(new o.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._inReplay=!1,this._pid=-1,this._cwd="",this._titleSource=R.TitleEventSource.Process,g&&this.setTitle(g,R.TitleEventSource.Api),this._logService.trace("persistentTerminalProcess#ctor",e,arguments),this._wasRevived=w!==void 0,this._serializer=new V(c,u,d.scrollback,f,w,this._logService),this._fixedDimensions=h,this._orphanQuestionBarrier=null,this._orphanQuestionReplyTime=0,this._disconnectRunner1=this._register(new y.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The reconnection grace time of ${E(d.graceTime)} has expired, shutting down pid "${this._pid}"`),this.shutdown(!0)},d.graceTime)),this._disconnectRunner2=this._register(new y.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The short reconnection grace time of ${E(d.shortGraceTime)} has expired, shutting down pid ${this._pid}`),this.shutdown(!0)},d.shortGraceTime)),this._register(this._terminalProcess.onProcessExit(()=>this._bufferer.stopBuffering(this._persistentProcessId))),this._register(this._terminalProcess.onProcessReady(n=>{this._pid=n.pid,this._cwd=n.cwd,this._onProcessReady.fire(n)})),this._register(this._terminalProcess.onDidChangeProperty(n=>{this._onDidChangeProperty.fire(n)})),this._bufferer=new O.TerminalDataBufferer((n,U)=>this._onProcessData.fire(U)),this._register(this._bufferer.startBuffering(this._persistentProcessId,this._terminalProcess.onProcessData)),this._register(this.onProcessData(n=>this._serializer.handleData(n))),this._register((0,m.toDisposable)(()=>{for(const n of this._autoReplies.values())n.dispose();this._autoReplies.clear()}))}attach(){this._logService.trace("persistentTerminalProcess#attach",this._persistentProcessId),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel()}async detach(){this._logService.trace("persistentTerminalProcess#detach",this._persistentProcessId),this.shouldPersistTerminal?this._disconnectRunner1.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this._serializer.generateReplayEvent(!0)}async refreshProperty(e){return this._terminalProcess.refreshProperty(e)}async updateProperty(e,t){if(e==="fixedDimensions")return this._setFixedDimensions(t)}async start(){if(this._logService.trace("persistentTerminalProcess#start",this._persistentProcessId,this._isStarted),this._isStarted)this._onProcessReady.fire({pid:this._pid,cwd:this._cwd,requiresWindowsMode:v.isWindows&&(0,b.getWindowsBuildNumber)()<21376}),this._onDidChangeProperty.fire({type:"title",value:this._terminalProcess.currentTitle}),this._onDidChangeProperty.fire({type:"shellType",value:this._terminalProcess.shellType}),this.triggerReplay();else{const e=await this._terminalProcess.start();if(e)return e;this._isStarted=!0,this._wasRevived?this.triggerReplay():this._onPersistentProcessReady.fire()}}shutdown(e){return this._terminalProcess.shutdown(e)}input(e){if(this._hasWrittenData=!0,!this._inReplay){for(const t of this._autoReplies.values())t.handleInput();return this._terminalProcess.input(e)}}writeBinary(e){return this._terminalProcess.processBinary(e)}resize(e,t){if(!this._inReplay){this._serializer.handleResize(e,t),this._bufferer.flushBuffer(this._persistentProcessId);for(const s of this._autoReplies.values())s.handleResize();return this._terminalProcess.resize(e,t)}}setUnicodeVersion(e){this.unicodeVersion=e,this._serializer.setUnicodeVersion?.(e)}acknowledgeDataEvent(e){if(!this._inReplay)return this._terminalProcess.acknowledgeDataEvent(e)}getInitialCwd(){return this._terminalProcess.getInitialCwd()}getCwd(){return this._terminalProcess.getCwd()}getLatency(){return this._terminalProcess.getLatency()}async triggerReplay(){this._hasWrittenData=!0;const e=await this._serializer.generateReplayEvent();let t=0;for(const s of e.events)t+=s.data.length;this._logService.info(`Persistent process "${this._persistentProcessId}": Replaying ${t} chars and ${e.events.length} size events`),this._onProcessReplay.fire(e),this._terminalProcess.clearUnacknowledgedChars(),this._onPersistentProcessReady.fire()}installAutoReply(e,t){this._autoReplies.get(e)?.dispose(),this._autoReplies.set(e,new L.TerminalAutoResponder(this._terminalProcess,e,t))}uninstallAutoReply(e){this._autoReplies.get(e)?.dispose(),this._autoReplies.delete(e)}sendCommandResult(e,t,s){!this._pendingCommands.get(e)||this._pendingCommands.delete(e)}orphanQuestionReply(){if(this._orphanQuestionReplyTime=Date.now(),this._orphanQuestionBarrier){const e=this._orphanQuestionBarrier;this._orphanQuestionBarrier=null,e.open()}}reduceGraceTime(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&this._disconnectRunner2.schedule()}async isOrphaned(){return await this._orphanRequestQueue.queue(async()=>this._isOrphaned())}async _isOrphaned(){return this._disconnectRunner1.isScheduled()||this._disconnectRunner2.isScheduled()?!0:(this._orphanQuestionBarrier||(this._orphanQuestionBarrier=new y.AutoOpenBarrier(4e3),this._orphanQuestionReplyTime=0,this._onProcessOrphanQuestion.fire()),await this._orphanQuestionBarrier.wait(),Date.now()-this._orphanQuestionReplyTime>500)}}_.PersistentTerminalProcess=C;class V{constructor(e,t,s,i,r,c){this._xterm=new $.Terminal({cols:e,rows:t,scrollback:s,allowProposedApi:!0}),r&&this._xterm.writeln(r),this.setUnicodeVersion(i),this._shellIntegrationAddon=new M.ShellIntegrationAddon(!0,void 0,c),this._xterm.loadAddon(this._shellIntegrationAddon)}handleData(e){this._xterm.write(e)}handleResize(e,t){this._xterm.resize(e,t)}async generateReplayEvent(e){const t=new(await this._getSerializeConstructor());this._xterm.loadAddon(t);const s={scrollback:this._xterm.options.scrollback};e&&(s.excludeAltBuffer=!0,s.excludeModes=!0);const i=t.serialize(s);return{events:[{cols:this._xterm.cols,rows:this._xterm.rows,data:i}],commands:this._shellIntegrationAddon.serialize()}}async setUnicodeVersion(e){this._xterm.unicode.activeVersion!==e&&(e==="11"?(this._unicodeAddon=new(await this._getUnicode11Constructor()),this._xterm.loadAddon(this._unicodeAddon)):(this._unicodeAddon?.dispose(),this._unicodeAddon=void 0),this._xterm.unicode.activeVersion=e)}async _getUnicode11Constructor(){return S||(S=(await new Promise((e,t)=>{T(["xterm-addon-unicode11"],e,t)})).Unicode11Addon),S}async _getSerializeConstructor(){return D||(D=(await new Promise((e,t)=>{T(["xterm-addon-serialize"],e,t)})).SerializeAddon),D}}function E(l){let e=0,t=0,s=0;l>=1e3&&(s=Math.floor(l/1e3),l-=s*1e3),s>=60&&(t=Math.floor(s/60),s-=t*60),t>=60&&(e=Math.floor(t/60),t-=e*60);const i=e?`${e}h`:"",r=t?`${t}m`:"",c=s?`${s}s`:"",u=l?`${l}ms`:"";return`${i}${r}${c}${u}`}});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/terminal/node/ptyService.js.map
