define(["require","exports","os","vs/base/common/network","vs/base/common/objects","vs/base/common/path","vs/base/common/platform","vs/base/common/process","vs/base/common/strings","vs/base/common/types","vs/base/node/pfs"],function(A,t,I,z,W,s,v,m,c,k,Z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shellIntegrationArgs=t.ShellIntegrationExecutable=t.getShellIntegrationInjection=t.findExecutable=t.getWindowsBuildNumber=void 0;function y(){const e=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());let a=0;return e&&e.length===4&&(a=parseInt(e[3])),a}t.getWindowsBuildNumber=y;async function B(e,a,h,o=m.env,u=Z.Promises.exists){if(s.isAbsolute(e))return await u(e)?e:void 0;if(a===void 0&&(a=m.cwd()),s.dirname(e)!=="."){const r=s.join(a,e);return await u(r)?r:void 0}const n=(0,W.getCaseInsensitive)(o,"PATH");if(h===void 0&&(0,k.isString)(n)&&(h=n.split(s.delimiter)),h===void 0||h.length===0){const r=s.join(a,e);return await u(r)?r:void 0}for(let r of h){let l;if(s.isAbsolute(r)?l=s.join(r,e):l=s.join(a,r,e),await u(l))return l;if(v.isWindows){let f=l+".com";if(await u(f)||(f=l+".exe",await u(f)))return f}}const g=s.join(a,e);return await u(g)?g:void 0}t.findExecutable=B;function C(e,a,h){if(!a.enabled||!e.executable||e.isFeatureTerminal||e.hideFromUser)return;const o=e.args,u=m.platform==="win32"?s.basename(e.executable).toLowerCase():s.basename(e.executable),d=s.dirname(z.FileAccess.asFileUri("",A).fsPath);let n;if(v.isWindows){if(u==="pwsh.exe")return!o||j(o)?n=t.shellIntegrationArgs.get(i.WindowsPwsh):P(o)&&(n=t.shellIntegrationArgs.get(i.WindowsPwshLogin)),n?(n&&(n=[...n],n[n.length-1]=(0,c.format)(n[n.length-1],d,"")),{newArgs:n}):void 0;h.warn(`Shell integration cannot be enabled for executable "${e.executable}" and args`,e.args);return}const g={};switch(u){case"bash":return!o||o.length===0?n=t.shellIntegrationArgs.get(i.Bash):L(o)&&(g.VSCODE_SHELL_LOGIN="1",n=t.shellIntegrationArgs.get(i.Bash)),n?(n=[...n],n[n.length-1]=(0,c.format)(n[n.length-1],d),{newArgs:n,envMixin:g}):void 0;case"pwsh":return!o||j(o)?n=t.shellIntegrationArgs.get(i.Pwsh):P(o)&&(n=t.shellIntegrationArgs.get(i.PwshLogin)),n?(n=[...n],n[n.length-1]=(0,c.format)(n[n.length-1],d,""),{newArgs:n}):void 0;case"zsh":{if(!o||o.length===0?n=t.shellIntegrationArgs.get(i.Zsh):L(o)?n=t.shellIntegrationArgs.get(i.ZshLogin):(o===t.shellIntegrationArgs.get(i.Zsh)||o===t.shellIntegrationArgs.get(i.ZshLogin))&&(n=o),!n)return;n=[...n],n[n.length-1]=(0,c.format)(n[n.length-1],d);const r=s.join(I.tmpdir(),"vscode-zsh");g.ZDOTDIR=r;const l=[];return l.push({source:s.join(d,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:s.join(r,".zshrc")}),l.push({source:s.join(d,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:s.join(r,".zprofile")}),l.push({source:s.join(d,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:s.join(r,".zshenv")}),l.push({source:s.join(d,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:s.join(r,".zlogin")}),{newArgs:n,envMixin:g,filesToCopy:l}}}h.warn(`Shell integration cannot be enabled for executable "${e.executable}" and args`,e.args)}t.getShellIntegrationInjection=C;var i;(function(e){e.WindowsPwsh="windows-pwsh",e.WindowsPwshLogin="windows-pwsh-login",e.Pwsh="pwsh",e.PwshLogin="pwsh-login",e.Zsh="zsh",e.ZshLogin="zsh-login",e.Bash="bash"})(i||(t.ShellIntegrationExecutable=i={})),t.shellIntegrationArgs=new Map,t.shellIntegrationArgs.set(i.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),t.shellIntegrationArgs.set(i.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),t.shellIntegrationArgs.set(i.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),t.shellIntegrationArgs.set(i.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),t.shellIntegrationArgs.set(i.Zsh,["-i"]),t.shellIntegrationArgs.set(i.ZshLogin,["-il"]),t.shellIntegrationArgs.set(i.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const w=["-login","-l"],b=["-nol","-nologo"];function P(e){return typeof e=="string"?w.includes(e.toLowerCase()):e.length===1&&w.includes(e[0].toLowerCase())||e.length===2&&(w.includes(e[0].toLowerCase())||w.includes(e[1].toLowerCase()))&&(b.includes(e[0].toLowerCase())||b.includes(e[1].toLowerCase()))}function j(e){return typeof e=="string"?b.includes(e.toLowerCase()):e.length===0||e?.length===1&&b.includes(e[0].toLowerCase())}function L(e){return e==="string"&&w.includes(e.toLowerCase())||typeof e!="string"&&e.length===1&&w.includes(e[0].toLowerCase())}});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/terminal/node/terminalEnvironment.js.map
