define(["require","exports","vs/base/common/async","vs/base/common/color","vs/base/common/event","vs/nls!vs/platform/theme/common/tokenClassificationRegistry","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/registry/common/platform"],function(N,n,E,h,_,o,z,S){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.tokenStylingSchemaId=n.getTokenClassificationRegistry=n.parseClassifierString=n.Extensions=n.SemanticTokenRule=n.TokenStyle=n.fontStylePattern=n.selectorPattern=n.typeAndModifierIdPattern=n.idPattern=n.CLASSIFIER_MODIFIER_SEPARATOR=n.TOKEN_CLASSIFIER_LANGUAGE_SEPARATOR=n.TOKEN_TYPE_WILDCARD=void 0,n.TOKEN_TYPE_WILDCARD="*",n.TOKEN_CLASSIFIER_LANGUAGE_SEPARATOR=":",n.CLASSIFIER_MODIFIER_SEPARATOR=".",n.idPattern="\\w+[-_\\w+]*",n.typeAndModifierIdPattern=`^${n.idPattern}$`,n.selectorPattern=`^(${n.idPattern}|\\*)(\\${n.CLASSIFIER_MODIFIER_SEPARATOR}${n.idPattern})*(${n.TOKEN_CLASSIFIER_LANGUAGE_SEPARATOR}${n.idPattern})?$`,n.fontStylePattern="^(\\s*(italic|bold|underline|strikethrough))*\\s*$";class y{constructor(e,i,r,d,a){this.foreground=e,this.bold=i,this.underline=r,this.strikethrough=d,this.italic=a}}n.TokenStyle=y,function(l){function e(t){return{_foreground:t.foreground===void 0?null:h.Color.Format.CSS.formatHexA(t.foreground,!0),_bold:t.bold===void 0?null:t.bold,_underline:t.underline===void 0?null:t.underline,_italic:t.italic===void 0?null:t.italic,_strikethrough:t.strikethrough===void 0?null:t.strikethrough}}l.toJSONObject=e;function i(t){if(t){const c=s=>typeof s=="boolean"?s:void 0,f=s=>typeof s=="string"?h.Color.fromHex(s):void 0;return new l(f(t._foreground),c(t._bold),c(t._underline),c(t._strikethrough),c(t._italic))}}l.fromJSONObject=i;function r(t,c){return t===c?!0:t!==void 0&&c!==void 0&&(t.foreground instanceof h.Color?t.foreground.equals(c.foreground):c.foreground===void 0)&&t.bold===c.bold&&t.underline===c.underline&&t.strikethrough===c.strikethrough&&t.italic===c.italic}l.equals=r;function d(t){return t instanceof l}l.is=d;function a(t){return new l(t.foreground,t.bold,t.underline,t.strikethrough,t.italic)}l.fromData=a;function u(t,c,f,s,m,b){let A;if(t!==void 0&&(A=h.Color.fromHex(t)),c!==void 0){f=b=s=m=!1;const L=/italic|bold|underline|strikethrough/g;let C;for(;C=L.exec(c);)switch(C[0]){case"bold":f=!0;break;case"italic":b=!0;break;case"underline":s=!0;break;case"strikethrough":m=!0;break}}return new l(A,f,s,m,b)}l.fromSettings=u}(y||(n.TokenStyle=y={}));var k;(function(l){function e(a,u){if(u&&typeof u._selector=="string"&&u._style){const t=y.fromJSONObject(u._style);if(t)try{return{selector:a.parseTokenSelector(u._selector),style:t}}catch{}}}l.fromJSONObject=e;function i(a){return{_selector:a.selector.id,_style:y.toJSONObject(a.style)}}l.toJSONObject=i;function r(a,u){return a===u?!0:a!==void 0&&u!==void 0&&a.selector&&u.selector&&a.selector.id===u.selector.id&&y.equals(a.style,u.style)}l.equals=r;function d(a){return a&&a.selector&&typeof a.selector.id=="string"&&y.is(a.style)}l.is=d})(k||(n.SemanticTokenRule=k={})),n.Extensions={TokenClassificationContribution:"base.contributions.tokenClassification"};class v{constructor(){this._onDidChangeSchema=new _.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.currentTypeNumber=0,this.currentModifierBit=1,this.tokenStylingDefaultRules=[],this.tokenStylingSchema={type:"object",properties:{},patternProperties:{[n.selectorPattern]:p()},additionalProperties:!1,definitions:{style:{type:"object",description:o.localize(0,null),properties:{foreground:{type:"string",description:o.localize(1,null),format:"color-hex",default:"#ff0000"},background:{type:"string",deprecationMessage:o.localize(2,null)},fontStyle:{type:"string",description:o.localize(3,null),pattern:n.fontStylePattern,patternErrorMessage:o.localize(4,null),defaultSnippets:[{label:o.localize(5,null),bodyText:'""'},{body:"italic"},{body:"bold"},{body:"underline"},{body:"strikethrough"},{body:"italic bold"},{body:"italic underline"},{body:"italic strikethrough"},{body:"bold underline"},{body:"bold strikethrough"},{body:"underline strikethrough"},{body:"italic bold underline"},{body:"italic bold strikethrough"},{body:"italic underline strikethrough"},{body:"bold underline strikethrough"},{body:"italic bold underline strikethrough"}]},bold:{type:"boolean",description:o.localize(6,null)},italic:{type:"boolean",description:o.localize(7,null)},underline:{type:"boolean",description:o.localize(8,null)},strikethrough:{type:"boolean",description:o.localize(9,null)}},defaultSnippets:[{body:{foreground:"${1:#FF0000}",fontStyle:"${2:bold}"}}]}}},this.tokenTypeById=Object.create(null),this.tokenModifierById=Object.create(null),this.typeHierarchy=Object.create(null)}registerTokenType(e,i,r,d){if(!e.match(n.typeAndModifierIdPattern))throw new Error("Invalid token type id.");if(r&&!r.match(n.typeAndModifierIdPattern))throw new Error("Invalid token super type id.");let u={num:this.currentTypeNumber++,id:e,superType:r,description:i,deprecationMessage:d};this.tokenTypeById[e]=u;const t=p(i,d);this.tokenStylingSchema.properties[e]=t,this.typeHierarchy=Object.create(null)}registerTokenModifier(e,i,r){if(!e.match(n.typeAndModifierIdPattern))throw new Error("Invalid token modifier id.");const d=this.currentModifierBit;this.currentModifierBit=this.currentModifierBit*2;let a={num:d,id:e,description:i,deprecationMessage:r};this.tokenModifierById[e]=a,this.tokenStylingSchema.properties[`*.${e}`]=p(i,r)}parseTokenSelector(e,i){const r=O(e,i);return r.type?{match:(d,a,u)=>{let t=0;if(r.language!==void 0){if(r.language!==u)return-1;t+=10}if(r.type!==n.TOKEN_TYPE_WILDCARD){const f=this.getTypeHierarchy(d).indexOf(r.type);if(f===-1)return-1;t+=100-f}for(const c of r.modifiers)if(a.indexOf(c)===-1)return-1;return t+r.modifiers.length*100},id:`${[r.type,...r.modifiers.sort()].join(".")}${r.language!==void 0?":"+r.language:""}`}:{match:()=>-1,id:"$invalid"}}registerTokenStyleDefault(e,i){this.tokenStylingDefaultRules.push({selector:e,defaults:i})}deregisterTokenStyleDefault(e){const i=e.id;this.tokenStylingDefaultRules=this.tokenStylingDefaultRules.filter(r=>r.selector.id!==i)}deregisterTokenType(e){delete this.tokenTypeById[e],delete this.tokenStylingSchema.properties[e],this.typeHierarchy=Object.create(null)}deregisterTokenModifier(e){delete this.tokenModifierById[e],delete this.tokenStylingSchema.properties[`*.${e}`]}getTokenTypes(){return Object.keys(this.tokenTypeById).map(e=>this.tokenTypeById[e])}getTokenModifiers(){return Object.keys(this.tokenModifierById).map(e=>this.tokenModifierById[e])}getTokenStylingSchema(){return this.tokenStylingSchema}getTokenStylingDefaultRules(){return this.tokenStylingDefaultRules}getTypeHierarchy(e){let i=this.typeHierarchy[e];if(!i){this.typeHierarchy[e]=i=[e];let r=this.tokenTypeById[e];for(;r&&r.superType;)i.push(r.superType),r=this.tokenTypeById[r.superType]}return i}toString(){let e=(i,r)=>{let d=i.indexOf(".")===-1?0:1,a=r.indexOf(".")===-1?0:1;return d!==a?d-a:i.localeCompare(r)};return Object.keys(this.tokenTypeById).sort(e).map(i=>`- \`${i}\`: ${this.tokenTypeById[i].description}`).join(`
`)}}const T=n.TOKEN_CLASSIFIER_LANGUAGE_SEPARATOR.charCodeAt(0),M=n.CLASSIFIER_MODIFIER_SEPARATOR.charCodeAt(0);function O(l,e){let i=l.length,r=e;const d=[];for(let u=i-1;u>=0;u--){const t=l.charCodeAt(u);if(t===T||t===M){const c=l.substring(u+1,i);i=u,t===T?r=c:d.push(c)}}return{type:l.substring(0,i),modifiers:d,language:r}}n.parseClassifierString=O;let g=P();S.Registry.add(n.Extensions.TokenClassificationContribution,g);function P(){const l=new v;function e(r,d,a=[],u,t){return l.registerTokenType(r,d,u,t),a&&i(r,a),r}function i(r,d){try{const a=l.parseTokenSelector(r);l.registerTokenStyleDefault(a,{scopesToProbe:d})}catch(a){console.log(a)}}return e("comment",o.localize(10,null),[["comment"]]),e("string",o.localize(11,null),[["string"]]),e("keyword",o.localize(12,null),[["keyword.control"]]),e("number",o.localize(13,null),[["constant.numeric"]]),e("regexp",o.localize(14,null),[["constant.regexp"]]),e("operator",o.localize(15,null),[["keyword.operator"]]),e("namespace",o.localize(16,null),[["entity.name.namespace"]]),e("type",o.localize(17,null),[["entity.name.type"],["support.type"]]),e("struct",o.localize(18,null),[["entity.name.type.struct"]]),e("class",o.localize(19,null),[["entity.name.type.class"],["support.class"]]),e("interface",o.localize(20,null),[["entity.name.type.interface"]]),e("enum",o.localize(21,null),[["entity.name.type.enum"]]),e("typeParameter",o.localize(22,null),[["entity.name.type.parameter"]]),e("function",o.localize(23,null),[["entity.name.function"],["support.function"]]),e("member",o.localize(24,null),[],"method","Deprecated use `method` instead"),e("method",o.localize(25,null),[["entity.name.function.member"],["support.function"]]),e("macro",o.localize(26,null),[["entity.name.function.preprocessor"]]),e("variable",o.localize(27,null),[["variable.other.readwrite"],["entity.name.variable"]]),e("parameter",o.localize(28,null),[["variable.parameter"]]),e("property",o.localize(29,null),[["variable.other.property"]]),e("enumMember",o.localize(30,null),[["variable.other.enummember"]]),e("event",o.localize(31,null),[["variable.other.event"]]),e("decorator",o.localize(32,null),[["entity.name.decorator"],["entity.name.function"]]),e("label",o.localize(33,null),void 0),l.registerTokenModifier("declaration",o.localize(34,null),void 0),l.registerTokenModifier("documentation",o.localize(35,null),void 0),l.registerTokenModifier("static",o.localize(36,null),void 0),l.registerTokenModifier("abstract",o.localize(37,null),void 0),l.registerTokenModifier("deprecated",o.localize(38,null),void 0),l.registerTokenModifier("modification",o.localize(39,null),void 0),l.registerTokenModifier("async",o.localize(40,null),void 0),l.registerTokenModifier("readonly",o.localize(41,null),void 0),i("variable.readonly",[["variable.other.constant"]]),i("property.readonly",[["variable.other.constant.property"]]),i("type.defaultLibrary",[["support.type"]]),i("class.defaultLibrary",[["support.class"]]),i("interface.defaultLibrary",[["support.class"]]),i("variable.defaultLibrary",[["support.variable"],["support.other.variable"]]),i("variable.defaultLibrary.readonly",[["support.constant"]]),i("property.defaultLibrary",[["support.variable.property"]]),i("property.defaultLibrary.readonly",[["support.constant.property"]]),i("function.defaultLibrary",[["support.function"]]),i("member.defaultLibrary",[["support.function"]]),l}function D(){return g}n.getTokenClassificationRegistry=D;function p(l,e){return{description:l,deprecationMessage:e,defaultSnippets:[{body:"${1:#ff0000}"}],anyOf:[{type:"string",format:"color-hex"},{$ref:"#/definitions/style"}]}}n.tokenStylingSchemaId="vscode://schemas/token-styling";let I=S.Registry.as(z.Extensions.JSONContribution);I.registerSchema(n.tokenStylingSchemaId,g.getTokenStylingSchema());const R=new E.RunOnceScheduler(()=>I.notifySchemaChanged(n.tokenStylingSchemaId),200);g.onDidChangeSchema(()=>{R.isScheduled()||R.schedule()})});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/theme/common/tokenClassificationRegistry.js.map
