var __decorate=this&&this.__decorate||function(w,u,d,p){var v=arguments.length,h=v<3?u:p===null?p=Object.getOwnPropertyDescriptor(u,d):p,f;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")h=Reflect.decorate(w,u,d,p);else for(var l=w.length-1;l>=0;l--)(f=w[l])&&(h=(v<3?f(h):v>3?f(u,d,h):f(u,d))||h);return v>3&&h&&Object.defineProperty(u,d,h),h},__param=this&&this.__param||function(w,u){return function(d,p){u(d,p,w)}};define(["require","exports","vs/base/common/arrays","vs/base/common/async","vs/base/common/errorMessage","vs/base/common/event","vs/base/common/lifecycle","vs/base/common/resources","vs/base/common/types","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/instantiation","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSync"],function(w,u,d,p,v,h,f,l,P,C,I,T,_,A,x,M,q,k,U,H,O,a){"use strict";Object.defineProperty(u,"__esModule",{value:!0}),u.UserDataSyncService=void 0;const E="sync.lastSyncTime";let b=class extends f.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(e,s,r,t,n,i,o,c){super();this.userDataSyncStoreService=e,this.userDataSyncStoreManagementService=s,this.instantiationService=r,this.configurationService=t,this.logService=n,this.telemetryService=i,this.storageService=o,this.userDataSyncEnablementService=c,this._status="uninitialized",this._onDidChangeStatus=this._register(new h.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new h.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new h.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new h.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new h.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new h.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new h.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new f.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(E,0,void 0)}async createSyncTask(e,s){this.checkEnablement();const r=(0,C.generateUuid)();try{const c=(0,a.createSyncHeaders)(r);s&&(c["Cache-Control"]="no-cache"),e=await this.userDataSyncStoreService.manifest(e,c)}catch(c){const S=a.UserDataSyncError.toUserDataSyncError(c);throw this.reportUserDataSyncError(S,r),S}let t=!1;const n=this,i=this.getEnabledSynchronizers();let o;return{manifest:e,async run(){if(t)throw new Error("Can run a task only once");return o=(0,p.createCancelablePromise)(c=>n.sync(i,e,r,c)),o.finally(()=>o=void 0)},async stop(){if(o&&o.cancel(),n.status!=="idle")return n.stop(i)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new a.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const e=(0,C.generateUuid)(),s=(0,a.createSyncHeaders)(e);let r;try{r=await this.userDataSyncStoreService.manifest(null,s)}catch(i){const o=a.UserDataSyncError.toUserDataSyncError(i);throw this.reportUserDataSyncError(o,e),o}await this.resetLocal();const t=this.getEnabledSynchronizers(),n=async()=>{await this.stop(t),await this.resetLocal()};return new Y(e,r,s,t,n,this.configurationService,this.logService)}async sync(e,s,r,t){if(t.isCancellationRequested||!e.length)return;const n=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const i=(0,a.createSyncHeaders)(r);for(const o of e){if(t.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(o.resource))return;try{await o.sync(s,i)}catch(c){let S=!1;if(c instanceof a.UserDataSyncError)switch(c.code){case"TooLarge":c=new a.UserDataSyncError(c.message,c.code,o.resource),S=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":S=!0;break}const m=a.UserDataSyncError.toUserDataSyncError(c);if(this.reportUserDataSyncError(m,r),S)throw m;this.logService.error(c),this.logService.error(`${o.resource}: ${(0,v.toErrorMessage)(c)}`),this._syncErrors.push([o.resource,m])}}this.logService.info(`Sync done. Took ${new Date().getTime()-n}ms`),this.updateLastSyncTime()}catch(i){const o=a.UserDataSyncError.toUserDataSyncError(i);throw this.reportUserDataSyncError(o,r),o}finally{this.updateStatus(e),this._onSyncErrors.fire(this._syncErrors)}}async stop(e){if(this.status!=="idle")for(const s of e)try{s.status!=="idle"&&await s.stop()}catch(r){this.logService.error(r)}}async replace(e){this.checkEnablement(),await this.performSynchronizerAction(async s=>{if(await s.replace(e))return!0})}async accept(e,s,r,t){this.checkEnablement(),await this.performSynchronizerAction(async n=>{if(n.resource===e)return await n.accept(s,r),t&&await n.apply(!1,(0,a.createSyncHeaders)((0,C.generateUuid)())),!0})}async resolveContent(e){return this.performSynchronizerAction(async s=>{const r=await s.resolveContent(e);if(r)return r})}async getRemoteSyncResourceHandles(e){return await this.performSynchronizerAction(async r=>{if(r.resource===e)return r.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(e){return await this.performSynchronizerAction(async r=>{if(r.resource===e)return r.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(e,s){return await this.performSynchronizerAction(async t=>{if(t.resource===e)return t.getAssociatedResources(s)})||[]}async getMachineId(e,s){return await this.performSynchronizerAction(async t=>{if(t.resource===e)return await t.getMachineId(s)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async s=>{if(s.resource!=="globalState"&&await s.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async s=>{if(await s.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(e){this.logService.error(e)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(E,0),this.synchronizers.value){for(const e of this.synchronizers.value.enabled)try{await e.resetLocal()}catch(s){this.logService.error(`${e.resource}: ${(0,v.toErrorMessage)(s)}`),this.logService.error(s)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(e){const s=new f.DisposableStore;try{const r=this.synchronizers.value||s.add(this.instantiationService.createInstance(R,()=>{},()=>{},()=>{})),t=[...r.enabled,...r.disabled.map(n=>s.add(r.createSynchronizer(n)))];for(const n of t){const i=await e(n);if(!(0,P.isUndefined)(i))return i}return null}finally{s.dispose()}}setStatus(e){const s=this._status;this._status!==e&&(this._status=e,this._onDidChangeStatus.fire(e),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(e){this.updateConflicts(e);const s=this.computeStatus(e);this.setStatus(s)}updateConflicts(e){const s=this.computeConflicts(e);(0,d.equals)(this._conflicts,s,([r,t],[n,i])=>r===r&&(0,d.equals)(t,i,(o,c)=>(0,l.isEqual)(o.previewResource,c.previewResource)))||(this._conflicts=this.computeConflicts(e),this._onDidChangeConflicts.fire(s))}computeConflicts(e){return e.filter(s=>s.status==="hasConflicts").map(s=>[s.resource,s.conflicts.map(L)])}computeStatus(e){return this.userDataSyncStoreManagementService.userDataSyncStore?e.some(s=>s.status==="hasConflicts")?"hasConflicts":e.some(s=>s.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(E,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(e,s){this.telemetryService.publicLog2("sync/error",{code:e.code,serverCode:e instanceof a.UserDataSyncStoreError?String(e.serverCode):void 0,url:e instanceof a.UserDataSyncStoreError?e.url:void 0,resource:e.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(R,e=>this.updateStatus(e),e=>this.updateConflicts(e),e=>this._onDidChangeLocal.fire(e))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};u.UserDataSyncService=b,u.UserDataSyncService=b=__decorate([__param(0,a.IUserDataSyncStoreService),__param(1,a.IUserDataSyncStoreManagementService),__param(2,_.IInstantiationService),__param(3,I.IConfigurationService),__param(4,a.IUserDataSyncLogService),__param(5,x.ITelemetryService),__param(6,A.IStorageService),__param(7,a.IUserDataSyncEnablementService)],b);class Y extends f.Disposable{get status(){return this.synchronisers.some(e=>e.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(e=>e.status==="syncing")?"syncing":"idle"}constructor(e,s,r,t,n,i,o){super();this.id=e,this.manifest=s,this.syncHeaders=r,this.synchronisers=t,this.onStop=n,this.configurationService=i,this.logService=o,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new h.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,p.createCancelablePromise)(e=>this.getPreviews(e))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(e){throw this.logService.error(e),e}}async accept(e,s){try{return await this.performAction(e,r=>r.accept(e,s))}catch(r){throw this.logService.error(r),r}}async merge(e){try{return e?await this.performAction(e,s=>s.merge(e)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(e){try{return await this.performAction(e,s=>s.discard(e))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const e=[];for(const[,s]of this.previews)for(const r of s.resourcePreviews)r.mergeState==="conflict"&&e.push(r.previewResource);for(const s of e)await this.discard(s);return this.previews}catch(e){throw this.logService.error(e),e}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const e=[];for(const[s,r]of this.previews){this.synchronizingResources.push([s,r.resourcePreviews.map(i=>i.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const t=this.synchronisers.find(i=>i.resource===s);for(const i of r.resourcePreviews)(i.localChange!==0||i.remoteChange!==0)&&i.mergeState==="preview"&&await t.merge(i.previewResource);const n=await t.apply(!1,this.syncHeaders);n&&e.push(this.toSyncResourcePreview(t.resource,n)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(i=>i[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=e,this.previews}catch(e){throw this.logService.error(e),e}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[e,s]of this.previews){this.synchronizingResources.push([e,s.resourcePreviews.map(t=>t.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const r=this.synchronisers.find(t=>t.resource===e);for(const t of s.resourcePreviews)await r.accept(t.remoteResource);await r.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(t=>t[0]===e),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(e){throw this.logService.error(e),e}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[e,s]of this.previews){this.synchronizingResources.push([e,s.resourcePreviews.map(t=>t.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const r=this.synchronisers.find(t=>t.resource===e);for(const t of s.resourcePreviews)await r.accept(t.localResource);await r.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(t=>t[0]===e),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(e){throw this.logService.error(e),e}}async stop(){await this.onStop(),this.reset()}async performAction(e,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const r=this.previews.findIndex(([,y])=>y.resourcePreviews.some(({localResource:D,previewResource:z,remoteResource:N})=>(0,l.isEqual)(e,D)||(0,l.isEqual)(e,z)||(0,l.isEqual)(e,N)));if(r===-1)return this.previews;const[t,n]=this.previews[r],i=n.resourcePreviews.find(({localResource:y,remoteResource:D,previewResource:z})=>(0,l.isEqual)(y,e)||(0,l.isEqual)(D,e)||(0,l.isEqual)(z,e));if(!i)return this.previews;let o=this.synchronizingResources.find(y=>y[0]===t);o||(o=[t,[]],this.synchronizingResources.push(o)),o[1].some(y=>(0,l.isEqual)(y,i.localResource))||(o[1].push(i.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const c=this.synchronisers.find(y=>y.resource===this.previews[r][0]),S=await s(c);S?this.previews.splice(r,1,this.toSyncResourcePreview(c.resource,S)):this.previews.splice(r,1);const m=this.synchronizingResources.findIndex(y=>y[0]===t);return this.synchronizingResources[m][1].splice(o[1].findIndex(y=>(0,l.isEqual)(y,i.localResource)),1),o[1].length||(this.synchronizingResources.splice(m,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const e=[];for(const[s,r]of this.previews){this.synchronizingResources.push([s,r.resourcePreviews.map(i=>i.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const t=this.synchronisers.find(i=>i.resource===s);let n=r;for(const i of r.resourcePreviews)(i.localChange!==0||i.remoteChange!==0)&&i.mergeState==="preview"&&(n=await t.merge(i.previewResource));n&&e.push(this.toSyncResourcePreview(t.resource,n)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(i=>i[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=e,this.previews}async getPreviews(e){const s=[],r=await this.getUserDataSyncConfiguration();for(const t of this.synchronisers){if(e.isCancellationRequested)return[];const n=await t.preview(this.manifest,r,this.syncHeaders);n&&s.push(this.toSyncResourcePreview(t.resource,n))}return s}async getUserDataSyncConfiguration(){const e=this.configurationService.getValue(a.USER_DATA_SYNC_CONFIGURATION_SCOPE),s=this.synchronisers.find(r=>r instanceof U.SettingsSynchroniser);if(s){const r=await s.getRemoteUserDataSyncConfiguration(this.manifest);return{...e,...r}}return e}toSyncResourcePreview(e,s){return[e,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(L)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let R=class extends f.Disposable{get enabled(){return this._enabled.sort((e,s)=>e[1]-s[1]).map(([e])=>e)}get disabled(){return a.ALL_SYNC_RESOURCES.filter(e=>!this.userDataSyncEnablementService.isResourceEnabled(e))}constructor(e,s,r,t,n,i,o){super();this.onDidChangeStatus=e,this.onDidChangeConflicts=s,this.onDidChangeLocal=r,this.userDataSyncEnablementService=t,this.instantiationService=n,this.extensionGalleryService=i,this.logService=o,this._enabled=[],this._register(t.onDidChangeResourceEnablement(([c,S])=>this.onDidChangeResourceEnablement(c,S))),this._register((0,f.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,c])=>c.dispose())));for(const c of a.ALL_SYNC_RESOURCES)t.isResourceEnabled(c)&&this.registerSynchronizer(c)}onDidChangeResourceEnablement(e,s){s?this.registerSynchronizer(e):this.deRegisterSynchronizer(e)}registerSynchronizer(e){if(this._enabled.some(([n])=>n.resource===e))return;if(e==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const s=new f.DisposableStore,r=s.add(this.createSynchronizer(e));s.add(r.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),s.add(r.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),s.add(r.onDidChangeLocal(()=>this.onDidChangeLocal(e)));const t=this.getOrder(e);this._enabled.push([r,t,s])}deRegisterSynchronizer(e){const s=this._enabled.findIndex(([r])=>r.resource===e);if(s!==-1){const r=this._enabled.splice(s,1);for(const[t,,n]of r){if(t.status!=="idle"){const i=t.conflicts.length>0;t.stop(),i&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}n.dispose()}}}createSynchronizer(e){switch(e){case"settings":return this.instantiationService.createInstance(U.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(k.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(H.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(O.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(q.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(M.ExtensionsSynchroniser)}}getOrder(e){switch(e){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};R=__decorate([__param(3,a.IUserDataSyncEnablementService),__param(4,_.IInstantiationService),__param(5,T.IExtensionGalleryService),__param(6,a.IUserDataSyncLogService)],R);function L(g){return{localResource:g.localResource,previewResource:g.previewResource,remoteResource:g.remoteResource,acceptedResource:g.acceptedResource,localChange:g.localChange,remoteChange:g.remoteChange,mergeState:g.mergeState}}});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/userDataSync/common/userDataSyncService.js.map
