define(["require","exports","vs/base/common/event","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/uri","vs/platform/userDataSync/common/userDataSync"],function(w,h,l,u,S,a,d){"use strict";Object.defineProperty(h,"__esModule",{value:!0}),h.UserDataSyncChannelClient=h.UserDataSyncChannel=void 0;class p{constructor(e,s){this.service=e,this.logService=s,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new l.Emitter}listen(e,s){switch(s){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${s}`)}async call(e,s,t){try{return await this._call(e,s,t)}catch(n){throw this.logService.error(n),n}}async _call(e,s,t){switch(s){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(a.URI.revive(t[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(t[0],a.URI.revive(t[1]),t[2],t[3]);case"resolveContent":return this.service.resolveContent(a.URI.revive(t[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(t[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(t[0]);case"getAssociatedResources":return this.service.getAssociatedResources(t[0],{created:t[1].created,uri:a.URI.revive(t[1].uri)});case"getMachineId":return this.service.getMachineId(t[0],{created:t[1].created,uri:a.URI.revive(t[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(s.startsWith("manualSync/")){const n=s.substring("manualSync/".length),c=t[0],r=this.getManualSyncTask(c);switch(t=t.slice(1),n){case"preview":return r.preview();case"accept":return r.accept(a.URI.revive(t[0]),t[1]);case"merge":return r.merge(a.URI.revive(t[0]));case"discard":return r.discard(a.URI.revive(t[0]));case"discardConflicts":return r.discardConflicts();case"apply":return r.apply();case"pull":return r.pull();case"push":return r.push();case"stop":return r.stop();case"_getStatus":return r.status;case"dispose":return this.disposeManualSyncTask(r)}}throw new Error("Invalid call")}getManualSyncTask(e){const s=this.manualSyncTasks.get(this.createKey(e));if(!s)throw new Error(`Manual sync taks not found: ${e}`);return s.manualSyncTask}async createManualSyncTask(){const e=new u.DisposableStore,s=e.add(await this.service.createManualSyncTask());return e.add(s.onSynchronizeResources(t=>this.onManualSynchronizeResources.fire({manualSyncTaskId:s.id,data:t}))),this.manualSyncTasks.set(this.createKey(s.id),{manualSyncTask:s,disposables:e}),{id:s.id,manifest:s.manifest,status:s.status}}disposeManualSyncTask(e){e.dispose();const s=this.createKey(e.id);this.manualSyncTasks.get(s)?.disposables.dispose(),this.manualSyncTasks.delete(s)}createKey(e){return`manualSyncTask-${e}`}}h.UserDataSyncChannel=p;class m extends u.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(e){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new l.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new l.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new l.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new l.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(s,t,n){return e.call(s,t,n).then(null,c=>{throw d.UserDataSyncError.toUserDataSyncError(c)})},listen(s,t){return e.listen(s,t)}},this.channel.call("_getInitialData").then(([s,t,n])=>{this.updateStatus(s),this.updateConflicts(t),n&&this.updateLastSyncTime(n),this._register(this.channel.listen("onDidChangeStatus")(c=>this.updateStatus(c))),this._register(this.channel.listen("onDidChangeLastSyncTime")(c=>this.updateLastSyncTime(c)))}),this._register(this.channel.listen("onDidChangeConflicts")(s=>this.updateConflicts(s))),this._register(this.channel.listen("onSyncErrors")(s=>this._onSyncErrors.fire(s.map(([t,n])=>[t,d.UserDataSyncError.toUserDataSyncError(n)]))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:e,manifest:s,status:t}=await this.channel.call("createManualSyncTask"),n=this,c=new R(e,s,t,{async call(r,i,o){return n.channel.call(`manualSync/${r}`,[e,...(0,S.isArray)(i)?i:[i]],o)},listen(r,i){return l.Event.map(l.Event.filter(n.channel.listen(`manualSync/${r}`,i),o=>!c.isDiposed()&&o.manualSyncTaskId===e),o=>o.data)}});return c}replace(e){return this.channel.call("replace",[e])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(e,s,t,n){return this.channel.call("accept",[e,s,t,n])}resolveContent(e){return this.channel.call("resolveContent",[e])}async getLocalSyncResourceHandles(e){return(await this.channel.call("getLocalSyncResourceHandles",[e])).map(({created:t,uri:n})=>({created:t,uri:a.URI.revive(n)}))}async getRemoteSyncResourceHandles(e){return(await this.channel.call("getRemoteSyncResourceHandles",[e])).map(({created:t,uri:n})=>({created:t,uri:a.URI.revive(n)}))}async getAssociatedResources(e,s){return(await this.channel.call("getAssociatedResources",[e,s])).map(({resource:n,comparableResource:c})=>({resource:a.URI.revive(n),comparableResource:a.URI.revive(c)}))}async getMachineId(e,s){return this.channel.call("getMachineId",[e,s])}async updateStatus(e){this._status=e,this._onDidChangeStatus.fire(e)}async updateConflicts(e){this._conflicts=e.map(([s,t])=>[s,t.map(n=>({...n,localResource:a.URI.revive(n.localResource),remoteResource:a.URI.revive(n.remoteResource),previewResource:a.URI.revive(n.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(e){this._lastSyncTime!==e&&(this._lastSyncTime=e,this._onDidChangeLastSyncTime.fire(e))}}h.UserDataSyncChannelClient=m;class R extends u.Disposable{get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}constructor(e,s,t,n){super();this.id=e,this.manifest=s,this._disposed=!1,this._status=t;const c=this;this.channel={async call(r,i,o){try{const y=await n.call(r,i,o);return c.isDiposed()||(c._status=await n.call("_getStatus")),y}catch(y){throw d.UserDataSyncError.toUserDataSyncError(y)}},listen(r,i){return n.listen(r,i)}}}async preview(){const e=await this.channel.call("preview");return this.deserializePreviews(e)}async accept(e,s){const t=await this.channel.call("accept",[e,s]);return this.deserializePreviews(t)}async merge(e){const s=await this.channel.call("merge",[e]);return this.deserializePreviews(s)}async discard(e){const s=await this.channel.call("discard",[e]);return this.deserializePreviews(s)}async discardConflicts(){const e=await this.channel.call("discardConflicts");return this.deserializePreviews(e)}async apply(){const e=await this.channel.call("apply");return this.deserializePreviews(e)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(e){return e.map(([s,t])=>[s,{isLastSyncFromCurrentMachine:t.isLastSyncFromCurrentMachine,resourcePreviews:t.resourcePreviews.map(n=>({...n,localResource:a.URI.revive(n.localResource),remoteResource:a.URI.revive(n.remoteResource),previewResource:a.URI.revive(n.previewResource),acceptedResource:a.URI.revive(n.acceptedResource)}))}])}}});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/userDataSync/common/userDataSyncServiceIpc.js.map
