/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/glob","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/severity","child_process","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/collections","vs/base/common/stopwatch","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/assert","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","os","vs/editor/common/languages","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/idGenerator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist","dns"],Pe=function(Q){for(var e=[],u=0,i=Q.length;u<i;u++)e[u]=ke[Q[u]];return e};define(ke[57],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function u(i,y){if(!i)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=u}),define(ke[78],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function u(C){return C?C.replace(/\$\((.*?)\)/g,(D,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=u;class i{constructor(D,b,T){this.id=D,this.definition=b,this.description=T,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function y(C,D){const b=["codicon","codicon-"+C];return D&&b.push("codicon-modifier-"+D),b}e.getClassNamesArray=y;var A;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function b(P){if(P instanceof i)return["codicon","codicon-"+P.id];const S=D.exec(P.id);if(!S)return b(i.error);let[,I,E]=S;const v=["codicon","codicon-"+I];return E&&v.push("codicon-modifier-"+E.substr(1)),v}C.asClassNameArray=b;function T(P){return b(P).join(" ")}C.asClassName=T;function L(P){return"."+b(P).join(".")}C.asCSSSelector=L})(A||(e.CSSIcon=A={}))}),define(ke[48],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const u=Object.prototype.hasOwnProperty;function i(L){const P=[];for(let S in L)u.call(L,S)&&P.push(L[S]);return P}e.values=i;function y(L,P){for(let S in L)if(u.call(L,S)&&P({key:S,value:L[S]},function(){delete L[S]})===!1)return}e.forEach=y;function A(L,P){const S=Object.create(null);for(const I of L){const E=P(I);let v=S[E];v||(v=S[E]=[]),v.push(I)}return S}e.groupBy=A;function C(L){const P=Object.create(null);return L&&L.forEach((S,I)=>{P[I]=S}),P}e.fromMap=C;function D(L,P){const S=[],I=[];for(let E of L)P.has(E)||S.push(E);for(let E of P)L.has(E)||I.push(E);return{removed:S,added:I}}e.diffSets=D;function b(L,P){const S=[],I=[];for(let[E,v]of L)P.has(E)||S.push(v);for(let[E,v]of P)L.has(E)||I.push(v);return{removed:S,added:I}}e.diffMaps=b;class T{constructor(){this.map=new Map}add(P,S){let I=this.map.get(P);I||(I=new Set,this.map.set(P,I)),I.add(S)}delete(P,S){const I=this.map.get(P);!I||(I.delete(S),I.size===0&&this.map.delete(P))}forEach(P,S){const I=this.map.get(P);!I||I.forEach(S)}}e.SetMap=T}),define(ke[58],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function u(C){return(D,b,T)=>{let L=null,P=null;if(typeof T.value=="function"?(L="value",P=T.value):typeof T.get=="function"&&(L="get",P=T.get),!P)throw new Error("not supported");T[L]=C(P,b)}}e.createDecorator=u;function i(C,D,b){let T=null,L=null;if(typeof b.value=="function"?(T="value",L=b.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(T="get",L=b.get),!L)throw new Error("not supported");const P=`$memoize$${D}`;b[T]=function(...S){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,S)}),this[P]}}e.memoize=i;function y(C,D,b){return u((T,L)=>{const P=`$debounce$${L}`,S=`$debounce$result$${L}`;return function(...I){this[S]||(this[S]=b?b():void 0),clearTimeout(this[P]),D&&(this[S]=D(this[S],...I),I=[this[S]]),this[P]=setTimeout(()=>{T.apply(this,I),this[S]=b?b():void 0},C)}})}e.debounce=y;function A(C,D,b){return u((T,L)=>{const P=`$throttle$timer$${L}`,S=`$throttle$result$${L}`,I=`$throttle$lastRun$${L}`,E=`$throttle$pending$${L}`;return function(...v){if(this[S]||(this[S]=b?b():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),D&&(this[S]=D(this[S],...v)),this[E])return;const w=this[I]+C;w<=Date.now()?(this[I]=Date.now(),T.apply(this,[this[S]]),this[S]=b?b():void 0):(this[E]=!0,this[P]=setTimeout(()=>{this[E]=!1,this[I]=Date.now(),T.apply(this,[this[S]]),this[S]=b?b():void 0},w-Date.now()))}})}e.throttle=A}),define(ke[11],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class u{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(d=>{d(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=u,e.errorHandler=new u;function i(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=i;function y(m){b(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=y;function A(m){b(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=A;function C(m){if(m instanceof Error){let{name:o,message:d}=m;const r=m.stacktrace||m.stack;return{$isError:!0,name:o,message:d,stack:r}}return m}e.transformErrorForSerialization=C;const D="Canceled";function b(m){return m instanceof T?!0:m instanceof Error&&m.name===D&&m.message===D}e.isCancellationError=b;class T extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=T;function L(){const m=new Error(D);return m.name=m.message,m}e.canceled=L;function P(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=P;function S(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=S;function I(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=I;function E(m){const o=new Error(`${m} has been disposed`);return o.name="DISPOSED",o}e.disposed=E;function v(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=v;class w extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=w;class g extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=g;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;class f extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(o){if(o&&o instanceof f)return o;if(o&&o instanceof Error){const d=new f;return d.name=o.name,d.message=o.message,d.stack=o.stack,d}return new f(o)}}e.ErrorNoTelemetry=f;class a extends Error{constructor(o){super(o||"An unexpected bug occurred.");Object.setPrototypeOf(this,a.prototype);debugger}}e.BugIndicatingError=a}),define(ke[16],Pe([1,0,11]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(se,be=0){return se[se.length-(1+be)]}e.tail=i;function y(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}e.tail2=y;function A(se,be,Te=(pe,we)=>pe===we){if(se===be)return!0;if(!se||!be||se.length!==be.length)return!1;for(let pe=0,we=se.length;pe<we;pe++)if(!Te(se[pe],be[pe]))return!1;return!0}e.equals=A;function C(se,be,Te){return D(se.length,pe=>Te(se[pe],be))}e.binarySearch=C;function D(se,be){let Te=0,pe=se-1;for(;Te<=pe;){const we=(Te+pe)/2|0,Ae=be(we);if(Ae<0)Te=we+1;else if(Ae>0)pe=we-1;else return we}return-(Te+1)}e.binarySearch2=D;function b(se,be){let Te=0,pe=se.length;if(pe===0)return 0;for(;Te<pe;){const we=Math.floor((Te+pe)/2);be(se[we])?pe=we:Te=we+1}return Te}e.findFirstInSorted=b;function T(se,be,Te){if(se=se|0,se>=be.length)throw new TypeError("invalid index");let pe=be[Math.floor(be.length*Math.random())],we=[],Ae=[],ce=[];for(let me of be){const ie=Te(me,pe);ie<0?we.push(me):ie>0?Ae.push(me):ce.push(me)}return se<we.length?T(se,we,Te):se<we.length+ce.length?ce[0]:T(se-(we.length+ce.length),Ae,Te)}e.quickSelect=T;function L(se,be){const Te=[];let pe;for(const we of se.slice(0).sort(be))!pe||be(pe[0],we)!==0?(pe=[we],Te.push(pe)):pe.push(we);return Te}e.groupBy=L;function P(se,be,Te){const pe=[];function we(me,ie,ee){if(ie===0&&ee.length===0)return;const M=pe[pe.length-1];M&&M.start+M.deleteCount===me?(M.deleteCount+=ie,M.toInsert.push(...ee)):pe.push({start:me,deleteCount:ie,toInsert:ee})}let Ae=0,ce=0;for(;;){if(Ae===se.length){we(Ae,0,be.slice(ce));break}if(ce===be.length){we(Ae,se.length-Ae,[]);break}const me=se[Ae],ie=be[ce],ee=Te(me,ie);ee===0?(Ae+=1,ce+=1):ee<0?(we(Ae,1,[]),Ae+=1):ee>0&&(we(Ae,0,[ie]),ce+=1)}return pe}e.sortedDiff=P;function S(se,be,Te){const pe=P(se,be,Te),we=[],Ae=[];for(const ce of pe)we.push(...se.slice(ce.start,ce.start+ce.deleteCount)),Ae.push(...ce.toInsert);return{removed:we,added:Ae}}e.delta=S;function I(se,be,Te){if(Te===0)return[];const pe=se.slice(0,Te).sort(be);return v(se,be,pe,Te,se.length),pe}e.top=I;function E(se,be,Te,pe,we){return Te===0?Promise.resolve([]):new Promise((Ae,ce)=>{(async()=>{const me=se.length,ie=se.slice(0,Te).sort(be);for(let ee=Te,M=Math.min(Te+pe,me);ee<me;ee=M,M=Math.min(M+pe,me)){if(ee>Te&&await new Promise(x=>setTimeout(x)),we&&we.isCancellationRequested)throw new u.CancellationError;v(se,be,ie,ee,M)}return ie})().then(Ae,ce)})}e.topAsync=E;function v(se,be,Te,pe,we){for(const Ae=Te.length;pe<we;pe++){const ce=se[pe];if(be(ce,Te[Ae-1])<0){Te.pop();const me=b(Te,ie=>be(ce,ie)<0);Te.splice(me,0,ce)}}}function w(se){return se.filter(be=>!!be)}e.coalesce=w;function g(se){let be=0;for(let Te=0;Te<se.length;Te++)se[Te]&&(se[be]=se[Te],be+=1);se.length=be}e.coalesceInPlace=g;function _(se,be,Te){se.splice(Te,0,se.splice(be,1)[0])}e.move=_;function f(se){return!Array.isArray(se)||se.length===0}e.isFalsyOrEmpty=f;function a(se){return Array.isArray(se)&&se.length>0}e.isNonEmptyArray=a;function m(se,be=Te=>Te){const Te=new Set;return se.filter(pe=>{const we=be(pe);return Te.has(we)?!1:(Te.add(we),!0)})}e.distinct=m;function o(se){const be=new Set;return Te=>{const pe=se(Te);return be.has(pe)?!1:(be.add(pe),!0)}}e.uniqueFilter=o;function d(se,be){const Te=r(se,be);if(Te!==-1)return se[Te]}e.findLast=d;function r(se,be){for(let Te=se.length-1;Te>=0;Te--){const pe=se[Te];if(be(pe))return Te}return-1}e.lastIndex=r;function s(se,be){return se.length>0?se[0]:be}e.firstOrDefault=s;function n(se,be){return se.length>0?se[se.length-1]:be}e.lastOrDefault=n;function t(se,be,Te=(pe,we)=>pe===we){let pe=0;for(let we=0,Ae=Math.min(se.length,be.length);we<Ae&&Te(se[we],be[we]);we++)pe++;return pe}e.commonPrefixLength=t;function c(se){return[].concat(...se)}e.flatten=c;function l(se,be){let Te=typeof be=="number"?se:0;typeof be=="number"?Te=se:(Te=0,be=se);const pe=[];if(Te<=be)for(let we=Te;we<be;we++)pe.push(we);else for(let we=Te;we>be;we--)pe.push(we);return pe}e.range=l;function h(se,be,Te){return se.reduce((pe,we)=>(pe[be(we)]=Te?Te(we):we,pe),Object.create(null))}e.index=h;function p(se,be){return se.push(be),()=>R(se,be)}e.insert=p;function R(se,be){const Te=se.indexOf(be);if(Te>-1)return se.splice(Te,1),be}e.remove=R;function F(se,be,Te){const pe=se.slice(0,be),we=se.slice(be);return pe.concat(Te,we)}e.arrayInsert=F;function O(se,be){let Te;if(typeof be=="number"){let pe=be;Te=()=>{const we=Math.sin(pe++)*179426549;return we-Math.floor(we)}}else Te=Math.random;for(let pe=se.length-1;pe>0;pe-=1){const we=Math.floor(Te()*(pe+1)),Ae=se[pe];se[pe]=se[we],se[we]=Ae}}e.shuffle=O;function k(se,be){const Te=se.indexOf(be);Te>-1&&(se.splice(Te,1),se.unshift(be))}e.pushToStart=k;function U(se,be){const Te=se.indexOf(be);Te>-1&&(se.splice(Te,1),se.push(be))}e.pushToEnd=U;function B(se,be){for(const Te of be)se.push(Te)}e.pushMany=B;function z(se,be){return Array.isArray(se)?se.map(be):be(se)}e.mapArrayOrNot=z;function Y(se){return Array.isArray(se)?se:[se]}e.asArray=Y;function $(se){return se[Math.floor(Math.random()*se.length)]}e.getRandomElement=$;function N(se,be){for(const Te of se){const pe=be(Te);if(pe!==void 0)return pe}}e.mapFind=N;function V(se,be,Te){const pe=q(se,be),we=se.length,Ae=Te.length;se.length=we+Ae;for(let ce=we-1;ce>=pe;ce--)se[ce+Ae]=se[ce];for(let ce=0;ce<Ae;ce++)se[ce+pe]=Te[ce]}e.insertInto=V;function H(se,be,Te,pe){const we=q(se,be),Ae=se.splice(we,Te);return V(se,we,pe),Ae}e.splice=H;function q(se,be){return be<0?Math.max(be+se.length,0):Math.min(be,se.length)}var te;(function(se){function be(we){return we<0}se.isLessThan=be;function Te(we){return we>0}se.isGreaterThan=Te;function pe(we){return we===0}se.isNeitherLessOrGreaterThan=pe,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(te||(e.CompareResult=te={}));function fe(se,be){return(Te,pe)=>be(se(Te),se(pe))}e.compareBy=fe;const ne=(se,be)=>se-be;e.numberComparator=ne;function le(se,be){if(se.length===0)return;let Te=se[0];for(let pe=1;pe<se.length;pe++){const we=se[pe];be(we,Te)>0&&(Te=we)}return Te}e.findMaxBy=le;function K(se,be){if(se.length===0)return;let Te=se[0];for(let pe=1;pe<se.length;pe++){const we=se[pe];be(we,Te)>=0&&(Te=we)}return Te}e.findLastMaxBy=K;function ge(se,be){return le(se,(Te,pe)=>-be(Te,pe))}e.findMinBy=ge;class ve{constructor(be){this.items=be,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(be){let Te=this.firstIdx;for(;Te<this.items.length&&be(this.items[Te]);)Te++;const pe=Te===this.firstIdx?null:this.items.slice(this.firstIdx,Te);return this.firstIdx=Te,pe}takeFromEndWhile(be){let Te=this.lastIdx;for(;Te>=0&&be(this.items[Te]);)Te--;const pe=Te===this.lastIdx?null:this.items.slice(Te+1,this.lastIdx+1);return this.lastIdx=Te,pe}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const be=this.items[this.firstIdx];return this.firstIdx++,be}removeLast(){const be=this.items[this.lastIdx];return this.lastIdx--,be}takeCount(be){const Te=this.items.slice(this.firstIdx,this.firstIdx+be);return this.firstIdx+=be,Te}}e.ArrayQueue=ve}),define(ke[59],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function u(i){const y=this;let A=!1,C;return function(){return A||(A=!0,C=i.apply(y,arguments)),C}}e.once=u}),define(ke[79],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class u{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=u,e.defaultGenerator=new u("id#")}),define(ke[60],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(i){function y(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}i.is=y;const A=Object.freeze([]);function C(){return A}i.empty=C;function*D(d){yield d}i.single=D;function b(d){return d||A}i.from=b;function T(d){return!d||d[Symbol.iterator]().next().done===!0}i.isEmpty=T;function L(d){return d[Symbol.iterator]().next().value}i.first=L;function P(d,r){for(const s of d)if(r(s))return!0;return!1}i.some=P;function S(d,r){for(const s of d)if(r(s))return s}i.find=S;function*I(d,r){for(const s of d)r(s)&&(yield s)}i.filter=I;function*E(d,r){let s=0;for(const n of d)yield r(n,s++)}i.map=E;function*v(...d){for(const r of d)for(const s of r)yield s}i.concat=v;function*w(d){for(const r of d)for(const s of r)yield s}i.concatNested=w;function g(d,r,s){let n=s;for(const t of d)n=r(n,t);return n}i.reduce=g;function _(d,r){let s=0;for(const n of d)r(n,s++)}i.forEach=_;function*f(d,r,s=d.length){for(r<0&&(r+=d.length),s<0?s+=d.length:s>d.length&&(s=d.length);r<s;r++)yield d[r]}i.slice=f;function a(d,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,d];const n=d[Symbol.iterator]();for(let t=0;t<r;t++){const c=n.next();if(c.done)return[s,i.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return n}}]}i.consume=a;function m(d){return a(d)[0]}i.collect=m;function o(d,r,s=(n,t)=>n===t){const n=d[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const c=n.next(),l=t.next();if(c.done!==l.done)return!1;if(c.done)return!0;if(!s(c.value,l.value))return!1}}i.equals=o})(u||(e.Iterable=u={}))}),define(ke[143],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var u;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(u||(e.ScanError=u={}));var i;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(i||(e.SyntaxKind=i={}));var y;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(y||(e.ParseErrorCode=y={}));var A;(function(o){o.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function C(o,d=!1){let r=0,s=o.length,n="",t=0,c=16,l=0;function h(B){let z=0,Y=0;for(;z<B;){const $=o.charCodeAt(r);if($>=48&&$<=57)Y=Y*16+$-48;else if($>=65&&$<=70)Y=Y*16+$-65+10;else if($>=97&&$<=102)Y=Y*16+$-97+10;else break;r++,z++}return z<B&&(Y=-1),Y}function p(B){r=B,n="",t=0,c=16,l=0}function R(){const B=r;if(o.charCodeAt(r)===48)r++;else for(r++;r<o.length&&T(o.charCodeAt(r));)r++;if(r<o.length&&o.charCodeAt(r)===46)if(r++,r<o.length&&T(o.charCodeAt(r)))for(r++;r<o.length&&T(o.charCodeAt(r));)r++;else return l=3,o.substring(B,r);let z=r;if(r<o.length&&(o.charCodeAt(r)===69||o.charCodeAt(r)===101))if(r++,(r<o.length&&o.charCodeAt(r)===43||o.charCodeAt(r)===45)&&r++,r<o.length&&T(o.charCodeAt(r))){for(r++;r<o.length&&T(o.charCodeAt(r));)r++;z=r}else l=3;return o.substring(B,z)}function F(){let B="",z=r;for(;;){if(r>=s){B+=o.substring(z,r),l=2;break}const Y=o.charCodeAt(r);if(Y===34){B+=o.substring(z,r),r++;break}if(Y===92){if(B+=o.substring(z,r),r++,r>=s){l=2;break}switch(o.charCodeAt(r++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const N=h(4);N>=0?B+=String.fromCharCode(N):l=4;break}default:l=5}z=r;continue}if(Y>=0&&Y<=31)if(b(Y)){B+=o.substring(z,r),l=2;break}else l=6;r++}return B}function O(){if(n="",l=0,t=r,r>=s)return t=s,c=17;let B=o.charCodeAt(r);if(D(B)){do r++,n+=String.fromCharCode(B),B=o.charCodeAt(r);while(D(B));return c=15}if(b(B))return r++,n+=String.fromCharCode(B),B===13&&o.charCodeAt(r)===10&&(r++,n+=`
`),c=14;switch(B){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,n=F(),c=10;case 47:{const z=r-1;if(o.charCodeAt(r+1)===47){for(r+=2;r<s&&!b(o.charCodeAt(r));)r++;return n=o.substring(z,r),c=12}if(o.charCodeAt(r+1)===42){r+=2;const Y=s-1;let $=!1;for(;r<Y;){if(o.charCodeAt(r)===42&&o.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,l=1),n=o.substring(z,r),c=13}return n+=String.fromCharCode(B),r++,c=16}case 45:if(n+=String.fromCharCode(B),r++,r===s||!T(o.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),c=11;default:for(;r<s&&k(B);)r++,B=o.charCodeAt(r);if(t!==r){switch(n=o.substring(t,r),n){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(B),r++,c=16}}function k(B){if(D(B)||b(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let B;do B=O();while(B>=12&&B<=15);return B}return{setPosition:p,getPosition:()=>r,scan:d?U:O,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>t,getTokenLength:()=>r-t,getTokenError:()=>l}}e.createScanner=C;function D(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function b(o){return o===10||o===13||o===8232||o===8233}function T(o){return o>=48&&o<=57}var L;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(L||(L={}));function P(o,d){const r=[],s=new Object;let n;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function l(h,p,R,F){t.value=h,t.offset=p,t.length=R,t.type=F,t.colonOffset=void 0,n=t}try{f(o,{onObjectBegin:(h,p)=>{if(d<=h)throw s;n=void 0,c=d>h,r.push("")},onObjectProperty:(h,p,R)=>{if(d<p||(l(h,p,R,"property"),r[r.length-1]=h,d<=p+R))throw s},onObjectEnd:(h,p)=>{if(d<=h)throw s;n=void 0,r.pop()},onArrayBegin:(h,p)=>{if(d<=h)throw s;n=void 0,r.push(0)},onArrayEnd:(h,p)=>{if(d<=h)throw s;n=void 0,r.pop()},onLiteralValue:(h,p,R)=>{if(d<p||(l(h,p,R,m(h)),d<=p+R))throw s},onSeparator:(h,p,R)=>{if(d<=p)throw s;if(h===":"&&n&&n.type==="property")n.colonOffset=p,c=!1,n=void 0;else if(h===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(c=!0,r[r.length-1]=""),n=void 0}}})}catch(h){if(h!==s)throw h}return{path:r,previousNode:n,isAtPropertyKey:c,matches:h=>{let p=0;for(let R=0;p<h.length&&R<r.length;R++)if(h[p]===r[R]||h[p]==="*")p++;else if(h[p]!=="**")return!1;return p===h.length}}}e.getLocation=P;function S(o,d=[],r=A.DEFAULT){let s=null,n=[];const t=[];function c(h){Array.isArray(n)?n.push(h):s!==null&&(n[s]=h)}return f(o,{onObjectBegin:()=>{const h={};c(h),t.push(n),n=h,s=null},onObjectProperty:h=>{s=h},onObjectEnd:()=>{n=t.pop()},onArrayBegin:()=>{const h=[];c(h),t.push(n),n=h,s=null},onArrayEnd:()=>{n=t.pop()},onLiteralValue:c,onError:(h,p,R)=>{d.push({error:h,offset:p,length:R})}},r),n[0]}e.parse=S;function I(o,d=[],r=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(h){s.type==="property"&&(s.length=h-s.offset,s=s.parent)}function t(h){return s.children.push(h),h}f(o,{onObjectBegin:h=>{s=t({type:"object",offset:h,length:-1,parent:s,children:[]})},onObjectProperty:(h,p,R)=>{s=t({type:"property",offset:p,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:h,offset:p,length:R,parent:s})},onObjectEnd:(h,p)=>{s.length=h+p-s.offset,s=s.parent,n(h+p)},onArrayBegin:(h,p)=>{s=t({type:"array",offset:h,length:-1,parent:s,children:[]})},onArrayEnd:(h,p)=>{s.length=h+p-s.offset,s=s.parent,n(h+p)},onLiteralValue:(h,p,R)=>{t({type:m(h),offset:p,length:R,parent:s,value:h}),n(p+R)},onSeparator:(h,p,R)=>{s.type==="property"&&(h===":"?s.colonOffset=p:h===","&&n(p))},onError:(h,p,R)=>{d.push({error:h,offset:p,length:R})}},r);const l=s.children[0];return l&&delete l.parent,l}e.parseTree=I;function E(o,d){if(!o)return;let r=o;for(let s of d)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const t of r.children)if(Array.isArray(t.children)&&t.children[0].value===s){r=t.children[1],n=!0;break}if(!n)return}else{const n=s;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.findNodeAtLocation=E;function v(o){if(!o.parent||!o.parent.children)return[];const d=v(o.parent);if(o.parent.type==="property"){const r=o.parent.children[0].value;d.push(r)}else if(o.parent.type==="array"){const r=o.parent.children.indexOf(o);r!==-1&&d.push(r)}return d}e.getNodePath=v;function w(o){switch(o.type){case"array":return o.children.map(w);case"object":{const d=Object.create(null);for(let r of o.children){const s=r.children[1];s&&(d[r.children[0].value]=w(s))}return d}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=w;function g(o,d,r=!1){return d>=o.offset&&d<o.offset+o.length||r&&d===o.offset+o.length}e.contains=g;function _(o,d,r=!1){if(g(o,d,r)){const s=o.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=d;n++){const t=_(s[n],d,r);if(t)return t}return o}}e.findNodeAtOffset=_;function f(o,d,r=A.DEFAULT){const s=C(o,!1);function n(ne){return ne?()=>ne(s.getTokenOffset(),s.getTokenLength()):()=>!0}function t(ne){return ne?le=>ne(le,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=n(d.onObjectBegin),l=t(d.onObjectProperty),h=n(d.onObjectEnd),p=n(d.onArrayBegin),R=n(d.onArrayEnd),F=t(d.onLiteralValue),O=t(d.onSeparator),k=n(d.onComment),U=t(d.onError),B=r&&r.disallowComments,z=r&&r.allowTrailingComma;function Y(){for(;;){const ne=s.scan();switch(s.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:B||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ne){case 12:case 13:B?$(10):k();break;case 16:$(1);break;case 15:case 14:break;default:return ne}}}function $(ne,le=[],K=[]){if(U(ne),le.length+K.length>0){let ge=s.getToken();for(;ge!==17;){if(le.indexOf(ge)!==-1){Y();break}else if(K.indexOf(ge)!==-1)break;ge=Y()}}}function N(ne){const le=s.getTokenValue();return ne?F(le):l(le),Y(),!0}function V(){switch(s.getToken()){case 11:{let ne=0;try{ne=JSON.parse(s.getTokenValue()),typeof ne!="number"&&($(2),ne=0)}catch{$(2)}F(ne);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return Y(),!0}function H(){return s.getToken()!==10?($(3,[],[2,5]),!1):(N(!1),s.getToken()===6?(O(":"),Y(),fe()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function q(){c(),Y();let ne=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ne||$(4,[],[]),O(","),Y(),s.getToken()===2&&z)break}else ne&&$(6,[],[]);H()||$(4,[],[2,5]),ne=!0}return h(),s.getToken()!==2?$(7,[2],[]):Y(),!0}function te(){p(),Y();let ne=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ne||$(4,[],[]),O(","),Y(),s.getToken()===4&&z)break}else ne&&$(6,[],[]);fe()||$(4,[],[4,5]),ne=!0}return R(),s.getToken()!==4?$(8,[4],[]):Y(),!0}function fe(){switch(s.getToken()){case 3:return te();case 1:return q();case 10:return N(!0);default:return V()}}return Y(),s.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):fe()?(s.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=f;function a(o,d){let r=C(o),s=[],n,t=0,c;do switch(c=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:t!==c&&s.push(o.substring(t,c)),d!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,d)),t=r.getPosition();break}while(n!==17);return s.join("")}e.stripComments=a;function m(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(ke[80],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class u{constructor(y){this.executor=y,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(y){return new u(()=>y(this.getValue()))}}e.Lazy=u}),define(ke[6],Pe([1,0,59,60]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const y=!1;let A=null;function C(n){A=n}if(e.setDisposableTracker=C,y){const n="__is_disposable_tracked__";C(new class{trackDisposable(t){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{t[n]||console.log(c)},3e3)}setParent(t,c){if(t&&t!==_.None)try{t[n]=!0}catch{}}markAsDisposed(t){if(t&&t!==_.None)try{t[n]=!0}catch{}}markAsSingleton(t){}})}function D(n){return A?.trackDisposable(n),n}function b(n){A?.markAsDisposed(n)}function T(n,t){A?.setParent(n,t)}function L(n,t){if(!!A)for(const c of n)A.setParent(c,t)}function P(n){return A?.markAsSingleton(n),n}e.markAsSingleton=P;class S extends Error{constructor(t){super(`Encountered errors while disposing of store. Errors: [${t.join(", ")}]`);this.errors=t}}e.MultiDisposeError=S;function I(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=I;function E(n){if(i.Iterable.is(n)){let t=[];for(const c of n)if(c)try{c.dispose()}catch(l){t.push(l)}if(t.length===1)throw t[0];if(t.length>1)throw new S(t);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=E;function v(...n){const t=w(()=>E(n));return L(n,t),t}e.combinedDisposable=v;function w(n){const t=D({dispose:(0,u.once)(()=>{b(t),n()})});return t}e.toDisposable=w;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{E(this._toDispose.values())}finally{this._toDispose.clear()}}add(t){if(!t)return t;if(t===this)throw new Error("Cannot register a disposable on itself!");return T(t,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(t),t}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this._store=new g,D(this),T(this._store,this)}dispose(){b(this),this._store.dispose()}_register(t){if(t===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(t)}}e.Disposable=_,_.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(t){this._isDisposed||t===this._value||(this._value?.dispose(),t&&T(t,this),this._value=t)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const t=this._value;return this._value=void 0,t&&T(t,null),t}}e.MutableDisposable=f;class a{constructor(t){this._disposable=t,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(t){let c=t;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,b(this))},this}}e.SafeDisposable=m;class o{constructor(){this.references=new Map}acquire(t,...c){let l=this.references.get(t);l||(l={counter:0,object:this.createReferencedObject(t,...c)},this.references.set(t,l));const{object:h}=l,p=(0,u.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(t,l.object),this.references.delete(t))});return l.counter++,{object:h,dispose:p}}}e.ReferenceCollection=o;class d{constructor(t){this.referenceCollection=t}async acquire(t,...c){const l=this.referenceCollection.acquire(t,...c);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=d;class r{constructor(t){this.object=t}dispose(){}}e.ImmortalReference=r;function s(n){const t=new g;try{n(t)}finally{t.dispose()}}e.disposeOnReturn=s}),define(ke[81],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class u{constructor(A){this.element=A,this.next=u.Undefined,this.prev=u.Undefined}}u.Undefined=new u(void 0);class i{constructor(){this._first=u.Undefined,this._last=u.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===u.Undefined}clear(){let A=this._first;for(;A!==u.Undefined;){const C=A.next;A.prev=u.Undefined,A.next=u.Undefined,A=C}this._first=u.Undefined,this._last=u.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,C){const D=new u(A);if(this._first===u.Undefined)this._first=D,this._last=D;else if(C){const T=this._last;this._last=D,D.prev=T,T.next=D}else{const T=this._first;this._first=D,D.next=T,T.prev=D}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(D))}}shift(){if(this._first!==u.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==u.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==u.Undefined&&A.next!==u.Undefined){const C=A.prev;C.next=A.next,A.next.prev=C}else A.prev===u.Undefined&&A.next===u.Undefined?(this._first=u.Undefined,this._last=u.Undefined):A.next===u.Undefined?(this._last=this._last.prev,this._last.next=u.Undefined):A.prev===u.Undefined&&(this._first=this._first.next,this._first.prev=u.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==u.Undefined;)yield A.element,A=A.next}}e.LinkedList=i}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ke[144],Pe([0]),e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,e(Q.marked={}))}(this,function(Q){"use strict";function e(pe,we){for(var Ae=0;Ae<we.length;Ae++){var ce=we[Ae];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(pe,ce.key,ce)}}function u(pe,we,Ae){return we&&e(pe.prototype,we),Ae&&e(pe,Ae),Object.defineProperty(pe,"prototype",{writable:!1}),pe}function i(pe,we){if(!!pe){if(typeof pe=="string")return y(pe,we);var Ae=Object.prototype.toString.call(pe).slice(8,-1);if(Ae==="Object"&&pe.constructor&&(Ae=pe.constructor.name),Ae==="Map"||Ae==="Set")return Array.from(pe);if(Ae==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ae))return y(pe,we)}}function y(pe,we){(we==null||we>pe.length)&&(we=pe.length);for(var Ae=0,ce=new Array(we);Ae<we;Ae++)ce[Ae]=pe[Ae];return ce}function A(pe,we){var Ae=typeof Symbol!="undefined"&&pe[Symbol.iterator]||pe["@@iterator"];if(Ae)return(Ae=Ae.call(pe)).next.bind(Ae);if(Array.isArray(pe)||(Ae=i(pe))||we&&pe&&typeof pe.length=="number"){Ae&&(pe=Ae);var ce=0;return function(){return ce>=pe.length?{done:!0}:{done:!1,value:pe[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Q.defaults=C();function D(pe){Q.defaults=pe}var b=/[&<>"']/,T=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(we){return S[we]};function E(pe,we){if(we){if(b.test(pe))return pe.replace(T,I)}else if(L.test(pe))return pe.replace(P,I);return pe}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(pe){return pe.replace(v,function(we,Ae){return Ae=Ae.toLowerCase(),Ae==="colon"?":":Ae.charAt(0)==="#"?Ae.charAt(1)==="x"?String.fromCharCode(parseInt(Ae.substring(2),16)):String.fromCharCode(+Ae.substring(1)):""})}var g=/(^|[^\[])\^/g;function _(pe,we){pe=typeof pe=="string"?pe:pe.source,we=we||"";var Ae={replace:function(me,ie){return ie=ie.source||ie,ie=ie.replace(g,"$1"),pe=pe.replace(me,ie),Ae},getRegex:function(){return new RegExp(pe,we)}};return Ae}var f=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(pe,we,Ae){if(pe){var ce;try{ce=decodeURIComponent(w(Ae)).replace(f,"").toLowerCase()}catch{return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}we&&!a.test(Ae)&&(Ae=n(we,Ae));try{Ae=encodeURI(Ae).replace(/%25/g,"%")}catch{return null}return Ae}var o={},d=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(pe,we){o[" "+pe]||(d.test(pe)?o[" "+pe]=pe+"/":o[" "+pe]=h(pe,"/",!0)),pe=o[" "+pe];var Ae=pe.indexOf(":")===-1;return we.substring(0,2)==="//"?Ae?we:pe.replace(r,"$1")+we:we.charAt(0)==="/"?Ae?we:pe.replace(s,"$1")+we:pe+we}var t={exec:function(){}};function c(pe){for(var we=1,Ae,ce;we<arguments.length;we++){Ae=arguments[we];for(ce in Ae)Object.prototype.hasOwnProperty.call(Ae,ce)&&(pe[ce]=Ae[ce])}return pe}function l(pe,we){var Ae=pe.replace(/\|/g,function(ie,ee,M){for(var x=!1,G=ee;--G>=0&&M[G]==="\\";)x=!x;return x?"|":" |"}),ce=Ae.split(/ \|/),me=0;if(ce[0].trim()||ce.shift(),ce.length>0&&!ce[ce.length-1].trim()&&ce.pop(),ce.length>we)ce.splice(we);else for(;ce.length<we;)ce.push("");for(;me<ce.length;me++)ce[me]=ce[me].trim().replace(/\\\|/g,"|");return ce}function h(pe,we,Ae){var ce=pe.length;if(ce===0)return"";for(var me=0;me<ce;){var ie=pe.charAt(ce-me-1);if(ie===we&&!Ae)me++;else if(ie!==we&&Ae)me++;else break}return pe.slice(0,ce-me)}function p(pe,we){if(pe.indexOf(we[1])===-1)return-1;for(var Ae=pe.length,ce=0,me=0;me<Ae;me++)if(pe[me]==="\\")me++;else if(pe[me]===we[0])ce++;else if(pe[me]===we[1]&&(ce--,ce<0))return me;return-1}function R(pe){pe&&pe.sanitize&&!pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(pe,we){if(we<1)return"";for(var Ae="";we>1;)we&1&&(Ae+=pe),we>>=1,pe+=pe;return Ae+pe}function O(pe,we,Ae,ce){var me=we.href,ie=we.title?E(we.title):null,ee=pe[1].replace(/\\([\[\]])/g,"$1");if(pe[0].charAt(0)!=="!"){ce.state.inLink=!0;var M={type:"link",raw:Ae,href:me,title:ie,text:ee,tokens:ce.inlineTokens(ee,[])};return ce.state.inLink=!1,M}return{type:"image",raw:Ae,href:me,title:ie,text:E(ee)}}function k(pe,we){var Ae=pe.match(/^(\s+)(?:```)/);if(Ae===null)return we;var ce=Ae[1];return we.split(`
`).map(function(me){var ie=me.match(/^\s+/);if(ie===null)return me;var ee=ie[0];return ee.length>=ce.length?me.slice(ce.length):me}).join(`
`)}var U=function(){function pe(Ae){this.options=Ae||Q.defaults}var we=pe.prototype;return we.space=function(ce){var me=this.rules.block.newline.exec(ce);if(me&&me[0].length>0)return{type:"space",raw:me[0]}},we.code=function(ce){var me=this.rules.block.code.exec(ce);if(me){var ie=me[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:me[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:h(ie,`
`)}}},we.fences=function(ce){var me=this.rules.block.fences.exec(ce);if(me){var ie=me[0],ee=k(ie,me[3]||"");return{type:"code",raw:ie,lang:me[2]?me[2].trim():me[2],text:ee}}},we.heading=function(ce){var me=this.rules.block.heading.exec(ce);if(me){var ie=me[2].trim();if(/#$/.test(ie)){var ee=h(ie,"#");(this.options.pedantic||!ee||/ $/.test(ee))&&(ie=ee.trim())}var M={type:"heading",raw:me[0],depth:me[1].length,text:ie,tokens:[]};return this.lexer.inline(M.text,M.tokens),M}},we.hr=function(ce){var me=this.rules.block.hr.exec(ce);if(me)return{type:"hr",raw:me[0]}},we.blockquote=function(ce){var me=this.rules.block.blockquote.exec(ce);if(me){var ie=me[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:me[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},we.list=function(ce){var me=this.rules.block.list.exec(ce);if(me){var ie,ee,M,x,G,X,de,Ee,oe,De,ye,ze,Ve=me[1].trim(),Me=Ve.length>1,Je={type:"list",raw:"",ordered:Me,start:Me?+Ve.slice(0,-1):"",loose:!1,items:[]};Ve=Me?"\\d{1,9}\\"+Ve.slice(-1):"\\"+Ve,this.options.pedantic&&(Ve=Me?Ve:"[*+-]");for(var J=new RegExp("^( {0,3}"+Ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");ce&&(ze=!1,!(!(me=J.exec(ce))||this.rules.block.hr.test(ce)));){if(ie=me[0],ce=ce.substring(ie.length),Ee=me[2].split(`
`,1)[0],oe=ce.split(`
`,1)[0],this.options.pedantic?(x=2,ye=Ee.trimLeft()):(x=me[2].search(/[^ ]/),x=x>4?1:x,ye=Ee.slice(x),x+=me[1].length),X=!1,!Ee&&/^ *$/.test(oe)&&(ie+=oe+`
`,ce=ce.substring(oe.length+1),ze=!0),!ze)for(var re=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ce=new RegExp("^ {0,"+Math.min(3,x-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");ce&&(De=ce.split(`
`,1)[0],Ee=De,this.options.pedantic&&(Ee=Ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(re.test(Ee)||Ce.test(ce)));){if(Ee.search(/[^ ]/)>=x||!Ee.trim())ye+=`
`+Ee.slice(x);else if(!X)ye+=`
`+Ee;else break;!X&&!Ee.trim()&&(X=!0),ie+=De+`
`,ce=ce.substring(De.length+1)}Je.loose||(de?Je.loose=!0:/\n *\n *$/.test(ie)&&(de=!0)),this.options.gfm&&(ee=/^\[[ xX]\] /.exec(ye),ee&&(M=ee[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:ie,task:!!ee,checked:M,loose:!1,text:ye}),Je.raw+=ie}Je.items[Je.items.length-1].raw=ie.trimRight(),Je.items[Je.items.length-1].text=ye.trimRight(),Je.raw=Je.raw.trimRight();var ae=Je.items.length;for(G=0;G<ae;G++){this.lexer.state.top=!1,Je.items[G].tokens=this.lexer.blockTokens(Je.items[G].text,[]);var Ie=Je.items[G].tokens.filter(function($e){return $e.type==="space"}),Ne=Ie.every(function($e){for(var Ge=$e.raw.split(""),qe=0,Ze=A(Ge),Xe;!(Xe=Ze()).done;){var st=Xe.value;if(st===`
`&&(qe+=1),qe>1)return!0}return!1});!Je.loose&&Ie.length&&Ne&&(Je.loose=!0,Je.items[G].loose=!0)}return Je}},we.html=function(ce){var me=this.rules.block.html.exec(ce);if(me){var ie={type:"html",raw:me[0],pre:!this.options.sanitizer&&(me[1]==="pre"||me[1]==="script"||me[1]==="style"),text:me[0]};return this.options.sanitize&&(ie.type="paragraph",ie.text=this.options.sanitizer?this.options.sanitizer(me[0]):E(me[0]),ie.tokens=[],this.lexer.inline(ie.text,ie.tokens)),ie}},we.def=function(ce){var me=this.rules.block.def.exec(ce);if(me){me[3]&&(me[3]=me[3].substring(1,me[3].length-1));var ie=me[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:me[0],href:me[2],title:me[3]}}},we.table=function(ce){var me=this.rules.block.table.exec(ce);if(me){var ie={type:"table",header:l(me[1]).map(function(de){return{text:de}}),align:me[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:me[3]&&me[3].trim()?me[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=me[0];var ee=ie.align.length,M,x,G,X;for(M=0;M<ee;M++)/^ *-+: *$/.test(ie.align[M])?ie.align[M]="right":/^ *:-+: *$/.test(ie.align[M])?ie.align[M]="center":/^ *:-+ *$/.test(ie.align[M])?ie.align[M]="left":ie.align[M]=null;for(ee=ie.rows.length,M=0;M<ee;M++)ie.rows[M]=l(ie.rows[M],ie.header.length).map(function(de){return{text:de}});for(ee=ie.header.length,x=0;x<ee;x++)ie.header[x].tokens=[],this.lexer.inline(ie.header[x].text,ie.header[x].tokens);for(ee=ie.rows.length,x=0;x<ee;x++)for(X=ie.rows[x],G=0;G<X.length;G++)X[G].tokens=[],this.lexer.inline(X[G].text,X[G].tokens);return ie}}},we.lheading=function(ce){var me=this.rules.block.lheading.exec(ce);if(me){var ie={type:"heading",raw:me[0],depth:me[2].charAt(0)==="="?1:2,text:me[1],tokens:[]};return this.lexer.inline(ie.text,ie.tokens),ie}},we.paragraph=function(ce){var me=this.rules.block.paragraph.exec(ce);if(me){var ie={type:"paragraph",raw:me[0],text:me[1].charAt(me[1].length-1)===`
`?me[1].slice(0,-1):me[1],tokens:[]};return this.lexer.inline(ie.text,ie.tokens),ie}},we.text=function(ce){var me=this.rules.block.text.exec(ce);if(me){var ie={type:"text",raw:me[0],text:me[0],tokens:[]};return this.lexer.inline(ie.text,ie.tokens),ie}},we.escape=function(ce){var me=this.rules.inline.escape.exec(ce);if(me)return{type:"escape",raw:me[0],text:E(me[1])}},we.tag=function(ce){var me=this.rules.inline.tag.exec(ce);if(me)return!this.lexer.state.inLink&&/^<a /i.test(me[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(me[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(me[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(me[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:me[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):E(me[0]):me[0]}},we.link=function(ce){var me=this.rules.inline.link.exec(ce);if(me){var ie=me[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var ee=h(ie.slice(0,-1),"\\");if((ie.length-ee.length)%2==0)return}else{var M=p(me[2],"()");if(M>-1){var x=me[0].indexOf("!")===0?5:4,G=x+me[1].length+M;me[2]=me[2].substring(0,M),me[0]=me[0].substring(0,G).trim(),me[3]=""}}var X=me[2],de="";if(this.options.pedantic){var Ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);Ee&&(X=Ee[1],de=Ee[3])}else de=me[3]?me[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(ie)?X=X.slice(1):X=X.slice(1,-1)),O(me,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:de&&de.replace(this.rules.inline._escapes,"$1")},me[0],this.lexer)}},we.reflink=function(ce,me){var ie;if((ie=this.rules.inline.reflink.exec(ce))||(ie=this.rules.inline.nolink.exec(ce))){var ee=(ie[2]||ie[1]).replace(/\s+/g," ");if(ee=me[ee.toLowerCase()],!ee||!ee.href){var M=ie[0].charAt(0);return{type:"text",raw:M,text:M}}return O(ie,ee,ie[0],this.lexer)}},we.emStrong=function(ce,me,ie){ie===void 0&&(ie="");var ee=this.rules.inline.emStrong.lDelim.exec(ce);if(!!ee&&!(ee[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var M=ee[1]||ee[2]||"";if(!M||M&&(ie===""||this.rules.inline.punctuation.exec(ie))){var x=ee[0].length-1,G,X,de=x,Ee=0,oe=ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,me=me.slice(-1*ce.length+x);(ee=oe.exec(me))!=null;)if(G=ee[1]||ee[2]||ee[3]||ee[4]||ee[5]||ee[6],!!G){if(X=G.length,ee[3]||ee[4]){de+=X;continue}else if((ee[5]||ee[6])&&x%3&&!((x+X)%3)){Ee+=X;continue}if(de-=X,!(de>0)){if(X=Math.min(X,X+de+Ee),Math.min(x,X)%2){var De=ce.slice(1,x+ee.index+X);return{type:"em",raw:ce.slice(0,x+ee.index+X+1),text:De,tokens:this.lexer.inlineTokens(De,[])}}var ye=ce.slice(2,x+ee.index+X-1);return{type:"strong",raw:ce.slice(0,x+ee.index+X+1),text:ye,tokens:this.lexer.inlineTokens(ye,[])}}}}}},we.codespan=function(ce){var me=this.rules.inline.code.exec(ce);if(me){var ie=me[2].replace(/\n/g," "),ee=/[^ ]/.test(ie),M=/^ /.test(ie)&&/ $/.test(ie);return ee&&M&&(ie=ie.substring(1,ie.length-1)),ie=E(ie,!0),{type:"codespan",raw:me[0],text:ie}}},we.br=function(ce){var me=this.rules.inline.br.exec(ce);if(me)return{type:"br",raw:me[0]}},we.del=function(ce){var me=this.rules.inline.del.exec(ce);if(me)return{type:"del",raw:me[0],text:me[2],tokens:this.lexer.inlineTokens(me[2],[])}},we.autolink=function(ce,me){var ie=this.rules.inline.autolink.exec(ce);if(ie){var ee,M;return ie[2]==="@"?(ee=E(this.options.mangle?me(ie[1]):ie[1]),M="mailto:"+ee):(ee=E(ie[1]),M=ee),{type:"link",raw:ie[0],text:ee,href:M,tokens:[{type:"text",raw:ee,text:ee}]}}},we.url=function(ce,me){var ie;if(ie=this.rules.inline.url.exec(ce)){var ee,M;if(ie[2]==="@")ee=E(this.options.mangle?me(ie[0]):ie[0]),M="mailto:"+ee;else{var x;do x=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(x!==ie[0]);ee=E(ie[0]),ie[1]==="www."?M="http://"+ee:M=ee}return{type:"link",raw:ie[0],text:ee,href:M,tokens:[{type:"text",raw:ee,text:ee}]}}},we.inlineText=function(ce,me){var ie=this.rules.inline.text.exec(ce);if(ie){var ee;return this.lexer.state.inRawBlock?ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):E(ie[0]):ie[0]:ee=E(this.options.smartypants?me(ie[0]):ie[0]),{type:"text",raw:ie[0],text:ee}}},pe}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=_(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=_(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=_(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=_(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=_(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=_(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=c({},B),B.gfm=c({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=_(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=_(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=c({},B.normal,{html:_(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:_(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=_(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=_(B._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=_(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=_(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=_(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=_(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=_(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=_(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=_(z.reflink).replace("label",z._label).replace("ref",B._label).getRegex(),z.nolink=_(z.nolink).replace("ref",B._label).getRegex(),z.reflinkSearch=_(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=c({},z),z.pedantic=c({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:_(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:_(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=c({},z.normal,{escape:_(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=_(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=c({},z.gfm,{br:_(z.br).replace("{2,}","*").getRegex(),text:_(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Y(pe){return pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(pe){var we="",Ae,ce,me=pe.length;for(Ae=0;Ae<me;Ae++)ce=pe.charCodeAt(Ae),Math.random()>.5&&(ce="x"+ce.toString(16)),we+="&#"+ce+";";return we}var N=function(){function pe(Ae){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ae||Q.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ce={block:B.normal,inline:z.normal};this.options.pedantic?(ce.block=B.pedantic,ce.inline=z.pedantic):this.options.gfm&&(ce.block=B.gfm,this.options.breaks?ce.inline=z.breaks:ce.inline=z.gfm),this.tokenizer.rules=ce}pe.lex=function(ce,me){var ie=new pe(me);return ie.lex(ce)},pe.lexInline=function(ce,me){var ie=new pe(me);return ie.inlineTokens(ce)};var we=pe.prototype;return we.lex=function(ce){ce=ce.replace(/\r\n|\r/g,`
`),this.blockTokens(ce,this.tokens);for(var me;me=this.inlineQueue.shift();)this.inlineTokens(me.src,me.tokens);return this.tokens},we.blockTokens=function(ce,me){var ie=this;me===void 0&&(me=[]),this.options.pedantic?ce=ce.replace(/\t/g,"    ").replace(/^ +$/gm,""):ce=ce.replace(/^( *)(\t+)/gm,function(de,Ee,oe){return Ee+"    ".repeat(oe.length)});for(var ee,M,x,G;ce;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(de){return(ee=de.call({lexer:ie},ce,me))?(ce=ce.substring(ee.raw.length),me.push(ee),!0):!1}))){if(ee=this.tokenizer.space(ce)){ce=ce.substring(ee.raw.length),ee.raw.length===1&&me.length>0?me[me.length-1].raw+=`
`:me.push(ee);continue}if(ee=this.tokenizer.code(ce)){ce=ce.substring(ee.raw.length),M=me[me.length-1],M&&(M.type==="paragraph"||M.type==="text")?(M.raw+=`
`+ee.raw,M.text+=`
`+ee.text,this.inlineQueue[this.inlineQueue.length-1].src=M.text):me.push(ee);continue}if(ee=this.tokenizer.fences(ce)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(ee=this.tokenizer.heading(ce)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(ee=this.tokenizer.hr(ce)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(ee=this.tokenizer.blockquote(ce)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(ee=this.tokenizer.list(ce)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(ee=this.tokenizer.html(ce)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(ee=this.tokenizer.def(ce)){ce=ce.substring(ee.raw.length),M=me[me.length-1],M&&(M.type==="paragraph"||M.type==="text")?(M.raw+=`
`+ee.raw,M.text+=`
`+ee.raw,this.inlineQueue[this.inlineQueue.length-1].src=M.text):this.tokens.links[ee.tag]||(this.tokens.links[ee.tag]={href:ee.href,title:ee.title});continue}if(ee=this.tokenizer.table(ce)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(ee=this.tokenizer.lheading(ce)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(x=ce,this.options.extensions&&this.options.extensions.startBlock&&function(){var de=1/0,Ee=ce.slice(1),oe=void 0;ie.options.extensions.startBlock.forEach(function(De){oe=De.call({lexer:this},Ee),typeof oe=="number"&&oe>=0&&(de=Math.min(de,oe))}),de<1/0&&de>=0&&(x=ce.substring(0,de+1))}(),this.state.top&&(ee=this.tokenizer.paragraph(x))){M=me[me.length-1],G&&M.type==="paragraph"?(M.raw+=`
`+ee.raw,M.text+=`
`+ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=M.text):me.push(ee),G=x.length!==ce.length,ce=ce.substring(ee.raw.length);continue}if(ee=this.tokenizer.text(ce)){ce=ce.substring(ee.raw.length),M=me[me.length-1],M&&M.type==="text"?(M.raw+=`
`+ee.raw,M.text+=`
`+ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=M.text):me.push(ee);continue}if(ce){var X="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,me},we.inline=function(ce,me){this.inlineQueue.push({src:ce,tokens:me})},we.inlineTokens=function(ce,me){var ie=this;me===void 0&&(me=[]);var ee,M,x,G=ce,X,de,Ee;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)oe.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,X.index)+"["+F("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,X.index)+"["+F("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,X.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;)if(de||(Ee=""),de=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ee=ye.call({lexer:ie},ce,me))?(ce=ce.substring(ee.raw.length),me.push(ee),!0):!1}))){if(ee=this.tokenizer.escape(ce)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(ee=this.tokenizer.tag(ce)){ce=ce.substring(ee.raw.length),M=me[me.length-1],M&&ee.type==="text"&&M.type==="text"?(M.raw+=ee.raw,M.text+=ee.text):me.push(ee);continue}if(ee=this.tokenizer.link(ce)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(ee=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(ee.raw.length),M=me[me.length-1],M&&ee.type==="text"&&M.type==="text"?(M.raw+=ee.raw,M.text+=ee.text):me.push(ee);continue}if(ee=this.tokenizer.emStrong(ce,G,Ee)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(ee=this.tokenizer.codespan(ce)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(ee=this.tokenizer.br(ce)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(ee=this.tokenizer.del(ce)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(ee=this.tokenizer.autolink(ce,$)){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(!this.state.inLink&&(ee=this.tokenizer.url(ce,$))){ce=ce.substring(ee.raw.length),me.push(ee);continue}if(x=ce,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,ze=ce.slice(1),Ve=void 0;ie.options.extensions.startInline.forEach(function(Me){Ve=Me.call({lexer:this},ze),typeof Ve=="number"&&Ve>=0&&(ye=Math.min(ye,Ve))}),ye<1/0&&ye>=0&&(x=ce.substring(0,ye+1))}(),ee=this.tokenizer.inlineText(x,Y)){ce=ce.substring(ee.raw.length),ee.raw.slice(-1)!=="_"&&(Ee=ee.raw.slice(-1)),de=!0,M=me[me.length-1],M&&M.type==="text"?(M.raw+=ee.raw,M.text+=ee.text):me.push(ee);continue}if(ce){var De="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return me},u(pe,null,[{key:"rules",get:function(){return{block:B,inline:z}}}]),pe}(),V=function(){function pe(Ae){this.options=Ae||Q.defaults}var we=pe.prototype;return we.code=function(ce,me,ie){var ee=(me||"").match(/\S*/)[0];if(this.options.highlight){var M=this.options.highlight(ce,ee);M!=null&&M!==ce&&(ie=!0,ce=M)}return ce=ce.replace(/\n$/,"")+`
`,ee?'<pre><code class="'+this.options.langPrefix+E(ee,!0)+'">'+(ie?ce:E(ce,!0))+`</code></pre>
`:"<pre><code>"+(ie?ce:E(ce,!0))+`</code></pre>
`},we.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},we.html=function(ce){return ce},we.heading=function(ce,me,ie,ee){if(this.options.headerIds){var M=this.options.headerPrefix+ee.slug(ie);return"<h"+me+' id="'+M+'">'+ce+"</h"+me+`>
`}return"<h"+me+">"+ce+"</h"+me+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(ce,me,ie){var ee=me?"ol":"ul",M=me&&ie!==1?' start="'+ie+'"':"";return"<"+ee+M+`>
`+ce+"</"+ee+`>
`},we.listitem=function(ce){return"<li>"+ce+`</li>
`},we.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(ce){return"<p>"+ce+`</p>
`},we.table=function(ce,me){return me&&(me="<tbody>"+me+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+me+`</table>
`},we.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},we.tablecell=function(ce,me){var ie=me.header?"th":"td",ee=me.align?"<"+ie+' align="'+me.align+'">':"<"+ie+">";return ee+ce+("</"+ie+`>
`)},we.strong=function(ce){return"<strong>"+ce+"</strong>"},we.em=function(ce){return"<em>"+ce+"</em>"},we.codespan=function(ce){return"<code>"+ce+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(ce){return"<del>"+ce+"</del>"},we.link=function(ce,me,ie){if(ce=m(this.options.sanitize,this.options.baseUrl,ce),ce===null)return ie;var ee='<a href="'+E(ce)+'"';return me&&(ee+=' title="'+me+'"'),ee+=">"+ie+"</a>",ee},we.image=function(ce,me,ie){if(ce=m(this.options.sanitize,this.options.baseUrl,ce),ce===null)return ie;var ee='<img src="'+ce+'" alt="'+ie+'"';return me&&(ee+=' title="'+me+'"'),ee+=this.options.xhtml?"/>":">",ee},we.text=function(ce){return ce},pe}(),H=function(){function pe(){}var we=pe.prototype;return we.strong=function(ce){return ce},we.em=function(ce){return ce},we.codespan=function(ce){return ce},we.del=function(ce){return ce},we.html=function(ce){return ce},we.text=function(ce){return ce},we.link=function(ce,me,ie){return""+ie},we.image=function(ce,me,ie){return""+ie},we.br=function(){return""},pe}(),q=function(){function pe(){this.seen={}}var we=pe.prototype;return we.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(ce,me){var ie=ce,ee=0;if(this.seen.hasOwnProperty(ie)){ee=this.seen[ce];do ee++,ie=ce+"-"+ee;while(this.seen.hasOwnProperty(ie))}return me||(this.seen[ce]=ee,this.seen[ie]=0),ie},we.slug=function(ce,me){me===void 0&&(me={});var ie=this.serialize(ce);return this.getNextSafeSlug(ie,me.dryrun)},pe}(),te=function(){function pe(Ae){this.options=Ae||Q.defaults,this.options.renderer=this.options.renderer||new V,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new q}pe.parse=function(ce,me){var ie=new pe(me);return ie.parse(ce)},pe.parseInline=function(ce,me){var ie=new pe(me);return ie.parseInline(ce)};var we=pe.prototype;return we.parse=function(ce,me){me===void 0&&(me=!0);var ie="",ee,M,x,G,X,de,Ee,oe,De,ye,ze,Ve,Me,Je,J,re,Ce,ae,Ie,Ne=ce.length;for(ee=0;ee<Ne;ee++){if(ye=ce[ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ie=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ie!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ie+=Ie||"";continue}switch(ye.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,w(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(oe="",Ee="",G=ye.header.length,M=0;M<G;M++)Ee+=this.renderer.tablecell(this.parseInline(ye.header[M].tokens),{header:!0,align:ye.align[M]});for(oe+=this.renderer.tablerow(Ee),De="",G=ye.rows.length,M=0;M<G;M++){for(de=ye.rows[M],Ee="",X=de.length,x=0;x<X;x++)Ee+=this.renderer.tablecell(this.parseInline(de[x].tokens),{header:!1,align:ye.align[x]});De+=this.renderer.tablerow(Ee)}ie+=this.renderer.table(oe,De);continue}case"blockquote":{De=this.parse(ye.tokens),ie+=this.renderer.blockquote(De);continue}case"list":{for(ze=ye.ordered,Ve=ye.start,Me=ye.loose,G=ye.items.length,De="",M=0;M<G;M++)J=ye.items[M],re=J.checked,Ce=J.task,Je="",J.task&&(ae=this.renderer.checkbox(re),Me?J.tokens.length>0&&J.tokens[0].type==="paragraph"?(J.tokens[0].text=ae+" "+J.tokens[0].text,J.tokens[0].tokens&&J.tokens[0].tokens.length>0&&J.tokens[0].tokens[0].type==="text"&&(J.tokens[0].tokens[0].text=ae+" "+J.tokens[0].tokens[0].text)):J.tokens.unshift({type:"text",text:ae}):Je+=ae),Je+=this.parse(J.tokens,Me),De+=this.renderer.listitem(Je,Ce,re);ie+=this.renderer.list(De,ze,Ve);continue}case"html":{ie+=this.renderer.html(ye.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(De=ye.tokens?this.parseInline(ye.tokens):ye.text;ee+1<Ne&&ce[ee+1].type==="text";)ye=ce[++ee],De+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ie+=me?this.renderer.paragraph(De):De;continue}default:{var $e='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}}return ie},we.parseInline=function(ce,me){me=me||this.renderer;var ie="",ee,M,x,G=ce.length;for(ee=0;ee<G;ee++){if(M=ce[ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[M.type]&&(x=this.options.extensions.renderers[M.type].call({parser:this},M),x!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(M.type))){ie+=x||"";continue}switch(M.type){case"escape":{ie+=me.text(M.text);break}case"html":{ie+=me.html(M.text);break}case"link":{ie+=me.link(M.href,M.title,this.parseInline(M.tokens,me));break}case"image":{ie+=me.image(M.href,M.title,M.text);break}case"strong":{ie+=me.strong(this.parseInline(M.tokens,me));break}case"em":{ie+=me.em(this.parseInline(M.tokens,me));break}case"codespan":{ie+=me.codespan(M.text);break}case"br":{ie+=me.br();break}case"del":{ie+=me.del(this.parseInline(M.tokens,me));break}case"text":{ie+=me.text(M.text);break}default:{var X='Token with "'+M.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return ie},pe}();function fe(pe,we,Ae){if(typeof pe=="undefined"||pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(pe)+", string expected");if(typeof we=="function"&&(Ae=we,we=null),we=c({},fe.defaults,we||{}),R(we),Ae){var ce=we.highlight,me;try{me=N.lex(pe,we)}catch(x){return Ae(x)}var ie=function(G){var X;if(!G)try{we.walkTokens&&fe.walkTokens(me,we.walkTokens),X=te.parse(me,we)}catch(de){G=de}return we.highlight=ce,G?Ae(G):Ae(null,X)};if(!ce||ce.length<3||(delete we.highlight,!me.length))return ie();var ee=0;fe.walkTokens(me,function(x){x.type==="code"&&(ee++,setTimeout(function(){ce(x.text,x.lang,function(G,X){if(G)return ie(G);X!=null&&X!==x.text&&(x.text=X,x.escaped=!0),ee--,ee===0&&ie()})},0))}),ee===0&&ie();return}try{var M=N.lex(pe,we);return we.walkTokens&&fe.walkTokens(M,we.walkTokens),te.parse(M,we)}catch(x){if(x.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+E(x.message+"",!0)+"</pre>";throw x}}fe.options=fe.setOptions=function(pe){return c(fe.defaults,pe),D(fe.defaults),fe},fe.getDefaults=C,fe.defaults=Q.defaults,fe.use=function(){for(var pe=arguments.length,we=new Array(pe),Ae=0;Ae<pe;Ae++)we[Ae]=arguments[Ae];var ce=c.apply(void 0,[{}].concat(we)),me=fe.defaults.extensions||{renderers:{},childTokens:{}},ie;we.forEach(function(ee){if(ee.extensions&&(ie=!0,ee.extensions.forEach(function(x){if(!x.name)throw new Error("extension name required");if(x.renderer){var G=me.renderers?me.renderers[x.name]:null;G?me.renderers[x.name]=function(){for(var X=arguments.length,de=new Array(X),Ee=0;Ee<X;Ee++)de[Ee]=arguments[Ee];var oe=x.renderer.apply(this,de);return oe===!1&&(oe=G.apply(this,de)),oe}:me.renderers[x.name]=x.renderer}if(x.tokenizer){if(!x.level||x.level!=="block"&&x.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");me[x.level]?me[x.level].unshift(x.tokenizer):me[x.level]=[x.tokenizer],x.start&&(x.level==="block"?me.startBlock?me.startBlock.push(x.start):me.startBlock=[x.start]:x.level==="inline"&&(me.startInline?me.startInline.push(x.start):me.startInline=[x.start]))}x.childTokens&&(me.childTokens[x.name]=x.childTokens)})),ee.renderer&&function(){var x=fe.defaults.renderer||new V,G=function(Ee){var oe=x[Ee];x[Ee]=function(){for(var De=arguments.length,ye=new Array(De),ze=0;ze<De;ze++)ye[ze]=arguments[ze];var Ve=ee.renderer[Ee].apply(x,ye);return Ve===!1&&(Ve=oe.apply(x,ye)),Ve}};for(var X in ee.renderer)G(X);ce.renderer=x}(),ee.tokenizer&&function(){var x=fe.defaults.tokenizer||new U,G=function(Ee){var oe=x[Ee];x[Ee]=function(){for(var De=arguments.length,ye=new Array(De),ze=0;ze<De;ze++)ye[ze]=arguments[ze];var Ve=ee.tokenizer[Ee].apply(x,ye);return Ve===!1&&(Ve=oe.apply(x,ye)),Ve}};for(var X in ee.tokenizer)G(X);ce.tokenizer=x}(),ee.walkTokens){var M=fe.defaults.walkTokens;ce.walkTokens=function(x){ee.walkTokens.call(this,x),M&&M.call(this,x)}}ie&&(ce.extensions=me),fe.setOptions(ce)})},fe.walkTokens=function(pe,we){for(var Ae=function(){var ee=me.value;switch(we.call(fe,ee),ee.type){case"table":{for(var M=A(ee.header),x;!(x=M()).done;){var G=x.value;fe.walkTokens(G.tokens,we)}for(var X=A(ee.rows),de;!(de=X()).done;)for(var Ee=de.value,oe=A(Ee),De;!(De=oe()).done;){var ye=De.value;fe.walkTokens(ye.tokens,we)}break}case"list":{fe.walkTokens(ee.items,we);break}default:fe.defaults.extensions&&fe.defaults.extensions.childTokens&&fe.defaults.extensions.childTokens[ee.type]?fe.defaults.extensions.childTokens[ee.type].forEach(function(ze){fe.walkTokens(ee[ze],we)}):ee.tokens&&fe.walkTokens(ee.tokens,we)}},ce=A(pe),me;!(me=ce()).done;)Ae()},fe.parseInline=function(pe,we){if(typeof pe=="undefined"||pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(pe)+", string expected");we=c({},fe.defaults,we||{}),R(we);try{var Ae=N.lexInline(pe,we);return we.walkTokens&&fe.walkTokens(Ae,we.walkTokens),te.parseInline(Ae,we)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+E(ce.message+"",!0)+"</pre>";throw ce}},fe.Parser=te,fe.parser=te.parse,fe.Renderer=V,fe.TextRenderer=H,fe.Lexer=N,fe.lexer=N.lex,fe.Tokenizer=U,fe.Slugger=q,fe.parse=fe;var ne=fe.options,le=fe.setOptions,K=fe.use,ge=fe.walkTokens,ve=fe.parseInline,se=fe,be=te.parse,Te=N.lex;Q.Lexer=N,Q.Parser=te,Q.Renderer=V,Q.Slugger=q,Q.TextRenderer=H,Q.Tokenizer=U,Q.getDefaults=C,Q.lexer=Te,Q.marked=fe,Q.options=ne,Q.parse=se,Q.parseInline=ve,Q.parser=be,Q.setOptions=le,Q.use=K,Q.walkTokens=ge,Object.defineProperty(Q,"__esModule",{value:!0})}),define(ke[94],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function u(D,b,T){return Math.min(Math.max(D,b),T)}e.clamp=u;function i(D,b){return(b+D%b)%b}e.rot=i;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class A{constructor(){this._n=1,this._val=0}update(b){return this._val=this._val+(b-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class C{constructor(b){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(b),this._values.fill(0,0,b)}update(b){const T=this._values[this._index];return this._values[this._index]=b,this._index=(this._index+1)%this._values.length,this._sum-=T,this._sum+=b,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=C}),function(){function Q(y){const A=[];typeof y=="number"&&A.push("code/timeOrigin",y);function C(b){A.push(b,Date.now())}function D(){const b=[];for(let T=0;T<A.length;T+=2)b.push({name:A[T],startTime:A[T+1]});return b}return{mark:C,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const C of performance.getEntriesByType("mark"))A.push({name:C.name,startTime:Math.round(y+C.startTime)});return A}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function u(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=u(i))}(),define(ke[13],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const u="en";let i=!1,y=!1,A=!1,C=!1,D=!1,b=!1,T=!1,L=!1,P=!1,S,I=u,E,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const g=typeof w?.versions?.electron=="string",_=g&&w?.type==="renderer";if(typeof navigator=="object"&&!_)v=navigator.userAgent,i=v.indexOf("Windows")>=0,y=v.indexOf("Macintosh")>=0,L=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=v.indexOf("Linux")>=0,b=!0,S=navigator.language,I=S;else if(typeof w=="object"){i=w.platform==="win32",y=w.platform==="darwin",A=w.platform==="linux",C=A&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,T=g,P=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=u,I=u;const t=w.env.VSCODE_NLS_CONFIG;if(t)try{const c=JSON.parse(t),l=c.availableLanguages["*"];S=c.locale,I=l||u,E=c._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var f;(function(t){t[t.Web=0]="Web",t[t.Mac=1]="Mac",t[t.Linux=2]="Linux",t[t.Windows=3]="Windows"})(f||(e.Platform=f={}));function a(t){switch(t){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let m=0;y?m=1:i?m=3:A&&(m=2),e.isWindows=i,e.isMacintosh=y,e.isLinux=A,e.isLinuxSnap=C,e.isNative=D,e.isElectron=T,e.isWeb=b,e.isWebWorker=b&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isCI=P,e.platform=m,e.userAgent=v,e.language=I;var o;(function(t){function c(){return e.language}t.value=c;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}t.isDefaultVariant=l;function h(){return e.language==="en"}t.isDefault=h})(o||(e.Language=o={})),e.locale=S,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){let t=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let h=0,p=t.length;h<p;h++){const R=t[h];if(R.id===l.data.vscodeScheduleAsyncWork){t.splice(h,1),R.callback();return}}});let c=0;return l=>{const h=++c;t.push({id:h,callback:l}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return t=>setTimeout(t)})();var d;(function(t){t[t.Windows=1]="Windows",t[t.Macintosh=2]="Macintosh",t[t.Linux=3]="Linux"})(d||(e.OperatingSystem=d={})),e.OS=y||L?2:i?1:3;let r=!0,s=!1;function n(){if(!s){s=!0;const t=new Uint8Array(2);t[0]=1,t[1]=2,r=new Uint16Array(t.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=n,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ke[40],Pe([1,0,13]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof u.globals.vscode!="undefined"&&typeof u.globals.vscode.process!="undefined"){const y=u.globals.vscode.process;i={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return u.isWindows?"win32":u.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(ke[9],Pe([1,0,40]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,y=97,A=90,C=122,D=46,b=47,T=92,L=58,P=63;class S extends Error{constructor(a,m,o){let d;typeof m=="string"&&m.indexOf("not ")===0?(d="must not be",m=m.replace(/^not /,"")):d="must be";const r=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${r} ${d} of type ${m}`;s+=`. Received type ${typeof o}`;super(s);this.code="ERR_INVALID_ARG_TYPE"}}function I(f,a){if(typeof f!="string")throw new S(a,"string",f)}function E(f){return f===b||f===T}function v(f){return f===b}function w(f){return f>=i&&f<=A||f>=y&&f<=C}function g(f,a,m,o){let d="",r=0,s=-1,n=0,t=0;for(let c=0;c<=f.length;++c){if(c<f.length)t=f.charCodeAt(c);else{if(o(t))break;t=b}if(o(t)){if(!(s===c-1||n===1))if(n===2){if(d.length<2||r!==2||d.charCodeAt(d.length-1)!==D||d.charCodeAt(d.length-2)!==D){if(d.length>2){const l=d.lastIndexOf(m);l===-1?(d="",r=0):(d=d.slice(0,l),r=d.length-1-d.lastIndexOf(m)),s=c,n=0;continue}else if(d.length!==0){d="",r=0,s=c,n=0;continue}}a&&(d+=d.length>0?`${m}..`:"..",r=2)}else d.length>0?d+=`${m}${f.slice(s+1,c)}`:d=f.slice(s+1,c),r=c-s-1;s=c,n=0}else t===D&&n!==-1?++n:n=-1}return d}function _(f,a){if(a===null||typeof a!="object")throw new S("pathObject","Object",a);const m=a.dir||a.root,o=a.base||`${a.name||""}${a.ext||""}`;return m?m===a.root?`${m}${o}`:`${m}${f}${o}`:o}e.win32={resolve(...f){let a="",m="",o=!1;for(let d=f.length-1;d>=-1;d--){let r;if(d>=0){if(r=f[d],I(r,"path"),r.length===0)continue}else a.length===0?r=u.cwd():(r=u.env[`=${a}`]||u.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===T)&&(r=`${a}\\`));const s=r.length;let n=0,t="",c=!1;const l=r.charCodeAt(0);if(s===1)E(l)&&(n=1,c=!0);else if(E(l))if(c=!0,E(r.charCodeAt(1))){let h=2,p=h;for(;h<s&&!E(r.charCodeAt(h));)h++;if(h<s&&h!==p){const R=r.slice(p,h);for(p=h;h<s&&E(r.charCodeAt(h));)h++;if(h<s&&h!==p){for(p=h;h<s&&!E(r.charCodeAt(h));)h++;(h===s||h!==p)&&(t=`\\\\${R}\\${r.slice(p,h)}`,n=h)}}}else n=1;else w(l)&&r.charCodeAt(1)===L&&(t=r.slice(0,2),n=2,s>2&&E(r.charCodeAt(2))&&(c=!0,n=3));if(t.length>0)if(a.length>0){if(t.toLowerCase()!==a.toLowerCase())continue}else a=t;if(o){if(a.length>0)break}else if(m=`${r.slice(n)}\\${m}`,o=c,c&&a.length>0)break}return m=g(m,!o,"\\",E),o?`${a}\\${m}`:`${a}${m}`||"."},normalize(f){I(f,"path");const a=f.length;if(a===0)return".";let m=0,o,d=!1;const r=f.charCodeAt(0);if(a===1)return v(r)?"\\":f;if(E(r))if(d=!0,E(f.charCodeAt(1))){let n=2,t=n;for(;n<a&&!E(f.charCodeAt(n));)n++;if(n<a&&n!==t){const c=f.slice(t,n);for(t=n;n<a&&E(f.charCodeAt(n));)n++;if(n<a&&n!==t){for(t=n;n<a&&!E(f.charCodeAt(n));)n++;if(n===a)return`\\\\${c}\\${f.slice(t)}\\`;n!==t&&(o=`\\\\${c}\\${f.slice(t,n)}`,m=n)}}}else m=1;else w(r)&&f.charCodeAt(1)===L&&(o=f.slice(0,2),m=2,a>2&&E(f.charCodeAt(2))&&(d=!0,m=3));let s=m<a?g(f.slice(m),!d,"\\",E):"";return s.length===0&&!d&&(s="."),s.length>0&&E(f.charCodeAt(a-1))&&(s+="\\"),o===void 0?d?`\\${s}`:s:d?`${o}\\${s}`:`${o}${s}`},isAbsolute(f){I(f,"path");const a=f.length;if(a===0)return!1;const m=f.charCodeAt(0);return E(m)||a>2&&w(m)&&f.charCodeAt(1)===L&&E(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let a,m;for(let r=0;r<f.length;++r){const s=f[r];I(s,"path"),s.length>0&&(a===void 0?a=m=s:a+=`\\${s}`)}if(a===void 0)return".";let o=!0,d=0;if(typeof m=="string"&&E(m.charCodeAt(0))){++d;const r=m.length;r>1&&E(m.charCodeAt(1))&&(++d,r>2&&(E(m.charCodeAt(2))?++d:o=!1))}if(o){for(;d<a.length&&E(a.charCodeAt(d));)d++;d>=2&&(a=`\\${a.slice(d)}`)}return e.win32.normalize(a)},relative(f,a){if(I(f,"from"),I(a,"to"),f===a)return"";const m=e.win32.resolve(f),o=e.win32.resolve(a);if(m===o||(f=m.toLowerCase(),a=o.toLowerCase(),f===a))return"";let d=0;for(;d<f.length&&f.charCodeAt(d)===T;)d++;let r=f.length;for(;r-1>d&&f.charCodeAt(r-1)===T;)r--;const s=r-d;let n=0;for(;n<a.length&&a.charCodeAt(n)===T;)n++;let t=a.length;for(;t-1>n&&a.charCodeAt(t-1)===T;)t--;const c=t-n,l=s<c?s:c;let h=-1,p=0;for(;p<l;p++){const F=f.charCodeAt(d+p);if(F!==a.charCodeAt(n+p))break;F===T&&(h=p)}if(p!==l){if(h===-1)return o}else{if(c>l){if(a.charCodeAt(n+p)===T)return o.slice(n+p+1);if(p===2)return o.slice(n+p)}s>l&&(f.charCodeAt(d+p)===T?h=p:p===2&&(h=3)),h===-1&&(h=0)}let R="";for(p=d+h+1;p<=r;++p)(p===r||f.charCodeAt(p)===T)&&(R+=R.length===0?"..":"\\..");return n+=h,R.length>0?`${R}${o.slice(n,t)}`:(o.charCodeAt(n)===T&&++n,o.slice(n,t))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const a=e.win32.resolve(f);if(a.length<=2)return f;if(a.charCodeAt(0)===T){if(a.charCodeAt(1)===T){const m=a.charCodeAt(2);if(m!==P&&m!==D)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(w(a.charCodeAt(0))&&a.charCodeAt(1)===L&&a.charCodeAt(2)===T)return`\\\\?\\${a}`;return f},dirname(f){I(f,"path");const a=f.length;if(a===0)return".";let m=-1,o=0;const d=f.charCodeAt(0);if(a===1)return E(d)?f:".";if(E(d)){if(m=o=1,E(f.charCodeAt(1))){let n=2,t=n;for(;n<a&&!E(f.charCodeAt(n));)n++;if(n<a&&n!==t){for(t=n;n<a&&E(f.charCodeAt(n));)n++;if(n<a&&n!==t){for(t=n;n<a&&!E(f.charCodeAt(n));)n++;if(n===a)return f;n!==t&&(m=o=n+1)}}}}else w(d)&&f.charCodeAt(1)===L&&(m=a>2&&E(f.charCodeAt(2))?3:2,o=m);let r=-1,s=!0;for(let n=a-1;n>=o;--n)if(E(f.charCodeAt(n))){if(!s){r=n;break}}else s=!1;if(r===-1){if(m===-1)return".";r=m}return f.slice(0,r)},basename(f,a){a!==void 0&&I(a,"ext"),I(f,"path");let m=0,o=-1,d=!0,r;if(f.length>=2&&w(f.charCodeAt(0))&&f.charCodeAt(1)===L&&(m=2),a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let s=a.length-1,n=-1;for(r=f.length-1;r>=m;--r){const t=f.charCodeAt(r);if(E(t)){if(!d){m=r+1;break}}else n===-1&&(d=!1,n=r+1),s>=0&&(t===a.charCodeAt(s)?--s==-1&&(o=r):(s=-1,o=n))}return m===o?o=n:o===-1&&(o=f.length),f.slice(m,o)}for(r=f.length-1;r>=m;--r)if(E(f.charCodeAt(r))){if(!d){m=r+1;break}}else o===-1&&(d=!1,o=r+1);return o===-1?"":f.slice(m,o)},extname(f){I(f,"path");let a=0,m=-1,o=0,d=-1,r=!0,s=0;f.length>=2&&f.charCodeAt(1)===L&&w(f.charCodeAt(0))&&(a=o=2);for(let n=f.length-1;n>=a;--n){const t=f.charCodeAt(n);if(E(t)){if(!r){o=n+1;break}continue}d===-1&&(r=!1,d=n+1),t===D?m===-1?m=n:s!==1&&(s=1):m!==-1&&(s=-1)}return m===-1||d===-1||s===0||s===1&&m===d-1&&m===o+1?"":f.slice(m,d)},format:_.bind(null,"\\"),parse(f){I(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const m=f.length;let o=0,d=f.charCodeAt(0);if(m===1)return E(d)?(a.root=a.dir=f,a):(a.base=a.name=f,a);if(E(d)){if(o=1,E(f.charCodeAt(1))){let h=2,p=h;for(;h<m&&!E(f.charCodeAt(h));)h++;if(h<m&&h!==p){for(p=h;h<m&&E(f.charCodeAt(h));)h++;if(h<m&&h!==p){for(p=h;h<m&&!E(f.charCodeAt(h));)h++;h===m?o=h:h!==p&&(o=h+1)}}}}else if(w(d)&&f.charCodeAt(1)===L){if(m<=2)return a.root=a.dir=f,a;if(o=2,E(f.charCodeAt(2))){if(m===3)return a.root=a.dir=f,a;o=3}}o>0&&(a.root=f.slice(0,o));let r=-1,s=o,n=-1,t=!0,c=f.length-1,l=0;for(;c>=o;--c){if(d=f.charCodeAt(c),E(d)){if(!t){s=c+1;break}continue}n===-1&&(t=!1,n=c+1),d===D?r===-1?r=c:l!==1&&(l=1):r!==-1&&(l=-1)}return n!==-1&&(r===-1||l===0||l===1&&r===n-1&&r===s+1?a.base=a.name=f.slice(s,n):(a.name=f.slice(s,r),a.base=f.slice(s,n),a.ext=f.slice(r,n))),s>0&&s!==o?a.dir=f.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let a="",m=!1;for(let o=f.length-1;o>=-1&&!m;o--){const d=o>=0?f[o]:u.cwd();I(d,"path"),d.length!==0&&(a=`${d}/${a}`,m=d.charCodeAt(0)===b)}return a=g(a,!m,"/",v),m?`/${a}`:a.length>0?a:"."},normalize(f){if(I(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===b,m=f.charCodeAt(f.length-1)===b;return f=g(f,!a,"/",v),f.length===0?a?"/":m?"./":".":(m&&(f+="/"),a?`/${f}`:f)},isAbsolute(f){return I(f,"path"),f.length>0&&f.charCodeAt(0)===b},join(...f){if(f.length===0)return".";let a;for(let m=0;m<f.length;++m){const o=f[m];I(o,"path"),o.length>0&&(a===void 0?a=o:a+=`/${o}`)}return a===void 0?".":e.posix.normalize(a)},relative(f,a){if(I(f,"from"),I(a,"to"),f===a||(f=e.posix.resolve(f),a=e.posix.resolve(a),f===a))return"";const m=1,o=f.length,d=o-m,r=1,s=a.length-r,n=d<s?d:s;let t=-1,c=0;for(;c<n;c++){const h=f.charCodeAt(m+c);if(h!==a.charCodeAt(r+c))break;h===b&&(t=c)}if(c===n)if(s>n){if(a.charCodeAt(r+c)===b)return a.slice(r+c+1);if(c===0)return a.slice(r+c)}else d>n&&(f.charCodeAt(m+c)===b?t=c:c===0&&(t=0));let l="";for(c=m+t+1;c<=o;++c)(c===o||f.charCodeAt(c)===b)&&(l+=l.length===0?"..":"/..");return`${l}${a.slice(r+t)}`},toNamespacedPath(f){return f},dirname(f){if(I(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===b;let m=-1,o=!0;for(let d=f.length-1;d>=1;--d)if(f.charCodeAt(d)===b){if(!o){m=d;break}}else o=!1;return m===-1?a?"/":".":a&&m===1?"//":f.slice(0,m)},basename(f,a){a!==void 0&&I(a,"ext"),I(f,"path");let m=0,o=-1,d=!0,r;if(a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let s=a.length-1,n=-1;for(r=f.length-1;r>=0;--r){const t=f.charCodeAt(r);if(t===b){if(!d){m=r+1;break}}else n===-1&&(d=!1,n=r+1),s>=0&&(t===a.charCodeAt(s)?--s==-1&&(o=r):(s=-1,o=n))}return m===o?o=n:o===-1&&(o=f.length),f.slice(m,o)}for(r=f.length-1;r>=0;--r)if(f.charCodeAt(r)===b){if(!d){m=r+1;break}}else o===-1&&(d=!1,o=r+1);return o===-1?"":f.slice(m,o)},extname(f){I(f,"path");let a=-1,m=0,o=-1,d=!0,r=0;for(let s=f.length-1;s>=0;--s){const n=f.charCodeAt(s);if(n===b){if(!d){m=s+1;break}continue}o===-1&&(d=!1,o=s+1),n===D?a===-1?a=s:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||o===-1||r===0||r===1&&a===o-1&&a===m+1?"":f.slice(a,o)},format:_.bind(null,"/"),parse(f){I(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const m=f.charCodeAt(0)===b;let o;m?(a.root="/",o=1):o=0;let d=-1,r=0,s=-1,n=!0,t=f.length-1,c=0;for(;t>=o;--t){const l=f.charCodeAt(t);if(l===b){if(!n){r=t+1;break}continue}s===-1&&(n=!1,s=t+1),l===D?d===-1?d=t:c!==1&&(c=1):d!==-1&&(c=-1)}if(s!==-1){const l=r===0&&m?1:r;d===-1||c===0||c===1&&d===s-1&&d===r+1?a.base=a.name=f.slice(l,s):(a.name=f.slice(l,d),a.base=f.slice(l,s),a.ext=f.slice(d,s))}return r>0?a.dir=f.slice(0,r-1):m&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=u.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=u.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=u.platform==="win32"?e.win32.join:e.posix.join,e.resolve=u.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=u.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=u.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=u.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=u.platform==="win32"?e.win32.extname:e.posix.extname,e.format=u.platform==="win32"?e.win32.format:e.posix.format,e.parse=u.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=u.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=u.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=u.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ke[95],Pe([1,0,9]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var i;(function(P){P.text="text/plain",P.binary="application/octet-stream",P.unknown="application/unknown",P.markdown="text/markdown",P.latex="text/latex",P.uriList="text/uri-list"})(i||(e.Mimes=i={}));const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(P){const S=(0,u.extname)(P),I=y[S.toLowerCase()];return I!==void 0?I:D(P)}e.getMediaOrTextMime=C;function D(P){const S=(0,u.extname)(P);return A[S.toLowerCase()]}e.getMediaMime=D;function b(P){for(const S in A)if(A[S]===P)return S}e.getExtensionForMimeType=b;const T=/^(.+)\/(.+?)(;.+)?$/;function L(P,S){const I=T.exec(P);return I?`${I[1].toLowerCase()}/${I[2].toLowerCase()}${I[3]??""}`:S?void 0:P}e.normalizeMimeType=L}),define(ke[96],Pe([1,0,13]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(i||(e.Source=i={}));var y;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(y||(e.TerminateResponseCode=y={}));function A(D,...b){const T=b.reduce((S,I)=>(S[I]=!0,S),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(S=>!T[S]).forEach(S=>{for(let I=0;I<L.length;I++)if(S.search(L[I])!==-1){delete D[S];break}})}e.sanitizeProcessEnvironment=A;function C(D){!D||(delete D.DEBUG,u.isMacintosh&&delete D.DYLD_LIBRARY_PATH,u.isLinux&&delete D.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var i in u)(typeof exports=="object"?exports:Q)[i]=u[i]}}(typeof self!="undefined"?self:this,function(){return function(Q){var e={};function u(i){if(e[i])return e[i].exports;var y=e[i]={i,l:!1,exports:{}};return Q[i].call(y.exports,y,y.exports,u),y.l=!0,y.exports}return u.m=Q,u.c=e,u.d=function(i,y,A){u.o(i,y)||Object.defineProperty(i,y,{enumerable:!0,get:A})},u.r=function(i){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},u.t=function(i,y){if(1&y&&(i=u(i)),8&y||4&y&&typeof i=="object"&&i&&i.__esModule)return i;var A=Object.create(null);if(u.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:i}),2&y&&typeof i!="string")for(var C in i)u.d(A,C,function(D){return i[D]}.bind(null,C));return A},u.n=function(i){var y=i&&i.__esModule?function(){return i.default}:function(){return i};return u.d(y,"a",y),y},u.o=function(i,y){return Object.prototype.hasOwnProperty.call(i,y)},u.p="",u(u.s=0)}([function(Q,e,u){(function(i){var y;e=Q.exports=K,y=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],b=e.src=[],T=0,L=T++;b[L]="0|[1-9]\\d*";var P=T++;b[P]="[0-9]+";var S=T++;b[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=T++;b[I]="("+b[L]+")\\.("+b[L]+")\\.("+b[L]+")";var E=T++;b[E]="("+b[P]+")\\.("+b[P]+")\\.("+b[P]+")";var v=T++;b[v]="(?:"+b[L]+"|"+b[S]+")";var w=T++;b[w]="(?:"+b[P]+"|"+b[S]+")";var g=T++;b[g]="(?:-("+b[v]+"(?:\\."+b[v]+")*))";var _=T++;b[_]="(?:-?("+b[w]+"(?:\\."+b[w]+")*))";var f=T++;b[f]="[0-9A-Za-z-]+";var a=T++;b[a]="(?:\\+("+b[f]+"(?:\\."+b[f]+")*))";var m=T++,o="v?"+b[I]+b[g]+"?"+b[a]+"?";b[m]="^"+o+"$";var d="[v=\\s]*"+b[E]+b[_]+"?"+b[a]+"?",r=T++;b[r]="^"+d+"$";var s=T++;b[s]="((?:<|>)?=?)";var n=T++;b[n]=b[P]+"|x|X|\\*";var t=T++;b[t]=b[L]+"|x|X|\\*";var c=T++;b[c]="[v=\\s]*("+b[t]+")(?:\\.("+b[t]+")(?:\\.("+b[t]+")(?:"+b[g]+")?"+b[a]+"?)?)?";var l=T++;b[l]="[v=\\s]*("+b[n]+")(?:\\.("+b[n]+")(?:\\.("+b[n]+")(?:"+b[_]+")?"+b[a]+"?)?)?";var h=T++;b[h]="^"+b[s]+"\\s*"+b[c]+"$";var p=T++;b[p]="^"+b[s]+"\\s*"+b[l]+"$";var R=T++;b[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=T++;b[F]="(?:~>?)";var O=T++;b[O]="(\\s*)"+b[F]+"\\s+",D[O]=new RegExp(b[O],"g");var k=T++;b[k]="^"+b[F]+b[c]+"$";var U=T++;b[U]="^"+b[F]+b[l]+"$";var B=T++;b[B]="(?:\\^)";var z=T++;b[z]="(\\s*)"+b[B]+"\\s+",D[z]=new RegExp(b[z],"g");var Y=T++;b[Y]="^"+b[B]+b[c]+"$";var $=T++;b[$]="^"+b[B]+b[l]+"$";var N=T++;b[N]="^"+b[s]+"\\s*("+d+")$|^$";var V=T++;b[V]="^"+b[s]+"\\s*("+o+")$|^$";var H=T++;b[H]="(\\s*)"+b[s]+"\\s*("+d+"|"+b[c]+")",D[H]=new RegExp(b[H],"g");var q=T++;b[q]="^\\s*("+b[c]+")\\s+-\\s+("+b[c]+")\\s*$";var te=T++;b[te]="^\\s*("+b[l]+")\\s+-\\s+("+b[l]+")\\s*$";var fe=T++;b[fe]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)y(ne,b[ne]),D[ne]||(D[ne]=new RegExp(b[ne]));function le(oe,De){if(oe instanceof K)return oe;if(typeof oe!="string"||oe.length>A||!(De?D[r]:D[m]).test(oe))return null;try{return new K(oe,De)}catch{return null}}function K(oe,De){if(oe instanceof K){if(oe.loose===De)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof K))return new K(oe,De);y("SemVer",oe,De),this.loose=De;var ye=oe.trim().match(De?D[r]:D[m]);if(!ye)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var Ve=+ze;if(Ve>=0&&Ve<C)return Ve}return ze}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=le,e.valid=function(oe,De){var ye=le(oe,De);return ye?ye.version:null},e.clean=function(oe,De){var ye=le(oe.trim().replace(/^[=v]+/,""),De);return ye?ye.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(oe){return y("SemVer.compare",this.version,this.loose,oe),oe instanceof K||(oe=new K(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},K.prototype.compareMain=function(oe){return oe instanceof K||(oe=new K(oe,this.loose)),ve(this.major,oe.major)||ve(this.minor,oe.minor)||ve(this.patch,oe.patch)},K.prototype.comparePre=function(oe){if(oe instanceof K||(oe=new K(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var De=0;do{var ye=this.prerelease[De],ze=oe.prerelease[De];if(y("prerelease compare",De,ye,ze),ye===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(ye===void 0)return-1;if(ye!==ze)return ve(ye,ze)}while(++De)},K.prototype.inc=function(oe,De){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,De,ye,ze){typeof ye=="string"&&(ze=ye,ye=void 0);try{return new K(oe,ye).inc(De,ze).version}catch{return null}},e.diff=function(oe,De){if(pe(oe,De))return null;var ye=le(oe),ze=le(De);if(ye.prerelease.length||ze.prerelease.length){for(var Ve in ye)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&ye[Ve]!==ze[Ve])return"pre"+Ve;return"prerelease"}for(var Ve in ye)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&ye[Ve]!==ze[Ve])return Ve},e.compareIdentifiers=ve;var ge=/^[0-9]+$/;function ve(oe,De){var ye=ge.test(oe),ze=ge.test(De);return ye&&ze&&(oe=+oe,De=+De),ye&&!ze?-1:ze&&!ye?1:oe<De?-1:oe>De?1:0}function se(oe,De,ye){return new K(oe,ye).compare(new K(De,ye))}function be(oe,De,ye){return se(oe,De,ye)>0}function Te(oe,De,ye){return se(oe,De,ye)<0}function pe(oe,De,ye){return se(oe,De,ye)===0}function we(oe,De,ye){return se(oe,De,ye)!==0}function Ae(oe,De,ye){return se(oe,De,ye)>=0}function ce(oe,De,ye){return se(oe,De,ye)<=0}function me(oe,De,ye,ze){var Ve;switch(De){case"===":typeof oe=="object"&&(oe=oe.version),typeof ye=="object"&&(ye=ye.version),Ve=oe===ye;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof ye=="object"&&(ye=ye.version),Ve=oe!==ye;break;case"":case"=":case"==":Ve=pe(oe,ye,ze);break;case"!=":Ve=we(oe,ye,ze);break;case">":Ve=be(oe,ye,ze);break;case">=":Ve=Ae(oe,ye,ze);break;case"<":Ve=Te(oe,ye,ze);break;case"<=":Ve=ce(oe,ye,ze);break;default:throw new TypeError("Invalid operator: "+De)}return Ve}function ie(oe,De){if(oe instanceof ie){if(oe.loose===De)return oe;oe=oe.value}if(!(this instanceof ie))return new ie(oe,De);y("comparator",oe,De),this.loose=De,this.parse(oe),this.semver===ee?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(oe,De){return ve(De,oe)},e.major=function(oe,De){return new K(oe,De).major},e.minor=function(oe,De){return new K(oe,De).minor},e.patch=function(oe,De){return new K(oe,De).patch},e.compare=se,e.compareLoose=function(oe,De){return se(oe,De,!0)},e.rcompare=function(oe,De,ye){return se(De,oe,ye)},e.sort=function(oe,De){return oe.sort(function(ye,ze){return e.compare(ye,ze,De)})},e.rsort=function(oe,De){return oe.sort(function(ye,ze){return e.rcompare(ye,ze,De)})},e.gt=be,e.lt=Te,e.eq=pe,e.neq=we,e.gte=Ae,e.lte=ce,e.cmp=me,e.Comparator=ie;var ee={};function M(oe,De){if(oe instanceof M)return oe.loose===De?oe:new M(oe.raw,De);if(oe instanceof ie)return new M(oe.value,De);if(!(this instanceof M))return new M(oe,De);if(this.loose=De,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function x(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function G(oe,De,ye,ze,Ve,Me,Je,J,re,Ce,ae,Ie,Ne){return((De=x(ye)?"":x(ze)?">="+ye+".0.0":x(Ve)?">="+ye+"."+ze+".0":">="+De)+" "+(J=x(re)?"":x(Ce)?"<"+(+re+1)+".0.0":x(ae)?"<"+re+"."+(+Ce+1)+".0":Ie?"<="+re+"."+Ce+"."+ae+"-"+Ie:"<="+J)).trim()}function X(oe,De){for(var ye=0;ye<oe.length;ye++)if(!oe[ye].test(De))return!1;if(De.prerelease.length){for(ye=0;ye<oe.length;ye++)if(y(oe[ye].semver),oe[ye].semver!==ee&&oe[ye].semver.prerelease.length>0){var ze=oe[ye].semver;if(ze.major===De.major&&ze.minor===De.minor&&ze.patch===De.patch)return!0}return!1}return!0}function de(oe,De,ye){try{De=new M(De,ye)}catch{return!1}return De.test(oe)}function Ee(oe,De,ye,ze){var Ve,Me,Je,J,re;switch(oe=new K(oe,ze),De=new M(De,ze),ye){case">":Ve=be,Me=ce,Je=Te,J=">",re=">=";break;case"<":Ve=Te,Me=Ae,Je=be,J="<",re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(de(oe,De,ze))return!1;for(var Ce=0;Ce<De.set.length;++Ce){var ae=De.set[Ce],Ie=null,Ne=null;if(ae.forEach(function($e){$e.semver===ee&&($e=new ie(">=0.0.0")),Ie=Ie||$e,Ne=Ne||$e,Ve($e.semver,Ie.semver,ze)?Ie=$e:Je($e.semver,Ne.semver,ze)&&(Ne=$e)}),Ie.operator===J||Ie.operator===re||(!Ne.operator||Ne.operator===J)&&Me(oe,Ne.semver)||Ne.operator===re&&Je(oe,Ne.semver))return!1}return!0}ie.prototype.parse=function(oe){var De=this.loose?D[N]:D[V],ye=oe.match(De);if(!ye)throw new TypeError("Invalid comparator: "+oe);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new K(ye[2],this.loose):this.semver=ee},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(oe){return y("Comparator.test",oe,this.loose),this.semver===ee||(typeof oe=="string"&&(oe=new K(oe,this.loose)),me(oe,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(oe,De){if(!(oe instanceof ie))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new M(oe.value,De),de(this.value,ye,De);if(oe.operator==="")return ye=new M(this.value,De),de(oe.semver,ye,De);var ze=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),Ve=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),Me=this.semver.version===oe.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),J=me(this.semver,"<",oe.semver,De)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),re=me(this.semver,">",oe.semver,De)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return ze||Ve||Me&&Je||J||re},e.Range=M,M.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},M.prototype.toString=function(){return this.range},M.prototype.parseRange=function(oe){var De=this.loose;oe=oe.trim(),y("range",oe,De);var ye=De?D[te]:D[q];oe=oe.replace(ye,G),y("hyphen replace",oe),oe=oe.replace(D[H],"$1$2$3"),y("comparator trim",oe,D[H]),oe=(oe=(oe=oe.replace(D[O],"$1~")).replace(D[z],"$1^")).split(/\s+/).join(" ");var ze=De?D[N]:D[V],Ve=oe.split(" ").map(function(Me){return function(Je,J){return y("comp",Je),Je=function(re,Ce){return re.trim().split(/\s+/).map(function(ae){return function(Ie,Ne){y("caret",Ie,Ne);var $e=Ne?D[$]:D[Y];return Ie.replace($e,function(Ge,qe,Ze,Xe,st){var et;return y("caret",Ie,Ge,qe,Ze,Xe,st),x(qe)?et="":x(Ze)?et=">="+qe+".0.0 <"+(+qe+1)+".0.0":x(Xe)?et=qe==="0"?">="+qe+"."+Ze+".0 <"+qe+"."+(+Ze+1)+".0":">="+qe+"."+Ze+".0 <"+(+qe+1)+".0.0":st?(y("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),et=qe==="0"?Ze==="0"?">="+qe+"."+Ze+"."+Xe+st+" <"+qe+"."+Ze+"."+(+Xe+1):">="+qe+"."+Ze+"."+Xe+st+" <"+qe+"."+(+Ze+1)+".0":">="+qe+"."+Ze+"."+Xe+st+" <"+(+qe+1)+".0.0"):(y("no pr"),et=qe==="0"?Ze==="0"?">="+qe+"."+Ze+"."+Xe+" <"+qe+"."+Ze+"."+(+Xe+1):">="+qe+"."+Ze+"."+Xe+" <"+qe+"."+(+Ze+1)+".0":">="+qe+"."+Ze+"."+Xe+" <"+(+qe+1)+".0.0"),y("caret return",et),et})}(ae,Ce)}).join(" ")}(Je,J),y("caret",Je),Je=function(re,Ce){return re.trim().split(/\s+/).map(function(ae){return function(Ie,Ne){var $e=Ne?D[U]:D[k];return Ie.replace($e,function(Ge,qe,Ze,Xe,st){var et;return y("tilde",Ie,Ge,qe,Ze,Xe,st),x(qe)?et="":x(Ze)?et=">="+qe+".0.0 <"+(+qe+1)+".0.0":x(Xe)?et=">="+qe+"."+Ze+".0 <"+qe+"."+(+Ze+1)+".0":st?(y("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),et=">="+qe+"."+Ze+"."+Xe+st+" <"+qe+"."+(+Ze+1)+".0"):et=">="+qe+"."+Ze+"."+Xe+" <"+qe+"."+(+Ze+1)+".0",y("tilde return",et),et})}(ae,Ce)}).join(" ")}(Je,J),y("tildes",Je),Je=function(re,Ce){return y("replaceXRanges",re,Ce),re.split(/\s+/).map(function(ae){return function(Ie,Ne){Ie=Ie.trim();var $e=Ne?D[p]:D[h];return Ie.replace($e,function(Ge,qe,Ze,Xe,st,et){y("xRange",Ie,Ge,qe,Ze,Xe,st,et);var rt=x(Ze),ot=rt||x(Xe),Et=ot||x(st);return qe==="="&&Et&&(qe=""),rt?Ge=qe===">"||qe==="<"?"<0.0.0":"*":qe&&Et?(ot&&(Xe=0),Et&&(st=0),qe===">"?(qe=">=",ot?(Ze=+Ze+1,Xe=0,st=0):Et&&(Xe=+Xe+1,st=0)):qe==="<="&&(qe="<",ot?Ze=+Ze+1:Xe=+Xe+1),Ge=qe+Ze+"."+Xe+"."+st):ot?Ge=">="+Ze+".0.0 <"+(+Ze+1)+".0.0":Et&&(Ge=">="+Ze+"."+Xe+".0 <"+Ze+"."+(+Xe+1)+".0"),y("xRange return",Ge),Ge})}(ae,Ce)}).join(" ")}(Je,J),y("xrange",Je),Je=function(re,Ce){return y("replaceStars",re,Ce),re.trim().replace(D[fe],"")}(Je,J),y("stars",Je),Je}(Me,De)}).join(" ").split(/\s+/);return this.loose&&(Ve=Ve.filter(function(Me){return!!Me.match(ze)})),Ve=Ve.map(function(Me){return new ie(Me,De)})},M.prototype.intersects=function(oe,De){if(!(oe instanceof M))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(ze){return oe.set.some(function(Ve){return Ve.every(function(Me){return ze.intersects(Me,De)})})})})},e.toComparators=function(oe,De){return new M(oe,De).set.map(function(ye){return ye.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},M.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new K(oe,this.loose));for(var De=0;De<this.set.length;De++)if(X(this.set[De],oe))return!0;return!1},e.satisfies=de,e.maxSatisfying=function(oe,De,ye){var ze=null,Ve=null;try{var Me=new M(De,ye)}catch{return null}return oe.forEach(function(Je){Me.test(Je)&&(ze&&Ve.compare(Je)!==-1||(Ve=new K(ze=Je,ye)))}),ze},e.minSatisfying=function(oe,De,ye){var ze=null,Ve=null;try{var Me=new M(De,ye)}catch{return null}return oe.forEach(function(Je){Me.test(Je)&&(ze&&Ve.compare(Je)!==1||(Ve=new K(ze=Je,ye)))}),ze},e.validRange=function(oe,De){try{return new M(oe,De).range||"*"}catch{return null}},e.ltr=function(oe,De,ye){return Ee(oe,De,"<",ye)},e.gtr=function(oe,De,ye){return Ee(oe,De,">",ye)},e.outside=Ee,e.prerelease=function(oe,De){var ye=le(oe,De);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(oe,De,ye){return oe=new M(oe,ye),De=new M(De,ye),oe.intersects(De)},e.coerce=function(oe){if(oe instanceof K)return oe;if(typeof oe!="string")return null;var De=oe.match(D[R]);return De==null?null:le((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,u(1))},function(Q,e){var u,i,y=Q.exports={};function A(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function D(w){if(u===setTimeout)return setTimeout(w,0);if((u===A||!u)&&setTimeout)return u=setTimeout,setTimeout(w,0);try{return u(w,0)}catch{try{return u.call(null,w,0)}catch{return u.call(this,w,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:A}catch{u=A}try{i=typeof clearTimeout=="function"?clearTimeout:C}catch{i=C}})();var b,T=[],L=!1,P=-1;function S(){L&&b&&(L=!1,b.length?T=b.concat(T):P=-1,T.length&&I())}function I(){if(!L){var w=D(S);L=!0;for(var g=T.length;g;){for(b=T,T=[];++P<g;)b&&b[P].run();P=-1,g=T.length}b=null,L=!1,function(_){if(i===clearTimeout)return clearTimeout(_);if((i===C||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(_);try{i(_)}catch{try{return i.call(null,_)}catch{return i.call(this,_)}}}(w)}}function E(w,g){this.fun=w,this.array=g}function v(){}y.nextTick=function(w){var g=new Array(arguments.length-1);if(arguments.length>1)for(var _=1;_<arguments.length;_++)g[_-1]=arguments[_];T.push(new E(w,g)),T.length!==1||L||D(I)},E.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=v,y.addListener=v,y.once=v,y.off=v,y.removeListener=v,y.removeAllListeners=v,y.emit=v,y.prependListener=v,y.prependOnceListener=v,y.listeners=function(w){return[]},y.binding=function(w){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(w){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(ke[49],Pe([1,0,13]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=u.globals.performance&&typeof u.globals.performance.now=="function";class y{static create(C=!0){return new y(C)}constructor(C){this._highResolution=i&&C,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?u.globals.performance.now():Date.now()}}e.StopWatch=y}),define(ke[3],Pe([1,0,11,59,6,81,49]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let D=!1,b=!1;var T;(function(t){t.None=()=>y.Disposable.None;function c(le){if(b){const{onListenerDidAdd:K}=le,ge=E.create();let ve=0;le.onListenerDidAdd=()=>{++ve==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ge.print()),K?.()}}}function l(le){return(K,ge=null,ve)=>{let se=!1,be;return be=le(Te=>{if(!se)return be?be.dispose():se=!0,K.call(ge,Te)},null,ve),se&&be.dispose(),be}}t.once=l;function h(le,K,ge){return U((ve,se=null,be)=>le(Te=>ve.call(se,K(Te)),null,be),ge)}t.map=h;function p(le,K,ge){return U((ve,se=null,be)=>le(Te=>{K(Te),ve.call(se,Te)},null,be),ge)}t.forEach=p;function R(le,K,ge){return U((ve,se=null,be)=>le(Te=>K(Te)&&ve.call(se,Te),null,be),ge)}t.filter=R;function F(le){return le}t.signal=F;function O(...le){return(K,ge=null,ve)=>(0,y.combinedDisposable)(...le.map(se=>se(be=>K.call(ge,be),null,ve)))}t.any=O;function k(le,K,ge,ve){let se=ge;return h(le,be=>(se=K(se,be),se),ve)}t.reduce=k;function U(le,K){let ge;const ve={onFirstListenerAdd(){ge=le(se.fire,se)},onLastListenerRemove(){ge.dispose()}};K||c(ve);const se=new w(ve);return K&&K.add(se),se.event}function B(le,K,ge=100,ve=!1,se,be){let Te,pe,we,Ae=0;const ce={leakWarningThreshold:se,onFirstListenerAdd(){Te=le(ie=>{Ae++,pe=K(pe,ie),ve&&!we&&(me.fire(pe),pe=void 0),clearTimeout(we),we=setTimeout(()=>{const ee=pe;pe=void 0,we=void 0,(!ve||Ae>1)&&me.fire(ee),Ae=0},ge)})},onLastListenerRemove(){Te.dispose()}};be||c(ce);const me=new w(ce);return be&&be.add(me),me.event}t.debounce=B;function z(le,K=(ve,se)=>ve===se,ge){let ve=!0,se;return R(le,be=>{const Te=ve||!K(be,se);return ve=!1,se=be,Te},ge)}t.latch=z;function Y(le,K,ge){return[t.filter(le,K,ge),t.filter(le,ve=>!K(ve),ge)]}t.split=Y;function $(le,K=!1,ge=[]){let ve=ge.slice(),se=le(pe=>{ve?ve.push(pe):Te.fire(pe)});const be=()=>{ve&&ve.forEach(pe=>Te.fire(pe)),ve=null},Te=new w({onFirstListenerAdd(){se||(se=le(pe=>Te.fire(pe)))},onFirstListenerDidAdd(){ve&&(K?setTimeout(be):be())},onLastListenerRemove(){se&&se.dispose(),se=null}});return Te.event}t.buffer=$;class N{constructor(K){this.event=K}map(K){return new N(h(this.event,K))}forEach(K){return new N(p(this.event,K))}filter(K){return new N(R(this.event,K))}reduce(K,ge){return new N(k(this.event,K,ge))}latch(){return new N(z(this.event))}debounce(K,ge=100,ve=!1,se){return new N(B(this.event,K,ge,ve,se))}on(K,ge,ve){return this.event(K,ge,ve)}once(K,ge,ve){return l(this.event)(K,ge,ve)}}function V(le){return new N(le)}t.chain=V;function H(le,K,ge=ve=>ve){const ve=(...pe)=>Te.fire(ge(...pe)),se=()=>le.on(K,ve),be=()=>le.removeListener(K,ve),Te=new w({onFirstListenerAdd:se,onLastListenerRemove:be});return Te.event}t.fromNodeEventEmitter=H;function q(le,K,ge=ve=>ve){const ve=(...pe)=>Te.fire(ge(...pe)),se=()=>le.addEventListener(K,ve),be=()=>le.removeEventListener(K,ve),Te=new w({onFirstListenerAdd:se,onLastListenerRemove:be});return Te.event}t.fromDOMEventEmitter=q;function te(le){return new Promise(K=>l(le)(K))}t.toPromise=te;function fe(le,K){return K(void 0),le(ge=>K(ge))}t.runAndSubscribe=fe;function ne(le,K){let ge=null;function ve(be){ge?.dispose(),ge=new y.DisposableStore,K(be,ge)}ve(void 0);const se=le(be=>ve(be));return(0,y.toDisposable)(()=>{se.dispose(),ge?.dispose()})}t.runAndSubscribeWithStore=ne})(T||(e.Event=T={}));class L{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${L._idPool++}`}start(c){this._stopWatch=new C.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}L._idPool=0;let P=-1;function S(t){const c=P;return P=t,{dispose(){P=c}}}e.setGlobalLeakWarningThreshold=S;class I{constructor(c,l=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,l){let h=P;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||l<h)return;this._stacks||(this._stacks=new Map);const p=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,p+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let R,F=0;for(const[O,k]of this._stacks)(!R||F<k)&&(R=O,F=k);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${F}):`),console.warn(R)}return()=>{const R=this._stacks.get(c.value)||0;this._stacks.set(c.value,R-1)}}}class E{static create(){return new E(new Error().stack??"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(c,l,h){this.callback=c,this.callbackThis=l,this.stack=h,this.subscription=new y.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class w{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=P>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new L(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(D){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const l of c)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,l,h)=>{this._listeners||(this._listeners=new A.LinkedList);const p=this._listeners.isEmpty();p&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let R,F;this._leakageMon&&this._listeners.size>=30&&(F=E.create(),R=this._leakageMon.check(F,this._listeners.size+1)),D&&(F=F??E.create());const O=new v(c,l,F),k=this._listeners.push(O);p&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,l);const U=O.subscription.set(()=>{R&&R(),this._disposed||(k(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof y.DisposableStore?h.add(U):Array.isArray(h)&&h.push(U),U}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _);for(let l of this._listeners)this._deliveryQueue.push(this,l,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class g{constructor(){this._queue=new A.LinkedList}get size(){return this._queue.size}push(c,l,h){this._queue.push(new f(c,l,h))}clear(c){const l=new A.LinkedList;for(const h of this._queue)h.emitter!==c&&l.push(h);this._queue=l}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(l){(0,u.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=g;class _ extends g{clear(c){this._queue.clear()}}class f{constructor(c,l,h){this.emitter=c,this.listener=l,this.event=h}}class a extends w{async fireAsync(c,l,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const p of this._listeners)this._asyncDeliveryQueue.push([p,c]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[p,R]=this._asyncDeliveryQueue.shift(),F=[],O={...R,token:l,waitUntil:k=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");h&&(k=h(k,p.callback)),F.push(k)}};try{p.invoke(O)}catch(k){(0,u.onUnexpectedError)(k);continue}Object.freeze(F),await Promise.allSettled(F).then(k=>{for(const U of k)U.status==="rejected"&&(0,u.onUnexpectedError)(U.reason)})}}}}e.AsyncEmitter=a;class m extends w{constructor(c){super(c);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=m;class o extends m{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=o;class d extends w{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const l={event:c,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const h=()=>{this.hasListeners&&this.unhook(l);const p=this.events.indexOf(l);this.events.splice(p,1)};return(0,y.toDisposable)((0,i.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(l=>this.emitter.fire(l))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class s{constructor(){this.buffers=[]}wrapEvent(c){return(l,h,p)=>c(R=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>l.call(h,R)):l.call(h,R)},void 0,p)}bufferEvents(c){const l=[];this.buffers.push(l);const h=c();return this.buffers.pop(),l.forEach(p=>p()),h}}e.EventBufferer=s;class n{constructor(){this.listening=!1,this.inputEvent=T.None,this.inputEventListener=y.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=n}),define(ke[21],Pe([1,0,3]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(D,b){const T=setTimeout(D.bind(b),0);return{dispose(){clearTimeout(T)}}});var y;(function(D){function b(T){return T===D.None||T===D.Cancelled||T instanceof A?!0:!T||typeof T!="object"?!1:typeof T.isCancellationRequested=="boolean"&&typeof T.onCancellationRequested=="function"}D.isCancellationToken=b,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(y||(e.CancellationToken=y={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new u.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=y.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=C}),define(ke[145],Pe([1,0,21]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new u.CancellationTokenSource,b=this.task(D.token);return this.result={promise:b,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=i;class y{constructor(D){this.fn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const b=JSON.stringify(D);return this.lastArgKey!==b&&(this.lastArgKey=b,this.lastCache=this.fn(D)),this.lastCache}}e.LRUCachedFunction=y;class A{get cachedValues(){return this._map}constructor(D){this.fn=D,this._map=new Map}get(D){if(this._map.has(D))return this._map.get(D);const b=this.fn(D);return this._map.set(D,b),b}}e.CachedFunction=A}),define(ke[97],Pe([1,0,11,6]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(a){const m=a;return m?typeof m.read=="function":!1}e.isReadable=y;function A(a){const m=a;return m?[m.on,m.pause,m.resume,m.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=A;function C(a){const m=a;return m?A(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=C;function D(a,m){return new b(a,m)}e.newWriteableStream=D;class b{constructor(m,o){this.reducer=m,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(o=>o(m))}emitError(m){this.listeners.error.length===0?(0,u.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(o=>o(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,o){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(m,o){if(this.state.destroyed)return;let d;switch(m){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const r=d.indexOf(o);r>=0&&d.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function T(a,m){const o=[];let d;for(;(d=a.read())!==null;)o.push(d);return m(o)}e.consumeReadable=T;function L(a,m,o){const d=[];let r;for(;(r=a.read())!==null&&d.length<o;)d.push(r);return r===null&&d.length>0?m(d):{read:()=>{if(d.length>0)return d.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return a.read()}}}e.peekReadable=L;function P(a,m){return new Promise((o,d)=>{const r=[];S(a,{onData:s=>{m&&r.push(s)},onError:s=>{m?d(s):o(void 0)},onEnd:()=>{o(m?m(r):void 0)}})})}e.consumeStream=P;function S(a,m){let o=!1;return a.on("error",d=>{o||m.onError(d)}),a.on("end",()=>{o||m.onEnd()}),a.on("data",d=>{o||m.onData(d)}),(0,i.toDisposable)(()=>o=!0)}e.listenStream=S;function I(a,m){return new Promise((o,d)=>{const r=new i.DisposableStore,s=[],n=l=>{if(s.push(l),s.length>m)return r.dispose(),a.pause(),o({stream:a,buffer:s,ended:!1})},t=l=>d(l),c=()=>o({stream:a,buffer:s,ended:!0});r.add((0,i.toDisposable)(()=>a.removeListener("error",t))),a.on("error",t),r.add((0,i.toDisposable)(()=>a.removeListener("end",c))),a.on("end",c),r.add((0,i.toDisposable)(()=>a.removeListener("data",n))),a.on("data",n)})}e.peekStream=I;function E(a,m){const o=D(m);return o.end(a),o}e.toStream=E;function v(){const a=D(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=v;function w(a){let m=!1;return{read:()=>m?null:(m=!0,a)}}e.toReadable=w;function g(a,m,o){const d=D(o);return S(a,{onData:r=>d.write(m.data(r)),onError:r=>d.error(m.error?m.error(r):r),onEnd:()=>d.end()}),d}e.transform=g;function _(a,m,o){let d=!1;return{read:()=>{const r=m.read();return d?r:(d=!0,r!==null?o([a,r]):a)}}}e.prefixedReadable=_;function f(a,m,o){let d=!1;const r=D(o);return S(m,{onData:s=>d?r.write(s):(d=!0,r.write(o([a,s]))),onError:s=>r.error(s),onEnd:()=>{d||(d=!0,r.write(a)),r.end()}}),r}e.prefixedStream=f}),define(ke[23],Pe([1,0,97]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let y,A;class C{static alloc(l){return i?new C(Buffer.allocUnsafe(l)):new C(new Uint8Array(l))}static wrap(l){return i&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new C(l)}static fromString(l,h){return!(h?.dontUseNodeBuffer||!1)&&i?new C(Buffer.from(l)):(y||(y=new TextEncoder),new C(y.encode(l)))}static fromByteArray(l){const h=C.alloc(l.length);for(let p=0,R=l.length;p<R;p++)h.buffer[p]=l[p];return h}static concat(l,h){if(typeof h=="undefined"){h=0;for(let F=0,O=l.length;F<O;F++)h+=l[F].byteLength}const p=C.alloc(h);let R=0;for(let F=0,O=l.length;F<O;F++){const k=l[F];p.set(k,R),R+=k.byteLength}return p}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=C.alloc(this.byteLength);return l.set(this),l}toString(){return i?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(l,h){return new C(this.buffer.subarray(l,h))}set(l,h){if(l instanceof C)this.buffer.set(l.buffer,h);else if(l instanceof Uint8Array)this.buffer.set(l,h);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),h);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return T(this.buffer,l)}writeUInt32BE(l,h){L(this.buffer,l,h)}readUInt32LE(l){return P(this.buffer,l)}writeUInt32LE(l,h){S(this.buffer,l,h)}readUInt8(l){return I(this.buffer,l)}writeUInt8(l,h){E(this.buffer,l,h)}}e.VSBuffer=C;function D(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0}e.readUInt16LE=D;function b(c,l,h){c[h+0]=l&255,l=l>>>8,c[h+1]=l&255}e.writeUInt16LE=b;function T(c,l){return c[l]*2**24+c[l+1]*2**16+c[l+2]*2**8+c[l+3]}e.readUInt32BE=T;function L(c,l,h){c[h+3]=l,l=l>>>8,c[h+2]=l,l=l>>>8,c[h+1]=l,l=l>>>8,c[h]=l}e.writeUInt32BE=L;function P(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0|c[l+2]<<16>>>0|c[l+3]<<24>>>0}e.readUInt32LE=P;function S(c,l,h){c[h+0]=l&255,l=l>>>8,c[h+1]=l&255,l=l>>>8,c[h+2]=l&255,l=l>>>8,c[h+3]=l&255}e.writeUInt32LE=S;function I(c,l){return c[l]}e.readUInt8=I;function E(c,l,h){c[h]=l}e.writeUInt8=E;function v(c){return u.consumeReadable(c,l=>C.concat(l))}e.readableToBuffer=v;function w(c){return u.toReadable(c)}e.bufferToReadable=w;function g(c){return u.consumeStream(c,l=>C.concat(l))}e.streamToBuffer=g;async function _(c){return c.ended?C.concat(c.buffer):C.concat([...c.buffer,await g(c.stream)])}e.bufferedStreamToBuffer=_;function f(c){return u.toStream(c,l=>C.concat(l))}e.bufferToStream=f;function a(c){return u.transform(c,{data:l=>typeof l=="string"?C.fromString(l):C.wrap(l)},l=>C.concat(l))}e.streamToBufferReadableStream=a;function m(c){return u.newWriteableStream(l=>C.concat(l),c)}e.newWriteableBufferStream=m;function o(c,l){return u.prefixedReadable(c,l,h=>C.concat(h))}e.prefixedBufferReadable=o;function d(c,l){return u.prefixedStream(c,l,h=>C.concat(h))}e.prefixedBufferStream=d;function r(c){let l=0,h=0,p=0;const R=new Uint8Array(Math.floor(c.length/4*3)),F=k=>{switch(h){case 3:R[p++]=l|k,h=0;break;case 2:R[p++]=l|k>>>2,l=k<<6,h=3;break;case 1:R[p++]=l|k>>>4,l=k<<4,h=2;break;default:l=k<<2,h=1}};for(let k=0;k<c.length;k++){const U=c.charCodeAt(k);if(U>=65&&U<=90)F(U-65);else if(U>=97&&U<=122)F(U-97+26);else if(U>=48&&U<=57)F(U-48+52);else if(U===43||U===45)F(62);else if(U===47||U===95)F(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${c[k]}`)}}const O=p;for(;h>0;)F(0);return C.wrap(R).slice(0,O)}e.decodeBase64=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:c},l=!0,h=!1){const p=h?n:s;let R="";const F=c.byteLength%3;let O=0;for(;O<c.byteLength-F;O+=3){const k=c[O+0],U=c[O+1],B=c[O+2];R+=p[k>>>2],R+=p[(k<<4|U>>>4)&63],R+=p[(U<<2|B>>>6)&63],R+=p[B&63]}if(F===1){const k=c[O+0];R+=p[k>>>2],R+=p[k<<4&63],l&&(R+="==")}else if(F===2){const k=c[O+0],U=c[O+1];R+=p[k>>>2],R+=p[(k<<4|U>>>4)&63],R+=p[U<<2&63],l&&(R+="=")}return R}e.encodeBase64=t}),define(ke[8],Pe([1,0,145,80]),function(Q,e,u,i){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(ae){return!ae||typeof ae!="string"?!0:ae.trim().length===0}e.isFalsyOrWhitespace=A;const C=/{(\d+)}/g;function D(ae,...Ie){return Ie.length===0?ae:ae.replace(C,function(Ne,$e){const Ge=parseInt($e,10);return isNaN(Ge)||Ge<0||Ge>=Ie.length?Ne:Ie[Ge]})}e.format=D;const b=/{([^}]+)}/g;function T(ae,Ie){return ae.replace(b,(Ne,$e)=>Ie[$e]??Ne)}e.format2=T;function L(ae){return ae.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=L;function P(ae){return ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function S(ae,Ie){let Ne=0;const $e=Ie.charCodeAt(0);for(let Ge=ae.length-1;Ge>=0;Ge--)ae.charCodeAt(Ge)===$e&&Ne++;return Ne}e.count=S;function I(ae,Ie,Ne="\u2026"){return ae.length<=Ie?ae:`${ae.substr(0,Ie)}${Ne}`}e.truncate=I;function E(ae,Ie=" "){const Ne=v(ae,Ie);return w(Ne,Ie)}e.trim=E;function v(ae,Ie){if(!ae||!Ie)return ae;const Ne=Ie.length;if(Ne===0||ae.length===0)return ae;let $e=0;for(;ae.indexOf(Ie,$e)===$e;)$e=$e+Ne;return ae.substring($e)}e.ltrim=v;function w(ae,Ie){if(!ae||!Ie)return ae;const Ne=Ie.length,$e=ae.length;if(Ne===0||$e===0)return ae;let Ge=$e,qe=-1;for(;qe=ae.lastIndexOf(Ie,Ge-1),!(qe===-1||qe+Ne!==Ge);){if(qe===0)return"";Ge=qe}return ae.substring(0,Ge)}e.rtrim=w;function g(ae){return ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function _(ae){return ae.replace(/\*/g,"")}e.stripWildcards=_;function f(ae,Ie,Ne={}){if(!ae)throw new Error("Cannot create regex from empty string");Ie||(ae=P(ae)),Ne.wholeWord&&(/\B/.test(ae.charAt(0))||(ae="\\b"+ae),/\B/.test(ae.charAt(ae.length-1))||(ae=ae+"\\b"));let $e="";return Ne.global&&($e+="g"),Ne.matchCase||($e+="i"),Ne.multiline&&($e+="m"),Ne.unicode&&($e+="u"),new RegExp(ae,$e)}e.createRegExp=f;function a(ae){return ae.source==="^"||ae.source==="^$"||ae.source==="$"||ae.source==="^\\s*$"?!1:!!(ae.exec("")&&ae.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function m(ae){return!!ae.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function o(ae){return(ae.global?"g":"")+(ae.ignoreCase?"i":"")+(ae.multiline?"m":"")+(ae.unicode?"u":"")}e.regExpFlags=o;function d(ae){return ae.split(/\r\n|\r|\n/)}e.splitLines=d;function r(ae){for(let Ie=0,Ne=ae.length;Ie<Ne;Ie++){const $e=ae.charCodeAt(Ie);if($e!==32&&$e!==9)return Ie}return-1}e.firstNonWhitespaceIndex=r;function s(ae,Ie=0,Ne=ae.length){for(let $e=Ie;$e<Ne;$e++){const Ge=ae.charCodeAt($e);if(Ge!==32&&Ge!==9)return ae.substring(Ie,$e)}return ae.substring(Ie,Ne)}e.getLeadingWhitespace=s;function n(ae,Ie=ae.length-1){for(let Ne=Ie;Ne>=0;Ne--){const $e=ae.charCodeAt(Ne);if($e!==32&&$e!==9)return Ne}return-1}e.lastNonWhitespaceIndex=n;function t(ae,Ie,Ne){let $e=[],Ge=0;for(const qe of ae.matchAll(Ie)){if($e.push(ae.slice(Ge,qe.index)),qe.index===void 0)throw new Error("match.index should be defined");Ge=qe.index+qe[0].length,$e.push(Ne(qe[0],...qe.slice(1),qe.index,ae,qe.groups))}return $e.push(ae.slice(Ge)),Promise.all($e).then(qe=>qe.join(""))}e.replaceAsync=t;function c(ae,Ie){return ae<Ie?-1:ae>Ie?1:0}e.compare=c;function l(ae,Ie,Ne=0,$e=ae.length,Ge=0,qe=Ie.length){for(;Ne<$e&&Ge<qe;Ne++,Ge++){let st=ae.charCodeAt(Ne),et=Ie.charCodeAt(Ge);if(st<et)return-1;if(st>et)return 1}const Ze=$e-Ne,Xe=qe-Ge;return Ze<Xe?-1:Ze>Xe?1:0}e.compareSubstring=l;function h(ae,Ie){return p(ae,Ie,0,ae.length,0,Ie.length)}e.compareIgnoreCase=h;function p(ae,Ie,Ne=0,$e=ae.length,Ge=0,qe=Ie.length){for(;Ne<$e&&Ge<qe;Ne++,Ge++){let st=ae.charCodeAt(Ne),et=Ie.charCodeAt(Ge);if(st===et)continue;if(st>=128||et>=128)return l(ae.toLowerCase(),Ie.toLowerCase(),Ne,$e,Ge,qe);R(st)&&(st-=32),R(et)&&(et-=32);const rt=st-et;if(rt!==0)return rt}const Ze=$e-Ne,Xe=qe-Ge;return Ze<Xe?-1:Ze>Xe?1:0}e.compareSubstringIgnoreCase=p;function R(ae){return ae>=97&&ae<=122}e.isLowerAsciiLetter=R;function F(ae){return ae>=65&&ae<=90}e.isUpperAsciiLetter=F;function O(ae,Ie){return ae.length===Ie.length&&p(ae,Ie)===0}e.equalsIgnoreCase=O;function k(ae,Ie){const Ne=Ie.length;return Ie.length>ae.length?!1:p(ae,Ie,0,Ne)===0}e.startsWithIgnoreCase=k;function U(ae,Ie){let Ne,$e=Math.min(ae.length,Ie.length);for(Ne=0;Ne<$e;Ne++)if(ae.charCodeAt(Ne)!==Ie.charCodeAt(Ne))return Ne;return $e}e.commonPrefixLength=U;function B(ae,Ie){let Ne,$e=Math.min(ae.length,Ie.length);const Ge=ae.length-1,qe=Ie.length-1;for(Ne=0;Ne<$e;Ne++)if(ae.charCodeAt(Ge-Ne)!==Ie.charCodeAt(qe-Ne))return Ne;return $e}e.commonSuffixLength=B;function z(ae){return 55296<=ae&&ae<=56319}e.isHighSurrogate=z;function Y(ae){return 56320<=ae&&ae<=57343}e.isLowSurrogate=Y;function $(ae,Ie){return(ae-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=$;function N(ae,Ie,Ne){const $e=ae.charCodeAt(Ne);if(z($e)&&Ne+1<Ie){const Ge=ae.charCodeAt(Ne+1);if(Y(Ge))return $($e,Ge)}return $e}e.getNextCodePoint=N;function V(ae,Ie){const Ne=ae.charCodeAt(Ie-1);if(Y(Ne)&&Ie>1){const $e=ae.charCodeAt(Ie-2);if(z($e))return $($e,Ne)}return Ne}class H{get offset(){return this._offset}constructor(Ie,Ne=0){this._str=Ie,this._len=Ie.length,this._offset=Ne}setOffset(Ie){this._offset=Ie}prevCodePoint(){const Ie=V(this._str,this._offset);return this._offset-=Ie>=65536?2:1,Ie}nextCodePoint(){const Ie=N(this._str,this._len,this._offset);return this._offset+=Ie>=65536?2:1,Ie}eol(){return this._offset>=this._len}}e.CodePointIterator=H;class q{get offset(){return this._iterator.offset}constructor(Ie,Ne=0){this._iterator=new H(Ie,Ne)}nextGraphemeLength(){const Ie=ye.getInstance(),Ne=this._iterator,$e=Ne.offset;let Ge=Ie.getGraphemeBreakType(Ne.nextCodePoint());for(;!Ne.eol();){const qe=Ne.offset,Ze=Ie.getGraphemeBreakType(Ne.nextCodePoint());if(oe(Ge,Ze)){Ne.setOffset(qe);break}Ge=Ze}return Ne.offset-$e}prevGraphemeLength(){const Ie=ye.getInstance(),Ne=this._iterator,$e=Ne.offset;let Ge=Ie.getGraphemeBreakType(Ne.prevCodePoint());for(;Ne.offset>0;){const qe=Ne.offset,Ze=Ie.getGraphemeBreakType(Ne.prevCodePoint());if(oe(Ze,Ge)){Ne.setOffset(qe);break}Ge=Ze}return $e-Ne.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function te(ae,Ie){return new q(ae,Ie).nextGraphemeLength()}e.nextCharLength=te;function fe(ae,Ie){return new q(ae,Ie).prevGraphemeLength()}e.prevCharLength=fe;function ne(ae,Ie){Ie>0&&Y(ae.charCodeAt(Ie))&&Ie--;const Ne=Ie+te(ae,Ie);return[Ne-fe(ae,Ne),Ne]}e.getCharContainingOffset=ne;const le=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(ae){return le.test(ae)}e.containsRTL=K;const ge=/^[\t\n\r\x20-\x7E]*$/;function ve(ae){return ge.test(ae)}e.isBasicASCII=ve,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(ae){return e.UNUSUAL_LINE_TERMINATORS.test(ae)}e.containsUnusualLineTerminators=se;function be(ae){return ae>=11904&&ae<=55215||ae>=63744&&ae<=64255||ae>=65281&&ae<=65374}e.isFullWidthCharacter=be;function Te(ae){return ae>=127462&&ae<=127487||ae===8986||ae===8987||ae===9200||ae===9203||ae>=9728&&ae<=10175||ae===11088||ae===11093||ae>=127744&&ae<=128591||ae>=128640&&ae<=128764||ae>=128992&&ae<=129008||ae>=129280&&ae<=129535||ae>=129648&&ae<=129782}e.isEmojiImprecise=Te;function pe(ae,Ie){if(ae.length<Ie)return ae;const Ne=/\b/g;let $e=0;for(;Ne.test(ae)&&!(ae.length-Ne.lastIndex<Ie);)$e=Ne.lastIndex,Ne.lastIndex+=1;return ae.substring($e).replace(/^\s/,"")}e.lcut=pe;const we=/\x1B\x5B[12]?K/g,Ae=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function me(ae){return ae&&(ae=ae.replace(we,""),ae=ae.replace(Ae,""),ae=ae.replace(ce,"")),ae}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ie(ae){return!!(ae&&ae.length>0&&ae.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ie;function ee(ae){return ie(ae)?ae.substr(1):ae}e.stripUTF8BOM=ee;function M(ae,Ie){if(!ae||!Ie||ae.length<Ie.length)return!1;const Ne=Ie.length,$e=ae.toLowerCase();let Ge=0,qe=-1;for(;Ge<Ne;){const Ze=$e.indexOf(Ie[Ge],qe+1);if(Ze<0)return!1;qe=Ze,Ge++}return!0}e.fuzzyContains=M;function x(ae,Ie=!1){return ae?(Ie&&(ae=ae.replace(/\\./g,"")),ae.toLowerCase()!==ae):!1}e.containsUppercaseCharacter=x;function G(ae){return ae.charAt(0).toUpperCase()+ae.slice(1)}e.uppercaseFirstLetter=G;function X(ae,Ie=1){if(Ie===0)return"";let Ne=-1;do Ne=ae.indexOf(`
`,Ne+1),Ie--;while(Ie>0&&Ne>=0);return Ne===-1?ae:(ae[Ne-1]==="\r"&&Ne--,ae.substr(0,Ne))}e.getNLines=X;function de(ae){const Ie=90-65+1;return ae=ae%(2*Ie),ae<Ie?String.fromCharCode(97+ae):String.fromCharCode(65+ae-Ie)}e.singleLetterHash=de;function Ee(ae){return ye.getInstance().getGraphemeBreakType(ae)}e.getGraphemeBreakType=Ee;function oe(ae,Ie){return ae===0?Ie!==5&&Ie!==7:ae===2&&Ie===3?!1:ae===4||ae===2||ae===3||Ie===4||Ie===2||Ie===3?!0:!(ae===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ae===11||ae===9)&&(Ie===9||Ie===10)||(ae===12||ae===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ae===1||ae===13&&Ie===14||ae===6&&Ie===6)}var De;(function(ae){ae[ae.Other=0]="Other",ae[ae.Prepend=1]="Prepend",ae[ae.CR=2]="CR",ae[ae.LF=3]="LF",ae[ae.Control=4]="Control",ae[ae.Extend=5]="Extend",ae[ae.Regional_Indicator=6]="Regional_Indicator",ae[ae.SpacingMark=7]="SpacingMark",ae[ae.L=8]="L",ae[ae.V=9]="V",ae[ae.T=10]="T",ae[ae.LV=11]="LV",ae[ae.LVT=12]="LVT",ae[ae.ZWJ=13]="ZWJ",ae[ae.Extended_Pictographic=14]="Extended_Pictographic"})(De||(e.GraphemeBreakType=De={}));class ye{static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}constructor(){this._data=ze()}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ne=this._data,$e=Ne.length/3;let Ge=1;for(;Ge<=$e;)if(Ie<Ne[3*Ge])Ge=2*Ge;else if(Ie>Ne[3*Ge+1])Ge=2*Ge+1;else return Ne[3*Ge+2];return 0}}ye._INSTANCE=null;function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(ae,Ie){if(ae===0)return 0;const Ne=Me(ae,Ie);if(Ne!==void 0)return Ne;const $e=new H(Ie,ae);return $e.prevCodePoint(),$e.offset}e.getLeftDeleteOffset=Ve;function Me(ae,Ie){const Ne=new H(Ie,ae);let $e=Ne.prevCodePoint();for(;Je($e)||$e===65039||$e===8419;){if(Ne.offset===0)return;$e=Ne.prevCodePoint()}if(!Te($e))return;let Ge=Ne.offset;return Ge>0&&Ne.prevCodePoint()===8205&&(Ge=Ne.offset),Ge}function Je(ae){return 127995<=ae&&ae<=127999}var J;(function(ae){ae[ae.zwj=8205]="zwj",ae[ae.emojiVariantSelector=65039]="emojiVariantSelector",ae[ae.enclosingKeyCap=8419]="enclosingKeyCap"})(J||(J={})),e.noBreakWhitespace="\xA0";class re{static getInstance(Ie){return y.cache.get(Array.from(Ie))}static getLocales(){return y._locales.getValue()}constructor(Ie){this.confusableDictionary=Ie}isAmbiguous(Ie){return this.confusableDictionary.has(Ie)}getPrimaryConfusable(Ie){return this.confusableDictionary.get(Ie)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=re,y=re,re.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),re.cache=new u.LRUCachedFunction(ae=>{function Ie(et){const rt=new Map;for(let ot=0;ot<et.length;ot+=2)rt.set(et[ot],et[ot+1]);return rt}function Ne(et,rt){const ot=new Map(et);for(const[Et,At]of rt)ot.set(Et,At);return ot}function $e(et,rt){if(!et)return rt;const ot=new Map;for(const[Et,At]of et)rt.has(Et)&&ot.set(Et,At);return ot}const Ge=y.ambiguousCharacterData.getValue();let qe=ae.filter(et=>!et.startsWith("_")&&et in Ge);qe.length===0&&(qe=["_default"]);let Ze;for(const et of qe){const rt=Ie(Ge[et]);Ze=$e(Ze,rt)}const Xe=Ie(Ge._common),st=Ne(Xe,Ze);return new y(st)}),re._locales=new i.Lazy(()=>Object.keys(y.ambiguousCharacterData.getValue()).filter(ae=>!ae.startsWith("_")));class Ce{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ce.getRawData())),this._data}static isInvisibleCharacter(Ie){return Ce.getData().has(Ie)}static get codePoints(){return Ce.getData()}}e.InvisibleCharacters=Ce,Ce._data=void 0}),define(ke[61],Pe([1,0,8]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(g){return y(g,0)}e.hash=i;function y(g,_){switch(typeof g){case"object":return g===null?A(349,_):Array.isArray(g)?b(g,_):T(g,_);case"string":return D(g,_);case"boolean":return C(g,_);case"number":return A(g,_);case"undefined":return A(937,_);default:return A(617,_)}}e.doHash=y;function A(g,_){return(_<<5)-_+g|0}e.numberHash=A;function C(g,_){return A(g?433:863,_)}function D(g,_){_=A(149417,_);for(let f=0,a=g.length;f<a;f++)_=A(g.charCodeAt(f),_);return _}e.stringHash=D;function b(g,_){return _=A(104579,_),g.reduce((f,a)=>y(a,f),_)}function T(g,_){return _=A(181387,_),Object.keys(g).sort().reduce((f,a)=>(f=D(a,f),y(g[a],f)),_)}class L{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=y(_,this._value),this._value}}e.Hasher=L;var P;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function S(g,_,f=32){const a=f-_,m=~((1<<a)-1);return(g<<_|(m&g)>>>a)>>>0}function I(g,_=0,f=g.byteLength,a=0){for(let m=0;m<f;m++)g[_+m]=a}function E(g,_,f="0"){for(;g.length<_;)g=f+g;return g}function v(g,_=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(f=>f.toString(16).padStart(2,"0")).join(""):E((g>>>0).toString(16),_/4)}e.toHexString=v;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const f=_.length;if(f===0)return;const a=this._buff;let m=this._buffLen,o=this._leftoverHighSurrogate,d,r;for(o!==0?(d=o,r=-1,o=0):(d=_.charCodeAt(0),r=0);;){let s=d;if(u.isHighSurrogate(d))if(r+1<f){const n=_.charCodeAt(r+1);u.isLowSurrogate(n)?(r++,s=u.computeCodePoint(d,n)):s=65533}else{o=d;break}else u.isLowSurrogate(d)&&(s=65533);if(m=this._push(a,m,s),r++,r<f)d=_.charCodeAt(r);else break}this._buffLen=m,this._leftoverHighSurrogate=o}_push(_,f,a){return a<128?_[f++]=a:a<2048?(_[f++]=192|(a&1984)>>>6,_[f++]=128|(a&63)>>>0):a<65536?(_[f++]=224|(a&61440)>>>12,_[f++]=128|(a&4032)>>>6,_[f++]=128|(a&63)>>>0):(_[f++]=240|(a&1835008)>>>18,_[f++]=128|(a&258048)>>>12,_[f++]=128|(a&4032)>>>6,_[f++]=128|(a&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,I(this._buff,this._buffLen),this._buffLen>56&&(this._step(),I(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=w._bigBlock32,f=this._buffDV;for(let c=0;c<64;c+=4)_.setUint32(c,f.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)_.setUint32(c,S(_.getUint32(c-12,!1)^_.getUint32(c-32,!1)^_.getUint32(c-56,!1)^_.getUint32(c-64,!1),1),!1);let a=this._h0,m=this._h1,o=this._h2,d=this._h3,r=this._h4,s,n,t;for(let c=0;c<80;c++)c<20?(s=m&o|~m&d,n=1518500249):c<40?(s=m^o^d,n=1859775393):c<60?(s=m&o|m&d|o&d,n=2400959708):(s=m^o^d,n=3395469782),t=S(a,5)+s+r+n+_.getUint32(c*4,!1)&4294967295,r=d,d=o,o=S(m,30),m=a,a=t;this._h0=this._h0+a&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+d&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))});var Ue=this&&this.__classPrivateFieldGet||function(Q,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Q):i?i.value:e.get(Q)},tt=this&&this.__classPrivateFieldSet||function(Q,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u};define(ke[25],Pe([1,0,16,8]),function(Q,e,u,i){"use strict";var y,A,C,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(n,t,c){let l=n.get(t);return l===void 0&&(l=c,n.set(t,l)),l}e.getOrSet=b;function T(n){const t=[];return n.forEach((c,l)=>{t.push(`${l} => ${c}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=T;function L(n){const t=[];return n.forEach(c=>{t.push(c)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=L;class P{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const c=t.charCodeAt(0),l=this._value.charCodeAt(this._pos);return c-l}value(){return this._value[this._pos]}}e.StringIterator=P;class S{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class I{constructor(t=!0,c=!0){this._splitOnBackslash=t,this._caseSensitive=c}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let c=t.length-1;c>=0;c--,this._valueLen--){const l=this._value.charCodeAt(c);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var E;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(E||(E={}));class v{constructor(t,c){this._ignorePathCasing=t,this._ignoreQueryAndFragment=c,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(t)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=v;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(g||(g={}));class _{static forUris(t=()=>!1,c=()=>!1){return new _(new v(t,c))}static forPaths(t=!1){return new _(new I(void 0,!t))}static forStrings(){return new _(new P)}static forConfigKeys(){return new _(new S)}constructor(t){this._iter=t}clear(){this._root=void 0}fill(t,c){if(c){const l=c.slice(0);(0,u.shuffle)(l);for(let h of l)this.set(h,t)}else{const l=t.slice(0);(0,u.shuffle)(l);for(let h of l)this.set(h[0],h[1])}}set(t,c){const l=this._iter.reset(t);let h;this._root||(this._root=new w,this._root.segment=l.value());const p=[];for(h=this._root;;){const F=l.cmp(h.segment);if(F>0)h.left||(h.left=new w,h.left.segment=l.value()),p.push([-1,h]),h=h.left;else if(F<0)h.right||(h.right=new w,h.right.segment=l.value()),p.push([1,h]),h=h.right;else if(l.hasNext())l.next(),h.mid||(h.mid=new w,h.mid.segment=l.value()),p.push([0,h]),h=h.mid;else break}const R=h.value;h.value=c,h.key=t;for(let F=p.length-1;F>=0;F--){const O=p[F][1];O.updateHeight();const k=O.balanceFactor();if(k<-1||k>1){const U=p[F][0],B=p[F+1][0];if(U===1&&B===1)p[F][1]=O.rotateLeft();else if(U===-1&&B===-1)p[F][1]=O.rotateRight();else if(U===1&&B===-1)O.right=p[F+1][1]=p[F+1][1].rotateRight(),p[F][1]=O.rotateLeft();else if(U===-1&&B===1)O.left=p[F+1][1]=p[F+1][1].rotateLeft(),p[F][1]=O.rotateRight();else throw new Error;if(F>0)switch(p[F-1][0]){case-1:p[F-1][1].left=p[F][1];break;case 1:p[F-1][1].right=p[F][1];break;case 0:p[F-1][1].mid=p[F][1];break}else this._root=p[0][1]}}return R}get(t){return this._getNode(t)?.value}_getNode(t){const c=this._iter.reset(t);let l=this._root;for(;l;){const h=c.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(c.hasNext())c.next(),l=l.mid;else break}return l}has(t){const c=this._getNode(t);return!(c?.value===void 0&&c?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,c){const l=this._iter.reset(t),h=[];let p=this._root;for(;p;){const R=l.cmp(p.segment);if(R>0)h.push([-1,p]),p=p.left;else if(R<0)h.push([1,p]),p=p.right;else if(l.hasNext())l.next(),h.push([0,p]),p=p.mid;else break}if(!!p){if(c?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const R=this._min(p.right),{key:F,value:O,segment:k}=R;this._delete(R.key,!1),p.key=F,p.value=O,p.segment=k}else{const R=p.left??p.right;if(h.length>0){const[F,O]=h[h.length-1];switch(F){case-1:O.left=R;break;case 0:O.mid=R;break;case 1:O.right=R;break}}else this._root=R}for(let R=h.length-1;R>=0;R--){const F=h[R][1];F.updateHeight();const O=F.balanceFactor();if(O>1?(F.right.balanceFactor()>=0||(F.right=F.right.rotateRight()),h[R][1]=F.rotateLeft()):O<-1&&(F.left.balanceFactor()<=0||(F.left=F.left.rotateLeft()),h[R][1]=F.rotateRight()),R>0)switch(h[R-1][0]){case-1:h[R-1][1].left=h[R][1];break;case 1:h[R-1][1].right=h[R][1];break;case 0:h[R-1][1].mid=h[R][1];break}else this._root=h[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const c=this._iter.reset(t);let l=this._root,h;for(;l;){const p=c.cmp(l.segment);if(p>0)l=l.left;else if(p<0)l=l.right;else if(c.hasNext())c.next(),h=l.value||h,l=l.mid;else break}return l&&l.value||h}findSuperstr(t){const c=this._iter.reset(t);let l=this._root;for(;l;){const h=c.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(c.hasNext())c.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(t){for(const[c,l]of this)t(l,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=c=>{if(!c)return!0;const l=c.balanceFactor();return l<-1||l>1?!1:t(c.left)&&t(c.right)};return t(this._root)}}e.TernarySearchTree=_;class f{constructor(t,c){this.uri=t,this.value=c}}class a{constructor(t,c){this[y]="ResourceMap",t instanceof a?(this.map=new Map(t.map),this.toKey=c??a.defaultToKey):(this.map=new Map,this.toKey=t??a.defaultToKey)}set(t,c){return this.map.set(this.toKey(t),new f(t,c)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,c){typeof c!="undefined"&&(t=t.bind(c));for(let[l,h]of this.map)t(h.value,h.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=a,a.defaultToKey=n=>n.toString();class m{constructor(t,c){this[A]="ResourceSet",!t||typeof t=="function"?this._map=new a(t):(this._map=new a(c),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,c){this._map.forEach((l,h)=>t.call(c,h,h,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=m;var o;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(o||(e.Touch=o={}));class d{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,c=0){const l=this._map.get(t);if(!!l)return c!==0&&this.touch(l,c),l.value}set(t,c,l=0){let h=this._map.get(t);if(h)h.value=c,l!==0&&this.touch(h,l);else{switch(h={key:t,value:c,next:void 0,previous:void 0},l){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(t,h),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this._map.get(t);if(!!c)return this._map.delete(t),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,c){const l=this._state;let h=this._head;for(;h;){if(c?t.bind(c)(h.value,h.key,this):t(h.value,h.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const t=this,c=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:l.key,done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return h}values(){const t=this,c=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:l.value,done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return h}entries(){const t=this,c=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:[l.key,l.value],done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return h}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this._head,l=this.size;for(;c&&l>t;)this._map.delete(c.key),c=c.next,l--;this._head=c,this._size=l,c&&(c.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const c=t.next,l=t.previous;if(!c||!l)throw new Error("Invalid list");c.previous=l,l.next=c}t.next=void 0,t.previous=void 0,this._state++}touch(t,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this._head)return;const l=t.next,h=t.previous;t===this._tail?(h.next=void 0,this._tail=h):(l.previous=h,h.next=l),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(c===2){if(t===this._tail)return;const l=t.next,h=t.previous;t===this._head?(l.previous=void 0,this._head=l):(l.previous=h,h.next=l),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((c,l)=>{t.push([l,c])}),t}fromJSON(t){this.clear();for(const[c,l]of t)this.set(c,l)}}e.LinkedMap=d;class r extends d{constructor(t,c=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class s{get size(){return Ue(this,D,"f").size}constructor(t){D.set(this,void 0),tt(this,D,t,"f")}forEach(t,c){Ue(this,D,"f").forEach(t,c)}get(t){return Ue(this,D,"f").get(t)}has(t){return Ue(this,D,"f").has(t)}entries(){return Ue(this,D,"f").entries()}keys(){return Ue(this,D,"f").keys()}values(){return Ue(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return Ue(this,D,"f").entries()}}e.ReadonlyMapView=s}),define(ke[98],Pe([1,0,25,8]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...ie){return function(ee,M){for(let x=0,G=ie.length;x<G;x++){const X=ie[x](ee,M);if(X)return X}return null}}e.or=y,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ie,ee,M){if(!M||M.length<ee.length)return null;let x;return ie?x=i.startsWithIgnoreCase(M,ee):x=M.indexOf(ee)===0,x?ee.length>0?[{start:0,end:ee.length}]:[]:null}function C(ie,ee){const M=ee.toLowerCase().indexOf(ie.toLowerCase());return M===-1?null:[{start:M,end:M+ie.length}]}e.matchesContiguousSubString=C;function D(ie,ee){return b(ie.toLowerCase(),ee.toLowerCase(),0,0)}e.matchesSubString=D;function b(ie,ee,M,x){if(M===ie.length)return[];if(x===ee.length)return null;if(ie[M]===ee[x]){let G=null;return(G=b(ie,ee,M+1,x+1))?g({start:x,end:x+1},G):null}return b(ie,ee,M,x+1)}function T(ie){return 97<=ie&&ie<=122}function L(ie){return 65<=ie&&ie<=90}e.isUpper=L;function P(ie){return 48<=ie&&ie<=57}function S(ie){return ie===32||ie===9||ie===10||ie===13}const I=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>I.add(ie.charCodeAt(0)));function E(ie){return S(ie)||I.has(ie)}function v(ie,ee){return ie===ee||E(ie)&&E(ee)}function w(ie){return T(ie)||L(ie)||P(ie)}function g(ie,ee){return ee.length===0?ee=[ie]:ie.end===ee[0].start?ee[0].start=ie.start:ee.unshift(ie),ee}function _(ie,ee){for(let M=ee;M<ie.length;M++){const x=ie.charCodeAt(M);if(L(x)||P(x)||M>0&&!w(ie.charCodeAt(M-1)))return M}return ie.length}function f(ie,ee,M,x){if(M===ie.length)return[];if(x===ee.length)return null;if(ie[M]!==ee[x].toLowerCase())return null;{let G=null,X=x+1;for(G=f(ie,ee,M+1,x+1);!G&&(X=_(ee,X))<ee.length;)G=f(ie,ee,M+1,X),X++;return G===null?null:g({start:x,end:x+1},G)}}function a(ie){let ee=0,M=0,x=0,G=0,X=0;for(let ye=0;ye<ie.length;ye++)X=ie.charCodeAt(ye),L(X)&&ee++,T(X)&&M++,w(X)&&x++,P(X)&&G++;const de=ee/ie.length,Ee=M/ie.length,oe=x/ie.length,De=G/ie.length;return{upperPercent:de,lowerPercent:Ee,alphaPercent:oe,numericPercent:De}}function m(ie){const{upperPercent:ee,lowerPercent:M}=ie;return M===0&&ee>.6}function o(ie){const{upperPercent:ee,lowerPercent:M,alphaPercent:x,numericPercent:G}=ie;return M>.2&&ee<.8&&x>.6&&G<.2}function d(ie){let ee=0,M=0,x=0,G=0;for(let X=0;X<ie.length;X++)x=ie.charCodeAt(X),L(x)&&ee++,T(x)&&M++,S(x)&&G++;return(ee===0||M===0)&&G===0?ie.length<=30:ee<=5}function r(ie,ee){if(!ee||(ee=ee.trim(),ee.length===0)||!d(ie)||ee.length>60)return null;const M=a(ee);if(!o(M)){if(!m(M))return null;ee=ee.toLowerCase()}let x=null,G=0;for(ie=ie.toLowerCase();G<ee.length&&(x=f(ie,ee,0,G))===null;)G=_(ee,G+1);return x}e.matchesCamelCase=r;function s(ie,ee,M=!1){if(!ee||ee.length===0)return null;let x=null,G=0;for(ie=ie.toLowerCase(),ee=ee.toLowerCase();G<ee.length&&(x=n(ie,ee,0,G,M))===null;)G=t(ee,G+1);return x}e.matchesWords=s;function n(ie,ee,M,x,G){if(M===ie.length)return[];if(x===ee.length)return null;if(v(ie.charCodeAt(M),ee.charCodeAt(x))){let X=null,de=x+1;if(X=n(ie,ee,M+1,x+1,G),!G)for(;!X&&(de=t(ee,de))<ee.length;)X=n(ie,ee,M+1,de,G),de++;return X===null?null:g({start:x,end:x+1},X)}else return null}function t(ie,ee){for(let M=ee;M<ie.length;M++)if(E(ie.charCodeAt(M))||M>0&&E(ie.charCodeAt(M-1)))return M;return ie.length}const c=y(e.matchesPrefix,r,C),l=y(e.matchesPrefix,r,D),h=new u.LRUCache(1e4);function p(ie,ee,M=!1){if(typeof ie!="string"||typeof ee!="string")return null;let x=h.get(ie);x||(x=new RegExp(i.convertSimple2RegExpPattern(ie),"i"),h.set(ie,x));const G=x.exec(ee);return G?[{start:G.index,end:G.index+G[0].length}]:M?l(ie,ee):c(ie,ee)}e.matchesFuzzy=p;function R(ie,ee){const M=be(ie,ie.toLowerCase(),0,ee,ee.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return M?O(M):null}e.matchesFuzzy2=R;function F(ie,ee,M,x,G,X){const de=Math.min(13,ie.length);for(;M<de;M++){const Ee=be(ie,ee,M,x,G,X,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Ee)return Ee}return[0,X]}e.anyScore=F;function O(ie){if(typeof ie=="undefined")return[];const ee=[],M=ie[1];for(let x=ie.length-1;x>1;x--){const G=ie[x]+M,X=ee[ee.length-1];X&&X.end===G?X.end=G+1:ee.push({start:G,end:G+1})}return ee}e.createMatches=O;const k=128;function U(){const ie=[],ee=[];for(let M=0;M<=k;M++)ee[M]=0;for(let M=0;M<=k;M++)ie.push(ee.slice(0));return ie}function B(ie){const ee=[];for(let M=0;M<=ie;M++)ee[M]=0;return ee}const z=B(2*k),Y=B(2*k),$=U(),N=U(),V=U(),H=!1;function q(ie,ee,M,x,G){function X(Ee,oe,De=" "){for(;Ee.length<oe;)Ee=De+Ee;return Ee}let de=` |   |${x.split("").map(Ee=>X(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=M;Ee++)Ee===0?de+=" |":de+=`${ee[Ee-1]}|`,de+=ie[Ee].slice(0,G+1).map(oe=>X(oe.toString(),3)).join("|")+`
`;return de}function te(ie,ee,M,x){ie=ie.substr(ee),M=M.substr(x),console.log(q(N,ie,ie.length,M,M.length)),console.log(q(V,ie,ie.length,M,M.length)),console.log(q($,ie,ie.length,M,M.length))}function fe(ie,ee){if(ee<0||ee>=ie.length)return!1;const M=ie.codePointAt(ee);switch(M){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(M)}}function ne(ie,ee){if(ee<0||ee>=ie.length)return!1;switch(ie.charCodeAt(ee)){case 32:case 9:return!0;default:return!1}}function le(ie,ee,M){return ee[ie]!==M[ie]}function K(ie,ee,M,x,G,X,de=!1){for(;ee<M&&G<X;)ie[ee]===x[G]&&(de&&(z[ee]=G),ee+=1),G+=1;return ee===M}e.isPatternInWord=K;var ge;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var ve;(function(ie){ie.Default=[-100,0];function ee(M){return!M||M.length===2&&M[0]===-100&&M[1]===0}ie.isDefault=ee})(ve||(e.FuzzyScore=ve={}));class se{constructor(ee,M){this.firstMatchCanBeWeak=ee,this.boostFullMatch=M}}e.FuzzyScoreOptions=se,se.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function be(ie,ee,M,x,G,X,de=se.default){const Ee=ie.length>k?k:ie.length,oe=x.length>k?k:x.length;if(M>=Ee||X>=oe||Ee-M>oe-X||!K(ee,M,Ee,G,X,oe,!0))return;Te(Ee,oe,M,X,ee,G);let De=1,ye=1,ze=M,Ve=X;const Me=[!1];for(De=1,ze=M;ze<Ee;De++,ze++){const ae=z[ze],Ie=Y[ze],Ne=ze+1<Ee?Y[ze+1]:oe;for(ye=ae-X+1,Ve=ae;Ve<Ne;ye++,Ve++){let $e=Number.MIN_SAFE_INTEGER,Ge=!1;Ve<=Ie&&($e=pe(ie,ee,ze,M,x,G,Ve,oe,X,$[De-1][ye-1]===0,Me));let qe=0;$e!==Number.MAX_SAFE_INTEGER&&(Ge=!0,qe=$e+N[De-1][ye-1]);const Ze=Ve>ae,Xe=Ze?N[De][ye-1]+($[De][ye-1]>0?-5:0):0,st=Ve>ae+1&&$[De][ye-1]>0,et=st?N[De][ye-2]+($[De][ye-2]>0?-5:0):0;if(st&&(!Ze||et>=Xe)&&(!Ge||et>=qe))N[De][ye]=et,V[De][ye]=3,$[De][ye]=0;else if(Ze&&(!Ge||Xe>=qe))N[De][ye]=Xe,V[De][ye]=2,$[De][ye]=0;else if(Ge)N[De][ye]=qe,V[De][ye]=1,$[De][ye]=$[De-1][ye-1]+1;else throw new Error("not possible")}}if(H&&te(ie,M,x,X),!Me[0]&&!de.firstMatchCanBeWeak)return;De--,ye--;const Je=[N[De][ye],X];let J=0,re=0;for(;De>=1;){let ae=ye;do{const Ie=V[De][ae];if(Ie===3)ae=ae-2;else if(Ie===2)ae=ae-1;else break}while(ae>=1);J>1&&ee[M+De-1]===G[X+ye-1]&&!le(ae+X-1,x,G)&&J+1>$[De][ae]&&(ae=ye),ae===ye?J++:J=1,re||(re=ae),De--,ye=ae-1,Je.push(ye)}oe===Ee&&de.boostFullMatch&&(Je[0]+=2);const Ce=re-Ee;return Je[0]-=Ce,Je}e.fuzzyScore=be;function Te(ie,ee,M,x,G,X){let de=ie-1,Ee=ee-1;for(;de>=M&&Ee>=x;)G[de]===X[Ee]&&(Y[de]=Ee,de--),Ee--}function pe(ie,ee,M,x,G,X,de,Ee,oe,De,ye){if(ee[M]!==X[de])return Number.MIN_SAFE_INTEGER;let ze=1,Ve=!1;return de===M-x?ze=ie[M]===G[de]?7:5:le(de,G,X)&&(de===0||!le(de-1,G,X))?(ze=ie[M]===G[de]?7:5,Ve=!0):fe(X,de)&&(de===0||!fe(X,de-1))?ze=5:(fe(X,de-1)||ne(X,de-1))&&(ze=5,Ve=!0),ze>1&&M===x&&(ye[0]=!0),Ve||(Ve=le(de,G,X)||fe(X,de-1)||ne(X,de-1)),M===x?de>oe&&(ze-=Ve?3:5):De?ze+=Ve?2:0:ze+=Ve?0:1,de+1===Ee&&(ze-=Ve?3:5),ze}function we(ie,ee,M,x,G,X,de){return ce(ie,ee,M,x,G,X,!0,de)}e.fuzzyScoreGracefulAggressive=we;function Ae(ie,ee,M,x,G,X,de){return ce(ie,ee,M,x,G,X,!1,de)}e.fuzzyScoreGraceful=Ae;function ce(ie,ee,M,x,G,X,de,Ee){let oe=be(ie,ee,M,x,G,X,Ee);if(oe&&!de)return oe;if(ie.length>=3){const De=Math.min(7,ie.length-1);for(let ye=M+1;ye<De;ye++){const ze=me(ie,ye);if(ze){const Ve=be(ze,ze.toLowerCase(),M,x,G,X,Ee);Ve&&(Ve[0]-=3,(!oe||Ve[0]>oe[0])&&(oe=Ve))}}}return oe}function me(ie,ee){if(ee+1>=ie.length)return;const M=ie[ee],x=ie[ee+1];if(M!==x)return ie.slice(0,ee)+x+M+ie.slice(ee+2)}}),define(ke[146],Pe([1,0,78,98,8]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(u.CSSIcon.iconNameCharacter),D=new RegExp(`(\\\\)?${A.source}`,"g");function b(w){return w.replace(D,(g,_)=>_?g:`\\${g}`)}e.escapeIcons=b;const T=new RegExp(`\\\\${A.source}`,"g");function L(w){return w.replace(T,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=L;const P=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function S(w){return w.indexOf(e.iconStartMarker)===-1?w:w.replace(P,(g,_,f,a)=>f?g:_||a||"")}e.stripIcons=S;function I(w){const g=w.indexOf(e.iconStartMarker);return g===-1?{text:w}:E(w,g)}e.parseLabelWithIcons=I;function E(w,g){const _=[];let f="";function a(c){if(c){f+=c;for(const l of c)_.push(d)}}let m=-1,o="",d=0,r,s,n=g;const t=w.length;for(a(w.substr(0,g));n<t;)r=w[n],s=w[n+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(m=n,a(o),o=e.iconStartMarker,n++):r===")"&&m!==-1?(d+=n-m+1,m=-1,o=""):m!==-1?C.test(r)?o+=r:(a(o),m=-1,o=""):a(r),n++;return a(o),{text:f,iconOffsets:_}}function v(w,g,_=!1){const{text:f,iconOffsets:a}=g;if(!a||a.length===0)return(0,i.matchesFuzzy)(w,f,_);const m=(0,y.ltrim)(f," "),o=f.length-m.length,d=(0,i.matchesFuzzy)(w,m,_);if(d)for(const r of d){const s=a[r.start+o]+o;r.start+=s,r.end+=s}return d}e.matchesFuzzyIconAware=v}),define(ke[82],Pe([1,0,25]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new u.LRUCache(1e4);function y(T){return b(T,"NFC",i)}e.normalizeNFC=y;const A=new u.LRUCache(1e4);function C(T){return b(T,"NFD",A)}e.normalizeNFD=C;const D=/[^\u0000-\u0080]/;function b(T,L,P){if(!T)return T;const S=P.get(T);if(S)return S;let I;return D.test(T)?I=T.normalize(L):I=T,P.set(T,I),I}e.removeAccents=function(){const T=/[\u0300-\u036f]/g;return function(L){return C(L).replace(T,"")}}()}),define(ke[41],Pe([1,0,8]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(i||(i={})),function(y){const A="error",C="warning",D="warn",b="info",T="ignore";function L(S){return S?u.equalsIgnoreCase(A,S)?y.Error:u.equalsIgnoreCase(C,S)||u.equalsIgnoreCase(D,S)?y.Warning:u.equalsIgnoreCase(b,S)?y.Info:y.Ignore:y.Ignore}y.fromValue=L;function P(S){switch(S){case y.Error:return A;case y.Warning:return C;case y.Info:return b;default:return T}}y.toString=P}(i||(i={})),e.default=i}),define(ke[12],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function u(c){return Array.isArray(c)}e.isArray=u;function i(c){return typeof c=="string"}e.isString=i;function y(c){return Array.isArray(c)&&c.every(l=>i(l))}e.isStringArray=y;function A(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=A;function C(c){return typeof c=="object"&&(c instanceof Uint8Array||c instanceof Uint16Array||c instanceof Uint32Array||c instanceof Float32Array||c instanceof Float64Array||c instanceof Int8Array||c instanceof Int16Array||c instanceof Int32Array||c instanceof BigInt64Array||c instanceof BigUint64Array||c instanceof Uint8ClampedArray)}e.isTypedArray=C;function D(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=D;function b(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=b;function T(c){return c===!0||c===!1}e.isBoolean=T;function L(c){return typeof c=="undefined"}e.isUndefined=L;function P(c){return!S(c)}e.isDefined=P;function S(c){return L(c)||c===null}e.isUndefinedOrNull=S;function I(c,l){if(!c)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=I;function E(c){if(S(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=E;function v(...c){const l=[];for(let h=0;h<c.length;h++){const p=c[h];if(S(p))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);l.push(p)}return l}e.assertAllDefined=v;const w=Object.prototype.hasOwnProperty;function g(c){if(!A(c))return!1;for(let l in c)if(w.call(c,l))return!1;return!0}e.isEmptyObject=g;function _(c){return typeof c=="function"}e.isFunction=_;function f(...c){return c.length>0&&c.every(_)}e.areFunctions=f;function a(c,l){const h=Math.min(c.length,l.length);for(let p=0;p<h;p++)m(c[p],l[p])}e.validateConstraints=a;function m(c,l){if(i(l)){if(typeof c!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(_(l)){try{if(c instanceof l)return}catch{}if(!S(c)&&c.constructor===l||l.length===1&&l.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function o(c){let l=[],h=Object.getPrototypeOf(c);for(;Object.prototype!==h;)l=l.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return l}e.getAllPropertyNames=o;function d(c){const l=[];for(const h of o(c))typeof c[h]=="function"&&l.push(h);return l}e.getAllMethodNames=d;function r(c,l){const h=R=>function(){const F=Array.prototype.slice.call(arguments,0);return l(R,F)};let p={};for(const R of c)p[R]=h(R);return p}e.createProxyObject=r;function s(c){return c===null?void 0:c}e.withNullAsUndefined=s;function n(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=n;function t(c,l="Unreachable"){throw new Error(l)}e.assertNever=t}),define(ke[30],Pe([1,0,9,13,8,12]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(n){return n===47||n===92}e.isPathSeparator=C;function D(n){return n.replace(/[\\/]/g,u.posix.sep)}e.toSlashes=D;function b(n){return n.indexOf("/")===-1&&(n=D(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=b;function T(n,t=u.posix.sep){if(!n)return"";const c=n.length,l=n.charCodeAt(0);if(C(l)){if(C(n.charCodeAt(1))&&!C(n.charCodeAt(2))){let p=3;const R=p;for(;p<c&&!C(n.charCodeAt(p));p++);if(R!==p&&!C(n.charCodeAt(p+1))){for(p+=1;p<c;p++)if(C(n.charCodeAt(p)))return n.slice(0,p+1).replace(/[\\/]/g,t)}}return t}else if(g(l)&&n.charCodeAt(1)===58)return C(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<c;h++)if(C(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=T;function L(n){if(!i.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let c=2;const l=c;for(;c<n.length&&(t=n.charCodeAt(c),t!==92);c++);return!(l===c||(t=n.charCodeAt(c+1),isNaN(t)||t===92))}e.isUNC=L;const P=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(n,t=i.isWindows){const c=t?P:S;return!(!n||n.length===0||/^\s+$/.test(n)||(c.lastIndex=0,c.test(n))||t&&I.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=E;function v(n,t,c){const l=n===t;return!c||l?l:!n||!t?!1:(0,y.equalsIgnoreCase)(n,t)}e.isEqual=v;function w(n,t,c,l=u.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(c){if(!(0,y.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let p=t.length;return t.charAt(t.length-1)===l&&p--,n.charAt(p)===l}return t.charAt(t.length-1)!==l&&(t+=l),n.indexOf(t)===0}e.isEqualOrParent=w;function g(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=g;function _(n,t){return i.isWindows&&n.endsWith(":")&&(n+=u.sep),(0,u.isAbsolute)(n)||(n=(0,u.join)(t,n)),n=(0,u.normalize)(n),i.isWindows?(n=(0,y.rtrim)(n,u.sep),n.endsWith(":")&&(n+=u.sep)):(n=(0,y.rtrim)(n,u.sep),n||(n=u.sep)),n}e.sanitizeFilePath=_;function f(n){const t=(0,u.normalize)(n);return i.isWindows?n.length>3?!1:a(t)&&(n.length===2||t.charCodeAt(2)===92):t===u.posix.sep}e.isRootOrDriveLetter=f;function a(n,t=i.isWindows){return t?g(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function m(n){return a(n)?n[0]:void 0}e.getDriveLetter=m;function o(n,t,c){return t.length>n.length?-1:n===t?0:(c&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=o;function d(n){const t=n.split(":");let c,l,h;for(const p of t){const R=Number(p);(0,A.isNumber)(R)?l===void 0?l=R:h===void 0&&(h=R):c=c?[c,p].join(":"):p}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(n,t,c=8){let l="";for(let p=0;p<c;p++)l+=r.charAt(Math.floor(Math.random()*r.length));let h;return t?h=`${t}-${l}`:h=l,n?(0,u.join)(n,h):h}e.randomPath=s}),define(ke[24],Pe([1,0,12]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const w=Array.isArray(v)?[]:{};return Object.keys(v).forEach(g=>{v[g]&&typeof v[g]=="object"?w[g]=i(v[g]):w[g]=v[g]}),w}e.deepClone=i;function y(v){if(!v||typeof v!="object")return v;const w=[v];for(;w.length>0;){const g=w.shift();Object.freeze(g);for(const _ in g)if(A.call(g,_)){const f=g[_];typeof f=="object"&&!Object.isFrozen(f)&&!(0,u.isTypedArray)(f)&&w.push(f)}}return v}e.deepFreeze=y;const A=Object.prototype.hasOwnProperty;function C(v,w){return D(v,w,new Set)}e.cloneAndChange=C;function D(v,w,g){if((0,u.isUndefinedOrNull)(v))return v;const _=w(v);if(typeof _!="undefined")return _;if((0,u.isArray)(v)){const f=[];for(const a of v)f.push(D(a,w,g));return f}if((0,u.isObject)(v)){if(g.has(v))throw new Error("Cannot clone recursive data-structure");g.add(v);const f={};for(let a in v)A.call(v,a)&&(f[a]=D(v[a],w,g));return g.delete(v),f}return v}function b(v,w,g=!0){return(0,u.isObject)(v)?((0,u.isObject)(w)&&Object.keys(w).forEach(_=>{_ in v?g&&((0,u.isObject)(v[_])&&(0,u.isObject)(w[_])?b(v[_],w[_],g):v[_]=w[_]):v[_]=w[_]}),v):w}e.mixin=b;function T(v,w){if(v===w)return!0;if(v==null||w===null||w===void 0||typeof v!=typeof w||typeof v!="object"||Array.isArray(v)!==Array.isArray(w))return!1;let g,_;if(Array.isArray(v)){if(v.length!==w.length)return!1;for(g=0;g<v.length;g++)if(!T(v[g],w[g]))return!1}else{const f=[];for(_ in v)f.push(_);f.sort();const a=[];for(_ in w)a.push(_);if(a.sort(),!T(f,a))return!1;for(g=0;g<f.length;g++)if(!T(v[f[g]],w[f[g]]))return!1}return!0}e.equals=T;function L(v){const w=new Set;return JSON.stringify(v,(g,_)=>{if((0,u.isObject)(_)||Array.isArray(_)){if(w.has(_))return"[Circular]";w.add(_)}return _})}e.safeStringify=L;function P(v,w,g){const _=w(v);return typeof _=="undefined"?g:_}e.getOrDefault=P;function S(v,w){const g=Object.create(null);return!v||!w||Object.keys(w).forEach(f=>{const a=v[f],m=w[f];T(a,m)||(g[f]=m)}),g}e.distinct=S;function I(v,w){const g=w.toLowerCase(),_=Object.keys(v).find(f=>f.toLowerCase()===g);return _?v[_]:v[w]}e.getCaseInsensitive=I;function E(v,w){const g=Object.create(null);for(const[_,f]of Object.entries(v))w(_,f)&&(g[_]=f);return g}e.filter=E}),define(ke[99],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var u;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u||(e.Constants=u={}));function i(A){return A<0?0:A>255?255:A|0}e.toUint8=i;function y(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=y}),define(ke[2],Pe([1,0,9,13]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const y=/^\w[\w\d+.-]*$/,A=/^\//,C=/^\/\//;function D(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!y.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!A.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(r,s){return!r&&!s?"file":r}function T(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==P&&(s=P+s):s=P;break}return s}const L="",P="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class I{static isUri(s){return s instanceof I?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,n,t,c,l,h=!1){typeof s=="object"?(this.scheme=s.scheme||L,this.authority=s.authority||L,this.path=s.path||L,this.query=s.query||L,this.fragment=s.fragment||L):(this.scheme=b(s,h),this.authority=n||L,this.path=T(this.scheme,t||L),this.query=c||L,this.fragment=l||L,D(this,h))}get fsPath(){return f(this,!1)}with(s){if(!s)return this;let{scheme:n,authority:t,path:c,query:l,fragment:h}=s;return n===void 0?n=this.scheme:n===null&&(n=L),t===void 0?t=this.authority:t===null&&(t=L),c===void 0?c=this.path:c===null&&(c=L),l===void 0?l=this.query:l===null&&(l=L),h===void 0?h=this.fragment:h===null&&(h=L),n===this.scheme&&t===this.authority&&c===this.path&&l===this.query&&h===this.fragment?this:new v(n,t,c,l,h)}static parse(s,n=!1){const t=S.exec(s);return t?new v(t[2]||L,d(t[4]||L),d(t[5]||L),d(t[7]||L),d(t[9]||L),n):new v(L,L,L,L,L)}static file(s){let n=L;if(i.isWindows&&(s=s.replace(/\\/g,P)),s[0]===P&&s[1]===P){const t=s.indexOf(P,2);t===-1?(n=s.substring(2),s=P):(n=s.substring(2,t),s=s.substring(t)||P)}return new v("file",n,s,L,L)}static from(s){const n=new v(s.scheme,s.authority,s.path,s.query,s.fragment);return D(n,!0),n}static joinPath(s,...n){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let t;return i.isWindows&&s.scheme==="file"?t=I.file(u.win32.join(f(s,!0),...n)).path:t=u.posix.join(s.path,...n),s.with({path:t})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof I)return s;{const n=new v(s);return n._formatted=s.external,n._fsPath=s._sep===E?s.fsPath:null,n}}else return s}}e.URI=I;const E=i.isWindows?1:void 0;class v extends I{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=E),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(r,s){let n,t=-1;for(let c=0;c<r.length;c++){const l=r.charCodeAt(c);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||s&&l===47)t!==-1&&(n+=encodeURIComponent(r.substring(t,c)),t=-1),n!==void 0&&(n+=r.charAt(c));else{n===void 0&&(n=r.substr(0,c));const h=w[l];h!==void 0?(t!==-1&&(n+=encodeURIComponent(r.substring(t,c)),t=-1),n+=h):t===-1&&(t=c)}}return t!==-1&&(n+=encodeURIComponent(r.substring(t))),n!==void 0?n:r}function _(r){let s;for(let n=0;n<r.length;n++){const t=r.charCodeAt(n);t===35||t===63?(s===void 0&&(s=r.substr(0,n)),s+=w[t]):s!==void 0&&(s+=r[n])}return s!==void 0?s:r}function f(r,s){let n;return r.authority&&r.path.length>1&&r.scheme==="file"?n=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?n=r.path.substr(1):n=r.path[1].toLowerCase()+r.path.substr(2):n=r.path,i.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=f;function a(r,s){const n=s?_:g;let t="",{scheme:c,authority:l,path:h,query:p,fragment:R}=r;if(c&&(t+=c,t+=":"),(l||c==="file")&&(t+=P,t+=P),l){let F=l.indexOf("@");if(F!==-1){const O=l.substr(0,F);l=l.substr(F+1),F=O.indexOf(":"),F===-1?t+=n(O,!1):(t+=n(O.substr(0,F),!1),t+=":",t+=n(O.substr(F+1),!1)),t+="@"}l=l.toLowerCase(),F=l.indexOf(":"),F===-1?t+=n(l,!1):(t+=n(l.substr(0,F),!1),t+=l.substr(F))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const F=h.charCodeAt(1);F>=65&&F<=90&&(h=`/${String.fromCharCode(F+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const F=h.charCodeAt(0);F>=65&&F<=90&&(h=`${String.fromCharCode(F+32)}:${h.substr(2)}`)}t+=n(h,!0)}return p&&(t+="?",t+=n(p,!1)),R&&(t+="#",t+=s?R:g(R,!1)),t}function m(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+m(r.substr(3)):r}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(r){return r.match(o)?r.replace(o,s=>m(s)):r}}),define(ke[62],Pe([1,0,23,8,2]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(T){return JSON.stringify(T,D)}e.stringify=A;function C(T){let L=JSON.parse(T);return L=b(L),L}e.parse=C;function D(T,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,i.regExpFlags)(L)}:L}function b(T,L=0){if(!T||L>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return y.URI.revive(T);case 2:return new RegExp(T.source,T.flags);case 14:return new Date(T.source)}if(T instanceof u.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let P=0;P<T.length;++P)T[P]=b(T[P],L+1);else for(const P in T)Object.hasOwnProperty.call(T,P)&&(T[P]=b(T[P],L+1))}return T}e.revive=b}),define(ke[10],Pe([1,0,13,2]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.vscodeUserData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls"})(y||(e.Schemas=y={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${y.vscodeRemoteResource}`}set(b,T,L){this._hosts[b]=T,this._ports[b]=L}setConnectionToken(b,T){this._connectionTokens[b]=T}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const T=b.authority;let L=this._hosts[T];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const P=this._ports[T],S=this._connectionTokens[T];let I=`path=${encodeURIComponent(b.path)}`;return typeof S=="string"&&(I+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),i.URI.from({scheme:u.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${L}:${P}`,path:this._remoteResourcesPath,query:I})}}e.RemoteAuthorities=new A;class C{asBrowserUri(b,T){const L=this.toUri(b,T);return L.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===y.file&&(u.isNative||u.isWebWorker&&u.globals.origin===`${y.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?L.with({scheme:y.vscodeFileResource,authority:L.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(b,T){const L=this.toUri(b,T);return L.scheme===y.vscodeFileResource?L.with({scheme:y.file,authority:L.authority!==C.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(b,T){return i.URI.isUri(b)?b:i.URI.parse(T.toUrl(b))}}C.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new C}),define(ke[22],Pe([1,0,30,10,9,13,8,2]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(I){return(0,D.uriToFsPath)(I,!0)}e.originalFSPath=b;class T{constructor(E){this._ignorePathCasing=E}compare(E,v,w=!1){return E===v?0:(0,C.compare)(this.getComparisonKey(E,w),this.getComparisonKey(v,w))}isEqual(E,v,w=!1){return E===v?!0:!E||!v?!1:this.getComparisonKey(E,w)===this.getComparisonKey(v,w)}getComparisonKey(E,v=!1){return E.with({path:this._ignorePathCasing(E)?E.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(E){return this._ignorePathCasing(E)}isEqualOrParent(E,v,w=!1){if(E.scheme===v.scheme){if(E.scheme===i.Schemas.file)return u.isEqualOrParent(b(E),b(v),this._ignorePathCasing(E))&&E.query===v.query&&(w||E.fragment===v.fragment);if((0,e.isEqualAuthority)(E.authority,v.authority))return u.isEqualOrParent(E.path,v.path,this._ignorePathCasing(E),"/")&&E.query===v.query&&(w||E.fragment===v.fragment)}return!1}joinPath(E,...v){return D.URI.joinPath(E,...v)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return y.posix.basename(E.path)}extname(E){return y.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let v;return E.scheme===i.Schemas.file?v=D.URI.file(y.dirname(b(E))).path:(v=y.posix.dirname(E.path),E.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),v="/")),E.with({path:v})}normalizePath(E){if(!E.path.length)return E;let v;return E.scheme===i.Schemas.file?v=D.URI.file(y.normalize(b(E))).path:v=y.posix.normalize(E.path),E.with({path:v})}relativePath(E,v){if(E.scheme!==v.scheme||!(0,e.isEqualAuthority)(E.authority,v.authority))return;if(E.scheme===i.Schemas.file){const _=y.relative(b(E),b(v));return A.isWindows?u.toSlashes(_):_}let w=E.path||"/",g=v.path||"/";if(this._ignorePathCasing(E)){let _=0;for(const f=Math.min(w.length,g.length);_<f&&!(w.charCodeAt(_)!==g.charCodeAt(_)&&w.charAt(_).toLowerCase()!==g.charAt(_).toLowerCase());_++);w=g.substr(0,_)+w.substr(_)}return y.posix.relative(w,g)}resolvePath(E,v){if(E.scheme===i.Schemas.file){const w=D.URI.file(y.resolve(b(E),v));return E.with({authority:w.authority,path:w.path})}return v=u.toPosixPath(v),E.with({path:y.posix.resolve(E.path,v)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,v){return E===v||E!==void 0&&v!==void 0&&(0,C.equalsIgnoreCase)(E,v)}hasTrailingPathSeparator(E,v=y.sep){if(E.scheme===i.Schemas.file){const w=b(E);return w.length>u.getRoot(w).length&&w[w.length-1]===v}else{const w=E.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,v=y.sep){return(0,e.hasTrailingPathSeparator)(E,v)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,v=y.sep){let w=!1;if(E.scheme===i.Schemas.file){const g=b(E);w=g!==void 0&&g.length===u.getRoot(g).length&&g[g.length-1]===v}else{v="/";const g=E.path;w=g.length===1&&g.charCodeAt(g.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(E,v)?E.with({path:E.path+"/"}):E}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(I=>I.scheme===i.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new T(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(I,E){const v=[];for(let w=0;w<I.length;w++){const g=E(I[w]);I.some((_,f)=>f===w?!1:(0,e.isEqualOrParent)(g,E(_)))||v.push(I[w])}return v}e.distinctParents=L;var P;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function E(v){const w=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(f=>{const[a,m]=f.split(":");a&&m&&w.set(a,m)});const _=v.path.substring(0,v.path.indexOf(";"));return _&&w.set(I.META_DATA_MIME,_),w}I.parseMetaData=E})(P||(e.DataUri=P={}));function S(I,E,v){if(E){let w=I.path;return w&&w[0]!==y.posix.sep&&(w=y.posix.sep+w),I.with({scheme:v,authority:E,path:w})}return I.with({scheme:v})}e.toLocalResource=S}),define(ke[17],Pe([1,0,21,11,3,6,22,13]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(le){return!!le&&typeof le.then=="function"}e.isThenable=b;function T(le){const K=new u.CancellationTokenSource,ge=le(K.token),ve=new Promise((se,be)=>{const Te=K.token.onCancellationRequested(()=>{Te.dispose(),K.dispose(),be(new i.CancellationError)});Promise.resolve(ge).then(pe=>{Te.dispose(),K.dispose(),se(pe)},pe=>{Te.dispose(),K.dispose(),be(pe)})});return new class{cancel(){K.cancel()}then(se,be){return ve.then(se,be)}catch(se){return this.then(void 0,se)}finally(se){return ve.finally(se)}}}e.createCancelablePromise=T;function L(le,K,ge){return new Promise((ve,se)=>{const be=K.onCancellationRequested(()=>{be.dispose(),ve(ge)});le.then(ve,se).finally(()=>be.dispose())})}e.raceCancellation=L;function P(le,K){return new Promise((ge,ve)=>{const se=K.onCancellationRequested(()=>{se.dispose(),ve(new i.CancellationError)});le.then(ge,ve).finally(()=>se.dispose())})}e.raceCancellationError=P;async function S(le){let K=-1;const ge=le.map((se,be)=>se.then(Te=>(K=be,Te))),ve=await Promise.race(ge);return le.forEach((se,be)=>{be!==K&&se.cancel()}),ve}e.raceCancellablePromises=S;function I(le,K,ge){let ve;const se=setTimeout(()=>{ve?.(void 0),ge?.()},K);return Promise.race([le.finally(()=>clearTimeout(se)),new Promise(be=>ve=be)])}e.raceTimeout=I;function E(le){return new Promise((K,ge)=>{const ve=le();b(ve)?ve.then(K,ge):K(ve)})}e.asPromise=E;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(K){if(this.activePromise){if(this.queuedPromiseFactory=K,!this.queuedPromise){const ge=()=>{this.queuedPromise=null;const ve=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ve};this.queuedPromise=new Promise(ve=>{this.activePromise.then(ge,ge).then(ve)})}return new Promise((ge,ve)=>{this.queuedPromise.then(ge,ve)})}return this.activePromise=K(),new Promise((ge,ve)=>{this.activePromise.then(se=>{this.activePromise=null,ge(se)},se=>{this.activePromise=null,ve(se)})})}}e.Throttler=v;class w{constructor(){this.current=Promise.resolve(null)}queue(K){return this.current=this.current.then(()=>K(),()=>K())}}e.Sequencer=w;class g{constructor(){this.promiseMap=new Map}queue(K,ge){const se=(this.promiseMap.get(K)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.promiseMap.get(K)===se&&this.promiseMap.delete(K)});return this.promiseMap.set(K,se),se}}e.SequencerByKey=g;const _=(le,K)=>{let ge=!0;const ve=setTimeout(()=>{ge=!1,K()},le);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(ve),ge=!1}}},f=le=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,le())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class a{constructor(K){this.defaultDelay=K,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(K,ge=this.defaultDelay){this.task=K,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((se,be)=>{this.doResolve=se,this.doReject=be}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const se=this.task;return this.task=null,se()}}));const ve=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ge===e.MicrotaskDelay?f(ve):_(ge,ve),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=a;class m{constructor(K){this.delayer=new a(K),this.throttler=new v}trigger(K,ge){return this.delayer.trigger(()=>this.throttler.queue(K),ge)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class o{constructor(){this._isOpen=!1,this._promise=new Promise((K,ge)=>{this._completePromise=K})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class d extends o{constructor(K){super();this._timeout=setTimeout(()=>this.open(),K)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function r(le,K){return K?new Promise((ge,ve)=>{const se=setTimeout(()=>{be.dispose(),ge()},le),be=K.onCancellationRequested(()=>{clearTimeout(se),be.dispose(),ve(new i.CancellationError)})}):T(ge=>r(le,ge))}e.timeout=r;function s(le,K=0){const ge=setTimeout(le,K);return(0,A.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=s;function n(le){const K=[];let ge=0;const ve=le.length;function se(){return ge<ve?le[ge++]():null}function be(Te){Te!=null&&K.push(Te);const pe=se();return pe?pe.then(be):Promise.resolve(K)}return Promise.resolve(null).then(be)}e.sequence=n;function t(le,K=ve=>!!ve,ge=null){let ve=0;const se=le.length,be=()=>{if(ve>=se)return Promise.resolve(ge);const Te=le[ve++];return Promise.resolve(Te()).then(we=>K(we)?Promise.resolve(we):be())};return be()}e.first=t;function c(le,K=ve=>!!ve,ge=null){if(le.length===0)return Promise.resolve(ge);let ve=le.length;const se=()=>{ve=-1;for(const be of le)be.cancel?.()};return new Promise((be,Te)=>{for(const pe of le)pe.then(we=>{--ve>=0&&K(we)?(se(),be(we)):ve===0&&be(ge)}).catch(we=>{--ve>=0&&(se(),Te(we))})})}e.firstParallel=c;class l{constructor(K){this._size=0,this.maxDegreeOfParalellism=K,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new y.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(K){return this._size++,new Promise((ge,ve)=>{this.outstandingPromises.push({factory:K,c:ge,e:ve}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const K=this.outstandingPromises.shift();this.runningPromises++;const ge=K.factory();ge.then(K.c,K.e),ge.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class h extends l{constructor(){super(1)}}e.Queue=h;class p{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const K=new V;return this.drainers.add(K),K.p}isDrained(){for(const[,K]of this.queues)if(K.size>0)return!1;return!0}queueFor(K,ge=C.extUri){const ve=ge.getComparisonKey(K);let se=this.queues.get(ve);return se||(se=new h,y.Event.once(se.onDrained)(()=>{se?.dispose(),this.queues.delete(ve),this.onDidQueueDrain()}),this.queues.set(ve,se)),se}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const K of this.drainers)K.complete();this.drainers.clear()}dispose(){for(const[,K]of this.queues)K.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=p;class R{constructor(K,ge){this._token=-1,typeof K=="function"&&typeof ge=="number"&&this.setIfNotSet(K,ge)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(K,ge){this.cancel(),this._token=setTimeout(()=>{this._token=-1,K()},ge)}setIfNotSet(K,ge){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,K()},ge))}}e.TimeoutTimer=R;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(K,ge){this.cancel(),this._token=setInterval(()=>{K()},ge)}}e.IntervalTimer=F;class O{constructor(K,ge){this.timeoutToken=-1,this.runner=K,this.timeout=ge,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(K=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,K)}get delay(){return this.timeout}set delay(K){this.timeout=K}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=O;class k{constructor(K,ge){ge%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.runner=K,this.timeout=ge,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(K=this.timeout){K%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(K/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=k;class U extends O{constructor(K,ge){super(K,ge);this.units=[]}work(K){this.units.push(K),this.isScheduled()||this.schedule()}doRun(){const K=this.units;this.units=[],this.runner&&this.runner(K)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class B extends A.Disposable{constructor(K,ge){super();this.options=K,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(K){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+K.length>this.options.maxBufferedWork)return!1}else if(this.pending+K.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...K),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=le=>{(0,D.setTimeout0)(()=>{if(K)return;const ge=Date.now()+15;le(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let K=!1;return{dispose(){K||(K=!0)}}}:e.runWhenIdle=(le,K)=>{const ge=requestIdleCallback(le,typeof K=="number"?{timeout:K}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(ge))}}}}();class z{constructor(K){this._didRun=!1,this._executor=()=>{try{this._value=K()}catch(ge){this._error=ge}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=z;async function Y(le,K,ge){let ve;for(let se=0;se<ge;se++)try{return await le()}catch(be){ve=be,await r(K)}throw ve}e.retry=Y;class ${hasPending(K){return this._pending?typeof K=="number"?this._pending.taskId===K:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(K,ge,ve){return this._pending={taskId:K,cancel:()=>ve?.(),promise:ge},ge.then(()=>this.donePending(K),()=>this.donePending(K)),ge}donePending(K){this._pending&&K===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const K=this._next;this._next=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}setNext(K){if(this._next)this._next.run=K;else{let ge,ve;const se=new Promise((be,Te)=>{ge=be,ve=Te});this._next={run:K,promise:se,promiseResolve:ge,promiseReject:ve}}return this._next.promise}}e.TaskSequentializer=$;class N{constructor(K,ge=()=>Date.now()){this.interval=K,this.nowFn=ge,this.lastIncrementTime=0,this.value=0}increment(){const K=this.nowFn();return K-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=K,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class V{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((K,ge)=>{this.completeCallback=K,this.errorCallback=ge})}complete(K){return new Promise(ge=>{this.completeCallback(K),this.resolved=!0,ge()})}error(K){return new Promise(ge=>{this.errorCallback(K),this.rejected=!0,ge()})}cancel(){new Promise(K=>{this.errorCallback(new i.CancellationError),this.rejected=!0,K()})}}e.DeferredPromise=V;var H;(function(le){async function K(ve){let se;const be=await Promise.all(ve.map(Te=>Te.then(pe=>pe,pe=>{se||(se=pe)})));if(typeof se!="undefined")throw se;return be}le.settled=K;function ge(ve){return new Promise(async(se,be)=>{try{await ve(se,be)}catch(Te){be(Te)}})}le.withAsyncBody=ge})(H||(e.Promises=H={}));var q;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(q||(q={}));class te{static fromArray(K){return new te(ge=>{ge.emitMany(K)})}static fromPromise(K){return new te(async ge=>{ge.emitMany(await K)})}static fromPromises(K){return new te(async ge=>{await Promise.all(K.map(async ve=>ge.emitOne(await ve)))})}static merge(K){return new te(async ge=>{await Promise.all(K.map(async ve=>{for await(const se of ve)ge.emitOne(se)}))})}constructor(K){this._state=0,this._results=[],this._error=null,this._onStateChanged=new y.Emitter,queueMicrotask(async()=>{const ge={emitOne:ve=>this.emitOne(ve),emitMany:ve=>this.emitMany(ve),reject:ve=>this.reject(ve)};try{await Promise.resolve(K(ge)),this.resolve()}catch(ve){this.reject(ve)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(K<this._results.length)return{done:!1,value:this._results[K++]};if(this._state===1)return{done:!0,value:void 0};await y.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(K,ge){return new te(async ve=>{for await(const se of K)ve.emitOne(ge(se))})}map(K){return te.map(this,K)}static filter(K,ge){return new te(async ve=>{for await(const se of K)ge(se)&&ve.emitOne(se)})}filter(K){return te.filter(this,K)}static coalesce(K){return te.filter(K,ge=>!!ge)}coalesce(){return te.coalesce(this)}static async toPromise(K){const ge=[];for await(const ve of K)ge.push(ve);return ge}toPromise(){return te.toPromise(this)}emitOne(K){this._state===0&&(this._results.push(K),this._onStateChanged.fire())}emitMany(K){this._state===0&&(this._results=this._results.concat(K),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(K){this._state===0&&(this._state=2,this._error=K,this._onStateChanged.fire())}}e.AsyncIterableObject=te,te.EMPTY=te.fromArray([]);class fe extends te{constructor(K,ge){super(ge);this._source=K}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=fe;function ne(le){const K=new u.CancellationTokenSource,ge=le(K.token);return new fe(K,async ve=>{const se=K.token.onCancellationRequested(()=>{se.dispose(),K.dispose(),ve.reject(new i.CancellationError)});try{for await(const be of ge){if(K.token.isCancellationRequested)return;ve.emitOne(be)}se.dispose(),K.dispose()}catch(be){se.dispose(),K.dispose(),ve.reject(be)}})}e.createCancelableAsyncIterable=ne}),define(ke[100],Pe([1,0,17,9]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new u.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),A=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(h,p,R=!1){const F=h||"",O=p||"",k=y.value.collator.compare(F,O);return y.value.collatorIsNumeric&&k===0&&F!==O?F<O?-1:1:k}e.compareFileNames=D;function b(h,p){const R=A.value.collator;return h=h||"",p=p||"",m(R,h,p)}e.compareFileNamesDefault=b;function T(h,p){const R=A.value.collator;return h=h||"",p=p||"",s(h,p)||m(R,h,p)}e.compareFileNamesUpper=T;function L(h,p){const R=A.value.collator;return h=h||"",p=p||"",r(h,p)||m(R,h,p)}e.compareFileNamesLower=L;function P(h,p){return h=h||"",p=p||"",h===p?0:h<p?-1:1}e.compareFileNamesUnicode=P;function S(h,p,R=!1){R||(h=h&&h.toLowerCase(),p=p&&p.toLowerCase());const[F,O]=f(h),[k,U]=f(p);return F!==k?F<k?-1:1:O===U?0:O<U?-1:1}e.noIntlCompareFileNames=S;function I(h,p){const[R,F]=f(h),[O,k]=f(p);let U=y.value.collator.compare(F,k);if(U===0){if(y.value.collatorIsNumeric&&F!==k)return F<k?-1:1;if(U=y.value.collator.compare(R,O),y.value.collatorIsNumeric&&U===0&&R!==O)return R<O?-1:1}return U}e.compareFileExtensions=I;function E(h,p){h=h||"",p=p||"";const R=a(h),F=a(p),O=A.value.collator,k=C.value.collator;return m(k,R,F)||m(O,h,p)}e.compareFileExtensionsDefault=E;function v(h,p){h=h||"",p=p||"";const R=a(h),F=a(p),O=A.value.collator,k=C.value.collator;return m(k,R,F)||s(h,p)||m(O,h,p)}e.compareFileExtensionsUpper=v;function w(h,p){h=h||"",p=p||"";const R=a(h),F=a(p),O=A.value.collator,k=C.value.collator;return m(k,R,F)||r(h,p)||m(O,h,p)}e.compareFileExtensionsLower=w;function g(h,p){h=h||"",p=p||"";const R=a(h).toLowerCase(),F=a(p).toLowerCase();return R!==F?R<F?-1:1:h!==p?h<p?-1:1:0}e.compareFileExtensionsUnicode=g;const _=/^(.*?)(\.([^.]*))?$/;function f(h,p=!1){const R=h?_.exec(h):[];let F=[R&&R[1]||"",R&&R[3]||""];return p&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function a(h){const p=h?_.exec(h):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function m(h,p,R){let F=h.compare(p,R);return F!==0?F:p.length!==R.length?p.length<R.length?-1:1:0}function o(h){const p=h.charAt(0);return p.toLocaleUpperCase()!==p}function d(h){const p=h.charAt(0);return p.toLocaleLowerCase()!==p}function r(h,p){return o(h)&&d(p)?-1:d(h)&&o(p)?1:0}function s(h,p){return d(h)&&o(p)?-1:o(h)&&d(p)?1:0}function n(h,p,R=!1){return R||(h=h&&h.toLowerCase(),p=p&&p.toLowerCase()),h===p?0:h<p?-1:1}function t(h,p,R=!1){const F=h.split(i.sep),O=p.split(i.sep),k=F.length-1,U=O.length-1;let B,z;for(let Y=0;;Y++){if(B=k===Y,z=U===Y,B&&z)return D(F[Y],O[Y],R);if(B)return-1;if(z)return 1;const $=n(F[Y],O[Y],R);if($!==0)return $}}e.comparePaths=t;function c(h,p,R){const F=h.toLowerCase(),O=p.toLowerCase(),k=l(h,p,R);if(k)return k;const U=F.endsWith(R),B=O.endsWith(R);if(U!==B)return U?-1:1;const z=D(F,O);return z!==0?z:F.localeCompare(O)}e.compareAnything=c;function l(h,p,R){const F=h.toLowerCase(),O=p.toLowerCase(),k=F.startsWith(R),U=O.startsWith(R);if(k!==U)return k?-1:1;if(k&&U){if(F.length<O.length)return-1;if(F.length>O.length)return 1}return 0}e.compareByPrefix=l}),define(ke[101],Pe([1,0,100,98,61,9,13,8]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const b=0,T=[b,[]];function L($,N,V,H){if(!$||!N)return T;const q=$.length,te=N.length;if(q<te)return T;const fe=$.toLowerCase();return P(N,V,te,$,fe,q,H)}e.scoreFuzzy=L;function P($,N,V,H,q,te,fe){const ne=[],le=[];for(let se=0;se<V;se++){const be=se*te,Te=be-te,pe=se>0,we=$[se],Ae=N[se];for(let ce=0;ce<te;ce++){const me=ce>0,ie=be+ce,ee=ie-1,M=Te+ce-1,x=me?ne[ee]:0,G=pe&&me?ne[M]:0,X=pe&&me?le[M]:0;let de;!G&&pe?de=0:de=S(we,Ae,H,q,ce,X),de&&G+de>=x&&(fe||pe||q.startsWith(N,ce))?(le[ie]=X+1,ne[ie]=G+de):(le[ie]=b,ne[ie]=x)}}const K=[];let ge=V-1,ve=te-1;for(;ge>=0&&ve>=0;){const se=ge*te+ve;le[se]===b||(K.push(ve),ge--),ve--}return[ne[V*te-1],K.reverse()]}function S($,N,V,H,q,te){let fe=0;if(!I(N,H[q]))return fe;if(fe+=1,te>0&&(fe+=te*5),$===V[q]&&(fe+=1),q===0)fe+=8;else{const ne=E(V.charCodeAt(q-1));ne?fe+=ne:(0,i.isUpper)(V.charCodeAt(q))&&te===0&&(fe+=2)}return fe}function I($,N){return $===N?!0:$==="/"||$==="\\"?N==="/"||N==="\\":!1}function E($){switch($){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function w($,N,V=0,H=0){const q=N;return q.values&&q.values.length>1?g($,q.values,V,H):_($,N,V,H)}e.scoreFuzzy2=w;function g($,N,V,H){let q=0;const te=[];for(const fe of N){const[ne,le]=_($,fe,V,H);if(typeof ne!="number")return v;q+=ne,te.push(...le)}return[q,l(te)]}function _($,N,V,H){const q=(0,i.fuzzyScore)(N.original,N.originalLowercase,V,$,$.toLowerCase(),H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?[q[0],(0,i.createMatches)(q)]:v}const f=Object.freeze({score:0}),a=1<<18,m=1<<17,o=1<<16;function d($,N,V,H){const q=H.values?H.values:[H];return(0,y.hash)({[H.normalized]:{values:q.map(fe=>({value:fe.normalized,expectContiguousMatch:fe.expectContiguousMatch})),label:$,description:N,allowNonContiguousMatches:V}})}function r($,N,V,H,q){if(!$||!N.normalized)return f;const te=H.getItemLabel($);if(!te)return f;const fe=H.getItemDescription($),ne=d(te,fe,V,N),le=q[ne];if(le)return le;const K=s(te,fe,H.getItemPath($),N,V);return q[ne]=K,K}e.scoreItemFuzzy=r;function s($,N,V,H,q){const te=!V||!H.containsPathSeparator;return V&&(C.isLinux?H.pathNormalized===V:(0,D.equalsIgnoreCase)(H.pathNormalized,V))?{score:a,labelMatch:[{start:0,end:$.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:H.values&&H.values.length>1?n($,N,V,H.values,te,q):t($,N,V,H,te,q)}function n($,N,V,H,q,te){let fe=0;const ne=[],le=[];for(const K of H){const{score:ge,labelMatch:ve,descriptionMatch:se}=t($,N,V,K,q,te);if(ge===b)return f;fe+=ge,ve&&ne.push(...ve),se&&le.push(...se)}return{score:fe,labelMatch:l(ne),descriptionMatch:l(le)}}function t($,N,V,H,q,te){if(q||!N){const[fe,ne]=L($,H.normalized,H.normalizedLowercase,te&&!H.expectContiguousMatch);if(fe){const le=(0,i.matchesPrefix)(H.normalized,$);let K;return le?(K=m,K+=Math.round(H.normalized.length/$.length*100)):K=o,{score:K+fe,labelMatch:le||c(ne)}}}if(N){let fe=N;V&&(fe=`${N}${A.sep}`);const ne=fe.length,le=`${fe}${$}`,[K,ge]=L(le,H.normalized,H.normalizedLowercase,te&&!H.expectContiguousMatch);if(K){const ve=c(ge),se=[],be=[];return ve.forEach(Te=>{Te.start<ne&&Te.end>ne?(se.push({start:0,end:Te.end-ne}),be.push({start:Te.start,end:ne})):Te.start>=ne?se.push({start:Te.start-ne,end:Te.end-ne}):be.push(Te)}),{score:K,labelMatch:se,descriptionMatch:be}}}return f}function c($){const N=[];if(!$)return N;let V;for(const H of $)V&&V.end===H?V.end+=1:(V={start:H,end:H+1},N.push(V));return N}function l($){const N=$.sort((q,te)=>q.start-te.start),V=[];let H;for(const q of N)!H||!h(H,q)?(H=q,V.push(q)):(H.start=Math.min(H.start,q.start),H.end=Math.max(H.end,q.end));return V}function h($,N){return!($.end<N.start||N.end<$.start)}function p($,N,V,H,q,te){const fe=r($,V,H,q,te),ne=r(N,V,H,q,te),le=fe.score,K=ne.score;if((le===a||K===a)&&le!==K)return le===a?-1:1;if(le>o||K>o){if(le!==K)return le>K?-1:1;if(le<m&&K<m){const we=F(fe.labelMatch,ne.labelMatch);if(we!==0)return we}const Te=q.getItemLabel($)||"",pe=q.getItemLabel(N)||"";if(Te.length!==pe.length)return Te.length-pe.length}if(le!==K)return le>K?-1:1;const ge=Array.isArray(fe.labelMatch)&&fe.labelMatch.length>0,ve=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(ge&&!ve)return-1;if(ve&&!ge)return 1;const se=R($,fe,q),be=R(N,ne,q);return se&&be&&se!==be?be>se?-1:1:O($,N,V,q)}e.compareItemsByFuzzyScore=p;function R($,N,V){let H=-1,q=-1;if(N.descriptionMatch&&N.descriptionMatch.length?H=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(H=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(q=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const te=V.getItemDescription($);te&&(q+=te.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(q=N.descriptionMatch[N.descriptionMatch.length-1].end);return q-H}function F($,N){if(!$&&!N||(!$||!$.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!$||!$.length)return 1;const V=$[0].start,q=$[$.length-1].end-V,te=N[0].start,ne=N[N.length-1].end-te;return q===ne?0:ne<q?1:-1}function O($,N,V,H){const q=H.getItemLabel($)||"",te=H.getItemLabel(N)||"",fe=H.getItemDescription($),ne=H.getItemDescription(N),le=q.length+(fe?fe.length:0),K=te.length+(ne?ne.length:0);if(le!==K)return le-K;const ge=H.getItemPath($),ve=H.getItemPath(N);return ge&&ve&&ge.length!==ve.length?ge.length-ve.length:q!==te?(0,u.compareAnything)(q,te,V.normalized):fe&&ne&&fe!==ne?(0,u.compareAnything)(fe,ne,V.normalized):ge&&ve&&ge!==ve?(0,u.compareAnything)(ge,ve,V.normalized):0}function k($){return $.startsWith('"')&&$.endsWith('"')}const U=" ";function B($){typeof $!="string"&&($="");const N=$.toLowerCase(),{pathNormalized:V,normalized:H,normalizedLowercase:q}=z($),te=V.indexOf(A.sep)>=0,fe=k($);let ne;const le=$.split(U);if(le.length>1)for(const K of le){const ge=k(K),{pathNormalized:ve,normalized:se,normalizedLowercase:be}=z(K);se&&(ne||(ne=[]),ne.push({original:K,originalLowercase:K.toLowerCase(),pathNormalized:ve,normalized:se,normalizedLowercase:be,expectContiguousMatch:ge}))}return{original:$,originalLowercase:N,pathNormalized:V,normalized:H,normalizedLowercase:q,values:ne,containsPathSeparator:te,expectContiguousMatch:fe}}e.prepareQuery=B;function z($){let N;C.isWindows?N=$.replace(/\//g,A.sep):N=$.replace(/\\/g,A.sep);const V=(0,D.stripWildcards)(N).replace(/\s|"/g,"");return{pathNormalized:N,normalized:V,normalizedLowercase:V.toLowerCase()}}function Y($){return Array.isArray($)?B($.map(N=>N.original).join(U)):B($.original)}e.pieceToQuery=Y}),define(ke[34],Pe([1,0,16,17,30,25,9,13,8]),function(Q,e,u,i,y,A,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",P="[^/\\\\]",S=/\//g;function I(V,H){switch(V){case 0:return"";case 1:return`${P}*?`;default:return`(?:${L}|${P}+${L}${H?`|${L}${P}+`:""})*?`}}function E(V,H){if(!V)return[];const q=[];let te=!1,fe=!1,ne="";for(const le of V){switch(le){case H:if(!te&&!fe){q.push(ne),ne="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}ne+=le}return ne&&q.push(ne),q}e.splitGlobAware=E;function v(V){if(!V)return"";let H="";const q=E(V,e.GLOB_SPLIT);if(q.every(te=>te===e.GLOBSTAR))H=".*";else{let te=!1;q.forEach((fe,ne)=>{if(fe===e.GLOBSTAR){if(te)return;H+=I(2,ne===q.length-1)}else{let le=!1,K="",ge=!1,ve="";for(const se of fe){if(se!=="}"&&le){K+=se;continue}if(ge&&(se!=="]"||!ve)){let be;se==="-"?be=se:(se==="^"||se==="!")&&!ve?be="^":se===e.GLOB_SPLIT?be="":be=(0,b.escapeRegExpCharacters)(se),ve+=be;continue}switch(se){case"{":le=!0;continue;case"[":ge=!0;continue;case"}":{H+=`(?:${E(K,",").map(pe=>v(pe)).join("|")})`,le=!1,K="";break}case"]":{H+="["+ve+"]",ge=!1,ve="";break}case"?":H+=P;continue;case"*":H+=I(1);continue;default:H+=(0,b.escapeRegExpCharacters)(se)}}ne<q.length-1&&(q[ne+1]!==e.GLOBSTAR||ne+2<q.length)&&(H+=L)}te=fe===e.GLOBSTAR})}return H}const w=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new A.LRUCache(1e4),d=function(){return!1},r=function(){return null};function s(V,H){if(!V)return r;let q;typeof V!="string"?q=V.pattern:q=V,q=q.trim();const te=`${q}_${!!H.trimForExclusions}`;let fe=o.get(te);if(fe)return n(fe,V);let ne;return w.test(q)?fe=c(q.substr(4),q):(ne=g.exec(t(q,H)))?fe=l(ne[1],q):(H.trimForExclusions?f:_).test(q)?fe=h(q,H):(ne=a.exec(t(q,H)))?fe=p(ne[1].substr(1),q,!0):(ne=m.exec(t(q,H)))?fe=p(ne[1],q,!1):fe=R(q),o.set(te,fe),n(fe,V)}function n(V,H){if(typeof H=="string")return V;const q=function(te,fe){return(0,y.isEqualOrParent)(te,H.base,!D.isLinux)?V(te.substr(H.base.length+1),fe):null};return q.allBasenames=V.allBasenames,q.allPaths=V.allPaths,q.basenames=V.basenames,q.patterns=V.patterns,q}function t(V,H){return H.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function c(V,H){return function(q,te){return typeof q=="string"&&q.endsWith(V)?H:null}}function l(V,H){const q=`/${V}`,te=`\\${V}`,fe=function(le,K){return typeof le!="string"?null:K?K===V?H:null:le===V||le.endsWith(q)||le.endsWith(te)?H:null},ne=[V];return fe.basenames=ne,fe.patterns=[H],fe.allBasenames=ne,fe}function h(V,H){const q=$(V.slice(1,-1).split(",").map(K=>s(K,H)).filter(K=>K!==r),V),te=q.length;if(!te)return r;if(te===1)return q[0];const fe=function(K,ge){for(let ve=0,se=q.length;ve<se;ve++)if(q[ve](K,ge))return V;return null},ne=q.find(K=>!!K.allBasenames);ne&&(fe.allBasenames=ne.allBasenames);const le=q.reduce((K,ge)=>ge.allPaths?K.concat(ge.allPaths):K,[]);return le.length&&(fe.allPaths=le),fe}function p(V,H,q){const te=C.sep===C.posix.sep,fe=te?V:V.replace(S,C.sep),ne=C.sep+fe,le=C.posix.sep+V;let K;return q?K=function(ge,ve){return typeof ge=="string"&&(ge===fe||ge.endsWith(ne)||!te&&(ge===V||ge.endsWith(le)))?H:null}:K=function(ge,ve){return typeof ge=="string"&&(ge===fe||!te&&ge===V)?H:null},K.allPaths=[(q?"*/":"./")+V],K}function R(V){try{const H=new RegExp(`^${v(V)}$`);return function(q){return H.lastIndex=0,typeof q=="string"&&H.test(q)?V:null}}catch{return r}}function F(V,H,q){return!V||typeof H!="string"?!1:O(V)(H,void 0,q)}e.match=F;function O(V,H={}){if(!V)return d;if(typeof V=="string"||k(V)){const q=s(V,H);if(q===r)return d;const te=function(fe,ne){return!!q(fe,ne)};return q.allBasenames&&(te.allBasenames=q.allBasenames),q.allPaths&&(te.allPaths=q.allPaths),te}return z(V,H)}e.parse=O;function k(V){const H=V;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=k;function U(V){return V.allBasenames||[]}e.getBasenameTerms=U;function B(V){return V.allPaths||[]}e.getPathTerms=B;function z(V,H){const q=$(Object.getOwnPropertyNames(V).map(K=>Y(K,V[K],H)).filter(K=>K!==r)),te=q.length;if(!te)return r;if(!q.some(K=>!!K.requiresSiblings)){if(te===1)return q[0];const K=function(se,be){let Te;for(let pe=0,we=q.length;pe<we;pe++){const Ae=q[pe](se,be);if(typeof Ae=="string")return Ae;(0,i.isThenable)(Ae)&&(Te||(Te=[]),Te.push(Ae))}return Te?(async()=>{for(const pe of Te){const we=await pe;if(typeof we=="string")return we}return null})():null},ge=q.find(se=>!!se.allBasenames);ge&&(K.allBasenames=ge.allBasenames);const ve=q.reduce((se,be)=>be.allPaths?se.concat(be.allPaths):se,[]);return ve.length&&(K.allPaths=ve),K}const fe=function(K,ge,ve){let se,be;for(let Te=0,pe=q.length;Te<pe;Te++){const we=q[Te];we.requiresSiblings&&ve&&(ge||(ge=(0,C.basename)(K)),se||(se=ge.substr(0,ge.length-(0,C.extname)(K).length)));const Ae=we(K,ge,se,ve);if(typeof Ae=="string")return Ae;(0,i.isThenable)(Ae)&&(be||(be=[]),be.push(Ae))}return be?(async()=>{for(const Te of be){const pe=await Te;if(typeof pe=="string")return pe}return null})():null},ne=q.find(K=>!!K.allBasenames);ne&&(fe.allBasenames=ne.allBasenames);const le=q.reduce((K,ge)=>ge.allPaths?K.concat(ge.allPaths):K,[]);return le.length&&(fe.allPaths=le),fe}function Y(V,H,q){if(H===!1)return r;const te=s(V,q);if(te===r)return r;if(typeof H=="boolean")return te;if(H){const fe=H.when;if(typeof fe=="string"){const ne=(le,K,ge,ve)=>{if(!ve||!te(le,K))return null;const se=fe.replace("$(basename)",ge),be=ve(se);return(0,i.isThenable)(be)?be.then(Te=>Te?V:null):be?V:null};return ne.requiresSiblings=!0,ne}}return te}function $(V,H){const q=V.filter(K=>!!K.basenames);if(q.length<2)return V;const te=q.reduce((K,ge)=>{const ve=ge.basenames;return ve?K.concat(ve):K},[]);let fe;if(H){fe=[];for(let K=0,ge=te.length;K<ge;K++)fe.push(H)}else fe=q.reduce((K,ge)=>{const ve=ge.patterns;return ve?K.concat(ve):K},[]);const ne=function(K,ge){if(typeof K!="string")return null;if(!ge){let se;for(se=K.length;se>0;se--){const be=K.charCodeAt(se-1);if(be===47||be===92)break}ge=K.substr(se)}const ve=te.indexOf(ge);return ve!==-1?fe[ve]:null};ne.basenames=te,ne.patterns=fe,ne.allBasenames=te;const le=V.filter(K=>!K.basenames);return le.push(ne),le}function N(V,H){return(0,u.equals)(V,H,(q,te)=>typeof q=="string"&&typeof te=="string"?q===te:typeof q!="string"&&typeof te!="string"?q.base===te.base&&q.pattern===te.pattern:!1)}e.patternsEquals=N}),define(ke[102],Pe([1,0,11,146,22,8,2]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(v){v[v.Paragraph=0]="Paragraph",v[v.Break=1]="Break"})(D||(e.MarkdownStringTextNewlineStyle=D={}));class b{constructor(w="",g=!1){if(this.value=w,typeof this.value!="string")throw(0,u.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(w,g=0){return this.value+=S(this.supportThemeIcons?(0,i.escapeIcons)(w):w).replace(/([ \t]+)/g,(_,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(w){return this.value+=w,this}appendCodeblock(w,g){return this.value+="\n```",this.value+=w,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(w,g,_){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(w),")"),_&&(this.value+=` "${this._escape(this._escape(_,'"'),")")}"`),this.value+=")",this}_escape(w,g){const _=new RegExp((0,A.escapeRegExpCharacters)(g),"g");return w.replace(_,(f,a)=>w.charAt(a-1)!=="\\"?`\\${f}`:f)}}e.MarkdownString=b;function T(v){return L(v)?!v.value:Array.isArray(v)?v.every(T):!0}e.isEmptyMarkdownString=T;function L(v){return v instanceof b?!0:v&&typeof v=="object"?typeof v.value=="string"&&(typeof v.isTrusted=="boolean"||v.isTrusted===void 0)&&(typeof v.supportThemeIcons=="boolean"||v.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function P(v,w){return v===w?!0:!v||!w?!1:v.value===w.value&&v.isTrusted===w.isTrusted&&v.supportThemeIcons===w.supportThemeIcons&&v.supportHtml===w.supportHtml&&(v.baseUri===w.baseUri||!!v.baseUri&&!!w.baseUri&&(0,y.isEqual)(C.URI.from(v.baseUri),C.URI.from(w.baseUri)))}e.markdownStringEqual=P;function S(v){return v.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function I(v){return v&&v.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=I;function E(v){const w=[],g=v.split("|").map(f=>f.trim());v=g[0];const _=g[1];if(_){const f=/height=(\d+)/.exec(_),a=/width=(\d+)/.exec(_),m=f?f[1]:"",o=a?a[1]:"",d=isFinite(parseInt(o)),r=isFinite(parseInt(m));d&&w.push(`width="${o}"`),r&&w.push(`height="${m}"`)}return{href:v,dimensions:w}}e.parseHrefAndDimensions=E}),define(ke[103],Pe([1,0,16,30,10,9,13,22,8,2]),function(Q,e,u,i,y,A,C,D,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function L(t,c){const{os:l,tildify:h,relative:p}=c;if(p){const O=P(t,p,l);if(typeof O=="string")return O}let R=t.fsPath;if(l===1&&!C.isWindows?R=R.replace(/\//g,"\\"):l!==1&&C.isWindows&&(R=R.replace(/\\/g,"/")),l!==1&&h?.userHome){let O=h.userHome.fsPath,k;t.scheme!==h.userHome.scheme&&t.path.startsWith(A.posix.sep)?k=h.userHome.with({path:t.path}).fsPath:k=t.fsPath,R=v(k,O,l)}return(l===1?A.win32:A.posix).normalize(I(R,l===1))}e.getPathLabel=L;function P(t,c,l){const h=l===1?A.win32:A.posix,p=l===3?D.extUri:D.extUriIgnorePathCase,R=c.getWorkspace(),F=(0,u.firstOrDefault)(R.folders);if(!F)return;t.scheme!==F.uri.scheme&&t.path.startsWith(A.posix.sep)&&(t=F.uri.with({path:t.path}));const O=c.getWorkspaceFolder(t);if(!O)return;let k;if(p.isEqual(O.uri,t)?k="":k=p.relativePath(O.uri,t)??"",k&&(k=h.normalize(k)),R.folders.length>1&&!c.noPrefix){const U=O.name?O.name:p.basenameOrAuthority(O.uri);k=k?`${U} \u2022 ${k}`:U}return k}function S(t){if(!t)return;typeof t=="string"&&(t=T.URI.file(t));const c=(0,D.basename)(t)||(t.scheme===y.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,i.isRootOrDriveLetter)(c)?I(c):c}e.getBaseLabel=S;function I(t,c=C.isWindows){return(0,i.hasDriveLetter)(t,c)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=I;let E=Object.create(null);function v(t,c,l=C.OS){if(l===1||!t||!c)return t;let h=E.original===c?E.normalized:void 0;h||(h=c,C.isWindows&&(h=(0,i.toSlashes)(h)),h=`${(0,b.rtrim)(h,A.posix.sep)}${A.posix.sep}`,E={original:c,normalized:h});let p=t;return C.isWindows&&(p=(0,i.toSlashes)(p)),(l===3?p.startsWith(h):(0,b.startsWithIgnoreCase)(p,h))?`~/${p.substr(h.length)}`:t}e.tildify=v;function w(t,c){return t.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=w;const g="\u2026",_="\\\\",f="~";function a(t,c=A.sep){const l=new Array(t.length);let h=!1;for(let p=0;p<t.length;p++){let R=t[p];if(R===""){l[p]=`.${c}`;continue}if(!R){l[p]=R;continue}h=!0;let F="",O=R;O.indexOf(_)===0?(F=O.substr(0,O.indexOf(_)+_.length),O=O.substr(O.indexOf(_)+_.length)):O.indexOf(c)===0?(F=O.substr(0,O.indexOf(c)+c.length),O=O.substr(O.indexOf(c)+c.length)):O.indexOf(f)===0&&(F=O.substr(0,O.indexOf(f)+f.length),O=O.substr(O.indexOf(f)+f.length));const k=O.split(c);for(let U=1;h&&U<=k.length;U++)for(let B=k.length-U;h&&B>=0;B--){h=!1;let z=k.slice(B,B+U).join(c);for(let Y=0;!h&&Y<t.length;Y++)if(Y!==p&&t[Y]&&t[Y].indexOf(z)>-1){const $=B+U===k.length,N=B>0&&t[Y].indexOf(c)>-1?c+z:z,V=t[Y].endsWith(N);h=!$||V}if(!h){let Y="";(k[0].endsWith(":")||F!=="")&&(B===1&&(B=0,U++,z=k[0]+c+z),B>0&&(Y=k[0]+c),Y=F+Y),B>0&&(Y=Y+g+c),Y=Y+z,B+U<k.length&&(Y=Y+c+g),l[p]=Y}}h&&(l[p]=R)}return l}e.shorten=a;var m;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function o(t,c=Object.create(null)){const l=[];let h=!1,p="";for(const R of t)if(R==="$"||h&&R==="{")p&&l.push({value:p,type:m.TEXT}),p="",h=!0;else if(R==="}"&&h){const F=c[p];if(typeof F=="string")F.length&&l.push({value:F,type:m.VARIABLE});else if(F){const O=l[l.length-1];(!O||O.type!==m.SEPARATOR)&&l.push({value:F.label,type:m.SEPARATOR})}p="",h=!1}else p+=R;return p&&!h&&l.push({value:p,type:m.TEXT}),l.filter((R,F)=>{if(R.type===m.SEPARATOR){const O=l[F-1],k=l[F+1];return[O,k].every(U=>U&&(U.type===m.VARIABLE||U.type===m.TEXT)&&U.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=o;function d(t,c){return C.isMacintosh||c?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=d;function r(t,c){return C.isMacintosh||c?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,l=>l==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=r;function s(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=s;function n(t){const c=t.indexOf("/")!==-1?A.posix:A.win32,l=c.basename(t),h=c.dirname(t);return l.length?{name:l,parentPath:h}:{name:h,parentPath:""}}e.splitName=n}),define(ke[104],Pe([1,0,2]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(L){return L.toJSON()}class y{constructor(P){this._uriTransformer=P}transformIncoming(P){const S=this._uriTransformer.transformIncoming(P);return S===P?P:i(u.URI.from(S))}transformOutgoing(P){const S=this._uriTransformer.transformOutgoing(P);return S===P?P:i(u.URI.from(S))}transformOutgoingURI(P){const S=this._uriTransformer.transformOutgoing(P);return S===P?P:u.URI.from(S)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function A(L,P,S){if(!L||S>200)return null;if(typeof L=="object"){if(L instanceof u.URI)return P.transformOutgoing(L);for(let I in L)if(Object.hasOwnProperty.call(L,I)){const E=A(L[I],P,S+1);E!==null&&(L[I]=E)}}return null}function C(L,P){const S=A(L,P,0);return S===null?L:S}e.transformOutgoingURIs=C;function D(L,P,S,I){if(!L||I>200)return null;if(typeof L=="object"){if(L.$mid===1)return S?u.URI.revive(P.transformIncoming(L)):P.transformIncoming(L);for(let E in L)if(Object.hasOwnProperty.call(L,E)){const v=D(L[E],P,S,I+1);v!==null&&(L[E]=v)}}return null}function b(L,P){const S=D(L,P,!1,0);return S===null?L:S}e.transformIncomingURIs=b;function T(L,P){const S=D(L,P,!0,0);return S===null?L:S}e.transformAndReviveIncomingURIs=T}),define(ke[35],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(y){return u.test(y)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let b=0;b<D.length;b++)D[b]=Math.floor(Math.random()*256);return D};const A=new Uint8Array(16),C=[];for(let D=0;D<256;D++)C.push(D.toString(16).padStart(2,"0"));return function(){y(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let b=0,T="";return T+=C[A[b++]],T+=C[A[b++]],T+=C[A[b++]],T+=C[A[b++]],T+="-",T+=C[A[b++]],T+=C[A[b++]],T+="-",T+=C[A[b++]],T+=C[A[b++]],T+="-",T+=C[A[b++]],T+=C[A[b++]],T+="-",T+=C[A[b++]],T+=C[A[b++]],T+=C[A[b++]],T+=C[A[b++]],T+=C[A[b++]],T+=C[A[b++]],T}}()}),define(ke[147],Pe([1,0,105]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(A="utf8"){this.stringDecoder=new u.StringDecoder(A),this.remaining=null}write(A){const C=[],D=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(D.length<1)return C;let b=0,T,L=b;for(;L<D.length;)if(T=D.charCodeAt(L),T===13||T===10){if(C.push(D.substring(b,L)),L++,L<D.length){const P=T;T=D.charCodeAt(L),(P===13&&T===10||P===10&&T===13)&&L++}b=L}else L++;return this.remaining=b<D.length?D.substr(b):null,C}end(){return this.remaining}}e.LineDecoder=i}),define(ke[29],Pe([1,0,63,64,298,17,30,82,9,13,22,2]),function(Q,e,u,i,y,A,C,D,b,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(S||(e.RimRafMode=S={}));async function I(B,z=S.UNLINK){if((0,C.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return z===S.UNLINK?v(B):E(B)}async function E(B){try{const z=(0,C.randomPath)((0,i.tmpdir)());try{await u.promises.rename(B,z)}catch{return v(B)}v(z).catch(Y=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function v(B){return(0,y.promisify)(u.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function w(B){if((0,C.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function g(B,z){return a(await(z?_(B):(0,y.promisify)(u.readdir)(B)))}async function _(B){try{return await(0,y.promisify)(u.readdir)(B,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const z=[],Y=await g(B);for(const $ of Y){let N=!1,V=!1,H=!1;try{const q=await e.Promises.lstat((0,b.join)(B,$));N=q.isFile(),V=q.isDirectory(),H=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}z.push({name:$,isFile:()=>N,isDirectory:()=>V,isSymbolicLink:()=>H})}return z}function f(B){return a(u.readdirSync(B))}e.readdirSync=f;function a(B){return B.map(z=>typeof z=="string"?T.isMacintosh?(0,D.normalizeNFC)(z):z:(z.name=T.isMacintosh?(0,D.normalizeNFC)(z.name):z.name,z))}async function m(B){const z=await g(B),Y=[];for(const $ of z)await d.existsDirectory((0,b.join)(B,$))&&Y.push($);return Y}function o(B,z=1e3){return new Promise(Y=>{let $=!1;const N=setInterval(()=>{$||($=!0,u.access(B,V=>{$=!1,V&&(clearInterval(N),Y(void 0))}))},z)})}e.whenDeleted=o;var d;(function(B){async function z(N){let V;try{if(V=await e.Promises.lstat(N),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(N),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(T.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw q}throw H}}B.stat=z;async function Y(N){try{const{stat:V,symbolicLink:H}=await B.stat(N);return V.isFile()&&H?.dangling!==!0}catch{}return!1}B.existsFile=Y;async function $(N){try{const{stat:V,symbolicLink:H}=await B.stat(N);return V.isDirectory()&&H?.dangling!==!0}catch{}return!1}B.existsDirectory=$})(d||(e.SymlinkSupport=d={}));const r=new A.ResourceQueue;function s(B,z,Y){return r.queueFor(P.URI.file(B),L.extUriBiasedIgnorePathCase).queue(()=>{const $=l(Y);return new Promise((N,V)=>t(B,z,$,H=>H?V(H):N()))})}let n=!0;function t(B,z,Y,$){if(!n)return u.writeFile(B,z,{mode:Y.mode,flag:Y.flag},$);u.open(B,Y.flag,Y.mode,(N,V)=>{if(N)return $(N);u.writeFile(V,z,H=>{if(H)return u.close(V,()=>$(H));u.fdatasync(V,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),n=!1),u.close(V,te=>$(te))))})})}function c(B,z,Y){const $=l(Y);if(!n)return u.writeFileSync(B,z,{mode:$.mode,flag:$.flag});const N=u.openSync(B,$.flag,$.mode);try{u.writeFileSync(N,z);try{u.fdatasyncSync(N)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),n=!1}}finally{u.closeSync(N)}}e.writeFileSync=c;function l(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function h(B,z){if(B!==z)try{await e.Promises.rename(B,z)}catch(Y){if(B.toLowerCase()!==z.toLowerCase()&&Y.code==="EXDEV"||B.endsWith("."))await p(B,z,{preserveSymlinks:!1}),await I(B,S.MOVE);else throw Y}}async function p(B,z,Y){return F(B,z,{root:{source:B,target:z},options:Y,handledSourcePaths:new Set})}const R=511;async function F(B,z,Y){if(Y.handledSourcePaths.has(B))return;Y.handledSourcePaths.add(B);const{stat:$,symbolicLink:N}=await d.stat(B);if(N){if(Y.options.preserveSymlinks)try{return await U(B,z,Y)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(N.dangling)return}return $.isDirectory()?O(B,z,$.mode&R,Y):k(B,z,$.mode&R)}async function O(B,z,Y,$){await e.Promises.mkdir(z,{recursive:!0,mode:Y});const N=await g(B);for(const V of N)await F((0,b.join)(B,V),(0,b.join)(z,V),$)}async function k(B,z,Y){await e.Promises.copyFile(B,z),await e.Promises.chmod(z,Y)}async function U(B,z,Y){let $=await e.Promises.readlink(B);(0,C.isEqualOrParent)($,Y.root.source,!T.isLinux)&&($=(0,b.join)(Y.root.target,$.substr(Y.root.source.length+1))),await e.Promises.symlink($,z)}e.Promises=new class{get access(){return(0,y.promisify)(u.access)}get stat(){return(0,y.promisify)(u.stat)}get lstat(){return(0,y.promisify)(u.lstat)}get utimes(){return(0,y.promisify)(u.utimes)}get read(){return(B,z,Y,$,N)=>new Promise((V,H)=>{u.read(B,z,Y,$,N,(q,te,fe)=>q?H(q):V({bytesRead:te,buffer:fe}))})}get readFile(){return(0,y.promisify)(u.readFile)}get write(){return(B,z,Y,$,N)=>new Promise((V,H)=>{u.write(B,z,Y,$,N,(q,te,fe)=>q?H(q):V({bytesWritten:te,buffer:fe}))})}get appendFile(){return(0,y.promisify)(u.appendFile)}get fdatasync(){return(0,y.promisify)(u.fdatasync)}get truncate(){return(0,y.promisify)(u.truncate)}get rename(){return(0,y.promisify)(u.rename)}get copyFile(){return(0,y.promisify)(u.copyFile)}get open(){return(0,y.promisify)(u.open)}get close(){return(0,y.promisify)(u.close)}get symlink(){return(0,y.promisify)(u.symlink)}get readlink(){return(0,y.promisify)(u.readlink)}get chmod(){return(0,y.promisify)(u.chmod)}get mkdir(){return(0,y.promisify)(u.mkdir)}get unlink(){return(0,y.promisify)(u.unlink)}get rmdir(){return(0,y.promisify)(u.rmdir)}get realpath(){return(0,y.promisify)(u.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return m}get writeFile(){return s}get rm(){return I}get move(){return h}get copy(){return p}}}),define(ke[106],Pe([1,0,63,9,13,8,29]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(S){if(y.isLinux)return S;const I=(0,i.dirname)(S);if(S===I)return S;const E=((0,i.basename)(S)||S).toLowerCase();try{const w=(0,C.readdirSync)(I).filter(g=>g.toLowerCase()===E);if(w.length===1){const g=D(I);if(g)return(0,i.join)(g,w[0])}else if(w.length>1){const g=w.indexOf(E);if(g>=0){const _=D(I);if(_)return(0,i.join)(_,w[g])}}}catch{}return null}e.realcaseSync=D;async function b(S){if(y.isLinux)return S;const I=(0,i.dirname)(S);if(S===I)return S;const E=((0,i.basename)(S)||S).toLowerCase();try{const w=(await C.Promises.readdir(I)).filter(g=>g.toLowerCase()===E);if(w.length===1){const g=await b(I);if(g)return(0,i.join)(g,w[0])}else if(w.length>1){const g=w.indexOf(E);if(g>=0){const _=await b(I);if(_)return(0,i.join)(_,w[g])}}}catch{}return null}e.realcase=b;async function T(S){try{return await C.Promises.realpath(S)}catch{const E=P(S);return await C.Promises.access(E,u.constants.R_OK),E}}e.realpath=T;function L(S){try{return u.realpathSync(S)}catch{const E=P(S);return u.accessSync(E,u.constants.R_OK),E}}e.realpathSync=L;function P(S){return(0,A.rtrim)((0,i.normalize)(S),i.sep)}});var je=this&&this.__decorate||function(Q,e,u,i){var y=arguments.length,A=y<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,u):i,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Q,e,u,i);else for(var D=Q.length-1;D>=0;D--)(C=Q[D])&&(A=(y<3?C(A):y>3?C(e,u,A):C(e,u))||A);return y>3&&A&&Object.defineProperty(e,u,A),A};define(ke[107],Pe([1,0,16,17,23,21,58,11,3,6,62,8,12]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var I;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(I||(e.RequestType=I={}));function E(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(v||(e.ResponseType=v={}));function w(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(g||(g={}));class _{constructor(H){this.buffer=H,this.pos=0}read(H){const q=this.buffer.slice(this.pos,this.pos+H);return this.pos+=q.byteLength,q}}class f{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(H){this.buffers.push(H)}}var a;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(a||(a={}));function m(V){const H=y.VSBuffer.alloc(4);return H.writeUInt32BE(V,0),H}function o(V){return V.read(4).readUInt32BE(0)}function d(V){const H=y.VSBuffer.alloc(1);return H.writeUInt8(V,0),H}const r={Undefined:d(a.Undefined),String:d(a.String),Buffer:d(a.Buffer),VSBuffer:d(a.VSBuffer),Array:d(a.Array),Object:d(a.Object)},s=typeof Buffer!="undefined";function n(V,H){if(typeof H=="undefined")V.write(r.Undefined);else if(typeof H=="string"){const q=y.VSBuffer.fromString(H);V.write(r.String),V.write(m(q.byteLength)),V.write(q)}else if(s&&Buffer.isBuffer(H)){const q=y.VSBuffer.wrap(H);V.write(r.Buffer),V.write(m(q.byteLength)),V.write(q)}else if(H instanceof y.VSBuffer)V.write(r.VSBuffer),V.write(m(H.byteLength)),V.write(H);else if(Array.isArray(H)){V.write(r.Array),V.write(m(H.length));for(const q of H)n(V,q)}else{const q=y.VSBuffer.fromString(JSON.stringify(H));V.write(r.Object),V.write(m(q.byteLength)),V.write(q)}}function t(V){switch(V.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return V.read(o(V)).toString();case a.Buffer:return V.read(o(V)).buffer;case a.VSBuffer:return V.read(o(V));case a.Array:{const q=o(V),te=[];for(let fe=0;fe<q;fe++)te.push(t(V));return te}case a.Object:return JSON.parse(V.read(o(V)).toString())}}class c{constructor(H,q,te=null,fe=1e3){this.protocol=H,this.ctx=q,this.logger=te,this.timeoutDelay=fe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ne=>this.onRawMessage(ne)),this.sendResponse({type:200})}registerChannel(H,q){this.channels.set(H,q),setTimeout(()=>this.flushPendingRequests(H),0)}sendResponse(H){switch(H.type){case 200:{const q=this.send([H.type]);this.logger?.logOutgoing(q,0,1,w(H.type));return}case 201:case 202:case 204:case 203:{const q=this.send([H.type,H.id],H.data);this.logger?.logOutgoing(q,H.id,1,w(H.type),H.data);return}}}send(H,q=void 0){const te=new f;return n(te,H),n(te,q),this.sendBuffer(te.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onRawMessage(H){const q=new _(H),te=t(q),fe=t(q),ne=te[0];switch(ne){case 100:return this.logger?.logIncoming(H.byteLength,te[1],1,`${E(ne)}: ${te[2]}.${te[3]}`,fe),this.onPromise({type:ne,id:te[1],channelName:te[2],name:te[3],arg:fe});case 102:return this.logger?.logIncoming(H.byteLength,te[1],1,`${E(ne)}: ${te[2]}.${te[3]}`,fe),this.onEventListen({type:ne,id:te[1],channelName:te[2],name:te[3],arg:fe});case 101:return this.logger?.logIncoming(H.byteLength,te[1],1,`${E(ne)}`),this.disposeActiveRequest({type:ne,id:te[1]});case 103:return this.logger?.logIncoming(H.byteLength,te[1],1,`${E(ne)}`),this.disposeActiveRequest({type:ne,id:te[1]})}}onPromise(H){const q=this.channels.get(H.channelName);if(!q){this.collectPendingRequest(H);return}const te=new A.CancellationTokenSource;let fe;try{fe=q.call(this.ctx,H.name,H.arg,te.token)}catch(K){fe=Promise.reject(K)}const ne=H.id;fe.then(K=>{this.sendResponse({id:ne,data:K,type:201}),this.activeRequests.delete(H.id)},K=>{K instanceof Error?this.sendResponse({id:ne,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:ne,data:K,type:203}),this.activeRequests.delete(H.id)});const le=(0,T.toDisposable)(()=>te.cancel());this.activeRequests.set(H.id,le)}onEventListen(H){const q=this.channels.get(H.channelName);if(!q){this.collectPendingRequest(H);return}const te=H.id,ne=q.listen(this.ctx,H.name,H.arg)(le=>this.sendResponse({id:te,data:le,type:204}));this.activeRequests.set(H.id,ne)}disposeActiveRequest(H){const q=this.activeRequests.get(H.id);q&&(q.dispose(),this.activeRequests.delete(H.id))}collectPendingRequest(H){let q=this.pendingRequests.get(H.channelName);q||(q=[],this.pendingRequests.set(H.channelName,q));const te=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.sendResponse({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:H,timeoutTimer:te})}flushPendingRequests(H){const q=this.pendingRequests.get(H);if(q){for(const te of q)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete(H)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,T.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var l;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(l||(e.RequestInitiator=l={}));class h{constructor(H,q=null){this.protocol=H,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=q}getChannel(H){const q=this;return{call(te,fe,ne){return q.isDisposed?Promise.reject(D.canceled()):q.requestPromise(H,te,fe,ne)},listen(te,fe){return q.isDisposed?b.Event.None:q.requestEvent(H,te,fe)}}}requestPromise(H,q,te,fe=A.CancellationToken.None){const ne=this.lastRequestId++,K={id:ne,type:100,channelName:H,name:q,arg:te};if(fe.isCancellationRequested)return Promise.reject(D.canceled());let ge;return new Promise((se,be)=>{if(fe.isCancellationRequested)return be(D.canceled());const Te=()=>{const ce=me=>{switch(me.type){case 201:this.handlers.delete(ne),se(me.data);break;case 202:{this.handlers.delete(ne);const ie=new Error(me.data.message);ie.stack=me.data.stack,ie.name=me.data.name,be(ie);break}case 203:this.handlers.delete(ne),be(me.data);break}};this.handlers.set(ne,ce),this.sendRequest(K)};let pe=null;this.state===g.Idle?Te():(pe=(0,i.createCancelablePromise)(ce=>this.whenInitialized()),pe.then(()=>{pe=null,Te()}));const we=()=>{pe?(pe.cancel(),pe=null):this.sendRequest({id:ne,type:101}),be(D.canceled())},Ae=fe.onCancellationRequested(we);ge=(0,T.combinedDisposable)((0,T.toDisposable)(we),Ae),this.activeRequests.add(ge)}).finally(()=>{this.activeRequests.delete(ge)})}requestEvent(H,q,te){const fe=this.lastRequestId++,le={id:fe,type:102,channelName:H,name:q,arg:te};let K=null;const ge=new b.Emitter({onFirstListenerAdd:()=>{K=(0,i.createCancelablePromise)(se=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(ge),this.sendRequest(le)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(ge),this.sendRequest({id:fe,type:103}))}}),ve=se=>ge.fire(se.data);return this.handlers.set(fe,ve),ge.event}sendRequest(H){switch(H.type){case 100:case 102:{const q=this.send([H.type,H.id,H.channelName,H.name],H.arg);this.logger&&this.logger.logOutgoing(q,H.id,0,`${E(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const q=this.send([H.type,H.id]);this.logger&&this.logger.logOutgoing(q,H.id,0,E(H.type));return}}}send(H,q=void 0){const te=new f;return n(te,H),n(te,q),this.sendBuffer(te.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onBuffer(H){const q=new _(H),te=t(q),fe=t(q),ne=te[0];switch(ne){case 200:return this.logger&&this.logger.logIncoming(H.byteLength,0,0,w(ne)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(H.byteLength,te[1],0,w(ne),fe),this.onResponse({type:te[0],id:te[1],data:fe})}}onResponse(H){if(H.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(H.id);q&&q(H)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,T.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=h,je([C.memoize],h.prototype,"onDidInitializePromise",null);class p{get connections(){const H=[];return this._connections.forEach(q=>H.push(q)),H}constructor(H){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,H(({protocol:q,onDidClientDisconnect:te})=>{b.Event.once(q.onMessage)(ne=>{const le=new _(ne),K=t(le),ge=new c(q,K),ve=new h(q);this.channels.forEach((be,Te)=>ge.registerChannel(Te,be));const se={channelServer:ge,channelClient:ve,ctx:K};this._connections.add(se),this._onDidAddConnection.fire(se),te(()=>{ge.dispose(),ve.dispose(),this._connections.delete(se),this._onDidRemoveConnection.fire(se)})})})}getChannel(H,q){const te=this;return{call(fe,ne,le){let K;if((0,S.isFunction)(q)){let ve=(0,u.getRandomElement)(te.connections.filter(q));K=ve?Promise.resolve(ve):b.Event.toPromise(b.Event.filter(te.onDidAddConnection,q))}else K=q.routeCall(te,fe,ne);const ge=K.then(ve=>ve.channelClient.getChannel(H));return F(ge).call(fe,ne,le)},listen(fe,ne){if((0,S.isFunction)(q))return te.getMulticastEvent(H,q,fe,ne);const le=q.routeEvent(te,fe,ne).then(K=>K.channelClient.getChannel(H));return F(le).listen(fe,ne)}}}getMulticastEvent(H,q,te,fe){const ne=this;let le=new T.DisposableStore;const K=new b.Emitter({onFirstListenerAdd:()=>{le=new T.DisposableStore;const ge=new b.EventMultiplexer,ve=new Map,se=Te=>{const we=Te.channelClient.getChannel(H).listen(te,fe),Ae=ge.add(we);ve.set(Te,Ae)},be=Te=>{const pe=ve.get(Te);!pe||(pe.dispose(),ve.delete(Te))};ne.connections.filter(q).forEach(se),b.Event.filter(ne.onDidAddConnection,q)(se,void 0,le),ne.onDidRemoveConnection(be,void 0,le),ge.event(K.fire,K,le),le.add(ge)},onLastListenerRemove:()=>{le.dispose()}});return K.event}registerChannel(H,q){this.channels.set(H,q),this._connections.forEach(te=>{te.channelServer.registerChannel(H,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=p;class R{constructor(H,q,te=null){const fe=new f;n(fe,q),H.send(fe.buffer),this.channelClient=new h(H,te),this.channelServer=new c(H,q,te)}getChannel(H){return this.channelClient.getChannel(H)}registerChannel(H,q){this.channelServer.registerChannel(H,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function F(V){return{call(H,q,te){return V.then(fe=>fe.call(H,q,te))},listen(H,q){const te=new b.Relay;return V.then(fe=>te.input=fe.listen(H,q)),te.event}}}e.getDelayedChannel=F;function O(V){let H=!1;return{call(q,te,fe){return H?V.call(q,te,fe):(0,i.timeout)(0).then(()=>H=!0).then(()=>V.call(q,te,fe))},listen(q,te){if(H)return V.listen(q,te);const fe=new b.Relay;return(0,i.timeout)(0).then(()=>H=!0).then(()=>fe.input=V.listen(q,te)),fe.event}}}e.getNextTickChannel=O;class k{constructor(H){this.fn=H}routeCall(H){return this.route(H)}routeEvent(H){return this.route(H)}async route(H){for(const q of H.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await b.Event.toPromise(H.onDidAddConnection),await this.route(H)}}e.StaticRouter=k;var U;(function(V){function H(ne,le){const K=ne,ge=le&&le.disableMarshalling,ve=new Map;for(const se in K)te(se)&&ve.set(se,b.Event.buffer(K[se],!0));return new class{listen(se,be,Te){const pe=ve.get(be);if(pe)return pe;if(fe(be)){const we=K[be];if(typeof we=="function")return we.call(K,Te)}throw new Error(`Event not found: ${be}`)}call(se,be,Te){const pe=K[be];if(typeof pe=="function"){if(!ge&&Array.isArray(Te))for(let we=0;we<Te.length;we++)Te[we]=(0,L.revive)(Te[we]);return pe.apply(K,Te)}throw new Error(`Method not found: ${be}`)}}}V.fromService=H;function q(ne,le){const K=le&&le.disableMarshalling;return new Proxy({},{get(ge,ve){if(typeof ve=="string")return le?.properties?.has(ve)?le.properties.get(ve):fe(ve)?function(se){return ne.listen(ve,se)}:te(ve)?ne.listen(ve):async function(...se){let be;le&&!(0,S.isUndefinedOrNull)(le.context)?be=[le.context,...se]:be=se;const Te=await ne.call(ve,be);return K?Te:(0,L.revive)(Te)};throw new Error(`Property not found: ${String(ve)}`)}})}V.toService=q;function te(ne){return ne[0]==="o"&&ne[1]==="n"&&P.isUpperAsciiLetter(ne.charCodeAt(2))}function fe(ne){return/^onDynamic/.test(ne)&&P.isUpperAsciiLetter(ne.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let H=V.toString();if(H!=="[object Object]")return H}return V}function Y(V){return Array.isArray(V)?V.map(z):z(V)}function $(V,H,q,te,fe,ne,le){le=Y(le);const K=B[fe],ge=K[te%K.length];let ve=[`%c[${V}]%c[${String(H).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${ge}`];/\($/.test(ne)?(ve=ve.concat(le),ve.push(")")):ve.push(le),console.log.apply(console,ve)}e.logWithColors=$;class N{constructor(H,q){this._outgoingPrefix=H,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(H,q,te,fe,ne){this._totalOutgoing+=H,$(this._outgoingPrefix,this._totalOutgoing,H,q,te,fe,ne)}logIncoming(H,q,te,fe,ne){this._totalIncoming+=H,$(this._incomingPrefix,this._totalIncoming,H,q,te,fe,ne)}}e.IPCLogger=N}),define(ke[108],Pe([1,0,23,3,6,107]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var D;(function(s){s.enableDiagnostics=!1,s.records=[];const n=new WeakMap;let t=0;function c(h,p){if(!n.has(h)){const R=String(++t);n.set(h,R)}return n.get(h)}function l(h,p,R,F){if(!s.enableDiagnostics)return;const O=c(h,p);if(F instanceof u.VSBuffer||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const k=u.VSBuffer.alloc(F.byteLength);k.set(F),s.records.push({timestamp:Date.now(),id:O,label:p,type:R,buff:k})}else s.records.push({timestamp:Date.now(),id:O,label:p,type:R,data:F})}s.traceSocketEvent=l})(D||(e.SocketDiagnostics=D={}));var b;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let T=null;function L(){return T||(T=u.VSBuffer.alloc(0)),T}class P{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,t){if(n===0)return L();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const p=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=n),p}if(this._chunks[0].byteLength>n){const p=this._chunks[0].slice(0,n);return t&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),p}let c=u.VSBuffer.alloc(n),l=0,h=0;for(;n>0;){const p=this._chunks[h];if(p.byteLength>n){const R=p.slice(0,n);c.set(R,l),l+=n,t&&(this._chunks[h]=p.slice(n),this._totalLength-=n),n-=n}else c.set(p,l),l+=p.byteLength,t?(this._chunks.shift(),this._totalLength-=p.byteLength):h++,n-=p.byteLength}return c}}e.ChunkStream=P;var S;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume"})(S||(S={}));function I(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var E;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E||(e.ProtocolConstants=E={}));class v{constructor(n,t,c,l){this.type=n,this.id=t,this.ack=c,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends y.Disposable{constructor(n){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(t=>this.acceptChunk(t))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const t=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=t.readUInt32BE(9),this._state.messageType=t.readUInt8(0),this._state.id=t.readUInt32BE(1),this._state.ack=t.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:I(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,l=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",t),this._onMessage.fire(new v(c,l,h,t)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=u.VSBuffer.alloc(13);t.writeUInt8(n.type,0),t.writeUInt32BE(n.id,1),t.writeUInt32BE(n.ack,5),t.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:I(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(t,n.data)}_bufferAdd(n,t){const c=this._totalLength===0;return this._data.push(n,t),this._totalLength+=n.byteLength+t.byteLength,c}_bufferTake(){const n=u.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,t){this._bufferAdd(n,t)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class _ extends y.Disposable{constructor(n){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(t=>{t.type===1&&this._onMessage.fire(t.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new v(1,0,0,n))}}e.Protocol=_;class f extends A.IPCClient{static fromSocket(n,t){return new f(new _(n),t)}get onDidDispose(){return this.protocol.onDidDispose}constructor(n,t,c=null){super(n,t,c);this.protocol=n}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=f;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class m{constructor(n){this.data=n,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],t=0,c=this._first;for(;c;)n[t++]=c.data,c=c.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const t=new m(n);if(!this._first){this._first=t,this._last=t;return}this._last.next=t,this._last=t}}class d{static getInstance(){return d._INSTANCE||(d._INSTANCE=new d),d._INSTANCE}constructor(){this.lastRuns=[];const n=Date.now();for(let t=0;t<d._HISTORY_LENGTH;t++)this.lastRuns[t]=n-1e3*t;setInterval(()=>{for(let t=d._HISTORY_LENGTH;t>=1;t--)this.lastRuns[t]=this.lastRuns[t-1];this.lastRuns[0]=Date.now()},1e3)}load(){const n=Date.now(),t=(1+d._HISTORY_LENGTH)*1e3;let c=0;for(let l=0;l<d._HISTORY_LENGTH;l++)n-this.lastRuns[l]<=t&&c++;return 1-c/d._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}d._HISTORY_LENGTH=10,d._INSTANCE=null;class r{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(n,t=null,c=d.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=n,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),t&&this._socketReader.acceptChunk(t)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,y.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new v(5,0,0,L());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new v(7,0,0,L());this._socketWriter.write(n)}sendResume(){const n=new v(8,0,0,L());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,t){this._isReconnecting=!0,this._socketDisposables=(0,y.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new v(3,0,this._incomingAckId,L());this._socketWriter.write(n);const t=this._outgoingUnackMsg.toArray();for(let c=0,l=t.length;c<l;c++)this._socketWriter.write(t[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const t=this._outgoingUnackMsg.peek();if(t&&t.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const t=Date.now();t-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=t,this._socketWriter.write(new v(6,0,0,L())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const t=this._outgoingUnackMsg.toArray();for(let c=0,l=t.length;c<l;c++)this._socketWriter.write(t[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new v(1,t,this._incomingAckId,n);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(n){const t=new v(2,0,0,n);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),t=Date.now()-n.writtenTime,c=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(t>=2e4&&c>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const h=Math.max(2e4-t,2e4-c,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new v(3,0,this._incomingAckId,L());this._socketWriter.write(n)}}e.PersistentProtocol=r}),define(ke[109],Pe([1,0,99]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class i{constructor(D){const b=(0,u.toUint8)(D);this._defaultValue=b,this._asciiMap=i._createAsciiMap(b),this._map=new Map}static _createAsciiMap(D){const b=new Uint8Array(256);for(let T=0;T<256;T++)b[T]=D;return b}set(D,b){const T=(0,u.toUint8)(b);D>=0&&D<256?this._asciiMap[D]=T:this._map.set(D,T)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=i;var y;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(y||(y={}));class A{constructor(){this._actual=new i(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=A}),define(ke[50],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class u{constructor(y,A){this.lineNumber=y,this.column=A}with(y=this.lineNumber,A=this.column){return y===this.lineNumber&&A===this.column?this:new u(y,A)}delta(y=0,A=0){return this.with(this.lineNumber+y,this.column+A)}equals(y){return u.equals(this,y)}static equals(y,A){return!y&&!A?!0:!!y&&!!A&&y.lineNumber===A.lineNumber&&y.column===A.column}isBefore(y){return u.isBefore(this,y)}static isBefore(y,A){return y.lineNumber<A.lineNumber?!0:A.lineNumber<y.lineNumber?!1:y.column<A.column}isBeforeOrEqual(y){return u.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,A){return y.lineNumber<A.lineNumber?!0:A.lineNumber<y.lineNumber?!1:y.column<=A.column}static compare(y,A){const C=y.lineNumber|0,D=A.lineNumber|0;if(C===D){const b=y.column|0,T=A.column|0;return b-T}return C-D}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new u(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}}e.Position=u}),define(ke[36],Pe([1,0,50]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class i{constructor(A,C,D,b){A>D||A===D&&C>b?(this.startLineNumber=D,this.startColumn=b,this.endLineNumber=A,this.endColumn=C):(this.startLineNumber=A,this.startColumn=C,this.endLineNumber=D,this.endColumn=b)}isEmpty(){return i.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return i.containsPosition(this,A)}static containsPosition(A,C){return!(C.lineNumber<A.startLineNumber||C.lineNumber>A.endLineNumber||C.lineNumber===A.startLineNumber&&C.column<A.startColumn||C.lineNumber===A.endLineNumber&&C.column>A.endColumn)}static strictContainsPosition(A,C){return!(C.lineNumber<A.startLineNumber||C.lineNumber>A.endLineNumber||C.lineNumber===A.startLineNumber&&C.column<=A.startColumn||C.lineNumber===A.endLineNumber&&C.column>=A.endColumn)}containsRange(A){return i.containsRange(this,A)}static containsRange(A,C){return!(C.startLineNumber<A.startLineNumber||C.endLineNumber<A.startLineNumber||C.startLineNumber>A.endLineNumber||C.endLineNumber>A.endLineNumber||C.startLineNumber===A.startLineNumber&&C.startColumn<A.startColumn||C.endLineNumber===A.endLineNumber&&C.endColumn>A.endColumn)}strictContainsRange(A){return i.strictContainsRange(this,A)}static strictContainsRange(A,C){return!(C.startLineNumber<A.startLineNumber||C.endLineNumber<A.startLineNumber||C.startLineNumber>A.endLineNumber||C.endLineNumber>A.endLineNumber||C.startLineNumber===A.startLineNumber&&C.startColumn<=A.startColumn||C.endLineNumber===A.endLineNumber&&C.endColumn>=A.endColumn)}plusRange(A){return i.plusRange(this,A)}static plusRange(A,C){let D,b,T,L;return C.startLineNumber<A.startLineNumber?(D=C.startLineNumber,b=C.startColumn):C.startLineNumber===A.startLineNumber?(D=C.startLineNumber,b=Math.min(C.startColumn,A.startColumn)):(D=A.startLineNumber,b=A.startColumn),C.endLineNumber>A.endLineNumber?(T=C.endLineNumber,L=C.endColumn):C.endLineNumber===A.endLineNumber?(T=C.endLineNumber,L=Math.max(C.endColumn,A.endColumn)):(T=A.endLineNumber,L=A.endColumn),new i(D,b,T,L)}intersectRanges(A){return i.intersectRanges(this,A)}static intersectRanges(A,C){let D=A.startLineNumber,b=A.startColumn,T=A.endLineNumber,L=A.endColumn,P=C.startLineNumber,S=C.startColumn,I=C.endLineNumber,E=C.endColumn;return D<P?(D=P,b=S):D===P&&(b=Math.max(b,S)),T>I?(T=I,L=E):T===I&&(L=Math.min(L,E)),D>T||D===T&&b>L?null:new i(D,b,T,L)}equalsRange(A){return i.equalsRange(this,A)}static equalsRange(A,C){return!!A&&!!C&&A.startLineNumber===C.startLineNumber&&A.startColumn===C.startColumn&&A.endLineNumber===C.endLineNumber&&A.endColumn===C.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(A){return new u.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(A){return new u.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,C){return new i(this.startLineNumber,this.startColumn,A,C)}setStartPosition(A,C){return new i(A,C,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(A){return new i(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,C=A){return new i(A.lineNumber,A.column,C.lineNumber,C.column)}static lift(A){return A?new i(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,C){return!(A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<C.startColumn||C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<A.startColumn)}static areIntersecting(A,C){return!(A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<=C.startColumn||C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,C){if(A&&C){const T=A.startLineNumber|0,L=C.startLineNumber|0;if(T===L){const P=A.startColumn|0,S=C.startColumn|0;if(P===S){const I=A.endLineNumber|0,E=C.endLineNumber|0;if(I===E){const v=A.endColumn|0,w=C.endColumn|0;return v-w}return I-E}return P-S}return T-L}return(A?1:0)-(C?1:0)}static compareRangesUsingEnds(A,C){return A.endLineNumber===C.endLineNumber?A.endColumn===C.endColumn?A.startLineNumber===C.startLineNumber?A.startColumn-C.startColumn:A.startLineNumber-C.startLineNumber:A.endColumn-C.endColumn:A.endLineNumber-C.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=i}),define(ke[148],Pe([1,0,50,36]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var y;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(y||(e.SelectionDirection=y={}));class A extends i.Range{constructor(D,b,T,L){super(D,b,T,L);this.selectionStartLineNumber=D,this.selectionStartColumn=b,this.positionLineNumber=T,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return A.selectionsEqual(this,D)}static selectionsEqual(D,b){return D.selectionStartLineNumber===b.selectionStartLineNumber&&D.selectionStartColumn===b.selectionStartColumn&&D.positionLineNumber===b.positionLineNumber&&D.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,b){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,D,b):new A(D,b,this.startLineNumber,this.startColumn)}getPosition(){return new u.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(D,b){return this.getDirection()===0?new A(D,b,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,D,b)}static fromPositions(D,b=D){return new A(D.lineNumber,D.column,b.lineNumber,b.column)}static fromRange(D,b){return b===0?new A(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):new A(D.endLineNumber,D.endColumn,D.startLineNumber,D.startColumn)}static liftSelection(D){return new A(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,b){if(D&&!b||!D&&b)return!1;if(!D&&!b)return!0;if(D.length!==b.length)return!1;for(let T=0,L=D.length;T<L;T++)if(!this.selectionsEqual(D[T],b[T]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,b,T,L,P){return P===0?new A(D,b,T,L):new A(T,L,D,b)}}e.Selection=A}),define(ke[149],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[150],Pe([1,0,109]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var i;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(i||(e.WordCharacterClass=i={}));class y extends u.CharacterClassifier{constructor(D){super(0);for(let b=0,T=D.length;b<T;b++)this.set(D.charCodeAt(b),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=y;function A(C){const D={};return b=>(D.hasOwnProperty(b)||(D[b]=C(b)),D[b])}e.getMapForWordSeparators=A(C=>new y(C))}),define(ke[110],Pe([1,0,60,6,81]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(P=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)P.indexOf(I)>=0||(S+="\\"+I);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=A();function C(P){let S=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)S=P;else{let I="g";P.ignoreCase&&(I+="i"),P.multiline&&(I+="m"),P.unicode&&(I+="u"),S=new RegExp(P.source,I)}return S.lastIndex=0,S}e.ensureValidWordDefinition=C;const D=new y.LinkedList;D.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(P){const S=D.unshift(P);return(0,i.toDisposable)(S)}e.setDefaultGetWordAtTextConfig=b;function T(P,S,I,E,v){if(v||(v=u.Iterable.first(D)),I.length>v.maxLen){let a=P-v.maxLen/2;return a<0?a=0:E+=a,I=I.substring(a,P+v.maxLen/2),T(P,S,I,E,v)}const w=Date.now(),g=P-1-E;let _=-1,f=null;for(let a=1;!(Date.now()-w>=v.timeBudget);a++){const m=g-v.windowSize*a;S.lastIndex=Math.max(0,m);const o=L(S,I,g,_);if(!o&&f||(f=o,m<=0))break;_=m}if(f){const a={word:f[0],startColumn:E+1+f.index,endColumn:E+1+f.index+f[0].length};return S.lastIndex=0,a}return null}e.getWordAtText=T;function L(P,S,I,E){let v;for(;v=P.exec(S);){const w=v.index||0;if(w<=I&&P.lastIndex>=I)return v;if(E>0&&w>E)return null}return null}}),define(ke[151],Pe([1,0,34,9]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(A,C,D,b,T,L){if(Array.isArray(A)){let P=0;for(const S of A){const I=y(S,C,D,b,T,L);if(I===10)return I;I>P&&(P=I)}return P}else{if(typeof A=="string")return b?A==="*"?5:A===D?10:0:0;if(A){const{language:P,pattern:S,scheme:I,hasAccessToAllModels:E,notebookType:v}=A;if(!b&&!E)return 0;v&&T&&(C=T);let w=0;if(I)if(I===C.scheme)w=10;else if(I==="*")w=5;else return 0;if(P)if(P===D)w=10;else if(P==="*")w=Math.max(w,5);else return 0;if(v)if(v===L)w=10;else if(v==="*"&&L!==void 0)w=Math.max(w,5);else return 0;if(S){let g;if(typeof S=="string"?g=S:g={...S,base:(0,i.normalize)(S.base)},g===C.fsPath||(0,u.match)(g,C.fsPath))w=10;else return 0}return w}else return 0}}e.score=y}),define(ke[152],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var u;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(u||(e.IndentAction=u={}));class i{constructor(D){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=D.open,this.close=D.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(D.notIn))for(let b=0,T=D.notIn.length;b<T;b++)switch(D.notIn[b]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(D){switch(D){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(D,b){if(D.getTokenCount()===0)return!0;const T=D.findTokenIndexAtOffset(b-2),L=D.getStandardTokenType(T);return this.isOK(L)}_findNeutralCharacterInRange(D,b){for(let T=D;T<=b;T++){const L=String.fromCharCode(T);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=i;class y{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of D)A(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),A(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),A(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),A(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&A(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.AutoClosingPairs=y;function A(C,D,b){C.has(D)?C.get(D).push(b):C.set(D,[b])}}),define(ke[153],Pe([1,0,109]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var i;(function(I){I[I.Invalid=0]="Invalid",I[I.Start=1]="Start",I[I.H=2]="H",I[I.HT=3]="HT",I[I.HTT=4]="HTT",I[I.HTTP=5]="HTTP",I[I.F=6]="F",I[I.FI=7]="FI",I[I.FIL=8]="FIL",I[I.BeforeColon=9]="BeforeColon",I[I.AfterColon=10]="AfterColon",I[I.AlmostThere=11]="AlmostThere",I[I.End=12]="End",I[I.Accept=13]="Accept",I[I.LastKnownState=14]="LastKnownState"})(i||(e.State=i={}));class y{constructor(E,v,w){const g=new Uint8Array(E*v);for(let _=0,f=E*v;_<f;_++)g[_]=w;this._data=g,this.rows=E,this.cols=v}get(E,v){return this._data[E*this.cols+v]}set(E,v,w){this._data[E*this.cols+v]=w}}e.Uint8Matrix=y;class A{constructor(E){let v=0,w=0;for(let _=0,f=E.length;_<f;_++){const[a,m,o]=E[_];m>v&&(v=m),a>w&&(w=a),o>w&&(w=o)}v++,w++;const g=new y(w,v,0);for(let _=0,f=E.length;_<f;_++){const[a,m,o]=E[_];g.set(a,m,o)}this._states=g,this._maxCharCode=v}nextState(E,v){return v<0||v>=this._maxCharCode?0:this._states.get(E,v)}}e.StateMachine=A;let C=null;function D(){return C===null&&(C=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var b;(function(I){I[I.None=0]="None",I[I.ForceTermination=1]="ForceTermination",I[I.CannotEndIn=2]="CannotEndIn"})(b||(b={}));let T=null;function L(){if(T===null){T=new u.CharacterClassifier(0);const I=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<I.length;v++)T.set(I.charCodeAt(v),1);const E=".,;:";for(let v=0;v<E.length;v++)T.set(E.charCodeAt(v),2)}return T}class P{static _createLink(E,v,w,g,_){let f=_-1;do{const a=v.charCodeAt(f);if(E.get(a)!==2)break;f--}while(f>g);if(g>0){const a=v.charCodeAt(g-1),m=v.charCodeAt(f);(a===40&&m===41||a===91&&m===93||a===123&&m===125)&&f--}return{range:{startLineNumber:w,startColumn:g+1,endLineNumber:w,endColumn:f+2},url:v.substring(g,f+1)}}static computeLinks(E,v=D()){const w=L(),g=[];for(let _=1,f=E.getLineCount();_<=f;_++){const a=E.getLineContent(_),m=a.length;let o=0,d=0,r=0,s=1,n=!1,t=!1,c=!1,l=!1;for(;o<m;){let h=!1;const p=a.charCodeAt(o);if(s===13){let R;switch(p){case 40:n=!0,R=0;break;case 41:R=n?0:1;break;case 91:c=!0,t=!0,R=0;break;case 93:c=!1,R=t?0:1;break;case 123:l=!0,R=0;break;case 125:R=l?0:1;break;case 39:R=r===34||r===96?0:1;break;case 34:R=r===39||r===96?0:1;break;case 96:R=r===39||r===34?0:1;break;case 42:R=r===42?1:0;break;case 124:R=r===124?1:0;break;case 32:R=c?0:1;break;default:R=w.get(p)}R===1&&(g.push(P._createLink(w,a,_,d,o)),h=!0)}else if(s===12){let R;p===91?(t=!0,R=0):R=w.get(p),R===1?h=!0:s=13}else s=v.nextState(s,p),s===0&&(h=!0);h&&(s=1,n=!1,t=!1,l=!1,d=o+1,r=p),o++}s===13&&g.push(P._createLink(w,a,_,d,m))}return g}}e.LinkComputer=P;function S(I){return!I||typeof I.getLineCount!="function"||typeof I.getLineContent!="function"?[]:P.computeLinks(I)}e.computeLinks=S}),define(ke[111],Pe([1,0,24]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var i;(function(_){_[_.Left=1]="Left",_[_.Center=2]="Center",_[_.Right=4]="Right",_[_.Full=7]="Full"})(i||(e.OverviewRulerLane=i={}));var y;(function(_){_[_.Inline=1]="Inline",_[_.Gutter=2]="Gutter"})(y||(e.MinimapPosition=y={}));var A;(function(_){_[_.Both=0]="Both",_[_.Right=1]="Right",_[_.Left=2]="Left",_[_.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var C;(function(_){_[_.TextDefined=0]="TextDefined",_[_.LF=1]="LF",_[_.CRLF=2]="CRLF"})(C||(e.EndOfLinePreference=C={}));var D;(function(_){_[_.LF=1]="LF",_[_.CRLF=2]="CRLF"})(D||(e.DefaultEndOfLine=D={}));var b;(function(_){_[_.LF=0]="LF",_[_.CRLF=1]="CRLF"})(b||(e.EndOfLineSequence=b={}));class T{constructor(f){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,f.tabSize|0),this.indentSize=f.tabSize|0,this.insertSpaces=Boolean(f.insertSpaces),this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=Boolean(f.trimAutoWhitespace),this.bracketPairColorizationOptions=f.bracketPairColorizationOptions}equals(f){return this.tabSize===f.tabSize&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace&&(0,u.equals)(this.bracketPairColorizationOptions,f.bracketPairColorizationOptions)}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}e.TextModelResolvedOptions=T;class L{constructor(f,a){this._findMatchBrand=void 0,this.range=f,this.matches=a}}e.FindMatch=L;var P;(function(_){_[_.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",_[_.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",_[_.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",_[_.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P||(e.TrackedRangeStickiness=P={}));var S;(function(_){_[_.Left=0]="Left",_[_.Right=1]="Right",_[_.None=2]="None",_[_.LeftOfInjectedText=3]="LeftOfInjectedText",_[_.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var I;(function(_){_[_.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I||(e.ModelConstants=I={}));class E{constructor(f,a,m,o,d,r){this.identifier=f,this.range=a,this.text=m,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=d,this._isTracked=r}}e.ValidAnnotatedEditOperation=E;class v{constructor(f,a,m){this.regex=f,this.wordSeparators=a,this.simpleSearch=m}}e.SearchData=v;class w{constructor(f,a,m){this.reverseEdits=f,this.changes=a,this.trimAutoWhitespaceLineNumbers=m}}e.ApplyEditsResult=w;function g(_){return!_.isTooLargeForSyncing()&&!_.isForSimpleWidget}e.shouldSynchronizeModel=g}),define(ke[154],Pe([1,0,16,99]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class y{constructor(b){this.values=b,this.prefixSum=new Uint32Array(b.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(b,T){b=(0,i.toUint32)(b);const L=this.values,P=this.prefixSum,S=T.length;return S===0?!1:(this.values=new Uint32Array(L.length+S),this.values.set(L.subarray(0,b),0),this.values.set(L.subarray(b),b+S),this.values.set(T,b),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(b,T){return b=(0,i.toUint32)(b),T=(0,i.toUint32)(T),this.values[b]===T?!1:(this.values[b]=T,b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),!0)}removeValues(b,T){b=(0,i.toUint32)(b),T=(0,i.toUint32)(T);const L=this.values,P=this.prefixSum;if(b>=L.length)return!1;const S=L.length-b;return T>=S&&(T=S),T===0?!1:(this.values=new Uint32Array(L.length-T),this.values.set(L.subarray(0,b),0),this.values.set(L.subarray(b+T),b),this.prefixSum=new Uint32Array(this.values.length),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(b){return b<0?0:(b=(0,i.toUint32)(b),this._getPrefixSum(b))}_getPrefixSum(b){if(b<=this.prefixSumValidIndex[0])return this.prefixSum[b];let T=this.prefixSumValidIndex[0]+1;T===0&&(this.prefixSum[0]=this.values[0],T++),b>=this.values.length&&(b=this.values.length-1);for(let L=T;L<=b;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],b),this.prefixSum[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let T=0,L=this.values.length-1,P=0,S=0,I=0;for(;T<=L;)if(P=T+(L-T)/2|0,S=this.prefixSum[P],I=S-this.values[P],b<I)L=P-1;else if(b>=S)T=P+1;else break;return new C(P,b-I)}}e.PrefixSumComputer=y;class A{constructor(b){this._values=b,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(b){return this._ensureValid(),b===0?0:this._prefixSum[b-1]}getIndexOf(b){this._ensureValid();const T=this._indexBySum[b],L=T>0?this._prefixSum[T-1]:0;return new C(T,b-L)}removeValues(b,T){this._values.splice(b,T),this._invalidate(b)}insertValues(b,T){this._values=(0,u.arrayInsert)(this._values,b,T),this._invalidate(b)}_invalidate(b){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,b-1)}_ensureValid(){if(!this._isValid){for(let b=this._validEndIndex+1,T=this._values.length;b<T;b++){const L=this._values[b],P=b>0?this._prefixSum[b-1]:0;this._prefixSum[b]=P+L;for(let S=0;S<L;S++)this._indexBySum[P+S]=b}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(b,T){this._values[b]!==T&&(this._values[b]=T,this._invalidate(b))}}e.ConstantTimePrefixSumComputer=A;class C{constructor(b,T){this.index=b,this.remainder=T,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=T}}e.PrefixSumIndexOfResult=C}),define(ke[155],Pe([1,0,8,50,154]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(D,b,T,L){this._uri=D,this._lines=b,this._eol=T,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const b=D.changes;for(const T of b)this._acceptDeleteRange(T.range),this._acceptInsertText(new i.Position(T.range.startLineNumber,T.range.startColumn),T.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,b=this._lines.length,T=new Uint32Array(b);for(let L=0;L<b;L++)T[L]=this._lines[L].length+D;this._lineStarts=new y.PrefixSumComputer(T)}}_setLineText(D,b){this._lines[D]=b,this._lineStarts&&this._lineStarts.setValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,b){if(b.length===0)return;const T=(0,u.splitLines)(b);if(T.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+T[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}T[T.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+T[0]);const L=new Uint32Array(T.length-1);for(let P=1;P<T.length;P++)this._lines.splice(D.lineNumber+P-1,0,T[P]),L[P-1]=T[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,L)}}e.MirrorTextModel=A}),define(ke[156],Pe([1,0,8,150,50,36,111]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class b{constructor(_,f,a,m){this.searchString=_,this.isRegex=f,this.matchCase=a,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let _;this.isRegex?_=T(this.searchString):_=this.searchString.indexOf(`
`)>=0;let f=null;try{f=u.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:_,global:!0,unicode:!0})}catch{return null}if(!f)return null;let a=!this.isRegex&&!_;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new C.SearchData(f,this.wordSeparators?(0,i.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}e.SearchParams=b;function T(g){if(!g||g.length===0)return!1;for(let _=0,f=g.length;_<f;_++)if(g.charCodeAt(_)===92){if(_++,_>=f)break;const m=g.charCodeAt(_);if(m===110||m===114||m===87)return!0}return!1}e.isMultilineRegexSource=T;function L(g,_,f){if(!f)return new C.FindMatch(g,null);const a=[];for(let m=0,o=_.length;m<o;m++)a[m]=_[m];return new C.FindMatch(g,a)}e.createFindMatch=L;class P{constructor(_){const f=[];let a=0;for(let m=0,o=_.length;m<o;m++)_.charCodeAt(m)===10&&(f[a++]=m);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(_){const f=this._lineFeedsOffsets;let a=0,m=f.length-1;if(m===-1||_<=f[0])return 0;for(;a<m;){const o=a+((m-a)/2>>0);f[o]>=_?m=o-1:f[o+1]>=_?(a=o,m=o):a=o+1}return a+1}}class S{static findMatches(_,f,a,m,o){const d=f.parseSearchRequest();return d?d.regex.multiline?this._doFindMatchesMultiline(_,a,new w(d.wordSeparators,d.regex),m,o):this._doFindMatchesLineByLine(_,a,d,m,o):[]}static _getMultilineMatchRange(_,f,a,m,o,d){let r,s=0;m?(s=m.findLineFeedCountBeforeOffset(o),r=f+o+s):r=f+o;let n;if(m){const h=m.findLineFeedCountBeforeOffset(o+d.length)-s;n=r+d.length+h}else n=r+d.length;const t=_.getPositionAt(r),c=_.getPositionAt(n);return new A.Range(t.lineNumber,t.column,c.lineNumber,c.column)}static _doFindMatchesMultiline(_,f,a,m,o){const d=_.getOffsetAt(f.getStartPosition()),r=_.getValueInRange(f,1),s=_.getEOL()===`\r
`?new P(r):null,n=[];let t=0,c;for(a.reset(0);c=a.next(r);)if(n[t++]=L(this._getMultilineMatchRange(_,d,r,s,c.index,c[0]),c,m),t>=o)return n;return n}static _doFindMatchesLineByLine(_,f,a,m,o){const d=[];let r=0;if(f.startLineNumber===f.endLineNumber){const n=_.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return r=this._findMatchesInLine(a,n,f.startLineNumber,f.startColumn-1,r,d,m,o),d}const s=_.getLineContent(f.startLineNumber).substring(f.startColumn-1);r=this._findMatchesInLine(a,s,f.startLineNumber,f.startColumn-1,r,d,m,o);for(let n=f.startLineNumber+1;n<f.endLineNumber&&r<o;n++)r=this._findMatchesInLine(a,_.getLineContent(n),n,0,r,d,m,o);if(r<o){const n=_.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);r=this._findMatchesInLine(a,n,f.endLineNumber,0,r,d,m,o)}return d}static _findMatchesInLine(_,f,a,m,o,d,r,s){const n=_.wordSeparators;if(!r&&_.simpleSearch){const l=_.simpleSearch,h=l.length,p=f.length;let R=-h;for(;(R=f.indexOf(l,R+h))!==-1;)if((!n||v(n,f,p,R,h))&&(d[o++]=new C.FindMatch(new A.Range(a,R+1+m,a,R+1+h+m),null),o>=s))return o;return o}const t=new w(_.wordSeparators,_.regex);let c;t.reset(0);do if(c=t.next(f),c&&(d[o++]=L(new A.Range(a,c.index+1+m,a,c.index+1+c[0].length+m),c,r),o>=s))return o;while(c);return o}static findNextMatch(_,f,a,m){const o=f.parseSearchRequest();if(!o)return null;const d=new w(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindNextMatchMultiline(_,a,d,m):this._doFindNextMatchLineByLine(_,a,d,m)}static _doFindNextMatchMultiline(_,f,a,m){const o=new y.Position(f.lineNumber,1),d=_.getOffsetAt(o),r=_.getLineCount(),s=_.getValueInRange(new A.Range(o.lineNumber,o.column,r,_.getLineMaxColumn(r)),1),n=_.getEOL()===`\r
`?new P(s):null;a.reset(f.column-1);let t=a.next(s);return t?L(this._getMultilineMatchRange(_,d,s,n,t.index,t[0]),t,m):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(_,new y.Position(1,1),a,m):null}static _doFindNextMatchLineByLine(_,f,a,m){const o=_.getLineCount(),d=f.lineNumber,r=_.getLineContent(d),s=this._findFirstMatchInLine(a,r,d,f.column,m);if(s)return s;for(let n=1;n<=o;n++){const t=(d+n-1)%o,c=_.getLineContent(t+1),l=this._findFirstMatchInLine(a,c,t+1,1,m);if(l)return l}return null}static _findFirstMatchInLine(_,f,a,m,o){_.reset(m-1);const d=_.next(f);return d?L(new A.Range(a,d.index+1,a,d.index+1+d[0].length),d,o):null}static findPreviousMatch(_,f,a,m){const o=f.parseSearchRequest();if(!o)return null;const d=new w(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindPreviousMatchMultiline(_,a,d,m):this._doFindPreviousMatchLineByLine(_,a,d,m)}static _doFindPreviousMatchMultiline(_,f,a,m){const o=this._doFindMatchesMultiline(_,new A.Range(1,1,f.lineNumber,f.column),a,m,10*D);if(o.length>0)return o[o.length-1];const d=_.getLineCount();return f.lineNumber!==d||f.column!==_.getLineMaxColumn(d)?this._doFindPreviousMatchMultiline(_,new y.Position(d,_.getLineMaxColumn(d)),a,m):null}static _doFindPreviousMatchLineByLine(_,f,a,m){const o=_.getLineCount(),d=f.lineNumber,r=_.getLineContent(d).substring(0,f.column-1),s=this._findLastMatchInLine(a,r,d,m);if(s)return s;for(let n=1;n<=o;n++){const t=(o+d-n-1)%o,c=_.getLineContent(t+1),l=this._findLastMatchInLine(a,c,t+1,m);if(l)return l}return null}static _findLastMatchInLine(_,f,a,m){let o=null,d;for(_.reset(0);d=_.next(f);)o=L(new A.Range(a,d.index+1,a,d.index+1+d[0].length),d,m);return o}}e.TextModelSearch=S;function I(g,_,f,a,m){if(a===0)return!0;const o=_.charCodeAt(a-1);if(g.get(o)!==0||o===13||o===10)return!0;if(m>0){const d=_.charCodeAt(a);if(g.get(d)!==0)return!0}return!1}function E(g,_,f,a,m){if(a+m===f)return!0;const o=_.charCodeAt(a+m);if(g.get(o)!==0||o===13||o===10)return!0;if(m>0){const d=_.charCodeAt(a+m-1);if(g.get(d)!==0)return!0}return!1}function v(g,_,f,a,m){return I(g,_,f,a,m)&&E(g,_,f,a,m)}e.isValidMatch=v;class w{constructor(_,f){this._wordSeparators=_,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(_){this._searchRegex.lastIndex=_,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(_){const f=_.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(a=this._searchRegex.exec(_),!a))return null;const m=a.index,o=a[0].length;if(m===this._prevMatchStartIndex&&o===this._prevMatchLength){if(o===0){u.getNextCodePoint(_,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=o,!this._wordSeparators||v(this._wordSeparators,_,f,m,o))return a}while(a);return null}}e.Searcher=w}),define(ke[112],Pe([1,0,23,13]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(y||(y={}));function A(P){for(let S=0,I=P.length;S<I;S+=4){const E=P[S+0],v=P[S+1],w=P[S+2],g=P[S+3];P[S+0]=g,P[S+1]=w,P[S+2]=v,P[S+3]=E}}function C(P){const S=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return i.isLittleEndian()||A(S),u.VSBuffer.wrap(S)}function D(P){const S=P.buffer;if(i.isLittleEndian()||A(S),S.byteOffset%4==0)return new Uint32Array(S.buffer,S.byteOffset,S.length/4);{const I=new Uint8Array(S.byteLength);return I.set(S),new Uint32Array(I.buffer,I.byteOffset,I.length/4)}}function b(P){const S=new Uint32Array(T(P));let I=0;if(S[I++]=P.id,P.type==="full")S[I++]=1,S[I++]=P.data.length,S.set(P.data,I),I+=P.data.length;else{S[I++]=2,S[I++]=P.deltas.length;for(const E of P.deltas)S[I++]=E.start,S[I++]=E.deleteCount,E.data?(S[I++]=E.data.length,S.set(E.data,I),I+=E.data.length):S[I++]=0}return C(S)}e.encodeSemanticTokensDto=b;function T(P){let S=0;if(S+=1+1,P.type==="full")S+=1+P.data.length;else{S+=1,S+=(1+1+1)*P.deltas.length;for(const I of P.deltas)I.data&&(S+=I.data.length)}return S}function L(P){const S=D(P);let I=0;const E=S[I++];if(S[I++]===1){const _=S[I++],f=S.subarray(I,I+_);return I+=_,{id:E,type:"full",data:f}}const w=S[I++],g=[];for(let _=0;_<w;_++){const f=S[I++],a=S[I++],m=S[I++];let o;m>0&&(o=S.subarray(I,I+m),I+=m),g[_]={start:f,deleteCount:a,data:o}}return{id:E,type:"delta",deltas:g}}e.decodeSemanticTokensDto=L}),define(ke[157],Pe([1,0,3,6]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class y{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new u.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,b){return this._map.set(D,b),this.fire([D]),(0,i.toDisposable)(()=>{this._map.get(D)===b&&(this._map.delete(D),this.fire([D]))})}registerFactory(D,b){this._factories.get(D)?.dispose();const T=new A(this,D,b);return this._factories.set(D,T),(0,i.toDisposable)(()=>{const L=this._factories.get(D);!L||L!==T||(this._factories.delete(D),L.dispose())})}async getOrCreate(D){const b=this.get(D);if(b)return b;const T=this._factories.get(D);return!T||T.isResolved?null:(await T.resolve(),this.get(D))}get(D){return this._map.get(D)||null}isResolved(D){if(this.get(D))return!0;const T=this._factories.get(D);return!!(!T||T.isResolved)}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=y;class A extends i.Disposable{get isResolved(){return this._isResolved}constructor(D,b,T){super();this._registry=D,this._languageId=b,this._factory=T,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const D=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,D&&!this._isDisposed&&this._register(this._registry.register(this._languageId,D))}}}),define(ke[65],Pe([1,0,78,2,36,157]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(h,p,R){this._tokenBrand=void 0,this.offset=h,this.type=p,this.language=R}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class D{constructor(h,p){this._tokenizationResultBrand=void 0,this.tokens=h,this.endState=p}}e.TokenizationResult=D;class b{constructor(h,p){this._encodedTokenizationResultBrand=void 0,this.tokens=h,this.endState=p}}e.EncodedTokenizationResult=b;var T;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(T||(e.CompletionItemKind=T={}));var L;(function(l){const h=new Map;h.set(0,u.Codicon.symbolMethod),h.set(1,u.Codicon.symbolFunction),h.set(2,u.Codicon.symbolConstructor),h.set(3,u.Codicon.symbolField),h.set(4,u.Codicon.symbolVariable),h.set(5,u.Codicon.symbolClass),h.set(6,u.Codicon.symbolStruct),h.set(7,u.Codicon.symbolInterface),h.set(8,u.Codicon.symbolModule),h.set(9,u.Codicon.symbolProperty),h.set(10,u.Codicon.symbolEvent),h.set(11,u.Codicon.symbolOperator),h.set(12,u.Codicon.symbolUnit),h.set(13,u.Codicon.symbolValue),h.set(15,u.Codicon.symbolEnum),h.set(14,u.Codicon.symbolConstant),h.set(15,u.Codicon.symbolEnum),h.set(16,u.Codicon.symbolEnumMember),h.set(17,u.Codicon.symbolKeyword),h.set(27,u.Codicon.symbolSnippet),h.set(18,u.Codicon.symbolText),h.set(19,u.Codicon.symbolColor),h.set(20,u.Codicon.symbolFile),h.set(21,u.Codicon.symbolReference),h.set(22,u.Codicon.symbolCustomColor),h.set(23,u.Codicon.symbolFolder),h.set(24,u.Codicon.symbolTypeParameter),h.set(25,u.Codicon.account),h.set(26,u.Codicon.issues);function p(O){let k=h.get(O);return k||(console.info("No codicon found for CompletionItemKind "+O),k=u.Codicon.symbolProperty),k}l.toIcon=p;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function F(O,k){let U=R.get(O);return typeof U=="undefined"&&!k&&(U=9),U}l.fromString=F})(L||(e.CompletionItemKinds=L={}));var P;(function(l){l[l.Deprecated=1]="Deprecated"})(P||(e.CompletionItemTag=P={}));var S;(function(l){l[l.None=0]="None",l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var I;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I||(e.CompletionTriggerKind=I={}));var E;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(E||(e.InlineCompletionTriggerKind=E={}));var v;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(v||(e.CodeActionTriggerType=v={}));var w;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(w||(e.SignatureHelpTriggerKind=w={}));var g;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(g||(e.DocumentHighlightKind=g={}));function _(l){return l&&i.URI.isUri(l.uri)&&y.Range.isIRange(l.range)&&(y.Range.isIRange(l.originSelectionRange)||y.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=_;var f;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(f||(e.SymbolKind=f={}));var a;(function(l){l[l.Deprecated=1]="Deprecated"})(a||(e.SymbolTag=a={}));var m;(function(l){const h=new Map;h.set(0,u.Codicon.symbolFile),h.set(1,u.Codicon.symbolModule),h.set(2,u.Codicon.symbolNamespace),h.set(3,u.Codicon.symbolPackage),h.set(4,u.Codicon.symbolClass),h.set(5,u.Codicon.symbolMethod),h.set(6,u.Codicon.symbolProperty),h.set(7,u.Codicon.symbolField),h.set(8,u.Codicon.symbolConstructor),h.set(9,u.Codicon.symbolEnum),h.set(10,u.Codicon.symbolInterface),h.set(11,u.Codicon.symbolFunction),h.set(12,u.Codicon.symbolVariable),h.set(13,u.Codicon.symbolConstant),h.set(14,u.Codicon.symbolString),h.set(15,u.Codicon.symbolNumber),h.set(16,u.Codicon.symbolBoolean),h.set(17,u.Codicon.symbolArray),h.set(18,u.Codicon.symbolObject),h.set(19,u.Codicon.symbolKey),h.set(20,u.Codicon.symbolNull),h.set(21,u.Codicon.symbolEnumMember),h.set(22,u.Codicon.symbolStruct),h.set(23,u.Codicon.symbolEvent),h.set(24,u.Codicon.symbolOperator),h.set(25,u.Codicon.symbolTypeParameter);function p(R){let F=h.get(R);return F||(console.info("No codicon found for SymbolKind "+R),F=u.Codicon.symbolProperty),F}l.toIcon=p})(m||(e.SymbolKinds=m={}));class o{constructor(h){this.value=h}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var d;(function(l){function h(p){return!p||typeof p!="object"?!1:typeof p.id=="string"&&typeof p.title=="string"}l.is=h})(d||(e.Command=d={}));var r;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(r||(e.CommentThreadCollapsibleState=r={}));var s;(function(l){l[l.Unresolved=0]="Unresolved",l[l.Resolved=1]="Resolved"})(s||(e.CommentThreadState=s={}));var n;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(n||(e.CommentMode=n={}));var t;(function(l){l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(t||(e.InlayHintKind=t={})),e.TokenizationRegistry=new A.TokenizationRegistry;var c;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(c||(e.ExternalUriOpenerPriority=c={}))}),define(ke[158],Pe([19,20]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ke[159],Pe([1,0,158]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,y=i*60,A=y*24,C=A*7,D=A*30,b=A*365;function T(P,S,I){typeof P!="number"&&(P=P.getTime());const E=Math.round((new Date().getTime()-P)/1e3);if(E<-30)return(0,u.localize)(0,null,T(new Date().getTime()+E*1e3,!1));if(E<30)return(0,u.localize)(1,null);let v;return E<i?(v=E,S?v===1?I?(0,u.localize)(2,null,v):(0,u.localize)(3,null,v):I?(0,u.localize)(4,null,v):(0,u.localize)(5,null,v):v===1?I?(0,u.localize)(6,null,v):(0,u.localize)(7,null,v):I?(0,u.localize)(8,null,v):(0,u.localize)(9,null,v)):E<y?(v=Math.floor(E/i),S?v===1?I?(0,u.localize)(10,null,v):(0,u.localize)(11,null,v):I?(0,u.localize)(12,null,v):(0,u.localize)(13,null,v):v===1?I?(0,u.localize)(14,null,v):(0,u.localize)(15,null,v):I?(0,u.localize)(16,null,v):(0,u.localize)(17,null,v)):E<A?(v=Math.floor(E/y),S?v===1?I?(0,u.localize)(18,null,v):(0,u.localize)(19,null,v):I?(0,u.localize)(20,null,v):(0,u.localize)(21,null,v):v===1?I?(0,u.localize)(22,null,v):(0,u.localize)(23,null,v):I?(0,u.localize)(24,null,v):(0,u.localize)(25,null,v)):E<C?(v=Math.floor(E/A),S?v===1?(0,u.localize)(26,null,v):(0,u.localize)(27,null,v):v===1?(0,u.localize)(28,null,v):(0,u.localize)(29,null,v)):E<D?(v=Math.floor(E/C),S?v===1?I?(0,u.localize)(30,null,v):(0,u.localize)(31,null,v):I?(0,u.localize)(32,null,v):(0,u.localize)(33,null,v):v===1?I?(0,u.localize)(34,null,v):(0,u.localize)(35,null,v):I?(0,u.localize)(36,null,v):(0,u.localize)(37,null,v)):E<b?(v=Math.floor(E/D),S?v===1?I?(0,u.localize)(38,null,v):(0,u.localize)(39,null,v):I?(0,u.localize)(40,null,v):(0,u.localize)(41,null,v):v===1?I?(0,u.localize)(42,null,v):(0,u.localize)(43,null,v):I?(0,u.localize)(44,null,v):(0,u.localize)(45,null,v)):(v=Math.floor(E/b),S?v===1?I?(0,u.localize)(46,null,v):(0,u.localize)(47,null,v):I?(0,u.localize)(48,null,v):(0,u.localize)(49,null,v):v===1?I?(0,u.localize)(50,null,v):(0,u.localize)(51,null,v):I?(0,u.localize)(52,null,v):(0,u.localize)(53,null,v))}e.fromNow=T;function L(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ke[160],Pe([19,20]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ke[51],Pe([1,0,16,12,160]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(P,S){return S&&(P.stack||P.stacktrace)?y.localize(0,null,D(P),C(P.stack)||C(P.stacktrace)):D(P)}function C(P){return Array.isArray(P)?P.join(`
`):P}function D(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?y.localize(1,null,P.message):P.message||y.localize(2,null)}function b(P=null,S=!1){if(!P)return y.localize(3,null);if(Array.isArray(P)){const I=u.coalesce(P),E=b(I[0],S);return I.length>1?y.localize(4,null,E,I.length):E}if(i.isString(P))return P;if(P.detail){const I=P.detail;if(I.error)return A(I.error,S);if(I.exception)return A(I.exception,S)}return P.stack?A(P,S):P.message?P.message:y.localize(5,null)}e.toErrorMessage=b;function T(P){const S=P;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=T;function L(P,S){let I;return typeof P=="string"?I=new Error(P):I=P,I.actions=S,I}e.createErrorWithActions=L}),define(ke[161],Pe([19,20]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(ke[113],Pe([1,0,42,30,10,24,9,13,40,96,12,147,29,161]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function E(m){switch(m){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(m,o){if(D.isWindows)try{const d={stdio:["pipe","pipe","ignore"]};o&&(d.cwd=o);const r=u.execFile("taskkill",["/T","/F","/PID",m.pid.toString()],d);return new Promise(s=>{r.once("error",n=>{s({success:!1,error:n})}),r.once("exit",(n,t)=>{s(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(d){return Promise.resolve({success:!1,error:d,code:d.status?E(d.status):1})}else if(D.isLinux||D.isMacintosh)try{const d=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(r=>{u.execFile(d,[m.pid.toString()],{encoding:"utf8",shell:!0},(s,n,t)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(d){return Promise.resolve({success:!1,error:d})}else m.kill("SIGKILL");return Promise.resolve({success:!0})}function w(m=b.env){return m.comspec||"cmd.exe"}e.getWindowsShell=w;class g{constructor(o,d,r,s){if(d!==void 0&&r!==void 0&&s!==void 0)this.cmd=o,this.args=d,this.shell=r,this.options=s;else{const n=o;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(b.env).forEach(t=>{n[t]=b.env[t]}),Object.keys(this.options.env).forEach(t=>{n[t]=this.options.env[t]}),this.options.env=n}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const d=o.lastIndexOf(C.sep);return d!==-1&&(o=o.substring(d+1)),g.WellKnowCommands[o]?o:"other"}start(o){return D.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(b.cwd()))?Promise.reject(new Error(I.localize(0,null))):this.useExec().then(d=>{let r,s;const n=new Promise((t,c)=>{r=t,s=c});if(d){let t=this.cmd;this.args&&(t=t+" "+this.args.join(" ")),this.childProcess=u.exec(t,this.options,(c,l,h)=>{this.childProcess=null;const p=c;p&&p.killed?s({killed:this.terminateRequested,stdout:l.toString(),stderr:h.toString()}):this.handleExec(r,o,c,l,h)})}else{let t=null;const c=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,o,s);const h={terminated:this.terminateRequested};L.isNumber(l)&&(h.cmdCode=l),r(h)};if(this.shell&&D.isWindows){const l=A.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let h=!1,p=!1;const R=[];let F=this.ensureQuotes(this.cmd);R.push(F.value),h=F.quoted,this.args&&this.args.forEach(k=>{F=this.ensureQuotes(k),R.push(F.value),p=p&&F.quoted});const O=["/s","/c"];h?p?O.push('"'+R.join(" ")+'"'):R.length>1?O.push('"'+R[0]+'" '+R.slice(1).join(" ")):O.push('"'+R[0]+'"'):O.push(R.join(" ")),t=u.spawn(w(),O,l)}else this.cmd&&(t=u.spawn(this.cmd,this.args,this.options));t&&(this.childProcess=t,this.childProcessPromise=Promise.resolve(t),this.pidResolve&&(this.pidResolve(L.isNumber(t.pid)?t.pid:-1),this.pidResolve=void 0),t.on("error",l=>{this.childProcess=null,s({terminated:this.terminateRequested,error:l})}),t.pid&&(this.childProcess.on("close",c),this.handleSpawn(t,r,o,s,!0)))}return n})}handleClose(o,d,r,s){}ensureQuotes(o){return g.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,v(o,this.options.cwd).then(d=>(d.success&&(this.childProcess=null),d))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!D.isWindows)return o(!1);const d=u.spawn(w(),["/s","/c"]);d.on("error",r=>o(!0)),d.on("exit",r=>o(!1))})}}e.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;class _ extends g{constructor(o,d,r,s){super(o,d,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,d,r,s,n){[s,n].forEach((t,c)=>{const l=new P.LineDecoder;l.write(t).forEach(R=>{d({line:R,source:c===0?0:1})});const p=l.end();p&&d({line:p,source:c===0?0:1})}),o({terminated:this.terminateRequested,error:r})}handleSpawn(o,d,r,s,n){const t=new P.LineDecoder,c=new P.LineDecoder;o.stdout.on("data",l=>{t.write(l).forEach(p=>r({line:p,source:0}))}),o.stderr.on("data",l=>{c.write(l).forEach(p=>r({line:p,source:1}))}),this.stdoutLineDecoder=t,this.stderrLineDecoder=c}handleClose(o,d,r,s){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&r({line:n,source:0});const t=this.stderrLineDecoder?this.stderrLineDecoder.end():null;t&&r({line:t,source:1})}}e.LineProcess=_;function f(m){let o=[],d=!1;const r=function(s){if(d){o.push(s);return}(!m.send(s,t=>{if(t&&console.error(t),d=!1,o.length>0){const c=o.slice(0);o=[],c.forEach(l=>r(l))}})||D.isWindows)&&(d=!0)};return{send:r}}e.createQueuedSender=f;var a;(function(m){async function o(d,r,s){if(C.isAbsolute(d))return d;if(r===void 0&&(r=b.cwd()),C.dirname(d)!=="."||(s===void 0&&L.isString(b.env.PATH)&&(s=b.env.PATH.split(C.delimiter)),s===void 0||s.length===0))return C.join(r,d);async function t(c){if(await S.Promises.exists(c)){let l;try{l=await S.Promises.stat(c)}catch(h){h.message.startsWith("EACCES")&&(l=await S.Promises.lstat(c))}return l?!l.isDirectory():!1}return!1}for(let c of s){let l;if(C.isAbsolute(c)?l=C.join(c,d):l=C.join(r,c,d),await t(l))return l;let h=l+".com";if(await t(h)||(h=l+".exe",await t(h)))return h}return C.join(r,d)}m.findExecutable=o})(a||(e.win32=a={}))}),define(ke[162],Pe([19,20]),function(Q,e){return Q.create("vs/editor/common/config/editorOptions",e)}),define(ke[114],Pe([1,0,162,13,110,16,24,149]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var b;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(b||(e.EditorAutoIndentStrategy=b={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=T;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class P{constructor(re,Ce,ae,Ie){this.id=re,this.name=Ce,this.defaultValue=ae,this.schema=Ie}applyUpdate(re,Ce){return I(re,Ce)}compute(re,Ce,ae){return ae}}class S{constructor(re,Ce){this.newValue=re,this.didChange=Ce}}e.ApplyUpdateResult=S;function I(J,re){if(typeof J!="object"||typeof re!="object"||!J||!re)return new S(re,J!==re);if(Array.isArray(J)||Array.isArray(re)){const ae=Array.isArray(J)&&Array.isArray(re)&&A.equals(J,re);return new S(re,ae)}let Ce=!1;for(const ae in re)if(re.hasOwnProperty(ae)){const Ie=I(J[ae],re[ae]);Ie.didChange&&(J[ae]=Ie.newValue,Ce=!0)}return new S(J,Ce)}class E{constructor(re){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0}applyUpdate(re,Ce){return I(re,Ce)}validate(re){return this.defaultValue}}class v{constructor(re,Ce,ae,Ie){this.id=re,this.name=Ce,this.defaultValue=ae,this.schema=Ie}applyUpdate(re,Ce){return I(re,Ce)}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,Ce,ae){return ae}}function w(J,re){return typeof J=="undefined"?re:J==="false"?!1:Boolean(J)}e.boolean=w;class g extends v{constructor(re,Ce,ae,Ie=void 0){typeof Ie!="undefined"&&(Ie.type="boolean",Ie.default=ae);super(re,Ce,ae,Ie)}validate(re){return w(re,this.defaultValue)}}function _(J,re,Ce,ae){if(typeof J=="undefined")return re;let Ie=parseInt(J,10);return isNaN(Ie)?re:(Ie=Math.max(Ce,Ie),Ie=Math.min(ae,Ie),Ie|0)}e.clampedInt=_;class f extends v{static clampedInt(re,Ce,ae,Ie){return _(re,Ce,ae,Ie)}constructor(re,Ce,ae,Ie,Ne,$e=void 0){typeof $e!="undefined"&&($e.type="integer",$e.default=ae,$e.minimum=Ie,$e.maximum=Ne);super(re,Ce,ae,$e);this.minimum=Ie,this.maximum=Ne}validate(re){return f.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class a extends v{static clamp(re,Ce,ae){return re<Ce?Ce:re>ae?ae:re}static float(re,Ce){if(typeof re=="number")return re;if(typeof re=="undefined")return Ce;const ae=parseFloat(re);return isNaN(ae)?Ce:ae}constructor(re,Ce,ae,Ie,Ne){typeof Ne!="undefined"&&(Ne.type="number",Ne.default=ae);super(re,Ce,ae,Ne);this.validationFn=Ie}validate(re){return this.validationFn(a.float(re,this.defaultValue))}}class m extends v{static string(re,Ce){return typeof re!="string"?Ce:re}constructor(re,Ce,ae,Ie=void 0){typeof Ie!="undefined"&&(Ie.type="string",Ie.default=ae);super(re,Ce,ae,Ie)}validate(re){return m.string(re,this.defaultValue)}}function o(J,re,Ce){return typeof J!="string"||Ce.indexOf(J)===-1?re:J}e.stringSet=o;class d extends v{constructor(re,Ce,ae,Ie,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.enum=Ie,Ne.default=ae);super(re,Ce,ae,Ne);this._allowedValues=Ie}validate(re){return o(re,this.defaultValue,this._allowedValues)}}class r extends P{constructor(re,Ce,ae,Ie,Ne,$e,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="string",Ge.enum=Ne,Ge.default=Ie);super(re,Ce,ae,Ge);this._allowedValues=Ne,this._convert=$e}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function s(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",description:u.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,Ce,ae){return ae===0?re.accessibilitySupport:ae}}class t extends P{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:u.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{insertSpace:w(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:w(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(c||(e.TextEditorCursorBlinkingStyle=c={}));function l(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(h||(e.TextEditorCursorStyle=h={}));function p(J){switch(J){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=p;function R(J){switch(J){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class F extends E{constructor(){super(129)}compute(re,Ce,ae){const Ie=["monaco-editor"];return Ce.get(34)&&Ie.push(Ce.get(34)),re.extraEditorClassName&&Ie.push(re.extraEditorClassName),Ce.get(67)==="default"?Ie.push("mouse-default"):Ce.get(67)==="copy"&&Ie.push("mouse-copy"),Ce.get(101)&&Ie.push("showUnused"),Ce.get(127)&&Ie.push("showDeprecated"),Ie.join(" ")}}class O extends g{constructor(){super(33,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(re,Ce,ae){return ae&&re.emptySelectionClipboard}}class k extends P{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:re.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:u.localize(16,null),included:i.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:u.localize(18,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{cursorMoveOnType:w(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof re.seedSearchStringFromSelection=="boolean"?re.seedSearchStringFromSelection?"always":"never":o(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":o(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:w(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:w(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:w(Ce.loop,this.defaultValue.loop)}}}class U extends P{constructor(){super(46,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?U.OFF:re==="true"?U.ON:re:Boolean(re)?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class B extends E{constructor(){super(45)}compute(re,Ce,ae){return re.fontInfo}}class z extends v{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(22,null)})}validate(re){const Ce=a.float(re,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ce,6,100)}compute(re,Ce,ae){return re.fontInfo.fontSize}}class Y extends P{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.MINIMUM_VALUE,maximum:Y.MAXIMUM_VALUE,errorMessage:u.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(24,null)})}validate(re){return re==="normal"||re==="bold"?re:String(f.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.MINIMUM_VALUE,Y.MAXIMUM_VALUE))}}Y.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],Y.MINIMUM_VALUE=1,Y.MAXIMUM_VALUE=1e3;class $ extends P{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[u.localize(25,null),u.localize(26,null),u.localize(27,null)]},ae=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(29,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(30,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:u.localize(31,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:u.localize(32,null),...Ce},"editor.gotoLocation.multipleReferences":{description:u.localize(33,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:ae,description:u.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:ae,description:u.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:ae,description:u.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:ae,description:u.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:ae,description:u.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{multiple:o(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??o(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??o(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??o(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??o(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??o(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class N extends P{constructor(){const re={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:u.localize(39,null)},"editor.hover.delay":{type:"number",default:re.delay,minimum:0,maximum:1e4,description:u.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:u.localize(41,null)},"editor.hover.above":{type:"boolean",default:re.above,description:u.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:w(Ce.enabled,this.defaultValue.enabled),delay:f.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:w(Ce.sticky,this.defaultValue.sticky),above:w(Ce.above,this.defaultValue.above)}}}var V;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(V||(e.RenderMinimap=V={}));class H extends E{constructor(){super(132)}compute(re,Ce,ae){return H.computeLayout(Ce,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const Ce=re.height/re.lineHeight,ae=re.scrollBeyondLastLine?Ce-1:0,Ie=(re.viewLineCount+ae)/(re.pixelRatio*re.height),Ne=Math.floor(re.viewLineCount/Ie);return{typicalViewportLineCount:Ce,extraLinesBeyondLastLine:ae,desiredRatio:Ie,minimapLineCount:Ne}}static _computeMinimapLayout(re,Ce){const ae=re.outerWidth,Ie=re.outerHeight,Ne=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ne*Ie),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ie};const $e=Ce.stableMinimapLayoutInput,Ge=$e&&re.outerHeight===$e.outerHeight&&re.lineHeight===$e.lineHeight&&re.typicalHalfwidthCharacterWidth===$e.typicalHalfwidthCharacterWidth&&re.pixelRatio===$e.pixelRatio&&re.scrollBeyondLastLine===$e.scrollBeyondLastLine&&re.minimap.enabled===$e.minimap.enabled&&re.minimap.side===$e.minimap.side&&re.minimap.size===$e.minimap.size&&re.minimap.showSlider===$e.minimap.showSlider&&re.minimap.renderCharacters===$e.minimap.renderCharacters&&re.minimap.maxColumn===$e.minimap.maxColumn&&re.minimap.scale===$e.minimap.scale&&re.verticalScrollbarWidth===$e.verticalScrollbarWidth&&re.isViewportWrapping===$e.isViewportWrapping,qe=re.lineHeight,Ze=re.typicalHalfwidthCharacterWidth,Xe=re.scrollBeyondLastLine,st=re.minimap.renderCharacters;let et=Ne>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const rt=re.minimap.maxColumn,ot=re.minimap.size,Et=re.minimap.side,At=re.verticalScrollbarWidth,It=re.viewLineCount,ft=re.remainingWidth,Rt=re.isViewportWrapping,Bt=st?2:3;let St=Math.floor(Ne*Ie);const Ke=St/Ne;let Lt=!1,Mt=!1,Ot=Bt*et,pt=et/Ne,yt=1;if(ot==="fill"||ot==="fit"){const{typicalViewportLineCount:Oe,extraLinesBeyondLastLine:We,desiredRatio:it,minimapLineCount:Qe}=H.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:Xe,height:Ie,lineHeight:qe,pixelRatio:Ne});if(It/Qe>1)Lt=!0,Mt=!0,et=1,Ot=1,pt=et/Ne;else{let ht=!1,wt=et+1;if(ot==="fit"){const mt=Math.ceil((It+We)*Ot);Rt&&Ge&&ft<=Ce.stableFitRemainingWidth?(ht=!0,wt=Ce.stableFitMaxMinimapScale):ht=mt>St}if(ot==="fill"||ht){Lt=!0;const mt=et;Ot=Math.min(qe*Ne,Math.max(1,Math.floor(1/it))),Rt&&Ge&&ft<=Ce.stableFitRemainingWidth&&(wt=Ce.stableFitMaxMinimapScale),et=Math.min(wt,Math.max(1,Math.floor(Ot/Bt))),et>mt&&(yt=Math.min(2,et/mt)),pt=et/Ne/yt,St=Math.ceil(Math.max(Oe,It+We)*Ot),Rt?(Ce.stableMinimapLayoutInput=re,Ce.stableFitRemainingWidth=ft,Ce.stableFitMaxMinimapScale=et):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const kt=Math.floor(rt*pt),_t=Math.min(kt,Math.max(0,Math.floor((ft-At-2)*pt/(Ze+pt)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(Ne*_t);const Fe=Re/Ne;Re=Math.floor(Re*yt);const _e=st?1:2,Z=Et==="left"?0:ae-_t-At;return{renderMinimap:_e,minimapLeft:Z,minimapWidth:_t,minimapHeightIsEditorHeight:Lt,minimapIsSampling:Mt,minimapScale:et,minimapLineHeight:Ot,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:St,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:Ke}}static computeLayout(re,Ce){const ae=Ce.outerWidth|0,Ie=Ce.outerHeight|0,Ne=Ce.lineHeight|0,$e=Ce.lineNumbersDigitCount|0,Ge=Ce.typicalHalfwidthCharacterWidth,qe=Ce.maxDigitWidth,Ze=Ce.pixelRatio,Xe=Ce.viewLineCount,st=re.get(124),et=st==="inherit"?re.get(123):st,rt=et==="inherit"?re.get(119):et,ot=re.get(122),Et=re.get(2),At=Ce.isDominatedByLongLines,It=re.get(51),ft=re.get(61).renderType!==0,Rt=re.get(62),Bt=re.get(95),St=re.get(66),Ke=re.get(93),Lt=Ke.verticalScrollbarSize,Mt=Ke.verticalHasArrows,Ot=Ke.arrowSize,pt=Ke.horizontalScrollbarSize,yt=re.get(59),kt=re.get(38);let _t;if(typeof yt=="string"&&/^\d+(\.\d+)?ch$/.test(yt)){const vt=parseFloat(yt.substr(0,yt.length-2));_t=f.clampedInt(vt*Ge,0,0,1e3)}else _t=f.clampedInt(yt,0,0,1e3);kt&&(_t+=16);let Re=0;if(ft){const vt=Math.max($e,Rt);Re=Math.round(vt*qe)}let Fe=0;It&&(Fe=Ne);let _e=0,Z=_e+Fe,Oe=Z+Re,We=Oe+_t;const it=ae-Fe-Re-_t;let Qe=!1,ut=!1,ht=-1;Et!==2&&(et==="inherit"&&At?(Qe=!0,ut=!0):rt==="on"||rt==="bounded"?ut=!0:rt==="wordWrapColumn"&&(ht=ot));const wt=H._computeMinimapLayout({outerWidth:ae,outerHeight:Ie,lineHeight:Ne,typicalHalfwidthCharacterWidth:Ge,pixelRatio:Ze,scrollBeyondLastLine:Bt,minimap:St,verticalScrollbarWidth:Lt,viewLineCount:Xe,remainingWidth:it,isViewportWrapping:ut},Ce.memory||new L);wt.renderMinimap!==0&&wt.minimapLeft===0&&(_e+=wt.minimapWidth,Z+=wt.minimapWidth,Oe+=wt.minimapWidth,We+=wt.minimapWidth);const mt=it-wt.minimapWidth,Pt=Math.max(1,Math.floor((mt-Lt-2)/Ge)),Ft=Mt?Ot:0;return ut&&(ht=Math.max(1,Pt),rt==="bounded"&&(ht=Math.min(ht,ot))),{width:ae,height:Ie,glyphMarginLeft:_e,glyphMarginWidth:Fe,lineNumbersLeft:Z,lineNumbersWidth:Re,decorationsLeft:Oe,decorationsWidth:_t,contentLeft:We,contentWidth:mt,minimap:wt,viewportColumn:Pt,isWordWrapMinified:Qe,isViewportWrapping:ut,wrappingColumn:ht,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:pt,overviewRuler:{top:Ft,width:Lt,height:Ie-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=H;class q extends P{constructor(){const re={enabled:!0};super(58,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:u.localize(43,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:w(re.enabled,this.defaultValue.enabled)}}}class te extends P{constructor(){const re={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(128,"inlayHints",re,{"editor.inlayHints.enabled":{type:"string",default:re.enabled,description:u.localize(44,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[u.localize(45,null),u.localize(46,null),u.localize(47,null),u.localize(48,null)]},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,markdownDescription:u.localize(49,null)},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,markdownDescription:u.localize(50,null)},"editor.inlayHints.padding":{type:"boolean",default:re.padding,description:u.localize(51,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:o(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:w(Ce.padding,this.defaultValue.padding)}}}class fe extends a{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,re=>a.clamp(re,0,150),{markdownDescription:u.localize(52,null)})}compute(re,Ce,ae){return re.fontInfo.lineHeight}}class ne extends P{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:u.localize(53,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(54,null),u.localize(55,null),u.localize(56,null)],default:re.size,description:u.localize(57,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:u.localize(58,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:u.localize(59,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(60,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:u.localize(61,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:u.localize(62,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:w(Ce.enabled,this.defaultValue.enabled),size:o(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(Ce.side,this.defaultValue.side,["right","left"]),showSlider:o(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:w(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(Ce.scale,1,1,3),maxColumn:f.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(J){return J==="ctrlCmd"?i.isMacintosh?"metaKey":"ctrlKey":"altKey"}class K extends P{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(63,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(64,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{top:f.clampedInt(Ce.top,0,0,1e3),bottom:f.clampedInt(Ce.bottom,0,0,1e3)}}}class ge extends P{constructor(){const re={enabled:!0,cycle:!1};super(77,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:u.localize(65,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:u.localize(66,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:w(Ce.enabled,this.defaultValue.enabled),cycle:w(Ce.cycle,this.defaultValue.cycle)}}}class ve extends E{constructor(){super(130)}compute(re,Ce,ae){return re.pixelRatio}}class se extends P{constructor(){const re={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[u.localize(67,null),u.localize(68,null),u.localize(69,null)]}];super(80,"quickSuggestions",re,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:re.strings,description:u.localize(70,null)},comments:{anyOf:Ce,default:re.comments,description:u.localize(71,null)},other:{anyOf:Ce,default:re.other,description:u.localize(72,null)}},default:re,markdownDescription:u.localize(73,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean"){const Ze=re?"on":"off";return{comments:Ze,strings:Ze,other:Ze}}if(!re||typeof re!="object")return this.defaultValue;const{other:Ce,comments:ae,strings:Ie}=re,Ne=["on","inline","off"];let $e,Ge,qe;return typeof Ce=="boolean"?$e=Ce?"on":"off":$e=o(Ce,this.defaultValue.other,Ne),typeof ae=="boolean"?Ge=ae?"on":"off":Ge=o(ae,this.defaultValue.comments,Ne),typeof Ie=="boolean"?qe=Ie?"on":"off":qe=o(Ie,this.defaultValue.strings,Ne),{other:$e,comments:Ge,strings:qe}}}var be;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(be||(e.RenderLineNumbersType=be={}));class Te extends P{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(74,null),u.localize(75,null),u.localize(76,null),u.localize(77,null)],default:"on",description:u.localize(78,null)})}validate(re){let Ce=this.defaultValue.renderType,ae=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(Ce=4,ae=re):re==="interval"?Ce=3:re==="relative"?Ce=2:re==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:ae}}}function pe(J){const re=J.get(88);return re==="editable"?J.get(82):re!=="on"}e.filterValidationDecorations=pe;class we extends P{constructor(){const re=[],Ce={type:"number",description:u.localize(79,null)};super(92,"rulers",re,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:u.localize(80,null),format:"color-hex"}}}]},default:re,description:u.localize(81,null)})}validate(re){if(Array.isArray(re)){const Ce=[];for(let ae of re)if(typeof ae=="number")Ce.push({column:f.clampedInt(ae,0,0,1e4),color:null});else if(ae&&typeof ae=="object"){const Ie=ae;Ce.push({column:f.clampedInt(Ie.column,0,0,1e4),color:Ie.color})}return Ce.sort((ae,Ie)=>ae.column-Ie.column),Ce}return this.defaultValue}}function Ae(J,re){if(typeof J!="string")return re;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class ce extends P{constructor(){const re={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",re,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(82,null),u.localize(83,null),u.localize(84,null)],default:"auto",description:u.localize(85,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(86,null),u.localize(87,null),u.localize(88,null)],default:"auto",description:u.localize(89,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:re.verticalScrollbarSize,description:u.localize(90,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:re.horizontalScrollbarSize,description:u.localize(91,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:re.scrollByPage,description:u.localize(92,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re,ae=f.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ie=f.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ae(Ce.vertical,this.defaultValue.vertical),horizontal:Ae(Ce.horizontal,this.defaultValue.horizontal),useShadows:w(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:w(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:w(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:w(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:w(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ae,horizontalSliderSize:f.clampedInt(Ce.horizontalSliderSize,ae,0,1e3),verticalScrollbarSize:Ie,verticalSliderSize:f.clampedInt(Ce.verticalSliderSize,Ie,0,1e3),scrollByPage:w(Ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class me extends P{constructor(){const re={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(114,"unicodeHighlight",re,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.nonBasicASCII,description:u.localize(93,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:re.invisibleCharacters,description:u.localize(94,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:re.ambiguousCharacters,description:u.localize(95,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeComments,description:u.localize(96,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeStrings,description:u.localize(97,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:re.allowedCharacters,description:u.localize(98,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:re.allowedLocales,description:u.localize(99,null)}})}applyUpdate(re,Ce){let ae=!1;Ce.allowedCharacters&&(C.equals(re.allowedCharacters,Ce.allowedCharacters)||(re={...re,allowedCharacters:Ce.allowedCharacters},ae=!0)),Ce.allowedLocales&&(C.equals(re.allowedLocales,Ce.allowedLocales)||(re={...re,allowedLocales:Ce.allowedLocales},ae=!0));const Ie=super.applyUpdate(re,Ce);return ae?new S(Ie.newValue,!0):Ie}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{nonBasicASCII:x(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:w(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:w(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(re.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(re.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(re,Ce){if(typeof re!="object"||!re)return Ce;const ae={};for(const[Ie,Ne]of Object.entries(re))Ne===!0&&(ae[Ie]=!0);return ae}}class ie extends P{constructor(){const re={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:u.localize(100,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:w(Ce.enabled,this.defaultValue.enabled),mode:o(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends P{constructor(){const re={enabled:D.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:D.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",re,{"editor.bracketPairColorization.enabled":{type:"boolean",default:re.enabled,markdownDescription:u.localize(101,null)},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:re.independentColorPoolPerBracketType,description:u.localize(102,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:w(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:w(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class M extends P{constructor(){const re={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",re,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(103,null),u.localize(104,null),u.localize(105,null)],default:re.bracketPairs,description:u.localize(106,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(107,null),u.localize(108,null),u.localize(109,null)],default:re.bracketPairsHorizontal,description:u.localize(110,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:re.highlightActiveBracketPair,description:u.localize(111,null)},"editor.guides.indentation":{type:"boolean",default:re.indentation,description:u.localize(112,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[u.localize(113,null),u.localize(114,null),u.localize(115,null)],default:re.highlightActiveIndentation,description:u.localize(116,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{bracketPairs:x(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:w(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:w(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(J,re,Ce){const ae=Ce.indexOf(J);return ae===-1?re:Ce[ae]}class G extends P{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(107,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(117,null),u.localize(118,null)],default:re.insertMode,description:u.localize(119,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:u.localize(120,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:u.localize(121,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:u.localize(122,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:u.localize(123,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:u.localize(124,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:u.localize(125,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:u.localize(126,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:u.localize(127,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(128,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(129,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(130,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(131,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(132,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(133,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(134,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(135,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(136,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(137,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(138,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(139,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(140,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(141,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(142,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(143,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(144,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(145,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(146,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(147,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(148,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(149,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(150,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(151,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(152,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(153,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(154,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(155,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(156,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(157,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(158,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{insertMode:o(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:w(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:w(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:w(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:w(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:w(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:w(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:w(Ce.preview,this.defaultValue.preview),previewMode:o(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:w(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:w(Ce.showMethods,this.defaultValue.showMethods),showFunctions:w(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:w(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:w(Ce.showDeprecated,this.defaultValue.showDeprecated),showFields:w(Ce.showFields,this.defaultValue.showFields),showVariables:w(Ce.showVariables,this.defaultValue.showVariables),showClasses:w(Ce.showClasses,this.defaultValue.showClasses),showStructs:w(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:w(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:w(Ce.showModules,this.defaultValue.showModules),showProperties:w(Ce.showProperties,this.defaultValue.showProperties),showEvents:w(Ce.showEvents,this.defaultValue.showEvents),showOperators:w(Ce.showOperators,this.defaultValue.showOperators),showUnits:w(Ce.showUnits,this.defaultValue.showUnits),showValues:w(Ce.showValues,this.defaultValue.showValues),showConstants:w(Ce.showConstants,this.defaultValue.showConstants),showEnums:w(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:w(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:w(Ce.showKeywords,this.defaultValue.showKeywords),showWords:w(Ce.showWords,this.defaultValue.showWords),showColors:w(Ce.showColors,this.defaultValue.showColors),showFiles:w(Ce.showFiles,this.defaultValue.showFiles),showReferences:w(Ce.showReferences,this.defaultValue.showReferences),showFolders:w(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:w(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:w(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:w(Ce.showUsers,this.defaultValue.showUsers),showIssues:w(Ce.showIssues,this.defaultValue.showIssues)}}}class X extends P{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(159,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:w(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends E{constructor(){super(131)}compute(re,Ce,ae){return Ce.get(82)?!0:re.tabFocusMode}}var Ee;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(Ee||(e.WrappingIndent=Ee={}));function oe(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class De extends E{constructor(){super(133)}compute(re,Ce,ae){const Ie=Ce.get(132);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:Ie.isWordWrapMinified,isViewportWrapping:Ie.isViewportWrapping,wrappingColumn:Ie.wrappingColumn}}}const ye="Consolas, 'Courier New', monospace",ze="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:i.isMacintosh?ze:i.isLinux?Ve:ye,fontWeight:"normal",fontSize:i.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(J){return e.editorOptionsRegistry[J.id]=J,J}var Je;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.enableDropIntoEditor=32]="enableDropIntoEditor",J[J.emptySelectionClipboard=33]="emptySelectionClipboard",J[J.extraEditorClassName=34]="extraEditorClassName",J[J.fastScrollSensitivity=35]="fastScrollSensitivity",J[J.find=36]="find",J[J.fixedOverflowWidgets=37]="fixedOverflowWidgets",J[J.folding=38]="folding",J[J.foldingStrategy=39]="foldingStrategy",J[J.foldingHighlight=40]="foldingHighlight",J[J.foldingImportsByDefault=41]="foldingImportsByDefault",J[J.foldingMaximumRegions=42]="foldingMaximumRegions",J[J.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=44]="fontFamily",J[J.fontInfo=45]="fontInfo",J[J.fontLigatures=46]="fontLigatures",J[J.fontSize=47]="fontSize",J[J.fontWeight=48]="fontWeight",J[J.formatOnPaste=49]="formatOnPaste",J[J.formatOnType=50]="formatOnType",J[J.glyphMargin=51]="glyphMargin",J[J.gotoLocation=52]="gotoLocation",J[J.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",J[J.hover=54]="hover",J[J.inDiffEditor=55]="inDiffEditor",J[J.inlineSuggest=56]="inlineSuggest",J[J.letterSpacing=57]="letterSpacing",J[J.lightbulb=58]="lightbulb",J[J.lineDecorationsWidth=59]="lineDecorationsWidth",J[J.lineHeight=60]="lineHeight",J[J.lineNumbers=61]="lineNumbers",J[J.lineNumbersMinChars=62]="lineNumbersMinChars",J[J.linkedEditing=63]="linkedEditing",J[J.links=64]="links",J[J.matchBrackets=65]="matchBrackets",J[J.minimap=66]="minimap",J[J.mouseStyle=67]="mouseStyle",J[J.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=69]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",J[J.multiCursorModifier=71]="multiCursorModifier",J[J.multiCursorPaste=72]="multiCursorPaste",J[J.occurrencesHighlight=73]="occurrencesHighlight",J[J.overviewRulerBorder=74]="overviewRulerBorder",J[J.overviewRulerLanes=75]="overviewRulerLanes",J[J.padding=76]="padding",J[J.parameterHints=77]="parameterHints",J[J.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",J[J.quickSuggestions=80]="quickSuggestions",J[J.quickSuggestionsDelay=81]="quickSuggestionsDelay",J[J.readOnly=82]="readOnly",J[J.renameOnType=83]="renameOnType",J[J.renderControlCharacters=84]="renderControlCharacters",J[J.renderFinalNewline=85]="renderFinalNewline",J[J.renderLineHighlight=86]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=88]="renderValidationDecorations",J[J.renderWhitespace=89]="renderWhitespace",J[J.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",J[J.roundedSelection=91]="roundedSelection",J[J.rulers=92]="rulers",J[J.scrollbar=93]="scrollbar",J[J.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=95]="scrollBeyondLastLine",J[J.scrollPredominantAxis=96]="scrollPredominantAxis",J[J.selectionClipboard=97]="selectionClipboard",J[J.selectionHighlight=98]="selectionHighlight",J[J.selectOnLineNumbers=99]="selectOnLineNumbers",J[J.showFoldingControls=100]="showFoldingControls",J[J.showUnused=101]="showUnused",J[J.snippetSuggestions=102]="snippetSuggestions",J[J.smartSelect=103]="smartSelect",J[J.smoothScrolling=104]="smoothScrolling",J[J.stickyTabStops=105]="stickyTabStops",J[J.stopRenderingLineAfter=106]="stopRenderingLineAfter",J[J.suggest=107]="suggest",J[J.suggestFontSize=108]="suggestFontSize",J[J.suggestLineHeight=109]="suggestLineHeight",J[J.suggestOnTriggerCharacters=110]="suggestOnTriggerCharacters",J[J.suggestSelection=111]="suggestSelection",J[J.tabCompletion=112]="tabCompletion",J[J.tabIndex=113]="tabIndex",J[J.unicodeHighlighting=114]="unicodeHighlighting",J[J.unusualLineTerminators=115]="unusualLineTerminators",J[J.useShadowDOM=116]="useShadowDOM",J[J.useTabStops=117]="useTabStops",J[J.wordSeparators=118]="wordSeparators",J[J.wordWrap=119]="wordWrap",J[J.wordWrapBreakAfterCharacters=120]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=121]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=122]="wordWrapColumn",J[J.wordWrapOverride1=123]="wordWrapOverride1",J[J.wordWrapOverride2=124]="wordWrapOverride2",J[J.wrappingIndent=125]="wrappingIndent",J[J.wrappingStrategy=126]="wrappingStrategy",J[J.showDeprecated=127]="showDeprecated",J[J.inlayHints=128]="inlayHints",J[J.editorClassName=129]="editorClassName",J[J.pixelRatio=130]="pixelRatio",J[J.tabFocusMode=131]="tabFocusMode",J[J.layoutInfo=132]="layoutInfo",J[J.wrappingInfo=133]="wrappingInfo"})(Je||(e.EditorOption=Je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(160,null)})),acceptSuggestionOnEnter:Me(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(161,null),""],markdownDescription:u.localize(162,null)})),accessibilitySupport:Me(new n),accessibilityPageSize:Me(new f(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(163,null)})),ariaLabel:Me(new m(4,"ariaLabel",u.localize(164,null))),autoClosingBrackets:Me(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(165,null),u.localize(166,null),""],description:u.localize(167,null)})),autoClosingDelete:Me(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(168,null),""],description:u.localize(169,null)})),autoClosingOvertype:Me(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(170,null),""],description:u.localize(171,null)})),autoClosingQuotes:Me(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(172,null),u.localize(173,null),""],description:u.localize(174,null)})),autoIndent:Me(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[u.localize(175,null),u.localize(176,null),u.localize(177,null),u.localize(178,null),u.localize(179,null)],description:u.localize(180,null)})),automaticLayout:Me(new g(10,"automaticLayout",!1)),autoSurround:Me(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(181,null),u.localize(182,null),u.localize(183,null),""],description:u.localize(184,null)})),bracketPairColorization:Me(new ee),bracketPairGuides:Me(new M),stickyTabStops:Me(new g(105,"stickyTabStops",!1,{description:u.localize(185,null)})),codeLens:Me(new g(14,"codeLens",!0,{description:u.localize(186,null)})),codeLensFontFamily:Me(new m(15,"codeLensFontFamily","",{description:u.localize(187,null)})),codeLensFontSize:Me(new f(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(188,null)})),colorDecorators:Me(new g(17,"colorDecorators",!0,{description:u.localize(189,null)})),columnSelection:Me(new g(18,"columnSelection",!1,{description:u.localize(190,null)})),comments:Me(new t),contextmenu:Me(new g(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new g(21,"copyWithSyntaxHighlighting",!0,{description:u.localize(191,null)})),cursorBlinking:Me(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:u.localize(192,null)})),cursorSmoothCaretAnimation:Me(new g(23,"cursorSmoothCaretAnimation",!1,{description:u.localize(193,null)})),cursorStyle:Me(new r(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:u.localize(194,null)})),cursorSurroundingLines:Me(new f(25,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(195,null)})),cursorSurroundingLinesStyle:Me(new d(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(196,null),u.localize(197,null)],description:u.localize(198,null)})),cursorWidth:Me(new f(27,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(199,null)})),disableLayerHinting:Me(new g(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new g(29,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new g(30,"domReadOnly",!1)),dragAndDrop:Me(new g(31,"dragAndDrop",!0,{description:u.localize(200,null)})),emptySelectionClipboard:Me(new O),enableDropIntoEditor:Me(new g(32,"enableDropIntoEditor",!0)),extraEditorClassName:Me(new m(34,"extraEditorClassName","")),fastScrollSensitivity:Me(new a(35,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:u.localize(201,null)})),find:Me(new k),fixedOverflowWidgets:Me(new g(37,"fixedOverflowWidgets",!1)),folding:Me(new g(38,"folding",!0,{description:u.localize(202,null)})),foldingStrategy:Me(new d(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(203,null),u.localize(204,null)],description:u.localize(205,null)})),foldingHighlight:Me(new g(40,"foldingHighlight",!0,{description:u.localize(206,null)})),foldingImportsByDefault:Me(new g(41,"foldingImportsByDefault",!1,{description:u.localize(207,null)})),foldingMaximumRegions:Me(new f(42,"foldingMaximumRegions",5e3,10,65e3,{description:u.localize(208,null)})),unfoldOnClickAfterEndOfLine:Me(new g(43,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(209,null)})),fontFamily:Me(new m(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(210,null)})),fontInfo:Me(new B),fontLigatures2:Me(new U),fontSize:Me(new z),fontWeight:Me(new Y),formatOnPaste:Me(new g(49,"formatOnPaste",!1,{description:u.localize(211,null)})),formatOnType:Me(new g(50,"formatOnType",!1,{description:u.localize(212,null)})),glyphMargin:Me(new g(51,"glyphMargin",!0,{description:u.localize(213,null)})),gotoLocation:Me(new $),hideCursorInOverviewRuler:Me(new g(53,"hideCursorInOverviewRuler",!1,{description:u.localize(214,null)})),hover:Me(new N),inDiffEditor:Me(new g(55,"inDiffEditor",!1)),letterSpacing:Me(new a(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>a.clamp(J,-5,20),{description:u.localize(215,null)})),lightbulb:Me(new q),lineDecorationsWidth:Me(new v(59,"lineDecorationsWidth",10)),lineHeight:Me(new fe),lineNumbers:Me(new Te),lineNumbersMinChars:Me(new f(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new g(63,"linkedEditing",!1,{description:u.localize(216,null)})),links:Me(new g(64,"links",!0,{description:u.localize(217,null)})),matchBrackets:Me(new d(65,"matchBrackets","always",["always","near","never"],{description:u.localize(218,null)})),minimap:Me(new ne),mouseStyle:Me(new d(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new a(68,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:u.localize(219,null)})),mouseWheelZoom:Me(new g(69,"mouseWheelZoom",!1,{markdownDescription:u.localize(220,null)})),multiCursorMergeOverlapping:Me(new g(70,"multiCursorMergeOverlapping",!0,{description:u.localize(221,null)})),multiCursorModifier:Me(new r(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[u.localize(222,null),u.localize(223,null)],markdownDescription:u.localize(224,null)})),multiCursorPaste:Me(new d(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(225,null),u.localize(226,null)],markdownDescription:u.localize(227,null)})),occurrencesHighlight:Me(new g(73,"occurrencesHighlight",!0,{description:u.localize(228,null)})),overviewRulerBorder:Me(new g(74,"overviewRulerBorder",!0,{description:u.localize(229,null)})),overviewRulerLanes:Me(new f(75,"overviewRulerLanes",3,0,3)),padding:Me(new K),parameterHints:Me(new ge),peekWidgetDefaultFocus:Me(new d(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(230,null),u.localize(231,null)],description:u.localize(232,null)})),definitionLinkOpensInPeek:Me(new g(79,"definitionLinkOpensInPeek",!1,{description:u.localize(233,null)})),quickSuggestions:Me(new se),quickSuggestionsDelay:Me(new f(81,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(234,null)})),readOnly:Me(new g(82,"readOnly",!1)),renameOnType:Me(new g(83,"renameOnType",!1,{description:u.localize(235,null),markdownDeprecationMessage:u.localize(236,null)})),renderControlCharacters:Me(new g(84,"renderControlCharacters",!0,{description:u.localize(237,null),restricted:!0})),renderFinalNewline:Me(new g(85,"renderFinalNewline",!0,{description:u.localize(238,null)})),renderLineHighlight:Me(new d(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(239,null)],description:u.localize(240,null)})),renderLineHighlightOnlyWhenFocus:Me(new g(87,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(241,null)})),renderValidationDecorations:Me(new d(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new d(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(242,null),u.localize(243,null),u.localize(244,null),""],description:u.localize(245,null)})),revealHorizontalRightPadding:Me(new f(90,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Me(new g(91,"roundedSelection",!0,{description:u.localize(246,null)})),rulers:Me(new we),scrollbar:Me(new ce),scrollBeyondLastColumn:Me(new f(94,"scrollBeyondLastColumn",5,0,1073741824,{description:u.localize(247,null)})),scrollBeyondLastLine:Me(new g(95,"scrollBeyondLastLine",!0,{description:u.localize(248,null)})),scrollPredominantAxis:Me(new g(96,"scrollPredominantAxis",!0,{description:u.localize(249,null)})),selectionClipboard:Me(new g(97,"selectionClipboard",!0,{description:u.localize(250,null),included:i.isLinux})),selectionHighlight:Me(new g(98,"selectionHighlight",!0,{description:u.localize(251,null)})),selectOnLineNumbers:Me(new g(99,"selectOnLineNumbers",!0)),showFoldingControls:Me(new d(100,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[u.localize(252,null),u.localize(253,null)],description:u.localize(254,null)})),showUnused:Me(new g(101,"showUnused",!0,{description:u.localize(255,null)})),showDeprecated:Me(new g(127,"showDeprecated",!0,{description:u.localize(256,null)})),inlayHints:Me(new te),snippetSuggestions:Me(new d(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(257,null),u.localize(258,null),u.localize(259,null),u.localize(260,null)],description:u.localize(261,null)})),smartSelect:Me(new X),smoothScrolling:Me(new g(104,"smoothScrolling",!1,{description:u.localize(262,null)})),stopRenderingLineAfter:Me(new f(106,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new G),inlineSuggest:Me(new ie),suggestFontSize:Me(new f(108,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(263,null)})),suggestLineHeight:Me(new f(109,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(264,null)})),suggestOnTriggerCharacters:Me(new g(110,"suggestOnTriggerCharacters",!0,{description:u.localize(265,null)})),suggestSelection:Me(new d(111,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(266,null),u.localize(267,null),u.localize(268,null)],description:u.localize(269,null)})),tabCompletion:Me(new d(112,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(270,null),u.localize(271,null),u.localize(272,null)],description:u.localize(273,null)})),tabIndex:Me(new f(113,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new me),unusualLineTerminators:Me(new d(115,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(274,null),u.localize(275,null),u.localize(276,null)],description:u.localize(277,null)})),useShadowDOM:Me(new g(116,"useShadowDOM",!0)),useTabStops:Me(new g(117,"useTabStops",!0,{description:u.localize(278,null)})),wordSeparators:Me(new m(118,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:u.localize(279,null)})),wordWrap:Me(new d(119,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(280,null),u.localize(281,null),u.localize(282,null),u.localize(283,null)],description:u.localize(284,null)})),wordWrapBreakAfterCharacters:Me(new m(120,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new m(121,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new f(122,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(285,null)})),wordWrapOverride1:Me(new d(123,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new d(124,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Me(new r(125,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],oe,{enumDescriptions:[u.localize(286,null),u.localize(287,null),u.localize(288,null),u.localize(289,null)],description:u.localize(290,null)})),wrappingStrategy:Me(new d(126,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[u.localize(291,null),u.localize(292,null)],description:u.localize(293,null)})),editorClassName:Me(new F),pixelRatio:Me(new ve),tabFocusMode:Me(new de),layoutInfo:Me(new H),wrappingInfo:Me(new De)}}),define(ke[163],Pe([19,20]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[164],Pe([19,20]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[165],Pe([19,20]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[166],Pe([19,20]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[167],Pe([19,20]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ke[168],Pe([19,20]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(ke[169],Pe([19,20]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(ke[170],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[171],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[172],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[173],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[174],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[175],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[176],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[177],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[178],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ke[179],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/common/editor",e)}),define(ke[180],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[181],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[182],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[183],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[184],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[185],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[186],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[187],Pe([19,20]),function(Q,e){return Q.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[188],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var u;(function(D){D[D.ACTIVATE=1]="ACTIVATE",D[D.RESTORE=2]="RESTORE",D[D.PRESERVE=3]="PRESERVE"})(u||(e.EditorActivation=u={}));var i;(function(D){D[D.PICK=0]="PICK",D[D.DISABLED=1]="DISABLED",D[D.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(i||(e.EditorResolution=i={}));var y;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(y||(e.EditorOpenSource=y={}));var A;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A||(e.TextEditorSelectionRevealType=A={}));var C;(function(D){D.PROGRAMMATIC="api",D.NAVIGATION="code.navigation",D.JUMP="code.jump"})(C||(e.TextEditorSelectionSource=C={}))}),define(ke[189],Pe([1,0,22,41,165,299]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function b(g){return g=g.trim(),g==="*"||C.test(g)}e.isValidVersionStr=b;function T(g){if(!b(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let _=g.match(C);return _?{hasCaret:_[1]==="^",hasGreaterEquals:_[1]===">=",majorBase:_[2]==="x"?0:parseInt(_[2],10),majorMustEqual:_[2]!=="x",minorBase:_[4]==="x"?0:parseInt(_[4],10),minorMustEqual:_[4]!=="x",patchBase:_[6]==="x"?0:parseInt(_[6],10),patchMustEqual:_[6]!=="x",preRelease:_[8]||null}:null}e.parseVersion=T;function L(g){if(!g)return null;let _=g.majorBase,f=g.majorMustEqual,a=g.minorBase,m=g.minorMustEqual,o=g.patchBase,d=g.patchMustEqual;g.hasCaret&&(_===0||(m=!1),d=!1);let r=0;if(g.preRelease){const s=D.exec(g.preRelease);if(s){const[,n,t,c]=s;r=Date.UTC(Number(n),Number(t)-1,Number(c))}}return{majorBase:_,majorMustEqual:f,minorBase:a,minorMustEqual:m,patchBase:o,patchMustEqual:d,isMinimum:g.hasGreaterEquals,notBefore:r}}e.normalizeVersion=L;function P(g,_,f){let a;typeof g=="string"?a=L(T(g)):a=g;let m;_ instanceof Date?m=_.getTime():typeof _=="string"&&(m=new Date(_).getTime());let o;if(typeof f=="string"?o=L(T(f)):o=f,!a||!o)return!1;let d=a.majorBase,r=a.minorBase,s=a.patchBase,n=o.majorBase,t=o.minorBase,c=o.patchBase,l=o.notBefore,h=o.majorMustEqual,p=o.minorMustEqual,R=o.patchMustEqual;return o.isMinimum?d>n?!0:d<n?!1:r>t?!0:r<t||m&&m<l?!1:s>=c:(d===1&&n===0&&(!h||!p||!R)&&(n=1,t=0,c=0,h=!0,p=!1,R=!1),d<n?!1:d>n?!h:r<t?!1:r>t?!p:s<c?!1:s>c?!R:!(m&&m<l))}e.isValidVersion=P;function S(g,_,f,a,m){const o=[];if(typeof a.publisher!="undefined"&&typeof a.publisher!="string")return o.push([i.default.Error,y.localize(0,null)]),o;if(typeof a.name!="string")return o.push([i.default.Error,y.localize(1,null,"name")]),o;if(typeof a.version!="string")return o.push([i.default.Error,y.localize(2,null,"version")]),o;if(!a.engines)return o.push([i.default.Error,y.localize(3,null,"engines")]),o;if(typeof a.engines.vscode!="string")return o.push([i.default.Error,y.localize(4,null,"engines.vscode")]),o;if(typeof a.extensionDependencies!="undefined"&&!w(a.extensionDependencies))return o.push([i.default.Error,y.localize(5,null,"extensionDependencies")]),o;if(typeof a.activationEvents!="undefined"){if(!w(a.activationEvents))return o.push([i.default.Error,y.localize(6,null,"activationEvents")]),o;if(typeof a.main=="undefined"&&typeof a.browser=="undefined")return o.push([i.default.Error,y.localize(7,null,"activationEvents","main")]),o}if(typeof a.extensionKind!="undefined"&&typeof a.main=="undefined"&&o.push([i.default.Warning,y.localize(8,null,"extensionKind")]),typeof a.main!="undefined"){if(typeof a.main!="string")return o.push([i.default.Error,y.localize(9,null,"main")]),o;{const s=(0,u.joinPath)(f,a.main);(0,u.isEqualOrParent)(s,f)||o.push([i.default.Warning,y.localize(10,null,s.path,f.path)])}if(typeof a.activationEvents=="undefined")return o.push([i.default.Error,y.localize(11,null,"activationEvents","main")]),o}if(typeof a.browser!="undefined"){if(typeof a.browser!="string")return o.push([i.default.Error,y.localize(12,null,"browser")]),o;{const s=(0,u.joinPath)(f,a.browser);(0,u.isEqualOrParent)(s,f)||o.push([i.default.Warning,y.localize(13,null,s.path,f.path)])}if(typeof a.activationEvents=="undefined")return o.push([i.default.Error,y.localize(14,null,"activationEvents","browser")]),o}if(!A.valid(a.version))return o.push([i.default.Error,y.localize(15,null)]),o;const d=[];if(!I(g,_,a,m,d))for(const s of d)o.push([i.default.Error,s]);return o}e.validateExtensionManifest=S;function I(g,_,f,a,m){return a||typeof f.main=="undefined"&&typeof f.browser=="undefined"?!0:v(g,_,f.engines.vscode,m)}e.isValidExtensionVersion=I;function E(g,_,f){return g==="*"||v(_,f,g)}e.isEngineValid=E;function v(g,_,f,a=[]){let m=L(T(f));if(!m)return a.push(y.localize(16,null,f)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return a.push(y.localize(17,null,f)),!1}else if(!m.majorMustEqual)return a.push(y.localize(18,null,f)),!1;return P(g,_,m)?!0:(a.push(y.localize(19,null,g,f)),!1)}function w(g){if(!Array.isArray(g))return!1;for(let _=0,f=g.length;_<f;_++)if(typeof g[_]!="string")return!1;return!0}}),define(ke[115],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class u{constructor(y,A=[],C=!1){this.ctor=y,this.staticArguments=A,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=u}),define(ke[83],Pe([1,0,115]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function y(C,D,b){D instanceof u.SyncDescriptor||(D=new u.SyncDescriptor(D,[],b)),i.push([C,D])}e.registerSingleton=y;function A(){return i}e.getSingletonServiceDescriptors=A}),define(ke[190],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class u{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=u;class i{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let C of this._nodes.values())C.outgoing.size===0&&A.push(C);return A}insertEdge(A,C){const D=this.lookupOrInsertNode(A),b=this.lookupOrInsertNode(C);D.outgoing.set(this._hashFn(C),b),b.incoming.set(this._hashFn(A),D)}removeNode(A){const C=this._hashFn(A);this._nodes.delete(C);for(let D of this._nodes.values())D.outgoing.delete(C),D.incoming.delete(C)}lookupOrInsertNode(A){const C=this._hashFn(A);let D=this._nodes.get(C);return D||(D=new u(A),this._nodes.set(C,D)),D}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[C,D]of this._nodes)A.push(`${C}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,C]of this._nodes){const D=new Set([A]),b=this._findCycle(C,D);if(b)return b}}_findCycle(A,C){for(let[D,b]of A.outgoing){if(C.has(D))return[...C,D].join(" -> ");C.add(D);const T=this._findCycle(b,C);if(T)return T;C.delete(D)}}}e.Graph=i}),define(ke[4],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var u;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(b){return b[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(u||(e._util=u={})),e.IInstantiationService=y("instantiationService");function i(C,D,b){D[u.DI_TARGET]===D?D[u.DI_DEPENDENCIES].push({id:C,index:b}):(D[u.DI_DEPENDENCIES]=[{id:C,index:b}],D[u.DI_TARGET]=D)}function y(C){if(u.serviceIds.has(C))return u.serviceIds.get(C);const D=function(b,T,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(D,b,L)};return D.toString=()=>C,u.serviceIds.set(C,D),D}e.createDecorator=y;function A(C){return C}e.refineServiceDecorator=A}),define(ke[84],Pe([1,0,12,2,4]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function A(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof i.URI)}e.isConfigurationOverrides=A;function C(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||u.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=C;var D;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(D||(e.ConfigurationTarget=D={}));function b(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function T(g,_){const f=Object.create(null);for(let a in g)L(f,a,g[a],_);return f}e.toValuesTree=T;function L(g,_,f,a){const m=_.split("."),o=m.pop();let d=g;for(let r=0;r<m.length;r++){let s=m[r],n=d[s];switch(typeof n){case"undefined":n=d[s]=Object.create(null);break;case"object":break;default:a(`Ignoring ${_} as ${m.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}d=n}if(typeof d=="object"&&d!==null)try{d[o]=f}catch{a(`Ignoring ${_} as ${m.join(".")} is ${JSON.stringify(d)}`)}else a(`Ignoring ${_} as ${m.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=L;function P(g,_){const f=_.split(".");S(g,f)}e.removeFromValueTree=P;function S(g,_){const f=_.shift();if(_.length===0){delete g[f];return}if(Object.keys(g).indexOf(f)!==-1){const a=g[f];typeof a=="object"&&!Array.isArray(a)&&(S(a,_),Object.keys(a).length===0&&delete g[f])}}function I(g,_,f){function a(d,r){let s=d;for(const n of r){if(typeof s!="object"||s===null)return;s=s[n]}return s}const m=_.split("."),o=a(g,m);return typeof o=="undefined"?f:o}e.getConfigurationValue=I;function E(g,_,f){Object.keys(_).forEach(a=>{a!=="__proto__"&&(a in g?u.isObject(g[a])&&u.isObject(_[a])?E(g[a],_[a],f):f&&(g[a]=_[a]):g[a]=_[a])})}e.merge=E;function v(g,_,f){const a=g.inspect(_),m=g.inspect(f);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:a.defaultValue}e.getMigratedSettingValue=v;function w(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(ke[52],Pe([1,0,13,8,4]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",u.isMacintosh),A.set("isLinux",u.isLinux),A.set("isWindows",u.isWindows),A.set("isWeb",u.isWeb),A.set("isMacNative",u.isMacintosh&&!u.isWeb),A.set("isEdge",u.isEdge),A.set("isFirefox",u.isFirefox),A.set("isChrome",u.isChrome),A.set("isSafari",u.isSafari);const C=Object.prototype.hasOwnProperty;var D;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));class b{static false(){return P.INSTANCE}static true(){return S.INSTANCE}static has(k){return I.create(k)}static equals(k,U){return E.create(k,U)}static notEquals(k,U){return g.create(k,U)}static regex(k,U){return r.create(k,U)}static in(k,U){return v.create(k,U)}static not(k){return _.create(k)}static and(...k){return t.create(k,null)}static or(...k){return c.create(k,null,!0)}static greater(k,U){return a.create(k,U)}static greaterEquals(k,U){return m.create(k,U)}static smaller(k,U){return o.create(k,U)}static smallerEquals(k,U){return d.create(k,U)}static deserialize(k,U=!1){if(!!k)return this._deserializeOrExpression(k,U)}static _deserializeOrExpression(k,U){let B=k.split("||");return c.create(B.map(z=>this._deserializeAndExpression(z,U)),null,!0)}static _deserializeAndExpression(k,U){let B=k.split("&&");return t.create(B.map(z=>this._deserializeOne(z,U)),null)}static _deserializeOne(k,U){if(k=k.trim(),k.indexOf("!=")>=0){let B=k.split("!=");return g.create(B[0].trim(),this._deserializeValue(B[1],U))}if(k.indexOf("==")>=0){let B=k.split("==");return E.create(B[0].trim(),this._deserializeValue(B[1],U))}if(k.indexOf("=~")>=0){let B=k.split("=~");return r.create(B[0].trim(),this._deserializeRegexValue(B[1],U))}if(k.indexOf(" in ")>=0){let B=k.split(" in ");return v.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const B=k.split(">=");return m.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const B=k.split(">");return a.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const B=k.split("<=");return d.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const B=k.split("<");return o.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(k)?_.create(k.substr(1).trim()):I.create(k)}static _deserializeValue(k,U){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;let B=/^'([^']*)'$/.exec(k);return B?B[1].trim():k}static _deserializeRegexValue(k,U){if((0,i.isFalsyOrWhitespace)(k)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let B=k.indexOf("/"),z=k.lastIndexOf("/");if(B===z||B<0){if(U)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}let Y=k.slice(B+1,z),$=k[z+1]==="i"?"i":"";try{return new RegExp(Y,$)}catch(N){if(U)throw new Error(`bad regexp-value '${k}', parse error: ${N}`);return console.warn(`bad regexp-value '${k}', parse error: ${N}`),null}}}e.ContextKeyExpr=b;function T(O,k){const U=O?O.substituteConstants():void 0,B=k?k.substituteConstants():void 0;return!U&&!B?!0:!U||!B?!1:U.equals(B)}e.expressionsAreEqualWithConstantSubstitution=T;function L(O,k){return O.cmp(k)}class P{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class S{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class I{static create(k,U=null){const B=A.get(k);return typeof B=="boolean"?B?S.INSTANCE:P.INSTANCE:new I(k,U)}constructor(k,U){this.key=k,this.negated=U,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:h(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=A.get(this.key);return typeof k=="boolean"?k?S.INSTANCE:P.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=I;class E{static create(k,U,B=null){if(typeof U=="boolean")return U?I.create(k,B):_.create(k,B);const z=A.get(k);return typeof z=="boolean"?U===(z?"true":"false")?S.INSTANCE:P.INSTANCE:new E(k,U,B)}constructor(k,U,B){this.key=k,this.value=U,this.negated=B,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:p(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=A.get(this.key);if(typeof k=="boolean"){const U=k?"true":"false";return this.value===U?S.INSTANCE:P.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=E;class v{static create(k,U){return new v(k,U)}constructor(k,U){this.key=k,this.valueKey=U,this.type=10,this.negated=null}cmp(k){return k.type!==this.type?this.type-k.type:p(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const U=k.getValue(this.valueKey),B=k.getValue(this.key);return Array.isArray(U)?U.includes(B):typeof B=="string"&&typeof U=="object"&&U!==null?C.call(U,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this)),this.negated}}e.ContextKeyInExpr=v;class w{static create(k){return new w(k)}constructor(k){this._actual=k,this.type=11}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new w(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class g{static create(k,U,B=null){if(typeof U=="boolean")return U?_.create(k,B):I.create(k,B);const z=A.get(k);return typeof z=="boolean"?U===(z?"true":"false")?P.INSTANCE:S.INSTANCE:new g(k,U,B)}constructor(k,U,B){this.key=k,this.value=U,this.negated=B,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:p(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=A.get(this.key);if(typeof k=="boolean"){const U=k?"true":"false";return this.value===U?P.INSTANCE:S.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class _{static create(k,U=null){const B=A.get(k);return typeof B=="boolean"?B?P.INSTANCE:S.INSTANCE:new _(k,U)}constructor(k,U){this.key=k,this.negated=U,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:h(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=A.get(this.key);return typeof k=="boolean"?k?P.INSTANCE:S.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function f(O,k){if(typeof O=="string"){const U=parseFloat(O);isNaN(U)||(O=U)}return typeof O=="string"||typeof O=="number"?k(O):P.INSTANCE}class a{static create(k,U,B=null){return f(U,z=>new a(k,z,B))}constructor(k,U,B){this.key=k,this.value=U,this.negated=B,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:p(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class m{static create(k,U,B=null){return f(U,z=>new m(k,z,B))}constructor(k,U,B){this.key=k,this.value=U,this.negated=B,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:p(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=m;class o{static create(k,U,B=null){return f(U,z=>new o(k,z,B))}constructor(k,U,B){this.key=k,this.value=U,this.negated=B,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:p(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class d{static create(k,U,B=null){return f(U,z=>new d(k,z,B))}constructor(k,U,B){this.key=k,this.value=U,this.negated=B,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:p(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=d;class r{static create(k,U){return new r(k,U)}constructor(k,U){this.key=k,this.regexp=U,this.type=7,this.negated=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const U=this.regexp?this.regexp.source:"",B=k.regexp?k.regexp.source:"";return U<B?-1:U>B?1:0}equals(k){if(k.type===this.type){const U=this.regexp?this.regexp.source:"",B=k.regexp?k.regexp.source:"";return this.key===k.key&&U===B}return!1}substituteConstants(){return this}evaluate(k){let U=k.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class s{static create(k){return new s(k)}constructor(k){this._actual=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new s(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function n(O){let k=null;for(let U=0,B=O.length;U<B;U++){const z=O[U].substituteConstants();if(O[U]!==z&&k===null){k=[];for(let Y=0;Y<U;Y++)k[Y]=O[Y]}k!==null&&(k[U]=z)}return k===null?O:k}class t{static create(k,U){return t._normalizeArr(k,U)}constructor(k,U){this.expr=k,this.negated=U,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,B=this.expr.length;U<B;U++){const z=L(this.expr[U],k.expr[U]);if(z!==0)return z}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=n(this.expr);return k===this.expr?this:t.create(k,this.negated)}evaluate(k){for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].evaluate(k))return!1;return!0}static _normalizeArr(k,U){const B=[];let z=!1;for(const Y of k)if(!!Y){if(Y.type===1){z=!0;continue}if(Y.type===0)return P.INSTANCE;if(Y.type===6){B.push(...Y.expr);continue}B.push(Y)}if(B.length===0&&z)return S.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(L);for(let Y=1;Y<B.length;Y++)B[Y-1].equals(B[Y])&&(B.splice(Y,1),Y--);if(B.length===1)return B[0];for(;B.length>1;){const Y=B[B.length-1];if(Y.type!==9)break;B.pop();const $=B.pop(),N=B.length===0,V=c.create(Y.expr.map(H=>t.create([H,$],null)),null,N);V&&(B.push(V),B.sort(L))}return B.length===1?B[0]:new t(B,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(let U of this.expr)k.push(...U.keys());return k}map(k){return new t(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.negated){const k=[];for(let U of this.expr)k.push(U.negate());this.negated=c.create(k,this,!0)}return this.negated}}class c{static create(k,U,B){return c._normalizeArr(k,U,B)}constructor(k,U){this.expr=k,this.negated=U,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,B=this.expr.length;U<B;U++){const z=L(this.expr[U],k.expr[U]);if(z!==0)return z}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=n(this.expr);return k===this.expr?this:c.create(k,this.negated,!1)}evaluate(k){for(let U=0,B=this.expr.length;U<B;U++)if(this.expr[U].evaluate(k))return!0;return!1}static _normalizeArr(k,U,B){let z=[],Y=!1;if(k){for(let $=0,N=k.length;$<N;$++){const V=k[$];if(!!V){if(V.type===0){Y=!0;continue}if(V.type===1)return S.INSTANCE;if(V.type===9){z=z.concat(V.expr);continue}z.push(V)}}if(z.length===0&&Y)return P.INSTANCE;z.sort(L)}if(z.length!==0){if(z.length===1)return z[0];for(let $=1;$<z.length;$++)z[$-1].equals(z[$])&&(z.splice($,1),$--);if(z.length===1)return z[0];if(B){for(let $=0;$<z.length;$++)for(let N=$+1;N<z.length;N++)R(z[$],z[N])&&(z.splice(N,1),N--);if(z.length===1)return z[0]}return new c(z,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(let U of this.expr)k.push(...U.keys());return k}map(k){return new c(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.negated){let k=[];for(let U of this.expr)k.push(U.negate());for(;k.length>1;){const U=k.shift(),B=k.shift(),z=[];for(const $ of F(U))for(const N of F(B))z.push(t.create([$,N],null));const Y=k.length===0;k.unshift(c.create(z,null,Y))}this.negated=k[0]}return this.negated}}class l extends I{static all(){return l._info.values()}constructor(k,U,B){super(k,null);this._defaultValue=U,typeof B=="object"?l._info.push({...B,key:k}):B!==!0&&l._info.push({key:k,description:B,type:U!=null?typeof U:void 0})}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return E.create(this.key,k)}notEqualsTo(k){return g.create(this.key,k)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(O,k){return O<k?-1:O>k?1:0}function p(O,k,U,B){return O<U?-1:O>U?1:k<B?-1:k>B?1:0}function R(O,k){if(k.type===6&&O.type!==9&&O.type!==6){for(const z of k.expr)if(O.equals(z))return!0}const U=O.negate(),B=F(U).concat(F(k));B.sort(L);for(let z=0;z<B.length;z++){const $=B[z].negate();for(let N=z+1;N<B.length;N++){const V=B[N];if($.equals(V))return!0}}return!1}e.implies=R;function F(O){return O.type===9?O.expr:[O]}}),define(ke[191],Pe([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,u.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,u.refineServiceDecorator)(e.IEnvironmentService)}),define(ke[85],Pe([1,0,164,4]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function A(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function C(g,_){switch(g){case 3:return _==="x64"?"win32-x64":_==="ia32"?"win32-ia32":_==="arm64"?"win32-arm64":"unknown";case 2:return _==="x64"?"linux-x64":_==="arm64"?"linux-arm64":_==="arm"?"linux-armhf":"unknown";case"alpine":return _==="x64"?"alpine-x64":_==="arm64"?"alpine-arm64":"unknown";case 1:return _==="x64"?"darwin-x64":_==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function D(g,_){return _==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function b(g,_,f){return D(_,f)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===f?!0:T(f).includes(g)}e.isTargetPlatformCompatible=b;function T(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=T;function L(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=L;var P;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var S;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var I;(function(g){g.Install="install",g.Uninstall="uninstall"})(I||(e.StatisticType=I={}));var E;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var v;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));class w extends Error{constructor(_,f){super(_);this.code=f,this.name=f}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,u.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,u.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,i.createDecorator)("IExtensionManagementCLIService")}),define(ke[192],Pe([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,u.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,u.createDecorator)("externalTerminal")}),define(ke[193],Pe([1,0,42,10,9,13,96,29,113,166,192]),function(Q,e,u,i,y,A,C,D,b,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=T.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:I.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class I extends S{openTerminal(a,m){return this.spawnTerminal(u,a,b.getWindowsShell(),m)}spawnTerminal(a,m,o,d){const r=m.windowsExec||I.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const s=y.basename(r).toLowerCase();if(s==="cmder"||s==="cmder.exe")return a.spawn(r,d?[d]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),(s==="wt"||s==="wt.exe")&&n.push("-d ."),new Promise((t,c)=>{const l=w(process),h=a.spawn(o,n,{cwd:d,env:l});h.on("error",c),h.on("exit",()=>t())})}runInTerminal(a,m,o,d,r){const s="windowsExec"in r&&r.windowsExec?r.windowsExec:I.getDefaultTerminalWindows();return new Promise((n,t)=>{const c=`"${m} - ${P}"`,l=`""${o.join('" "')}" & pause"`,h=["/c","start",c,"/wait",s,"/c",l],p=Object.assign({},w(process),d);Object.keys(p).filter(O=>p[O]===null).forEach(O=>delete p[O]);const R={cwd:m,env:p,windowsVerbatimArguments:!0};u.spawn(I.CMD,h,R).on("error",O=>{t(g(O))}),n(void 0)})}static getDefaultTerminalWindows(){if(!I._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");I._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return I._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=I,I.CMD="cmd.exe";class E extends S{openTerminal(a,m){return this.spawnTerminal(u,a,m)}runInTerminal(a,m,o,d,r){const s=r.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{if(s===L.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const c=s===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[i.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,Q).fsPath,"-t",a||P,"-w",m];for(let F of o)h.push("-a"),h.push(F);if(d){const F=Object.assign({},w(process),d);for(let O in F){const k=F[O];k===null?(h.push("-u"),h.push(O)):(h.push("-e"),h.push(`${O}=${k}`))}}let p="";const R=u.spawn(E.OSASCRIPT,h);R.on("error",F=>{t(g(F))}),R.stderr.on("data",F=>{p+=F.toString()}),R.on("exit",F=>{if(F===0)n(void 0);else if(p){const O=p.split(`
`,1);t(new Error(O[0]))}else t(new Error(T.localize(1,null,c,F)))})}else t(new Error(T.localize(2,null,s)))})}spawnTerminal(a,m,o){const d=m.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{const n=["-a",d];o&&n.push(o);const t=w(process),c=a.spawn("/usr/bin/open",n,{cwd:o,env:t});c.on("error",s),c.on("exit",()=>r())})}}e.MacExternalTerminalService=E,E.OSASCRIPT="/usr/bin/osascript";class v extends S{openTerminal(a,m){return this.spawnTerminal(u,a,m)}runInTerminal(a,m,o,d,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{let c=[];s.then(l=>{l.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const h=`${_(o)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;c.push(`''${h}''`);const p=Object.assign({},w(process),d);Object.keys(p).filter(k=>p[k]===null).forEach(k=>delete p[k]);const R={cwd:m,env:p};let F="";const O=u.spawn(l,c,R);O.on("error",k=>{t(g(k))}),O.stderr.on("data",k=>{F+=k.toString()}),O.on("exit",k=>{if(k===0)n(void 0);else if(F){const U=F.split(`
`,1);t(new Error(U[0]))}else t(new Error(T.localize(4,null,l,k)))})})})}static async getDefaultTerminalLinuxReady(){if(!v._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)v._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await D.Promises.exists("/etc/debian_version");v._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{a?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,m,o){const d=m.linuxExec?Promise.resolve(m.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{d.then(n=>{const t=w(process),c=a.spawn(n,[],{cwd:o,env:t});c.on("error",s),c.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=T.localize(3,null);function w(f){const a={...f.env};return(0,C.sanitizeProcessEnvironment)(a),a}function g(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(T.localize(5,null,f.path)):f}function _(f){let a="";for(let m of f)m.indexOf(" ")>=0?a+='"'+m+'"':a+=m,a+=" ";return a}}),define(ke[43],Pe([1,0,11,25,9,8,12,2,167,4]),function(Q,e,u,i,y,A,C,D,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function L(N){return N.create===!0}e.isFileOpenForWriteOptions=L;var P;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(P||(e.FileType=P={}));var S;(function(N){N[N.Readonly=1]="Readonly"})(S||(e.FilePermission=S={}));var I;(function(N){N[N.None=0]="None",N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead",N[N.FileClone=32768]="FileClone"})(I||(e.FileSystemProviderCapabilities=I={}));function E(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=E;function v(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=v;function w(N){return!!(N.capabilities&32768)}e.hasFileCloneCapability=w;function g(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function _(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=_;function f(N){return E(N)?!!(N.capabilities&16384):!1}e.hasFileAtomicReadCapability=f;var a;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class m extends Error{constructor(V,H){super(V);this.code=H}}e.FileSystemProviderError=m;function o(N,V){const H=new m(N.toString(),V);return r(H,V),H}e.createFileSystemProviderError=o;function d(N){return N||o((0,b.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=d;function r(N,V){return N.name=V?`${V} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=r;function s(N){if(!N)return a.Unknown;if(N instanceof m)return N.code;const V=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!V)return a.Unknown;switch(V[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=s;function n(N){if(N instanceof R)return N.fileOperationResult;switch(s(N)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var t;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY",N[N.WRITE=4]="WRITE"})(t||(e.FileOperation=t={}));class c{constructor(V,H,q){this.resource=V,this.operation=H,this.target=q}isOperation(V){return this.operation===V}}e.FileOperationEvent=c;var l;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(l||(e.FileChangeType=l={}));class h{constructor(V,H){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=V;const q=new Map;for(const te of V){const fe=q.get(te.type);switch(fe?fe.push([te.resource,te]):q.set(te.type,[[te.resource,te]]),te.type){case 1:this.rawAdded.push(te.resource);break;case 0:this.rawUpdated.push(te.resource);break;case 2:this.rawDeleted.push(te.resource);break}}for(const[te,fe]of q)switch(te){case 1:this.added=i.TernarySearchTree.forUris(()=>H),this.added.fill(fe);break;case 0:this.updated=i.TernarySearchTree.forUris(()=>H),this.updated.fill(fe);break;case 2:this.deleted=i.TernarySearchTree.forUris(()=>H),this.deleted.fill(fe);break}}contains(V,...H){return this.doContains(V,{includeChildren:!1},...H)}affects(V,...H){return this.doContains(V,{includeChildren:!0},...H)}doContains(V,H,...q){if(!V)return!1;const te=q.length>0;return!!((!te||q.includes(1))&&(this.added?.get(V)||H.includeChildren&&this.added?.findSuperstr(V))||(!te||q.includes(0))&&(this.updated?.get(V)||H.includeChildren&&this.updated?.findSuperstr(V))||(!te||q.includes(2))&&(this.deleted?.findSubstr(V)||H.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function p(N,V,H){return!N||!V||N===V||V.length>N.length?!1:(V.charAt(V.length-1)!==y.sep&&(V+=y.sep),H?(0,A.startsWithIgnoreCase)(N,V):N.indexOf(V)===0)}e.isParent=p;class R extends u.ErrorNoTelemetry{constructor(V,H,q){super(V);this.fileOperationResult=H,this.options=q}}e.FileOperationError=R;class F extends R{constructor(V,H,q){super(V,2,q);this.stat=H}}e.NotModifiedSinceFileOperationError=F;var O;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O||(e.FileOperationResult=O={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(k||(e.FileKind=k={})),e.ETAG_DISABLED="";function U(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=U;async function B(N,V){if(!V.hasProvider(D.URI.from({scheme:N.scheme})))return new Promise(H=>{const q=V.onDidChangeFileSystemProviderRegistrations(te=>{te.scheme===N.scheme&&te.added&&(q.dispose(),H())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(V){return(0,C.isNumber)(V)||(V=0),V<z.KB?(0,b.localize)(1,null,V.toFixed(0)):V<z.MB?(0,b.localize)(2,null,(V/z.KB).toFixed(2)):V<z.GB?(0,b.localize)(3,null,(V/z.MB).toFixed(2)):V<z.TB?(0,b.localize)(4,null,(V/z.GB).toFixed(2)):(0,b.localize)(5,null,(V/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var Y;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(Y||(e.Arch=Y={}));function $(N){return{maxFileSize:N===0?300*z.MB:16*z.GB,maxHeapSize:N===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=$}),define(ke[86],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class u{constructor(...y){this._entries=new Map;for(let[A,C]of y)this.set(A,C)}set(y,A){const C=this._entries.get(y);return this._entries.set(y,A),C}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=u}),define(ke[194],Pe([1,0,17,11,115,190,4,86]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class T extends Error{constructor(E){super("cyclic dependency between services");this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class L{constructor(E=new D.ServiceCollection,v=!1,w){this._activeInstantiations=new Set,this._services=E,this._strict=v,this._parent=w,this._services.set(C.IInstantiationService,this)}createChild(E){return new L(E,this._strict,this)}invokeFunction(E,...v){let w=S.traceInvocation(E),g=!1;try{return E({get:f=>{if(g)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(f,w);if(!a)throw new Error(`[invokeFunction] unknown service '${f}'`);return a}},...v)}finally{g=!0,w.stop()}}createInstance(E,...v){let w,g;return E instanceof y.SyncDescriptor?(w=S.traceCreation(E.ctor),g=this._createInstance(E.ctor,E.staticArguments.concat(v),w)):(w=S.traceCreation(E),g=this._createInstance(E,v,w)),w.stop(),g}_createInstance(E,v=[],w){let g=C._util.getServiceDependencies(E).sort((a,m)=>a.index-m.index),_=[];for(const a of g){let m=this._getOrCreateServiceInstance(a.id,w);m||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${a.id}.`,!1),_.push(m)}let f=g.length>0?g[0].index:v.length;if(v.length!==f){console.trace(`[createInstance] First service dependency of ${E.name} at position ${f+1} conflicts with ${v.length} static arguments`);let a=f-v.length;a>0?v=v.concat(new Array(a)):v=v.slice(0,f)}return new E(...[...v,..._])}_setServiceInstance(E,v){if(this._services.get(E)instanceof y.SyncDescriptor)this._services.set(E,v);else if(this._parent)this._parent._setServiceInstance(E,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){let v=this._services.get(E);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):v}_getOrCreateServiceInstance(E,v){let w=this._getServiceInstanceOrDescriptor(E);return w instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,w,v.branch(E,!0)):(v.branch(E,!1),w)}_safeCreateAndCacheServiceInstance(E,v,w){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,v,w)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,v,w){const g=new A.Graph(a=>a.id.toString());let _=0;const f=[{id:E,desc:v,_trace:w}];for(;f.length;){const a=f.pop();if(g.lookupOrInsertNode(a),_++>1e3)throw new T(g);for(let m of C._util.getServiceDependencies(a.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(m.id);if(o||this._throwIfStrict(`[createInstance] ${E} depends on ${m.id} which is NOT registered.`,!0),o instanceof y.SyncDescriptor){const d={id:m.id,desc:o,_trace:a._trace.branch(m.id,!0)};g.insertEdge(a,d),f.push(d)}}}for(;;){const a=g.roots();if(a.length===0){if(!g.isEmpty())throw new T(g);break}for(const{data:m}of a){if(this._getServiceInstanceOrDescriptor(m.id)instanceof y.SyncDescriptor){const d=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,d)}g.removeNode(m)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,v,w=[],g,_){if(this._services.get(E)instanceof y.SyncDescriptor)return this._createServiceInstance(v,w,g,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,v,w,g,_);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(E,v=[],w,g){if(w){const _=new u.IdleValue(()=>this._createInstance(E,v,g));return new Proxy(Object.create(null),{get(f,a){if(a in f)return f[a];let m=_.value,o=m[a];return typeof o!="function"||(o=o.bind(m),f[a]=o),o},set(f,a,m){return _.value[a]=m,!0}})}else return this._createInstance(E,v,g)}_throwIfStrict(E,v){if(v&&console.warn(v),this._strict)throw new Error(E)}}e.InstantiationService=L;var P;(function(I){I[I.None=0]="None",I[I.Creation=1]="Creation",I[I.Invocation=2]="Invocation",I[I.Branch=3]="Branch"})(P||(P={}));class S{static traceInvocation(E){return b?new S(2,E.name||E.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(E){return b?new S(1,E.name):S._None}constructor(E,v){this.type=E,this.name=v,this._start=Date.now(),this._dep=[]}branch(E,v){let w=new S(3,E.toString());return this._dep.push([E,v,w]),w}stop(){let E=Date.now()-this._start;S._totals+=E;let v=!1;function w(_,f){let a=[],m=new Array(_+1).join("	");for(const[o,d,r]of f._dep)if(d&&r){v=!0,a.push(`${m}CREATES -> ${o}`);let s=w(_+1,r);s&&a.push(s)}else a.push(`${m}uses -> ${o}`);return a.join(`
`)}let g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(E>2||v)&&console.log(g.join(`
`))}}e.Trace=S,S._None=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}},S._totals=0}),define(ke[14],Pe([1,0,51,3,6,13,4]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function D(){return new Date().toISOString()}var b;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(b||(e.LogLevel=b={})),e.DEFAULT_LOG_LEVEL=b.Info;function T(d,r,s){switch(r){case b.Trace:d.trace(s);break;case b.Debug:d.debug(s);break;case b.Info:d.info(s);break;case b.Warning:d.warn(s);break;case b.Error:d.error(s);break;case b.Critical:d.critical(s);break;default:throw new Error("Invalid log level")}}e.log=T;function L(d){let r="";for(let s=0;s<d.length;s++){let n=d[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}r+=(s>0?" ":"")+n}return r}e.format=L;class P extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class S extends P{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...s){this.checkLogLevel(b.Trace)&&this.log(b.Trace,L([r,...s]))}debug(r,...s){this.checkLogLevel(b.Debug)&&this.log(b.Debug,L([r,...s]))}info(r,...s){this.checkLogLevel(b.Info)&&this.log(b.Info,L([r,...s]))}warn(r,...s){this.checkLogLevel(b.Warning)&&this.log(b.Warning,L([r,...s]))}error(r,...s){if(this.checkLogLevel(b.Error))if(r instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=r.stack,this.log(b.Error,L(n))}else this.log(b.Error,L([r,...s]))}critical(r,...s){this.checkLogLevel(b.Critical)&&this.log(b.Critical,L([r,...s]))}flush(){}}e.AbstractMessageLogger=S;class I extends P{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!A.isWindows}trace(r,...s){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,r,...s):console.log(`[main ${D()}]`,r,...s))}debug(r,...s){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,r,...s):console.log(`[main ${D()}]`,r,...s))}info(r,...s){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,r,...s):console.log(`[main ${D()}]`,r,...s))}warn(r,...s){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,r,...s):console.warn(`[main ${D()}]`,r,...s))}error(r,...s){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,r,...s):console.error(`[main ${D()}]`,r,...s))}critical(r,...s){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,r,...s):console.error(`[main ${D()}]`,r,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class E extends P{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...s){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",r,...s)}debug(r,...s){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...s)}info(r,...s){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",r,...s)}warn(r,...s){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",r,...s)}error(r,...s){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",r,...s)}critical(r,...s){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...s)}dispose(){}flush(){}}e.ConsoleLogger=E;class v extends P{constructor(r,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(s)}trace(r,...s){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(r),...s])}debug(r,...s){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(r),...s])}info(r,...s){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(r),...s])}warn(r,...s){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(r),...s])}error(r,...s){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(r),...s])}critical(r,...s){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(r),...s])}extractMessage(r){return typeof r=="string"?r:(0,u.toErrorMessage)(r,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class w extends P{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const s of this.logServices)s.setLevel(r);super.setLevel(r)}trace(r,...s){for(const n of this.logServices)n.trace(r,...s)}debug(r,...s){for(const n of this.logServices)n.debug(r,...s)}info(r,...s){for(const n of this.logServices)n.info(r,...s)}warn(r,...s){for(const n of this.logServices)n.warn(r,...s)}error(r,...s){for(const n of this.logServices)n.error(r,...s)}critical(r,...s){for(const n of this.logServices)n.critical(r,...s)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=w;class g extends y.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...s){this.logger.trace(r,...s)}debug(r,...s){this.logger.debug(r,...s)}info(r,...s){this.logger.info(r,...s)}warn(r,...s){this.logger.warn(r,...s)}error(r,...s){this.logger.error(r,...s)}critical(r,...s){this.logger.critical(r,...s)}flush(){this.logger.flush()}}e.LogService=g;class _ extends y.Disposable{constructor(r,s){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(n))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,s){let n=this.loggers.get(r.toString());return n||(n=this.doCreateLogger(r,s?.always?b.Trace:this.logLevel,s),this.loggers.set(r.toString(),n),s?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class f{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(r){}getLevel(){return b.Info}trace(r,...s){}debug(r,...s){}info(r,...s){}warn(r,...s){}error(r,...s){}critical(r,...s){}dispose(){}flush(){}}e.NullLogService=f;function a(d){if(d.verbose)return b.Trace;if(typeof d.logLevel=="string"){const r=m(d.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function m(d){switch(d){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=m;function o(d){switch(d){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=o}),define(ke[195],Pe([1,0,43,14]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function y(D,b,T,L,P){try{const S=await new Promise((E,v)=>{Q(["spdlog"],E,v)});S.setFlushOn(i.LogLevel.Trace);const I=await S.createAsyncRotatingLogger(D,b,T,L);return P&&I.clearFormatters(),I}catch(S){console.error(S)}return null}function A(D,b,T){switch(b){case i.LogLevel.Trace:D.trace(T);break;case i.LogLevel.Debug:D.debug(T);break;case i.LogLevel.Info:D.info(T);break;case i.LogLevel.Warning:D.warn(T);break;case i.LogLevel.Error:D.error(T);break;case i.LogLevel.Critical:D.critical(T);break;default:throw new Error("Invalid log level")}}class C extends i.AbstractMessageLogger{constructor(b,T,L,P,S){super();this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(b,T,L,P),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}async _createSpdLogLogger(b,T,L,P){const S=L?6:1,I=30/S*u.ByteSize.MB,E=await y(b,T,I,S,P);if(E){this._logger=E,this._logger.setLevel(this.getLevel());for(const{level:v,message:w}of this.buffer)A(this._logger,v,w);this.buffer=[]}}log(b,T){this._logger?A(this._logger,b,T):this.getLevel()<=b&&this.buffer.push({level:b,message:T})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(ke[116],Pe([1,0,41,168,4]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var C;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(C||(e.MarkerSeverity=C={})),function(b){function T(E,v){return v-E}b.compare=T;const L=Object.create(null);L[b.Error]=(0,i.localize)(0,null),L[b.Warning]=(0,i.localize)(1,null),L[b.Info]=(0,i.localize)(2,null);function P(E){return L[E]||""}b.toString=P;function S(E){switch(E){case u.default.Error:return b.Error;case u.default.Warning:return b.Warning;case u.default.Info:return b.Info;case u.default.Ignore:return b.Hint}}b.fromSeverity=S;function I(E){switch(E){case b.Error:return u.default.Error;case b.Warning:return u.default.Warning;case b.Info:return u.default.Info;case b.Hint:return u.default.Ignore}}b.toSeverity=I}(C||(e.MarkerSeverity=C={}));var D;(function(b){const T="";function L(S){return P(S,!0)}b.makeKey=L;function P(S,I){let E=[T];return S.source?E.push(S.source.replace("\xA6","\\\xA6")):E.push(T),S.code?typeof S.code=="string"?E.push(S.code.replace("\xA6","\\\xA6")):E.push(S.code.value.replace("\xA6","\\\xA6")):E.push(T),S.severity!==void 0&&S.severity!==null?E.push(C.toString(S.severity)):E.push(T),S.message&&I?E.push(S.message.replace("\xA6","\\\xA6")):E.push(T),S.startLineNumber!==void 0&&S.startLineNumber!==null?E.push(S.startLineNumber.toString()):E.push(T),S.startColumn!==void 0&&S.startColumn!==null?E.push(S.startColumn.toString()):E.push(T),S.endLineNumber!==void 0&&S.endLineNumber!==null?E.push(S.endLineNumber.toString()):E.push(T),S.endColumn!==void 0&&S.endColumn!==null?E.push(S.endColumn.toString()):E.push(T),E.push(T),E.join("\xA6")}b.makeKeyOptionalMessage=P})(D||(e.IMarkerData=D={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(ke[196],Pe([1,0,3,41,4]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=i.default,e.INotificationService=(0,y.createDecorator)("notificationService");var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(A||(e.NeverShowAgainScope=A={}));var C;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(C||(e.NotificationsFilter=C={}));class D{constructor(){this.progress=new b,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=D;class b{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=b}),define(ke[117],Pe([1,0,6,8,2,4]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return u.Disposable.None},registerValidator(){return u.Disposable.None},registerExternalUriResolver(){return u.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return u.Disposable.None},async open(){return!1},async resolveExternalUri(L){return{resolved:L,dispose(){}}}});function C(L,P){return y.URI.isUri(L)?(0,i.equalsIgnoreCase)(L.scheme,P):(0,i.startsWithIgnoreCase)(L,P+":")}e.matchesScheme=C;function D(L,...P){return P.some(S=>C(L,S))}e.matchesSomeScheme=D;function b(L,P){return L.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.withSelection=b;function T(L){let P;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(L.fragment);return S&&(P={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},L=L.with({fragment:""})),{selection:P,uri:L}}e.extractSelection=T}),define(ke[197],Pe([1,0,10,13,40,22]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const D=i.globals.vscode.context.configuration();if(D)C=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const D=(0,A.dirname)(u.FileAccess.asFileUri("",Q));C=Q.__$__nodeRequire((0,A.joinPath)(D,"product.json").fsPath);const b=Q.__$__nodeRequire((0,A.joinPath)(D,"package.json").fsPath);y.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),Object.assign(C,{IDEVersion:b.IDEVersion,version:b.version})}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.67.0-dev",nameShort:"Kylin-Code Dev",nameLong:"Kylin-Code Dev",applicationName:"kylin-code",dataFolderName:".kylin-code",urlProtocol:"kylin-code",reportIssueUrl:"https://gitee.com/openkylin/kylin-code/issues",licenseName:"MIT",licenseUrl:"https://gitee.com/openkylin/kylin-code/blob/master/LICENSE.txt"});e.default=C}),define(ke[198],Pe([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,u.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var He=this&&this.__param||function(Q,e){return function(u,i){e(u,i,Q)}};define(ke[118],Pe([1,0,17,21,6,4]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var C;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(C||(e.ProgressLocation=C={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{get value(){return this._value}constructor(P){this.callback=P}report(P){this._value=P,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let b=class extends y.Disposable{constructor(P,S){super();this.deferred=new u.DeferredPromise,S.withProgress(P,I=>(this.reporter=I,this.lastStep&&I.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};e.UnmanagedProgress=b,e.UnmanagedProgress=b=je([He(1,e.IProgressService)],b);class T extends y.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(P){this.stop();const S=++this.currentOperationId,I=new i.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{S===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>I.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:S,token:I.token,stop:()=>this.doStop(S),isCurrent:()=>this.currentOperationId===S}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(ke[44],Pe([1,0,57,12]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(C,D){u.ok(i.isString(C)),u.ok(i.isObject(D)),u.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,D)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new y}),define(ke[119],Pe([1,0,3,44]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class A{constructor(){this._onDidChangeSchema=new u.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,T){this.schemasById[y(b)]=T,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new A;i.Registry.add(e.Extensions.JSONContribution,C)}),define(ke[120],Pe([1,0,16,3,12,163,84,119,44]),function(Q,e,u,i,y,A,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var T;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(T||(e.EditPresentationTypes=T={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=b.Registry.as(D.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,d=!0){this.registerConfigurations([o],d)}registerConfigurations(o,d=!0){const r=this.doRegisterConfigurations(o,d);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(o){const d=this.doDeregisterConfigurations(o);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:o,remove:d}){const r=[];r.push(...this.doDeregisterConfigurations(d)),r.push(...this.doRegisterConfigurations(o,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,u.distinct)(r)})}registerDefaultConfigurations(o){const d=[],r=[];for(const{overrides:s,source:n}of o)for(const t in s)if(d.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const c=this.configurationDefaultsOverrides.get(t),l=c?.valuesSources??new Map;if(n)for(const F of Object.keys(s[t]))l.set(F,n);const h={...c?.value||{},...s[t]};this.configurationDefaultsOverrides.set(t,{source:n,value:h,valuesSources:l});const p=(0,C.getLanguageTagSettingPlainKey)(t),R={type:"object",default:h,description:A.localize(1,null,p),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:y.isString(n)?void 0:n,defaultValueSource:n};r.push(...v(t)),this.configurationProperties[t]=R,this.defaultLanguageConfigurationOverridesNode.properties[t]=R}else{this.configurationDefaultsOverrides.set(t,{value:s[t],source:n});const c=this.configurationProperties[t];c&&(this.updatePropertyDefaultValue(t,c),this.updateSchema(t,c))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const d=[];for(const{overrides:r,source:s}of o)for(const n in r){const t=this.configurationDefaultsOverrides.get(n),c=y.isString(s)?s:s?.id,l=y.isString(t?.source)?t?.source:t?.source?.id;if(c===l)if(d.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const h=this.configurationProperties[n];h&&(this.updatePropertyDefaultValue(n,h),this.updateSchema(n,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const d of o)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,d){const r=[];return o.forEach(s=>{r.push(...this.validateAndRegisterProperties(s,d,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),r}doDeregisterConfigurations(o){const d=[],r=s=>{if(s.properties)for(const n in s.properties){d.push(n);const t=this.configurationProperties[n];t?.policy?.name&&this.policyConfigurations.delete(t.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,s.properties[n])}s.allOf&&s.allOf.forEach(n=>r(n))};for(const s of o){r(s);const n=this.configurationContributors.indexOf(s);n!==-1&&this.configurationContributors.splice(n,1)}return d}validateAndRegisterProperties(o,d=!0,r,s,n=3){n=y.isUndefinedOrNull(o.scope)?n:o.scope;let t=[],c=o.properties;if(c)for(let h in c){const p=c[h];if(d&&f(h,p)){delete c[h];continue}if(p.source=r,p.defaultDefaultValue=c[h].default,this.updatePropertyDefaultValue(h,p),e.OVERRIDE_PROPERTY_REGEX.test(h)?p.scope=void 0:(p.scope=y.isUndefinedOrNull(p.scope)?n:p.scope,p.restricted=y.isUndefinedOrNull(p.restricted)?!!s?.includes(h):p.restricted),c[h].hasOwnProperty("included")&&!c[h].included){this.excludedConfigurationProperties[h]=c[h],delete c[h];continue}else this.configurationProperties[h]=c[h],c[h].policy?.name&&this.policyConfigurations.set(c[h].policy.name,h);!c[h].deprecationMessage&&c[h].markdownDeprecationMessage&&(c[h].deprecationMessage=c[h].markdownDeprecationMessage),t.push(h)}let l=o.allOf;if(l)for(let h of l)t.push(...this.validateAndRegisterProperties(h,d,r,s,n));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const d=r=>{let s=r.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);let n=r.allOf;n&&n.forEach(d)};d(o)}updateSchema(o,d){switch(e.allSettings.properties[o]=d,d.scope){case 1:e.applicationSettings.properties[o]=d;break;case 2:e.machineSettings.properties[o]=d;break;case 6:e.machineOverridableSettings.properties[o]=d;break;case 3:e.windowSettings.properties[o]=d;break;case 4:e.resourceSettings.properties[o]=d;break;case 5:e.resourceSettings.properties[o]=d,this.resourceLanguageSettingsSchema.properties[o]=d;break}}removeFromSchema(o,d){switch(delete e.allSettings.properties[o],d.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const d=`[${o}]`,r={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,r),e.allSettings.properties[d]=r,e.applicationSettings.properties[d]=r,e.machineSettings.properties[d]=r,e.machineOverridableSettings.properties[d]=r,e.windowSettings.properties[d]=r,e.resourceSettings.properties[d]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,d){const r=this.configurationDefaultsOverrides.get(o);let s=r?.value,n=r?.source;y.isUndefined(s)&&(s=d.defaultDefaultValue,n=void 0),y.isUndefined(s)&&(s=g(d.type)),d.default=s,d.defaultValueSource=n}}const I="\\[([^\\]]+)\\]",E=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(m){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let d=E.exec(m);for(;d?.length;){const r=d[1].trim();r&&o.push(r),d=E.exec(m)}}return(0,u.distinct)(o)}e.overrideIdentifiersFromKey=v;function w(m){return m.reduce((o,d)=>`${o}[${d}]`,"")}e.keyFromOverrideIdentifiers=w;function g(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const _=new S;b.Registry.add(e.Extensions.Configuration,_);function f(m,o){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?A.localize(7,null,m):_.getConfigurationProperties()[m]!==void 0?A.localize(8,null,m):o.policy?.name&&_.getPolicyConfigurations().get(o.policy?.name)!==void 0?A.localize(9,null,m,o.policy?.name,_.getPolicyConfigurations().get(o.policy?.name)):null:A.localize(6,null)}e.validateProperty=f;function a(){const m=[],o=_.getConfigurationProperties();for(const d of Object.keys(o))m.push([d,o[d].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=a}),define(ke[199],Pe([1,0,16,3,143,6,25,24,12,2,84,120,44]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class I{constructor(d={},r=[],s=[]){this._contents=d,this._keys=r,this._overrides=s,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(d){return d?(0,L.getConfigurationValue)(this.contents,d):this.contents}getOverrideValue(d,r){const s=this.getContentsForOverrideIdentifer(r);return s?d?(0,L.getConfigurationValue)(s,d):s:void 0}getKeysForOverrideIdentifier(d){const r=[];for(const s of this.overrides)s.identifiers.includes(d)&&r.push(...s.keys);return u.distinct(r)}getAllOverrideIdentifiers(){const d=[];for(const r of this.overrides)d.push(...r.identifiers);return u.distinct(d)}override(d){let r=this.overrideConfigurations.get(d);return r||(r=this.createOverrideConfigurationModel(d),this.overrideConfigurations.set(d,r)),r}merge(...d){const r=D.deepClone(this.contents),s=D.deepClone(this.overrides),n=[...this.keys];for(const t of d){this.mergeContents(r,t.contents);for(const c of t.overrides){const[l]=s.filter(h=>u.equals(h.identifiers,c.identifiers));l?(this.mergeContents(l.contents,c.contents),l.keys.push(...c.keys),l.keys=u.distinct(l.keys)):s.push(D.deepClone(c))}for(const c of t.keys)n.indexOf(c)===-1&&n.push(c)}return new I(r,n,s)}freeze(){return this.frozen=!0,this}clone(){return new I(D.deepClone(this.contents),[...this.keys],D.deepClone(this.overrides))}createOverrideConfigurationModel(d){const r=this.getContentsForOverrideIdentifer(d);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const n of u.distinct([...Object.keys(this.contents),...Object.keys(r)])){let t=this.contents[n],c=r[n];c&&(typeof t=="object"&&typeof c=="object"?(t=D.deepClone(t),this.mergeContents(t,c)):t=c),s[n]=t}return new I(s,this.keys,this.overrides)}mergeContents(d,r){for(const s of Object.keys(r)){if(s in d&&b.isObject(d[s])&&b.isObject(r[s])){this.mergeContents(d[s],r[s]);continue}d[s]=D.deepClone(r[s])}}checkAndFreeze(d){return this.frozen&&!Object.isFrozen(d)?D.deepFreeze(d):d}getContentsForOverrideIdentifer(d){let r=null,s=null;const n=t=>{t&&(s?this.mergeContents(s,t):s=D.deepClone(t))};for(const t of this.overrides)u.equals(t.identifiers,[d])?r=t.contents:t.identifiers.includes(d)&&n(t.contents);return n(r),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(d,r){this.addKey(d),(0,L.addToValueTree)(this.contents,d,r,s=>{throw new Error(s)})}removeValue(d){this.removeKey(d)&&(0,L.removeFromValueTree)(this.contents,d)}addKey(d){let r=this.keys.length;for(let s=0;s<r;s++)d.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,d)}removeKey(d){let r=this.keys.indexOf(d);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=I;class E{constructor(d){this._name=d,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(d,r){if(!b.isUndefinedOrNull(d)){const s=this.doParseContent(d);this.parseRaw(s,r)}}reparse(d){this._raw&&this.parseRaw(this._raw,d)}parseRaw(d,r){this._raw=d;const{contents:s,keys:n,overrides:t,restricted:c}=this.doParseRaw(d,r);this._configurationModel=new I(s,n,t),this._restrictedConfigurations=c||[]}doParseContent(d){let r={},s=null,n=[],t=[],c=[];function l(p){Array.isArray(n)?n.push(p):s!==null&&(n[s]=p)}let h={onObjectBegin:()=>{let p={};l(p),t.push(n),n=p,s=null},onObjectProperty:p=>{s=p},onObjectEnd:()=>{n=t.pop()},onArrayBegin:()=>{let p=[];l(p),t.push(n),n=p,s=null},onArrayEnd:()=>{n=t.pop()},onLiteralValue:l,onError:(p,R,F)=>{c.push({error:p,offset:R,length:F})}};if(d)try{y.visit(d,h),r=n[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return r}doParseRaw(d,r){const s=S.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),n=this.filter(d,s,!0,r);d=n.raw;const t=(0,L.toValuesTree)(d,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),c=Object.keys(d),l=this.toOverrides(d,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:t,keys:c,overrides:l,restricted:n.restricted}}filter(d,r,s,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:d,restricted:[]};const t={},c=[];for(let l in d)if(P.OVERRIDE_PROPERTY_REGEX.test(l)&&s){const h=this.filter(d[l],r,!1,n);t[l]=h.raw,c.push(...h.restricted)}else{const h=r[l],p=h?typeof h.scope!="undefined"?h.scope:3:void 0;h?.restricted&&c.push(l),(p===void 0||n.scopes===void 0||n.scopes.includes(p))&&(n.skipRestricted&&h?.restricted||(t[l]=d[l]))}return{raw:t,restricted:c}}toOverrides(d,r){const s=[];for(const n of Object.keys(d))if(P.OVERRIDE_PROPERTY_REGEX.test(n)){const t={};for(const c in d[n])t[c]=d[n][c];s.push({identifiers:(0,P.overrideIdentifiersFromKey)(n),keys:Object.keys(t),contents:(0,L.toValuesTree)(t,r)})}return s}}e.ConfigurationModelParser=E;class v extends A.Disposable{constructor(d,r,s,n){super();this.userSettingsResource=d,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.any(i.Event.filter(this.fileService.onDidFilesChange,t=>t.contains(this.userSettingsResource)),i.Event.filter(this.fileService.onDidRunOperation,t=>(t.isOperation(0)||t.isOperation(3)||t.isOperation(1)||t.isOperation(4))&&s.isEqual(t.resource,d)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const d=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(d.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class w{constructor(d,r,s,n=new I,t=new I,c=new C.ResourceMap,l=new I,h=new C.ResourceMap,p=!0){this._defaultConfiguration=d,this._policyConfiguration=r,this._localUserConfiguration=s,this._remoteUserConfiguration=n,this._workspaceConfiguration=t,this._folderConfigurations=c,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=p,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(d,r,s){return this.getConsolidatedConfigurationModel(d,r,s).getValue(d)}updateValue(d,r,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new I,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(d):n.setValue(d,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(d,r,s){const n=this.getConsolidatedConfigurationModel(d,r,s),t=this.getFolderConfigurationModelForResource(r.resource,s),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this._defaultConfiguration.freeze().getValue(d),h=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(d),p=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this.userConfiguration.freeze().getValue(d),R=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this.localUserConfiguration.freeze().getValue(d),F=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this.remoteUserConfiguration.freeze().getValue(d),O=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this._workspaceConfiguration.freeze().getValue(d):void 0,k=t?r.overrideIdentifier?t.freeze().override(r.overrideIdentifier).getValue(d):t.freeze().getValue(d):void 0,U=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(d):c.getValue(d),B=n.getValue(d),z=u.distinct(n.overrides.map(Y=>Y.identifiers).flat()).filter(Y=>n.getOverrideValue(d,Y)!==void 0);return{defaultValue:l,policyValue:h,userValue:p,userLocalValue:R,userRemoteValue:F,workspaceValue:O,workspaceFolderValue:k,memoryValue:U,value:B,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,policy:h!==void 0?{value:h}:void 0,user:p!==void 0?{value:this.userConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,workspaceFolder:k!==void 0?{value:t?.freeze().getValue(d),override:r.overrideIdentifier?t?.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:c.getValue(d),override:r.overrideIdentifier?c.getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(d){const r=this.getFolderConfigurationModelForResource(void 0,d);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(d){this._defaultConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(d){this._policyConfiguration=d}updateLocalUserConfiguration(d){this._localUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(d){this._remoteUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(d){this._workspaceConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(d,r){this._folderConfigurations.set(d,r),this._foldersConsolidatedConfigurations.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this._foldersConsolidatedConfigurations.delete(d)}compareAndUpdateDefaultConfiguration(d,r){const s=[];if(!r){const{added:n,updated:t,removed:c}=a(this._defaultConfiguration,d);r=[...n,...t,...c]}for(const n of r)for(const t of(0,P.overrideIdentifiersFromKey)(n)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(t),l=d.getKeysForOverrideIdentifier(t),h=[...l.filter(p=>c.indexOf(p)===-1),...c.filter(p=>l.indexOf(p)===-1),...c.filter(p=>!D.equals(this._defaultConfiguration.override(t).getValue(p),d.override(t).getValue(p)))];s.push([t,h])}return this.updateDefaultConfiguration(d),{keys:r,overrides:s}}compareAndUpdatePolicyConfiguration(d){const{added:r,updated:s,removed:n}=a(this._policyConfiguration,d),t=[...r,...s,...n];return t.length&&this.updatePolicyConfiguration(d),{keys:t,overrides:[]}}compareAndUpdateLocalUserConfiguration(d){const{added:r,updated:s,removed:n,overrides:t}=a(this.localUserConfiguration,d),c=[...r,...s,...n];return c.length&&this.updateLocalUserConfiguration(d),{keys:c,overrides:t}}compareAndUpdateRemoteUserConfiguration(d){const{added:r,updated:s,removed:n,overrides:t}=a(this.remoteUserConfiguration,d);let c=[...r,...s,...n];return c.length&&this.updateRemoteUserConfiguration(d),{keys:c,overrides:t}}compareAndUpdateWorkspaceConfiguration(d){const{added:r,updated:s,removed:n,overrides:t}=a(this.workspaceConfiguration,d);let c=[...r,...s,...n];return c.length&&this.updateWorkspaceConfiguration(d),{keys:c,overrides:t}}compareAndUpdateFolderConfiguration(d,r){const s=this.folderConfigurations.get(d),{added:n,updated:t,removed:c,overrides:l}=a(s,r);let h=[...n,...t,...c];return(h.length||!s)&&this.updateFolderConfiguration(d,r),{keys:h,overrides:l}}compareAndDeleteFolderConfiguration(d){const r=this.folderConfigurations.get(d);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:s,updated:n,removed:t,overrides:c}=a(r,void 0);return{keys:[...s,...n,...t],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(d,r,s){let n=this.getConsolidatedConfigurationModelForResource(r,s);return r.overrideIdentifier&&(n=n.override(r.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(d)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:d},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&d){const n=r.getFolder(d);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const t=this._memoryConfigurationByResource.get(d);t&&(s=s.merge(t))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(d){let r=this._foldersConsolidatedConfigurations.get(d);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(d);n?(r=s.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(d,r)):r=s}return r}getFolderConfigurationModelForResource(d,r){if(r&&d){const s=r.getFolder(d);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((d,r)=>{const{contents:s,overrides:n,keys:t}=this._folderConfigurations.get(r);return d.push([r,{contents:s,overrides:n,keys:t}]),d},[])}}allKeys(){const d=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>d.add(r)),this.userConfiguration.freeze().keys.forEach(r=>d.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>d.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>d.add(s))),[...d.values()]}allOverrideIdentifiers(){const d=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>d.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>d.add(r)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>d.add(r)),this._folderConfigurations.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(s=>d.add(s))),[...d.values()]}getAllKeysForOverrideIdentifier(d){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(d).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(d).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(d).forEach(n=>r.add(n))),[...r.values()]}static parse(d){const r=this.parseConfigurationModel(d.defaults),s=this.parseConfigurationModel(d.policy),n=this.parseConfigurationModel(d.user),t=this.parseConfigurationModel(d.workspace),c=d.folders.reduce((l,h)=>(l.set(T.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new C.ResourceMap);return new w(r,s,n,new I,t,c,new I,new C.ResourceMap,!1)}static parseConfigurationModel(d){return new I(d.contents,d.keys,d.overrides).freeze()}}e.Configuration=w;function g(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const d=new Set,r=new Map;for(const n of o)n.keys.forEach(t=>d.add(t)),n.overrides.forEach(([t,c])=>{const l=(0,C.getOrSet)(r,t,new Set);c.forEach(h=>l.add(h))});const s=[];return r.forEach((n,t)=>s.push([t,[...n.values()]])),{keys:[...d.values()],overrides:s}}e.mergeChanges=g;class _{constructor(d,r,s,n){this.change=d,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const t=new Set;d.keys.forEach(l=>t.add(l)),d.overrides.forEach(([,l])=>l.forEach(h=>t.add(h))),this.affectedKeys=[...t.values()];const c=new I;this.affectedKeys.forEach(l=>c.setValue(l,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(d,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,d)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(d,r,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(d,r,this.currentWorkspace);return!D.equals(s,n)}return!0}return!1}doesAffectedKeysTreeContains(d,r){let s=(0,L.toValuesTree)({[r]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(d=d[n],!d)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=_;class f extends _{constructor(d,r,s,n){super({keys:d.allKeys(),overrides:[]},void 0,d,r);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=f;function a(o,d){const{added:r,removed:s,updated:n}=m(d,o),t=[],c=o?.getAllOverrideIdentifiers()||[],l=d?.getAllOverrideIdentifiers()||[];if(d){const h=l.filter(p=>!c.includes(p));for(const p of h)t.push([p,d.getKeysForOverrideIdentifier(p)])}if(o){const h=c.filter(p=>!l.includes(p));for(const p of h)t.push([p,o.getKeysForOverrideIdentifier(p)])}if(d&&o){for(const h of c)if(l.includes(h)){const p=m({contents:o.getOverrideValue(void 0,h)||{},keys:o.getKeysForOverrideIdentifier(h)},{contents:d.getOverrideValue(void 0,h)||{},keys:d.getKeysForOverrideIdentifier(h)});t.push([h,[...p.added,...p.removed,...p.updated]])}}return{added:r,removed:s,updated:n,overrides:t}}function m(o,d){const r=o?d?o.keys.filter(t=>d.keys.indexOf(t)===-1):[...o.keys]:[],s=d?o?d.keys.filter(t=>o.keys.indexOf(t)===-1):[...d.keys]:[],n=[];if(o&&d){for(const t of d.keys)if(o.keys.indexOf(t)!==-1){const c=(0,L.getConfigurationValue)(d.contents,t),l=(0,L.getConfigurationValue)(o.contents,t);D.equals(c,l)||n.push(t)}}return{added:r,removed:s,updated:n}}}),define(ke[121],Pe([1,0,11,4]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var y;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(y||(e.RemoteAuthorityResolverErrorCode=y={}));class A extends u.ErrorNoTelemetry{static isTemporarilyNotAvailable(D){return D instanceof A&&D._code===y.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof A&&D._code===y.NoResolverFound}static isHandled(D){return D instanceof A&&D.isHandled}constructor(D,b=y.Unknown,T){super(D);this._message=D,this._code=b,this._detail=T,this.isHandled=b===y.NotAvailable&&T===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(ke[122],Pe([1,0,10]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(C){return C.scheme===u.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=i;function y(C){if(!C)return;const D=C.indexOf("+");return D<0?C:C.substr(0,D)}e.getRemoteName=y;function A(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=A}),define(ke[26],Pe([1,0,8,4,122]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(I){if(typeof I=="object"&&I!==null&&I.supported!==!0)return I.description}e.getWorkspaceSupportTypeMessage=A;function C(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(I){I[I.System=0]="System",I[I.User=1]="User"})(D||(e.ExtensionType=D={}));var b;(function(I){I.WIN32_X64="win32-x64",I.WIN32_IA32="win32-ia32",I.WIN32_ARM64="win32-arm64",I.LINUX_X64="linux-x64",I.LINUX_ARM64="linux-arm64",I.LINUX_ARMHF="linux-armhf",I.ALPINE_X64="alpine-x64",I.ALPINE_ARM64="alpine-arm64",I.DARWIN_X64="darwin-x64",I.DARWIN_ARM64="darwin-arm64",I.WEB="web",I.UNIVERSAL="universal",I.UNKNOWN="unknown",I.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class T{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,v){if(typeof E=="undefined"||E===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof E=="string"||typeof v=="string"){let w=typeof E=="string"?E:E.value,g=typeof v=="string"?v:v.value;return u.equalsIgnoreCase(w,g)}return E._lower===v._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=T;function L(I){return I.contributes&&I.contributes.localizations?I.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function P(I){return I.contributes&&I.contributes.authentication?I.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function S(I,E){if(E){const v=`onResolveRemoteAuthority:${(0,y.getRemoteName)(E)}`;return I.activationEvents?.indexOf(v)!==-1}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(ke[200],Pe([1,0,8,85,26,13,2,11,40]),function(Q,e,u,i,y,A,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(r,s){return r.uuid&&s.uuid?r.uuid===s.uuid:r.id===s.id?!0:(0,u.compareIgnoreCase)(r.id,s.id)===0}e.areSameExtensions=T;const L=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{static create(s){const n=s.manifest?s.manifest.version:s.version,t=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new P(s.identifier,n,t)}static parse(s){const n=L.exec(s);return n&&n[1]&&n[2]?new P({id:n[1]},n[2],n[4]||void 0):null}constructor(s,n,t="undefined"){this.version=n,this.targetPlatform=t,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof P?T(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=P;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(r){const s=S.exec(r);return s&&s[1]?[v(s[1]),s[2]]:[v(r),void 0]}e.getIdAndVersion=I;function E(r,s){return`${r}.${s}`}e.getExtensionId=E;function v(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=v;function w(r,s){return v(E(r,s))}e.getGalleryExtensionId=w;function g(r,s){const n=[],t=c=>{for(const l of n)if(l.some(h=>T(s(h),s(c))))return l;return null};for(const c of r){const l=t(c);l?l.push(c):n.push([c])}return n}e.groupByExtension=g;function _(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=_;function f(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function a(r){const s=new Set;if(r.malicious)for(const n of r.malicious)s.add(n.id);return s}e.getMaliciousExtensionsSet=a;function m(r,s){const n=[],t=s.manifest.extensionDependencies?.slice(0)??[];for(;t.length;){const c=t.shift();if(c&&n.every(l=>!T(l.identifier,{id:c}))){const l=r.filter(h=>T(h.identifier,{id:c}));l.length===1&&(n.push(l[0]),t.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=m;async function o(r,s){if(!A.isLinux)return!1;let n;try{n=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){s.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=o;async function d(r,s){const n=await o(r,s),t=(0,i.getTargetPlatform)(n?"alpine":A.platform,b.arch);return s.debug("ComputeTargetPlatform:",t),t}e.computeTargetPlatform=d}),define(ke[201],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class u{constructor(){this.validators=new Map}vsda(){return new Promise((y,A)=>Q(["vsda"],y,A))}async createNewMessage(y){try{const A=await this.vsda(),C=new A.validator;if(C){const D=String(u._nextId++);return this.validators.set(D,C),{id:D,data:C.createNewMessage(y)}}}catch{}return{id:"",data:y}}async validate(y,A){if(!y.id)return!0;const C=this.validators.get(y.id);if(!C)return!1;this.validators.delete(y.id);try{return C.validate(A)==="ok"}catch{return!1}}async sign(y){try{const A=await this.vsda(),C=new A.signer;if(C)return C.sign(y)}catch{}return y}}e.SignService=u,u._nextId=1}),define(ke[202],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class u{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,A,C=5){let D;return D=A(b=>{const T=typeof b=="string"?b:b.data;let L=this._terminalBufferMap.get(y);if(L){L.data.push(T);return}const P=setTimeout(()=>this.flushBuffer(y),C);L={data:[T],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(y),D.dispose()}},this._terminalBufferMap.set(y,L)}),D}stopBuffering(y){const A=this._terminalBufferMap.get(y);A&&A.dispose()}flushBuffer(y){const A=this._terminalBufferMap.get(y);A&&(this._terminalBufferMap.delete(y),this._callback(y,A.data.join("")))}}e.TerminalDataBufferer=u}),define(ke[203],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var u;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(u||(e.ColorScheme=u={}));function i(A){return A===u.HIGH_CONTRAST_DARK||A===u.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function y(A){return A===u.DARK||A===u.HIGH_CONTRAST_DARK}e.isDark=y}),define(ke[87],Pe([1,0,78,3,6,4,44,203]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var b;(function(w){function g(_){return _&&typeof _=="object"&&typeof _.id=="string"}w.isThemeColor=g})(b||(e.ThemeColor=b={}));function T(w){return{id:w}}e.themeColorFromId=T;var L;(function(w){function g(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||b.isThemeColor(s.color))}w.isThemeIcon=g;const _=new RegExp(`^\\$\\((${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?)\\)$`);function f(s){const n=_.exec(s);if(!n)return;let[,t]=n;return{id:t}}w.fromString=f;function a(s){return{id:s}}w.fromId=a;function m(s,n){let t=s.id;const c=t.lastIndexOf("~");return c!==-1&&(t=t.substring(0,c)),n&&(t=`${t}~${n}`),{id:t}}w.modify=m;function o(s){const n=s.id.lastIndexOf("~");if(n!==-1)return s.id.substring(n+1)}w.getModifier=o;function d(s,n){return s.id===n.id&&s.color?.id===n.color?.id}w.isEqual=d;function r(s,n){return{id:s.id,color:n?T(n):void 0}}w.asThemeIcon=r,w.asClassNameArray=u.CSSIcon.asClassNameArray,w.asClassName=u.CSSIcon.asClassName,w.asCSSSelector=u.CSSIcon.asCSSSelector})(L||(e.ThemeIcon=L={})),e.FileThemeIcon=u.Codicon.file,e.FolderThemeIcon=u.Codicon.folder;function P(w){switch(w){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case D.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,y.toDisposable)(()=>{const _=this.themingParticipants.indexOf(g);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let I=new S;C.Registry.add(e.Extensions.ThemingContribution,I);function E(w){return I.onColorThemeChange(w)}e.registerThemingParticipant=E;class v extends y.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,_){let f=this.theme.getColor(g);return f&&_&&(f=_(f,this.theme)),f?f.toString():null}}e.Themable=v}),define(ke[123],Pe([1,0,3,13,4,14]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var C;(function(E){E.Http="http",E.Https="https"})(C||(e.TunnelProtocol=C={}));var D;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(D||(e.TunnelPrivacyId=D={}));var b;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function T(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=P;function S(E,v){return v?v!==1&&E<1024:!i.isWindows&&E<1024}e.isPortPrivileged=S;let I=class{constructor(v){this.logService=v,this._onTunnelOpened=new u.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new u.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new u.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v){return this._tunnelProvider=v,v?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],w=Array.from(this._tunnels.values());for(let g of w){const _=Array.from(g.values());for(let f of _){const a=await f.value;a&&v.push(a)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:w}of v.values())await w.then(g=>g?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,w,g,_,f=!1,a,m){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${g} on local port ${_}.`),!v)return;if(w||(w="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(v,w,g,_,f,a,m);return o?o.then(d=>{if(!d){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(w,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(d);return(d.tunnelRemoteHost!==w||d.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const w=this._tunnels.get(v.tunnelRemoteHost);if(w){const g=w.get(v.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,g))}}}}async tryDisposeTunnel(v,w,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${w}.`);const _=g.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(w),_}}async closeTunnel(v,w){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${w} `);const g=this._tunnels.get(v);if(g&&g.has(w)){const _=g.get(w);_.refcount=0,await this.tryDisposeTunnel(v,w,_)}}addTunnelToMap(v,w,g){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(w,{refcount:1,value:g})}async removeEmptyTunnelFromMap(v,w){const g=this._tunnels.get(v);g&&(await g.get(w)||g.delete(w),g.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,w){let g=[v];L(v)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):P(v)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const _=g.map(f=>this._tunnels.get(f));for(const f of _){const a=f?.get(w);if(a)return a}}canTunnel(v){return!!T(v)}createWithProvider(v,w,g,_,f,a,m){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${g} on local port ${_}.`);const o=g;this._factoryInProgress.add(o);const r={elevationRequired:f?S(_===void 0?g:_):!1},s={remoteAddress:{host:w,port:g},localAddressPort:_,privacy:a,public:a?a!==D.Private:void 0,protocol:m},n=v.forwardPort(s,r);return n?(this.addTunnelToMap(w,g,n),n.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),n}};e.AbstractTunnelService=I,e.AbstractTunnelService=I=je([He(0,A.ILogService)],I)}),define(ke[204],Pe([1,0,10]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function i(b){return b.scheme!==u.Schemas.file&&b.scheme!==u.Schemas.vscodeRemote}e.isVirtualResource=i;function y(b){if(b.folders.length)return b.folders.every(T=>i(T.uri))?b.folders[0].uri:void 0;if(b.configuration&&i(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=y;function A(b){return y(b)?.scheme}e.getVirtualWorkspaceScheme=A;function C(b){return y(b)?.authority}e.getVirtualWorkspaceAuthority=C;function D(b){return y(b)!==void 0}e.isVirtualWorkspace=D}),define(ke[45],Pe([1,0,169,9,25,22,2,4,10]),function(Q,e,u,i,y,A,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function T(r){const s=r;return typeof s?.id=="string"&&C.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=T;function L(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=L;function P(r){const s=r;return typeof s?.id=="string"&&C.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=P;function S(r){const s=r;if(s?.uri)return{id:s.id,uri:C.URI.revive(s.uri)};const n=r;if(n?.configPath)return{id:n.id,configPath:C.URI.revive(n.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=S;var I;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(I||(e.WorkbenchState=I={}));function E(r){const s=r;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=E;function v(r){const s=r;return!!(s&&typeof s=="object"&&C.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=v;class w{constructor(s,n,t,c,l){this._id=s,this._transient=t,this._configuration=c,this._ignorePathCasing=l,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class g{constructor(s,n){this.raw=n,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function _(r){return new g({uri:r,index:0,name:(0,A.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=_,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,u.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(r,s){return A.extUriBiasedIgnorePathCase.isEqualOrParent(r,s.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function m(r){let s;return C.URI.isUri(r)?s=r:s=r.configuration,s?.scheme===b.Schemas.tmp}e.isTemporaryWorkspace=m;function o(r,s){return!a(r,s)&&!m(r)}e.isSavedWorkspace=o;function d(r){return(typeof r=="string"?(0,i.extname)(r):(0,A.extname)(r))===f}e.hasWorkspaceFileExtension=d}),define(ke[88],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class u{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const A=this._idPool++;return this._data.set(A,y),this.logDebugInfo(),A}get(y,A){return this._data.has(y)?this._data.get(y)[A]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!u.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=u,u.enableDebugLogging=!1}),define(ke[46],Pe([1,0,10,22,4]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(u.Schemas)),this._providerInfo=new Map,this.extUri=new i.ExtUri(D=>{const b=this._providerInfo.get(D.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(D,b){b===null?this._providerInfo.delete(D.scheme):this._providerInfo.set(D.scheme,b)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(ke[27],Pe([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,u.createDecorator)("IExtHostInitDataService")}),define(ke[205],Pe([1,0,17]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class i{constructor(C,D,b){this._deferredPromises=new Map,this._id=C,this._shared=D,this._storage=b,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new u.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of T.values())L.complete()}catch(L){for(const P of T.values())P.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(C,D){let b=this._value[C];return typeof b=="undefined"&&(b=D),b}update(C,D){this._value[C]=D;let b=this._deferredPromises.get(C);if(b!==void 0)return b.p;const T=new u.DeferredPromise;return this._deferredPromises.set(C,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=i;class y extends i{setKeysForSync(C){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},C)}constructor(C,D){super(C.identifier.value,!0,D);this._extension=C}}e.ExtensionGlobalMemento=y}),define(ke[206],Pe([1,0,3,2]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(C){this._notebooksAndEditors=C,this._onDidSaveNotebookDocument=new u.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new u.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(C,D,b,T){const P=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(C)).acceptModelChanged(D.value,b,T);this._onDidChangeNotebookDocument.fire(P)}$acceptDirtyStateChanged(C,D){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(C)).acceptDirty(D)}$acceptModelSaved(C){const D=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(C));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(ke[18],Pe([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,u.createDecorator)("IExtHostRpcService");class i{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=i});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Ue=this&&this.__classPrivateFieldGet||function(Q,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Q):i?i.value:e.get(Q)};define(ke[207],Pe([1,0,26,3]),function(Q,e,u,i){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(D,b){y.set(this,void 0),this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._id=u.ExtensionIdentifier.toKey(D.identifier),tt(this,y,b,"f"),Ue(this,y,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(D){return Ue(this,y,"f").get(this._id,D)}store(D,b){return Ue(this,y,"f").store(this._id,D,b)}delete(D){return Ue(this,y,"f").delete(this._id,D)}}e.ExtensionSecrets=A,y=new WeakMap}),define(ke[124],Pe([1,0,4,3]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class y{constructor(){this._onDidChangeTelemetryEnabled=new i.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new i.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(C,D){this._level=C,this._productConfig=D||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(C){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=C,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=y,e.IExtHostTelemetry=(0,u.createDecorator)("IExtHostTelemetry")}),define(ke[53],Pe([1,0,4,123,3,18]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(b){function T(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?i.TunnelPrivacyId.Public:i.TunnelPrivacyId.Private),protocol:P.protocol}}b.fromApiTunnel=T;function L(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==i.TunnelPrivacyId.ConstantPrivate&&P.privacy!==i.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}b.fromServiceTunnel=L})(C||(e.TunnelDtoConverter=C={})),e.IExtHostTunnelService=(0,u.createDecorator)("IExtHostTunnelService");let D=class{constructor(T){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,L){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,L){return{dispose:()=>{}}}async $providePortAttributes(T,L,P,S,I){return[]}async $forwardPort(T,L){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.ExtHostTunnelService=D,e.ExtHostTunnelService=D=je([He(0,A.IExtHostRpcService)],D)});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Ue=this&&this.__classPrivateFieldGet||function(Q,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Q):i?i.value:e.get(Q)};define(ke[7],Pe([1,0,16,11,102,25,95,8,12,2,35,43,121]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S){"use strict";var I,E,v,w,g,_,f,a,m,o,d,r,s,n,t,c,l,h,p,R,F,O;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(j){function W(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(W,j),Object.setPrototypeOf(W.prototype,j.prototype),W}let U=_=class{static from(...W){let ue=W;return new _(function(){if(ue){for(const Le of ue)Le&&typeof Le.dispose=="function"&&Le.dispose();ue=void 0}})}constructor(W){I.set(this,void 0),tt(this,I,W,"f")}dispose(){typeof Ue(this,I,"f")=="function"&&(Ue(this,I,"f").call(this),tt(this,I,void 0,"f"))}};e.Disposable=U,I=new WeakMap,e.Disposable=U=_=je([k],U);let B=f=class{static Min(...W){if(W.length===0)throw new TypeError;let ue=W[0];for(let Le=1;Le<W.length;Le++){const Ye=W[Le];Ye.isBefore(ue)&&(ue=Ye)}return ue}static Max(...W){if(W.length===0)throw new TypeError;let ue=W[0];for(let Le=1;Le<W.length;Le++){const Ye=W[Le];Ye.isAfter(ue)&&(ue=Ye)}return ue}static isPosition(W){if(!W)return!1;if(W instanceof f)return!0;let{line:ue,character:Le}=W;return typeof ue=="number"&&typeof Le=="number"}static of(W){if(W instanceof f)return W;if(this.isPosition(W))return new f(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(W,ue){if(W<0)throw(0,i.illegalArgument)("line must be non-negative");if(ue<0)throw(0,i.illegalArgument)("character must be non-negative");this._line=W,this._character=ue}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,ue=0){if(W===null||ue===null)throw(0,i.illegalArgument)();let Le;return typeof W=="undefined"?Le=0:typeof W=="number"?Le=W:(Le=typeof W.lineDelta=="number"?W.lineDelta:0,ue=typeof W.characterDelta=="number"?W.characterDelta:0),Le===0&&ue===0?this:new f(this.line+Le,this.character+ue)}with(W,ue=this.character){if(W===null||ue===null)throw(0,i.illegalArgument)();let Le;return typeof W=="undefined"?Le=this.line:typeof W=="number"?Le=W:(Le=typeof W.line=="number"?W.line:this.line,ue=typeof W.character=="number"?W.character:this.character),Le===this.line&&ue===this.character?this:new f(Le,ue)}toJSON(){return{line:this.line,character:this.character}}};e.Position=B,e.Position=B=f=je([k],B);let z=a=class{static isRange(W){return W instanceof a?!0:W?B.isPosition(W.start)&&B.isPosition(W.end):!1}static of(W){if(W instanceof a)return W;if(this.isRange(W))return new a(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(W,ue,Le,Ye){let nt,ct;if(typeof W=="number"&&typeof ue=="number"&&typeof Le=="number"&&typeof Ye=="number"?(nt=new B(W,ue),ct=new B(Le,Ye)):B.isPosition(W)&&B.isPosition(ue)&&(nt=B.of(W),ct=B.of(ue)),!nt||!ct)throw new Error("Invalid arguments");nt.isBefore(ct)?(this._start=nt,this._end=ct):(this._start=ct,this._end=nt)}contains(W){return a.isRange(W)?this.contains(W.start)&&this.contains(W.end):B.isPosition(W)?!(B.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const ue=B.Max(W.start,this._start),Le=B.Min(W.end,this._end);if(!ue.isAfter(Le))return new a(ue,Le)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ue=B.Min(W.start,this._start),Le=B.Max(W.end,this.end);return new a(ue,Le)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,ue=this.end){if(W===null||ue===null)throw(0,i.illegalArgument)();let Le;return W?B.isPosition(W)?Le=W:(Le=W.start||this.start,ue=W.end||this.end):Le=this.start,Le.isEqual(this._start)&&ue.isEqual(this.end)?this:new a(Le,ue)}toJSON(){return[this.start,this.end]}};e.Range=z,e.Range=z=a=je([k],z);let Y=m=class extends z{static isSelection(W){return W instanceof m?!0:W?z.isRange(W)&&B.isPosition(W.anchor)&&B.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(W,ue,Le,Ye){let nt,ct;if(typeof W=="number"&&typeof ue=="number"&&typeof Le=="number"&&typeof Ye=="number"?(nt=new B(W,ue),ct=new B(Le,Ye)):B.isPosition(W)&&B.isPosition(ue)&&(nt=B.of(W),ct=B.of(ue)),!nt||!ct)throw new Error("Invalid arguments");super(nt,ct);this._anchor=nt,this._active=ct}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=Y,e.Selection=Y=m=je([k],Y);class ${constructor(W,ue,Le){if(typeof W!="string"||W.length===0)throw(0,i.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,i.illegalArgument)("port");if(typeof Le!="undefined"&&(typeof Le!="string"||Le.length===0||!/^[0-9A-Za-z\-]+$/.test(Le)))throw(0,i.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(ue),this.connectionToken=Le}}e.ResolvedAuthority=$;class N extends Error{static NotAvailable(W,ue){return new N(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(W){return new N(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ue=S.RemoteAuthorityResolverErrorCode.Unknown,Le){super(W);this._message=W,this._code=ue,this._detail=Le,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}}e.RemoteAuthorityResolverError=N;var V;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(V||(e.EndOfLine=V={}));var H;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(H||(e.EnvironmentVariableMutatorType=H={}));let q=o=class{static isTextEdit(W){return W instanceof o?!0:W?z.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ue){return new o(W,ue)}static insert(W,ue){return o.replace(new z(W,W),ue)}static delete(W){return o.replace(W,"")}static setEndOfLine(W){const ue=new o(new z(new B(0,0),new B(0,0)),"");return ue.newEol=W,ue}get range(){return this._range}set range(W){if(W&&!z.isRange(W))throw(0,i.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,i.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,i.illegalArgument)("newEol");this._newEol=W}constructor(W,ue){this._range=W,this._newText=ue}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=q,e.TextEdit=q=o=je([k],q);let te=d=class{static isNotebookCellEdit(W){return W instanceof d?!0:W?Ut.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ue){return new d(W,ue)}static insertCells(W,ue){return new d(new Ut(W,W),ue)}static deleteCells(W){return new d(W,[])}static updateCellMetadata(W,ue){const Le=new d(new Ut(W,W),[]);return Le.newCellMetadata=ue,Le}static updateNotebookMetadata(W){const ue=new d(new Ut(0,0),[]);return ue.newNotebookMetadata=W,ue}constructor(W,ue){this.range=W,this.newCells=ue}};e.NotebookEdit=te,e.NotebookEdit=te=d=je([k],te);class fe{constructor(W,ue){this.range=W,this.snippet=ue}}e.SnippetTextEdit=fe;var ne;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(ne||(e.FileEditType=ne={}));let le=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,ue,Le,Ye){this._edits.push({_type:1,from:W,to:ue,options:Le,metadata:Ye})}createFile(W,ue,Le){this._edits.push({_type:1,from:void 0,to:W,options:ue,metadata:Le})}deleteFile(W,ue,Le){this._edits.push({_type:1,from:W,to:void 0,options:ue,metadata:Le})}replaceNotebookMetadata(W,ue,Le){this._edits.push({_type:3,metadata:Le,uri:W,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells(W,ue,Le,Ye,nt){let ct,lt,Dt=[],Nt;if(Ut.isNotebookRange(ue)&&jt.isNotebookCellDataArray(Le)&&!jt.isNotebookCellDataArray(Ye)?(ct=ue.start,lt=ue.end,Dt=Le,Nt=Ye):typeof ue=="number"&&typeof Le=="number"&&jt.isNotebookCellDataArray(Ye)&&(ct=ue,lt=Le,Dt=Ye,Nt=nt),ct===void 0||lt===void 0)throw new Error("Invalid arguments");(ct!==lt||Dt.length>0)&&this._edits.push({_type:5,uri:W,index:ct,count:lt-ct,cells:Dt,metadata:Nt})}replaceNotebookCellMetadata(W,ue,Le,Ye){this._edits.push({_type:3,metadata:Ye,uri:W,edit:{editType:8,index:ue,metadata:Le}})}replace(W,ue,Le,Ye){this._edits.push({_type:2,uri:W,edit:new q(ue,Le),metadata:Ye})}insert(W,ue,Le,Ye){this.replace(W,new z(ue,ue),Le,Ye)}delete(W,ue,Le){this.replace(W,ue,"",Le)}has(W){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===W.toString())}set(W,ue){if(ue)for(const Le of ue)Le&&(te.isNotebookCellEdit(Le)?Le.newCellMetadata?this.replaceNotebookCellMetadata(W,Le.range.start,Le.newCellMetadata):Le.newNotebookMetadata?this.replaceNotebookMetadata(W,Le.newNotebookMetadata):this.replaceNotebookCells(W,Le.range,Le.newCells):this._edits.push({_type:2,uri:W,edit:Le}));else{for(let Le=0;Le<this._edits.length;Le++){const Ye=this._edits[Le];Ye._type===2&&Ye.uri.toString()===W.toString()&&(this._edits[Le]=void 0)}(0,u.coalesceInPlace)(this._edits)}}get(W){const ue=[];for(let Le of this._edits)Le._type===2&&Le.uri.toString()===W.toString()&&ue.push(Le.edit);return ue}entries(){const W=new A.ResourceMap;for(let ue of this._edits)if(ue._type===2){let Le=W.get(ue.uri);Le||(Le=[ue.uri,[]],W.set(ue.uri,Le)),Le[1].push(ue.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=le,e.WorkspaceEdit=le=je([k],le);let K=r=class{static isSnippetString(W){return W instanceof r?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this._tabstop=1,this.value=W||""}appendText(W){return this.value+=r._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ue=this._tabstop++){if(typeof W=="function"){const Le=new r;Le._tabstop=this._tabstop,W(Le),this._tabstop=Le._tabstop,W=Le.value}else W=r._escape(W);return this.value+="${",this.value+=ue,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ue=this._tabstop++){const Le=W.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(W,ue){if(typeof ue=="function"){const Le=new r;Le._tabstop=this._tabstop,ue(Le),this._tabstop=Le._tabstop,ue=Le.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};e.SnippetString=K,e.SnippetString=K=r=je([k],K);var ge;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ge||(e.DiagnosticTag=ge={}));var ve;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ve||(e.DiagnosticSeverity=ve={}));let se=s=class{static isLocation(W){return W instanceof s?!0:W?z.isRange(W.range)&&T.URI.isUri(W.uri):!1}constructor(W,ue){if(this.uri=W,ue)if(z.isRange(ue))this.range=z.of(ue);else if(B.isPosition(ue))this.range=new z(ue,ue);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=se,e.Location=se=s=je([k],se);let be=class{static is(W){return W?typeof W.message=="string"&&W.location&&z.isRange(W.location.range)&&T.URI.isUri(W.location.uri):!1}constructor(W,ue){this.location=W,this.message=ue}static isEqual(W,ue){return W===ue?!0:!W||!ue?!1:W.message===ue.message&&W.location.range.isEqual(ue.location.range)&&W.location.uri.toString()===ue.location.uri.toString()}};e.DiagnosticRelatedInformation=be,e.DiagnosticRelatedInformation=be=je([k],be);let Te=class{constructor(W,ue,Le=ve.Error){if(!z.isRange(W))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=W,this.message=ue,this.severity=Le}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ue){return W===ue?!0:!W||!ue?!1:W.message===ue.message&&W.severity===ue.severity&&W.code===ue.code&&W.severity===ue.severity&&W.source===ue.source&&W.range.isEqual(ue.range)&&(0,u.equals)(W.tags,ue.tags)&&(0,u.equals)(W.relatedInformation,ue.relatedInformation,be.isEqual)}};e.Diagnostic=Te,e.Diagnostic=Te=je([k],Te);let pe=class{constructor(W,ue){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ue}};e.Hover=pe,e.Hover=pe=je([k],pe);var we;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(we||(e.DocumentHighlightKind=we={}));let Ae=class{constructor(W,ue=we.Text){this.range=W,this.kind=ue}toJSON(){return{range:this.range,kind:we[this.kind]}}};e.DocumentHighlight=Ae,e.DocumentHighlight=Ae=je([k],Ae);var ce;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ce||(e.SymbolKind=ce={}));var me;(function(j){j[j.Deprecated=1]="Deprecated"})(me||(e.SymbolTag=me={}));let ie=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ue,Le,Ye,nt){this.name=W,this.kind=ue,this.containerName=nt,typeof Le=="string"&&(this.containerName=Le),Ye instanceof se?this.location=Ye:Le instanceof z&&(this.location=new se(Ye,Le)),n.validate(this)}toJSON(){return{name:this.name,kind:ce[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=ie,e.SymbolInformation=ie=n=je([k],ie);let ee=t=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(t.validate)}constructor(W,ue,Le,Ye,nt){this.name=W,this.detail=ue,this.kind=Le,this.range=Ye,this.selectionRange=nt,this.children=[],t.validate(this)}};e.DocumentSymbol=ee,e.DocumentSymbol=ee=t=je([k],ee);var M;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(M||(e.CodeActionTriggerKind=M={}));let x=class{constructor(W,ue){this.title=W,this.kind=ue}};e.CodeAction=x,e.CodeAction=x=je([k],x);let G=c=class{constructor(W){this.value=W}append(W){return new c(this.value?this.value+c.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+c.sep)}};e.CodeActionKind=G,G.sep=".",e.CodeActionKind=G=c=je([k],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll");let X=class{constructor(W,ue){if(this.range=W,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=X,e.SelectionRange=X=je([k],X);class de{constructor(W,ue,Le,Ye,nt,ct){this.kind=W,this.name=ue,this.detail=Le,this.uri=Ye,this.range=nt,this.selectionRange=ct}}e.CallHierarchyItem=de;class Ee{constructor(W,ue){this.fromRanges=ue,this.from=W}}e.CallHierarchyIncomingCall=Ee;class oe{constructor(W,ue){this.fromRanges=ue,this.to=W}}e.CallHierarchyOutgoingCall=oe;var De;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(De||(e.LanguageStatusSeverity=De={}));let ye=class{constructor(W,ue){this.range=W,this.command=ue}get isResolved(){return!!this.command}};e.CodeLens=ye,e.CodeLens=ye=je([k],ye);let ze=l=class{static isMarkdownString(W){return W instanceof l?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ue=!1){E.set(this,void 0),tt(this,E,new y.MarkdownString(W,{supportThemeIcons:ue}),"f")}get value(){return Ue(this,E,"f").value}set value(W){Ue(this,E,"f").value=W}get isTrusted(){return Ue(this,E,"f").isTrusted}set isTrusted(W){Ue(this,E,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,E,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,E,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,E,"f").supportHtml}set supportHtml(W){Ue(this,E,"f").supportHtml=W}get baseUri(){return Ue(this,E,"f").baseUri}set baseUri(W){Ue(this,E,"f").baseUri=W}appendText(W){return Ue(this,E,"f").appendText(W),this}appendMarkdown(W){return Ue(this,E,"f").appendMarkdown(W),this}appendCodeblock(W,ue){return Ue(this,E,"f").appendCodeblock(ue??"",W),this}};e.MarkdownString=ze,E=new WeakMap,e.MarkdownString=ze=l=je([k],ze);let Ve=class{constructor(W,ue){this.label=W,this.documentation=ue}};e.ParameterInformation=Ve,e.ParameterInformation=Ve=je([k],Ve);let Me=class{constructor(W,ue){this.label=W,this.documentation=ue,this.parameters=[]}};e.SignatureInformation=Me,e.SignatureInformation=Me=je([k],Me);let Je=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Je,e.SignatureHelp=Je=je([k],Je);var J;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(J||(e.SignatureHelpTriggerKind=J={}));var re;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(re||(e.InlayHintKind=re={}));let Ce=class{constructor(W){this.value=W}};e.InlayHintLabelPart=Ce,e.InlayHintLabelPart=Ce=je([k],Ce);let ae=class{constructor(W,ue,Le){this.position=W,this.label=ue,this.kind=Le}};e.InlayHint=ae,e.InlayHint=ae=je([k],ae);var Ie;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ie||(e.CompletionTriggerKind=Ie={}));var Ne;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Ne||(e.CompletionItemKind=Ne={}));var $e;(function(j){j[j.Deprecated=1]="Deprecated"})($e||(e.CompletionItemTag=$e={}));let Ge=class{constructor(W,ue){this.label=W,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Ge,e.CompletionItem=Ge=je([k],Ge);let qe=class{constructor(W=[],ue=!1){this.items=W,this.isIncomplete=ue}};e.CompletionList=qe,e.CompletionList=qe=je([k],qe);let Ze=class{constructor(W,ue,Le){this.insertText=W,this.range=ue,this.command=Le}};e.InlineSuggestion=Ze,e.InlineSuggestion=Ze=je([k],Ze);let Xe=class{constructor(W){this.commands=void 0,this.items=W}};e.InlineSuggestionList=Xe,e.InlineSuggestionList=Xe=je([k],Xe);let st=class{constructor(W,ue,Le){this.insertText=W,this.range=ue,this.command=Le}};e.InlineSuggestionNew=st,e.InlineSuggestionNew=st=je([k],st);let et=class{constructor(W,ue){this.items=W,this.commands=ue}};e.InlineSuggestionsNew=et,e.InlineSuggestionsNew=et=je([k],et);var rt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var ot;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));var Et;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Et||(e.TextEditorLineNumbersStyle=Et={}));var At;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(At||(e.TextDocumentSaveReason=At={}));var It;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(It||(e.TextEditorRevealType=It={}));var ft;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(ft||(e.TextEditorSelectionChangeKind=ft={}));var Rt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Rt||(e.TextDocumentChangeReason=Rt={}));var Bt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Bt||(e.DecorationRangeBehavior=Bt={})),function(j){function W(ue){switch(ue){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=W}(ft||(e.TextEditorSelectionChangeKind=ft={}));let St=class{constructor(W,ue){if(ue&&!T.URI.isUri(ue))throw(0,i.illegalArgument)("target");if(!z.isRange(W)||W.isEmpty)throw(0,i.illegalArgument)("range");this.range=W,this.target=ue}};e.DocumentLink=St,e.DocumentLink=St=je([k],St);let Ke=class{constructor(W,ue,Le,Ye){this.red=W,this.green=ue,this.blue=Le,this.alpha=Ye}};e.Color=Ke,e.Color=Ke=je([k],Ke);let Lt=class{constructor(W,ue){if(ue&&!(ue instanceof Ke))throw(0,i.illegalArgument)("color");if(!z.isRange(W)||W.isEmpty)throw(0,i.illegalArgument)("range");this.range=W,this.color=ue}};e.ColorInformation=Lt,e.ColorInformation=Lt=je([k],Lt);let Mt=class{constructor(W){if(!W||typeof W!="string")throw(0,i.illegalArgument)("label");this.label=W}};e.ColorPresentation=Mt,e.ColorPresentation=Mt=je([k],Mt);var Ot;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Ot||(e.ColorFormat=Ot={}));var pt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(pt||(e.SourceControlInputBoxValidationType=pt={}));class yt{constructor(W,ue,Le){if(this.startIndex=W,this.length=ue,this.tooltip=Le,typeof W!="number"||W<0)throw(0,i.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,i.illegalArgument)("length");if(Le!==void 0&&typeof Le!="string")throw(0,i.illegalArgument)("tooltip")}}e.TerminalLink=yt;var kt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class _t{constructor(W){if(this.options=W,typeof W!="object")throw(0,i.illegalArgument)("options")}}e.TerminalProfile=_t;var Re;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Re||(e.TaskRevealKind=Re={}));var Fe;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Fe||(e.TaskPanelKind=Fe={}));let _e=h=class{static from(W){switch(W){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(W,ue){if(this.label=ue,typeof W!="string"||typeof ue!="string")throw(0,i.illegalArgument)("name");this._id=W}get id(){return this._id}};e.TaskGroup=_e,_e.Clean=new h("clean","Clean"),_e.Build=new h("build","Build"),_e.Rebuild=new h("rebuild","Rebuild"),_e.Test=new h("test","Test"),e.TaskGroup=_e=h=je([k],_e);function Z(j){let W="";for(let ue=0;ue<j.length;ue++)W+=j[ue].replace(/,/g,",,")+",";return W}let Oe=class{constructor(W,ue,Le){if(typeof W!="string")throw(0,i.illegalArgument)("process");this._args=[],this._process=W,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=Le):this._options=ue)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,i.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let ue of this._args)W.push(ue);return Z(W)}};e.ProcessExecution=Oe,e.ProcessExecution=Oe=je([k],Oe);let We=class{constructor(W,ue,Le){if(this._args=[],Array.isArray(ue)){if(!W)throw(0,i.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,i.illegalArgument)("command");this._command=W,this._args=ue,this._options=Le}else{if(typeof W!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=W,this._options=ue}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,i.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ue of this._args)W.push(typeof ue=="string"?ue:ue.value);return Z(W)}};e.ShellExecution=We,e.ShellExecution=We=je([k],We);var it;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(it||(e.ShellQuoting=it={}));var Qe;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Qe||(e.TaskScope=Qe={}));class ut{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=ut;let ht=p=class{constructor(W,ue,Le,Ye,nt,ct){this.__deprecated=!1,this._definition=this.definition=W;let lt;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=Le,this.execution=Ye,lt=nt,this.__deprecated=!0):ue===Qe.Global||ue===Qe.Workspace?(this.target=ue,this._name=this.name=Le,this._source=this.source=Ye,this.execution=nt,lt=ct):(this.target=ue,this._name=this.name=Le,this._source=this.source=Ye,this.execution=nt,lt=ct),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Oe?this._definition={type:p.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:p.ShellType,id:this._execution.computeId()}:this._execution instanceof ut?this._definition={type:p.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:p.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,i.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,i.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const ue=this._definition.type;(p.EmptyType===ue||p.ProcessType===ue||p.ShellType===ue||p.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,i.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};e.Task=ht,ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",e.Task=ht=p=je([k],ht);var wt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(wt||(e.ProgressLocation=wt={}));let mt=class{constructor(W,ue=Pt.None){this.collapsibleState=ue,T.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.TreeItem=mt,e.TreeItem=mt=je([k],mt);var Pt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Pt||(e.TreeItemCollapsibleState=Pt={}));let Ft=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.DataTransferItem=Ft,e.DataTransferItem=Ft=je([k],Ft);let vt=class{constructor(W){v.set(this,new Map);for(const[ue,Le]of W??[]){const Ye=Ue(this,v,"f").get(ue);Ye?Ye.push(Le):Ue(this,v,"f").set(ue,[Le])}}get(W){return Ue(this,v,"f").get(W)?.[0]}set(W,ue){Ue(this,v,"f").set(W,[ue])}forEach(W){for(const[ue,Le]of Ue(this,v,"f"))Le.forEach(Ye=>W(Ye,ue))}};e.DataTransfer=vt,v=new WeakMap,e.DataTransfer=vt=je([k],vt);let Wt=class{constructor(W,ue){this.id=W,this.color=ue}};e.ThemeIcon=Wt,e.ThemeIcon=Wt=je([k],Wt),Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let Yt=class{constructor(W){this.id=W}};e.ThemeColor=Yt,e.ThemeColor=Yt=je([k],Yt);var ai;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(ai||(e.ConfigurationTarget=ai={}));let ci=class{get base(){return this._base}set base(W){this._base=W,this._baseUri=T.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}constructor(W,ue){if(typeof W!="string"&&(!W||!T.URI.isUri(W)&&!T.URI.isUri(W.uri)))throw(0,i.illegalArgument)("base");if(typeof ue!="string")throw(0,i.illegalArgument)("pattern");typeof W=="string"?this.baseUri=T.URI.file(W):T.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ue}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=ci,e.RelativePattern=ci=je([k],ci);let Ct=class{constructor(W,ue,Le,Ye){this.enabled=typeof W=="boolean"?W:!0,typeof ue=="string"&&(this.condition=ue),typeof Le=="string"&&(this.hitCondition=Le),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};e.Breakpoint=Ct,e.Breakpoint=Ct=je([k],Ct);let ii=class extends Ct{constructor(W,ue,Le,Ye,nt){super(ue,Le,Ye,nt);if(W===null)throw(0,i.illegalArgument)("location");this.location=W}};e.SourceBreakpoint=ii,e.SourceBreakpoint=ii=je([k],ii);let li=class extends Ct{constructor(W,ue,Le,Ye,nt){super(ue,Le,Ye,nt);this.functionName=W}};e.FunctionBreakpoint=li,e.FunctionBreakpoint=li=je([k],li);let Gt=class extends Ct{constructor(W,ue,Le,Ye,nt,ct,lt){super(Ye,nt,ct,lt);if(!ue)throw(0,i.illegalArgument)("dataId");this.label=W,this.dataId=ue,this.canPersist=Le}};e.DataBreakpoint=Gt,e.DataBreakpoint=Gt=je([k],Gt);let Kt=class{constructor(W,ue,Le){this.command=W,this.args=ue||[],this.options=Le}};e.DebugAdapterExecutable=Kt,e.DebugAdapterExecutable=Kt=je([k],Kt);let dt=class{constructor(W,ue){this.port=W,this.host=ue}};e.DebugAdapterServer=dt,e.DebugAdapterServer=dt=je([k],dt);let ui=class{constructor(W){this.path=W}};e.DebugAdapterNamedPipeServer=ui,e.DebugAdapterNamedPipeServer=ui=je([k],ui);let xt=class{constructor(W){this.implementation=W}};e.DebugAdapterInlineImplementation=xt,e.DebugAdapterInlineImplementation=xt=je([k],xt);let Vt=class{constructor(W,ue){this.range=W,this.expression=ue}};e.EvaluatableExpression=Vt,e.EvaluatableExpression=Vt=je([k],Vt);var di;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(di||(e.InlineCompletionTriggerKind=di={}));var vi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(vi||(e.InlineCompletionTriggerKindNew=vi={}));let ni=class{constructor(W,ue){this.range=W,this.text=ue}};e.InlineValueText=ni,e.InlineValueText=ni=je([k],ni);let hi=class{constructor(W,ue,Le=!0){this.range=W,this.variableName=ue,this.caseSensitiveLookup=Le}};e.InlineValueVariableLookup=hi,e.InlineValueVariableLookup=hi=je([k],hi);let ri=class{constructor(W,ue){this.range=W,this.expression=ue}};e.InlineValueEvaluatableExpression=ri,e.InlineValueEvaluatableExpression=ri=je([k],ri);let Xt=class{constructor(W,ue){this.frameId=W,this.stoppedLocation=ue}};e.InlineValueContext=Xt,e.InlineValueContext=Xt=je([k],Xt);var wi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(wi||(e.FileChangeType=wi={}));let Jt=R=class extends Error{static FileExists(W){return new R(W,P.FileSystemProviderErrorCode.FileExists,R.FileExists)}static FileNotFound(W){return new R(W,P.FileSystemProviderErrorCode.FileNotFound,R.FileNotFound)}static FileNotADirectory(W){return new R(W,P.FileSystemProviderErrorCode.FileNotADirectory,R.FileNotADirectory)}static FileIsADirectory(W){return new R(W,P.FileSystemProviderErrorCode.FileIsADirectory,R.FileIsADirectory)}static NoPermissions(W){return new R(W,P.FileSystemProviderErrorCode.NoPermissions,R.NoPermissions)}static Unavailable(W){return new R(W,P.FileSystemProviderErrorCode.Unavailable,R.Unavailable)}constructor(W,ue=P.FileSystemProviderErrorCode.Unknown,Le){super(T.URI.isUri(W)?W.toString(!0):W);this.code=Le?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.FileSystemError=Jt,e.FileSystemError=Jt=R=je([k],Jt);let Zt=class{constructor(W,ue,Le){this.start=W,this.end=ue,this.kind=Le}};e.FoldingRange=Zt,e.FoldingRange=Zt=je([k],Zt);var bi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(bi||(e.FoldingRangeKind=bi={}));var Ei;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ei||(e.CommentThreadCollapsibleState=Ei={}));var Qt;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Qt||(e.CommentMode=Qt={}));var _i;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Ri{constructor(W,ue=[]){this.tokenTypes=W,this.tokenModifiers=ue}}e.SemanticTokensLegend=Ri;function Li(j){return typeof j=="undefined"||(0,b.isStringArray)(j)}class fi{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let ue=0,Le=W.tokenTypes.length;ue<Le;ue++)this._tokenTypeStrToInt.set(W.tokenTypes[ue],ue);for(let ue=0,Le=W.tokenModifiers.length;ue<Le;ue++)this._tokenModifierStrToInt.set(W.tokenModifiers[ue],ue)}}push(W,ue,Le,Ye,nt){if(typeof W=="number"&&typeof ue=="number"&&typeof Le=="number"&&typeof Ye=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(W,ue,Le,Ye,nt);if(z.isRange(W)&&typeof ue=="string"&&Li(Le))return this._push(W,ue,Le);throw(0,i.illegalArgument)()}_push(W,ue,Le){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const Ye=W.start.line,nt=W.start.character,ct=W.end.character-W.start.character,lt=this._tokenTypeStrToInt.get(ue);let Dt=0;if(Le)for(const Nt of Le){if(!this._tokenModifierStrToInt.has(Nt))throw new Error("`tokenModifier` is not in the provided legend");const $t=this._tokenModifierStrToInt.get(Nt);Dt|=1<<$t>>>0}this._pushEncoded(Ye,nt,ct,lt,Dt)}_pushEncoded(W,ue,Le,Ye,nt){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Nt=0,$t=0;for(let Ht=0;Ht<Dt;Ht++){let qt=this._data[5*Ht],gi=this._data[5*Ht+1];qt===0?(qt=Nt,gi+=$t):qt+=Nt,this._data[5*Ht]=qt,this._data[5*Ht+1]=gi,Nt=qt,$t=gi}}let ct=W,lt=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=Le,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=nt,this._prevLine=W,this._prevChar=ue}static _sortAndDeltaEncode(W){let ue=[];const Le=W.length/5|0;for(let lt=0;lt<Le;lt++)ue[lt]=lt;ue.sort((lt,Dt)=>{const Nt=W[5*lt],$t=W[5*Dt];if(Nt===$t){const Ht=W[5*lt+1],qt=W[5*Dt+1];return Ht-qt}return Nt-$t});const Ye=new Uint32Array(W.length);let nt=0,ct=0;for(let lt=0;lt<Le;lt++){const Dt=5*ue[lt],Nt=W[Dt+0],$t=W[Dt+1],Ht=W[Dt+2],qt=W[Dt+3],gi=W[Dt+4],Ki=Nt-nt,on=Ki===0?$t-ct:$t,pi=5*lt;Ye[pi+0]=Ki,Ye[pi+1]=on,Ye[pi+2]=Ht,Ye[pi+3]=qt,Ye[pi+4]=gi,nt=Nt,ct=$t}return Ye}build(W){return this._dataIsSortedAndDeltaEncoded?new ei(new Uint32Array(this._data),W):new ei(fi._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=fi;class ei{constructor(W,ue){this.resultId=ue,this.data=W}}e.SemanticTokens=ei;class Si{constructor(W,ue,Le){this.start=W,this.deleteCount=ue,this.data=Le}}e.SemanticTokensEdit=Si;class yi{constructor(W,ue){this.resultId=ue,this.edits=W}}e.SemanticTokensEdits=yi;var xe;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(xe||(e.DebugConsoleMode=xe={}));let zt=class{constructor(){}};e.QuickInputButtons=zt,zt.Back={iconPath:new Wt("arrow-left")},e.QuickInputButtons=zt=je([k],zt);var mi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(mi||(e.QuickPickItemKind=mi={}));var gt;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(gt||(e.InputBoxValidationSeverity=gt={}));var Ci;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Ci||(e.ExtensionKind=Ci={}));class Oi{static validate(W){if(W.badge){let ue=(0,D.nextCharLength)(W.badge,0);if(ue<W.badge.length&&(ue+=(0,D.nextCharLength)(W.badge,ue)),W.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ue,Le){this.badge=W,this.tooltip=ue,this.color=Le}}e.FileDecoration=Oi;let si=class{constructor(W){this.kind=W}};e.ColorTheme=si,e.ColorTheme=si=je([k],si);var Di;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Di||(e.ColorThemeKind=Di={}));class Ut{static isNotebookRange(W){return W instanceof Ut?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(W,ue){if(W<0)throw(0,i.illegalArgument)("start must be positive");if(ue<0)throw(0,i.illegalArgument)("end must be positive");W<=ue?(this._start=W,this._end=ue):(this._start=ue,this._end=W)}with(W){let ue=this._start,Le=this._end;return W.start!==void 0&&(ue=W.start),W.end!==void 0&&(Le=W.end),ue===this._start&&Le===this._end?this:new Ut(ue,Le)}}e.NotebookRange=Ut;class jt{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ue=>jt.isNotebookCellData(ue))}static isNotebookCellData(W){return!0}constructor(W,ue,Le,Ye,nt,ct,lt){this.kind=W,this.value=ue,this.languageId=Le,this.mime=Ye,this.outputs=nt??[],this.metadata=ct,this.executionSummary=lt,jt.validate(this)}}e.NotebookCellData=jt;class Fi{constructor(W){this.cells=W}}e.NotebookData=Fi;class Ii{static isNotebookCellOutputItem(W){return W instanceof w?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ue={name:W.name,message:W.message,stack:W.stack};return w.json(ue,"application/vnd.code.notebook.error")}static stdout(W){return w.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return w.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ue="application/octet-stream"){return new w(W,ue)}static text(W,ue=C.Mimes.text){const Le=Ue(w,w,"f",g).encode(String(W));return new w(Le,ue)}static json(W,ue="text/x-json"){const Le=JSON.stringify(W,void 0,"	");return w.text(Le,ue)}constructor(W,ue){this.data=W,this.mime=ue;const Le=(0,C.normalizeMimeType)(ue,!0);if(!Le)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.NotebookCellOutputItem=Ii,w=Ii,g={value:new TextEncoder};class ti{static isNotebookCellOutput(W){return W instanceof ti?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&(0,b.isArray)(W.items)}static ensureUniqueMimeTypes(W,ue=!1){const Le=new Set,Ye=new Set;for(let nt=0;nt<W.length;nt++){const ct=W[nt],lt=(0,C.normalizeMimeType)(ct.mime);if(!Le.has(lt)){Le.add(lt);continue}Ye.add(nt),ue&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ye.size===0?W:W.filter((nt,ct)=>!Ye.has(ct))}constructor(W,ue,Le){this.items=ti.ensureUniqueMimeTypes(W,!0),typeof ue=="string"?(this.id=ue,this.metadata=Le):(this.id=(0,L.generateUuid)(),this.metadata=ue??Le)}}e.NotebookCellOutput=ti;var ki;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(ki||(e.NotebookCellKind=ki={}));var Pi;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Pi||(e.NotebookCellExecutionState=Pi={}));var Ti;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ti||(e.NotebookCellStatusBarAlignment=Ti={}));var Ai;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ai||(e.NotebookEditorRevealType=Ai={}));class Ni{constructor(W,ue){this.text=W,this.alignment=ue}}e.NotebookCellStatusBarItem=Ni;var he;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(he||(e.NotebookControllerAffinity=he={}));class Se{constructor(W,ue=[]){this.uri=W,this.provides=(0,u.asArray)(ue)}}e.NotebookRendererScript=Se;let Be=class{constructor(W,ue){this.label=W,this.timestamp=ue}};e.TimelineItem=Be,e.TimelineItem=Be=je([k],Be);var at;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(at||(e.ExtensionMode=at={}));var bt;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(bt||(e.ExtensionRuntime=bt={}));var Tt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Tt||(e.StandardTokenType=Tt={}));class Xi{constructor(W,ue){this.ranges=W,this.wordPattern=ue}}e.LinkedEditingRanges=Xi;class Qi{constructor(W,ue){this._port=W,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Qi;var Hi;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Hi||(e.TestResultState=Hi={}));var Vi;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(Vi||(e.TestRunProfileKind=Vi={}));let Mi=class{constructor(W=void 0,ue=void 0,Le=void 0){this.include=W,this.exclude=ue,this.profile=Le}};e.TestRunRequest=Mi,e.TestRunRequest=Mi=je([k],Mi);let Ui=F=class{static diff(W,ue,Le){const Ye=new F(W);return Ye.expectedOutput=ue,Ye.actualOutput=Le,Ye}constructor(W){this.message=W}};e.TestMessage=Ui,e.TestMessage=Ui=F=je([k],Ui);let Bi=class{constructor(W){this.id=W}};e.TestTag=Bi,e.TestTag=Bi=je([k],Bi);let oi=class{constructor(W,ue){this.covered=W,this.total=ue}};e.CoveredCount=oi,e.CoveredCount=oi=je([k],oi);let zi=O=class{static fromDetails(W,ue){const Le=new oi(0,0),Ye=new oi(0,0),nt=new oi(0,0);for(const lt of ue)if("branches"in lt){Le.total+=1,Le.covered+=lt.executionCount>0?1:0;for(const Dt of lt.branches)Ye.total+=1,Ye.covered+=Dt.executionCount>0?1:0}else nt.total+=1,nt.covered+=lt.executionCount>0?1:0;const ct=new O(W,Le,Ye.total>0?Ye:void 0,nt.total>0?nt:void 0);return ct.detailedCoverage=ue,ct}constructor(W,ue,Le,Ye){this.uri=W,this.statementCoverage=ue,this.branchCoverage=Le,this.functionCoverage=Ye}};e.FileCoverage=zi,e.FileCoverage=zi=O=je([k],zi);let Wi=class{constructor(W,ue,Le=[]){this.executionCount=W,this.location=ue,this.branches=Le}};e.StatementCoverage=Wi,e.StatementCoverage=Wi=je([k],Wi);let xi=class{constructor(W,ue){this.executionCount=W,this.location=ue}};e.BranchCoverage=xi,e.BranchCoverage=xi=je([k],xi);let $i=class{constructor(W,ue){this.executionCount=W,this.location=ue}};e.FunctionCoverage=$i,e.FunctionCoverage=$i=je([k],$i);var ji;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(ji||(e.ExternalUriOpenerPriority=ji={}));var qi;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(qi||(e.WorkspaceTrustState=qi={}));var Gi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Gi||(e.PortAutoForwardAction=Gi={}));class Yi{constructor(W,ue,Le,Ye,nt,ct){this.kind=W,this.name=ue,this.detail=Le,this.uri=Ye,this.range=nt,this.selectionRange=ct}}e.TypeHierarchyItem=Yi;class Ji{constructor(W){this.uri=W}}e.TextTabInput=Ji;class Zi{constructor(W,ue){this.original=W,this.modified=ue}}e.TextDiffTabInput=Zi;class en{constructor(W,ue){this.uri=W,this.viewType=ue}}e.CustomEditorTabInput=en;class tn{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=tn;class nn{constructor(W,ue){this.uri=W,this.notebookType=ue}}e.NotebookEditorTabInput=nn;class rn{constructor(W,ue,Le){this.original=W,this.modified=ue,this.notebookType=Le}}e.NotebookDiffEditorTabInput=rn;class sn{constructor(){}}e.TerminalEditorTabInput=sn}),define(ke[125],Pe([1,0,57,10,8,155,110,7,16]),function(Q,e,u,i,y,A,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function L(E,v){v?T.set(E,v):T.delete(E)}e.setWordDefinitionFor=L;function P(E){return T.get(E)}e.getWordDefinitionFor=P;class S extends A.MirrorTextModel{constructor(v,w,g,_,f,a,m,o){super(w,g,_,f);this._proxy=v,this._languageId=a,this._isDirty=m,this.notebook=o,this._isDisposed=!1}dispose(){(0,u.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,b.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===i.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},save(){return v._save()},getText(w){return w?v._getTextInRange(w):v.getText()},get eol(){return v._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(w){return v._lineAt(w)},offsetAt(w){return v._offsetAt(w)},positionAt(w){return v._positionAt(w)},validateRange(w){return v._validateRange(w)},validatePosition(w){return v._validatePosition(w)},getWordRangeAtPosition(w,g){return v._getWordRangeAtPosition(w,g)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,u.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,u.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const w=this._validateRange(v);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const g=this._eol,_=w.start.line,f=w.end.line,a=[];a.push(this._lines[_].substring(w.start.character));for(let m=_+1;m<f;m++)a.push(this._lines[m]);return a.push(this._lines[f].substring(0,w.end.character)),a.join(g)}_lineAt(v){let w;if(v instanceof D.Position?w=v.line:typeof v=="number"&&(w=v),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new I(w,this._lines[w],w===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(v),g=this._lines[w.index].length;return new D.Position(w.index,Math.min(w.remainder,g))}_validateRange(v){if(!(v instanceof D.Range))throw new Error("Invalid argument");const w=this._validatePosition(v.start),g=this._validatePosition(v.end);return w===v.start&&g===v.end?v:new D.Range(w.line,w.character,g.line,g.character)}_validatePosition(v){if(!(v instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:w,character:g}=v,_=!1;if(w<0)w=0,g=0,_=!0;else if(w>=this._lines.length)w=this._lines.length-1,g=this._lines[w].length,_=!0;else{const f=this._lines[w].length;g<0?(g=0,_=!0):g>f&&(g=f,_=!0)}return _?new D.Position(w,g):v}_getWordRangeAtPosition(v,w){const g=this._validatePosition(v);if(!w)w=P(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const _=(0,C.getWordAtText)(g.character+1,(0,C.ensureValidWordDefinition)(w),this._lines[g.line],0);if(_)return new D.Range(g.line,_.startColumn-1,g.line,_.endColumn-1)}}e.ExtHostDocumentData=S;class I{constructor(v,w,g){this._line=v,this._text=w,this._isLastLine=g}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=I}),define(ke[208],Pe([1,0,7,18,3]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(D){this._actual=new u.ColorTheme(u.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let b;switch(D){case"light":b=u.ColorThemeKind.Light;break;case"hcDark":b=u.ColorThemeKind.HighContrast;break;case"hcLight":b=u.ColorThemeKind.HighContrastLight;break;default:b=u.ColorThemeKind.Dark}this._actual=new u.ColorTheme(b),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=A,e.ExtHostTheming=A=je([He(0,i.IExtHostRpcService)],A)}),define(ke[66],Pe([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,u.createDecorator)("IURITransformerService");class i{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=i}),define(ke[209],Pe([1,0,23]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class i{constructor(){this.buffers=[]}add(b){let T=this.buffers.indexOf(b);return T<0&&(T=this.buffers.length,this.buffers.push(b)),T}}function y(D,b){if(b.serializeBuffersForPostMessage){const T=new i,L=(I,E)=>{if(E instanceof ArrayBuffer){const v=T.add(E);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(E)){const v=A(E);if(v){const w=T.add(E.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:v,byteLength:E.byteLength,byteOffset:E.byteOffset}}}}return E},P=JSON.stringify(D,L),S=T.buffers.map(I=>{const E=new Uint8Array(I);return u.VSBuffer.wrap(E)});return{message:P,buffers:S}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=y;function A(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(D,b){const T=b.map(S=>{const I=new ArrayBuffer(S.byteLength);return new Uint8Array(I).set(S.buffer),I}),L=b.length?(S,I)=>{if(I&&typeof I=="object"&&I.$$vscode_array_buffer_reference$$){const E=I,{index:v}=E,w=T[v];if(E.view)switch(E.view.type){case 1:return new Int8Array(w,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return I}:void 0;return{message:JSON.parse(D,L),arrayBuffers:T}}e.deserializeWebviewMessage=C}),define(ke[210],Pe([1,0,104]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function i(A){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:A,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function y(A){return new u.URITransformer(i(A))}e.createURITransformer=y}),define(ke[211],Pe([1,0,179,12,2,6,4,44,43,16,10]),function(Q,e,u,i,y,A,C,D,b,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var P;(function($){$[$.PROGRAMMATIC=1]="PROGRAMMATIC",$[$.USER=2]="USER",$[$.EDIT=3]="EDIT",$[$.NAVIGATION=4]="NAVIGATION",$[$.JUMP=5]="JUMP"})(P||(e.EditorPaneSelectionChangeReason=P={}));var S;(function($){$[$.IDENTICAL=1]="IDENTICAL",$[$.SIMILAR=2]="SIMILAR",$[$.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function I($){const N=$;return!!N&&typeof N.getSelection=="function"&&!!N.onDidChangeSelection}e.isEditorPaneWithSelection=I;function E($,N,V){for(const H of V.visibleEditorPanes)if(H.group.id===N&&$.matches(H.input))return H.getViewState()}e.findViewStateForEditor=E;function v($){if(r($))return!1;const N=$;return y.URI.isUri(N?.resource)}e.isResourceEditorInput=v;function w($){if(r($))return!1;const N=$;return N?.original!==void 0&&N.modified!==void 0}e.isResourceDiffEditorInput=w;function g($){if(r($)||w($))return!1;const N=$;return N?.primary!==void 0&&N.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function _($){if(r($))return!1;const N=$;return N?N.resource===void 0||N.resource.scheme===L.Schemas.untitled||N.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=_;var f;(function($){$[$.SHORT=0]="SHORT",$[$.MEDIUM=1]="MEDIUM",$[$.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var a;(function($){$[$.EXPLICIT=1]="EXPLICIT",$[$.AUTO=2]="AUTO",$[$.FOCUS_CHANGE=3]="FOCUS_CHANGE",$[$.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class m{constructor(){this.mapIdToSaveSource=new Map}registerSource(N,V){let H=this.mapIdToSaveSource.get(N);return H||(H={source:N,label:V},this.mapIdToSaveSource.set(N,H)),H.source}getSourceLabel(N){return this.mapIdToSaveSource.get(N)?.label??N}}e.SaveSourceRegistry=new m;var o;(function($){$[$.None=0]="None",$[$.Readonly=2]="Readonly",$[$.Untitled=4]="Untitled",$[$.Singleton=8]="Singleton",$[$.RequiresTrust=16]="RequiresTrust",$[$.CanSplitInGroup=32]="CanSplitInGroup",$[$.ForceDescription=64]="ForceDescription",$[$.CanDropIntoEditor=128]="CanDropIntoEditor"})(o||(e.EditorInputCapabilities=o={}));class d extends A.Disposable{}e.AbstractEditorInput=d;function r($){return $ instanceof d}e.isEditorInput=r;function s($){const N=$;return y.URI.isUri(N?.preferredResource)}function n($){const N=$;return r(N?.primary)&&r(N?.secondary)}e.isSideBySideEditorInput=n;function t($){const N=$;return r(N?.modified)&&r(N?.original)}e.isDiffEditorInput=t;function c($){return r($?.editor)}e.isEditorInputWithOptions=c;function l($){const N=$;return c($)&&N?.group!==void 0}e.isEditorInputWithOptionsAndGroup=l;function h($){const N=$;return typeof N?.groupId=="number"&&r(N.editor)}e.isEditorIdentifier=h;var p;(function($){$[$.UNKNOWN=0]="UNKNOWN",$[$.REPLACE=1]="REPLACE",$[$.MOVE=2]="MOVE",$[$.UNPIN=3]="UNPIN"})(p||(e.EditorCloseContext=p={}));var R;(function($){$[$.GROUP_ACTIVE=0]="GROUP_ACTIVE",$[$.GROUP_INDEX=1]="GROUP_INDEX",$[$.GROUP_LOCKED=2]="GROUP_LOCKED",$[$.EDITOR_OPEN=3]="EDITOR_OPEN",$[$.EDITOR_CLOSE=4]="EDITOR_CLOSE",$[$.EDITOR_MOVE=5]="EDITOR_MOVE",$[$.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",$[$.EDITOR_LABEL=7]="EDITOR_LABEL",$[$.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",$[$.EDITOR_PIN=9]="EDITOR_PIN",$[$.EDITOR_STICKY=10]="EDITOR_STICKY",$[$.EDITOR_DIRTY=11]="EDITOR_DIRTY",$[$.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var F;(function($){$[$.PRIMARY=1]="PRIMARY",$[$.SECONDARY=2]="SECONDARY",$[$.BOTH=3]="BOTH",$[$.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class O{getOriginalUri(N,V){if(!N)return;if(V?.supportSideBySide){const{primary:q,secondary:te}=this.getSideEditors(N);if(q&&te){if(V?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(te,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===F.ANY)return this.getOriginalUri(q,{filterByScheme:V.filterByScheme})??this.getOriginalUri(te,{filterByScheme:V.filterByScheme});N=V.supportSideBySide===F.PRIMARY?q:te}}if(w(N)||g(N))return;const H=s(N)?N.preferredResource:N.resource;return!H||!V||!V.filterByScheme?H:this.filterUri(H,V.filterByScheme)}getSideEditors(N){return n(N)||g(N)?{primary:N.primary,secondary:N.secondary}:t(N)||w(N)?{primary:N.modified,secondary:N.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(N,V){if(!N)return;if(V?.supportSideBySide){const{primary:q,secondary:te}=this.getSideEditors(N);if(q&&te){if(V?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(te,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===F.ANY)return this.getCanonicalUri(q,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(te,{filterByScheme:V.filterByScheme});N=V.supportSideBySide===F.PRIMARY?q:te}}if(w(N)||g(N))return;const H=N.resource;return!H||!V||!V.filterByScheme?H:this.filterUri(H,V.filterByScheme)}filterUri(N,V){if(Array.isArray(V)){if(V.some(H=>N.scheme===H))return N}else if(V===N.scheme)return N}}e.EditorResourceAccessor=new O;var k;(function($){$[$.LEFT=0]="LEFT",$[$.RIGHT=1]="RIGHT"})(k||(e.CloseDirection=k={}));class U{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(N){const V=this.instantiationService=N.get(C.IInstantiationService);for(const[H,q]of this.editorSerializerConstructors)this.createEditorSerializer(H,q,V);this.editorSerializerConstructors.clear()}createEditorSerializer(N,V,H){const q=H.createInstance(V);this.editorSerializerInstances.set(N,q)}registerFileEditorFactory(N){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=N}getFileEditorFactory(){return(0,i.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(N,V){if(this.editorSerializerConstructors.has(N)||this.editorSerializerInstances.has(N))throw new Error(`A editor serializer with type ID '${N}' was already registered.`);return this.instantiationService?this.createEditorSerializer(N,V,this.instantiationService):this.editorSerializerConstructors.set(N,V),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(N),this.editorSerializerInstances.delete(N)})}getEditorSerializer(N){return this.editorSerializerInstances.get(typeof N=="string"?N:N.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new U);async function B($,N){if(!$||!$.length)return[];const V=await Promise.all($.map(async H=>{const q=y.URI.revive(H.fileUri);if(!q||!await N.canHandleResource(q))return;let fe=H.exists,ne=H.type;if(typeof fe!="boolean"||typeof ne!="number")try{ne=(await N.stat(q)).isDirectory?b.FileType.Directory:b.FileType.Unknown,fe=!0}catch{fe=!1}if(!fe&&H.openOnlyIfExists||ne===b.FileType.Directory)return;const le={...H.options,pinned:!0};let K;return fe?K={resource:q,options:le}:K={resource:q,options:le,forceUntitled:!0},K}));return(0,T.coalesce)(V)}e.pathsToEditors=B;var z;(function($){$[$.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",$[$.SEQUENTIAL=1]="SEQUENTIAL"})(z||(e.EditorsOrder=z={}));function Y($){const N=$;if(!N)return!1;const V=N;if(V.modified)return Y(V.modified);const H=N;return!!(H.contributionsState&&H.viewState&&Array.isArray(H.cursorState))}e.isTextEditorViewState=Y}),define(ke[89],Pe([1,0,10,2]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(D,b){return D.scheme===u.Schemas.http||D.scheme===u.Schemas.https?D:(b&&b.authority&&b.isRemote&&D.scheme===u.Schemas.file&&(D=i.URI.from({scheme:u.Schemas.vscodeRemote,authority:b.authority,path:D.path})),i.URI.from({scheme:u.Schemas.https,authority:`${D.scheme}+${A(D.authority)}.${e.webviewRootResourceAuthority}`,path:D.path,fragment:D.fragment,query:D.query}))}e.asWebviewUri=y;function A(D){return D.replace(/./g,b=>{const T=b.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?b:"-"+T.toString(16).padStart(4,"0")})}function C(D){return D.replace(/-([0-9a-f]{4})/g,(b,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=C}),define(ke[212],Pe([1,0,3,6,89]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(D,b,T){this._proxy=D,this._editors=b,this._remoteInfo=T,this._handlePool=0,this._disposables=new i.DisposableStore,this._insets=new Map,this._disposables.add(b.onDidChangeVisibleTextEditors(()=>{const L=b.getVisibleTextEditors();for(const P of this._insets.values())L.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,b,T,L,P){let S;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===D){S=f;break}if(!S)throw new Error("not a visible editor");const I=this,E=this._handlePool++,v=new u.Emitter,w=new u.Emitter,g=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,y.asWebviewUri)(f,I._remoteInfo)}get cspSource(){return y.webviewGenericCspSource}set options(f){this._options=f,I._proxy.$setOptions(E,f)}get options(){return this._options}set html(f){this._html=f,I._proxy.$setHtml(E,f)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(f){return I._proxy.$postMessage(E,f)}},_=new class{constructor(){this.editor=D,this.line=b,this.height=T,this.webview=g,this.onDidDispose=w.event}dispose(){I._insets.has(E)&&(I._insets.delete(E),I._proxy.$disposeEditorInset(E),w.fire(),w.dispose(),v.dispose())}};return this._proxy.$createEditorInset(E,S.id,S.value.document.uri,b+1,T,L||{},P.identifier,P.extensionLocation),this._insets.set(E,{editor:D,inset:_,onDidReceiveMessage:v}),_}$onDidDispose(D){const b=this._insets.get(D);b&&b.inset.dispose()}$onDidReceiveMessage(D,b){const T=this._insets.get(D);T&&T.onDidReceiveMessage.fire(b)}}e.ExtHostEditorInsets=A}),define(ke[126],Pe([1,0,3,17,180]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new u.Emitter,this._onExit=new u.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,b,T,L){const P={command:D};if(b&&Object.keys(b).length>0&&(P.arguments=b),this.internalSend("request",P),typeof L=="number"){const S=setTimeout(()=>{clearTimeout(S);const I=this.pendingRequests.get(P.seq);if(I){this.pendingRequests.delete(P.seq);const E={type:"response",seq:0,request_seq:P.seq,success:!1,command:D,message:(0,y.localize)(0,null,L,D)};I(E)}},L)}return T&&this.pendingRequests.set(P.seq,T),P.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,b){return D.type!=="event"||b.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,i.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":{const b=D,T=this.pendingRequests.get(b.request_seq);T&&(this.pendingRequests.delete(b.request_seq),T(b));break}}}}internalSend(D,b){b.type=D,b.seq=this.sequence++,this.sendMessage(b)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((b,T)=>D.set(T,b)),await(0,i.timeout)(500),D.forEach((b,T)=>{b({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ke[213],Pe([1,0,181,52,4]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new i.RawContextKey("debugType",void 0,{type:"string",description:u.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new i.RawContextKey("debugConfigurationType",void 0,{type:"string",description:u.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new i.RawContextKey("debugState","inactive",{type:"string",description:u.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new i.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:u.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new i.RawContextKey("inDebugMode",!1,{type:"boolean",description:u.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new i.RawContextKey("inDebugRepl",!1,{type:"boolean",description:u.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new i.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:u.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new i.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:u.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new i.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:u.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new i.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:u.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new i.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:u.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new i.RawContextKey("variablesFocused",!0,{type:"boolean",description:u.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new i.RawContextKey("expressionSelected",!1,{type:"boolean",description:u.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new i.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:u.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new i.RawContextKey("callStackItemType",void 0,{type:"string",description:u.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new i.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:u.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new i.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:u.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new i.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:u.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new i.RawContextKey("watchItemType",void 0,{type:"string",description:u.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new i.RawContextKey("canViewMemory",void 0,{type:"boolean",description:u.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new i.RawContextKey("breakpointItemType",void 0,{type:"string",description:u.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new i.RawContextKey("breakpointAccessType",void 0,{type:"string",description:u.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new i.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:u.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new i.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:u.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new i.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:u.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new i.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:u.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new i.RawContextKey("stepBackSupported",!1,{type:"boolean",description:u.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new i.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:u.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new i.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:u.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new i.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:u.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new i.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:u.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new i.RawContextKey("breakpointsExist",!1,{type:"boolean",description:u.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new i.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:u.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new i.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:u.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new i.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:u.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new i.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:u.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new i.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:u.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new i.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:u.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new i.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:u.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new i.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:u.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new i.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:u.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new i.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:u.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new i.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:u.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new i.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:u.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new i.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:u.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new i.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:u.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new i.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:u.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new i.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:u.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new i.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:u.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new i.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:u.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new i.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:u.localize(50,null)});const A=S=>u.localize(51,null,S);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:u.localize(52,null)};var C;(function(S){S[S.Inactive=0]="Inactive",S[S.Initializing=1]="Initializing",S[S.Stopped=2]="Stopped",S[S.Running=3]="Running"})(C||(e.State=C={}));function D(S){switch(S){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=D;var b;(function(S){S[S.Valid=0]="Valid",S[S.Unreadable=1]="Unreadable",S[S.Error=2]="Error"})(b||(e.MemoryRangeType=b={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var T;(function(S){S[S.Initial=1]="Initial",S[S.Dynamic=2]="Dynamic"})(T||(e.DebugConfigurationProviderTriggerKind=T={}));var L;(function(S){S.UnverifiedBreakpoints="unverifiedBreakpoints"})(L||(e.DebuggerUiMessage=L={})),e.IDebugService=(0,y.createDecorator)(e.DEBUG_SERVICE_ID);var P;(function(S){S[S.CONDITION=0]="CONDITION",S[S.HIT_COUNT=1]="HIT_COUNT",S[S.LOG_MESSAGE=2]="LOG_MESSAGE"})(P||(e.BreakpointWidgetContext=P={}))}),define(ke[214],Pe([1,0,8,2,9,24,10]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function b(r,s,n){return r.replace(D,function(t,c){return s&&c.length>0&&c[0]!=="_"?t:n&&n.hasOwnProperty(c)?n[c]:t})}e.formatPII=b;function T(r){const s={};for(const n of Object.keys(r))n.startsWith("!")||(s[n]=r[n]);return s}e.filterExceptionsFromTelemetry=T;function L(r){return r.configuration.request==="attach"&&!P(r)&&(!r.parentSession||L(r.parentSession))}e.isSessionAttach=L;function P(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,u.equalsIgnoreCase)(s,"extensionhost")||(0,u.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?P(r.parentSession):void 0}e.getExtensionHostDebugSession=P;function S(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=S;function I(r,s,n){let t,c=0;const l=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=l.exec(r);){const p=h.index+1,R=p+h[0].length;if(p<=s&&R>=n){t=h[0],c=p;break}}if(t){const p=/\w+/g;let R=null;for(;(R=p.exec(t))&&!(R.index+1+c+R[0].length>=n););R&&(t=t.substring(0,p.lastIndex))}return t?{start:c,end:c+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=I;const E=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(r){return!!(r&&r.match(E))}e.isUri=v;function w(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(v(r.path))return i.URI.parse(r.path);if((0,y.isAbsolute)(r.path))return i.URI.file(r.path)}return r.path}function g(r){if(typeof r.path=="object"){const s=i.URI.revive(r.path);if(s)return s.scheme===C.Schemas.file?s.fsPath:s.toString()}return r.path}function _(r,s){const n=s?w:g,t=(0,A.deepClone)(r);return a(t,(c,l)=>{c&&l&&(l.path=n(l))}),t}e.convertToDAPaths=_;function f(r,s){const n=s?w:g,t=(0,A.deepClone)(r);return a(t,(c,l)=>{!c&&l&&(l.path=n(l))}),t}e.convertToVSCPaths=f;function a(r,s){switch(r.type){case"event":{const n=r;switch(n.event){case"output":s(!1,n.body.source);break;case"loadedSource":s(!1,n.body.source);break;case"breakpoint":s(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=r;switch(n.command){case"setBreakpoints":s(!0,n.arguments.source);break;case"breakpointLocations":s(!0,n.arguments.source);break;case"source":s(!0,n.arguments.source);break;case"gotoTargets":s(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(t=>s(!1,t));break;default:break}break}case"response":{const n=r;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(t=>s(!1,t.source));break;case"loadedSources":n.body.sources.forEach(t=>s(!1,t));break;case"scopes":n.body.scopes.forEach(t=>s(!1,t.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(t=>s(!1,t.source));break;case"setBreakpoints":n.body.breakpoints.forEach(t=>s(!1,t.source));break;case"disassemble":{const t=n;t.body&&t.body.instructions.forEach(c=>s(!1,c.location))}break;default:break}break}}}function m(r){return r.filter(s=>!s.presentation?.hidden).sort((s,n)=>s.presentation?n.presentation?s.presentation.group?n.presentation.group?s.presentation.group!==n.presentation.group?s.presentation.group.localeCompare(n.presentation.group):o(s.presentation.order,n.presentation.order):-1:n.presentation.group?1:o(s.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=m;function o(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}async function d(r,s){const n=r.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(n!=="none"&&(await s.saveAll(),n==="allEditorsInActiveGroup")){const t=s.activeEditorPane;t&&t.input.resource?.scheme===C.Schemas.untitled&&await s.save({editor:t.input,groupId:t.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(ke[215],Pe([1,0,29,42,182,127,9,8,24,13,85,126]),function(Q,e,u,i,y,A,C,D,b,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class S extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,f){this.outputStream=f,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",a=>this.handleData(a))}sendMessage(_){if(this.outputStream){const f=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${S.TWO_CRLF}${f}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const f=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(a){this._onError.fire(new Error((a.message||a)+`
`+f))}continue}}else{const f=this.rawData.indexOf(S.TWO_CRLF);if(f!==-1){const m=this.rawData.toString("utf8",0,f).split(S.HEADER_LINESEPARATOR);for(const o of m){const d=o.split(S.HEADER_FIELDSEPARATOR);d[0]==="Content-Length"&&(this.contentLength=Number(d[1]))}this.rawData=this.rawData.slice(f+S.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=S,S.TWO_CRLF=`\r
\r
`,S.HEADER_LINESEPARATOR=/\r?\n/,S.HEADER_FIELDSEPARATOR=/: */;class I extends S{startSession(){return new Promise((_,f)=>{let a=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),a=!0}),this.socket.on("close",()=>{a?this._onError.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.socket.on("error",m=>{a?this._onError.fire(m):f(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=I;class E extends I{constructor(_){super();this.adapterServer=_}createConnection(_){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=E;class v extends I{constructor(_){super();this.adapterServer=_}createConnection(_){return A.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=v;class w extends S{constructor(_,f,a){super();this.adapterExecutable=_,this.debugType=f,this.outputService=a}async startSession(){const _=this.adapterExecutable.command,f=this.adapterExecutable.args,a=this.adapterExecutable.options||{};try{if(_)if(C.isAbsolute(_)){if(!await u.Promises.exists(_))throw new Error(y.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let m=process.env;if(a.env&&Object.keys(a.env).length>0&&(m=b.mixin(b.deepClone(process.env),a.env)),_==="node")if(Array.isArray(f)&&f.length>0){const d=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:m,execArgv:d?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(r.cwd=a.cwd);const s=i.fork(f[0],f.slice(1),r);if(!s.pid)throw new Error(y.localize(2,null,f[0]));this.serverProcess=s}else throw new Error(y.localize(3,null));else{const d={env:m};a.cwd&&(d.cwd=a.cwd),this.serverProcess=i.spawn(_,f,d)}this.serverProcess.on("error",d=>{this._onError.fire(d)}),this.serverProcess.on("exit",(d,r)=>{this._onExit.fire(d)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",d=>{this._onError.fire(d)}),this.serverProcess.stdin.on("error",d=>{this._onError.fire(d)});const o=this.outputService;if(o){const d=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const s=o.getChannel(L.ExtensionsChannelId);s&&s.append(d(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),T.isWindows?new Promise((_,f)=>{const a=i.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,o,d){if(m)return f(m)});a.on("exit",_),a.on("error",f)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,f){if(!_)return;const a=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?a.runtime=C.join(f,_.runtime):a.runtime=_.runtime),_.runtimeArgs&&(a.runtimeArgs=_.runtimeArgs),_.program&&(C.isAbsolute(_.program)?a.program=_.program:a.program=C.join(f,_.program)),_.args&&(a.args=_.args);const m=_;return m.win&&(a.win=w.extract(m.win,f)),m.winx86&&(a.winx86=w.extract(m.winx86,f)),m.windows&&(a.windows=w.extract(m.windows,f)),m.osx&&(a.osx=w.extract(m.osx,f)),m.linux&&(a.linux=w.extract(m.linux,f)),a}static platformAdapterExecutable(_,f){let a=Object.create(null);f=f.toLowerCase();for(const n of _)if(n.contributes){const t=n.contributes.debuggers;t&&t.length>0&&t.filter(c=>typeof c.type=="string"&&D.equalsIgnoreCase(c.type,f)).forEach(c=>{const l=w.extract(c,n.extensionLocation.fsPath);a=b.mixin(a,l,n.isBuiltin)})}let m;T.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=a.winx86||a.win||a.windows:T.isWindows?m=a.win||a.windows:T.isMacintosh?m=a.osx:T.isLinux&&(m=a.linux),m=m||a;const o=m.program||a.program,d=m.args||a.args,r=m.runtime||a.runtime,s=m.runtimeArgs||a.runtimeArgs;if(r)return{type:"executable",command:r,args:(s||[]).concat(typeof o=="string"?[o]:[]).concat(d||[])};if(o)return{type:"executable",command:o,args:d||[]}}}e.ExecutableDebugAdapter=w}),define(ke[216],Pe([1,0,42,30,13]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(T,L){return new Promise((P,S)=>{let I="";const E=u.spawn(T,L);E.pid&&E.stdout.on("data",v=>{I+=v.toString()}),E.on("error",v=>{S(v)}),E.on("close",v=>{P(I)})})}async function C(T){if(T)if(y.isWindows){const L=await new Promise((P,S)=>{Q(["windows-process-tree"],P,S)});return new Promise(P=>{L.getProcessTree(T,S=>{P(!!S&&S.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(T)]).then(L=>{const P=L.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var D;(function(T){T[T.cmd=0]="cmd",T[T.powershell=1]="powershell",T[T.bash=2]="bash"})(D||(D={}));function b(T,L,P,S){T=T.trim().toLowerCase();let I;T.indexOf("powershell")>=0||T.indexOf("pwsh")>=0?I=1:T.indexOf("cmd.exe")>=0?I=0:T.indexOf("bash")>=0?I=2:y.isWindows?I=0:I=2;let E,v=" ";switch(I){case 1:if(E=w=>(w=w.replace(/\'/g,"''"),w.length>0&&w.charAt(w.length-1)==="\\"?`'${w}\\'`:`'${w}'`),P){const w=(0,i.getDriveLetter)(P);w&&(v+=`${w}:; `),v+=`cd ${E(P)}; `}if(S)for(const w in S){const g=S[w];g===null?v+=`Remove-Item env:${w}; `:v+=`\${env:${w}}='${g}'; `}if(L.length>0){const w=E(L.shift());v+=w[0]==="'"?`& ${w} `:`${w} `;for(const g of L)v+=g==="<"||g===">"?g:E(g),v+=" "}break;case 0:if(E=w=>(w=w.replace(/\"/g,'""'),w=w.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>w.includes(g))||w.length===0?`"${w}"`:w),P){const w=(0,i.getDriveLetter)(P);w&&(v+=`${w}: && `),v+=`cd ${E(P)} && `}if(S){v+='cmd /C "';for(const w in S){let g=S[w];g===null?v+=`set "${w}=" && `:(g=g.replace(/[&^|<>]/g,_=>`^${_}`),v+=`set "${w}=${g}" && `)}}for(const w of L)v+=w==="<"||w===">"?w:E(w),v+=" ";S&&(v+='"');break;case 2:{E=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),g.length===0?'""':g);const w=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(P&&(v+=`cd ${E(P)} ; `),S){v+="/usr/bin/env";for(const g in S){const _=S[g];_===null?v+=` -u ${w(g)}`:v+=` ${w(`${g}=${_}`)}`}v+=" "}for(const g of L)v+=g==="<"||g===">"?g:E(g),v+=" ";break}}return v}e.prepareCommand=b}),define(ke[128],Pe([1,0,34,60,95,10,9,13,52]),function(Q,e,u,i,y,A,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var T;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(T||(e.CellKind=T={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(L||(e.NotebookRunState=L={}));var P;(function(n){n[n.Unconfirmed=1]="Unconfirmed",n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(P||(e.NotebookCellExecutionState=P={}));var S;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var I;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(I||(e.RendererMessagingSpec=I={}));var E;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeCellLanguage=5]="ChangeCellLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(E||(e.NotebookCellsChangeType=E={}));var v;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(v||(e.SelectionStateType=v={}));var w;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(w||(e.CellEditType=w={}));var g;(function(n){n.scheme=A.Schemas.vscodeNotebookCell;const t=/^ch(\d{7,})/;function c(O,k){return O.with({scheme:n.scheme,fragment:`ch${k.toString().padStart(7,"0")}${O.scheme!==A.Schemas.file?O.scheme:""}`})}n.generate=c;function l(O){if(O.scheme!==n.scheme)return;const k=t.exec(O.fragment);return k?{handle:Number(k[1]),notebook:O.with({scheme:O.fragment.substring(k[0].length)||A.Schemas.file,fragment:null})}:void 0}n.parse=l;function h(O,k){return O.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${k??""},${O.scheme!==A.Schemas.file?O.scheme:""}`})}n.generateCellOutputUri=h;function p(O){if(O.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const k=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(O.fragment);if(!k)return;const U=k[1]&&k[1]!==""?k[1]:void 0,B=k[2];return{outputId:U,notebook:O.with({scheme:B||A.Schemas.file,fragment:null})}}n.parseCellOutputUri=p;function R(O,k,U){return O.with({scheme:U,fragment:`ch${k.toString().padStart(7,"0")}${O.scheme!==A.Schemas.file?O.scheme:""}`})}n.generateCellUri=R;function F(O,k){if(O.scheme!==k)return;const U=t.exec(O.fragment);return U?{handle:Number(U[1]),notebook:O.with({scheme:O.fragment.substring(U[0].length)||A.Schemas.file,fragment:null})}:void 0}n.parseCellUri=F})(g||(e.CellUri=g={}));const _=n=>D.isWindows?n.replace(/\//g,"\\"):n;class f{constructor(t=[],c=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=c,this.order=[...new Set(t)].map(l=>({pattern:l,matches:u.parse(_(l))}))}sort(t){const c=new Map(i.Iterable.map(t,h=>[h,_(h)]));let l=[];for(const{matches:h}of this.order)for(const[p,R]of c)if(h(R)){l.push(p),c.delete(p);break}return c.size&&(l=l.concat([...c.keys()].sort((h,p)=>this.defaultOrder.indexOf(h)-this.defaultOrder.indexOf(p)))),l}prioritize(t,c){const l=this.findIndex(t);if(l===-1){this.order.unshift({pattern:t,matches:u.parse(_(t))});return}const h=new Set(c.map(R=>this.findIndex(R,l)));h.delete(-1);const p=Array.from(h).sort();this.order.splice(l+1,0,...p.map(R=>this.order[R]));for(let R=p.length-1;R>=0;R--)this.order.splice(p[R],1)}toArray(){return this.order.map(t=>t.pattern)}findIndex(t,c=this.order.length){const l=_(t);for(let h=0;h<c;h++)if(this.order[h].matches(l))return h;return-1}}e.MimeTypeDisplayOrder=f;function a(n,t,c,l=(h,p)=>h===p){const h=[];function p(O,k,U){if(k===0&&U.length===0)return;const B=h[h.length-1];B&&B.start+B.deleteCount===O?(B.deleteCount+=k,B.toInsert.push(...U)):h.push({start:O,deleteCount:k,toInsert:U})}let R=0,F=0;for(;;){if(R===n.length){p(R,0,t.slice(F));break}if(F===t.length){p(R,n.length-R,[]);break}const O=n[R],k=t[F];if(l(O,k)){R+=1,F+=1;continue}c(k)?(p(R,1,[]),R+=1):(p(R,0,[k]),F+=1)}return h}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new b.RawContextKey("notebookEditorCursorAtBoundary","none");var m;(function(n){n.default="default",n.option="option"})(m||(e.NotebookEditorPriority=m={}));function o(n){const t=n;return!!((typeof t.include=="string"||u.isRelativePattern(t.include))&&(typeof t.exclude=="string"||u.isRelativePattern(t.exclude)))}e.isDocumentExcludePattern=o;function d(n,t,c){if(Array.isArray(n.viewType)&&n.viewType.indexOf(t)>=0||n.viewType===t)return!0;if(n.filenamePattern){const l=o(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,h=o(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(u.match(l,(0,C.basename)(c.fsPath).toLowerCase()))return!(h&&u.match(h,(0,C.basename)(c.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",interactiveWindowAlwaysScrollOnNewCell:"interactiveWindow.alwaysScrollOnNewCell"};var r;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(r||(e.CellStatusbarAlignment=r={}));class s{static create(t){return`${s._prefix}${t}`}static parse(t){if(t.startsWith(s._prefix))return t.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(ke[217],Pe([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var i;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(i||(e.CellExecutionUpdateType=i={})),e.INotebookExecutionService=(0,u.createDecorator)("INotebookExecutionService")}),define(ke[218],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function u(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=u;function i(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=i}),define(ke[67],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(A){A.Delimiter="\0"})(u||(e.TestIdPathParts=u={}));var i;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(i||(e.TestPosition=i={}));class y{static fromExtHostTestItem(C,D,b=C.parent){if(C.id===D)return new y([D]);let T=[C.id];for(let L=b;L&&L.id!==D;L=L.parent)T.push(L.id);return T.push(D),new y(T.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const D=C.indexOf("\0");return D===-1?C:C.slice(0,D)}static fromString(C){return new y(C.split("\0"))}static join(C,D){return new y([...C.path,D])}static joinToString(C,D){return C.toString()+"\0"+D}static compare(C,D){return C===D?0:D.startsWith(C+"\0")?2:C.startsWith(D+"\0")?3:1}constructor(C,D=C.length){if(this.path=C,this.viewEnd=D,C.length===0||D<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let C=1;C<=this.viewEnd;C++)yield new y(this.path,C)}compare(C){if(typeof C=="string")return y.compare(this.toString(),C);for(let D=0;D<C.viewEnd&&D<this.viewEnd;D++)if(C.path[D]!==this.path[D])return 1;return C.viewEnd>this.viewEnd?2:C.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let C=1;C<this.viewEnd;C++)this.stringifed+="\0",this.stringifed+=this.path[C]}return this.stringifed}}e.TestId=y}),define(ke[68],Pe([1,0,2,36]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var y;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(y||(e.TestResultState=y={}));var A;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(A||(e.TestRunProfileBitset=A={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:i.Range.lift(t.range),uri:u.URI.revive(t.uri)})})(C||(e.IRichLocation=C={}));var D;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(D||(e.TestMessageType=D={}));var b;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&C.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&C.deserialize(t.location)})})(b||(e.ITestErrorMessage=b={}));var T;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&C.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&C.deserialize(t.location)})})(T||(e.ITestOutputMessage=T={}));var L;(function(n){n.serialize=t=>t.type===0?b.serialize(t):T.serialize(t),n.deserialize=t=>t.type===0?b.deserialize(t):T.deserialize(t)})(L||(e.ITestMessage=L={}));var P;(function(n){n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.deserialize)})})(P||(e.ITestTaskState=P={}));const S="\0",I=(n,t)=>n+S+t;e.namespaceTestTag=I;const E=n=>{const t=n.indexOf(S);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=E;var v;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?u.URI.revive(t.uri):void 0,range:t.range?i.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(v||(e.ITestItem=v={}));var w;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(w||(e.TestItemExpandState=w={}));var g;(function(n){n.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:v.serialize(t.item)}),n.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:v.deserialize(t.item)})})(g||(e.InternalTestItem=g={}));var _;(function(n){n.serialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.uri!==void 0&&(c.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(c.range=t.item.range?.toJSON()),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}},n.deserialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.range!==void 0&&(c.range=t.item.range?i.Range.lift(t.item.range):null),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}}})(_||(e.ITestItemUpdate=_={}));const f=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=f;var a;(function(n){n.serialize=(t,c)=>({...g.serialize(t),children:c,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(P.serialize)})})(a||(e.TestResultItem=a={}));var m;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(m||(e.DetailType=m={}));var o;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.Remove=2]="Remove",n[n.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",n[n.Retire=4]="Retire",n[n.AddTag=5]="AddTag",n[n.RemoveTag=6]="RemoveTag"})(o||(e.TestDiffOpType=o={}));var d;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:g.deserialize(t.item)}:t.op===1?{op:t.op,item:_.deserialize(t.item)}:t,n.serialize=t=>t.op===0?{op:t.op,item:g.serialize(t.item)}:t.op===1?{op:t.op,item:_.serialize(t.item)}:t})(d||(e.TestsDiffOp=d={}));class r{add(t){}update(t){}remove(t,c){}complete(){}}e.IncrementalChangeCollector=r;class s{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const c=this.createChangeCollector();for(const l of t)switch(l.op){case 0:{const h=g.deserialize(l.item);if(h.parent){if(this.items.has(h.parent)){const p=this.items.get(h.parent);p.children.add(h.item.extId);const R=this.createItem(h,p);this.items.set(h.item.extId,R),c.add(R)}}else{const p=this.createItem(h);this.roots.add(p),this.items.set(h.item.extId,p),c.add(p)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=_.deserialize(l.item),p=this.items.get(h.extId);if(!p)break;h.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,h),c.update(p);break}case 2:{const h=this.items.get(l.itemId);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const p=[[l.itemId]];for(;p.length;)for(const R of p.pop()){const F=this.items.get(R);F&&(p.push(F.children),this.items.delete(R),c.remove(F,F!==h),F.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l.itemId);break;case 3:this.updatePendingRoots(l.amount);break;case 5:this._tags.set(l.tag.id,l.tag);break;case 6:this._tags.delete(l.id);break}c.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new r}}e.AbstractIncrementalTestCollection=s}),define(ke[90],Pe([1,0,17,3,6,12,68,67]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var b;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk"})(b||(e.TestItemEventOp=b={}));const T=(g,_)=>g===_,L={range:(g,_)=>g===_?!0:!g||!_?!1:g.equalsRange(_),busy:T,label:T,description:T,error:T,tags:(g,_)=>!(g.length!==_.length||g.some(f=>!_.includes(f)))},P=(g,_)=>{let f;for(const[a,m]of Object.entries(L))m(g[a],_[a])||(f?f[a]=_[a]:f={[a]:_[a]});return f};class S extends y.Disposable{get root(){return this.options.root}constructor(_){super();this.options=_,this.debounceSendDiff=this._register(new u.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new i.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(_){this._resolveHandler=_;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const _=this.diff;return this.diff=[],_}pushDiff(_){const f=this.diff[this.diff.length-1];if(f&&_.op===1){if(f.op===1&&f.item.extId===_.item.extId){(0,C.applyTestItemUpdate)(f.item,_.item);return}if(f.op===0&&f.item.item.extId===_.item.extId){(0,C.applyTestItemUpdate)(f.item,_.item);return}}this.diff.push(_),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(_,f){const a=this.tree.get(_);if(!!a){if((a.expandLevels===void 0||f>a.expandLevels)&&(a.expandLevels=f),a.expand===1){const m=this.resolveChildren(a);return m.isOpen()?this.expandChildren(a,f-1):m.wait().then(()=>this.expandChildren(a,f-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,f-1)):this.expandChildren(a,f-1)}}dispose(){for(const _ of this.tree.values())this.options.getApiFor(_.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(_,f){switch(f.op){case 3:this.removeItem(D.TestId.joinToString(_.fullId,f.id));break;case 0:this.upsertItem(f.item,_);break;case 5:for(const a of f.ops)this.onTestItemEvent(_,a);break;case 1:this.diffTagRefs(f.new,f.old,_.fullId.toString());break;case 2:this.updateExpandability(_);break;case 4:this.pushDiff({op:1,item:{extId:_.fullId.toString(),item:f.update}});break;default:(0,A.assertNever)(f)}}upsertItem(_,f){const a=D.TestId.fromExtHostTestItem(_,this.root.id,f?.actual),m=this.options.getApiFor(_);m.parent&&m.parent!==f?.actual&&this.options.getChildren(m.parent).delete(_.id);let o=this.tree.get(a.toString());if(!o){o={fullId:a,actual:_,parent:f?a.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},_.tags.forEach(this.incrementTagRefs,this),this.tree.set(o.fullId.toString(),o),this.setItemParent(_,f),this.pushDiff({op:0,item:{parent:o.parent&&o.parent.toString(),controllerId:this.options.controllerId,expand:o.expand,item:this.options.toITestItem(_)}}),this.connectItemAndChildren(_,o,f);return}if(o.actual===_){this.connectItem(_,o,f);return}const d=this.options.getChildren(o.actual),r=o.actual,s=P(this.options.toITestItem(r),this.options.toITestItem(_));this.options.getApiFor(r).listener=void 0,o.actual=_,o.expand=0,s&&(s.hasOwnProperty("tags")&&(this.diffTagRefs(_.tags,r.tags,a.toString()),delete s.tags),this.onTestItemEvent(o,{op:4,update:s})),this.connectItemAndChildren(_,o,f);for(const n of d)this.options.getChildren(_).get(n.id)||this.removeItem(D.TestId.joinToString(a,n.id))}diffTagRefs(_,f,a){const m=new Set(f.map(o=>o.id));for(const o of _)m.delete(o.id)||this.incrementTagRefs(o);this.pushDiff({op:1,item:{extId:a,item:{tags:_.map(o=>(0,C.namespaceTestTag)(this.options.controllerId,o.id))}}}),m.forEach(this.decrementTagRefs,this)}incrementTagRefs(_){const f=this.tags.get(_.id);f?f.refCount++:(this.tags.set(_.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,C.namespaceTestTag)(this.options.controllerId,_.id)}}))}decrementTagRefs(_){const f=this.tags.get(_);f&&!--f.refCount&&(this.tags.delete(_),this.pushDiff({op:6,id:(0,C.namespaceTestTag)(this.options.controllerId,_)}))}setItemParent(_,f){this.options.getApiFor(_).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(_,f,a){this.setItemParent(_,a);const m=this.options.getApiFor(_);m.parent=a?.actual,m.listener=o=>this.onTestItemEvent(f,o),this.updateExpandability(f)}connectItemAndChildren(_,f,a){this.connectItem(_,f,a);for(const m of this.options.getChildren(_))this.upsertItem(m,f)}updateExpandability(_){let f;this._resolveHandler?_.resolveBarrier?f=_.resolveBarrier.isOpen()?3:2:f=_.actual.canResolveChildren?1:0:f=0,f!==_.expand&&(_.expand=f,this.pushDiff({op:1,item:{extId:_.fullId.toString(),expand:f}}),f===1&&_.expandLevels!==void 0&&this.resolveChildren(_))}expandChildren(_,f){if(f<0)return;const a=[];for(const m of this.options.getChildren(_.actual)){const o=this.expand(D.TestId.joinToString(_.fullId,m.id),f);(0,u.isThenable)(o)&&a.push(o)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(_){if(_.resolveBarrier)return _.resolveBarrier;if(!this._resolveHandler){const o=new u.Barrier;return o.open(),o}_.expand=2,this.pushExpandStateUpdate(_);const f=_.resolveBarrier=new u.Barrier,a=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,o)};let m;try{m=this._resolveHandler(_.actual===this.root?void 0:_.actual)}catch(o){a(o)}return(0,u.isThenable)(m)?m.catch(a).then(()=>{f.open(),this.updateExpandability(_)}):(f.open(),this.updateExpandability(_)),_.resolveBarrier}pushExpandStateUpdate(_){this.pushDiff({op:1,item:{extId:_.fullId.toString(),expand:_.expand}})}removeItem(_){const f=this.tree.get(_);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:_});const a=[f];for(;a.length;){const m=a.pop();if(!!m){this.options.getApiFor(m.actual).listener=void 0;for(const o of m.actual.tags)this.decrementTagRefs(o.id);this.tree.delete(m.fullId.toString());for(const o of this.options.getChildren(m.actual))a.push(this.tree.get(D.TestId.joinToString(m.fullId,o.id)))}}}flushDiff(){const _=this.collectDiff();_.length&&this.diffOpEmitter.fire(_)}}e.TestItemCollection=S;class I extends Error{constructor(_){super(`Attempted to insert a duplicate test item ID ${_}`)}}e.DuplicateTestItemError=I;class E extends Error{constructor(_){super(`TestItem with ID "${_}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class v extends Error{constructor(_,f,a){super(`TestItem with ID "${_}" is from controller "${f}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=v;const w=(g,_,f)=>{let a=new Map;return{get size(){return a.size},forEach(m,o){for(const d of a.values())m.call(o,d,this)},replace(m){const o=new Map,d=new Set(a.keys()),r={op:5,ops:[]};for(const s of m){if(!(s instanceof f))throw new E(s.id);const n=_(s).controllerId;if(n!==g.controllerId)throw new v(s.id,n,g.controllerId);if(o.has(s.id))throw new I(s.id);o.set(s.id,s),d.delete(s.id),r.ops.push({op:0,item:s})}for(const s of d.keys())r.ops.push({op:3,id:s});g.listener?.(r),a=o},add(m){if(!(m instanceof f))throw new E(m.id);a.set(m.id,m),g.listener?.({op:0,item:m})},delete(m){a.delete(m)&&g.listener?.({op:3,id:m})},get(m){return a.get(m)},toJSON(){return Array.from(a.values())},[Symbol.iterator](){return a.values()}}};e.createTestItemChildren=w}),define(ke[129],Pe([1,0,90]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const i=new WeakMap,y=(C,D)=>{const b={controllerId:D};return i.set(C,b),b};e.createPrivateApiFor=y;const A=C=>{const D=i.get(C);if(!D)throw new u.InvalidTestItemError(C?.id||"<unknown>");return D};e.getPrivateApiFor=A}),define(ke[219],Pe([1,0,9,40,12,24,13,103,185,8]),function(Q,e,u,i,y,A,C,D,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class L{constructor(S,I,E,v){this._contributedVariables=new Map,this._context=S,this._labelService=I,this._userHomePromise=E,v&&(this._envVariablesPromise=v.then(w=>this.prepareEnv(w)))}prepareEnv(S){if(C.isWindows){const I=Object.create(null);return Object.keys(S).forEach(E=>{I[E.toLowerCase()]=S[E]}),I}return S}resolveWithEnvironment(S,I,E){return this.recursiveResolve({env:this.prepareEnv(S),userHome:void 0},I?I.uri:void 0,E)}async resolveAsync(S,I){const E={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(E,S?S.uri:void 0,I)}async resolveAnyBase(S,I,E,v){const w=A.deepClone(I);C.isWindows&&w.windows?Object.keys(w.windows).forEach(_=>w[_]=w.windows[_]):C.isMacintosh&&w.osx?Object.keys(w.osx).forEach(_=>w[_]=w.osx[_]):C.isLinux&&w.linux&&Object.keys(w.linux).forEach(_=>w[_]=w.linux[_]),delete w.windows,delete w.osx,delete w.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,S?S.uri:void 0,w,E,v)}async resolveAnyAsync(S,I,E){return this.resolveAnyBase(S,I,E)}async resolveAnyMap(S,I,E){const v=new Map;return{newConfig:await this.resolveAnyBase(S,I,E,v),resolvedVariables:v}}resolveWithInteractionReplace(S,I,E,v){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,I,E,v){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,I){if(this._contributedVariables.has(S))throw new Error("Variable "+S+" is contributed twice.");this._contributedVariables.set(S,I)}async recursiveResolve(S,I,E,v,w){if(y.isString(E))return this.resolveString(S,I,E,v,w);if(y.isArray(E))return Promise.all(E.map(g=>this.recursiveResolve(S,I,g,v,w)));if(y.isObject(E)){let g=Object.create(null);const _=await Promise.all(Object.keys(E).map(async f=>[await this.resolveString(S,I,f,v,w),await this.recursiveResolve(S,I,E[f],v,w)]));for(const[f,a]of _)g[f]=a;return g}return E}resolveString(S,I,E,v,w){return(0,T.replaceAsync)(E,L.VARIABLE_REGEXP,async(g,_)=>{if(_.includes(L.VARIABLE_LHS))return g;let f=await this.evaluateSingleVariable(S,g,_,I,v);return w&&w.set(_,f),f!==g&&y.isString(f)&&f.match(L.VARIABLE_REGEXP)&&(f=await this.resolveString(S,I,f,v,w)),f})}fsPath(S){return this._labelService?this._labelService.getUriLabel(S,{noPrefix:!0}):S.fsPath}async evaluateSingleVariable(S,I,E,v,w){let g;const _=E.split(":");_.length>1&&(E=_[0],g=_[1]);const f=()=>{const o=this._context.getFilePath();if(o)return o;throw new Error((0,b.localize)(0,null,I))},a=()=>{const o=f();if(this._context.getWorkspaceFolderPathForFile){const d=this._context.getWorkspaceFolderPathForFile();if(d)return d}throw new Error((0,b.localize)(1,null,I,u.basename(o)))},m=()=>{if(g){const o=this._context.getFolderUri(g);if(o)return o;throw new Error((0,b.localize)(2,null,I,g))}if(v)return v;throw this._context.getWorkspaceFolderCount()>1?new Error((0,b.localize)(3,null,I)):new Error((0,b.localize)(4,null,I))};switch(E){case"env":if(g){if(S.env){const o=S.env[C.isWindows?g.toLowerCase():g];if(y.isString(o))return o}return""}throw new Error((0,b.localize)(5,null,I));case"config":if(g){const o=this._context.getConfigurationValue(v,g);if(y.isUndefinedOrNull(o))throw new Error((0,b.localize)(6,null,I,g));if(y.isObject(o))throw new Error((0,b.localize)(7,null,I,g));return o}throw new Error((0,b.localize)(8,null,I));case"command":return this.resolveFromMap(I,g,w,"command");case"input":return this.resolveFromMap(I,g,w,"input");case"extensionInstallFolder":if(g){const o=await this._context.getExtension(g);if(!o)throw new Error((0,b.localize)(9,null,I,g));return this.fsPath(o.extensionLocation)}throw new Error((0,b.localize)(10,null,I));default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(m()));case"cwd":return v||g?(0,D.normalizeDriveLetter)(this.fsPath(m())):i.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return u.basename(this.fsPath(m()));case"userHome":{if(S.userHome)return S.userHome;throw new Error((0,b.localize)(11,null,I))}case"lineNumber":{const o=this._context.getLineNumber();if(o)return o;throw new Error((0,b.localize)(12,null,I))}case"selectedText":{const o=this._context.getSelectedText();if(o)return o;throw new Error((0,b.localize)(13,null,I))}case"file":return f();case"fileWorkspaceFolder":return a();case"relativeFile":return v||g?u.relative(this.fsPath(m()),f()):f();case"relativeFileDirname":{const o=u.dirname(f());if(v||g){const d=u.relative(this.fsPath(m()),o);return d.length===0?".":d}return o}case"fileDirname":return u.dirname(f());case"fileExtname":return u.extname(f());case"fileBasename":return u.basename(f());case"fileBasenameNoExtension":{const o=u.basename(f());return o.slice(0,o.length-u.extname(o).length)}case"fileDirnameBasename":return u.basename(u.dirname(f()));case"execPath":{const o=this._context.getExecPath();return o||I}case"execInstallFolder":{const o=this._context.getAppRoot();return o||I}case"pathSeparator":return u.sep;default:try{const o=g?`${E}:${g}`:E;return this.resolveFromMap(I,o,w,void 0)}catch{return I}}}}resolveFromMap(S,I,E,v){if(I&&E){const w=v===void 0?E[I]:E[v+":"+I];if(typeof w=="string")return w;throw new Error((0,b.localize)(14,null,S))}return S}}e.AbstractVariableResolverService=L,L.VARIABLE_LHS="${",L.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ke[130],Pe([1,0,4,211]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,u.createDecorator)("editorGroupsService");var y;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(y||(e.GroupDirection=y={}));var A;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var C;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(C||(e.GroupLocation=C={}));var D;(function(E){E[E.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",E[E.EVEN=1]="EVEN",E[E.TOGGLE=2]="TOGGLE"})(D||(e.GroupsArrangement=D={}));var b;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function T(E){const v=E;return(0,i.isEditorInput)(v?.editor)&&(0,i.isEditorInput)(v?.replacement)}e.isEditorReplacement=T;var L;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var P;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function S(E){const v=E;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.isEditorGroup=S;function I(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(ke[220],Pe([1,0,4,130]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,u.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(A){const C=A;return typeof A=="number"||(0,i.isEditorGroup)(C)}e.isPreferredGroup=y}),define(ke[15],Pe([1,0,16,23,102,25,144,62,24,12,2,36,65,188,116,129,128,67,68,220,7,59]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_,f,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.SnippetTextEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(Re){function Fe(Z){const{selectionStartLineNumber:Oe,selectionStartColumn:We,positionLineNumber:it,positionColumn:Qe}=Z,ut=new a.Position(Oe-1,We-1),ht=new a.Position(it-1,Qe-1);return new a.Selection(ut,ht)}Re.to=Fe;function _e(Z){const{anchor:Oe,active:We}=Z;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Re.from=_e})(o||(e.Selection=o={}));var d;(function(Re){function Fe(Z){if(!Z)return;const{start:Oe,end:We}=Z;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Re.from=Fe;function _e(Z){if(!Z)return;const{startLineNumber:Oe,startColumn:We,endLineNumber:it,endColumn:Qe}=Z;return new a.Range(Oe-1,We-1,it-1,Qe-1)}Re.to=_e})(d||(e.Range=d={}));var r;(function(Re){function Fe(_e){switch(_e){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Re.to=Fe})(r||(e.TokenType=r={}));var s;(function(Re){function Fe(Z){return new a.Position(Z.lineNumber-1,Z.column-1)}Re.to=Fe;function _e(Z){return{lineNumber:Z.line+1,column:Z.character+1}}Re.from=_e})(s||(e.Position=s={}));var n;(function(Re){function Fe(Oe,We){return(0,u.coalesce)((0,u.asArray)(Oe).map(it=>_e(it,We)))}Re.from=Fe;function _e(Oe,We){if(typeof Oe=="string")return{$serialized:!0,language:Oe};if(Oe)return{$serialized:!0,language:Oe.language,scheme:Z(Oe.scheme,We),pattern:Ne.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType}}function Z(Oe,We){return We&&typeof Oe=="string"?We.transformOutgoingScheme(Oe):Oe}})(n||(e.DocumentSelector=n={}));var t;(function(Re){function Fe(Z){switch(Z){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Re.from=Fe;function _e(Z){switch(Z){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Re.to=_e})(t||(e.DiagnosticTag=t={}));var c;(function(Re){function Fe(Z){let Oe;return Z.code&&((0,T.isString)(Z.code)||(0,T.isNumber)(Z.code)?Oe=String(Z.code):Oe={value:String(Z.code.value),target:Z.code.target}),{...d.from(Z.range),message:Z.message,source:Z.source,code:Oe,severity:h.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(l.from),tags:Array.isArray(Z.tags)?(0,u.coalesce)(Z.tags.map(t.from)):void 0}}Re.from=Fe;function _e(Z){const Oe=new a.Diagnostic(d.to(Z),Z.message,h.to(Z.severity));return Oe.source=Z.source,Oe.code=(0,T.isString)(Z.code)?Z.code:Z.code?.value,Oe.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(l.to),Oe.tags=Z.tags&&(0,u.coalesce)(Z.tags.map(t.to)),Oe}Re.to=_e})(c||(e.Diagnostic=c={}));var l;(function(Re){function Fe(Z){return{...d.from(Z.location.range),message:Z.message,resource:Z.location.uri}}Re.from=Fe;function _e(Z){return new a.DiagnosticRelatedInformation(new a.Location(Z.resource,d.to(Z)),Z.message)}Re.to=_e})(l||(e.DiagnosticRelatedInformation=l={}));var h;(function(Re){function Fe(Z){switch(Z){case a.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}Re.from=Fe;function _e(Z){switch(Z){case E.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Re.to=_e})(h||(e.DiagnosticSeverity=h={}));var p;(function(Re){function Fe(Z){return typeof Z=="number"&&Z>=a.ViewColumn.One?Z-1:Z===a.ViewColumn.Beside?f.SIDE_GROUP:f.ACTIVE_GROUP}Re.from=Fe;function _e(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=_e})(p||(e.ViewColumn=p={}));function R(Re){return typeof Re.range!="undefined"}function F(Re){return Re.length===0?!0:!!R(Re[0])}e.isDecorationOptionsArr=F;var O;(function(Re){function Fe(Qe){return Qe.map(Re.from)}Re.fromMany=Fe;function _e(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function Z(Qe){let ut;if(_e(Qe)){const{language:Pt,value:Ft}=Qe;ut={value:"```"+Pt+`
`+Ft+"\n```\n"}}else a.MarkdownString.isMarkdownString(Qe)?ut={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ut={value:Qe}:ut={value:""};const ht=Object.create(null);ut.uris=ht;const wt=Pt=>{try{let Ft=L.URI.parse(Pt,!0);Ft=Ft.with({query:Oe(Ft.query,ht)}),ht[Pt]=Ft}catch{}return""},mt=new C.marked.Renderer;return mt.link=wt,mt.image=Pt=>typeof Pt=="string"?wt(y.parseHrefAndDimensions(Pt).href):"",(0,C.marked)(ut.value,{renderer:mt}),ut}Re.from=Z;function Oe(Qe,ut){if(!Qe)return Qe;let ht;try{ht=(0,D.parse)(Qe)}catch{}if(!ht)return Qe;let wt=!1;return ht=(0,b.cloneAndChange)(ht,mt=>{if(L.URI.isUri(mt)){const Pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Pt]=mt,wt=!0,Pt}else return}),wt?JSON.stringify(ht):Qe}function We(Qe){const ut=new a.MarkdownString(Qe.value,Qe.supportThemeIcons);return ut.isTrusted=Qe.isTrusted,ut.supportHtml=Qe.supportHtml,ut.baseUri=Qe.baseUri?L.URI.from(Qe.baseUri):void 0,ut}Re.to=We;function it(Qe){if(!!Qe)return typeof Qe=="string"?Qe:Re.from(Qe)}Re.fromStrict=it})(O||(e.MarkdownString=O={}));function k(Re){return F(Re)?Re.map(Fe=>({range:d.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?O.fromMany(Fe.hoverMessage):Fe.hoverMessage?O.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Re.map(Fe=>({range:d.from(Fe)}))}e.fromRangeOrRangeWithMessage=k;function U(Re){return typeof Re=="undefined"?Re:typeof Re=="string"?L.URI.file(Re):Re}e.pathOrURIToURI=U;var B;(function(Re){function Fe(_e){return typeof _e=="undefined"?_e:{contentText:_e.contentText,contentIconPath:_e.contentIconPath?U(_e.contentIconPath):void 0,border:_e.border,borderColor:_e.borderColor,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,color:_e.color,backgroundColor:_e.backgroundColor,margin:_e.margin,width:_e.width,height:_e.height}}Re.from=Fe})(B||(e.ThemableDecorationAttachmentRenderOptions=B={}));var z;(function(Re){function Fe(_e){return typeof _e=="undefined"?_e:{backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?U(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?B.from(_e.before):void 0,after:_e.after?B.from(_e.after):void 0}}Re.from=Fe})(z||(e.ThemableDecorationRenderOptions=z={}));var Y;(function(Re){function Fe(_e){if(typeof _e=="undefined")return _e;switch(_e){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Fe})(Y||(e.DecorationRangeBehavior=Y={}));var $;(function(Re){function Fe(_e){return{isWholeLine:_e.isWholeLine,rangeBehavior:_e.rangeBehavior?Y.from(_e.rangeBehavior):void 0,overviewRulerLane:_e.overviewRulerLane,light:_e.light?z.from(_e.light):void 0,dark:_e.dark?z.from(_e.dark):void 0,backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?U(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?B.from(_e.before):void 0,after:_e.after?B.from(_e.after):void 0}}Re.from=Fe})($||(e.DecorationRenderOptions=$={}));var N;(function(Re){function Fe(Z){return{text:Z.newText,eol:Z.newEol&&J.from(Z.newEol),range:d.from(Z.range)}}Re.from=Fe;function _e(Z){const Oe=new a.TextEdit(d.to(Z.range),Z.text);return Oe.newEol=typeof Z.eol=="undefined"?void 0:J.to(Z.eol),Oe}Re.to=_e})(N||(e.TextEdit=N={}));var V;(function(Re){function Fe(_e){return{range:d.from(_e.range),snippet:_e.snippet.value}}Re.from=Fe})(V||(e.SnippetTextEdit=V={}));var H;(function(Re){function Fe(Z,Oe){const We={edits:[]};if(Z instanceof a.WorkspaceEdit){const it=new A.ResourceSet;for(const Qe of Z._allEntries())Qe._type===1&&L.URI.isUri(Qe.to)&&Qe.from===void 0&&it.add(Qe.to);for(const Qe of Z._allEntries())Qe._type===1?We.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata}):Qe._type===2?We.edits.push({_type:2,resource:Qe.uri,edit:N.from(Qe.edit),modelVersionId:it.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?We.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&We.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri),edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(et.from)}})}return We}Re.from=Fe;function _e(Z){const Oe=new a.WorkspaceEdit;for(const We of Z.edits)We.edit?Oe.replace(L.URI.revive(We.resource),d.to(We.edit.range),We.edit.text):Oe.renameFile(L.URI.revive(We.oldUri),L.URI.revive(We.newUri),We.options);return Oe}Re.to=_e})(H||(e.WorkspaceEdit=H={}));var q;(function(Re){const Fe=Object.create(null);Fe[a.SymbolKind.File]=0,Fe[a.SymbolKind.Module]=1,Fe[a.SymbolKind.Namespace]=2,Fe[a.SymbolKind.Package]=3,Fe[a.SymbolKind.Class]=4,Fe[a.SymbolKind.Method]=5,Fe[a.SymbolKind.Property]=6,Fe[a.SymbolKind.Field]=7,Fe[a.SymbolKind.Constructor]=8,Fe[a.SymbolKind.Enum]=9,Fe[a.SymbolKind.Interface]=10,Fe[a.SymbolKind.Function]=11,Fe[a.SymbolKind.Variable]=12,Fe[a.SymbolKind.Constant]=13,Fe[a.SymbolKind.String]=14,Fe[a.SymbolKind.Number]=15,Fe[a.SymbolKind.Boolean]=16,Fe[a.SymbolKind.Array]=17,Fe[a.SymbolKind.Object]=18,Fe[a.SymbolKind.Key]=19,Fe[a.SymbolKind.Null]=20,Fe[a.SymbolKind.EnumMember]=21,Fe[a.SymbolKind.Struct]=22,Fe[a.SymbolKind.Event]=23,Fe[a.SymbolKind.Operator]=24,Fe[a.SymbolKind.TypeParameter]=25;function _e(Oe){return typeof Fe[Oe]=="number"?Fe[Oe]:6}Re.from=_e;function Z(Oe){for(const We in Fe)if(Fe[We]===Oe)return Number(We);return a.SymbolKind.Property}Re.to=Z})(q||(e.SymbolKind=q={}));var te;(function(Re){function Fe(Z){switch(Z){case a.SymbolTag.Deprecated:return 1}}Re.from=Fe;function _e(Z){switch(Z){case 1:return a.SymbolTag.Deprecated}}Re.to=_e})(te||(e.SymbolTag=te={}));var fe;(function(Re){function Fe(Z){return{name:Z.name,kind:q.from(Z.kind),tags:Z.tags&&Z.tags.map(te.from),containerName:Z.containerName,location:ve.from(Z.location)}}Re.from=Fe;function _e(Z){const Oe=new a.SymbolInformation(Z.name,q.to(Z.kind),Z.containerName,ve.to(Z.location));return Oe.tags=Z.tags&&Z.tags.map(te.to),Oe}Re.to=_e})(fe||(e.WorkspaceSymbol=fe={}));var ne;(function(Re){function Fe(Z){const Oe={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:d.from(Z.range),selectionRange:d.from(Z.selectionRange),kind:q.from(Z.kind),tags:Z.tags?.map(te.from)??[]};return Z.children&&(Oe.children=Z.children.map(Fe)),Oe}Re.from=Fe;function _e(Z){const Oe=new a.DocumentSymbol(Z.name,Z.detail,q.to(Z.kind),d.to(Z.range),d.to(Z.selectionRange));return(0,u.isNonEmptyArray)(Z.tags)&&(Oe.tags=Z.tags.map(te.to)),Z.children&&(Oe.children=Z.children.map(_e)),Oe}Re.to=_e})(ne||(e.DocumentSymbol=ne={}));var le;(function(Re){function Fe(Z){const Oe=new a.CallHierarchyItem(q.to(Z.kind),Z.name,Z.detail||"",L.URI.revive(Z.uri),d.to(Z.range),d.to(Z.selectionRange));return Oe._sessionId=Z._sessionId,Oe._itemId=Z._itemId,Oe}Re.to=Fe;function _e(Z,Oe,We){if(Oe=Oe??Z._sessionId,We=We??Z._itemId,Oe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:We,name:Z.name,detail:Z.detail,kind:q.from(Z.kind),uri:Z.uri,range:d.from(Z.range),selectionRange:d.from(Z.selectionRange),tags:Z.tags?.map(te.from)}}Re.from=_e})(le||(e.CallHierarchyItem=le={}));var K;(function(Re){function Fe(_e){return new a.CallHierarchyIncomingCall(le.to(_e.from),_e.fromRanges.map(Z=>d.to(Z)))}Re.to=Fe})(K||(e.CallHierarchyIncomingCall=K={}));var ge;(function(Re){function Fe(_e){return new a.CallHierarchyOutgoingCall(le.to(_e.to),_e.fromRanges.map(Z=>d.to(Z)))}Re.to=Fe})(ge||(e.CallHierarchyOutgoingCall=ge={}));var ve;(function(Re){function Fe(Z){return{range:Z.range&&d.from(Z.range),uri:Z.uri}}Re.from=Fe;function _e(Z){return new a.Location(L.URI.revive(Z.uri),d.to(Z.range))}Re.to=_e})(ve||(e.location=ve={}));var se;(function(Re){function Fe(Z){const Oe=Z,We=Z;return{originSelectionRange:Oe.originSelectionRange?d.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:We.uri,range:d.from(Oe.targetRange?Oe.targetRange:We.range),targetSelectionRange:Oe.targetSelectionRange?d.from(Oe.targetSelectionRange):void 0}}Re.from=Fe;function _e(Z){return{targetUri:L.URI.revive(Z.uri),targetRange:d.to(Z.range),targetSelectionRange:Z.targetSelectionRange?d.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?d.to(Z.originSelectionRange):void 0}}Re.to=_e})(se||(e.DefinitionLink=se={}));var be;(function(Re){function Fe(Z){return{range:d.from(Z.range),contents:O.fromMany(Z.contents)}}Re.from=Fe;function _e(Z){return new a.Hover(Z.contents.map(O.to),d.to(Z.range))}Re.to=_e})(be||(e.Hover=be={}));var Te;(function(Re){function Fe(Z){return{range:d.from(Z.range),expression:Z.expression}}Re.from=Fe;function _e(Z){return new a.EvaluatableExpression(d.to(Z.range),Z.expression)}Re.to=_e})(Te||(e.EvaluatableExpression=Te={}));var pe;(function(Re){function Fe(Z){if(Z instanceof a.InlineValueText)return{type:"text",range:d.from(Z.range),text:Z.text};if(Z instanceof a.InlineValueVariableLookup)return{type:"variable",range:d.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Fe;function _e(Z){switch(Z.type){case"text":return{range:d.to(Z.range),text:Z.text};case"variable":return{range:d.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:d.to(Z.range),expression:Z.expression}}}Re.to=_e})(pe||(e.InlineValue=pe={}));var we;(function(Re){function Fe(Z){return{frameId:Z.frameId,stoppedLocation:d.from(Z.stoppedLocation)}}Re.from=Fe;function _e(Z){return new a.InlineValueContext(Z.frameId,d.to(Z.stoppedLocation))}Re.to=_e})(we||(e.InlineValueContext=we={}));var Ae;(function(Re){function Fe(Z){return{range:d.from(Z.range),kind:Z.kind}}Re.from=Fe;function _e(Z){return new a.DocumentHighlight(d.to(Z.range),Z.kind)}Re.to=_e})(Ae||(e.DocumentHighlight=Ae={}));var ce;(function(Re){function Fe(_e){switch(_e){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Re.to=Fe})(ce||(e.CompletionTriggerKind=ce={}));var me;(function(Re){function Fe(_e){return{triggerKind:ce.to(_e.triggerKind),triggerCharacter:_e.triggerCharacter}}Re.to=Fe})(me||(e.CompletionContext=me={}));var ie;(function(Re){function Fe(Z){switch(Z){case a.CompletionItemTag.Deprecated:return 1}}Re.from=Fe;function _e(Z){switch(Z){case 1:return a.CompletionItemTag.Deprecated}}Re.to=_e})(ie||(e.CompletionItemTag=ie={}));var ee;(function(Re){const Fe=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function _e(We){return Fe.get(We)??9}Re.from=_e;const Z=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Oe(We){return Z.get(We)??a.CompletionItemKind.Property}Re.to=Oe})(ee||(e.CompletionItemKind=ee={}));var M;(function(Re){function Fe(_e,Z){const Oe=new a.CompletionItem(_e.label);return Oe.insertText=_e.insertText,Oe.kind=ee.to(_e.kind),Oe.tags=_e.tags?.map(ie.to),Oe.detail=_e.detail,Oe.documentation=y.isMarkdownString(_e.documentation)?O.to(_e.documentation):_e.documentation,Oe.sortText=_e.sortText,Oe.filterText=_e.filterText,Oe.preselect=_e.preselect,Oe.commitCharacters=_e.commitCharacters,P.Range.isIRange(_e.range)?Oe.range=d.to(_e.range):typeof _e.range=="object"&&(Oe.range={inserting:d.to(_e.range.insert),replacing:d.to(_e.range.replace)}),Oe.keepWhitespace=typeof _e.insertTextRules=="undefined"?!1:Boolean(_e.insertTextRules&1),typeof _e.insertTextRules!="undefined"&&_e.insertTextRules&4?Oe.insertText=new a.SnippetString(_e.insertText):(Oe.insertText=_e.insertText,Oe.textEdit=Oe.range instanceof a.Range?new a.TextEdit(Oe.range,Oe.insertText):void 0),_e.additionalTextEdits&&_e.additionalTextEdits.length>0&&(Oe.additionalTextEdits=_e.additionalTextEdits.map(We=>N.to(We))),Oe.command=Z&&_e.command?Z.fromInternal(_e.command):void 0,Oe}Re.to=Fe})(M||(e.CompletionItem=M={}));var x;(function(Re){function Fe(Z){return{label:Z.label,documentation:O.fromStrict(Z.documentation)}}Re.from=Fe;function _e(Z){return{label:Z.label,documentation:y.isMarkdownString(Z.documentation)?O.to(Z.documentation):Z.documentation}}Re.to=_e})(x||(e.ParameterInformation=x={}));var G;(function(Re){function Fe(Z){return{label:Z.label,documentation:O.fromStrict(Z.documentation),parameters:Array.isArray(Z.parameters)?Z.parameters.map(x.from):[],activeParameter:Z.activeParameter}}Re.from=Fe;function _e(Z){return{label:Z.label,documentation:y.isMarkdownString(Z.documentation)?O.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(x.to):[],activeParameter:Z.activeParameter}}Re.to=_e})(G||(e.SignatureInformation=G={}));var X;(function(Re){function Fe(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(G.from):[]}}Re.from=Fe;function _e(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(G.to):[]}}Re.to=_e})(X||(e.SignatureHelp=X={}));var de;(function(Re){function Fe(_e,Z){const Oe=new a.InlayHint(s.to(Z.position),typeof Z.label=="string"?Z.label:Z.label.map(Ee.to.bind(void 0,_e)),Z.kind&&oe.to(Z.kind));return Oe.textEdits=Z.textEdits&&Z.textEdits.map(N.to),Oe.tooltip=y.isMarkdownString(Z.tooltip)?O.to(Z.tooltip):Z.tooltip,Oe.paddingLeft=Z.paddingLeft,Oe.paddingRight=Z.paddingRight,Oe}Re.to=Fe})(de||(e.InlayHint=de={}));var Ee;(function(Re){function Fe(_e,Z){const Oe=new a.InlayHintLabelPart(Z.label);return Oe.tooltip=y.isMarkdownString(Z.tooltip)?O.to(Z.tooltip):Z.tooltip,S.Command.is(Z.command)&&(Oe.command=_e.fromInternal(Z.command)),Z.location&&(Oe.location=ve.to(Z.location)),Oe}Re.to=Fe})(Ee||(e.InlayHintLabelPart=Ee={}));var oe;(function(Re){function Fe(Z){return Z}Re.from=Fe;function _e(Z){return Z}Re.to=_e})(oe||(e.InlayHintKind=oe={}));var De;(function(Re){function Fe(Z){return{range:d.from(Z.range),url:Z.target,tooltip:Z.tooltip}}Re.from=Fe;function _e(Z){let Oe;if(Z.url)try{Oe=typeof Z.url=="string"?L.URI.parse(Z.url,!0):L.URI.revive(Z.url)}catch{}return new a.DocumentLink(d.to(Z.range),Oe)}Re.to=_e})(De||(e.DocumentLink=De={}));var ye;(function(Re){function Fe(Z){const Oe=new a.ColorPresentation(Z.label);return Z.textEdit&&(Oe.textEdit=N.to(Z.textEdit)),Z.additionalTextEdits&&(Oe.additionalTextEdits=Z.additionalTextEdits.map(We=>N.to(We))),Oe}Re.to=Fe;function _e(Z){return{label:Z.label,textEdit:Z.textEdit?N.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Oe=>N.from(Oe)):void 0}}Re.from=_e})(ye||(e.ColorPresentation=ye={}));var ze;(function(Re){function Fe(Z){return new a.Color(Z[0],Z[1],Z[2],Z[3])}Re.to=Fe;function _e(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}Re.from=_e})(ze||(e.Color=ze={}));var Ve;(function(Re){function Fe(Z){return{range:d.from(Z.range)}}Re.from=Fe;function _e(Z){return new a.SelectionRange(d.to(Z.range))}Re.to=_e})(Ve||(e.SelectionRange=Ve={}));var Me;(function(Re){function Fe(_e){switch(_e){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Re.to=Fe})(Me||(e.TextDocumentSaveReason=Me={}));var Je;(function(Re){function Fe(Z){switch(Z){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Fe;function _e(Z){switch(Z){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Re.to=_e})(Je||(e.TextEditorLineNumbersStyle=Je={}));var J;(function(Re){function Fe(Z){if(Z===a.EndOfLine.CRLF)return 1;if(Z===a.EndOfLine.LF)return 0}Re.from=Fe;function _e(Z){if(Z===1)return a.EndOfLine.CRLF;if(Z===0)return a.EndOfLine.LF}Re.to=_e})(J||(e.EndOfLine=J={}));var re;(function(Re){function Fe(_e){if(typeof _e=="object")return _e.viewId;switch(_e){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Fe})(re||(e.ProgressLocation=re={}));var Ce;(function(Re){function Fe(_e){const Z={start:_e.start+1,end:_e.end+1};return _e.kind&&(Z.kind=ae.from(_e.kind)),Z}Re.from=Fe})(Ce||(e.FoldingRange=Ce={}));var ae;(function(Re){function Fe(_e){if(_e)switch(_e){case a.FoldingRangeKind.Comment:return S.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return S.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return S.FoldingRangeKind.Region}}Re.from=Fe})(ae||(e.FoldingRangeKind=ae={}));var Ie;(function(Re){function Fe(_e){if(_e)return{pinned:typeof _e.preview=="boolean"?!_e.preview:void 0,inactive:_e.background,preserveFocus:_e.preserveFocus,selection:typeof _e.selection=="object"?d.from(_e.selection):void 0,override:typeof _e.override=="boolean"?I.EditorResolution.DISABLED:void 0}}Re.from=Fe})(Ie||(e.TextEditorOpenOptions=Ie={}));var Ne;(function(Re){function Fe(We){return We instanceof a.RelativePattern?We.toJSON():typeof We=="string"?We:_e(We)||Z(We)?new a.RelativePattern(We.baseUri??We.base,We.pattern).toJSON():We}Re.from=Fe;function _e(We){const it=We;return it?L.URI.isUri(it.baseUri)&&typeof it.pattern=="string":!1}function Z(We){const it=We;return it?typeof it.base=="string"&&typeof it.pattern=="string":!1}function Oe(We){return typeof We=="string"?We:new a.RelativePattern(L.URI.revive(We.baseUri),We.pattern)}Re.to=Oe})(Ne||(e.GlobPattern=Ne={}));var $e;(function(Re){function Fe(_e){if(_e){if(Array.isArray(_e))return _e.map(Fe);if(typeof _e=="string")return _e;{const Z=_e;return{language:Z.language,scheme:Z.scheme,pattern:Ne.from(Z.pattern),exclusive:Z.exclusive,notebookType:Z.notebookType}}}else return}Re.from=Fe})($e||(e.LanguageSelector=$e={}));var Ge;(function(Re){function Fe(Z){return{start:Z.start,end:Z.end}}Re.from=Fe;function _e(Z){return new a.NotebookRange(Z.start,Z.end)}Re.to=_e})(Ge||(e.NotebookRange=Ge={}));var qe;(function(Re){function Fe(Z){return{timing:typeof Z.runStartTime=="number"&&typeof Z.runEndTime=="number"?{startTime:Z.runStartTime,endTime:Z.runEndTime}:void 0,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}Re.to=Fe;function _e(Z){return{lastRunSuccess:Z.success,runStartTime:Z.timing?.startTime,runEndTime:Z.timing?.endTime,executionOrder:Z.executionOrder}}Re.from=_e})(qe||(e.NotebookCellExecutionSummary=qe={}));var Ze;(function(Re){function Fe(_e){if(_e===w.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;if(_e===w.NotebookCellExecutionState.Pending)return a.NotebookCellExecutionState.Pending;if(_e===w.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${_e}`)}Re.to=Fe})(Ze||(e.NotebookCellExecutionState=Ze={}));var Xe;(function(Re){function Fe(Z){switch(Z){case a.NotebookCellKind.Markup:return w.CellKind.Markup;case a.NotebookCellKind.Code:default:return w.CellKind.Code}}Re.from=Fe;function _e(Z){switch(Z){case w.CellKind.Markup:return a.NotebookCellKind.Markup;case w.CellKind.Code:default:return a.NotebookCellKind.Code}}Re.to=_e})(Xe||(e.NotebookCellKind=Xe={}));var st;(function(Re){function Fe(Z){const Oe={metadata:Z.metadata??Object.create(null),cells:[]};for(let We of Z.cells)a.NotebookCellData.validate(We),Oe.cells.push(et.from(We));return Oe}Re.from=Fe;function _e(Z){const Oe=new a.NotebookData(Z.cells.map(et.to));return(0,T.isEmptyObject)(Z.metadata)||(Oe.metadata=Z.metadata),Oe}Re.to=_e})(st||(e.NotebookData=st={}));var et;(function(Re){function Fe(Z){return{cellKind:Xe.from(Z.kind),language:Z.languageId,mime:Z.mime,source:Z.value,metadata:Z.metadata,internalMetadata:qe.from(Z.executionSummary??{}),outputs:Z.outputs?Z.outputs.map(ot.from):[]}}Re.from=Fe;function _e(Z){return new a.NotebookCellData(Xe.to(Z.cellKind),Z.source,Z.language,Z.mime,Z.outputs?Z.outputs.map(ot.to):void 0,Z.metadata,Z.internalMetadata?qe.to(Z.internalMetadata):void 0)}Re.to=_e})(et||(e.NotebookCellData=et={}));var rt;(function(Re){function Fe(Z){return{mime:Z.mime,valueBytes:i.VSBuffer.wrap(Z.data)}}Re.from=Fe;function _e(Z){return new a.NotebookCellOutputItem(Z.valueBytes.buffer,Z.mime)}Re.to=_e})(rt||(e.NotebookCellOutputItem=rt={}));var ot;(function(Re){function Fe(Z){return{outputId:Z.id,items:Z.items.map(rt.from),metadata:Z.metadata}}Re.from=Fe;function _e(Z){const Oe=Z.items.map(rt.to);return new a.NotebookCellOutput(Oe,Z.outputId,Z.metadata)}Re.to=_e})(ot||(e.NotebookCellOutput=ot={}));var Et;(function(Re){function Fe(Oe){return Z(Oe)?{include:(0,T.withNullAsUndefined)(Ne.from(Oe.include)),exclude:(0,T.withNullAsUndefined)(Ne.from(Oe.exclude))}:(0,T.withNullAsUndefined)(Ne.from(Oe))}Re.from=Fe;function _e(Oe){return Z(Oe)?{include:Ne.to(Oe.include),exclude:Ne.to(Oe.exclude)}:Ne.to(Oe)}Re.to=_e;function Z(Oe){const We=Oe;return We?!(0,T.isUndefinedOrNull)(We.include)&&!(0,T.isUndefinedOrNull)(We.exclude):!1}})(Et||(e.NotebookExclusiveDocumentPattern=Et={}));var At;(function(Re){function Fe(_e){return{backgroundColor:_e.backgroundColor,borderColor:_e.borderColor,top:_e.top?B.from(_e.top):void 0}}Re.from=Fe})(At||(e.NotebookDecorationRenderOptions=At={}));var It;(function(Re){function Fe(_e,Z,Oe){const We=typeof _e.command=="string"?{title:"",command:_e.command}:_e.command;return{alignment:_e.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(We,Oe),text:_e.text,tooltip:_e.tooltip,accessibilityInformation:_e.accessibilityInformation,priority:_e.priority}}Re.from=Fe})(It||(e.NotebookStatusBarItem=It={}));var ft;(function(Re){function Fe(_e){return{transientOutputs:_e?.transientOutputs??!1,transientCellMetadata:_e?.transientCellMetadata??{},transientDocumentMetadata:_e?.transientDocumentMetadata??{}}}Re.from=Fe})(ft||(e.NotebookDocumentContentOptions=ft={}));var Rt;(function(Re){function Fe(Z){return{uri:Z.uri,provides:Z.provides}}Re.from=Fe;function _e(Z){return new a.NotebookRendererScript(L.URI.revive(Z.uri),Z.provides)}Re.to=_e})(Rt||(e.NotebookRendererScript=Rt={}));var Bt;(function(Re){function Fe(Z){return{message:O.fromStrict(Z.message)||"",type:0,expected:Z.expectedOutput,actual:Z.actualOutput,location:Z.location&&{range:d.from(Z.location.range),uri:Z.location.uri}}}Re.from=Fe;function _e(Z){const Oe=new a.TestMessage(typeof Z.message=="string"?Z.message:O.to(Z.message));return Oe.actualOutput=Z.actual,Oe.expectedOutput=Z.expected,Oe.location=Z.location?ve.to(Z.location):void 0,Oe}Re.to=_e})(Bt||(e.TestMessage=Bt={}));var St;(function(Re){Re.namespace=_.namespaceTestTag,Re.denamespace=_.denamespaceTestTag})(St||(e.TestTag=St={}));var Ke;(function(Re){function Fe(Z){const Oe=(0,v.getPrivateApiFor)(Z).controllerId;return{extId:g.TestId.fromExtHostTestItem(Z,Oe).toString(),label:Z.label,uri:L.URI.revive(Z.uri),busy:!1,tags:Z.tags.map(We=>St.namespace(Oe,We.id)),range:P.Range.lift(d.from(Z.range)),description:Z.description||null,sortText:Z.sortText||null,error:Z.error&&O.fromStrict(Z.error)||null}}Re.from=Fe;function _e(Z){return{parent:void 0,error:void 0,id:g.TestId.fromString(Z.extId).localId,label:Z.label,uri:L.URI.revive(Z.uri),tags:(Z.tags||[]).map(Oe=>{const{tagId:We}=St.denamespace(Oe);return new a.TestTag(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},get:()=>{},replace:()=>{},size:0},range:d.to(Z.range||void 0),canResolveChildren:!1,busy:!1,description:Z.description||void 0,sortText:Z.sortText||void 0}}Re.toPlain=_e})(Ke||(e.TestItem=Ke={})),function(Re){function Fe(Z){return{id:Z.id}}Re.from=Fe;function _e(Z){return new a.TestTag(Z.id)}Re.to=_e}(St||(e.TestTag=St={}));var Lt;(function(Re){const Fe=(Z,Oe)=>{const We={...Ke.toPlain(Z.item),parent:void 0,taskStates:Z.tasks.map(it=>({state:it.state,duration:it.duration,messages:it.messages.filter(Qe=>Qe.type===0).map(Bt.to)})),children:Z.children.map(it=>Oe.get(it)).filter(T.isDefined).map(it=>Fe(it,Oe))};for(const it of We.children)it.parent=We;return We};function _e(Z){const Oe=[],We=new Map;for(const it of Z.items)We.set(it.item.extId,it),Z.request.targets.some(Qe=>Qe.controllerId===it.controllerId&&Qe.testIds.includes(it.item.extId))&&Oe.push(it);return{completedAt:Z.completedAt,results:Oe.map(it=>Fe(it,We))}}Re.to=_e})(Lt||(e.TestResults=Lt={}));var Mt;(function(Re){function Fe(We){return{covered:We.covered,total:We.covered}}function _e(We){return"line"in We?s.from(We):d.from(We)}function Z(We){return"branches"in We?{count:We.executionCount,location:_e(We.location),type:1,branches:We.branches.length?We.branches.map(it=>({count:it.executionCount,location:it.location&&_e(it.location)})):void 0}:{type:0,count:We.executionCount,location:_e(We.location)}}Re.fromDetailed=Z;function Oe(We){return{uri:We.uri,statement:Fe(We.statementCoverage),branch:We.branchCoverage&&Fe(We.branchCoverage),function:We.functionCoverage&&Fe(We.functionCoverage),details:We.detailedCoverage?.map(Z)}}Re.fromFile=Oe})(Mt||(e.TestCoverage=Mt={}));var Ot;(function(Re){function Fe(_e){switch(_e){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Re.to=Fe})(Ot||(e.CodeActionTriggerKind=Ot={}));var pt;(function(Re){function Fe(Z){const Oe=new a.TypeHierarchyItem(q.to(Z.kind),Z.name,Z.detail||"",L.URI.revive(Z.uri),d.to(Z.range),d.to(Z.selectionRange));return Oe._sessionId=Z._sessionId,Oe._itemId=Z._itemId,Oe}Re.to=Fe;function _e(Z,Oe,We){if(Oe=Oe??Z._sessionId,We=We??Z._itemId,Oe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:We,kind:q.from(Z.kind),name:Z.name,detail:Z.detail??"",uri:Z.uri,range:d.from(Z.range),selectionRange:d.from(Z.selectionRange),tags:Z.tags?.map(te.from)}}Re.from=_e})(pt||(e.TypeHierarchyItem=pt={}));var yt;(function(Re){function Fe(_e){if(!!_e)return{value:_e.value,tooltip:_e.tooltip}}Re.from=Fe})(yt||(e.ViewBadge=yt={}));var kt;(function(Re){function Fe(_e,Z){const Oe=_e.fileData;return Oe?new class extends a.DataTransferItem{asFile(){return{name:Oe.name,uri:L.URI.revive(Oe.uri),data:(0,m.once)(()=>Z())}}}(""):new a.DataTransferItem(_e.asString)}Re.toDataTransferItem=Fe})(kt||(e.DataTransferItem=kt={}));var _t;(function(Re){function Fe(Z,Oe){const We=Z.items.map(([it,Qe],ut)=>[it,kt.toDataTransferItem(Qe,()=>Oe(ut))]);return new a.DataTransfer(We)}Re.toDataTransfer=Fe;async function _e(Z){const Oe={items:[]},We=[];return Z.forEach((it,Qe)=>{We.push((async()=>{const ut=await it.asString(),ht=it.asFile();Oe.items.push([Qe,{asString:ut,fileData:ht?{name:ht.name,uri:ht.uri}:void 0}])})())}),await Promise.all(We),Oe}Re.toDataTransferDTO=_e})(_t||(e.DataTransfer=_t={}))}),define(ke[221],Pe([1,0,2,11,7,15,81]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(T,L,P,S={timeout:1500,errors:3}){this._logService=T,this._documents=L,this._mainThreadBulkEdits=P,this._thresholds=S,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(L,P,S)=>{const E={dispose:this._callbacks.push([L,P,T])};return Array.isArray(S)&&S.push(E),E}}async $participateInSave(T,L){const P=u.URI.revive(T);let S=!1;const I=setTimeout(()=>S=!0,this._thresholds.timeout),E=[];try{for(let v of[...this._callbacks]){if(S)break;const w=this._documents.getDocument(P),g=await this._deliverEventAsyncAndBlameBadListeners(v,{document:w,reason:A.TextDocumentSaveReason.to(L)});E.push(g)}}finally{clearTimeout(I)}return E}_deliverEventAsyncAndBlameBadListeners([T,L,P],S){const I=this._badListeners.get(T);return typeof I=="number"&&I>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,T,L,S).then(()=>!0,E=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const v=this._badListeners.get(T);this._badListeners.set(T,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,L,P,S){const I=[],E=Date.now(),{document:v,reason:w}=S,{version:g}=v,_=Object.freeze({document:v,reason:w,waitUntil(f){if(Object.isFrozen(I))throw(0,i.illegalState)("waitUntil can not be called async");I.push(Promise.resolve(f))}});try{L.apply(P,[_])}catch(f){return Promise.reject(f)}return Object.freeze(I),new Promise((f,a)=>{const m=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(I).then(o=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(m),f(o)}).catch(o=>{clearTimeout(m),a(o)})}).then(f=>{const a={edits:[]};for(const m of f)if(Array.isArray(m)&&m.every(o=>o instanceof y.TextEdit))for(const{newText:o,newEol:d,range:r}of m)a.edits.push({_type:2,resource:v.uri,edit:{range:r&&A.Range.from(r),text:o,eol:d&&A.EndOfLine.from(d)}});if(a.edits.length!==0)return g===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(ke[222],Pe([1,0,10,2,15,7,128]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(P,S,I,E){this.start=P,this.deletedCount=S,this.deletedItems=I,this.items=E}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class b{static asModelAddData(P,S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,S,I){this.notebook=P,this._extHostDocument=S,this._cellData=I,this.handle=I.handle,this.uri=i.URI.revive(I.uri),this.cellKind=I.cellKind,this._outputs=I.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=I.internalMetadata??{},this._metadata=Object.freeze(I.metadata??{}),this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(I.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const P=this,S=this._extHostDocument.getDocument(this.uri);if(!S)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const I={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:S.document,get mime(){return P._mime},set mime(E){P._mime=E},get outputs(){return P._outputs.slice(0)},get metadata(){return P._metadata},get executionSummary(){return P._previousResult}};this._apiCell=Object.freeze(I)}return this._apiCell}setOutputs(P){this._outputs=P.map(y.NotebookCellOutput.to)}setOutputItems(P,S,I){const E=I.map(y.NotebookCellOutputItem.to),v=this._outputs.find(w=>w.id===P);v&&(S||(v.items.length=0),v.items.push(...E))}setMetadata(P){this._metadata=Object.freeze(P)}setInternalMetadata(P){this._internalMetadata=P,this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=b;class T{constructor(P,S,I,E,v){this._proxy=P,this._textDocumentsAndEditors=S,this._textDocuments=I,this.uri=E,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=v.viewType,this._metadata=Object.freeze(v.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,v.cells]],!0,void 0),this._versionId=v.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const P=this,S={get uri(){return P.uri},get version(){return P._versionId},get notebookType(){return P._notebookType},get isDirty(){return P._isDirty},get isUntitled(){return P.uri.scheme===u.Schemas.untitled},get isClosed(){return P._disposed},get metadata(){return P._metadata},get cellCount(){return P._cells.length},cellAt(I){return I=P._validateIndex(I),P._cells[I].apiCell},getCells(I){return(I?P._getCells(I):P._cells).map(v=>v.apiCell)},save(){return P._save()}};this._notebook=Object.freeze(S)}return this._notebook}updateBackup(P){this._backup?.delete(),this._backup=P}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(P){P.metadata&&(this._metadata=Object.freeze({...this._metadata,...P.metadata}))}acceptDirty(P){this._isDirty=P}acceptModelChanged(P,S,I){this._versionId=P.versionId,this._isDirty=S,this.acceptDocumentPropertiesChanged({metadata:I});const E={notebook:this.apiNotebook,metadata:I,cellChanges:[],contentChanges:[]},v=[];for(const g of P.rawEvents)g.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(g.changes,!1,E.contentChanges):g.kind===C.NotebookCellsChangeType.Move?this._moveCell(g.index,g.newIdx,E.contentChanges):g.kind===C.NotebookCellsChangeType.Output?(this._setCellOutputs(g.index,g.outputs),v.push({cell:this._cells[g.index].apiCell,outputs:this._cells[g.index].apiCell.outputs})):g.kind===C.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(g.index,g.outputId,g.append,g.outputItems),v.push({cell:this._cells[g.index].apiCell,outputs:this._cells[g.index].apiCell.outputs})):g.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(g.index,g.language),v.push({cell:this._cells[g.index].apiCell,document:this._cells[g.index].apiCell.document})):g.kind===C.NotebookCellsChangeType.ChangeCellContent?v.push({cell:this._cells[g.index].apiCell,document:this._cells[g.index].apiCell.document}):g.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(g.index,g.mime):g.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(g.index,g.metadata),v.push({cell:this._cells[g.index].apiCell,metadata:this._cells[g.index].apiCell.metadata})):g.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(g.index,g.internalMetadata),v.push({cell:this._cells[g.index].apiCell,executionSummary:this._cells[g.index].apiCell.executionSummary}));const w=new Map;for(let g=0;g<v.length;g++){const _=v[g],f=w.get(_.cell);if(f===void 0){const a=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,..._});w.set(_.cell,a-1)}else E.cellChanges[f]={...E.cellChanges[f],..._}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}_validateIndex(P){return P=P|0,P<0?0:P>=this._cells.length?this._cells.length-1:P}_validateRange(P){let S=P.start|0,I=P.end|0;return S<0&&(S=0),I>this._cells.length&&(I=this._cells.length),P.with({start:S,end:I})}_getCells(P){P=this._validateRange(P);const S=[];for(let I=P.start;I<P.end;I++)S.push(this._cells[I]);return S}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(P,S,I){if(this._disposed)return;const E=[],v=[],w=[];if(P.reverse().forEach(g=>{const f=g[2].map(o=>{const d=new b(this,this._textDocumentsAndEditors,o);return S||v.push(b.asModelAddData(this.apiNotebook,o)),d}),a=new D(g[0],g[1],[],f),m=this._cells.splice(g[0],g[1],...f);for(const o of m)w.push(o.uri),a.deletedItems.push(o.apiCell);E.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:w}),I)for(let g of E)I.push(g.asApiEvent())}_moveCell(P,S,I){const E=this._cells.splice(P,1);this._cells.splice(S,0,...E);const v=[new D(P,1,E.map(w=>w.apiCell),[]),new D(S,0,[],E)];for(const w of v)I.push(w.asApiEvent())}_setCellOutputs(P,S){this._cells[P].setOutputs(S)}_setCellOutputItems(P,S,I,E){this._cells[P].setOutputItems(S,I,E)}_changeCellLanguage(P,S){const I=this._cells[P];I.apiCell.document.languageId!==S&&this._textDocuments.$acceptModelLanguageChanged(I.uri,S)}_changeCellMime(P,S){const I=this._cells[P];I.apiCell.mime=S}_changeCellMetadata(P,S){this._cells[P].setMetadata(S)}_changeCellInternalMetadata(P,S){this._cells[P].setInternalMetadata(S)}getCellFromApiCell(P){return this._cells.find(S=>S.apiCell===P)}getCellFromIndex(P){return this._cells[P]}getCell(P){return this._cells.find(S=>S.handle===P)}getCellIndex(P){return this._cells.indexOf(P)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(ke[131],Pe([1,0,7,15,11]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(b){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=b}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(b){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:b})}replaceCellMetadata(b,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:b,metadata:T})}replaceCells(b,T,L){this._throwIfFinalized(),!(b===T&&L.length===0)&&this._collectedEdits.push({editType:1,index:b,count:T-b,cells:L.map(i.NotebookCellData.from)})}}class C{constructor(b,T,L,P,S,I){this.id=b,this._proxy=T,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._visibleRanges=P,this._viewColumn=I}get apiEditor(){if(!this._editor){const b=this;this._editor={get document(){return b.notebookData.apiNotebook},get notebook(){return b.notebookData.apiNotebook},get selection(){return b._selections[0]},set selection(T){this.selections=[T]},get selections(){return b._selections},set selections(T){if(!Array.isArray(T)||!T.every(u.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");b._selections=T,b._trySetSelections(T)},get visibleRanges(){return b._visibleRanges},revealRange(T,L){b._proxy.$tryRevealRange(b.id,i.NotebookRange.from(T),L??u.NotebookEditorRevealType.Default)},get viewColumn(){return b._viewColumn},edit(T){const L=new A(this.document.version);return T(L),b._applyEdit(L.finalize())},setDecorations(T,L){return b.setDecorations(T,L)}},C.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(b){this._visible=b}_acceptVisibleRanges(b){this._visibleRanges=b}_acceptSelections(b){this._selections=b}_trySetSelections(b){this._proxy.$trySetSelections(this.id,b.map(i.NotebookRange.from))}_acceptViewColumn(b){this._viewColumn=b}_applyEdit(b){if(b.cellEdits.length===0)return Promise.resolve(!0);const T=[];let L=-1;for(let P=0;P<b.cellEdits.length;P++){if(L<0){T.push(b.cellEdits[P]),L++;continue}const I=T[L],E=b.cellEdits[P];if(I.editType===1&&E.editType===1&&I.index===E.index){I.cells.push(...b.cellEdits[P].cells),I.count+=b.cellEdits[P].count;continue}T.push(b.cellEdits[P]),L++}return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,T)}setDecorations(b,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(b.key)))return T.isEmpty?this._hasDecorationsForKey.delete(b.key):this._hasDecorationsForKey.add(b.key),this._proxy.$trySetDecorations(this.id,i.NotebookRange.from(T),b.key)}}e.ExtHostNotebookEditor=C,C.apiEditorsToExtHost=new WeakMap}),define(ke[223],Pe([1,0,15,118,172,21,58,11]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class b{constructor(S){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=S}async withProgress(S,I,E){const v=this._handles++,{title:w,location:g,cancellable:_}=I,f={label:(0,y.localize)(0,null,S.displayName||S.name),id:S.identifier.value};return this._proxy.$startProgress(v,{location:u.ProgressLocation.from(g),title:w,source:f,cancellable:_},S.isUnderDevelopment?void 0:S.identifier.value).catch(D.onUnexpectedExternalError),this._withProgress(v,E,!!_)}_withProgress(S,I,E){let v;E&&(v=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(S,v));const w=_=>{this._proxy.$progressEnd(_),this._mapHandleToCancellationSource.delete(_),v&&v.dispose()};let g;try{g=I(new L(this._proxy,S),E&&v?v.token:A.CancellationToken.None)}catch(_){throw w(S),_}return g.then(_=>w(S),_=>w(S)),g}$acceptProgressCanceled(S){const I=this._mapHandleToCancellationSource.get(S);I&&(I.cancel(),this._mapHandleToCancellationSource.delete(S))}}e.ExtHostProgress=b;function T(P,S){return P.message=S.message,typeof S.increment=="number"&&(typeof P.increment=="number"?P.increment+=S.increment:P.increment=S.increment),P}class L extends i.Progress{constructor(S,I){super(E=>this.throttledReport(E));this._proxy=S,this._handle=I}throttledReport(S){this._proxy.$progressReport(this._handle,S)}}je([(0,C.throttle)(100,(P,S)=>T(P,S),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ke[132],Pe([1,0,36,129,67,90,68,15,2]),function(Q,e,u,i,y,A,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const T=(f,a,m,o)=>{let d=a;return{enumerable:!0,configurable:!1,get(){return d},set(r){if(!m(d,r)){const s=d;d=r,f.listener?.(o(r,s))}}}},L=(f,a)=>f===a,P={range:(f,a)=>f===a?!0:!f||!a?!1:f.isEqual(a),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(f,a)=>!(f.length!==a.length||f.some(m=>!a.find(o=>m.id===o.id)))},S=f=>a=>({op:4,update:f(a)}),I=(f,a)=>({range:T(f,void 0,P.range,S(m=>({range:u.Range.lift(D.Range.from(m))}))),label:T(f,a,P.label,S(m=>({label:m}))),description:T(f,void 0,P.description,S(m=>({description:m}))),sortText:T(f,void 0,P.sortText,S(m=>({sortText:m}))),canResolveChildren:T(f,!1,P.canResolveChildren,m=>({op:2,state:m})),busy:T(f,!1,P.busy,S(m=>({busy:m}))),error:T(f,void 0,P.error,S(m=>({error:D.MarkdownString.fromStrict(m)||null}))),tags:T(f,[],P.tags,(m,o)=>({op:1,new:m.map(D.TestTag.from),old:o.map(D.TestTag.from)}))}),E=f=>{const a=y.TestId.fromString(f.extId),m=new w(a.controllerId,a.localId,f.label,b.URI.revive(f.uri)||void 0);return m.range=D.Range.to(f.range||void 0),m.description=f.description||void 0,m.sortText=f.sortText||void 0,m.tags=f.tags.map(o=>D.TestTag.to({id:(0,C.denamespaceTestTag)(o).tagId})),m},v=f=>{let a;for(const m of f.tests){const o=E(m.item);(0,i.getPrivateApiFor)(o).parent=a,a=o}return a};e.toItemFromContext=v;class w{constructor(a,m,o,d){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const r=(0,i.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof g?void 0:r.parent}},children:{value:(0,A.createTestItemChildren)(r,i.getPrivateApiFor,w),enumerable:!0,writable:!1},...I(r,o)})}}e.TestItemImpl=w;class g extends w{constructor(a,m){super(a,a,m,void 0)}}e.TestItemRootImpl=g;class _ extends A.TestItemCollection{constructor(a,m){super({controllerId:a,getApiFor:i.getPrivateApiFor,getChildren:o=>o.children,root:new g(a,m),toITestItem:D.TestItem.from})}}e.ExtHostTestItemCollection=_}),define(ke[133],Pe([1,0,57,11,79,15,7]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(S,I,E){const v=D._Keys.nextId();S.$registerTextEditorDecorationType(I.identifier,v,A.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:v,dispose(){S.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=D,D._Keys=new y.IdGenerator("TextEditorDecorationType");class b{constructor(S,I){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=S,this._documentVersionId=S.version,this._undoStopBefore=I.undoStopBefore,this._undoStopAfter=I.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(S,I){this._throwIfFinalized();let E=null;if(S instanceof C.Position)E=new C.Range(S,S);else if(S instanceof C.Range)E=S;else throw new Error("Unrecognized location");this._pushEdit(E,I,!1)}insert(S,I){this._throwIfFinalized(),this._pushEdit(new C.Range(S,S),I,!0)}delete(S){this._throwIfFinalized();let I=null;if(S instanceof C.Range)I=S;else throw new Error("Unrecognized location");this._pushEdit(I,null,!0)}_pushEdit(S,I,E){const v=this._document.validateRange(S);this._collectedEdits.push({range:v,text:I,forceMoveMarkers:E})}setEndOfLine(S){if(this._throwIfFinalized(),S!==C.EndOfLine.LF&&S!==C.EndOfLine.CRLF)throw(0,i.illegalArgument)("endOfLine");this._setEndOfLine=S}}e.TextEditorEdit=b;class T{constructor(S,I,E,v){this._proxy=S,this._id=I,this._accept(E),this._logService=v;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(g){w._setTabSize(g)},get insertSpaces(){return w._insertSpaces},set insertSpaces(g){w._setInsertSpaces(g)},get cursorStyle(){return w._cursorStyle},set cursorStyle(g){w._setCursorStyle(g)},get lineNumbers(){return w._lineNumbers},set lineNumbers(g){w._setLineNumbers(g)}}}_accept(S){this._tabSize=S.tabSize,this._insertSpaces=S.insertSpaces,this._cursorStyle=S.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(S.lineNumbers)}_validateTabSize(S){if(S==="auto")return"auto";if(typeof S=="number"){const I=Math.floor(S);return I>0?I:null}if(typeof S=="string"){const I=parseInt(S,10);return isNaN(I)?null:I>0?I:null}return null}_setTabSize(S){const I=this._validateTabSize(S);if(I!==null){if(typeof I=="number"){if(this._tabSize===I)return;this._tabSize=I}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:I}))}}_validateInsertSpaces(S){return S==="auto"?"auto":S==="false"?!1:Boolean(S)}_setInsertSpaces(S){const I=this._validateInsertSpaces(S);if(typeof I=="boolean"){if(this._insertSpaces===I)return;this._insertSpaces=I}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:I}))}_setCursorStyle(S){this._cursorStyle!==S&&(this._cursorStyle=S,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:S})))}_setLineNumbers(S){this._lineNumbers!==S&&(this._lineNumbers=S,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(S)})))}assign(S){const I={};let E=!1;if(typeof S.tabSize!="undefined"){const v=this._validateTabSize(S.tabSize);v==="auto"?(E=!0,I.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,E=!0,I.tabSize=v)}if(typeof S.insertSpaces!="undefined"){const v=this._validateInsertSpaces(S.insertSpaces);v==="auto"?(E=!0,I.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,E=!0,I.insertSpaces=v)}typeof S.cursorStyle!="undefined"&&this._cursorStyle!==S.cursorStyle&&(this._cursorStyle=S.cursorStyle,E=!0,I.cursorStyle=S.cursorStyle),typeof S.lineNumbers!="undefined"&&this._lineNumbers!==S.lineNumbers&&(this._lineNumbers=S.lineNumbers,E=!0,I.lineNumbers=A.TextEditorLineNumbersStyle.from(S.lineNumbers)),E&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,I))}_warnOnError(S,I){I.catch(E=>{this._logService.warn(`ExtHostTextEditorOptions '${S}' failed:'`),this._logService.warn(E)})}}e.ExtHostTextEditorOptions=T;class L{constructor(S,I,E,v,w,g,_,f){this.id=S,this._proxy=I,this._logService=E,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new T(this._proxy,this.id,g,E),this._visibleRanges=_,this._viewColumn=f;const a=this;this.value=Object.freeze({get document(){return v.getValue()},set document(m){throw(0,i.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(m){if(!(m instanceof C.Selection))throw(0,i.illegalArgument)("selection");a._selections=[m],a._trySetSelection()},get selections(){return a._selections},set selections(m){if(!Array.isArray(m)||m.some(o=>!(o instanceof C.Selection)))throw(0,i.illegalArgument)("selections");a._selections=m,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(m){throw(0,i.readonly)("visibleRanges")},get options(){return a._options.value},set options(m){a._disposed||a._options.assign(m)},get viewColumn(){return a._viewColumn},set viewColumn(m){throw(0,i.readonly)("viewColumn")},edit(m,o={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new b(v.getValue(),o);return m(d),a._applyEdit(d)},insertSnippet(m,o,d={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!o||Array.isArray(o)&&o.length===0)r=a._selections.map(s=>A.Range.from(s));else if(o instanceof C.Position){const{lineNumber:s,column:n}=A.Position.from(o);r=[{startLineNumber:s,startColumn:n,endLineNumber:s,endColumn:n}]}else if(o instanceof C.Range)r=[A.Range.from(o)];else{r=[];for(const s of o)if(s instanceof C.Range)r.push(A.Range.from(s));else{const{lineNumber:n,column:t}=A.Position.from(s);r.push({startLineNumber:n,startColumn:t,endLineNumber:n,endColumn:t})}}return I.$tryInsertSnippet(S,v.getValue().version,m.value,r,d)},setDecorations(m,o){const d=o.length===0;d&&!a._hasDecorationsForKey.has(m.key)||(d?a._hasDecorationsForKey.delete(m.key):a._hasDecorationsForKey.add(m.key),a._runOnProxy(()=>{if(A.isDecorationOptionsArr(o))return I.$trySetDecorations(S,m.key,A.fromRangeOrRangeWithMessage(o));{const r=new Array(4*o.length);for(let s=0,n=o.length;s<n;s++){const t=o[s];r[4*s]=t.start.line+1,r[4*s+1]=t.start.character+1,r[4*s+2]=t.end.line+1,r[4*s+3]=t.end.character+1}return I.$trySetDecorationsFast(S,m.key,r)}}))},revealRange(m,o){a._runOnProxy(()=>I.$tryRevealRange(S,A.Range.from(m),o||C.TextEditorRevealType.Default))},show(m){I.$tryShowEditor(S,A.ViewColumn.from(m))},hide(){I.$tryHideEditor(S)}})}dispose(){(0,u.ok)(!this._disposed),this._disposed=!0}_acceptOptions(S){(0,u.ok)(!this._disposed),this._options._accept(S)}_acceptVisibleRanges(S){(0,u.ok)(!this._disposed),this._visibleRanges=S}_acceptViewColumn(S){(0,u.ok)(!this._disposed),this._viewColumn=S}_acceptSelections(S){(0,u.ok)(!this._disposed),this._selections=S}async _trySetSelection(){const S=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,S)),this.value}_applyEdit(S){const I=S.finalize();if(I.edits.length===0&&!I.setEndOfLine)return Promise.resolve(!0);const E=I.edits.map(w=>w.range);E.sort((w,g)=>w.end.line===g.end.line?w.end.character===g.end.character?w.start.line===g.start.line?w.start.character-g.start.character:w.start.line-g.start.line:w.end.character-g.end.character:w.end.line-g.end.line);for(let w=0,g=E.length-1;w<g;w++){const _=E[w].end;if(E[w+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=I.edits.map(w=>({range:A.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,I.documentVersionId,v,{setEndOfLine:typeof I.setEndOfLine=="number"?A.EndOfLine.from(I.setEndOfLine):void 0,undoStopBefore:I.undoStopBefore,undoStopAfter:I.undoStopAfter})}_runOnProxy(S){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):S().then(()=>this,I=>(I instanceof Error&&I.name==="DISPOSED"||this._logService.warn(I),null))}}e.ExtHostTextEditor=L}),define(ke[224],Pe([1,0,4,191]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,u.refineServiceDecorator)(i.IEnvironmentService)}),define(ke[225],Pe([1,0,26,3,9]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(L){this.removedDueToLooping=L}}e.DeltaExtensionsResult=A;class C{constructor(L){this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=L,this._initialize()}_initialize(){this._extensionDescriptions.sort(b),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const L of this._extensionDescriptions){if(this._extensionsMap.has(u.ExtensionIdentifier.toKey(L.identifier))){console.error("Extension `"+L.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(u.ExtensionIdentifier.toKey(L.identifier),L),this._extensionsArr.push(L),Array.isArray(L.activationEvents))for(let P of L.activationEvents)P==="onUri"&&(P=`onUri:${u.ExtensionIdentifier.toKey(L.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(L)}}set(L){this._extensionDescriptions=L,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(L,P){L.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(L));const S=C._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(S.map(I=>I.identifier)),P.length>0){const I=new Set;P.forEach(E=>I.add(u.ExtensionIdentifier.toKey(E))),this._extensionDescriptions=this._extensionDescriptions.filter(E=>!I.has(u.ExtensionIdentifier.toKey(E.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(S)}static _findLoopingExtensions(L){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,g){this.addNode(w),this.addNode(g),this._arcs.has(w)?this._arcs.get(w).push(g):this._arcs.set(w,[g])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,g){const _=P.getArcs(w);for(let f=0;f<_.length;f++)if(!g.has(_[f]))return!1;return!0}getNodes(){return this._nodesArr}};let S=new Map;for(let w of L){const g=u.ExtensionIdentifier.toKey(w.identifier);if(S.set(g,w),w.extensionDependencies)for(let _ of w.extensionDependencies){const f=u.ExtensionIdentifier.toKey(_);P.addArc(g,f)}}let I=new Set;P.getNodes().filter(w=>P.getArcs(w).length===0).forEach(w=>I.add(w));let E=P.getNodes().filter(w=>!I.has(w)),v;do{v=!1;for(let w=0;w<E.length;w++){const g=E[w];P.hasOnlyGoodArcs(g,I)&&(E.splice(w,1),w--,I.add(g),v=!0)}}while(v);return E.map(w=>S.get(w))}containsActivationEvent(L){return this._activationMap.has(L)}containsExtension(L){return this._extensionsMap.has(u.ExtensionIdentifier.toKey(L))}getExtensionDescriptionsForActivationEvent(L){const P=this._activationMap.get(L);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(L){const P=this._extensionsMap.get(u.ExtensionIdentifier.toKey(L));return P||void 0}}e.ExtensionDescriptionRegistry=C;var D;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(D||(D={}));function b(T,L){const P=T.isBuiltin?0:T.isUnderDevelopment?2:1,S=L.isBuiltin?0:L.isUnderDevelopment?2:1;if(P!==S)return P-S;const I=y.posix.basename(T.extensionLocation.path),E=y.posix.basename(L.extensionLocation.path);return I<E?-1:I>E?1:0}}),define(ke[134],Pe([1,0,23]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var i;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(i||(e.UIKind=i={}));var y;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(y||(e.ExtensionHostExitCode=y={}));var A;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function C(b){const T=u.VSBuffer.alloc(1);switch(b){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}e.createMessageOfType=C;function D(b,T){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}e.isMessageOfType=D}),define(ke[28],Pe([1,0,3,2,4,26,200]),function(Q,e,u,i,y,A,C){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:i.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");class b{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=b;class T{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=T;class L{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class P{constructor(t){this.dependency=t}}e.MissingExtensionDependency=P;var S;(function(n){n[n.LocalProcess=1]="LocalProcess",n[n.LocalWebWorker=2]="LocalWebWorker",n[n.Remote=3]="Remote"})(S||(e.ExtensionHostKind=S={}));function I(n){if(n===null)return"None";switch(n){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=I;class E{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,c){const l=[],h=[],p=[],R=[],F=g(this._allExtensions),O=g(t),k=(Y,$)=>Y.extensionLocation.toString()===$.extensionLocation.toString()||Y.isBuiltin===$.isBuiltin||Y.isUserBuiltin===$.isUserBuiltin||Y.isUnderDevelopment===$.isUnderDevelopment;for(const Y of this._allExtensions){const $=O.get(A.ExtensionIdentifier.toKey(Y.identifier));if(!$){l.push(Y.identifier),F.delete(A.ExtensionIdentifier.toKey(Y.identifier));continue}if(!k(Y,$)){l.push(Y.identifier),F.delete(A.ExtensionIdentifier.toKey(Y.identifier));continue}}for(const Y of t){const $=F.get(A.ExtensionIdentifier.toKey(Y.identifier));if(!$){h.push(Y);continue}if(!k($,Y)){l.push($.identifier),F.delete(A.ExtensionIdentifier.toKey($.identifier));continue}}const U=w(this._myExtensions),B=w(c);for(const Y of this._myExtensions)B.has(A.ExtensionIdentifier.toKey(Y))||p.push(Y);for(const Y of c)U.has(A.ExtensionIdentifier.toKey(Y))||R.push(Y);const z={toRemove:l,toAdd:h,myToRemove:p,myToAdd:R};return this.delta(z),z}delta(t){const{toRemove:c,toAdd:l,myToRemove:h,myToAdd:p}=t,R=w(c),F=w(h);for(let O=0;O<this._allExtensions.length;O++)R.has(A.ExtensionIdentifier.toKey(this._allExtensions[O].identifier))&&(this._allExtensions.splice(O,1),O--);for(let O=0;O<this._myExtensions.length;O++)F.has(A.ExtensionIdentifier.toKey(this._myExtensions[O]))&&(this._myExtensions.splice(O,1),O--);for(const O of l)this._allExtensions.push(O);for(const O of p)this._myExtensions.push(O)}containsExtension(t){for(const c of this._myExtensions)if(A.ExtensionIdentifier.equals(c,t))return!0;return!1}}e.ExtensionHostExtensions=E;class v{constructor(t){if(this[D]="ExtensionIdentifierSet",this._map=new Map,this._toKey=A.ExtensionIdentifier.toKey,t)for(const c of t)this.add(c)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,c){this._map.forEach(l=>t.call(c,l,l,this))}*entries(){for(let[t,c]of this._map)yield[c,c]}keys(){return this._map.values()}values(){return this._map.values()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=v;function w(n){const t=new Set;for(const c of n)t.add(A.ExtensionIdentifier.toKey(c));return t}e.extensionIdentifiersArrayToSet=w;function g(n){const t=new Map;for(const c of n)t.set(A.ExtensionIdentifier.toKey(c.identifier),c);return t}function _(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=_;function f(n,t){if(!_(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.checkProposedApiEnabled=f;class a{constructor(t,c,l,h){this.codeLoadingTime=t,this.activateCallTime=c,this.activateResolvedTime=l,this.activationReason=h}}e.ActivationTimes=a;class m{constructor(t,c){this.description=t,this.value=c}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var o;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function d(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function r(n,t){return{identifier:new A.ExtensionIdentifier((0,C.getExtensionId)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.toExtensionDescription=r;class s{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,c){return Promise.resolve(0)}getInspectPorts(t,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,c){return Promise.resolve()}}e.NullExtensionService=s}),define(ke[226],Pe([1,0,11,26,28,14,17]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class D{constructor(w,g,_,f){this.startup=w,this.codeLoadingTime=g,this.activateCallTime=_,this.activateResolvedTime=f}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class b{constructor(w){this._startup=w,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(w,g){return w===-1||g===-1?-1:g-w}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=b;class T{constructor(w,g,_,f,a,m){this.activationFailed=w,this.activationFailedError=g,this.activationTimes=_,this.module=f,this.exports=a,this.subscriptions=m}}e.ActivatedExtension=T;class L extends T{constructor(w){super(!1,null,w,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class P extends T{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=P;class S extends T{constructor(w){super(!0,w,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=S;let I=class{constructor(w,g,_,f,a){this._logService=a,this._registry=w,this._resolvedExtensionsSet=new Set,g.forEach(m=>this._resolvedExtensionsSet.add(i.ExtensionIdentifier.toKey(m))),this._externalExtensionsMap=new Map,_.forEach(m=>this._externalExtensionsMap.set(i.ExtensionIdentifier.toKey(m),m)),this._host=f,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[w,g]of this._operations)g.dispose()}isActivated(w){const g=this._operations.get(i.ExtensionIdentifier.toKey(w));return Boolean(g&&g.value)}getActivatedExtension(w){const g=this._operations.get(i.ExtensionIdentifier.toKey(w));if(!g||!g.value)throw new Error(`Extension '${w.value}' is not known or not activated`);return g.value}async activateByEvent(w,g){if(this._alreadyActivatedEvents[w])return;const _=this._registry.getExtensionDescriptionsForActivationEvent(w);await this._activateExtensions(_.map(f=>({id:f.identifier,reason:{startup:g,extensionId:f.identifier,activationEvent:w}}))),this._alreadyActivatedEvents[w]=!0}activateById(w,g){const _=this._registry.getExtensionDescription(w);if(!_)throw new Error(`Extension '${w}' is not known`);return this._activateExtensions([{id:_.identifier,reason:g}])}async _activateExtensions(w){const g=w.filter(_=>!this.isActivated(_.id)).map(_=>this._handleActivationRequest(_));await Promise.all(g.map(_=>_.wait()))}_handleActivationRequest(w){if(this._operations.has(i.ExtensionIdentifier.toKey(w.id)))return this._operations.get(i.ExtensionIdentifier.toKey(w.id));if(this._externalExtensionsMap.has(i.ExtensionIdentifier.toKey(w.id)))return this._createAndSaveOperation(w,null,[],null);const g=this._registry.getExtensionDescription(w.id);if(!g){const a=new Error(`Cannot activate unknown extension '${w.id.value}'`),m=this._createAndSaveOperation(w,null,[],new S(a));return this._host.onExtensionActivationError(w.id,a,new y.MissingExtensionDependency(w.id.value)),m}const _=[],f=typeof g.extensionDependencies=="undefined"?[]:g.extensionDependencies;for(const a of f){if(this._resolvedExtensionsSet.has(i.ExtensionIdentifier.toKey(a)))continue;const m=this._operations.get(i.ExtensionIdentifier.toKey(a));if(m){_.push(m);continue}if(this._externalExtensionsMap.has(i.ExtensionIdentifier.toKey(a))){_.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(i.ExtensionIdentifier.toKey(a)),reason:w.reason}));continue}const o=this._registry.getExtensionDescription(a);if(o){if(!o.main&&!o.browser)continue;_.push(this._handleActivationRequest({id:o.identifier,reason:w.reason}));continue}const d=g.displayName||g.identifier.value,r=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),s=this._createAndSaveOperation(w,g.displayName,[],new S(r));return this._host.onExtensionActivationError(g.identifier,r,new y.MissingExtensionDependency(a)),s}return this._createAndSaveOperation(w,g.displayName,_,null)}_createAndSaveOperation(w,g,_,f){const a=new E(w.id,g,w.reason,_,f,this._host,this._logService);return this._operations.set(i.ExtensionIdentifier.toKey(w.id),a),a}};e.ExtensionsActivator=I,e.ExtensionsActivator=I=je([He(4,A.ILogService)],I);let E=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(w,g,_,f,a,m,o){this._id=w,this._displayName=g,this._reason=_,this._deps=f,this._value=a,this._host=m,this._logService=o,this._barrier=new C.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let w=0;w<this._deps.length;w++){const g=this._deps[w];if(g.value&&!g.value.activationFailed){this._deps.splice(w,1),w--;continue}if(g.value&&g.value.activationFailed){const _=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);_.detail=g.value.activationFailedError,this._value=new S(_),this._host.onExtensionActivationError(this._id,_,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(w=>w.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(w){const g=new Error;if(w&&w.name&&(g.name=w.name),w&&w.message?g.message=`Activating extension '${this._id.value}' failed: ${w.message}.`:g.message=`Activating extension '${this._id.value}' failed: ${w}.`,w&&w.stack&&(g.stack=w.stack),this._value=new S(g),this._isDisposed&&u.isCancellationError(w))return;this._host.onExtensionActivationError(this._id,g,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(w)}}};E=je([He(6,A.ILogService)],E)}),define(ke[227],Pe([1,0,14,27,28]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends u.LogService{constructor(D,b){super(D.createLogger(b.logFile,{name:y.ExtensionHostLogFileName}))}};e.ExtHostLogService=A,e.ExtHostLogService=A=je([He(0,u.ILoggerService),He(1,i.IExtHostInitDataService)],A)}),define(ke[228],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorToolbar:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorToolbar.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",dataTransferFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dataTransferFiles.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorDecorationType:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorDecorationType.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmInput:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInput.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalNameChangeEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalNameChangeEvent.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textEditorDrop:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textEditorDrop.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[229],Pe([1,0,186,11,41,85,119,44,26,228,48,198]),function(Q,e,u,i,y,A,C,D,b,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const S=D.Registry.as(C.Extensions.JSONContribution);class I{constructor(m,o,d){this._messageHandler=m,this._extension=o,this._extensionPointId=d}_msg(m,o){this._messageHandler({type:m,message:o,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(m){this._msg(y.default.Error,m)}warn(m){this._msg(y.default.Warning,m)}info(m){this._msg(y.default.Info,m)}}e.ExtensionMessageCollector=I;class E{static _toSet(m){const o=new Set;for(let d=0,r=m.length;d<r;d++)o.add(b.ExtensionIdentifier.toKey(m[d].description.identifier));return o}static compute(m,o){if(!m||!m.length)return new E(o,[]);if(!o||!o.length)return new E([],m);const d=this._toSet(m),r=this._toSet(o);let s=o.filter(t=>!d.has(b.ExtensionIdentifier.toKey(t.description.identifier))),n=m.filter(t=>!r.has(b.ExtensionIdentifier.toKey(t.description.identifier)));return new E(s,n)}constructor(m,o){this.added=m,this.removed=o}}e.ExtensionPointUserDelta=E;class v{constructor(m,o){this.name=m,this.defaultExtensionKind=o,this._handler=null,this._users=null,this._delta=null}setHandler(m){if(this._handler!==null)throw new Error("Handler already set!");this._handler=m,this._handle()}acceptUsers(m){this._delta=E.compute(this._users,m),this._users=m,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(m){(0,i.onUnexpectedError)(m)}}}e.ExtensionPoint=v;const w={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},g="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:(0,L.values)(T.allApiProposals)}},activationEvents:{description:u.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:u.localize(28,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(29,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:u.localize(30,null)},{label:"onUri",body:"onUri",description:u.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(35,null)},{label:"onRenderer",description:u.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(38,null)},{label:"*",description:u.localize(39,null),body:"*"}]}},badges:{type:"array",description:u.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(41,null)},href:{type:"string",description:u.localize(42,null)},description:{type:"string",description:u.localize(43,null)}}}},markdown:{type:"string",description:u.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:u.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:u.localize(48,null),type:"array",items:w,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(49,null)},{body:["workspace"],description:u.localize(50,null)},{body:["ui","workspace"],description:u.localize(51,null)},{body:["workspace","ui"],description:u.localize(52,null)},{body:[],description:u.localize(53,null)}]},capabilities:{description:u.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(57,null),u.localize(58,null),u.localize(59,null)]},description:{type:"string",markdownDescription:u.localize(60,null)}}},untrustedWorkspaces:{description:u.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(63,null),u.localize(64,null),u.localize(65,null)]},restrictedConfigurations:{description:u.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(67,null)}}}}},sponsor:{description:u.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(70,null),type:"string"},"vscode:uninstall":{description:u.localize(71,null),type:"string"}}},icon:{type:"string",description:u.localize(72,null)}}};class _{constructor(){this._extensionPoints=new Map}registerExtensionPoint(m){if(this._extensionPoints.has(m.extensionPoint))throw new Error("Duplicate extension point: "+m.extensionPoint);const o=new v(m.extensionPoint,m.defaultExtensionKind);return this._extensionPoints.set(m.extensionPoint,o),e.schema.properties.contributes.properties[m.extensionPoint]=m.jsonSchema,S.registerSchema(g,e.schema),o}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=_;const f={ExtensionsRegistry:"ExtensionsRegistry"};D.Registry.add(f.ExtensionsRegistry,new _),e.ExtensionsRegistry=D.Registry.as(f.ExtensionsRegistry),S.registerSchema(g,e.schema),S.registerSchema(P.productSchemaId,{properties:{extensionEnabledApiProposals:{description:u.localize(73,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:(0,L.values)(T.allApiProposals)}}]}}}})}),define(ke[230],Pe([1,0,183,12,24,229,52,3]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var T;(function(S){function I(E,v,w){if(!E)return;let g=i.isString(E.type)?E.type:void 0;if(!g||g.length===0){w.error(u.localize(3,null));return}let _=[];if(Array.isArray(E.required))for(let f of E.required)i.isString(f)&&_.push(f);return{extensionId:v.value,taskType:g,required:_,properties:E.properties?y.deepClone(E.properties):{},when:E.when?C.ContextKeyExpr.deserialize(E.when):void 0}}S.from=I})(T||(T={}));const L=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:u.localize(4,null),type:"array",items:b}});class P{constructor(){this._onDefinitionsChanged=new D.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((I,E)=>{L.setHandler((v,w)=>{try{for(let g of w.removed){let _=g.value;for(let f of _)this.taskTypes&&f.type&&this.taskTypes[f.type]&&delete this.taskTypes[f.type]}for(let g of w.added){let _=g.value;for(let f of _){let a=T.from(f,g.description.identifier,g.collector);a&&(this.taskTypes[a.taskType]=a)}}(w.removed.length>0||w.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}I(void 0)})})}onReady(){return this.readyPromise}get(I){return this.taskTypes[I]}all(){return Object.keys(this.taskTypes).map(I=>this.taskTypes[I])}getJsonSchema(){if(this._schema===void 0){let I=[];for(let E of this.all()){let v={type:"object",additionalProperties:!1};E.required.length>0&&(v.required=E.required.slice(0)),E.properties!==void 0?v.properties=y.deepClone(E.properties):v.properties=Object.create(null),v.properties.type={type:"string",enum:[E.taskType]},I.push(v)}this._schema={oneOf:I}}return this._schema}}e.TaskDefinitionRegistryImpl=P,e.TaskDefinitionRegistry=new P}),define(ke[231],Pe([1,0,184,12,22,24,52,230]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,u.localize(0,null)),e.TASKS_CATEGORY={value:u.localize(1,null),original:"Tasks"};var b;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(b||(e.ShellQuoting=b={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function B(z){if(!z)return U.Strong;switch(z.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=B}(b||(e.ShellQuoting=b={}));var T;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(T||(e.CommandOptions=T={}));var L;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(L||(e.RevealKind=L={})),function(U){function B(z){switch(z.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=B}(L||(e.RevealKind=L={}));var P;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(U){function B(z){switch(z.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=B}(P||(e.RevealProblemKind=P={}));var S;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(S||(e.PanelKind=S={})),function(U){function B(z){switch(z.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=B}(S||(e.PanelKind=S={}));var I;(function(U){U.defaults={echo:!0,reveal:L.Always,revealProblems:P.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(I||(e.PresentationOptions=I={}));var E;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(E||(e.RuntimeType=E={})),function(U){function B(Y){switch(Y.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=B;function z(Y){switch(Y){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=z}(E||(e.RuntimeType=E={}));var v;(function(U){function B(z){return i.isString(z)?z:z.value}U.value=B})(v||(e.CommandString=v={}));var w;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function B(Y){return Y===U.Clean._id||Y===U.Build._id||Y===U.Rebuild._id||Y===U.Test._id}U.is=B;function z(Y){if(Y!==void 0)return i.isString(Y)?B(Y)?{_id:Y,isDefault:!1}:void 0:Y}U.from=z})(w||(e.TaskGroup=w={}));var g;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(g||(e.TaskScope=g={}));var _;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function B(z){switch(z){case U.User:return 1;case U.WorkspaceFile:return 4;default:return 5}}U.toConfigurationTarget=B})(_||(e.TaskSourceKind=_={}));var f;(function(U){U.parallel="parallel",U.sequence="sequence"})(f||(e.DependsOrder=f={}));var a;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var m;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(m||(e.RunOptions=m={}));class o{constructor(B,z,Y,$,N,V){this._label="",this._id=B,z&&(this._label=z),Y&&(this.type=Y),this.runOptions=$,this.configurationProperties=N,this._source=V}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.getFolderId(),id:this._id};return JSON.stringify(B)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,z=!1){if(B===void 0)return!1;if(i.isString(B))return B===this._label||B===this.configurationProperties.identifier||z&&B===this._id;let Y=this.getDefinition(!0);return Y!==void 0&&Y._key===B._key}getQualifiedLabel(){let B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),B&&(this._taskLoadMessages=this._taskLoadMessages.concat(B))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=o;class d extends o{constructor(B,z,Y,$,N,V,H,q){super(B,Y,void 0,H,q,z);this.command={},this._source=z,this.hasDefinedMatchers=V,N&&(this.command=N)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case E.Shell:z="shell";break;case E.Process:z="process";break;case E.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(B){return B instanceof d}getMapKey(){let B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===_.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){let B=this.getFolderId();if(!B)return;let z=this.configurationProperties.identifier;this._source.kind!==_.Workspace&&(z+=this._source.kind);let Y={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:z};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(B){return new d(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=d;class r extends o{constructor(B,z,Y,$,N,V,H){super(B,Y,$,V,H,z);this._source=z,this.configures=N}static is(B){return B instanceof r}fromObject(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===_.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){let B=this.getFolderId();if(!B)return;let z=this.configurationProperties.identifier;this._source.kind!==_.Workspace&&(z+=this._source.kind);let Y={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:z};return JSON.stringify(Y)}}e.ConfiguringTask=r;class s extends o{constructor(B,z,Y,$,N,V,H,q,te){super(B,Y,$,q,te,z);this.defines=N,this.hasDefinedMatchers=H,this.command=V}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof s}getMapKey(){let B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){let B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.getFolderId(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(B){return new s(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=s;class n extends o{constructor(B,z,Y,$,N,V){super(B,Y,$,N,V,z);this._source=z}clone(){return new n(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof n}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(B){return new n(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=n;var t;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(t||(e.ExecutionEngine=t={})),function(U){U._default=U.Terminal}(t||(e.ExecutionEngine=t={}));var c;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(c||(e.JsonSchemaVersion=c={}));class l{constructor(B){this._order=new Map;for(let z=0;z<B.length;z++)this._order.set(B[z].uri.toString(),z)}compare(B,z){let Y=B.getWorkspaceFolder(),$=z.getWorkspaceFolder();if(Y&&$){let N=this._order.get(Y.uri.toString());N=N===void 0?0:N+1;let V=this._order.get($.uri.toString());return V=V===void 0?0:V+1,N===V?B._label.localeCompare(z._label):N-V}else return!Y&&$?-1:Y&&!$?1:0}}e.TaskSorter=l;var h;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(h||(e.TaskEventKind=h={}));var p;(function(U){U.SingleRun="singleRun",U.Background="background"})(p||(e.TaskRunType=p={}));var R;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange"})(R||(e.TaskRunSource=R={}));var F;(function(U){function B(z,Y,$,N){if(Y){let V={kind:z,taskId:Y._id,taskName:Y.configurationProperties.name,runType:Y.configurationProperties.isBackground?"background":"singleRun",group:Y.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:Y};return z==="start"?(V.terminalId=$,V.resolvedVariables=N):z==="processStarted"?V.processId=$:z==="processEnded"&&(V.exitCode=$),Object.freeze(V)}else return Object.freeze({kind:"changed"})}U.create=B})(F||(e.TaskEvent=F={}));var O;(function(U){function B(Y){const $=Object.keys(Y).sort();let N="";for(const V of $){let H=Y[V];H instanceof Object?H=B(H):typeof H=="string"&&(H=H.replace(/,/g,",,")),N+=V+","+H+","}return N}function z(Y){let N={_key:B(Y),type:Y.taskType};return Object.assign(N,Y),N}U.create=z})(O||(e.KeyedTaskIdentifier=O={}));var k;(function(U){function B(z,Y){let $=D.TaskDefinitionRegistry.get(z.type);if($===void 0){let q=A.deepClone(z);return delete q._key,O.create(q)}let N=Object.create(null);N.type=$.taskType;let V=new Set;$.required.forEach(q=>V.add(q));let H=$.properties;for(let q of Object.keys(H)){let te=z[q];if(te!=null)N[q]=te;else if(V.has(q)){let fe=H[q];if(fe.default!==void 0)N[q]=A.deepClone(fe.default);else switch(fe.type){case"boolean":N[q]=!1;break;case"number":case"integer":N[q]=0;break;case"string":N[q]="";break;default:Y.error(u.localize(2,null,JSON.stringify(z,void 0,0),q));return}}}return O.create(N)}U.createTaskIdentifier=B})(k||(e.TaskDefinition=k={}))}),define(ke[232],Pe([1,0,11]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class i{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,C)=>{this._actualOk=A,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,u.onUnexpectedError)(A))}then(A,C){return this._ensureActual().then(A,C)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=i}),define(ke[54],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class u{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++u.count}}e.ProxyIdentifier=u,u.count=0;const i=[];function y(D){const b=new u(D);return i[b.nid]=b,b}e.createProxyIdentifier=y;function A(D){return i[D].sid}e.getStringIdentifierForProxy=A;class C{constructor(b){this.value=b}}e.SerializableObjectWithBuffers=C}),define(ke[5],Pe([1,0,62,2,54]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(A||(e.TextEditorRevealType=A={}));var C;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.NotebookInput=3]="NotebookInput",f[f.NotebookDiffInput=4]="NotebookDiffInput",f[f.CustomEditorInput=5]="CustomEditorInput",f[f.WebviewEditorInput=6]="WebviewEditorInput",f[f.TerminalEditorInput=7]="TerminalEditorInput"})(C||(e.TabInputKind=C={}));var D;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(D||(e.TabModelOperationKind=D={}));var b;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(b||(e.WebviewEditorCapabilities=b={}));var T;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var L;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(L||(e.CellOutputKind=L={}));var P;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(P||(e.NotebookEditorRevealType=P={}));var S;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(S||(e.CandidatePortSource=S={}));class I{static mixin(a){return a._id=I._n++,a}}e.IdObject=I,I._n=0;var E;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.command="m",f.kindModifier="n"})(E||(e.ISuggestDataDtoField=E={}));var v;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var w;(function(f){f[f.File=1]="File",f[f.Text=2]="Text",f[f.Cell=3]="Cell"})(w||(e.WorkspaceEditType=w={}));function g(f){if(f&&f.edits)for(const a of f.edits)typeof a.resource=="object"?a.resource=i.URI.revive(a.resource):(a.newUri=i.URI.revive(a.newUri),a.oldUri=i.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,u.revive)(a.metadata));return f}e.reviveWorkspaceEditDto=g;var _;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(_||(e.ExtHostTestingResource=_={})),e.MainContext={MainThreadAuthentication:(0,y.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createProxyIdentifier)("ExtHostTelemetry")}}),define(ke[91],Pe([1,0,5,3,4]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(D){this._onDidChangePassword=new i.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(u.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,b){return this._proxy.$getPassword(D,b)}store(D,b,T){return this._proxy.$setPassword(D,b,T)}delete(D,b){return this._proxy.$deletePassword(D,b)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(ke[69],Pe([1,0,4,14,5,18]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,u.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(b,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=b.getProxy(y.MainContext.MainThreadTelemetry)}report(b,T,L){const P=this.getUsageKey(b,T);this._reportedUsages.has(P)||(this._reportedUsages.add(P),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${b}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:b}))}getUsageKey(b,T){return`${b}-${T.identifier.value}`}};e.ExtHostApiDeprecationService=C,e.ExtHostApiDeprecationService=C=je([He(0,A.IExtHostRpcService),He(1,i.ILogService)],C),e.NullApiDeprecationService=Object.freeze(new class{report(D,b,T){}})}),define(ke[233],Pe([1,0,3,5,7,26]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(b){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new u.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=b.getProxy(i.MainContext.MainThreadAuthentication)}$setProviders(b){return this._providers=b,Promise.resolve()}async getSession(b,T,L,P={}){const S=A.ExtensionIdentifier.toKey(b.identifier),I=this._inFlightRequests.get(S)||[],E=[...L].sort().join(" ");let v=I.find(w=>w.providerId===T&&w.scopes===E);if(v)return v.result;{const w=this._getSession(b,S,T,L,P);v={providerId:T,scopes:E,result:w},I.push(v),this._inFlightRequests.set(S,I);try{await w}finally{const g=I.findIndex(_=>_.providerId===T&&_.scopes===E);g>-1&&(I.splice(g),this._inFlightRequests.set(S,I))}return w}}async _getSession(b,T,L,P,S={}){await this._proxy.$ensureProvider(L);const I=b.displayName||b.name;return this._proxy.$getSession(L,P,T,I,S)}async removeSession(b,T){const L=this._authenticationProviders.get(b);return L?L.provider.removeSession(T):this._proxy.$removeSession(b,T)}registerAuthenticationProvider(b,T,L,P){if(this._authenticationProviders.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this._authenticationProviders.set(b,{label:T,provider:L,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(I=>I.id===b)||this._providers.push({id:b,label:T});const S=L.onDidChangeSessions(I=>{this._proxy.$sendDidChangeSessions(b,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this._proxy.$registerAuthenticationProvider(b,T,P?.supportsMultipleAccounts??!1),new y.Disposable(()=>{S.dispose(),this._authenticationProviders.delete(b);const I=this._providers.findIndex(E=>E.id===b);I>-1&&this._providers.splice(I),this._proxy.$unregisterAuthenticationProvider(b)})}$createSession(b,T){const L=this._authenticationProviders.get(b);if(L)return Promise.resolve(L.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,T){const L=this._authenticationProviders.get(b);if(L)return Promise.resolve(L.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,T){const L=this._authenticationProviders.get(b);if(L)return Promise.resolve(L.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,T){return this._onDidChangeSessions.fire({provider:{id:b,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(ke[234],Pe([1,0,5,18,15]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(D,b){this._proxy=D.getProxy(u.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:T=>b.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(D){const b=y.WorkspaceEdit.from(D,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(b)}};e.ExtHostBulkEdits=A,e.ExtHostBulkEdits=A=je([He(0,i.IExtHostRpcService)],A)}),define(ke[235],Pe([1,0,5]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class i{constructor(A){const C=A.getProxy(u.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(D){return C.$writeText(D)}})}}e.ExtHostClipboard=i});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Ue=this&&this.__classPrivateFieldGet||function(Q,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Q):i?i.value:e.get(Q)};define(ke[37],Pe([1,0,12,7,15,24,5,16,14,62,36,50,2,6,4,18,132,23,54,51]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_,f){"use strict";var a,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(c,l){a.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,m.set(this,void 0),tt(this,a,c.getProxy(C.MainContext.MainThreadCommands),"f"),this._logService=l,tt(this,m,c.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,h=>{const p=this._apiCommands.get(h);return p?.result===s.Void?p:void 0},l),this._argumentProcessors=[{processArgument(h){return(0,T.revive)(h)}},{processArgument(h){return(0,A.cloneAndChange)(h,function(p){if(L.Range.isIRange(p))return y.Range.to(p);if(P.Position.isIPosition(p))return y.Position.to(p);if(L.Range.isIRange(p.range)&&S.URI.isUri(p.uri))return y.location.to(p);if(p instanceof g.VSBuffer)return p.buffer.buffer;if(!Array.isArray(p))return p})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const l=this.registerCommand(!1,c.id,async(...h)=>{const p=c.args.map((F,O)=>{if(!F.validate(h[O]))throw new Error(`Invalid argument '${F.name}' when running '${c.id}', received: ${h[O]}`);return F.convert(h[O])}),R=await this.executeCommand(c.internalId,...p);return c.result.convert(R,h,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new i.Disposable(()=>{l.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,l,h,p,R,F){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:h,thisArg:p,description:R,extension:F}),c&&Ue(this,a,"f").$registerCommand(l),new i.Disposable(()=>{this._commands.delete(l)&&c&&Ue(this,a,"f").$unregisterCommand(l)})}executeCommand(c,...l){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,l,!0)}async _doExecuteCommand(c,l,h){if(this._commands.has(c))return this._executeContributedCommand(c,l,!1);{let p=!1;const R=(0,A.cloneAndChange)(l,function(F){if(F instanceof i.Position)return y.Position.from(F);if(F instanceof i.Range)return y.Range.from(F);if(F instanceof i.Location)return y.location.from(F);if(i.NotebookRange.isNotebookRange(F))return y.NotebookRange.from(F);if(F instanceof ArrayBuffer)return p=!0,g.VSBuffer.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return p=!0,g.VSBuffer.wrap(F);if(F instanceof g.VSBuffer)return p=!0,F;if(!Array.isArray(F))return F});try{const F=await Ue(this,a,"f").$executeCommand(c,p?new _.SerializableObjectWithBuffers(R):R,h);return(0,T.revive)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this._doExecuteCommand(c,l,!1);throw F}}}async _executeContributedCommand(c,l,h){const p=this._commands.get(c);if(!p)throw new Error("Unknown command");this._reportTelemetry(p,c);let{callback:R,thisArg:F,description:O}=p;if(O)for(let k=0;k<O.args.length;k++)try{(0,u.validateConstraint)(l[k],O.args[k].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${O.args[k].name}' - ${O.args[k].description}`)}try{return await R.apply(F,l)}catch(k){if(c===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...l);U&&(c=U.command)}throw this._logService.error(k,c,p.extension?.identifier),h?new class extends Error{constructor(){super((0,f.toErrorMessage)(k));this.id=c,this.source=p.extension?.displayName??p.extension?.name}}:k}}_reportTelemetry(c,l){!c.extension||c.extension.isBuiltin||Ue(this,m,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:l})}$executeContributedCommand(c,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(l=l.map(h=>this._argumentProcessors.reduce((p,R)=>R.processArgument(p),h)),this._executeContributedCommand(c,l,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Ue(this,a,"f").$getCommands().then(l=>(c&&(l=l.filter(h=>h[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(let[l,h]of this._commands){let{description:p}=h;p&&(c[l]=p)}return Promise.resolve(c)}};e.ExtHostCommands=o,a=new WeakMap,m=new WeakMap,e.ExtHostCommands=o=je([He(0,v.IExtHostRpcService),He(1,b.ILogService)],o),e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class d{constructor(c,l,h){this._commands=c,this._lookupApiCommand=l,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,l){if(!c)return;const h={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return h;const p=this._lookupApiCommand(c.command);if(p)h.id=p.internalId,h.arguments=p.args.map((R,F)=>R.convert(c.arguments&&c.arguments[F]));else if((0,D.isNonEmptyArray)(c.arguments)){const R=++this._cachIdPool;this._cache.set(R,c),l.add((0,I.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),h.$ident=R,h.id=this.delegatingCommandId,h.arguments=[R],this._logService.trace("CommandsConverter#CREATE",c.command,R)}return h}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const l=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class r{constructor(c,l,h,p){this.name=c,this.description=l,this.validate=h,this.convert=p}optional(){return new r(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,l){return new r(c??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",t=>S.URI.isUri(t),t=>t),r.Position=new r("position","A position in a text document",t=>i.Position.isPosition(t),y.Position.from),r.Range=new r("range","A range in a text document",t=>i.Range.isRange(t),y.Range.from),r.Selection=new r("selection","A selection in a text document",t=>i.Selection.isSelection(t),y.Selection.from),r.Number=new r("number","",t=>typeof t=="number",t=>t),r.String=new r("string","",t=>typeof t=="string",t=>t),r.CallHierarchyItem=new r("item","A call hierarchy item",t=>t instanceof i.CallHierarchyItem,y.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",t=>t instanceof i.TypeHierarchyItem,y.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",t=>t instanceof w.TestItemImpl,y.TestItem.from);class s{constructor(c,l){this.description=c,this.convert=l}}e.ApiCommandResult=s,s.Void=new s("no result",t=>t);class n{constructor(c,l,h,p,R){this.id=c,this.internalId=l,this.description=h,this.args=p,this.result=R}}e.ApiCommand=n}),define(ke[236],Pe([1,0,2,15,7,65,37,16,112,117,10]),function(Q,e,u,i,y,A,C,D,b,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(i.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(v,w)=>{if((0,D.isFalsyOrEmpty)(v))return;class g extends y.SymbolInformation{static to(f){const a=new g(f.name,i.SymbolKind.to(f.kind),f.containerName||"",new y.Location(w[0],i.Range.to(f.range)));return a.detail=f.detail,a.range=a.location.range,a.selectionRange=i.Range.to(f.selectionRange),a.children=f.children?f.children.map(g.to):[],a}}return v.map(g.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",v=>!0,v=>v)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(i.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",v=>!0,v=>v)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(i.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",v=>typeof v=="string",v=>v),new C.ApiCommandArgument("options","Formatting options",v=>!0,v=>v)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(i.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(i.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(i.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",v=>Array.isArray(v)&&v.every(w=>y.Position.isPosition(w)),v=>v.map(i.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",v=>v.map(w=>{let g;for(const _ of w.reverse())g=new y.SelectionRange(i.Range.to(_),g);return g}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",v=>v.map(i.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",v=>v.map(i.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",v=>v.map(i.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",v=>v.map(i.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",v=>{if(!!v)return{range:i.Range.to(v.range),placeholder:v.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",v=>{if(!!v){if(v.rejectReason)throw new Error(v.rejectReason);return i.WorkspaceEdit.to(v)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",v=>v.map(i.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",v=>{if(!!v)return new y.SemanticTokensLegend(v.tokenTypes,v.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",v=>{if(!v)return;const w=(0,b.decodeSemanticTokensDto)(v);if(w.type==="full")return new y.SemanticTokens(w.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",v=>{if(!!v)return new y.SemanticTokensLegend(v.tokenTypes,v.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",v=>{if(!v)return;const w=(0,b.decodeSemanticTokensDto)(v);if(w.type==="full")return new y.SemanticTokens(w.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(v,w,g)=>{if(!v)return new y.CompletionList([]);const _=v.suggestions.map(f=>i.CompletionItem.to(f,g));return new y.CompletionList(_,v.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",v=>{if(v)return i.SignatureHelp.to(v)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(v,w,g)=>I(_=>new y.CodeLens(i.Range.to(_.range),_.command&&g.fromInternal(_.command)))(v))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",v=>y.Range.isRange(v),v=>y.Selection.isSelection(v)?i.Selection.from(v):i.Range.from(v)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(v,w,g)=>I(_=>{if(_._isSynthetic){if(!_.command)throw new Error("Synthetic code actions must have a command");return g.fromInternal(_.command)}else{const f=new y.CodeAction(_.title,_.kind?new y.CodeActionKind(_.kind):void 0);return _.edit&&(f.edit=i.WorkspaceEdit.to(_.edit)),_.command&&(f.command=g.fromInternal(_.command)),f.isPreferred=_.isPreferred,f}})(v))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",v=>v?v.map(w=>new y.ColorInformation(i.Range.to(w.range),i.Color.to(w.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",v=>v instanceof y.Color,i.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",v=>!0,v=>({uri:v.uri,range:i.Range.from(v.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",v=>v?v.map(i.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(v,w,g)=>v.map(i.InlayHint.to.bind(void 0,g)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(v=>({viewType:v.viewType,displayName:v.displayName,options:{transientOutputs:v.options.transientOutputs,transientCellMetadata:v.options.transientCellMetadata,transientDocumentMetadata:v.options.transientDocumentMetadata},filenamePattern:v.filenamePattern.map(w=>i.NotebookExclusiveDocumentPattern.to(w))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",v=>v.map(i.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",v=>u.URI.isUri(v)||typeof v=="string"&&(0,T.matchesSomeScheme)(v,L.Schemas.http,L.Schemas.https),v=>v),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",v=>v===void 0||typeof v=="number"||typeof v=="object",v=>v&&(typeof v=="number"?[i.ViewColumn.from(v),void 0]:[i.ViewColumn.from(v.viewColumn),i.TextEditorOpenOptions.from(v)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",v=>v===void 0||typeof v=="number"||typeof v=="object",v=>v&&(typeof v=="number"?[i.ViewColumn.from(v),void 0]:[i.ViewColumn.from(v.viewColumn),i.TextEditorOpenOptions.from(v)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",v=>v===void 0||typeof v=="object",v=>v&&[i.ViewColumn.from(v.viewColumn),i.TextEditorOpenOptions.from(v)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",v=>v.map(i.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",v=>v.map(i.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",v=>v.map(i.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class S{static register(w){P.forEach(w.registerApiCommand,w)}}e.ExtHostApiCommands=S;function I(v){return w=>{if(Array.isArray(w))return w.map(v)}}function E(v){if(!Array.isArray(v))return;const w=[];for(const g of v)A.isLocationLink(g)?w.push(i.DefinitionLink.to(g)):w.push(i.location.to(g));return w}}),define(ke[237],Pe([1,0,17,58,3,6,2,65,26,15,7,28,5]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function I(E,v,w){const g=E.getProxy(S.MainContext.MainThreadComments);class _{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,v.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const c=this._commentControllers.get(t.handle);return c?c.value:t}else if(t&&t.$mid===7){const c=this._commentControllers.get(t.commentControlHandle);if(!c)return t;const l=c.getCommentThread(t.commentThreadHandle);return l?l.value:t}else if(t&&t.$mid===8){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const l=c.getCommentThread(t.thread.commentThreadHandle);return l?{thread:l.value,text:t.text}:t}else if(t&&t.$mid===9){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const l=c.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;let h=t.commentUniqueId,p=l.getCommentByUniqueId(h);return p||t}else if(t&&t.$mid===10){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const l=c.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;let h=t.text,p=t.commentUniqueId,R=l.getCommentByUniqueId(p);return R?(R.body=h,R):t}return t}})}createCommentController(t,c,l){const h=_.handlePool++,p=new a(t,h,c,l);this._commentControllers.set(p.handle,p);const R=this._commentControllersByExtension.get(b.ExtensionIdentifier.toKey(t.identifier))||[];return R.push(p),this._commentControllersByExtension.set(b.ExtensionIdentifier.toKey(t.identifier),R),p.value}$createCommentThreadTemplate(t,c,l){const h=this._commentControllers.get(t);!h||h.$createCommentThreadTemplate(c,l)}async $updateCommentThreadTemplate(t,c,l){const h=this._commentControllers.get(t);!h||h.$updateCommentThreadTemplate(c,l)}$deleteCommentThread(t,c){const l=this._commentControllers.get(t);l&&l.$deleteCommentThread(c)}$provideCommentingRanges(t,c,l){const h=this._commentControllers.get(t);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const p=w.getDocument(C.URI.revive(c));return(0,u.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(p,l)).then(R=>R?R.map(F=>T.Range.from(F)):void 0)}$toggleReaction(t,c,l,h,p){const R=this._commentControllers.get(t);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,u.asPromise)(()=>{const F=R.getCommentThread(c);if(F){const O=F.getCommentByUniqueId(h.uniqueIdInThread);if(R!==void 0&&O&&R.reactionHandler)return R.reactionHandler(O,d(p))}return Promise.resolve(void 0)})}dispose(){}}_.handlePool=0;class f{set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(t,c,l,h,p,R,F,O){this._commentControllerHandle=c,this._id=l,this._uri=h,this._range=p,this._comments=R,this.extensionDescription=F,this._isTemplate=O,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),g.$createCommentThread(c,this.handle,this._id,this._uri,T.Range.from(this._range),F.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{g.$deleteCommentThread(c,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(U){k.range=U},get comments(){return k.comments},set comments(U){k.comments=U},get collapsibleState(){return k.collapsibleState},set collapsibleState(U){k.collapsibleState=U},get canReply(){return k.canReply},set canReply(U){k.canReply=U},get contextValue(){return k.contextValue},set contextValue(U){k.contextValue=U},get label(){return k.label},set label(U){k.label=U},get state(){return k.state},set state(U){k.state=U},dispose:()=>{k.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const t=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),c={};t("range")&&(c.range=T.Range.from(this._range)),t("label")&&(c.label=this.label),t("contextValue")&&(c.contextValue=this.contextValue??null),t("comments")&&(c.comments=this._comments.map(l=>m(this,l,this._commentsMap))),t("collapsibleState")&&(c.collapseState=r(this._collapseState)),t("canReply")&&(c.canReply=this.canReply),t("state")&&(c.state=s(this._state)),t("isTemplate")&&(c.isTemplate=this._isTemplate),this.modifications={},g.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(t){for(let c of this._commentsMap){let l=c[0],h=c[1];if(t===h)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}f._handlePool=0,je([(0,i.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,g.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,g.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(t,c,l,h){this._extension=t,this._handle=c,this._id=l,this._label=h,this._threads=new Map,g.$registerCommentController(this.handle,l,h);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(R){p.options=R},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(R){p.commentingRangeProvider=R},get reactionHandler(){return p.reactionHandler},set reactionHandler(R){p.reactionHandler=R},createCommentThread(R,F,O){return p.createCommentThread(R,F,O).value},dispose:()=>{p.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}createCommentThread(t,c,l,h){if(typeof t=="string"){const p=new f(this.id,this.handle,t,c,l,h,this._extension,!1);return this._threads.set(p.handle,p),p}else{const p=new f(this.id,this.handle,void 0,t,c,l,this._extension,!1);return this._threads.set(p.handle,p),p}}$createCommentThreadTemplate(t,c){const l=new f(this.id,this.handle,void 0,C.URI.revive(t),T.Range.to(c),[],this._extension,!0);return l.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(t,c){let l=this._threads.get(t);l&&(l.range=T.Range.to(c))}$deleteCommentThread(t){let c=this._threads.get(t);c&&c.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function m(n,t,c){let l=c.get(t);l||(l=++n.commentHandle,c.set(t,l));const h=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:l,body:typeof t.body=="string"?t.body:T.MarkdownString.from(t.body),userName:t.author.name,userIconPath:h,label:t.label,commentReactions:t.reactions?t.reactions.map(p=>o(p)):void 0,timestamp:t.timestamp?.toJSON()}}function o(n){return{label:n.label,iconPath:n.iconPath?T.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function d(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?C.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function r(n){if(n!==void 0)switch(n){case L.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}function s(n){if(n!==void 0)switch(n){case L.CommentThreadState.Unresolved:return D.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return D.CommentThreadState.Resolved}return D.CommentThreadState.Unresolved}return new _}e.createExtHostComments=I}),define(ke[135],Pe([1,0,2,5,7,4,18,14,16,8,9]),function(Q,e,u,i,y,A,C,D,b,T,L){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=P=class{constructor(E,v){this._logService=v,this._provider=new Map,this._proxy=E.getProxy(i.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,v){const w=P._handlePool++;this._provider.set(w,{provider:E,extensionId:v}),this._proxy.$registerDecorationProvider(w,v.value);const g=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(_=>{if(!_){this._proxy.$onDidChange(w,null);return}let f=(0,b.asArray)(_);if(f.length<=P._maxEventSize){this._proxy.$onDidChange(w,f);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",v.value,f.length);const a=f.map(d=>({uri:d,rank:(0,T.count)(d.path,"/")})),m=(0,b.groupBy)(a,(d,r)=>d.rank-r.rank||(0,T.compare)(d.uri.path,r.uri.path));let o=[];e:for(let d of m){let r;for(let s of d){let n=(0,L.dirname)(s.uri.path);if(r!==n&&(r=n,o.push(s.uri)>=P._maxEventSize))break e}}this._proxy.$onDidChange(w,o)});return new y.Disposable(()=>{g?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(E,v,w){if(!this._provider.has(E))return Object.create(null);const g=Object.create(null),{provider:_,extensionId:f}=this._provider.get(E);return await Promise.all(v.map(async a=>{try{const{uri:m,id:o}=a,d=await Promise.resolve(_.provideFileDecoration(u.URI.revive(m),w));if(!d)return;try{y.FileDecoration.validate(d),g[o]=[d.propagate,d.tooltip,d.badge,d.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${f.value}': ${r}`)}}catch(m){this._logService.error(m)}})),g}};e.ExtHostDecorations=S,S._handlePool=0,S._maxEventSize=250,e.ExtHostDecorations=S=P=je([He(0,C.IExtHostRpcService),He(1,D.ILogService)],S),e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Ue=this&&this.__classPrivateFieldGet||function(Q,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Q):i?i.value:e.get(Q)};define(ke[238],Pe([1,0,170,116,2,5,7,15,3,14,25,46]),function(Q,e,u,i,y,A,C,D,b,T,L,P){"use strict";var S,I,E,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(f,a,m,o,d,r){this._name=f,this._owner=a,this._maxDiagnosticsPerFile=m,S.set(this,void 0),I.set(this,void 0),E.set(this,void 0),this._isDisposed=!1,tt(this,E,new L.ResourceMap(s=>o.getComparisonKey(s)),"f"),tt(this,S,d,"f"),tt(this,I,r,"f")}dispose(){this._isDisposed||(Ue(this,I,"f").fire([...Ue(this,E,"f").keys()]),Ue(this,S,"f")&&Ue(this,S,"f").$clear(this._owner),Ue(this,E,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(f,a){if(!f){this.clear();return}this._checkDisposed();let m=[];if(y.URI.isUri(f)){if(!a){this.delete(f);return}Ue(this,E,"f").set(f,a.slice()),m=[f]}else if(Array.isArray(f)){m=[];let d;f=[...f].sort(w._compareIndexedTuplesByUri);for(const r of f){const[s,n]=r;if((!d||s.toString()!==d.toString())&&(d&&Ue(this,E,"f").get(d).length===0&&Ue(this,E,"f").delete(d),d=s,m.push(s),Ue(this,E,"f").set(s,[])),n){const t=Ue(this,E,"f").get(s);t&&t.push(...n)}else{const t=Ue(this,E,"f").get(s);t&&(t.length=0)}}}if(Ue(this,I,"f").fire(m),!Ue(this,S,"f"))return;const o=[];for(let d of m){let r=[];const s=Ue(this,E,"f").get(d);if(s)if(s.length>this._maxDiagnosticsPerFile){r=[];const n=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let c of s)if(c.severity===n[t]&&r.push(D.Diagnostic.from(c))===this._maxDiagnosticsPerFile)break e;r.push({severity:i.MarkerSeverity.Info,message:(0,u.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(n=>D.Diagnostic.from(n));o.push([d,r])}Ue(this,S,"f").$changeMany(this._owner,o)}delete(f){this._checkDisposed(),Ue(this,I,"f").fire([f]),Ue(this,E,"f").delete(f),Ue(this,S,"f")&&Ue(this,S,"f").$changeMany(this._owner,[[f,void 0]])}clear(){this._checkDisposed(),Ue(this,I,"f").fire([...Ue(this,E,"f").keys()]),Ue(this,E,"f").clear(),Ue(this,S,"f")&&Ue(this,S,"f").$clear(this._owner)}forEach(f,a){this._checkDisposed();for(let m of Ue(this,E,"f").keys())f.apply(a,[m,this.get(m),this])}get(f){this._checkDisposed();const a=Ue(this,E,"f").get(f);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(f){return this._checkDisposed(),Array.isArray(Ue(this,E,"f").get(f))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(f,a){return f[0].toString()<a[0].toString()?-1:f[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=w,S=new WeakMap,I=new WeakMap,E=new WeakMap;let g=v=class{static _mapper(f){const a=new L.ResourceMap;for(const m of f)a.set(m,m);return{uris:Object.freeze(Array.from(a.values()))}}constructor(f,a,m){this._logService=a,this._fileSystemInfoService=m,this._collections=new Map,this._onDidChangeDiagnostics=new b.DebounceEmitter({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this._onDidChangeDiagnostics.event,v._mapper),this._proxy=f.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(f,a){const{_collections:m,_proxy:o,_onDidChangeDiagnostics:d,_logService:r,_fileSystemInfoService:s}=this,n=new class{$changeMany(l,h){o.$changeMany(l,h),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,l,h.length===0?"CLEARING":h)}$clear(l){o.$clear(l),r.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,l)}dispose(){o.dispose()}};let t;if(!a)a="_generated_diagnostic_collection_name_#"+v._idPool++,t=a;else if(!m.has(a))t=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do t=a+v._idPool++;while(m.has(t))}return new class extends w{constructor(){super(a,t,v._maxDiagnosticsPerFile,s.extUri,n,d);m.set(t,this)}dispose(){super.dispose(),m.delete(t)}}}getDiagnostics(f){if(f)return this._getDiagnostics(f);{const a=new Map,m=[];for(const o of this._collections.values())o.forEach((d,r)=>{let s=a.get(d.toString());typeof s=="undefined"&&(s=m.length,a.set(d.toString(),s),m.push([d,[]])),m[s][1]=m[s][1].concat(...r)});return m}}_getDiagnostics(f){let a=[];for(let m of this._collections.values())m.has(f)&&(a=a.concat(m.get(f)));return a}$acceptMarkersChange(f){if(!this._mirrorCollection){const a="_generated_mirror",m=new w(a,a,v._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,m),this._mirrorCollection=m}for(const[a,m]of f)this._mirrorCollection.set(y.URI.revive(a),m.map(D.Diagnostic.to))}};e.ExtHostDiagnostics=g,g._idPool=0,g._maxDiagnosticsPerFile=1e3,e.ExtHostDiagnostics=g=v=je([He(1,T.ILogService),He(2,P.IExtHostFileSystemInfo)],g)}),define(ke[239],Pe([1,0,2,5]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(C){this._proxy=C.getProxy(i.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(D=>D?D.map(b=>u.URI.revive(b)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(D=>D?u.URI.revive(D):void 0)}}e.ExtHostDialogs=y}),define(ke[240],Pe([1,0,11,2,7,5,10,21,8]),function(Q,e,u,i,y,A,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(P,S,I){this._documentsAndEditors=S,this._logService=I,this._documentContentProviders=new Map,this._proxy=P.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,S){if(Object.keys(C.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const I=T._handlePool++;this._documentContentProviders.set(I,S),this._proxy.$registerTextContentProvider(I,P);let E;return typeof S.onDidChange=="function"&&(E=S.onDidChange(v=>{if(v.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(I,v).then(w=>{if(!w&&typeof w!="string")return;const g=this._documentsAndEditors.getDocument(v);if(!g)return;const _=(0,b.splitLines)(w);if(!g.equalLines(_))return this._proxy.$onVirtualDocumentChange(v,w)},u.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(I)&&this._proxy.$unregisterTextContentProvider(I),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(P,S){const I=this._documentContentProviders.get(P);return I?Promise.resolve(I.provideTextDocumentContent(i.URI.revive(S),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${S.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(ke[241],Pe([1,0,3,6,2,5,125,15,12,24,7]),function(Q,e,u,i,y,A,C,D,b,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(I,E){this._onDidAddDocument=new u.Emitter,this._onDidRemoveDocument=new u.Emitter,this._onDidChangeDocument=new u.Emitter,this._onDidSaveDocument=new u.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new i.DisposableStore,this._documentLoader=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=E,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const w of v)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const w of v)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(I){if(!I)return;const E=this._documentsAndEditors.getDocument(I);if(E)return E}getDocument(I){const E=this.getDocumentData(I);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return E.document}ensureDocumentData(I){const E=this._documentsAndEditors.getDocument(I);if(E)return Promise.resolve(E);let v=this._documentLoader.get(I.toString());return v||(v=this._proxy.$tryOpenDocument(I).then(w=>{this._documentLoader.delete(I.toString());const g=y.URI.revive(w);return(0,b.assertIsDefined)(this._documentsAndEditors.getDocument(g))},w=>(this._documentLoader.delete(I.toString()),Promise.reject(w))),this._documentLoader.set(I.toString(),v)),v}createDocumentData(I){return this._proxy.$tryCreateDocument(I).then(E=>y.URI.revive(E))}$acceptModelLanguageChanged(I,E){const v=y.URI.revive(I),w=this._documentsAndEditors.getDocument(v);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(E),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(I){const E=y.URI.revive(I),v=this._documentsAndEditors.getDocument(E);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(I,E){const v=y.URI.revive(I),w=this._documentsAndEditors.getDocument(v);if(!w)throw new Error("unknown document");w._acceptIsDirty(E),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,E,v){const w=y.URI.revive(I),g=this._documentsAndEditors.getDocument(w);if(!g)throw new Error("unknown document");g._acceptIsDirty(v),g.onEvents(E);let _;E.isUndoing?_=L.TextDocumentChangeReason.Undo:E.isRedoing&&(_=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:g.document,contentChanges:E.changes.map(f=>({range:D.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:_}))}setWordDefinitionFor(I,E){(0,C.setWordDefinitionFor)(I,E)}}e.ExtHostDocuments=P}),define(ke[55],Pe([1,0,57,3,6,2,4,5,125,18,133,15,14,25,10,60,80]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class g{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(a,m){this._extHostRpc=a,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new I.ResourceMap,this._onDidAddDocuments=new i.Emitter,this._onDidRemoveDocuments=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const m=[],o=[],d=[];if(a.removedDocuments)for(const r of a.removedDocuments){const s=A.URI.revive(r),n=this._documents.get(s);n?.unref()&&(this._documents.delete(s),m.push(n.value))}if(a.addedDocuments)for(const r of a.addedDocuments){const s=A.URI.revive(r.uri);let n=this._documents.get(s);if(n&&s.scheme!==E.Schemas.vscodeNotebookCell&&s.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);n||(n=new g(new b.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(s,n),o.push(n.value)),n.ref()}if(a.removedEditors)for(const r of a.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&d.push(s)}if(a.addedEditors)for(const r of a.addedEditors){const s=A.URI.revive(r.documentUri);u.ok(this._documents.has(s),`document '${s}' does not exist`),u.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const n=this._documents.get(s).value,t=new L.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>n.document),r.selections.map(P.Selection.to),r.options,r.visibleRanges.map(c=>P.Range.to(c)),typeof r.editorPosition=="number"?P.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,t)}a.newActiveEditor!==void 0&&(u.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,y.dispose)(m),(0,y.dispose)(d),a.removedDocuments&&this._onDidRemoveDocuments.fire(m),a.addedDocuments&&this._onDidAddDocuments.fire(o),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return a?m:m?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=_,e.ExtHostDocumentsAndEditors=_=je([He(0,T.IExtHostRpcService),He(1,S.ILogService)],_),e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(ke[56],Pe([1,0,15,5,2,3,4,7,18,12,48]),function(Q,e,u,i,y,A,C,D,b,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class P{constructor(w,g,_){this._activeTabIdGetter=_,this._parentGroup=g,this.acceptDtoUpdate(w)}get apiObject(){if(!this._apiObject){const w=this,g={get isActive(){return w._dto.id===w._activeTabIdGetter()},get label(){return w._dto.label},get input(){return w._input},get isDirty(){return w._dto.isDirty},get isPinned(){return w._dto.isPinned},get isPreview(){return w._dto.isPreview},get group(){return w._parentGroup.apiObject}};this._apiObject=Object.freeze(g)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(w){this._dto=w,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new D.TextTabInput(y.URI.revive(this._dto.input.uri));case 2:return new D.TextDiffTabInput(y.URI.revive(this._dto.input.original),y.URI.revive(this._dto.input.modified));case 5:return new D.CustomEditorTabInput(y.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 6:return new D.WebviewEditorTabInput(this._dto.input.viewType);case 3:return new D.NotebookEditorTabInput(y.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 4:return new D.NotebookDiffEditorTabInput(y.URI.revive(this._dto.input.original),y.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 7:return new D.TerminalEditorTabInput;default:return}}}class S{constructor(w,g,_){this._tabs=[],this._activeTabId="",this._dto=w,this._activeGroupIdGetter=_;for(const f of w.tabs)f.isActive&&(this._activeTabId=f.id),this._tabs.push(new P(f,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const w=this,g={get isActive(){return w._dto.groupId===w._activeGroupIdGetter()},get viewColumn(){return u.ViewColumn.to(w._dto.viewColumn)},get activeTab(){return w._tabs.find(_=>_.tabId===w._activeTabId)?.apiObject},get tabs(){return Object.freeze(w._tabs.map(_=>_.apiObject))}};this._apiObject=Object.freeze(g)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(w){this._dto=w}acceptTabOperation(w){if(w.kind===0){const _=new P(w.tabDto,this,()=>this.activeTabId());return this._tabs.splice(w.index,0,_),w.tabDto.isActive&&(this._activeTabId=_.tabId),_}else if(w.kind===1){const _=this._tabs.splice(w.index,1)[0];if(!_)throw new Error(`Tab close updated received for index ${w.index} which does not exist`);return _.tabId===this._activeTabId&&(this._activeTabId=""),_}else if(w.kind===3){if(w.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const _=this._tabs.splice(w.oldIndex,1)[0];if(!_)throw new Error(`Tab move updated received for index ${w.oldIndex} which does not exist`);return this._tabs.splice(w.index,0,_),_}const g=this._tabs.find(_=>_.tabId===w.tabDto.id);if(!g)throw new Error("INVALID tab");return w.tabDto.isActive?this._activeTabId=w.tabDto.id:this._activeTabId===w.tabDto.id&&!w.tabDto.isActive&&(this._activeTabId=""),g.acceptDtoUpdate(w.tabDto),g}activeTabId(){return this._activeTabId}}let I=class{constructor(w){this._onDidChangeTabs=new A.Emitter,this._onDidChangeTabGroups=new A.Emitter,this._extHostTabGroups=[],this._proxy=w.getProxy(i.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const w=this,g={onDidChangeTabGroups:w._onDidChangeTabGroups.event,onDidChangeTabs:w._onDidChangeTabs.event,get all(){return Object.freeze(w._extHostTabGroups.map(_=>_.apiObject))},get activeTabGroup(){const _=w._activeGroupId;return(0,T.assertIsDefined)(w._extHostTabGroups.find(a=>a.groupId===_)?.apiObject)},close:async(_,f)=>{const a=Array.isArray(_)?_:[_];return a.length?E(a[0])?this._closeGroups(a,f):this._closeTabs(a,f):!0}};this._apiObject=Object.freeze(g)}return this._apiObject}$acceptEditorTabModel(w){const g=new Set(this._extHostTabGroups.map(r=>r.groupId)),_=new Set(w.map(r=>r.groupId)),f=(0,L.diffSets)(g,_),a=this._extHostTabGroups.filter(r=>f.removed.includes(r.groupId)).map(r=>r.apiObject),m=[],o=[];this._extHostTabGroups=w.map(r=>{const s=new S(r,this._proxy,()=>this._activeGroupId);return f.added.includes(s.groupId)?m.push(s.apiObject):o.push(s.apiObject),s});const d=(0,T.assertIsDefined)(w.find(r=>r.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:m,closed:a,changed:o}))}$acceptTabGroupUpdate(w){const g=this._extHostTabGroups.find(_=>_.groupId===w.groupId);if(!g)throw new Error("Update Group IPC call received before group creation.");g.acceptGroupDtoUpdate(w),w.isActive&&(this._activeGroupId=w.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[g.apiObject],opened:[],closed:[]}))}$acceptTabOperation(w){const g=this._extHostTabGroups.find(f=>f.groupId===w.groupId);if(!g)throw new Error("Update Tabs IPC call received before group creation.");const _=g.acceptTabOperation(w);switch(w.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[_.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[_.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[_.apiObject]}));return}}_findExtHostTabFromApi(w){for(const g of this._extHostTabGroups)for(const _ of g.tabs)if(_.apiObject===w)return _}_findExtHostTabGroupFromApi(w){return this._extHostTabGroups.find(g=>g.apiObject===w)}async _closeTabs(w,g){const _=[];for(const f of w){const a=this._findExtHostTabFromApi(f);if(!a)throw new Error("Tab close: Invalid tab not found!");_.push(a.tabId)}return this._proxy.$closeTab(_,g)}async _closeGroups(w,g){const _=[];for(const f of w){const a=this._findExtHostTabGroupFromApi(f);if(!a)throw new Error("Group close: Invalid group not found!");_.push(a.groupId)}return this._proxy.$closeGroup(_,g)}};e.ExtHostEditorTabs=I,e.ExtHostEditorTabs=I=je([He(0,b.IExtHostRpcService)],I);function E(v){return v.tabs!==void 0}}),define(ke[242],Pe([1,0,2,5,6,7,15,153,8,23,28]),function(Q,e,u,i,y,A,C,D,b,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this._schemes=[]}add(E){this._stateMachine=void 0,this._schemes.push(E)}delete(E){const v=this._schemes.indexOf(E);v>=0&&(this._schemes.splice(v,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const E=this._schemes.sort(),v=[];let w,g,_=14,f=14;for(const a of E){let m=w?(0,b.commonPrefixLength)(w,a):0;for(m===0?g=1:g=f;m<a.length;m++)m+1===a.length?(_=f,f=9):f+=1,v.push([g,a.toUpperCase().charCodeAt(m),f]),v.push([g,a.toLowerCase().charCodeAt(m),f]),g=f;w=a,f=_}v.push([9,58,10]),v.push([10,47,12]),this._stateMachine=new D.StateMachine(v)}}provideDocumentLinks(E){this._initStateMachine();const v=[],w=D.LinkComputer.computeLinks({getLineContent(g){return E.lineAt(g-1).text},getLineCount(){return E.lineCount}},this._stateMachine);for(const g of w){const _=C.DocumentLink.to(g);_.target&&v.push(_)}return v}}class S{constructor(E,v){this._extHostLanguageFeatures=v,this._linkProvider=new P,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=E.getProxy(i.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(E,v,w,g={}){if(this._registeredSchemes.has(v))throw new Error(`a provider for the scheme '${v}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(E,"*",this._linkProvider));const _=this._handlePool++;this._linkProvider.add(v),this._registeredSchemes.add(v),this._fsProvider.set(_,w);let f=2;g.isCaseSensitive&&(f+=1024),g.isReadonly&&(f+=2048),typeof w.copy=="function"&&(f+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&((0,L.checkProposedApiEnabled)(E,"fsChunks"),f+=4),this._proxy.$registerFileSystemProvider(_,v,f).catch(m=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${v}`),console.error(m)});const a=w.onDidChangeFile(m=>{const o=[];for(const d of m){let{uri:r,type:s}=d;if(r.scheme!==v)continue;let n;switch(s){case A.FileChangeType.Changed:n=0;break;case A.FileChangeType.Created:n=1;break;case A.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:r,type:n})}this._proxy.$onFileSystemChange(_,o)});return(0,y.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(v),this._registeredSchemes.delete(v),this._fsProvider.delete(_),this._proxy.$unregisterProvider(_)})}static _asIStat(E){const{type:v,ctime:w,mtime:g,size:_,permissions:f}=E;return{type:v,ctime:w,mtime:g,size:_,permissions:f}}$stat(E,v){return Promise.resolve(this._getFsProvider(E).stat(u.URI.revive(v))).then(w=>S._asIStat(w))}$readdir(E,v){return Promise.resolve(this._getFsProvider(E).readDirectory(u.URI.revive(v)))}$readFile(E,v){return Promise.resolve(this._getFsProvider(E).readFile(u.URI.revive(v))).then(w=>T.VSBuffer.wrap(w))}$writeFile(E,v,w,g){return Promise.resolve(this._getFsProvider(E).writeFile(u.URI.revive(v),w.buffer,g))}$delete(E,v,w){return Promise.resolve(this._getFsProvider(E).delete(u.URI.revive(v),w))}$rename(E,v,w,g){return Promise.resolve(this._getFsProvider(E).rename(u.URI.revive(v),u.URI.revive(w),g))}$copy(E,v,w,g){const _=this._getFsProvider(E);if(!_.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(_.copy(u.URI.revive(v),u.URI.revive(w),g))}$mkdir(E,v){return Promise.resolve(this._getFsProvider(E).createDirectory(u.URI.revive(v)))}$watch(E,v,w,g){const _=this._getFsProvider(E).watch(u.URI.revive(w),g);this._watches.set(v,_)}$unwatch(E,v){const w=this._watches.get(v);w&&(w.dispose(),this._watches.delete(v))}$open(E,v,w){const g=this._getFsProvider(E);if(!g.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(g.open(u.URI.revive(v),w))}$close(E,v){const w=this._getFsProvider(E);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(v))}$read(E,v,w,g){const _=this._getFsProvider(E);if(!_.read)throw new Error('FileSystemProvider does not implement "read"');const f=T.VSBuffer.alloc(g);return Promise.resolve(_.read(v,w,f.buffer,0,g)).then(a=>f.slice(0,a))}$write(E,v,w,g){const _=this._getFsProvider(E);if(!_.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(_.write(v,w,g.buffer,0,g.byteLength))}_getFsProvider(E){const v=this._fsProvider.get(E);if(!v){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return v}}e.ExtHostFileSystem=S}),define(ke[70],Pe([1,0,5,43,7,23,4,18,46,6]),function(Q,e,u,i,y,A,C,D,b,T){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=L=class{constructor(I,E){this._fileSystemProvider=new Map,this._proxy=I.getProxy(u.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(w){try{const g=v._fileSystemProvider.get(w.scheme);if(!g)return await v._proxy.$stat(w);await v._proxy.$ensureActivation(w.scheme);const _=await g.stat(w);return{type:_.type,ctime:_.ctime,mtime:_.mtime,size:_.size,permissions:_.permissions}}catch(g){L._handleError(g)}},async readDirectory(w){try{const g=v._fileSystemProvider.get(w.scheme);return g?(await v._proxy.$ensureActivation(w.scheme),(await g.readDirectory(w)).slice()):await v._proxy.$readdir(w)}catch(g){return L._handleError(g)}},async createDirectory(w){try{return await v._proxy.$mkdir(w)}catch(g){return L._handleError(g)}},async readFile(w){try{const g=v._fileSystemProvider.get(w.scheme);return g?(await v._proxy.$ensureActivation(w.scheme),(await g.readFile(w)).slice()):(await v._proxy.$readFile(w)).buffer}catch(g){return L._handleError(g)}},async writeFile(w,g){try{return await v._proxy.$writeFile(w,A.VSBuffer.wrap(g))}catch(_){return L._handleError(_)}},async delete(w,g){try{const _=v._fileSystemProvider.get(w.scheme);return _?(await v._proxy.$ensureActivation(w.scheme),await _.delete(w,{recursive:!1,...g})):await v._proxy.$delete(w,{recursive:!1,useTrash:!1,...g})}catch(_){return L._handleError(_)}},async rename(w,g,_){try{return await v._proxy.$rename(w,g,{overwrite:!1,..._})}catch(f){return L._handleError(f)}},async copy(w,g,_){try{return await v._proxy.$copy(w,g,{overwrite:!1,..._})}catch(f){return L._handleError(f)}},isWritableFileSystem(w){const g=E.getCapabilities(w);if(typeof g=="number")return!(g&2048)}})}static _handleError(I){if(I instanceof y.FileSystemError)throw I;if(!(I instanceof Error))throw new y.FileSystemError(String(I));if(I.name==="ENOPRO")throw y.FileSystemError.Unavailable(I.message);switch(I.name){case i.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(I.message);case i.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(I.message);case i.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(I.message);case i.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(I.message);case i.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(I.message);case i.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(I.message);default:throw new y.FileSystemError(I.message,I.name)}}addFileSystemProvider(I,E){return this._fileSystemProvider.set(I,E),(0,T.toDisposable)(()=>this._fileSystemProvider.delete(I))}};e.ExtHostConsumerFileSystem=P,e.ExtHostConsumerFileSystem=P=L=je([He(0,D.IExtHostRpcService),He(1,b.IExtHostFileSystemInfo)],P),e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(ke[243],Pe([1,0,3,34,2,5,15,7]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class b{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(P,S,I,E,v,w,g,_){this._onDidCreate=new u.Emitter,this._onDidChange=new u.Emitter,this._onDidDelete=new u.Emitter;const f=this.ensureWatching(P,I,v);this._config=0,w&&(this._config+=1),g&&(this._config+=2),_&&(this._config+=4);const a=(0,i.parse)(v),m=typeof v=="string",o=E(d=>{if(!w)for(let r of d.created){const s=y.URI.revive(r);a(s.fsPath)&&(!m||S.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!g)for(let r of d.changed){const s=y.URI.revive(r);a(s.fsPath)&&(!m||S.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!_)for(let r of d.deleted){const s=y.URI.revive(r);a(s.fsPath)&&(!m||S.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=D.Disposable.from(f,this._onDidCreate,this._onDidChange,this._onDidDelete,o)}ensureWatching(P,S,I){let E=D.Disposable.from();if(typeof I=="string")return E;const v=P.getProxy(A.MainContext.MainThreadFileSystem);let w=!1;(I.pattern.includes(i.GLOBSTAR)||I.pattern.includes(i.GLOB_SPLIT))&&(w=!0);const g=Math.random();return v.$watch(S.identifier.value,g,I.baseUri,{recursive:w,excludes:[]}),D.Disposable.from({dispose:()=>v.$unwatch(g)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class T{constructor(P,S,I){this._mainContext=P,this._logService=S,this._extHostDocumentsAndEditors=I,this._onFileSystemEvent=new u.Emitter,this._onDidRenameFile=new u.Emitter,this._onDidCreateFile=new u.Emitter,this._onDidDeleteFile=new u.Emitter,this._onWillRenameFile=new u.AsyncEmitter,this._onWillCreateFile=new u.AsyncEmitter,this._onWillDeleteFile=new u.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,S,I,E,v,w){return new b(this._mainContext,P,S,this._onFileSystemEvent.event,C.GlobPattern.from(I),E,v,w)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,S){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:S.map(I=>({oldUri:y.URI.revive(I.source),newUri:y.URI.revive(I.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:S.map(I=>y.URI.revive(I.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:S.map(I=>y.URI.revive(I.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,S){return(I,E,v)=>{const w=function(_){I.call(E,_)};return w.extension=P,S.event(w,void 0,v)}}async $onWillRunFileOperation(P,S,I,E){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:S.map(v=>({oldUri:y.URI.revive(v.source),newUri:y.URI.revive(v.target)}))},I,E);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:S.map(v=>y.URI.revive(v.target))},I,E);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:S.map(v=>y.URI.revive(v.target))},I,E)}}async _fireWillEvent(P,S,I,E){const v=new Set,w=[];if(await P.fireAsync(S,E,async(_,f)=>{const a=Date.now(),m=await Promise.resolve(_);m instanceof D.WorkspaceEdit&&(w.push(m),v.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-a>I&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),E.isCancellationRequested||w.length===0)return;const g={edits:[]};for(let _ of w){let{edits:f}=C.WorkspaceEdit.from(_,{getTextDocumentVersion:a=>this._extHostDocumentsAndEditors.getDocument(a)?.version,getNotebookDocumentVersion:()=>{}});g.edits=g.edits.concat(f)}return{edit:g,extensionNames:Array.from(v)}}}e.ExtHostFileSystemEventService=T}),define(ke[244],Pe([1,0,2,37]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(C,D,b,T){this._extHostNotebooks=D,this._textDocumentsAndEditors=b,this._commands=T;const L=new i.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new i.ApiCommandArgument("showOptions","Show Options",P=>!0,P=>P),new i.ApiCommandArgument("resource","Interactive resource Uri",P=>!0,P=>P),new i.ApiCommandArgument("controllerId","Notebook controller Id",P=>!0,P=>P),new i.ApiCommandArgument("title","Interactive editor title",P=>!0,P=>P)],new i.ApiCommandResult("Notebook and input URI",P=>{if(P.notebookEditorId!==void 0){const S=this._extHostNotebooks.getEditorById(P.notebookEditorId);return{notebookUri:u.URI.revive(P.notebookUri),inputUri:u.URI.revive(P.inputUri),notebookEditor:S.apiEditor}}return{notebookUri:u.URI.revive(P.notebookUri),inputUri:u.URI.revive(P.inputUri)}}));this._commands.registerApiCommand(L)}$willAddInteractiveDocument(C,D,b,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:D,lines:[""],languageId:b,uri:C,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(u.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=y}),define(ke[245],Pe([1,0,6,5]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(C){this._handlePool=0,this._proxy=C.getProxy(i.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,C),(0,u.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=y}),define(ke[246],Pe([1,0,2,24,15,7,65,5,8,36,16,12,148,21,6,112,79,88,49,11,17,28]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_,f,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(M,x){this._documents=M,this._provider=x}async provideDocumentSymbols(M,x){const G=this._documents.getDocument(M),X=await this._provider.provideDocumentSymbols(G,x);if(!(0,L.isFalsyOrEmpty)(X))return X[0]instanceof A.DocumentSymbol?X.map(y.DocumentSymbol.from):o._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(M){M=M.slice(0).sort((X,de)=>{let Ee=X.location.range.start.compareTo(de.location.range.start);return Ee===0&&(Ee=de.location.range.end.compareTo(X.location.range.end)),Ee});const x=[],G=[];for(const X of M){const de={name:X.name||"!!MISSING: name!!",kind:y.SymbolKind.from(X.kind),tags:X.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:y.Range.from(X.location.range),selectionRange:y.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(de),x.push(de);break}const Ee=G[G.length-1];if(T.Range.containsRange(Ee.range,de.range)&&!T.Range.equalsRange(Ee.range,de.range)){Ee.children&&Ee.children.push(de),G.push(de);break}G.pop()}}return x}}class d{constructor(M,x,G){this._documents=M,this._commands=x,this._provider=G,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(M,x){const G=this._documents.getDocument(M),X=await this._provider.provideCodeLenses(G,x);if(!X||x.isCancellationRequested)return;const de=this._cache.add(X),Ee=new E.DisposableStore;this._disposables.set(de,Ee);const oe={cacheId:de,lenses:[]};for(let De=0;De<X.length;De++)oe.lenses.push({cacheId:[de,De],range:y.Range.from(X[De].range),command:this._commands.toInternal(X[De].command,Ee)});return oe}async resolveCodeLens(M,x){const G=M.cacheId&&this._cache.get(...M.cacheId);if(!G)return;let X;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?X=G:X=await this._provider.resolveCodeLens(G,x),X||(X=G),x.isCancellationRequested)return;const de=M.cacheId&&this._disposables.get(M.cacheId[0]);if(!!de)return M.command=this._commands.toInternal(X.command??d._badCmd,de),M}releaseCodeLenses(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function r(ee){return Array.isArray(ee)?ee.map(y.DefinitionLink.from):ee?[y.DefinitionLink.from(ee)]:[]}class s{constructor(M,x){this._documents=M,this._provider=x}async provideDefinition(M,x,G){const X=this._documents.getDocument(M),de=y.Position.to(x),Ee=await this._provider.provideDefinition(X,de,G);return r(Ee)}}class n{constructor(M,x){this._documents=M,this._provider=x}async provideDeclaration(M,x,G){const X=this._documents.getDocument(M),de=y.Position.to(x),Ee=await this._provider.provideDeclaration(X,de,G);return r(Ee)}}class t{constructor(M,x){this._documents=M,this._provider=x}async provideImplementation(M,x,G){const X=this._documents.getDocument(M),de=y.Position.to(x),Ee=await this._provider.provideImplementation(X,de,G);return r(Ee)}}class c{constructor(M,x){this._documents=M,this._provider=x}async provideTypeDefinition(M,x,G){const X=this._documents.getDocument(M),de=y.Position.to(x),Ee=await this._provider.provideTypeDefinition(X,de,G);return r(Ee)}}class l{constructor(M,x){this._documents=M,this._provider=x}async provideHover(M,x,G){const X=this._documents.getDocument(M),de=y.Position.to(x),Ee=await this._provider.provideHover(X,de,G);if(!(!Ee||(0,L.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=X.getWordRangeAtPosition(de)),Ee.range||(Ee.range=new A.Range(de,de)),y.Hover.from(Ee)}}class h{constructor(M,x){this._documents=M,this._provider=x}async provideEvaluatableExpression(M,x,G){const X=this._documents.getDocument(M),de=y.Position.to(x),Ee=await this._provider.provideEvaluatableExpression(X,de,G);if(Ee)return y.EvaluatableExpression.from(Ee)}}class p{constructor(M,x){this._documents=M,this._provider=x}async provideInlineValues(M,x,G,X){const de=this._documents.getDocument(M),Ee=await this._provider.provideInlineValues(de,y.Range.to(x),y.InlineValueContext.to(G),X);if(Array.isArray(Ee))return Ee.map(oe=>y.InlineValue.from(oe))}}class R{constructor(M,x){this._documents=M,this._provider=x}async provideDocumentHighlights(M,x,G){const X=this._documents.getDocument(M),de=y.Position.to(x),Ee=await this._provider.provideDocumentHighlights(X,de,G);if(Array.isArray(Ee))return Ee.map(y.DocumentHighlight.from)}}class F{constructor(M,x){this._documents=M,this._provider=x}async provideLinkedEditingRanges(M,x,G){const X=this._documents.getDocument(M),de=y.Position.to(x),Ee=await this._provider.provideLinkedEditingRanges(X,de,G);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,L.coalesce)(Ee.ranges.map(y.Range.from)),wordPattern:Ee.wordPattern}}}class O{constructor(M,x){this._documents=M,this._provider=x}async provideReferences(M,x,G,X){const de=this._documents.getDocument(M),Ee=y.Position.to(x),oe=await this._provider.provideReferences(de,Ee,G,X);if(Array.isArray(oe))return oe.map(y.location.from)}}class k{constructor(M,x,G,X,de,Ee,oe){this._documents=M,this._commands=x,this._diagnostics=G,this._provider=X,this._logService=de,this._extension=Ee,this._apiDeprecation=oe,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(M,x,G,X){const de=this._documents.getDocument(M),Ee=S.Selection.isISelection(x)?y.Selection.to(x):y.Range.to(x),oe=[];for(const Je of this._diagnostics.getDiagnostics(M))if(Ee.intersection(Je.range)&&oe.push(Je)>k._maxCodeActionsPerFile)break;const De={diagnostics:oe,only:G.only?new A.CodeActionKind(G.only):void 0,triggerKind:y.CodeActionTriggerKind.to(G.trigger)},ye=await this._provider.provideCodeActions(de,Ee,De,X);if(!(0,L.isNonEmptyArray)(ye)||X.isCancellationRequested)return;const ze=this._cache.add(ye),Ve=new E.DisposableStore;this._disposables.set(ze,Ve);const Me=[];for(let Je=0;Je<ye.length;Je++){const J=ye[Je];!J||(k._isCommand(J)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Me.push({_isSynthetic:!0,title:J.title,command:this._commands.toInternal(J,Ve)})):(De.only&&(J.kind?De.only.contains(J.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action is of kind '${J.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Me.push({cacheId:[ze,Je],title:J.title,command:J.command&&this._commands.toInternal(J.command,Ve),diagnostics:J.diagnostics&&J.diagnostics.map(y.Diagnostic.from),edit:J.edit&&y.WorkspaceEdit.from(J.edit),kind:J.kind&&J.kind.value,isPreferred:J.isPreferred,disabled:J.disabled?.reason})))}return{cacheId:ze,actions:Me}}async resolveCodeAction(M,x){const[G,X]=M,de=this._cache.get(G,X);if(!de||k._isCommand(de)||!this._provider.resolveCodeAction)return;const Ee=await this._provider.resolveCodeAction(de,x)??de;return Ee?.edit?y.WorkspaceEdit.from(Ee.edit):void 0}releaseCodeActions(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}static _isCommand(M){return typeof M.command=="string"&&typeof M.title=="string"}}k._maxCodeActionsPerFile=1e3;class U{constructor(M,x,G,X){this._proxy=M,this._documents=x,this._provider=G,this._handle=X}async prepareDocumentPaste(M,x,G,X){if(!this._provider.prepareDocumentPaste)return;const de=this._documents.getDocument(M),Ee=y.Range.to(x),oe=y.DataTransfer.toDataTransfer(G,()=>{throw new f.NotImplementedError});return await this._provider.prepareDocumentPaste(de,Ee,oe,X),y.DataTransfer.toDataTransferDTO(oe)}async providePasteEdits(M,x,G,X,de){const Ee=this._documents.getDocument(x),oe=y.Range.to(G),De=y.DataTransfer.toDataTransfer(X,async ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,M,ze)).buffer),ye=await this._provider.provideDocumentPasteEdits(Ee,oe,De,de);if(!!ye)return ye instanceof A.WorkspaceEdit?y.WorkspaceEdit.from(ye):y.SnippetTextEdit.from(ye)}}class B{constructor(M,x){this._documents=M,this._provider=x}async provideDocumentFormattingEdits(M,x,G){const X=this._documents.getDocument(M),de=await this._provider.provideDocumentFormattingEdits(X,x,G);if(Array.isArray(de))return de.map(y.TextEdit.from)}}class z{constructor(M,x){this._documents=M,this._provider=x}async provideDocumentRangeFormattingEdits(M,x,G,X){const de=this._documents.getDocument(M),Ee=y.Range.to(x),oe=await this._provider.provideDocumentRangeFormattingEdits(de,Ee,G,X);if(Array.isArray(oe))return oe.map(y.TextEdit.from)}}class Y{constructor(M,x){this._documents=M,this._provider=x,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,x,G,X,de){const Ee=this._documents.getDocument(M),oe=y.Position.to(x),De=await this._provider.provideOnTypeFormattingEdits(Ee,oe,G,X,de);if(Array.isArray(De))return De.map(y.TextEdit.from)}}class ${constructor(M,x){this._provider=M,this._logService=x,this._cache=new g.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(M,x){const G=await this._provider.provideWorkspaceSymbols(M,x);if(!(0,L.isNonEmptyArray)(G))return{symbols:[]};const X=this._cache.add(G),de={cacheId:X,symbols:[]};for(let Ee=0;Ee<G.length;Ee++){const oe=G[Ee];if(!oe||!oe.name){this._logService.warn("INVALID SymbolInformation",oe);continue}de.symbols.push({...y.WorkspaceSymbol.from(oe),cacheId:[X,Ee]})}return de}async resolveWorkspaceSymbol(M,x){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const G=this._cache.get(...M.cacheId);if(G){const X=await this._provider.resolveWorkspaceSymbol(G,x);return X&&(0,i.mixin)(M,y.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(M){this._cache.delete(M)}}class N{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,x,G){this._documents=M,this._provider=x,this._logService=G}async provideRenameEdits(M,x,G,X){const de=this._documents.getDocument(M),Ee=y.Position.to(x);try{const oe=await this._provider.provideRenameEdits(de,Ee,G,X);return oe?y.WorkspaceEdit.from(oe):void 0}catch(oe){const De=N._asMessage(oe);return De?{rejectReason:De,edits:void 0}:Promise.reject(oe)}}async resolveRenameLocation(M,x,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(M),de=y.Position.to(x);try{const Ee=await this._provider.prepareRename(X,de,G);let oe,De;if(A.Range.isRange(Ee)?(oe=Ee,De=X.getText(Ee)):(0,P.isObject)(Ee)&&(oe=Ee.range,De=Ee.placeholder),!oe||!De)return;if(oe.start.line>de.line||oe.end.line<de.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(oe),text:De}}catch(Ee){const oe=N._asMessage(Ee);return oe?{rejectReason:oe,range:void 0,text:void 0}:Promise.reject(Ee)}}static _asMessage(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class V{constructor(M,x){this.resultId=M,this.tokens=x}}class H{constructor(M,x){this._documents=M,this._provider=x,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(M,x,G){const X=this._documents.getDocument(M),de=x!==0?this._previousResults.get(x):null;let Ee=typeof de?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,de.resultId,G):await this._provider.provideDocumentSemanticTokens(X,G);return de&&this._previousResults.delete(x),Ee?(Ee=H._fixProvidedSemanticTokens(Ee),this._send(H._convertToEdits(de,Ee),Ee)):null}async releaseDocumentSemanticColoring(M){this._previousResults.delete(M)}static _fixProvidedSemanticTokens(M){return H._isSemanticTokens(M)?H._isCorrectSemanticTokens(M)?M:new A.SemanticTokens(new Uint32Array(M.data),M.resultId):H._isSemanticTokensEdits(M)?H._isCorrectSemanticTokensEdits(M)?M:new A.SemanticTokensEdits(M.edits.map(x=>new A.SemanticTokensEdit(x.start,x.deleteCount,x.data?new Uint32Array(x.data):x.data)),M.resultId):M}static _isSemanticTokens(M){return M&&!!M.data}static _isCorrectSemanticTokens(M){return M.data instanceof Uint32Array}static _isSemanticTokensEdits(M){return M&&Array.isArray(M.edits)}static _isCorrectSemanticTokensEdits(M){for(const x of M.edits)if(!(x.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(M,x){if(!H._isSemanticTokens(x)||!M||!M.tokens)return x;const G=M.tokens,X=G.length,de=x.data,Ee=de.length;let oe=0;const De=Math.min(X,Ee);for(;oe<De&&G[oe]===de[oe];)oe++;if(oe===X&&oe===Ee)return new A.SemanticTokensEdits([],x.resultId);let ye=0;const ze=De-oe;for(;ye<ze&&G[X-ye-1]===de[Ee-ye-1];)ye++;return new A.SemanticTokensEdits([{start:oe,deleteCount:X-oe-ye,data:de.subarray(oe,Ee-ye)}],x.resultId)}_send(M,x){if(H._isSemanticTokens(M)){const G=this._nextResultId++;return this._previousResults.set(G,new V(M.resultId,M.data)),(0,v.encodeSemanticTokensDto)({id:G,type:"full",data:M.data})}if(H._isSemanticTokensEdits(M)){const G=this._nextResultId++;return H._isSemanticTokens(x)?this._previousResults.set(G,new V(x.resultId,x.data)):this._previousResults.set(G,new V(M.resultId)),(0,v.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(M.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=H;class q{constructor(M,x){this._documents=M,this._provider=x}async provideDocumentRangeSemanticTokens(M,x,G){const X=this._documents.getDocument(M),de=await this._provider.provideDocumentRangeSemanticTokens(X,y.Range.to(x),G);return de?this._send(de):null}_send(M){return(0,v.encodeSemanticTokensDto)({id:0,type:"full",data:M.data})}}e.DocumentRangeSemanticTokensAdapter=q;class te{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,x,G,X,de){this._documents=M,this._commands=x,this._provider=G,this._apiDeprecation=X,this._extension=de,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(M,x,G,X){const de=this._documents.getDocument(M),Ee=y.Position.to(x),oe=de.getWordRangeAtPosition(Ee)||new A.Range(Ee,Ee),De=oe.with({end:Ee}),ye=new _.StopWatch(!0),ze=await this._provider.provideCompletionItems(de,Ee,X,y.CompletionContext.to(G));if(!ze||X.isCancellationRequested)return;const Ve=Array.isArray(ze)?new A.CompletionList(ze):ze,Me=te.supportsResolving(this._provider)?this._cache.add(Ve.items):this._cache.add([]),Je=new E.DisposableStore;this._disposables.set(Me,Je);const J=[],re={x:Me,b:J,a:{replace:y.Range.from(oe),insert:y.Range.from(De)},c:Ve.isIncomplete||void 0,d:ye.elapsed()};for(let Ce=0;Ce<Ve.items.length;Ce++){const ae=Ve.items[Ce],Ie=this._convertCompletionItem(ae,[Me,Ce],De,oe);J.push(Ie)}return re}async resolveCompletionItem(M,x){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...M);if(!G)return;const X=await this._provider.resolveCompletionItem(G,x);if(!!X)return this._convertCompletionItem(X,M)}releaseCompletionItems(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_convertCompletionItem(M,x,G,X){const de=this._disposables.get(x[0]);if(!de)throw Error("DisposableStore is missing...");const Ee={x,a:M.label,b:M.kind!==void 0?y.CompletionItemKind.from(M.kind):void 0,n:M.tags&&M.tags.map(y.CompletionItemTag.from),c:M.detail,d:typeof M.documentation=="undefined"?void 0:y.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters,l:M.additionalTextEdits&&M.additionalTextEdits.map(y.TextEdit.from),m:this._commands.toInternal(M.command,de)};M.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=M.textEdit.newText):typeof M.insertText=="string"?Ee.h=M.insertText:M.insertText instanceof A.SnippetString&&(Ee.h=M.insertText.value,Ee.i|=4);let oe;return M.textEdit?oe=M.textEdit.range:M.range&&(oe=M.range),A.Range.isRange(oe)?Ee.j=y.Range.from(oe):oe&&(!G?.isEqual(oe.inserting)||!X?.isEqual(oe.replacing))&&(Ee.j={insert:y.Range.from(oe.inserting),replace:y.Range.from(oe.replacing)}),Ee}}class fe{async provideInlineCompletions(M,x,G,X){}disposeCompletions(M){}handleDidShowCompletionItem(M,x){}}class ne extends fe{constructor(M,x,G,X){super();this._extension=M,this._documents=x,this._provider=G,this._commands=X,this._references=new K,this._isAdditionsProposedApiEnabled=(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[C.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(M,x,G,X){const de=this._documents.getDocument(M),Ee=y.Position.to(x),oe=await this._provider.provideInlineCompletionItems(de,Ee,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:y.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!oe||X.isCancellationRequested)return;const De=(0,P.isArray)(oe)?oe:oe.items,ye=this._isAdditionsProposedApiEnabled?(0,P.isArray)(oe)?[]:oe.commands||[]:[];let ze;return{pid:this._references.createReferenceId({dispose(){ze&&ze.dispose()},items:De}),items:De.map((Me,Je)=>{let J;Me.command&&(ze||(ze=new E.DisposableStore),J=this._commands.toInternal(Me.command,ze));const re=Me.insertText;return{insertText:typeof re=="string"?re:{snippet:re.value},filterText:Me.filterText,range:Me.range?y.Range.from(Me.range):void 0,command:J,idx:Je,completeBracketPairs:this._isAdditionsProposedApiEnabled?Me.completeBracketPairs:!1}}),commands:ye.map(Me=>(ze||(ze=new E.DisposableStore),this._commands.toInternal(Me,ze)))}}disposeCompletions(M){this._references.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,x){const G=this._references.get(M)?.items[x];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class le extends fe{constructor(M,x,G,X){super();this.extension=M,this._documents=x,this._provider=G,this._commands=X,this._references=new K,this.isAdditionProposedApiEnabled=(0,m.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[C.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKindNew.Automatic,[C.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(M,x,G,X){const de=this._documents.getDocument(M),Ee=y.Position.to(x),oe=await this._provider.provideInlineCompletionItems(de,Ee,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:y.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!oe||X.isCancellationRequested)return;const De=(0,P.isArray)(oe)?oe:oe.items,ye=(0,P.isArray)(oe)?[]:oe.commands||[];let ze;return{pid:this._references.createReferenceId({dispose(){ze&&ze.dispose()},items:De}),items:De.map((Me,Je)=>{let J;Me.command&&(ze||(ze=new E.DisposableStore),J=this._commands.toInternal(Me.command,ze));const re=Me.insertText;return{insertText:typeof re=="string"?re:{snippet:re.value},filterText:Me.filterText,range:Me.range?y.Range.from(Me.range):void 0,command:J,idx:Je,completeBracketPairs:this.isAdditionProposedApiEnabled?Me.completeBracketPairs:!1}}),commands:ye.map(Me=>(ze||(ze=new E.DisposableStore),this._commands.toInternal(Me,ze)))}}disposeCompletions(M){this._references.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,x){const G=this._references.get(M)?.items[x];G&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class K{constructor(){this._references=new Map,this._idPool=1}createReferenceId(M){const x=this._idPool++;return this._references.set(x,M),x}disposeReferenceId(M){const x=this._references.get(M);return this._references.delete(M),x}get(M){return this._references.get(M)}}class ge{constructor(M,x){this._documents=M,this._provider=x,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(M,x,G,X){const de=this._documents.getDocument(M),Ee=y.Position.to(x),oe=this.reviveContext(G),De=await this._provider.provideSignatureHelp(de,Ee,X,oe);if(De){const ye=this._cache.add([De]);return{...y.SignatureHelp.from(De),id:ye}}}reviveContext(M){let x;if(M.activeSignatureHelp){const G=y.SignatureHelp.to(M.activeSignatureHelp),X=this._cache.get(M.activeSignatureHelp.id,0);X?(x=X,x.activeSignature=G.activeSignature,x.activeParameter=G.activeParameter):x=G}return{...M,activeSignatureHelp:x}}releaseSignatureHelp(M){this._cache.delete(M)}}class ve{constructor(M,x,G,X,de){this._documents=M,this._commands=x,this._provider=G,this._logService=X,this._extension=de,this._cache=new g.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(M,x,G){const X=this._documents.getDocument(M),de=y.Range.to(x),Ee=await this._provider.provideInlayHints(X,de,G);if(!Array.isArray(Ee)||Ee.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${x}`);return}if(G.isCancellationRequested)return;const oe=this._cache.add(Ee);this._disposables.set(oe,new E.DisposableStore);const De={hints:[],cacheId:oe};for(let ye=0;ye<Ee.length;ye++)this._isValidInlayHint(Ee[ye],de)&&De.hints.push(this._convertInlayHint(Ee[ye],[oe,ye]));return this._logService.trace(`[InlayHints] ${De.hints.length} inlay hints from '${this._extension.identifier.value}' for ${x}`),De}async resolveInlayHint(M,x){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...M);if(!G)return;const X=await this._provider.resolveInlayHint(G,x);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,M)}releaseHints(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_isValidInlayHint(M,x){return M.label.length===0||Array.isArray(M.label)&&M.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(x&&!x.contains(M.position))}_convertInlayHint(M,x){const G=this._disposables.get(x[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:x,tooltip:y.MarkdownString.fromStrict(M.tooltip),position:y.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(y.TextEdit.from),kind:M.kind&&y.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?X.label=M.label:X.label=M.label.map(de=>{let Ee={label:de.value};return Ee.tooltip=y.MarkdownString.fromStrict(de.tooltip),A.Location.isLocation(de.location)&&(Ee.location=y.location.from(de.location)),de.command&&(Ee.command=this._commands.toInternal(de.command,G)),Ee}),X}}class se{constructor(M,x){this._documents=M,this._provider=x,this._cache=new g.Cache("DocumentLink")}async provideLinks(M,x){const G=this._documents.getDocument(M),X=await this._provider.provideDocumentLinks(G,x);if(!(!Array.isArray(X)||X.length===0)&&!x.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(se._validateLink).map(y.DocumentLink.from)};{const de=this._cache.add(X),Ee={links:[],cacheId:de};for(let oe=0;oe<X.length;oe++){if(!se._validateLink(X[oe]))continue;const De=y.DocumentLink.from(X[oe]);De.cacheId=[de,oe],Ee.links.push(De)}return Ee}}}static _validateLink(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,x){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...M);if(!G)return;const X=await this._provider.resolveDocumentLink(G,x);if(!(!X||!se._validateLink(X)))return y.DocumentLink.from(X)}releaseLinks(M){this._cache.delete(M)}}class be{constructor(M,x){this._documents=M,this._provider=x}async provideColors(M,x){const G=this._documents.getDocument(M),X=await this._provider.provideDocumentColors(G,x);return Array.isArray(X)?X.map(Ee=>({color:y.Color.from(Ee.color),range:y.Range.from(Ee.range)})):[]}async provideColorPresentations(M,x,G){const X=this._documents.getDocument(M),de=y.Range.to(x.range),Ee=y.Color.to(x.color),oe=await this._provider.provideColorPresentations(Ee,{document:X,range:de},G);if(!!Array.isArray(oe))return oe.map(y.ColorPresentation.from)}}class Te{constructor(M,x){this._documents=M,this._provider=x}async provideFoldingRanges(M,x,G){const X=this._documents.getDocument(M),de=await this._provider.provideFoldingRanges(X,x,G);if(!!Array.isArray(de))return de.map(y.FoldingRange.from)}}class pe{constructor(M,x,G){this._documents=M,this._provider=x,this._logService=G}async provideSelectionRanges(M,x,G){const X=this._documents.getDocument(M),de=x.map(y.Position.to),Ee=await this._provider.provideSelectionRanges(X,de,G);if(!(0,L.isNonEmptyArray)(Ee))return[];if(Ee.length!==de.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const oe=[];for(let De=0;De<de.length;De++){const ye=[];oe.push(ye);let ze=de[De],Ve=Ee[De];for(;;){if(!Ve.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(y.SelectionRange.from(Ve)),!Ve.parent)break;ze=Ve.range,Ve=Ve.parent}}return oe}}class we{constructor(M,x){this._documents=M,this._provider=x,this._idPool=new w.IdGenerator(""),this._cache=new Map}async prepareSession(M,x,G){const X=this._documents.getDocument(M),de=y.Position.to(x),Ee=await this._provider.prepareCallHierarchy(X,de,G);if(!Ee)return;const oe=this._idPool.nextId();return this._cache.set(oe,new Map),Array.isArray(Ee)?Ee.map(De=>this._cacheAndConvertItem(oe,De)):[this._cacheAndConvertItem(oe,Ee)]}async provideCallsTo(M,x,G){const X=this._itemFromCache(M,x);if(!X)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyIncomingCalls(X,G);if(!!de)return de.map(Ee=>({from:this._cacheAndConvertItem(M,Ee.from),fromRanges:Ee.fromRanges.map(oe=>y.Range.from(oe))}))}async provideCallsFrom(M,x,G){const X=this._itemFromCache(M,x);if(!X)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyOutgoingCalls(X,G);if(!!de)return de.map(Ee=>({to:this._cacheAndConvertItem(M,Ee.to),fromRanges:Ee.fromRanges.map(oe=>y.Range.from(oe))}))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,x){const G=this._cache.get(M),X=y.CallHierarchyItem.from(x,M,G.size.toString(36));return G.set(X._itemId,x),X}_itemFromCache(M,x){return this._cache.get(M)?.get(x)}}class Ae{constructor(M,x){this._documents=M,this._provider=x,this._idPool=new w.IdGenerator(""),this._cache=new Map}async prepareSession(M,x,G){const X=this._documents.getDocument(M),de=y.Position.to(x),Ee=await this._provider.prepareTypeHierarchy(X,de,G);if(!Ee)return;const oe=this._idPool.nextId();return this._cache.set(oe,new Map),Array.isArray(Ee)?Ee.map(De=>this._cacheAndConvertItem(oe,De)):[this._cacheAndConvertItem(oe,Ee)]}async provideSupertypes(M,x,G){const X=this._itemFromCache(M,x);if(!X)throw new Error("missing type hierarchy item");const de=await this._provider.provideTypeHierarchySupertypes(X,G);if(!!de)return de.map(Ee=>this._cacheAndConvertItem(M,Ee))}async provideSubtypes(M,x,G){const X=this._itemFromCache(M,x);if(!X)throw new Error("missing type hierarchy item");const de=await this._provider.provideTypeHierarchySubtypes(X,G);if(!!de)return de.map(Ee=>this._cacheAndConvertItem(M,Ee))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,x){const G=this._cache.get(M),X=y.TypeHierarchyItem.from(x,M,G.size.toString(36));return G.set(X._itemId,x),X}_itemFromCache(M,x){return this._cache.get(M)?.get(x)}}class ce{constructor(M,x,G,X){this._proxy=M,this._documents=x,this._provider=G,this._handle=X}async provideDocumentOnDropEdits(M,x,G,X,de){const Ee=this._documents.getDocument(x),oe=y.Position.to(G),De=y.DataTransfer.toDataTransfer(X,async ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,M,ze)).buffer),ye=await this._provider.provideDocumentOnDropEdits(Ee,oe,De,de);if(!!ye)return y.SnippetTextEdit.from(ye)}}class me{constructor(M,x){this.adapter=M,this.extension=x}}class ie{constructor(M,x,G,X,de,Ee,oe){this._adapter=new Map,this._uriTransformer=x,this._proxy=M.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=X,this._diagnostics=de,this._logService=Ee,this._apiDeprecation=oe}_transformDocumentSelector(M){return y.DocumentSelector.from(M,this._uriTransformer)}_createDisposable(M){return new A.Disposable(()=>{this._adapter.delete(M),this._proxy.$unregister(M)})}_nextHandle(){return ie._handlePool++}async _withAdapter(M,x,G,X,de,Ee=!1){const oe=this._adapter.get(M);if(!oe||!(oe.adapter instanceof x))return X;const De=Date.now();Ee||this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const ye=G(oe.adapter,oe.extension);return Promise.resolve(ye).catch(ze=>{(0,f.isCancellationError)(ze)||(this._logService.error(`[${oe.extension.identifier.value}] provider FAILED`),this._logService.error(ze))}).finally(()=>{Ee||this._logService.trace(`[${oe.extension.identifier.value}] provider DONE after ${Date.now()-De}ms`)}),I.CancellationToken.isCancellationToken(de)?(0,a.raceCancellationError)(ye,de):ye}_addNewAdapter(M,x){const G=this._nextHandle();return this._adapter.set(G,new me(M,x)),G}static _extLabel(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,x,G,X){const de=this._addNewAdapter(new o(this._documents,G),M),Ee=X&&X.label||ie._extLabel(M);return this._proxy.$registerDocumentSymbolProvider(de,this._transformDocumentSelector(x),Ee),this._createDisposable(de)}$provideDocumentSymbols(M,x,G){return this._withAdapter(M,o,X=>X.provideDocumentSymbols(u.URI.revive(x),G),void 0,G)}registerCodeLensProvider(M,x,G){const X=this._nextHandle(),de=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new me(new d(this._documents,this._commands.converter,G),M)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(x),de);let Ee=this._createDisposable(X);if(de!==void 0){const oe=G.onDidChangeCodeLenses(De=>this._proxy.$emitCodeLensEvent(de));Ee=A.Disposable.from(Ee,oe)}return Ee}$provideCodeLenses(M,x,G){return this._withAdapter(M,d,X=>X.provideCodeLenses(u.URI.revive(x),G),void 0,G)}$resolveCodeLens(M,x,G){return this._withAdapter(M,d,X=>X.resolveCodeLens(x,G),void 0,void 0)}$releaseCodeLenses(M,x){this._withAdapter(M,d,G=>Promise.resolve(G.releaseCodeLenses(x)),void 0,void 0)}registerDefinitionProvider(M,x,G){const X=this._addNewAdapter(new s(this._documents,G),M);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(x)),this._createDisposable(X)}$provideDefinition(M,x,G,X){return this._withAdapter(M,s,de=>de.provideDefinition(u.URI.revive(x),G,X),[],X)}registerDeclarationProvider(M,x,G){const X=this._addNewAdapter(new n(this._documents,G),M);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(x)),this._createDisposable(X)}$provideDeclaration(M,x,G,X){return this._withAdapter(M,n,de=>de.provideDeclaration(u.URI.revive(x),G,X),[],X)}registerImplementationProvider(M,x,G){const X=this._addNewAdapter(new t(this._documents,G),M);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(x)),this._createDisposable(X)}$provideImplementation(M,x,G,X){return this._withAdapter(M,t,de=>de.provideImplementation(u.URI.revive(x),G,X),[],X)}registerTypeDefinitionProvider(M,x,G){const X=this._addNewAdapter(new c(this._documents,G),M);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(x)),this._createDisposable(X)}$provideTypeDefinition(M,x,G,X){return this._withAdapter(M,c,de=>de.provideTypeDefinition(u.URI.revive(x),G,X),[],X)}registerHoverProvider(M,x,G,X){const de=this._addNewAdapter(new l(this._documents,G),M);return this._proxy.$registerHoverProvider(de,this._transformDocumentSelector(x)),this._createDisposable(de)}$provideHover(M,x,G,X){return this._withAdapter(M,l,de=>de.provideHover(u.URI.revive(x),G,X),void 0,X)}registerEvaluatableExpressionProvider(M,x,G,X){const de=this._addNewAdapter(new h(this._documents,G),M);return this._proxy.$registerEvaluatableExpressionProvider(de,this._transformDocumentSelector(x)),this._createDisposable(de)}$provideEvaluatableExpression(M,x,G,X){return this._withAdapter(M,h,de=>de.provideEvaluatableExpression(u.URI.revive(x),G,X),void 0,X)}registerInlineValuesProvider(M,x,G,X){const de=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new p(this._documents,G),M);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector(x),de);let oe=this._createDisposable(Ee);if(de!==void 0){const De=G.onDidChangeInlineValues(ye=>this._proxy.$emitInlineValuesEvent(de));oe=A.Disposable.from(oe,De)}return oe}$provideInlineValues(M,x,G,X,de){return this._withAdapter(M,p,Ee=>Ee.provideInlineValues(u.URI.revive(x),G,X,de),void 0,de)}registerDocumentHighlightProvider(M,x,G){const X=this._addNewAdapter(new R(this._documents,G),M);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(x)),this._createDisposable(X)}$provideDocumentHighlights(M,x,G,X){return this._withAdapter(M,R,de=>de.provideDocumentHighlights(u.URI.revive(x),G,X),void 0,X)}registerLinkedEditingRangeProvider(M,x,G){const X=this._addNewAdapter(new F(this._documents,G),M);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(x)),this._createDisposable(X)}$provideLinkedEditingRanges(M,x,G,X){return this._withAdapter(M,F,async de=>{const Ee=await de.provideLinkedEditingRanges(u.URI.revive(x),G,X);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?ie._serializeRegExp(Ee.wordPattern):void 0}},void 0,X)}registerReferenceProvider(M,x,G){const X=this._addNewAdapter(new O(this._documents,G),M);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(x)),this._createDisposable(X)}$provideReferences(M,x,G,X,de){return this._withAdapter(M,O,Ee=>Ee.provideReferences(u.URI.revive(x),G,X,de),void 0,de)}registerCodeActionProvider(M,x,G,X){const de=new E.DisposableStore,Ee=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,G,this._logService,M,this._apiDeprecation),M);return this._proxy.$registerQuickFixSupport(Ee,this._transformDocumentSelector(x),{providedKinds:X?.providedCodeActionKinds?.map(oe=>oe.value),documentation:X?.documentation?.map(oe=>({kind:oe.kind.value,command:this._commands.converter.toInternal(oe.command,de)}))},ie._extLabel(M),Boolean(G.resolveCodeAction)),de.add(this._createDisposable(Ee)),de}$provideCodeActions(M,x,G,X,de){return this._withAdapter(M,k,Ee=>Ee.provideCodeActions(u.URI.revive(x),G,X,de),void 0,de)}$resolveCodeAction(M,x,G){return this._withAdapter(M,k,X=>X.resolveCodeAction(x,G),void 0,void 0)}$releaseCodeActions(M,x){this._withAdapter(M,k,G=>Promise.resolve(G.releaseCodeActions(x)),void 0,void 0)}registerDocumentFormattingEditProvider(M,x,G){const X=this._addNewAdapter(new B(this._documents,G),M);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(x),M.identifier,M.displayName||M.name),this._createDisposable(X)}$provideDocumentFormattingEdits(M,x,G,X){return this._withAdapter(M,B,de=>de.provideDocumentFormattingEdits(u.URI.revive(x),G,X),void 0,X)}registerDocumentRangeFormattingEditProvider(M,x,G){const X=this._addNewAdapter(new z(this._documents,G),M);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(x),M.identifier,M.displayName||M.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(M,x,G,X,de){return this._withAdapter(M,z,Ee=>Ee.provideDocumentRangeFormattingEdits(u.URI.revive(x),G,X,de),void 0,de)}registerOnTypeFormattingEditProvider(M,x,G,X){const de=this._addNewAdapter(new Y(this._documents,G),M);return this._proxy.$registerOnTypeFormattingSupport(de,this._transformDocumentSelector(x),X,M.identifier),this._createDisposable(de)}$provideOnTypeFormattingEdits(M,x,G,X,de,Ee){return this._withAdapter(M,Y,oe=>oe.provideOnTypeFormattingEdits(u.URI.revive(x),G,X,de,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(M,x){const G=this._addNewAdapter(new $(x,this._logService),M);return this._proxy.$registerNavigateTypeSupport(G,typeof x.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(M,x,G){return this._withAdapter(M,$,X=>X.provideWorkspaceSymbols(x,G),{symbols:[]},G)}$resolveWorkspaceSymbol(M,x,G){return this._withAdapter(M,$,X=>X.resolveWorkspaceSymbol(x,G),void 0,void 0)}$releaseWorkspaceSymbols(M,x){this._withAdapter(M,$,G=>G.releaseWorkspaceSymbols(x),void 0,void 0)}registerRenameProvider(M,x,G){const X=this._addNewAdapter(new N(this._documents,G,this._logService),M);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(x),N.supportsResolving(G)),this._createDisposable(X)}$provideRenameEdits(M,x,G,X,de){return this._withAdapter(M,N,Ee=>Ee.provideRenameEdits(u.URI.revive(x),G,X,de),void 0,de)}$resolveRenameLocation(M,x,G,X){return this._withAdapter(M,N,de=>de.resolveRenameLocation(u.URI.revive(x),G,X),void 0,X)}registerDocumentSemanticTokensProvider(M,x,G,X){const de=this._addNewAdapter(new H(this._documents,G),M),Ee=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(de,this._transformDocumentSelector(x),X,Ee);let oe=this._createDisposable(de);if(Ee){const De=G.onDidChangeSemanticTokens(ye=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));oe=A.Disposable.from(oe,De)}return oe}$provideDocumentSemanticTokens(M,x,G,X){return this._withAdapter(M,H,de=>de.provideDocumentSemanticTokens(u.URI.revive(x),G,X),null,X)}$releaseDocumentSemanticTokens(M,x){this._withAdapter(M,H,G=>G.releaseDocumentSemanticColoring(x),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,x,G,X){const de=this._addNewAdapter(new q(this._documents,G),M);return this._proxy.$registerDocumentRangeSemanticTokensProvider(de,this._transformDocumentSelector(x),X),this._createDisposable(de)}$provideDocumentRangeSemanticTokens(M,x,G,X){return this._withAdapter(M,q,de=>de.provideDocumentRangeSemanticTokens(u.URI.revive(x),G,X),null,X)}registerCompletionItemProvider(M,x,G,X){const de=this._addNewAdapter(new te(this._documents,this._commands.converter,G,this._apiDeprecation,M),M);return this._proxy.$registerCompletionsProvider(de,this._transformDocumentSelector(x),X,te.supportsResolving(G),`${M.identifier.value}(${X.join("")})`),this._createDisposable(de)}$provideCompletionItems(M,x,G,X,de){return this._withAdapter(M,te,Ee=>Ee.provideCompletionItems(u.URI.revive(x),G,X,de),void 0,de)}$resolveCompletionItem(M,x,G){return this._withAdapter(M,te,X=>X.resolveCompletionItem(x,G),void 0,G)}$releaseCompletionItems(M,x){this._withAdapter(M,te,G=>G.releaseCompletionItems(x),void 0,void 0)}registerInlineCompletionsProvider(M,x,G){const X=new ne(M,this._documents,G,this._commands.converter),de=this._addNewAdapter(X,M);return this._proxy.$registerInlineCompletionsSupport(de,this._transformDocumentSelector(x),X.supportsHandleDidShowCompletionItem),this._createDisposable(de)}registerInlineCompletionsProviderNew(M,x,G){const X=this._addNewAdapter(new le(M,this._documents,G,this._commands.converter),M);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(x),!0),this._createDisposable(X)}$provideInlineCompletions(M,x,G,X,de){return this._withAdapter(M,fe,Ee=>Ee.provideInlineCompletions(u.URI.revive(x),G,X,de),void 0,de)}$handleInlineCompletionDidShow(M,x,G){this._withAdapter(M,fe,async X=>{X.handleDidShowCompletionItem(x,G)},void 0,void 0)}$freeInlineCompletionsList(M,x){this._withAdapter(M,fe,async G=>{G.disposeCompletions(x)},void 0,void 0)}registerSignatureHelpProvider(M,x,G,X){const de=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,Ee=this._addNewAdapter(new ge(this._documents,G),M);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector(x),de),this._createDisposable(Ee)}$provideSignatureHelp(M,x,G,X,de){return this._withAdapter(M,ge,Ee=>Ee.provideSignatureHelp(u.URI.revive(x),G,X,de),void 0,de)}$releaseSignatureHelp(M,x){this._withAdapter(M,ge,G=>G.releaseSignatureHelp(x),void 0,void 0)}registerInlayHintsProvider(M,x,G){const X=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new ve(this._documents,this._commands.converter,G,this._logService,M),M);this._proxy.$registerInlayHintsProvider(de,this._transformDocumentSelector(x),typeof G.resolveInlayHint=="function",X,ie._extLabel(M));let Ee=this._createDisposable(de);if(X!==void 0){const oe=G.onDidChangeInlayHints(De=>this._proxy.$emitInlayHintsEvent(X));Ee=A.Disposable.from(Ee,oe)}return Ee}$provideInlayHints(M,x,G,X){return this._withAdapter(M,ve,de=>de.provideInlayHints(u.URI.revive(x),G,X),void 0,X)}$resolveInlayHint(M,x,G){return this._withAdapter(M,ve,X=>X.resolveInlayHint(x,G),void 0,G)}$releaseInlayHints(M,x){this._withAdapter(M,ve,G=>G.releaseHints(x),void 0,void 0)}registerDocumentLinkProvider(M,x,G){const X=this._addNewAdapter(new se(this._documents,G),M);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(x),typeof G.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(M,x,G){return this._withAdapter(M,se,X=>X.provideLinks(u.URI.revive(x),G),void 0,G,x.scheme==="output")}$resolveDocumentLink(M,x,G){return this._withAdapter(M,se,X=>X.resolveLink(x,G),void 0,void 0,!0)}$releaseDocumentLinks(M,x){this._withAdapter(M,se,G=>G.releaseLinks(x),void 0,void 0,!0)}registerColorProvider(M,x,G){const X=this._addNewAdapter(new be(this._documents,G),M);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(x)),this._createDisposable(X)}$provideDocumentColors(M,x,G){return this._withAdapter(M,be,X=>X.provideColors(u.URI.revive(x),G),[],G)}$provideColorPresentations(M,x,G,X){return this._withAdapter(M,be,de=>de.provideColorPresentations(u.URI.revive(x),G,X),void 0,X)}registerFoldingRangeProvider(M,x,G){const X=this._nextHandle(),de=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new me(new Te(this._documents,G),M)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(x),de);let Ee=this._createDisposable(X);if(de!==void 0){const oe=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(de));Ee=A.Disposable.from(Ee,oe)}return Ee}$provideFoldingRanges(M,x,G,X){return this._withAdapter(M,Te,de=>de.provideFoldingRanges(u.URI.revive(x),G,X),void 0,X)}registerSelectionRangeProvider(M,x,G){const X=this._addNewAdapter(new pe(this._documents,G,this._logService),M);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(x)),this._createDisposable(X)}$provideSelectionRanges(M,x,G,X){return this._withAdapter(M,pe,de=>de.provideSelectionRanges(u.URI.revive(x),G,X),[],X)}registerCallHierarchyProvider(M,x,G){const X=this._addNewAdapter(new we(this._documents,G),M);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(x)),this._createDisposable(X)}$prepareCallHierarchy(M,x,G,X){return this._withAdapter(M,we,de=>Promise.resolve(de.prepareSession(u.URI.revive(x),G,X)),void 0,X)}$provideCallHierarchyIncomingCalls(M,x,G,X){return this._withAdapter(M,we,de=>de.provideCallsTo(x,G,X),void 0,X)}$provideCallHierarchyOutgoingCalls(M,x,G,X){return this._withAdapter(M,we,de=>de.provideCallsFrom(x,G,X),void 0,X)}$releaseCallHierarchy(M,x){this._withAdapter(M,we,G=>Promise.resolve(G.releaseSession(x)),void 0,void 0)}registerTypeHierarchyProvider(M,x,G){const X=this._addNewAdapter(new Ae(this._documents,G),M);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(x)),this._createDisposable(X)}$prepareTypeHierarchy(M,x,G,X){return this._withAdapter(M,Ae,de=>Promise.resolve(de.prepareSession(u.URI.revive(x),G,X)),void 0,X)}$provideTypeHierarchySupertypes(M,x,G,X){return this._withAdapter(M,Ae,de=>de.provideSupertypes(x,G,X),void 0,X)}$provideTypeHierarchySubtypes(M,x,G,X){return this._withAdapter(M,Ae,de=>de.provideSubtypes(x,G,X),void 0,X)}$releaseTypeHierarchy(M,x){this._withAdapter(M,Ae,G=>Promise.resolve(G.releaseSession(x)),void 0,void 0)}registerDocumentOnDropEditProvider(M,x,G){const X=this._nextHandle();return this._adapter.set(X,new me(new ce(this._proxy,this._documents,G,X),M)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(x)),this._createDisposable(X)}$provideDocumentOnDropEdits(M,x,G,X,de,Ee){return this._withAdapter(M,ce,oe=>Promise.resolve(oe.provideDocumentOnDropEdits(x,u.URI.revive(G),X,de,Ee)),void 0,void 0)}registerDocumentPasteEditProvider(M,x,G){const X=this._nextHandle();return this._adapter.set(X,new me(new U(this._proxy,this._documents,G,X),M)),this._proxy.$registerPasteEditProvider(X,this._transformDocumentSelector(x),!!G.prepareDocumentPaste),this._createDisposable(X)}$prepareDocumentPaste(M,x,G,X,de){return this._withAdapter(M,U,Ee=>Ee.prepareDocumentPaste(u.URI.revive(x),G,X,de),void 0,de)}$providePasteEdits(M,x,G,X,de){return this._withAdapter(M,U,Ee=>Ee.providePasteEdits(0,u.URI.revive(x),G,X,de),void 0,de)}static _serializeRegExp(M){return{pattern:M.source,flags:(0,b.regExpFlags)(M)}}static _serializeIndentationRule(M){return{decreaseIndentPattern:ie._serializeRegExp(M.decreaseIndentPattern),increaseIndentPattern:ie._serializeRegExp(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?ie._serializeRegExp(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?ie._serializeRegExp(M.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(M){return{beforeText:ie._serializeRegExp(M.beforeText),afterText:M.afterText?ie._serializeRegExp(M.afterText):void 0,previousLineText:M.previousLineText?ie._serializeRegExp(M.previousLineText):void 0,action:M.action}}static _serializeOnEnterRules(M){return M.map(ie._serializeOnEnterRule)}setLanguageConfiguration(M,x,G){let{wordPattern:X}=G;if(X&&(0,b.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(x,X):this._documents.setWordDefinitionFor(x,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",M,"Do not use.");const de=this._nextHandle(),Ee={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ie._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?ie._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ie._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(de,x,Ee),this._createDisposable(de)}$setWordDefinitions(M){for(const x of M)this._documents.setWordDefinitionFor(x.languageId,new RegExp(x.regexSource,x.regexFlags))}}e.ExtHostLanguageFeatures=ie,ie._handlePool=0}),define(ke[247],Pe([1,0,5,15,7,41,17,6]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class b{constructor(L,P,S,I){this._documents=P,this._commands=S,this._uriTransformer=I,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(u.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,P){await this._proxy.$changeLanguage(L,P);const S=this._documents.getDocumentData(L);if(!S)throw new Error(`document '${L.toString()}' NOT found`);return S.document}async tokenAtPosition(L,P){const S=L.version,I=i.Position.from(P),E=await this._proxy.$tokensAtPosition(L.uri,I),v={type:y.StandardTokenType.Other,range:L.getWordRangeAtPosition(P)??new y.Range(P.line,P.character,P.line,P.character)};if(!E)return v;const w={range:i.Range.to(E.range),type:i.TokenType.to(E.type)};return!w.range.contains(P)||S!==L.version?v:w}createLanguageStatusItem(L,P,S){const I=this._handlePool++,E=this._proxy,v=this._ids,w=`${L.identifier.value}/${P}`;if(v.has(w))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);v.add(w);const g={selector:S,id:P,name:L.displayName??L.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let _,f=new D.DisposableStore;const a=()=>{_?.dispose(),_=(0,C.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(I,{id:w,name:g.name??L.displayName??L.name,source:L.displayName??L.name,selector:i.DocumentSelector.from(g.selector,this._uriTransformer),label:g.text,detail:g.detail??"",severity:g.severity===y.LanguageStatusSeverity.Error?A.default.Error:g.severity===y.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:g.command&&this._commands.toInternal(g.command,f),accessibilityInfo:g.accessibilityInformation,busy:g.busy})},0)},m={dispose(){f.dispose(),_?.dispose(),E.$removeLanguageStatus(I),v.delete(w)},get id(){return g.id},get name(){return g.name},set name(o){g.name=o,a()},get selector(){return g.selector},set selector(o){g.selector=o,a()},get text(){return g.text},set text(o){g.text=o,a()},get detail(){return g.detail},set detail(o){g.detail=o,a()},get severity(){return g.severity},set severity(o){g.severity=o,a()},get accessibilityInformation(){return g.accessibilityInformation},set accessibilityInformation(o){g.accessibilityInformation=o,a()},get command(){return g.command},set command(o){g.command=o,a()},get busy(){return g.busy},set busy(o){g.busy=o,a()}};return a(),m}}e.ExtHostLanguages=b}),define(ke[136],Pe([1,0,14,5,27,18,3]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends u.AbstractLoggerService{constructor(L,P){const S=new C.Emitter;super(P.logLevel,S.event);this._proxy=L.getProxy(i.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(S)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,P,S){return new b(this._proxy,L,P,S)}};e.ExtHostLoggerService=D,e.ExtHostLoggerService=D=je([He(0,A.IExtHostRpcService),He(1,y.IExtHostInitDataService)],D);class b extends u.AbstractMessageLogger{constructor(L,P,S,I){super(I?.always);this.proxy=L,this.file=P,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.proxy.$createLogger(P,I).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,P){const S=[[L,P]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(L){this.proxy.$log(this.file,L)}}}),define(ke[248],Pe([1,0,5,14,28]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(D){return D&&D.title}let C=class{constructor(b,T){this._logService=T,this._proxy=b.getProxy(u.MainContext.MainThreadMessageService)}showMessage(b,T,L,P,S){const I={source:{identifier:b.identifier,label:b.displayName||b.name}};let E;typeof P=="string"||A(P)?E=[P,...S]:(I.modal=P?.modal,I.useCustom=P?.useCustom,I.detail=P?.detail,E=S),I.useCustom&&(0,y.checkProposedApiEnabled)(b,"resolvers");const v=[];for(let w=0;w<E.length;w++){const g=E[w];if(typeof g=="string")v.push({title:g,handle:w,isCloseAffordance:!1});else if(typeof g=="object"){let{title:_,isCloseAffordance:f}=g;v.push({title:_,isCloseAffordance:!!f,handle:w})}else this._logService.warn("Invalid message item:",g)}return this._proxy.$showMessage(T,L,I,v).then(w=>{if(typeof w=="number")return E[w]})}};e.ExtHostMessageService=C,e.ExtHostMessageService=C=je([He(1,i.ILogService)],C)}),define(ke[249],Pe([1,0,23,3,61,6,25,8,12,2,88,5,37,15,7,54,222,131]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class _{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}constructor(a,m,o,d,r){this._textDocumentsAndEditors=o,this._textDocuments=d,this._extensionStoragePaths=r,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new i.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new i.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new i.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new i.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=m.converter,m.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const n=s.notebookEditor?.notebookUri,t=s.cell.handle,l=this._documents.get(n)?.getCell(t);if(l)return l.apiCell}return s}}),_._registerApiCommands(m)}getEditorById(a){const m=this._editors.get(a);if(!m)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return m}getIdByEditor(a){for(const[m,o]of this._editors)if(o.apiEditor===a)return m}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,m){const o=this._documents.get(a);if(!o&&!m)throw new Error(`NO notebook document for '${a}'`);return o}_getProviderData(a){const m=this._notebookContentProviders.get(a);if(!m)throw new Error(`NO provider for '${a}'`);return m}registerNotebookContentProvider(a,m,o,d,r){if((0,D.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(m))throw new Error(`Notebook provider for '${m}' already registered`);this._notebookContentProviders.set(m,{extension:a,provider:o});let s;return o.onDidChangeNotebookContentOptions&&(s=o.onDidChangeNotebookContentOptions(()=>{const n=I.NotebookDocumentContentOptions.from(o.options);this._notebookProxy.$updateNotebookProviderOptions(m,n)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},m,I.NotebookDocumentContentOptions.from(d),_._convertNotebookRegistrationData(a,r)),new E.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(m),this._notebookProxy.$unregisterNotebookProvider(m)})}static _convertNotebookRegistrationData(a,m){if(!m)return;const o=m.filenamePattern.map(d=>I.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(m.filenamePattern&&!o){console.warn(`Notebook content provider view options file name pattern is invalid ${m.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:m.displayName,filenamePattern:o,exclusive:m.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,m,o){const d=_._notebookStatusBarItemProviderHandlePool++,r=typeof o.onDidChangeCellStatusBarItems=="function"?_._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(d,o),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(d,r,m);let s;return r!==void 0&&(s=o.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(r))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(d),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(d,r),s&&s.dispose()})}async createNotebookDocument(a){const m=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&I.NotebookData.from(a.content)});return T.URI.revive(m)}async openNotebookDocument(a){const m=this._documents.get(a);if(m)return m.apiNotebook;const o=await this._notebookDocumentsProxy.$tryOpenNotebook(a),d=this._documents.get(T.URI.revive(o));return(0,b.assertIsDefined)(d?.apiNotebook)}async showNotebookDocument(a,m){T.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let o;typeof m=="object"?o={position:I.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selections:m.selections&&m.selections.map(I.NotebookRange.from),pinned:typeof m.preview=="boolean"?!m.preview:void 0}:o={preserveFocus:!1};const d=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,o),r=d&&this._editors.get(d)?.apiEditor;if(r)return r;throw d?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,m,o,d){const r=this._notebookStatusBarItemProviders.get(a),s=T.URI.revive(m),n=this._documents.get(s);if(!n||!r)return;const t=n.getCellFromIndex(o);if(!t)return;const c=await r.provideCellStatusBarItems(t.apiCell,d);if(!c)return;const l=new A.DisposableStore,h=this._statusBarCache.add([l]),R=(Array.isArray(c)?c:[c]).map(F=>I.NotebookStatusBarItem.from(F,this._commandsConverter,l));return{cacheId:h,items:R}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,m,o,d,r){if((0,D.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,o),this._notebookProxy.$registerNotebookSerializer(s,{id:a.identifier,location:a.extensionLocation},m,I.NotebookDocumentContentOptions.from(d),_._convertNotebookRegistrationData(a,r)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(a,m,o){const d=this._notebookSerializer.get(a);if(!d)throw new Error("NO serializer found");const r=await d.deserializeNotebook(m.buffer,o);return new v.SerializableObjectWithBuffers(I.NotebookData.from(r))}async $notebookToData(a,m,o){const d=this._notebookSerializer.get(a);if(!d)throw new Error("NO serializer found");const r=await d.serializeNotebook(I.NotebookData.to(m.value),o);return u.VSBuffer.wrap(r)}async $openNotebook(a,m,o,d,r){const{provider:s}=this._getProviderData(a),n=await s.openNotebook(T.URI.revive(m),{backupId:o,untitledDocumentData:d?.buffer},r);return new v.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(I.NotebookCellData.from)})}async $saveNotebook(a,m,o){const d=this.getNotebookDocument(T.URI.revive(m)),{provider:r}=this._getProviderData(a);return await r.saveNotebook(d.apiNotebook,o),!0}async $saveNotebookAs(a,m,o,d){const r=this.getNotebookDocument(T.URI.revive(m)),{provider:s}=this._getProviderData(a);return await s.saveNotebookAs(T.URI.revive(o),r.apiNotebook,d),!0}async $backupNotebook(a,m,o){const d=this.getNotebookDocument(T.URI.revive(m)),r=this._getProviderData(a),s=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension),n=String((0,y.hash)([d.uri.toString(),this._backupIdPool++])),t=T.URI.joinPath(s,n),c=await r.provider.backupNotebook(d.apiNotebook,{destination:t},o);return d.updateBackup(c),c.id}_createExtHostEditor(a,m,o){if(this._editors.has(m))throw new Error(`editor with id ALREADY EXSIST: ${m}`);const d=new g.ExtHostNotebookEditor(m,this._notebookEditorsProxy,a,o.visibleRanges.map(I.NotebookRange.to),o.selections.map(I.NotebookRange.to),typeof o.viewColumn=="number"?I.ViewColumn.to(o.viewColumn):void 0);this._editors.set(m,d)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const o of a.value.removedDocuments){const d=T.URI.revive(o),r=this._documents.get(d);r&&(r.dispose(),this._documents.delete(d),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===d.toString()&&this._editors.delete(s.id)}if(a.value.addedDocuments){const o=[];for(const d of a.value.addedDocuments){const r=T.URI.revive(d.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const s=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,r,d);o.push(...d.cells.map(n=>w.ExtHostCell.asModelAddData(s.apiNotebook,n))),this._documents.get(r)?.dispose(),this._documents.set(r,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:o}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(a.value.addedEditors)for(const o of a.value.addedEditors){if(this._editors.has(o.id))return;const d=T.URI.revive(o.documentUri),r=this._documents.get(d);r&&this._createExtHostEditor(r,o.id,o)}const m=[];if(a.value.removedEditors)for(const o of a.value.removedEditors){const d=this._editors.get(o);d&&(this._editors.delete(o),this._activeNotebookEditor?.id===d.id&&(this._activeNotebookEditor=void 0),m.push(d))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(d=>this._editors.get(d)).filter(d=>!!d);const o=new Set;this._visibleNotebookEditors.forEach(d=>o.add(d.id));for(const d of this._editors.values()){const r=o.has(d.id);d._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(d=>d).filter(d=>d.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(a){const m=S.ApiCommandArgument.String.with("notebookType","A notebook type"),o=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[m,new S.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>u.VSBuffer.wrap(r))],new S.ApiCommandResult("Notebook Data",r=>I.NotebookData.to(r.value))),d=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[m,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new v.SerializableObjectWithBuffers(I.NotebookData.from(r)))],new S.ApiCommandResult("Bytes",r=>r.buffer));a.registerApiCommand(o),a.registerApiCommand(d)}}e.ExtHostNotebookController=_,_._notebookStatusBarItemProviderHandlePool=0}),define(ke[250],Pe([1,0,3,79,14,5,18,15]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class b{constructor(P,S){const I=b._Keys.nextId();P.$registerNotebookEditorDecorationType(I,D.NotebookDecorationRenderOptions.from(S)),this.value={key:I,dispose(){P.$removeNotebookEditorDecorationType(I)}}}}b._Keys=new i.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(P,S,I){this._logService=P,this._extHostRpc=S,this._notebooksAndEditors=I,this._onDidChangeNotebookEditorSelection=new u.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new u.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(P){return new b(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),P).value}$acceptEditorPropertiesChanged(P,S){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,S);const I=this._notebooksAndEditors.getEditorById(P);S.visibleRanges&&I._acceptVisibleRanges(S.visibleRanges.ranges.map(D.NotebookRange.to)),S.selections&&I._acceptSelections(S.selections.selections.map(D.NotebookRange.to)),S.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),S.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const S in P)this._notebooksAndEditors.getEditorById(S)._acceptViewColumn(D.ViewColumn.to(P[S]))}};e.ExtHostNotebookEditors=T,e.ExtHostNotebookEditors=T=je([He(0,y.ILogService),He(1,C.IExtHostRpcService)],T)}),define(ke[251],Pe([1,0,16,17,21,3,6,25,2,26,14,5,37,15,7,89,217,28,54]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let f=class{constructor(s,n,t,c,l){this._initData=n,this._extHostNotebook=t,this._commands=c,this._logService=l,this._activeExecutions=new D.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=s.getProxy(P.MainContext.MainThreadNotebookKernels);const h=new S.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new S.ApiCommandArgument("options","Select kernel options",p=>!0,p=>{if(p&&"notebookEditor"in p&&"id"in p){const R=this._extHostNotebook.getIdByEditor(p.notebookEditor);return{id:p.id,extension:p.extension,notebookEditorId:R}}else if(p&&"notebookEditor"in p){const R=this._extHostNotebook.getIdByEditor(p.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${p.notebookEditor.document.uri.toString()}`);return{notebookEditorId:R}}return p})],S.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(s,n,t,c,l,h){for(const te of this._kernelData.values())if(te.controller.id===n&&T.ExtensionIdentifier.equals(s.identifier,te.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const p=this._handlePool++,R=this;this._logService.trace(`NotebookController[${p}], CREATED by ${s.identifier.value}, ${n}`);const F=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${s.identifier}'`);let O=!1;const k=new C.DisposableStore,U=new A.Emitter,B=new A.Emitter,z={id:d(s.identifier,n),notebookType:t,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:c||s.identifier.value,preloads:h?h.map(I.NotebookRendererScript.from):[]};let Y=l??F,$;this._proxy.$addKernel(p,z).catch(te=>{console.log(te),O=!0});let N=0;const V=()=>{if(O)return;const te=++N;Promise.resolve().then(()=>{te===N&&this._proxy.$updateKernel(p,z)})},H=new D.ResourceMap,q={get id(){return n},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return z.label},set label(te){z.label=te??s.displayName??s.name,V()},get detail(){return z.detail??""},set detail(te){z.detail=te,V()},get description(){return z.description??""},set description(te){z.description=te,V()},get kind(){return(0,g.checkProposedApiEnabled)(s,"notebookControllerKind"),z.kind??""},set kind(te){(0,g.checkProposedApiEnabled)(s,"notebookControllerKind"),z.kind=te,V()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(te){z.supportedLanguages=te,V()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(te){z.supportsExecutionOrder=te,V()},get rendererScripts(){return z.preloads?z.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(te){Y=te??F},get interruptHandler(){return $},set interruptHandler(te){$=te,z.supportsInterrupt=Boolean(te),V()},createNotebookCellExecution(te){if(O)throw new Error("notebook controller is DISPOSED");if(!H.has(te.notebook.uri))throw R._logService.trace(`NotebookController[${p}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(fe=>fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.notebook.uri.toString()}`);return R._createNotebookCellExecution(te,d(s.identifier,this.id))},dispose:()=>{O||(this._logService.trace(`NotebookController[${p}], DISPOSED`),O=!0,this._kernelData.delete(p),k.dispose(),U.dispose(),B.dispose(),this._proxy.$removeKernel(p))},updateNotebookAffinity(te,fe){R._proxy.$updateNotebookPriority(p,te.uri,fe)},onDidReceiveMessage:B.event,postMessage(te,fe){return(0,g.checkProposedApiEnabled)(s,"notebookMessaging"),R._proxy.$postMessage(p,fe&&R._extHostNotebook.getIdByEditor(fe),te)},asWebviewUri(te){return(0,g.checkProposedApiEnabled)(s,"notebookMessaging"),(0,v.asWebviewUri)(te,R._initData.remote)}};return this._kernelData.set(p,{extensionId:s.identifier,controller:q,onDidReceiveMessage:B,onDidChangeSelection:U,associatedNotebooks:H}),q}getIdByController(s){for(const[n,t]of this._kernelData)if(t.controller===s)return d(t.extensionId,s.id);return null}$acceptNotebookAssociation(s,n,t){const c=this._kernelData.get(s);if(c){const l=this._extHostNotebook.getNotebookDocument(b.URI.revive(n));t?c.associatedNotebooks.set(l.uri,!0):c.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,l.uri.toString(),t),c.onDidChangeSelection.fire({selected:t,notebook:l.apiNotebook})}}async $executeCells(s,n,t){const c=this._kernelData.get(s);if(!c)return;const l=this._extHostNotebook.getNotebookDocument(b.URI.revive(n)),h=[];for(const p of t){const R=l.getCell(p);R&&h.push(R.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,l.uri.toString(),h.length),await c.controller.executeHandler.call(c.controller,h,l.apiNotebook,c.controller)}catch(p){this._logService.error(`NotebookController[${s}] execute cells FAILED`,p),console.error(p)}}async $cancelCells(s,n,t){const c=this._kernelData.get(s);if(!c)return;const l=this._extHostNotebook.getNotebookDocument(b.URI.revive(n));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,l.apiNotebook);else for(const h of t){const p=l.getCell(h);p&&this._activeExecutions.get(p.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,n,t){const c=this._kernelData.get(s);if(!c)return;const l=this._extHostNotebook.getEditorById(n);c.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:t}))}$cellExecutionChanged(s,n,t){const l=this._extHostNotebook.getNotebookDocument(b.URI.revive(s)).getCell(n);l&&this._onDidChangeCellExecutionState.fire({cell:l.apiCell,state:t?I.NotebookCellExecutionState.to(t):E.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(s,n){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const l=new m(n,c,this._proxy);this._activeExecutions.set(c.uri,l);const h=l.onDidChangeState(()=>{l.state===a.Resolved&&(l.dispose(),h.dispose(),this._activeExecutions.delete(c.uri))});return l.asApiObject()}};e.ExtHostNotebookKernels=f,e.ExtHostNotebookKernels=f=je([He(4,L.ILogService)],f);var a;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(a||(a={}));class m extends C.Disposable{get state(){return this._state}constructor(s,n,t){super();this._cell=n,this._proxy=t,this._handle=m.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new o(10,c=>this.update(c)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,s,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const n=Array.isArray(s)?s:[s];return this._proxy.$updateExecution(this._handle,new _.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(s){return s.map(n=>{const t=E.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return t===n.items?I.NotebookCellOutput.from(n):I.NotebookCellOutput.from({items:t,id:n.id,metadata:n.metadata})})}async updateOutputs(s,n,t){const c=this.validateAndConvertOutputs((0,u.asArray)(s));return this.updateSoon({editType:w.CellExecutionUpdateType.Output,append:t,outputs:c})}async updateOutputItems(s,n,t){return s=E.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(s),!0),this.updateSoon({editType:w.CellExecutionUpdateType.OutputItems,items:s.map(I.NotebookCellOutputItem.from),outputId:n.id,append:t})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(t){s._executionOrder=t,s.update([{editType:w.CellExecutionUpdateType.ExecutionState,executionOrder:s._executionOrder}])},start(t){if(s._state===a.Resolved||s._state===a.Started)throw new Error("Cannot call start again");s._state=a.Started,s._onDidChangeState.fire(),s.update({editType:w.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,c){if(s._state===a.Resolved)throw new Error("Cannot call resolve twice");s._state=a.Resolved,s._onDidChangeState.fire(),s._collector.flush(),s._proxy.$completeExecution(s._handle,new _.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:t}))},clearOutput(t){return s.verifyStateForOutput(),s.updateOutputs([],t,!1)},appendOutput(t,c){return s.verifyStateForOutput(),s.updateOutputs(t,c,!0)},replaceOutput(t,c){return s.verifyStateForOutput(),s.updateOutputs(t,c,!1)},appendOutputItems(t,c){return s.verifyStateForOutput(),s.updateOutputItems(t,c,!0)},replaceOutputItems(t,c){return s.verifyStateForOutput(),s.updateOutputItems(t,c,!1)}})}}m.HANDLE=0;class o{constructor(s,n){this.delay=s,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new i.DeferredPromise,this.startedTimer=Date.now(),(0,i.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>s.complete())}}function d(r,s){return`${r.value}/${s}`}e.createKernelId=d}),define(ke[252],Pe([1,0,3,5,131]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(D,b){this._extHostNotebook=b,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(i.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,b,T){const L=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(b)?.fire({editor:L.apiEditor,message:T})}createRendererMessaging(D,b){if(!D.contributes?.notebookRenderer?.some(L=>L.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(L,P,S)=>this.getOrCreateEmitterFor(b).event(L,P,S),postMessage:(L,P)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,P]=[P,L]);const S=P&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.proxy.$postMessage(S?.id,b,L)}}}getOrCreateEmitterFor(D){let b=this._rendererMessageEmitters.get(D);return b||(b=new u.Emitter({onLastListenerRemove:()=>{b?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,b),b)}}e.ExtHostNotebookRenderers=A}),define(ke[253],Pe([1,0,21,3,6,5,2,7,11,16,41,87]),function(Q,e,u,i,y,A,C,D,b,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function S(I,E,v){const w=I.getProxy(A.MainContext.MainThreadQuickOpen);class g{constructor(n,t){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=t}showQuickPick(n,t,c=u.CancellationToken.None){this._onDidSelectItem=void 0;const l=Promise.resolve(n),h=++this._instances,p=w.$show(h,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},c),R={},F=p.then(()=>R);return Promise.race([F,l]).then(O=>{if(O!==R)return l.then(k=>{const U=[];for(let B=0;B<k.length;B++){const z=k[B];typeof z=="string"?U.push({label:z,handle:B}):z.kind===D.QuickPickItemKind.Separator?U.push({type:"separator",label:z.label}):U.push({label:z.label,description:z.description,detail:z.detail,picked:z.picked,alwaysShow:z.alwaysShow,handle:B})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{t.onDidSelectItem(k[B])}),w.$setItems(h,U),p.then(B=>{if(typeof B=="number")return k[B];if(Array.isArray(B))return B.map(z=>k[z])})})}).then(void 0,O=>{if(!(0,b.isCancellationError)(O))return w.$setError(h,O),Promise.reject(O)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,t=u.CancellationToken.None){return this._validateInput=n?.validateInput,w.$input(n,typeof this._validateInput=="function",t).then(void 0,c=>{if(!(0,b.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(n){if(!this._validateInput)return;const t=await this._validateInput(n);if(!t||typeof t=="string")return t;let c;switch(t.severity){case D.InputBoxValidationSeverity.Info:c=L.default.Info;break;case D.InputBoxValidationSeverity.Warning:c=L.default.Warning;break;case D.InputBoxValidationSeverity.Error:c=L.default.Error;break;default:c=t.message?L.default.Error:L.default.Ignore;break}return{content:t.message,severity:c}}async showWorkspaceFolderPick(n,t=u.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!c)return;const l=await this._workspace.getWorkspaceFolders2();if(!!l)return l.find(h=>h.uri.toString()===c.uri.toString())}createQuickPick(n){const t=new d(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(n){const t=new r(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(n,t){const c=this._sessions.get(n);c&&c._fireDidChangeValue(t)}$onDidAccept(n){const t=this._sessions.get(n);t&&t._fireDidAccept()}$onDidChangeActive(n,t){const c=this._sessions.get(n);c instanceof d&&c._fireDidChangeActive(t)}$onDidChangeSelection(n,t){const c=this._sessions.get(n);c instanceof d&&c._fireDidChangeSelection(t)}$onDidTriggerButton(n,t){const c=this._sessions.get(n);c&&c._fireDidTriggerButton(t)}$onDidTriggerItemButton(n,t,c){const l=this._sessions.get(n);l instanceof d&&l._fireDidTriggerItemButton(t,c)}$onDidHide(n){const t=this._sessions.get(n);t&&t._fireDidHide()}}class _{constructor(n,t){this._extensionId=n,this._onDidDispose=t,this._id=d._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new i.Emitter,this._onDidChangeValueEmitter=new i.Emitter,this._onDidTriggerButtonEmitter=new i.Emitter,this._onDidHideEmitter=new i.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((t,c)=>{const l=t===D.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(l,t)}),this.update({buttons:n.map((t,c)=>({...o(t),tooltip:t.tooltip,handle:t===D.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const t=this._handlesToButtons.get(n);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(n){if(!this._disposed){for(const t of Object.keys(n)){const c=n[t];this._pendingUpdate[t]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function f(s){if(s instanceof D.ThemeIcon)return{id:s.id};const n=m(s),t=a(s);return{dark:typeof n=="string"?C.URI.file(n):n,light:typeof t=="string"?C.URI.file(t):t}}function a(s){return typeof s=="object"&&"light"in s?s.light:s}function m(s){return typeof s=="object"&&"dark"in s?s.dark:s}function o(s){const n=f(s.iconPath);let t,c;return"id"in n?c=P.ThemeIcon.asClassName(n):t=n,{iconPath:t,iconClass:c}}class d extends _{constructor(n,t){super(n.identifier,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new i.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new i.Emitter,this._onDidTriggerItemButtonEmitter=new i.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((c,l)=>{this._handlesToItems.set(l,c),this._itemsToHandles.set(c,l)});const t=[];for(let c=0;c<n.length;c++){const l=n[c];l.kind===D.QuickPickItemKind.Separator?t.push({type:"separator",label:l.label}):t.push({handle:c,label:l.label,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons?.map((h,p)=>({...o(h),tooltip:h.tooltip,handle:p}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(n){this._keepScrollPosition=n,this.update({keepScrollPosition:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(n){const t=(0,T.coalesce)(n.map(c=>this._handlesToItems.get(c)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(n){const t=(0,T.coalesce)(n.map(c=>this._handlesToItems.get(c)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(n,t){const c=this._handlesToItems.get(n);if(!c||!c.buttons||!c.buttons.length)return;const l=c.buttons[t];l&&this._onDidTriggerItemButtonEmitter.fire({button:l,item:c})}}class r extends _{constructor(n,t){super(n.identifier,t);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,n?typeof n=="string"?this.update({validationMessage:n,severity:L.default.Error}):this.update({validationMessage:n.message,severity:n.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new g(E,v)}e.createExtHostQuickOpen=S});var Ue=this&&this.__classPrivateFieldGet||function(Q,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Q):i?i.value:e.get(Q)},tt=this&&this.__classPrivateFieldSet||function(Q,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u};define(ke[254],Pe([1,0,2,3,58,6,17,5,16,100,14,26,87,15,28]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E){"use strict";var v,w,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function _(h){if(h)return typeof h.iconPath=="string"?u.URI.file(h.iconPath):u.URI.isUri(h.iconPath)||S.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function f(h,p){if(!h.iconPath&&!p.iconPath)return 0;if(h.iconPath){if(!p.iconPath)return 1}else return-1;const R=typeof h.iconPath=="string"?h.iconPath:u.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,F=typeof p.iconPath=="string"?p.iconPath:u.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,T.comparePaths)(R,F)}function a(h,p){let R=0;if(h.strikeThrough!==p.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==p.faded)return h.faded?1:-1;if(h.tooltip!==p.tooltip)return(h.tooltip||"").localeCompare(p.tooltip||"");if(R=f(h,p),R!==0)return R;if(h.light&&p.light)R=f(h.light,p.light);else{if(h.light)return 1;if(p.light)return-1}if(R!==0)return R;if(h.dark&&p.dark)R=f(h.dark,p.dark);else{if(h.dark)return 1;if(p.dark)return-1}return R}function m(h,p){if(h.command!==p.command)return h.command<p.command?-1:1;if(h.title!==p.title)return h.title<p.title?-1:1;if(h.tooltip!==p.tooltip){if(h.tooltip!==void 0&&p.tooltip!==void 0)return h.tooltip<p.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(h.arguments===p.arguments)return 0;if(h.arguments)if(p.arguments){if(h.arguments.length!==p.arguments.length)return h.arguments.length-p.arguments.length}else return 1;else return-1;for(let R=0;R<h.arguments.length;R++){const F=h.arguments[R],O=p.arguments[R];if(F!==O)return F<O?-1:1}return 0}function o(h,p){let R=(0,T.comparePaths)(h.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(R!==0)return R;if(h.command&&p.command)R=m(h.command,p.command);else{if(h.command)return 1;if(p.command)return-1}if(R!==0)return R;if(h.decorations&&p.decorations)R=a(h.decorations,p.decorations);else{if(h.decorations)return 1;if(p.decorations)return-1}return R}function d(h,p){for(let R=0;R<h.length;R++)if(h[R]!==p[R])return!1;return!0}function r(h,p){return h.command===p.command&&h.title===p.title&&h.tooltip===p.tooltip&&(h.arguments&&p.arguments?d(h.arguments,p.arguments):h.arguments===p.arguments)}function s(h,p){return(0,b.equals)(h,p,r)}class n{get value(){return this._value}set value(p){p=p??"",Ue(this,v,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Ue(this,v,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Ue(this,v,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get enabled(){return(0,E.checkProposedApiEnabled)(this._extension,"scmInput"),this._enabled}set enabled(p){(0,E.checkProposedApiEnabled)(this._extension,"scmInput"),p=!!p,this._enabled!==p&&(this._enabled=p,Ue(this,v,"f").$setInputBoxEnablement(this._sourceControlHandle,p))}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Ue(this,v,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}constructor(p,R,F){this._extension=p,this._sourceControlHandle=F,v.set(this,void 0),this._value="",this._onDidChange=new i.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,v,R,"f")}showValidationMessage(p,R){(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),Ue(this,v,"f").$showValidationMessage(this._sourceControlHandle,p,R)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=n,v=new WeakMap;class t{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}constructor(p,R,F,O,k){this._proxy=p,this._commands=R,this._sourceControlHandle=F,this._id=O,this._label=k,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new i.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,R){const F=this._resourceStatesCommandsMap.get(p);return F?(0,C.asPromise)(()=>this._commands.executeCommand(F.command,...F.arguments||[],R)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(o),F=(0,b.sortedDiff)(this._resourceSnapshot,p,o).map(U=>{const B=U.toInsert.map(z=>{const Y=this._resourceHandlePool++;this._resourceStatesMap.set(Y,z);const $=z.resourceUri;let N;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const ve=new A.DisposableStore;N=this._commands.converter.toInternal(z.command,ve),this._resourceStatesDisposablesMap.set(Y,ve)}else this._resourceStatesCommandsMap.set(Y,z.command);const V=_(z.decorations),H=z.decorations&&_(z.decorations.light)||V,q=z.decorations&&_(z.decorations.dark)||V,te=[H,q],fe=z.decorations&&z.decorations.tooltip||"",ne=z.decorations&&!!z.decorations.strikeThrough,le=z.decorations&&!!z.decorations.faded,K=z.contextValue||"";return{rawResource:[Y,$,te,fe,ne,le,K,N],handle:Y}});return{start:U.start,deleteCount:U.deleteCount,toInsert:B}}),O=F.map(({start:U,deleteCount:B,toInsert:z})=>[U,B,z.map(Y=>Y.rawResource)]),k=F.reverse();for(const{start:U,deleteCount:B,toInsert:z}of k){const Y=z.map(N=>N.handle),$=this._handlesSnapshot.splice(U,B,...Y);for(const N of $)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=p,O}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class c{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Ue(this,w,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Ue(this,w,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Ue(this,w,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=p;const R=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Ue(this,w,"f").$updateSourceControl(this.handle,{acceptInputCommand:R})}get actionButton(){return(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=p;const R=p!==void 0?{command:this._commands.converter.toInternal(p.command,this._actionButtonDisposables.value),description:p.description}:void 0;Ue(this,w,"f").$updateSourceControl(this.handle,{actionButton:R??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&s(this._statusBarCommands,p))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=p;const R=(p||[]).map(F=>this._commands.converter.toInternal(F,this._statusBarDisposables.value));Ue(this,w,"f").$updateSourceControl(this.handle,{statusBarCommands:R})}get selected(){return this._selected}constructor(p,R,F,O,k,U){this._extension=p,this._commands=F,this._id=O,this._label=k,this._rootUri=U,w.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new i.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=c._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,w,R,"f"),this._inputBox=new n(p,Ue(this,w,"f"),this.handle),Ue(this,w,"f").$registerSourceControl(this.handle,O,k,U)}createResourceGroup(p,R){const F=new t(Ue(this,w,"f"),this._commands,this.handle,p,R),O=i.Event.once(F.onDidDispose)(()=>this.createdResourceGroups.delete(F));return this.createdResourceGroups.set(F,O),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const p=[],R=[];for(const[F,O]of this.createdResourceGroups){O.dispose();const k=F.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(F),this.eventuallyUpdateResourceStates()});i.Event.once(F.onDidDispose)(()=>{this.updatedResourceGroups.delete(F),k.dispose(),this._groups.delete(F.handle),Ue(this,w,"f").$unregisterGroup(this.handle,F.handle)}),p.push([F.handle,F.id,F.label,F.features]);const U=F._takeResourceStateSnapshot();U.length>0&&R.push([F.handle,U]),this._groups.set(F.handle,F)}Ue(this,w,"f").$registerGroups(this.handle,p,R),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(R=>{const F=R._takeResourceStateSnapshot();F.length!==0&&p.push([R.handle,F])}),p.length>0&&Ue(this,w,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Ue(this,w,"f").$unregisterSourceControl(this.handle)}}w=new WeakMap,c._handlePool=0,je([(0,y.debounce)(100)],c.prototype,"eventuallyAddResourceGroups",null),je([(0,y.debounce)(100)],c.prototype,"eventuallyUpdateResourceStates",null);let l=g=class{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(p,R,F){this._commands=R,this.logService=F,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new i.Emitter,this._proxy=p.getProxy(D.MainContext.MainThreadSCM),this._telemetry=p.getProxy(D.MainContext.MainThreadTelemetry),R.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const k=this._sourceControls.get(O.sourceControlHandle);if(!k)return O;const U=k.getResourceGroup(O.groupHandle);return U?U.getResourceState(O.handle):O}else if(O&&O.$mid===4){const k=this._sourceControls.get(O.sourceControlHandle);return k?k.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const k=this._sourceControls.get(O.handle);return k||O}return O}})}createSourceControl(p,R,F,O){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,R,F,O),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const k=g._handlePool++,U=new c(p,this._proxy,this._commands,R,F,O);this._sourceControls.set(k,U);const B=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(p.identifier))||[];return B.push(U),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(p.identifier),B),U}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const R=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(p.identifier)),F=R&&R[R.length-1];return F&&F.inputBox}$provideOriginalResource(p,R,F){const O=u.URI.revive(R);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,O.toString());const k=this._sourceControls.get(p);return!k||!k.quickDiffProvider||!k.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>k.quickDiffProvider.provideOriginalResource(O,F)).then(U=>U||null)}$onInputBoxValueChange(p,R){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const F=this._sourceControls.get(p);return F&&F.inputBox.$onInputBoxValueChange(R),Promise.resolve(void 0)}$executeResourceCommand(p,R,F,O){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,R,F);const k=this._sourceControls.get(p);if(!k)return Promise.resolve(void 0);const U=k.getResourceGroup(R);return U?U.$executeResourceCommand(F,O):Promise.resolve(void 0)}$validateInput(p,R,F){this.logService.trace("ExtHostSCM#$validateInput",p);const O=this._sourceControls.get(p);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>O.inputBox.validateInput(R,F)).then(k=>{if(!k)return Promise.resolve(void 0);const U=I.MarkdownString.fromStrict(k.message);return U?Promise.resolve([U,k.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};e.ExtHostSCM=l,l._handlePool=0,e.ExtHostSCM=l=g=je([He(2,L.ILogService)],l)});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Ue=this&&this.__classPrivateFieldGet||function(Q,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Q):i?i.value:e.get(Q)};define(ke[255],Pe([1,0,7,5,173,6,15,12]),function(Q,e,u,i,y,A,C,D){"use strict";var b,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(E,v,w,g,_=u.StatusBarAlignment.Left,f){b.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,tt(this,b,E,"f"),tt(this,T,v,"f"),this._entryId=L.ID_GEN++,this._extension=w,this._id=g,this._alignment=_,this._priority=this.validatePriority(f)}validatePriority(E){if(!!(0,D.isNumber)(E))return E===Number.POSITIVE_INFINITY?Number.MAX_VALUE:E===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(E){this._text=E,this.update()}set name(E){this._name=E,this.update()}set tooltip(E){this._tooltip=E,this.update()}set color(E){this._color=E,this.update()}set backgroundColor(E){E&&!L.ALLOWED_BACKGROUND_COLORS.has(E.id)&&(E=void 0),this._backgroundColor=E,this.update()}set command(E){this._command?.fromApi!==E&&(this._internalCommandRegistration.clear(),typeof E=="string"?this._command={fromApi:E,internal:Ue(this,T,"f").toInternal({title:"",command:E},this._internalCommandRegistration)}:E?this._command={fromApi:E,internal:Ue(this,T,"f").toInternal(E,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(E){this._accessibilityInformation=E,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,b,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let E;this._extension?this._id?E=`${this._extension.identifier.value}.${this._id}`:E=this._extension.identifier.value:E=this._id;let v;this._name?v=this._name:v=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let w=this._color;this._backgroundColor&&(w=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const g=C.MarkdownString.fromStrict(this._tooltip);Ue(this,b,"f").$setEntry(this._entryId,E,v,this._text,g,this._command?.internal,w,this._backgroundColor,this._alignment===u.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,b=new WeakMap,T=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new u.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(E){this._messages=[],this._item=E.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(E){const v={message:E};return this._messages.unshift(v),this._update(),new u.Disposable(()=>{const w=this._messages.indexOf(v);w>=0&&(this._messages.splice(w,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class S{constructor(E,v){this._proxy=E.getProxy(i.MainContext.MainThreadStatusBar),this._commands=v,this._statusMessage=new P(this)}createStatusBarEntry(E,v,w,g){return new L(this._proxy,this._commands,E,v,w,g)}setStatusBarMessage(E,v){const w=this._statusMessage.setMessage(E);let g;return typeof v=="number"?g=setTimeout(()=>w.dispose(),v):typeof v!="undefined"&&v.then(()=>w.dispose(),()=>w.dispose()),new u.Disposable(()=>{w.dispose(),clearTimeout(g)})}}e.ExtHostStatusBar=S}),define(ke[92],Pe([1,0,5,3,4]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(D){this._onDidChangeStorage=new i.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(u.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,b){this._proxy.$registerExtensionStorageKeysToSync(D,b)}initializeExtensionStorage(D,b,T){return this._proxy.$initializeExtensionStorage(D,b).then(L=>L||T)}setValue(D,b,T){return this._proxy.$setValue(D,b,T)}$acceptValue(D,b,T){this._onDidChangeStorage.fire({shared:D,key:b,value:T})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(ke[71],Pe([1,0,4,27,14,70,2]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,u.createDecorator)("IExtensionStoragePaths");let D=class{constructor(T,L,P){this._logService=L,this._extHostFileSystem=P,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(S=>this._value=S)}async _getWorkspaceStorageURI(T){return C.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,L=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:C.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(P){this._logService.error("[ExtHostStorage]",P);return}}workspaceValue(T){if(this._value)return C.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return C.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=D,e.ExtensionStoragePaths=D=je([He(0,i.IExtHostInitDataService),He(1,y.ILogService),He(2,A.IExtHostConsumerFileSystem)],D)}),define(ke[38],Pe([1,0,3,5,4,2,18,6,7,174,11,218,21,35,202,87,12,17]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class _{constructor(t,c,l,h){this._proxy=t,this._id=c,this._creationOptions=l,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const p=this;this.value={get name(){return p._name||""},get processId(){return p._pidPromise},get creationOptions(){return p._creationOptions},get exitStatus(){return p._exitStatus},get state(){return p._state},sendText(R,F=!0){p._checkDisposed(),p._proxy.$sendText(p._id,R,F)},show(R){p._checkDisposed(),p._proxy.$show(p._id,R)},hide(){p._checkDisposed(),p._proxy.$hide(p._id)},dispose(){p._disposed||(p._disposed=!0,p._proxy.$dispose(p._id))},get dimensions(){if(!(p._cols===void 0||p._rows===void 0))return{columns:p._cols,rows:p._rows}}}}async create(t,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,w.withNullAsUndefined)(t.shellPath),shellArgs:(0,w.withNullAsUndefined)(t.shellArgs),cwd:(0,w.withNullAsUndefined)(t.cwd),env:(0,w.withNullAsUndefined)(t.env),icon:(0,w.withNullAsUndefined)(r(t.iconPath)),color:v.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,w.withNullAsUndefined)(t.message),strictEnv:(0,w.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,w.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,w.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,w.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(t.location,c?.resolvedExtHostIdentifier),isTransient:(0,w.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,c,l,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:l,color:v.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(t,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,c){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,c){return t===this._cols&&c===this._rows||t===0||c===0?!1:(this._cols=t,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=_;class f{get onProcessReady(){return this._onProcessReady.event}constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new u.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new u.Emitter,this._onDidChangeProperty=new u.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new u.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,c){this._pty.setDimensions?.({columns:t,rows:c})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=f;let a=1,m=class extends D.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(t,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new u.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new u.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new u.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new u.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new u.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(i.MainContext.MainThreadTerminalService),this._bufferer=new E.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new u.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[l,h]of this._terminalProcesses)h.shutdown(!0)}})}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,c){const l=new _(this._proxy,(0,I.generateUuid)(),t,t.name),h=new f(t.pty);return l.createExtensionTerminal(t.location,this._serializeParentTerminal(t,c).resolvedExtHostIdentifier,r(t.iconPath),s(t.color)).then(p=>{const R=this._setupExtHostProcessListeners(p,h);this._terminalProcessDisposables[p]=R}),this._terminals.push(l),l.value}_serializeParentTerminal(t,c){if(c=c||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const l=t.location.parentTerminal;if(l){const h=this._terminals.find(p=>p.value===l);h&&(c.resolvedExtHostIdentifier=h._id)}}else t.location&&typeof t.location!="object"?c.location=t.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(t,c){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const h=new f(c),p=this._setupExtHostProcessListeners(t,h);this._terminalProcessDisposables[t]=p}async $acceptActiveTerminalChanged(t){const c=this._activeTerminal;if(t===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(t);l&&(this._activeTerminal=l,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,c){const l=this._getTerminalById(t);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:c})}async $acceptTerminalDimensions(t,c,l){const h=this._getTerminalById(t);h&&h.setDimensions(c,l)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(t,c,l){this._terminalProcesses.get(t)?.resize(c,l)}async $acceptTerminalTitleChange(t,c){const l=this._getTerminalById(t);l&&(l.name=c)}async $acceptTerminalClosed(t,c){const l=this._getTerminalObjectIndexById(this._terminals,t);if(l!==null){const h=this._terminals.splice(l,1)[0];h.setExitCode(c),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(t,c,l,h){if(c){const F=this._getTerminalObjectIndexById(this._terminals,c);if(F!==null){this._terminals[F]._id=t,this._onDidOpenTerminal.fire(this.terminals[F]),this._terminals[F].isOpen=!0;return}}const p={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:A.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},R=new _(this._proxy,t,p,l);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(t,c){const l=this._getTerminalById(t);l&&l._setProcessId(c)}async $startExtensionTerminal(t,c){const l=this._getTerminalById(t);if(!l)return{message:(0,T.localize)(0,null,t)};l.isOpen||await new Promise(p=>{const R=this.onDidOpenTerminal(async F=>{F===l.value&&(R.dispose(),p())})});const h=this._terminalProcesses.get(t);h?h.startSendingEvents(c):this._extensionTerminalAwaitingStart[t]={initialDimensions:c}}_setupExtHostProcessListeners(t,c){const l=new D.DisposableStore;l.add(c.onProcessReady(p=>this._proxy.$sendProcessReady(t,p.pid,p.cwd))),l.add(c.onDidChangeProperty(p=>this._proxy.$sendProcessProperty(t,p))),this._bufferer.startBuffering(t,c.onProcessData),l.add(c.onProcessExit(p=>this._onProcessExit(t,p))),this._terminalProcesses.set(t,c);const h=this._extensionTerminalAwaitingStart[t];return h&&c instanceof f&&(c.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),l}$acceptProcessAckDataEvent(t,c){this._terminalProcesses.get(t)?.acknowledgeDataEvent(c)}$acceptProcessInput(t,c){this._terminalProcesses.get(t)?.input(c)}$acceptTerminalInteraction(t){const c=this._getTerminalById(t);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(t,c,l){try{this._terminalProcesses.get(t)?.resize(c,l)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(t,c){this._terminalProcesses.get(t)?.shutdown(c)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:c}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new b.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,c,l){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,l),this._proxy.$registerProfileProvider(c,t.identifier.value),new b.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(t,c){const l=new S.CancellationTokenSource().token;let h=await this._profileProviders.get(t)?.provideTerminalProfile(l);if(!l.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,c);return}this.createTerminalFromOptions(h.options,c)}}async $provideLinks(t,c){const l=this._getTerminalById(t);if(!l)return[];this._terminalLinkCache.delete(t);const h=this._terminalLinkCancellationSource.get(t);h&&h.dispose(!0);const p=new S.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,p);const R=[],F={terminal:l.value,line:c},O=[];for(const B of this._linkProviders)O.push(g.Promises.withAsyncBody(async z=>{p.token.onCancellationRequested(()=>z({provider:B,links:[]}));const Y=await B.provideTerminalLinks(F,p.token)||[];p.token.isCancellationRequested||z({provider:B,links:Y})}));const k=await Promise.all(O);if(p.token.isCancellationRequested)return[];const U=new Map;for(const B of k)B&&B.links.length>0&&R.push(...B.links.map(z=>{const Y={id:a++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return U.set(Y.id,{provider:B.provider,link:z}),Y}));return this._terminalLinkCache.set(t,U),R}$activateLink(t,c){const l=this._terminalLinkCache.get(t)?.get(c);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(t,c){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const l=this._terminalProcessDisposables[t];l&&(l.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,c)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,c){const l=this._getTerminalObjectIndexById(t,c);return l!==null?t[l]:null}_getTerminalObjectIndexById(t,c){let l=null;return t.some((h,p)=>h._id===c?(l=p,!0):!1),l}getEnvironmentVariableCollection(t){let c=this._environmentVariableCollections.get(t.identifier.value);return c||(c=new o,this._setEnvironmentVariableCollection(t.identifier.value,c)),c}_syncEnvironmentVariableCollection(t,c){const l=(0,P.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(t,c.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(t){t.forEach(c=>{const l=c[0],h=new o(c[1]);this._setEnvironmentVariableCollection(l,h)})}$acceptDefaultProfile(t,c){this._defaultProfile=t,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(t,c){this._environmentVariableCollections.set(t,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,c)})}};e.BaseExtHostTerminalService=m,e.BaseExtHostTerminalService=m=je([He(1,C.IExtHostRpcService)],m);class o{get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new u.Emitter,this.map=new Map(t)}get size(){return this.map.size}replace(t,c){this._setIfDiffers(t,{value:c,type:b.EnvironmentVariableMutatorType.Replace})}append(t,c){this._setIfDiffers(t,{value:c,type:b.EnvironmentVariableMutatorType.Append})}prepend(t,c){this._setIfDiffers(t,{value:c,type:b.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,c){const l=this.map.get(t);(!l||l.value!==c.value||l.type!==c.type)&&(this.map.set(t,c),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,c){this.map.forEach((l,h)=>t.call(c,h,l,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=o;let d=class extends m{constructor(t){super(!1,t)}createTerminal(t,c,l){throw new L.NotSupportedError}createTerminalFromOptions(t,c){throw new L.NotSupportedError}};e.WorkerExtHostTerminalService=d,e.WorkerExtHostTerminalService=d=je([He(0,C.IExtHostRpcService)],d);function r(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function s(n){return v.ThemeColor.isThemeColor(n)?n:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(Q,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Q):i?i.value:e.get(Q)},tt=this&&this.__classPrivateFieldSet||function(Q,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u};define(ke[256],Pe([1,0,16,23,21,3,59,61,6,24,12,35,5,18,132,15,7,67,90,68]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_,f){"use strict";var a,m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(O,k){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=O.getProxy(S.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new r(this.proxy),k.registerArgumentProcessor({processArgument:U=>U?.$mid===13?(0,E.toItemFromContext)(U):U})}createTestController(O,k,U){if(this.controllers.has(O))throw new Error(`Attempt to insert a duplicate controller with ID "${O}"`);const B=new b.DisposableStore,z=B.add(new E.ExtHostTestItemCollection(O,k));z.root.label=k;const Y=new Map,$=this.proxy,N={items:z.root.children,get label(){return k},set label(H){k=H,z.root.label=H,$.$updateController(O,{label:k})},get refreshHandler(){return U},set refreshHandler(H){U=H,$.$updateController(O,{canRefresh:!!H})},get id(){return O},createRunProfile:(H,q,te,fe,ne)=>{let le=(0,D.hash)(H);for(;Y.has(le);)le++;return new p(this.proxy,Y,O,le,H,q,te,fe,ne)},createTestItem(H,q,te){return new E.TestItemImpl(O,H,q,te)},createTestRun:(H,q,te=!0)=>this.runTracker.createTestRun(O,z,H,q,te),set resolveHandler(H){z.resolveHandler=H},get resolveHandler(){return z.resolveHandler},dispose:()=>{B.dispose()}};$.$registerTestController(O,k,!!U),B.add((0,b.toDisposable)(()=>$.$unregisterTestController(O)));const V={controller:N,collection:z,profiles:Y};return this.controllers.set(O,V),B.add((0,b.toDisposable)(()=>this.controllers.delete(O))),B.add(z.onDidGenerateDiff(H=>$.$publishDiff(O,H.map(f.TestsDiffOp.serialize)))),N}createTestObserver(){return this.observer.checkout()}async runTests(O,k=y.CancellationToken.None){const U=s(O);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.controllers.get(U.controllerId);if(!B)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(z=>g.TestId.fromExtHostTestItem(z,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:R[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:O.exclude?.map(z=>z.id)},k)}$provideFileCoverage(O,k,U){return(0,u.mapFind)(this.runTracker.trackers,z=>z.id===O?z.getCoverage(k):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(O,k,U,B){return(0,u.mapFind)(this.runTracker.trackers,Y=>Y.id===O?Y.getCoverage(k):void 0)?.resolveFileCoverage(U,B)??Promise.resolve([])}$configureRunProfile(O,k){this.controllers.get(O)?.profiles.get(k)?.configureHandler?.()}async $refreshTests(O,k){await this.controllers.get(O)?.controller.refreshHandler?.(k)}$publishTestResults(O){this.results=Object.freeze(O.map(k=>(0,T.deepFreeze)(v.TestResults.to(k))).concat(this.results).sort((k,U)=>U.completedAt-k.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(O,k){const U=this.controllers.get(g.TestId.fromString(O).controllerId)?.collection;U&&(await U.expand(O,k<0?1/0:k),U.flushDiff())}$acceptDiff(O){this.observer.applyDiff(O.map(f.TestsDiffOp.deserialize))}async $runControllerTests(O,k){const U=this.controllers.get(O.controllerId);if(!U)return;const{collection:B,profiles:z}=U,Y=z.get(O.profileId);if(!Y)return;const $=O.testIds.map(q=>B.tree.get(q)).filter(L.isDefined),N=O.excludeExtIds.map(q=>U.collection.tree.get(q)).filter(L.isDefined).filter(q=>$.some(te=>te.fullId.compare(q.fullId)===2));if(!$.length)return;const V=new w.TestRunRequest($.some(q=>q.actual instanceof E.TestItemRootImpl)?void 0:$.map(q=>q.actual),N.map(q=>q.actual),Y),H=this.runTracker.prepareForMainThreadTestRun(V,n.fromInternal(O,U.collection),k);try{await Y.runHandler(V,k)}finally{H.isRunning&&!k.isCancellationRequested&&await A.Event.toPromise(H.onEnd),H.dispose()}}$cancelExtensionTestRun(O){O===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(O)}};e.ExtHostTesting=o,e.ExtHostTesting=o=je([He(0,I.IExtHostRpcService)],o);class d extends b.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(O,k,U){super();this.dto=O,this.proxy=k,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(U)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:B}of this.tasks.values())B.end()}))}getCoverage(O){return this.tasks.get(O)?.coverage}createRun(O){const k=this.dto.id,U=this.dto.controllerId,B=(0,P.generateUuid)(),z=new t(this.proxy,k,B),Y=H=>(q,...te)=>{if(N){console.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(q)||(this.ensureTestIsKnown(q),H(q,...te))},$=(H,q)=>{const te=q instanceof Array?q.map(v.TestMessage.from):[v.TestMessage.from(q)];if(H.uri&&H.range){const fe={range:v.Range.from(H.range),uri:H.uri};for(const ne of te)ne.location=ne.location||fe}this.proxy.$appendTestMessagesInRun(k,B,g.TestId.fromExtHostTestItem(H,U).toString(),te)};let N=!1;const V={isPersisted:this.dto.isPersisted,token:this.cts.token,name:O,get coverageProvider(){return z.coverageProvider},set coverageProvider(H){z.coverageProvider=H},enqueued:Y(H=>{this.proxy.$updateTestStateInRun(k,B,g.TestId.fromExtHostTestItem(H,U).toString(),1)}),skipped:Y(H=>{this.proxy.$updateTestStateInRun(k,B,g.TestId.fromExtHostTestItem(H,U).toString(),5)}),started:Y(H=>{this.proxy.$updateTestStateInRun(k,B,g.TestId.fromExtHostTestItem(H,U).toString(),2)}),errored:Y((H,q,te)=>{$(H,q),this.proxy.$updateTestStateInRun(k,B,g.TestId.fromExtHostTestItem(H,U).toString(),6,te)}),failed:Y((H,q,te)=>{$(H,q),this.proxy.$updateTestStateInRun(k,B,g.TestId.fromExtHostTestItem(H,U).toString(),4,te)}),passed:Y((H,q)=>{this.proxy.$updateTestStateInRun(k,B,g.TestId.fromExtHostTestItem(H,this.dto.controllerId).toString(),3,q)}),appendOutput:(H,q,te)=>{N||(te&&(this.dto.isIncluded(te)?this.ensureTestIsKnown(te):te=void 0),this.proxy.$appendOutputToRun(k,B,i.VSBuffer.fromString(H),q&&v.location.from(q),te&&g.TestId.fromExtHostTestItem(te,U).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(k,B),this.tasks.delete(B),this.isRunning||this.dispose())}};return this.tasks.set(B,{run:V,coverage:z}),this.proxy.$startedTestRunTask(k,{id:B,name:O,running:!0}),V}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(O){if(!(O instanceof E.TestItemImpl))throw new _.InvalidTestItemError(O.id);if(this.sharedTestIds.has(g.TestId.fromExtHostTestItem(O,this.dto.controllerId).toString()))return;const k=[],U=this.dto.colllection.root;for(;;){const B=v.TestItem.from(O);if(k.unshift(B),this.sharedTestIds.has(B.extId)||(this.sharedTestIds.add(B.extId),O===U))break;O=O.parent||U}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,k)}}class r{get trackers(){return this.tracked.values()}constructor(O){this.proxy=O,this.tracked=new Map}prepareForMainThreadTestRun(O,k,U){return this.getTracker(O,k,U)}cancelRunById(O){for(const k of this.tracked.values())if(k.id===O){k.dispose();return}}cancelAllRuns(){for(const O of this.tracked.values())O.dispose()}createTestRun(O,k,U,B,z){const Y=this.tracked.get(U);if(Y)return Y.createRun(B);const $=n.fromPublic(O,k,U,z),N=s(U);this.proxy.$startedExtensionTestRun({controllerId:O,profile:N&&{group:R[N.kind],id:N.profileId},exclude:U.exclude?.map(H=>g.TestId.fromExtHostTestItem(H,k.root.id).toString())??[],id:$.id,include:U.include?.map(H=>g.TestId.fromExtHostTestItem(H,k.root.id).toString())??[k.root.id],persist:z});const V=this.getTracker(U,$);return V.onEnd(()=>this.proxy.$finishedExtensionTestRun($.id)),V.createRun(B)}getTracker(O,k,U){const B=new d(k,this.proxy,U);return this.tracked.set(O,B),B.onEnd(()=>this.tracked.delete(O)),B}}e.TestRunCoordinator=r;const s=F=>{if(!!F.profile){if(!(F.profile instanceof p))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return F.profile}};class n{static fromPublic(O,k,U,B){return new n(O,(0,P.generateUuid)(),U.include?.map(z=>g.TestId.fromExtHostTestItem(z,O).toString())??[O],U.exclude?.map(z=>g.TestId.fromExtHostTestItem(z,O).toString())??[],B,k)}static fromInternal(O,k){return new n(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,k)}constructor(O,k,U,B,z,Y){this.controllerId=O,this.id=k,this.isPersisted=z,this.colllection=Y,this.includePrefix=U.map($=>$+"\0"),this.excludePrefix=B.map($=>$+"\0")}isIncluded(O){const k=g.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const U of this.excludePrefix)if(k===U||k.startsWith(U))return!1;for(const U of this.includePrefix)if(k===U||k.startsWith(U))return!0;return!1}}e.TestRunDto=n;class t{set coverageProvider(O){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this._coverageProvider=O,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(O,k,U){this.proxy=O,this.runId=k,this.taskId=U}async provideFileCoverage(O){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(O))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(k){throw this.fileCoverage=void 0,k}}async resolveFileCoverage(O,k){const U=await this.fileCoverage;let B=U?.[O];return!this._coverageProvider||!U||!B?[]:(B.detailedCoverage||(B=U[O]=await this._coverageProvider.resolveFileCoverage?.(B,k)??B),B.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class c extends f.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(O){super();this.emitter=O,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(O){this.added.add(O)}update(O){Object.assign(O.revived,v.TestItem.toPlain(O.item)),this.added.has(O)||this.updated.add(O)}remove(O){if(this.added.has(O)){this.added.delete(O);return}if(this.updated.delete(O),O.parent&&this.alreadyRemoved.has(O.parent)){this.alreadyRemoved.add(O.item.extId);return}this.removed.add(O)}getChangeEvent(){const{added:O,updated:k,removed:U}=this;return{get added(){return[...O].map(B=>B.revived)},get updated(){return[...k].map(B=>B.revived)},get removed(){return[...U].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(O){return this.items.get(O)}getMirroredTestDataByReference(O){return this.items.get(O.id)}createItem(O,k){return{...O,revived:v.TestItem.toPlain(O.item),depth:k?k.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=l;class h{constructor(O){this.proxy=O}checkout(){this.current||(this.current=this.createObserverData());const O=this.current;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(k=>k.revived)},dispose:(0,C.once)(()=>{--O.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(O){return this.current?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.current?.tests.apply(O)}createObserverData(){const O=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:O}}}class p{get label(){return this._label}set label(O){O!==this._label&&(this._label=O,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get isDefault(){return this._isDefault}set isDefault(O){O!==this._isDefault&&(this._isDefault=O,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?v.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(O){O!==this._configureHandler&&(this._configureHandler=O,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}constructor(O,k,U,B,z,Y,$,N=!1,V=void 0){this.controllerId=U,this.profileId=B,this._label=z,this.kind=Y,this.runHandler=$,this._isDefault=N,this._tag=V,a.set(this,void 0),m.set(this,void 0),tt(this,a,O,"f"),tt(this,m,k,"f"),k.set(B,this);const H=R[Y];if(typeof H!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);Ue(this,a,"f").$publishTestRunProfile({profileId:B,controllerId:U,tag:V?v.TestTag.namespace(this.controllerId,V.id):null,label:z,group:H,isDefault:N,hasConfigurationHandler:!1})}dispose(){Ue(this,m,"f")?.delete(this.profileId)&&(tt(this,m,void 0,"f"),Ue(this,a,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=p,a=new WeakMap,m=new WeakMap;const R={[w.TestRunProfileKind.Coverage]:8,[w.TestRunProfileKind.Debug]:4,[w.TestRunProfileKind.Run]:2}}),define(ke[257],Pe([1,0,16,3,5,133,15,7]),function(Q,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class b{constructor(L,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new i.Emitter,this._onDidChangeTextEditorOptions=new i.Emitter,this._onDidChangeTextEditorVisibleRanges=new i.Emitter,this._onDidChangeTextEditorViewColumn=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(S=>this._onDidChangeVisibleTextEditors.fire(S)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(S=>this._onDidChangeActiveTextEditor.fire(S))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const P=this._extHostDocumentsAndEditors.allEditors();return L?P:P.map(S=>S.value)}async showTextDocument(L,P,S){let I;typeof P=="number"?I={position:C.ViewColumn.from(P),preserveFocus:S}:typeof P=="object"?I={position:C.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?C.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:I={preserveFocus:!1};const E=await this._proxy.$tryShowTextDocument(L.uri,I),v=E&&this._extHostDocumentsAndEditors.getEditor(E);if(v)return v.value;throw E?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,P){return new A.TextEditorDecorationType(this._proxy,L,P).value}$acceptEditorPropertiesChanged(L,P){const S=this._extHostDocumentsAndEditors.getEditor(L);if(!S)throw new Error("unknown text editor");if(P.options&&S._acceptOptions(P.options),P.selections){const I=P.selections.selections.map(C.Selection.to);S._acceptSelections(I)}if(P.visibleRanges){const I=u.coalesce(P.visibleRanges.map(C.Range.to));S._acceptVisibleRanges(I)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:S.value,options:{...P.options,lineNumbers:C.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const I=D.TextEditorSelectionChangeKind.fromValue(P.selections.source),E=P.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:S.value,selections:E,kind:I})}if(P.visibleRanges){const I=u.coalesce(P.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:S.value,visibleRanges:I})}}$acceptEditorPositionData(L){for(const P in L){const S=this._extHostDocumentsAndEditors.getEditor(P);if(!S)throw new Error("Unknown text editor");const I=C.ViewColumn.to(L[P]);S.value.viewColumn!==I&&(S._acceptViewColumn(I),this._onDidChangeTextEditorViewColumn.fire({textEditor:S.value,viewColumn:I}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=b}),define(ke[258],Pe([1,0,2,4,5,6,7,15,12]),function(Q,e,u,i,y,A,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,i.createDecorator)("IExtHostTimeline");class T{constructor(S,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=S.getProxy(y.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===11){const v=E.uri===void 0?void 0:u.URI.revive(E.uri);return this._itemsBySourceAndUriMap.get(E.source)?.get(L(v))?.get(E.handle)}return E}})}async $getTimeline(S,I,E,v){return this._providers.get(S)?.provideTimeline(u.URI.revive(I),E,v)}registerTimelineProvider(S,I,E,v){const w=new A.DisposableStore,g=this.convertTimelineItem(I.id,v,w).bind(this);let _;I.onDidChange&&(_=I.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:I.id}),this));const f=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:S,onDidChange:void 0,async provideTimeline(a,m,o){m?.resetCache&&(w.clear(),f.get(I.id)?.clear());const d=await I.provideTimeline(a,m,o);if(d==null)return;const r=g(a,m);return{...d,source:I.id,items:d.items.map(r)}},dispose(){for(const a of f.values())a.get(I.id)?.clear();_?.dispose(),w.dispose()}})}convertTimelineItem(S,I,E){return(v,w)=>{let g;if(w?.cacheResults){let _=this._itemsBySourceAndUriMap.get(S);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(S,_));const f=L(v);g=_.get(f),g===void 0&&(g=new Map,_.set(f,g))}return _=>{const{iconPath:f,...a}=_,m=`${S}|${_.id??_.timestamp}`;g?.set(m,_);let o,d,r;_.iconPath&&(f instanceof C.ThemeIcon?r={id:f.id,color:f.color}:u.URI.isUri(f)?(o=f,d=f):{light:o,dark:d}=f);let s;return C.MarkdownString.isMarkdownString(a.tooltip)?s=D.MarkdownString.from(a.tooltip):(0,b.isString)(a.tooltip)?s=a.tooltip:C.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=D.MarkdownString.from(a.detail)):(0,b.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=a.detail),{...a,id:a.id??void 0,handle:m,source:S,command:_.command?I.toInternal(_.command,E):void 0,icon:o,iconDark:d,themeIcon:r,tooltip:s,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(S){if(this._providers.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this._proxy.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this._providers.set(S.id,S),(0,A.toDisposable)(()=>{for(const E of this._itemsBySourceAndUriMap.values())E.get(S.id)?.clear();this._providers.delete(S.id),this._proxy.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=T;function L(P){return P?.toString()}}),define(ke[259],Pe([1,0,6,10,2,5]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(b){this._openers=new Map,this._proxy=b.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(b,T,L,P){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const S=P.schemes.find(I=>!C.supportedSchemes.has(I));if(S)throw new Error(`Scheme '${S}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,L),this._proxy.$registerUriOpener(T,P.schemes,b,P.label),(0,u.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(b,T,L){const P=this._openers.get(b);if(!P)throw new Error(`Unknown opener with id: ${b}`);const S=y.URI.revive(T);return P.canOpenExternalUri(S,L)}async $openUri(b,T,L){const P=this._openers.get(b);if(!P)throw new Error(`Unknown opener id: '${b}'`);return P.openExternalUri(y.URI.revive(T.resolvedUri),{sourceUri:y.URI.revive(T.sourceUri)},L)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([i.Schemas.http,i.Schemas.https])}),define(ke[260],Pe([1,0,5,2,6,11,26]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(u.MainContext.MainThreadUrls)}registerUriHandler(T,L){if(this.handles.has(C.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const P=D.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(T)),this.handlers.set(P,L),this._proxy.$registerUriHandler(P,T),(0,y.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(T)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(T,L){const P=this.handlers.get(T);if(!P)return Promise.resolve(void 0);try{P.handleUri(i.URI.revive(L))}catch(S){(0,A.onUnexpectedError)(S)}return Promise.resolve(void 0)}async createAppUri(T){return i.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=D,D.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Ue=this&&this.__classPrivateFieldGet||function(Q,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Q):i?i.value:e.get(Q)};define(ke[72],Pe([1,0,3,10,2,189,209,89,5]),function(Q,e,u,i,y,A,C,D,b){"use strict";var T,L,P,S,I,E,v,w,g,_,f,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(l,h,p,R,F,O,k){T.set(this,void 0),L.set(this,void 0),P.set(this,void 0),S.set(this,void 0),I.set(this,void 0),E.set(this,void 0),v.set(this,""),w.set(this,void 0),g.set(this,!1),_.set(this,!1),f.set(this,!1),this._onMessageEmitter=new u.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new u.Emitter),this._onDidDispose=Ue(this,a,"f").event,tt(this,T,l,"f"),tt(this,L,h,"f"),tt(this,w,p,"f"),tt(this,S,R,"f"),tt(this,I,F,"f"),tt(this,E,O,"f"),tt(this,f,o(O),"f"),tt(this,P,k,"f")}dispose(){tt(this,g,!0,"f"),Ue(this,a,"f").fire(),Ue(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(l){return tt(this,_,!0,"f"),(0,D.asWebviewUri)(l,Ue(this,S,"f"))}get cspSource(){const l=Ue(this,E,"f").extensionLocation;if(l.scheme===i.Schemas.https||l.scheme===i.Schemas.http){let h=l.toString();return h.endsWith("/")||(h+="/"),h+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,v,"f")}set html(l){this.assertNotDisposed(),Ue(this,v,"f")!==l&&(tt(this,v,l,"f"),!Ue(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(l)&&(tt(this,_,!0,"f"),Ue(this,P,"f").report("Webview vscode-resource: uris",Ue(this,E,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,L,"f").$setHtml(Ue(this,T,"f"),l))}get options(){return this.assertNotDisposed(),Ue(this,w,"f")}set options(l){this.assertNotDisposed(),Ue(this,L,"f").$setOptions(Ue(this,T,"f"),s(Ue(this,E,"f"),Ue(this,I,"f"),l)),tt(this,w,l,"f")}async postMessage(l){if(Ue(this,g,"f"))return!1;const h=(0,C.serializeWebviewMessage)(l,{serializeBuffersForPostMessage:Ue(this,f,"f")});return Ue(this,L,"f").$postMessage(Ue(this,T,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Ue(this,g,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,T=new WeakMap,L=new WeakMap,P=new WeakMap,S=new WeakMap,I=new WeakMap,E=new WeakMap,v=new WeakMap,w=new WeakMap,g=new WeakMap,_=new WeakMap,f=new WeakMap,a=new WeakMap;function o(c){try{const l=(0,A.normalizeVersion)((0,A.parseVersion)(c.engines.vscode));return!!l&&l.majorBase>=1&&l.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;class d{constructor(l,h,p,R,F){this.remoteInfo=h,this.workspace=p,this._logService=R,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=l.getProxy(b.MainContext.MainThreadWebviews)}$onMessage(l,h,p){const R=this.getWebview(l);if(R){const{message:F}=(0,C.deserializeWebviewMessage)(h,p.value);R._onMessageEmitter.fire(F)}}$onMissingCsp(l,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(l,h,p){const R=new m(l,this._webviewProxy,n(h),this.remoteInfo,this.workspace,p,this._deprecationService);return this._webviews.set(l,R),R._onDidDispose(()=>{this._webviews.delete(l)}),R}deleteWebview(l){this._webviews.delete(l)}getWebview(l){return this._webviews.get(l)}}e.ExtHostWebviews=d;function r(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=r;function s(c,l,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||t(c,l)}}e.serializeWebviewOptions=s;function n(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(l=>y.URI.from(l))}}e.reviveOptions=n;function t(c,l){return[...(l?.getWorkspaceFolders()||[]).map(h=>h.uri),c.extensionLocation]}}),define(ke[261],Pe([1,0,21,61,6,10,22,2,15,72,88,5,7]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class I{constructor(o,d){this.document=o,this._storagePath=d,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,d){await this.getEdit(o).undo(),d||this.disposeBackup()}async redo(o,d){await this.getEdit(o).redo(),d||this.disposeBackup()}disposeEdits(o){for(const d of o)this._edits.delete(d)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=a(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const d=this._edits.get(o,0);if(!d)throw new Error("No edit found");return d}}class E{constructor(){this._documents=new Map}get(o,d){return this._documents.get(this.key(o,d))}add(o,d,r){const s=this.key(o,d.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${o} resource:${d.uri}`);const n=new I(d,r);return this._documents.set(s,n),n}delete(o,d){const r=this.key(o,d.uri);this._documents.delete(r)}key(o,d){return`${o}@@@${d}`}}var v;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(v||(v={}));class w{constructor(){this._providers=new Map}addTextProvider(o,d,r){return this.add(0,o,d,r)}addCustomProvider(o,d,r){return this.add(1,o,d,r)}get(o){return this._providers.get(o)}add(o,d,r,s){if(this._providers.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this._providers.set(d,{type:o,extension:r,provider:s}),new S.Disposable(()=>this._providers.delete(d))}}class g{constructor(o,d,r,s,n){this._extHostDocuments=d,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=n,this._editorProviders=new w,this._documents=new E,this._proxy=o.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,d,r,s){const n=new y.DisposableStore;return _(r)?(n.add(this._editorProviders.addTextProvider(d,o,r)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(o),d,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(o))):(n.add(this._editorProviders.addCustomProvider(d,o,r)),this.supportEditing(r)&&n.add(r.onDidChangeCustomDocument(t=>{const c=this.getCustomDocumentEntry(d,t.document.uri);if(f(t)){const l=c.addEdit(t);this._proxy.$onDidEdit(t.document.uri,d,l,t.label)}else this._proxy.$onContentChange(t.document.uri,d)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(o),d,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(o))),S.Disposable.from(n,new S.Disposable(()=>{this._proxy.$unregisterEditorProvider(d)}))}async $createCustomDocument(o,d,r,s,n){const t=this._editorProviders.get(d);if(!t)throw new Error(`No provider found for '${d}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${d}'`);const c=D.URI.revive(o),l=await t.provider.openCustomDocument(c,{backupId:r,untitledDocumentData:s?.buffer},n);let h;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(d,l,h),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(o,d){const r=this._editorProviders.get(d);if(!r)throw new Error(`No provider found for '${d}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${d}'`);const s=D.URI.revive(o),{document:n}=this.getCustomDocumentEntry(d,s);this._documents.delete(d,n),n.dispose()}async $resolveWebviewEditor(o,d,r,s,n,t){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);const l=b.ViewColumn.to(n),h=this._extHostWebview.createNewWebview(d,s.webviewOptions,c.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(d,r,s.title,l,s.panelOptions,h,!0),R=D.URI.revive(o);switch(c.type){case 1:{const{document:F}=this.getCustomDocumentEntry(r,R);return c.provider.resolveCustomEditor(F,p,t)}case 0:{const F=this._extHostDocuments.getDocument(R);return c.provider.resolveCustomTextEditor(F,p,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,d,r){this.getCustomDocumentEntry(d,o).disposeEdits(r)}async $onMoveCustomEditor(o,d,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const n=this._extHostWebviewPanels.getWebviewPanel(o);if(!n)throw new Error("No webview found");const t=D.URI.revive(d),c=this._extHostDocuments.getDocument(t);await s.provider.moveCustomTextEditor(c,n,u.CancellationToken.None)}async $undo(o,d,r,s){return this.getCustomDocumentEntry(d,o).undo(r,s)}async $redo(o,d,r,s){return this.getCustomDocumentEntry(d,o).redo(r,s)}async $revert(o,d,r){const s=this.getCustomDocumentEntry(d,o);await this.getCustomEditorProvider(d).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(o,d,r){const s=this.getCustomDocumentEntry(d,o);await this.getCustomEditorProvider(d).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(o,d,r,s){const n=this.getCustomDocumentEntry(d,o);return this.getCustomEditorProvider(d).saveCustomDocumentAs(n.document,D.URI.revive(r),s)}async $backup(o,d,r){const s=this.getCustomDocumentEntry(d,o),t=await this.getCustomEditorProvider(d).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(t),t.id}getCustomDocumentEntry(o,d){const r=this._documents.get(o,D.URI.revive(d));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(o){const r=this._editorProviders.get(o)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(o){return!!o.onDidChangeCustomDocument}}e.ExtHostCustomEditors=g;function _(m){return typeof m.resolveCustomTextEditor=="function"}function f(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function a(m){const o=m.scheme===A.Schemas.file||m.scheme===A.Schemas.untitled?m.fsPath:m.toString();return(0,i.hash)(o)+""}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Ue=this&&this.__classPrivateFieldGet||function(Q,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Q):i?i.value:e.get(Q)};define(ke[262],Pe([1,0,3,6,2,35,15,72,5,7]),function(Q,e,u,i,y,A,C,D,b,T){"use strict";var L,P,S,I,E,v,w,g,_,f,a,m,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends i.Disposable{constructor(t,c,l,h){super();L.set(this,void 0),P.set(this,void 0),S.set(this,void 0),I.set(this,void 0),E.set(this,void 0),v.set(this,void 0),w.set(this,void 0),g.set(this,void 0),_.set(this,!0),f.set(this,void 0),a.set(this,!1),m.set(this,this._register(new u.Emitter)),this.onDidDispose=Ue(this,m,"f").event,o.set(this,this._register(new u.Emitter)),this.onDidChangeViewState=Ue(this,o,"f").event,tt(this,L,t,"f"),tt(this,P,c,"f"),tt(this,I,l,"f"),tt(this,S,h.viewType,"f"),tt(this,E,h.panelOptions,"f"),tt(this,g,h.viewColumn,"f"),tt(this,v,h.title,"f"),tt(this,f,h.active,"f")}dispose(){Ue(this,a,"f")||(tt(this,a,!0,"f"),Ue(this,m,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,L,"f")),Ue(this,I,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,I,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,S,"f")}get title(){return this.assertNotDisposed(),Ue(this,v,"f")}set title(t){this.assertNotDisposed(),Ue(this,v,"f")!==t&&(tt(this,v,t,"f"),Ue(this,P,"f").$setTitle(Ue(this,L,"f"),t))}get iconPath(){return this.assertNotDisposed(),Ue(this,w,"f")}set iconPath(t){this.assertNotDisposed(),Ue(this,w,"f")!==t&&(tt(this,w,t,"f"),Ue(this,P,"f").$setIconPath(Ue(this,L,"f"),y.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Ue(this,E,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,g,"f")=="number"&&Ue(this,g,"f")<0))return Ue(this,g,"f")}get active(){return this.assertNotDisposed(),Ue(this,f,"f")}get visible(){return this.assertNotDisposed(),Ue(this,_,"f")}_updateViewState(t){Ue(this,a,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(tt(this,f,t.active,"f"),tt(this,_,t.visible,"f"),tt(this,g,t.viewColumn,"f"),Ue(this,o,"f").fire({webviewPanel:this}))}reveal(t,c){this.assertNotDisposed(),Ue(this,P,"f").$reveal(Ue(this,L,"f"),{viewColumn:typeof t=="undefined"?void 0:C.ViewColumn.from(t),preserveFocus:!!c})}assertNotDisposed(){if(Ue(this,a,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,P=new WeakMap,S=new WeakMap,I=new WeakMap,E=new WeakMap,v=new WeakMap,w=new WeakMap,g=new WeakMap,_=new WeakMap,f=new WeakMap,a=new WeakMap,m=new WeakMap,o=new WeakMap;class r{static newHandle(){return(0,A.generateUuid)()}constructor(t,c,l){this.webviews=c,this.workspace=l,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(b.MainContext.MainThreadWebviewPanels)}createWebviewPanel(t,c,l,h,p={}){const R=typeof h=="object"?h.viewColumn:h,F={viewColumn:C.ViewColumn.from(R),preserveFocus:typeof h=="object"&&!!h.preserveFocus},O=(0,D.shouldSerializeBuffersForPostMessage)(t),k=r.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(t),k,c,{title:l,panelOptions:s(p),webviewOptions:(0,D.serializeWebviewOptions)(t,this.workspace,p),serializeBuffersForPostMessage:O},F);const U=this.webviews.createNewWebview(k,p,t);return this.createNewWebviewPanel(k,c,l,R,p,U,!0)}$onDidChangeWebviewPanelViewStates(t){const c=Object.keys(t);c.sort((l,h)=>{const p=t[l],R=t[h];return p.active?1:R.active?-1:+p.visible-+R.visible});for(const l of c){const h=this.getWebviewPanel(l);if(!h)continue;const p=t[l];h._updateViewState({active:p.active,visible:p.visible,viewColumn:C.ViewColumn.to(p.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,c,l){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:l,extension:t}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(t)}),new T.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(t,c,l,h){const p=this._serializers.get(c);if(!p)throw new Error(`No serializer found for '${c}'`);const{serializer:R,extension:F}=p,O=this.webviews.createNewWebview(t,l.webviewOptions,F),k=this.createNewWebviewPanel(t,c,l.title,h,l.panelOptions,O,l.active);await R.deserializeWebviewPanel(k,l.state)}createNewWebviewPanel(t,c,l,h,p,R,F){const O=new d(t,this._proxy,R,{viewType:c,title:l,viewColumn:h,panelOptions:p,active:F});return this._webviewPanels.set(t,O),O}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=r;function s(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Ue=this&&this.__classPrivateFieldGet||function(Q,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Q):i?i.value:e.get(Q)};define(ke[263],Pe([1,0,3,6,72,28,15,5,7]),function(Q,e,u,i,y,A,C,D,b){"use strict";var T,L,P,S,I,E,v,w,g,_,f,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends i.Disposable{constructor(r,s,n,t,c,l,h){super();T.set(this,void 0),L.set(this,void 0),P.set(this,void 0),S.set(this,void 0),I.set(this,void 0),E.set(this,!1),v.set(this,void 0),w.set(this,void 0),g.set(this,void 0),_.set(this,void 0),f.set(this,this._register(new u.Emitter)),this.onDidChangeVisibility=Ue(this,f,"f").event,a.set(this,this._register(new u.Emitter)),this.onDidDispose=Ue(this,a,"f").event,tt(this,P,n,"f"),tt(this,w,t,"f"),tt(this,T,r,"f"),tt(this,L,s,"f"),tt(this,S,c,"f"),tt(this,I,l,"f"),tt(this,v,h,"f")}dispose(){Ue(this,E,"f")||(tt(this,E,!0,"f"),Ue(this,a,"f").fire(),Ue(this,S,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,w,"f")}set title(r){this.assertNotDisposed(),Ue(this,w,"f")!==r&&(tt(this,w,r,"f"),Ue(this,L,"f").$setWebviewViewTitle(Ue(this,T,"f"),r))}get description(){return this.assertNotDisposed(),Ue(this,g,"f")}set description(r){this.assertNotDisposed(),Ue(this,g,"f")!==r&&(tt(this,g,r,"f"),Ue(this,L,"f").$setWebviewViewDescription(Ue(this,T,"f"),r))}get visible(){return Ue(this,v,"f")}get webview(){return Ue(this,S,"f")}get viewType(){return Ue(this,P,"f")}_setVisible(r){r===Ue(this,v,"f")||Ue(this,E,"f")||(tt(this,v,r,"f"),Ue(this,f,"f").fire())}get badge(){return this.assertNotDisposed(),(0,A.checkProposedApiEnabled)(Ue(this,I,"f"),"badges"),Ue(this,_,"f")}set badge(r){this.assertNotDisposed(),(0,A.checkProposedApiEnabled)(Ue(this,I,"f"),"badges"),!(r?.value===Ue(this,_,"f")?.value&&r?.tooltip===Ue(this,_,"f")?.tooltip)&&(tt(this,_,C.ViewBadge.from(r),"f"),Ue(this,L,"f").$setWebviewViewBadge(Ue(this,T,"f"),r))}show(r){this.assertNotDisposed(),Ue(this,L,"f").$show(Ue(this,T,"f"),!!r)}assertNotDisposed(){if(Ue(this,E,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,L=new WeakMap,P=new WeakMap,S=new WeakMap,I=new WeakMap,E=new WeakMap,v=new WeakMap,w=new WeakMap,g=new WeakMap,_=new WeakMap,f=new WeakMap,a=new WeakMap;class o{constructor(r,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,s,n,t){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:n,extension:r}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(r),s,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(r)}),new b.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(r,s,n,t,c){const l=this._viewProviders.get(s);if(!l)throw new Error(`No view provider found for '${s}'`);const{provider:h,extension:p}=l,R=this._extHostWebview.createNewWebview(r,{},p),F=new m(r,this._proxy,s,n,R,p,!0);this._webviewViews.set(r,F),await h.resolveWebviewView(F,{state:t},c)}async $onDidChangeWebviewViewVisibility(r,s){this.getWebviewView(r)._setVisible(s)}async $disposeWebviewView(r){const s=this.getWebviewView(r);this._webviewViews.delete(r),s.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const s=this._webviewViews.get(r);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=o}),define(ke[137],Pe([1,0,3,5,2,10,8,4,18]),function(Q,e,u,i,y,A,C,D,b){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let L=T=class{get state(){return this._state}constructor(S){this._onDidChangeWindowState=new u.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=T.InitialState,this._proxy=S.getProxy(i.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(I=>this.$onDidChangeWindowFocus(I))}$onDidChangeWindowFocus(S){S!==this._state.focused&&(this._state={...this._state,focused:S},this._onDidChangeWindowState.fire(this._state))}openUri(S,I){let E;if(typeof S=="string"){E=S;try{S=y.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,C.isFalsyOrWhitespace)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this._proxy.$openUri(S,E,I)}async asExternalUri(S,I){if((0,C.isFalsyOrWhitespace)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(S,I);return y.URI.from(E)}};e.ExtHostWindow=L,L.InitialState={focused:!0},e.ExtHostWindow=L=T=je([He(0,b.IExtHostRpcService)],L),e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(ke[264],Pe([1,0,9,64,35,37,6,5,2,18]),function(Q,e,u,i,y,A,C,D,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends C.Disposable{constructor(S,I){super();const E=S.getProxy(D.MainContext.MainThreadDownloadService);I.registerCommand(!1,"_workbench.downloadResource",async v=>{const w=b.URI.file((0,u.join)((0,i.tmpdir)(),(0,y.generateUuid)()));return await E.$download(v,w),w})}};e.ExtHostDownloadService=L,e.ExtHostDownloadService=L=je([He(0,T.IExtHostRpcService),He(1,A.IExtHostCommands)],L)}),define(ke[265],Pe([1,0,136,10,195,35]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends u.ExtHostLoggerService{doCreateLogger(b,T,L){return b.scheme===i.Schemas.file?new y.SpdLogLogger(L?.name||(0,A.generateUuid)(),b.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,T):super.doCreateLogger(b,T,L)}}e.ExtHostLoggerService=C}),define(ke[266],Pe([1,0,63,9,2,71,6,10,17,29]),function(Q,e,u,i,y,A,C,D,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends A.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(o){const d=await super._getWorkspaceStorageURI(o);if(d.scheme!==D.Schemas.file)return d;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const r=d.fsPath;let s=0;do{let n;s===0?n=r:n=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${s}`:`${r}-${s}`,await P(n);const t=i.join(n,"vscode.lock"),c=await v(this._logService,t,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),y.URI.file(n);s++}while(s<10);return d}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function P(m){try{await T.Promises.stat(m);return}catch{}try{await T.Promises.mkdir(m,{recursive:!0})}catch{}}const S=1e3,I=10*60*1e3;class E extends C.Disposable{constructor(o,d){super();this.logService=o,this.filename=d,this._timer=this._register(new b.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await w(o,d);(!r||r.pid!==process.pid)&&(o.info(`Lock '${d}': The lock was lost unexpectedly.`),this._timer.cancel());try{await T.Promises.utimes(d,new Date,new Date)}catch(s){o.error(s),o.info(`Lock '${d}': Could not update mtime.`)}},S)}dispose(){super.dispose();try{u.unlinkSync(this.filename)}catch{}}async setWillRelease(o){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+o};await T.Promises.writeFile(this.filename,JSON.stringify(d),{flag:"w"})}catch(d){this.logService.error(d)}}}async function v(m,o,d){try{const s={pid:process.pid,willReleaseAt:0};await T.Promises.writeFile(o,JSON.stringify(s),{flag:"wx"})}catch(s){m.error(s)}const r=await w(m,o);return!r||r.pid!==process.pid?d?(m.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),f(m,o)):(m.info(`Lock '${o}': Lock acquired.`),new E(m,o))}async function w(m,o){let d;try{d=await T.Promises.readFile(o)}catch(r){return m.error(r),null}try{return JSON.parse(String(d))}catch(r){return m.error(r),null}}async function g(m,o){let d;try{d=await T.Promises.stat(o)}catch(r){return m.error(r),0}return d.mtime.getTime()}function _(m){try{return process.kill(m,0),!0}catch{return!1}}async function f(m,o){const d=await w(m,o);if(!d)return m.info(`Lock '${o}': Could not read pid of lock holder.`),a(m,o);if(d.willReleaseAt){let c=d.willReleaseAt-Date.now();if(c<5e3){for(c>0?m.info(`Lock '${o}': The lockfile is scheduled to be released in ${c} ms.`):m.info(`Lock '${o}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,b.timeout)(Math.min(100,c)),await g(m,o)===0)return a(m,o);c=d.willReleaseAt-Date.now()}return a(m,o)}}if(!_(d.pid))return m.info(`Lock '${o}': The pid ${d.pid} appears to be gone.`),a(m,o);const r=await g(m,o),s=Date.now()-r;if(s<=I)return m.info(`Lock '${o}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;m.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,b.timeout)(2e3);const n=await g(m,o),t=Date.now()-n;return t<=I?(m.info(`Lock '${o}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null):(m.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),a(m,o))}async function a(m,o){m.info(`Lock '${o}': Deleting a stale lock.`);try{await T.Promises.unlink(o)}catch{}return v(m,o,!0)}}),define(ke[267],Pe([1,0,35,18,38]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends y.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,b,T){return this.createTerminalFromOptions({name:D,shellPath:b,shellArgs:T})}createTerminalFromOptions(D,b){const T=new y.ExtHostTerminal(this._proxy,(0,u.generateUuid)(),D,D.name);return this._terminals.push(T),T.create(D,this._serializeParentTerminal(D,b)),T.value}};e.ExtHostTerminalService=A,e.ExtHostTerminalService=A=je([He(0,i.IExtHostRpcService)],A)}),define(ke[268],Pe([1,0,5,18,178,6,27,2,42,22,29,7,13,53,3,123,94,14]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class _{constructor(l,h,p){this.remoteAddress=l,this.localAddress=h,this._dispose=p,this._onDispose=new E.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function f(c){const l=c.trim().split(`
`),h=[];return l.forEach(R=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);F&&F.length>=3&&h.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),h.reduce((R,F)=>(R[F.socket]=F,R),{})}e.getSockets=f;function a(...c){const l=[].concat(...c.map(o));return[...new Map(l.filter(h=>h.st==="0A").map(h=>{const p=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:m(p[0]),port:parseInt(p[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=a;function m(c){let l="";if(c.length===8)for(let h=c.length-2;h>=0;h-=2)l+=parseInt(c.substr(h,2),16),h!==0&&(l+=".");else for(let h=c.length-4;h>=0;h-=4)l+=parseInt(c.substr(h,4),16).toString(16),h!==0&&(l+=":");return l}e.parseIpAddress=m;function o(c){const l=c.trim().split(`
`),h=l.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return l.map(R=>R.trim().split(/\s+/).reduce((F,O,k)=>(F[h[k]||k]=O,F),{}))}e.loadConnectionTable=o;function d(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/server-main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function r(c){const l=c.trim().split(`
`),h=[];return l.forEach(p=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(p);R&&R.length>=4&&h.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),h}e.getRootProcesses=r;async function s(c,l,h){const p=h.reduce((F,O)=>(F[O.pid]=O,F),{}),R=[];return c.forEach(({socket:F,ip:O,port:k})=>{const U=l[F]?l[F].pid:void 0,B=U?p[U]?.cmd:void 0;U&&B&&!d(B)&&R.push({host:O,port:k,detail:B,pid:U})}),R}e.findPorts=s;function n(c,l,h){const p=new Map,R=r(l);for(const F of c){const O=h.get(F.port);if(O){p.set(F.port,O);continue}const k=R.find(U=>U.cmd.includes(`${F.port}`));if(k){let U=k,B;do B=R.find(z=>z.ppid===U.pid),B&&(U=B);while(B);p.set(F.port,{host:F.ip,port:F.port,pid:U.pid,detail:U.cmd,ppid:U.ppid})}else p.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return p}e.tryFindRootPorts=n;let t=class extends A.Disposable{constructor(l,h,p){super();this.logService=p,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new E.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=l.getProxy(u.MainContext.MainThreadTunnelService),S.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(l,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${l.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const p=await this._proxy.$openTunnel(h,l.displayName);if(p){const R=new _(p.remoteAddress,p.localAddress,()=>this._proxy.$closeTunnel(p.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(l){return Math.max(l*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(l,h){const p=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(p,{selector:l,provider:h}),this._proxy.$registerPortsAttributesProvider(l,p),new P.Disposable(()=>{this._portAttributesProviders.delete(p),this._proxy.$unregisterPortsAttributesProvider(p)})}async $providePortAttributes(l,h,p,R,F){const O=[];for(const U of l){const B=this._portAttributesProviders.get(U);if(!B)return[];O.push(...await Promise.all(h.map(async z=>B.provider.providePortAttributes(z,p,R,F))))}const k=O.filter(U=>!!U);return k.length>0?k.map(U=>({autoForwardAction:U.autoForwardAction,port:U.port})):[]}async $registerCandidateFinder(l){if(l&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=l;let h=new w.MovingAverage,p;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),F=(await this.findCandidatePorts()).filter(k=>(0,v.isLocalhost)(k.host)||(0,v.isAllInterfaces)(k.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(k=>k.port).join(", ")}`);const O=new Date().getTime()-R;h.update(O),(!p||JSON.stringify(p)!==JSON.stringify(F))&&(p=F,await this._proxy.$onFoundNewCandidates(p)),await new Promise(k=>setTimeout(()=>k(),this.calculateDelay(h.value)))}}async setTunnelFactory(l){if(l){if(l.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(l.candidatePortSource),l.showCandidatePort&&(this._showCandidatePort=l.showCandidatePort,this._proxy.$setCandidateFilter()),l.tunnelFactory){this._forwardPortProvider=l.tunnelFactory;let h=l.tunnelFeatures?.privacyOptions??[];l.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:y.localize(0,null),themeIcon:"lock"},{id:"public",label:y.localize(1,null),themeIcon:"eye"}]);const p=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,public:!!l.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(p)}}else this._forwardPortProvider=void 0;return(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(l,h){if(this._extensionTunnels.has(l.host)){const p=this._extensionTunnels.get(l.host);p.has(l.port)&&(h&&p.get(l.port).disposeListener.dispose(),await p.get(l.port).tunnel.dispose(),p.delete(l.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(l,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const p=this._forwardPortProvider(l,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),p!==void 0){const R=await p;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(l.remoteAddress.host)||this._extensionTunnels.set(l.remoteAddress.host,new Map);const F=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(l.remoteAddress.host).set(l.remoteAddress.port,{tunnel:R,disposeListener:F}),I.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(l){const h=await Promise.all(l.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),p=l.filter((R,F)=>h[F]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${l.map(R=>R.port).join(", ")} to ${p.map(R=>R.port).join(", ")}`),p}async findCandidatePorts(){let l="",h="";try{l=await L.Promises.readFile("/proc/net/tcp","utf8"),h=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const p=a(l,h),R=await new Promise($=>{(0,b.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(N,V,H)=>{$(V)})}),F=f(R),O=await L.Promises.readdir("/proc"),k=[];for(let $ of O)try{const N=Number($),V=T.joinPath(D.URI.file("/proc"),$);if((await L.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(N)){const q=await L.Promises.readlink(T.joinPath(V,"cwd").fsPath),te=await L.Promises.readFile(T.joinPath(V,"cmdline").fsPath,"utf8");k.push({pid:N,cwd:q,cmd:te})}}catch{}const U=[],B=p.filter($=>{const N=F[$.socket];return N||U.push($),N}),z=s(B,F,k);let Y;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${U.length}`),U.length>0){const $=await new Promise(N=>{(0,b.exec)("ps -F -A -l | grep root",(V,H,q)=>{N(H)})});this._foundRootPorts=n(U,$,this._foundRootPorts),Y=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Y.join(", ")}`)}return z.then($=>Y?$.concat(Y):$)}};e.ExtHostTunnelService=t,e.ExtHostTunnelService=t=je([He(0,i.IExtHostRpcService),He(1,C.IExtHostInitDataService),He(2,g.ILogService)],t)}),define(ke[269],Pe([1,0,17,23,21,11,3,6,104,232,54]),function(Q,e,u,i,y,A,C,D,b,T,L){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function S(p,R){try{return JSON.stringify(p,R)}catch{return"null"}}const I="$$ref$$",E={[I]:-1};class v{constructor(R,F){this.jsonString=R,this.referencedBuffers=F}}function w(p,R=null,F=!1){const O=[];return{jsonString:(F?S:JSON.stringify)(p,(U,B)=>{if(typeof B=="undefined")return E;if(typeof B=="object"){if(B instanceof i.VSBuffer){const z=O.push(B)-1;return{[I]:z}}if(R)return R(U,B)}return B}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=w;function g(p,R,F){return JSON.parse(p,(O,k)=>{if(k){const U=k[I];if(typeof U=="number")return R[U];if(F&&k.$mid===1)return F.transformIncoming(k)}return k})}e.parseJsonAndRestoreBufferRefs=g;function _(p,R){return JSON.stringify(p,R)}function f(p){return p?(R,F)=>F&&F.$mid===1?p.transformOutgoing(F):F:null}var a;(function(p){p[p.LocalSide=0]="LocalSide",p[p.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var m;(function(p){p[p.Responsive=0]="Responsive",p[p.Unresponsive=1]="Unresponsive"})(m||(e.ResponsiveState=m={}));const o=()=>{},d=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends D.Disposable{constructor(R,F=null,O=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new C.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=F,this._uriTransformer=O,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let k=0,U=L.ProxyIdentifier.count;k<U;k++)this._locals[k]=null,this._proxies[k]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new u.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(k=>this._receiveOneMessage(k))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,b.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:F,sid:O}=R;return this._proxies[F]||(this._proxies[F]=this._createProxy(F,O)),this._proxies[F]}_createProxy(R,F){let O={get:(k,U)=>(typeof U=="string"&&!k[U]&&U.charCodeAt(0)===36&&(k[U]=(...B)=>this._remoteCall(R,U,B)),U===r?F:k[U])};return new Proxy(Object.create(null),O)}set(R,F){return this._locals[R.nid]=F,F}assertRegistered(R){for(let F=0,O=R.length;F<O;F++){const k=R[F];if(!this._locals[k.nid])throw new Error(`Missing proxy instance ${k.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const F=R.byteLength,O=n.read(R,0),k=O.readUInt8(),U=O.readUInt32();switch(k){case 1:case 2:{let{rpcId:B,method:z,args:Y}=c.deserializeRequestJSONArgs(O);this._uriTransformer&&(Y=(0,b.transformIncomingURIs)(Y,this._uriTransformer)),this._receiveRequest(F,U,B,z,Y,k===2);break}case 3:case 4:{let{rpcId:B,method:z,args:Y}=c.deserializeRequestMixedArgs(O);this._uriTransformer&&(Y=(0,b.transformIncomingURIs)(Y,this._uriTransformer)),this._receiveRequest(F,U,B,z,Y,k===4);break}case 5:{this._logger&&this._logger.logIncoming(F,U,0,"ack"),this._onDidReceiveAcknowledge(U);break}case 6:{this._receiveCancel(F,U);break}case 7:{this._receiveReply(F,U,void 0);break}case 9:{let B=c.deserializeReplyOKJSON(O);this._uriTransformer&&(B=(0,b.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReply(F,U,B);break}case 10:{const B=c.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(F,U,B);break}case 8:{let B=c.deserializeReplyOKVSBuffer(O);this._receiveReply(F,U,B);break}case 11:{let B=c.deserializeReplyErrError(O);this._uriTransformer&&(B=(0,b.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReplyErr(F,U,B);break}case 12:{this._receiveReplyErr(F,U,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,F,O,k,U,B){this._logger&&this._logger.logIncoming(R,F,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(O)}.${k}(`,U);const z=String(F);let Y,$;if(B){const V=new y.CancellationTokenSource;U.push(V.token),Y=this._invokeHandler(O,k,U),$=()=>V.cancel()}else Y=this._invokeHandler(O,k,U),$=o;this._cancelInvokedHandlers[z]=$;const N=c.serializeAcknowledged(F);this._logger&&this._logger.logOutgoing(N.byteLength,F,1,"ack"),this._protocol.send(N),Y.then(V=>{delete this._cancelInvokedHandlers[z];const H=c.serializeReplyOK(F,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(H.byteLength,F,1,"reply:",V),this._protocol.send(H)},V=>{delete this._cancelInvokedHandlers[z];const H=c.serializeReplyErr(F,V);this._logger&&this._logger.logOutgoing(H.byteLength,F,1,"replyErr:",V),this._protocol.send(H)})}_receiveCancel(R,F){this._logger&&this._logger.logIncoming(R,F,1,"receiveCancel");const O=String(F);this._cancelInvokedHandlers[O]&&this._cancelInvokedHandlers[O]()}_receiveReply(R,F,O){this._logger&&this._logger.logIncoming(R,F,0,"receiveReply:",O);const k=String(F);if(!this._pendingRPCReplies.hasOwnProperty(k))return;const U=this._pendingRPCReplies[k];delete this._pendingRPCReplies[k],U.resolveOk(O)}_receiveReplyErr(R,F,O){this._logger&&this._logger.logIncoming(R,F,0,"receiveReplyErr:",O);const k=String(F);if(!this._pendingRPCReplies.hasOwnProperty(k))return;const U=this._pendingRPCReplies[k];delete this._pendingRPCReplies[k];let B;O&&(O.$isError?(B=new Error,B.name=O.name,B.message=O.message,B.stack=O.stack):B=O),U.resolveErr(B)}_invokeHandler(R,F,O){try{return Promise.resolve(this._doInvokeHandler(R,F,O))}catch(k){return Promise.reject(k)}}_doInvokeHandler(R,F,O){const k=this._locals[R];if(!k)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(R));let U=k[F];if(typeof U!="function")throw new Error("Unknown method "+F+" on actor "+(0,L.getStringIdentifierForProxy)(R));return U.apply(k,O)}_remoteCall(R,F,O){if(this._isDisposed)return Promise.reject(A.canceled());let k=null;if(O.length>0&&y.CancellationToken.isCancellationToken(O[O.length-1])&&(k=O.pop()),k&&k.isCancellationRequested)return Promise.reject(A.canceled());const U=c.serializeRequestArguments(O,this._uriReplacer),B=++this._lastMessageId,z=String(B),Y=new T.LazyPromise;k&&k.onCancellationRequested(()=>{const N=c.serializeCancel(B);this._logger&&this._logger.logOutgoing(N.byteLength,B,0,"cancel"),this._protocol.send(c.serializeCancel(B))}),this._pendingRPCReplies[z]=Y,this._onWillSendRequest(B);const $=c.serializeRequest(B,R,F,U,!!k);return this._logger&&this._logger.logOutgoing($.byteLength,B,0,`request: ${(0,L.getStringIdentifierForProxy)(R)}.${F}(`,O),this._protocol.send($),Y}}e.RPCProtocol=s,P=d,s.UNRESPONSIVE_TIME=3*1e3;class n{static alloc(R,F,O){let k=new n(i.VSBuffer.alloc(O+1+4),0);return k.writeUInt8(R),k.writeUInt32(F),k}static read(R,F){return new n(R,F)}get buffer(){return this._buff}constructor(R,F){this._buff=R,this._offset=F}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,O}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,O}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,F}static sizeMixedArray(R){let F=0;F+=1;for(let O=0,k=R.length;O<k;O++){const U=R[O];switch(F+=1,U.type){case 1:F+=this.sizeLongString(U.value);break;case 2:F+=this.sizeVSBuffer(U.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(U.value);for(let B=0;B<U.buffers.length;++B)F+=this.sizeVSBuffer(U.buffers[B]);break;case 4:break}}return F}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let F=0,O=R.length;F<O;F++){const k=R[F];switch(k.type){case 1:this.writeUInt8(1),this.writeLongString(k.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(k.value);break;case 3:this.writeUInt8(3),this.writeUInt32(k.buffers.length),this.writeLongString(k.value);for(let U=0;U<k.buffers.length;++U)this.writeBuffer(k.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let F=new Array(R);for(let O=0;O<R;O++)switch(this.readUInt8()){case 1:F[O]=this.readLongString();break;case 2:F[O]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),B=this.readLongString(),z=[];for(let Y=0;Y<U;++Y)z.push(this.readVSBuffer());F[O]=new L.SerializableObjectWithBuffers(g(B,z,null));break}case 4:F[O]=void 0;break}return F}}n.sizeUInt32=4;var t;(function(p){p[p.Simple=0]="Simple",p[p.Mixed=1]="Mixed"})(t||(t={}));class c{static _useMixedArgSerialization(R){for(let F=0,O=R.length;F<O;F++)if(R[F]instanceof i.VSBuffer||R[F]instanceof L.SerializableObjectWithBuffers||typeof R[F]=="undefined")return!0;return!1}static serializeRequestArguments(R,F){if(this._useMixedArgSerialization(R)){const O=[];for(let k=0,U=R.length;k<U;k++){const B=R[k];if(B instanceof i.VSBuffer)O[k]={type:2,value:B};else if(typeof B=="undefined")O[k]={type:4};else if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:Y}=w(B.value,F);O[k]={type:3,value:i.VSBuffer.fromString(z),buffers:Y}}else O[k]={type:1,value:i.VSBuffer.fromString(_(B,F))}}return{type:1,args:O}}return{type:0,args:_(R,F)}}static serializeRequest(R,F,O,k,U){switch(k.type){case 0:return this._requestJSONArgs(R,F,O,k.args,U);case 1:return this._requestMixedArgs(R,F,O,k.args,U)}}static _requestJSONArgs(R,F,O,k,U){const B=i.VSBuffer.fromString(O),z=i.VSBuffer.fromString(k);let Y=0;Y+=n.sizeUInt8(),Y+=n.sizeShortString(B),Y+=n.sizeLongString(z);let $=n.alloc(U?2:1,R,Y);return $.writeUInt8(F),$.writeShortString(B),$.writeLongString(z),$.buffer}static deserializeRequestJSONArgs(R){const F=R.readUInt8(),O=R.readShortString(),k=R.readLongString();return{rpcId:F,method:O,args:JSON.parse(k)}}static _requestMixedArgs(R,F,O,k,U){const B=i.VSBuffer.fromString(O);let z=0;z+=n.sizeUInt8(),z+=n.sizeShortString(B),z+=n.sizeMixedArray(k);let Y=n.alloc(U?4:3,R,z);return Y.writeUInt8(F),Y.writeShortString(B),Y.writeMixedArray(k),Y.buffer}static deserializeRequestMixedArgs(R){const F=R.readUInt8(),O=R.readShortString(),k=R.readMixedArray(),U=new Array(k.length);for(let B=0,z=k.length;B<z;B++){const Y=k[B];typeof Y=="string"?U[B]=JSON.parse(Y):U[B]=Y}return{rpcId:F,method:O,args:U}}static serializeAcknowledged(R){return n.alloc(5,R,0).buffer}static serializeCancel(R){return n.alloc(6,R,0).buffer}static serializeReplyOK(R,F,O){if(typeof F=="undefined")return this._serializeReplyOKEmpty(R);if(F instanceof i.VSBuffer)return this._serializeReplyOKVSBuffer(R,F);if(F instanceof L.SerializableObjectWithBuffers){const{jsonString:k,referencedBuffers:U}=w(F.value,O,!0);return this._serializeReplyOKJSONWithBuffers(R,k,U)}else return this._serializeReplyOKJSON(R,S(F,O))}static _serializeReplyOKEmpty(R){return n.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,F){let O=0;O+=n.sizeVSBuffer(F);let k=n.alloc(8,R,O);return k.writeVSBuffer(F),k.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,F){const O=i.VSBuffer.fromString(F);let k=0;k+=n.sizeLongString(O);let U=n.alloc(9,R,k);return U.writeLongString(O),U.buffer}static _serializeReplyOKJSONWithBuffers(R,F,O){const k=i.VSBuffer.fromString(F);let U=0;U+=n.sizeUInt32,U+=n.sizeLongString(k);for(const z of O)U+=n.sizeVSBuffer(z);let B=n.alloc(10,R,U);B.writeUInt32(O.length),B.writeLongString(k);for(const z of O)B.writeBuffer(z);return B.buffer}static deserializeReplyOKJSON(R){const F=R.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(R,F){const O=R.readUInt32(),k=R.readLongString(),U=[];for(let B=0;B<O;++B)U.push(R.readVSBuffer());return new L.SerializableObjectWithBuffers(g(k,U,F))}static serializeReplyErr(R,F){const O=F?S(A.transformErrorForSerialization(F),null):void 0;if(typeof O!="string")return this._serializeReplyErrEmpty(R);const k=i.VSBuffer.fromString(O);let U=0;U+=n.sizeLongString(k);let B=n.alloc(11,R,U);return B.writeLongString(k),B.buffer}static deserializeReplyErrError(R){const F=R.readLongString();return JSON.parse(F)}static _serializeReplyErrEmpty(R){return n.alloc(12,R,0).buffer}}var l;(function(p){p[p.RequestJSONArgs=1]="RequestJSONArgs",p[p.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",p[p.RequestMixedArgs=3]="RequestMixedArgs",p[p.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",p[p.Acknowledged=5]="Acknowledged",p[p.Cancel=6]="Cancel",p[p.ReplyOKEmpty=7]="ReplyOKEmpty",p[p.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",p[p.ReplyOKJSON=9]="ReplyOKJSON",p[p.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",p[p.ReplyErrError=11]="ReplyErrError",p[p.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var h;(function(p){p[p.String=1]="String",p[p.VSBuffer=2]="VSBuffer",p[p.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",p[p.Undefined=4]="Undefined"})(h||(h={}))}),define(ke[270],Pe([1,0,3,44,52,4,43,11,17]),function(Q,e,u,i,y,A,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)(e.OUTPUT_SERVICE_ID);var T;(function(I){I[I.Append=1]="Append",I[I.Replace=2]="Replace",I[I.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.channels=new Map,this._onDidRegisterChannel=new u.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new u.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(E){this.channels.has(E.id)||(this.channels.set(E.id,E),this._onDidRegisterChannel.fire(E.id))}getChannels(){const E=[];return this.channels.forEach(v=>E.push(v)),E}getChannel(E){return this.channels.get(E)}removeChannel(E){this.channels.delete(E),this._onDidRemoveChannel.fire(E)}}i.Registry.add(e.Extensions.OutputChannels,new L);function P(I,E,v,w,g){return(0,b.createCancelablePromise)(async _=>{await(0,C.whenProviderRegistered)(v,w);const f=i.Registry.as(e.Extensions.OutputChannels);try{await S(v,1,w,g,_),f.registerChannel({id:I,label:E,file:v,log:!0})}catch(a){(0,D.isCancellationError)(a)||g.error("Error while registering log channel",v.toString(),(0,D.getErrorMessage)(a))}})}e.registerLogChannel=P;async function S(I,E,v,w,g){if(!await v.exists(I)){if(g.isCancellationRequested)throw new D.CancellationError;if(E>10)throw new Error("Timed out while waiting for file to be created");w.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",I.toString()),await(0,b.timeout)(1e3,g),await S(I,E+1,v,w,g)}}}),define(ke[138],Pe([1,0,5,6,4,18,14,270,70,27,46,159,23,12]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends i.Disposable{get disposed(){return this._disposed}constructor(g,_,f,a){super();this.id=g,this.name=_,this.logger=f,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}appendLine(g){this.append(g+`
`)}append(g){this.write(g),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Append))}clear(){const g=this.offset;this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Clear,g)}replace(g){const _=this.offset;this.write(g),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Replace,_),this.visible&&this.logger.flush()}show(g,_){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof g=="boolean"?g:_))}hide(){this.proxy.$close(this.id)}write(g){this.offset+=S.VSBuffer.fromString(g).byteLength,this.logger.info(g)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let v=class{constructor(g,_,f,a,m){this.extHostFileSystem=f,this.extHostFileSystemInfo=a,this.loggerService=m,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=g.getProxy(u.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(_.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.visibleChannelId=g;for(const[_,f]of this.channels)f.visible=_===this.visibleChannelId}createOutputChannel(g,_,f){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");if((0,I.isString)(_)&&!_.trim())throw new Error("illegal argument `languageId`. must not be empty");const a=this.doCreateOutputChannel(g,_,f);return a.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(g,a)}async doCreateOutputChannel(g,_,f){const a=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(a,`${this.namePool++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.proxy.$register(g,!1,m,_,f.identifier.value);return new E(d,g,o,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(g,_){let f=!1;const a=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return g},append(m){a(),_.then(o=>o.append(m))},appendLine(m){a(),_.then(o=>o.appendLine(m))},clear(){a(),_.then(m=>m.clear())},replace(m){a(),_.then(o=>o.replace(m))},show(m,o){a(),_.then(d=>d.show(m,o))},hide(){a(),_.then(m=>m.hide())},dispose(){f=!0,_.then(m=>m.dispose())}}}};e.ExtHostOutputService=v,e.ExtHostOutputService=v=je([He(0,A.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,b.IExtHostConsumerFileSystem),He(3,L.IExtHostFileSystemInfo),He(4,C.ILoggerService)],v),e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(ke[271],Pe([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,u.createDecorator)("remoteAgentService")}),define(ke[272],Pe([1,0,30,10,9,13,22,2,4,204,45,224,271]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,b.createDecorator)("pathService");let E=I=class{constructor(w,g,_,f){this.localUserHome=w,this.remoteAgentService=g,this.environmentService=_,this.contextService=f,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const a=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=a?.userHome??w})()}hasValidBasename(w,g,_){return typeof g=="string"||typeof g=="undefined"?this.resolveOS.then(f=>this.doHasValidBasename(w,f,g)):this.doHasValidBasename(w,g,_)}doHasValidBasename(w,g,_){return w.scheme===i.Schemas.file||w.scheme===i.Schemas.vscodeRemote?(0,u.isValidBasename)(_??(0,C.basename)(w),g===1):!0}get defaultUriScheme(){return I.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(w,g){if(w.remoteAuthority)return i.Schemas.vscodeRemote;const _=(0,T.getVirtualWorkspaceScheme)(g.getWorkspace());if(_)return _;const f=g.getWorkspace().folders[0];if(f)return f.uri.scheme;const a=g.getWorkspace().configuration;return a?a.scheme:i.Schemas.file}userHome(w){return w?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(w=>w===1?y.win32:y.posix)}async fileURI(w){let g="";if(await this.resolveOS===1&&(w=w.replace(/\\/g,"/")),w[0]==="/"&&w[1]==="/"){const f=w.indexOf("/",2);f===-1?(g=w.substring(2),w="/"):(g=w.substring(2,f),w=w.substring(f)||"/")}return D.URI.from({scheme:i.Schemas.file,authority:g,path:w,query:"",fragment:""})}};e.AbstractPathService=E,e.AbstractPathService=E=I=je([He(1,S.IRemoteAgentService),He(2,P.IWorkbenchEnvironmentService),He(3,L.IWorkspaceContextService)],E)}),define(ke[73],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class u{constructor(C,D){this.line=C,this.character=D}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,D){return new u(0,0)}with(C){return new u(0,0)}}e.Position=u;class i{constructor(C,D,b,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(C,D),this.end=new u(b,T)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new i(0,0,0,0)}with(C){return new i(0,0,0,0)}}e.Range=i;var y;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(y||(e.TextSearchCompleteMessageType=y={}))}),define(ke[31],Pe([1,0,16,34,24,30,8,4,9,11,73,17]),function(Q,e,u,i,y,A,C,D,b,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const S="\u27EA ",I=" characters skipped \u27EB",E=(S.length+I.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var v;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(v||(e.SearchProviderType=v={}));var w;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(w||(e.QueryType=w={}));function g(q){return!!q.preview}e.resultIsMatch=g;function _(q){return!!q.resource}e.isFileMatch=_;function f(q){return!!q.message}e.isProgressMessage=f;var a;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class m{constructor(te){this.resource=te,this.results=[]}}e.FileMatch=m;class o{constructor(te,fe,ne){this.ranges=fe;const le=Array.isArray(fe)?fe:[fe];if(ne&&ne.matchLines===1&&d(le)){te=(0,C.getNLines)(te,ne.matchLines);let K="",ge=0,ve=0;const se=Math.floor(ne.charsPerLine/5),be=[];for(const Te of le){const pe=Math.max(Te.startColumn-se,0),we=Te.startColumn+ne.charsPerLine;if(pe>ve+se+E){const Ae=S+(pe-ve)+I;K+=Ae+te.slice(pe,we),ge+=pe-(ve+Ae.length)}else K+=te.slice(ve,we);be.push(new s(0,Te.startColumn-ge,Te.endColumn-ge)),ve=we}this.preview={text:K,matches:Array.isArray(this.ranges)?be:be[0]}}else{const K=Array.isArray(fe)?fe[0].startLineNumber:fe.startLineNumber;this.preview={text:te,matches:(0,u.mapArrayOrNot)(fe,ge=>new r(ge.startLineNumber-K,ge.startColumn,ge.endLineNumber-K,ge.endColumn))}}}}e.TextSearchMatch=o;function d(q){const te=q[0].startLineNumber;for(const fe of q)if(fe.startLineNumber!==te||fe.endLineNumber!==te)return!1;return!0}class r{constructor(te,fe,ne,le){this.startLineNumber=te,this.startColumn=fe,this.endLineNumber=ne,this.endColumn=le}}e.SearchRange=r;class s extends r{constructor(te,fe,ne){super(te,fe,te,ne)}}e.OneLineRange=s;var n;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(n||(e.SearchSortOrder=n={}));function t(q,te=!0){const fe=q&&q.files&&q.files.exclude,ne=te&&q&&q.search&&q.search.exclude;if(!fe&&!ne)return;if(!fe||!ne)return fe||ne;let le=Object.create(null);return le=y.mixin(le,y.deepClone(fe)),le=y.mixin(le,y.deepClone(ne),!0),le}e.getExcludes=t;function c(q,te){return q.excludePattern&&i.match(q.excludePattern,te)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&i.match(q.includePattern,te)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(fe=>{const ne=fe.folder.fsPath;if(A.isEqualOrParent(te,ne)){const le=b.relative(ne,te);return!fe.includePattern||!!i.match(fe.includePattern,le)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var l;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(l||(e.SearchErrorCode=l={}));class h extends Error{constructor(te,fe){super(te);this.code=fe}}e.SearchError=h;function p(q){const te=q.message;if((0,T.isCancellationError)(q))return new h(te,l.canceled);try{const fe=JSON.parse(te);return new h(fe.message,fe.code)}catch{return new h(te,l.other)}}e.deserializeSearchError=p;function R(q){const te={message:q.message,code:q.code};return new Error(JSON.stringify(te))}e.serializeSearchError=R;function F(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=F;function O(q){return q.type==="success"}e.isSerializedSearchSuccess=O;function k(q){return!!q.path}e.isSerializedFileMatch=k;function U(q,te){const fe=q.searchPath?q.searchPath:q.relativePath;return(0,C.fuzzyContains)(fe,te)}e.isFilePatternMatch=U;class B{constructor(te){this.path=te,this.results=[]}addMatch(te){this.results.push(te)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=B;function z(q,te){const fe={...q||{},...te||{}};return Object.keys(fe).filter(ne=>{const le=fe[ne];return typeof le=="boolean"&&le})}e.resolvePatternsForProvider=z;class Y{constructor(te,fe){this._parsedIncludeExpression=null,this._excludeExpression={...te.excludePattern||{},...fe.excludePattern||{}},this._parsedExcludeExpression=i.parse(this._excludeExpression);let ne=te.includePattern;fe.includePattern&&(ne?ne={...ne,...fe.includePattern}:ne=fe.includePattern),ne&&(this._parsedIncludeExpression=i.parse(ne))}matchesExcludesSync(te,fe,ne){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(te,fe,ne))}includedInQuerySync(te,fe,ne){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(te,fe,ne)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(te,fe,ne))}includedInQuery(te,fe,ne){const le=this._parsedExcludeExpression(te,fe,ne),K=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(te,fe,ne):!0;return(0,P.isThenable)(le)?le.then(ge=>ge?!1:K()):K()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=Y;function $(q){for(const te in q)if(typeof q[te]!="boolean")return!0;return!1}function N(q){if(!q)return;let te;return fe=>(te||(te=(q()||Promise.resolve([])).then(ne=>ne?H(ne):{})),te.then(ne=>!!ne[fe]))}e.hasSiblingPromiseFn=N;function V(q){if(!q)return;let te;return fe=>{if(!te){const ne=q();te=ne?H(ne):{}}return!!te[fe]}}e.hasSiblingFn=V;function H(q){const te={};for(const fe of q)te[fe]=!0;return te}}),define(ke[32],Pe([1,0,16,17,21,3,25,10,94,22,8,12,2,176,4,14,196,45,46,27,18,15,7,31,5]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_,f,a,m,o,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(F,O,k){return new T.ExtUri(U=>l(U,k)).isEqual(F,O)}function n(F,O,k){return s(F.uri,O.uri,k)?0:(0,L.compare)(F.uri.toString(),O.uri.toString())}function t(F,O,k){return F.index!==O.index?F.index<O.index?-1:1:s(F.uri,O.uri,k)?(0,L.compare)(F.name,O.name):(0,L.compare)(F.uri.toString(),O.uri.toString())}function c(F,O,k,U){const B=F.slice(0).sort((Y,$)=>k(Y,$,U)),z=O.slice(0).sort((Y,$)=>k(Y,$,U));return(0,u.delta)(B,z,(Y,$)=>k(Y,$,U))}function l(F,O){const k=O.getCapabilities(F.scheme);return!(k&&k&1024)}class h extends g.Workspace{static toExtHostWorkspace(O,k,U,B){if(!O)return{workspace:null,added:[],removed:[]};const{id:z,name:Y,folders:$,configuration:N,transient:V,isUntitled:H}=O,q=[],te=k;k?$.forEach((K,ge)=>{const ve=S.URI.revive(K.uri),se=h._findFolder(U||k,ve,B);se?(se.name=K.name,se.index=K.index,q.push(se)):q.push({uri:ve,name:K.name,index:ge})}):q.push(...$.map(({uri:K,name:ge,index:ve})=>({uri:S.URI.revive(K),name:ge,index:ve}))),q.sort((K,ge)=>K.index<ge.index?-1:1);const fe=new h(z,Y,q,!!V,N?S.URI.revive(N):null,!!H,K=>l(K,B)),{added:ne,removed:le}=c(te?te.workspaceFolders:[],fe.workspaceFolders,n,B);return{workspace:fe,added:ne,removed:le}}static _findFolder(O,k,U){for(let B=0;B<O.folders.length;B++){const z=O.workspaceFolders[B];if(s(z.uri,k,U))return z}}constructor(O,k,U,B,z,Y,$){super(O,U.map(N=>new g.WorkspaceFolder(N)),B,z,$);this._name=k,this._isUntitled=Y,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris($),U.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,k){return k&&this._structure.get(O)&&(O=(0,T.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let p=class{constructor(O,k,U,B){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=B,this._extHostFileSystemInfo=U,this._requestIdProvider=new b.Counter,this._barrier=new i.Barrier,this._proxy=O.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(r.MainContext.MainThreadMessageService);const z=k.workspace;this._confirmedWorkspace=z?new h(z.id,z.name,[],!!z.transient,z.configuration?S.URI.revive(z.configuration):null,!!z.isUntitled,Y=>l(Y,U)):void 0}$initializeWorkspace(O,k){this._trusted=k,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?S.URI.from({scheme:D.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,k,U,...B){const z=[];if(Array.isArray(B)&&B.forEach(H=>{S.URI.isUri(H.uri)&&!z.some(q=>s(q.uri,H.uri,this._extHostFileSystemInfo))&&z.push({uri:H.uri,name:H.name||(0,T.basenameOrAuthority)(H.uri)})}),this._unconfirmedWorkspace||[k,U].some(H=>typeof H!="number"||H<0)||U===0&&z.length===0)return!1;const Y=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(k+U>Y.length)return!1;const $=Y.slice(0);$.splice(k,U,...z.map(H=>({uri:H.uri,name:H.name||(0,T.basenameOrAuthority)(H.uri),index:void 0})));for(let H=0;H<$.length;H++){const q=$[H];if($.some((te,fe)=>fe!==H&&s(q.uri,te.uri,this._extHostFileSystemInfo)))return!1}$.forEach((H,q)=>H.index=q);const{added:N,removed:V}=c(Y,$,t,this._extHostFileSystemInfo);if(N.length===0&&V.length===0)return!1;if(this._proxy){const H=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(H,k,U,z).then(void 0,q=>{this._unconfirmedWorkspace=void 0;const te={source:{identifier:O.identifier,label:O.displayName||O.name}};this._messageService.$showMessage(w.Severity.Error,(0,I.localize)(0,null,H,q.toString()),te,[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(O,k){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,k)}async getWorkspaceFolder2(O,k){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,k)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,k){let U,B="";if(typeof O=="string"?(U=S.URI.file(O),B=O):typeof O!="undefined"&&(U=O,B=O.fsPath),!U)return B;const z=this.getWorkspaceFolder(U,!0);if(!z)return B;typeof k=="undefined"&&this._actualWorkspace&&(k=this._actualWorkspace.folders.length>1);let Y=(0,T.relativePath)(z.uri,U);return k&&z.name&&(Y=`${z.name}/${Y}`),Y}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:k,added:U,removed:B}=h.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=k||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:B}))}findFiles(O,k,U,B,z=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let Y;if(k===null?Y=!1:k&&(typeof k=="string"?Y=k:Y=k.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:N}=R(m.GlobPattern.from(O));return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)($),(0,P.withUndefinedAsNull)(N),(0,P.withUndefinedAsNull)(Y),(0,P.withUndefinedAsNull)(U),z).then(V=>Array.isArray(V)?V.map(H=>S.URI.revive(H)):[])}async findTextInFiles(O,k,U,B,z=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const Y=this._requestIdProvider.getNext(),$=typeof k.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:k.previewOptions,{includePattern:N,folder:V}=R(m.GlobPattern.from(k.include)),H=typeof k.exclude=="string"?k.exclude:k.exclude?k.exclude.pattern:void 0,q={ignoreSymlinks:typeof k.followSymlinks=="boolean"?!k.followSymlinks:void 0,disregardIgnoreFiles:typeof k.useIgnoreFiles=="boolean"?!k.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof k.useGlobalIgnoreFiles=="boolean"?!k.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof k.useParentIgnoreFiles=="boolean"?!k.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof k.useDefaultExcludes=="boolean"?!k.useDefaultExcludes:!0,fileEncoding:k.encoding,maxResults:k.maxResults,previewOptions:$,afterContext:k.afterContext,beforeContext:k.beforeContext,includePattern:N,excludePattern:H},te=!1;if(this._activeSearchCallbacks[Y]=fe=>{if(te)return;const ne=S.URI.revive(fe.resource);fe.results.forEach(le=>{(0,d.resultIsMatch)(le)?U({uri:ne,preview:{text:le.preview.text,matches:(0,u.mapArrayOrNot)(le.preview.matches,K=>new o.Range(K.startLineNumber,K.startColumn,K.endLineNumber,K.endColumn))},ranges:(0,u.mapArrayOrNot)(le.ranges,K=>new o.Range(K.startLineNumber,K.startColumn,K.endLineNumber,K.endColumn))}):U({uri:ne,text:le.text,lineNumber:le.lineNumber})})},z.isCancellationRequested)return{};try{const fe=await this._proxy.$startTextSearch(O,(0,P.withUndefinedAsNull)(V),q,Y,z);return delete this._activeSearchCallbacks[Y],fe||{}}catch(fe){throw delete this._activeSearchCallbacks[Y],fe}}$handleTextSearchResult(O,k){this._activeSearchCallbacks[k]&&this._activeSearchCallbacks[k](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};e.ExtHostWorkspace=p,e.ExtHostWorkspace=p=je([He(0,a.IExtHostRpcService),He(1,f.IExtHostInitDataService),He(2,_.IExtHostFileSystemInfo),He(3,v.ILogService)],p),e.IExtHostWorkspace=(0,E.createDecorator)("IExtHostWorkspace");function R(F){let O,k;return F&&(typeof F=="string"?O=F:(O=F.pattern,k=S.URI.revive(F.baseUri))),{includePattern:O,folder:k}}}),define(ke[33],Pe([1,0,24,3,32,5,7,199,120,12,17,4,18,14,2]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(d,r){if(r){const s=r.split(".");let n=d;for(let t=0;n&&t<s.length;t++)n=n[s[t]];return n}}function w(d){return d instanceof E.URI}function g(d){return d&&d.uri instanceof E.URI&&d.languageId&&typeof d.languageId=="string"}function _(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function f(d){return d&&d.uri instanceof E.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function a(d){if(w(d))return{resource:d};if(g(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(_(d))return{overrideIdentifier:d.languageId};if(f(d))return{resource:d.uri};if(d===null)return{resource:null}}let m=class{constructor(r,s,n){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=n,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new o(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(r,s))}};e.ExtHostConfiguration=m,e.ExtHostConfiguration=m=je([He(0,S.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,I.ILogService)],m);class o{constructor(r,s,n,t){this._onDidChangeConfiguration=new i.Emitter,this._proxy=r,this._logService=t,this._extHostWorkspace=s,this._configuration=D.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,n))}getConfiguration(r,s,n){const t=a(s)||{},c=this._toReadonlyValue(r?v(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,t,n?.identifier);function l(p){if(p==null)return null;if(typeof p=="boolean")return p?1:4;switch(p){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(p){return typeof v(c,p)!="undefined"},get:(p,R)=>{this._validateConfigurationAccess(r?`${r}.${p}`:p,t,n?.identifier);let F=v(c,p);if(typeof F=="undefined")F=R;else{let O;const k=(U,B)=>{let z;const Y=()=>{O=O||(0,u.deepClone)(c),z=z||v(O,B)};return(0,T.isObject)(U)?new Proxy(U,{get:($,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return Y(),()=>z;if(O)return z=z||v(O,B),z[N];const V=$[N];return typeof N=="string"?k(V,`${B}.${N}`):V},set:($,N,V)=>(Y(),z&&(z[N]=V),!0),deleteProperty:($,N)=>(Y(),z&&delete z[N],!0),defineProperty:($,N,V)=>(Y(),z&&Object.defineProperty(z,N,V),!0)}):U};F=k(F,p)}return F},update:(p,R,F,O)=>{p=r?`${r}.${p}`:p;const k=l(F);return R!==void 0?this._proxy.$updateConfigurationOption(k,p,R,t,O):this._proxy.$removeConfigurationOption(k,p,t,O)},inspect:p=>{p=r?`${r}.${p}`:p;const R=(0,u.deepClone)(this._configuration.inspect(p,t,this._extHostWorkspace.workspace));if(R)return{key:p,defaultValue:R.policy?.value??R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof c=="object"&&(0,u.mixin)(h,c,!1),Object.freeze(h)}_toReadonlyValue(r){const s=n=>(0,T.isObject)(n)?new Proxy(n,{get:(t,c)=>s(t[c]),set:(t,c,l)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(t,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(t,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return s(r)}_validateConfigurationAccess(r,s,n){const t=b.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),c=n?`[${n.value}] `:"";if(t===4){typeof s?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){s?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const n=new D.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,c)=>n.affectsConfiguration(t,a(c))})}_toMap(r){return r.reduce((s,n)=>(s.set(n[0],n[1]),s),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Ue=this&&this.__classPrivateFieldGet||function(Q,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Q):i?i.value:e.get(Q)};define(ke[74],Pe([1,0,2,17,3,5,7,32,55,33,21,38,18,27,4,10,13,14,69,231,11]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_,f,a){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var o;(function(B){function z($){if($!=null)return $}B.from=z;function Y($){if($!=null)return $}B.to=Y})(o||(e.TaskDefinitionDTO=o={}));var d;(function(B){function z($){if($!=null)return $}B.from=z;function Y($){if($!=null)return $}B.to=Y})(d||(e.TaskPresentationOptionsDTO=d={}));var r;(function(B){function z($){if($!=null)return $}B.from=z;function Y($){if($!=null)return $}B.to=Y})(r||(e.ProcessExecutionOptionsDTO=r={}));var s;(function(B){function z(N){if(N){const V=N;return V&&!!V.process}else return!1}B.is=z;function Y(N){if(N==null)return;const V={process:N.process,args:N.args};return N.options&&(V.options=r.from(N.options)),V}B.from=Y;function $(N){if(N!=null)return new C.ProcessExecution(N.process,N.args,N.options)}B.to=$})(s||(e.ProcessExecutionDTO=s={}));var n;(function(B){function z($){if($!=null)return $}B.from=z;function Y($){if($!=null)return $}B.to=Y})(n||(e.ShellExecutionOptionsDTO=n={}));var t;(function(B){function z(N){if(N){const V=N;return V&&(!!V.commandLine||!!V.command)}else return!1}B.is=z;function Y(N){if(N==null)return;const V={};return N.commandLine!==void 0?V.commandLine=N.commandLine:(V.command=N.command,V.args=N.args),N.options&&(V.options=n.from(N.options)),V}B.from=Y;function $(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new C.ShellExecution(N.commandLine,N.options):new C.ShellExecution(N.command,N.args?N.args:[],N.options)}B.to=$})(t||(e.ShellExecutionDTO=t={}));var c;(function(B){function z(N){if(N){let V=N;return V&&V.customExecution==="customExecution"}else return!1}B.is=z;function Y(N){return{customExecution:"customExecution"}}B.from=Y;function $(N,V){return V.get(N)}B.to=$})(c||(e.CustomExecutionDTO=c={}));var l;(function(B){function z(Y,$){let N;return Y.scope!==void 0&&typeof Y.scope!="number"?N=Y.scope.uri:Y.scope!==void 0&&typeof Y.scope=="number"&&(Y.scope===C.TaskScope.Workspace&&$&&$.workspaceFile?N=$.workspaceFile:N=f.USER_TASKS_GROUP_KEY),{id:Y._id,workspaceFolder:N}}B.from=z})(l||(e.TaskHandleDTO=l={}));var h;(function(B){function z(Y){if(Y!=null)return{_id:Y.id,isDefault:Y.isDefault}}B.from=z})(h||(e.TaskGroupDTO=h={}));var p;(function(B){function z(N,V){if(N==null)return[];const H=[];for(let q of N){const te=Y(q,V);te&&H.push(te)}return H}B.fromMany=z;function Y(N,V){if(N==null)return;let H;N.execution instanceof C.ProcessExecution?H=s.from(N.execution):N.execution instanceof C.ShellExecution?H=t.from(N.execution):N.execution&&N.execution instanceof C.CustomExecution&&(H=c.from(N.execution));const q=o.from(N.definition);let te;return N.scope?typeof N.scope=="number"?te=N.scope:te=N.scope.uri:te=C.TaskScope.Workspace,!q||!te?void 0:{_id:N._id,definition:q,name:N.name,source:{extensionId:V.identifier.value,label:N.source,scope:te},execution:H,isBackground:N.isBackground,group:h.from(N.group),presentationOptions:d.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}B.from=Y;async function $(N,V,H){if(N==null)return;let q;s.is(N.execution)?q=s.to(N.execution):t.is(N.execution)?q=t.to(N.execution):c.is(N.execution)&&(q=c.to(N._id,H));const te=o.to(N.definition);let fe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?fe=N.source.scope:fe=await V.resolveWorkspaceFolder(u.URI.revive(N.source.scope)):fe=C.TaskScope.Workspace),!te||!fe)return;const ne=new C.Task(te,fe,N.name,N.source.label,q,N.problemMatchers);return N.isBackground!==void 0&&(ne.isBackground=N.isBackground),N.group!==void 0&&(ne.group=C.TaskGroup.from(N.group._id),ne.group&&N.group.isDefault&&(ne.group=new C.TaskGroup(ne.group.id,ne.group.label),N.group.isDefault===!0&&(ne.group.isDefault=N.group.isDefault))),N.presentationOptions&&(ne.presentationOptions=d.to(N.presentationOptions)),N._id&&(ne._id=N._id),N.detail&&(ne.detail=N.detail),ne}B.to=$})(p||(e.TaskDTO=p={}));var R;(function(B){function z($){return $}B.from=z;function Y($){if(!!$)return Object.assign(Object.create(null),$)}B.to=Y})(R||(e.TaskFilterDTO=R={}));class F{constructor(z,Y,$){this._id=Y,this._task=$,m.set(this,void 0),tt(this,m,z,"f")}get task(){return this._task}terminate(){Ue(this,m,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}m=new WeakMap;var O;(function(B){function z(Y){return{id:Y._id,task:void 0}}B.from=z})(O||(e.TaskExecutionDTO=O={}));let k=class{constructor(z,Y,$,N,V,H,q,te){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=z.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=N,this._configurationService=V,this._terminalService=H,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=q,this._deprecationService=te,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,Y,$){if(!$)return new C.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:Y,provider:$,extension:z}),this._proxy.$registerTaskProvider(N,Y),new C.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(z,Y){this._proxy.$registerTaskSystem(z,Y)}fetchTasks(z){return this._proxy.$fetchTasks(R.from(z)).then(async Y=>{const $=[];for(let N of Y){const V=await p.to(N,this._workspaceProvider,this._providedCustomExecutions2);V&&$.push(V)}return $})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(Y=>z.push(Y)),z}terminateTask(z){if(!(z instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,Y,$){const N=this._providedCustomExecutions2.get(z.id);N&&(this._activeCustomExecutions2.set(z.id,N),this._terminalService.attachPtyToTerminal(Y,await N.callback($))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const Y=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:Y})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const Y=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:Y,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const Y=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:Y,exitCode:z.exitCode})}$provideTasks(z,Y){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));const N=[],V=(0,i.asPromise)(()=>$.provider.provideTasks(L.CancellationToken.None)).then(H=>this.provideTasksInternal(Y,N,$,H));return new Promise(H=>{V.then(q=>{Promise.all(N).then(()=>{H(q)})})})}async $resolveTask(z,Y){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));if(Y.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${Y.definition.type}] cannot be resolved by provider of type [${$.type}].`);const N=await p.to(Y,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const V=await $.provider.resolveTask(N,L.CancellationToken.None);if(!V)return;this.checkDeprecation(V,$);const H=p.from(V,$.extension);if(!H)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(H.execution)&&await this.addCustomExecution(H,V,!0),await this.resolveTaskInternal(H)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,Y,$){const N=await this._proxy.$createTaskId(z);!$&&!this._providedCustomExecutions2.has(N)&&(this._notProvidedCustomExecutions.add(N),this._activeCustomExecutions2.set(N,Y.execution)),this._providedCustomExecutions2.set(N,Y.execution)}async getTaskExecution(z,Y){if(typeof z=="string"){const V=this._taskExecutionPromises.get(z);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}let $=this._taskExecutionPromises.get(z.id);if($)return $;const N=new Promise((V,H)=>{function q(te,fe,ne){ne?V(new F(te,fe.id,ne)):H("Unexpected: Task does not exist.")}Y?q(this,z,Y):p.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(te=>q(this,z,te))});return this._taskExecutionPromises.set(z.id,N),N.then(V=>(this._taskExecutions.set(z.id,V),V),V=>Promise.reject(V))}checkDeprecation(z,Y){z._deprecated&&this._deprecationService.report("Task.constructor",Y.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let $=this._notProvidedCustomExecutions.values(),N=$.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=$.next()}};e.ExtHostTaskBase=k,e.ExtHostTaskBase=k=je([He(0,S.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,D.IExtHostWorkspace),He(3,b.IExtHostDocumentsAndEditors),He(4,T.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,g.ILogService),He(7,_.IExtHostApiDeprecationService)],k);let U=class extends k{constructor(z,Y,$,N,V,H,q,te){super(z,Y,$,N,V,H,q,te);this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(z,Y){if(!Y.execution)throw new Error("Tasks to execute must include an execution");const $=p.from(Y,z);if($===void 0)throw new Error("Task is not valid");if(c.is($.execution))await this.addCustomExecution($,Y,!1);else throw new a.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution($),Y);return this._proxy.$executeTask($).catch(V=>{throw new Error(V)}),N}provideTasksInternal(z,Y,$,N){const V=[];if(N)for(let H of N){this.checkDeprecation(H,$),(!H.definition||!z[H.definition.type])&&this._logService.warn(`The task [${H.source}, ${H.name}] uses an undefined task type. The task will be ignored in the future.`);const q=p.from(H,$.extension);q&&c.is(q.execution)?(V.push(q),Y.push(this.addCustomExecution(q,H,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:$.extension}}async resolveTaskInternal(z){if(c.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,Y){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,Y,$){}};e.WorkerExtHostTask=U,e.WorkerExtHostTask=U=je([He(0,S.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,D.IExtHostWorkspace),He(3,b.IExtHostDocumentsAndEditors),He(4,T.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,g.ILogService),He(7,_.IExtHostApiDeprecationService)],U),e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(ke[273],Pe([1,0,9,21,51,34,22,49,31]),function(Q,e,u,i,y,A,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(S,I,E){this.config=S,this.provider=I,this.sessionToken=E,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=S.filePattern,this.includePattern=S.includePattern&&A.parse(S.includePattern),this.maxResults=S.maxResults||void 0,this.exists=S.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=S.excludePattern&&A.parse(S.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(S=>S.cancel()),this.activeCancellationTokens=new Set}search(S){const I=this.config.folderQueries||[];return new Promise((E,v)=>{const w=g=>{this.resultCount++,S(g)};if(this.isCanceled)return E({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(g=>{const _=g.toString(),f=u.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,f)||this.matchFile(w,{base:g,basename:f})}),Promise.all(I.map(g=>this.searchInFolder(g,w))).then(g=>{E({limitHit:this.isLimitHit,stats:g[0]||void 0})},g=>{v(new Error((0,y.toErrorMessage)(g)))})})}async searchInFolder(S,I){const E=new i.CancellationTokenSource,v=this.getSearchOptionsForFolder(S),w=this.initDirectoryTree(),g=new b.QueryGlobTester(this.config,S),_=!g.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(E),f=D.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,E.token),m=f.elapsed(),o=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(d=>{const r=u.posix.relative(S.folder.path,d.path);if(_){const s=u.basename(d.path);this.matchFile(I,{base:S.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(w,S.folder,r,I)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,g,I),{providerTime:m,postProcessTime:o.elapsed()})}finally{E.dispose(),this.activeCancellationTokens.delete(E)}}getSearchOptionsForFolder(S){const I=(0,b.resolvePatternsForProvider)(this.config.includePattern,S.includePattern),E=(0,b.resolvePatternsForProvider)(this.config.excludePattern,S.excludePattern);return{folder:S.folder,excludes:E,includes:I,useIgnoreFiles:!S.disregardIgnoreFiles,useGlobalIgnoreFiles:!S.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!S.disregardParentIgnoreFiles,followSymlinks:!S.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const S={rootEntries:[],pathToEntries:Object.create(null)};return S.pathToEntries["."]=S.rootEntries,S}addDirectoryEntries({pathToEntries:S},I,E,v){if(E===this.filePattern){const g=u.basename(this.filePattern);this.matchFile(v,{base:I,relativePath:this.filePattern,basename:g})}function w(g){const _=u.basename(g),f=u.dirname(g);let a=S[f];a||(a=S[f]=[],w(f)),a.push({base:I,relativePath:g,basename:_})}w(E)}matchDirectoryTree({rootEntries:S,pathToEntries:I},E,v){const w=this,g=this.filePattern;function _(f){const a=(0,b.hasSiblingFn)(()=>f.map(m=>m.basename));for(let m=0,o=f.length;m<o;m++){const d=f[m],{relativePath:r,basename:s}=d;if(E.matchesExcludesSync(r,s,g!==s?a:void 0))continue;const n=I[r];if(n)_(n);else{if(r===g)continue;w.matchFile(v,d)}if(w.isLimitHit)break}}_(S)}matchFile(S,I){(!this.includePattern||I.relativePath&&this.includePattern(I.relativePath,I.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||S(I))}}class L{constructor(){this.sessions=new Map}fileSearch(S,I,E,v){const w=this.getSessionTokenSource(S.cacheKey),g=new T(S,I,w&&w.token);let _=0;const f=a=>{_+=a.length,E(a.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(g,L.BATCH_SIZE,f,v).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:a.stats}}))}clearCache(S){const I=this.getSessionTokenSource(S);I&&I.cancel()}getSessionTokenSource(S){if(!!S)return this.sessions.has(S)||this.sessions.set(S,new i.CancellationTokenSource),this.sessions.get(S)}rawMatchToSearchItem(S){return S.relativePath?{resource:C.joinPath(S.base,S.relativePath)}:{resource:S.base}}doSearch(S,I,E,v){v.onCancellationRequested(()=>{S.cancel()});const w=_=>{_&&(g.push(_),I>0&&g.length>=I&&(E(g),g=[]))};let g=[];return S.search(w).then(_=>(g.length&&E(g),_),_=>(g.length&&E(g),Promise.reject(_)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(ke[274],Pe([1,0,16,48,34,103,25,10,9,22,8,12,2,156,187,84,14,45,130,272,31]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(h,p,R,F,O){this.configurationService=h,this.workspaceContextService=p,this.editorGroupsService=R,this.logService=F,this.pathService=O}text(h,p,R={}){h=this.getContentPattern(h,R);const F=this.configurationService.getValue(),O=p&&p.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(p?.map(g.toWorkspaceFolder),R),type:2,contentPattern:h,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:F.search.usePCRE2||O||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(h,p){const R=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const F={...h,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(h,p)&&(F.isCaseSensitive=!0),this.isMultiline(h)&&(F.isMultiline=!0),F}file(h,p={}){return{...this.commonQuery(h,p),type:1,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey}}handleIncludeExclude(h,p){return h?(h=Array.isArray(h)?h.map(n):n(h),p?this.parseSearchPaths(h):{pattern:d(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],p={}){const R=this.handleIncludeExclude(p.includePattern,p.expandPatterns),F=this.handleIncludeExclude(p.excludePattern,p.expandPatterns),O=h.length>1,k=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,p,F)):h.map(z=>this.getFolderQueryForRoot(z,p,F,O))).filter(z=>!!z),U={_reason:p._reason,folderQueries:k,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:F.pattern,includePattern:R.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const z=u.coalesce(u.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(V=>V.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const Y=z.filter(N=>(0,a.pathIncludedInQuery)(U,N.fsPath)),$=this.commonQueryFromFileList(Y);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify($)),{...U,...$}}const B=p.extraFileResources&&p.extraFileResources.filter(z=>(0,a.pathIncludedInQuery)(U,z.fsPath));return U.extraFileResources=B&&B.length?B:void 0,U}commonQueryFromFileList(h){const p=[],R=new C.ResourceMap,F={};let O=!1;return h.forEach(k=>{if(k.scheme===D.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(k)){const B=this.workspaceContextService.getWorkspaceFolder(k)?.uri??k.with({path:b.dirname(k.fsPath)});let z=R.get(B);z||(O=!0,z={folder:B,includePattern:{}},p.push(z),R.set(B,z));const Y=b.relative(B.fsPath,k.fsPath);(0,P.assertIsDefined)(z.includePattern)[Y.replace(/\\/g,"/")]=!0}else k.fsPath&&(O=!0,F[k.fsPath]=!0)}),{folderQueries:p,includePattern:F,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(h,p){if(p.isSmartCase){if(h.isRegExp){if(L.containsUppercaseCharacter(h.pattern,!0))return!0}else if(L.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,I.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const p=$=>b.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),F=(Array.isArray(h)?h:r(h)).map($=>{const N=this.pathService.resolvedUserHome;return N?(0,A.untildify)($,N.scheme===D.Schemas.file?N.fsPath:N.path):$}),O=i.groupBy(F,$=>p($)?"searchPaths":"exprSegments"),k=(O.exprSegments||[]).map($=>L.rtrim($,"/")).map($=>L.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),s($))),U={},B=this.expandSearchPathPatterns(O.searchPaths||[]);B&&B.length&&(U.searchPaths=B);const z=u.flatten(k),Y=d(...z);return Y&&(U.pattern=Y),U}getExcludesForFolder(h,p){return p.disregardExcludeSettings?void 0:(0,a.getExcludes)(h,!p.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const p=u.flatten(h.map(F=>{let{pathPortion:O,globPortion:k}=o(F);k&&(k=t(k));const U=this.expandOneSearchPath(O);return u.flatten(U.map(B=>this.resolveOneSearchPathPattern(B,k)))})),R=new Map;return p.forEach(F=>{const O=F.searchPath.toString(),k=R.get(O);k?F.pattern&&(k.pattern=k.pattern||{},k.pattern[F.pattern]=!0):R.set(O,{searchPath:F.searchPath,pattern:F.pattern?d(F.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(h){if(b.isAbsolute(h)){const p=this.workspaceContextService.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==D.Schemas.file?[{searchPath:p[0].uri.with({path:h})}]:[{searchPath:S.URI.file(b.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const p=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=n(h),h.startsWith("../")||h===".."){const F=b.posix.resolve(p.path,h);return[{searchPath:p.with({path:F})}]}const R=t(h);return[{searchPath:p,pattern:R}]}else{if(h==="./"||h===".\\")return[];{const p=h.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(O=>{const k=p.match(new RegExp(`^${L.escapeRegExpCharacters(O.name)}(?:/(.*)|$)`));return k?{match:k,folder:O}:null}).filter(P.isDefined);if(F.length)return F.map(O=>{const k=O.match[1];return{searchPath:O.folder.uri,pattern:k&&t(k)}});{const O=h.match(/\.[\/\\](.+)[\/\\]?/),k=O?O[1]:h,U=E.localize(0,null,k);throw new Error(U)}}}}resolveOneSearchPathPattern(h,p){const R=h.pattern&&p?`${h.pattern}/${p}`:h.pattern||p,F=[{searchPath:h.searchPath,pattern:R}];return R&&!R.endsWith("**")&&F.push({searchPath:h.searchPath,pattern:R+"/**"}),F}getFolderQueryForSearchPath(h,p,R){const F=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(h.searchPath),p,R,!1);return F?{...F,includePattern:h.pattern}:null}getFolderQueryForRoot(h,p,R,F){let O;const k=S.URI.isUri(h)?h:h.uri;if(R.searchPaths){const $=R.searchPaths.filter(N=>(0,T.isEqual)(N.searchPath,k))[0];if($&&!$.pattern)return null;$&&(O=$.pattern)}const U=this.configurationService.getValue({resource:k}),z={...this.getExcludesForFolder(U,p)||{},...O||{}},Y=S.URI.isUri(h)?(0,T.basename)(h):h.name;return{folder:k,folderName:F?Y:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!U.search.followSymlinks}}};e.QueryBuilder=m,e.QueryBuilder=m=je([He(0,v.IConfigurationService),He(1,g.IWorkspaceContextService),He(2,_.IEditorGroupsService),He(3,w.ILogService),He(4,f.IPathService)],m);function o(l){const h=l.match(/[\*\{\}\(\)\[\]\?]/);if(h){const p=h.index,R=l.substr(0,p).match(/[/|\\][^/\\]*$/);if(R){let F=l.substr(0,R.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:l.substr((R.index||0)+1)}}}return{pathPortion:l}}function d(...l){return l.length?l.reduce((h,p)=>(h[p]=!0,h),Object.create(null)):void 0}function r(l){return y.splitGlobAware(l,",").map(h=>h.trim()).filter(h=>!!h.length)}function s(l){return[`**/${l}/**`,`**/${l}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function n(l){return l.replace(/\\/g,"/")}function t(l){return n(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(l,h){l=u.distinct(l,F=>F.toString());const p=[],R=h.getWorkspace();return l&&l.forEach(F=>{let O;if(h.getWorkbenchState()===2)O=(0,T.relativePath)(R.folders[0].uri,F),O&&O!=="."&&(O="./"+O);else{const k=h.getWorkspaceFolder(F);if(k){const U=k.name;if(R.folders.filter(z=>z.name===U).length===1){const z=(0,T.relativePath)(k.uri,F);z===""?O=`./${k.name}`:O=`./${k.name}/${z}`}else O=F.fsPath}}O&&p.push(O)}),p}e.resolveResourcesForSearchIncludes=c}),define(ke[275],Pe([1,0,22,2,21,11,4,274,31,45]),function(Q,e,u,i,y,A,C,D,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function P(v,w){const g=w.activationEvents;if(!g)return Promise.resolve(void 0);const _=[],f=[];for(const s of g)if(/^workspaceContains:/.test(s)){const n=s.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||v.forceUsingSearch?f.push(n):_.push(n)}if(_.length===0&&f.length===0)return Promise.resolve(void 0);let a;const m=new Promise((s,n)=>{a=s}),o=s=>a({activationEvent:s}),d=Promise.all(_.map(s=>S(v,s,o))).then(()=>{}),r=I(v,w.identifier,f,o);return Promise.all([d,r]).then(()=>{a(void 0)}),m}e.checkActivateWorkspaceContainsExtension=P;async function S(v,w,g){for(const _ of v.folders)if(await v.exists(u.joinPath(i.URI.revive(_),w))){g(`workspaceContains:${w}`);return}}async function I(v,w,g,_){if(g.length===0)return Promise.resolve(void 0);const f=new y.CancellationTokenSource,a=v.checkExists(v.folders,g,f.token),m=setTimeout(async()=>{f.cancel(),v.logService.info(`Not activating extension '${w.value}': Timed out while searching for 'workspaceContains' pattern ${g.join(",")}`)},L);let o=!1;try{o=await a}catch(d){A.isCancellationError(d)||A.onUnexpectedError(d)}f.dispose(),clearTimeout(m),o&&_(`workspaceContains:${g.join(",")}`)}function E(v,w,g,_){const f=v.get(C.IInstantiationService),a=v.get(b.ISearchService),o=f.createInstance(D.QueryBuilder).file(w.map(d=>(0,T.toWorkspaceFolder)(i.URI.revive(d))),{_reason:"checkExists",includePattern:g,exists:!0});return a.fileSearch(o,_).then(d=>!!d.limitHit,d=>A.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=E});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Ue=this&&this.__classPrivateFieldGet||function(Q,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Q):i?i.value:e.get(Q)};define(ke[39],Pe([1,0,171,9,75,22,17,6,25,2,14,5,33,226,92,32,28,225,11,26,23,205,7,121,4,27,71,18,86,53,38,3,275,91,207,10]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_,f,a,m,o,d,r,s,n,t,c,l,h,p,R,F,O,k){"use strict";var U,B,z,Y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let $=Y=class extends D.Disposable{constructor(ne,le,K,ge,ve,se,be,Te,pe,we){super();this._onDidChangeRemoteConnectionData=this._register(new p.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=le,this._extHostContext=K,this._initData=be,this._extHostWorkspace=ge,this._extHostConfiguration=ve,this._logService=se,this._extHostTunnelService=pe,this._extHostTerminalService=we,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._globalRegistry=new g.ExtensionDescriptionRegistry(this._initData.allExtensions);const Ae=(0,w.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new g.ExtensionDescriptionRegistry(H(this._globalRegistry,Ae)),this._storage=new E.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=ne.createChild(new c.ServiceCollection([E.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));let ce=[],me=[];this._initData.remote.isRemote&&(ce=this._initData.allExtensions.filter(ee=>!ee.main&&!ee.browser).map(ee=>ee.identifier),me=this._initData.allExtensions.filter(ee=>!Ae.has(f.ExtensionIdentifier.toKey(ee.identifier.value))).filter(ee=>(ee.main||ee.browser)&&ee.api==="none").map(ee=>ee.identifier));const ie=(0,w.extensionIdentifiersArrayToSet)(me);this._activator=this._register(new I.ExtensionsActivator(this._myRegistry,ce,me,{onExtensionActivationError:(ee,M,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,_.transformErrorForSerialization(M),x)},actualActivateExtension:async(ee,M)=>{if(ie.has(f.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,M),new I.HostExtension;const x=this._myRegistry.getExtensionDescription(ee);return this._activateExtension(x,M)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ne){_.onUnexpectedError(ne)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ne=[];try{ne=this._myRegistry.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this._deactivate(ve))}catch{}await Promise.all(ne)}terminate(ne,le=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ne}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),_.setUnexpectedErrorHandler(ge=>{this._logService.error(ge)}),this._extHostContext.dispose();const K=this._deactivateAll();Promise.race([(0,C.timeout)(5e3),K]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${le}`):this._logService.info(`Extension host exiting with code ${le}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(le)})}isActivated(ne){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ne):!1}async getExtension(ne){const le=await this._mainThreadExtensionsProxy.$getExtension(ne);return le&&{...le,identifier:new f.ExtensionIdentifier(le.identifier.value),extensionLocation:T.URI.revive(le.extensionLocation)}}_activateByEvent(ne,le){return this._activator.activateByEvent(ne,le)}_activateById(ne,le){return this._activator.activateById(ne,le)}activateByIdWithErrors(ne,le){return this._activateById(ne,le).then(()=>{const K=this._activator.getActivatedExtension(ne);if(K.activationFailed)return Promise.reject(K.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ne=>this._myRegistry)}getExtensionExports(ne){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ne).exports:null}async _realPathExtensionUri(ne){if(ne.scheme!==k.Schemas.file)return ne;const le=await this._hostUtils.realpath(ne.fsPath);return T.URI.file(le)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ne=>new te(ne))),this._extensionPathIndex}async _createExtensionPathIndex(ne){const le=b.TernarySearchTree.forUris(K=>A.extUriBiasedIgnorePathCase.ignorePathCasing(K));return await Promise.all(ne.map(async K=>{if(this._getEntryPoint(K)){const ge=await this._realPathExtensionUri(K.extensionLocation);le.set(ge,K)}})),le}_deactivate(ne){let le=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ne))return le;const K=this._activator.getActivatedExtension(ne);if(!K)return le;try{typeof K.module.deactivate=="function"&&(le=Promise.resolve(K.module.deactivate()).then(void 0,ge=>(this._logService.error(ge),Promise.resolve(void 0))))}catch(ge){this._logService.error(`An error occurred when deactivating the extension '${ne.value}':`),this._logService.error(ge)}try{(0,D.dispose)(K.subscriptions)}catch(ge){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ne.value}':`),this._logService.error(ge)}return le}async _activateExtension(ne,le){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ne.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ne.identifier),this._doActivateExtension(ne,le).then(K=>{const ge=K.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ne.identifier,ge.codeLoadingTime,ge.activateCallTime,ge.activateResolvedTime,le),this._logExtensionActivationTimes(ne,le,"success",ge),K},K=>{throw this._logExtensionActivationTimes(ne,le,"failure"),K})}_logExtensionActivationTimes(ne,le,K,ge){const ve=N(ne,le);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ve,...ge||{},outcome:K})}_doActivateExtension(ne,le){const K=N(ne,le);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",K);const ge=this._getEntryPoint(ne);if(!ge)return Promise.resolve(new I.EmptyExtension(I.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ne.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${ne.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this._logService.flush();const ve=new I.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this._loadCommonJSModule(ne.identifier,(0,A.joinPath)(ne.extensionLocation,ge),ve),this._loadExtensionContext(ne)]).then(se=>(y.mark(`code/extHost/willActivateExtension/${ne.identifier.value}`),Y._callActivate(this._logService,ne.identifier,se[0],se[1],ve))).then(se=>(y.mark(`code/extHost/didActivateExtension/${ne.identifier.value}`),se))}_loadExtensionContext(ne){const le=new m.ExtensionGlobalMemento(ne,this._storage),K=new m.ExtensionMemento(ne.identifier.value,!1,this._storage),ge=new O.ExtensionSecrets(ne,this._secretState),ve=ne.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,se=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ne.identifier.value}`),Promise.all([le.whenReady,K.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Te,pe;const we=(0,w.isProposedApiEnabled)(ne,"ipc")?this._initData.messagePorts?.get(f.ExtensionIdentifier.toKey(ne.identifier)):void 0;return Object.freeze({globalState:le,workspaceState:K,secrets:ge,subscriptions:[],get extensionUri(){return ne.extensionLocation},get extensionPath(){return ne.extensionLocation.fsPath},asAbsolutePath(Ae){return i.join(ne.extensionLocation.fsPath,Ae)},get storagePath(){return be._storagePath.workspaceValue(ne)?.fsPath},get globalStoragePath(){return be._storagePath.globalValue(ne).fsPath},get logPath(){return i.join(be._initData.logsLocation.fsPath,ne.identifier.value)},get logUri(){return T.URI.joinPath(be._initData.logsLocation,ne.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(ne)},get globalStorageUri(){return be._storagePath.globalValue(ne)},get extensionMode(){return ve},get extension(){return Te===void 0&&(Te=new V(be,ne.identifier,ne,se,!1)),Te},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(ne,"extensionRuntime"),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(ne)},get messagePassingProtocol(){if(!pe){if(!we)return;const Ae=p.Event.buffer(p.Event.fromDOMEventEmitter(we,"message",ce=>ce.data));we.start(),pe={onDidReceiveMessage:Ae,postMessage:we.postMessage.bind(we)}}return pe}})})}static _callActivate(ne,le,K,ge,ve){return K=K||{activate:void 0,deactivate:void 0},this._callActivateOptional(ne,le,K,ge,ve).then(se=>new I.ActivatedExtension(!1,null,ve.build(),K,se,ge.subscriptions))}static _callActivateOptional(ne,le,K,ge,ve){if(typeof K.activate=="function")try{ve.activateCallStart(),ne.trace(`ExtensionService#_callActivateOptional ${le.value}`);const se=typeof global=="object"?global:self,be=K.activate.apply(se,[ge]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(be).then(Te=>(ve.activateResolveStop(),Te))}catch(se){return Promise.reject(se)}else return Promise.resolve(K)}_activateOneStartupFinished(ne,le){this._activateById(ne.identifier,{startup:!1,extensionId:ne.identifier,activationEvent:le}).then(void 0,K=>{this._logService.error(K)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const ne of this._myRegistry.getAllExtensionDescriptions())if(ne.activationEvents)for(const le of ne.activationEvents)le==="onStartupFinished"&&this._activateOneStartupFinished(ne,le)}_handleEagerExtensions(){const ne=this._activateByEvent("*",!0).then(void 0,ve=>{this._logService.error(ve)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ve=>this._handleWorkspaceContainsEagerExtensions(ve.added)));const le=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],K=this._handleWorkspaceContainsEagerExtensions(le),ge=Promise.all([ne,K]).then(()=>{});return Promise.race([ge,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ge}_handleWorkspaceContainsEagerExtensions(ne){return ne.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(le=>this._handleWorkspaceContainsEagerExtension(ne,le))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ne,le){if(this.isActivated(le.identifier))return;const K=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ge={logService:this._logService,folders:ne.map(se=>se.uri),forceUsingSearch:K,exists:se=>this._hostUtils.exists(se.fsPath),checkExists:(se,be,Te)=>this._mainThreadWorkspaceProxy.$checkExists(se,be,Te)},ve=await(0,R.checkActivateWorkspaceContainsExtension)(ge,le);if(!!ve)return this._activateById(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:ve.activationEvent}).then(void 0,se=>this._logService.error(se))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ne){throw console.error(ne),ne}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ne,extensionTestsLocationURI:le}=this._initData.environment;if(!ne||!le)throw new Error(u.localize(0,null));const K=await this._loadCommonJSModule(null,le,new I.ExtensionActivationTimesBuilder(!1));if(!K||typeof K.run!="function")throw new Error(u.localize(1,null,le.toString()));return new Promise((ge,ve)=>{const se=(pe,we)=>{pe?ve(pe):ge(typeof we=="number"&&we>0?1:0)},be=(0,A.originalFSPath)(le),Te=K.run(be,se);Te&&Te.then&&Te.then(()=>{ge(0)}).catch(pe=>{ve(pe instanceof Error&&pe.stack?pe.stack:String(pe))})})}async $extensionTestsExit(ne){this.terminate(`test runner requested exit with code ${ne}`,ne)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ne,le){return this._resolvers[ne]=le,(0,D.toDisposable)(()=>{delete this._resolvers[ne]})}async _activateAndGetResolver(ne){const le=ne.indexOf("+");if(le===-1)throw new Error("Not an authority that can be resolved!");const K=ne.substr(0,le);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${K}`,!1),{authorityPrefix:K,resolver:this._resolvers[K]}}async $resolveAuthority(ne,le){this._logService.info(`$resolveAuthority invoked for authority (${q(ne)})`);const{authorityPrefix:K,resolver:ge}=await this._activateAndGetResolver(ne);if(!ge)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${K}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ge)),y.mark(`code/extHost/willResolveAuthority/${K}`);const ve=await ge.resolve(ne,{resolveAttempt:le});y.mark(`code/extHost/didResolveAuthorityOK/${K}`);const se={authority:ne,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},be={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:se,options:be,tunnelInformation:{environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures}}}}catch(ve){if(y.mark(`code/extHost/didResolveAuthorityError/${K}`),ve instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}async $getCanonicalURI(ne,le){this._logService.info(`$getCanonicalURI invoked for authority (${q(ne)})`);const{resolver:K}=await this._activateAndGetResolver(ne);if(!K)return null;const ge=T.URI.revive(le);if(typeof K.getCanonicalURI=="undefined")return ge;const ve=await(0,C.asPromise)(()=>K.getCanonicalURI(ge));return ve||ge}static _applyExtensionsDelta(ne,le,K){const ge=new g.ExtensionDescriptionRegistry(ne.getAllExtensionDescriptions());ge.deltaExtensions(K.toAdd,K.toRemove);const ve=(0,w.extensionIdentifiersArrayToSet)(le.getAllExtensionDescriptions().map(be=>be.identifier));for(const be of K.myToRemove)ve.delete(f.ExtensionIdentifier.toKey(be));for(const be of K.myToAdd)ve.add(f.ExtensionIdentifier.toKey(be));const se=H(ge,ve);return{globalRegistry:ge,myExtensions:se}}$startExtensionHost(ne){ne.toAdd.forEach(ge=>ge.extensionLocation=T.URI.revive(ge.extensionLocation));const{globalRegistry:le,myExtensions:K}=Y._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ne);return this._globalRegistry.set(le.getAllExtensionDescriptions()),this._myRegistry.set(K),this._startExtensionHost()}$activateByEvent(ne,le){return le===1?this._activateByEvent(ne,!1):this._readyToRunExtensions.wait().then(K=>this._activateByEvent(ne,!1))}async $activate(ne,le){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ne)?(await this._activateById(ne,le),!0):!1}async $deltaExtensions(ne){ne.toAdd.forEach(se=>se.extensionLocation=T.URI.revive(se.extensionLocation));const{globalRegistry:le,myExtensions:K}=Y._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ne),ge=await this._createExtensionPathIndex(K);return(await this.getExtensionPathIndex()).setSearchTree(ge),this._globalRegistry.set(le.getAllExtensionDescriptions()),this._myRegistry.set(K),Promise.resolve(void 0)}async $test_latency(ne){return ne}async $test_up(ne){return ne.byteLength}async $test_down(ne){let le=a.VSBuffer.alloc(ne),K=Math.random()%256;for(let ge=0;ge<ne;ge++)le.writeUInt8(K,ge);return le}async $updateRemoteConnectionData(ne){this._remoteConnectionData=ne,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=$,e.AbstractExtHostExtensionService=$=Y=je([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,t.IExtHostRpcService),He(3,v.IExtHostWorkspace),He(4,S.IExtHostConfiguration),He(5,L.ILogService),He(6,s.IExtHostInitDataService),He(7,n.IExtensionStoragePaths),He(8,l.IExtHostTunnelService),He(9,h.IExtHostTerminalService)],$);function N(fe,ne){return{id:fe.identifier.value,name:fe.name,extensionVersion:fe.version,publisherDisplayName:fe.publisher,activationEvents:fe.activationEvents?fe.activationEvents.join(","):null,isBuiltin:fe.isBuiltin,reason:ne.activationEvent,reasonId:ne.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class V{constructor(ne,le,K,ge,ve){U.set(this,void 0),B.set(this,void 0),z.set(this,void 0),tt(this,U,ne,"f"),tt(this,B,le,"f"),tt(this,z,K.identifier,"f"),this.id=K.identifier.value,this.extensionUri=K.extensionLocation,this.extensionPath=i.normalize((0,A.originalFSPath)(K.extensionLocation)),this.packageJSON=K,this.extensionKind=ge,this.isFromDifferentExtensionHost=ve}get isActive(){return Ue(this,U,"f").isActivated(Ue(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,U,"f").getExtensionExports(Ue(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,U,"f").activateByIdWithErrors(Ue(this,z,"f"),{startup:!1,extensionId:Ue(this,B,"f"),activationEvent:"api"}),this.exports}}e.Extension=V,U=new WeakMap,B=new WeakMap,z=new WeakMap;function H(fe,ne){return fe.getAllExtensionDescriptions().filter(le=>ne.has(f.ExtensionIdentifier.toKey(le.identifier)))}function q(fe){const ne=fe.indexOf("+");return ne===-1?fe:fe.substring(0,ne)}class te{constructor(ne){this._searchTree=ne}setSearchTree(ne){this._searchTree=ne}findSubstr(ne){return this._searchTree.findSubstr(ne)}forEach(ne){return this._searchTree.forEach(ne)}}e.ExtensionPaths=te}),define(ke[276],Pe([1,0,75,2,5,33,28,26,18,27,4,39,40,14,8]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let w=class{constructor(o,d,r,s,n,t,c){this._apiFactory=o,this._extensionRegistry=d,this._instaService=r,this._extHostConfiguration=s,this._extHostExtensionService=n,this._initData=t,this._logService=c,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),u.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new _(this._apiFactory,d,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(f,d)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(a,d,this._initData.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(let d of o.nodeModuleName)this._factories.set(d,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(d=>o.alternativeModuleName(d))}};e.RequireInterceptor=w,e.RequireInterceptor=w=je([He(2,L.IInstantiationService),He(3,A.IExtHostConfiguration),He(4,P.IExtHostExtensionService),He(5,T.IExtHostInitDataService),He(6,I.ILogService)],w);let g=v=class{constructor(o){if(o.environment.appRoot&&v.aliased.size){const d=(0,E.escapeRegExpCharacters)(this.forceForwardSlashes(o.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${d}/${n}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.re)return;const d=this.re.exec(this.forceForwardSlashes(o));if(!d)return;const[,r,s,n]=d,t=v.aliased.get(s);if(t!==void 0)return console.warn(`${s} as been renamed to ${t}, please update your imports`),r+t+n}forceForwardSlashes(o){return o.replace(/\\/g,"/")}};g.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),g=v=je([He(0,T.IExtHostInitDataService)],g);class _{constructor(o,d,r,s,n){this._apiFactory=o,this._extensionPaths=d,this._extensionRegistry=r,this._configProvider=s,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,d){const r=this._extensionPaths.findSubstr(d);if(r){let s=this._extApiImpl.get(D.ExtensionIdentifier.toKey(r.identifier));return s||(s=this._apiFactory(r,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(r.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((n,t)=>s+=`	${t} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let f=class{constructor(o,d,r){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=d.getProxy(y.MainContext.MainThreadTelemetry);const{environment:s}=r,n=d.getProxy(y.MainContext.MainThreadKeytar);if(s.appRoot){let t=s.appRoot.fsPath;S.platform==="win32"&&(t=t.replace(/\\/g,"/")),t[t.length-1]==="/"&&(t=t.substr(0,t.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${t}/node_modules.asar/keytar`),this.alternativeNames.add(`${t}/node_modules/keytar`)}this._impl={getPassword:(t,c)=>n.$getPassword(t,c),setPassword:(t,c,l)=>n.$setPassword(t,c,l),deletePassword:(t,c)=>n.$deletePassword(t,c),findPassword:t=>n.$findPassword(t),findCredentials(t){return n.$findCredentials(t)}}}load(o,d){const r=this._extensionPaths.findSubstr(d);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:r?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const d=o.length;if(d<=7||!this.alternativeNames)return;const r=d-7;if((o.charAt(r)==="/"||o.charAt(r)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};f=je([He(1,b.IExtHostRpcService),He(2,T.IExtHostInitDataService)],f);let a=class{constructor(o,d,r){this._extensionPaths=o,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=r.getProxy(y.MainContext.MainThreadTelemetry);const s=r.getProxy(y.MainContext.MainThreadWindow);this._impl=(n,t)=>{const c=i.URI.parse(n);return t?this.callOriginal(n,t):c.scheme==="http"||c.scheme==="https"?s.$openUri(c,n,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this._appUriScheme?s.$openUri(c,n,{}):this.callOriginal(n,t)}}load(o,d,r){const s=this._extensionPaths.findSubstr(d);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=r(o),this._impl}callOriginal(o,d){return this.sendNoForwardTelemetry(),this._original(o,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};a=je([He(2,b.IExtHostRpcService)],a)}),define(ke[47],Pe([1,0,80,6,9,40,4,55,56,39,7,32,219,33]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class E extends S.AbstractVariableResolverService{constructor(g,_,f,a,m,o,d){function r(){if(f){const s=f.activeEditor();if(s)return s.document.uri;const n=a.tabGroups.all.find(t=>t.isActive)?.activeTab;if(n!==void 0){if(n.input instanceof L.TextDiffTabInput||n.input instanceof L.NotebookDiffEditorTabInput)return n.input.modified;if(n.input instanceof L.TextTabInput||n.input instanceof L.NotebookEditorTabInput||n.input instanceof L.CustomEditorTabInput)return n.input.uri}}}super({getFolderUri:s=>{const n=o.folders.filter(t=>t.name===s);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(s,n)=>m.getConfiguration(void 0,s).get(n),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=r();if(s)return y.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(_){const s=r();if(s){const n=_.getWorkspaceFolder(s);if(n)return y.normalize(n.uri.fsPath)}}},getSelectedText:()=>{if(f){const s=f.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(f){const s=f.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>g.getExtension(s)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(A.env))}}let v=class extends i.Disposable{constructor(g,_,f,a,m){super();this.extensionService=g,this.workspaceService=_,this.editorService=f,this.configurationService=a,this.editorTabs=m,this._resolver=new u.Lazy(async()=>{const o=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new E(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,o,r,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};e.ExtHostVariableResolverProviderService=v,e.ExtHostVariableResolverProviderService=v=je([He(0,T.IExtHostExtensionService),He(1,P.IExtHostWorkspace),He(2,D.IExtHostDocumentsAndEditors),He(3,I.IExtHostConfiguration),He(4,b.IExtHostEditorTabs)],v)}),define(ke[76],Pe([1,0,17,3,12,2,4,5,56,39,18,7,32,126,214,33,47]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let g=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,s,n,t,c,l){this._workspaceService=s,this._extensionService=n,this._configurationService=t,this._editorTabs=c,this._variableResolver=l,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new i.Emitter,this._onDidTerminateDebugSession=new i.Emitter,this._onDidChangeActiveDebugSession=new i.Emitter,this._onDidReceiveDebugSessionCustomEvent=new i.Emitter,this._debugServiceProxy=r.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new i.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(h=>{h.onDidChange(p=>{this.registerAllDebugTypes(h)}),this.registerAllDebugTypes(h)})}asDebugSourceUri(r,s){const n=r;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let t=`debug:${encodeURIComponent(n.path||"")}`,c="?";return s&&(t+=`${c}session=${encodeURIComponent(s.id)}`,c="&"),t+=`${c}ref=${n.sourceReference}`,A.URI.parse(t)}else{if(n.path)return A.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const s=[];for(const n of r.getAllExtensionDescriptions())if(n.contributes){const t=n.contributes.debuggers;if(t&&t.length>0)for(const c of t)(0,E.isDebuggerMainContribution)(c)&&s.push(c.type)}this._debugServiceProxy.$registerDebugTypes(s)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(s=>r.push(s)),r}addBreakpoints(r){this.startBreakpoints();const s=r.filter(c=>{const l=c.id;return this._breakpoints.has(l)?!1:(this._breakpoints.set(l,c),!0)});this.fireBreakpointChanges(s,[],[]);const n=[],t=new Map;for(const c of s)if(c instanceof P.SourceBreakpoint){let l=t.get(c.location.uri.toString());l||(l={type:"sourceMulti",uri:c.location.uri,lines:[]},t.set(c.location.uri.toString(),l),n.push(l)),l.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof P.FunctionBreakpoint&&n.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this._debugServiceProxy.$registerBreakpoints(n)}removeBreakpoints(r){this.startBreakpoints();const s=r.filter(l=>this._breakpoints.delete(l.id));this.fireBreakpointChanges([],s,[]);const n=s.filter(l=>l instanceof P.SourceBreakpoint).map(l=>l.id),t=s.filter(l=>l instanceof P.FunctionBreakpoint).map(l=>l.id),c=s.filter(l=>l instanceof P.DataBreakpoint).map(l=>l.id);return this._debugServiceProxy.$unregisterBreakpoints(n,t,c)}startDebugging(r,s,n){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,s,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,debugUI:n.debugUI,suppressSaveBeforeStart:n.suppressSaveBeforeStart})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,n){if(!s)return new P.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:t,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,n,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,t),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(c=>c.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(r,s,n){if(!n)return new P.Disposable(()=>{});if(!this.definesDebugType(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:t,factory:n}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,t),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(c=>c.factory!==n),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new P.Disposable(()=>{});const n=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:n,factory:s}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let n;const t=await this.getFolder(r);return t&&(n={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(n,s)}createDebugAdapter(r,s){if(r.type==="implementation")return new m(r.implementation)}createSignService(){}async $startDASession(r,s){const n=this,t=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const l=this.convertToDto(c),h=this.createDebugAdapter(l,t);if(!h)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const p=h;return this._debugAdapters.set(r,p),this.getDebugAdapterTrackers(t).then(R=>(R&&this._debugAdaptersTrackers.set(r,R),p.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const O=F,k={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(O.arguments.value);k.body={signature:U},p.sendResponse(k)}else throw new Error("no signer")}catch(U){k.success=!1,k.message=U.message,p.sendResponse(k)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(F),F=(0,E.convertToVSCPaths)(F,!0),n._debugServiceProxy.$acceptDAMessage(r,F)}),p.onError(F=>{R&&R.onError&&R.onError(F),this._debugServiceProxy.$acceptDAError(r,F.name,F.message,F.stack)}),p.onExit(F=>{R&&R.onExit&&R.onExit((0,y.withNullAsUndefined)(F),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,y.withNullAsUndefined)(F),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),p.startSession()))})}$sendDAMessage(r,s){s=(0,E.convertToDAPaths)(s,!1);const n=this._debugAdaptersTrackers.get(r);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(s);const t=this._debugAdapters.get(r);t&&t.sendMessage(s)}$stopDASession(r){const s=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const n=this._debugAdapters.get(r);return this._debugAdapters.delete(r),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],n=[],t=[];if(r.added)for(const c of r.added){const l=c.id;if(l&&!this._breakpoints.has(l)){let h;if(c.type==="function")h=new P.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")h=new P.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const p=A.URI.revive(c.uri);h=new P.SourceBreakpoint(new P.Location(p,new P.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}h._id=l,this._breakpoints.set(l,h),s.push(h)}}if(r.removed)for(const c of r.removed){const l=this._breakpoints.get(c);l&&(this._breakpoints.delete(c),n.push(l))}if(r.changed){for(const c of r.changed)if(c.id){const l=this._breakpoints.get(c.id);if(l){if(l instanceof P.FunctionBreakpoint&&c.type==="function"){const h=l;h.enabled=c.enabled,h.condition=c.condition,h.hitCondition=c.hitCondition,h.logMessage=c.logMessage,h.functionName=c.functionName}else if(l instanceof P.SourceBreakpoint&&c.type==="source"){const h=l;h.enabled=c.enabled,h.condition=c.condition,h.hitCondition=c.hitCondition,h.logMessage=c.logMessage,h.location=new P.Location(A.URI.revive(c.uri),new P.Position(c.line,c.character))}t.push(l)}}}this.fireBreakpointChanges(s,n,t)}$provideDebugConfigurations(r,s,n){return(0,u.asPromise)(async()=>{const t=this.getConfigProviderByHandle(r);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.getFolder(s);return t.provideDebugConfigurations(c,n)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(r,s,n,t){return(0,u.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const l=await this.getFolder(s);return c.resolveDebugConfiguration(l,n,t)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,n,t){return(0,u.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const l=await this.getFolder(s);return c.resolveDebugConfigurationWithSubstitutedVariables(l,n,t)})}async $provideDebugAdapter(r,s){const n=this.getAdapterDescriptorFactoryByHandle(r);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(s);return this.getAdapterDescriptor(n,t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(c)})}async $acceptDebugSessionStarted(r){const s=await this.getSession(r);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.getSession(r);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,s){const n=await this.getSession(r);n&&n._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const t={session:await this.getSession(r),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(r){if(r instanceof P.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof P.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const s=this._adapterFactories.filter(n=>n.type===r);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(r){const s=this._adapterFactories.filter(n=>n.handle===r);if(s.length>0)return s[0].factory}getConfigProviderByHandle(r){const s=this._configProviders.filter(n=>n.handle===r);if(s.length>0)return s[0].provider}definesDebugType(r,s){if(r.contributes){const n=r.contributes.debuggers;if(n&&n.length>0){for(const t of n)if(t.label&&t.type&&t.type===s)return!0}}return!1}getDebugAdapterTrackers(r){const n=r.configuration.type,t=this._trackerFactories.filter(c=>c.type===n||c.type==="*").map(c=>(0,u.asPromise)(()=>c.factory.createDebugAdapterTracker(r)).then(l=>l,l=>null));return Promise.race([Promise.all(t).then(c=>{const l=c.filter(h=>!!h);if(l.length>0)return new a(l)}),new Promise((c,l)=>{const h=setTimeout(()=>{clearTimeout(h),l(new Error("timeout"))},1e3)})]).catch(c=>{})}async getAdapterDescriptor(r,s){const n=s.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new P.DebugAdapterServer(n));if(r){const c=await this._extensionService.getExtensionRegistry();return(0,u.asPromise)(()=>r.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,c))).then(l=>{if(l)return l})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,t))}daExecutableFromPackage(r,s){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,s,n){(r.length>0||s.length>0||n.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:s,changed:n}))}async getSession(r){if(r)if(typeof r=="string"){const s=this._debugSessions.get(r);if(s)return s}else{let s=this._debugSessions.get(r.id);if(!s){const n=await this.getFolder(r.folderUri),t=r.parent?this._debugSessions.get(r.parent):void 0;s=new _(this._debugServiceProxy,r.id,r.type,r.name,n,r.configuration,t),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(r){if(r){const s=A.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=g,e.ExtHostDebugServiceBase=g=je([He(0,L.IExtHostRpcService),He(1,S.IExtHostWorkspace),He(2,T.IExtHostExtensionService),He(3,v.IExtHostConfiguration),He(4,b.IExtHostEditorTabs),He(5,w.IExtHostVariableResolverProvider)],g);class _{constructor(r,s,n,t,c,l,h){this._debugServiceProxy=r,this._id=s,this._type=n,this._name=t,this._workspaceFolder=c,this._configuration=l,this._parentSession=h}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,s)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=_;class f{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=f;class a{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.trackers.forEach(n=>n.onExit?n.onExit(r,s):void 0)}}class m extends I.AbstractDebugAdapter{constructor(r){super();this.implementation=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends g{constructor(r,s,n,t,c,l){super(r,s,n,t,c,l)}};e.WorkerExtHostDebugService=o,e.WorkerExtHostDebugService=o=je([He(0,L.IExtHostRpcService),He(1,S.IExtHostWorkspace),He(2,T.IExtHostExtensionService),He(3,v.IExtHostConfiguration),He(4,b.IExtHostEditorTabs),He(5,w.IExtHostVariableResolverProvider)],o)}),define(ke[277],Pe([1,0,11,75,2,5,269,14,83,86,27,194,18,66,39]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class v{constructor(g,_,f,a,m){this._hostUtils=f,this._rpcProtocol=new C.RPCProtocol(g,null,a),_=v._transform(_,this._rpcProtocol);const o=new T.ServiceCollection(...(0,b.getSingletonServiceDescriptors)());o.set(L.IExtHostInitDataService,{_serviceBrand:void 0,..._,messagePorts:m}),o.set(S.IExtHostRpcService,new S.ExtHostRpcService(this._rpcProtocol)),o.set(I.IURITransformerService,new I.URITransformerService(a)),o.set(E.IHostUtils,f);const d=new P.InstantiationService(o,!0);this._logService=d.invokeFunction(t=>t.get(D.ILogService)),i.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",_),this._extensionService=d.invokeFunction(t=>t.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const r=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(c,l)=>{let h="",p,R;for(const F of l)h+=`
	at ${F.toString()}`,R=F.getFileName(),!p&&R&&(p=t.findSubstr(y.URI.file(R)));return r.set(c,p),`${c.name||"Error"}: ${c.message||""}${h}`}});const s=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),n=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);u.setUnexpectedErrorHandler(t=>{const c=u.transformErrorForSerialization(t),l=r.get(t);l?s.$onExtensionRuntimeError(l.identifier,c):n.$onUnexpectedError(c)})}async asBrowserUri(g){const _=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return y.URI.revive(await _.$asBrowserUri(g))}terminate(g){this._extensionService.terminate(g)}static _transform(g,_){g.allExtensions.forEach(a=>a.extensionLocation=y.URI.revive(_.transformIncomingURIs(a.extensionLocation))),g.environment.appRoot=y.URI.revive(_.transformIncomingURIs(g.environment.appRoot));const f=g.environment.extensionDevelopmentLocationURI;return f&&(g.environment.extensionDevelopmentLocationURI=f.map(a=>y.URI.revive(_.transformIncomingURIs(a)))),g.environment.extensionTestsLocationURI=y.URI.revive(_.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=y.URI.revive(_.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=y.URI.revive(_.transformIncomingURIs(g.environment.workspaceStorageHome)),g.logsLocation=y.URI.revive(_.transformIncomingURIs(g.logsLocation)),g.logFile=y.URI.revive(_.transformIncomingURIs(g.logFile)),g.workspace=_.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=v}),define(ke[278],Pe([1,0,17,13,177,193,201,76,56,39,18,38,7,47,32,215,216,33]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let _=class extends D.ExtHostDebugServiceBase{constructor(d,r,s,n,t,c,l){super(d,r,s,n,c,l);this._terminalService=t,this._integratedTerminalInstances=new m}createDebugAdapter(d,r){switch(d.type){case"server":return new v.SocketDebugAdapter(d);case"pipeServer":return new v.NamedPipeDebugAdapter(d);case"executable":return new v.ExecutableDebugAdapter(d,r.type)}return super.createDebugAdapter(d,r)}daExecutableFromPackage(d,r){const s=v.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),d.type);if(s)return new S.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new C.SignService}async $runInTerminal(d,r){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(U=>{this._integratedTerminalInstances.onTerminalClosed(U)}));const s=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),t=this._terminalService.getDefaultShellArgs(!0),c=d.title||y.localize(0,null),l=JSON.stringify({shell:n,shellArgs:t});let h=await this._integratedTerminalInstances.checkout(l,c),p,R=!1;if(h)p=d.cwd;else{const U={shellPath:n,shellArgs:t,cwd:d.cwd,name:c,iconPath:new S.ThemeIcon("debug")};R=!0,h=this._terminalService.createTerminalFromOptions(U,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,l)}h.show(!0);const F=await h.processId;R?await new Promise(U=>setTimeout(U,1e3)):s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?h.sendText("cls"):n.indexOf("bash")>=0?h.sendText("clear"):i.isWindows?h.sendText("cls"):h.sendText("clear"));const O=(0,w.prepareCommand)(n,d.args,p,d.env);h.sendText(O);const k=this.onDidTerminateDebugSession(U=>{U.id===r&&(this._integratedTerminalInstances.free(h),k.dispose())});return F}else if(d.kind==="external")return a(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,r)}};e.ExtHostDebugService=_,e.ExtHostDebugService=_=je([He(0,L.IExtHostRpcService),He(1,E.IExtHostWorkspace),He(2,T.IExtHostExtensionService),He(3,g.IExtHostConfiguration),He(4,P.IExtHostTerminalService),He(5,b.IExtHostEditorTabs),He(6,I.IExtHostVariableResolverProvider)],_);let f;function a(o,d){if(!f)if(i.isWindows)f=new A.WindowsExternalTerminalService;else if(i.isMacintosh)f=new A.MacExternalTerminalService;else if(i.isLinux)f=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=d.getConfiguration("terminal");return f.runInTerminal(o.title,o.cwd,o.args,o.env||{},r.external||{})}e.runInExternalTerminal=a;class m{constructor(){this._terminalInstances=new Map}async checkout(d,r){const n=[...this._terminalInstances.entries()].map(([t,c])=>(0,u.createCancelablePromise)(async l=>{if(t.name!==r||c.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await t.processId))return null;const h=Date.now();return c.lastUsedAt+m.minUseDelay>h||l.isCancellationRequested||c.config!==d?null:(c.lastUsedAt=h,t)}));return await(0,u.firstParallel)(n,t=>!!t)}insert(d,r){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:r})}free(d){const r=this._terminalInstances.get(d);r&&(r.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}m.minUseDelay=1e3}),define(ke[279],Pe([1,0,9,2,113,32,55,33,45,38,18,27,74,10,14,69,22,64,47]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends S.ExtHostTaskBase{constructor(m,o,d,r,s,n,t,c,l){super(m,o,d,r,s,n,t,c);this.workspaceService=d,this.variableResolver=l,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(I.Schemas.vscodeRemote,{scheme:I.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(I.Schemas.file,{scheme:I.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(m,o){const d=o;if(!o.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const r=S.TaskHandleDTO.from(d,this.workspaceService),s=await this._proxy.$getTaskExecution(r);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(s,o);return this._proxy.$executeTask(r).catch(()=>{}),n}else{const r=S.TaskDTO.from(o,m);if(r===void 0)return Promise.reject(new Error("Task is not valid"));S.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,o,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),o);return this._proxy.$executeTask(r).catch(()=>{}),s}}provideTasksInternal(m,o,d,r){const s=[];if(r)for(let n of r){this.checkDeprecation(n,d),(!n.definition||!m[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const t=S.TaskDTO.from(n,d.extension);t&&(s.push(t),S.CustomExecutionDTO.is(t.execution)&&o.push(this.addCustomExecution(t,n,!0)))}return{tasks:s,extension:d.extension}}async resolveTaskInternal(m){return m}async getAFolder(m){let o=m&&m.length>0?m[0]:void 0;if(!o){const d=i.URI.file((0,g.homedir)());o=new b.WorkspaceFolder({uri:d,name:w.basename(d),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(m,o){const d=i.URI.revive(m),r={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(d),n=await this._workspaceProvider.getWorkspaceFolders2()??[],t=await this.variableResolver.getResolver(),c=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(n);for(let l of o.variables)r.variables[l]=await t.resolveAsync(c,l);if(o.process!==void 0){let l;if(o.process.path!==void 0){l=o.process.path.split(u.delimiter);for(let h=0;h<l.length;h++)l[h]=await t.resolveAsync(c,l[h])}r.process=await y.win32.findExecutable(await t.resolveAsync(c,o.process.name),o.process.cwd!==void 0?await t.resolveAsync(c,o.process.cwd):void 0,l)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(m,o,d){return y.win32.findExecutable(m,o,d)}};e.ExtHostTask=f,e.ExtHostTask=f=je([He(0,L.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,A.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,T.IExtHostTerminalService),He(6,E.ILogService),He(7,v.IExtHostApiDeprecationService),He(8,_.IExtHostVariableResolverProvider)],f)}),define(ke[280],Pe([1,0,64,47]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class y extends i.ExtHostVariableResolverProviderService{homeDir(){return(0,u.homedir)()}}e.NodeExtHostVariableResolverProviderService=y}),define(ke[139],Pe([1,0,16,17,21,51,10,9,22,12,2,31]),function(Q,e,u,i,y,A,C,D,b,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class S{constructor(f,a,m,o){this.query=f,this.provider=a,this.fileUtils=m,this.processType=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,a){const m=this.query.folderQueries||[],o=new y.CancellationTokenSource;return a.onCancellationRequested(()=>o.cancel()),new Promise((d,r)=>{this.collector=new E(f);let s=!1;const n=(t,c)=>{if(!s&&!this.isLimitHit){const l=this.resultSize(t);w(t)&&typeof this.query.maxResults=="number"&&this.resultCount+l>this.query.maxResults&&(this.isLimitHit=!0,s=!0,o.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const h=this.resultSize(t);this.resultCount+=h,(h>0||!w(t))&&this.collector.add(t,c)}};Promise.all(m.map((t,c)=>this.searchInFolder(t,l=>n(l,c),o.token))).then(t=>{o.dispose(),this.collector.flush();const c=t.some(l=>!!l&&!!l.limitHit);d({limitHit:this.isLimitHit||c,messages:(0,u.flatten)(t.map(l=>l?.message?(0,T.isArray)(l.message)?l.message:[l.message]:[])),stats:{type:this.processType}})},t=>{o.dispose();const c=(0,A.toErrorMessage)(t);r(new Error(c))})})}resultSize(f){return w(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,a){const m=Array.isArray(f.ranges)?f.ranges:[f.ranges],o=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:m.slice(0,a),preview:{matches:o.slice(0,a),text:f.preview.text},uri:f.uri}}async searchInFolder(f,a,m){const o=new P.QueryGlobTester(this.query,f),d=[],r={report:t=>{if(!this.validateProviderResult(t))return;const c=f.folder.scheme===C.Schemas.file?(0,P.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(b.dirname(t.uri))):void 0,l=b.relativePath(f.folder,t.uri);if(l){const h=o.includedInQuery(l,D.basename(l),c);(0,i.isThenable)(h)?d.push(h.then(p=>{p&&a(t)})):h&&a(t)}}},s=this.getSearchOptionsForFolder(f),n=await this.provider.provideTextSearchResults(I(this.query.contentPattern),s,r,m);return d.length&&await Promise.all(d),n}validateProviderResult(f){if(w(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const a=(0,P.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),m=(0,P.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),o={folder:L.URI.from(f.folder),excludes:m,includes:a,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return o.usePCRE2=this.query.usePCRE2,o}}e.TextSearchManager=S;function I(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class E{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,a=>this.sendItems(a))}add(f,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!b.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(v(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=E;function v(_){return w(_)?{preview:{matches:(0,u.mapArrayOrNot)(_.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:_.preview.text},ranges:(0,u.mapArrayOrNot)(_.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function w(_){return!!_.preview}e.extensionResultIsMatch=w;class g{constructor(f,a){this.maxBatchSize=f,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,a){!f||this.addItemToBatch(f,a)}addItems(f,a){!f||this.addItemsToBatch(f,a)}addItemToBatch(f,a){this.batch.push(f),this.batchSize+=a,this.onUpdate()}addItemsToBatch(f,a){this.batch=this.batch.concat(f),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(ke[77],Pe([1,0,6,5,4,273,18,66,14,2,139]),function(Q,e,u,i,y,A,C,D,b,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let P=class{constructor(v,w,g){this.extHostRpc=v,this._uriTransformer=w,this._logService=g,this._proxy=this.extHostRpc.getProxy(i.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,w){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const g=this._handlePool++;return this._textSearchProvider.set(g,w),this._proxy.$registerTextSearchProvider(g,this._transformScheme(v)),(0,u.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}registerFileSearchProvider(v,w){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const g=this._handlePool++;return this._fileSearchProvider.set(g,w),this._proxy.$registerFileSearchProvider(g,this._transformScheme(v)),(0,u.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(v,w,g,_){const f=S(g),a=this._fileSearchProvider.get(v);if(a)return this._fileSearchManager.fileSearch(f,a,m=>{this._proxy.$handleFileMatch(v,w,m.map(o=>o.resource))},_);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,w,g,_){const f=this._textSearchProvider.get(v);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const a=S(g);return this.createTextSearchManager(a,f).search(o=>this._proxy.$handleTextMatch(v,w,o),_)}$enableExtensionHostSearch(){}createTextSearchManager(v,w){return new L.TextSearchManager(v,w,{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g},"textSearchProvider")}};e.ExtHostSearch=P,e.ExtHostSearch=P=je([He(0,C.IExtHostRpcService),He(1,D.IURITransformerService),He(2,b.ILogService)],P);function S(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(I),extraFileResources:E.extraFileResources&&E.extraFileResources.map(v=>T.URI.revive(v))}}e.reviveQuery=S;function I(E){return{...E,folder:T.URI.revive(E.folder)}}}),define(ke[281],Pe([1,0,83,138,32,135,33,37,55,38,74,76,77,92,53,69,137,70,46,91,124,56,136,14,227,47]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_,f,a,m,o,d,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(d.ILoggerService,o.ExtHostLoggerService),(0,u.registerSingleton)(d.ILogService,r.ExtHostLogService),(0,u.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,u.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,u.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,u.registerSingleton)(g.IExtHostConsumerFileSystem,g.ExtHostConsumerFileSystem),(0,u.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,u.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,u.registerSingleton)(b.IExtHostDocumentsAndEditors,b.ExtHostDocumentsAndEditors),(0,u.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,u.registerSingleton)(i.IExtHostOutputService,i.ExtHostOutputService),(0,u.registerSingleton)(S.IExtHostSearch,S.ExtHostSearch),(0,u.registerSingleton)(I.IExtHostStorage,I.ExtHostStorage),(0,u.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,u.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,u.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService),(0,u.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,u.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace),(0,u.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState),(0,u.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry),(0,u.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs),(0,u.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService)}),define(ke[93],Pe([1,0,16,14,31,73]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=C;function D(P,S,I,E){const v=(0,u.mapArrayOrNot)(I,b),w=new y.TextSearchMatch(S,v,E),g=w.preview.matches;return{ranges:(0,u.mapArrayOrNot)(v,T),uri:P,preview:{text:w.preview.text,matches:(0,u.mapArrayOrNot)(g,T)}}}e.createTextSearchResult=D;function b(P){return new y.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function T(P){return new A.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let L=class{constructor(S,I){this.prefix=S,this.logService=I}appendLine(S){this.logService.debug(`${this.prefix}#search`,S)}};e.OutputChannel=L,e.OutputChannel=L=je([He(1,i.ILogService)],L)}),define(ke[282],Pe([1,0,42,9,82,30,13,8,93,283]),function(Q,e,u,i,y,A,C,D,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=T.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(f,a,m,o){const d=S(f,a,m,o),r=a.folder.fsPath;return{cmd:u.spawn(L,d.args,{cwd:r}),rgDiskPath:L,siblingClauses:d.siblingClauses,rgArgs:d,cwd:r}}e.spawnRipgrepCmd=P;function S(f,a,m,o){const d=["--files","--hidden","--case-sensitive"];E([a],m,!1).forEach(s=>{const n=(0,b.anchorGlob)(s);if(d.push("-g",n),C.isMacintosh){const t=(0,y.normalizeNFD)(n);t!==n&&d.push("-g",t)}});const r=I([a],o,void 0,!1);return r.globArgs.forEach(s=>{const n=`!${(0,b.anchorGlob)(s)}`;if(d.push("-g",n),C.isMacintosh){const t=(0,y.normalizeNFD)(n);t!==n&&d.push("-g",t)}}),a.disregardIgnoreFiles!==!1?d.push("--no-ignore"):a.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),a.ignoreSymlinks||d.push("--follow"),f.exists&&d.push("--quiet"),d.push("--no-config"),a.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:r.siblingClauses}}function I(f,a,m,o=!0){const d=[];let r={};return f.forEach(s=>{const n=Object.assign({},s.excludePattern||{},a||{}),t=v(n,o?s.folder.fsPath:void 0,m);d.push(...t.globArgs),t.siblingClauses&&(r=Object.assign(r,t.siblingClauses))}),{globArgs:d,siblingClauses:r}}e.foldersToRgExcludeGlobs=I;function E(f,a,m=!0){const o=[];return f.forEach(d=>{const r=Object.assign({},a||{},d.includePattern||{}),s=v(r,m?d.folder.fsPath:void 0);o.push(...s.globArgs)}),o}e.foldersToIncludeGlobs=E;function v(f,a,m){const o=[],d={};return Object.keys(f).forEach(r=>{if(m&&m.has(r)||!r)return;const s=f[r];r=g(a?w(a,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof s=="boolean"&&s?(r.startsWith("\\\\")&&(r+="**"),o.push(_(r))):s&&s.when&&(d[r]=s)}),{globArgs:o,siblingClauses:d}}function w(f,a){return i.isAbsolute(a)?a:i.join(f,a)}e.getAbsoluteGlob=w;function g(f){return f=D.rtrim(f,"\\"),D.rtrim(f,"/")}function _(f){return A.getRoot(f).toLowerCase()==="c:/"?f.replace(/^c:[/\\]/i,"/"):f}e.fixDriveC=_}),define(ke[284],Pe([1,0,42,63,9,105,16,51,34,82,30,13,49,8,12,29,31,282,101]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const f=new Set;process.on("exit",()=>{f.forEach(r=>r())});class a{constructor(s){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=s,this.filePattern=s.filePattern||"",this.includePattern=s.includePattern&&b.parse(s.includePattern),this.maxResults=s.maxResults||null,this.exists=!!s.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=s.excludePattern&&b.parse(s.excludePattern),this.folderExcludePatterns=new Map,s.folderQueries.forEach(n=>{const t=Object.assign({},n.excludePattern||{},this.config.excludePattern||{}),c=n.folder.fsPath;s.folderQueries.map(l=>l.folder.fsPath).filter(l=>l!==c).forEach(l=>{(0,L.isEqualOrParent)(l,c)&&(t[y.relative(c,l)]=!0)}),this.folderExcludePatterns.set(c,new o(t,c))})}cancel(){this.isCanceled=!0,f.forEach(s=>s())}walk(s,n,t,c,l){if(this.fileWalkSW=S.StopWatch.create(!1),this.isCanceled)return l(null,this.isLimitHit);n.forEach(h=>{const p=y.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,p)||this.matchFile(t,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=S.StopWatch.create(!1),this.parallel(s,(h,p)=>{this.call(this.cmdTraversal,this,h,t,c,R=>{if(R){const F=(0,D.toErrorMessage)(R);console.error(F),this.errors.push(F),p(R,void 0)}else p(null,void 0)})},(h,p)=>{this.fileWalkSW.stop();const R=h?C.coalesce(h)[0]:null;l(R,this.isLimitHit)})}parallel(s,n,t){const c=new Array(s.length),l=new Array(s.length);let h=!1,p=0;if(s.length===0)return t(null,[]);s.forEach((R,F)=>{n(R,(O,k)=>{if(O?(h=!0,c[F]=null,l[F]=O):(c[F]=k,l[F]=null),++p===s.length)return t(h?l:null,c)})})}call(s,n,...t){try{s.apply(n,t)}catch(c){t[t.length-1](c)}}cmdTraversal(s,n,t,c){const l=s.folder.fsPath,h=P.isMacintosh;let p;const R=()=>p&&p.kill();f.add(R);let F=$=>{f.delete(R),F=()=>{},c($)},O="";const k=this.initDirectoryTree();let U;const B=(0,g.spawnRipgrepCmd)(this.config,s,this.config.includePattern,this.folderExcludePatterns.get(s.folder.fsPath).expression);p=B.cmd,U=!Object.keys(B.siblingClauses).length;const z=B.rgArgs.args.map($=>$.match(/^-/)?$:`'${$}'`).join(" ");let Y=`${B.rgDiskPath} ${z}
 - cwd: ${B.cwd}`;B.rgArgs.siblingClauses&&(Y+=`
 - Sibling clauses: ${JSON.stringify(B.rgArgs.siblingClauses)}`),t({message:Y}),this.cmdResultCount=0,this.collectStdout(p,"utf8",t,($,N,V)=>{if($){F($);return}if(this.isLimitHit){F();return}const q=(O+(h?T.normalizeNFC(N||""):N)).split(`
`);if(V){const te=q.length;q[te-1]=q[te-1].trim(),q[te-1]||q.pop()}else O=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){F(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,U){for(const te of q)if(this.matchFile(n,{base:l,relativePath:te,searchPath:this.getSearchPath(s,te)}),this.isLimitHit){R();break}(V||this.isLimitHit)&&F();return}this.addDirectoryEntries(s,k,l,q,n),V&&(this.matchDirectoryTree(k,l,n),F())})}spawnFindCmd(s){const n=this.folderExcludePatterns.get(s.folder.fsPath),t=n.getBasenameTerms(),c=n.getPathTerms(),l=["-L","."];if(t.length||c.length){l.push("-not","(","(");for(const h of t)l.push("-name",h),l.push("-o");for(const h of c)l.push("-path",h),l.push("-o");l.pop(),l.push(")","-prune",")")}return l.push("-type","f"),u.spawn("find",l,{cwd:s.folder.fsPath})}readStdout(s,n,t){let c="";this.collectStdout(s,n,()=>{},(l,h,p)=>{if(l){t(l);return}c+=h,p&&t(null,c)})}collectStdout(s,n,t,c){let l=(R,F,O)=>{(R||O)&&(l=()=>{},this.cmdSW&&this.cmdSW.stop()),c(R,F,O)},h=!1;s.stdout?(this.forwardData(s.stdout,n,l),s.stdout.once("data",()=>h=!0)):t({message:"stdout is null"});let p;s.stderr?p=this.collectData(s.stderr):t({message:"stderr is null"}),s.on("error",R=>{l(R)}),s.on("close",R=>{let F;!h&&(F=this.decodeData(p,n))&&d(F)?l(new Error(`command failed with error code ${R}: ${this.decodeData(p,n)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),l(null,"",!0))})}forwardData(s,n,t){const c=new A.StringDecoder(n);return s.on("data",l=>{t(null,c.write(l))}),c}collectData(s){const n=[];return s.on("data",t=>{n.push(t)}),n}decodeData(s,n){const t=new A.StringDecoder(n);return s.map(c=>t.write(c)).join("")}initDirectoryTree(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}addDirectoryEntries(s,{pathToEntries:n},t,c,l){c.indexOf(this.filePattern)!==-1&&this.matchFile(l,{base:t,relativePath:this.filePattern,searchPath:this.getSearchPath(s,this.filePattern)});const h=p=>{const R=y.basename(p),F=y.dirname(p);let O=n[F];O||(O=n[F]=[],h(F)),O.push({base:t,relativePath:p,basename:R,searchPath:this.getSearchPath(s,p)})};c.forEach(h)}matchDirectoryTree({rootEntries:s,pathToEntries:n},t,c){const l=this,h=this.folderExcludePatterns.get(t),p=this.filePattern;function R(F){l.directoriesWalked++;const O=(0,w.hasSiblingFn)(()=>F.map(k=>k.basename));for(let k=0,U=F.length;k<U;k++){const B=F[k],{relativePath:z,basename:Y}=B;if(h.test(z,Y,p!==Y?O:void 0))continue;const $=n[z];if($)R($);else{if(l.filesWalked++,z===p)continue;l.matchFile(c,B)}if(l.isLimitHit)break}}R(s)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(s,n,t,c,l){const h=s.folder,p=(0,w.hasSiblingFn)(()=>t);this.parallel(t,(R,F)=>{if(this.isCanceled||this.isLimitHit)return F(null);const O=n?[n,R].join(y.sep):R;if(this.folderExcludePatterns.get(s.folder.fsPath).test(O,R,this.config.filePattern!==R?p:void 0))return F(null);const k=[h.fsPath,O].join(y.sep);i.lstat(k,(U,B)=>{if(U||this.isCanceled||this.isLimitHit)return F(null);this.statLinkIfNeeded(k,B,(z,Y)=>z||this.isCanceled||this.isLimitHit?F(null):Y.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(k,B,($,N)=>$||this.isCanceled||this.isLimitHit||(N=N||"",this.walkedPaths[N])?F(null):(this.walkedPaths[N]=!0,v.Promises.readdir(k).then(V=>{if(this.isCanceled||this.isLimitHit)return F(null);this.doWalk(s,O,V,c,H=>F(H||null))},V=>{F(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&E.isNumber(Y.size)&&Y.size>this.maxFilesize||this.matchFile(c,{base:h.fsPath,relativePath:O,searchPath:this.getSearchPath(s,O)}),F(null,void 0)))})},R=>{const F=R&&C.coalesce(R);return l(F&&F.length>0?F[0]:void 0)})}matchFile(s,n){this.isFileMatch(n)&&(!this.includePattern||this.includePattern(n.relativePath,y.basename(n.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||s(n))}isFileMatch(s){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,w.isFilePatternMatch)(s,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(s,n,t){return n.isSymbolicLink()?i.stat(s,t):t(null,n)}realPathIfNeeded(s,n,t){return n.isSymbolicLink()?i.realpath(s,(c,l)=>c?t(c):t(null,l)):t(null,s)}getSearchPath(s,n){return s.folderName?y.join(s.folderName,n):n}}e.FileWalker=a;class m{constructor(s){this.folderQueries=s.folderQueries,this.extraFiles=s.extraFileResources||[],this.walker=new a(s)}search(s,n,t){this.walker.walk(this.folderQueries,this.extraFiles,s,n,(c,l)=>{t(c,{limitHit:l,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class o{constructor(s,n){this.expression=s,this.root=n,this.init(s)}init(s){let n,t;Object.keys(s).filter(c=>s[c]).forEach(c=>{y.isAbsolute(c)?(n=n||b.getEmptyExpression(),n[c]=s[c]):(t=t||b.getEmptyExpression(),t[c]=s[c])}),this.absoluteParsedExpr=n&&b.parse(n,{trimForExclusions:!0}),this.relativeParsedExpr=t&&b.parse(t,{trimForExclusions:!0})}test(s,n,t){return this.relativeParsedExpr&&this.relativeParsedExpr(s,n,t)||this.absoluteParsedExpr&&this.absoluteParsedExpr(y.join(this.root,s),n,t)}getBasenameTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...b.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...b.getBasenameTerms(this.relativeParsedExpr)),s}getPathTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...b.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...b.getPathTerms(this.relativeParsedExpr)),s}}function d(r){const s=r.trim().split(`
`),n=s[0].trim();if(n.startsWith("Error parsing regex"))return n;if(n.startsWith("regex parse error"))return I.uppercaseFirstLetter(s[s.length-1].trim());if(n.startsWith("error parsing glob")||n.startsWith("unsupported encoding"))return n.charAt(0).toUpperCase()+n.substr(1);if(n==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(n.startsWith("Literal "))return n}e.rgErrorMsgForDisplay=d}),define(ke[285],Pe([1,0,97,23]),function(Q,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function y(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===r)}e.isUTFEncoding=y,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,C=512,D=512*8,b=512*128;var T;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(T||(e.DecodeStreamErrorKind=T={}));class L extends Error{constructor(s,n){super(s);this.decodeStreamErrorKind=n}}e.DecodeStreamError=L;class P{static async create(s){let n;if(s!==e.UTF8)n=(await new Promise((c,l)=>{Q(["@vscode/iconv-lite-umd"],c,l)})).getDecoder(v(s));else{const t=new TextDecoder;n={write(c){return t.decode(c,{stream:!0})},end(){return t.decode()}}}return new P(n)}constructor(s){this.iconvLiteDecoder=s}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function S(r,s){const n=s.minBytesRequiredForDetection??s.guessEncoding?D:C;return new Promise((t,c)=>{const l=(0,u.newWriteableStream)(k=>k.join("")),h=[];let p=0,R,F;const O=async()=>{try{const k=await d({buffer:i.VSBuffer.concat(h),bytesRead:p},s.guessEncoding);if(k.seemsBinary&&s.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);k.encoding=await s.overwriteEncoding(k.encoding),R=await P.create(k.encoding);const U=R.write(i.VSBuffer.concat(h).buffer);l.write(U),h.length=0,p=0,t({stream:l,detected:k})}catch(k){F?.dispose(),l.destroy(),c(k)}};F=(0,u.listenStream)(r,{onData:async k=>{R?l.write(R.write(k.buffer)):(h.push(k),p+=k.byteLength,p>=n&&(r.pause(),await O(),setTimeout(()=>r.resume())))},onError:k=>l.error(k),onEnd:async()=>{R||await O(),l.end(R?.end())}})})}e.toDecodeStream=S;async function I(r,s,n){const c=(await new Promise((p,R)=>{Q(["@vscode/iconv-lite-umd"],p,R)})).getEncoder(v(s),n);let l=!1,h=!1;return{read(){if(h)return null;const p=r.read();if(typeof p!="string"){if(h=!0,!l&&n?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return i.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=c.end();return R&&R.length>0?(l=!0,i.VSBuffer.wrap(R)):null}return l=!0,i.VSBuffer.wrap(c.write(p))}}}e.toEncodeReadable=I;async function E(r){return(await new Promise((n,t)=>{Q(["@vscode/iconv-lite-umd"],n,t)})).encodingExists(v(r))}e.encodingExists=E;function v(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=v;function w(r,s){if(!r||s<e.UTF16be_BOM.length)return null;const n=r.readUInt8(0),t=r.readUInt8(1);if(n===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const c=r.readUInt8(2);return n===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=w;const g=["ascii","utf-16","utf-32"];async function _(r){const s=await new Promise((h,p)=>{Q(["jschardet"],h,p)}),n=r.slice(0,b),t=m(n.buffer),c=s.detect(t);if(!c||!c.encoding)return null;const l=c.encoding.toLowerCase();return 0<=g.indexOf(l)?null:a(c.encoding)}const f={ibm866:"cp866",big5:"cp950"};function a(r){const s=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return f[s]||s}function m(r){let s="";for(let n=0;n<r.length;n++)s+=String.fromCharCode(r[n]);return s}function o(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const s=r.match(/windows(\d+)/);return s?"windows-"+s[1]:r}}}e.toCanonicalName=o;function d({buffer:r,bytesRead:s},n){let t=w(r,s),c=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&r){let l=!0,h=!0,p=!1;for(let R=0;R<s&&R<A;R++){const F=R%2==1,O=r.readUInt8(R)===0;if(O&&(p=!0),l&&(F&&!O||!F&&O)&&(l=!1),h&&(F&&O||!F&&!O)&&(h=!1),O&&!l&&!h)break}p&&(l?t=e.UTF16le:h?t=e.UTF16be:c=!0)}return n&&!c&&!t&&r?_(r.slice(0,s)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:c,encoding:t}}e.detectEncodingFromBuffer=d,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[140],Pe([1,0,285,29,139]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends y.TextSearchManager{constructor(D,b,T=i,L="searchProcess"){super(D,b,{readdir:P=>T.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,u.toCanonicalName)(P)},L)}}e.NativeTextSearchManager=A}),define(ke[286],Pe([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class u{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(y){if(y&&this._dragOperations.has(y)){const A=this._dragOperations.get(y);return this._dragOperations.delete(y),A}}addDragOperationTransfer(y,A){this._dragOperations.set(y,A)}getRenderedTreeElement(y){if(this._renderedElements.has(y))return this._renderedElements.get(y)}addRenderedTreeItemElement(y,A){this._renderedElements.set(y,A)}removeRenderedTreeItemElement(y){this._renderedElements.has(y)&&this._renderedElements.delete(y)}}e.TreeviewsService=u}),define(ke[287],Pe([1,0,175,7,22,2,3,6,17,7,12,16,15,21,286,28]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function w(f,a){if((0,L.isString)(f))return{label:f};if(f&&typeof f=="object"&&typeof f.label=="string"){let m;return Array.isArray(f.highlights)&&(m=f.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),m=m.length?m:void 0),{label:f.label,highlights:m}}}class g{constructor(a,m,o){this._proxy=a,this.commands=m,this.logService=o,this.treeViews=new Map,this.treeDragAndDropService=new E.TreeviewsService;function d(r){return r&&r.$treeViewId&&r.$treeItemHandle}m.registerArgumentProcessor({processArgument:r=>d(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>d(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(a,m,o){const d=this.createTreeView(a,{treeDataProvider:m},o);return{dispose:()=>d.dispose()}}createTreeView(a,m,o){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=m.dragAndDropController?.dropMimeTypes??[],r=m.dragAndDropController?.dragMimeTypes??[],s=!!m.dragAndDropController?.handleDrag,n=!!m.dragAndDropController?.handleDrop,t=(0,v.isProposedApiEnabled)(o,"dataTransferFiles"),c=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,dropMimeTypes:d,dragMimeTypes:r,hasHandleDrag:s,hasHandleDrop:n,supportsFileDataTransfers:t}),l=this.createExtHostTreeView(a,m,o);return{get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get message(){return l.message},set message(h){l.message=h},get title(){return l.title},set title(h){l.title=h},get description(){return l.description},set description(h){l.description=h},get badge(){return(0,v.checkProposedApiEnabled)(o,"badges"),l.badge},set badge(h){(0,v.checkProposedApiEnabled)(o,"badges"),l.badge=h},reveal:(h,p)=>l.reveal(h,p),dispose:async()=>{await c,this.treeViews.delete(a),l.dispose()}}}$getChildren(a,m){const o=this.treeViews.get(a);return o?o.getChildren(m):Promise.reject(new Error((0,u.localize)(0,null,a)))}async $handleDrop(a,m,o,d,r,s,n,t){const c=this.treeViews.get(a);if(!c)return Promise.reject(new Error((0,u.localize)(1,null,a)));const l=S.DataTransfer.toDataTransfer(o,async h=>(await this._proxy.$resolveDropFileData(a,m,h)).buffer);return n===a&&t&&await this.addAdditionalTransferItems(l,c,t,r,s),c.onDrop(l,d,r)}async addAdditionalTransferItems(a,m,o,d,r){const s=this.treeDragAndDropService.removeDragOperationTransfer(r);if(s)(await s)?.forEach((n,t)=>{n&&a.set(t,n)});else if(r&&m.handleDrag){const n=m.handleDrag(o,a,d);this.treeDragAndDropService.addDragOperationTransfer(r,n),await n}return a}async $handleDrag(a,m,o,d){const r=this.treeViews.get(a);if(!r)return Promise.reject(new Error((0,u.localize)(2,null,a)));const s=await this.addAdditionalTransferItems(new i.DataTransfer,r,m,d,o);if(!!s)return S.DataTransfer.toDataTransferDTO(s)}async $hasResolve(a){const m=this.treeViews.get(a);if(!m)throw new Error((0,u.localize)(3,null,a));return m.hasResolve}$resolve(a,m,o){const d=this.treeViews.get(a);if(!d)throw new Error((0,u.localize)(4,null,a));return d.resolveTreeItem(m,o)}$setExpanded(a,m,o){const d=this.treeViews.get(a);if(!d)throw new Error((0,u.localize)(5,null,a));d.setExpanded(m,o)}$setSelection(a,m){const o=this.treeViews.get(a);if(!o)throw new Error((0,u.localize)(6,null,a));o.setSelection(m)}$setVisible(a,m){const o=this.treeViews.get(a);if(!o)throw new Error((0,u.localize)(7,null,a));o.setVisible(m)}createExtHostTreeView(a,m,o){const d=new _(a,m,this._proxy,this.commands.converter,this.logService,o);return this.treeViews.set(a,d),d}convertArgument(a){const m=this.treeViews.get(a.$treeViewId);return m?m.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=g;class _ extends D.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,L.isUndefinedOrNull)(a))}constructor(a,m,o,d,r,s){super();if(this.viewId=a,this.proxy=o,this.commands=d,this.logService=r,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new I.CancellationTokenSource,s.contributes&&s.contributes.views)for(const c in s.contributes.views)for(const l of s.contributes.views[c])l.id===a&&(this._title=l.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let n,t;this._register(C.Event.debounce(this._onDidChangeData.event,(c,l)=>(c||(c={message:!1,elements:[]}),l.element!==!1&&(n||(n=new Promise(h=>t=h),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(l.element)?c.elements.push(...l.element):c.elements.push(l.element)),l.message&&(c.message=!0),c),200,!0)(({message:c,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=t;return n=null,this.refresh(l).then(()=>h())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(a){const m=a?this.getExtensionElement(a):void 0;if(a&&!m)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let o=this.getChildrenNodes(a);return o||(o=await this.fetchChildrenNodes(m)),o?o.map(d=>d.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,m){m=m||{select:!0,focus:!1};const o=(0,L.isUndefinedOrNull)(m.select)?!0:m.select,d=(0,L.isUndefinedOrNull)(m.focus)?!1:m.focus,r=(0,L.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(s=>this.resolveTreeNode(a,s[s.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:s.map(t=>t.item)},{select:o,focus:d,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:o,focus:d,expand:r})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}get badge(){return this._badge}set badge(a){this._badge?.value===a?.value&&this._badge?.tooltip===a?.tooltip||(this._badge=S.ViewBadge.from(a),this.proxy.$setBadge(this.viewId,a))}setExpanded(a,m){const o=this.getExtensionElement(a);o&&(m?this._onDidExpandElement.fire(Object.freeze({element:o})):this._onDidCollapseElement.fire(Object.freeze({element:o})))}setSelection(a){(0,P.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(a,m,o){const d=[];for(const r of a){const s=this.getExtensionElement(r);s&&d.push(s)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,m,o),m}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,m,o){const d=m?this.getExtensionElement(m):void 0;if(!(!d&&m||!this.dndController?.handleDrop))return(0,b.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(d,a,o):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,m){if(!this.dataProvider.resolveTreeItem)return;const o=this.elements.get(a);if(o){const d=this.nodes.get(o);if(d){const r=await this.dataProvider.resolveTreeItem(d.extensionItem,o,m)??d.extensionItem;return d.item.tooltip=this.getTooltip(r.tooltip),d.item.command=this.getCommand(d.disposableStore,r.command),d.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(m=>m?this.resolveUnknownParentChain(m).then(o=>this.resolveTreeNode(m,o[o.length-1]).then(d=>(o.push(d),o))):Promise.resolve([]))}resolveParent(a){const m=this.nodes.get(a);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,b.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,m){const o=this.nodes.get(a);return o?Promise.resolve(o):(0,b.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(d=>this.createHandle(a,d,m,!0)).then(d=>this.getChildren(m?m.item.handle:void 0).then(()=>{const r=this.getExtensionElement(d);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(a){if(a){let m;if(typeof a=="string"){const o=this.getExtensionElement(a);m=o?this.nodes.get(o):void 0}else m=a;return m&&m.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const m=new I.CancellationTokenSource(this._refreshCancellationSource.token);try{const o=a?this.nodes.get(a):void 0,d=await this.dataProvider.getChildren(a);if(m.token.isCancellationRequested)return;const r=await Promise.all((0,P.coalesce)(d||[]).map(async s=>{const n=await this.dataProvider.getTreeItem(s);return n&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(s,n,o):null}));return m.token.isCancellationRequested?void 0:(0,P.coalesce)(r)}finally{m.dispose()}}refresh(a){if(a.some(o=>!o))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new I.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const o=this.getHandlesToRefresh(a);if(o.length)return this.refreshHandles(o)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const m=new Set,o=a.map(r=>this.nodes.get(r));for(const r of o)if(r&&!m.has(r.item.handle)){let s=r;for(;s&&s.parent&&o.findIndex(n=>s&&s.parent&&n&&n.item.handle===s.parent.item.handle)===-1;){const n=this.elements.get(s.parent.item.handle);s=n?this.nodes.get(n):void 0}s&&!s.parent&&m.add(r.item.handle)}const d=[];return m.forEach(r=>{const s=this.elements.get(r);if(s){const n=this.nodes.get(s);n&&(!n.parent||!m.has(n.parent.item.handle))&&d.push(r)}}),d}refreshHandles(a){const m={};return Promise.all(a.map(o=>this.refreshNode(o).then(d=>{d&&(m[o]=d.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(a){const m=this.getExtensionElement(a);if(m){const o=this.nodes.get(m);if(o)return this.clearChildren(m),(0,b.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(d=>{if(d){const r=this.createTreeNode(m,d,o.parent);return this.updateNodeCache(m,r,o,o.parent),o.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,m,o){const d=this.createTreeNode(a,m,o);if(m.id&&this.elements.has(d.item.handle))throw new Error((0,u.localize)(8,null,m.id));return this.addNodeToCache(a,d),this.addNodeToParentCache(d,o),d}getTooltip(a){return T.MarkdownString.isMarkdownString(a)?S.MarkdownString.from(a):a}getCommand(a,m){return m?this.commands.toInternal(m,a):void 0}createTreeNode(a,m,o){const d=new D.DisposableStore,r=this.createHandle(a,m,o),s=this.getLightIconPath(m);return{item:{handle:r,parentHandle:o?o.item.handle:void 0,label:w(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(d,m.command),contextValue:m.contextValue,icon:s,iconDark:this.getDarkIconPath(m)||s,themeIcon:this.getThemeIcon(m),collapsibleState:(0,L.isUndefinedOrNull)(m.collapsibleState)?T.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:o,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(a){return a.iconPath instanceof T.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:m,label:o,resourceUri:d},r,s){if(m)return`${_.ID_HANDLE_PREFIX}/${m}`;const n=w(o,this.extension),t=r?r.item.handle:_.LABEL_HANDLE_PREFIX;let c=n?n.label:d?(0,y.basename)(d):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const l=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,h=this.getChildrenNodes(r)||[];let p,R=0;do{if(p=`${t}/${R}:${c}`,s||!this.elements.has(p)||l===p)break;R++}while(R<=h.length);return p}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof T.ThemeIcon))return typeof a.iconPath=="string"||A.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof T.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return A.URI.isUri(a)?a:A.URI.file(a)}addNodeToCache(a,m){this.elements.set(m.item.handle,a),this.nodes.set(a,m)}updateNodeCache(a,m,o,d){this.elements.delete(m.item.handle),this.nodes.delete(a),m.item.handle!==o.item.handle&&this.elements.delete(o.item.handle),this.addNodeToCache(a,m);const r=this.getChildrenNodes(d)||[],s=r.filter(n=>n.item.handle===o.item.handle)[0];s&&r.splice(r.indexOf(s),1,m)}addNodeToParentCache(a,m){m?(m.children||(m.children=[]),m.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const m=this.nodes.get(a);if(m){if(m.children)for(const o of m.children){const d=this.elements.get(o.item.handle);d&&this.clear(d)}m.children=void 0}}else this.clearAll()}clear(a){const m=this.nodes.get(a);if(m){if(m.children)for(const o of m.children){const d=this.elements.get(o.item.handle);d&&this.clear(d)}this.nodes.delete(a),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}_.LABEL_HANDLE_PREFIX="0",_.ID_HANDLE_PREFIX="1"}),define(ke[288],Pe([1,0,21,11,3,41,2,114,111,152,151,43,5,134,236,235,37,237,33,238,239,240,221,241,55,39,242,243,246,247,248,138,223,253,254,255,92,38,257,287,15,7,260,72,137,32,48,212,245,122,135,74,76,77,14,66,18,27,249,208,53,69,233,258,71,70,263,261,262,234,46,256,259,91,56,124,251,73,252,10,117,250,206,244,6,28,213]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_,f,a,m,o,d,r,s,n,t,c,l,h,p,R,F,O,k,U,B,z,Y,$,N,V,H,q,te,fe,ne,le,K,ge,ve,se,be,Te,pe,we,Ae,ce,me,ie,ee,M,x,G,X,de,Ee,oe,De,ye,ze,Ve,Me,Je,J,re,Ce,ae,Ie,Ne,$e,Ge,qe,Ze,Xe,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function et(rt){const ot=rt.get(Ae.IExtHostInitDataService),Et=rt.get(ye.IExtHostFileSystemInfo),At=rt.get(X.IExtHostConsumerFileSystem),It=rt.get(s.IExtHostExtensionService),ft=rt.get(te.IExtHostWorkspace),Rt=rt.get(J.IExtHostTelemetry),Bt=rt.get(_.IExtHostConfiguration),St=rt.get(pe.IURITransformerService),Ke=rt.get(we.IExtHostRpcService),Lt=rt.get(U.IExtHostStorage),Mt=rt.get(G.IExtensionStoragePaths),Ot=rt.get(Te.ILoggerService),pt=rt.get(Te.ILogService),yt=rt.get(ie.IExtHostTunnelService),kt=rt.get(ee.IExtHostApiDeprecationService),_t=rt.get(q.IExtHostWindow),Re=rt.get(Me.IExtHostSecretState),Fe=rt.get(Je.IExtHostEditorTabs);Ke.set(S.ExtHostContext.ExtHostFileSystemInfo,Et),Ke.set(S.ExtHostContext.ExtHostLogLevelServiceShape,Ot),Ke.set(S.ExtHostContext.ExtHostWorkspace,ft),Ke.set(S.ExtHostContext.ExtHostConfiguration,Bt),Ke.set(S.ExtHostContext.ExtHostExtensionService,It),Ke.set(S.ExtHostContext.ExtHostStorage,Lt),Ke.set(S.ExtHostContext.ExtHostTunnelService,yt),Ke.set(S.ExtHostContext.ExtHostWindow,_t),Ke.set(S.ExtHostContext.ExtHostSecretState,Re),Ke.set(S.ExtHostContext.ExtHostTelemetry,Rt),Ke.set(S.ExtHostContext.ExtHostEditorTabs,Fe);const _e=Ke.set(S.ExtHostContext.ExtHostDecorations,rt.get(ge.IExtHostDecorations)),Z=Ke.set(S.ExtHostContext.ExtHostDocumentsAndEditors,rt.get(r.IExtHostDocumentsAndEditors)),Oe=Ke.set(S.ExtHostContext.ExtHostCommands,rt.get(w.IExtHostCommands)),We=Ke.set(S.ExtHostContext.ExtHostTerminalService,rt.get(B.IExtHostTerminalService)),it=Ke.set(S.ExtHostContext.ExtHostDebugService,rt.get(se.IExtHostDebugService)),Qe=Ke.set(S.ExtHostContext.ExtHostSearch,rt.get(be.IExtHostSearch)),ut=Ke.set(S.ExtHostContext.ExtHostTask,rt.get(ve.IExtHostTask)),ht=Ke.set(S.ExtHostContext.ExtHostOutputService,rt.get(p.IExtHostOutputService)),wt=Ke.set(S.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(Ke)),mt=Ke.set(S.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Ke,Z)),Pt=Ke.set(S.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(Ke,Z,pt)),Ft=Ke.set(S.ExtHostContext.ExtHostDocumentSaveParticipant,new o.ExtHostDocumentSaveParticipant(pt,mt,Ke.getProxy(S.MainContext.MainThreadBulkEdits))),vt=Ke.set(S.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(Ke,Oe,Z,mt,Mt)),Wt=Ke.set(S.ExtHostContext.ExtHostNotebookDocuments,new Ge.ExtHostNotebookDocuments(vt)),Yt=Ke.set(S.ExtHostContext.ExtHostNotebookEditors,new $e.ExtHostNotebookEditors(pt,Ke,vt)),ai=Ke.set(S.ExtHostContext.ExtHostNotebookKernels,new re.ExtHostNotebookKernels(Ke,ot,vt,Oe,pt)),ci=Ke.set(S.ExtHostContext.ExtHostNotebookRenderers,new ae.ExtHostNotebookRenderers(Ke,vt)),Ct=Ke.set(S.ExtHostContext.ExtHostEditors,new z.ExtHostEditors(Ke,Z)),ii=Ke.set(S.ExtHostContext.ExtHostTreeViews,new Y.ExtHostTreeViews(Ke.getProxy(S.MainContext.MainThreadTreeViews),Oe,pt)),li=Ke.set(S.ExtHostContext.ExtHostEditorInsets,new ne.ExtHostEditorInsets(Ke.getProxy(S.MainContext.MainThreadEditorInsets),Ct,ot.remote)),Gt=Ke.set(S.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(Ke,pt,Et)),Kt=Ke.set(S.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(Ke,mt,Oe.converter,St)),dt=Ke.set(S.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ke,St,mt,Oe,Gt,pt,kt)),ui=Ke.set(S.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Ke,dt)),xt=Ke.set(S.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ke,pt,Z)),Vt=Ke.set(S.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(Ke,ft,Oe)),di=Ke.set(S.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(Ke,Oe,pt)),vi=Ke.set(S.ExtHostContext.ExtHostComments,(0,g.createExtHostComments)(Ke,Oe,mt)),ni=Ke.set(S.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Ke.getProxy(S.MainContext.MainThreadProgress))),hi=Ke.set(S.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Ke)),ri=Ke.set(S.ExtHostContext.ExtHostTheming,new me.ExtHostTheming(Ke)),Xt=Ke.set(S.ExtHostContext.ExtHostAuthentication,new M.ExtHostAuthentication(Ke)),wi=Ke.set(S.ExtHostContext.ExtHostTimeline,new x.ExtHostTimeline(Ke,Oe)),Jt=Ke.set(S.ExtHostContext.ExtHostWebviews,new H.ExtHostWebviews(Ke,ot.remote,ft,pt,kt)),Zt=Ke.set(S.ExtHostContext.ExtHostWebviewPanels,new oe.ExtHostWebviewPanels(Ke,Jt,ft)),bi=Ke.set(S.ExtHostContext.ExtHostCustomEditors,new Ee.ExtHostCustomEditors(Ke,mt,Mt,Jt,Zt)),Ei=Ke.set(S.ExtHostContext.ExtHostWebviewViews,new de.ExtHostWebviewViews(Ke,Jt)),Qt=Ke.set(S.ExtHostContext.ExtHostTesting,new ze.ExtHostTesting(Ke,Oe)),_i=Ke.set(S.ExtHostContext.ExtHostUriOpeners,new Ve.ExtHostUriOpeners(Ke));Ke.set(S.ExtHostContext.ExtHostInteractive,new qe.ExtHostInteractive(Ke,vt,Z,Oe));const Ri=(0,fe.values)(S.ExtHostContext);Ke.assertRegistered(Ri);const Li=new De.ExtHostBulkEdits(Ke,Z),fi=new v.ExtHostClipboard(Ke),ei=new h.ExtHostMessageService(Ke,pt),Si=new a.ExtHostDialogs(Ke),yi=new k.ExtHostStatusBar(Ke,Oe.converter);return E.ExtHostApiCommands.register(Oe),function(xe,zt,mi){const gt=function(){let he=!xe.isUnderDevelopment;function Se(){he||(pt.info(`Extension '${xe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),he=!0)}return function Be(at){if(Array.isArray(at))at.forEach(Be);else if(typeof at=="string")Se();else{const bt=at;typeof bt.scheme=="undefined"&&Se(),typeof bt.exclusive=="boolean"&&(0,Xe.checkProposedApiEnabled)(xe,"documentFiltersExclusive")}return at}}(),Ci={getSession(he,Se,Be){return Xt.getSession(xe,he,Se,Be)},async hasSession(he,Se){return(0,Xe.checkProposedApiEnabled)(xe,"authSession"),!!await Xt.getSession(xe,he,Se,{silent:!0})},get onDidChangeSessions(){return Xt.onDidChangeSessions},registerAuthenticationProvider(he,Se,Be,at){return Xt.registerAuthenticationProvider(he,Se,Be,at)}},Oi={registerCommand(he,Se,Be){return Oe.registerCommand(!0,he,Se,Be,void 0,xe)},registerTextEditorCommand(he,Se,Be){return Oe.registerCommand(!0,he,(...at)=>{const bt=Ct.getActiveTextEditor();if(!bt){pt.warn("Cannot execute "+he+" because there is no active text editor.");return}return bt.edit(Tt=>{Se.apply(Be,[bt,Tt,...at])}).then(Tt=>{Tt||pt.warn("Edits from command "+he+" were not applied.")},Tt=>{pt.warn("An error occurred while running command "+he,Tt)})},void 0,void 0,xe)},registerDiffInformationCommand:(he,Se,Be)=>((0,Xe.checkProposedApiEnabled)(xe,"diffCommand"),Oe.registerCommand(!0,he,async(...at)=>{const bt=Z.activeEditor(!0);if(!bt){pt.warn("Cannot execute "+he+" because there is no active text editor.");return}const Tt=await Ct.getDiffInformation(bt.id);Se.apply(Be,[Tt,...at])},void 0,void 0,xe)),executeCommand(he,...Se){return Oe.executeCommand(he,...Se)},getCommands(he=!1){return Oe.getCommands(he)}},si={get machineId(){return ot.telemetryInfo.machineId},get sessionId(){return ot.telemetryInfo.sessionId},get language(){return ot.environment.appLanguage},get appName(){return ot.environment.appName},get appRoot(){return ot.environment.appRoot?.fsPath??""},get appHost(){return ot.environment.appHost},get uriScheme(){return ot.environment.appUriScheme},get clipboard(){return fi.value},get shell(){return We.getDefaultShell(!1)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Rt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(xe,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(xe,"telemetry"),Rt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const he=Date.now()-new Date(ot.telemetryInfo.firstSessionDate).getTime();return isNaN(he)?!1:he<1e3*60*60*24},openExternal(he,Se){return _t.openUri(he,{allowTunneling:!!ot.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(he){if(he.scheme===ot.environment.appUriScheme)return wt.createAppUri(he);try{return await _t.asExternalUri(he,{allowTunneling:!!ot.remote.authority})}catch(Se){if((0,Ne.matchesScheme)(he,Ie.Schemas.http)||(0,Ne.matchesScheme)(he,Ie.Schemas.https))return he;throw Se}},get remoteName(){return(0,K.getRemoteName)(ot.remote.authority)},get remoteAuthority(){return(0,Xe.checkProposedApiEnabled)(xe,"resolvers"),ot.remote.authority},get uiKind(){return ot.uiKind}};ot.environment.extensionTestsLocationURI||Object.freeze(si);const Di={createTestController(he,Se,Be){return Qt.createTestController(he,Se,Be)},createTestObserver(){return(0,Xe.checkProposedApiEnabled)(xe,"testObserver"),Qt.createTestObserver()},runTests(he){return(0,Xe.checkProposedApiEnabled)(xe,"testObserver"),Qt.runTests(he)},get onDidChangeTestResults(){return(0,Xe.checkProposedApiEnabled)(xe,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,Xe.checkProposedApiEnabled)(xe,"testObserver"),Qt.results}},Ut=ot.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,jt={getExtension(he,Se){(0,Xe.isProposedApiEnabled)(xe,"extensionsAny")||(Se=!1);const Be=zt.mine.getExtensionDescription(he);if(Be)return new s.Extension(It,xe.identifier,Be,Ut,!1);if(Se){const at=zt.all.getExtensionDescription(he);if(at)return new s.Extension(It,xe.identifier,at,Ut,!0)}},get all(){const he=[];for(const Se of zt.mine.getAllExtensionDescriptions())he.push(new s.Extension(It,xe.identifier,Se,Ut,!1));return he},get allAcrossExtensionHosts(){(0,Xe.checkProposedApiEnabled)(xe,"extensionsAny");const he=new Xe.ExtensionIdentifierSet(zt.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),Se=[];for(const Be of zt.all.getAllExtensionDescriptions()){const at=!he.has(Be.identifier);Se.push(new s.Extension(It,xe.identifier,Be,Ut,at))}return Se},get onDidChange(){return(0,Xe.isProposedApiEnabled)(xe,"extensionsAny")?y.Event.any(zt.mine.onDidChange,zt.all.onDidChange):zt.mine.onDidChange}},Fi={createDiagnosticCollection(he){return Gt.createDiagnosticCollection(xe.identifier,he)},get onDidChangeDiagnostics(){return Gt.onDidChangeDiagnostics},getDiagnostics:he=>Gt.getDiagnostics(he),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(he,Se){return Kt.changeLanguage(he.uri,Se)},match(he,Se){const Be=mt.getDocumentData(Se.uri)?.notebook;return(0,L.score)($.LanguageSelector.from(he),Se.uri,Se.languageId,!0,Be?.uri,Be?.notebookType)},registerCodeActionsProvider(he,Se,Be){return dt.registerCodeActionProvider(xe,gt(he),Se,Be)},registerDocumentPasteEditProvider(he,Se){return(0,Xe.checkProposedApiEnabled)(xe,"documentPaste"),dt.registerDocumentPasteEditProvider(xe,gt(he),Se)},registerCodeLensProvider(he,Se){return dt.registerCodeLensProvider(xe,gt(he),Se)},registerDefinitionProvider(he,Se){return dt.registerDefinitionProvider(xe,gt(he),Se)},registerDeclarationProvider(he,Se){return dt.registerDeclarationProvider(xe,gt(he),Se)},registerImplementationProvider(he,Se){return dt.registerImplementationProvider(xe,gt(he),Se)},registerTypeDefinitionProvider(he,Se){return dt.registerTypeDefinitionProvider(xe,gt(he),Se)},registerHoverProvider(he,Se){return dt.registerHoverProvider(xe,gt(he),Se,xe.identifier)},registerEvaluatableExpressionProvider(he,Se){return dt.registerEvaluatableExpressionProvider(xe,gt(he),Se,xe.identifier)},registerInlineValuesProvider(he,Se){return dt.registerInlineValuesProvider(xe,gt(he),Se,xe.identifier)},registerDocumentHighlightProvider(he,Se){return dt.registerDocumentHighlightProvider(xe,gt(he),Se)},registerLinkedEditingRangeProvider(he,Se){return dt.registerLinkedEditingRangeProvider(xe,gt(he),Se)},registerReferenceProvider(he,Se){return dt.registerReferenceProvider(xe,gt(he),Se)},registerRenameProvider(he,Se){return dt.registerRenameProvider(xe,gt(he),Se)},registerDocumentSymbolProvider(he,Se,Be){return dt.registerDocumentSymbolProvider(xe,gt(he),Se,Be)},registerWorkspaceSymbolProvider(he){return dt.registerWorkspaceSymbolProvider(xe,he)},registerDocumentFormattingEditProvider(he,Se){return dt.registerDocumentFormattingEditProvider(xe,gt(he),Se)},registerDocumentRangeFormattingEditProvider(he,Se){return dt.registerDocumentRangeFormattingEditProvider(xe,gt(he),Se)},registerOnTypeFormattingEditProvider(he,Se,Be,...at){return dt.registerOnTypeFormattingEditProvider(xe,gt(he),Se,[Be].concat(at))},registerDocumentSemanticTokensProvider(he,Se,Be){return dt.registerDocumentSemanticTokensProvider(xe,gt(he),Se,Be)},registerDocumentRangeSemanticTokensProvider(he,Se,Be){return dt.registerDocumentRangeSemanticTokensProvider(xe,gt(he),Se,Be)},registerSignatureHelpProvider(he,Se,Be,...at){return typeof Be=="object"?dt.registerSignatureHelpProvider(xe,gt(he),Se,Be):dt.registerSignatureHelpProvider(xe,gt(he),Se,typeof Be=="undefined"?[]:[Be,...at])},registerCompletionItemProvider(he,Se,...Be){return dt.registerCompletionItemProvider(xe,gt(he),Se,Be)},registerInlineCompletionItemProvider(he,Se){return Se.handleDidShowCompletionItem&&(0,Xe.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(xe,gt(he),Se)},registerInlineCompletionItemProviderNew(he,Se){if((0,Xe.checkProposedApiEnabled)(xe,"inlineCompletionsNew"),Se.handleDidShowCompletionItem&&!(0,Xe.isProposedApiEnabled)(xe,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew(xe,gt(he),Se)},registerDocumentLinkProvider(he,Se){return dt.registerDocumentLinkProvider(xe,gt(he),Se)},registerColorProvider(he,Se){return dt.registerColorProvider(xe,gt(he),Se)},registerFoldingRangeProvider(he,Se){return dt.registerFoldingRangeProvider(xe,gt(he),Se)},registerSelectionRangeProvider(he,Se){return dt.registerSelectionRangeProvider(xe,he,Se)},registerCallHierarchyProvider(he,Se){return dt.registerCallHierarchyProvider(xe,he,Se)},registerTypeHierarchyProvider(he,Se){return dt.registerTypeHierarchyProvider(xe,he,Se)},setLanguageConfiguration:(he,Se)=>dt.setLanguageConfiguration(xe,he,Se),getTokenInformationAtPosition(he,Se){return(0,Xe.checkProposedApiEnabled)(xe,"tokenInformation"),Kt.tokenAtPosition(he,Se)},registerInlayHintsProvider(he,Se){return dt.registerInlayHintsProvider(xe,he,Se)},createLanguageStatusItem(he,Se){return Kt.createLanguageStatusItem(xe,he,Se)},registerDocumentOnDropEditProvider(he,Se){return(0,Xe.checkProposedApiEnabled)(xe,"textEditorDrop"),dt.registerDocumentOnDropEditProvider(xe,he,Se)}},Ii={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return We.activeTerminal},get terminals(){return We.terminals},async showTextDocument(he,Se,Be){const at=await(C.URI.isUri(he)?Promise.resolve(ti.openTextDocument(he)):Promise.resolve(he));return Ct.showTextDocument(at,Se,Be)},createTextEditorDecorationType(he){return Ct.createTextEditorDecorationType(xe,he)},onDidChangeActiveTextEditor(he,Se,Be){return Ct.onDidChangeActiveTextEditor(he,Se,Be)},onDidChangeVisibleTextEditors(he,Se,Be){return Ct.onDidChangeVisibleTextEditors(he,Se,Be)},onDidChangeTextEditorSelection(he,Se,Be){return Ct.onDidChangeTextEditorSelection(he,Se,Be)},onDidChangeTextEditorOptions(he,Se,Be){return Ct.onDidChangeTextEditorOptions(he,Se,Be)},onDidChangeTextEditorVisibleRanges(he,Se,Be){return Ct.onDidChangeTextEditorVisibleRanges(he,Se,Be)},onDidChangeTextEditorViewColumn(he,Se,Be){return Ct.onDidChangeTextEditorViewColumn(he,Se,Be)},onDidCloseTerminal(he,Se,Be){return We.onDidCloseTerminal(he,Se,Be)},onDidOpenTerminal(he,Se,Be){return We.onDidOpenTerminal(he,Se,Be)},onDidChangeActiveTerminal(he,Se,Be){return We.onDidChangeActiveTerminal(he,Se,Be)},onDidChangeTerminalDimensions(he,Se,Be){return(0,Xe.checkProposedApiEnabled)(xe,"terminalDimensions"),We.onDidChangeTerminalDimensions(he,Se,Be)},onDidChangeTerminalState(he,Se,Be){return We.onDidChangeTerminalState(he,Se,Be)},onDidWriteTerminalData(he,Se,Be){return(0,Xe.checkProposedApiEnabled)(xe,"terminalDataWriteEvent"),We.onDidWriteTerminalData(he,Se,Be)},get state(){return _t.state},onDidChangeWindowState(he,Se,Be){return _t.onDidChangeWindowState(he,Se,Be)},showInformationMessage(he,...Se){return ei.showMessage(xe,A.default.Info,he,Se[0],Se.slice(1))},showWarningMessage(he,...Se){return ei.showMessage(xe,A.default.Warning,he,Se[0],Se.slice(1))},showErrorMessage(he,...Se){return ei.showMessage(xe,A.default.Error,he,Se[0],Se.slice(1))},showQuickPick(he,Se,Be){return Vt.showQuickPick(he,Se,Be)},showWorkspaceFolderPick(he){return Vt.showWorkspaceFolderPick(he)},showInputBox(he,Se){return Vt.showInput(he,Se)},showOpenDialog(he){return Si.showOpenDialog(he)},showSaveDialog(he){return Si.showSaveDialog(he)},createStatusBarItem(he,Se,Be){let at,bt,Tt;return typeof he=="string"?(at=he,bt=Se,Tt=Be):(bt=he,Tt=Se),yi.createStatusBarEntry(xe,at,bt,Tt)},setStatusBarMessage(he,Se){return yi.setStatusBarMessage(he,Se)},withScmProgress(he){return kt.report("window.withScmProgress",xe,"Use 'withProgress' instead."),ni.withProgress(xe,{location:N.ProgressLocation.SourceControl},(Se,Be)=>he({report(at){}}))},withProgress(he,Se){return ni.withProgress(xe,he,Se)},createOutputChannel(he,Se){return ht.createOutputChannel(he,Se,xe)},createWebviewPanel(he,Se,Be,at){return Zt.createWebviewPanel(xe,he,Se,Be,at)},createWebviewTextEditorInset(he,Se,Be,at){return(0,Xe.checkProposedApiEnabled)(xe,"editorInsets"),li.createWebviewEditorInset(he,Se,Be,at,xe)},createTerminal(he,Se,Be){return typeof he=="object"?"pty"in he?We.createExtensionTerminal(he):We.createTerminalFromOptions(he):We.createTerminal(he,Se,Be)},registerTerminalLinkProvider(he){return We.registerLinkProvider(he)},registerTerminalProfileProvider(he,Se){return We.registerProfileProvider(xe,he,Se)},registerTreeDataProvider(he,Se){return ii.registerTreeDataProvider(he,Se,xe)},createTreeView(he,Se){return ii.createTreeView(he,Se,xe)},registerWebviewPanelSerializer:(he,Se)=>Zt.registerWebviewPanelSerializer(xe,he,Se),registerCustomEditorProvider:(he,Se,Be={})=>bi.registerCustomEditorProvider(xe,he,Se,Be),registerFileDecorationProvider(he){return _e.registerFileDecorationProvider(he,xe.identifier)},registerUriHandler(he){return wt.registerUriHandler(xe.identifier,he)},createQuickPick(){return Vt.createQuickPick(xe)},createInputBox(){return Vt.createInputBox(xe)},get activeColorTheme(){return ri.activeColorTheme},onDidChangeActiveColorTheme(he,Se,Be){return ri.onDidChangeActiveColorTheme(he,Se,Be)},registerWebviewViewProvider(he,Se,Be){return Ei.registerWebviewViewProvider(xe,he,Se,Be?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(he,Se,Be){return vt.onDidChangeActiveNotebookEditor(he,Se,Be)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(he,Se,Be){return Yt.onDidChangeNotebookEditorSelection(he,Se,Be)},onDidChangeNotebookEditorVisibleRanges(he,Se,Be){return Yt.onDidChangeNotebookEditorVisibleRanges(he,Se,Be)},showNotebookDocument(he,Se){return C.URI.isUri(he)&&kt.report("window.showNotebookDocument(uri)",xe,"Please use 'window.openNotebookDocument' and 'window.showTextDocument'"),vt.showNotebookDocument(he,Se)},registerExternalUriOpener(he,Se,Be){return(0,Xe.checkProposedApiEnabled)(xe,"externalUriOpener"),_i.registerExternalUriOpener(xe.identifier,he,Se,Be)},get tabGroups(){return Fe.tabGroups}},ti={get rootPath(){return kt.report("workspace.rootPath",xe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(he){throw i.readonly()},getWorkspaceFolder(he){return ft.getWorkspaceFolder(he)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(he){throw i.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(he){throw i.readonly()},updateWorkspaceFolders:(he,Se,...Be)=>ft.updateWorkspaceFolders(xe,he,Se||0,...Be),onDidChangeWorkspaceFolders:function(he,Se,Be){return ft.onDidChangeWorkspace(he,Se,Be)},asRelativePath:(he,Se)=>ft.getRelativePath(he,Se),findFiles:(he,Se,Be,at)=>ft.findFiles(he,Se,Be,xe.identifier,at),findTextInFiles:(he,Se,Be,at)=>{(0,Xe.checkProposedApiEnabled)(xe,"findTextInFiles");let bt,Tt;return typeof Se=="object"?(bt=Se,Tt=Be):(bt={},Tt=Se,at=Be),ft.findTextInFiles(he,bt||{},Tt,xe.identifier,at)},saveAll:he=>ft.saveAll(he),applyEdit(he){return Li.applyWorkspaceEdit(he)},createFileSystemWatcher:(he,Se,Be,at)=>xt.createFileSystemWatcher(ft,xe,he,Se,Be,at),get textDocuments(){return mt.getAllDocumentData().map(he=>he.document)},set textDocuments(he){throw i.readonly()},openTextDocument(he){let Se;const Be=he;if(typeof he=="string")Se=Promise.resolve(C.URI.file(he));else if(C.URI.isUri(he))Se=Promise.resolve(he);else if(!Be||typeof Be=="object")Se=mt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(at=>mt.ensureDocumentData(at).then(bt=>bt.document))},onDidOpenTextDocument:(he,Se,Be)=>mt.onDidAddDocument(he,Se,Be),onDidCloseTextDocument:(he,Se,Be)=>mt.onDidRemoveDocument(he,Se,Be),onDidChangeTextDocument:(he,Se,Be)=>mt.onDidChangeDocument(he,Se,Be),onDidSaveTextDocument:(he,Se,Be)=>mt.onDidSaveDocument(he,Se,Be),onWillSaveTextDocument:(he,Se,Be)=>Ft.getOnWillSaveTextDocumentEvent(xe)(he,Se,Be),get notebookDocuments(){return vt.notebookDocuments.map(he=>he.apiNotebook)},async openNotebookDocument(he,Se){let Be;if(C.URI.isUri(he))Be=he,await vt.openNotebookDocument(he);else if(typeof he=="string")Be=C.URI.revive(await vt.createNotebookDocument({viewType:he,content:Se}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(he,Se,Be){return Wt.onDidSaveNotebookDocument(he,Se,Be)},onDidChangeNotebookDocument(he,Se,Be){return Wt.onDidChangeNotebookDocument(he,Se,Be)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(he,Se,Be,at){return vt.registerNotebookSerializer(xe,he,Se,Be,(0,Xe.isProposedApiEnabled)(xe,"notebookLiveShare")?at:void 0)},registerNotebookContentProvider:(he,Se,Be,at)=>((0,Xe.checkProposedApiEnabled)(xe,"notebookContentProvider"),kt.report("workspace.registerNotebookContentProvider",xe,"The notebookContentProvider API is not on track for finalization and will be removed."),vt.registerNotebookContentProvider(xe,he,Se,Be,(0,Xe.isProposedApiEnabled)(xe,"notebookLiveShare")?at:void 0)),onDidChangeConfiguration:(he,Se,Be)=>mi.onDidChangeConfiguration(he,Se,Be),getConfiguration(he,Se){return Se=arguments.length===1?void 0:Se,mi.getConfiguration(he,Se,xe)},registerTextDocumentContentProvider(he,Se){return Pt.registerTextDocumentContentProvider(he,Se)},registerTaskProvider:(he,Se)=>(kt.report("window.registerTaskProvider",xe,"Use the corresponding function on the 'tasks' namespace instead"),ut.registerTaskProvider(xe,he,Se)),registerFileSystemProvider(he,Se,Be){return(0,Ze.combinedDisposable)(ui.registerFileSystemProvider(xe,he,Se,Be),At.addFileSystemProvider(he,Se))},get fs(){return At.value},registerFileSearchProvider:(he,Se)=>((0,Xe.checkProposedApiEnabled)(xe,"fileSearchProvider"),Qe.registerFileSearchProvider(he,Se)),registerTextSearchProvider:(he,Se)=>((0,Xe.checkProposedApiEnabled)(xe,"textSearchProvider"),Qe.registerTextSearchProvider(he,Se)),registerRemoteAuthorityResolver:(he,Se)=>((0,Xe.checkProposedApiEnabled)(xe,"resolvers"),It.registerRemoteAuthorityResolver(he,Se)),registerResourceLabelFormatter:he=>((0,Xe.checkProposedApiEnabled)(xe,"resolvers"),hi.$registerResourceLabelFormatter(he)),onDidCreateFiles:(he,Se,Be)=>xt.onDidCreateFile(he,Se,Be),onDidDeleteFiles:(he,Se,Be)=>xt.onDidDeleteFile(he,Se,Be),onDidRenameFiles:(he,Se,Be)=>xt.onDidRenameFile(he,Se,Be),onWillCreateFiles:(he,Se,Be)=>xt.getOnWillCreateFileEvent(xe)(he,Se,Be),onWillDeleteFiles:(he,Se,Be)=>xt.getOnWillDeleteFileEvent(xe)(he,Se,Be),onWillRenameFiles:(he,Se,Be)=>xt.getOnWillRenameFileEvent(xe)(he,Se,Be),openTunnel:he=>((0,Xe.checkProposedApiEnabled)(xe,"resolvers"),yt.openTunnel(xe,he).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,Xe.checkProposedApiEnabled)(xe,"resolvers"),yt.getTunnels()},onDidChangeTunnels:(he,Se,Be)=>((0,Xe.checkProposedApiEnabled)(xe,"resolvers"),yt.onDidChangeTunnels(he,Se,Be)),registerPortAttributesProvider:(he,Se)=>((0,Xe.checkProposedApiEnabled)(xe,"portsAttributes"),yt.registerPortsAttributesProvider(he,Se)),registerTimelineProvider:(he,Se)=>((0,Xe.checkProposedApiEnabled)(xe,"timeline"),wi.registerTimelineProvider(he,Se,xe.identifier,Oe.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:he=>((0,Xe.checkProposedApiEnabled)(xe,"workspaceTrust"),ft.requestWorkspaceTrust(he)),onDidGrantWorkspaceTrust:(he,Se,Be)=>ft.onDidGrantWorkspaceTrust(he,Se,Be)},ki={get inputBox(){return kt.report("scm.inputBox",xe,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(xe)},createSourceControl(he,Se,Be){return di.createSourceControl(xe,he,Se,Be)}},Pi={createCommentController(he,Se){return vi.createCommentController(xe,he,Se)}},Ti={get activeDebugSession(){return it.activeDebugSession},get activeDebugConsole(){return it.activeDebugConsole},get breakpoints(){return it.breakpoints},onDidStartDebugSession(he,Se,Be){return it.onDidStartDebugSession(he,Se,Be)},onDidTerminateDebugSession(he,Se,Be){return it.onDidTerminateDebugSession(he,Se,Be)},onDidChangeActiveDebugSession(he,Se,Be){return it.onDidChangeActiveDebugSession(he,Se,Be)},onDidReceiveDebugSessionCustomEvent(he,Se,Be){return it.onDidReceiveDebugSessionCustomEvent(he,Se,Be)},onDidChangeBreakpoints(he,Se,Be){return it.onDidChangeBreakpoints(he,Se,Be)},registerDebugConfigurationProvider(he,Se,Be){return it.registerDebugConfigurationProvider(he,Se,Be||st.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(he,Se){return it.registerDebugAdapterDescriptorFactory(xe,he,Se)},registerDebugAdapterTrackerFactory(he,Se){return it.registerDebugAdapterTrackerFactory(he,Se)},startDebugging(he,Se,Be){return!Be||typeof Be=="object"&&"configuration"in Be?it.startDebugging(he,Se,{parentSession:Be}):it.startDebugging(he,Se,Be||{})},stopDebugging(he){return it.stopDebugging(he)},addBreakpoints(he){return it.addBreakpoints(he)},removeBreakpoints(he){return it.removeBreakpoints(he)},asDebugSourceUri(he,Se){return it.asDebugSourceUri(he,Se)}},Ai={registerTaskProvider:(he,Se)=>ut.registerTaskProvider(xe,he,Se),fetchTasks:he=>ut.fetchTasks(he),executeTask:he=>ut.executeTask(xe,he),get taskExecutions(){return ut.taskExecutions},onDidStartTask:(he,Se,Be)=>ut.onDidStartTask(he,Se,Be),onDidEndTask:(he,Se,Be)=>ut.onDidEndTask(he,Se,Be),onDidStartTaskProcess:(he,Se,Be)=>ut.onDidStartTaskProcess(he,Se,Be),onDidEndTaskProcess:(he,Se,Be)=>ut.onDidEndTaskProcess(he,Se,Be)},Ni={createNotebookController(he,Se,Be,at,bt){return ai.createNotebookController(xe,he,Se,Be,at,(0,Xe.isProposedApiEnabled)(xe,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(he,Se)=>vt.registerNotebookCellStatusBarItemProvider(xe,he,Se),createNotebookEditorDecorationType(he){return(0,Xe.checkProposedApiEnabled)(xe,"notebookEditorDecorationType"),Yt.createNotebookEditorDecorationType(he)},createRendererMessaging(he){return ci.createRendererMessaging(xe,he)},onDidChangeNotebookCellExecutionState(he,Se,Be){return(0,Xe.checkProposedApiEnabled)(xe,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(he,Se,Be)}};return{version:ot.version,authentication:Ci,commands:Oi,comments:Pi,debug:Ti,env:si,extensions:jt,languages:Fi,notebooks:Ni,scm:ki,tasks:Ai,tests:Di,window:Ii,workspace:ti,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:i.CancellationError,CancellationTokenSource:u.CancellationTokenSource,CandidatePortSource:S.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CommentThreadState:N.CommentThreadState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:st.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:N.InlineCompletionTriggerKindNew,EventEmitter:y.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionItemNew:N.InlineSuggestionNew,InlineCompletionList:N.InlineSuggestionList,InlineCompletionListNew:N.InlineSuggestionsNew,Hover:N.Hover,IndentAction:T.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SnippetTextEdit:N.SnippetTextEdit,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:I.UIKind,Uri:C.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintLabelPart:N.InlayHintLabelPart,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,NotebookEdit:N.NotebookEdit,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:Ce.TextSearchCompleteMessageType,DataTransfer:N.DataTransfer,DataTransferItem:N.DataTransferItem,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity,QuickPickItemKind:N.QuickPickItemKind,InputBoxValidationSeverity:N.InputBoxValidationSeverity,TabInputText:N.TextTabInput,TabInputTextDiff:N.TextDiffTabInput,TabInputCustom:N.CustomEditorTabInput,TabInputNotebook:N.NotebookEditorTabInput,TabInputNotebookDiff:N.NotebookDiffEditorTabInput,TabInputWebview:N.WebviewEditorTabInput,TabInputTerminal:N.TerminalEditorTabInput}}}e.createApiFactoryAndRegisterActors=et}),define(ke[289],Pe([1,0,290,300,301,2,302]),function(Q,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function D(P,S,I,E,v,w){const g=w.environment.useHostProxy,_=typeof g=="boolean"?g:!w.remote.isRemote,f=(0,C.createProxyResolver)({resolveProxy:m=>P.resolveProxy(m),getHttpProxySetting:()=>S.getConfiguration("http").get("proxy"),log:(m,o,...d)=>{switch(m){case C.LogLevel.Trace:E.trace(o,...d);break;case C.LogLevel.Debug:E.debug(o,...d);break;case C.LogLevel.Info:E.info(o,...d);break;case C.LogLevel.Warning:E.warn(o,...d);break;case C.LogLevel.Error:E.error(o,...d);break;case C.LogLevel.Critical:E.critical(o,...d);break;case C.LogLevel.Off:break;default:r(m,o,d);break}function r(s,n,...t){E.error("Unknown log level",s),E.error(n,...t)}},getLogLevel:()=>E.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:_,env:process.env}),a=b(S,f);return L(I,a)}e.connectProxyResolver=D;function b(P,S){const I={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(v=>{I.config=P.getConfiguration("http").get("proxySupport")||"off"});const E={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(v=>{E.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},u,(0,C.createHttpPatch)(u,S,{config:"off"},E,!0)),on:Object.assign({},u,(0,C.createHttpPatch)(u,S,{config:"on"},E,!0)),override:Object.assign({},u,(0,C.createHttpPatch)(u,S,{config:"override"},E,!0)),onRequest:Object.assign({},u,(0,C.createHttpPatch)(u,S,I,E,!0)),default:Object.assign(u,(0,C.createHttpPatch)(u,S,I,E,!1))},https:{off:Object.assign({},i,(0,C.createHttpPatch)(i,S,{config:"off"},E,!0)),on:Object.assign({},i,(0,C.createHttpPatch)(i,S,{config:"on"},E,!0)),override:Object.assign({},i,(0,C.createHttpPatch)(i,S,{config:"override"},E,!0)),onRequest:Object.assign({},i,(0,C.createHttpPatch)(i,S,I,E,!0)),default:Object.assign(i,(0,C.createHttpPatch)(i,S,I,E,!1))},tls:Object.assign(y,(0,C.createTlsPatch)(y))}}const T=new Map;function L(P,S){return P.getExtensionPathIndex().then(I=>{const E=Q.__$__nodeRequire("module"),v=E._load;E._load=function(g,_,f){if(g==="tls")return S.tls;if(g!=="http"&&g!=="https")return v.apply(this,arguments);const a=S[g],m=I.findSubstr(A.URI.file(_.filename));let o=T.get(m);if(o||T.set(m,o={}),!o[g]){let d=a.default;o[g]={...d}}return o[g]}})}}),define(ke[141],Pe([1,0,42,303,105,16,48,34,9,8,2,31,73,304,283,93]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const w=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(h){this.outputChannel=h}provideTextSearchResults(h,p,R,F){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...p,folder:p.folder.toString()})}`),new Promise((O,k)=>{F.onCancellationRequested(()=>H());const U=d(h,p),B=p.folder.fsPath,z=U.map(le=>le.match(/^-/)?le:`'${le}'`).join(" ");this.outputChannel.appendLine(`${w} ${z}
 - cwd: ${B}`);let Y=u.spawn(w,U,{cwd:B});Y.on("error",le=>{console.error(le),this.outputChannel.appendLine("Error: "+(le&&le.message)),k((0,P.serializeSearchError)(new P.SearchError(le&&le.message,P.SearchErrorCode.rgProcessError)))});let $=!1;const N=new a(p.maxResults,B,p.previewOptions);N.on("result",le=>{$=!0,te="",R.report(le)});let V=!1;const H=()=>{V=!0,Y&&Y.kill(),N&&N.cancel()};let q=!1;N.on("hitLimit",()=>{q=!0,H()});let te="";Y.stdout.on("data",le=>{N.handleData(le),$||(te+=le)});let fe=!1;Y.stdout.once("data",()=>fe=!0);let ne="";Y.stderr.on("data",le=>{const K=le.toString();this.outputChannel.appendLine(K),ne+=K}),Y.on("close",()=>{if(this.outputChannel.appendLine(fe?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine($?"Got result from parser":"No result from parser"),te&&this.outputChannel.appendLine(`Got data without result: ${te}`),this.outputChannel.appendLine(""),V)O({limitHit:q});else{N.flush(),Y=null;let le;ne&&!fe&&(le=_(ne))?k((0,P.serializeSearchError)(new P.SearchError(le.message,le.code))):O({limitHit:q})}})})}}e.RipgrepTextSearchEngine=g;function _(l){const h=l.split(`
`),p=h[0].trim();if(h.some(F=>F.startsWith("regex parse error")))return new P.SearchError(f(h),P.SearchErrorCode.regexParseError);const R=p.match(/grep config error: unknown encoding: (.*)/);if(R)return new P.SearchError(`Unknown encoding: ${R[1]}`,P.SearchErrorCode.unknownEncoding);if(p.startsWith("error parsing glob"))return new P.SearchError(p.charAt(0).toUpperCase()+p.substr(1),P.SearchErrorCode.globParseError);if(p.startsWith("the literal"))return new P.SearchError(p.charAt(0).toUpperCase()+p.substr(1),P.SearchErrorCode.invalidLiteral);if(p.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(p,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function f(l){const h=["Regex parse error"],p=l.filter(R=>R.startsWith("PCRE2:"));if(p.length>=1){const R=p[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const F=R.split(":")[1];h.push(":"+F)}}return h.join("")}e.buildRegexParseError=f;class a extends i.EventEmitter{constructor(h,p,R){super();this.maxResults=h,this.rootFolder=p,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new y.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,p){return super.on(h,p),this}handleData(h){if(this.isDone)return;const p=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(p)}handleDecodedData(h){let p=h.indexOf(`
`);const R=this.remainder+h;if(p>=0)p+=this.remainder.length;else{this.remainder=R;return}let F=0;for(;p>=0;)this.handleLine(R.substring(F,p).trim()),F=p+1,p=R.indexOf(`
`,F);this.remainder=R.substring(F)}handleLine(h){if(this.isDone||!h)return;let p;try{p=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(p.type==="match"){const R=m(p.data.path),F=L.URI.file(b.join(this.rootFolder,R)),O=this.createTextSearchMatch(p.data,F);this.onResult(O),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(p.type==="context"){const R=m(p.data.path),F=L.URI.file(b.join(this.rootFolder,R));this.createTextSearchContext(p.data,F).forEach(k=>this.onResult(k))}}createTextSearchMatch(h,p){const R=h.line_number-1,F=m(h.lines),O=Buffer.from(F);let k=0,U=0,B=R;h.submatches.length===0&&h.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const z=(0,A.coalesce)(h.submatches.map((Y,$)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const N=m(Y.match),V=O.slice(k,Y.start).toString().length,H=U+V,q=o(N),te=B,fe=q.numLines+te,ne=q.numLines>0?q.lastLineLength:q.lastLineLength+H;return k=Y.end,U=ne,B=fe,new S.Range(te,H,fe,ne)}));return(0,v.createTextSearchResult)(p,F,z,this.previewOptions)}createTextSearchContext(h,p){const R=m(h.lines),F=h.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((O,k)=>({text:O,uri:p,lineNumber:F+k}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=a;function m(l){return l.bytes?Buffer.from(l.bytes,"base64").toString():l.text}function o(l){const h=/\n/g;let p=0,R=-1,F;for(;F=h.exec(l);)p++,R=F.index;const O=R>=0?l.length-R-1:l.length;return{numLines:p,lastLineLength:O}}function d(l,h){const p=["--hidden"];p.push(l.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:F}=(0,C.groupBy)(h.includes,k=>k.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const k=new Set;F.forEach(U=>{k.add(U)}),p.push("-g","!*"),k.forEach(U=>{r(U).map(v.anchorGlob).forEach(B=>{p.push("-g",B)})})}R&&R.length&&R.forEach(k=>{p.push("-g",k)}),h.excludes.map(v.anchorGlob).forEach(k=>p.push("-g",`!${k}`)),h.maxFileSize&&p.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||p.push("--no-ignore-parent"):p.push("--no-ignore"),h.followSymlinks&&p.push("--follow"),h.encoding&&h.encoding!=="utf8"&&p.push("--encoding",h.encoding),l.pattern==="--"&&(l.isRegExp=!0,l.pattern="\\-\\-"),l.isMultiline&&!l.isRegExp&&(l.pattern=(0,T.escapeRegExpCharacters)(l.pattern),l.isRegExp=!0),h.usePCRE2&&p.push("--pcre2"),p.push("--crlf"),l.isRegExp&&(l.pattern=s(l.pattern),p.push("--engine","auto"));let O;if(l.isWordMatch){const U=(0,T.createRegExp)(l.pattern,!!l.isRegExp,{wholeWord:l.isWordMatch}).source.replace(/\\\//g,"/");p.push("--regexp",U)}else if(l.isRegExp){let k=t(l.pattern);k=c(k),p.push("--regexp",k)}else O=l.pattern,p.push("--fixed-strings");return p.push("--no-config"),h.useGlobalIgnoreFiles||p.push("--no-ignore-global"),p.push("--json"),l.isMultiline&&p.push("--multiline"),h.beforeContext&&p.push("--before-context",h.beforeContext+""),h.afterContext&&p.push("--after-context",h.afterContext+""),p.push("--"),O&&p.push(O),p.push("."),p}function r(l){const h=(0,D.splitGlobAware)(l,"/");return h.map((p,R)=>h.slice(0,R+1).join("/"))}e.spreadGlobComponents=r;function s(l){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;l.match(h);)l=l.replace(h,"$1\\x{$2}");const p=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;l.match(p);)l=l.replace(p,"$1\\x{$2}");return l}e.unicodeEscapesToPCRE2=s;const n=l=>l.type==="Assertion"&&l.kind==="lookbehind";function t(l){let h;try{h=new I.RegExpParser().parsePattern(l)}catch{return l}let p="",R=0;const F=(U,B,z)=>{p+=l.slice(R,U)+z,R=B},O=[];return new I.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const B=O[0];if(!B)F(U.start,U.end,"\\r?\\n");else if(!O.some(n))if(B.type==="CharacterClass")if(B.negate){const z=l.slice(B.start+2,U.start)+l.slice(U.end,B.end-1);B.parent?.type==="Quantifier"?F(B.start,B.end,z?`[^${z}]`:"."):F(B.start,B.end,"(?!\\r?\\n"+(z?`|[${z}]`:"")+")")}else{const z=l.slice(B.start+1,U.start)+l.slice(U.end,B.end-1);F(B.start,B.end,z===""?"\\r?\\n":`(?:[${z}]|\\r?\\n)`)}else B.type==="Quantifier"&&F(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){O.unshift(U)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(U){O.unshift(U)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(U){O.unshift(U)},onCharacterClassLeave(){O.shift()},onAssertionEnter(U){n(U)&&O.push(U)},onAssertionLeave(U){O[0]===U&&O.shift()}}).visit(h),p+=l.slice(R),p}e.fixRegexNewline=t;function c(l){return l.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(ke[291],Pe([1,0,21,141,118,10]),function(Q,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(T){this.outputChannel=T,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(T,L,P,S){const I=new i.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===A.Schemas.vscodeUserData){const E={...L,folder:L.folder.with({scheme:A.Schemas.file})},v=new y.Progress(w=>P.report({...w,uri:w.uri.with({scheme:L.folder.scheme})}));return this.withToken(S,w=>I.provideTextSearchResults(T,E,v,w))}else return this.withToken(S,E=>I.provideTextSearchResults(T,L,P,E))}async withToken(T,L){const P=D(T);this.inProgress.add(P);const S=await L(P.token);return this.inProgress.delete(P),S}dispose(){this.inProgress.forEach(T=>T.cancel())}}e.RipgrepSearchProvider=C;function D(b){const T=new u.CancellationTokenSource;return b.onCancellationRequested(()=>T.cancel()),T}}),define(ke[292],Pe([1,0,29,141,140]),function(Q,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(b){this.query=b}search(b,T,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(I){L({message:I})}},S=new y.NativeTextSearchManager(this.query,new i.RipgrepTextSearchEngine(P),u);return new Promise((I,E)=>S.search(v=>{T(v.map(C))},b).then(v=>I({limitHit:v.limitHit,type:"success",stats:v.stats}),E))}}e.TextSearchEngineAdapter=A;function C(D){return{path:D.resource&&D.resource.fsPath,results:D.results,numMatches:(D.results||[]).reduce((b,T)=>{if(T.ranges){const L=T;return b+(Array.isArray(L.ranges)?L.ranges.length:1)}else return b+1},0)}}}),define(ke[293],Pe([1,0,16,17,11,3,101,9,49,2,43,31,284,292]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class E{constructor(a="searchProcess"){this.processType=a,this.caches=Object.create(null)}fileSearch(a){let m;const o=g(a),d=new A.Emitter({onFirstListenerDidAdd:()=>{m=(0,i.createCancelablePromise)(r=>this.doFileSearchWithEngine(S.Engine,o,s=>d.fire(s),r)),m.then(r=>d.fire(r),r=>d.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return d.event}textSearch(a){let m;const o=g(a),d=new A.Emitter({onFirstListenerDidAdd:()=>{m=(0,i.createCancelablePromise)(r=>this.ripgrepTextSearch(o,s=>d.fire(s),r)),m.then(r=>d.fire(r),r=>d.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return d.event}ripgrepTextSearch(a,m,o){return a.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new I.TextSearchEngineAdapter(a).search(o,m,m)}doFileSearch(a,m,o){return this.doFileSearchWithEngine(S.Engine,a,m,o)}doFileSearchWithEngine(a,m,o,d,r=E.BATCH_SIZE){let s=0;const n=c=>{Array.isArray(c)?(s+=c.length,o(c.map(l=>this.rawMatchToSearchItem(l)))):c.relativePath?(s++,o(this.rawMatchToSearchItem(c))):o(c)};if(m.sortByScore){let c=this.trySortedSearchFromCache(m,n,d);if(!c){const l=m.maxResults?Object.assign({},m,{maxResults:null}):m,h=new a(l);c=this.doSortedSearch(h,m,o,n,d)}return new Promise((l,h)=>{c.then(([p,R])=>{const F=R.map(O=>this.rawMatchToSearchItem(O));this.sendProgress(F,o,r),l(p)},h)})}const t=new a(m);return this.doSearch(t,n,r,d).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.processType,fromCache:!1,resultCount:s,sortingTime:void 0}}))}rawMatchToSearchItem(a){return{path:a.base?(0,D.join)(a.base,a.relativePath):a.relativePath}}doSortedSearch(a,m,o,d,r){const s=new A.Emitter;let n=(0,i.createCancelablePromise)(c=>{let l=[];const h=p=>{Array.isArray(p)?l=p:(d(p),s.fire(p))};return this.doSearch(a,h,-1,c).then(p=>[p,l])}),t;if(m.cacheKey){t=this.getOrCreateCache(m.cacheKey);const c={promise:n,event:s.event,resolved:!1};t.resultsToSearchCache[m.filePattern||""]=c,n.then(()=>{c.resolved=!0},l=>{delete t.resultsToSearchCache[m.filePattern||""]}),n=this.preventCancellation(n)}return n.then(([c,l])=>{const h=t?t.scorerCache:Object.create(null),p=(typeof m.maxResults!="number"||m.maxResults>0)&&b.StopWatch.create(!1);return this.sortResults(m,l,h,r).then(R=>{const F=p?p.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:F,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:R.length},messages:c.messages,limitHit:c.limitHit||typeof m.maxResults=="number"&&l.length>m.maxResults},R]})})}getOrCreateCache(a){const m=this.caches[a];return m||(this.caches[a]=new v)}trySortedSearchFromCache(a,m,o){const d=a.cacheKey&&this.caches[a.cacheKey];if(!d)return;const r=this.getResultsFromCache(d,a.filePattern||"",m,o);if(r)return r.then(([s,n,t])=>{const c=b.StopWatch.create(!1);return this.sortResults(a,n,d.scorerCache,o).then(l=>{const h=c.elapsed(),p={fromCache:!0,detailStats:t,type:this.processType,resultCount:n.length,sortingTime:h};return[{type:"success",limitHit:s.limitHit||typeof a.maxResults=="number"&&n.length>a.maxResults,stats:p},l]})})}sortResults(a,m,o,d){const r=(0,C.prepareQuery)(a.filePattern||""),s=(t,c)=>(0,C.compareItemsByFuzzyScore)(t,c,r,!0,w,o),n=typeof a.maxResults=="number"?a.maxResults:Number.MAX_VALUE;return u.topAsync(m,s,n,1e4,d)}sendProgress(a,m,o){if(o&&o>0)for(let d=0;d<a.length;d+=o)m(a.slice(d,d+o));else m(a)}getResultsFromCache(a,m,o,d){const r=b.StopWatch.create(!1),s=m.indexOf(D.sep)>=0;let n;for(const h in a.resultsToSearchCache)if(m.startsWith(h)){if(s&&h.indexOf(D.sep)<0&&h!=="")continue;const p=a.resultsToSearchCache[h];n={promise:this.preventCancellation(p.promise),event:p.event,resolved:p.resolved};break}if(!n)return null;const t=r.elapsed(),c=b.StopWatch.create(!1),l=n.event(o);return d&&d.onCancellationRequested(()=>{l.dispose()}),n.promise.then(([h,p])=>{if(d&&d.isCancellationRequested)throw(0,y.canceled)();const R=[],F=(0,C.prepareQuery)(m).normalizedLowercase;for(const O of p)!(0,P.isFilePatternMatch)(O,F)||R.push(O);return[h,R,{cacheWasResolved:n.resolved,cacheLookupTime:t,cacheFilterTime:c.elapsed(),cacheEntryCount:p.length}]})}doSearch(a,m,o,d){return new Promise((r,s)=>{let n=[];d&&d.onCancellationRequested(()=>a.cancel()),a.search(t=>{t&&(o?(n.push(t),o>0&&n.length>=o&&(m(n),n=[])):m(t))},t=>{m(t)},(t,c)=>{n.length&&m(n),t?s(t):r(c)})})}clearCache(a){return delete this.caches[a],Promise.resolve(void 0)}preventCancellation(a){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,o){return a.then(m,o)}catch(m){return this.then(void 0,m)}finally(m){return a.finally(m)}}}}e.SearchService=E,E.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const w=new class{getItemLabel(f){return(0,D.basename)(f.relativePath)}getItemDescription(f){return(0,D.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function g(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(_),extraFileResources:f.extraFileResources&&f.extraFileResources.map(a=>T.URI.revive(a))}}function _(f){return{...f,folder:T.URI.revive(f.folder)}}}),define(ke[294],Pe([1,0,6,10,2,29,14,27,18,77,66,31,293,291,93,140]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let w=class extends T.ExtHostSearch{constructor(_,f,a,m){super(_,a,m);this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const o=new E.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(i.Schemas.vscodeUserData,new I.RipgrepSearchProvider(o)),f.remote.isRemote&&f.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const _=new E.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(i.Schemas.file,new I.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(i.Schemas.file,new S.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(_,f){const a=this._handlePool++;return this._internalFileSearchProvider=f,this._internalFileSearchHandle=a,this._proxy.$registerFileSearchProvider(a,this._transformScheme(_)),(0,u.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(_,f,a,m){const o=(0,T.reviveQuery)(a);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,f,o,m):super.$provideFileSearchResults(_,f,a,m)}doInternalFileSearch(_,f,a,m){const o=d=>{if((0,P.isSerializedFileMatch)(d)&&(d=[d]),Array.isArray(d)){this._proxy.$handleFileMatch(_,f,d.map(r=>y.URI.file(r.path)));return}d.message&&this._logService.debug("ExtHostSearch",d.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(a,o,m)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,f){return new v.NativeTextSearchManager(_,f,void 0,"textSearchProvider")}};e.NativeExtHostSearch=w,e.NativeExtHostSearch=w=je([He(0,b.IExtHostRpcService),He(1,D.IExtHostInitDataService),He(2,L.IURITransformerService),He(3,C.ILogService)],w)}),define(ke[142],Pe([1,0,305,127,64,23,11,3,6,9,13,35,107,108,306]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{traceSocketEvent(p,R){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,R)}constructor(p,R=""){this.debugLabel=R,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=F=>{if(this.traceSocketEvent("error",{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,C.onUnexpectedError)(F)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(p){const R=F=>{this.traceSocketEvent("read",F),p(A.VSBuffer.wrap(F))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(p){const R=F=>{this.traceSocketEvent("close",{hadError:F}),p({type:0,hadError:F,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(p){const R=()=>{this.traceSocketEvent("nodeEndReceived"),p()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(p){if(!this.socket.destroyed)try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,C.onUnexpectedError)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,C.onUnexpectedError)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=v;var w;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var g;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(g||(g={}));class _ extends b.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(p,R){this.socket.traceSocketEvent(p,R)}constructor(p,R,F,O){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:F?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new f(this,R,F,O,this._onData,(k,U)=>this._write(k,U))),this._register(this._flowManager.onError(k=>{console.error(k),(0,C.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(k=>this._acceptChunk(k))),this._register(this.socket.onClose(k=>this._onClose.fire(k)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this._onData.event(p)}onClose(p){return this._onClose.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){this._flowManager.writeMessage(p)}_write(p,R){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let F=2;p.byteLength<126?F+=0:p.byteLength<2**16?F+=2:F+=8;const O=A.VSBuffer.alloc(F);if(R?O.writeUInt8(194,0):O.writeUInt8(130,0),p.byteLength<126)O.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){O.writeUInt8(126,1);let k=1;O.writeUInt8(p.byteLength>>>8&255,++k),O.writeUInt8(p.byteLength>>>0&255,++k)}else{O.writeUInt8(127,1);let k=1;O.writeUInt8(0,++k),O.writeUInt8(0,++k),O.writeUInt8(0,++k),O.writeUInt8(0,++k),O.writeUInt8(p.byteLength>>>24&255,++k),O.writeUInt8(p.byteLength>>>16&255,++k),O.writeUInt8(p.byteLength>>>8&255,++k),O.writeUInt8(p.byteLength>>>0&255,++k)}this.socket.write(A.VSBuffer.concat([O,p]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(p){if(p.byteLength!==0){for(this._incomingData.acceptChunk(p);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const R=this._incomingData.peek(this._state.readLen),F=R.readUInt8(0),O=(F&128)>>>7,k=(F&64)>>>6,U=R.readUInt8(1),B=(U&128)>>>7,z=U&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(z===126?2:0)+(z===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(k)),this._state.firstFrameOfMessage=Boolean(O),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const R=this._incomingData.read(this._state.readLen),F=R.readUInt8(1),O=(F&128)>>>7;let k=F&127,U=1;k===126?k=R.readUInt8(++U)*2**8+R.readUInt8(++U):k===127&&(k=R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U));let B=0;O&&(B=R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U)),this._state.state=3,this._state.readLen=k,this._state.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const R=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),o(R,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(R,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=_;class f extends b.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}constructor(p,R,F,O,k,U){super();this._tracer=p,this._onData=k,this._writeFn=U,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,R?(this._zlibInflateStream=this._register(new a(this._tracer,O,F,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(B=>this._onError.fire(B))),this._register(this._zlibDeflateStream.onError(B=>this._onError.fire(B)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(p){this._writeQueue.push(p),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const p=this._writeQueue.shift();if(this._zlibDeflateStream){const R=await this._deflateMessage(this._zlibDeflateStream,p);this._writeFn(R,!0)}else this._writeFn(p,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(p,R){return new Promise((F,O)=>{p.write(R),p.flush(k=>F(k))})}acceptFrame(p,R,F){this._readQueue.push({data:p,isCompressed:R,isLastFrameOfMessage:F}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const p=this._readQueue.shift();if(this._zlibInflateStream&&p.isCompressed){const R=await this._inflateFrame(this._zlibInflateStream,p.data,p.isLastFrameOfMessage);this._onData.fire(R)}else this._onData.fire(p.data)}this._isProcessingReadQueue=!1}}_inflateFrame(p,R,F){return new Promise((O,k)=>{p.write(R),F&&p.write(A.VSBuffer.fromByteArray([0,0,255,255])),p.flush(U=>O(U))})}}class a extends b.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}constructor(p,R,F,O){super();this._tracer=p,this._recordInflateBytes=R,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=E.createInflateRaw(O),this._zlibInflate.on("error",k=>{this._tracer.traceSocketEvent("zlibInflateError",{message:k?.message,code:k?.code}),this._onError.fire(k)}),this._zlibInflate.on("data",k=>{this._tracer.traceSocketEvent("zlibInflateData",k),this._pendingInflateData.push(A.VSBuffer.wrap(k))}),F&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",F.buffer),this._zlibInflate.write(F.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(p){this._recordInflateBytes&&this._recordedInflateBytes.push(p.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",p),this._zlibInflate.write(p.buffer)}flush(p){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const R=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,p(R)})}}class m extends b.Disposable{constructor(p,R){super();this._tracer=p,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=E.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",F=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibDeflate.on("data",F=>{this._tracer.traceSocketEvent("zlibDeflateData",F),this._pendingDeflateData.push(A.VSBuffer.wrap(F))})}write(p){this._tracer.traceSocketEvent("zlibDeflateWrite",p.buffer),this._zlibDeflate.write(p.buffer)}flush(p){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let R=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,R=R.slice(0,R.byteLength-4),p(R)})}}function o(h,p){if(p===0)return;let R=h.byteLength>>>2;for(let z=0;z<R;z++){const Y=h.readUInt32BE(z*4);h.writeUInt32BE(Y^p,z*4)}let F=R*4,O=h.byteLength-F;const k=p>>>24&255,U=p>>>16&255,B=p>>>8&255;O>=1&&h.writeUInt8(h.readUInt8(F)^k,F),O>=2&&h.writeUInt8(h.readUInt8(F+1)^U,F+1),O>=3&&h.writeUInt8(h.readUInt8(F+2)^B,F+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const d={[2]:107,[1]:103};function r(){const h=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let p;return e.XDG_RUNTIME_DIR?p=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):p=(0,T.join)((0,y.tmpdir)(),`vscode-ipc-${h}.sock`),n(p),p}e.createRandomIPCHandle=r;function s(h,p,R){const F=(0,u.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${R}-${p}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${F.substr(0,8)}-${R}-${p}.sock`):O=(0,T.join)(h,`${R}-${p}.sock`),n(O),O}e.createStaticIPCHandle=s;function n(h){const p=d[L.platform];typeof p=="number"&&h.length>=p&&console.warn(`WARNING: IPC handle "${h}" is longer than ${p} chars, try a shorter --user-data-dir`)}class t extends S.IPCServer{static toClientConnectionEvent(p){const R=D.Event.fromNodeEventEmitter(p,"connection");return D.Event.map(R,F=>({protocol:new I.Protocol(new v(F,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(F,"close"))}))}constructor(p){super(t.toClientConnectionEvent(p));this.server=p}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function c(h){return new Promise((p,R)=>{const F=(0,i.createServer)();F.on("error",R),F.listen(h,()=>{F.removeListener("error",R),p(new t(F))})})}e.serve=c;function l(h,p){return new Promise((R,F)=>{const O=(0,i.createConnection)(h,()=>{O.removeListener("error",F),R(I.Client.fromSocket(new v(O,`ipc-client${p}`),p))});O.once("error",F)})}e.connect=l}),define(ke[295],Pe([1,0,142,290,63,37,2,14,45]),function(Q,e,u,i,y,A,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class T{constructor(S,I,E){this._commands=S,this.logService=I,this._ipcHandlePath=E,this._server=i.createServer((v,w)=>this.onRequest(v,w)),this.setup().catch(v=>(I.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",S=>this.logService.error(S))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(S,I){const E=(w,g)=>{I.writeHead(w,{"content-type":"application/json"}),I.end(JSON.stringify(g||null),_=>_&&this.logService.error(_))},v=[];S.setEncoding("utf8"),S.on("data",w=>v.push(w)),S.on("end",async()=>{try{const w=JSON.parse(v.join(""));let g;switch(w.type){case"open":g=await this.open(w);break;case"openExternal":g=await this.openExternal(w);break;case"status":g=await this.getStatus(w);break;case"extensionManagement":g=await this.manageExtensions(w);break;default:E(404,`Unknown message type: ${w.type}`);break}E(200,g)}catch(w){const g=w instanceof Error?w.message:JSON.stringify(w);E(500,g),this.logService.error("Error while processing pipe request",w)}})}async open(S){const{fileURIs:I,folderURIs:E,forceNewWindow:v,diffMode:w,addMode:g,forceReuseWindow:_,gotoLineMode:f,waitMarkerFilePath:a,remoteAuthority:m}=S,o=[];if(Array.isArray(E))for(const n of E)try{o.push({folderUri:C.URI.parse(n)})}catch{}if(Array.isArray(I))for(const n of I)try{(0,b.hasWorkspaceFileExtension)(n)?o.push({workspaceUri:C.URI.parse(n)}):o.push({fileUri:C.URI.parse(n)})}catch{}const d=a?C.URI.file(a):void 0,s={forceNewWindow:v,diffMode:w,addMode:g,gotoLineMode:f,forceReuseWindow:_,preferNewWindow:!_&&!d&&!g,waitMarkerFileURI:d,remoteAuthority:m};return this._commands.executeCommand("_remoteCLI.windowOpen",o,s),""}async openExternal(S){for(const I of S.uris){const E=C.URI.parse(I),v=E.scheme==="file"?E:I;await this._commands.executeCommand("_remoteCLI.openExternal",v)}}async manageExtensions(S){const I=v=>v?.map(w=>/\.vsix$/i.test(w)?C.URI.parse(w):w),E={list:S.list,install:I(S.install),uninstall:I(S.uninstall),force:S.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",E)}async getStatus(S){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&y.existsSync(this._ipcHandlePath)&&y.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=T;let L=class extends T{constructor(S,I){super(S,I,(0,u.createRandomIPCHandle)())}};e.CLIServer=L,e.CLIServer=L=je([He(0,A.IExtHostCommands),He(1,D.ILogService)],L)}),define(ke[296],Pe([1,0,75,288,276,5,289,39,264,2,10,7,295,106]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class E extends y.RequireInterceptor{_installInterceptor(){const g=this,_=Q.__$__nodeRequire("module"),f=_._load;_._load=function(d,r,s){return d=m(d),g._factories.has(d)?g._factories.get(d).load(d,T.URI.file((0,I.realpathSync)(r.filename)),n=>f.apply(this,[n,r,s])):f.apply(this,arguments)};const a=_._resolveLookupPaths;_._resolveLookupPaths=(o,d)=>a.call(this,m(o),d);const m=o=>{for(let d of g._alternatives){let r=d(o);if(r){o=r;break}}return o}}}class v extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const g=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(b.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const o=this._instaService.createInstance(S.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}await this._instaService.createInstance(E,g,{mine:this._myRegistry,all:this._globalRegistry}).install(),u.mark("code/extHost/didInitAPI");const f=await this._extHostConfiguration.getConfigProvider();await(0,C.connectProxyResolver)(this._extHostWorkspace,f,this,this._logService,this._mainThreadTelemetryProxy,this._initData),u.mark("code/extHost/didInitProxyResolver");const a=process.send,m=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...o)=>o.length===0||!o[0]||o[0].type!=="__$console"?a.apply(process,o):(m.$logExtensionHostMessage(o[0]),!1)}_getEntryPoint(g){return g.main}_loadCommonJSModule(g,_,f){if(_.scheme!==L.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let a=null;f.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{g&&u.mark(`code/extHost/willLoadExtensionCode/${g.value}`),a=Q.__$__nodeRequire(_.fsPath)}catch(m){return Promise.reject(m)}finally{g&&u.mark(`code/extHost/didLoadExtensionCode/${g.value}`),f.codeLoadingStop()}return Promise.resolve(a)}async $setRemoteEnvironment(g){if(!!this._initData.remote.isRemote)for(const _ in g){const f=g[_];f===null?delete process.env[_]:process.env[_]=f}}}e.ExtHostExtensionService=v}),define(ke[297],Pe([1,0,83,267,279,278,294,296,268,76,39,77,74,38,53,71,266,265,14,280,47]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g,_,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(L.IExtHostExtensionService,D.ExtHostExtensionService),(0,u.registerSingleton)(_.ILoggerService,g.ExtHostLoggerService),(0,u.registerSingleton)(v.IExtensionStoragePaths,w.ExtensionStoragePaths),(0,u.registerSingleton)(T.IExtHostDebugService,A.ExtHostDebugService),(0,u.registerSingleton)(P.IExtHostSearch,C.NativeExtHostSearch),(0,u.registerSingleton)(S.IExtHostTask,y.ExtHostTask),(0,u.registerSingleton)(I.IExtHostTerminalService,i.ExtHostTerminalService),(0,u.registerSingleton)(E.IExtHostTunnelService,b.ExtHostTunnelService),(0,u.registerSingleton)(a.IExtHostVariableResolverProvider,f.NodeExtHostVariableResolverProviderService)}),define(ke[307],Pe([1,0,127,308,309,75,11,108,142,197,134,277,23,29,106,17,114,210,281,297]),function(Q,e,u,i,y,A,C,D,b,T,L,P,S,I,E,v,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let t=0;t<process.execArgv.length;t++)process.execArgv[t]==="--inspect-port=0"&&(process.execArgv.splice(t,1),t--)}(),function(){y.setDefaultResultOrder("ipv4first")}();const _=i(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const n=Q.__$__nodeRequire("module"),t=n._load;n._load=function(c){if(c==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return t.apply(this,arguments)}})();const f=process.exit.bind(process);function a(n){process.exit=function(t){if(n)f(t);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const t=new Error("An extension called process.crash() and this was prevented.");console.warn(t.stack)}}let m=function(n){f()};function o(){if(process.env.VSCODE_WILL_SEND_MESSAGE_PORT)return new Promise((n,t)=>{const c=l=>{const h=l[0],p=new D.BufferedEmitter;h.on("message",R=>p.fire(S.VSBuffer.wrap(R.data))),h.on("close",()=>{m("renderer closed the MessagePort")}),h.start(),n({onMessage:p.event,send:R=>h.postMessage(R.buffer)})};if(global.vscodePorts){const l=global.vscodePorts;delete global.vscodePorts,c(l)}else global.vscodePortsCallback=c});if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,t)=>{let c=null,l=setTimeout(()=>{m("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const h=108e5,p=3e5,R=new v.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (1)"),h),F=new v.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (2)"),p);process.on("message",(k,U)=>{if(k&&k.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const B=S.VSBuffer.wrap(Buffer.from(k.initialDataChunk,"base64"));let z;if(k.skipWebSocketFrames)z=new b.NodeSocket(U,"extHost-socket");else{const Y=S.VSBuffer.wrap(Buffer.from(k.inflateBytes,"base64"));z=new b.WebSocketNodeSocket(new b.NodeSocket(U,"extHost-socket"),k.permessageDeflate,Y,!1)}c?(R.cancel(),F.cancel(),c.beginAcceptReconnection(z,B),c.endAcceptReconnection(),c.sendResume()):(clearTimeout(l),c=new D.PersistentProtocol(z,B),c.sendResume(),c.onDidDispose(()=>m("renderer disconnected")),n(c),c.onSocketClose(()=>{R.schedule()}))}if(k&&k.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;R.isScheduled()&&F.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(O)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((t,c)=>{const l=u.createConnection(n,()=>{l.removeListener("error",c);const h=new D.PersistentProtocol(new b.NodeSocket(l,"extHost-renderer"));h.sendResume(),t(h)});l.once("error",c),l.on("close",()=>{m("renderer closed the socket")})})}}async function d(){const n=await o();return new class{constructor(){this._onMessage=new D.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(t=>{(0,L.isMessageOfType)(t,2)?(this._terminating=!0,m("received terminate message from renderer")):this._onMessage.fire(t)})}send(t){this._terminating||n.send(t)}async drain(){if(n.drain)return n.drain()}}}function r(n){return new Promise(t=>{const c=n.onMessage(l=>{c.dispose();const h=JSON.parse(l.toString()),p=h.commit,R=T.default.commit;p&&R&&p!==R&&f(55);let F=0;setInterval(function(){try{process.kill(h.parentPid,0),F=0}catch(k){k&&k.code==="EPERM"?(F++,F>=3&&m(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${k.message} (code: ${k.code}) (errno: ${k.errno})`)):m(`parent process ${h.parentPid} does not exist anymore: ${k.message} (code: ${k.code}) (errno: ${k.errno})`)}},1e3);let O;try{O=Q.__$__nodeRequire("native-watchdog"),O.start(h.parentPid)}catch(k){(0,C.onUnexpectedError)(k)}n.send((0,L.createMessageOfType)(0)),t({protocol:n,initData:h})});n.send((0,L.createMessageOfType)(1))})}async function s(){const n=[];process.on("unhandledRejection",(F,O)=>{n.push(O),setTimeout(()=>{const k=n.indexOf(O);k>=0&&O.catch(U=>{n.splice(k,1),(0,C.isCancellationError)(U)||(console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),F&&(0,C.onUnexpectedError)(F))})},1e3)}),process.on("rejectionHandled",F=>{const O=n.indexOf(F);O>=0&&n.splice(O,1)}),process.on("uncaughtException",function(F){(0,C.onUnexpectedError)(F)}),A.mark("code/extHost/willConnectToRenderer");const t=await d();A.mark("code/extHost/didConnectToRenderer");const c=await r(t);A.mark("code/extHost/didWaitForInitData");const{initData:l}=c;a(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=_.useHostProxy!==void 0?_.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,w.boolean)(_.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(O){f(O)}exists(O){return I.Promises.exists(O)}realpath(O){return(0,E.realpath)(O)}};let p=null;l.remote.authority&&_.transformURIs&&(p=(0,g.createURITransformer)(l.remote.authority));const R=new P.ExtensionHostMain(c.protocol,l,h,p);m=F=>R.terminate(F)}e.startExtensionHostProcess=s,s().catch(n=>console.log(n))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/workbench/api/node/extensionHostProcess.js.map
