/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/platform","vs/base/common/buffer","vs/base/common/map","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/collections","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Te=function(ee){for(var e=[],s=0,C=ee.length;s<C;s++)e[s]=Ie[ee[s]];return e};define(Ie[42],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function s(C,g){if(!C)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=s}),define(Ie[43],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const s=Object.prototype.hasOwnProperty;function C(O){const S=[];for(let m in O)s.call(O,m)&&S.push(O[m]);return S}e.values=C;function g(O,S){for(let m in O)if(s.call(O,m)&&S({key:m,value:O[m]},function(){delete O[m]})===!1)return}e.forEach=g;function U(O,S){const m=Object.create(null);for(const _ of O){const f=S(_);let u=m[f];u||(u=m[f]=[]),u.push(_)}return m}e.groupBy=U;function I(O){const S=Object.create(null);return O&&O.forEach((m,_)=>{S[_]=m}),S}e.fromMap=I;function P(O,S){const m=[],_=[];for(let f of O)S.has(f)||m.push(f);for(let f of S)O.has(f)||_.push(f);return{removed:m,added:_}}e.diffSets=P;function w(O,S){const m=[],_=[];for(let[f,u]of O)S.has(f)||m.push(u);for(let[f,u]of S)O.has(f)||_.push(u);return{removed:m,added:_}}e.diffMaps=w;class A{constructor(){this.map=new Map}add(S,m){let _=this.map.get(S);_||(_=new Set,this.map.set(S,_)),_.add(m)}delete(S,m){const _=this.map.get(S);!_||(_.delete(m),_.size===0&&this.map.delete(S))}forEach(S,m){const _=this.map.get(S);!_||_.forEach(m)}}e.SetMap=A}),define(Ie[55],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function s(I){return(P,w,A)=>{let O=null,S=null;if(typeof A.value=="function"?(O="value",S=A.value):typeof A.get=="function"&&(O="get",S=A.get),!S)throw new Error("not supported");A[O]=I(S,w)}}e.createDecorator=s;function C(I,P,w){let A=null,O=null;if(typeof w.value=="function"?(A="value",O=w.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(A="get",O=w.get),!O)throw new Error("not supported");const S=`$memoize$${P}`;w[A]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,m)}),this[S]}}e.memoize=C;function g(I,P,w){return s((A,O)=>{const S=`$debounce$${O}`,m=`$debounce$result$${O}`;return function(..._){this[m]||(this[m]=w?w():void 0),clearTimeout(this[S]),P&&(this[m]=P(this[m],..._),_=[this[m]]),this[S]=setTimeout(()=>{A.apply(this,_),this[m]=w?w():void 0},I)}})}e.debounce=g;function U(I,P,w){return s((A,O)=>{const S=`$throttle$timer$${O}`,m=`$throttle$result$${O}`,_=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...u){if(this[m]||(this[m]=w?w():void 0),(this[_]===null||this[_]===void 0)&&(this[_]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...u)),this[f])return;const d=this[_]+I;d<=Date.now()?(this[_]=Date.now(),A.apply(this,[this[m]]),this[m]=w?w():void 0):(this[f]=!0,this[S]=setTimeout(()=>{this[f]=!1,this[_]=Date.now(),A.apply(this,[this[m]]),this[m]=w?w():void 0},d-Date.now()))}})}e.throttle=U}),define(Ie[56],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class s{constructor(g){this._prefix=g,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=s,e.defaultGenerator=new s("id#")}),define(Ie[104],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var s;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(s||(e.ScanError=s={}));var C;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var g;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var U;(function(r){r.DEFAULT={allowTrailingComma:!0}})(U||(e.ParseOptions=U={}));function I(r,h=!1){let i=0,o=r.length,n="",t=0,l=16,b=0;function v(M){let z=0,Z=0;for(;z<M;){const K=r.charCodeAt(i);if(K>=48&&K<=57)Z=Z*16+K-48;else if(K>=65&&K<=70)Z=Z*16+K-65+10;else if(K>=97&&K<=102)Z=Z*16+K-97+10;else break;i++,z++}return z<M&&(Z=-1),Z}function E(M){i=M,n="",t=0,l=16,b=0}function x(){const M=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&A(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&A(r.charCodeAt(i)))for(i++;i<r.length&&A(r.charCodeAt(i));)i++;else return b=3,r.substring(M,i);let z=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&A(r.charCodeAt(i))){for(i++;i<r.length&&A(r.charCodeAt(i));)i++;z=i}else b=3;return r.substring(M,z)}function $(){let M="",z=i;for(;;){if(i>=o){M+=r.substring(z,i),b=2;break}const Z=r.charCodeAt(i);if(Z===34){M+=r.substring(z,i),i++;break}if(Z===92){if(M+=r.substring(z,i),i++,i>=o){b=2;break}switch(r.charCodeAt(i++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const N=v(4);N>=0?M+=String.fromCharCode(N):b=4;break}default:b=5}z=i;continue}if(Z>=0&&Z<=31)if(w(Z)){M+=r.substring(z,i),b=2;break}else b=6;i++}return M}function R(){if(n="",b=0,t=i,i>=o)return t=o,l=17;let M=r.charCodeAt(i);if(P(M)){do i++,n+=String.fromCharCode(M),M=r.charCodeAt(i);while(P(M));return l=15}if(w(M))return i++,n+=String.fromCharCode(M),M===13&&r.charCodeAt(i)===10&&(i++,n+=`
`),l=14;switch(M){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,n=$(),l=10;case 47:{const z=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<o&&!w(r.charCodeAt(i));)i++;return n=r.substring(z,i),l=12}if(r.charCodeAt(i+1)===42){i+=2;const Z=o-1;let K=!1;for(;i<Z;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,b=1),n=r.substring(z,i),l=13}return n+=String.fromCharCode(M),i++,l=16}case 45:if(n+=String.fromCharCode(M),i++,i===o||!A(r.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=x(),l=11;default:for(;i<o&&p(M);)i++,M=r.charCodeAt(i);if(t!==i){switch(n=r.substring(t,i),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(M),i++,l=16}}function p(M){if(P(M)||w(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let M;do M=R();while(M>=12&&M<=15);return M}return{setPosition:E,getPosition:()=>i,scan:h?F:R,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>t,getTokenLength:()=>i-t,getTokenError:()=>b}}e.createScanner=I;function P(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function w(r){return r===10||r===13||r===8232||r===8233}function A(r){return r>=48&&r<=57}var O;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(O||(O={}));function S(r,h){const i=[],o=new Object;let n;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function b(v,E,x,$){t.value=v,t.offset=E,t.length=x,t.type=$,t.colonOffset=void 0,n=t}try{y(r,{onObjectBegin:(v,E)=>{if(h<=v)throw o;n=void 0,l=h>v,i.push("")},onObjectProperty:(v,E,x)=>{if(h<E||(b(v,E,x,"property"),i[i.length-1]=v,h<=E+x))throw o},onObjectEnd:(v,E)=>{if(h<=v)throw o;n=void 0,i.pop()},onArrayBegin:(v,E)=>{if(h<=v)throw o;n=void 0,i.push(0)},onArrayEnd:(v,E)=>{if(h<=v)throw o;n=void 0,i.pop()},onLiteralValue:(v,E,x)=>{if(h<E||(b(v,E,x,D(v)),h<=E+x))throw o},onSeparator:(v,E,x)=>{if(h<=E)throw o;if(v===":"&&n&&n.type==="property")n.colonOffset=E,l=!1,n=void 0;else if(v===","){const $=i[i.length-1];typeof $=="number"?i[i.length-1]=$+1:(l=!0,i[i.length-1]=""),n=void 0}}})}catch(v){if(v!==o)throw v}return{path:i,previousNode:n,isAtPropertyKey:l,matches:v=>{let E=0;for(let x=0;E<v.length&&x<i.length;x++)if(v[E]===i[x]||v[E]==="*")E++;else if(v[E]!=="**")return!1;return E===v.length}}}e.getLocation=S;function m(r,h=[],i=U.DEFAULT){let o=null,n=[];const t=[];function l(v){Array.isArray(n)?n.push(v):o!==null&&(n[o]=v)}return y(r,{onObjectBegin:()=>{const v={};l(v),t.push(n),n=v,o=null},onObjectProperty:v=>{o=v},onObjectEnd:()=>{n=t.pop()},onArrayBegin:()=>{const v=[];l(v),t.push(n),n=v,o=null},onArrayEnd:()=>{n=t.pop()},onLiteralValue:l,onError:(v,E,x)=>{h.push({error:v,offset:E,length:x})}},i),n[0]}e.parse=m;function _(r,h=[],i=U.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(v){o.type==="property"&&(o.length=v-o.offset,o=o.parent)}function t(v){return o.children.push(v),v}y(r,{onObjectBegin:v=>{o=t({type:"object",offset:v,length:-1,parent:o,children:[]})},onObjectProperty:(v,E,x)=>{o=t({type:"property",offset:E,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:v,offset:E,length:x,parent:o})},onObjectEnd:(v,E)=>{o.length=v+E-o.offset,o=o.parent,n(v+E)},onArrayBegin:(v,E)=>{o=t({type:"array",offset:v,length:-1,parent:o,children:[]})},onArrayEnd:(v,E)=>{o.length=v+E-o.offset,o=o.parent,n(v+E)},onLiteralValue:(v,E,x)=>{t({type:D(v),offset:E,length:x,parent:o,value:v}),n(E+x)},onSeparator:(v,E,x)=>{o.type==="property"&&(v===":"?o.colonOffset=E:v===","&&n(E))},onError:(v,E,x)=>{h.push({error:v,offset:E,length:x})}},i);const b=o.children[0];return b&&delete b.parent,b}e.parseTree=_;function f(r,h){if(!r)return;let i=r;for(let o of h)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const t of i.children)if(Array.isArray(t.children)&&t.children[0].value===o){i=t.children[1],n=!0;break}if(!n)return}else{const n=o;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}e.findNodeAtLocation=f;function u(r){if(!r.parent||!r.parent.children)return[];const h=u(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;h.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&h.push(i)}return h}e.getNodePath=u;function d(r){switch(r.type){case"array":return r.children.map(d);case"object":{const h=Object.create(null);for(let i of r.children){const o=i.children[1];o&&(h[i.children[0].value]=d(o))}return h}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=d;function c(r,h,i=!1){return h>=r.offset&&h<r.offset+r.length||i&&h===r.offset+r.length}e.contains=c;function k(r,h,i=!1){if(c(r,h,i)){const o=r.children;if(Array.isArray(o))for(let n=0;n<o.length&&o[n].offset<=h;n++){const t=k(o[n],h,i);if(t)return t}return r}}e.findNodeAtOffset=k;function y(r,h,i=U.DEFAULT){const o=I(r,!1);function n(ce){return ce?()=>ce(o.getTokenOffset(),o.getTokenLength()):()=>!0}function t(ce){return ce?ve=>ce(ve,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=n(h.onObjectBegin),b=t(h.onObjectProperty),v=n(h.onObjectEnd),E=n(h.onArrayBegin),x=n(h.onArrayEnd),$=t(h.onLiteralValue),R=t(h.onSeparator),p=n(h.onComment),F=t(h.onError),M=i&&i.disallowComments,z=i&&i.allowTrailingComma;function Z(){for(;;){const ce=o.scan();switch(o.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:M||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(ce){case 12:case 13:M?K(10):p();break;case 16:K(1);break;case 15:case 14:break;default:return ce}}}function K(ce,ve=[],J=[]){if(F(ce),ve.length+J.length>0){let Ee=o.getToken();for(;Ee!==17;){if(ve.indexOf(Ee)!==-1){Z();break}else if(J.indexOf(Ee)!==-1)break;Ee=Z()}}}function N(ce){const ve=o.getTokenValue();return ce?$(ve):b(ve),Z(),!0}function se(){switch(o.getToken()){case 11:{let ce=0;try{ce=JSON.parse(o.getTokenValue()),typeof ce!="number"&&(K(2),ce=0)}catch{K(2)}$(ce);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return Z(),!0}function le(){return o.getToken()!==10?(K(3,[],[2,5]),!1):(N(!1),o.getToken()===6?(R(":"),Z(),be()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function oe(){l(),Z();let ce=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ce||K(4,[],[]),R(","),Z(),o.getToken()===2&&z)break}else ce&&K(6,[],[]);le()||K(4,[],[2,5]),ce=!0}return v(),o.getToken()!==2?K(7,[2],[]):Z(),!0}function fe(){E(),Z();let ce=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ce||K(4,[],[]),R(","),Z(),o.getToken()===4&&z)break}else ce&&K(6,[],[]);be()||K(4,[],[4,5]),ce=!0}return x(),o.getToken()!==4?K(8,[4],[]):Z(),!0}function be(){switch(o.getToken()){case 3:return fe();case 1:return oe();case 10:return N(!0);default:return se()}}return Z(),o.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):be()?(o.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=y;function a(r,h){let i=I(r),o=[],n,t=0,l;do switch(l=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:t!==l&&o.push(r.substring(t,l)),h!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,h)),t=i.getPosition();break}while(n!==17);return o.join("")}e.stripComments=a;function D(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(Ie[105],Te([0]),e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(ke,Se){for(var Pe=0;Pe<Se.length;Pe++){var re=Se[Pe];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ke,re.key,re)}}function s(ke,Se,Pe){return Se&&e(ke.prototype,Se),Pe&&e(ke,Pe),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function C(ke,Se){if(!!ke){if(typeof ke=="string")return g(ke,Se);var Pe=Object.prototype.toString.call(ke).slice(8,-1);if(Pe==="Object"&&ke.constructor&&(Pe=ke.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(ke);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return g(ke,Se)}}function g(ke,Se){(Se==null||Se>ke.length)&&(Se=ke.length);for(var Pe=0,re=new Array(Se);Pe<Se;Pe++)re[Pe]=ke[Pe];return re}function U(ke,Se){var Pe=typeof Symbol!="undefined"&&ke[Symbol.iterator]||ke["@@iterator"];if(Pe)return(Pe=Pe.call(ke)).next.bind(Pe);if(Array.isArray(ke)||(Pe=C(ke))||Se&&ke&&typeof ke.length=="number"){Pe&&(ke=Pe);var re=0;return function(){return re>=ke.length?{done:!0}:{done:!1,value:ke[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=I();function P(ke){ee.defaults=ke}var w=/[&<>"']/,A=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},_=function(Se){return m[Se]};function f(ke,Se){if(Se){if(w.test(ke))return ke.replace(A,_)}else if(O.test(ke))return ke.replace(S,_);return ke}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(ke){return ke.replace(u,function(Se,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var c=/(^|[^\[])\^/g;function k(ke,Se){ke=typeof ke=="string"?ke:ke.source,Se=Se||"";var Pe={replace:function(ae,X){return X=X.source||X,X=X.replace(c,"$1"),ke=ke.replace(ae,X),Pe},getRegex:function(){return new RegExp(ke,Se)}};return Pe}var y=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(ke,Se,Pe){if(ke){var re;try{re=decodeURIComponent(d(Pe)).replace(y,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}Se&&!a.test(Pe)&&(Pe=n(Se,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch{return null}return Pe}var r={},h=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(ke,Se){r[" "+ke]||(h.test(ke)?r[" "+ke]=ke+"/":r[" "+ke]=v(ke,"/",!0)),ke=r[" "+ke];var Pe=ke.indexOf(":")===-1;return Se.substring(0,2)==="//"?Pe?Se:ke.replace(i,"$1")+Se:Se.charAt(0)==="/"?Pe?Se:ke.replace(o,"$1")+Se:ke+Se}var t={exec:function(){}};function l(ke){for(var Se=1,Pe,re;Se<arguments.length;Se++){Pe=arguments[Se];for(re in Pe)Object.prototype.hasOwnProperty.call(Pe,re)&&(ke[re]=Pe[re])}return ke}function b(ke,Se){var Pe=ke.replace(/\|/g,function(X,G,T){for(var B=!1,H=G;--H>=0&&T[H]==="\\";)B=!B;return B?"|":" |"}),re=Pe.split(/ \|/),ae=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>Se)re.splice(Se);else for(;re.length<Se;)re.push("");for(;ae<re.length;ae++)re[ae]=re[ae].trim().replace(/\\\|/g,"|");return re}function v(ke,Se,Pe){var re=ke.length;if(re===0)return"";for(var ae=0;ae<re;){var X=ke.charAt(re-ae-1);if(X===Se&&!Pe)ae++;else if(X!==Se&&Pe)ae++;else break}return ke.slice(0,re-ae)}function E(ke,Se){if(ke.indexOf(Se[1])===-1)return-1;for(var Pe=ke.length,re=0,ae=0;ae<Pe;ae++)if(ke[ae]==="\\")ae++;else if(ke[ae]===Se[0])re++;else if(ke[ae]===Se[1]&&(re--,re<0))return ae;return-1}function x(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function $(ke,Se){if(Se<1)return"";for(var Pe="";Se>1;)Se&1&&(Pe+=ke),Se>>=1,ke+=ke;return Pe+ke}function R(ke,Se,Pe,re){var ae=Se.href,X=Se.title?f(Se.title):null,G=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){re.state.inLink=!0;var T={type:"link",raw:Pe,href:ae,title:X,text:G,tokens:re.inlineTokens(G,[])};return re.state.inLink=!1,T}return{type:"image",raw:Pe,href:ae,title:X,text:f(G)}}function p(ke,Se){var Pe=ke.match(/^(\s+)(?:```)/);if(Pe===null)return Se;var re=Pe[1];return Se.split(`
`).map(function(ae){var X=ae.match(/^\s+/);if(X===null)return ae;var G=X[0];return G.length>=re.length?ae.slice(re.length):ae}).join(`
`)}var F=function(){function ke(Pe){this.options=Pe||ee.defaults}var Se=ke.prototype;return Se.space=function(re){var ae=this.rules.block.newline.exec(re);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},Se.code=function(re){var ae=this.rules.block.code.exec(re);if(ae){var X=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?X:v(X,`
`)}}},Se.fences=function(re){var ae=this.rules.block.fences.exec(re);if(ae){var X=ae[0],G=p(X,ae[3]||"");return{type:"code",raw:X,lang:ae[2]?ae[2].trim():ae[2],text:G}}},Se.heading=function(re){var ae=this.rules.block.heading.exec(re);if(ae){var X=ae[2].trim();if(/#$/.test(X)){var G=v(X,"#");(this.options.pedantic||!G||/ $/.test(G))&&(X=G.trim())}var T={type:"heading",raw:ae[0],depth:ae[1].length,text:X,tokens:[]};return this.lexer.inline(T.text,T.tokens),T}},Se.hr=function(re){var ae=this.rules.block.hr.exec(re);if(ae)return{type:"hr",raw:ae[0]}},Se.blockquote=function(re){var ae=this.rules.block.blockquote.exec(re);if(ae){var X=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(X,[]),text:X}}},Se.list=function(re){var ae=this.rules.block.list.exec(re);if(ae){var X,G,T,B,H,V,ne,ue,Q,ge,pe,Ne,Be=ae[1].trim(),Ae=Be.length>1,Ke={type:"list",raw:"",ordered:Ae,start:Ae?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Ae?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Ae?Be:"[*+-]");for(var q=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Ne=!1,!(!(ae=q.exec(re))||this.rules.block.hr.test(re)));){if(X=ae[0],re=re.substring(X.length),ue=ae[2].split(`
`,1)[0],Q=re.split(`
`,1)[0],this.options.pedantic?(B=2,pe=ue.trimLeft()):(B=ae[2].search(/[^ ]/),B=B>4?1:B,pe=ue.slice(B),B+=ae[1].length),V=!1,!ue&&/^ *$/.test(Q)&&(X+=Q+`
`,re=re.substring(Q.length+1),Ne=!0),!Ne)for(var Y=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),me=new RegExp("^ {0,"+Math.min(3,B-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");re&&(ge=re.split(`
`,1)[0],ue=ge,this.options.pedantic&&(ue=ue.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Y.test(ue)||me.test(re)));){if(ue.search(/[^ ]/)>=B||!ue.trim())pe+=`
`+ue.slice(B);else if(!V)pe+=`
`+ue;else break;!V&&!ue.trim()&&(V=!0),X+=ge+`
`,re=re.substring(ge.length+1)}Ke.loose||(ne?Ke.loose=!0:/\n *\n *$/.test(X)&&(ne=!0)),this.options.gfm&&(G=/^\[[ xX]\] /.exec(pe),G&&(T=G[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:X,task:!!G,checked:T,loose:!1,text:pe}),Ke.raw+=X}Ke.items[Ke.items.length-1].raw=X.trimRight(),Ke.items[Ke.items.length-1].text=pe.trimRight(),Ke.raw=Ke.raw.trimRight();var Le=Ke.items.length;for(H=0;H<Le;H++){this.lexer.state.top=!1,Ke.items[H].tokens=this.lexer.blockTokens(Ke.items[H].text,[]);var ze=Ke.items[H].tokens.filter(function(Ze){return Ze.type==="space"}),Ge=ze.every(function(Ze){for(var ot=Ze.raw.split(""),Qe=0,et=U(ot),qe;!(qe=et()).done;){var st=qe.value;if(st===`
`&&(Qe+=1),Qe>1)return!0}return!1});!Ke.loose&&ze.length&&Ge&&(Ke.loose=!0,Ke.items[H].loose=!0)}return Ke}},Se.html=function(re){var ae=this.rules.block.html.exec(re);if(ae){var X={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};return this.options.sanitize&&(X.type="paragraph",X.text=this.options.sanitizer?this.options.sanitizer(ae[0]):f(ae[0]),X.tokens=[],this.lexer.inline(X.text,X.tokens)),X}},Se.def=function(re){var ae=this.rules.block.def.exec(re);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var X=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:X,raw:ae[0],href:ae[2],title:ae[3]}}},Se.table=function(re){var ae=this.rules.block.table.exec(re);if(ae){var X={type:"table",header:b(ae[1]).map(function(ne){return{text:ne}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(X.header.length===X.align.length){X.raw=ae[0];var G=X.align.length,T,B,H,V;for(T=0;T<G;T++)/^ *-+: *$/.test(X.align[T])?X.align[T]="right":/^ *:-+: *$/.test(X.align[T])?X.align[T]="center":/^ *:-+ *$/.test(X.align[T])?X.align[T]="left":X.align[T]=null;for(G=X.rows.length,T=0;T<G;T++)X.rows[T]=b(X.rows[T],X.header.length).map(function(ne){return{text:ne}});for(G=X.header.length,B=0;B<G;B++)X.header[B].tokens=[],this.lexer.inline(X.header[B].text,X.header[B].tokens);for(G=X.rows.length,B=0;B<G;B++)for(V=X.rows[B],H=0;H<V.length;H++)V[H].tokens=[],this.lexer.inline(V[H].text,V[H].tokens);return X}}},Se.lheading=function(re){var ae=this.rules.block.lheading.exec(re);if(ae){var X={type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},Se.paragraph=function(re){var ae=this.rules.block.paragraph.exec(re);if(ae){var X={type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1],tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},Se.text=function(re){var ae=this.rules.block.text.exec(re);if(ae){var X={type:"text",raw:ae[0],text:ae[0],tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},Se.escape=function(re){var ae=this.rules.inline.escape.exec(re);if(ae)return{type:"escape",raw:ae[0],text:f(ae[1])}},Se.tag=function(re){var ae=this.rules.inline.tag.exec(re);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):f(ae[0]):ae[0]}},Se.link=function(re){var ae=this.rules.inline.link.exec(re);if(ae){var X=ae[2].trim();if(!this.options.pedantic&&/^</.test(X)){if(!/>$/.test(X))return;var G=v(X.slice(0,-1),"\\");if((X.length-G.length)%2==0)return}else{var T=E(ae[2],"()");if(T>-1){var B=ae[0].indexOf("!")===0?5:4,H=B+ae[1].length+T;ae[2]=ae[2].substring(0,T),ae[0]=ae[0].substring(0,H).trim(),ae[3]=""}}var V=ae[2],ne="";if(this.options.pedantic){var ue=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);ue&&(V=ue[1],ne=ue[3])}else ne=ae[3]?ae[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(X)?V=V.slice(1):V=V.slice(1,-1)),R(ae,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:ne&&ne.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},Se.reflink=function(re,ae){var X;if((X=this.rules.inline.reflink.exec(re))||(X=this.rules.inline.nolink.exec(re))){var G=(X[2]||X[1]).replace(/\s+/g," ");if(G=ae[G.toLowerCase()],!G||!G.href){var T=X[0].charAt(0);return{type:"text",raw:T,text:T}}return R(X,G,X[0],this.lexer)}},Se.emStrong=function(re,ae,X){X===void 0&&(X="");var G=this.rules.inline.emStrong.lDelim.exec(re);if(!!G&&!(G[3]&&X.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var T=G[1]||G[2]||"";if(!T||T&&(X===""||this.rules.inline.punctuation.exec(X))){var B=G[0].length-1,H,V,ne=B,ue=0,Q=G[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Q.lastIndex=0,ae=ae.slice(-1*re.length+B);(G=Q.exec(ae))!=null;)if(H=G[1]||G[2]||G[3]||G[4]||G[5]||G[6],!!H){if(V=H.length,G[3]||G[4]){ne+=V;continue}else if((G[5]||G[6])&&B%3&&!((B+V)%3)){ue+=V;continue}if(ne-=V,!(ne>0)){if(V=Math.min(V,V+ne+ue),Math.min(B,V)%2){var ge=re.slice(1,B+G.index+V);return{type:"em",raw:re.slice(0,B+G.index+V+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var pe=re.slice(2,B+G.index+V-1);return{type:"strong",raw:re.slice(0,B+G.index+V+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}}}}},Se.codespan=function(re){var ae=this.rules.inline.code.exec(re);if(ae){var X=ae[2].replace(/\n/g," "),G=/[^ ]/.test(X),T=/^ /.test(X)&&/ $/.test(X);return G&&T&&(X=X.substring(1,X.length-1)),X=f(X,!0),{type:"codespan",raw:ae[0],text:X}}},Se.br=function(re){var ae=this.rules.inline.br.exec(re);if(ae)return{type:"br",raw:ae[0]}},Se.del=function(re){var ae=this.rules.inline.del.exec(re);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2],[])}},Se.autolink=function(re,ae){var X=this.rules.inline.autolink.exec(re);if(X){var G,T;return X[2]==="@"?(G=f(this.options.mangle?ae(X[1]):X[1]),T="mailto:"+G):(G=f(X[1]),T=G),{type:"link",raw:X[0],text:G,href:T,tokens:[{type:"text",raw:G,text:G}]}}},Se.url=function(re,ae){var X;if(X=this.rules.inline.url.exec(re)){var G,T;if(X[2]==="@")G=f(this.options.mangle?ae(X[0]):X[0]),T="mailto:"+G;else{var B;do B=X[0],X[0]=this.rules.inline._backpedal.exec(X[0])[0];while(B!==X[0]);G=f(X[0]),X[1]==="www."?T="http://"+G:T=G}return{type:"link",raw:X[0],text:G,href:T,tokens:[{type:"text",raw:G,text:G}]}}},Se.inlineText=function(re,ae){var X=this.rules.inline.text.exec(re);if(X){var G;return this.lexer.state.inRawBlock?G=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):f(X[0]):X[0]:G=f(this.options.smartypants?ae(X[0]):X[0]),{type:"text",raw:X[0],text:G}}},ke}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=k(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=k(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=k(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=k(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=k(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=k(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=l({},M),M.gfm=l({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=k(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=k(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=l({},M.normal,{html:k(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:k(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=k(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=k(M._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=k(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=k(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=k(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=k(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=k(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=k(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=k(z.reflink).replace("label",z._label).replace("ref",M._label).getRegex(),z.nolink=k(z.nolink).replace("ref",M._label).getRegex(),z.reflinkSearch=k(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=l({},z),z.pedantic=l({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:k(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:k(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=l({},z.normal,{escape:k(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=k(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=l({},z.gfm,{br:k(z.br).replace("{2,}","*").getRegex(),text:k(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Z(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(ke){var Se="",Pe,re,ae=ke.length;for(Pe=0;Pe<ae;Pe++)re=ke.charCodeAt(Pe),Math.random()>.5&&(re="x"+re.toString(16)),Se+="&#"+re+";";return Se}var N=function(){function ke(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||ee.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:M.normal,inline:z.normal};this.options.pedantic?(re.block=M.pedantic,re.inline=z.pedantic):this.options.gfm&&(re.block=M.gfm,this.options.breaks?re.inline=z.breaks:re.inline=z.gfm),this.tokenizer.rules=re}ke.lex=function(re,ae){var X=new ke(ae);return X.lex(re)},ke.lexInline=function(re,ae){var X=new ke(ae);return X.inlineTokens(re)};var Se=ke.prototype;return Se.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},Se.blockTokens=function(re,ae){var X=this;ae===void 0&&(ae=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(ne,ue,Q){return ue+"    ".repeat(Q.length)});for(var G,T,B,H;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ne){return(G=ne.call({lexer:X},re,ae))?(re=re.substring(G.raw.length),ae.push(G),!0):!1}))){if(G=this.tokenizer.space(re)){re=re.substring(G.raw.length),G.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(G);continue}if(G=this.tokenizer.code(re)){re=re.substring(G.raw.length),T=ae[ae.length-1],T&&(T.type==="paragraph"||T.type==="text")?(T.raw+=`
`+G.raw,T.text+=`
`+G.text,this.inlineQueue[this.inlineQueue.length-1].src=T.text):ae.push(G);continue}if(G=this.tokenizer.fences(re)){re=re.substring(G.raw.length),ae.push(G);continue}if(G=this.tokenizer.heading(re)){re=re.substring(G.raw.length),ae.push(G);continue}if(G=this.tokenizer.hr(re)){re=re.substring(G.raw.length),ae.push(G);continue}if(G=this.tokenizer.blockquote(re)){re=re.substring(G.raw.length),ae.push(G);continue}if(G=this.tokenizer.list(re)){re=re.substring(G.raw.length),ae.push(G);continue}if(G=this.tokenizer.html(re)){re=re.substring(G.raw.length),ae.push(G);continue}if(G=this.tokenizer.def(re)){re=re.substring(G.raw.length),T=ae[ae.length-1],T&&(T.type==="paragraph"||T.type==="text")?(T.raw+=`
`+G.raw,T.text+=`
`+G.raw,this.inlineQueue[this.inlineQueue.length-1].src=T.text):this.tokens.links[G.tag]||(this.tokens.links[G.tag]={href:G.href,title:G.title});continue}if(G=this.tokenizer.table(re)){re=re.substring(G.raw.length),ae.push(G);continue}if(G=this.tokenizer.lheading(re)){re=re.substring(G.raw.length),ae.push(G);continue}if(B=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var ne=1/0,ue=re.slice(1),Q=void 0;X.options.extensions.startBlock.forEach(function(ge){Q=ge.call({lexer:this},ue),typeof Q=="number"&&Q>=0&&(ne=Math.min(ne,Q))}),ne<1/0&&ne>=0&&(B=re.substring(0,ne+1))}(),this.state.top&&(G=this.tokenizer.paragraph(B))){T=ae[ae.length-1],H&&T.type==="paragraph"?(T.raw+=`
`+G.raw,T.text+=`
`+G.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=T.text):ae.push(G),H=B.length!==re.length,re=re.substring(G.raw.length);continue}if(G=this.tokenizer.text(re)){re=re.substring(G.raw.length),T=ae[ae.length-1],T&&T.type==="text"?(T.raw+=`
`+G.raw,T.text+=`
`+G.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=T.text):ae.push(G);continue}if(re){var V="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,ae},Se.inline=function(re,ae){this.inlineQueue.push({src:re,tokens:ae})},Se.inlineTokens=function(re,ae){var X=this;ae===void 0&&(ae=[]);var G,T,B,H=re,V,ne,ue;if(this.tokens.links){var Q=Object.keys(this.tokens.links);if(Q.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)Q.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,V.index)+"["+$("a",V[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,V.index)+"["+$("a",V[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,V.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(ne||(ue=""),ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(pe){return(G=pe.call({lexer:X},re,ae))?(re=re.substring(G.raw.length),ae.push(G),!0):!1}))){if(G=this.tokenizer.escape(re)){re=re.substring(G.raw.length),ae.push(G);continue}if(G=this.tokenizer.tag(re)){re=re.substring(G.raw.length),T=ae[ae.length-1],T&&G.type==="text"&&T.type==="text"?(T.raw+=G.raw,T.text+=G.text):ae.push(G);continue}if(G=this.tokenizer.link(re)){re=re.substring(G.raw.length),ae.push(G);continue}if(G=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(G.raw.length),T=ae[ae.length-1],T&&G.type==="text"&&T.type==="text"?(T.raw+=G.raw,T.text+=G.text):ae.push(G);continue}if(G=this.tokenizer.emStrong(re,H,ue)){re=re.substring(G.raw.length),ae.push(G);continue}if(G=this.tokenizer.codespan(re)){re=re.substring(G.raw.length),ae.push(G);continue}if(G=this.tokenizer.br(re)){re=re.substring(G.raw.length),ae.push(G);continue}if(G=this.tokenizer.del(re)){re=re.substring(G.raw.length),ae.push(G);continue}if(G=this.tokenizer.autolink(re,K)){re=re.substring(G.raw.length),ae.push(G);continue}if(!this.state.inLink&&(G=this.tokenizer.url(re,K))){re=re.substring(G.raw.length),ae.push(G);continue}if(B=re,this.options.extensions&&this.options.extensions.startInline&&function(){var pe=1/0,Ne=re.slice(1),Be=void 0;X.options.extensions.startInline.forEach(function(Ae){Be=Ae.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(pe=Math.min(pe,Be))}),pe<1/0&&pe>=0&&(B=re.substring(0,pe+1))}(),G=this.tokenizer.inlineText(B,Z)){re=re.substring(G.raw.length),G.raw.slice(-1)!=="_"&&(ue=G.raw.slice(-1)),ne=!0,T=ae[ae.length-1],T&&T.type==="text"?(T.raw+=G.raw,T.text+=G.text):ae.push(G);continue}if(re){var ge="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return ae},s(ke,null,[{key:"rules",get:function(){return{block:M,inline:z}}}]),ke}(),se=function(){function ke(Pe){this.options=Pe||ee.defaults}var Se=ke.prototype;return Se.code=function(re,ae,X){var G=(ae||"").match(/\S*/)[0];if(this.options.highlight){var T=this.options.highlight(re,G);T!=null&&T!==re&&(X=!0,re=T)}return re=re.replace(/\n$/,"")+`
`,G?'<pre><code class="'+this.options.langPrefix+f(G,!0)+'">'+(X?re:f(re,!0))+`</code></pre>
`:"<pre><code>"+(X?re:f(re,!0))+`</code></pre>
`},Se.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},Se.html=function(re){return re},Se.heading=function(re,ae,X,G){if(this.options.headerIds){var T=this.options.headerPrefix+G.slug(X);return"<h"+ae+' id="'+T+'">'+re+"</h"+ae+`>
`}return"<h"+ae+">"+re+"</h"+ae+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(re,ae,X){var G=ae?"ol":"ul",T=ae&&X!==1?' start="'+X+'"':"";return"<"+G+T+`>
`+re+"</"+G+`>
`},Se.listitem=function(re){return"<li>"+re+`</li>
`},Se.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(re){return"<p>"+re+`</p>
`},Se.table=function(re,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+ae+`</table>
`},Se.tablerow=function(re){return`<tr>
`+re+`</tr>
`},Se.tablecell=function(re,ae){var X=ae.header?"th":"td",G=ae.align?"<"+X+' align="'+ae.align+'">':"<"+X+">";return G+re+("</"+X+`>
`)},Se.strong=function(re){return"<strong>"+re+"</strong>"},Se.em=function(re){return"<em>"+re+"</em>"},Se.codespan=function(re){return"<code>"+re+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(re){return"<del>"+re+"</del>"},Se.link=function(re,ae,X){if(re=D(this.options.sanitize,this.options.baseUrl,re),re===null)return X;var G='<a href="'+f(re)+'"';return ae&&(G+=' title="'+ae+'"'),G+=">"+X+"</a>",G},Se.image=function(re,ae,X){if(re=D(this.options.sanitize,this.options.baseUrl,re),re===null)return X;var G='<img src="'+re+'" alt="'+X+'"';return ae&&(G+=' title="'+ae+'"'),G+=this.options.xhtml?"/>":">",G},Se.text=function(re){return re},ke}(),le=function(){function ke(){}var Se=ke.prototype;return Se.strong=function(re){return re},Se.em=function(re){return re},Se.codespan=function(re){return re},Se.del=function(re){return re},Se.html=function(re){return re},Se.text=function(re){return re},Se.link=function(re,ae,X){return""+X},Se.image=function(re,ae,X){return""+X},Se.br=function(){return""},ke}(),oe=function(){function ke(){this.seen={}}var Se=ke.prototype;return Se.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(re,ae){var X=re,G=0;if(this.seen.hasOwnProperty(X)){G=this.seen[re];do G++,X=re+"-"+G;while(this.seen.hasOwnProperty(X))}return ae||(this.seen[re]=G,this.seen[X]=0),X},Se.slug=function(re,ae){ae===void 0&&(ae={});var X=this.serialize(re);return this.getNextSafeSlug(X,ae.dryrun)},ke}(),fe=function(){function ke(Pe){this.options=Pe||ee.defaults,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new oe}ke.parse=function(re,ae){var X=new ke(ae);return X.parse(re)},ke.parseInline=function(re,ae){var X=new ke(ae);return X.parseInline(re)};var Se=ke.prototype;return Se.parse=function(re,ae){ae===void 0&&(ae=!0);var X="",G,T,B,H,V,ne,ue,Q,ge,pe,Ne,Be,Ae,Ke,q,Y,me,Le,ze,Ge=re.length;for(G=0;G<Ge;G++){if(pe=re[G],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(ze=this.options.extensions.renderers[pe.type].call({parser:this},pe),ze!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(pe.type))){X+=ze||"";continue}switch(pe.type){case"space":continue;case"hr":{X+=this.renderer.hr();continue}case"heading":{X+=this.renderer.heading(this.parseInline(pe.tokens),pe.depth,d(this.parseInline(pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{X+=this.renderer.code(pe.text,pe.lang,pe.escaped);continue}case"table":{for(Q="",ue="",H=pe.header.length,T=0;T<H;T++)ue+=this.renderer.tablecell(this.parseInline(pe.header[T].tokens),{header:!0,align:pe.align[T]});for(Q+=this.renderer.tablerow(ue),ge="",H=pe.rows.length,T=0;T<H;T++){for(ne=pe.rows[T],ue="",V=ne.length,B=0;B<V;B++)ue+=this.renderer.tablecell(this.parseInline(ne[B].tokens),{header:!1,align:pe.align[B]});ge+=this.renderer.tablerow(ue)}X+=this.renderer.table(Q,ge);continue}case"blockquote":{ge=this.parse(pe.tokens),X+=this.renderer.blockquote(ge);continue}case"list":{for(Ne=pe.ordered,Be=pe.start,Ae=pe.loose,H=pe.items.length,ge="",T=0;T<H;T++)q=pe.items[T],Y=q.checked,me=q.task,Ke="",q.task&&(Le=this.renderer.checkbox(Y),Ae?q.tokens.length>0&&q.tokens[0].type==="paragraph"?(q.tokens[0].text=Le+" "+q.tokens[0].text,q.tokens[0].tokens&&q.tokens[0].tokens.length>0&&q.tokens[0].tokens[0].type==="text"&&(q.tokens[0].tokens[0].text=Le+" "+q.tokens[0].tokens[0].text)):q.tokens.unshift({type:"text",text:Le}):Ke+=Le),Ke+=this.parse(q.tokens,Ae),ge+=this.renderer.listitem(Ke,me,Y);X+=this.renderer.list(ge,Ne,Be);continue}case"html":{X+=this.renderer.html(pe.text);continue}case"paragraph":{X+=this.renderer.paragraph(this.parseInline(pe.tokens));continue}case"text":{for(ge=pe.tokens?this.parseInline(pe.tokens):pe.text;G+1<Ge&&re[G+1].type==="text";)pe=re[++G],ge+=`
`+(pe.tokens?this.parseInline(pe.tokens):pe.text);X+=ae?this.renderer.paragraph(ge):ge;continue}default:{var Ze='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return X},Se.parseInline=function(re,ae){ae=ae||this.renderer;var X="",G,T,B,H=re.length;for(G=0;G<H;G++){if(T=re[G],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[T.type]&&(B=this.options.extensions.renderers[T.type].call({parser:this},T),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(T.type))){X+=B||"";continue}switch(T.type){case"escape":{X+=ae.text(T.text);break}case"html":{X+=ae.html(T.text);break}case"link":{X+=ae.link(T.href,T.title,this.parseInline(T.tokens,ae));break}case"image":{X+=ae.image(T.href,T.title,T.text);break}case"strong":{X+=ae.strong(this.parseInline(T.tokens,ae));break}case"em":{X+=ae.em(this.parseInline(T.tokens,ae));break}case"codespan":{X+=ae.codespan(T.text);break}case"br":{X+=ae.br();break}case"del":{X+=ae.del(this.parseInline(T.tokens,ae));break}case"text":{X+=ae.text(T.text);break}default:{var V='Token with "'+T.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return X},ke}();function be(ke,Se,Pe){if(typeof ke=="undefined"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof Se=="function"&&(Pe=Se,Se=null),Se=l({},be.defaults,Se||{}),x(Se),Pe){var re=Se.highlight,ae;try{ae=N.lex(ke,Se)}catch(B){return Pe(B)}var X=function(H){var V;if(!H)try{Se.walkTokens&&be.walkTokens(ae,Se.walkTokens),V=fe.parse(ae,Se)}catch(ne){H=ne}return Se.highlight=re,H?Pe(H):Pe(null,V)};if(!re||re.length<3||(delete Se.highlight,!ae.length))return X();var G=0;be.walkTokens(ae,function(B){B.type==="code"&&(G++,setTimeout(function(){re(B.text,B.lang,function(H,V){if(H)return X(H);V!=null&&V!==B.text&&(B.text=V,B.escaped=!0),G--,G===0&&X()})},0))}),G===0&&X();return}try{var T=N.lex(ke,Se);return Se.walkTokens&&be.walkTokens(T,Se.walkTokens),fe.parse(T,Se)}catch(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(B.message+"",!0)+"</pre>";throw B}}be.options=be.setOptions=function(ke){return l(be.defaults,ke),P(be.defaults),be},be.getDefaults=I,be.defaults=ee.defaults,be.use=function(){for(var ke=arguments.length,Se=new Array(ke),Pe=0;Pe<ke;Pe++)Se[Pe]=arguments[Pe];var re=l.apply(void 0,[{}].concat(Se)),ae=be.defaults.extensions||{renderers:{},childTokens:{}},X;Se.forEach(function(G){if(G.extensions&&(X=!0,G.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var H=ae.renderers?ae.renderers[B.name]:null;H?ae.renderers[B.name]=function(){for(var V=arguments.length,ne=new Array(V),ue=0;ue<V;ue++)ne[ue]=arguments[ue];var Q=B.renderer.apply(this,ne);return Q===!1&&(Q=H.apply(this,ne)),Q}:ae.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[B.level]?ae[B.level].unshift(B.tokenizer):ae[B.level]=[B.tokenizer],B.start&&(B.level==="block"?ae.startBlock?ae.startBlock.push(B.start):ae.startBlock=[B.start]:B.level==="inline"&&(ae.startInline?ae.startInline.push(B.start):ae.startInline=[B.start]))}B.childTokens&&(ae.childTokens[B.name]=B.childTokens)})),G.renderer&&function(){var B=be.defaults.renderer||new se,H=function(ue){var Q=B[ue];B[ue]=function(){for(var ge=arguments.length,pe=new Array(ge),Ne=0;Ne<ge;Ne++)pe[Ne]=arguments[Ne];var Be=G.renderer[ue].apply(B,pe);return Be===!1&&(Be=Q.apply(B,pe)),Be}};for(var V in G.renderer)H(V);re.renderer=B}(),G.tokenizer&&function(){var B=be.defaults.tokenizer||new F,H=function(ue){var Q=B[ue];B[ue]=function(){for(var ge=arguments.length,pe=new Array(ge),Ne=0;Ne<ge;Ne++)pe[Ne]=arguments[Ne];var Be=G.tokenizer[ue].apply(B,pe);return Be===!1&&(Be=Q.apply(B,pe)),Be}};for(var V in G.tokenizer)H(V);re.tokenizer=B}(),G.walkTokens){var T=be.defaults.walkTokens;re.walkTokens=function(B){G.walkTokens.call(this,B),T&&T.call(this,B)}}X&&(re.extensions=ae),be.setOptions(re)})},be.walkTokens=function(ke,Se){for(var Pe=function(){var G=ae.value;switch(Se.call(be,G),G.type){case"table":{for(var T=U(G.header),B;!(B=T()).done;){var H=B.value;be.walkTokens(H.tokens,Se)}for(var V=U(G.rows),ne;!(ne=V()).done;)for(var ue=ne.value,Q=U(ue),ge;!(ge=Q()).done;){var pe=ge.value;be.walkTokens(pe.tokens,Se)}break}case"list":{be.walkTokens(G.items,Se);break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[G.type]?be.defaults.extensions.childTokens[G.type].forEach(function(Ne){be.walkTokens(G[Ne],Se)}):G.tokens&&be.walkTokens(G.tokens,Se)}},re=U(ke),ae;!(ae=re()).done;)Pe()},be.parseInline=function(ke,Se){if(typeof ke=="undefined"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");Se=l({},be.defaults,Se||{}),x(Se);try{var Pe=N.lexInline(ke,Se);return Se.walkTokens&&be.walkTokens(Pe,Se.walkTokens),fe.parseInline(Pe,Se)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(re.message+"",!0)+"</pre>";throw re}},be.Parser=fe,be.parser=fe.parse,be.Renderer=se,be.TextRenderer=le,be.Lexer=N,be.lexer=N.lex,be.Tokenizer=F,be.Slugger=oe,be.parse=be;var ce=be.options,ve=be.setOptions,J=be.use,Ee=be.walkTokens,_e=be.parseInline,Fe=be,xe=fe.parse,Xe=N.lex;ee.Lexer=N,ee.Parser=fe,ee.Renderer=se,ee.Slugger=oe,ee.TextRenderer=le,ee.Tokenizer=F,ee.getDefaults=I,ee.lexer=Xe,ee.marked=be,ee.options=ce,ee.parse=Fe,ee.parseInline=_e,ee.parser=xe,ee.setOptions=ve,ee.use=J,ee.walkTokens=Ee,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Ie[106],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function s(P,w,A){return Math.min(Math.max(P,w),A)}e.clamp=s;function C(P,w){return(w+P%w)%w}e.rot=C;class g{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=g;class U{constructor(){this._n=1,this._val=0}update(w){return this._val=this._val+(w-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=U;class I{constructor(w){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(w),this._values.fill(0,0,w)}update(w){const A=this._values[this._index];return this._values[this._index]=w,this._index=(this._index+1)%this._values.length,this._sum-=A,this._sum+=w,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=I}),function(){function ee(g){const U=[];typeof g=="number"&&U.push("code/timeOrigin",g);function I(w){U.push(w,Date.now())}function P(){const w=[];for(let A=0;A<U.length;A+=2)w.push({name:U[A],startTime:U[A+1]});return w}return{mark:I,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const U=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const I of performance.getEntriesByType("mark"))U.push({name:I.name,startTime:Math.round(g+I.startTime)});return U}};if(typeof process=="object"){const g=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function s(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=s(C))}(),define(Ie[74],Te([1,0,19]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var C;(function(S){S.text="text/plain",S.binary="application/octet-stream",S.unknown="application/unknown",S.markdown="text/markdown",S.latex="text/latex",S.uriList="text/uri-list"})(C||(e.Mimes=C={}));const g={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},U={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(S){const m=(0,s.extname)(S),_=g[m.toLowerCase()];return _!==void 0?_:P(S)}e.getMediaOrTextMime=I;function P(S){const m=(0,s.extname)(S);return U[m.toLowerCase()]}e.getMediaMime=P;function w(S){for(const m in U)if(U[m]===S)return m}e.getExtensionForMimeType=w;const A=/^(.+)\/(.+?)(;.+)?$/;function O(S,m){const _=A.exec(S);return _?`${_[1].toLowerCase()}/${_[2].toLowerCase()}${_[3]??""}`:m?void 0:S}e.normalizeMimeType=O}),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var s=e();for(var C in s)(typeof exports=="object"?exports:ee)[C]=s[C]}}(typeof self!="undefined"?self:this,function(){return function(ee){var e={};function s(C){if(e[C])return e[C].exports;var g=e[C]={i:C,l:!1,exports:{}};return ee[C].call(g.exports,g,g.exports,s),g.l=!0,g.exports}return s.m=ee,s.c=e,s.d=function(C,g,U){s.o(C,g)||Object.defineProperty(C,g,{enumerable:!0,get:U})},s.r=function(C){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},s.t=function(C,g){if(1&g&&(C=s(C)),8&g||4&g&&typeof C=="object"&&C&&C.__esModule)return C;var U=Object.create(null);if(s.r(U),Object.defineProperty(U,"default",{enumerable:!0,value:C}),2&g&&typeof C!="string")for(var I in C)s.d(U,I,function(P){return C[P]}.bind(null,I));return U},s.n=function(C){var g=C&&C.__esModule?function(){return C.default}:function(){return C};return s.d(g,"a",g),g},s.o=function(C,g){return Object.prototype.hasOwnProperty.call(C,g)},s.p="",s(s.s=0)}([function(ee,e,s){(function(C){var g;e=ee.exports=J,g=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var U=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],w=e.src=[],A=0,O=A++;w[O]="0|[1-9]\\d*";var S=A++;w[S]="[0-9]+";var m=A++;w[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var _=A++;w[_]="("+w[O]+")\\.("+w[O]+")\\.("+w[O]+")";var f=A++;w[f]="("+w[S]+")\\.("+w[S]+")\\.("+w[S]+")";var u=A++;w[u]="(?:"+w[O]+"|"+w[m]+")";var d=A++;w[d]="(?:"+w[S]+"|"+w[m]+")";var c=A++;w[c]="(?:-("+w[u]+"(?:\\."+w[u]+")*))";var k=A++;w[k]="(?:-?("+w[d]+"(?:\\."+w[d]+")*))";var y=A++;w[y]="[0-9A-Za-z-]+";var a=A++;w[a]="(?:\\+("+w[y]+"(?:\\."+w[y]+")*))";var D=A++,r="v?"+w[_]+w[c]+"?"+w[a]+"?";w[D]="^"+r+"$";var h="[v=\\s]*"+w[f]+w[k]+"?"+w[a]+"?",i=A++;w[i]="^"+h+"$";var o=A++;w[o]="((?:<|>)?=?)";var n=A++;w[n]=w[S]+"|x|X|\\*";var t=A++;w[t]=w[O]+"|x|X|\\*";var l=A++;w[l]="[v=\\s]*("+w[t]+")(?:\\.("+w[t]+")(?:\\.("+w[t]+")(?:"+w[c]+")?"+w[a]+"?)?)?";var b=A++;w[b]="[v=\\s]*("+w[n]+")(?:\\.("+w[n]+")(?:\\.("+w[n]+")(?:"+w[k]+")?"+w[a]+"?)?)?";var v=A++;w[v]="^"+w[o]+"\\s*"+w[l]+"$";var E=A++;w[E]="^"+w[o]+"\\s*"+w[b]+"$";var x=A++;w[x]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=A++;w[$]="(?:~>?)";var R=A++;w[R]="(\\s*)"+w[$]+"\\s+",P[R]=new RegExp(w[R],"g");var p=A++;w[p]="^"+w[$]+w[l]+"$";var F=A++;w[F]="^"+w[$]+w[b]+"$";var M=A++;w[M]="(?:\\^)";var z=A++;w[z]="(\\s*)"+w[M]+"\\s+",P[z]=new RegExp(w[z],"g");var Z=A++;w[Z]="^"+w[M]+w[l]+"$";var K=A++;w[K]="^"+w[M]+w[b]+"$";var N=A++;w[N]="^"+w[o]+"\\s*("+h+")$|^$";var se=A++;w[se]="^"+w[o]+"\\s*("+r+")$|^$";var le=A++;w[le]="(\\s*)"+w[o]+"\\s*("+h+"|"+w[l]+")",P[le]=new RegExp(w[le],"g");var oe=A++;w[oe]="^\\s*("+w[l]+")\\s+-\\s+("+w[l]+")\\s*$";var fe=A++;w[fe]="^\\s*("+w[b]+")\\s+-\\s+("+w[b]+")\\s*$";var be=A++;w[be]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)g(ce,w[ce]),P[ce]||(P[ce]=new RegExp(w[ce]));function ve(Q,ge){if(Q instanceof J)return Q;if(typeof Q!="string"||Q.length>U||!(ge?P[i]:P[D]).test(Q))return null;try{return new J(Q,ge)}catch{return null}}function J(Q,ge){if(Q instanceof J){if(Q.loose===ge)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>U)throw new TypeError("version is longer than "+U+" characters");if(!(this instanceof J))return new J(Q,ge);g("SemVer",Q,ge),this.loose=ge;var pe=Q.trim().match(ge?P[i]:P[D]);if(!pe)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+pe[1],this.minor=+pe[2],this.patch=+pe[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");pe[4]?this.prerelease=pe[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<I)return Be}return Ne}):this.prerelease=[],this.build=pe[5]?pe[5].split("."):[],this.format()}e.parse=ve,e.valid=function(Q,ge){var pe=ve(Q,ge);return pe?pe.version:null},e.clean=function(Q,ge){var pe=ve(Q.trim().replace(/^[=v]+/,""),ge);return pe?pe.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(Q){return g("SemVer.compare",this.version,this.loose,Q),Q instanceof J||(Q=new J(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},J.prototype.compareMain=function(Q){return Q instanceof J||(Q=new J(Q,this.loose)),_e(this.major,Q.major)||_e(this.minor,Q.minor)||_e(this.patch,Q.patch)},J.prototype.comparePre=function(Q){if(Q instanceof J||(Q=new J(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var ge=0;do{var pe=this.prerelease[ge],Ne=Q.prerelease[ge];if(g("prerelease compare",ge,pe,Ne),pe===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(pe===void 0)return-1;if(pe!==Ne)return _e(pe,Ne)}while(++ge)},J.prototype.inc=function(Q,ge){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var pe=this.prerelease.length;--pe>=0;)typeof this.prerelease[pe]=="number"&&(this.prerelease[pe]++,pe=-2);pe===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,ge,pe,Ne){typeof pe=="string"&&(Ne=pe,pe=void 0);try{return new J(Q,pe).inc(ge,Ne).version}catch{return null}},e.diff=function(Q,ge){if(ke(Q,ge))return null;var pe=ve(Q),Ne=ve(ge);if(pe.prerelease.length||Ne.prerelease.length){for(var Be in pe)if((Be==="major"||Be==="minor"||Be==="patch")&&pe[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in pe)if((Be==="major"||Be==="minor"||Be==="patch")&&pe[Be]!==Ne[Be])return Be},e.compareIdentifiers=_e;var Ee=/^[0-9]+$/;function _e(Q,ge){var pe=Ee.test(Q),Ne=Ee.test(ge);return pe&&Ne&&(Q=+Q,ge=+ge),pe&&!Ne?-1:Ne&&!pe?1:Q<ge?-1:Q>ge?1:0}function Fe(Q,ge,pe){return new J(Q,pe).compare(new J(ge,pe))}function xe(Q,ge,pe){return Fe(Q,ge,pe)>0}function Xe(Q,ge,pe){return Fe(Q,ge,pe)<0}function ke(Q,ge,pe){return Fe(Q,ge,pe)===0}function Se(Q,ge,pe){return Fe(Q,ge,pe)!==0}function Pe(Q,ge,pe){return Fe(Q,ge,pe)>=0}function re(Q,ge,pe){return Fe(Q,ge,pe)<=0}function ae(Q,ge,pe,Ne){var Be;switch(ge){case"===":typeof Q=="object"&&(Q=Q.version),typeof pe=="object"&&(pe=pe.version),Be=Q===pe;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof pe=="object"&&(pe=pe.version),Be=Q!==pe;break;case"":case"=":case"==":Be=ke(Q,pe,Ne);break;case"!=":Be=Se(Q,pe,Ne);break;case">":Be=xe(Q,pe,Ne);break;case">=":Be=Pe(Q,pe,Ne);break;case"<":Be=Xe(Q,pe,Ne);break;case"<=":Be=re(Q,pe,Ne);break;default:throw new TypeError("Invalid operator: "+ge)}return Be}function X(Q,ge){if(Q instanceof X){if(Q.loose===ge)return Q;Q=Q.value}if(!(this instanceof X))return new X(Q,ge);g("comparator",Q,ge),this.loose=ge,this.parse(Q),this.semver===G?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(Q,ge){return _e(ge,Q)},e.major=function(Q,ge){return new J(Q,ge).major},e.minor=function(Q,ge){return new J(Q,ge).minor},e.patch=function(Q,ge){return new J(Q,ge).patch},e.compare=Fe,e.compareLoose=function(Q,ge){return Fe(Q,ge,!0)},e.rcompare=function(Q,ge,pe){return Fe(ge,Q,pe)},e.sort=function(Q,ge){return Q.sort(function(pe,Ne){return e.compare(pe,Ne,ge)})},e.rsort=function(Q,ge){return Q.sort(function(pe,Ne){return e.rcompare(pe,Ne,ge)})},e.gt=xe,e.lt=Xe,e.eq=ke,e.neq=Se,e.gte=Pe,e.lte=re,e.cmp=ae,e.Comparator=X;var G={};function T(Q,ge){if(Q instanceof T)return Q.loose===ge?Q:new T(Q.raw,ge);if(Q instanceof X)return new T(Q.value,ge);if(!(this instanceof T))return new T(Q,ge);if(this.loose=ge,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(pe){return this.parseRange(pe.trim())},this).filter(function(pe){return pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function B(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function H(Q,ge,pe,Ne,Be,Ae,Ke,q,Y,me,Le,ze,Ge){return((ge=B(pe)?"":B(Ne)?">="+pe+".0.0":B(Be)?">="+pe+"."+Ne+".0":">="+ge)+" "+(q=B(Y)?"":B(me)?"<"+(+Y+1)+".0.0":B(Le)?"<"+Y+"."+(+me+1)+".0":ze?"<="+Y+"."+me+"."+Le+"-"+ze:"<="+q)).trim()}function V(Q,ge){for(var pe=0;pe<Q.length;pe++)if(!Q[pe].test(ge))return!1;if(ge.prerelease.length){for(pe=0;pe<Q.length;pe++)if(g(Q[pe].semver),Q[pe].semver!==G&&Q[pe].semver.prerelease.length>0){var Ne=Q[pe].semver;if(Ne.major===ge.major&&Ne.minor===ge.minor&&Ne.patch===ge.patch)return!0}return!1}return!0}function ne(Q,ge,pe){try{ge=new T(ge,pe)}catch{return!1}return ge.test(Q)}function ue(Q,ge,pe,Ne){var Be,Ae,Ke,q,Y;switch(Q=new J(Q,Ne),ge=new T(ge,Ne),pe){case">":Be=xe,Ae=re,Ke=Xe,q=">",Y=">=";break;case"<":Be=Xe,Ae=Pe,Ke=xe,q="<",Y="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ne(Q,ge,Ne))return!1;for(var me=0;me<ge.set.length;++me){var Le=ge.set[me],ze=null,Ge=null;if(Le.forEach(function(Ze){Ze.semver===G&&(Ze=new X(">=0.0.0")),ze=ze||Ze,Ge=Ge||Ze,Be(Ze.semver,ze.semver,Ne)?ze=Ze:Ke(Ze.semver,Ge.semver,Ne)&&(Ge=Ze)}),ze.operator===q||ze.operator===Y||(!Ge.operator||Ge.operator===q)&&Ae(Q,Ge.semver)||Ge.operator===Y&&Ke(Q,Ge.semver))return!1}return!0}X.prototype.parse=function(Q){var ge=this.loose?P[N]:P[se],pe=Q.match(ge);if(!pe)throw new TypeError("Invalid comparator: "+Q);this.operator=pe[1],this.operator==="="&&(this.operator=""),pe[2]?this.semver=new J(pe[2],this.loose):this.semver=G},X.prototype.toString=function(){return this.value},X.prototype.test=function(Q){return g("Comparator.test",Q,this.loose),this.semver===G||(typeof Q=="string"&&(Q=new J(Q,this.loose)),ae(Q,this.operator,this.semver,this.loose))},X.prototype.intersects=function(Q,ge){if(!(Q instanceof X))throw new TypeError("a Comparator is required");var pe;if(this.operator==="")return pe=new T(Q.value,ge),ne(this.value,pe,ge);if(Q.operator==="")return pe=new T(this.value,ge),ne(Q.semver,pe,ge);var Ne=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Ae=this.semver.version===Q.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),q=ae(this.semver,"<",Q.semver,ge)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),Y=ae(this.semver,">",Q.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return Ne||Be||Ae&&Ke||q||Y},e.Range=T,T.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},T.prototype.toString=function(){return this.range},T.prototype.parseRange=function(Q){var ge=this.loose;Q=Q.trim(),g("range",Q,ge);var pe=ge?P[fe]:P[oe];Q=Q.replace(pe,H),g("hyphen replace",Q),Q=Q.replace(P[le],"$1$2$3"),g("comparator trim",Q,P[le]),Q=(Q=(Q=Q.replace(P[R],"$1~")).replace(P[z],"$1^")).split(/\s+/).join(" ");var Ne=ge?P[N]:P[se],Be=Q.split(" ").map(function(Ae){return function(Ke,q){return g("comp",Ke),Ke=function(Y,me){return Y.trim().split(/\s+/).map(function(Le){return function(ze,Ge){g("caret",ze,Ge);var Ze=Ge?P[K]:P[Z];return ze.replace(Ze,function(ot,Qe,et,qe,st){var it;return g("caret",ze,ot,Qe,et,qe,st),B(Qe)?it="":B(et)?it=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":B(qe)?it=Qe==="0"?">="+Qe+"."+et+".0 <"+Qe+"."+(+et+1)+".0":">="+Qe+"."+et+".0 <"+(+Qe+1)+".0.0":st?(g("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),it=Qe==="0"?et==="0"?">="+Qe+"."+et+"."+qe+st+" <"+Qe+"."+et+"."+(+qe+1):">="+Qe+"."+et+"."+qe+st+" <"+Qe+"."+(+et+1)+".0":">="+Qe+"."+et+"."+qe+st+" <"+(+Qe+1)+".0.0"):(g("no pr"),it=Qe==="0"?et==="0"?">="+Qe+"."+et+"."+qe+" <"+Qe+"."+et+"."+(+qe+1):">="+Qe+"."+et+"."+qe+" <"+Qe+"."+(+et+1)+".0":">="+Qe+"."+et+"."+qe+" <"+(+Qe+1)+".0.0"),g("caret return",it),it})}(Le,me)}).join(" ")}(Ke,q),g("caret",Ke),Ke=function(Y,me){return Y.trim().split(/\s+/).map(function(Le){return function(ze,Ge){var Ze=Ge?P[F]:P[p];return ze.replace(Ze,function(ot,Qe,et,qe,st){var it;return g("tilde",ze,ot,Qe,et,qe,st),B(Qe)?it="":B(et)?it=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":B(qe)?it=">="+Qe+"."+et+".0 <"+Qe+"."+(+et+1)+".0":st?(g("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),it=">="+Qe+"."+et+"."+qe+st+" <"+Qe+"."+(+et+1)+".0"):it=">="+Qe+"."+et+"."+qe+" <"+Qe+"."+(+et+1)+".0",g("tilde return",it),it})}(Le,me)}).join(" ")}(Ke,q),g("tildes",Ke),Ke=function(Y,me){return g("replaceXRanges",Y,me),Y.split(/\s+/).map(function(Le){return function(ze,Ge){ze=ze.trim();var Ze=Ge?P[E]:P[v];return ze.replace(Ze,function(ot,Qe,et,qe,st,it){g("xRange",ze,ot,Qe,et,qe,st,it);var at=B(et),ct=at||B(qe),Tt=ct||B(st);return Qe==="="&&Tt&&(Qe=""),at?ot=Qe===">"||Qe==="<"?"<0.0.0":"*":Qe&&Tt?(ct&&(qe=0),Tt&&(st=0),Qe===">"?(Qe=">=",ct?(et=+et+1,qe=0,st=0):Tt&&(qe=+qe+1,st=0)):Qe==="<="&&(Qe="<",ct?et=+et+1:qe=+qe+1),ot=Qe+et+"."+qe+"."+st):ct?ot=">="+et+".0.0 <"+(+et+1)+".0.0":Tt&&(ot=">="+et+"."+qe+".0 <"+et+"."+(+qe+1)+".0"),g("xRange return",ot),ot})}(Le,me)}).join(" ")}(Ke,q),g("xrange",Ke),Ke=function(Y,me){return g("replaceStars",Y,me),Y.trim().replace(P[be],"")}(Ke,q),g("stars",Ke),Ke}(Ae,ge)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Ae){return!!Ae.match(Ne)})),Be=Be.map(function(Ae){return new X(Ae,ge)})},T.prototype.intersects=function(Q,ge){if(!(Q instanceof T))throw new TypeError("a Range is required");return this.set.some(function(pe){return pe.every(function(Ne){return Q.set.some(function(Be){return Be.every(function(Ae){return Ne.intersects(Ae,ge)})})})})},e.toComparators=function(Q,ge){return new T(Q,ge).set.map(function(pe){return pe.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},T.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new J(Q,this.loose));for(var ge=0;ge<this.set.length;ge++)if(V(this.set[ge],Q))return!0;return!1},e.satisfies=ne,e.maxSatisfying=function(Q,ge,pe){var Ne=null,Be=null;try{var Ae=new T(ge,pe)}catch{return null}return Q.forEach(function(Ke){Ae.test(Ke)&&(Ne&&Be.compare(Ke)!==-1||(Be=new J(Ne=Ke,pe)))}),Ne},e.minSatisfying=function(Q,ge,pe){var Ne=null,Be=null;try{var Ae=new T(ge,pe)}catch{return null}return Q.forEach(function(Ke){Ae.test(Ke)&&(Ne&&Be.compare(Ke)!==1||(Be=new J(Ne=Ke,pe)))}),Ne},e.validRange=function(Q,ge){try{return new T(Q,ge).range||"*"}catch{return null}},e.ltr=function(Q,ge,pe){return ue(Q,ge,"<",pe)},e.gtr=function(Q,ge,pe){return ue(Q,ge,">",pe)},e.outside=ue,e.prerelease=function(Q,ge){var pe=ve(Q,ge);return pe&&pe.prerelease.length?pe.prerelease:null},e.intersects=function(Q,ge,pe){return Q=new T(Q,pe),ge=new T(ge,pe),Q.intersects(ge)},e.coerce=function(Q){if(Q instanceof J)return Q;if(typeof Q!="string")return null;var ge=Q.match(P[x]);return ge==null?null:ve((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,s(1))},function(ee,e){var s,C,g=ee.exports={};function U(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function P(d){if(s===setTimeout)return setTimeout(d,0);if((s===U||!s)&&setTimeout)return s=setTimeout,setTimeout(d,0);try{return s(d,0)}catch{try{return s.call(null,d,0)}catch{return s.call(this,d,0)}}}(function(){try{s=typeof setTimeout=="function"?setTimeout:U}catch{s=U}try{C=typeof clearTimeout=="function"?clearTimeout:I}catch{C=I}})();var w,A=[],O=!1,S=-1;function m(){O&&w&&(O=!1,w.length?A=w.concat(A):S=-1,A.length&&_())}function _(){if(!O){var d=P(m);O=!0;for(var c=A.length;c;){for(w=A,A=[];++S<c;)w&&w[S].run();S=-1,c=A.length}w=null,O=!1,function(k){if(C===clearTimeout)return clearTimeout(k);if((C===I||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(k);try{C(k)}catch{try{return C.call(null,k)}catch{return C.call(this,k)}}}(d)}}function f(d,c){this.fun=d,this.array=c}function u(){}g.nextTick=function(d){var c=new Array(arguments.length-1);if(arguments.length>1)for(var k=1;k<arguments.length;k++)c[k-1]=arguments[k];A.push(new f(d,c)),A.length!==1||O||P(_)},f.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=u,g.addListener=u,g.once=u,g.off=u,g.removeListener=u,g.removeAllListeners=u,g.emit=u,g.prependListener=u,g.prependOnceListener=u,g.listeners=function(d){return[]},g.binding=function(d){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(d){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(Ie[107],Te([1,0,11,7]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function g(a){const D=a;return D?typeof D.read=="function":!1}e.isReadable=g;function U(a){const D=a;return D?[D.on,D.pause,D.resume,D.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=U;function I(a){const D=a;return D?U(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.isReadableBufferedStream=I;function P(a,D){return new w(a,D)}e.newWriteableStream=P;class w{constructor(D,r){this.reducer=D,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(D){if(!this.state.destroyed){if(this.state.flowing)this.emitData(D);else if(this.buffer.data.push(D),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(D){this.state.destroyed||(this.state.flowing?this.emitError(D):this.buffer.error.push(D))}end(D){this.state.destroyed||(typeof D!="undefined"&&this.write(D),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(D){this.listeners.data.slice(0).forEach(r=>r(D))}emitError(D){this.listeners.error.length===0?(0,s.onUnexpectedError)(D):this.listeners.error.slice(0).forEach(r=>r(D))}emitEnd(){this.listeners.end.slice(0).forEach(D=>D())}on(D,r){if(!this.state.destroyed)switch(D){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(D,r){if(this.state.destroyed)return;let h;switch(D){case"data":h=this.listeners.data;break;case"end":h=this.listeners.end;break;case"error":h=this.listeners.error;break}if(h){const i=h.indexOf(r);i>=0&&h.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const D=this.reducer(this.buffer.data);this.emitData(D),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(h=>h())}}flowErrors(){if(this.listeners.error.length>0){for(const D of this.buffer.error)this.emitError(D);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function A(a,D){const r=[];let h;for(;(h=a.read())!==null;)r.push(h);return D(r)}e.consumeReadable=A;function O(a,D,r){const h=[];let i;for(;(i=a.read())!==null&&h.length<r;)h.push(i);return i===null&&h.length>0?D(h):{read:()=>{if(h.length>0)return h.shift();if(typeof i!="undefined"){const o=i;return i=void 0,o}return a.read()}}}e.peekReadable=O;function S(a,D){return new Promise((r,h)=>{const i=[];m(a,{onData:o=>{D&&i.push(o)},onError:o=>{D?h(o):r(void 0)},onEnd:()=>{r(D?D(i):void 0)}})})}e.consumeStream=S;function m(a,D){let r=!1;return a.on("error",h=>{r||D.onError(h)}),a.on("end",()=>{r||D.onEnd()}),a.on("data",h=>{r||D.onData(h)}),(0,C.toDisposable)(()=>r=!0)}e.listenStream=m;function _(a,D){return new Promise((r,h)=>{const i=new C.DisposableStore,o=[],n=b=>{if(o.push(b),o.length>D)return i.dispose(),a.pause(),r({stream:a,buffer:o,ended:!1})},t=b=>h(b),l=()=>r({stream:a,buffer:o,ended:!0});i.add((0,C.toDisposable)(()=>a.removeListener("error",t))),a.on("error",t),i.add((0,C.toDisposable)(()=>a.removeListener("end",l))),a.on("end",l),i.add((0,C.toDisposable)(()=>a.removeListener("data",n))),a.on("data",n)})}e.peekStream=_;function f(a,D){const r=P(D);return r.end(a),r}e.toStream=f;function u(){const a=P(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=u;function d(a){let D=!1;return{read:()=>D?null:(D=!0,a)}}e.toReadable=d;function c(a,D,r){const h=P(r);return m(a,{onData:i=>h.write(D.data(i)),onError:i=>h.error(D.error?D.error(i):i),onEnd:()=>h.end()}),h}e.transform=c;function k(a,D,r){let h=!1;return{read:()=>{const i=D.read();return h?i:(h=!0,i!==null?r([a,i]):a)}}}e.prefixedReadable=k;function y(a,D,r){let h=!1;const i=P(r);return m(D,{onData:o=>h?i.write(o):(h=!0,i.write(r([a,o]))),onError:o=>i.error(o),onEnd:()=>{h||(h=!0,i.write(a)),i.end()}}),i}e.prefixedStream=y}),define(Ie[23],Te([1,0,107]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined";let g,U;class I{static alloc(b){return C?new I(Buffer.allocUnsafe(b)):new I(new Uint8Array(b))}static wrap(b){return C&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new I(b)}static fromString(b,v){return!(v?.dontUseNodeBuffer||!1)&&C?new I(Buffer.from(b)):(g||(g=new TextEncoder),new I(g.encode(b)))}static fromByteArray(b){const v=I.alloc(b.length);for(let E=0,x=b.length;E<x;E++)v.buffer[E]=b[E];return v}static concat(b,v){if(typeof v=="undefined"){v=0;for(let $=0,R=b.length;$<R;$++)v+=b[$].byteLength}const E=I.alloc(v);let x=0;for(let $=0,R=b.length;$<R;$++){const p=b[$];E.set(p,x),x+=p.byteLength}return E}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=I.alloc(this.byteLength);return b.set(this),b}toString(){return C?this.buffer.toString():(U||(U=new TextDecoder),U.decode(this.buffer))}slice(b,v){return new I(this.buffer.subarray(b,v))}set(b,v){if(b instanceof I)this.buffer.set(b.buffer,v);else if(b instanceof Uint8Array)this.buffer.set(b,v);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),v);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return A(this.buffer,b)}writeUInt32BE(b,v){O(this.buffer,b,v)}readUInt32LE(b){return S(this.buffer,b)}writeUInt32LE(b,v){m(this.buffer,b,v)}readUInt8(b){return _(this.buffer,b)}writeUInt8(b,v){f(this.buffer,b,v)}}e.VSBuffer=I;function P(l,b){return l[b+0]<<0>>>0|l[b+1]<<8>>>0}e.readUInt16LE=P;function w(l,b,v){l[v+0]=b&255,b=b>>>8,l[v+1]=b&255}e.writeUInt16LE=w;function A(l,b){return l[b]*2**24+l[b+1]*2**16+l[b+2]*2**8+l[b+3]}e.readUInt32BE=A;function O(l,b,v){l[v+3]=b,b=b>>>8,l[v+2]=b,b=b>>>8,l[v+1]=b,b=b>>>8,l[v]=b}e.writeUInt32BE=O;function S(l,b){return l[b+0]<<0>>>0|l[b+1]<<8>>>0|l[b+2]<<16>>>0|l[b+3]<<24>>>0}e.readUInt32LE=S;function m(l,b,v){l[v+0]=b&255,b=b>>>8,l[v+1]=b&255,b=b>>>8,l[v+2]=b&255,b=b>>>8,l[v+3]=b&255}e.writeUInt32LE=m;function _(l,b){return l[b]}e.readUInt8=_;function f(l,b,v){l[v]=b}e.writeUInt8=f;function u(l){return s.consumeReadable(l,b=>I.concat(b))}e.readableToBuffer=u;function d(l){return s.toReadable(l)}e.bufferToReadable=d;function c(l){return s.consumeStream(l,b=>I.concat(b))}e.streamToBuffer=c;async function k(l){return l.ended?I.concat(l.buffer):I.concat([...l.buffer,await c(l.stream)])}e.bufferedStreamToBuffer=k;function y(l){return s.toStream(l,b=>I.concat(b))}e.bufferToStream=y;function a(l){return s.transform(l,{data:b=>typeof b=="string"?I.fromString(b):I.wrap(b)},b=>I.concat(b))}e.streamToBufferReadableStream=a;function D(l){return s.newWriteableStream(b=>I.concat(b),l)}e.newWriteableBufferStream=D;function r(l,b){return s.prefixedReadable(l,b,v=>I.concat(v))}e.prefixedBufferReadable=r;function h(l,b){return s.prefixedStream(l,b,v=>I.concat(v))}e.prefixedBufferStream=h;function i(l){let b=0,v=0,E=0;const x=new Uint8Array(Math.floor(l.length/4*3)),$=p=>{switch(v){case 3:x[E++]=b|p,v=0;break;case 2:x[E++]=b|p>>>2,b=p<<6,v=3;break;case 1:x[E++]=b|p>>>4,b=p<<4,v=2;break;default:b=p<<2,v=1}};for(let p=0;p<l.length;p++){const F=l.charCodeAt(p);if(F>=65&&F<=90)$(F-65);else if(F>=97&&F<=122)$(F-97+26);else if(F>=48&&F<=57)$(F-48+52);else if(F===43||F===45)$(62);else if(F===47||F===95)$(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${l[p]}`)}}const R=E;for(;v>0;)$(0);return I.wrap(x).slice(0,R)}e.decodeBase64=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:l},b=!0,v=!1){const E=v?n:o;let x="";const $=l.byteLength%3;let R=0;for(;R<l.byteLength-$;R+=3){const p=l[R+0],F=l[R+1],M=l[R+2];x+=E[p>>>2],x+=E[(p<<4|F>>>4)&63],x+=E[(F<<2|M>>>6)&63],x+=E[M&63]}if($===1){const p=l[R+0];x+=E[p>>>2],x+=E[p<<4&63],b&&(x+="==")}else if($===2){const p=l[R+0],F=l[R+1];x+=E[p>>>2],x+=E[(p<<4|F>>>4)&63],x+=E[F<<2&63],b&&(x+="=")}return x}e.encodeBase64=t});var Re=this&&this.__classPrivateFieldGet||function(ee,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ee):C?C.value:e.get(ee)},Ye=this&&this.__classPrivateFieldSet||function(ee,e,s,C,g){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?g.call(ee,s):g?g.value=s:e.set(ee,s),s};define(Ie[24],Te([1,0,15,10]),function(ee,e,s,C){"use strict";var g,U,I,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function w(n,t,l){let b=n.get(t);return b===void 0&&(b=l,n.set(t,b)),b}e.getOrSet=w;function A(n){const t=[];return n.forEach((l,b)=>{t.push(`${b} => ${l}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=A;function O(n){const t=[];return n.forEach(l=>{t.push(l)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=O;class S{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const l=t.charCodeAt(0),b=this._value.charCodeAt(this._pos);return l-b}value(){return this._value[this._pos]}}e.StringIterator=S;class m{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,C.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=m;class _{constructor(t=!0,l=!0){this._splitOnBackslash=t,this._caseSensitive=l}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let l=t.length-1;l>=0;l--,this._valueLen--){const b=this._value.charCodeAt(l);if(!(b===47||this._splitOnBackslash&&b===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,C.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var f;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(f||(f={}));class u{constructor(t,l){this._ignorePathCasing=t,this._ignoreQueryAndFragment=l,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(t)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,C.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,C.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,C.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,C.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var c;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(c||(c={}));class k{static forUris(t=()=>!1,l=()=>!1){return new k(new u(t,l))}static forPaths(t=!1){return new k(new _(void 0,!t))}static forStrings(){return new k(new S)}static forConfigKeys(){return new k(new m)}constructor(t){this._iter=t}clear(){this._root=void 0}fill(t,l){if(l){const b=l.slice(0);(0,s.shuffle)(b);for(let v of b)this.set(v,t)}else{const b=t.slice(0);(0,s.shuffle)(b);for(let v of b)this.set(v[0],v[1])}}set(t,l){const b=this._iter.reset(t);let v;this._root||(this._root=new d,this._root.segment=b.value());const E=[];for(v=this._root;;){const $=b.cmp(v.segment);if($>0)v.left||(v.left=new d,v.left.segment=b.value()),E.push([-1,v]),v=v.left;else if($<0)v.right||(v.right=new d,v.right.segment=b.value()),E.push([1,v]),v=v.right;else if(b.hasNext())b.next(),v.mid||(v.mid=new d,v.mid.segment=b.value()),E.push([0,v]),v=v.mid;else break}const x=v.value;v.value=l,v.key=t;for(let $=E.length-1;$>=0;$--){const R=E[$][1];R.updateHeight();const p=R.balanceFactor();if(p<-1||p>1){const F=E[$][0],M=E[$+1][0];if(F===1&&M===1)E[$][1]=R.rotateLeft();else if(F===-1&&M===-1)E[$][1]=R.rotateRight();else if(F===1&&M===-1)R.right=E[$+1][1]=E[$+1][1].rotateRight(),E[$][1]=R.rotateLeft();else if(F===-1&&M===1)R.left=E[$+1][1]=E[$+1][1].rotateLeft(),E[$][1]=R.rotateRight();else throw new Error;if($>0)switch(E[$-1][0]){case-1:E[$-1][1].left=E[$][1];break;case 1:E[$-1][1].right=E[$][1];break;case 0:E[$-1][1].mid=E[$][1];break}else this._root=E[0][1]}}return x}get(t){return this._getNode(t)?.value}_getNode(t){const l=this._iter.reset(t);let b=this._root;for(;b;){const v=l.cmp(b.segment);if(v>0)b=b.left;else if(v<0)b=b.right;else if(l.hasNext())l.next(),b=b.mid;else break}return b}has(t){const l=this._getNode(t);return!(l?.value===void 0&&l?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,l){const b=this._iter.reset(t),v=[];let E=this._root;for(;E;){const x=b.cmp(E.segment);if(x>0)v.push([-1,E]),E=E.left;else if(x<0)v.push([1,E]),E=E.right;else if(b.hasNext())b.next(),v.push([0,E]),E=E.mid;else break}if(!!E){if(l?(E.left=void 0,E.mid=void 0,E.right=void 0,E.height=1):(E.key=void 0,E.value=void 0),!E.mid&&!E.value)if(E.left&&E.right){const x=this._min(E.right),{key:$,value:R,segment:p}=x;this._delete(x.key,!1),E.key=$,E.value=R,E.segment=p}else{const x=E.left??E.right;if(v.length>0){const[$,R]=v[v.length-1];switch($){case-1:R.left=x;break;case 0:R.mid=x;break;case 1:R.right=x;break}}else this._root=x}for(let x=v.length-1;x>=0;x--){const $=v[x][1];$.updateHeight();const R=$.balanceFactor();if(R>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),v[x][1]=$.rotateLeft()):R<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),v[x][1]=$.rotateRight()),x>0)switch(v[x-1][0]){case-1:v[x-1][1].left=v[x][1];break;case 1:v[x-1][1].right=v[x][1];break;case 0:v[x-1][1].mid=v[x][1];break}else this._root=v[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const l=this._iter.reset(t);let b=this._root,v;for(;b;){const E=l.cmp(b.segment);if(E>0)b=b.left;else if(E<0)b=b.right;else if(l.hasNext())l.next(),v=b.value||v,b=b.mid;else break}return b&&b.value||v}findSuperstr(t){const l=this._iter.reset(t);let b=this._root;for(;b;){const v=l.cmp(b.segment);if(v>0)b=b.left;else if(v<0)b=b.right;else if(l.hasNext())l.next(),b=b.mid;else return b.mid?this._entries(b.mid):void 0}}forEach(t){for(const[l,b]of this)t(b,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=l=>{if(!l)return!0;const b=l.balanceFactor();return b<-1||b>1?!1:t(l.left)&&t(l.right)};return t(this._root)}}e.TernarySearchTree=k;class y{constructor(t,l){this.uri=t,this.value=l}}class a{constructor(t,l){this[g]="ResourceMap",t instanceof a?(this.map=new Map(t.map),this.toKey=l??a.defaultToKey):(this.map=new Map,this.toKey=t??a.defaultToKey)}set(t,l){return this.map.set(this.toKey(t),new y(t,l)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,l){typeof l!="undefined"&&(t=t.bind(l));for(let[b,v]of this.map)t(v.value,v.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(g=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=a,a.defaultToKey=n=>n.toString();class D{constructor(t,l){this[U]="ResourceSet",!t||typeof t=="function"?this._map=new a(t):(this._map=new a(l),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,l){this._map.forEach((b,v)=>t.call(l,v,v,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=D;var r;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(r||(e.Touch=r={}));class h{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,l=0){const b=this._map.get(t);if(!!b)return l!==0&&this.touch(b,l),b.value}set(t,l,b=0){let v=this._map.get(t);if(v)v.value=l,b!==0&&this.touch(v,b);else{switch(v={key:t,value:l,next:void 0,previous:void 0},b){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(t,v),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const l=this._map.get(t);if(!!l)return this._map.delete(t),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,l){const b=this._state;let v=this._head;for(;v;){if(l?t.bind(l)(v.value,v.key,this):t(v.value,v.key,this),this._state!==b)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const t=this,l=this._state;let b=this._head;const v={[Symbol.iterator](){return v},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(b){const E={value:b.key,done:!1};return b=b.next,E}else return{value:void 0,done:!0}}};return v}values(){const t=this,l=this._state;let b=this._head;const v={[Symbol.iterator](){return v},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(b){const E={value:b.value,done:!1};return b=b.next,E}else return{value:void 0,done:!0}}};return v}entries(){const t=this,l=this._state;let b=this._head;const v={[Symbol.iterator](){return v},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(b){const E={value:[b.key,b.value],done:!1};return b=b.next,E}else return{value:void 0,done:!0}}};return v}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this._head,b=this.size;for(;l&&b>t;)this._map.delete(l.key),l=l.next,b--;this._head=l,this._size=b,l&&(l.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const l=t.next,b=t.previous;if(!l||!b)throw new Error("Invalid list");l.previous=b,b.next=l}t.next=void 0,t.previous=void 0,this._state++}touch(t,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(t===this._head)return;const b=t.next,v=t.previous;t===this._tail?(v.next=void 0,this._tail=v):(b.previous=v,v.next=b),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(l===2){if(t===this._tail)return;const b=t.next,v=t.previous;t===this._head?(b.previous=void 0,this._head=b):(b.previous=v,v.next=b),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((l,b)=>{t.push([b,l])}),t}fromJSON(t){this.clear();for(const[l,b]of t)this.set(l,b)}}e.LinkedMap=h;class i extends h{constructor(t,l=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,l=2){return super.get(t,l)}peek(t){return super.get(t,0)}set(t,l){return super.set(t,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class o{get size(){return Re(this,P,"f").size}constructor(t){P.set(this,void 0),Ye(this,P,t,"f")}forEach(t,l){Re(this,P,"f").forEach(t,l)}get(t){return Re(this,P,"f").get(t)}has(t){return Re(this,P,"f").has(t)}entries(){return Re(this,P,"f").entries()}keys(){return Re(this,P,"f").keys()}values(){return Re(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Re(this,P,"f").entries()}}e.ReadonlyMapView=o}),define(Ie[108],Te([1,0,24,10]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function g(...X){return function(G,T){for(let B=0,H=X.length;B<H;B++){const V=X[B](G,T);if(V)return V}return null}}e.or=g,e.matchesStrictPrefix=U.bind(void 0,!1),e.matchesPrefix=U.bind(void 0,!0);function U(X,G,T){if(!T||T.length<G.length)return null;let B;return X?B=C.startsWithIgnoreCase(T,G):B=T.indexOf(G)===0,B?G.length>0?[{start:0,end:G.length}]:[]:null}function I(X,G){const T=G.toLowerCase().indexOf(X.toLowerCase());return T===-1?null:[{start:T,end:T+X.length}]}e.matchesContiguousSubString=I;function P(X,G){return w(X.toLowerCase(),G.toLowerCase(),0,0)}e.matchesSubString=P;function w(X,G,T,B){if(T===X.length)return[];if(B===G.length)return null;if(X[T]===G[B]){let H=null;return(H=w(X,G,T+1,B+1))?c({start:B,end:B+1},H):null}return w(X,G,T,B+1)}function A(X){return 97<=X&&X<=122}function O(X){return 65<=X&&X<=90}e.isUpper=O;function S(X){return 48<=X&&X<=57}function m(X){return X===32||X===9||X===10||X===13}const _=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(X=>_.add(X.charCodeAt(0)));function f(X){return m(X)||_.has(X)}function u(X,G){return X===G||f(X)&&f(G)}function d(X){return A(X)||O(X)||S(X)}function c(X,G){return G.length===0?G=[X]:X.end===G[0].start?G[0].start=X.start:G.unshift(X),G}function k(X,G){for(let T=G;T<X.length;T++){const B=X.charCodeAt(T);if(O(B)||S(B)||T>0&&!d(X.charCodeAt(T-1)))return T}return X.length}function y(X,G,T,B){if(T===X.length)return[];if(B===G.length)return null;if(X[T]!==G[B].toLowerCase())return null;{let H=null,V=B+1;for(H=y(X,G,T+1,B+1);!H&&(V=k(G,V))<G.length;)H=y(X,G,T+1,V),V++;return H===null?null:c({start:B,end:B+1},H)}}function a(X){let G=0,T=0,B=0,H=0,V=0;for(let pe=0;pe<X.length;pe++)V=X.charCodeAt(pe),O(V)&&G++,A(V)&&T++,d(V)&&B++,S(V)&&H++;const ne=G/X.length,ue=T/X.length,Q=B/X.length,ge=H/X.length;return{upperPercent:ne,lowerPercent:ue,alphaPercent:Q,numericPercent:ge}}function D(X){const{upperPercent:G,lowerPercent:T}=X;return T===0&&G>.6}function r(X){const{upperPercent:G,lowerPercent:T,alphaPercent:B,numericPercent:H}=X;return T>.2&&G<.8&&B>.6&&H<.2}function h(X){let G=0,T=0,B=0,H=0;for(let V=0;V<X.length;V++)B=X.charCodeAt(V),O(B)&&G++,A(B)&&T++,m(B)&&H++;return(G===0||T===0)&&H===0?X.length<=30:G<=5}function i(X,G){if(!G||(G=G.trim(),G.length===0)||!h(X)||G.length>60)return null;const T=a(G);if(!r(T)){if(!D(T))return null;G=G.toLowerCase()}let B=null,H=0;for(X=X.toLowerCase();H<G.length&&(B=y(X,G,0,H))===null;)H=k(G,H+1);return B}e.matchesCamelCase=i;function o(X,G,T=!1){if(!G||G.length===0)return null;let B=null,H=0;for(X=X.toLowerCase(),G=G.toLowerCase();H<G.length&&(B=n(X,G,0,H,T))===null;)H=t(G,H+1);return B}e.matchesWords=o;function n(X,G,T,B,H){if(T===X.length)return[];if(B===G.length)return null;if(u(X.charCodeAt(T),G.charCodeAt(B))){let V=null,ne=B+1;if(V=n(X,G,T+1,B+1,H),!H)for(;!V&&(ne=t(G,ne))<G.length;)V=n(X,G,T+1,ne,H),ne++;return V===null?null:c({start:B,end:B+1},V)}else return null}function t(X,G){for(let T=G;T<X.length;T++)if(f(X.charCodeAt(T))||T>0&&f(X.charCodeAt(T-1)))return T;return X.length}const l=g(e.matchesPrefix,i,I),b=g(e.matchesPrefix,i,P),v=new s.LRUCache(1e4);function E(X,G,T=!1){if(typeof X!="string"||typeof G!="string")return null;let B=v.get(X);B||(B=new RegExp(C.convertSimple2RegExpPattern(X),"i"),v.set(X,B));const H=B.exec(G);return H?[{start:H.index,end:H.index+H[0].length}]:T?b(X,G):l(X,G)}e.matchesFuzzy=E;function x(X,G){const T=xe(X,X.toLowerCase(),0,G,G.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return T?R(T):null}e.matchesFuzzy2=x;function $(X,G,T,B,H,V){const ne=Math.min(13,X.length);for(;T<ne;T++){const ue=xe(X,G,T,B,H,V,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(ue)return ue}return[0,V]}e.anyScore=$;function R(X){if(typeof X=="undefined")return[];const G=[],T=X[1];for(let B=X.length-1;B>1;B--){const H=X[B]+T,V=G[G.length-1];V&&V.end===H?V.end=H+1:G.push({start:H,end:H+1})}return G}e.createMatches=R;const p=128;function F(){const X=[],G=[];for(let T=0;T<=p;T++)G[T]=0;for(let T=0;T<=p;T++)X.push(G.slice(0));return X}function M(X){const G=[];for(let T=0;T<=X;T++)G[T]=0;return G}const z=M(2*p),Z=M(2*p),K=F(),N=F(),se=F(),le=!1;function oe(X,G,T,B,H){function V(ue,Q,ge=" "){for(;ue.length<Q;)ue=ge+ue;return ue}let ne=` |   |${B.split("").map(ue=>V(ue,3)).join("|")}
`;for(let ue=0;ue<=T;ue++)ue===0?ne+=" |":ne+=`${G[ue-1]}|`,ne+=X[ue].slice(0,H+1).map(Q=>V(Q.toString(),3)).join("|")+`
`;return ne}function fe(X,G,T,B){X=X.substr(G),T=T.substr(B),console.log(oe(N,X,X.length,T,T.length)),console.log(oe(se,X,X.length,T,T.length)),console.log(oe(K,X,X.length,T,T.length))}function be(X,G){if(G<0||G>=X.length)return!1;const T=X.codePointAt(G);switch(T){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(T)}}function ce(X,G){if(G<0||G>=X.length)return!1;switch(X.charCodeAt(G)){case 32:case 9:return!0;default:return!1}}function ve(X,G,T){return G[X]!==T[X]}function J(X,G,T,B,H,V,ne=!1){for(;G<T&&H<V;)X[G]===B[H]&&(ne&&(z[G]=H),G+=1),H+=1;return G===T}e.isPatternInWord=J;var Ee;(function(X){X[X.Diag=1]="Diag",X[X.Left=2]="Left",X[X.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var _e;(function(X){X.Default=[-100,0];function G(T){return!T||T.length===2&&T[0]===-100&&T[1]===0}X.isDefault=G})(_e||(e.FuzzyScore=_e={}));class Fe{constructor(G,T){this.firstMatchCanBeWeak=G,this.boostFullMatch=T}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function xe(X,G,T,B,H,V,ne=Fe.default){const ue=X.length>p?p:X.length,Q=B.length>p?p:B.length;if(T>=ue||V>=Q||ue-T>Q-V||!J(G,T,ue,H,V,Q,!0))return;Xe(ue,Q,T,V,G,H);let ge=1,pe=1,Ne=T,Be=V;const Ae=[!1];for(ge=1,Ne=T;Ne<ue;ge++,Ne++){const Le=z[Ne],ze=Z[Ne],Ge=Ne+1<ue?Z[Ne+1]:Q;for(pe=Le-V+1,Be=Le;Be<Ge;pe++,Be++){let Ze=Number.MIN_SAFE_INTEGER,ot=!1;Be<=ze&&(Ze=ke(X,G,Ne,T,B,H,Be,Q,V,K[ge-1][pe-1]===0,Ae));let Qe=0;Ze!==Number.MAX_SAFE_INTEGER&&(ot=!0,Qe=Ze+N[ge-1][pe-1]);const et=Be>Le,qe=et?N[ge][pe-1]+(K[ge][pe-1]>0?-5:0):0,st=Be>Le+1&&K[ge][pe-1]>0,it=st?N[ge][pe-2]+(K[ge][pe-2]>0?-5:0):0;if(st&&(!et||it>=qe)&&(!ot||it>=Qe))N[ge][pe]=it,se[ge][pe]=3,K[ge][pe]=0;else if(et&&(!ot||qe>=Qe))N[ge][pe]=qe,se[ge][pe]=2,K[ge][pe]=0;else if(ot)N[ge][pe]=Qe,se[ge][pe]=1,K[ge][pe]=K[ge-1][pe-1]+1;else throw new Error("not possible")}}if(le&&fe(X,T,B,V),!Ae[0]&&!ne.firstMatchCanBeWeak)return;ge--,pe--;const Ke=[N[ge][pe],V];let q=0,Y=0;for(;ge>=1;){let Le=pe;do{const ze=se[ge][Le];if(ze===3)Le=Le-2;else if(ze===2)Le=Le-1;else break}while(Le>=1);q>1&&G[T+ge-1]===H[V+pe-1]&&!ve(Le+V-1,B,H)&&q+1>K[ge][Le]&&(Le=pe),Le===pe?q++:q=1,Y||(Y=Le),ge--,pe=Le-1,Ke.push(pe)}Q===ue&&ne.boostFullMatch&&(Ke[0]+=2);const me=Y-ue;return Ke[0]-=me,Ke}e.fuzzyScore=xe;function Xe(X,G,T,B,H,V){let ne=X-1,ue=G-1;for(;ne>=T&&ue>=B;)H[ne]===V[ue]&&(Z[ne]=ue,ne--),ue--}function ke(X,G,T,B,H,V,ne,ue,Q,ge,pe){if(G[T]!==V[ne])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return ne===T-B?Ne=X[T]===H[ne]?7:5:ve(ne,H,V)&&(ne===0||!ve(ne-1,H,V))?(Ne=X[T]===H[ne]?7:5,Be=!0):be(V,ne)&&(ne===0||!be(V,ne-1))?Ne=5:(be(V,ne-1)||ce(V,ne-1))&&(Ne=5,Be=!0),Ne>1&&T===B&&(pe[0]=!0),Be||(Be=ve(ne,H,V)||be(V,ne-1)||ce(V,ne-1)),T===B?ne>Q&&(Ne-=Be?3:5):ge?Ne+=Be?2:0:Ne+=Be?0:1,ne+1===ue&&(Ne-=Be?3:5),Ne}function Se(X,G,T,B,H,V,ne){return re(X,G,T,B,H,V,!0,ne)}e.fuzzyScoreGracefulAggressive=Se;function Pe(X,G,T,B,H,V,ne){return re(X,G,T,B,H,V,!1,ne)}e.fuzzyScoreGraceful=Pe;function re(X,G,T,B,H,V,ne,ue){let Q=xe(X,G,T,B,H,V,ue);if(Q&&!ne)return Q;if(X.length>=3){const ge=Math.min(7,X.length-1);for(let pe=T+1;pe<ge;pe++){const Ne=ae(X,pe);if(Ne){const Be=xe(Ne,Ne.toLowerCase(),T,B,H,V,ue);Be&&(Be[0]-=3,(!Q||Be[0]>Q[0])&&(Q=Be))}}}return Q}function ae(X,G){if(G+1>=X.length)return;const T=X[G],B=X[G+1];if(T!==B)return X.slice(0,G)+B+T+X.slice(G+2)}}),define(Ie[109],Te([1,0,110,108,10]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const U=new RegExp(`\\$\\(${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(s.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${U.source}`,"g");function w(d){return d.replace(P,(c,k)=>k?c:`\\${c}`)}e.escapeIcons=w;const A=new RegExp(`\\\\${U.source}`,"g");function O(d){return d.replace(A,c=>`\\${c}`)}e.markdownEscapeEscapedIcons=O;const S=new RegExp(`(\\s)?(\\\\)?${U.source}(\\s)?`,"g");function m(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(S,(c,k,y,a)=>y?c:k||a||"")}e.stripIcons=m;function _(d){const c=d.indexOf(e.iconStartMarker);return c===-1?{text:d}:f(d,c)}e.parseLabelWithIcons=_;function f(d,c){const k=[];let y="";function a(l){if(l){y+=l;for(const b of l)k.push(h)}}let D=-1,r="",h=0,i,o,n=c;const t=d.length;for(a(d.substr(0,c));n<t;)i=d[n],o=d[n+1],i===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(D=n,a(r),r=e.iconStartMarker,n++):i===")"&&D!==-1?(h+=n-D+1,D=-1,r=""):D!==-1?I.test(i)?r+=i:(a(r),D=-1,r=""):a(i),n++;return a(r),{text:y,iconOffsets:k}}function u(d,c,k=!1){const{text:y,iconOffsets:a}=c;if(!a||a.length===0)return(0,C.matchesFuzzy)(d,y,k);const D=(0,g.ltrim)(y," "),r=y.length-D.length,h=(0,C.matchesFuzzy)(d,D,k);if(h)for(const i of h){const o=a[i.start+r]+r;i.start+=o,i.end+=o}return h}e.matchesFuzzyIconAware=u}),define(Ie[29],Te([1,0,10]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(C||(C={})),function(g){const U="error",I="warning",P="warn",w="info",A="ignore";function O(m){return m?s.equalsIgnoreCase(U,m)?g.Error:s.equalsIgnoreCase(I,m)||s.equalsIgnoreCase(P,m)?g.Warning:s.equalsIgnoreCase(w,m)?g.Info:g.Ignore:g.Ignore}g.fromValue=O;function S(m){switch(m){case g.Error:return U;case g.Warning:return I;case g.Info:return w;default:return A}}g.toString=S}(C||(C={})),e.default=C}),define(Ie[37],Te([1,0,19,22,10,9]),function(ee,e,s,C,g,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(n){return n===47||n===92}e.isPathSeparator=I;function P(n){return n.replace(/[\\/]/g,s.posix.sep)}e.toSlashes=P;function w(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=w;function A(n,t=s.posix.sep){if(!n)return"";const l=n.length,b=n.charCodeAt(0);if(I(b)){if(I(n.charCodeAt(1))&&!I(n.charCodeAt(2))){let E=3;const x=E;for(;E<l&&!I(n.charCodeAt(E));E++);if(x!==E&&!I(n.charCodeAt(E+1))){for(E+=1;E<l;E++)if(I(n.charCodeAt(E)))return n.slice(0,E+1).replace(/[\\/]/g,t)}}return t}else if(c(b)&&n.charCodeAt(1)===58)return I(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let v=n.indexOf("://");if(v!==-1){for(v+=3;v<l;v++)if(I(n.charCodeAt(v)))return n.slice(0,v+1)}return""}e.getRoot=A;function O(n){if(!C.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let l=2;const b=l;for(;l<n.length&&(t=n.charCodeAt(l),t!==92);l++);return!(b===l||(t=n.charCodeAt(l+1),isNaN(t)||t===92))}e.isUNC=O;const S=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,_=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(n,t=C.isWindows){const l=t?S:m;return!(!n||n.length===0||/^\s+$/.test(n)||(l.lastIndex=0,l.test(n))||t&&_.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=f;function u(n,t,l){const b=n===t;return!l||b?b:!n||!t?!1:(0,g.equalsIgnoreCase)(n,t)}e.isEqual=u;function d(n,t,l,b=s.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(l){if(!(0,g.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let E=t.length;return t.charAt(t.length-1)===b&&E--,n.charAt(E)===b}return t.charAt(t.length-1)!==b&&(t+=b),n.indexOf(t)===0}e.isEqualOrParent=d;function c(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=c;function k(n,t){return C.isWindows&&n.endsWith(":")&&(n+=s.sep),(0,s.isAbsolute)(n)||(n=(0,s.join)(t,n)),n=(0,s.normalize)(n),C.isWindows?(n=(0,g.rtrim)(n,s.sep),n.endsWith(":")&&(n+=s.sep)):(n=(0,g.rtrim)(n,s.sep),n||(n=s.sep)),n}e.sanitizeFilePath=k;function y(n){const t=(0,s.normalize)(n);return C.isWindows?n.length>3?!1:a(t)&&(n.length===2||t.charCodeAt(2)===92):t===s.posix.sep}e.isRootOrDriveLetter=y;function a(n,t=C.isWindows){return t?c(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function D(n){return a(n)?n[0]:void 0}e.getDriveLetter=D;function r(n,t,l){return t.length>n.length?-1:n===t?0:(l&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=r;function h(n){const t=n.split(":");let l,b,v;for(const E of t){const x=Number(E);(0,U.isNumber)(x)?b===void 0?b=x:v===void 0&&(v=x):l=l?[l,E].join(":"):E}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:b!==void 0?b:void 0,column:v!==void 0?v:b!==void 0?1:void 0}}e.parseLineAndColumnAware=h;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(n,t,l=8){let b="";for(let E=0;E<l;E++)b+=i.charAt(Math.floor(Math.random()*i.length));let v;return t?v=`${t}-${b}`:v=b,n?(0,s.join)(n,v):v}e.randomPath=o}),define(Ie[57],Te([1,0,23,10,2]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function U(A){return JSON.stringify(A,P)}e.stringify=U;function I(A){let O=JSON.parse(A);return O=w(O),O}e.parse=I;function P(A,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,C.regExpFlags)(O)}:O}function w(A,O=0){if(!A||O>200)return A;if(typeof A=="object"){switch(A.$mid){case 1:return g.URI.revive(A);case 2:return new RegExp(A.source,A.flags);case 14:return new Date(A.source)}if(A instanceof s.VSBuffer||A instanceof Uint8Array)return A;if(Array.isArray(A))for(let S=0;S<A.length;++S)A[S]=w(A[S],O+1);else for(const S in A)Object.hasOwnProperty.call(A,S)&&(A[S]=w(A[S],O+1))}return A}e.revive=w}),define(Ie[12],Te([1,0,22,2]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var g;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(g||(e.Schemas=g={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class U{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${g.vscodeRemoteResource}`}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}setServerRootPath(w){this._remoteResourcesPath=`${w}/${g.vscodeRemoteResource}`}set(w,A,O){this._hosts[w]=A,this._ports[w]=O}setConnectionToken(w,A){this._connectionTokens[w]=A}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(w){if(this._delegate)return this._delegate(w);const A=w.authority;let O=this._hosts[A];O&&O.indexOf(":")!==-1&&(O=`[${O}]`);const S=this._ports[A],m=this._connectionTokens[A];let _=`path=${encodeURIComponent(w.path)}`;return typeof m=="string"&&(_+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),C.URI.from({scheme:s.isWeb?this._preferredWebSchema:g.vscodeRemoteResource,authority:`${O}:${S}`,path:this._remoteResourcesPath,query:_})}}e.RemoteAuthorities=new U;class I{asBrowserUri(w,A){const O=this.toUri(w,A);return O.scheme===g.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===g.file&&(s.isNative||s.isWebWorker&&s.globals.origin===`${g.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?O.with({scheme:g.vscodeFileResource,authority:O.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):O}asFileUri(w,A){const O=this.toUri(w,A);return O.scheme===g.vscodeFileResource?O.with({scheme:g.file,authority:O.authority!==I.FALLBACK_AUTHORITY?O.authority:null,query:null,fragment:null}):O}toUri(w,A){return C.URI.isUri(w)?w:C.URI.parse(A.toUrl(w))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I}),define(Ie[21],Te([1,0,37,12,19,22,10,2]),function(ee,e,s,C,g,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(_){return(0,P.uriToFsPath)(_,!0)}e.originalFSPath=w;class A{constructor(f){this._ignorePathCasing=f}compare(f,u,d=!1){return f===u?0:(0,I.compare)(this.getComparisonKey(f,d),this.getComparisonKey(u,d))}isEqual(f,u,d=!1){return f===u?!0:!f||!u?!1:this.getComparisonKey(f,d)===this.getComparisonKey(u,d)}getComparisonKey(f,u=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,u,d=!1){if(f.scheme===u.scheme){if(f.scheme===C.Schemas.file)return s.isEqualOrParent(w(f),w(u),this._ignorePathCasing(f))&&f.query===u.query&&(d||f.fragment===u.fragment);if((0,e.isEqualAuthority)(f.authority,u.authority))return s.isEqualOrParent(f.path,u.path,this._ignorePathCasing(f),"/")&&f.query===u.query&&(d||f.fragment===u.fragment)}return!1}joinPath(f,...u){return P.URI.joinPath(f,...u)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return g.posix.basename(f.path)}extname(f){return g.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let u;return f.scheme===C.Schemas.file?u=P.URI.file(g.dirname(w(f))).path:(u=g.posix.dirname(f.path),f.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),u="/")),f.with({path:u})}normalizePath(f){if(!f.path.length)return f;let u;return f.scheme===C.Schemas.file?u=P.URI.file(g.normalize(w(f))).path:u=g.posix.normalize(f.path),f.with({path:u})}relativePath(f,u){if(f.scheme!==u.scheme||!(0,e.isEqualAuthority)(f.authority,u.authority))return;if(f.scheme===C.Schemas.file){const k=g.relative(w(f),w(u));return U.isWindows?s.toSlashes(k):k}let d=f.path||"/",c=u.path||"/";if(this._ignorePathCasing(f)){let k=0;for(const y=Math.min(d.length,c.length);k<y&&!(d.charCodeAt(k)!==c.charCodeAt(k)&&d.charAt(k).toLowerCase()!==c.charAt(k).toLowerCase());k++);d=c.substr(0,k)+d.substr(k)}return g.posix.relative(d,c)}resolvePath(f,u){if(f.scheme===C.Schemas.file){const d=P.URI.file(g.resolve(w(f),u));return f.with({authority:d.authority,path:d.path})}return u=s.toPosixPath(u),f.with({path:g.posix.resolve(f.path,u)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,u){return f===u||f!==void 0&&u!==void 0&&(0,I.equalsIgnoreCase)(f,u)}hasTrailingPathSeparator(f,u=g.sep){if(f.scheme===C.Schemas.file){const d=w(f);return d.length>s.getRoot(d).length&&d[d.length-1]===u}else{const d=f.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,u=g.sep){return(0,e.hasTrailingPathSeparator)(f,u)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,u=g.sep){let d=!1;if(f.scheme===C.Schemas.file){const c=w(f);d=c!==void 0&&c.length===s.getRoot(c).length&&c[c.length-1]===u}else{u="/";const c=f.path;d=c.length===1&&c.charCodeAt(c.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(f,u)?f.with({path:f.path+"/"}):f}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(_=>_.scheme===C.Schemas.file?!U.isLinux:!0),e.extUriIgnorePathCase=new A(_=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(_,f){const u=[];for(let d=0;d<_.length;d++){const c=f(_[d]);_.some((k,y)=>y===d?!1:(0,e.isEqualOrParent)(c,f(k)))||u.push(_[d])}return u}e.distinctParents=O;var S;(function(_){_.META_DATA_LABEL="label",_.META_DATA_DESCRIPTION="description",_.META_DATA_SIZE="size",_.META_DATA_MIME="mime";function f(u){const d=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(y=>{const[a,D]=y.split(":");a&&D&&d.set(a,D)});const k=u.path.substring(0,u.path.indexOf(";"));return k&&d.set(_.META_DATA_MIME,k),d}_.parseMetaData=f})(S||(e.DataUri=S={}));function m(_,f,u){if(f){let d=_.path;return d&&d[0]!==g.posix.sep&&(d=g.posix.sep+d),_.with({scheme:u,authority:f,path:d})}return _.with({scheme:u})}e.toLocalResource=m}),define(Ie[13],Te([1,0,20,11,5,7,21,22]),function(ee,e,s,C,g,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(ve){return!!ve&&typeof ve.then=="function"}e.isThenable=w;function A(ve){const J=new s.CancellationTokenSource,Ee=ve(J.token),_e=new Promise((Fe,xe)=>{const Xe=J.token.onCancellationRequested(()=>{Xe.dispose(),J.dispose(),xe(new C.CancellationError)});Promise.resolve(Ee).then(ke=>{Xe.dispose(),J.dispose(),Fe(ke)},ke=>{Xe.dispose(),J.dispose(),xe(ke)})});return new class{cancel(){J.cancel()}then(Fe,xe){return _e.then(Fe,xe)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return _e.finally(Fe)}}}e.createCancelablePromise=A;function O(ve,J,Ee){return new Promise((_e,Fe)=>{const xe=J.onCancellationRequested(()=>{xe.dispose(),_e(Ee)});ve.then(_e,Fe).finally(()=>xe.dispose())})}e.raceCancellation=O;function S(ve,J){return new Promise((Ee,_e)=>{const Fe=J.onCancellationRequested(()=>{Fe.dispose(),_e(new C.CancellationError)});ve.then(Ee,_e).finally(()=>Fe.dispose())})}e.raceCancellationError=S;async function m(ve){let J=-1;const Ee=ve.map((Fe,xe)=>Fe.then(Xe=>(J=xe,Xe))),_e=await Promise.race(Ee);return ve.forEach((Fe,xe)=>{xe!==J&&Fe.cancel()}),_e}e.raceCancellablePromises=m;function _(ve,J,Ee){let _e;const Fe=setTimeout(()=>{_e?.(void 0),Ee?.()},J);return Promise.race([ve.finally(()=>clearTimeout(Fe)),new Promise(xe=>_e=xe)])}e.raceTimeout=_;function f(ve){return new Promise((J,Ee)=>{const _e=ve();w(_e)?_e.then(J,Ee):J(_e)})}e.asPromise=f;class u{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(J){if(this.activePromise){if(this.queuedPromiseFactory=J,!this.queuedPromise){const Ee=()=>{this.queuedPromise=null;const _e=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_e};this.queuedPromise=new Promise(_e=>{this.activePromise.then(Ee,Ee).then(_e)})}return new Promise((Ee,_e)=>{this.queuedPromise.then(Ee,_e)})}return this.activePromise=J(),new Promise((Ee,_e)=>{this.activePromise.then(Fe=>{this.activePromise=null,Ee(Fe)},Fe=>{this.activePromise=null,_e(Fe)})})}}e.Throttler=u;class d{constructor(){this.current=Promise.resolve(null)}queue(J){return this.current=this.current.then(()=>J(),()=>J())}}e.Sequencer=d;class c{constructor(){this.promiseMap=new Map}queue(J,Ee){const Fe=(this.promiseMap.get(J)??Promise.resolve()).catch(()=>{}).then(Ee).finally(()=>{this.promiseMap.get(J)===Fe&&this.promiseMap.delete(J)});return this.promiseMap.set(J,Fe),Fe}}e.SequencerByKey=c;const k=(ve,J)=>{let Ee=!0;const _e=setTimeout(()=>{Ee=!1,J()},ve);return{isTriggered:()=>Ee,dispose:()=>{clearTimeout(_e),Ee=!1}}},y=ve=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ve())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class a{constructor(J){this.defaultDelay=J,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(J,Ee=this.defaultDelay){this.task=J,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,xe)=>{this.doResolve=Fe,this.doReject=xe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const _e=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Ee===e.MicrotaskDelay?y(_e):k(Ee,_e),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new C.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=a;class D{constructor(J){this.delayer=new a(J),this.throttler=new u}trigger(J,Ee){return this.delayer.trigger(()=>this.throttler.queue(J),Ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class r{constructor(){this._isOpen=!1,this._promise=new Promise((J,Ee)=>{this._completePromise=J})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class h extends r{constructor(J){super();this._timeout=setTimeout(()=>this.open(),J)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function i(ve,J){return J?new Promise((Ee,_e)=>{const Fe=setTimeout(()=>{xe.dispose(),Ee()},ve),xe=J.onCancellationRequested(()=>{clearTimeout(Fe),xe.dispose(),_e(new C.CancellationError)})}):A(Ee=>i(ve,Ee))}e.timeout=i;function o(ve,J=0){const Ee=setTimeout(ve,J);return(0,U.toDisposable)(()=>clearTimeout(Ee))}e.disposableTimeout=o;function n(ve){const J=[];let Ee=0;const _e=ve.length;function Fe(){return Ee<_e?ve[Ee++]():null}function xe(Xe){Xe!=null&&J.push(Xe);const ke=Fe();return ke?ke.then(xe):Promise.resolve(J)}return Promise.resolve(null).then(xe)}e.sequence=n;function t(ve,J=_e=>!!_e,Ee=null){let _e=0;const Fe=ve.length,xe=()=>{if(_e>=Fe)return Promise.resolve(Ee);const Xe=ve[_e++];return Promise.resolve(Xe()).then(Se=>J(Se)?Promise.resolve(Se):xe())};return xe()}e.first=t;function l(ve,J=_e=>!!_e,Ee=null){if(ve.length===0)return Promise.resolve(Ee);let _e=ve.length;const Fe=()=>{_e=-1;for(const xe of ve)xe.cancel?.()};return new Promise((xe,Xe)=>{for(const ke of ve)ke.then(Se=>{--_e>=0&&J(Se)?(Fe(),xe(Se)):_e===0&&xe(Ee)}).catch(Se=>{--_e>=0&&(Fe(),Xe(Se))})})}e.firstParallel=l;class b{constructor(J){this._size=0,this.maxDegreeOfParalellism=J,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new g.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(J){return this._size++,new Promise((Ee,_e)=>{this.outstandingPromises.push({factory:J,c:Ee,e:_e}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const J=this.outstandingPromises.shift();this.runningPromises++;const Ee=J.factory();Ee.then(J.c,J.e),Ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=b;class v extends b{constructor(){super(1)}}e.Queue=v;class E{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const J=new se;return this.drainers.add(J),J.p}isDrained(){for(const[,J]of this.queues)if(J.size>0)return!1;return!0}queueFor(J,Ee=I.extUri){const _e=Ee.getComparisonKey(J);let Fe=this.queues.get(_e);return Fe||(Fe=new v,g.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(_e),this.onDidQueueDrain()}),this.queues.set(_e,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const J of this.drainers)J.complete();this.drainers.clear()}dispose(){for(const[,J]of this.queues)J.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=E;class x{constructor(J,Ee){this._token=-1,typeof J=="function"&&typeof Ee=="number"&&this.setIfNotSet(J,Ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(J,Ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,J()},Ee)}setIfNotSet(J,Ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,J()},Ee))}}e.TimeoutTimer=x;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(J,Ee){this.cancel(),this._token=setInterval(()=>{J()},Ee)}}e.IntervalTimer=$;class R{constructor(J,Ee){this.timeoutToken=-1,this.runner=J,this.timeout=Ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(J=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,J)}get delay(){return this.timeout}set delay(J){this.timeout=J}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class p{constructor(J,Ee){Ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Ee}ms is not a multiple of 1000ms.`),this.runner=J,this.timeout=Ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(J=this.timeout){J%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(J/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=p;class F extends R{constructor(J,Ee){super(J,Ee);this.units=[]}work(J){this.units.push(J),this.isScheduled()||this.schedule()}doRun(){const J=this.units;this.units=[],this.runner&&this.runner(J)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class M extends U.Disposable{constructor(J,Ee){super();this.options=J,this.handler=Ee,this.pendingWork=[],this.throttler=this._register(new U.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(J){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+J.length>this.options.maxBufferedWork)return!1}else if(this.pending+J.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...J),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ve=>{(0,P.setTimeout0)(()=>{if(J)return;const Ee=Date.now()+15;ve(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Ee-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.runWhenIdle=(ve,J)=>{const Ee=requestIdleCallback(ve,typeof J=="number"?{timeout:J}:void 0);let _e=!1;return{dispose(){_e||(_e=!0,cancelIdleCallback(Ee))}}}}();class z{constructor(J){this._didRun=!1,this._executor=()=>{try{this._value=J()}catch(Ee){this._error=Ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=z;async function Z(ve,J,Ee){let _e;for(let Fe=0;Fe<Ee;Fe++)try{return await ve()}catch(xe){_e=xe,await i(J)}throw _e}e.retry=Z;class K{hasPending(J){return this._pending?typeof J=="number"?this._pending.taskId===J:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(J,Ee,_e){return this._pending={taskId:J,cancel:()=>_e?.(),promise:Ee},Ee.then(()=>this.donePending(J),()=>this.donePending(J)),Ee}donePending(J){this._pending&&J===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const J=this._next;this._next=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}setNext(J){if(this._next)this._next.run=J;else{let Ee,_e;const Fe=new Promise((xe,Xe)=>{Ee=xe,_e=Xe});this._next={run:J,promise:Fe,promiseResolve:Ee,promiseReject:_e}}return this._next.promise}}e.TaskSequentializer=K;class N{constructor(J,Ee=()=>Date.now()){this.interval=J,this.nowFn=Ee,this.lastIncrementTime=0,this.value=0}increment(){const J=this.nowFn();return J-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=J,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class se{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((J,Ee)=>{this.completeCallback=J,this.errorCallback=Ee})}complete(J){return new Promise(Ee=>{this.completeCallback(J),this.resolved=!0,Ee()})}error(J){return new Promise(Ee=>{this.errorCallback(J),this.rejected=!0,Ee()})}cancel(){new Promise(J=>{this.errorCallback(new C.CancellationError),this.rejected=!0,J()})}}e.DeferredPromise=se;var le;(function(ve){async function J(_e){let Fe;const xe=await Promise.all(_e.map(Xe=>Xe.then(ke=>ke,ke=>{Fe||(Fe=ke)})));if(typeof Fe!="undefined")throw Fe;return xe}ve.settled=J;function Ee(_e){return new Promise(async(Fe,xe)=>{try{await _e(Fe,xe)}catch(Xe){xe(Xe)}})}ve.withAsyncBody=Ee})(le||(e.Promises=le={}));var oe;(function(ve){ve[ve.Initial=0]="Initial",ve[ve.DoneOK=1]="DoneOK",ve[ve.DoneError=2]="DoneError"})(oe||(oe={}));class fe{static fromArray(J){return new fe(Ee=>{Ee.emitMany(J)})}static fromPromise(J){return new fe(async Ee=>{Ee.emitMany(await J)})}static fromPromises(J){return new fe(async Ee=>{await Promise.all(J.map(async _e=>Ee.emitOne(await _e)))})}static merge(J){return new fe(async Ee=>{await Promise.all(J.map(async _e=>{for await(const Fe of _e)Ee.emitOne(Fe)}))})}constructor(J){this._state=0,this._results=[],this._error=null,this._onStateChanged=new g.Emitter,queueMicrotask(async()=>{const Ee={emitOne:_e=>this.emitOne(_e),emitMany:_e=>this.emitMany(_e),reject:_e=>this.reject(_e)};try{await Promise.resolve(J(Ee)),this.resolve()}catch(_e){this.reject(_e)}finally{Ee.emitOne=void 0,Ee.emitMany=void 0,Ee.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(J<this._results.length)return{done:!1,value:this._results[J++]};if(this._state===1)return{done:!0,value:void 0};await g.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(J,Ee){return new fe(async _e=>{for await(const Fe of J)_e.emitOne(Ee(Fe))})}map(J){return fe.map(this,J)}static filter(J,Ee){return new fe(async _e=>{for await(const Fe of J)Ee(Fe)&&_e.emitOne(Fe)})}filter(J){return fe.filter(this,J)}static coalesce(J){return fe.filter(J,Ee=>!!Ee)}coalesce(){return fe.coalesce(this)}static async toPromise(J){const Ee=[];for await(const _e of J)Ee.push(_e);return Ee}toPromise(){return fe.toPromise(this)}emitOne(J){this._state===0&&(this._results.push(J),this._onStateChanged.fire())}emitMany(J){this._state===0&&(this._results=this._results.concat(J),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(J){this._state===0&&(this._state=2,this._error=J,this._onStateChanged.fire())}}e.AsyncIterableObject=fe,fe.EMPTY=fe.fromArray([]);class be extends fe{constructor(J,Ee){super(Ee);this._source=J}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=be;function ce(ve){const J=new s.CancellationTokenSource,Ee=ve(J.token);return new be(J,async _e=>{const Fe=J.token.onCancellationRequested(()=>{Fe.dispose(),J.dispose(),_e.reject(new C.CancellationError)});try{for await(const xe of Ee){if(J.token.isCancellationRequested)return;_e.emitOne(xe)}Fe.dispose(),J.dispose()}catch(xe){Fe.dispose(),J.dispose(),_e.reject(xe)}})}e.createCancelableAsyncIterable=ce}),define(Ie[111],Te([1,0,13,19]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const g=new s.IdleValue(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),U=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(v,E,x=!1){const $=v||"",R=E||"",p=g.value.collator.compare($,R);return g.value.collatorIsNumeric&&p===0&&$!==R?$<R?-1:1:p}e.compareFileNames=P;function w(v,E){const x=U.value.collator;return v=v||"",E=E||"",D(x,v,E)}e.compareFileNamesDefault=w;function A(v,E){const x=U.value.collator;return v=v||"",E=E||"",o(v,E)||D(x,v,E)}e.compareFileNamesUpper=A;function O(v,E){const x=U.value.collator;return v=v||"",E=E||"",i(v,E)||D(x,v,E)}e.compareFileNamesLower=O;function S(v,E){return v=v||"",E=E||"",v===E?0:v<E?-1:1}e.compareFileNamesUnicode=S;function m(v,E,x=!1){x||(v=v&&v.toLowerCase(),E=E&&E.toLowerCase());const[$,R]=y(v),[p,F]=y(E);return $!==p?$<p?-1:1:R===F?0:R<F?-1:1}e.noIntlCompareFileNames=m;function _(v,E){const[x,$]=y(v),[R,p]=y(E);let F=g.value.collator.compare($,p);if(F===0){if(g.value.collatorIsNumeric&&$!==p)return $<p?-1:1;if(F=g.value.collator.compare(x,R),g.value.collatorIsNumeric&&F===0&&x!==R)return x<R?-1:1}return F}e.compareFileExtensions=_;function f(v,E){v=v||"",E=E||"";const x=a(v),$=a(E),R=U.value.collator,p=I.value.collator;return D(p,x,$)||D(R,v,E)}e.compareFileExtensionsDefault=f;function u(v,E){v=v||"",E=E||"";const x=a(v),$=a(E),R=U.value.collator,p=I.value.collator;return D(p,x,$)||o(v,E)||D(R,v,E)}e.compareFileExtensionsUpper=u;function d(v,E){v=v||"",E=E||"";const x=a(v),$=a(E),R=U.value.collator,p=I.value.collator;return D(p,x,$)||i(v,E)||D(R,v,E)}e.compareFileExtensionsLower=d;function c(v,E){v=v||"",E=E||"";const x=a(v).toLowerCase(),$=a(E).toLowerCase();return x!==$?x<$?-1:1:v!==E?v<E?-1:1:0}e.compareFileExtensionsUnicode=c;const k=/^(.*?)(\.([^.]*))?$/;function y(v,E=!1){const x=v?k.exec(v):[];let $=[x&&x[1]||"",x&&x[3]||""];return E&&(!$[0]&&$[1]||$[0]&&$[0].charAt(0)===".")&&($=[$[0]+"."+$[1],""]),$}function a(v){const E=v?k.exec(v):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function D(v,E,x){let $=v.compare(E,x);return $!==0?$:E.length!==x.length?E.length<x.length?-1:1:0}function r(v){const E=v.charAt(0);return E.toLocaleUpperCase()!==E}function h(v){const E=v.charAt(0);return E.toLocaleLowerCase()!==E}function i(v,E){return r(v)&&h(E)?-1:h(v)&&r(E)?1:0}function o(v,E){return h(v)&&r(E)?-1:r(v)&&h(E)?1:0}function n(v,E,x=!1){return x||(v=v&&v.toLowerCase(),E=E&&E.toLowerCase()),v===E?0:v<E?-1:1}function t(v,E,x=!1){const $=v.split(C.sep),R=E.split(C.sep),p=$.length-1,F=R.length-1;let M,z;for(let Z=0;;Z++){if(M=p===Z,z=F===Z,M&&z)return P($[Z],R[Z],x);if(M)return-1;if(z)return 1;const K=n($[Z],R[Z],x);if(K!==0)return K}}e.comparePaths=t;function l(v,E,x){const $=v.toLowerCase(),R=E.toLowerCase(),p=b(v,E,x);if(p)return p;const F=$.endsWith(x),M=R.endsWith(x);if(F!==M)return F?-1:1;const z=P($,R);return z!==0?z:$.localeCompare(R)}e.compareAnything=l;function b(v,E,x){const $=v.toLowerCase(),R=E.toLowerCase(),p=$.startsWith(x),F=R.startsWith(x);if(p!==F)return p?-1:1;if(p&&F){if($.length<R.length)return-1;if($.length>R.length)return 1}return 0}e.compareByPrefix=b}),define(Ie[34],Te([1,0,15,13,37,24,19,22,10]),function(ee,e,s,C,g,U,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function A(){return Object.create(null)}e.getEmptyExpression=A,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",S="[^/\\\\]",m=/\//g;function _(se,le){switch(se){case 0:return"";case 1:return`${S}*?`;default:return`(?:${O}|${S}+${O}${le?`|${O}${S}+`:""})*?`}}function f(se,le){if(!se)return[];const oe=[];let fe=!1,be=!1,ce="";for(const ve of se){switch(ve){case le:if(!fe&&!be){oe.push(ce),ce="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":be=!0;break;case"]":be=!1;break}ce+=ve}return ce&&oe.push(ce),oe}e.splitGlobAware=f;function u(se){if(!se)return"";let le="";const oe=f(se,e.GLOB_SPLIT);if(oe.every(fe=>fe===e.GLOBSTAR))le=".*";else{let fe=!1;oe.forEach((be,ce)=>{if(be===e.GLOBSTAR){if(fe)return;le+=_(2,ce===oe.length-1)}else{let ve=!1,J="",Ee=!1,_e="";for(const Fe of be){if(Fe!=="}"&&ve){J+=Fe;continue}if(Ee&&(Fe!=="]"||!_e)){let xe;Fe==="-"?xe=Fe:(Fe==="^"||Fe==="!")&&!_e?xe="^":Fe===e.GLOB_SPLIT?xe="":xe=(0,w.escapeRegExpCharacters)(Fe),_e+=xe;continue}switch(Fe){case"{":ve=!0;continue;case"[":Ee=!0;continue;case"}":{le+=`(?:${f(J,",").map(ke=>u(ke)).join("|")})`,ve=!1,J="";break}case"]":{le+="["+_e+"]",Ee=!1,_e="";break}case"?":le+=S;continue;case"*":le+=_(1);continue;default:le+=(0,w.escapeRegExpCharacters)(Fe)}}ce<oe.length-1&&(oe[ce+1]!==e.GLOBSTAR||ce+2<oe.length)&&(le+=O)}fe=be===e.GLOBSTAR})}return le}const d=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,k=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new U.LRUCache(1e4),h=function(){return!1},i=function(){return null};function o(se,le){if(!se)return i;let oe;typeof se!="string"?oe=se.pattern:oe=se,oe=oe.trim();const fe=`${oe}_${!!le.trimForExclusions}`;let be=r.get(fe);if(be)return n(be,se);let ce;return d.test(oe)?be=l(oe.substr(4),oe):(ce=c.exec(t(oe,le)))?be=b(ce[1],oe):(le.trimForExclusions?y:k).test(oe)?be=v(oe,le):(ce=a.exec(t(oe,le)))?be=E(ce[1].substr(1),oe,!0):(ce=D.exec(t(oe,le)))?be=E(ce[1],oe,!1):be=x(oe),r.set(fe,be),n(be,se)}function n(se,le){if(typeof le=="string")return se;const oe=function(fe,be){return(0,g.isEqualOrParent)(fe,le.base,!P.isLinux)?se(fe.substr(le.base.length+1),be):null};return oe.allBasenames=se.allBasenames,oe.allPaths=se.allPaths,oe.basenames=se.basenames,oe.patterns=se.patterns,oe}function t(se,le){return le.trimForExclusions&&se.endsWith("/**")?se.substr(0,se.length-2):se}function l(se,le){return function(oe,fe){return typeof oe=="string"&&oe.endsWith(se)?le:null}}function b(se,le){const oe=`/${se}`,fe=`\\${se}`,be=function(ve,J){return typeof ve!="string"?null:J?J===se?le:null:ve===se||ve.endsWith(oe)||ve.endsWith(fe)?le:null},ce=[se];return be.basenames=ce,be.patterns=[le],be.allBasenames=ce,be}function v(se,le){const oe=K(se.slice(1,-1).split(",").map(J=>o(J,le)).filter(J=>J!==i),se),fe=oe.length;if(!fe)return i;if(fe===1)return oe[0];const be=function(J,Ee){for(let _e=0,Fe=oe.length;_e<Fe;_e++)if(oe[_e](J,Ee))return se;return null},ce=oe.find(J=>!!J.allBasenames);ce&&(be.allBasenames=ce.allBasenames);const ve=oe.reduce((J,Ee)=>Ee.allPaths?J.concat(Ee.allPaths):J,[]);return ve.length&&(be.allPaths=ve),be}function E(se,le,oe){const fe=I.sep===I.posix.sep,be=fe?se:se.replace(m,I.sep),ce=I.sep+be,ve=I.posix.sep+se;let J;return oe?J=function(Ee,_e){return typeof Ee=="string"&&(Ee===be||Ee.endsWith(ce)||!fe&&(Ee===se||Ee.endsWith(ve)))?le:null}:J=function(Ee,_e){return typeof Ee=="string"&&(Ee===be||!fe&&Ee===se)?le:null},J.allPaths=[(oe?"*/":"./")+se],J}function x(se){try{const le=new RegExp(`^${u(se)}$`);return function(oe){return le.lastIndex=0,typeof oe=="string"&&le.test(oe)?se:null}}catch{return i}}function $(se,le,oe){return!se||typeof le!="string"?!1:R(se)(le,void 0,oe)}e.match=$;function R(se,le={}){if(!se)return h;if(typeof se=="string"||p(se)){const oe=o(se,le);if(oe===i)return h;const fe=function(be,ce){return!!oe(be,ce)};return oe.allBasenames&&(fe.allBasenames=oe.allBasenames),oe.allPaths&&(fe.allPaths=oe.allPaths),fe}return z(se,le)}e.parse=R;function p(se){const le=se;return le?typeof le.base=="string"&&typeof le.pattern=="string":!1}e.isRelativePattern=p;function F(se){return se.allBasenames||[]}e.getBasenameTerms=F;function M(se){return se.allPaths||[]}e.getPathTerms=M;function z(se,le){const oe=K(Object.getOwnPropertyNames(se).map(J=>Z(J,se[J],le)).filter(J=>J!==i)),fe=oe.length;if(!fe)return i;if(!oe.some(J=>!!J.requiresSiblings)){if(fe===1)return oe[0];const J=function(Fe,xe){let Xe;for(let ke=0,Se=oe.length;ke<Se;ke++){const Pe=oe[ke](Fe,xe);if(typeof Pe=="string")return Pe;(0,C.isThenable)(Pe)&&(Xe||(Xe=[]),Xe.push(Pe))}return Xe?(async()=>{for(const ke of Xe){const Se=await ke;if(typeof Se=="string")return Se}return null})():null},Ee=oe.find(Fe=>!!Fe.allBasenames);Ee&&(J.allBasenames=Ee.allBasenames);const _e=oe.reduce((Fe,xe)=>xe.allPaths?Fe.concat(xe.allPaths):Fe,[]);return _e.length&&(J.allPaths=_e),J}const be=function(J,Ee,_e){let Fe,xe;for(let Xe=0,ke=oe.length;Xe<ke;Xe++){const Se=oe[Xe];Se.requiresSiblings&&_e&&(Ee||(Ee=(0,I.basename)(J)),Fe||(Fe=Ee.substr(0,Ee.length-(0,I.extname)(J).length)));const Pe=Se(J,Ee,Fe,_e);if(typeof Pe=="string")return Pe;(0,C.isThenable)(Pe)&&(xe||(xe=[]),xe.push(Pe))}return xe?(async()=>{for(const Xe of xe){const ke=await Xe;if(typeof ke=="string")return ke}return null})():null},ce=oe.find(J=>!!J.allBasenames);ce&&(be.allBasenames=ce.allBasenames);const ve=oe.reduce((J,Ee)=>Ee.allPaths?J.concat(Ee.allPaths):J,[]);return ve.length&&(be.allPaths=ve),be}function Z(se,le,oe){if(le===!1)return i;const fe=o(se,oe);if(fe===i)return i;if(typeof le=="boolean")return fe;if(le){const be=le.when;if(typeof be=="string"){const ce=(ve,J,Ee,_e)=>{if(!_e||!fe(ve,J))return null;const Fe=be.replace("$(basename)",Ee),xe=_e(Fe);return(0,C.isThenable)(xe)?xe.then(Xe=>Xe?se:null):xe?se:null};return ce.requiresSiblings=!0,ce}}return fe}function K(se,le){const oe=se.filter(J=>!!J.basenames);if(oe.length<2)return se;const fe=oe.reduce((J,Ee)=>{const _e=Ee.basenames;return _e?J.concat(_e):J},[]);let be;if(le){be=[];for(let J=0,Ee=fe.length;J<Ee;J++)be.push(le)}else be=oe.reduce((J,Ee)=>{const _e=Ee.patterns;return _e?J.concat(_e):J},[]);const ce=function(J,Ee){if(typeof J!="string")return null;if(!Ee){let Fe;for(Fe=J.length;Fe>0;Fe--){const xe=J.charCodeAt(Fe-1);if(xe===47||xe===92)break}Ee=J.substr(Fe)}const _e=fe.indexOf(Ee);return _e!==-1?be[_e]:null};ce.basenames=fe,ce.patterns=be,ce.allBasenames=fe;const ve=se.filter(J=>!J.basenames);return ve.push(ce),ve}function N(se,le){return(0,s.equals)(se,le,(oe,fe)=>typeof oe=="string"&&typeof fe=="string"?oe===fe:typeof oe!="string"&&typeof fe!="string"?oe.base===fe.base&&oe.pattern===fe.pattern:!1)}e.patternsEquals=N}),define(Ie[75],Te([1,0,11,109,21,10,2]),function(ee,e,s,C,g,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(P||(e.MarkdownStringTextNewlineStyle=P={}));class w{constructor(d="",c=!1){if(this.value=d,typeof this.value!="string")throw(0,s.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(d,c=0){return this.value+=m(this.supportThemeIcons?(0,C.escapeIcons)(d):d).replace(/([ \t]+)/g,(k,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,c){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(d,c,k){return this.value+="[",this.value+=this._escape(c,"]"),this.value+="](",this.value+=this._escape(String(d),")"),k&&(this.value+=` "${this._escape(this._escape(k,'"'),")")}"`),this.value+=")",this}_escape(d,c){const k=new RegExp((0,U.escapeRegExpCharacters)(c),"g");return d.replace(k,(y,a)=>d.charAt(a-1)!=="\\"?`\\${y}`:y)}}e.MarkdownString=w;function A(u){return O(u)?!u.value:Array.isArray(u)?u.every(A):!0}e.isEmptyMarkdownString=A;function O(u){return u instanceof w?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function S(u,d){return u===d?!0:!u||!d?!1:u.value===d.value&&u.isTrusted===d.isTrusted&&u.supportThemeIcons===d.supportThemeIcons&&u.supportHtml===d.supportHtml&&(u.baseUri===d.baseUri||!!u.baseUri&&!!d.baseUri&&(0,g.isEqual)(I.URI.from(u.baseUri),I.URI.from(d.baseUri)))}e.markdownStringEqual=S;function m(u){return u.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function _(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=_;function f(u){const d=[],c=u.split("|").map(y=>y.trim());u=c[0];const k=c[1];if(k){const y=/height=(\d+)/.exec(k),a=/width=(\d+)/.exec(k),D=y?y[1]:"",r=a?a[1]:"",h=isFinite(parseInt(r)),i=isFinite(parseInt(D));h&&d.push(`width="${r}"`),i&&d.push(`height="${D}"`)}return{href:u,dimensions:d}}e.parseHrefAndDimensions=f}),define(Ie[76],Te([1,0,15,37,12,19,22,21,10,2]),function(ee,e,s,C,g,U,I,P,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function O(t,l){const{os:b,tildify:v,relative:E}=l;if(E){const R=S(t,E,b);if(typeof R=="string")return R}let x=t.fsPath;if(b===1&&!I.isWindows?x=x.replace(/\//g,"\\"):b!==1&&I.isWindows&&(x=x.replace(/\\/g,"/")),b!==1&&v?.userHome){let R=v.userHome.fsPath,p;t.scheme!==v.userHome.scheme&&t.path.startsWith(U.posix.sep)?p=v.userHome.with({path:t.path}).fsPath:p=t.fsPath,x=u(p,R,b)}return(b===1?U.win32:U.posix).normalize(_(x,b===1))}e.getPathLabel=O;function S(t,l,b){const v=b===1?U.win32:U.posix,E=b===3?P.extUri:P.extUriIgnorePathCase,x=l.getWorkspace(),$=(0,s.firstOrDefault)(x.folders);if(!$)return;t.scheme!==$.uri.scheme&&t.path.startsWith(U.posix.sep)&&(t=$.uri.with({path:t.path}));const R=l.getWorkspaceFolder(t);if(!R)return;let p;if(E.isEqual(R.uri,t)?p="":p=E.relativePath(R.uri,t)??"",p&&(p=v.normalize(p)),x.folders.length>1&&!l.noPrefix){const F=R.name?R.name:E.basenameOrAuthority(R.uri);p=p?`${F} \u2022 ${p}`:F}return p}function m(t){if(!t)return;typeof t=="string"&&(t=A.URI.file(t));const l=(0,P.basename)(t)||(t.scheme===g.Schemas.file?t.fsPath:t.path);return I.isWindows&&(0,C.isRootOrDriveLetter)(l)?_(l):l}e.getBaseLabel=m;function _(t,l=I.isWindows){return(0,C.hasDriveLetter)(t,l)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=_;let f=Object.create(null);function u(t,l,b=I.OS){if(b===1||!t||!l)return t;let v=f.original===l?f.normalized:void 0;v||(v=l,I.isWindows&&(v=(0,C.toSlashes)(v)),v=`${(0,w.rtrim)(v,U.posix.sep)}${U.posix.sep}`,f={original:l,normalized:v});let E=t;return I.isWindows&&(E=(0,C.toSlashes)(E)),(b===3?E.startsWith(v):(0,w.startsWithIgnoreCase)(E,v))?`~/${E.substr(v.length)}`:t}e.tildify=u;function d(t,l){return t.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=d;const c="\u2026",k="\\\\",y="~";function a(t,l=U.sep){const b=new Array(t.length);let v=!1;for(let E=0;E<t.length;E++){let x=t[E];if(x===""){b[E]=`.${l}`;continue}if(!x){b[E]=x;continue}v=!0;let $="",R=x;R.indexOf(k)===0?($=R.substr(0,R.indexOf(k)+k.length),R=R.substr(R.indexOf(k)+k.length)):R.indexOf(l)===0?($=R.substr(0,R.indexOf(l)+l.length),R=R.substr(R.indexOf(l)+l.length)):R.indexOf(y)===0&&($=R.substr(0,R.indexOf(y)+y.length),R=R.substr(R.indexOf(y)+y.length));const p=R.split(l);for(let F=1;v&&F<=p.length;F++)for(let M=p.length-F;v&&M>=0;M--){v=!1;let z=p.slice(M,M+F).join(l);for(let Z=0;!v&&Z<t.length;Z++)if(Z!==E&&t[Z]&&t[Z].indexOf(z)>-1){const K=M+F===p.length,N=M>0&&t[Z].indexOf(l)>-1?l+z:z,se=t[Z].endsWith(N);v=!K||se}if(!v){let Z="";(p[0].endsWith(":")||$!=="")&&(M===1&&(M=0,F++,z=p[0]+l+z),M>0&&(Z=p[0]+l),Z=$+Z),M>0&&(Z=Z+c+l),Z=Z+z,M+F<p.length&&(Z=Z+l+c),b[E]=Z}}v&&(b[E]=x)}return b}e.shorten=a;var D;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(D||(D={}));function r(t,l=Object.create(null)){const b=[];let v=!1,E="";for(const x of t)if(x==="$"||v&&x==="{")E&&b.push({value:E,type:D.TEXT}),E="",v=!0;else if(x==="}"&&v){const $=l[E];if(typeof $=="string")$.length&&b.push({value:$,type:D.VARIABLE});else if($){const R=b[b.length-1];(!R||R.type!==D.SEPARATOR)&&b.push({value:$.label,type:D.SEPARATOR})}E="",v=!1}else E+=x;return E&&!v&&b.push({value:E,type:D.TEXT}),b.filter((x,$)=>{if(x.type===D.SEPARATOR){const R=b[$-1],p=b[$+1];return[R,p].every(F=>F&&(F.type===D.VARIABLE||F.type===D.TEXT)&&F.value.length>0)}return!0}).map(x=>x.value).join("")}e.template=r;function h(t,l){return I.isMacintosh||l?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):t.replace(/&&|&/g,b=>b==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function i(t,l){return I.isMacintosh||l?t.replace(/\(&&\w\)|&&/g,""):I.isWindows?t.replace(/&&|&/g,b=>b==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function o(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=o;function n(t){const l=t.indexOf("/")!==-1?U.posix:U.win32,b=l.basename(t),v=l.dirname(t);return b.length?{name:b,parentPath:v}:{name:v,parentPath:""}}e.splitName=n}),define(Ie[112],Te([1,0,2]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(O){return O.toJSON()}class g{constructor(S){this._uriTransformer=S}transformIncoming(S){const m=this._uriTransformer.transformIncoming(S);return m===S?S:C(s.URI.from(m))}transformOutgoing(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:C(s.URI.from(m))}transformOutgoingURI(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:s.URI.from(m)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=g,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function U(O,S,m){if(!O||m>200)return null;if(typeof O=="object"){if(O instanceof s.URI)return S.transformOutgoing(O);for(let _ in O)if(Object.hasOwnProperty.call(O,_)){const f=U(O[_],S,m+1);f!==null&&(O[_]=f)}}return null}function I(O,S){const m=U(O,S,0);return m===null?O:m}e.transformOutgoingURIs=I;function P(O,S,m,_){if(!O||_>200)return null;if(typeof O=="object"){if(O.$mid===1)return m?s.URI.revive(S.transformIncoming(O)):S.transformIncoming(O);for(let f in O)if(Object.hasOwnProperty.call(O,f)){const u=P(O[f],S,m,_+1);u!==null&&(O[f]=u)}}return null}function w(O,S){const m=P(O,S,!1,0);return m===null?O:m}e.transformIncomingURIs=w;function A(O,S){const m=P(O,S,!0,0);return m===null?O:m}e.transformAndReviveIncomingURIs=A}),define(Ie[44],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(g){return s.test(g)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(P){for(let w=0;w<P.length;w++)P[w]=Math.floor(Math.random()*256);return P};const U=new Uint8Array(16),I=[];for(let P=0;P<256;P++)I.push(P.toString(16).padStart(2,"0"));return function(){g(U),U[6]=U[6]&15|64,U[8]=U[8]&63|128;let w=0,A="";return A+=I[U[w++]],A+=I[U[w++]],A+=I[U[w++]],A+=I[U[w++]],A+="-",A+=I[U[w++]],A+=I[U[w++]],A+="-",A+=I[U[w++]],A+=I[U[w++]],A+="-",A+=I[U[w++]],A+=I[U[w++]],A+="-",A+=I[U[w++]],A+=I[U[w++]],A+=I[U[w++]],A+=I[U[w++]],A+=I[U[w++]],A+=I[U[w++]],A}}()}),define(Ie[113],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[114],Te([1,0,34,19]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function g(U,I,P,w,A,O){if(Array.isArray(U)){let S=0;for(const m of U){const _=g(m,I,P,w,A,O);if(_===10)return _;_>S&&(S=_)}return S}else{if(typeof U=="string")return w?U==="*"?5:U===P?10:0:0;if(U){const{language:S,pattern:m,scheme:_,hasAccessToAllModels:f,notebookType:u}=U;if(!w&&!f)return 0;u&&A&&(I=A);let d=0;if(_)if(_===I.scheme)d=10;else if(_==="*")d=5;else return 0;if(S)if(S===P)d=10;else if(S==="*")d=Math.max(d,5);else return 0;if(u)if(u===O)d=10;else if(u==="*"&&O!==void 0)d=Math.max(d,5);else return 0;if(m){let c;if(typeof m=="string"?c=m:c={...m,base:(0,C.normalize)(m.base)},c===I.fsPath||(0,s.match)(c,I.fsPath))d=10;else return 0}return d}else return 0}}e.score=g}),define(Ie[115],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var s;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(s||(e.IndentAction=s={}));class C{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let w=0,A=P.notIn.length;w<A;w++)switch(P.notIn[w]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,w){if(P.getTokenCount()===0)return!0;const A=P.findTokenIndexAtOffset(w-2),O=P.getStandardTokenType(A);return this.isOK(O)}_findNeutralCharacterInRange(P,w){for(let A=P;A<=w;A++){const O=String.fromCharCode(A);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=C;class g{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of P)U(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),U(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),U(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),U(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&U(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=g;function U(I,P,w){I.has(P)?I.get(P).push(w):I.set(P,[w])}}),define(Ie[77],Te([1,0,23,22]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var g;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(g||(g={}));function U(S){for(let m=0,_=S.length;m<_;m+=4){const f=S[m+0],u=S[m+1],d=S[m+2],c=S[m+3];S[m+0]=c,S[m+1]=d,S[m+2]=u,S[m+3]=f}}function I(S){const m=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return C.isLittleEndian()||U(m),s.VSBuffer.wrap(m)}function P(S){const m=S.buffer;if(C.isLittleEndian()||U(m),m.byteOffset%4==0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const _=new Uint8Array(m.byteLength);return _.set(m),new Uint32Array(_.buffer,_.byteOffset,_.length/4)}}function w(S){const m=new Uint32Array(A(S));let _=0;if(m[_++]=S.id,S.type==="full")m[_++]=1,m[_++]=S.data.length,m.set(S.data,_),_+=S.data.length;else{m[_++]=2,m[_++]=S.deltas.length;for(const f of S.deltas)m[_++]=f.start,m[_++]=f.deleteCount,f.data?(m[_++]=f.data.length,m.set(f.data,_),_+=f.data.length):m[_++]=0}return I(m)}e.encodeSemanticTokensDto=w;function A(S){let m=0;if(m+=1+1,S.type==="full")m+=1+S.data.length;else{m+=1,m+=(1+1+1)*S.deltas.length;for(const _ of S.deltas)_.data&&(m+=_.data.length)}return m}function O(S){const m=P(S);let _=0;const f=m[_++];if(m[_++]===1){const k=m[_++],y=m.subarray(_,_+k);return _+=k,{id:f,type:"full",data:y}}const d=m[_++],c=[];for(let k=0;k<d;k++){const y=m[_++],a=m[_++],D=m[_++];let r;D>0&&(r=m.subarray(_,_+D),_+=D),c[k]={start:y,deleteCount:a,data:r}}return{id:f,type:"delta",deltas:c}}e.decodeSemanticTokensDto=O}),define(Ie[116],Te([17,18]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ie[117],Te([1,0,116]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,g=C*60,U=g*24,I=U*7,P=U*30,w=U*365;function A(S,m,_){typeof S!="number"&&(S=S.getTime());const f=Math.round((new Date().getTime()-S)/1e3);if(f<-30)return(0,s.localize)(0,null,A(new Date().getTime()+f*1e3,!1));if(f<30)return(0,s.localize)(1,null);let u;return f<C?(u=f,m?u===1?_?(0,s.localize)(2,null,u):(0,s.localize)(3,null,u):_?(0,s.localize)(4,null,u):(0,s.localize)(5,null,u):u===1?_?(0,s.localize)(6,null,u):(0,s.localize)(7,null,u):_?(0,s.localize)(8,null,u):(0,s.localize)(9,null,u)):f<g?(u=Math.floor(f/C),m?u===1?_?(0,s.localize)(10,null,u):(0,s.localize)(11,null,u):_?(0,s.localize)(12,null,u):(0,s.localize)(13,null,u):u===1?_?(0,s.localize)(14,null,u):(0,s.localize)(15,null,u):_?(0,s.localize)(16,null,u):(0,s.localize)(17,null,u)):f<U?(u=Math.floor(f/g),m?u===1?_?(0,s.localize)(18,null,u):(0,s.localize)(19,null,u):_?(0,s.localize)(20,null,u):(0,s.localize)(21,null,u):u===1?_?(0,s.localize)(22,null,u):(0,s.localize)(23,null,u):_?(0,s.localize)(24,null,u):(0,s.localize)(25,null,u)):f<I?(u=Math.floor(f/U),m?u===1?(0,s.localize)(26,null,u):(0,s.localize)(27,null,u):u===1?(0,s.localize)(28,null,u):(0,s.localize)(29,null,u)):f<P?(u=Math.floor(f/I),m?u===1?_?(0,s.localize)(30,null,u):(0,s.localize)(31,null,u):_?(0,s.localize)(32,null,u):(0,s.localize)(33,null,u):u===1?_?(0,s.localize)(34,null,u):(0,s.localize)(35,null,u):_?(0,s.localize)(36,null,u):(0,s.localize)(37,null,u)):f<w?(u=Math.floor(f/P),m?u===1?_?(0,s.localize)(38,null,u):(0,s.localize)(39,null,u):_?(0,s.localize)(40,null,u):(0,s.localize)(41,null,u):u===1?_?(0,s.localize)(42,null,u):(0,s.localize)(43,null,u):_?(0,s.localize)(44,null,u):(0,s.localize)(45,null,u)):(u=Math.floor(f/w),m?u===1?_?(0,s.localize)(46,null,u):(0,s.localize)(47,null,u):_?(0,s.localize)(48,null,u):(0,s.localize)(49,null,u):u===1?_?(0,s.localize)(50,null,u):(0,s.localize)(51,null,u):_?(0,s.localize)(52,null,u):(0,s.localize)(53,null,u))}e.fromNow=A;function O(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ie[118],Te([17,18]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ie[45],Te([1,0,15,9,118]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function U(S,m){return m&&(S.stack||S.stacktrace)?g.localize(0,null,P(S),I(S.stack)||I(S.stacktrace)):P(S)}function I(S){return Array.isArray(S)?S.join(`
`):S}function P(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?g.localize(1,null,S.message):S.message||g.localize(2,null)}function w(S=null,m=!1){if(!S)return g.localize(3,null);if(Array.isArray(S)){const _=s.coalesce(S),f=w(_[0],m);return _.length>1?g.localize(4,null,f,_.length):f}if(C.isString(S))return S;if(S.detail){const _=S.detail;if(_.error)return U(_.error,m);if(_.exception)return U(_.exception,m)}return S.stack?U(S,m):S.message?S.message:g.localize(5,null)}e.toErrorMessage=w;function A(S){const m=S;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=A;function O(S,m){let _;return typeof S=="string"?_=new Error(S):_=S,_.actions=m,_}e.createErrorWithActions=O}),define(Ie[119],Te([17,18]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ie[120],Te([1,0,119,22,121,15,27,113]),function(ee,e,s,C,g,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(w||(e.EditorAutoIndentStrategy=w={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=A;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class S{constructor(Y,me,Le,ze){this.id=Y,this.name=me,this.defaultValue=Le,this.schema=ze}applyUpdate(Y,me){return _(Y,me)}compute(Y,me,Le){return Le}}class m{constructor(Y,me){this.newValue=Y,this.didChange=me}}e.ApplyUpdateResult=m;function _(q,Y){if(typeof q!="object"||typeof Y!="object"||!q||!Y)return new m(Y,q!==Y);if(Array.isArray(q)||Array.isArray(Y)){const Le=Array.isArray(q)&&Array.isArray(Y)&&U.equals(q,Y);return new m(Y,Le)}let me=!1;for(const Le in Y)if(Y.hasOwnProperty(Le)){const ze=_(q[Le],Y[Le]);ze.didChange&&(q[Le]=ze.newValue,me=!0)}return new m(q,me)}class f{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,me){return _(Y,me)}validate(Y){return this.defaultValue}}class u{constructor(Y,me,Le,ze){this.id=Y,this.name=me,this.defaultValue=Le,this.schema=ze}applyUpdate(Y,me){return _(Y,me)}validate(Y){return typeof Y=="undefined"?this.defaultValue:Y}compute(Y,me,Le){return Le}}function d(q,Y){return typeof q=="undefined"?Y:q==="false"?!1:Boolean(q)}e.boolean=d;class c extends u{constructor(Y,me,Le,ze=void 0){typeof ze!="undefined"&&(ze.type="boolean",ze.default=Le);super(Y,me,Le,ze)}validate(Y){return d(Y,this.defaultValue)}}function k(q,Y,me,Le){if(typeof q=="undefined")return Y;let ze=parseInt(q,10);return isNaN(ze)?Y:(ze=Math.max(me,ze),ze=Math.min(Le,ze),ze|0)}e.clampedInt=k;class y extends u{static clampedInt(Y,me,Le,ze){return k(Y,me,Le,ze)}constructor(Y,me,Le,ze,Ge,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=Le,Ze.minimum=ze,Ze.maximum=Ge);super(Y,me,Le,Ze);this.minimum=ze,this.maximum=Ge}validate(Y){return y.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class a extends u{static clamp(Y,me,Le){return Y<me?me:Y>Le?Le:Y}static float(Y,me){if(typeof Y=="number")return Y;if(typeof Y=="undefined")return me;const Le=parseFloat(Y);return isNaN(Le)?me:Le}constructor(Y,me,Le,ze,Ge){typeof Ge!="undefined"&&(Ge.type="number",Ge.default=Le);super(Y,me,Le,Ge);this.validationFn=ze}validate(Y){return this.validationFn(a.float(Y,this.defaultValue))}}class D extends u{static string(Y,me){return typeof Y!="string"?me:Y}constructor(Y,me,Le,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.default=Le);super(Y,me,Le,ze)}validate(Y){return D.string(Y,this.defaultValue)}}function r(q,Y,me){return typeof q!="string"||me.indexOf(q)===-1?Y:q}e.stringSet=r;class h extends u{constructor(Y,me,Le,ze,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="string",Ge.enum=ze,Ge.default=Le);super(Y,me,Le,Ge);this._allowedValues=ze}validate(Y){return r(Y,this.defaultValue,this._allowedValues)}}class i extends S{constructor(Y,me,Le,ze,Ge,Ze,ot=void 0){typeof ot!="undefined"&&(ot.type="string",ot.enum=Ge,ot.default=ze);super(Y,me,Le,ot);this._allowedValues=Ge,this._convert=Ze}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function o(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(0,null),s.localize(1,null),s.localize(2,null)],default:"auto",description:s.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,me,Le){return Le===0?Y.accessibilitySupport:Le}}class t extends S{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:s.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:s.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertSpace:d(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(l||(e.TextEditorCursorBlinkingStyle=l={}));function b(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(v||(e.TextEditorCursorStyle=v={}));function E(q){switch(q){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function x(q){switch(q){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class $ extends f{constructor(){super(129)}compute(Y,me,Le){const ze=["monaco-editor"];return me.get(34)&&ze.push(me.get(34)),Y.extraEditorClassName&&ze.push(Y.extraEditorClassName),me.get(67)==="default"?ze.push("mouse-default"):me.get(67)==="copy"&&ze.push("mouse-copy"),me.get(101)&&ze.push("showUnused"),me.get(127)&&ze.push("showDeprecated"),ze.join(" ")}}class R extends c{constructor(){super(33,"emptySelectionClipboard",!0,{description:s.localize(6,null)})}compute(Y,me,Le){return Le&&Y.emptySelectionClipboard}}class p extends S{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:s.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[s.localize(8,null),s.localize(9,null),s.localize(10,null)],description:s.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[s.localize(12,null),s.localize(13,null),s.localize(14,null)],description:s.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:s.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:s.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:s.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{cursorMoveOnType:d(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":r(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":r(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(me.loop,this.defaultValue.loop)}}}class F extends S{constructor(){super(46,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:s.localize(19,null)},{type:"string",description:s.localize(20,null)}],description:s.localize(21,null),default:!1})}validate(Y){return typeof Y=="undefined"?this.defaultValue:typeof Y=="string"?Y==="false"?F.OFF:Y==="true"?F.ON:Y:Boolean(Y)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class M extends f{constructor(){super(45)}compute(Y,me,Le){return Y.fontInfo}}class z extends u{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(22,null)})}validate(Y){const me=a.float(Y,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(me,6,100)}compute(Y,me,Le){return Y.fontInfo.fontSize}}class Z extends S{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Z.MINIMUM_VALUE,maximum:Z.MAXIMUM_VALUE,errorMessage:s.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(24,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(y.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,Z.MINIMUM_VALUE,Z.MAXIMUM_VALUE))}}Z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],Z.MINIMUM_VALUE=1,Z.MAXIMUM_VALUE=1e3;class K extends S{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[s.localize(25,null),s.localize(26,null),s.localize(27,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:s.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:s.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:s.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Le,description:s.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Le,description:s.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Le,description:s.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Le,description:s.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Le,description:s.localize(38,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{multiple:r(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??r(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??r(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??r(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??r(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??r(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:D.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:D.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:D.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:D.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:D.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class N extends S{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:s.localize(39,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:s.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:s.localize(41,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:s.localize(42,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:d(me.enabled,this.defaultValue.enabled),delay:y.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:d(me.sticky,this.defaultValue.sticky),above:d(me.above,this.defaultValue.above)}}}var se;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(se||(e.RenderMinimap=se={}));class le extends f{constructor(){super(132)}compute(Y,me,Le){return le.computeLayout(me,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const me=Y.height/Y.lineHeight,Le=Y.scrollBeyondLastLine?me-1:0,ze=(Y.viewLineCount+Le)/(Y.pixelRatio*Y.height),Ge=Math.floor(Y.viewLineCount/ze);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Le,desiredRatio:ze,minimapLineCount:Ge}}static _computeMinimapLayout(Y,me){const Le=Y.outerWidth,ze=Y.outerHeight,Ge=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ge*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Ze=me.stableMinimapLayoutInput,ot=Ze&&Y.outerHeight===Ze.outerHeight&&Y.lineHeight===Ze.lineHeight&&Y.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Ze.pixelRatio&&Y.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&Y.minimap.enabled===Ze.minimap.enabled&&Y.minimap.side===Ze.minimap.side&&Y.minimap.size===Ze.minimap.size&&Y.minimap.showSlider===Ze.minimap.showSlider&&Y.minimap.renderCharacters===Ze.minimap.renderCharacters&&Y.minimap.maxColumn===Ze.minimap.maxColumn&&Y.minimap.scale===Ze.minimap.scale&&Y.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&Y.isViewportWrapping===Ze.isViewportWrapping,Qe=Y.lineHeight,et=Y.typicalHalfwidthCharacterWidth,qe=Y.scrollBeyondLastLine,st=Y.minimap.renderCharacters;let it=Ge>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const at=Y.minimap.maxColumn,ct=Y.minimap.size,Tt=Y.minimap.side,Ut=Y.verticalScrollbarWidth,Ct=Y.viewLineCount,ft=Y.remainingWidth,At=Y.isViewportWrapping,xt=st?2:3;let _t=Math.floor(Ge*ze);const He=_t/Ge;let Rt=!1,Mt=!1,Ot=xt*it,pt=it/Ge,St=1;if(ct==="fill"||ct==="fit"){const{typicalViewportLineCount:De,extraLinesBeyondLastLine:Me,desiredRatio:Je,minimapLineCount:Ve}=le.computeContainedMinimapLineCount({viewLineCount:Ct,scrollBeyondLastLine:qe,height:ze,lineHeight:Qe,pixelRatio:Ge});if(Ct/Ve>1)Rt=!0,Mt=!0,it=1,Ot=1,pt=it/Ge;else{let ht=!1,Et=it+1;if(ct==="fit"){const mt=Math.ceil((Ct+Me)*Ot);At&&ot&&ft<=me.stableFitRemainingWidth?(ht=!0,Et=me.stableFitMaxMinimapScale):ht=mt>_t}if(ct==="fill"||ht){Rt=!0;const mt=it;Ot=Math.min(Qe*Ge,Math.max(1,Math.floor(1/Je))),At&&ot&&ft<=me.stableFitRemainingWidth&&(Et=me.stableFitMaxMinimapScale),it=Math.min(Et,Math.max(1,Math.floor(Ot/xt))),it>mt&&(St=Math.min(2,it/mt)),pt=it/Ge/St,_t=Math.ceil(Math.max(De,Ct+Me)*Ot),At?(me.stableMinimapLayoutInput=Y,me.stableFitRemainingWidth=ft,me.stableFitMaxMinimapScale=it):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const It=Math.floor(at*pt),wt=Math.min(It,Math.max(0,Math.floor((ft-Ut-2)*pt/(et+pt)))+e.MINIMAP_GUTTER_WIDTH);let we=Math.floor(Ge*wt);const Ce=we/Ge;we=Math.floor(we*St);const de=st?1:2,j=Tt==="left"?0:Le-wt-Ut;return{renderMinimap:de,minimapLeft:j,minimapWidth:wt,minimapHeightIsEditorHeight:Rt,minimapIsSampling:Mt,minimapScale:it,minimapLineHeight:Ot,minimapCanvasInnerWidth:we,minimapCanvasInnerHeight:_t,minimapCanvasOuterWidth:Ce,minimapCanvasOuterHeight:He}}static computeLayout(Y,me){const Le=me.outerWidth|0,ze=me.outerHeight|0,Ge=me.lineHeight|0,Ze=me.lineNumbersDigitCount|0,ot=me.typicalHalfwidthCharacterWidth,Qe=me.maxDigitWidth,et=me.pixelRatio,qe=me.viewLineCount,st=Y.get(124),it=st==="inherit"?Y.get(123):st,at=it==="inherit"?Y.get(119):it,ct=Y.get(122),Tt=Y.get(2),Ut=me.isDominatedByLongLines,Ct=Y.get(51),ft=Y.get(61).renderType!==0,At=Y.get(62),xt=Y.get(95),_t=Y.get(66),He=Y.get(93),Rt=He.verticalScrollbarSize,Mt=He.verticalHasArrows,Ot=He.arrowSize,pt=He.horizontalScrollbarSize,St=Y.get(59),It=Y.get(38);let wt;if(typeof St=="string"&&/^\d+(\.\d+)?ch$/.test(St)){const vt=parseFloat(St.substr(0,St.length-2));wt=y.clampedInt(vt*ot,0,0,1e3)}else wt=y.clampedInt(St,0,0,1e3);It&&(wt+=16);let we=0;if(ft){const vt=Math.max(Ze,At);we=Math.round(vt*Qe)}let Ce=0;Ct&&(Ce=Ge);let de=0,j=de+Ce,De=j+we,Me=De+wt;const Je=Le-Ce-we-wt;let Ve=!1,ut=!1,ht=-1;Tt!==2&&(it==="inherit"&&Ut?(Ve=!0,ut=!0):at==="on"||at==="bounded"?ut=!0:at==="wordWrapColumn"&&(ht=ct));const Et=le._computeMinimapLayout({outerWidth:Le,outerHeight:ze,lineHeight:Ge,typicalHalfwidthCharacterWidth:ot,pixelRatio:et,scrollBeyondLastLine:xt,minimap:_t,verticalScrollbarWidth:Rt,viewLineCount:qe,remainingWidth:Je,isViewportWrapping:ut},me.memory||new O);Et.renderMinimap!==0&&Et.minimapLeft===0&&(de+=Et.minimapWidth,j+=Et.minimapWidth,De+=Et.minimapWidth,Me+=Et.minimapWidth);const mt=Je-Et.minimapWidth,kt=Math.max(1,Math.floor((mt-Rt-2)/ot)),Ft=Mt?Ot:0;return ut&&(ht=Math.max(1,kt),at==="bounded"&&(ht=Math.min(ht,ct))),{width:Le,height:ze,glyphMarginLeft:de,glyphMarginWidth:Ce,lineNumbersLeft:j,lineNumbersWidth:we,decorationsLeft:De,decorationsWidth:wt,contentLeft:Me,contentWidth:mt,minimap:Et,viewportColumn:kt,isWordWrapMinified:Ve,isViewportWrapping:ut,wrappingColumn:ht,verticalScrollbarWidth:Rt,horizontalScrollbarHeight:pt,overviewRuler:{top:Ft,width:Rt,height:ze-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=le;class oe extends S{constructor(){const Y={enabled:!0};super(58,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:s.localize(43,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:d(Y.enabled,this.defaultValue.enabled)}}}class fe extends S{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(128,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:s.localize(44,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(45,null),s.localize(46,null),s.localize(47,null),s.localize(48,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:s.localize(49,null)},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:s.localize(50,null)},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:s.localize(51,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:r(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:y.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:D.string(me.fontFamily,this.defaultValue.fontFamily),padding:d(me.padding,this.defaultValue.padding)}}}class be extends a{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>a.clamp(Y,0,150),{markdownDescription:s.localize(52,null)})}compute(Y,me,Le){return Y.fontInfo.lineHeight}}class ce extends S{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:s.localize(53,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(54,null),s.localize(55,null),s.localize(56,null)],default:Y.size,description:s.localize(57,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:s.localize(58,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:s.localize(59,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(60,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:s.localize(61,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:s.localize(62,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:d(me.enabled,this.defaultValue.enabled),size:r(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(me.side,this.defaultValue.side,["right","left"]),showSlider:r(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(me.renderCharacters,this.defaultValue.renderCharacters),scale:y.clampedInt(me.scale,1,1,3),maxColumn:y.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ve(q){return q==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class J extends S{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(63,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(64,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{top:y.clampedInt(me.top,0,0,1e3),bottom:y.clampedInt(me.bottom,0,0,1e3)}}}class Ee extends S{constructor(){const Y={enabled:!0,cycle:!1};super(77,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:s.localize(65,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:s.localize(66,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:d(me.enabled,this.defaultValue.enabled),cycle:d(me.cycle,this.defaultValue.cycle)}}}class _e extends f{constructor(){super(130)}compute(Y,me,Le){return Y.pixelRatio}}class Fe extends S{constructor(){const Y={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(67,null),s.localize(68,null),s.localize(69,null)]}];super(80,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Y.strings,description:s.localize(70,null)},comments:{anyOf:me,default:Y.comments,description:s.localize(71,null)},other:{anyOf:me,default:Y.other,description:s.localize(72,null)}},default:Y,markdownDescription:s.localize(73,null)});this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const et=Y?"on":"off";return{comments:et,strings:et,other:et}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:me,comments:Le,strings:ze}=Y,Ge=["on","inline","off"];let Ze,ot,Qe;return typeof me=="boolean"?Ze=me?"on":"off":Ze=r(me,this.defaultValue.other,Ge),typeof Le=="boolean"?ot=Le?"on":"off":ot=r(Le,this.defaultValue.comments,Ge),typeof ze=="boolean"?Qe=ze?"on":"off":Qe=r(ze,this.defaultValue.strings,Ge),{other:Ze,comments:ot,strings:Qe}}}var xe;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(xe||(e.RenderLineNumbersType=xe={}));class Xe extends S{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(74,null),s.localize(75,null),s.localize(76,null),s.localize(77,null)],default:"on",description:s.localize(78,null)})}validate(Y){let me=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Y!="undefined"&&(typeof Y=="function"?(me=4,Le=Y):Y==="interval"?me=3:Y==="relative"?me=2:Y==="on"?me=1:me=0),{renderType:me,renderFn:Le}}}function ke(q){const Y=q.get(88);return Y==="editable"?q.get(82):Y!=="on"}e.filterValidationDecorations=ke;class Se extends S{constructor(){const Y=[],me={type:"number",description:s.localize(79,null)};super(92,"rulers",Y,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:s.localize(80,null),format:"color-hex"}}}]},default:Y,description:s.localize(81,null)})}validate(Y){if(Array.isArray(Y)){const me=[];for(let Le of Y)if(typeof Le=="number")me.push({column:y.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const ze=Le;me.push({column:y.clampedInt(ze.column,0,0,1e4),color:ze.color})}return me.sort((Le,ze)=>Le.column-ze.column),me}return this.defaultValue}}function Pe(q,Y){if(typeof q!="string")return Y;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class re extends S{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(82,null),s.localize(83,null),s.localize(84,null)],default:"auto",description:s.localize(85,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(86,null),s.localize(87,null),s.localize(88,null)],default:"auto",description:s.localize(89,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:s.localize(90,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:s.localize(91,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:s.localize(92,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y,Le=y.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=y.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:y.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(me.vertical,this.defaultValue.vertical),horizontal:Pe(me.horizontal,this.defaultValue.horizontal),useShadows:d(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:y.clampedInt(me.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:y.clampedInt(me.verticalSliderSize,ze,0,1e3),scrollByPage:d(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ae extends S{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(114,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:s.localize(93,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:s.localize(94,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:s.localize(95,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:s.localize(96,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:s.localize(97,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:s.localize(98,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:s.localize(99,null)}})}applyUpdate(Y,me){let Le=!1;me.allowedCharacters&&(I.equals(Y.allowedCharacters,me.allowedCharacters)||(Y={...Y,allowedCharacters:me.allowedCharacters},Le=!0)),me.allowedLocales&&(I.equals(Y.allowedLocales,me.allowedLocales)||(Y={...Y,allowedLocales:me.allowedLocales},Le=!0));const ze=super.applyUpdate(Y,me);return Le?new m(ze.newValue,!0):ze}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{nonBasicASCII:B(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:B(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:B(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,me){if(typeof Y!="object"||!Y)return me;const Le={};for(const[ze,Ge]of Object.entries(Y))Ge===!0&&(Le[ze]=!0);return Le}}class X extends S{constructor(){const Y={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:s.localize(100,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:d(me.enabled,this.defaultValue.enabled),mode:r(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class G extends S{constructor(){const Y={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:s.localize(101,null)},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:s.localize(102,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:d(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class T extends S{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(103,null),s.localize(104,null),s.localize(105,null)],default:Y.bracketPairs,description:s.localize(106,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(107,null),s.localize(108,null),s.localize(109,null)],default:Y.bracketPairsHorizontal,description:s.localize(110,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:s.localize(111,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:s.localize(112,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(113,null),s.localize(114,null),s.localize(115,null)],default:Y.highlightActiveIndentation,description:s.localize(116,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{bracketPairs:B(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:B(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:B(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function B(q,Y,me){const Le=me.indexOf(q);return Le===-1?Y:me[Le]}class H extends S{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(107,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(117,null),s.localize(118,null)],default:Y.insertMode,description:s.localize(119,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:s.localize(120,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:s.localize(121,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:s.localize(122,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:s.localize(123,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:s.localize(124,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:s.localize(125,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:s.localize(126,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:s.localize(127,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(128,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(129,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(130,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(131,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(132,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(133,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(134,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(135,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(136,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(137,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(138,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(139,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(140,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(141,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(142,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(143,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(144,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(145,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(146,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(147,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(148,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(149,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(150,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(151,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(152,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(153,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(154,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(155,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(156,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(157,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(158,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertMode:r(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(me.showIcons,this.defaultValue.showIcons),showStatusBar:d(me.showStatusBar,this.defaultValue.showStatusBar),preview:d(me.preview,this.defaultValue.preview),previewMode:r(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(me.showMethods,this.defaultValue.showMethods),showFunctions:d(me.showFunctions,this.defaultValue.showFunctions),showConstructors:d(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(me.showDeprecated,this.defaultValue.showDeprecated),showFields:d(me.showFields,this.defaultValue.showFields),showVariables:d(me.showVariables,this.defaultValue.showVariables),showClasses:d(me.showClasses,this.defaultValue.showClasses),showStructs:d(me.showStructs,this.defaultValue.showStructs),showInterfaces:d(me.showInterfaces,this.defaultValue.showInterfaces),showModules:d(me.showModules,this.defaultValue.showModules),showProperties:d(me.showProperties,this.defaultValue.showProperties),showEvents:d(me.showEvents,this.defaultValue.showEvents),showOperators:d(me.showOperators,this.defaultValue.showOperators),showUnits:d(me.showUnits,this.defaultValue.showUnits),showValues:d(me.showValues,this.defaultValue.showValues),showConstants:d(me.showConstants,this.defaultValue.showConstants),showEnums:d(me.showEnums,this.defaultValue.showEnums),showEnumMembers:d(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(me.showKeywords,this.defaultValue.showKeywords),showWords:d(me.showWords,this.defaultValue.showWords),showColors:d(me.showColors,this.defaultValue.showColors),showFiles:d(me.showFiles,this.defaultValue.showFiles),showReferences:d(me.showReferences,this.defaultValue.showReferences),showFolders:d(me.showFolders,this.defaultValue.showFolders),showTypeParameters:d(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(me.showSnippets,this.defaultValue.showSnippets),showUsers:d(me.showUsers,this.defaultValue.showUsers),showIssues:d(me.showIssues,this.defaultValue.showIssues)}}}class V extends S{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(159,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ne extends f{constructor(){super(131)}compute(Y,me,Le){return me.get(82)?!0:Y.tabFocusMode}}var ue;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(ue||(e.WrappingIndent=ue={}));function Q(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends f{constructor(){super(133)}compute(Y,me,Le){const ze=me.get(132);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}const pe="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?Ne:C.isLinux?Be:pe,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ae(q){return e.editorOptionsRegistry[q.id]=q,q}var Ke;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.enableDropIntoEditor=32]="enableDropIntoEditor",q[q.emptySelectionClipboard=33]="emptySelectionClipboard",q[q.extraEditorClassName=34]="extraEditorClassName",q[q.fastScrollSensitivity=35]="fastScrollSensitivity",q[q.find=36]="find",q[q.fixedOverflowWidgets=37]="fixedOverflowWidgets",q[q.folding=38]="folding",q[q.foldingStrategy=39]="foldingStrategy",q[q.foldingHighlight=40]="foldingHighlight",q[q.foldingImportsByDefault=41]="foldingImportsByDefault",q[q.foldingMaximumRegions=42]="foldingMaximumRegions",q[q.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=44]="fontFamily",q[q.fontInfo=45]="fontInfo",q[q.fontLigatures=46]="fontLigatures",q[q.fontSize=47]="fontSize",q[q.fontWeight=48]="fontWeight",q[q.formatOnPaste=49]="formatOnPaste",q[q.formatOnType=50]="formatOnType",q[q.glyphMargin=51]="glyphMargin",q[q.gotoLocation=52]="gotoLocation",q[q.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",q[q.hover=54]="hover",q[q.inDiffEditor=55]="inDiffEditor",q[q.inlineSuggest=56]="inlineSuggest",q[q.letterSpacing=57]="letterSpacing",q[q.lightbulb=58]="lightbulb",q[q.lineDecorationsWidth=59]="lineDecorationsWidth",q[q.lineHeight=60]="lineHeight",q[q.lineNumbers=61]="lineNumbers",q[q.lineNumbersMinChars=62]="lineNumbersMinChars",q[q.linkedEditing=63]="linkedEditing",q[q.links=64]="links",q[q.matchBrackets=65]="matchBrackets",q[q.minimap=66]="minimap",q[q.mouseStyle=67]="mouseStyle",q[q.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=69]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",q[q.multiCursorModifier=71]="multiCursorModifier",q[q.multiCursorPaste=72]="multiCursorPaste",q[q.occurrencesHighlight=73]="occurrencesHighlight",q[q.overviewRulerBorder=74]="overviewRulerBorder",q[q.overviewRulerLanes=75]="overviewRulerLanes",q[q.padding=76]="padding",q[q.parameterHints=77]="parameterHints",q[q.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",q[q.quickSuggestions=80]="quickSuggestions",q[q.quickSuggestionsDelay=81]="quickSuggestionsDelay",q[q.readOnly=82]="readOnly",q[q.renameOnType=83]="renameOnType",q[q.renderControlCharacters=84]="renderControlCharacters",q[q.renderFinalNewline=85]="renderFinalNewline",q[q.renderLineHighlight=86]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=88]="renderValidationDecorations",q[q.renderWhitespace=89]="renderWhitespace",q[q.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",q[q.roundedSelection=91]="roundedSelection",q[q.rulers=92]="rulers",q[q.scrollbar=93]="scrollbar",q[q.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=95]="scrollBeyondLastLine",q[q.scrollPredominantAxis=96]="scrollPredominantAxis",q[q.selectionClipboard=97]="selectionClipboard",q[q.selectionHighlight=98]="selectionHighlight",q[q.selectOnLineNumbers=99]="selectOnLineNumbers",q[q.showFoldingControls=100]="showFoldingControls",q[q.showUnused=101]="showUnused",q[q.snippetSuggestions=102]="snippetSuggestions",q[q.smartSelect=103]="smartSelect",q[q.smoothScrolling=104]="smoothScrolling",q[q.stickyTabStops=105]="stickyTabStops",q[q.stopRenderingLineAfter=106]="stopRenderingLineAfter",q[q.suggest=107]="suggest",q[q.suggestFontSize=108]="suggestFontSize",q[q.suggestLineHeight=109]="suggestLineHeight",q[q.suggestOnTriggerCharacters=110]="suggestOnTriggerCharacters",q[q.suggestSelection=111]="suggestSelection",q[q.tabCompletion=112]="tabCompletion",q[q.tabIndex=113]="tabIndex",q[q.unicodeHighlighting=114]="unicodeHighlighting",q[q.unusualLineTerminators=115]="unusualLineTerminators",q[q.useShadowDOM=116]="useShadowDOM",q[q.useTabStops=117]="useTabStops",q[q.wordSeparators=118]="wordSeparators",q[q.wordWrap=119]="wordWrap",q[q.wordWrapBreakAfterCharacters=120]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=121]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=122]="wordWrapColumn",q[q.wordWrapOverride1=123]="wordWrapOverride1",q[q.wordWrapOverride2=124]="wordWrapOverride2",q[q.wrappingIndent=125]="wrappingIndent",q[q.wrappingStrategy=126]="wrappingStrategy",q[q.showDeprecated=127]="showDeprecated",q[q.inlayHints=128]="inlayHints",q[q.editorClassName=129]="editorClassName",q[q.pixelRatio=130]="pixelRatio",q[q.tabFocusMode=131]="tabFocusMode",q[q.layoutInfo=132]="layoutInfo",q[q.wrappingInfo=133]="wrappingInfo"})(Ke||(e.EditorOption=Ke={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(160,null)})),acceptSuggestionOnEnter:Ae(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(161,null),""],markdownDescription:s.localize(162,null)})),accessibilitySupport:Ae(new n),accessibilityPageSize:Ae(new y(3,"accessibilityPageSize",10,1,1073741824,{description:s.localize(163,null)})),ariaLabel:Ae(new D(4,"ariaLabel",s.localize(164,null))),autoClosingBrackets:Ae(new h(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(165,null),s.localize(166,null),""],description:s.localize(167,null)})),autoClosingDelete:Ae(new h(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(168,null),""],description:s.localize(169,null)})),autoClosingOvertype:Ae(new h(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(170,null),""],description:s.localize(171,null)})),autoClosingQuotes:Ae(new h(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(172,null),s.localize(173,null),""],description:s.localize(174,null)})),autoIndent:Ae(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[s.localize(175,null),s.localize(176,null),s.localize(177,null),s.localize(178,null),s.localize(179,null)],description:s.localize(180,null)})),automaticLayout:Ae(new c(10,"automaticLayout",!1)),autoSurround:Ae(new h(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(181,null),s.localize(182,null),s.localize(183,null),""],description:s.localize(184,null)})),bracketPairColorization:Ae(new G),bracketPairGuides:Ae(new T),stickyTabStops:Ae(new c(105,"stickyTabStops",!1,{description:s.localize(185,null)})),codeLens:Ae(new c(14,"codeLens",!0,{description:s.localize(186,null)})),codeLensFontFamily:Ae(new D(15,"codeLensFontFamily","",{description:s.localize(187,null)})),codeLensFontSize:Ae(new y(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(188,null)})),colorDecorators:Ae(new c(17,"colorDecorators",!0,{description:s.localize(189,null)})),columnSelection:Ae(new c(18,"columnSelection",!1,{description:s.localize(190,null)})),comments:Ae(new t),contextmenu:Ae(new c(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new c(21,"copyWithSyntaxHighlighting",!0,{description:s.localize(191,null)})),cursorBlinking:Ae(new i(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:s.localize(192,null)})),cursorSmoothCaretAnimation:Ae(new c(23,"cursorSmoothCaretAnimation",!1,{description:s.localize(193,null)})),cursorStyle:Ae(new i(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],x,{description:s.localize(194,null)})),cursorSurroundingLines:Ae(new y(25,"cursorSurroundingLines",0,0,1073741824,{description:s.localize(195,null)})),cursorSurroundingLinesStyle:Ae(new h(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(196,null),s.localize(197,null)],description:s.localize(198,null)})),cursorWidth:Ae(new y(27,"cursorWidth",0,0,1073741824,{markdownDescription:s.localize(199,null)})),disableLayerHinting:Ae(new c(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new c(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new c(30,"domReadOnly",!1)),dragAndDrop:Ae(new c(31,"dragAndDrop",!0,{description:s.localize(200,null)})),emptySelectionClipboard:Ae(new R),enableDropIntoEditor:Ae(new c(32,"enableDropIntoEditor",!0)),extraEditorClassName:Ae(new D(34,"extraEditorClassName","")),fastScrollSensitivity:Ae(new a(35,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:s.localize(201,null)})),find:Ae(new p),fixedOverflowWidgets:Ae(new c(37,"fixedOverflowWidgets",!1)),folding:Ae(new c(38,"folding",!0,{description:s.localize(202,null)})),foldingStrategy:Ae(new h(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(203,null),s.localize(204,null)],description:s.localize(205,null)})),foldingHighlight:Ae(new c(40,"foldingHighlight",!0,{description:s.localize(206,null)})),foldingImportsByDefault:Ae(new c(41,"foldingImportsByDefault",!1,{description:s.localize(207,null)})),foldingMaximumRegions:Ae(new y(42,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(208,null)})),unfoldOnClickAfterEndOfLine:Ae(new c(43,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(209,null)})),fontFamily:Ae(new D(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(210,null)})),fontInfo:Ae(new M),fontLigatures2:Ae(new F),fontSize:Ae(new z),fontWeight:Ae(new Z),formatOnPaste:Ae(new c(49,"formatOnPaste",!1,{description:s.localize(211,null)})),formatOnType:Ae(new c(50,"formatOnType",!1,{description:s.localize(212,null)})),glyphMargin:Ae(new c(51,"glyphMargin",!0,{description:s.localize(213,null)})),gotoLocation:Ae(new K),hideCursorInOverviewRuler:Ae(new c(53,"hideCursorInOverviewRuler",!1,{description:s.localize(214,null)})),hover:Ae(new N),inDiffEditor:Ae(new c(55,"inDiffEditor",!1)),letterSpacing:Ae(new a(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>a.clamp(q,-5,20),{description:s.localize(215,null)})),lightbulb:Ae(new oe),lineDecorationsWidth:Ae(new u(59,"lineDecorationsWidth",10)),lineHeight:Ae(new be),lineNumbers:Ae(new Xe),lineNumbersMinChars:Ae(new y(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new c(63,"linkedEditing",!1,{description:s.localize(216,null)})),links:Ae(new c(64,"links",!0,{description:s.localize(217,null)})),matchBrackets:Ae(new h(65,"matchBrackets","always",["always","near","never"],{description:s.localize(218,null)})),minimap:Ae(new ce),mouseStyle:Ae(new h(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new a(68,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:s.localize(219,null)})),mouseWheelZoom:Ae(new c(69,"mouseWheelZoom",!1,{markdownDescription:s.localize(220,null)})),multiCursorMergeOverlapping:Ae(new c(70,"multiCursorMergeOverlapping",!0,{description:s.localize(221,null)})),multiCursorModifier:Ae(new i(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ve,{markdownEnumDescriptions:[s.localize(222,null),s.localize(223,null)],markdownDescription:s.localize(224,null)})),multiCursorPaste:Ae(new h(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(225,null),s.localize(226,null)],markdownDescription:s.localize(227,null)})),occurrencesHighlight:Ae(new c(73,"occurrencesHighlight",!0,{description:s.localize(228,null)})),overviewRulerBorder:Ae(new c(74,"overviewRulerBorder",!0,{description:s.localize(229,null)})),overviewRulerLanes:Ae(new y(75,"overviewRulerLanes",3,0,3)),padding:Ae(new J),parameterHints:Ae(new Ee),peekWidgetDefaultFocus:Ae(new h(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(230,null),s.localize(231,null)],description:s.localize(232,null)})),definitionLinkOpensInPeek:Ae(new c(79,"definitionLinkOpensInPeek",!1,{description:s.localize(233,null)})),quickSuggestions:Ae(new Fe),quickSuggestionsDelay:Ae(new y(81,"quickSuggestionsDelay",10,0,1073741824,{description:s.localize(234,null)})),readOnly:Ae(new c(82,"readOnly",!1)),renameOnType:Ae(new c(83,"renameOnType",!1,{description:s.localize(235,null),markdownDeprecationMessage:s.localize(236,null)})),renderControlCharacters:Ae(new c(84,"renderControlCharacters",!0,{description:s.localize(237,null),restricted:!0})),renderFinalNewline:Ae(new c(85,"renderFinalNewline",!0,{description:s.localize(238,null)})),renderLineHighlight:Ae(new h(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(239,null)],description:s.localize(240,null)})),renderLineHighlightOnlyWhenFocus:Ae(new c(87,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(241,null)})),renderValidationDecorations:Ae(new h(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new h(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(242,null),s.localize(243,null),s.localize(244,null),""],description:s.localize(245,null)})),revealHorizontalRightPadding:Ae(new y(90,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ae(new c(91,"roundedSelection",!0,{description:s.localize(246,null)})),rulers:Ae(new Se),scrollbar:Ae(new re),scrollBeyondLastColumn:Ae(new y(94,"scrollBeyondLastColumn",5,0,1073741824,{description:s.localize(247,null)})),scrollBeyondLastLine:Ae(new c(95,"scrollBeyondLastLine",!0,{description:s.localize(248,null)})),scrollPredominantAxis:Ae(new c(96,"scrollPredominantAxis",!0,{description:s.localize(249,null)})),selectionClipboard:Ae(new c(97,"selectionClipboard",!0,{description:s.localize(250,null),included:C.isLinux})),selectionHighlight:Ae(new c(98,"selectionHighlight",!0,{description:s.localize(251,null)})),selectOnLineNumbers:Ae(new c(99,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new h(100,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[s.localize(252,null),s.localize(253,null)],description:s.localize(254,null)})),showUnused:Ae(new c(101,"showUnused",!0,{description:s.localize(255,null)})),showDeprecated:Ae(new c(127,"showDeprecated",!0,{description:s.localize(256,null)})),inlayHints:Ae(new fe),snippetSuggestions:Ae(new h(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(257,null),s.localize(258,null),s.localize(259,null),s.localize(260,null)],description:s.localize(261,null)})),smartSelect:Ae(new V),smoothScrolling:Ae(new c(104,"smoothScrolling",!1,{description:s.localize(262,null)})),stopRenderingLineAfter:Ae(new y(106,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ae(new H),inlineSuggest:Ae(new X),suggestFontSize:Ae(new y(108,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(263,null)})),suggestLineHeight:Ae(new y(109,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(264,null)})),suggestOnTriggerCharacters:Ae(new c(110,"suggestOnTriggerCharacters",!0,{description:s.localize(265,null)})),suggestSelection:Ae(new h(111,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(266,null),s.localize(267,null),s.localize(268,null)],description:s.localize(269,null)})),tabCompletion:Ae(new h(112,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(270,null),s.localize(271,null),s.localize(272,null)],description:s.localize(273,null)})),tabIndex:Ae(new y(113,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ae(new ae),unusualLineTerminators:Ae(new h(115,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(274,null),s.localize(275,null),s.localize(276,null)],description:s.localize(277,null)})),useShadowDOM:Ae(new c(116,"useShadowDOM",!0)),useTabStops:Ae(new c(117,"useTabStops",!0,{description:s.localize(278,null)})),wordSeparators:Ae(new D(118,"wordSeparators",g.USUAL_WORD_SEPARATORS,{description:s.localize(279,null)})),wordWrap:Ae(new h(119,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(280,null),s.localize(281,null),s.localize(282,null),s.localize(283,null)],description:s.localize(284,null)})),wordWrapBreakAfterCharacters:Ae(new D(120,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new D(121,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new y(122,"wordWrapColumn",80,1,1073741824,{markdownDescription:s.localize(285,null)})),wordWrapOverride1:Ae(new h(123,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new h(124,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ae(new i(125,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Q,{enumDescriptions:[s.localize(286,null),s.localize(287,null),s.localize(288,null),s.localize(289,null)],description:s.localize(290,null)})),wrappingStrategy:Ae(new h(126,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[s.localize(291,null),s.localize(292,null)],description:s.localize(293,null)})),editorClassName:Ae(new $),pixelRatio:Ae(new _e),tabFocusMode:Ae(new ne),layoutInfo:Ae(new le),wrappingInfo:Ae(new ge)}}),define(Ie[122],Te([17,18]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[123],Te([17,18]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[124],Te([17,18]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[125],Te([17,18]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ie[126],Te([17,18]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ie[127],Te([17,18]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Ie[128],Te([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[129],Te([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[130],Te([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[131],Te([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[132],Te([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[133],Te([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[134],Te([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[135],Te([17,18]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ie[136],Te([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[137],Te([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[138],Te([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[139],Te([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[140],Te([17,18]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[141],Te([17,18]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[142],Te([17,18]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[143],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var s;(function(P){P[P.ACTIVATE=1]="ACTIVATE",P[P.RESTORE=2]="RESTORE",P[P.PRESERVE=3]="PRESERVE"})(s||(e.EditorActivation=s={}));var C;(function(P){P[P.PICK=0]="PICK",P[P.DISABLED=1]="DISABLED",P[P.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(C||(e.EditorResolution=C={}));var g;(function(P){P[P.API=0]="API",P[P.USER=1]="USER"})(g||(e.EditorOpenSource=g={}));var U;(function(P){P[P.Center=0]="Center",P[P.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",P[P.NearTop=2]="NearTop",P[P.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(U||(e.TextEditorSelectionRevealType=U={}));var I;(function(P){P.PROGRAMMATIC="api",P.NAVIGATION="code.navigation",P.JUMP="code.jump"})(I||(e.TextEditorSelectionSource=I={}))}),define(Ie[144],Te([1,0,21,29,124,236]),function(ee,e,s,C,g,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function w(c){return c=c.trim(),c==="*"||I.test(c)}e.isValidVersionStr=w;function A(c){if(!w(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let k=c.match(I);return k?{hasCaret:k[1]==="^",hasGreaterEquals:k[1]===">=",majorBase:k[2]==="x"?0:parseInt(k[2],10),majorMustEqual:k[2]!=="x",minorBase:k[4]==="x"?0:parseInt(k[4],10),minorMustEqual:k[4]!=="x",patchBase:k[6]==="x"?0:parseInt(k[6],10),patchMustEqual:k[6]!=="x",preRelease:k[8]||null}:null}e.parseVersion=A;function O(c){if(!c)return null;let k=c.majorBase,y=c.majorMustEqual,a=c.minorBase,D=c.minorMustEqual,r=c.patchBase,h=c.patchMustEqual;c.hasCaret&&(k===0||(D=!1),h=!1);let i=0;if(c.preRelease){const o=P.exec(c.preRelease);if(o){const[,n,t,l]=o;i=Date.UTC(Number(n),Number(t)-1,Number(l))}}return{majorBase:k,majorMustEqual:y,minorBase:a,minorMustEqual:D,patchBase:r,patchMustEqual:h,isMinimum:c.hasGreaterEquals,notBefore:i}}e.normalizeVersion=O;function S(c,k,y){let a;typeof c=="string"?a=O(A(c)):a=c;let D;k instanceof Date?D=k.getTime():typeof k=="string"&&(D=new Date(k).getTime());let r;if(typeof y=="string"?r=O(A(y)):r=y,!a||!r)return!1;let h=a.majorBase,i=a.minorBase,o=a.patchBase,n=r.majorBase,t=r.minorBase,l=r.patchBase,b=r.notBefore,v=r.majorMustEqual,E=r.minorMustEqual,x=r.patchMustEqual;return r.isMinimum?h>n?!0:h<n?!1:i>t?!0:i<t||D&&D<b?!1:o>=l:(h===1&&n===0&&(!v||!E||!x)&&(n=1,t=0,l=0,v=!0,E=!1,x=!1),h<n?!1:h>n?!v:i<t?!1:i>t?!E:o<l?!1:o>l?!x:!(D&&D<b))}e.isValidVersion=S;function m(c,k,y,a,D){const r=[];if(typeof a.publisher!="undefined"&&typeof a.publisher!="string")return r.push([C.default.Error,g.localize(0,null)]),r;if(typeof a.name!="string")return r.push([C.default.Error,g.localize(1,null,"name")]),r;if(typeof a.version!="string")return r.push([C.default.Error,g.localize(2,null,"version")]),r;if(!a.engines)return r.push([C.default.Error,g.localize(3,null,"engines")]),r;if(typeof a.engines.vscode!="string")return r.push([C.default.Error,g.localize(4,null,"engines.vscode")]),r;if(typeof a.extensionDependencies!="undefined"&&!d(a.extensionDependencies))return r.push([C.default.Error,g.localize(5,null,"extensionDependencies")]),r;if(typeof a.activationEvents!="undefined"){if(!d(a.activationEvents))return r.push([C.default.Error,g.localize(6,null,"activationEvents")]),r;if(typeof a.main=="undefined"&&typeof a.browser=="undefined")return r.push([C.default.Error,g.localize(7,null,"activationEvents","main")]),r}if(typeof a.extensionKind!="undefined"&&typeof a.main=="undefined"&&r.push([C.default.Warning,g.localize(8,null,"extensionKind")]),typeof a.main!="undefined"){if(typeof a.main!="string")return r.push([C.default.Error,g.localize(9,null,"main")]),r;{const o=(0,s.joinPath)(y,a.main);(0,s.isEqualOrParent)(o,y)||r.push([C.default.Warning,g.localize(10,null,o.path,y.path)])}if(typeof a.activationEvents=="undefined")return r.push([C.default.Error,g.localize(11,null,"activationEvents","main")]),r}if(typeof a.browser!="undefined"){if(typeof a.browser!="string")return r.push([C.default.Error,g.localize(12,null,"browser")]),r;{const o=(0,s.joinPath)(y,a.browser);(0,s.isEqualOrParent)(o,y)||r.push([C.default.Warning,g.localize(13,null,o.path,y.path)])}if(typeof a.activationEvents=="undefined")return r.push([C.default.Error,g.localize(14,null,"activationEvents","browser")]),r}if(!U.valid(a.version))return r.push([C.default.Error,g.localize(15,null)]),r;const h=[];if(!_(c,k,a,D,h))for(const o of h)r.push([C.default.Error,o]);return r}e.validateExtensionManifest=m;function _(c,k,y,a,D){return a||typeof y.main=="undefined"&&typeof y.browser=="undefined"?!0:u(c,k,y.engines.vscode,D)}e.isValidExtensionVersion=_;function f(c,k,y){return c==="*"||u(k,y,c)}e.isEngineValid=f;function u(c,k,y,a=[]){let D=O(A(y));if(!D)return a.push(g.localize(16,null,y)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return a.push(g.localize(17,null,y)),!1}else if(!D.majorMustEqual)return a.push(g.localize(18,null,y)),!1;return S(c,k,D)?!0:(a.push(g.localize(19,null,c,y)),!1)}function d(c){if(!Array.isArray(c))return!1;for(let k=0,y=c.length;k<y;k++)if(typeof c[k]!="string")return!1;return!0}}),define(Ie[78],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class s{constructor(g,U=[],I=!1){this.ctor=g,this.staticArguments=U,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=s}),define(Ie[58],Te([1,0,78]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const C=[];function g(I,P,w){P instanceof s.SyncDescriptor||(P=new s.SyncDescriptor(P,[],w)),C.push([I,P])}e.registerSingleton=g;function U(){return C}e.getSingletonServiceDescriptors=U}),define(Ie[145],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class s{constructor(U){this.incoming=new Map,this.outgoing=new Map,this.data=U}}e.Node=s;class C{constructor(U){this._hashFn=U,this._nodes=new Map}roots(){const U=[];for(let I of this._nodes.values())I.outgoing.size===0&&U.push(I);return U}insertEdge(U,I){const P=this.lookupOrInsertNode(U),w=this.lookupOrInsertNode(I);P.outgoing.set(this._hashFn(I),w),w.incoming.set(this._hashFn(U),P)}removeNode(U){const I=this._hashFn(U);this._nodes.delete(I);for(let P of this._nodes.values())P.outgoing.delete(I),P.incoming.delete(I)}lookupOrInsertNode(U){const I=this._hashFn(U);let P=this._nodes.get(I);return P||(P=new s(U),this._nodes.set(I,P)),P}lookup(U){return this._nodes.get(this._hashFn(U))}isEmpty(){return this._nodes.size===0}toString(){let U=[];for(let[I,P]of this._nodes)U.push(`${I}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return U.join(`
`)}findCycleSlow(){for(let[U,I]of this._nodes){const P=new Set([U]),w=this._findCycle(I,P);if(w)return w}}_findCycle(U,I){for(let[P,w]of U.outgoing){if(I.has(P))return[...I,P].join(" -> ");I.add(P);const A=this._findCycle(w,I);if(A)return A;I.delete(P)}}}e.Graph=C}),define(Ie[3],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var s;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function P(w){return w[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=P})(s||(e._util=s={})),e.IInstantiationService=g("instantiationService");function C(I,P,w){P[s.DI_TARGET]===P?P[s.DI_DEPENDENCIES].push({id:I,index:w}):(P[s.DI_DEPENDENCIES]=[{id:I,index:w}],P[s.DI_TARGET]=P)}function g(I){if(s.serviceIds.has(I))return s.serviceIds.get(I);const P=function(w,A,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(P,w,O)};return P.toString=()=>I,s.serviceIds.set(I,P),P}e.createDecorator=g;function U(I){return I}e.refineServiceDecorator=U}),define(Ie[59],Te([1,0,9,2,3]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,g.createDecorator)("configurationService");function U(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof C.URI)}e.isConfigurationOverrides=U;function I(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||s.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=I;var P;(function(c){c[c.USER=1]="USER",c[c.USER_LOCAL=2]="USER_LOCAL",c[c.USER_REMOTE=3]="USER_REMOTE",c[c.WORKSPACE=4]="WORKSPACE",c[c.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",c[c.DEFAULT=6]="DEFAULT",c[c.MEMORY=7]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function w(c){switch(c){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=w;function A(c,k){const y=Object.create(null);for(let a in c)O(y,a,c[a],k);return y}e.toValuesTree=A;function O(c,k,y,a){const D=k.split("."),r=D.pop();let h=c;for(let i=0;i<D.length;i++){let o=D[i],n=h[o];switch(typeof n){case"undefined":n=h[o]=Object.create(null);break;case"object":break;default:a(`Ignoring ${k} as ${D.slice(0,i+1).join(".")} is ${JSON.stringify(n)}`);return}h=n}if(typeof h=="object"&&h!==null)try{h[r]=y}catch{a(`Ignoring ${k} as ${D.join(".")} is ${JSON.stringify(h)}`)}else a(`Ignoring ${k} as ${D.join(".")} is ${JSON.stringify(h)}`)}e.addToValueTree=O;function S(c,k){const y=k.split(".");m(c,y)}e.removeFromValueTree=S;function m(c,k){const y=k.shift();if(k.length===0){delete c[y];return}if(Object.keys(c).indexOf(y)!==-1){const a=c[y];typeof a=="object"&&!Array.isArray(a)&&(m(a,k),Object.keys(a).length===0&&delete c[y])}}function _(c,k,y){function a(h,i){let o=h;for(const n of i){if(typeof o!="object"||o===null)return;o=o[n]}return o}const D=k.split("."),r=a(c,D);return typeof r=="undefined"?y:r}e.getConfigurationValue=_;function f(c,k,y){Object.keys(k).forEach(a=>{a!=="__proto__"&&(a in c?s.isObject(c[a])&&s.isObject(k[a])?f(c[a],k[a],y):y&&(c[a]=k[a]):c[a]=k[a])})}e.merge=f;function u(c,k,y){const a=c.inspect(k),D=c.inspect(y);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof D.userValue!="undefined"||typeof D.workspaceValue!="undefined"||typeof D.workspaceFolderValue!="undefined"?D.value:a.defaultValue}e.getMigratedSettingValue=u;function d(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(Ie[38],Te([1,0,22,10,3]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const U=new Map;U.set("false",!1),U.set("true",!0),U.set("isMac",s.isMacintosh),U.set("isLinux",s.isLinux),U.set("isWindows",s.isWindows),U.set("isWeb",s.isWeb),U.set("isMacNative",s.isMacintosh&&!s.isWeb),U.set("isEdge",s.isEdge),U.set("isFirefox",s.isFirefox),U.set("isChrome",s.isChrome),U.set("isSafari",s.isSafari);const I=Object.prototype.hasOwnProperty;var P;(function(R){R[R.False=0]="False",R[R.True=1]="True",R[R.Defined=2]="Defined",R[R.Not=3]="Not",R[R.Equals=4]="Equals",R[R.NotEquals=5]="NotEquals",R[R.And=6]="And",R[R.Regex=7]="Regex",R[R.NotRegex=8]="NotRegex",R[R.Or=9]="Or",R[R.In=10]="In",R[R.NotIn=11]="NotIn",R[R.Greater=12]="Greater",R[R.GreaterEquals=13]="GreaterEquals",R[R.Smaller=14]="Smaller",R[R.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));class w{static false(){return S.INSTANCE}static true(){return m.INSTANCE}static has(p){return _.create(p)}static equals(p,F){return f.create(p,F)}static notEquals(p,F){return c.create(p,F)}static regex(p,F){return i.create(p,F)}static in(p,F){return u.create(p,F)}static not(p){return k.create(p)}static and(...p){return t.create(p,null)}static or(...p){return l.create(p,null,!0)}static greater(p,F){return a.create(p,F)}static greaterEquals(p,F){return D.create(p,F)}static smaller(p,F){return r.create(p,F)}static smallerEquals(p,F){return h.create(p,F)}static deserialize(p,F=!1){if(!!p)return this._deserializeOrExpression(p,F)}static _deserializeOrExpression(p,F){let M=p.split("||");return l.create(M.map(z=>this._deserializeAndExpression(z,F)),null,!0)}static _deserializeAndExpression(p,F){let M=p.split("&&");return t.create(M.map(z=>this._deserializeOne(z,F)),null)}static _deserializeOne(p,F){if(p=p.trim(),p.indexOf("!=")>=0){let M=p.split("!=");return c.create(M[0].trim(),this._deserializeValue(M[1],F))}if(p.indexOf("==")>=0){let M=p.split("==");return f.create(M[0].trim(),this._deserializeValue(M[1],F))}if(p.indexOf("=~")>=0){let M=p.split("=~");return i.create(M[0].trim(),this._deserializeRegexValue(M[1],F))}if(p.indexOf(" in ")>=0){let M=p.split(" in ");return u.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(p)){const M=p.split(">=");return D.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(p)){const M=p.split(">");return a.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(p)){const M=p.split("<=");return h.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(p)){const M=p.split("<");return r.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(p)?k.create(p.substr(1).trim()):_.create(p)}static _deserializeValue(p,F){if(p=p.trim(),p==="true")return!0;if(p==="false")return!1;let M=/^'([^']*)'$/.exec(p);return M?M[1].trim():p}static _deserializeRegexValue(p,F){if((0,C.isFalsyOrWhitespace)(p)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=p.indexOf("/"),z=p.lastIndexOf("/");if(M===z||M<0){if(F)throw new Error(`bad regexp-value '${p}', missing /-enclosure`);return console.warn(`bad regexp-value '${p}', missing /-enclosure`),null}let Z=p.slice(M+1,z),K=p[z+1]==="i"?"i":"";try{return new RegExp(Z,K)}catch(N){if(F)throw new Error(`bad regexp-value '${p}', parse error: ${N}`);return console.warn(`bad regexp-value '${p}', parse error: ${N}`),null}}}e.ContextKeyExpr=w;function A(R,p){const F=R?R.substituteConstants():void 0,M=p?p.substituteConstants():void 0;return!F&&!M?!0:!F||!M?!1:F.equals(M)}e.expressionsAreEqualWithConstantSubstitution=A;function O(R,p){return R.cmp(p)}class S{constructor(){this.type=0}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}substituteConstants(){return this}evaluate(p){return!1}serialize(){return"false"}keys(){return[]}map(p){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=S,S.INSTANCE=new S;class m{constructor(){this.type=1}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}substituteConstants(){return this}evaluate(p){return!0}serialize(){return"true"}keys(){return[]}map(p){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class _{static create(p,F=null){const M=U.get(p);return typeof M=="boolean"?M?m.INSTANCE:S.INSTANCE:new _(p,F)}constructor(p,F){this.key=p,this.negated=F,this.type=2}cmp(p){return p.type!==this.type?this.type-p.type:v(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}substituteConstants(){const p=U.get(this.key);return typeof p=="boolean"?p?m.INSTANCE:S.INSTANCE:this}evaluate(p){return!!p.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(p){return p.mapDefined(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=_;class f{static create(p,F,M=null){if(typeof F=="boolean")return F?_.create(p,M):k.create(p,M);const z=U.get(p);return typeof z=="boolean"?F===(z?"true":"false")?m.INSTANCE:S.INSTANCE:new f(p,F,M)}constructor(p,F,M){this.key=p,this.value=F,this.negated=M,this.type=4}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){const p=U.get(this.key);if(typeof p=="boolean"){const F=p?"true":"false";return this.value===F?m.INSTANCE:S.INSTANCE}return this}evaluate(p){return p.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(p){return p.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class u{static create(p,F){return new u(p,F)}constructor(p,F){this.key=p,this.valueKey=F,this.type=10,this.negated=null}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.valueKey,p.key,p.valueKey)}equals(p){return p.type===this.type?this.key===p.key&&this.valueKey===p.valueKey:!1}substituteConstants(){return this}evaluate(p){const F=p.getValue(this.valueKey),M=p.getValue(this.key);return Array.isArray(F)?F.includes(M):typeof M=="string"&&typeof F=="object"&&F!==null?I.call(F,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(p){return p.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyInExpr=u;class d{static create(p){return new d(p)}constructor(p){this._actual=p,this.type=11}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}substituteConstants(){return this}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new d(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotInExpr=d;class c{static create(p,F,M=null){if(typeof F=="boolean")return F?k.create(p,M):_.create(p,M);const z=U.get(p);return typeof z=="boolean"?F===(z?"true":"false")?S.INSTANCE:m.INSTANCE:new c(p,F,M)}constructor(p,F,M){this.key=p,this.value=F,this.negated=M,this.type=5}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){const p=U.get(this.key);if(typeof p=="boolean"){const F=p?"true":"false";return this.value===F?S.INSTANCE:m.INSTANCE}return this}evaluate(p){return p.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(p){return p.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=c;class k{static create(p,F=null){const M=U.get(p);return typeof M=="boolean"?M?S.INSTANCE:m.INSTANCE:new k(p,F)}constructor(p,F){this.key=p,this.negated=F,this.type=3}cmp(p){return p.type!==this.type?this.type-p.type:v(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}substituteConstants(){const p=U.get(this.key);return typeof p=="boolean"?p?S.INSTANCE:m.INSTANCE:this}evaluate(p){return!p.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(p){return p.mapNot(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=k;function y(R,p){if(typeof R=="string"){const F=parseFloat(R);isNaN(F)||(R=F)}return typeof R=="string"||typeof R=="number"?p(R):S.INSTANCE}class a{static create(p,F,M=null){return y(F,z=>new a(p,z,M))}constructor(p,F,M){this.key=p,this.value=F,this.negated=M,this.type=12}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class D{static create(p,F,M=null){return y(F,z=>new D(p,z,M))}constructor(p,F,M){this.key=p,this.value=F,this.negated=M,this.type=13}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=D;class r{static create(p,F,M=null){return y(F,z=>new r(p,z,M))}constructor(p,F,M){this.key=p,this.value=F,this.negated=M,this.type=14}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class h{static create(p,F,M=null){return y(F,z=>new h(p,z,M))}constructor(p,F,M){this.key=p,this.value=F,this.negated=M,this.type=15}cmp(p){return p.type!==this.type?this.type-p.type:E(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=h;class i{static create(p,F){return new i(p,F)}constructor(p,F){this.key=p,this.regexp=F,this.type=7,this.negated=null}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.key<p.key)return-1;if(this.key>p.key)return 1;const F=this.regexp?this.regexp.source:"",M=p.regexp?p.regexp.source:"";return F<M?-1:F>M?1:0}equals(p){if(p.type===this.type){const F=this.regexp?this.regexp.source:"",M=p.regexp?p.regexp.source:"";return this.key===p.key&&F===M}return!1}substituteConstants(){return this}evaluate(p){let F=p.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const p=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${p}`}keys(){return[this.key]}map(p){return p.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class o{static create(p){return new o(p)}constructor(p){this._actual=p,this.type=8}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}substituteConstants(){return this}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new o(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function n(R){let p=null;for(let F=0,M=R.length;F<M;F++){const z=R[F].substituteConstants();if(R[F]!==z&&p===null){p=[];for(let Z=0;Z<F;Z++)p[Z]=R[Z]}p!==null&&(p[F]=z)}return p===null?R:p}class t{static create(p,F){return t._normalizeArr(p,F)}constructor(p,F){this.expr=p,this.negated=F,this.type=6}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const z=O(this.expr[F],p.expr[F]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(p.expr[F]))return!1;return!0}return!1}substituteConstants(){const p=n(this.expr);return p===this.expr?this:t.create(p,this.negated)}evaluate(p){for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].evaluate(p))return!1;return!0}static _normalizeArr(p,F){const M=[];let z=!1;for(const Z of p)if(!!Z){if(Z.type===1){z=!0;continue}if(Z.type===0)return S.INSTANCE;if(Z.type===6){M.push(...Z.expr);continue}M.push(Z)}if(M.length===0&&z)return m.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(O);for(let Z=1;Z<M.length;Z++)M[Z-1].equals(M[Z])&&(M.splice(Z,1),Z--);if(M.length===1)return M[0];for(;M.length>1;){const Z=M[M.length-1];if(Z.type!==9)break;M.pop();const K=M.pop(),N=M.length===0,se=l.create(Z.expr.map(le=>t.create([le,K],null)),null,N);se&&(M.push(se),M.sort(O))}return M.length===1?M[0]:new t(M,F)}}serialize(){return this.expr.map(p=>p.serialize()).join(" && ")}keys(){const p=[];for(let F of this.expr)p.push(...F.keys());return p}map(p){return new t(this.expr.map(F=>F.map(p)),null)}negate(){if(!this.negated){const p=[];for(let F of this.expr)p.push(F.negate());this.negated=l.create(p,this,!0)}return this.negated}}class l{static create(p,F,M){return l._normalizeArr(p,F,M)}constructor(p,F){this.expr=p,this.negated=F,this.type=9}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const z=O(this.expr[F],p.expr[F]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(p.expr[F]))return!1;return!0}return!1}substituteConstants(){const p=n(this.expr);return p===this.expr?this:l.create(p,this.negated,!1)}evaluate(p){for(let F=0,M=this.expr.length;F<M;F++)if(this.expr[F].evaluate(p))return!0;return!1}static _normalizeArr(p,F,M){let z=[],Z=!1;if(p){for(let K=0,N=p.length;K<N;K++){const se=p[K];if(!!se){if(se.type===0){Z=!0;continue}if(se.type===1)return m.INSTANCE;if(se.type===9){z=z.concat(se.expr);continue}z.push(se)}}if(z.length===0&&Z)return S.INSTANCE;z.sort(O)}if(z.length!==0){if(z.length===1)return z[0];for(let K=1;K<z.length;K++)z[K-1].equals(z[K])&&(z.splice(K,1),K--);if(z.length===1)return z[0];if(M){for(let K=0;K<z.length;K++)for(let N=K+1;N<z.length;N++)x(z[K],z[N])&&(z.splice(N,1),N--);if(z.length===1)return z[0]}return new l(z,F)}}serialize(){return this.expr.map(p=>p.serialize()).join(" || ")}keys(){const p=[];for(let F of this.expr)p.push(...F.keys());return p}map(p){return new l(this.expr.map(F=>F.map(p)),null)}negate(){if(!this.negated){let p=[];for(let F of this.expr)p.push(F.negate());for(;p.length>1;){const F=p.shift(),M=p.shift(),z=[];for(const K of $(F))for(const N of $(M))z.push(t.create([K,N],null));const Z=p.length===0;p.unshift(l.create(z,null,Z))}this.negated=p[0]}return this.negated}}class b extends _{static all(){return b._info.values()}constructor(p,F,M){super(p,null);this._defaultValue=F,typeof M=="object"?b._info.push({...M,key:p}):M!==!0&&b._info.push({key:p,description:M,type:F!=null?typeof F:void 0})}bindTo(p){return p.createKey(this.key,this._defaultValue)}getValue(p){return p.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(p){return f.create(this.key,p)}notEqualsTo(p){return c.create(this.key,p)}}e.RawContextKey=b,b._info=[],e.IContextKeyService=(0,g.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(R,p){return R<p?-1:R>p?1:0}function E(R,p,F,M){return R<F?-1:R>F?1:p<M?-1:p>M?1:0}function x(R,p){if(p.type===6&&R.type!==9&&R.type!==6){for(const z of p.expr)if(R.equals(z))return!0}const F=R.negate(),M=$(F).concat($(p));M.sort(O);for(let z=0;z<M.length;z++){const K=M[z].negate();for(let N=z+1;N<M.length;N++){const se=M[N];if(K.equals(se))return!0}}return!1}e.implies=x;function $(R){return R.type===9?R.expr:[R]}}),define(Ie[146],Te([1,0,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,s.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,s.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[79],Te([1,0,123,3]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function g(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=g;function U(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=U;function I(c,k){switch(c){case 3:return k==="x64"?"win32-x64":k==="ia32"?"win32-ia32":k==="arm64"?"win32-arm64":"unknown";case 2:return k==="x64"?"linux-x64":k==="arm64"?"linux-arm64":k==="arm"?"linux-armhf":"unknown";case"alpine":return k==="x64"?"alpine-x64":k==="arm64"?"alpine-arm64":"unknown";case 1:return k==="x64"?"darwin-x64":k==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function P(c,k){return k==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function w(c,k,y){return P(k,y)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===y?!0:A(y).includes(c)}e.isTargetPlatformCompatible=w;function A(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=A;function O(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=O;var S;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var m;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var _;(function(c){c.Install="install",c.Uninstall="uninstall"})(_||(e.StatisticType=_={}));var f;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var u;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(u||(e.ExtensionManagementErrorCode=u={}));class d extends Error{constructor(k,y){super(k);this.code=y,this.name=y}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,s.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,s.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(Ie[39],Te([1,0,11,24,19,10,9,2,125,3]),function(ee,e,s,C,g,U,I,P,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function O(N){return N.create===!0}e.isFileOpenForWriteOptions=O;var S;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var m;(function(N){N[N.Readonly=1]="Readonly"})(m||(e.FilePermission=m={}));var _;(function(N){N[N.None=0]="None",N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead",N[N.FileClone=32768]="FileClone"})(_||(e.FileSystemProviderCapabilities=_={}));function f(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=f;function u(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=u;function d(N){return!!(N.capabilities&32768)}e.hasFileCloneCapability=d;function c(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function k(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=k;function y(N){return f(N)?!!(N.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var a;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class D extends Error{constructor(se,le){super(se);this.code=le}}e.FileSystemProviderError=D;function r(N,se){const le=new D(N.toString(),se);return i(le,se),le}e.createFileSystemProviderError=r;function h(N){return N||r((0,w.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=h;function i(N,se){return N.name=se?`${se} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=i;function o(N){if(!N)return a.Unknown;if(N instanceof D)return N.code;const se=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!se)return a.Unknown;switch(se[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=o;function n(N){if(N instanceof x)return N.fileOperationResult;switch(o(N)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var t;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY",N[N.WRITE=4]="WRITE"})(t||(e.FileOperation=t={}));class l{constructor(se,le,oe){this.resource=se,this.operation=le,this.target=oe}isOperation(se){return this.operation===se}}e.FileOperationEvent=l;var b;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(b||(e.FileChangeType=b={}));class v{constructor(se,le){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=se;const oe=new Map;for(const fe of se){const be=oe.get(fe.type);switch(be?be.push([fe.resource,fe]):oe.set(fe.type,[[fe.resource,fe]]),fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}}for(const[fe,be]of oe)switch(fe){case 1:this.added=C.TernarySearchTree.forUris(()=>le),this.added.fill(be);break;case 0:this.updated=C.TernarySearchTree.forUris(()=>le),this.updated.fill(be);break;case 2:this.deleted=C.TernarySearchTree.forUris(()=>le),this.deleted.fill(be);break}}contains(se,...le){return this.doContains(se,{includeChildren:!1},...le)}affects(se,...le){return this.doContains(se,{includeChildren:!0},...le)}doContains(se,le,...oe){if(!se)return!1;const fe=oe.length>0;return!!((!fe||oe.includes(1))&&(this.added?.get(se)||le.includeChildren&&this.added?.findSuperstr(se))||(!fe||oe.includes(0))&&(this.updated?.get(se)||le.includeChildren&&this.updated?.findSuperstr(se))||(!fe||oe.includes(2))&&(this.deleted?.findSubstr(se)||le.includeChildren&&this.deleted?.findSuperstr(se)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=v;function E(N,se,le){return!N||!se||N===se||se.length>N.length?!1:(se.charAt(se.length-1)!==g.sep&&(se+=g.sep),le?(0,U.startsWithIgnoreCase)(N,se):N.indexOf(se)===0)}e.isParent=E;class x extends s.ErrorNoTelemetry{constructor(se,le,oe){super(se);this.fileOperationResult=le,this.options=oe}}e.FileOperationError=x;class $ extends x{constructor(se,le,oe){super(se,2,oe);this.stat=le}}e.NotModifiedSinceFileOperationError=$;var R;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(R||(e.FileOperationResult=R={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var p;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(p||(e.FileKind=p={})),e.ETAG_DISABLED="";function F(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=F;async function M(N,se){if(!se.hasProvider(P.URI.from({scheme:N.scheme})))return new Promise(le=>{const oe=se.onDidChangeFileSystemProviderRegistrations(fe=>{fe.scheme===N.scheme&&fe.added&&(oe.dispose(),le())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(se){return(0,I.isNumber)(se)||(se=0),se<z.KB?(0,w.localize)(1,null,se.toFixed(0)):se<z.MB?(0,w.localize)(2,null,(se/z.KB).toFixed(2)):se<z.GB?(0,w.localize)(3,null,(se/z.MB).toFixed(2)):se<z.TB?(0,w.localize)(4,null,(se/z.GB).toFixed(2)):(0,w.localize)(5,null,(se/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var Z;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(Z||(e.Arch=Z={}));function K(N){return{maxFileSize:N===0?300*z.MB:16*z.GB,maxHeapSize:N===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=K}),define(Ie[60],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class s{constructor(...g){this._entries=new Map;for(let[U,I]of g)this.set(U,I)}set(g,U){const I=this._entries.get(g);return this._entries.set(g,U),I}has(g){return this._entries.has(g)}get(g){return this._entries.get(g)}}e.ServiceCollection=s}),define(Ie[147],Te([1,0,13,11,78,145,3,60]),function(ee,e,s,C,g,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class A extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class O{constructor(f=new P.ServiceCollection,u=!1,d){this._activeInstantiations=new Set,this._services=f,this._strict=u,this._parent=d,this._services.set(I.IInstantiationService,this)}createChild(f){return new O(f,this._strict,this)}invokeFunction(f,...u){let d=m.traceInvocation(f),c=!1;try{return f({get:y=>{if(c)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(y,d);if(!a)throw new Error(`[invokeFunction] unknown service '${y}'`);return a}},...u)}finally{c=!0,d.stop()}}createInstance(f,...u){let d,c;return f instanceof g.SyncDescriptor?(d=m.traceCreation(f.ctor),c=this._createInstance(f.ctor,f.staticArguments.concat(u),d)):(d=m.traceCreation(f),c=this._createInstance(f,u,d)),d.stop(),c}_createInstance(f,u=[],d){let c=I._util.getServiceDependencies(f).sort((a,D)=>a.index-D.index),k=[];for(const a of c){let D=this._getOrCreateServiceInstance(a.id,d);D||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${a.id}.`,!1),k.push(D)}let y=c.length>0?c[0].index:u.length;if(u.length!==y){console.trace(`[createInstance] First service dependency of ${f.name} at position ${y+1} conflicts with ${u.length} static arguments`);let a=y-u.length;a>0?u=u.concat(new Array(a)):u=u.slice(0,y)}return new f(...[...u,...k])}_setServiceInstance(f,u){if(this._services.get(f)instanceof g.SyncDescriptor)this._services.set(f,u);else if(this._parent)this._parent._setServiceInstance(f,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let u=this._services.get(f);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):u}_getOrCreateServiceInstance(f,u){let d=this._getServiceInstanceOrDescriptor(f);return d instanceof g.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,d,u.branch(f,!0)):(u.branch(f,!1),d)}_safeCreateAndCacheServiceInstance(f,u,d){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,u,d)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,u,d){const c=new U.Graph(a=>a.id.toString());let k=0;const y=[{id:f,desc:u,_trace:d}];for(;y.length;){const a=y.pop();if(c.lookupOrInsertNode(a),k++>1e3)throw new A(c);for(let D of I._util.getServiceDependencies(a.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(D.id);if(r||this._throwIfStrict(`[createInstance] ${f} depends on ${D.id} which is NOT registered.`,!0),r instanceof g.SyncDescriptor){const h={id:D.id,desc:r,_trace:a._trace.branch(D.id,!0)};c.insertEdge(a,h),y.push(h)}}}for(;;){const a=c.roots();if(a.length===0){if(!c.isEmpty())throw new A(c);break}for(const{data:D}of a){if(this._getServiceInstanceOrDescriptor(D.id)instanceof g.SyncDescriptor){const h=this._createServiceInstanceWithOwner(D.id,D.desc.ctor,D.desc.staticArguments,D.desc.supportsDelayedInstantiation,D._trace);this._setServiceInstance(D.id,h)}c.removeNode(D)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,u,d=[],c,k){if(this._services.get(f)instanceof g.SyncDescriptor)return this._createServiceInstance(u,d,c,k);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,u,d,c,k);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(f,u=[],d,c){if(d){const k=new s.IdleValue(()=>this._createInstance(f,u,c));return new Proxy(Object.create(null),{get(y,a){if(a in y)return y[a];let D=k.value,r=D[a];return typeof r!="function"||(r=r.bind(D),y[a]=r),r},set(y,a,D){return k.value[a]=D,!0}})}else return this._createInstance(f,u,c)}_throwIfStrict(f,u){if(u&&console.warn(u),this._strict)throw new Error(f)}}e.InstantiationService=O;var S;(function(_){_[_.None=0]="None",_[_.Creation=1]="Creation",_[_.Invocation=2]="Invocation",_[_.Branch=3]="Branch"})(S||(S={}));class m{static traceInvocation(f){return w?new m(2,f.name||f.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(f){return w?new m(1,f.name):m._None}constructor(f,u){this.type=f,this.name=u,this._start=Date.now(),this._dep=[]}branch(f,u){let d=new m(3,f.toString());return this._dep.push([f,u,d]),d}stop(){let f=Date.now()-this._start;m._totals+=f;let u=!1;function d(k,y){let a=[],D=new Array(k+1).join("	");for(const[r,h,i]of y._dep)if(h&&i){u=!0,a.push(`${D}CREATES -> ${r}`);let o=d(k+1,i);o&&a.push(o)}else a.push(`${D}uses -> ${r}`);return a.join(`
`)}let c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(f>2||u)&&console.log(c.join(`
`))}}e.Trace=m,m._None=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m._totals=0}),define(Ie[14],Te([1,0,45,5,7,22,3]),function(ee,e,s,C,g,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function P(){return new Date().toISOString()}var w;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function A(h,i,o){switch(i){case w.Trace:h.trace(o);break;case w.Debug:h.debug(o);break;case w.Info:h.info(o);break;case w.Warning:h.warn(o);break;case w.Error:h.error(o);break;case w.Critical:h.critical(o);break;default:throw new Error("Invalid log level")}}e.log=A;function O(h){let i="";for(let o=0;o<h.length;o++){let n=h[o];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}i+=(o>0?" ":"")+n}return i}e.format=O;class S extends g.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=S;class m extends S{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...o){this.checkLogLevel(w.Trace)&&this.log(w.Trace,O([i,...o]))}debug(i,...o){this.checkLogLevel(w.Debug)&&this.log(w.Debug,O([i,...o]))}info(i,...o){this.checkLogLevel(w.Info)&&this.log(w.Info,O([i,...o]))}warn(i,...o){this.checkLogLevel(w.Warning)&&this.log(w.Warning,O([i,...o]))}error(i,...o){if(this.checkLogLevel(w.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(w.Error,O(n))}else this.log(w.Error,O([i,...o]))}critical(i,...o){this.checkLogLevel(w.Critical)&&this.log(w.Critical,O([i,...o]))}flush(){}}e.AbstractMessageLogger=m;class _ extends S{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!U.isWindows}trace(i,...o){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...o):console.log(`[main ${P()}]`,i,...o))}debug(i,...o){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...o):console.log(`[main ${P()}]`,i,...o))}info(i,...o){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...o):console.log(`[main ${P()}]`,i,...o))}warn(i,...o){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...o):console.warn(`[main ${P()}]`,i,...o))}error(i,...o){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...o):console.error(`[main ${P()}]`,i,...o))}critical(i,...o){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...o):console.error(`[main ${P()}]`,i,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=_;class f extends S{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...o){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",i,...o)}debug(i,...o){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...o)}info(i,...o){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",i,...o)}warn(i,...o){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",i,...o)}error(i,...o){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",i,...o)}critical(i,...o){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...o)}dispose(){}flush(){}}e.ConsoleLogger=f;class u extends S{constructor(i,o=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(o)}trace(i,...o){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(i),...o])}debug(i,...o){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(i),...o])}info(i,...o){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(i),...o])}warn(i,...o){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(i),...o])}error(i,...o){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(i),...o])}critical(i,...o){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(i),...o])}extractMessage(i){return typeof i=="string"?i:(0,s.toErrorMessage)(i,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class d extends S{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const o of this.logServices)o.setLevel(i);super.setLevel(i)}trace(i,...o){for(const n of this.logServices)n.trace(i,...o)}debug(i,...o){for(const n of this.logServices)n.debug(i,...o)}info(i,...o){for(const n of this.logServices)n.info(i,...o)}warn(i,...o){for(const n of this.logServices)n.warn(i,...o)}error(i,...o){for(const n of this.logServices)n.error(i,...o)}critical(i,...o){for(const n of this.logServices)n.critical(i,...o)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class c extends g.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...o){this.logger.trace(i,...o)}debug(i,...o){this.logger.debug(i,...o)}info(i,...o){this.logger.info(i,...o)}warn(i,...o){this.logger.warn(i,...o)}error(i,...o){this.logger.error(i,...o)}critical(i,...o){this.logger.critical(i,...o)}flush(){this.logger.flush()}}e.LogService=c;class k extends g.Disposable{constructor(i,o){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(o(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(n))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,o){let n=this.loggers.get(i.toString());return n||(n=this.doCreateLogger(i,o?.always?w.Trace:this.logLevel,o),this.loggers.set(i.toString(),n),o?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=k;class y{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(i){}getLevel(){return w.Info}trace(i,...o){}debug(i,...o){}info(i,...o){}warn(i,...o){}error(i,...o){}critical(i,...o){}dispose(){}flush(){}}e.NullLogService=y;function a(h){if(h.verbose)return w.Trace;if(typeof h.logLevel=="string"){const i=D(h.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function D(h){switch(h){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=D;function r(h){switch(h){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=r}),define(Ie[80],Te([1,0,29,126,3]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var U;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(U||(e.MarkerTag=U={}));var I;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(I||(e.MarkerSeverity=I={})),function(w){function A(f,u){return u-f}w.compare=A;const O=Object.create(null);O[w.Error]=(0,C.localize)(0,null),O[w.Warning]=(0,C.localize)(1,null),O[w.Info]=(0,C.localize)(2,null);function S(f){return O[f]||""}w.toString=S;function m(f){switch(f){case s.default.Error:return w.Error;case s.default.Warning:return w.Warning;case s.default.Info:return w.Info;case s.default.Ignore:return w.Hint}}w.fromSeverity=m;function _(f){switch(f){case w.Error:return s.default.Error;case w.Warning:return s.default.Warning;case w.Info:return s.default.Info;case w.Hint:return s.default.Ignore}}w.toSeverity=_}(I||(e.MarkerSeverity=I={}));var P;(function(w){const A="";function O(m){return S(m,!0)}w.makeKey=O;function S(m,_){let f=[A];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(A),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(A),m.severity!==void 0&&m.severity!==null?f.push(I.toString(m.severity)):f.push(A),m.message&&_?f.push(m.message.replace("\xA6","\\\xA6")):f.push(A),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(A),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(A),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(A),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(A),f.push(A),f.join("\xA6")}w.makeKeyOptionalMessage=S})(P||(e.IMarkerData=P={})),e.IMarkerService=(0,g.createDecorator)("markerService")}),define(Ie[148],Te([1,0,5,29,3]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,g.createDecorator)("notificationService");var U;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(U||(e.NeverShowAgainScope=U={}));var I;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(I||(e.NotificationsFilter=I={}));class P{constructor(){this.progress=new w,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=P;class w{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=w}),define(Ie[81],Te([1,0,7,10,2,3]),function(ee,e,s,C,g,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,U.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return s.Disposable.None},registerValidator(){return s.Disposable.None},registerExternalUriResolver(){return s.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return s.Disposable.None},async open(){return!1},async resolveExternalUri(O){return{resolved:O,dispose(){}}}});function I(O,S){return g.URI.isUri(O)?(0,C.equalsIgnoreCase)(O.scheme,S):(0,C.startsWithIgnoreCase)(O,S+":")}e.matchesScheme=I;function P(O,...S){return S.some(m=>I(O,m))}e.matchesSomeScheme=P;function w(O,S){return O.with({fragment:`${S.startLineNumber},${S.startColumn}${S.endLineNumber?`-${S.endLineNumber}${S.endColumn?`,${S.endColumn}`:""}`:""}`})}e.withSelection=w;function A(O){let S;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(O.fragment);return m&&(S={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},O=O.with({fragment:""})),{selection:S,uri:O}}e.extractSelection=A}),define(Ie[149],Te([1,0,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,s.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__decorate||function(ee,e,s,C){var g=arguments.length,U=g<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,s):C,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(ee,e,s,C);else for(var P=ee.length-1;P>=0;P--)(I=ee[P])&&(U=(g<3?I(U):g>3?I(e,s,U):I(e,s))||U);return g>3&&U&&Object.defineProperty(e,s,U),U},We=this&&this.__param||function(ee,e){return function(s,C){e(s,C,ee)}};define(Ie[150],Te([1,0,13,20,7,3]),function(ee,e,s,C,g,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,U.createDecorator)("progressService");var I;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(I||(e.ProgressLocation=I={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{get value(){return this._value}constructor(S){this.callback=S}report(S){this._value=S,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let w=class extends g.Disposable{constructor(S,m){super();this.deferred=new s.DeferredPromise,m.withProgress(S,_=>(this.reporter=_,this.lastStep&&_.report(this.lastStep),this.deferred.p)),this._register((0,g.toDisposable)(()=>this.deferred.complete()))}report(S){this.reporter?this.reporter.report(S):this.lastStep=S}};e.UnmanagedProgress=w,e.UnmanagedProgress=w=$e([We(1,e.IProgressService)],w);class A extends g.Disposable{constructor(S){super();this.progressIndicator=S,this.currentOperationId=0,this.currentOperationDisposables=this._register(new g.DisposableStore)}start(S){this.stop();const m=++this.currentOperationId,_=new C.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},S),this.currentOperationDisposables.add((0,g.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,g.toDisposable)(()=>_.cancel())),this.currentOperationDisposables.add((0,g.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:_.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(S){this.currentOperationId===S&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,U.createDecorator)("editorProgressService")}),define(Ie[30],Te([1,0,42,9]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class g{constructor(){this.data=new Map}add(I,P){s.ok(C.isString(I)),s.ok(C.isObject(P)),s.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,P)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new g}),define(Ie[82],Te([1,0,5,30]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function g(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class U{constructor(){this._onDidChangeSchema=new s.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,A){this.schemasById[g(w)]=A,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new U;C.Registry.add(e.Extensions.JSONContribution,I)}),define(Ie[83],Te([1,0,15,5,9,122,59,82,30]),function(ee,e,s,C,g,U,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var A;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(A||(e.EditPresentationTypes=A={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O||(e.ConfigurationScope=O={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=w.Registry.as(P.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:U.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,h=!0){this.registerConfigurations([r],h)}registerConfigurations(r,h=!0){const i=this.doRegisterConfigurations(r,h);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(r){const h=this.doDeregisterConfigurations(r);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}updateConfigurations({add:r,remove:h}){const i=[];i.push(...this.doDeregisterConfigurations(h)),i.push(...this.doRegisterConfigurations(r,!1)),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,s.distinct)(i)})}registerDefaultConfigurations(r){const h=[],i=[];for(const{overrides:o,source:n}of r)for(const t in o)if(h.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const l=this.configurationDefaultsOverrides.get(t),b=l?.valuesSources??new Map;if(n)for(const $ of Object.keys(o[t]))b.set($,n);const v={...l?.value||{},...o[t]};this.configurationDefaultsOverrides.set(t,{source:n,value:v,valuesSources:b});const E=(0,I.getLanguageTagSettingPlainKey)(t),x={type:"object",default:v,description:U.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:g.isString(n)?void 0:n,defaultValueSource:n};i.push(...u(t)),this.configurationProperties[t]=x,this.defaultLanguageConfigurationOverridesNode.properties[t]=x}else{this.configurationDefaultsOverrides.set(t,{value:o[t],source:n});const l=this.configurationProperties[t];l&&(this.updatePropertyDefaultValue(t,l),this.updateSchema(t,l))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const h=[];for(const{overrides:i,source:o}of r)for(const n in i){const t=this.configurationDefaultsOverrides.get(n),l=g.isString(o)?o:o?.id,b=g.isString(t?.source)?t?.source:t?.source?.id;if(l===b)if(h.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const v=this.configurationProperties[n];v&&(this.updatePropertyDefaultValue(n,v),this.updateSchema(n,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const h of r)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,h){const i=[];return r.forEach(o=>{i.push(...this.validateAndRegisterProperties(o,h,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),i}doDeregisterConfigurations(r){const h=[],i=o=>{if(o.properties)for(const n in o.properties){h.push(n);const t=this.configurationProperties[n];t?.policy?.name&&this.policyConfigurations.delete(t.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,o.properties[n])}o.allOf&&o.allOf.forEach(n=>i(n))};for(const o of r){i(o);const n=this.configurationContributors.indexOf(o);n!==-1&&this.configurationContributors.splice(n,1)}return h}validateAndRegisterProperties(r,h=!0,i,o,n=3){n=g.isUndefinedOrNull(r.scope)?n:r.scope;let t=[],l=r.properties;if(l)for(let v in l){const E=l[v];if(h&&y(v,E)){delete l[v];continue}if(E.source=i,E.defaultDefaultValue=l[v].default,this.updatePropertyDefaultValue(v,E),e.OVERRIDE_PROPERTY_REGEX.test(v)?E.scope=void 0:(E.scope=g.isUndefinedOrNull(E.scope)?n:E.scope,E.restricted=g.isUndefinedOrNull(E.restricted)?!!o?.includes(v):E.restricted),l[v].hasOwnProperty("included")&&!l[v].included){this.excludedConfigurationProperties[v]=l[v],delete l[v];continue}else this.configurationProperties[v]=l[v],l[v].policy?.name&&this.policyConfigurations.set(l[v].policy.name,v);!l[v].deprecationMessage&&l[v].markdownDeprecationMessage&&(l[v].deprecationMessage=l[v].markdownDeprecationMessage),t.push(v)}let b=r.allOf;if(b)for(let v of b)t.push(...this.validateAndRegisterProperties(v,h,i,o,n));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const h=i=>{let o=i.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let n=i.allOf;n&&n.forEach(h)};h(r)}updateSchema(r,h){switch(e.allSettings.properties[r]=h,h.scope){case 1:e.applicationSettings.properties[r]=h;break;case 2:e.machineSettings.properties[r]=h;break;case 6:e.machineOverridableSettings.properties[r]=h;break;case 3:e.windowSettings.properties[r]=h;break;case 4:e.resourceSettings.properties[r]=h;break;case 5:e.resourceSettings.properties[r]=h,this.resourceLanguageSettingsSchema.properties[r]=h;break}}removeFromSchema(r,h){switch(delete e.allSettings.properties[r],h.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const h=`[${r}]`,i={type:"object",description:U.localize(2,null),errorMessage:U.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,i),e.allSettings.properties[h]=i,e.applicationSettings.properties[h]=i,e.machineSettings.properties[h]=i,e.machineOverridableSettings.properties[h]=i,e.windowSettings.properties[h]=i,e.resourceSettings.properties[h]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:U.localize(4,null),errorMessage:U.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,h){const i=this.configurationDefaultsOverrides.get(r);let o=i?.value,n=i?.source;g.isUndefined(o)&&(o=h.defaultDefaultValue,n=void 0),g.isUndefined(o)&&(o=c(h.type)),h.default=o,h.defaultValueSource=n}}const _="\\[([^\\]]+)\\]",f=new RegExp(_,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${_})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function u(D){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(D)){let h=f.exec(D);for(;h?.length;){const i=h[1].trim();i&&r.push(i),h=f.exec(D)}}return(0,s.distinct)(r)}e.overrideIdentifiersFromKey=u;function d(D){return D.reduce((r,h)=>`${r}[${h}]`,"")}e.keyFromOverrideIdentifiers=d;function c(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const k=new m;w.Registry.add(e.Extensions.Configuration,k);function y(D,r){return D.trim()?e.OVERRIDE_PROPERTY_REGEX.test(D)?U.localize(7,null,D):k.getConfigurationProperties()[D]!==void 0?U.localize(8,null,D):r.policy?.name&&k.getPolicyConfigurations().get(r.policy?.name)!==void 0?U.localize(9,null,D,r.policy?.name,k.getPolicyConfigurations().get(r.policy?.name)):null:U.localize(6,null)}e.validateProperty=y;function a(){const D=[],r=k.getConfigurationProperties();for(const h of Object.keys(r))D.push([h,r[h].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=a}),define(Ie[151],Te([1,0,15,5,104,7,24,27,9,2,59,83,30]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class _{constructor(h={},i=[],o=[]){this._contents=h,this._keys=i,this._overrides=o,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(h){return h?(0,O.getConfigurationValue)(this.contents,h):this.contents}getOverrideValue(h,i){const o=this.getContentsForOverrideIdentifer(i);return o?h?(0,O.getConfigurationValue)(o,h):o:void 0}getKeysForOverrideIdentifier(h){const i=[];for(const o of this.overrides)o.identifiers.includes(h)&&i.push(...o.keys);return s.distinct(i)}getAllOverrideIdentifiers(){const h=[];for(const i of this.overrides)h.push(...i.identifiers);return s.distinct(h)}override(h){let i=this.overrideConfigurations.get(h);return i||(i=this.createOverrideConfigurationModel(h),this.overrideConfigurations.set(h,i)),i}merge(...h){const i=P.deepClone(this.contents),o=P.deepClone(this.overrides),n=[...this.keys];for(const t of h){this.mergeContents(i,t.contents);for(const l of t.overrides){const[b]=o.filter(v=>s.equals(v.identifiers,l.identifiers));b?(this.mergeContents(b.contents,l.contents),b.keys.push(...l.keys),b.keys=s.distinct(b.keys)):o.push(P.deepClone(l))}for(const l of t.keys)n.indexOf(l)===-1&&n.push(l)}return new _(i,n,o)}freeze(){return this.frozen=!0,this}clone(){return new _(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(h){const i=this.getContentsForOverrideIdentifer(h);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const n of s.distinct([...Object.keys(this.contents),...Object.keys(i)])){let t=this.contents[n],l=i[n];l&&(typeof t=="object"&&typeof l=="object"?(t=P.deepClone(t),this.mergeContents(t,l)):t=l),o[n]=t}return new _(o,this.keys,this.overrides)}mergeContents(h,i){for(const o of Object.keys(i)){if(o in h&&w.isObject(h[o])&&w.isObject(i[o])){this.mergeContents(h[o],i[o]);continue}h[o]=P.deepClone(i[o])}}checkAndFreeze(h){return this.frozen&&!Object.isFrozen(h)?P.deepFreeze(h):h}getContentsForOverrideIdentifer(h){let i=null,o=null;const n=t=>{t&&(o?this.mergeContents(o,t):o=P.deepClone(t))};for(const t of this.overrides)s.equals(t.identifiers,[h])?i=t.contents:t.identifiers.includes(h)&&n(t.contents);return n(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(h,i){this.addKey(h),(0,O.addToValueTree)(this.contents,h,i,o=>{throw new Error(o)})}removeValue(h){this.removeKey(h)&&(0,O.removeFromValueTree)(this.contents,h)}addKey(h){let i=this.keys.length;for(let o=0;o<i;o++)h.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,h)}removeKey(h){let i=this.keys.indexOf(h);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=_;class f{constructor(h){this._name=h,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new _}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(h,i){if(!w.isUndefinedOrNull(h)){const o=this.doParseContent(h);this.parseRaw(o,i)}}reparse(h){this._raw&&this.parseRaw(this._raw,h)}parseRaw(h,i){this._raw=h;const{contents:o,keys:n,overrides:t,restricted:l}=this.doParseRaw(h,i);this._configurationModel=new _(o,n,t),this._restrictedConfigurations=l||[]}doParseContent(h){let i={},o=null,n=[],t=[],l=[];function b(E){Array.isArray(n)?n.push(E):o!==null&&(n[o]=E)}let v={onObjectBegin:()=>{let E={};b(E),t.push(n),n=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{n=t.pop()},onArrayBegin:()=>{let E=[];b(E),t.push(n),n=E,o=null},onArrayEnd:()=>{n=t.pop()},onLiteralValue:b,onError:(E,x,$)=>{l.push({error:E,offset:x,length:$})}};if(h)try{g.visit(h,v),i=n[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return i}doParseRaw(h,i){const o=m.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),n=this.filter(h,o,!0,i);h=n.raw;const t=(0,O.toValuesTree)(h,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),l=Object.keys(h),b=this.toOverrides(h,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:t,keys:l,overrides:b,restricted:n.restricted}}filter(h,i,o,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:h,restricted:[]};const t={},l=[];for(let b in h)if(S.OVERRIDE_PROPERTY_REGEX.test(b)&&o){const v=this.filter(h[b],i,!1,n);t[b]=v.raw,l.push(...v.restricted)}else{const v=i[b],E=v?typeof v.scope!="undefined"?v.scope:3:void 0;v?.restricted&&l.push(b),(E===void 0||n.scopes===void 0||n.scopes.includes(E))&&(n.skipRestricted&&v?.restricted||(t[b]=h[b]))}return{raw:t,restricted:l}}toOverrides(h,i){const o=[];for(const n of Object.keys(h))if(S.OVERRIDE_PROPERTY_REGEX.test(n)){const t={};for(const l in h[n])t[l]=h[n][l];o.push({identifiers:(0,S.overrideIdentifiersFromKey)(n),keys:Object.keys(t),contents:(0,O.toValuesTree)(t,i)})}return o}}e.ConfigurationModelParser=f;class u extends U.Disposable{constructor(h,i,o,n){super();this.userSettingsResource=h,this.scopes=i,this.fileService=n,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,t=>t.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,t=>(t.isOperation(0)||t.isOperation(3)||t.isOperation(1)||t.isOperation(4))&&o.isEqual(t.resource,h)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const h=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(h.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new _}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=u;class d{constructor(h,i,o,n=new _,t=new _,l=new I.ResourceMap,b=new _,v=new I.ResourceMap,E=!0){this._defaultConfiguration=h,this._policyConfiguration=i,this._localUserConfiguration=o,this._remoteUserConfiguration=n,this._workspaceConfiguration=t,this._folderConfigurations=l,this._memoryConfiguration=b,this._memoryConfigurationByResource=v,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(h,i,o){return this.getConsolidatedConfigurationModel(h,i,o).getValue(h)}updateValue(h,i,o={}){let n;o.resource?(n=this._memoryConfigurationByResource.get(o.resource),n||(n=new _,this._memoryConfigurationByResource.set(o.resource,n))):n=this._memoryConfiguration,i===void 0?n.removeValue(h):n.setValue(h,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(h,i,o){const n=this.getConsolidatedConfigurationModel(h,i,o),t=this.getFolderConfigurationModelForResource(i.resource,o),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,b=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(h):this._defaultConfiguration.freeze().getValue(h),v=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(h),E=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(h):this.userConfiguration.freeze().getValue(h),x=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(h):this.localUserConfiguration.freeze().getValue(h),$=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(h):this.remoteUserConfiguration.freeze().getValue(h),R=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(h):this._workspaceConfiguration.freeze().getValue(h):void 0,p=t?i.overrideIdentifier?t.freeze().override(i.overrideIdentifier).getValue(h):t.freeze().getValue(h):void 0,F=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(h):l.getValue(h),M=n.getValue(h),z=s.distinct(n.overrides.map(Z=>Z.identifiers).flat()).filter(Z=>n.getOverrideValue(h,Z)!==void 0);return{defaultValue:b,policyValue:v,userValue:E,userLocalValue:x,userRemoteValue:$,workspaceValue:R,workspaceFolderValue:p,memoryValue:F,value:M,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(h),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(h,i.overrideIdentifier):void 0}:void 0,policy:v!==void 0?{value:v}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(h),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(h,i.overrideIdentifier):void 0}:void 0,userLocal:x!==void 0?{value:this.localUserConfiguration.freeze().getValue(h),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(h,i.overrideIdentifier):void 0}:void 0,userRemote:$!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(h),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(h,i.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(h),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(h,i.overrideIdentifier):void 0}:void 0,workspaceFolder:p!==void 0?{value:t?.freeze().getValue(h),override:i.overrideIdentifier?t?.freeze().getOverrideValue(h,i.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:l.getValue(h),override:i.overrideIdentifier?l.getOverrideValue(h,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(h){const i=this.getFolderConfigurationModelForResource(void 0,h);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(h){this._defaultConfiguration=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(h){this._policyConfiguration=h}updateLocalUserConfiguration(h){this._localUserConfiguration=h,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(h){this._remoteUserConfiguration=h,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(h){this._workspaceConfiguration=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(h,i){this._folderConfigurations.set(h,i),this._foldersConsolidatedConfigurations.delete(h)}deleteFolderConfiguration(h){this.folderConfigurations.delete(h),this._foldersConsolidatedConfigurations.delete(h)}compareAndUpdateDefaultConfiguration(h,i){const o=[];if(!i){const{added:n,updated:t,removed:l}=a(this._defaultConfiguration,h);i=[...n,...t,...l]}for(const n of i)for(const t of(0,S.overrideIdentifiersFromKey)(n)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(t),b=h.getKeysForOverrideIdentifier(t),v=[...b.filter(E=>l.indexOf(E)===-1),...l.filter(E=>b.indexOf(E)===-1),...l.filter(E=>!P.equals(this._defaultConfiguration.override(t).getValue(E),h.override(t).getValue(E)))];o.push([t,v])}return this.updateDefaultConfiguration(h),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(h){const{added:i,updated:o,removed:n}=a(this._policyConfiguration,h),t=[...i,...o,...n];return t.length&&this.updatePolicyConfiguration(h),{keys:t,overrides:[]}}compareAndUpdateLocalUserConfiguration(h){const{added:i,updated:o,removed:n,overrides:t}=a(this.localUserConfiguration,h),l=[...i,...o,...n];return l.length&&this.updateLocalUserConfiguration(h),{keys:l,overrides:t}}compareAndUpdateRemoteUserConfiguration(h){const{added:i,updated:o,removed:n,overrides:t}=a(this.remoteUserConfiguration,h);let l=[...i,...o,...n];return l.length&&this.updateRemoteUserConfiguration(h),{keys:l,overrides:t}}compareAndUpdateWorkspaceConfiguration(h){const{added:i,updated:o,removed:n,overrides:t}=a(this.workspaceConfiguration,h);let l=[...i,...o,...n];return l.length&&this.updateWorkspaceConfiguration(h),{keys:l,overrides:t}}compareAndUpdateFolderConfiguration(h,i){const o=this.folderConfigurations.get(h),{added:n,updated:t,removed:l,overrides:b}=a(o,i);let v=[...n,...t,...l];return(v.length||!o)&&this.updateFolderConfiguration(h,i),{keys:v,overrides:b}}compareAndDeleteFolderConfiguration(h){const i=this.folderConfigurations.get(h);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(h);const{added:o,updated:n,removed:t,overrides:l}=a(i,void 0);return{keys:[...o,...n,...t],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(h,i,o){let n=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier&&(n=n.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(h)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:h},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&h){const n=i.getFolder(h);n&&(o=this.getFolderConsolidatedConfiguration(n.uri)||o);const t=this._memoryConfigurationByResource.get(h);t&&(o=o.merge(t))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(h){let i=this._foldersConsolidatedConfigurations.get(h);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(h);n?(i=o.merge(n),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(h,i)):i=o}return i}getFolderConfigurationModelForResource(h,i){if(i&&h){const o=i.getFolder(h);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((h,i)=>{const{contents:o,overrides:n,keys:t}=this._folderConfigurations.get(i);return h.push([i,{contents:o,overrides:n,keys:t}]),h},[])}}allKeys(){const h=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>h.add(i)),this.userConfiguration.freeze().keys.forEach(i=>h.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>h.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>h.add(o))),[...h.values()]}allOverrideIdentifiers(){const h=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>h.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>h.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>h.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(o=>h.add(o))),[...h.values()]}getAllKeysForOverrideIdentifier(h){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(h).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(h).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(h).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(h).forEach(n=>i.add(n))),[...i.values()]}static parse(h){const i=this.parseConfigurationModel(h.defaults),o=this.parseConfigurationModel(h.policy),n=this.parseConfigurationModel(h.user),t=this.parseConfigurationModel(h.workspace),l=h.folders.reduce((b,v)=>(b.set(A.URI.revive(v[0]),this.parseConfigurationModel(v[1])),b),new I.ResourceMap);return new d(i,o,n,new _,t,l,new _,new I.ResourceMap,!1)}static parseConfigurationModel(h){return new _(h.contents,h.keys,h.overrides).freeze()}}e.Configuration=d;function c(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const h=new Set,i=new Map;for(const n of r)n.keys.forEach(t=>h.add(t)),n.overrides.forEach(([t,l])=>{const b=(0,I.getOrSet)(i,t,new Set);l.forEach(v=>b.add(v))});const o=[];return i.forEach((n,t)=>o.push([t,[...n.values()]])),{keys:[...h.values()],overrides:o}}e.mergeChanges=c;class k{constructor(h,i,o,n){this.change=h,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=n,this._previousConfiguration=void 0;const t=new Set;h.keys.forEach(b=>t.add(b)),h.overrides.forEach(([,b])=>b.forEach(v=>t.add(v))),this.affectedKeys=[...t.values()];const l=new _;this.affectedKeys.forEach(b=>l.setValue(b,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(h,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,h)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(h,i,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(h,i,this.currentWorkspace);return!P.equals(o,n)}return!0}return!1}doesAffectedKeysTreeContains(h,i){let o=(0,O.toValuesTree)({[i]:!0},()=>{}),n;for(;typeof o=="object"&&(n=Object.keys(o)[0]);){if(h=h[n],!h)return!1;o=o[n]}return!0}}e.ConfigurationChangeEvent=k;class y extends k{constructor(h,i,o,n){super({keys:h.allKeys(),overrides:[]},void 0,h,i);this.source=o,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=y;function a(r,h){const{added:i,removed:o,updated:n}=D(h,r),t=[],l=r?.getAllOverrideIdentifiers()||[],b=h?.getAllOverrideIdentifiers()||[];if(h){const v=b.filter(E=>!l.includes(E));for(const E of v)t.push([E,h.getKeysForOverrideIdentifier(E)])}if(r){const v=l.filter(E=>!b.includes(E));for(const E of v)t.push([E,r.getKeysForOverrideIdentifier(E)])}if(h&&r){for(const v of l)if(b.includes(v)){const E=D({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:h.getOverrideValue(void 0,v)||{},keys:h.getKeysForOverrideIdentifier(v)});t.push([v,[...E.added,...E.removed,...E.updated]])}}return{added:i,removed:o,updated:n,overrides:t}}function D(r,h){const i=r?h?r.keys.filter(t=>h.keys.indexOf(t)===-1):[...r.keys]:[],o=h?r?h.keys.filter(t=>r.keys.indexOf(t)===-1):[...h.keys]:[],n=[];if(r&&h){for(const t of h.keys)if(r.keys.indexOf(t)!==-1){const l=(0,O.getConfigurationValue)(h.contents,t),b=(0,O.getConfigurationValue)(r.contents,t);P.equals(l,b)||n.push(t)}}return{added:i,removed:o,updated:n}}}),define(Ie[84],Te([1,0,11,3]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var g;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class U extends s.ErrorNoTelemetry{static isTemporarilyNotAvailable(P){return P instanceof U&&P._code===g.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof U&&P._code===g.NoResolverFound}static isHandled(P){return P instanceof U&&P.isHandled}constructor(P,w=g.Unknown,A){super(P);this._message=P,this._code=w,this._detail=A,this.isHandled=w===g.NotAvailable&&A===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}}e.RemoteAuthorityResolverError=U}),define(Ie[85],Te([1,0,12]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(I){return I.scheme===s.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=C;function g(I){if(!I)return;const P=I.indexOf("+");return P<0?I:I.substr(0,P)}e.getRemoteName=g;function U(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=U}),define(Ie[25],Te([1,0,10,3,85]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function U(_){if(typeof _=="object"&&_!==null&&_.supported!==!0)return _.description}e.getWorkspaceSupportTypeMessage=U;function I(_){return _&&typeof _=="object"&&typeof _.id=="string"&&(!_.uuid||typeof _.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(_){_[_.System=0]="System",_[_.User=1]="User"})(P||(e.ExtensionType=P={}));var w;(function(_){_.WIN32_X64="win32-x64",_.WIN32_IA32="win32-ia32",_.WIN32_ARM64="win32-arm64",_.LINUX_X64="linux-x64",_.LINUX_ARM64="linux-arm64",_.LINUX_ARMHF="linux-armhf",_.ALPINE_X64="alpine-x64",_.ALPINE_ARM64="alpine-arm64",_.DARWIN_X64="darwin-x64",_.DARWIN_ARM64="darwin-arm64",_.WEB="web",_.UNIVERSAL="universal",_.UNKNOWN="unknown",_.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class A{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,u){if(typeof f=="undefined"||f===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof f=="string"||typeof u=="string"){let d=typeof f=="string"?f:f.value,c=typeof u=="string"?u:u.value;return s.equalsIgnoreCase(d,c)}return f._lower===u._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=A;function O(_){return _.contributes&&_.contributes.localizations?_.contributes.localizations.length>0:!1}e.isLanguagePackExtension=O;function S(_){return _.contributes&&_.contributes.authentication?_.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function m(_,f){if(f){const u=`onResolveRemoteAuthority:${(0,g.getRemoteName)(f)}`;return _.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[152],Te([1,0,10,79,25,22,2,11,61]),function(ee,e,s,C,g,U,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function A(i,o){return i.uuid&&o.uuid?i.uuid===o.uuid:i.id===o.id?!0:(0,s.compareIgnoreCase)(i.id,o.id)===0}e.areSameExtensions=A;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(o){const n=o.manifest?o.manifest.version:o.version,t=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new S(o.identifier,n,t)}static parse(o){const n=O.exec(o);return n&&n[1]&&n[2]?new S({id:n[1]},n[2],n[4]||void 0):null}constructor(o,n,t="undefined"){this.version=n,this.targetPlatform=t,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof S?A(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=S;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function _(i){const o=m.exec(i);return o&&o[1]?[u(o[1]),o[2]]:[u(i),void 0]}e.getIdAndVersion=_;function f(i,o){return`${i}.${o}`}e.getExtensionId=f;function u(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function d(i,o){return u(f(i,o))}e.getGalleryExtensionId=d;function c(i,o){const n=[],t=l=>{for(const b of n)if(b.some(v=>A(o(v),o(l))))return b;return null};for(const l of i){const b=t(l);b?b.push(l):n.push([l])}return n}e.groupByExtension=c;function k(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=k;function y(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new g.ExtensionIdentifier("pprice.better-merge");function a(i){const o=new Set;if(i.malicious)for(const n of i.malicious)o.add(n.id);return o}e.getMaliciousExtensionsSet=a;function D(i,o){const n=[],t=o.manifest.extensionDependencies?.slice(0)??[];for(;t.length;){const l=t.shift();if(l&&n.every(b=>!A(b.identifier,{id:l}))){const b=i.filter(v=>A(v.identifier,{id:l}));b.length===1&&(n.push(b[0]),t.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=D;async function r(i,o){if(!U.isLinux)return!1;let n;try{n=(await i.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await i.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){o.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=r;async function h(i,o){const n=await r(i,o),t=(0,C.getTargetPlatform)(n?"alpine":U.platform,w.arch);return o.debug("ComputeTargetPlatform:",t),t}e.computeTargetPlatform=h}),define(Ie[153],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class s{constructor(g){this._callback=g,this._terminalBufferMap=new Map}dispose(){for(const g of this._terminalBufferMap.values())g.dispose()}startBuffering(g,U,I=5){let P;return P=U(w=>{const A=typeof w=="string"?w:w.data;let O=this._terminalBufferMap.get(g);if(O){O.data.push(A);return}const S=setTimeout(()=>this.flushBuffer(g),I);O={data:[A],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(g),P.dispose()}},this._terminalBufferMap.set(g,O)}),P}stopBuffering(g){const U=this._terminalBufferMap.get(g);U&&U.dispose()}flushBuffer(g){const U=this._terminalBufferMap.get(g);U&&(this._terminalBufferMap.delete(g),this._callback(g,U.data.join("")))}}e.TerminalDataBufferer=s}),define(Ie[154],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var s;(function(U){U.DARK="dark",U.LIGHT="light",U.HIGH_CONTRAST_DARK="hcDark",U.HIGH_CONTRAST_LIGHT="hcLight"})(s||(e.ColorScheme=s={}));function C(U){return U===s.HIGH_CONTRAST_DARK||U===s.HIGH_CONTRAST_LIGHT}e.isHighContrast=C;function g(U){return U===s.DARK||U===s.HIGH_CONTRAST_DARK}e.isDark=g}),define(Ie[62],Te([1,0,110,5,7,3,30,154]),function(ee,e,s,C,g,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,U.createDecorator)("themeService");var w;(function(d){function c(k){return k&&typeof k=="object"&&typeof k.id=="string"}d.isThemeColor=c})(w||(e.ThemeColor=w={}));function A(d){return{id:d}}e.themeColorFromId=A;var O;(function(d){function c(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||w.isThemeColor(o.color))}d.isThemeIcon=c;const k=new RegExp(`^\\$\\((${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?)\\)$`);function y(o){const n=k.exec(o);if(!n)return;let[,t]=n;return{id:t}}d.fromString=y;function a(o){return{id:o}}d.fromId=a;function D(o,n){let t=o.id;const l=t.lastIndexOf("~");return l!==-1&&(t=t.substring(0,l)),n&&(t=`${t}~${n}`),{id:t}}d.modify=D;function r(o){const n=o.id.lastIndexOf("~");if(n!==-1)return o.id.substring(n+1)}d.getModifier=r;function h(o,n){return o.id===n.id&&o.color?.id===n.color?.id}d.isEqual=h;function i(o,n){return{id:o.id,color:n?A(n):void 0}}d.asThemeIcon=i,d.asClassNameArray=s.CSSIcon.asClassNameArray,d.asClassName=s.CSSIcon.asClassName,d.asCSSSelector=s.CSSIcon.asCSSSelector})(O||(e.ThemeIcon=O={})),e.FileThemeIcon=s.Codicon.file,e.FolderThemeIcon=s.Codicon.folder;function S(d){switch(d){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new C.Emitter}onColorThemeChange(c){return this.themingParticipants.push(c),this.onThemingParticipantAddedEmitter.fire(c),(0,g.toDisposable)(()=>{const k=this.themingParticipants.indexOf(c);this.themingParticipants.splice(k,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let _=new m;I.Registry.add(e.Extensions.ThemingContribution,_);function f(d){return _.onColorThemeChange(d)}e.registerThemingParticipant=f;class u extends g.Disposable{constructor(c){super();this.themeService=c,this.theme=c.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(k=>this.onThemeChange(k)))}onThemeChange(c){this.theme=c,this.updateStyles()}updateStyles(){}getColor(c,k){let y=this.theme.getColor(c);return y&&k&&(y=k(y,this.theme)),y?y.toString():null}}e.Themable=u}),define(Ie[155],Te([1,0,5,22,3,14]),function(ee,e,s,C,g,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,g.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,g.createDecorator)("sharedTunnelsService");var I;(function(f){f.Http="http",f.Https="https"})(I||(e.TunnelProtocol=I={}));var P;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(P||(e.TunnelPrivacyId=P={}));var w;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function A(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=S;function m(f,u){return u?u!==1&&f<1024:!C.isWindows&&f<1024}e.isPortPrivileged=m;let _=class{constructor(u){this.logService=u,this._onTunnelOpened=new s.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new s.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new s.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],d=Array.from(this._tunnels.values());for(let c of d){const k=Array.from(c.values());for(let y of k){const a=await y.value;a&&u.push(a)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:d}of u.values())await d.then(c=>c?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,d,c,k,y=!1,a,D){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${c} on local port ${k}.`),!u)return;if(d||(d="localhost"),this._tunnelProvider&&this._factoryInProgress.has(c)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(u,d,c,k,y,a,D);return r?r.then(h=>{if(!h){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,c);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(h);return(h.tunnelRemoteHost!==d||h.tunnelRemotePort!==c)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const d=this._tunnels.get(u.tunnelRemoteHost);if(d){const c=d.get(u.tunnelRemotePort);c&&(c.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,c))}}}}async tryDisposeTunnel(u,d,c){if(c.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${d}.`);const k=c.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(d),k}}async closeTunnel(u,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${d} `);const c=this._tunnels.get(u);if(c&&c.has(d)){const k=c.get(d);k.refcount=0,await this.tryDisposeTunnel(u,d,k)}}addTunnelToMap(u,d,c){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(d,{refcount:1,value:c})}async removeEmptyTunnelFromMap(u,d){const c=this._tunnels.get(u);c&&(await c.get(d)||c.delete(d),c.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,d){let c=[u];O(u)?(c.push(...e.LOCALHOST_ADDRESSES),c.push(...e.ALL_INTERFACES_ADDRESSES)):S(u)&&c.push(...e.ALL_INTERFACES_ADDRESSES);const k=c.map(y=>this._tunnels.get(y));for(const y of k){const a=y?.get(d);if(a)return a}}canTunnel(u){return!!A(u)}createWithProvider(u,d,c,k,y,a,D){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${c} on local port ${k}.`);const r=c;this._factoryInProgress.add(r);const i={elevationRequired:y?m(k===void 0?c:k):!1},o={remoteAddress:{host:d,port:c},localAddressPort:k,privacy:a,public:a?a!==P.Private:void 0,protocol:D},n=u.forwardPort(o,i);return n?(this.addTunnelToMap(d,c,n),n.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),n}};e.AbstractTunnelService=_,e.AbstractTunnelService=_=$e([We(0,U.ILogService)],_)}),define(Ie[156],Te([1,0,12]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(w){return w.scheme!==s.Schemas.file&&w.scheme!==s.Schemas.vscodeRemote}e.isVirtualResource=C;function g(w){if(w.folders.length)return w.folders.every(A=>C(A.uri))?w.folders[0].uri:void 0;if(w.configuration&&C(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=g;function U(w){return g(w)?.scheme}e.getVirtualWorkspaceScheme=U;function I(w){return g(w)?.authority}e.getVirtualWorkspaceAuthority=I;function P(w){return g(w)!==void 0}e.isVirtualWorkspace=P}),define(Ie[46],Te([1,0,127,19,24,21,2,3,12]),function(ee,e,s,C,g,U,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function A(i){const o=i;return typeof o?.id=="string"&&I.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=A;function O(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=O;function S(i){const o=i;return typeof o?.id=="string"&&I.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=S;function m(i){const o=i;if(o?.uri)return{id:o.id,uri:I.URI.revive(o.uri)};const n=i;if(n?.configPath)return{id:n.id,configPath:I.URI.revive(n.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=m;var _;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(_||(e.WorkbenchState=_={}));function f(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=f;function u(i){const o=i;return!!(o&&typeof o=="object"&&I.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=u;class d{constructor(o,n,t,l,b){this._id=o,this._transient=t,this._configuration=l,this._ignorePathCasing=b,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class c{constructor(o,n){this.raw=n,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,U.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function k(i){return new c({uri:i,index:0,name:(0,U.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=k,e.WORKSPACE_EXTENSION="code-workspace";const y=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,s.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(i,o){return U.extUriBiasedIgnorePathCase.isEqualOrParent(i,o.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function D(i){let o;return I.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=D;function r(i,o){return!a(i,o)&&!D(i)}e.isSavedWorkspace=r;function h(i){return(typeof i=="string"?(0,C.extname)(i):(0,U.extname)(i))===y}e.hasWorkspaceFileExtension=h}),define(Ie[63],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class s{constructor(g){this.id=g,this._data=new Map,this._idPool=1}add(g){const U=this._idPool++;return this._data.set(U,g),this.logDebugInfo(),U}get(g,U){return this._data.has(g)?this._data.get(g)[U]:void 0}delete(g){this._data.delete(g),this.logDebugInfo()}logDebugInfo(){!s.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=s,s.enableDebugLogging=!1}),define(Ie[35],Te([1,0,12,21,3]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class U{constructor(){this._systemSchemes=new Set(Object.keys(s.Schemas)),this._providerInfo=new Map,this.extUri=new C.ExtUri(P=>{const w=this._providerInfo.get(P.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(P,w){w===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,w)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=U,e.IExtHostFileSystemInfo=(0,g.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[28],Te([1,0,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,s.createDecorator)("IExtHostInitDataService")}),define(Ie[157],Te([1,0,13]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(I,P,w){this._deferredPromises=new Map,this._id=I,this._shared=P,this._storage=w,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new s.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of A.values())O.complete()}catch(O){for(const S of A.values())S.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this._init}get(I,P){let w=this._value[I];return typeof w=="undefined"&&(w=P),w}update(I,P){this._value[I]=P;let w=this._deferredPromises.get(I);if(w!==void 0)return w.p;const A=new s.DeferredPromise;return this._deferredPromises.set(I,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=C;class g extends C{setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}constructor(I,P){super(I.identifier.value,!0,P);this._extension=I}}e.ExtensionGlobalMemento=g}),define(Ie[158],Te([1,0,5,2]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class g{constructor(I){this._notebooksAndEditors=I,this._onDidSaveNotebookDocument=new s.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new s.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(I,P,w,A){const S=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(I)).acceptModelChanged(P.value,w,A);this._onDidChangeNotebookDocument.fire(S)}$acceptDirtyStateChanged(I,P){this._notebooksAndEditors.getNotebookDocument(C.URI.revive(I)).acceptDirty(P)}$acceptModelSaved(I){const P=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(I));this._onDidSaveNotebookDocument.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=g}),define(Ie[16],Te([1,0,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,s.createDecorator)("IExtHostRpcService");class C{constructor(U){this.getProxy=U.getProxy.bind(U),this.set=U.set.bind(U),this.dispose=U.dispose.bind(U),this.assertRegistered=U.assertRegistered.bind(U),this.drain=U.drain.bind(U)}}e.ExtHostRpcService=C});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,s,C,g){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?g.call(ee,s):g?g.value=s:e.set(ee,s),s},Re=this&&this.__classPrivateFieldGet||function(ee,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[159],Te([1,0,25,5]),function(ee,e,s,C){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class U{constructor(P,w){g.set(this,void 0),this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._id=s.ExtensionIdentifier.toKey(P.identifier),Ye(this,g,w,"f"),Re(this,g,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(P){return Re(this,g,"f").get(this._id,P)}store(P,w){return Re(this,g,"f").store(this._id,P,w)}delete(P){return Re(this,g,"f").delete(this._id,P)}}e.ExtensionSecrets=U,g=new WeakMap}),define(Ie[86],Te([1,0,3,5]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class g{constructor(){this._onDidChangeTelemetryEnabled=new C.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new C.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(I,P){this._level=I,this._productConfig=P||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(I){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=I,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=g,e.IExtHostTelemetry=(0,s.createDecorator)("IExtHostTelemetry")}),define(Ie[64],Te([1,0,3,155,5,16]),function(ee,e,s,C,g,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(w){function A(S){return{remoteAddress:S.remoteAddress,localAddress:S.localAddress,public:!!S.public,privacy:S.privacy??(S.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:S.protocol}}w.fromApiTunnel=A;function O(S){return{remoteAddress:{host:S.tunnelRemoteHost,port:S.tunnelRemotePort},localAddress:S.localAddress,public:S.privacy!==C.TunnelPrivacyId.ConstantPrivate&&S.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:S.privacy,protocol:S.protocol}}w.fromServiceTunnel=O})(I||(e.TunnelDtoConverter=I={})),e.IExtHostTunnelService=(0,s.createDecorator)("IExtHostTunnelService");let P=class{constructor(A){this.onDidChangeTunnels=new g.Emitter().event}async $applyCandidateFilter(A){return A}async openTunnel(A,O){}async getTunnels(){return[]}async setTunnelFactory(A){return{dispose:()=>{}}}registerPortsAttributesProvider(A,O){return{dispose:()=>{}}}async $providePortAttributes(A,O,S,m,_){return[]}async $forwardPort(A,O){}async $closeTunnel(A){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.ExtHostTunnelService=P,e.ExtHostTunnelService=P=$e([We(0,U.IExtHostRpcService)],P)});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,s,C,g){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?g.call(ee,s):g?g.value=s:e.set(ee,s),s},Re=this&&this.__classPrivateFieldGet||function(ee,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[6],Te([1,0,15,11,75,24,74,10,9,2,44,39,84]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m){"use strict";var _,f,u,d,c,k,y,a,D,r,h,i,o,n,t,l,b,v,E,x,$,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function p(W){function L(){return Reflect.construct(W,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(W,"name")),Object.setPrototypeOf(L,W),Object.setPrototypeOf(L.prototype,W.prototype),L}let F=k=class{static from(...L){let te=L;return new k(function(){if(te){for(const ye of te)ye&&typeof ye.dispose=="function"&&ye.dispose();te=void 0}})}constructor(L){_.set(this,void 0),Ye(this,_,L,"f")}dispose(){typeof Re(this,_,"f")=="function"&&(Re(this,_,"f").call(this),Ye(this,_,void 0,"f"))}};e.Disposable=F,_=new WeakMap,e.Disposable=F=k=$e([p],F);let M=y=class{static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let ye=1;ye<L.length;ye++){const je=L[ye];je.isBefore(te)&&(te=je)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let ye=1;ye<L.length;ye++){const je=L[ye];je.isAfter(te)&&(te=je)}return te}static isPosition(L){if(!L)return!1;if(L instanceof y)return!0;let{line:te,character:ye}=L;return typeof te=="number"&&typeof ye=="number"}static of(L){if(L instanceof y)return L;if(this.isPosition(L))return new y(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(L,te){if(L<0)throw(0,C.illegalArgument)("line must be non-negative");if(te<0)throw(0,C.illegalArgument)("character must be non-negative");this._line=L,this._character=te}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,C.illegalArgument)();let ye;return typeof L=="undefined"?ye=0:typeof L=="number"?ye=L:(ye=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),ye===0&&te===0?this:new y(this.line+ye,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,C.illegalArgument)();let ye;return typeof L=="undefined"?ye=this.line:typeof L=="number"?ye=L:(ye=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),ye===this.line&&te===this.character?this:new y(ye,te)}toJSON(){return{line:this.line,character:this.character}}};e.Position=M,e.Position=M=y=$e([p],M);let z=a=class{static isRange(L){return L instanceof a?!0:L?M.isPosition(L.start)&&M.isPosition(L.end):!1}static of(L){if(L instanceof a)return L;if(this.isRange(L))return new a(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(L,te,ye,je){let tt,rt;if(typeof L=="number"&&typeof te=="number"&&typeof ye=="number"&&typeof je=="number"?(tt=new M(L,te),rt=new M(ye,je)):M.isPosition(L)&&M.isPosition(te)&&(tt=M.of(L),rt=M.of(te)),!tt||!rt)throw new Error("Invalid arguments");tt.isBefore(rt)?(this._start=tt,this._end=rt):(this._start=rt,this._end=tt)}contains(L){return a.isRange(L)?this.contains(L.start)&&this.contains(L.end):M.isPosition(L)?!(M.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=M.Max(L.start,this._start),ye=M.Min(L.end,this._end);if(!te.isAfter(ye))return new a(te,ye)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=M.Min(L.start,this._start),ye=M.Max(L.end,this.end);return new a(te,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,C.illegalArgument)();let ye;return L?M.isPosition(L)?ye=L:(ye=L.start||this.start,te=L.end||this.end):ye=this.start,ye.isEqual(this._start)&&te.isEqual(this.end)?this:new a(ye,te)}toJSON(){return[this.start,this.end]}};e.Range=z,e.Range=z=a=$e([p],z);let Z=D=class extends z{static isSelection(L){return L instanceof D?!0:L?z.isRange(L)&&M.isPosition(L.anchor)&&M.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(L,te,ye,je){let tt,rt;if(typeof L=="number"&&typeof te=="number"&&typeof ye=="number"&&typeof je=="number"?(tt=new M(L,te),rt=new M(ye,je)):M.isPosition(L)&&M.isPosition(te)&&(tt=M.of(L),rt=M.of(te)),!tt||!rt)throw new Error("Invalid arguments");super(tt,rt);this._anchor=tt,this._active=rt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=Z,e.Selection=Z=D=$e([p],Z);class K{constructor(L,te,ye){if(typeof L!="string"||L.length===0)throw(0,C.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,C.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,C.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=ye}}e.ResolvedAuthority=K;class N extends Error{static NotAvailable(L,te){return new N(L,m.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new N(L,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,te=m.RemoteAuthorityResolverErrorCode.Unknown,ye){super(L);this._message=L,this._code=te,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}}e.RemoteAuthorityResolverError=N;var se;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(se||(e.EndOfLine=se={}));var le;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(le||(e.EnvironmentVariableMutatorType=le={}));let oe=r=class{static isTextEdit(L){return L instanceof r?!0:L?z.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new r(L,te)}static insert(L,te){return r.replace(new z(L,L),te)}static delete(L){return r.replace(L,"")}static setEndOfLine(L){const te=new r(new z(new M(0,0),new M(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!z.isRange(L))throw(0,C.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,C.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,C.illegalArgument)("newEol");this._newEol=L}constructor(L,te){this._range=L,this._newText=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=oe,e.TextEdit=oe=r=$e([p],oe);let fe=h=class{static isNotebookCellEdit(L){return L instanceof h?!0:L?Lt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,te){return new h(L,te)}static insertCells(L,te){return new h(new Lt(L,L),te)}static deleteCells(L){return new h(L,[])}static updateCellMetadata(L,te){const ye=new h(new Lt(L,L),[]);return ye.newCellMetadata=te,ye}static updateNotebookMetadata(L){const te=new h(new Lt(0,0),[]);return te.newNotebookMetadata=L,te}constructor(L,te){this.range=L,this.newCells=te}};e.NotebookEdit=fe,e.NotebookEdit=fe=h=$e([p],fe);class be{constructor(L,te){this.range=L,this.snippet=te}}e.SnippetTextEdit=be;var ce;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace"})(ce||(e.FileEditType=ce={}));let ve=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,ye,je){this._edits.push({_type:1,from:L,to:te,options:ye,metadata:je})}createFile(L,te,ye){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:ye})}deleteFile(L,te,ye){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:ye})}replaceNotebookMetadata(L,te,ye){this._edits.push({_type:3,metadata:ye,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,ye,je,tt){let rt,lt,Dt=[],Nt;if(Lt.isNotebookRange(te)&&jt.isNotebookCellDataArray(ye)&&!jt.isNotebookCellDataArray(je)?(rt=te.start,lt=te.end,Dt=ye,Nt=je):typeof te=="number"&&typeof ye=="number"&&jt.isNotebookCellDataArray(je)&&(rt=te,lt=ye,Dt=je,Nt=tt),rt===void 0||lt===void 0)throw new Error("Invalid arguments");(rt!==lt||Dt.length>0)&&this._edits.push({_type:5,uri:L,index:rt,count:lt-rt,cells:Dt,metadata:Nt})}replaceNotebookCellMetadata(L,te,ye,je){this._edits.push({_type:3,metadata:je,uri:L,edit:{editType:8,index:te,metadata:ye}})}replace(L,te,ye,je){this._edits.push({_type:2,uri:L,edit:new oe(te,ye),metadata:je})}insert(L,te,ye,je){this.replace(L,new z(te,te),ye,je)}delete(L,te,ye){this.replace(L,te,"",ye)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const ye of te)ye&&(fe.isNotebookCellEdit(ye)?ye.newCellMetadata?this.replaceNotebookCellMetadata(L,ye.range.start,ye.newCellMetadata):ye.newNotebookMetadata?this.replaceNotebookMetadata(L,ye.newNotebookMetadata):this.replaceNotebookCells(L,ye.range,ye.newCells):this._edits.push({_type:2,uri:L,edit:ye}));else{for(let ye=0;ye<this._edits.length;ye++){const je=this._edits[ye];je._type===2&&je.uri.toString()===L.toString()&&(this._edits[ye]=void 0)}(0,s.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===L.toString()&&te.push(ye.edit);return te}entries(){const L=new U.ResourceMap;for(let te of this._edits)if(te._type===2){let ye=L.get(te.uri);ye||(ye=[te.uri,[]],L.set(te.uri,ye)),ye[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=ve,e.WorkspaceEdit=ve=$e([p],ve);let J=i=class{static isSnippetString(L){return L instanceof i?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this._tabstop=1,this.value=L||""}appendText(L){return this.value+=i._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const ye=new i;ye._tabstop=this._tabstop,L(ye),this._tabstop=ye._tabstop,L=ye.value}else L=i._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const ye=L.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const ye=new i;ye._tabstop=this._tabstop,te(ye),this._tabstop=ye._tabstop,te=ye.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.SnippetString=J,e.SnippetString=J=i=$e([p],J);var Ee;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(Ee||(e.DiagnosticTag=Ee={}));var _e;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(_e||(e.DiagnosticSeverity=_e={}));let Fe=o=class{static isLocation(L){return L instanceof o?!0:L?z.isRange(L.range)&&A.URI.isUri(L.uri):!1}constructor(L,te){if(this.uri=L,te)if(z.isRange(te))this.range=z.of(te);else if(M.isPosition(te))this.range=new z(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Fe,e.Location=Fe=o=$e([p],Fe);let xe=class{static is(L){return L?typeof L.message=="string"&&L.location&&z.isRange(L.location.range)&&A.URI.isUri(L.location.uri):!1}constructor(L,te){this.location=L,this.message=te}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};e.DiagnosticRelatedInformation=xe,e.DiagnosticRelatedInformation=xe=$e([p],xe);let Xe=class{constructor(L,te,ye=_e.Error){if(!z.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=ye}toJSON(){return{severity:_e[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,s.equals)(L.tags,te.tags)&&(0,s.equals)(L.relatedInformation,te.relatedInformation,xe.isEqual)}};e.Diagnostic=Xe,e.Diagnostic=Xe=$e([p],Xe);let ke=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};e.Hover=ke,e.Hover=ke=$e([p],ke);var Se;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(Se||(e.DocumentHighlightKind=Se={}));let Pe=class{constructor(L,te=Se.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Se[this.kind]}}};e.DocumentHighlight=Pe,e.DocumentHighlight=Pe=$e([p],Pe);var re;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(re||(e.SymbolKind=re={}));var ae;(function(W){W[W.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let X=n=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,te,ye,je,tt){this.name=L,this.kind=te,this.containerName=tt,typeof ye=="string"&&(this.containerName=ye),je instanceof Fe?this.location=je:ye instanceof z&&(this.location=new Fe(je,ye)),n.validate(this)}toJSON(){return{name:this.name,kind:re[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=X,e.SymbolInformation=X=n=$e([p],X);let G=t=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(t.validate)}constructor(L,te,ye,je,tt){this.name=L,this.detail=te,this.kind=ye,this.range=je,this.selectionRange=tt,this.children=[],t.validate(this)}};e.DocumentSymbol=G,e.DocumentSymbol=G=t=$e([p],G);var T;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(T||(e.CodeActionTriggerKind=T={}));let B=class{constructor(L,te){this.title=L,this.kind=te}};e.CodeAction=B,e.CodeAction=B=$e([p],B);let H=l=class{constructor(L){this.value=L}append(L){return new l(this.value?this.value+l.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+l.sep)}};e.CodeActionKind=H,H.sep=".",e.CodeActionKind=H=l=$e([p],H),H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll");let V=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=V,e.SelectionRange=V=$e([p],V);class ne{constructor(L,te,ye,je,tt,rt){this.kind=L,this.name=te,this.detail=ye,this.uri=je,this.range=tt,this.selectionRange=rt}}e.CallHierarchyItem=ne;class ue{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=ue;class Q{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=Q;var ge;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(ge||(e.LanguageStatusSeverity=ge={}));let pe=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};e.CodeLens=pe,e.CodeLens=pe=$e([p],pe);let Ne=b=class{static isMarkdownString(L){return L instanceof b?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,te=!1){f.set(this,void 0),Ye(this,f,new g.MarkdownString(L,{supportThemeIcons:te}),"f")}get value(){return Re(this,f,"f").value}set value(L){Re(this,f,"f").value=L}get isTrusted(){return Re(this,f,"f").isTrusted}set isTrusted(L){Re(this,f,"f").isTrusted=L}get supportThemeIcons(){return Re(this,f,"f").supportThemeIcons}set supportThemeIcons(L){Re(this,f,"f").supportThemeIcons=L}get supportHtml(){return Re(this,f,"f").supportHtml}set supportHtml(L){Re(this,f,"f").supportHtml=L}get baseUri(){return Re(this,f,"f").baseUri}set baseUri(L){Re(this,f,"f").baseUri=L}appendText(L){return Re(this,f,"f").appendText(L),this}appendMarkdown(L){return Re(this,f,"f").appendMarkdown(L),this}appendCodeblock(L,te){return Re(this,f,"f").appendCodeblock(te??"",L),this}};e.MarkdownString=Ne,f=new WeakMap,e.MarkdownString=Ne=b=$e([p],Ne);let Be=class{constructor(L,te){this.label=L,this.documentation=te}};e.ParameterInformation=Be,e.ParameterInformation=Be=$e([p],Be);let Ae=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};e.SignatureInformation=Ae,e.SignatureInformation=Ae=$e([p],Ae);let Ke=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Ke,e.SignatureHelp=Ke=$e([p],Ke);var q;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(q||(e.SignatureHelpTriggerKind=q={}));var Y;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(Y||(e.InlayHintKind=Y={}));let me=class{constructor(L){this.value=L}};e.InlayHintLabelPart=me,e.InlayHintLabelPart=me=$e([p],me);let Le=class{constructor(L,te,ye){this.position=L,this.label=te,this.kind=ye}};e.InlayHint=Le,e.InlayHint=Le=$e([p],Le);var ze;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze||(e.CompletionTriggerKind=ze={}));var Ge;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(Ge||(e.CompletionItemKind=Ge={}));var Ze;(function(W){W[W.Deprecated=1]="Deprecated"})(Ze||(e.CompletionItemTag=Ze={}));let ot=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=ot,e.CompletionItem=ot=$e([p],ot);let Qe=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};e.CompletionList=Qe,e.CompletionList=Qe=$e([p],Qe);let et=class{constructor(L,te,ye){this.insertText=L,this.range=te,this.command=ye}};e.InlineSuggestion=et,e.InlineSuggestion=et=$e([p],et);let qe=class{constructor(L){this.commands=void 0,this.items=L}};e.InlineSuggestionList=qe,e.InlineSuggestionList=qe=$e([p],qe);let st=class{constructor(L,te,ye){this.insertText=L,this.range=te,this.command=ye}};e.InlineSuggestionNew=st,e.InlineSuggestionNew=st=$e([p],st);let it=class{constructor(L,te){this.items=L,this.commands=te}};e.InlineSuggestionsNew=it,e.InlineSuggestionsNew=it=$e([p],it);var at;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(at||(e.ViewColumn=at={}));var ct;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(ct||(e.StatusBarAlignment=ct={}));var Tt;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(Tt||(e.TextEditorLineNumbersStyle=Tt={}));var Ut;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(Ut||(e.TextDocumentSaveReason=Ut={}));var Ct;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Ct||(e.TextEditorRevealType=Ct={}));var ft;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(ft||(e.TextEditorSelectionChangeKind=ft={}));var At;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(At||(e.TextDocumentChangeReason=At={}));var xt;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(xt||(e.DecorationRangeBehavior=xt={})),function(W){function L(te){switch(te){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=L}(ft||(e.TextEditorSelectionChangeKind=ft={}));let _t=class{constructor(L,te){if(te&&!A.URI.isUri(te))throw(0,C.illegalArgument)("target");if(!z.isRange(L)||L.isEmpty)throw(0,C.illegalArgument)("range");this.range=L,this.target=te}};e.DocumentLink=_t,e.DocumentLink=_t=$e([p],_t);let He=class{constructor(L,te,ye,je){this.red=L,this.green=te,this.blue=ye,this.alpha=je}};e.Color=He,e.Color=He=$e([p],He);let Rt=class{constructor(L,te){if(te&&!(te instanceof He))throw(0,C.illegalArgument)("color");if(!z.isRange(L)||L.isEmpty)throw(0,C.illegalArgument)("range");this.range=L,this.color=te}};e.ColorInformation=Rt,e.ColorInformation=Rt=$e([p],Rt);let Mt=class{constructor(L){if(!L||typeof L!="string")throw(0,C.illegalArgument)("label");this.label=L}};e.ColorPresentation=Mt,e.ColorPresentation=Mt=$e([p],Mt);var Ot;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Ot||(e.ColorFormat=Ot={}));var pt;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(pt||(e.SourceControlInputBoxValidationType=pt={}));class St{constructor(L,te,ye){if(this.startIndex=L,this.length=te,this.tooltip=ye,typeof L!="number"||L<0)throw(0,C.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,C.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=St;var It;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(It||(e.TerminalLocation=It={}));class wt{constructor(L){if(this.options=L,typeof L!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=wt;var we;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(we||(e.TaskRevealKind=we={}));var Ce;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(Ce||(e.TaskPanelKind=Ce={}));let de=v=class{static from(L){switch(L){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,C.illegalArgument)("name");this._id=L}get id(){return this._id}};e.TaskGroup=de,de.Clean=new v("clean","Clean"),de.Build=new v("build","Build"),de.Rebuild=new v("rebuild","Rebuild"),de.Test=new v("test","Test"),e.TaskGroup=de=v=$e([p],de);function j(W){let L="";for(let te=0;te<W.length;te++)L+=W[te].replace(/,/g,",,")+",";return L}let De=class{constructor(L,te,ye){if(typeof L!="string")throw(0,C.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=ye):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,C.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return j(L)}};e.ProcessExecution=De,e.ProcessExecution=De=$e([p],De);let Me=class{constructor(L,te,ye){if(this._args=[],Array.isArray(te)){if(!L)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,C.illegalArgument)("command");this._command=L,this._args=te,this._options=ye}else{if(typeof L!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,C.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return j(L)}};e.ShellExecution=Me,e.ShellExecution=Me=$e([p],Me);var Je;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(Je||(e.ShellQuoting=Je={}));var Ve;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(Ve||(e.TaskScope=Ve={}));class ut{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=ut;let ht=E=class{constructor(L,te,ye,je,tt,rt){this.__deprecated=!1,this._definition=this.definition=L;let lt;typeof te=="string"?(this._name=this.name=te,this._source=this.source=ye,this.execution=je,lt=tt,this.__deprecated=!0):te===Ve.Global||te===Ve.Workspace?(this.target=te,this._name=this.name=ye,this._source=this.source=je,this.execution=tt,lt=rt):(this.target=te,this._name=this.name=ye,this._source=this.source=je,this.execution=tt,lt=rt),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof De?this._definition={type:E.ProcessType,id:this._execution.computeId()}:this._execution instanceof Me?this._definition={type:E.ShellType,id:this._execution.computeId()}:this._execution instanceof ut?this._definition={type:E.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:E.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,C.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(E.EmptyType===te||E.ProcessType===te||E.ShellType===te||E.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};e.Task=ht,ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",e.Task=ht=E=$e([p],ht);var Et;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(Et||(e.ProgressLocation=Et={}));let mt=class{constructor(L,te=kt.None){this.collapsibleState=te,A.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.TreeItem=mt,e.TreeItem=mt=$e([p],mt);var kt;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(kt||(e.TreeItemCollapsibleState=kt={}));let Ft=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.DataTransferItem=Ft,e.DataTransferItem=Ft=$e([p],Ft);let vt=class{constructor(L){u.set(this,new Map);for(const[te,ye]of L??[]){const je=Re(this,u,"f").get(te);je?je.push(ye):Re(this,u,"f").set(te,[ye])}}get(L){return Re(this,u,"f").get(L)?.[0]}set(L,te){Re(this,u,"f").set(L,[te])}forEach(L){for(const[te,ye]of Re(this,u,"f"))ye.forEach(je=>L(je,te))}};e.DataTransfer=vt,u=new WeakMap,e.DataTransfer=vt=$e([p],vt);let zt=class{constructor(L,te){this.id=L,this.color=te}};e.ThemeIcon=zt,e.ThemeIcon=zt=$e([p],zt),zt.File=new zt("file"),zt.Folder=new zt("folder");let Yt=class{constructor(L){this.id=L}};e.ThemeColor=Yt,e.ThemeColor=Yt=$e([p],Yt);var ai;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(ai||(e.ConfigurationTarget=ai={}));let li=class{get base(){return this._base}set base(L){this._base=L,this._baseUri=A.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}constructor(L,te){if(typeof L!="string"&&(!L||!A.URI.isUri(L)&&!A.URI.isUri(L.uri)))throw(0,C.illegalArgument)("base");if(typeof te!="string")throw(0,C.illegalArgument)("pattern");typeof L=="string"?this.baseUri=A.URI.file(L):A.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=li,e.RelativePattern=li=$e([p],li);let yt=class{constructor(L,te,ye,je){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof ye=="string"&&(this.hitCondition=ye),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};e.Breakpoint=yt,e.Breakpoint=yt=$e([p],yt);let ii=class extends yt{constructor(L,te,ye,je,tt){super(te,ye,je,tt);if(L===null)throw(0,C.illegalArgument)("location");this.location=L}};e.SourceBreakpoint=ii,e.SourceBreakpoint=ii=$e([p],ii);let ci=class extends yt{constructor(L,te,ye,je,tt){super(te,ye,je,tt);this.functionName=L}};e.FunctionBreakpoint=ci,e.FunctionBreakpoint=ci=$e([p],ci);let Kt=class extends yt{constructor(L,te,ye,je,tt,rt,lt){super(je,tt,rt,lt);if(!te)throw(0,C.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=ye}};e.DataBreakpoint=Kt,e.DataBreakpoint=Kt=$e([p],Kt);let Gt=class{constructor(L,te,ye){this.command=L,this.args=te||[],this.options=ye}};e.DebugAdapterExecutable=Gt,e.DebugAdapterExecutable=Gt=$e([p],Gt);let dt=class{constructor(L,te){this.port=L,this.host=te}};e.DebugAdapterServer=dt,e.DebugAdapterServer=dt=$e([p],dt);let ui=class{constructor(L){this.path=L}};e.DebugAdapterNamedPipeServer=ui,e.DebugAdapterNamedPipeServer=ui=$e([p],ui);let $t=class{constructor(L){this.implementation=L}};e.DebugAdapterInlineImplementation=$t,e.DebugAdapterInlineImplementation=$t=$e([p],$t);let Vt=class{constructor(L,te){this.range=L,this.expression=te}};e.EvaluatableExpression=Vt,e.EvaluatableExpression=Vt=$e([p],Vt);var di;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(di||(e.InlineCompletionTriggerKind=di={}));var vi;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(vi||(e.InlineCompletionTriggerKindNew=vi={}));let ni=class{constructor(L,te){this.range=L,this.text=te}};e.InlineValueText=ni,e.InlineValueText=ni=$e([p],ni);let hi=class{constructor(L,te,ye=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=ye}};e.InlineValueVariableLookup=hi,e.InlineValueVariableLookup=hi=$e([p],hi);let ri=class{constructor(L,te){this.range=L,this.expression=te}};e.InlineValueEvaluatableExpression=ri,e.InlineValueEvaluatableExpression=ri=$e([p],ri);let Xt=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};e.InlineValueContext=Xt,e.InlineValueContext=Xt=$e([p],Xt);var Ei;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(Ei||(e.FileChangeType=Ei={}));let Jt=x=class extends Error{static FileExists(L){return new x(L,S.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(L){return new x(L,S.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(L){return new x(L,S.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(L){return new x(L,S.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(L){return new x(L,S.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(L){return new x(L,S.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(L,te=S.FileSystemProviderErrorCode.Unknown,ye){super(A.URI.isUri(L)?L.toString(!0):L);this.code=ye?.name??"Unknown",(0,S.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}};e.FileSystemError=Jt,e.FileSystemError=Jt=x=$e([p],Jt);let Zt=class{constructor(L,te,ye){this.start=L,this.end=te,this.kind=ye}};e.FoldingRange=Zt,e.FoldingRange=Zt=$e([p],Zt);var bi;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(bi||(e.FoldingRangeKind=bi={}));var wi;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(wi||(e.CommentThreadCollapsibleState=wi={}));var Qt;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(Qt||(e.CommentMode=Qt={}));var _i;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Ri{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=Ri;function Oi(W){return typeof W=="undefined"||(0,w.isStringArray)(W)}class fi{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,ye=L.tokenTypes.length;te<ye;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,ye=L.tokenModifiers.length;te<ye;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,ye,je,tt){if(typeof L=="number"&&typeof te=="number"&&typeof ye=="number"&&typeof je=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(L,te,ye,je,tt);if(z.isRange(L)&&typeof te=="string"&&Oi(ye))return this._push(L,te,ye);throw(0,C.illegalArgument)()}_push(L,te,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const je=L.start.line,tt=L.start.character,rt=L.end.character-L.start.character,lt=this._tokenTypeStrToInt.get(te);let Dt=0;if(ye)for(const Nt of ye){if(!this._tokenModifierStrToInt.has(Nt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(Nt);Dt|=1<<Wt>>>0}this._pushEncoded(je,tt,rt,lt,Dt)}_pushEncoded(L,te,ye,je,tt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Nt=0,Wt=0;for(let Ht=0;Ht<Dt;Ht++){let qt=this._data[5*Ht],gi=this._data[5*Ht+1];qt===0?(qt=Nt,gi+=Wt):qt+=Nt,this._data[5*Ht]=qt,this._data[5*Ht+1]=gi,Nt=qt,Wt=gi}}let rt=L,lt=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=je,this._data[this._dataLen++]=tt,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const ye=L.length/5|0;for(let lt=0;lt<ye;lt++)te[lt]=lt;te.sort((lt,Dt)=>{const Nt=L[5*lt],Wt=L[5*Dt];if(Nt===Wt){const Ht=L[5*lt+1],qt=L[5*Dt+1];return Ht-qt}return Nt-Wt});const je=new Uint32Array(L.length);let tt=0,rt=0;for(let lt=0;lt<ye;lt++){const Dt=5*te[lt],Nt=L[Dt+0],Wt=L[Dt+1],Ht=L[Dt+2],qt=L[Dt+3],gi=L[Dt+4],Gi=Nt-tt,on=Gi===0?Wt-rt:Wt,pi=5*lt;je[pi+0]=Gi,je[pi+1]=on,je[pi+2]=Ht,je[pi+3]=qt,je[pi+4]=gi,tt=Nt,rt=Wt}return je}build(L){return this._dataIsSortedAndDeltaEncoded?new ei(new Uint32Array(this._data),L):new ei(fi._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=fi;class ei{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=ei;class Si{constructor(L,te,ye){this.start=L,this.deleteCount=te,this.data=ye}}e.SemanticTokensEdit=Si;class yi{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=yi;var Ue;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(Ue||(e.DebugConsoleMode=Ue={}));let Bt=class{constructor(){}};e.QuickInputButtons=Bt,Bt.Back={iconPath:new zt("arrow-left")},e.QuickInputButtons=Bt=$e([p],Bt);var mi;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})(mi||(e.QuickPickItemKind=mi={}));var gt;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(gt||(e.InputBoxValidationSeverity=gt={}));var Di;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(Di||(e.ExtensionKind=Di={}));class Fi{static validate(L){if(L.badge){let te=(0,P.nextCharLength)(L.badge,0);if(te<L.badge.length&&(te+=(0,P.nextCharLength)(L.badge,te)),L.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,te,ye){this.badge=L,this.tooltip=te,this.color=ye}}e.FileDecoration=Fi;let si=class{constructor(L){this.kind=L}};e.ColorTheme=si,e.ColorTheme=si=$e([p],si);var Ci;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})(Ci||(e.ColorThemeKind=Ci={}));class Lt{static isNotebookRange(L){return L instanceof Lt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(L,te){if(L<0)throw(0,C.illegalArgument)("start must be positive");if(te<0)throw(0,C.illegalArgument)("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}with(L){let te=this._start,ye=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(ye=L.end),te===this._start&&ye===this._end?this:new Lt(te,ye)}}e.NotebookRange=Lt;class jt{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>jt.isNotebookCellData(te))}static isNotebookCellData(L){return!0}constructor(L,te,ye,je,tt,rt,lt){this.kind=L,this.value=te,this.languageId=ye,this.mime=je,this.outputs=tt??[],this.metadata=rt,this.executionSummary=lt,jt.validate(this)}}e.NotebookCellData=jt;class Ni{constructor(L){this.cells=L}}e.NotebookData=Ni;class Ii{static isNotebookCellOutputItem(L){return L instanceof d?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return d.json(te,"application/vnd.code.notebook.error")}static stdout(L){return d.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return d.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new d(L,te)}static text(L,te=I.Mimes.text){const ye=Re(d,d,"f",c).encode(String(L));return new d(ye,te)}static json(L,te="text/x-json"){const ye=JSON.stringify(L,void 0,"	");return d.text(ye,te)}constructor(L,te){this.data=L,this.mime=te;const ye=(0,I.normalizeMimeType)(te,!0);if(!ye)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}}e.NotebookCellOutputItem=Ii,d=Ii,c={value:new TextEncoder};class ti{static isNotebookCellOutput(L){return L instanceof ti?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,w.isArray)(L.items)}static ensureUniqueMimeTypes(L,te=!1){const ye=new Set,je=new Set;for(let tt=0;tt<L.length;tt++){const rt=L[tt],lt=(0,I.normalizeMimeType)(rt.mime);if(!ye.has(lt)){ye.add(lt);continue}je.add(tt),te&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return je.size===0?L:L.filter((tt,rt)=>!je.has(rt))}constructor(L,te,ye){this.items=ti.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=ye):(this.id=(0,O.generateUuid)(),this.metadata=te??ye)}}e.NotebookCellOutput=ti;var ki;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(ki||(e.NotebookCellKind=ki={}));var Ti;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(Ti||(e.NotebookCellExecutionState=Ti={}));var Pi;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(Pi||(e.NotebookCellStatusBarAlignment=Pi={}));var Ai;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Ai||(e.NotebookEditorRevealType=Ai={}));class Mi{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=Mi;var ie;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(ie||(e.NotebookControllerAffinity=ie={}));class he{constructor(L,te=[]){this.uri=L,this.provides=(0,s.asArray)(te)}}e.NotebookRendererScript=he;let Oe=class{constructor(L,te){this.label=L,this.timestamp=te}};e.TimelineItem=Oe,e.TimelineItem=Oe=$e([p],Oe);var nt;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(nt||(e.ExtensionMode=nt={}));var bt;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(bt||(e.ExtensionRuntime=bt={}));var Pt;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(Pt||(e.StandardTokenType=Pt={}));class Xi{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=Xi;class Qi{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Qi;var Hi;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(Hi||(e.TestResultState=Hi={}));var Vi;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(Vi||(e.TestRunProfileKind=Vi={}));let Li=class{constructor(L=void 0,te=void 0,ye=void 0){this.include=L,this.exclude=te,this.profile=ye}};e.TestRunRequest=Li,e.TestRunRequest=Li=$e([p],Li);let Ui=$=class{static diff(L,te,ye){const je=new $(L);return je.expectedOutput=te,je.actualOutput=ye,je}constructor(L){this.message=L}};e.TestMessage=Ui,e.TestMessage=Ui=$=$e([p],Ui);let xi=class{constructor(L){this.id=L}};e.TestTag=xi,e.TestTag=xi=$e([p],xi);let oi=class{constructor(L,te){this.covered=L,this.total=te}};e.CoveredCount=oi,e.CoveredCount=oi=$e([p],oi);let Bi=R=class{static fromDetails(L,te){const ye=new oi(0,0),je=new oi(0,0),tt=new oi(0,0);for(const lt of te)if("branches"in lt){ye.total+=1,ye.covered+=lt.executionCount>0?1:0;for(const Dt of lt.branches)je.total+=1,je.covered+=Dt.executionCount>0?1:0}else tt.total+=1,tt.covered+=lt.executionCount>0?1:0;const rt=new R(L,ye,je.total>0?je:void 0,tt.total>0?tt:void 0);return rt.detailedCoverage=te,rt}constructor(L,te,ye,je){this.uri=L,this.statementCoverage=te,this.branchCoverage=ye,this.functionCoverage=je}};e.FileCoverage=Bi,e.FileCoverage=Bi=R=$e([p],Bi);let zi=class{constructor(L,te,ye=[]){this.executionCount=L,this.location=te,this.branches=ye}};e.StatementCoverage=zi,e.StatementCoverage=zi=$e([p],zi);let $i=class{constructor(L,te){this.executionCount=L,this.location=te}};e.BranchCoverage=$i,e.BranchCoverage=$i=$e([p],$i);let Wi=class{constructor(L,te){this.executionCount=L,this.location=te}};e.FunctionCoverage=Wi,e.FunctionCoverage=Wi=$e([p],Wi);var ji;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(ji||(e.ExternalUriOpenerPriority=ji={}));var qi;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(qi||(e.WorkspaceTrustState=qi={}));var Ki;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki||(e.PortAutoForwardAction=Ki={}));class Yi{constructor(L,te,ye,je,tt,rt){this.kind=L,this.name=te,this.detail=ye,this.uri=je,this.range=tt,this.selectionRange=rt}}e.TypeHierarchyItem=Yi;class Ji{constructor(L){this.uri=L}}e.TextTabInput=Ji;class Zi{constructor(L,te){this.original=L,this.modified=te}}e.TextDiffTabInput=Zi;class en{constructor(L,te){this.uri=L,this.viewType=te}}e.CustomEditorTabInput=en;class tn{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=tn;class nn{constructor(L,te){this.uri=L,this.notebookType=te}}e.NotebookEditorTabInput=nn;class rn{constructor(L,te,ye){this.original=L,this.modified=te,this.notebookType=ye}}e.NotebookDiffEditorTabInput=rn;class sn{constructor(){}}e.TerminalEditorTabInput=sn}),define(Ie[87],Te([1,0,42,12,10,237,121,6,15]),function(ee,e,s,C,g,U,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function O(f,u){u?A.set(f,u):A.delete(f)}e.setWordDefinitionFor=O;function S(f){return A.get(f)}e.getWordDefinitionFor=S;class m extends U.MirrorTextModel{constructor(u,d,c,k,y,a,D,r){super(d,c,k,y);this._proxy=u,this._languageId=a,this._isDirty=D,this.notebook=r,this._isDisposed=!1}dispose(){(0,s.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,w.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===C.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},save(){return u._save()},getText(d){return d?u._getTextInRange(d):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(d){return u._lineAt(d)},offsetAt(d){return u._offsetAt(d)},positionAt(d){return u._positionAt(d)},validateRange(d){return u._validateRange(d)},validatePosition(d){return u._validatePosition(d)},getWordRangeAtPosition(d,c){return u._getWordRangeAtPosition(d,c)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,s.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,s.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const d=this._validateRange(u);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const c=this._eol,k=d.start.line,y=d.end.line,a=[];a.push(this._lines[k].substring(d.start.character));for(let D=k+1;D<y;D++)a.push(this._lines[D]);return a.push(this._lines[y].substring(0,d.end.character)),a.join(c)}_lineAt(u){let d;if(u instanceof P.Position?d=u.line:typeof u=="number"&&(d=u),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new _(d,this._lines[d],d===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(u),c=this._lines[d.index].length;return new P.Position(d.index,Math.min(d.remainder,c))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const d=this._validatePosition(u.start),c=this._validatePosition(u.end);return d===u.start&&c===u.end?u:new P.Range(d.line,d.character,c.line,c.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:d,character:c}=u,k=!1;if(d<0)d=0,c=0,k=!0;else if(d>=this._lines.length)d=this._lines.length-1,c=this._lines[d].length,k=!0;else{const y=this._lines[d].length;c<0?(c=0,k=!0):c>y&&(c=y,k=!0)}return k?new P.Position(d,c):u}_getWordRangeAtPosition(u,d){const c=this._validatePosition(u);if(!d)d=S(this._languageId);else if((0,g.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const k=(0,I.getWordAtText)(c.character+1,(0,I.ensureValidWordDefinition)(d),this._lines[c.line],0);if(k)return new P.Range(c.line,k.startColumn-1,c.line,k.endColumn-1)}}e.ExtHostDocumentData=m;class _{constructor(u,d,c){this._line=u,this._text=d,this._isLastLine=c}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=_}),define(Ie[160],Te([1,0,6,16,5]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let U=class{constructor(P){this._actual=new s.ColorTheme(s.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new g.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let w;switch(P){case"light":w=s.ColorThemeKind.Light;break;case"hcDark":w=s.ColorThemeKind.HighContrast;break;case"hcLight":w=s.ColorThemeKind.HighContrastLight;break;default:w=s.ColorThemeKind.Dark}this._actual=new s.ColorTheme(w),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=U,e.ExtHostTheming=U=$e([We(0,C.IExtHostRpcService)],U)}),define(Ie[65],Te([1,0,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,s.createDecorator)("IURITransformerService");class C{constructor(U){U?(this.transformIncoming=U.transformIncoming.bind(U),this.transformOutgoing=U.transformOutgoing.bind(U),this.transformOutgoingURI=U.transformOutgoingURI.bind(U),this.transformOutgoingScheme=U.transformOutgoingScheme.bind(U)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=C}),define(Ie[161],Te([1,0,23]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(w){let A=this.buffers.indexOf(w);return A<0&&(A=this.buffers.length,this.buffers.push(w)),A}}function g(P,w){if(w.serializeBuffersForPostMessage){const A=new C,O=(_,f)=>{if(f instanceof ArrayBuffer){const u=A.add(f);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(f)){const u=U(f);if(u){const d=A.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:u,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},S=JSON.stringify(P,O),m=A.buffers.map(_=>{const f=new Uint8Array(_);return s.VSBuffer.wrap(f)});return{message:S,buffers:m}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=g;function U(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(P,w){const A=w.map(m=>{const _=new ArrayBuffer(m.byteLength);return new Uint8Array(_).set(m.buffer),_}),O=w.length?(m,_)=>{if(_&&typeof _=="object"&&_.$$vscode_array_buffer_reference$$){const f=_,{index:u}=f,d=A[u];if(f.view)switch(f.view.type){case 1:return new Int8Array(d,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return _}:void 0;return{message:JSON.parse(P,O),arrayBuffers:A}}e.deserializeWebviewMessage=I}),define(Ie[162],Te([1,0,135,9,2,7,3,30,39,15,12]),function(ee,e,s,C,g,U,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,s.localize)(0,null),providerDisplayName:(0,s.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var S;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var m;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function _(K){const N=K;return!!N&&typeof N.getSelection=="function"&&!!N.onDidChangeSelection}e.isEditorPaneWithSelection=_;function f(K,N,se){for(const le of se.visibleEditorPanes)if(le.group.id===N&&K.matches(le.input))return le.getViewState()}e.findViewStateForEditor=f;function u(K){if(i(K))return!1;const N=K;return g.URI.isUri(N?.resource)}e.isResourceEditorInput=u;function d(K){if(i(K))return!1;const N=K;return N?.original!==void 0&&N.modified!==void 0}e.isResourceDiffEditorInput=d;function c(K){if(i(K)||d(K))return!1;const N=K;return N?.primary!==void 0&&N.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function k(K){if(i(K))return!1;const N=K;return N?N.resource===void 0||N.resource.scheme===O.Schemas.untitled||N.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=k;var y;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(y||(e.Verbosity=y={}));var a;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class D{constructor(){this.mapIdToSaveSource=new Map}registerSource(N,se){let le=this.mapIdToSaveSource.get(N);return le||(le={source:N,label:se},this.mapIdToSaveSource.set(N,le)),le.source}getSourceLabel(N){return this.mapIdToSaveSource.get(N)?.label??N}}e.SaveSourceRegistry=new D;var r;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor"})(r||(e.EditorInputCapabilities=r={}));class h extends U.Disposable{}e.AbstractEditorInput=h;function i(K){return K instanceof h}e.isEditorInput=i;function o(K){const N=K;return g.URI.isUri(N?.preferredResource)}function n(K){const N=K;return i(N?.primary)&&i(N?.secondary)}e.isSideBySideEditorInput=n;function t(K){const N=K;return i(N?.modified)&&i(N?.original)}e.isDiffEditorInput=t;function l(K){return i(K?.editor)}e.isEditorInputWithOptions=l;function b(K){const N=K;return l(K)&&N?.group!==void 0}e.isEditorInputWithOptionsAndGroup=b;function v(K){const N=K;return typeof N?.groupId=="number"&&i(N.editor)}e.isEditorIdentifier=v;var E;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(E||(e.EditorCloseContext=E={}));var x;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(x||(e.GroupModelChangeKind=x={}));var $;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})($||(e.SideBySideEditor=$={}));class R{getOriginalUri(N,se){if(!N)return;if(se?.supportSideBySide){const{primary:oe,secondary:fe}=this.getSideEditors(N);if(oe&&fe){if(se?.supportSideBySide===$.BOTH)return{primary:this.getOriginalUri(oe,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(fe,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===$.ANY)return this.getOriginalUri(oe,{filterByScheme:se.filterByScheme})??this.getOriginalUri(fe,{filterByScheme:se.filterByScheme});N=se.supportSideBySide===$.PRIMARY?oe:fe}}if(d(N)||c(N))return;const le=o(N)?N.preferredResource:N.resource;return!le||!se||!se.filterByScheme?le:this.filterUri(le,se.filterByScheme)}getSideEditors(N){return n(N)||c(N)?{primary:N.primary,secondary:N.secondary}:t(N)||d(N)?{primary:N.modified,secondary:N.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(N,se){if(!N)return;if(se?.supportSideBySide){const{primary:oe,secondary:fe}=this.getSideEditors(N);if(oe&&fe){if(se?.supportSideBySide===$.BOTH)return{primary:this.getCanonicalUri(oe,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(fe,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===$.ANY)return this.getCanonicalUri(oe,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(fe,{filterByScheme:se.filterByScheme});N=se.supportSideBySide===$.PRIMARY?oe:fe}}if(d(N)||c(N))return;const le=N.resource;return!le||!se||!se.filterByScheme?le:this.filterUri(le,se.filterByScheme)}filterUri(N,se){if(Array.isArray(se)){if(se.some(le=>N.scheme===le))return N}else if(se===N.scheme)return N}}e.EditorResourceAccessor=new R;var p;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(p||(e.CloseDirection=p={}));class F{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(N){const se=this.instantiationService=N.get(I.IInstantiationService);for(const[le,oe]of this.editorSerializerConstructors)this.createEditorSerializer(le,oe,se);this.editorSerializerConstructors.clear()}createEditorSerializer(N,se,le){const oe=le.createInstance(se);this.editorSerializerInstances.set(N,oe)}registerFileEditorFactory(N){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=N}getFileEditorFactory(){return(0,C.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(N,se){if(this.editorSerializerConstructors.has(N)||this.editorSerializerInstances.has(N))throw new Error(`A editor serializer with type ID '${N}' was already registered.`);return this.instantiationService?this.createEditorSerializer(N,se,this.instantiationService):this.editorSerializerConstructors.set(N,se),(0,U.toDisposable)(()=>{this.editorSerializerConstructors.delete(N),this.editorSerializerInstances.delete(N)})}getEditorSerializer(N){return this.editorSerializerInstances.get(typeof N=="string"?N:N.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new F);async function M(K,N){if(!K||!K.length)return[];const se=await Promise.all(K.map(async le=>{const oe=g.URI.revive(le.fileUri);if(!oe||!await N.canHandleResource(oe))return;let be=le.exists,ce=le.type;if(typeof be!="boolean"||typeof ce!="number")try{ce=(await N.stat(oe)).isDirectory?w.FileType.Directory:w.FileType.Unknown,be=!0}catch{be=!1}if(!be&&le.openOnlyIfExists||ce===w.FileType.Directory)return;const ve={...le.options,pinned:!0};let J;return be?J={resource:oe,options:ve}:J={resource:oe,options:ve,forceUntitled:!0},J}));return(0,A.coalesce)(se)}e.pathsToEditors=M;var z;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(z||(e.EditorsOrder=z={}));function Z(K){const N=K;if(!N)return!1;const se=N;if(se.modified)return Z(se.modified);const le=N;return!!(le.contributionsState&&le.viewState&&Array.isArray(le.cursorState))}e.isTextEditorViewState=Z}),define(Ie[66],Te([1,0,12,2]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function g(P,w){return P.scheme===s.Schemas.http||P.scheme===s.Schemas.https?P:(w&&w.authority&&w.isRemote&&P.scheme===s.Schemas.file&&(P=C.URI.from({scheme:s.Schemas.vscodeRemote,authority:w.authority,path:P.path})),C.URI.from({scheme:s.Schemas.https,authority:`${P.scheme}+${U(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=g;function U(P){return P.replace(/./g,w=>{const A=w.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?w:"-"+A.toString(16).padStart(4,"0")})}function I(P){return P.replace(/-([0-9a-f]{4})/g,(w,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=I}),define(Ie[163],Te([1,0,5,7,66]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class U{constructor(P,w,A){this._proxy=P,this._editors=w,this._remoteInfo=A,this._handlePool=0,this._disposables=new C.DisposableStore,this._insets=new Map,this._disposables.add(w.onDidChangeVisibleTextEditors(()=>{const O=w.getVisibleTextEditors();for(const S of this._insets.values())O.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,w,A,O,S){let m;for(const y of this._editors.getVisibleTextEditors(!0))if(y.value===P){m=y;break}if(!m)throw new Error("not a visible editor");const _=this,f=this._handlePool++,u=new s.Emitter,d=new s.Emitter,c=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(y){return(0,g.asWebviewUri)(y,_._remoteInfo)}get cspSource(){return g.webviewGenericCspSource}set options(y){this._options=y,_._proxy.$setOptions(f,y)}get options(){return this._options}set html(y){this._html=y,_._proxy.$setHtml(f,y)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(y){return _._proxy.$postMessage(f,y)}},k=new class{constructor(){this.editor=P,this.line=w,this.height=A,this.webview=c,this.onDidDispose=d.event}dispose(){_._insets.has(f)&&(_._insets.delete(f),_._proxy.$disposeEditorInset(f),d.fire(),d.dispose(),u.dispose())}};return this._proxy.$createEditorInset(f,m.id,m.value.document.uri,w+1,A,O||{},S.identifier,S.extensionLocation),this._insets.set(f,{editor:P,inset:k,onDidReceiveMessage:u}),k}$onDidDispose(P){const w=this._insets.get(P);w&&w.inset.dispose()}$onDidReceiveMessage(P,w){const A=this._insets.get(P);A&&A.onDidReceiveMessage.fire(w)}}e.ExtHostEditorInsets=U}),define(Ie[164],Te([1,0,5,13,136]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class U{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new s.Emitter,this._onExit=new s.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,w,A,O){const S={command:P};if(w&&Object.keys(w).length>0&&(S.arguments=w),this.internalSend("request",S),typeof O=="number"){const m=setTimeout(()=>{clearTimeout(m);const _=this.pendingRequests.get(S.seq);if(_){this.pendingRequests.delete(S.seq);const f={type:"response",seq:0,request_seq:S.seq,success:!1,command:P,message:(0,g.localize)(0,null,O,P)};_(f)}},O)}return A&&this.pendingRequests.set(S.seq,A),S.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,w){return P.type!=="event"||w.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,C.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":{const w=P,A=this.pendingRequests.get(w.request_seq);A&&(this.pendingRequests.delete(w.request_seq),A(w));break}}}}internalSend(P,w){w.type=P,w.seq=this.sequence++,this.sendMessage(w)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((w,A)=>P.set(A,w)),await(0,C.timeout)(500),P.forEach((w,A)=>{w({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=U}),define(Ie[165],Te([1,0,137,38,3]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:s.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:s.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:s.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:s.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:s.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:s.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:s.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:s.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:s.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:s.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:s.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:s.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:s.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:s.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:s.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:s.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:s.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:s.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:s.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:s.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:s.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new C.RawContextKey("breakpointAccessType",void 0,{type:"string",description:s.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:s.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:s.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:s.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:s.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:s.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:s.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:s.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:s.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:s.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:s.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:s.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:s.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:s.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:s.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:s.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:s.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:s.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:s.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:s.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:s.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:s.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:s.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:s.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:s.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:s.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:s.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:s.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:s.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:s.localize(50,null)});const U=m=>s.localize(51,null,m);e.debuggerDisabledMessage=U,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:s.localize(52,null)};var I;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(I||(e.State=I={}));function P(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var w;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(w||(e.MemoryRangeType=w={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var A;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(A||(e.DebugConfigurationProviderTriggerKind=A={}));var O;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(O||(e.DebuggerUiMessage=O={})),e.IDebugService=(0,g.createDecorator)(e.DEBUG_SERVICE_ID);var S;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Ie[166],Te([1,0,10,2,19,27,12]),function(ee,e,s,C,g,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function w(i,o,n){return i.replace(P,function(t,l){return o&&l.length>0&&l[0]!=="_"?t:n&&n.hasOwnProperty(l)?n[l]:t})}e.formatPII=w;function A(i){const o={};for(const n of Object.keys(i))n.startsWith("!")||(o[n]=i[n]);return o}e.filterExceptionsFromTelemetry=A;function O(i){return i.configuration.request==="attach"&&!S(i)&&(!i.parentSession||O(i.parentSession))}e.isSessionAttach=O;function S(i){let o=i.configuration.type;if(!!o)return o==="vslsShare"&&(o=i.configuration.adapterProxy.configuration.type),(0,s.equalsIgnoreCase)(o,"extensionhost")||(0,s.equalsIgnoreCase)(o,"pwa-extensionhost")?i:i.parentSession?S(i.parentSession):void 0}e.getExtensionHostDebugSession=S;function m(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=m;function _(i,o,n){let t,l=0;const b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let v=null;for(;v=b.exec(i);){const E=v.index+1,x=E+v[0].length;if(E<=o&&x>=n){t=v[0],l=E;break}}if(t){const E=/\w+/g;let x=null;for(;(x=E.exec(t))&&!(x.index+1+l+x[0].length>=n););x&&(t=t.substring(0,E.lastIndex))}return t?{start:l,end:l+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=_;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(i){return!!(i&&i.match(f))}e.isUri=u;function d(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(u(i.path))return C.URI.parse(i.path);if((0,g.isAbsolute)(i.path))return C.URI.file(i.path)}return i.path}function c(i){if(typeof i.path=="object"){const o=C.URI.revive(i.path);if(o)return o.scheme===I.Schemas.file?o.fsPath:o.toString()}return i.path}function k(i,o){const n=o?d:c,t=(0,U.deepClone)(i);return a(t,(l,b)=>{l&&b&&(b.path=n(b))}),t}e.convertToDAPaths=k;function y(i,o){const n=o?d:c,t=(0,U.deepClone)(i);return a(t,(l,b)=>{!l&&b&&(b.path=n(b))}),t}e.convertToVSCPaths=y;function a(i,o){switch(i.type){case"event":{const n=i;switch(n.event){case"output":o(!1,n.body.source);break;case"loadedSource":o(!1,n.body.source);break;case"breakpoint":o(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=i;switch(n.command){case"setBreakpoints":o(!0,n.arguments.source);break;case"breakpointLocations":o(!0,n.arguments.source);break;case"source":o(!0,n.arguments.source);break;case"gotoTargets":o(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(t=>o(!1,t));break;default:break}break}case"response":{const n=i;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(t=>o(!1,t.source));break;case"loadedSources":n.body.sources.forEach(t=>o(!1,t));break;case"scopes":n.body.scopes.forEach(t=>o(!1,t.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(t=>o(!1,t.source));break;case"setBreakpoints":n.body.breakpoints.forEach(t=>o(!1,t.source));break;case"disassemble":{const t=n;t.body&&t.body.instructions.forEach(l=>o(!1,l.location))}break;default:break}break}}}function D(i){return i.filter(o=>!o.presentation?.hidden).sort((o,n)=>o.presentation?n.presentation?o.presentation.group?n.presentation.group?o.presentation.group!==n.presentation.group?o.presentation.group.localeCompare(n.presentation.group):r(o.presentation.order,n.presentation.order):-1:n.presentation.group?1:r(o.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=D;function r(i,o){return typeof i!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:i-o}async function h(i,o){const n=i.getValue("debug.saveBeforeStart",{overrideIdentifier:o.activeTextEditorLanguageId});if(n!=="none"&&(await o.saveAll(),n==="allEditorsInActiveGroup")){const t=o.activeEditorPane;t&&t.input.resource?.scheme===I.Schemas.untitled&&await o.save({editor:t.input,groupId:t.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=h}),define(Ie[88],Te([1,0,34,167,74,12,19,22,38]),function(ee,e,s,C,g,U,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var A;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(A||(e.CellKind=A={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",g.Mimes.latex,g.Mimes.markdown,"image/png","image/jpeg",g.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[g.Mimes.latex,g.Mimes.markdown,"application/json",g.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var O;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(O||(e.NotebookRunState=O={}));var S;(function(n){n[n.Unconfirmed=1]="Unconfirmed",n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var m;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(m||(e.NotebookRendererMatch=m={}));var _;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(_||(e.RendererMessagingSpec=_={}));var f;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeCellLanguage=5]="ChangeCellLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var u;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(u||(e.SelectionStateType=u={}));var d;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(d||(e.CellEditType=d={}));var c;(function(n){n.scheme=U.Schemas.vscodeNotebookCell;const t=/^ch(\d{7,})/;function l(R,p){return R.with({scheme:n.scheme,fragment:`ch${p.toString().padStart(7,"0")}${R.scheme!==U.Schemas.file?R.scheme:""}`})}n.generate=l;function b(R){if(R.scheme!==n.scheme)return;const p=t.exec(R.fragment);return p?{handle:Number(p[1]),notebook:R.with({scheme:R.fragment.substring(p[0].length)||U.Schemas.file,fragment:null})}:void 0}n.parse=b;function v(R,p){return R.with({scheme:U.Schemas.vscodeNotebookCellOutput,fragment:`op${p??""},${R.scheme!==U.Schemas.file?R.scheme:""}`})}n.generateCellOutputUri=v;function E(R){if(R.scheme!==U.Schemas.vscodeNotebookCellOutput)return;const p=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(R.fragment);if(!p)return;const F=p[1]&&p[1]!==""?p[1]:void 0,M=p[2];return{outputId:F,notebook:R.with({scheme:M||U.Schemas.file,fragment:null})}}n.parseCellOutputUri=E;function x(R,p,F){return R.with({scheme:F,fragment:`ch${p.toString().padStart(7,"0")}${R.scheme!==U.Schemas.file?R.scheme:""}`})}n.generateCellUri=x;function $(R,p){if(R.scheme!==p)return;const F=t.exec(R.fragment);return F?{handle:Number(F[1]),notebook:R.with({scheme:R.fragment.substring(F[0].length)||U.Schemas.file,fragment:null})}:void 0}n.parseCellUri=$})(c||(e.CellUri=c={}));const k=n=>P.isWindows?n.replace(/\//g,"\\"):n;class y{constructor(t=[],l=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=l,this.order=[...new Set(t)].map(b=>({pattern:b,matches:s.parse(k(b))}))}sort(t){const l=new Map(C.Iterable.map(t,v=>[v,k(v)]));let b=[];for(const{matches:v}of this.order)for(const[E,x]of l)if(v(x)){b.push(E),l.delete(E);break}return l.size&&(b=b.concat([...l.keys()].sort((v,E)=>this.defaultOrder.indexOf(v)-this.defaultOrder.indexOf(E)))),b}prioritize(t,l){const b=this.findIndex(t);if(b===-1){this.order.unshift({pattern:t,matches:s.parse(k(t))});return}const v=new Set(l.map(x=>this.findIndex(x,b)));v.delete(-1);const E=Array.from(v).sort();this.order.splice(b+1,0,...E.map(x=>this.order[x]));for(let x=E.length-1;x>=0;x--)this.order.splice(E[x],1)}toArray(){return this.order.map(t=>t.pattern)}findIndex(t,l=this.order.length){const b=k(t);for(let v=0;v<l;v++)if(this.order[v].matches(b))return v;return-1}}e.MimeTypeDisplayOrder=y;function a(n,t,l,b=(v,E)=>v===E){const v=[];function E(R,p,F){if(p===0&&F.length===0)return;const M=v[v.length-1];M&&M.start+M.deleteCount===R?(M.deleteCount+=p,M.toInsert.push(...F)):v.push({start:R,deleteCount:p,toInsert:F})}let x=0,$=0;for(;;){if(x===n.length){E(x,0,t.slice($));break}if($===t.length){E(x,n.length-x,[]);break}const R=n[x],p=t[$];if(b(R,p)){x+=1,$+=1;continue}l(p)?(E(x,1,[]),x+=1):(E(x,0,[p]),$+=1)}return v}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new w.RawContextKey("notebookEditorCursorAtBoundary","none");var D;(function(n){n.default="default",n.option="option"})(D||(e.NotebookEditorPriority=D={}));function r(n){const t=n;return!!((typeof t.include=="string"||s.isRelativePattern(t.include))&&(typeof t.exclude=="string"||s.isRelativePattern(t.exclude)))}e.isDocumentExcludePattern=r;function h(n,t,l){if(Array.isArray(n.viewType)&&n.viewType.indexOf(t)>=0||n.viewType===t)return!0;if(n.filenamePattern){const b=r(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,v=r(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(s.match(b,(0,I.basename)(l.fsPath).toLowerCase()))return!(v&&s.match(v,(0,I.basename)(l.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",interactiveWindowAlwaysScrollOnNewCell:"interactiveWindow.alwaysScrollOnNewCell"};var i;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(i||(e.CellStatusbarAlignment=i={}));class o{static create(t){return`${o._prefix}${t}`}static parse(t){if(t.startsWith(o._prefix))return t.substring(o._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o._prefix="notebook/"}),define(Ie[168],Te([1,0,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(C||(e.CellExecutionUpdateType=C={})),e.INotebookExecutionService=(0,s.createDecorator)("INotebookExecutionService")}),define(Ie[169],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function s(g){return[...g.entries()]}e.serializeEnvironmentVariableCollection=s;function C(g){return new Map(g)}e.deserializeEnvironmentVariableCollection=C}),define(Ie[47],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(U){U.Delimiter="\0"})(s||(e.TestIdPathParts=s={}));var C;(function(U){U[U.IsSame=0]="IsSame",U[U.Disconnected=1]="Disconnected",U[U.IsChild=2]="IsChild",U[U.IsParent=3]="IsParent"})(C||(e.TestPosition=C={}));class g{static fromExtHostTestItem(I,P,w=I.parent){if(I.id===P)return new g([P]);let A=[I.id];for(let O=w;O&&O.id!==P;O=O.parent)A.push(O.id);return A.push(P),new g(A.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const P=I.indexOf("\0");return P===-1?I:I.slice(0,P)}static fromString(I){return new g(I.split("\0"))}static join(I,P){return new g([...I.path,P])}static joinToString(I,P){return I.toString()+"\0"+P}static compare(I,P){return I===P?0:P.startsWith(I+"\0")?2:I.startsWith(P+"\0")?3:1}constructor(I,P=I.length){if(this.path=I,this.viewEnd=P,I.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new g(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let I=1;I<=this.viewEnd;I++)yield new g(this.path,I)}compare(I){if(typeof I=="string")return g.compare(this.toString(),I);for(let P=0;P<I.viewEnd&&P<this.viewEnd;P++)if(I.path[P]!==this.path[P])return 1;return I.viewEnd>this.viewEnd?2:I.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let I=1;I<this.viewEnd;I++)this.stringifed+="\0",this.stringifed+=this.path[I]}return this.stringifed}}e.TestId=g}),define(Ie[48],Te([1,0,2,49]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(g||(e.TestResultState=g={}));var U;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(U||(e.TestRunProfileBitset=U={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:C.Range.lift(t.range),uri:s.URI.revive(t.uri)})})(I||(e.IRichLocation=I={}));var P;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(P||(e.TestMessageType=P={}));var w;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&I.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&I.deserialize(t.location)})})(w||(e.ITestErrorMessage=w={}));var A;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&I.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&I.deserialize(t.location)})})(A||(e.ITestOutputMessage=A={}));var O;(function(n){n.serialize=t=>t.type===0?w.serialize(t):A.serialize(t),n.deserialize=t=>t.type===0?w.deserialize(t):A.deserialize(t)})(O||(e.ITestMessage=O={}));var S;(function(n){n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(O.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(O.deserialize)})})(S||(e.ITestTaskState=S={}));const m="\0",_=(n,t)=>n+m+t;e.namespaceTestTag=_;const f=n=>{const t=n.indexOf(m);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=f;var u;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?s.URI.revive(t.uri):void 0,range:t.range?C.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(u||(e.ITestItem=u={}));var d;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(d||(e.TestItemExpandState=d={}));var c;(function(n){n.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:u.serialize(t.item)}),n.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:u.deserialize(t.item)})})(c||(e.InternalTestItem=c={}));var k;(function(n){n.serialize=t=>{let l;return t.item&&(l={},t.item.label!==void 0&&(l.label=t.item.label),t.item.tags!==void 0&&(l.tags=t.item.tags),t.item.busy!==void 0&&(l.busy=t.item.busy),t.item.uri!==void 0&&(l.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(l.range=t.item.range?.toJSON()),t.item.description!==void 0&&(l.description=t.item.description),t.item.error!==void 0&&(l.error=t.item.error),t.item.sortText!==void 0&&(l.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:l}},n.deserialize=t=>{let l;return t.item&&(l={},t.item.label!==void 0&&(l.label=t.item.label),t.item.tags!==void 0&&(l.tags=t.item.tags),t.item.busy!==void 0&&(l.busy=t.item.busy),t.item.range!==void 0&&(l.range=t.item.range?C.Range.lift(t.item.range):null),t.item.description!==void 0&&(l.description=t.item.description),t.item.error!==void 0&&(l.error=t.item.error),t.item.sortText!==void 0&&(l.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:l}}})(k||(e.ITestItemUpdate=k={}));const y=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=y;var a;(function(n){n.serialize=(t,l)=>({...c.serialize(t),children:l,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(S.serialize)})})(a||(e.TestResultItem=a={}));var D;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(D||(e.DetailType=D={}));var r;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.Remove=2]="Remove",n[n.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",n[n.Retire=4]="Retire",n[n.AddTag=5]="AddTag",n[n.RemoveTag=6]="RemoveTag"})(r||(e.TestDiffOpType=r={}));var h;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:c.deserialize(t.item)}:t.op===1?{op:t.op,item:k.deserialize(t.item)}:t,n.serialize=t=>t.op===0?{op:t.op,item:c.serialize(t.item)}:t.op===1?{op:t.op,item:k.serialize(t.item)}:t})(h||(e.TestsDiffOp=h={}));class i{add(t){}update(t){}remove(t,l){}complete(){}}e.IncrementalChangeCollector=i;class o{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const l=this.createChangeCollector();for(const b of t)switch(b.op){case 0:{const v=c.deserialize(b.item);if(v.parent){if(this.items.has(v.parent)){const E=this.items.get(v.parent);E.children.add(v.item.extId);const x=this.createItem(v,E);this.items.set(v.item.extId,x),l.add(x)}}else{const E=this.createItem(v);this.roots.add(E),this.items.set(v.item.extId,E),l.add(E)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=k.deserialize(b.item),E=this.items.get(v.extId);if(!E)break;v.expand!==void 0&&(E.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(E,v),l.update(E);break}case 2:{const v=this.items.get(b.itemId);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const E=[[b.itemId]];for(;E.length;)for(const x of E.pop()){const $=this.items.get(x);$&&(E.push($.children),this.items.delete(x),l.remove($,$!==v),$.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(b.itemId);break;case 3:this.updatePendingRoots(b.amount);break;case 5:this._tags.set(b.tag.id,b.tag);break;case 6:this._tags.delete(b.id);break}l.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new i}}e.AbstractIncrementalTestCollection=o}),define(Ie[67],Te([1,0,13,5,7,9,48,47]),function(ee,e,s,C,g,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk"})(w||(e.TestItemEventOp=w={}));const A=(c,k)=>c===k,O={range:(c,k)=>c===k?!0:!c||!k?!1:c.equalsRange(k),busy:A,label:A,description:A,error:A,tags:(c,k)=>!(c.length!==k.length||c.some(y=>!k.includes(y)))},S=(c,k)=>{let y;for(const[a,D]of Object.entries(O))D(c[a],k[a])||(y?y[a]=k[a]:y={[a]:k[a]});return y};class m extends g.Disposable{get root(){return this.options.root}constructor(k){super();this.options=k,this.debounceSendDiff=this._register(new s.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new C.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(k){this._resolveHandler=k;for(const y of this.tree.values())this.updateExpandability(y)}collectDiff(){const k=this.diff;return this.diff=[],k}pushDiff(k){const y=this.diff[this.diff.length-1];if(y&&k.op===1){if(y.op===1&&y.item.extId===k.item.extId){(0,I.applyTestItemUpdate)(y.item,k.item);return}if(y.op===0&&y.item.item.extId===k.item.extId){(0,I.applyTestItemUpdate)(y.item,k.item);return}}this.diff.push(k),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(k,y){const a=this.tree.get(k);if(!!a){if((a.expandLevels===void 0||y>a.expandLevels)&&(a.expandLevels=y),a.expand===1){const D=this.resolveChildren(a);return D.isOpen()?this.expandChildren(a,y-1):D.wait().then(()=>this.expandChildren(a,y-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,y-1)):this.expandChildren(a,y-1)}}dispose(){for(const k of this.tree.values())this.options.getApiFor(k.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(k,y){switch(y.op){case 3:this.removeItem(P.TestId.joinToString(k.fullId,y.id));break;case 0:this.upsertItem(y.item,k);break;case 5:for(const a of y.ops)this.onTestItemEvent(k,a);break;case 1:this.diffTagRefs(y.new,y.old,k.fullId.toString());break;case 2:this.updateExpandability(k);break;case 4:this.pushDiff({op:1,item:{extId:k.fullId.toString(),item:y.update}});break;default:(0,U.assertNever)(y)}}upsertItem(k,y){const a=P.TestId.fromExtHostTestItem(k,this.root.id,y?.actual),D=this.options.getApiFor(k);D.parent&&D.parent!==y?.actual&&this.options.getChildren(D.parent).delete(k.id);let r=this.tree.get(a.toString());if(!r){r={fullId:a,actual:k,parent:y?a.parentId:null,expandLevels:y?.expandLevels?y.expandLevels-1:void 0,expand:0},k.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(k,y),this.pushDiff({op:0,item:{parent:r.parent&&r.parent.toString(),controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(k)}}),this.connectItemAndChildren(k,r,y);return}if(r.actual===k){this.connectItem(k,r,y);return}const h=this.options.getChildren(r.actual),i=r.actual,o=S(this.options.toITestItem(i),this.options.toITestItem(k));this.options.getApiFor(i).listener=void 0,r.actual=k,r.expand=0,o&&(o.hasOwnProperty("tags")&&(this.diffTagRefs(k.tags,i.tags,a.toString()),delete o.tags),this.onTestItemEvent(r,{op:4,update:o})),this.connectItemAndChildren(k,r,y);for(const n of h)this.options.getChildren(k).get(n.id)||this.removeItem(P.TestId.joinToString(a,n.id))}diffTagRefs(k,y,a){const D=new Set(y.map(r=>r.id));for(const r of k)D.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:a,item:{tags:k.map(r=>(0,I.namespaceTestTag)(this.options.controllerId,r.id))}}}),D.forEach(this.decrementTagRefs,this)}incrementTagRefs(k){const y=this.tags.get(k.id);y?y.refCount++:(this.tags.set(k.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,I.namespaceTestTag)(this.options.controllerId,k.id)}}))}decrementTagRefs(k){const y=this.tags.get(k);y&&!--y.refCount&&(this.tags.delete(k),this.pushDiff({op:6,id:(0,I.namespaceTestTag)(this.options.controllerId,k)}))}setItemParent(k,y){this.options.getApiFor(k).parent=y&&y.actual!==this.root?y.actual:void 0}connectItem(k,y,a){this.setItemParent(k,a);const D=this.options.getApiFor(k);D.parent=a?.actual,D.listener=r=>this.onTestItemEvent(y,r),this.updateExpandability(y)}connectItemAndChildren(k,y,a){this.connectItem(k,y,a);for(const D of this.options.getChildren(k))this.upsertItem(D,y)}updateExpandability(k){let y;this._resolveHandler?k.resolveBarrier?y=k.resolveBarrier.isOpen()?3:2:y=k.actual.canResolveChildren?1:0:y=0,y!==k.expand&&(k.expand=y,this.pushDiff({op:1,item:{extId:k.fullId.toString(),expand:y}}),y===1&&k.expandLevels!==void 0&&this.resolveChildren(k))}expandChildren(k,y){if(y<0)return;const a=[];for(const D of this.options.getChildren(k.actual)){const r=this.expand(P.TestId.joinToString(k.fullId,D.id),y);(0,s.isThenable)(r)&&a.push(r)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(k){if(k.resolveBarrier)return k.resolveBarrier;if(!this._resolveHandler){const r=new s.Barrier;return r.open(),r}k.expand=2,this.pushExpandStateUpdate(k);const y=k.resolveBarrier=new s.Barrier,a=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let D;try{D=this._resolveHandler(k.actual===this.root?void 0:k.actual)}catch(r){a(r)}return(0,s.isThenable)(D)?D.catch(a).then(()=>{y.open(),this.updateExpandability(k)}):(y.open(),this.updateExpandability(k)),k.resolveBarrier}pushExpandStateUpdate(k){this.pushDiff({op:1,item:{extId:k.fullId.toString(),expand:k.expand}})}removeItem(k){const y=this.tree.get(k);if(!y)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:k});const a=[y];for(;a.length;){const D=a.pop();if(!!D){this.options.getApiFor(D.actual).listener=void 0;for(const r of D.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(D.fullId.toString());for(const r of this.options.getChildren(D.actual))a.push(this.tree.get(P.TestId.joinToString(D.fullId,r.id)))}}}flushDiff(){const k=this.collectDiff();k.length&&this.diffOpEmitter.fire(k)}}e.TestItemCollection=m;class _ extends Error{constructor(k){super(`Attempted to insert a duplicate test item ID ${k}`)}}e.DuplicateTestItemError=_;class f extends Error{constructor(k){super(`TestItem with ID "${k}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class u extends Error{constructor(k,y,a){super(`TestItem with ID "${k}" is from controller "${y}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=u;const d=(c,k,y)=>{let a=new Map;return{get size(){return a.size},forEach(D,r){for(const h of a.values())D.call(r,h,this)},replace(D){const r=new Map,h=new Set(a.keys()),i={op:5,ops:[]};for(const o of D){if(!(o instanceof y))throw new f(o.id);const n=k(o).controllerId;if(n!==c.controllerId)throw new u(o.id,n,c.controllerId);if(r.has(o.id))throw new _(o.id);r.set(o.id,o),h.delete(o.id),i.ops.push({op:0,item:o})}for(const o of h.keys())i.ops.push({op:3,id:o});c.listener?.(i),a=r},add(D){if(!(D instanceof y))throw new f(D.id);a.set(D.id,D),c.listener?.({op:0,item:D})},delete(D){a.delete(D)&&c.listener?.({op:3,id:D})},get(D){return a.get(D)},toJSON(){return Array.from(a.values())},[Symbol.iterator](){return a.values()}}};e.createTestItemChildren=d}),define(Ie[89],Te([1,0,67]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,g=(I,P)=>{const w={controllerId:P};return C.set(I,w),w};e.createPrivateApiFor=g;const U=I=>{const P=C.get(I);if(!P)throw new s.InvalidTestItemError(I?.id||"<unknown>");return P};e.getPrivateApiFor=U}),define(Ie[170],Te([1,0,19,61,9,27,22,76,140,10]),function(ee,e,s,C,g,U,I,P,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class O{constructor(m,_,f,u){this._contributedVariables=new Map,this._context=m,this._labelService=_,this._userHomePromise=f,u&&(this._envVariablesPromise=u.then(d=>this.prepareEnv(d)))}prepareEnv(m){if(I.isWindows){const _=Object.create(null);return Object.keys(m).forEach(f=>{_[f.toLowerCase()]=m[f]}),_}return m}resolveWithEnvironment(m,_,f){return this.recursiveResolve({env:this.prepareEnv(m),userHome:void 0},_?_.uri:void 0,f)}async resolveAsync(m,_){const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,m?m.uri:void 0,_)}async resolveAnyBase(m,_,f,u){const d=U.deepClone(_);I.isWindows&&d.windows?Object.keys(d.windows).forEach(k=>d[k]=d.windows[k]):I.isMacintosh&&d.osx?Object.keys(d.osx).forEach(k=>d[k]=d.osx[k]):I.isLinux&&d.linux&&Object.keys(d.linux).forEach(k=>d[k]=d.linux[k]),delete d.windows,delete d.osx,delete d.linux;const c={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(c,m?m.uri:void 0,d,f,u)}async resolveAnyAsync(m,_,f){return this.resolveAnyBase(m,_,f)}async resolveAnyMap(m,_,f){const u=new Map;return{newConfig:await this.resolveAnyBase(m,_,f,u),resolvedVariables:u}}resolveWithInteractionReplace(m,_,f,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,_,f,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,_){if(this._contributedVariables.has(m))throw new Error("Variable "+m+" is contributed twice.");this._contributedVariables.set(m,_)}async recursiveResolve(m,_,f,u,d){if(g.isString(f))return this.resolveString(m,_,f,u,d);if(g.isArray(f))return Promise.all(f.map(c=>this.recursiveResolve(m,_,c,u,d)));if(g.isObject(f)){let c=Object.create(null);const k=await Promise.all(Object.keys(f).map(async y=>[await this.resolveString(m,_,y,u,d),await this.recursiveResolve(m,_,f[y],u,d)]));for(const[y,a]of k)c[y]=a;return c}return f}resolveString(m,_,f,u,d){return(0,A.replaceAsync)(f,O.VARIABLE_REGEXP,async(c,k)=>{if(k.includes(O.VARIABLE_LHS))return c;let y=await this.evaluateSingleVariable(m,c,k,_,u);return d&&d.set(k,y),y!==c&&g.isString(y)&&y.match(O.VARIABLE_REGEXP)&&(y=await this.resolveString(m,_,y,u,d)),y})}fsPath(m){return this._labelService?this._labelService.getUriLabel(m,{noPrefix:!0}):m.fsPath}async evaluateSingleVariable(m,_,f,u,d){let c;const k=f.split(":");k.length>1&&(f=k[0],c=k[1]);const y=()=>{const r=this._context.getFilePath();if(r)return r;throw new Error((0,w.localize)(0,null,_))},a=()=>{const r=y();if(this._context.getWorkspaceFolderPathForFile){const h=this._context.getWorkspaceFolderPathForFile();if(h)return h}throw new Error((0,w.localize)(1,null,_,s.basename(r)))},D=()=>{if(c){const r=this._context.getFolderUri(c);if(r)return r;throw new Error((0,w.localize)(2,null,_,c))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,w.localize)(3,null,_)):new Error((0,w.localize)(4,null,_))};switch(f){case"env":if(c){if(m.env){const r=m.env[I.isWindows?c.toLowerCase():c];if(g.isString(r))return r}return""}throw new Error((0,w.localize)(5,null,_));case"config":if(c){const r=this._context.getConfigurationValue(u,c);if(g.isUndefinedOrNull(r))throw new Error((0,w.localize)(6,null,_,c));if(g.isObject(r))throw new Error((0,w.localize)(7,null,_,c));return r}throw new Error((0,w.localize)(8,null,_));case"command":return this.resolveFromMap(_,c,d,"command");case"input":return this.resolveFromMap(_,c,d,"input");case"extensionInstallFolder":if(c){const r=await this._context.getExtension(c);if(!r)throw new Error((0,w.localize)(9,null,_,c));return this.fsPath(r.extensionLocation)}throw new Error((0,w.localize)(10,null,_));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(D()));case"cwd":return u||c?(0,P.normalizeDriveLetter)(this.fsPath(D())):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return s.basename(this.fsPath(D()));case"userHome":{if(m.userHome)return m.userHome;throw new Error((0,w.localize)(11,null,_))}case"lineNumber":{const r=this._context.getLineNumber();if(r)return r;throw new Error((0,w.localize)(12,null,_))}case"selectedText":{const r=this._context.getSelectedText();if(r)return r;throw new Error((0,w.localize)(13,null,_))}case"file":return y();case"fileWorkspaceFolder":return a();case"relativeFile":return u||c?s.relative(this.fsPath(D()),y()):y();case"relativeFileDirname":{const r=s.dirname(y());if(u||c){const h=s.relative(this.fsPath(D()),r);return h.length===0?".":h}return r}case"fileDirname":return s.dirname(y());case"fileExtname":return s.extname(y());case"fileBasename":return s.basename(y());case"fileBasenameNoExtension":{const r=s.basename(y());return r.slice(0,r.length-s.extname(r).length)}case"fileDirnameBasename":return s.basename(s.dirname(y()));case"execPath":{const r=this._context.getExecPath();return r||_}case"execInstallFolder":{const r=this._context.getAppRoot();return r||_}case"pathSeparator":return s.sep;default:try{const r=c?`${f}:${c}`:f;return this.resolveFromMap(_,r,d,void 0)}catch{return _}}}}resolveFromMap(m,_,f,u){if(_&&f){const d=u===void 0?f[_]:f[u+":"+_];if(typeof d=="string")return d;throw new Error((0,w.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=O,O.VARIABLE_LHS="${",O.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[90],Te([1,0,3,162]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,s.createDecorator)("editorGroupsService");var g;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var U;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(U||(e.GroupOrientation=U={}));var I;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(I||(e.GroupLocation=I={}));var P;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(P||(e.GroupsArrangement=P={}));var w;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(w||(e.MergeGroupMode=w={}));function A(f){const u=f;return(0,C.isEditorInput)(u?.editor)&&(0,C.isEditorInput)(u?.replacement)}e.isEditorReplacement=A;var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O||(e.GroupsOrder=O={}));var S;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function m(f){const u=f;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.isEditorGroup=m;function _(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=_}),define(Ie[171],Te([1,0,3,90]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,s.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function g(U){const I=U;return typeof U=="number"||(0,C.isEditorGroup)(I)}e.isPreferredGroup=g}),define(Ie[8],Te([1,0,15,23,75,24,105,57,27,9,2,49,68,143,80,89,88,47,48,171,6,172]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d,c,k,y,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.SnippetTextEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(we){function Ce(j){const{selectionStartLineNumber:De,selectionStartColumn:Me,positionLineNumber:Je,positionColumn:Ve}=j,ut=new a.Position(De-1,Me-1),ht=new a.Position(Je-1,Ve-1);return new a.Selection(ut,ht)}we.to=Ce;function de(j){const{anchor:De,active:Me}=j;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}we.from=de})(r||(e.Selection=r={}));var h;(function(we){function Ce(j){if(!j)return;const{start:De,end:Me}=j;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}we.from=Ce;function de(j){if(!j)return;const{startLineNumber:De,startColumn:Me,endLineNumber:Je,endColumn:Ve}=j;return new a.Range(De-1,Me-1,Je-1,Ve-1)}we.to=de})(h||(e.Range=h={}));var i;(function(we){function Ce(de){switch(de){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}we.to=Ce})(i||(e.TokenType=i={}));var o;(function(we){function Ce(j){return new a.Position(j.lineNumber-1,j.column-1)}we.to=Ce;function de(j){return{lineNumber:j.line+1,column:j.character+1}}we.from=de})(o||(e.Position=o={}));var n;(function(we){function Ce(De,Me){return(0,s.coalesce)((0,s.asArray)(De).map(Je=>de(Je,Me)))}we.from=Ce;function de(De,Me){if(typeof De=="string")return{$serialized:!0,language:De};if(De)return{$serialized:!0,language:De.language,scheme:j(De.scheme,Me),pattern:Ge.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType}}function j(De,Me){return Me&&typeof De=="string"?Me.transformOutgoingScheme(De):De}})(n||(e.DocumentSelector=n={}));var t;(function(we){function Ce(j){switch(j){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}we.from=Ce;function de(j){switch(j){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}we.to=de})(t||(e.DiagnosticTag=t={}));var l;(function(we){function Ce(j){let De;return j.code&&((0,A.isString)(j.code)||(0,A.isNumber)(j.code)?De=String(j.code):De={value:String(j.code.value),target:j.code.target}),{...h.from(j.range),message:j.message,source:j.source,code:De,severity:v.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(b.from),tags:Array.isArray(j.tags)?(0,s.coalesce)(j.tags.map(t.from)):void 0}}we.from=Ce;function de(j){const De=new a.Diagnostic(h.to(j),j.message,v.to(j.severity));return De.source=j.source,De.code=(0,A.isString)(j.code)?j.code:j.code?.value,De.relatedInformation=j.relatedInformation&&j.relatedInformation.map(b.to),De.tags=j.tags&&(0,s.coalesce)(j.tags.map(t.to)),De}we.to=de})(l||(e.Diagnostic=l={}));var b;(function(we){function Ce(j){return{...h.from(j.location.range),message:j.message,resource:j.location.uri}}we.from=Ce;function de(j){return new a.DiagnosticRelatedInformation(new a.Location(j.resource,h.to(j)),j.message)}we.to=de})(b||(e.DiagnosticRelatedInformation=b={}));var v;(function(we){function Ce(j){switch(j){case a.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}we.from=Ce;function de(j){switch(j){case f.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}we.to=de})(v||(e.DiagnosticSeverity=v={}));var E;(function(we){function Ce(j){return typeof j=="number"&&j>=a.ViewColumn.One?j-1:j===a.ViewColumn.Beside?y.SIDE_GROUP:y.ACTIVE_GROUP}we.from=Ce;function de(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=de})(E||(e.ViewColumn=E={}));function x(we){return typeof we.range!="undefined"}function $(we){return we.length===0?!0:!!x(we[0])}e.isDecorationOptionsArr=$;var R;(function(we){function Ce(Ve){return Ve.map(we.from)}we.fromMany=Ce;function de(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function j(Ve){let ut;if(de(Ve)){const{language:kt,value:Ft}=Ve;ut={value:"```"+kt+`
`+Ft+"\n```\n"}}else a.MarkdownString.isMarkdownString(Ve)?ut={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?ut={value:Ve}:ut={value:""};const ht=Object.create(null);ut.uris=ht;const Et=kt=>{try{let Ft=O.URI.parse(kt,!0);Ft=Ft.with({query:De(Ft.query,ht)}),ht[kt]=Ft}catch{}return""},mt=new I.marked.Renderer;return mt.link=Et,mt.image=kt=>typeof kt=="string"?Et(g.parseHrefAndDimensions(kt).href):"",(0,I.marked)(ut.value,{renderer:mt}),ut}we.from=j;function De(Ve,ut){if(!Ve)return Ve;let ht;try{ht=(0,P.parse)(Ve)}catch{}if(!ht)return Ve;let Et=!1;return ht=(0,w.cloneAndChange)(ht,mt=>{if(O.URI.isUri(mt)){const kt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[kt]=mt,Et=!0,kt}else return}),Et?JSON.stringify(ht):Ve}function Me(Ve){const ut=new a.MarkdownString(Ve.value,Ve.supportThemeIcons);return ut.isTrusted=Ve.isTrusted,ut.supportHtml=Ve.supportHtml,ut.baseUri=Ve.baseUri?O.URI.from(Ve.baseUri):void 0,ut}we.to=Me;function Je(Ve){if(!!Ve)return typeof Ve=="string"?Ve:we.from(Ve)}we.fromStrict=Je})(R||(e.MarkdownString=R={}));function p(we){return $(we)?we.map(Ce=>({range:h.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?R.fromMany(Ce.hoverMessage):Ce.hoverMessage?R.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):we.map(Ce=>({range:h.from(Ce)}))}e.fromRangeOrRangeWithMessage=p;function F(we){return typeof we=="undefined"?we:typeof we=="string"?O.URI.file(we):we}e.pathOrURIToURI=F;var M;(function(we){function Ce(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?F(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}we.from=Ce})(M||(e.ThemableDecorationAttachmentRenderOptions=M={}));var z;(function(we){function Ce(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?F(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?M.from(de.before):void 0,after:de.after?M.from(de.after):void 0}}we.from=Ce})(z||(e.ThemableDecorationRenderOptions=z={}));var Z;(function(we){function Ce(de){if(typeof de=="undefined")return de;switch(de){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Ce})(Z||(e.DecorationRangeBehavior=Z={}));var K;(function(we){function Ce(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?Z.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?z.from(de.light):void 0,dark:de.dark?z.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?F(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?M.from(de.before):void 0,after:de.after?M.from(de.after):void 0}}we.from=Ce})(K||(e.DecorationRenderOptions=K={}));var N;(function(we){function Ce(j){return{text:j.newText,eol:j.newEol&&q.from(j.newEol),range:h.from(j.range)}}we.from=Ce;function de(j){const De=new a.TextEdit(h.to(j.range),j.text);return De.newEol=typeof j.eol=="undefined"?void 0:q.to(j.eol),De}we.to=de})(N||(e.TextEdit=N={}));var se;(function(we){function Ce(de){return{range:h.from(de.range),snippet:de.snippet.value}}we.from=Ce})(se||(e.SnippetTextEdit=se={}));var le;(function(we){function Ce(j,De){const Me={edits:[]};if(j instanceof a.WorkspaceEdit){const Je=new U.ResourceSet;for(const Ve of j._allEntries())Ve._type===1&&O.URI.isUri(Ve.to)&&Ve.from===void 0&&Je.add(Ve.to);for(const Ve of j._allEntries())Ve._type===1?Me.edits.push({_type:1,oldUri:Ve.from,newUri:Ve.to,options:Ve.options,metadata:Ve.metadata}):Ve._type===2?Me.edits.push({_type:2,resource:Ve.uri,edit:N.from(Ve.edit),modelVersionId:Je.has(Ve.uri)?void 0:De?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Me.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Me.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:De?.getNotebookDocumentVersion(Ve.uri),edit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(it.from)}})}return Me}we.from=Ce;function de(j){const De=new a.WorkspaceEdit;for(const Me of j.edits)Me.edit?De.replace(O.URI.revive(Me.resource),h.to(Me.edit.range),Me.edit.text):De.renameFile(O.URI.revive(Me.oldUri),O.URI.revive(Me.newUri),Me.options);return De}we.to=de})(le||(e.WorkspaceEdit=le={}));var oe;(function(we){const Ce=Object.create(null);Ce[a.SymbolKind.File]=0,Ce[a.SymbolKind.Module]=1,Ce[a.SymbolKind.Namespace]=2,Ce[a.SymbolKind.Package]=3,Ce[a.SymbolKind.Class]=4,Ce[a.SymbolKind.Method]=5,Ce[a.SymbolKind.Property]=6,Ce[a.SymbolKind.Field]=7,Ce[a.SymbolKind.Constructor]=8,Ce[a.SymbolKind.Enum]=9,Ce[a.SymbolKind.Interface]=10,Ce[a.SymbolKind.Function]=11,Ce[a.SymbolKind.Variable]=12,Ce[a.SymbolKind.Constant]=13,Ce[a.SymbolKind.String]=14,Ce[a.SymbolKind.Number]=15,Ce[a.SymbolKind.Boolean]=16,Ce[a.SymbolKind.Array]=17,Ce[a.SymbolKind.Object]=18,Ce[a.SymbolKind.Key]=19,Ce[a.SymbolKind.Null]=20,Ce[a.SymbolKind.EnumMember]=21,Ce[a.SymbolKind.Struct]=22,Ce[a.SymbolKind.Event]=23,Ce[a.SymbolKind.Operator]=24,Ce[a.SymbolKind.TypeParameter]=25;function de(De){return typeof Ce[De]=="number"?Ce[De]:6}we.from=de;function j(De){for(const Me in Ce)if(Ce[Me]===De)return Number(Me);return a.SymbolKind.Property}we.to=j})(oe||(e.SymbolKind=oe={}));var fe;(function(we){function Ce(j){switch(j){case a.SymbolTag.Deprecated:return 1}}we.from=Ce;function de(j){switch(j){case 1:return a.SymbolTag.Deprecated}}we.to=de})(fe||(e.SymbolTag=fe={}));var be;(function(we){function Ce(j){return{name:j.name,kind:oe.from(j.kind),tags:j.tags&&j.tags.map(fe.from),containerName:j.containerName,location:_e.from(j.location)}}we.from=Ce;function de(j){const De=new a.SymbolInformation(j.name,oe.to(j.kind),j.containerName,_e.to(j.location));return De.tags=j.tags&&j.tags.map(fe.to),De}we.to=de})(be||(e.WorkspaceSymbol=be={}));var ce;(function(we){function Ce(j){const De={name:j.name||"!!MISSING: name!!",detail:j.detail,range:h.from(j.range),selectionRange:h.from(j.selectionRange),kind:oe.from(j.kind),tags:j.tags?.map(fe.from)??[]};return j.children&&(De.children=j.children.map(Ce)),De}we.from=Ce;function de(j){const De=new a.DocumentSymbol(j.name,j.detail,oe.to(j.kind),h.to(j.range),h.to(j.selectionRange));return(0,s.isNonEmptyArray)(j.tags)&&(De.tags=j.tags.map(fe.to)),j.children&&(De.children=j.children.map(de)),De}we.to=de})(ce||(e.DocumentSymbol=ce={}));var ve;(function(we){function Ce(j){const De=new a.CallHierarchyItem(oe.to(j.kind),j.name,j.detail||"",O.URI.revive(j.uri),h.to(j.range),h.to(j.selectionRange));return De._sessionId=j._sessionId,De._itemId=j._itemId,De}we.to=Ce;function de(j,De,Me){if(De=De??j._sessionId,Me=Me??j._itemId,De===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Me,name:j.name,detail:j.detail,kind:oe.from(j.kind),uri:j.uri,range:h.from(j.range),selectionRange:h.from(j.selectionRange),tags:j.tags?.map(fe.from)}}we.from=de})(ve||(e.CallHierarchyItem=ve={}));var J;(function(we){function Ce(de){return new a.CallHierarchyIncomingCall(ve.to(de.from),de.fromRanges.map(j=>h.to(j)))}we.to=Ce})(J||(e.CallHierarchyIncomingCall=J={}));var Ee;(function(we){function Ce(de){return new a.CallHierarchyOutgoingCall(ve.to(de.to),de.fromRanges.map(j=>h.to(j)))}we.to=Ce})(Ee||(e.CallHierarchyOutgoingCall=Ee={}));var _e;(function(we){function Ce(j){return{range:j.range&&h.from(j.range),uri:j.uri}}we.from=Ce;function de(j){return new a.Location(O.URI.revive(j.uri),h.to(j.range))}we.to=de})(_e||(e.location=_e={}));var Fe;(function(we){function Ce(j){const De=j,Me=j;return{originSelectionRange:De.originSelectionRange?h.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Me.uri,range:h.from(De.targetRange?De.targetRange:Me.range),targetSelectionRange:De.targetSelectionRange?h.from(De.targetSelectionRange):void 0}}we.from=Ce;function de(j){return{targetUri:O.URI.revive(j.uri),targetRange:h.to(j.range),targetSelectionRange:j.targetSelectionRange?h.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?h.to(j.originSelectionRange):void 0}}we.to=de})(Fe||(e.DefinitionLink=Fe={}));var xe;(function(we){function Ce(j){return{range:h.from(j.range),contents:R.fromMany(j.contents)}}we.from=Ce;function de(j){return new a.Hover(j.contents.map(R.to),h.to(j.range))}we.to=de})(xe||(e.Hover=xe={}));var Xe;(function(we){function Ce(j){return{range:h.from(j.range),expression:j.expression}}we.from=Ce;function de(j){return new a.EvaluatableExpression(h.to(j.range),j.expression)}we.to=de})(Xe||(e.EvaluatableExpression=Xe={}));var ke;(function(we){function Ce(j){if(j instanceof a.InlineValueText)return{type:"text",range:h.from(j.range),text:j.text};if(j instanceof a.InlineValueVariableLookup)return{type:"variable",range:h.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Ce;function de(j){switch(j.type){case"text":return{range:h.to(j.range),text:j.text};case"variable":return{range:h.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:h.to(j.range),expression:j.expression}}}we.to=de})(ke||(e.InlineValue=ke={}));var Se;(function(we){function Ce(j){return{frameId:j.frameId,stoppedLocation:h.from(j.stoppedLocation)}}we.from=Ce;function de(j){return new a.InlineValueContext(j.frameId,h.to(j.stoppedLocation))}we.to=de})(Se||(e.InlineValueContext=Se={}));var Pe;(function(we){function Ce(j){return{range:h.from(j.range),kind:j.kind}}we.from=Ce;function de(j){return new a.DocumentHighlight(h.to(j.range),j.kind)}we.to=de})(Pe||(e.DocumentHighlight=Pe={}));var re;(function(we){function Ce(de){switch(de){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}we.to=Ce})(re||(e.CompletionTriggerKind=re={}));var ae;(function(we){function Ce(de){return{triggerKind:re.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}we.to=Ce})(ae||(e.CompletionContext=ae={}));var X;(function(we){function Ce(j){switch(j){case a.CompletionItemTag.Deprecated:return 1}}we.from=Ce;function de(j){switch(j){case 1:return a.CompletionItemTag.Deprecated}}we.to=de})(X||(e.CompletionItemTag=X={}));var G;(function(we){const Ce=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function de(Me){return Ce.get(Me)??9}we.from=de;const j=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function De(Me){return j.get(Me)??a.CompletionItemKind.Property}we.to=De})(G||(e.CompletionItemKind=G={}));var T;(function(we){function Ce(de,j){const De=new a.CompletionItem(de.label);return De.insertText=de.insertText,De.kind=G.to(de.kind),De.tags=de.tags?.map(X.to),De.detail=de.detail,De.documentation=g.isMarkdownString(de.documentation)?R.to(de.documentation):de.documentation,De.sortText=de.sortText,De.filterText=de.filterText,De.preselect=de.preselect,De.commitCharacters=de.commitCharacters,S.Range.isIRange(de.range)?De.range=h.to(de.range):typeof de.range=="object"&&(De.range={inserting:h.to(de.range.insert),replacing:h.to(de.range.replace)}),De.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?De.insertText=new a.SnippetString(de.insertText):(De.insertText=de.insertText,De.textEdit=De.range instanceof a.Range?new a.TextEdit(De.range,De.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(De.additionalTextEdits=de.additionalTextEdits.map(Me=>N.to(Me))),De.command=j&&de.command?j.fromInternal(de.command):void 0,De}we.to=Ce})(T||(e.CompletionItem=T={}));var B;(function(we){function Ce(j){return{label:j.label,documentation:R.fromStrict(j.documentation)}}we.from=Ce;function de(j){return{label:j.label,documentation:g.isMarkdownString(j.documentation)?R.to(j.documentation):j.documentation}}we.to=de})(B||(e.ParameterInformation=B={}));var H;(function(we){function Ce(j){return{label:j.label,documentation:R.fromStrict(j.documentation),parameters:Array.isArray(j.parameters)?j.parameters.map(B.from):[],activeParameter:j.activeParameter}}we.from=Ce;function de(j){return{label:j.label,documentation:g.isMarkdownString(j.documentation)?R.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(B.to):[],activeParameter:j.activeParameter}}we.to=de})(H||(e.SignatureInformation=H={}));var V;(function(we){function Ce(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(H.from):[]}}we.from=Ce;function de(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(H.to):[]}}we.to=de})(V||(e.SignatureHelp=V={}));var ne;(function(we){function Ce(de,j){const De=new a.InlayHint(o.to(j.position),typeof j.label=="string"?j.label:j.label.map(ue.to.bind(void 0,de)),j.kind&&Q.to(j.kind));return De.textEdits=j.textEdits&&j.textEdits.map(N.to),De.tooltip=g.isMarkdownString(j.tooltip)?R.to(j.tooltip):j.tooltip,De.paddingLeft=j.paddingLeft,De.paddingRight=j.paddingRight,De}we.to=Ce})(ne||(e.InlayHint=ne={}));var ue;(function(we){function Ce(de,j){const De=new a.InlayHintLabelPart(j.label);return De.tooltip=g.isMarkdownString(j.tooltip)?R.to(j.tooltip):j.tooltip,m.Command.is(j.command)&&(De.command=de.fromInternal(j.command)),j.location&&(De.location=_e.to(j.location)),De}we.to=Ce})(ue||(e.InlayHintLabelPart=ue={}));var Q;(function(we){function Ce(j){return j}we.from=Ce;function de(j){return j}we.to=de})(Q||(e.InlayHintKind=Q={}));var ge;(function(we){function Ce(j){return{range:h.from(j.range),url:j.target,tooltip:j.tooltip}}we.from=Ce;function de(j){let De;if(j.url)try{De=typeof j.url=="string"?O.URI.parse(j.url,!0):O.URI.revive(j.url)}catch{}return new a.DocumentLink(h.to(j.range),De)}we.to=de})(ge||(e.DocumentLink=ge={}));var pe;(function(we){function Ce(j){const De=new a.ColorPresentation(j.label);return j.textEdit&&(De.textEdit=N.to(j.textEdit)),j.additionalTextEdits&&(De.additionalTextEdits=j.additionalTextEdits.map(Me=>N.to(Me))),De}we.to=Ce;function de(j){return{label:j.label,textEdit:j.textEdit?N.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(De=>N.from(De)):void 0}}we.from=de})(pe||(e.ColorPresentation=pe={}));var Ne;(function(we){function Ce(j){return new a.Color(j[0],j[1],j[2],j[3])}we.to=Ce;function de(j){return[j.red,j.green,j.blue,j.alpha]}we.from=de})(Ne||(e.Color=Ne={}));var Be;(function(we){function Ce(j){return{range:h.from(j.range)}}we.from=Ce;function de(j){return new a.SelectionRange(h.to(j.range))}we.to=de})(Be||(e.SelectionRange=Be={}));var Ae;(function(we){function Ce(de){switch(de){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}we.to=Ce})(Ae||(e.TextDocumentSaveReason=Ae={}));var Ke;(function(we){function Ce(j){switch(j){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Ce;function de(j){switch(j){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}we.to=de})(Ke||(e.TextEditorLineNumbersStyle=Ke={}));var q;(function(we){function Ce(j){if(j===a.EndOfLine.CRLF)return 1;if(j===a.EndOfLine.LF)return 0}we.from=Ce;function de(j){if(j===1)return a.EndOfLine.CRLF;if(j===0)return a.EndOfLine.LF}we.to=de})(q||(e.EndOfLine=q={}));var Y;(function(we){function Ce(de){if(typeof de=="object")return de.viewId;switch(de){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Ce})(Y||(e.ProgressLocation=Y={}));var me;(function(we){function Ce(de){const j={start:de.start+1,end:de.end+1};return de.kind&&(j.kind=Le.from(de.kind)),j}we.from=Ce})(me||(e.FoldingRange=me={}));var Le;(function(we){function Ce(de){if(de)switch(de){case a.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}we.from=Ce})(Le||(e.FoldingRangeKind=Le={}));var ze;(function(we){function Ce(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?h.from(de.selection):void 0,override:typeof de.override=="boolean"?_.EditorResolution.DISABLED:void 0}}we.from=Ce})(ze||(e.TextEditorOpenOptions=ze={}));var Ge;(function(we){function Ce(Me){return Me instanceof a.RelativePattern?Me.toJSON():typeof Me=="string"?Me:de(Me)||j(Me)?new a.RelativePattern(Me.baseUri??Me.base,Me.pattern).toJSON():Me}we.from=Ce;function de(Me){const Je=Me;return Je?O.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function j(Me){const Je=Me;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function De(Me){return typeof Me=="string"?Me:new a.RelativePattern(O.URI.revive(Me.baseUri),Me.pattern)}we.to=De})(Ge||(e.GlobPattern=Ge={}));var Ze;(function(we){function Ce(de){if(de){if(Array.isArray(de))return de.map(Ce);if(typeof de=="string")return de;{const j=de;return{language:j.language,scheme:j.scheme,pattern:Ge.from(j.pattern),exclusive:j.exclusive,notebookType:j.notebookType}}}else return}we.from=Ce})(Ze||(e.LanguageSelector=Ze={}));var ot;(function(we){function Ce(j){return{start:j.start,end:j.end}}we.from=Ce;function de(j){return new a.NotebookRange(j.start,j.end)}we.to=de})(ot||(e.NotebookRange=ot={}));var Qe;(function(we){function Ce(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}we.to=Ce;function de(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}we.from=de})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var et;(function(we){function Ce(de){if(de===d.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;if(de===d.NotebookCellExecutionState.Pending)return a.NotebookCellExecutionState.Pending;if(de===d.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${de}`)}we.to=Ce})(et||(e.NotebookCellExecutionState=et={}));var qe;(function(we){function Ce(j){switch(j){case a.NotebookCellKind.Markup:return d.CellKind.Markup;case a.NotebookCellKind.Code:default:return d.CellKind.Code}}we.from=Ce;function de(j){switch(j){case d.CellKind.Markup:return a.NotebookCellKind.Markup;case d.CellKind.Code:default:return a.NotebookCellKind.Code}}we.to=de})(qe||(e.NotebookCellKind=qe={}));var st;(function(we){function Ce(j){const De={metadata:j.metadata??Object.create(null),cells:[]};for(let Me of j.cells)a.NotebookCellData.validate(Me),De.cells.push(it.from(Me));return De}we.from=Ce;function de(j){const De=new a.NotebookData(j.cells.map(it.to));return(0,A.isEmptyObject)(j.metadata)||(De.metadata=j.metadata),De}we.to=de})(st||(e.NotebookData=st={}));var it;(function(we){function Ce(j){return{cellKind:qe.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:Qe.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(ct.from):[]}}we.from=Ce;function de(j){return new a.NotebookCellData(qe.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(ct.to):void 0,j.metadata,j.internalMetadata?Qe.to(j.internalMetadata):void 0)}we.to=de})(it||(e.NotebookCellData=it={}));var at;(function(we){function Ce(j){return{mime:j.mime,valueBytes:C.VSBuffer.wrap(j.data)}}we.from=Ce;function de(j){return new a.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}we.to=de})(at||(e.NotebookCellOutputItem=at={}));var ct;(function(we){function Ce(j){return{outputId:j.id,items:j.items.map(at.from),metadata:j.metadata}}we.from=Ce;function de(j){const De=j.items.map(at.to);return new a.NotebookCellOutput(De,j.outputId,j.metadata)}we.to=de})(ct||(e.NotebookCellOutput=ct={}));var Tt;(function(we){function Ce(De){return j(De)?{include:(0,A.withNullAsUndefined)(Ge.from(De.include)),exclude:(0,A.withNullAsUndefined)(Ge.from(De.exclude))}:(0,A.withNullAsUndefined)(Ge.from(De))}we.from=Ce;function de(De){return j(De)?{include:Ge.to(De.include),exclude:Ge.to(De.exclude)}:Ge.to(De)}we.to=de;function j(De){const Me=De;return Me?!(0,A.isUndefinedOrNull)(Me.include)&&!(0,A.isUndefinedOrNull)(Me.exclude):!1}})(Tt||(e.NotebookExclusiveDocumentPattern=Tt={}));var Ut;(function(we){function Ce(de){return{backgroundColor:de.backgroundColor,borderColor:de.borderColor,top:de.top?M.from(de.top):void 0}}we.from=Ce})(Ut||(e.NotebookDecorationRenderOptions=Ut={}));var Ct;(function(we){function Ce(de,j,De){const Me=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal(Me,De),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}we.from=Ce})(Ct||(e.NotebookStatusBarItem=Ct={}));var ft;(function(we){function Ce(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{}}}we.from=Ce})(ft||(e.NotebookDocumentContentOptions=ft={}));var At;(function(we){function Ce(j){return{uri:j.uri,provides:j.provides}}we.from=Ce;function de(j){return new a.NotebookRendererScript(O.URI.revive(j.uri),j.provides)}we.to=de})(At||(e.NotebookRendererScript=At={}));var xt;(function(we){function Ce(j){return{message:R.fromStrict(j.message)||"",type:0,expected:j.expectedOutput,actual:j.actualOutput,location:j.location&&{range:h.from(j.location.range),uri:j.location.uri}}}we.from=Ce;function de(j){const De=new a.TestMessage(typeof j.message=="string"?j.message:R.to(j.message));return De.actualOutput=j.actual,De.expectedOutput=j.expected,De.location=j.location?_e.to(j.location):void 0,De}we.to=de})(xt||(e.TestMessage=xt={}));var _t;(function(we){we.namespace=k.namespaceTestTag,we.denamespace=k.denamespaceTestTag})(_t||(e.TestTag=_t={}));var He;(function(we){function Ce(j){const De=(0,u.getPrivateApiFor)(j).controllerId;return{extId:c.TestId.fromExtHostTestItem(j,De).toString(),label:j.label,uri:O.URI.revive(j.uri),busy:!1,tags:j.tags.map(Me=>_t.namespace(De,Me.id)),range:S.Range.lift(h.from(j.range)),description:j.description||null,sortText:j.sortText||null,error:j.error&&R.fromStrict(j.error)||null}}we.from=Ce;function de(j){return{parent:void 0,error:void 0,id:c.TestId.fromString(j.extId).localId,label:j.label,uri:O.URI.revive(j.uri),tags:(j.tags||[]).map(De=>{const{tagId:Me}=_t.denamespace(De);return new a.TestTag(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},get:()=>{},replace:()=>{},size:0},range:h.to(j.range||void 0),canResolveChildren:!1,busy:!1,description:j.description||void 0,sortText:j.sortText||void 0}}we.toPlain=de})(He||(e.TestItem=He={})),function(we){function Ce(j){return{id:j.id}}we.from=Ce;function de(j){return new a.TestTag(j.id)}we.to=de}(_t||(e.TestTag=_t={}));var Rt;(function(we){const Ce=(j,De)=>{const Me={...He.toPlain(j.item),parent:void 0,taskStates:j.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(Ve=>Ve.type===0).map(xt.to)})),children:j.children.map(Je=>De.get(Je)).filter(A.isDefined).map(Je=>Ce(Je,De))};for(const Je of Me.children)Je.parent=Me;return Me};function de(j){const De=[],Me=new Map;for(const Je of j.items)Me.set(Je.item.extId,Je),j.request.targets.some(Ve=>Ve.controllerId===Je.controllerId&&Ve.testIds.includes(Je.item.extId))&&De.push(Je);return{completedAt:j.completedAt,results:De.map(Je=>Ce(Je,Me))}}we.to=de})(Rt||(e.TestResults=Rt={}));var Mt;(function(we){function Ce(Me){return{covered:Me.covered,total:Me.covered}}function de(Me){return"line"in Me?o.from(Me):h.from(Me)}function j(Me){return"branches"in Me?{count:Me.executionCount,location:de(Me.location),type:1,branches:Me.branches.length?Me.branches.map(Je=>({count:Je.executionCount,location:Je.location&&de(Je.location)})):void 0}:{type:0,count:Me.executionCount,location:de(Me.location)}}we.fromDetailed=j;function De(Me){return{uri:Me.uri,statement:Ce(Me.statementCoverage),branch:Me.branchCoverage&&Ce(Me.branchCoverage),function:Me.functionCoverage&&Ce(Me.functionCoverage),details:Me.detailedCoverage?.map(j)}}we.fromFile=De})(Mt||(e.TestCoverage=Mt={}));var Ot;(function(we){function Ce(de){switch(de){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}we.to=Ce})(Ot||(e.CodeActionTriggerKind=Ot={}));var pt;(function(we){function Ce(j){const De=new a.TypeHierarchyItem(oe.to(j.kind),j.name,j.detail||"",O.URI.revive(j.uri),h.to(j.range),h.to(j.selectionRange));return De._sessionId=j._sessionId,De._itemId=j._itemId,De}we.to=Ce;function de(j,De,Me){if(De=De??j._sessionId,Me=Me??j._itemId,De===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Me,kind:oe.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:h.from(j.range),selectionRange:h.from(j.selectionRange),tags:j.tags?.map(fe.from)}}we.from=de})(pt||(e.TypeHierarchyItem=pt={}));var St;(function(we){function Ce(de){if(!!de)return{value:de.value,tooltip:de.tooltip}}we.from=Ce})(St||(e.ViewBadge=St={}));var It;(function(we){function Ce(de,j){const De=de.fileData;return De?new class extends a.DataTransferItem{asFile(){return{name:De.name,uri:O.URI.revive(De.uri),data:(0,D.once)(()=>j())}}}(""):new a.DataTransferItem(de.asString)}we.toDataTransferItem=Ce})(It||(e.DataTransferItem=It={}));var wt;(function(we){function Ce(j,De){const Me=j.items.map(([Je,Ve],ut)=>[Je,It.toDataTransferItem(Ve,()=>De(ut))]);return new a.DataTransfer(Me)}we.toDataTransfer=Ce;async function de(j){const De={items:[]},Me=[];return j.forEach((Je,Ve)=>{Me.push((async()=>{const ut=await Je.asString(),ht=Je.asFile();De.items.push([Ve,{asString:ut,fileData:ht?{name:ht.name,uri:ht.uri}:void 0}])})())}),await Promise.all(Me),De}we.toDataTransferDTO=de})(wt||(e.DataTransfer=wt={}))}),define(Ie[173],Te([1,0,2,11,6,8,238]),function(ee,e,s,C,g,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(A,O,S,m={timeout:1500,errors:3}){this._logService=A,this._documents=O,this._mainThreadBulkEdits=S,this._thresholds=m,this._callbacks=new I.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(O,S,m)=>{const f={dispose:this._callbacks.push([O,S,A])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(A,O){const S=s.URI.revive(A);let m=!1;const _=setTimeout(()=>m=!0,this._thresholds.timeout),f=[];try{for(let u of[...this._callbacks]){if(m)break;const d=this._documents.getDocument(S),c=await this._deliverEventAsyncAndBlameBadListeners(u,{document:d,reason:U.TextDocumentSaveReason.to(O)});f.push(c)}}finally{clearTimeout(_)}return f}_deliverEventAsyncAndBlameBadListeners([A,O,S],m){const _=this._badListeners.get(A);return typeof _=="number"&&_>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(S,A,O,m).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const u=this._badListeners.get(A);this._badListeners.set(A,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,O,S,m){const _=[],f=Date.now(),{document:u,reason:d}=m,{version:c}=u,k=Object.freeze({document:u,reason:d,waitUntil(y){if(Object.isFrozen(_))throw(0,C.illegalState)("waitUntil can not be called async");_.push(Promise.resolve(y))}});try{O.apply(S,[k])}catch(y){return Promise.reject(y)}return Object.freeze(_),new Promise((y,a)=>{const D=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(_).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(D),y(r)}).catch(r=>{clearTimeout(D),a(r)})}).then(y=>{const a={edits:[]};for(const D of y)if(Array.isArray(D)&&D.every(r=>r instanceof g.TextEdit))for(const{newText:r,newEol:h,range:i}of D)a.edits.push({_type:2,resource:u.uri,edit:{range:i&&U.Range.from(i),text:r,eol:h&&U.EndOfLine.from(h)}});if(a.edits.length!==0)return c===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(Ie[174],Te([1,0,12,2,8,6,88]),function(ee,e,s,C,g,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(S,m,_,f){this.start=S,this.deletedCount=m,this.deletedItems=_,this.items=f}asApiEvent(){return{range:new U.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class w{static asModelAddData(S,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,m,_){this.notebook=S,this._extHostDocument=m,this._cellData=_,this.handle=_.handle,this.uri=C.URI.revive(_.uri),this.cellKind=_.cellKind,this._outputs=_.outputs.map(g.NotebookCellOutput.to),this._internalMetadata=_.internalMetadata??{},this._metadata=Object.freeze(_.metadata??{}),this._previousResult=Object.freeze(g.NotebookCellExecutionSummary.to(_.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const S=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const _={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:g.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return S._mime},set mime(f){S._mime=f},get outputs(){return S._outputs.slice(0)},get metadata(){return S._metadata},get executionSummary(){return S._previousResult}};this._apiCell=Object.freeze(_)}return this._apiCell}setOutputs(S){this._outputs=S.map(g.NotebookCellOutput.to)}setOutputItems(S,m,_){const f=_.map(g.NotebookCellOutputItem.to),u=this._outputs.find(d=>d.id===S);u&&(m||(u.items.length=0),u.items.push(...f))}setMetadata(S){this._metadata=Object.freeze(S)}setInternalMetadata(S){this._internalMetadata=S,this._previousResult=Object.freeze(g.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.ExtHostCell=w;class A{constructor(S,m,_,f,u){this._proxy=S,this._textDocumentsAndEditors=m,this._textDocuments=_,this.uri=f,this.handle=A._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=u.viewType,this._metadata=Object.freeze(u.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,u.cells]],!0,void 0),this._versionId=u.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const S=this,m={get uri(){return S.uri},get version(){return S._versionId},get notebookType(){return S._notebookType},get isDirty(){return S._isDirty},get isUntitled(){return S.uri.scheme===s.Schemas.untitled},get isClosed(){return S._disposed},get metadata(){return S._metadata},get cellCount(){return S._cells.length},cellAt(_){return _=S._validateIndex(_),S._cells[_].apiCell},getCells(_){return(_?S._getCells(_):S._cells).map(u=>u.apiCell)},save(){return S._save()}};this._notebook=Object.freeze(m)}return this._notebook}updateBackup(S){this._backup?.delete(),this._backup=S}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(S){S.metadata&&(this._metadata=Object.freeze({...this._metadata,...S.metadata}))}acceptDirty(S){this._isDirty=S}acceptModelChanged(S,m,_){this._versionId=S.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:_});const f={notebook:this.apiNotebook,metadata:_,cellChanges:[],contentChanges:[]},u=[];for(const c of S.rawEvents)c.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1,f.contentChanges):c.kind===I.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx,f.contentChanges):c.kind===I.NotebookCellsChangeType.Output?(this._setCellOutputs(c.index,c.outputs),u.push({cell:this._cells[c.index].apiCell,outputs:this._cells[c.index].apiCell.outputs})):c.kind===I.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems),u.push({cell:this._cells[c.index].apiCell,outputs:this._cells[c.index].apiCell.outputs})):c.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(c.index,c.language),u.push({cell:this._cells[c.index].apiCell,document:this._cells[c.index].apiCell.document})):c.kind===I.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this._cells[c.index].apiCell,document:this._cells[c.index].apiCell.document}):c.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(c.index,c.metadata),u.push({cell:this._cells[c.index].apiCell,metadata:this._cells[c.index].apiCell.metadata})):c.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(c.index,c.internalMetadata),u.push({cell:this._cells[c.index].apiCell,executionSummary:this._cells[c.index].apiCell.executionSummary}));const d=new Map;for(let c=0;c<u.length;c++){const k=u[c],y=d.get(k.cell);if(y===void 0){const a=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...k});d.set(k.cell,a-1)}else f.cellChanges[y]={...f.cellChanges[y],...k}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(S){return S=S|0,S<0?0:S>=this._cells.length?this._cells.length-1:S}_validateRange(S){let m=S.start|0,_=S.end|0;return m<0&&(m=0),_>this._cells.length&&(_=this._cells.length),S.with({start:m,end:_})}_getCells(S){S=this._validateRange(S);const m=[];for(let _=S.start;_<S.end;_++)m.push(this._cells[_]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(S,m,_){if(this._disposed)return;const f=[],u=[],d=[];if(S.reverse().forEach(c=>{const y=c[2].map(r=>{const h=new w(this,this._textDocumentsAndEditors,r);return m||u.push(w.asModelAddData(this.apiNotebook,r)),h}),a=new P(c[0],c[1],[],y),D=this._cells.splice(c[0],c[1],...y);for(const r of D)d.push(r.uri),a.deletedItems.push(r.apiCell);f.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:d}),_)for(let c of f)_.push(c.asApiEvent())}_moveCell(S,m,_){const f=this._cells.splice(S,1);this._cells.splice(m,0,...f);const u=[new P(S,1,f.map(d=>d.apiCell),[]),new P(m,0,[],f)];for(const d of u)_.push(d.asApiEvent())}_setCellOutputs(S,m){this._cells[S].setOutputs(m)}_setCellOutputItems(S,m,_,f){this._cells[S].setOutputItems(m,_,f)}_changeCellLanguage(S,m){const _=this._cells[S];_.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(_.uri,m)}_changeCellMime(S,m){const _=this._cells[S];_.apiCell.mime=m}_changeCellMetadata(S,m){this._cells[S].setMetadata(m)}_changeCellInternalMetadata(S,m){this._cells[S].setInternalMetadata(m)}getCellFromApiCell(S){return this._cells.find(m=>m.apiCell===S)}getCellFromIndex(S){return this._cells[S]}getCell(S){return this._cells.find(m=>m.handle===S)}getCellIndex(S){return this._cells.indexOf(S)}}e.ExtHostNotebookDocument=A,A._handlePool=0}),define(Ie[91],Te([1,0,6,8,11]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class U{constructor(w){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=w}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(w){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:w})}replaceCellMetadata(w,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:w,metadata:A})}replaceCells(w,A,O){this._throwIfFinalized(),!(w===A&&O.length===0)&&this._collectedEdits.push({editType:1,index:w,count:A-w,cells:O.map(C.NotebookCellData.from)})}}class I{constructor(w,A,O,S,m,_){this.id=w,this._proxy=A,this.notebookData=O,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=m,this._visibleRanges=S,this._viewColumn=_}get apiEditor(){if(!this._editor){const w=this;this._editor={get document(){return w.notebookData.apiNotebook},get notebook(){return w.notebookData.apiNotebook},get selection(){return w._selections[0]},set selection(A){this.selections=[A]},get selections(){return w._selections},set selections(A){if(!Array.isArray(A)||!A.every(s.NotebookRange.isNotebookRange))throw(0,g.illegalArgument)("selections");w._selections=A,w._trySetSelections(A)},get visibleRanges(){return w._visibleRanges},revealRange(A,O){w._proxy.$tryRevealRange(w.id,C.NotebookRange.from(A),O??s.NotebookEditorRevealType.Default)},get viewColumn(){return w._viewColumn},edit(A){const O=new U(this.document.version);return A(O),w._applyEdit(O.finalize())},setDecorations(A,O){return w.setDecorations(A,O)}},I.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(w){this._visible=w}_acceptVisibleRanges(w){this._visibleRanges=w}_acceptSelections(w){this._selections=w}_trySetSelections(w){this._proxy.$trySetSelections(this.id,w.map(C.NotebookRange.from))}_acceptViewColumn(w){this._viewColumn=w}_applyEdit(w){if(w.cellEdits.length===0)return Promise.resolve(!0);const A=[];let O=-1;for(let S=0;S<w.cellEdits.length;S++){if(O<0){A.push(w.cellEdits[S]),O++;continue}const _=A[O],f=w.cellEdits[S];if(_.editType===1&&f.editType===1&&_.index===f.index){_.cells.push(...w.cellEdits[S].cells),_.count+=w.cellEdits[S].count;continue}A.push(w.cellEdits[S]),O++}return this._proxy.$tryApplyEdits(this.id,w.documentVersionId,A)}setDecorations(w,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(w.key)))return A.isEmpty?this._hasDecorationsForKey.delete(w.key):this._hasDecorationsForKey.add(w.key),this._proxy.$trySetDecorations(this.id,C.NotebookRange.from(A),w.key)}}e.ExtHostNotebookEditor=I,I.apiEditorsToExtHost=new WeakMap}),define(Ie[175],Te([1,0,8,150,130,20,55,11]),function(ee,e,s,C,g,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,_,f){const u=this._handles++,{title:d,location:c,cancellable:k}=_,y={label:(0,g.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(u,{location:s.ProgressLocation.from(c),title:d,source:y,cancellable:k},m.isUnderDevelopment?void 0:m.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(u,f,!!k)}_withProgress(m,_,f){let u;f&&(u=new U.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,u));const d=k=>{this._proxy.$progressEnd(k),this._mapHandleToCancellationSource.delete(k),u&&u.dispose()};let c;try{c=_(new O(this._proxy,m),f&&u?u.token:U.CancellationToken.None)}catch(k){throw d(m),k}return c.then(k=>d(m),k=>d(m)),c}$acceptProgressCanceled(m){const _=this._mapHandleToCancellationSource.get(m);_&&(_.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=w;function A(S,m){return S.message=m.message,typeof m.increment=="number"&&(typeof S.increment=="number"?S.increment+=m.increment:S.increment=m.increment),S}class O extends C.Progress{constructor(m,_){super(f=>this.throttledReport(f));this._proxy=m,this._handle=_}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}$e([(0,I.throttle)(100,(S,m)=>A(S,m),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ie[92],Te([1,0,49,89,47,67,48,8,2]),function(ee,e,s,C,g,U,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const A=(y,a,D,r)=>{let h=a;return{enumerable:!0,configurable:!1,get(){return h},set(i){if(!D(h,i)){const o=h;h=i,y.listener?.(r(i,o))}}}},O=(y,a)=>y===a,S={range:(y,a)=>y===a?!0:!y||!a?!1:y.isEqual(a),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(y,a)=>!(y.length!==a.length||y.some(D=>!a.find(r=>D.id===r.id)))},m=y=>a=>({op:4,update:y(a)}),_=(y,a)=>({range:A(y,void 0,S.range,m(D=>({range:s.Range.lift(P.Range.from(D))}))),label:A(y,a,S.label,m(D=>({label:D}))),description:A(y,void 0,S.description,m(D=>({description:D}))),sortText:A(y,void 0,S.sortText,m(D=>({sortText:D}))),canResolveChildren:A(y,!1,S.canResolveChildren,D=>({op:2,state:D})),busy:A(y,!1,S.busy,m(D=>({busy:D}))),error:A(y,void 0,S.error,m(D=>({error:P.MarkdownString.fromStrict(D)||null}))),tags:A(y,[],S.tags,(D,r)=>({op:1,new:D.map(P.TestTag.from),old:r.map(P.TestTag.from)}))}),f=y=>{const a=g.TestId.fromString(y.extId),D=new d(a.controllerId,a.localId,y.label,w.URI.revive(y.uri)||void 0);return D.range=P.Range.to(y.range||void 0),D.description=y.description||void 0,D.sortText=y.sortText||void 0,D.tags=y.tags.map(r=>P.TestTag.to({id:(0,I.denamespaceTestTag)(r).tagId})),D},u=y=>{let a;for(const D of y.tests){const r=f(D.item);(0,C.getPrivateApiFor)(r).parent=a,a=r}return a};e.toItemFromContext=u;class d{constructor(a,D,r,h){if(D.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(D)} symbol`);const i=(0,C.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:D,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof c?void 0:i.parent}},children:{value:(0,U.createTestItemChildren)(i,C.getPrivateApiFor,d),enumerable:!0,writable:!1},..._(i,r)})}}e.TestItemImpl=d;class c extends d{constructor(a,D){super(a,a,D,void 0)}}e.TestItemRootImpl=c;class k extends U.TestItemCollection{constructor(a,D){super({controllerId:a,getApiFor:C.getPrivateApiFor,getChildren:r=>r.children,root:new c(a,D),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=k}),define(Ie[93],Te([1,0,42,11,56,8,6]),function(ee,e,s,C,g,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(m,_,f){const u=P._Keys.nextId();m.$registerTextEditorDecorationType(_.identifier,u,U.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:u,dispose(){m.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=P,P._Keys=new g.IdGenerator("TextEditorDecorationType");class w{constructor(m,_){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=_.undoStopBefore,this._undoStopAfter=_.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,_){this._throwIfFinalized();let f=null;if(m instanceof I.Position)f=new I.Range(m,m);else if(m instanceof I.Range)f=m;else throw new Error("Unrecognized location");this._pushEdit(f,_,!1)}insert(m,_){this._throwIfFinalized(),this._pushEdit(new I.Range(m,m),_,!0)}delete(m){this._throwIfFinalized();let _=null;if(m instanceof I.Range)_=m;else throw new Error("Unrecognized location");this._pushEdit(_,null,!0)}_pushEdit(m,_,f){const u=this._document.validateRange(m);this._collectedEdits.push({range:u,text:_,forceMoveMarkers:f})}setEndOfLine(m){if(this._throwIfFinalized(),m!==I.EndOfLine.LF&&m!==I.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=w;class A{constructor(m,_,f,u){this._proxy=m,this._id=_,this._accept(f),this._logService=u;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(c){d._setTabSize(c)},get insertSpaces(){return d._insertSpaces},set insertSpaces(c){d._setInsertSpaces(c)},get cursorStyle(){return d._cursorStyle},set cursorStyle(c){d._setCursorStyle(c)},get lineNumbers(){return d._lineNumbers},set lineNumbers(c){d._setLineNumbers(c)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=U.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const _=Math.floor(m);return _>0?_:null}if(typeof m=="string"){const _=parseInt(m,10);return isNaN(_)?null:_>0?_:null}return null}_setTabSize(m){const _=this._validateTabSize(m);if(_!==null){if(typeof _=="number"){if(this._tabSize===_)return;this._tabSize=_}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:_}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const _=this._validateInsertSpaces(m);if(typeof _=="boolean"){if(this._insertSpaces===_)return;this._insertSpaces=_}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:_}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:U.TextEditorLineNumbersStyle.from(m)})))}assign(m){const _={};let f=!1;if(typeof m.tabSize!="undefined"){const u=this._validateTabSize(m.tabSize);u==="auto"?(f=!0,_.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,f=!0,_.tabSize=u)}if(typeof m.insertSpaces!="undefined"){const u=this._validateInsertSpaces(m.insertSpaces);u==="auto"?(f=!0,_.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,f=!0,_.insertSpaces=u)}typeof m.cursorStyle!="undefined"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,f=!0,_.cursorStyle=m.cursorStyle),typeof m.lineNumbers!="undefined"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,f=!0,_.lineNumbers=U.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,_))}_warnOnError(m,_){_.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=A;class O{constructor(m,_,f,u,d,c,k,y){this.id=m,this._proxy=_,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new A(this._proxy,this.id,c,f),this._visibleRanges=k,this._viewColumn=y;const a=this;this.value=Object.freeze({get document(){return u.getValue()},set document(D){throw(0,C.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(D){if(!(D instanceof I.Selection))throw(0,C.illegalArgument)("selection");a._selections=[D],a._trySetSelection()},get selections(){return a._selections},set selections(D){if(!Array.isArray(D)||D.some(r=>!(r instanceof I.Selection)))throw(0,C.illegalArgument)("selections");a._selections=D,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(D){throw(0,C.readonly)("visibleRanges")},get options(){return a._options.value},set options(D){a._disposed||a._options.assign(D)},get viewColumn(){return a._viewColumn},set viewColumn(D){throw(0,C.readonly)("viewColumn")},edit(D,r={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new w(u.getValue(),r);return D(h),a._applyEdit(h)},insertSnippet(D,r,h={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!r||Array.isArray(r)&&r.length===0)i=a._selections.map(o=>U.Range.from(o));else if(r instanceof I.Position){const{lineNumber:o,column:n}=U.Position.from(r);i=[{startLineNumber:o,startColumn:n,endLineNumber:o,endColumn:n}]}else if(r instanceof I.Range)i=[U.Range.from(r)];else{i=[];for(const o of r)if(o instanceof I.Range)i.push(U.Range.from(o));else{const{lineNumber:n,column:t}=U.Position.from(o);i.push({startLineNumber:n,startColumn:t,endLineNumber:n,endColumn:t})}}return _.$tryInsertSnippet(m,u.getValue().version,D.value,i,h)},setDecorations(D,r){const h=r.length===0;h&&!a._hasDecorationsForKey.has(D.key)||(h?a._hasDecorationsForKey.delete(D.key):a._hasDecorationsForKey.add(D.key),a._runOnProxy(()=>{if(U.isDecorationOptionsArr(r))return _.$trySetDecorations(m,D.key,U.fromRangeOrRangeWithMessage(r));{const i=new Array(4*r.length);for(let o=0,n=r.length;o<n;o++){const t=r[o];i[4*o]=t.start.line+1,i[4*o+1]=t.start.character+1,i[4*o+2]=t.end.line+1,i[4*o+3]=t.end.character+1}return _.$trySetDecorationsFast(m,D.key,i)}}))},revealRange(D,r){a._runOnProxy(()=>_.$tryRevealRange(m,U.Range.from(D),r||I.TextEditorRevealType.Default))},show(D){_.$tryShowEditor(m,U.ViewColumn.from(D))},hide(){_.$tryHideEditor(m)}})}dispose(){(0,s.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,s.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,s.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,s.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,s.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(U.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const _=m.finalize();if(_.edits.length===0&&!_.setEndOfLine)return Promise.resolve(!0);const f=_.edits.map(d=>d.range);f.sort((d,c)=>d.end.line===c.end.line?d.end.character===c.end.character?d.start.line===c.start.line?d.start.character-c.start.character:d.start.line-c.start.line:d.end.character-c.end.character:d.end.line-c.end.line);for(let d=0,c=f.length-1;d<c;d++){const k=f[d].end;if(f[d+1].start.isBefore(k))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=_.edits.map(d=>({range:U.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,u,{setEndOfLine:typeof _.setEndOfLine=="number"?U.EndOfLine.from(_.setEndOfLine):void 0,undoStopBefore:_.undoStopBefore,undoStopAfter:_.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,_=>(_ instanceof Error&&_.name==="DISPOSED"||this._logService.warn(_),null))}}e.ExtHostTextEditor=O}),define(Ie[176],Te([1,0,3,146]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,s.refineServiceDecorator)(C.IEnvironmentService)}),define(Ie[177],Te([1,0,25,5,19]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class U{constructor(O){this.removedDueToLooping=O}}e.DeltaExtensionsResult=U;class I{constructor(O){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=O,this._initialize()}_initialize(){this._extensionDescriptions.sort(w),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const O of this._extensionDescriptions){if(this._extensionsMap.has(s.ExtensionIdentifier.toKey(O.identifier))){console.error("Extension `"+O.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(s.ExtensionIdentifier.toKey(O.identifier),O),this._extensionsArr.push(O),Array.isArray(O.activationEvents))for(let S of O.activationEvents)S==="onUri"&&(S=`onUri:${s.ExtensionIdentifier.toKey(O.identifier)}`),this._activationMap.has(S)||this._activationMap.set(S,[]),this._activationMap.get(S).push(O)}}set(O){this._extensionDescriptions=O,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(O,S){O.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(O));const m=I._findLoopingExtensions(this._extensionDescriptions);if(S=S.concat(m.map(_=>_.identifier)),S.length>0){const _=new Set;S.forEach(f=>_.add(s.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>!_.has(s.ExtensionIdentifier.toKey(f.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new U(m)}static _findLoopingExtensions(O){const S=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,c){this.addNode(d),this.addNode(c),this._arcs.has(d)?this._arcs.get(d).push(c):this._arcs.set(d,[c])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,c){const k=S.getArcs(d);for(let y=0;y<k.length;y++)if(!c.has(k[y]))return!1;return!0}getNodes(){return this._nodesArr}};let m=new Map;for(let d of O){const c=s.ExtensionIdentifier.toKey(d.identifier);if(m.set(c,d),d.extensionDependencies)for(let k of d.extensionDependencies){const y=s.ExtensionIdentifier.toKey(k);S.addArc(c,y)}}let _=new Set;S.getNodes().filter(d=>S.getArcs(d).length===0).forEach(d=>_.add(d));let f=S.getNodes().filter(d=>!_.has(d)),u;do{u=!1;for(let d=0;d<f.length;d++){const c=f[d];S.hasOnlyGoodArcs(c,_)&&(f.splice(d,1),d--,_.add(c),u=!0)}}while(u);return f.map(d=>m.get(d))}containsActivationEvent(O){return this._activationMap.has(O)}containsExtension(O){return this._extensionsMap.has(s.ExtensionIdentifier.toKey(O))}getExtensionDescriptionsForActivationEvent(O){const S=this._activationMap.get(O);return S?S.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(O){const S=this._extensionsMap.get(s.ExtensionIdentifier.toKey(O));return S||void 0}}e.ExtensionDescriptionRegistry=I;var P;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(P||(P={}));function w(A,O){const S=A.isBuiltin?0:A.isUnderDevelopment?2:1,m=O.isBuiltin?0:O.isUnderDevelopment?2:1;if(S!==m)return S-m;const _=g.posix.basename(A.extensionLocation.path),f=g.posix.basename(O.extensionLocation.path);return _<f?-1:_>f?1:0}}),define(Ie[94],Te([1,0,23]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(C||(e.UIKind=C={}));var g;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var U;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(U||(e.MessageType=U={}));function I(w){const A=s.VSBuffer.alloc(1);switch(w){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=I;function P(w,A){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=P}),define(Ie[26],Te([1,0,5,2,3,25,152]),function(ee,e,s,C,g,U,I){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new U.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,g.createDecorator)("extensionService");class w{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=w;class A{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=A;class O{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class S{constructor(t){this.dependency=t}}e.MissingExtensionDependency=S;var m;(function(n){n[n.LocalProcess=1]="LocalProcess",n[n.LocalWebWorker=2]="LocalWebWorker",n[n.Remote=3]="Remote"})(m||(e.ExtensionHostKind=m={}));function _(n){if(n===null)return"None";switch(n){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=_;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,l){const b=[],v=[],E=[],x=[],$=c(this._allExtensions),R=c(t),p=(Z,K)=>Z.extensionLocation.toString()===K.extensionLocation.toString()||Z.isBuiltin===K.isBuiltin||Z.isUserBuiltin===K.isUserBuiltin||Z.isUnderDevelopment===K.isUnderDevelopment;for(const Z of this._allExtensions){const K=R.get(U.ExtensionIdentifier.toKey(Z.identifier));if(!K){b.push(Z.identifier),$.delete(U.ExtensionIdentifier.toKey(Z.identifier));continue}if(!p(Z,K)){b.push(Z.identifier),$.delete(U.ExtensionIdentifier.toKey(Z.identifier));continue}}for(const Z of t){const K=$.get(U.ExtensionIdentifier.toKey(Z.identifier));if(!K){v.push(Z);continue}if(!p(K,Z)){b.push(K.identifier),$.delete(U.ExtensionIdentifier.toKey(K.identifier));continue}}const F=d(this._myExtensions),M=d(l);for(const Z of this._myExtensions)M.has(U.ExtensionIdentifier.toKey(Z))||E.push(Z);for(const Z of l)F.has(U.ExtensionIdentifier.toKey(Z))||x.push(Z);const z={toRemove:b,toAdd:v,myToRemove:E,myToAdd:x};return this.delta(z),z}delta(t){const{toRemove:l,toAdd:b,myToRemove:v,myToAdd:E}=t,x=d(l),$=d(v);for(let R=0;R<this._allExtensions.length;R++)x.has(U.ExtensionIdentifier.toKey(this._allExtensions[R].identifier))&&(this._allExtensions.splice(R,1),R--);for(let R=0;R<this._myExtensions.length;R++)$.has(U.ExtensionIdentifier.toKey(this._myExtensions[R]))&&(this._myExtensions.splice(R,1),R--);for(const R of b)this._allExtensions.push(R);for(const R of E)this._myExtensions.push(R)}containsExtension(t){for(const l of this._myExtensions)if(U.ExtensionIdentifier.equals(l,t))return!0;return!1}}e.ExtensionHostExtensions=f;class u{constructor(t){if(this[P]="ExtensionIdentifierSet",this._map=new Map,this._toKey=U.ExtensionIdentifier.toKey,t)for(const l of t)this.add(l)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,l){this._map.forEach(b=>t.call(l,b,b,this))}*entries(){for(let[t,l]of this._map)yield[l,l]}keys(){return this._map.values()}values(){return this._map.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=u;function d(n){const t=new Set;for(const l of n)t.add(U.ExtensionIdentifier.toKey(l));return t}e.extensionIdentifiersArrayToSet=d;function c(n){const t=new Map;for(const l of n)t.set(U.ExtensionIdentifier.toKey(l.identifier),l);return t}function k(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=k;function y(n,t){if(!k(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.checkProposedApiEnabled=y;class a{constructor(t,l,b,v){this.codeLoadingTime=t,this.activateCallTime=l,this.activateResolvedTime=b,this.activationReason=v}}e.ActivationTimes=a;class D{constructor(t,l){this.description=t,this.value=l}}e.ExtensionPointContribution=D,e.ExtensionHostLogFileName="exthost";var r;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(r||(e.ActivationKind=r={}));function h(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.toExtension=h;function i(n,t){return{identifier:new U.ExtensionIdentifier((0,I.getExtensionId)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.toExtensionDescription=i;class o{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,l){return Promise.resolve(0)}getInspectPorts(t,l){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,l){return Promise.resolve()}}e.NullExtensionService=o}),define(Ie[178],Te([1,0,11,25,26,14,13]),function(ee,e,s,C,g,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class P{constructor(d,c,k,y){this.startup=d,this.codeLoadingTime=c,this.activateCallTime=k,this.activateResolvedTime=y}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class w{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,c){return d===-1||c===-1?-1:c-d}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=w;class A{constructor(d,c,k,y,a,D){this.activationFailed=d,this.activationFailedError=c,this.activationTimes=k,this.module=y,this.exports=a,this.subscriptions=D}}e.ActivatedExtension=A;class O extends A{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class S extends A{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=S;class m extends A{constructor(d){super(!0,d,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let _=class{constructor(d,c,k,y,a){this._logService=a,this._registry=d,this._resolvedExtensionsSet=new Set,c.forEach(D=>this._resolvedExtensionsSet.add(C.ExtensionIdentifier.toKey(D))),this._externalExtensionsMap=new Map,k.forEach(D=>this._externalExtensionsMap.set(C.ExtensionIdentifier.toKey(D),D)),this._host=y,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[d,c]of this._operations)c.dispose()}isActivated(d){const c=this._operations.get(C.ExtensionIdentifier.toKey(d));return Boolean(c&&c.value)}getActivatedExtension(d){const c=this._operations.get(C.ExtensionIdentifier.toKey(d));if(!c||!c.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return c.value}async activateByEvent(d,c){if(this._alreadyActivatedEvents[d])return;const k=this._registry.getExtensionDescriptionsForActivationEvent(d);await this._activateExtensions(k.map(y=>({id:y.identifier,reason:{startup:c,extensionId:y.identifier,activationEvent:d}}))),this._alreadyActivatedEvents[d]=!0}activateById(d,c){const k=this._registry.getExtensionDescription(d);if(!k)throw new Error(`Extension '${d}' is not known`);return this._activateExtensions([{id:k.identifier,reason:c}])}async _activateExtensions(d){const c=d.filter(k=>!this.isActivated(k.id)).map(k=>this._handleActivationRequest(k));await Promise.all(c.map(k=>k.wait()))}_handleActivationRequest(d){if(this._operations.has(C.ExtensionIdentifier.toKey(d.id)))return this._operations.get(C.ExtensionIdentifier.toKey(d.id));if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(d.id)))return this._createAndSaveOperation(d,null,[],null);const c=this._registry.getExtensionDescription(d.id);if(!c){const a=new Error(`Cannot activate unknown extension '${d.id.value}'`),D=this._createAndSaveOperation(d,null,[],new m(a));return this._host.onExtensionActivationError(d.id,a,new g.MissingExtensionDependency(d.id.value)),D}const k=[],y=typeof c.extensionDependencies=="undefined"?[]:c.extensionDependencies;for(const a of y){if(this._resolvedExtensionsSet.has(C.ExtensionIdentifier.toKey(a)))continue;const D=this._operations.get(C.ExtensionIdentifier.toKey(a));if(D){k.push(D);continue}if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(a))){k.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(C.ExtensionIdentifier.toKey(a)),reason:d.reason}));continue}const r=this._registry.getExtensionDescription(a);if(r){if(!r.main&&!r.browser)continue;k.push(this._handleActivationRequest({id:r.identifier,reason:d.reason}));continue}const h=c.displayName||c.identifier.value,i=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${a}'`),o=this._createAndSaveOperation(d,c.displayName,[],new m(i));return this._host.onExtensionActivationError(c.identifier,i,new g.MissingExtensionDependency(a)),o}return this._createAndSaveOperation(d,c.displayName,k,null)}_createAndSaveOperation(d,c,k,y){const a=new f(d.id,c,d.reason,k,y,this._host,this._logService);return this._operations.set(C.ExtensionIdentifier.toKey(d.id),a),a}};e.ExtensionsActivator=_,e.ExtensionsActivator=_=$e([We(4,U.ILogService)],_);let f=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(d,c,k,y,a,D,r){this._id=d,this._displayName=c,this._reason=k,this._deps=y,this._value=a,this._host=D,this._logService=r,this._barrier=new I.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let d=0;d<this._deps.length;d++){const c=this._deps[d];if(c.value&&!c.value.activationFailed){this._deps.splice(d,1),d--;continue}if(c.value&&c.value.activationFailed){const k=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);k.detail=c.value.activationFailedError,this._value=new m(k),this._host.onExtensionActivationError(this._id,k,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(d=>d.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(d){const c=new Error;if(d&&d.name&&(c.name=d.name),d&&d.message?c.message=`Activating extension '${this._id.value}' failed: ${d.message}.`:c.message=`Activating extension '${this._id.value}' failed: ${d}.`,d&&d.stack&&(c.stack=d.stack),this._value=new m(c),this._isDisposed&&s.isCancellationError(d))return;this._host.onExtensionActivationError(this._id,c,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(d)}}};f=$e([We(6,U.ILogService)],f)}),define(Ie[179],Te([1,0,14,28,26]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let U=class extends s.LogService{constructor(P,w){super(P.createLogger(w.logFile,{name:g.ExtensionHostLogFileName}))}};e.ExtHostLogService=U,e.ExtHostLogService=U=$e([We(0,s.ILoggerService),We(1,C.IExtHostInitDataService)],U)}),define(Ie[180],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorToolbar:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorToolbar.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",dataTransferFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dataTransferFiles.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorDecorationType:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorDecorationType.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmInput:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInput.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalNameChangeEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalNameChangeEvent.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textEditorDrop:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textEditorDrop.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[181],Te([1,0,141,11,29,79,82,30,25,180,43,149]),function(ee,e,s,C,g,U,I,P,w,A,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const m=P.Registry.as(I.Extensions.JSONContribution);class _{constructor(D,r,h){this._messageHandler=D,this._extension=r,this._extensionPointId=h}_msg(D,r){this._messageHandler({type:D,message:r,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(D){this._msg(g.default.Error,D)}warn(D){this._msg(g.default.Warning,D)}info(D){this._msg(g.default.Info,D)}}e.ExtensionMessageCollector=_;class f{static _toSet(D){const r=new Set;for(let h=0,i=D.length;h<i;h++)r.add(w.ExtensionIdentifier.toKey(D[h].description.identifier));return r}static compute(D,r){if(!D||!D.length)return new f(r,[]);if(!r||!r.length)return new f([],D);const h=this._toSet(D),i=this._toSet(r);let o=r.filter(t=>!h.has(w.ExtensionIdentifier.toKey(t.description.identifier))),n=D.filter(t=>!i.has(w.ExtensionIdentifier.toKey(t.description.identifier)));return new f(o,n)}constructor(D,r){this.added=D,this.removed=r}}e.ExtensionPointUserDelta=f;class u{constructor(D,r){this.name=D,this.defaultExtensionKind=r,this._handler=null,this._users=null,this._delta=null}setHandler(D){if(this._handler!==null)throw new Error("Handler already set!");this._handler=D,this._handle()}acceptUsers(D){this._delta=f.compute(this._users,D),this._users=D,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(D){(0,C.onUnexpectedError)(D)}}}e.ExtensionPoint=u;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[s.localize(0,null),s.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:s.localize(2,null),properties:{vscode:{type:"string",description:s.localize(3,null),default:"^1.22.0"}}},publisher:{description:s.localize(4,null),type:"string"},displayName:{description:s.localize(5,null),type:"string"},categories:{description:s.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:w.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:s.localize(7,null)}]}},galleryBanner:{type:"object",description:s.localize(8,null),properties:{color:{description:s.localize(9,null),type:"string"},theme:{description:s.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:s.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:s.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:s.localize(13,null)},enabledApiProposals:{markdownDescription:s.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(A.allApiProposals),markdownEnumDescriptions:(0,O.values)(A.allApiProposals)}},activationEvents:{description:s.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:s.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:s.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:s.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:s.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:s.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:s.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:s.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:s.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:s.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:s.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:s.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:s.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:s.localize(28,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:s.localize(29,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:s.localize(30,null)},{label:"onUri",body:"onUri",description:s.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:s.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:s.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:s.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:s.localize(35,null)},{label:"onRenderer",description:s.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:s.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:s.localize(38,null)},{label:"*",description:s.localize(39,null),body:"*"}]}},badges:{type:"array",description:s.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:s.localize(41,null)},href:{type:"string",description:s.localize(42,null)},description:{type:"string",description:s.localize(43,null)}}}},markdown:{type:"string",description:s.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:s.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:s.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:U.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:s.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:U.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:s.localize(48,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:s.localize(49,null)},{body:["workspace"],description:s.localize(50,null)},{body:["ui","workspace"],description:s.localize(51,null)},{body:["workspace","ui"],description:s.localize(52,null)},{body:[],description:s.localize(53,null)}]},capabilities:{description:s.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:s.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:s.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(57,null),s.localize(58,null),s.localize(59,null)]},description:{type:"string",markdownDescription:s.localize(60,null)}}},untrustedWorkspaces:{description:s.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:s.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(63,null),s.localize(64,null),s.localize(65,null)]},restrictedConfigurations:{description:s.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:s.localize(67,null)}}}}},sponsor:{description:s.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:s.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:s.localize(70,null),type:"string"},"vscode:uninstall":{description:s.localize(71,null),type:"string"}}},icon:{type:"string",description:s.localize(72,null)}}};class k{constructor(){this._extensionPoints=new Map}registerExtensionPoint(D){if(this._extensionPoints.has(D.extensionPoint))throw new Error("Duplicate extension point: "+D.extensionPoint);const r=new u(D.extensionPoint,D.defaultExtensionKind);return this._extensionPoints.set(D.extensionPoint,r),e.schema.properties.contributes.properties[D.extensionPoint]=D.jsonSchema,m.registerSchema(c,e.schema),r}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=k;const y={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(y.ExtensionsRegistry,new k),e.ExtensionsRegistry=P.Registry.as(y.ExtensionsRegistry),m.registerSchema(c,e.schema),m.registerSchema(S.productSchemaId,{properties:{extensionEnabledApiProposals:{description:s.localize(73,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(A.allApiProposals),markdownEnumDescriptions:(0,O.values)(A.allApiProposals)}}]}}}})}),define(Ie[182],Te([1,0,138,9,27,181,38,5]),function(ee,e,s,C,g,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const w={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:s.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:s.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:s.localize(2,null),default:""}}};var A;(function(m){function _(f,u,d){if(!f)return;let c=C.isString(f.type)?f.type:void 0;if(!c||c.length===0){d.error(s.localize(3,null));return}let k=[];if(Array.isArray(f.required))for(let y of f.required)C.isString(y)&&k.push(y);return{extensionId:u.value,taskType:c,required:k,properties:f.properties?g.deepClone(f.properties):{},when:f.when?I.ContextKeyExpr.deserialize(f.when):void 0}}m.from=_})(A||(A={}));const O=U.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:s.localize(4,null),type:"array",items:w}});class S{constructor(){this._onDefinitionsChanged=new P.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((_,f)=>{O.setHandler((u,d)=>{try{for(let c of d.removed){let k=c.value;for(let y of k)this.taskTypes&&y.type&&this.taskTypes[y.type]&&delete this.taskTypes[y.type]}for(let c of d.added){let k=c.value;for(let y of k){let a=A.from(y,c.description.identifier,c.collector);a&&(this.taskTypes[a.taskType]=a)}}(d.removed.length>0||d.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}_(void 0)})})}onReady(){return this.readyPromise}get(_){return this.taskTypes[_]}all(){return Object.keys(this.taskTypes).map(_=>this.taskTypes[_])}getJsonSchema(){if(this._schema===void 0){let _=[];for(let f of this.all()){let u={type:"object",additionalProperties:!1};f.required.length>0&&(u.required=f.required.slice(0)),f.properties!==void 0?u.properties=g.deepClone(f.properties):u.properties=Object.create(null),u.properties.type={type:"string",enum:[f.taskType]},_.push(u)}this._schema={oneOf:_}}return this._schema}}e.TaskDefinitionRegistryImpl=S,e.TaskDefinitionRegistry=new S}),define(Ie[183],Te([1,0,139,9,21,27,38,182]),function(ee,e,s,C,g,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new I.RawContextKey("taskRunning",!1,s.localize(0,null)),e.TASKS_CATEGORY={value:s.localize(1,null),original:"Tasks"};var w;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(w||(e.ShellQuoting=w={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function M(z){if(!z)return F.Strong;switch(z.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=M}(w||(e.ShellQuoting=w={}));var A;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(A||(e.CommandOptions=A={}));var O;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(O||(e.RevealKind=O={})),function(F){function M(z){switch(z.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=M}(O||(e.RevealKind=O={}));var S;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(F){function M(z){switch(z.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=M}(S||(e.RevealProblemKind=S={}));var m;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(m||(e.PanelKind=m={})),function(F){function M(z){switch(z.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=M}(m||(e.PanelKind=m={}));var _;(function(F){F.defaults={echo:!0,reveal:O.Always,revealProblems:S.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(_||(e.PresentationOptions=_={}));var f;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(f||(e.RuntimeType=f={})),function(F){function M(Z){switch(Z.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=M;function z(Z){switch(Z){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=z}(f||(e.RuntimeType=f={}));var u;(function(F){function M(z){return C.isString(z)?z:z.value}F.value=M})(u||(e.CommandString=u={}));var d;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function M(Z){return Z===F.Clean._id||Z===F.Build._id||Z===F.Rebuild._id||Z===F.Test._id}F.is=M;function z(Z){if(Z!==void 0)return C.isString(Z)?M(Z)?{_id:Z,isDefault:!1}:void 0:Z}F.from=z})(d||(e.TaskGroup=d={}));var c;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var k;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function M(z){switch(z){case F.User:return 1;case F.WorkspaceFile:return 4;default:return 5}}F.toConfigurationTarget=M})(k||(e.TaskSourceKind=k={}));var y;(function(F){F.parallel="parallel",F.sequence="sequence"})(y||(e.DependsOrder=y={}));var a;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var D;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(D||(e.RunOptions=D={}));class r{constructor(M,z,Z,K,N,se){this._label="",this._id=M,z&&(this._label=z),Z&&(this.type=Z),this.runOptions=K,this.configurationProperties=N,this._source=se}getDefinition(M){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const M={folder:this.getFolderId(),id:this._id};return JSON.stringify(M)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,z=!1){if(M===void 0)return!1;if(C.isString(M))return M===this._label||M===this.configurationProperties.identifier||z&&M===this._id;let Z=this.getDefinition(!0);return Z!==void 0&&Z._key===M._key}getQualifiedLabel(){let M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),M&&(this._taskLoadMessages=this._taskLoadMessages.concat(M))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=r;class h extends r{constructor(M,z,Z,K,N,se,le,oe){super(M,Z,void 0,le,oe,z);this.command={},this._source=z,this.hasDefinedMatchers=se,N&&(this.command=N)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case f.Shell:z="shell";break;case f.Process:z="process";break;case f.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(M){return M instanceof h}getMapKey(){let M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===k.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){let M=this.getFolderId();if(!M)return;let z=this.configurationProperties.identifier;this._source.kind!==k.Workspace&&(z+=this._source.kind);let Z={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:z};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(M){return new h(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.CustomTask=h;class i extends r{constructor(M,z,Z,K,N,se,le){super(M,Z,K,se,le,z);this._source=z,this.configures=N}static is(M){return M instanceof i}fromObject(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===k.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){let M=this.getFolderId();if(!M)return;let z=this.configurationProperties.identifier;this._source.kind!==k.Workspace&&(z+=this._source.kind);let Z={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:z};return JSON.stringify(Z)}}e.ConfiguringTask=i;class o extends r{constructor(M,z,Z,K,N,se,le,oe,fe){super(M,Z,K,oe,fe,z);this.defines=N,this.hasDefinedMatchers=le,this.command=se}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof o}getMapKey(){let M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){let M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.getFolderId(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(M){return new o(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.ContributedTask=o;class n extends r{constructor(M,z,Z,K,N,se){super(M,Z,K,N,se,z);this._source=z}clone(){return new n(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof n}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(M){return new n(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.InMemoryTask=n;var t;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(t||(e.ExecutionEngine=t={})),function(F){F._default=F.Terminal}(t||(e.ExecutionEngine=t={}));var l;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class b{constructor(M){this._order=new Map;for(let z=0;z<M.length;z++)this._order.set(M[z].uri.toString(),z)}compare(M,z){let Z=M.getWorkspaceFolder(),K=z.getWorkspaceFolder();if(Z&&K){let N=this._order.get(Z.uri.toString());N=N===void 0?0:N+1;let se=this._order.get(K.uri.toString());return se=se===void 0?0:se+1,N===se?M._label.localeCompare(z._label):N-se}else return!Z&&K?-1:Z&&!K?1:0}}e.TaskSorter=b;var v;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(v||(e.TaskEventKind=v={}));var E;(function(F){F.SingleRun="singleRun",F.Background="background"})(E||(e.TaskRunType=E={}));var x;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange"})(x||(e.TaskRunSource=x={}));var $;(function(F){function M(z,Z,K,N){if(Z){let se={kind:z,taskId:Z._id,taskName:Z.configurationProperties.name,runType:Z.configurationProperties.isBackground?"background":"singleRun",group:Z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:Z};return z==="start"?(se.terminalId=K,se.resolvedVariables=N):z==="processStarted"?se.processId=K:z==="processEnded"&&(se.exitCode=K),Object.freeze(se)}else return Object.freeze({kind:"changed"})}F.create=M})($||(e.TaskEvent=$={}));var R;(function(F){function M(Z){const K=Object.keys(Z).sort();let N="";for(const se of K){let le=Z[se];le instanceof Object?le=M(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),N+=se+","+le+","}return N}function z(Z){let N={_key:M(Z),type:Z.taskType};return Object.assign(N,Z),N}F.create=z})(R||(e.KeyedTaskIdentifier=R={}));var p;(function(F){function M(z,Z){let K=P.TaskDefinitionRegistry.get(z.type);if(K===void 0){let oe=U.deepClone(z);return delete oe._key,R.create(oe)}let N=Object.create(null);N.type=K.taskType;let se=new Set;K.required.forEach(oe=>se.add(oe));let le=K.properties;for(let oe of Object.keys(le)){let fe=z[oe];if(fe!=null)N[oe]=fe;else if(se.has(oe)){let be=le[oe];if(be.default!==void 0)N[oe]=U.deepClone(be.default);else switch(be.type){case"boolean":N[oe]=!1;break;case"number":case"integer":N[oe]=0;break;case"string":N[oe]="";break;default:Z.error(s.localize(2,null,JSON.stringify(z,void 0,0),oe));return}}}return R.create(N)}F.createTaskIdentifier=M})(p||(e.TaskDefinition=p={}))}),define(Ie[184],Te([1,0,11]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class C{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((U,I)=>{this._actualOk=U,this._actualErr=I,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(U){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=U,this._actual&&this._actualOk(U))}resolveErr(U){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=U,this._actual?this._actualErr(U):(0,s.onUnexpectedError)(U))}then(U,I){return this._ensureActual().then(U,I)}catch(U){return this._ensureActual().then(void 0,U)}finally(U){return this._ensureActual().finally(U)}}e.LazyPromise=C}),define(Ie[40],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class s{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++s.count}}e.ProxyIdentifier=s,s.count=0;const C=[];function g(P){const w=new s(P);return C[w.nid]=w,w}e.createProxyIdentifier=g;function U(P){return C[P].sid}e.getStringIdentifierForProxy=U;class I{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=I}),define(Ie[4],Te([1,0,57,2,40]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var U;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(U||(e.TextEditorRevealType=U={}));var I;(function(y){y[y.UnknownInput=0]="UnknownInput",y[y.TextInput=1]="TextInput",y[y.TextDiffInput=2]="TextDiffInput",y[y.NotebookInput=3]="NotebookInput",y[y.NotebookDiffInput=4]="NotebookDiffInput",y[y.CustomEditorInput=5]="CustomEditorInput",y[y.WebviewEditorInput=6]="WebviewEditorInput",y[y.TerminalEditorInput=7]="TerminalEditorInput"})(I||(e.TabInputKind=I={}));var P;(function(y){y[y.TAB_OPEN=0]="TAB_OPEN",y[y.TAB_CLOSE=1]="TAB_CLOSE",y[y.TAB_UPDATE=2]="TAB_UPDATE",y[y.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var w;(function(y){y[y.Editable=0]="Editable",y[y.SupportsHotExit=1]="SupportsHotExit"})(w||(e.WebviewEditorCapabilities=w={}));var A;(function(y){y[y.Int8Array=1]="Int8Array",y[y.Uint8Array=2]="Uint8Array",y[y.Uint8ClampedArray=3]="Uint8ClampedArray",y[y.Int16Array=4]="Int16Array",y[y.Uint16Array=5]="Uint16Array",y[y.Int32Array=6]="Int32Array",y[y.Uint32Array=7]="Uint32Array",y[y.Float32Array=8]="Float32Array",y[y.Float64Array=9]="Float64Array",y[y.BigInt64Array=10]="BigInt64Array",y[y.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var O;(function(y){y[y.Text=1]="Text",y[y.Error=2]="Error",y[y.Rich=3]="Rich"})(O||(e.CellOutputKind=O={}));var S;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(S||(e.NotebookEditorRevealType=S={}));var m;(function(y){y[y.None=0]="None",y[y.Process=1]="Process",y[y.Output=2]="Output"})(m||(e.CandidatePortSource=m={}));class _{static mixin(a){return a._id=_._n++,a}}e.IdObject=_,_._n=0;var f;(function(y){y.label="a",y.kind="b",y.detail="c",y.documentation="d",y.sortText="e",y.filterText="f",y.preselect="g",y.insertText="h",y.insertTextRules="i",y.range="j",y.commitCharacters="k",y.additionalTextEdits="l",y.command="m",y.kindModifier="n"})(f||(e.ISuggestDataDtoField=f={}));var u;(function(y){y.defaultRanges="a",y.completions="b",y.isIncomplete="c",y.duration="d"})(u||(e.ISuggestResultDtoField=u={}));var d;(function(y){y[y.File=1]="File",y[y.Text=2]="Text",y[y.Cell=3]="Cell"})(d||(e.WorkspaceEditType=d={}));function c(y){if(y&&y.edits)for(const a of y.edits)typeof a.resource=="object"?a.resource=C.URI.revive(a.resource):(a.newUri=C.URI.revive(a.newUri),a.oldUri=C.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,s.revive)(a.metadata));return y}e.reviveWorkspaceEditDto=c;var k;(function(y){y[y.Workspace=0]="Workspace",y[y.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.MainContext={MainThreadAuthentication:(0,g.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,g.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,g.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,g.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,g.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,g.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,g.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,g.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,g.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,g.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,g.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,g.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,g.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,g.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,g.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,g.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,g.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,g.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,g.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,g.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,g.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,g.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,g.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,g.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,g.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,g.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,g.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,g.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,g.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,g.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,g.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,g.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,g.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,g.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,g.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,g.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,g.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,g.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,g.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,g.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,g.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,g.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,g.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,g.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,g.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,g.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,g.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,g.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,g.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,g.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,g.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,g.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,g.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,g.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,g.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,g.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,g.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,g.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,g.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,g.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,g.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,g.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,g.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,g.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,g.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,g.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,g.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,g.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,g.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,g.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,g.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,g.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,g.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,g.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,g.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,g.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,g.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,g.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,g.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,g.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,g.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,g.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,g.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,g.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,g.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,g.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,g.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,g.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,g.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,g.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,g.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,g.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,g.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,g.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,g.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,g.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,g.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,g.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,g.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,g.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,g.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,g.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,g.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,g.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,g.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,g.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,g.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ie[69],Te([1,0,4,5,3]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class U{constructor(P){this._onDidChangePassword=new C.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(s.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,w){return this._proxy.$getPassword(P,w)}store(P,w,A){return this._proxy.$setPassword(P,w,A)}delete(P,w){return this._proxy.$deletePassword(P,w)}}e.ExtHostSecretState=U,e.IExtHostSecretState=(0,g.createDecorator)("IExtHostSecretState")}),define(Ie[70],Te([1,0,3,14,4,16]),function(ee,e,s,C,g,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,s.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(w,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=w.getProxy(g.MainContext.MainThreadTelemetry)}report(w,A,O){const S=this.getUsageKey(w,A);this._reportedUsages.has(S)||(this._reportedUsages.add(S),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${w}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:w}))}getUsageKey(w,A){return`${w}-${A.identifier.value}`}};e.ExtHostApiDeprecationService=I,e.ExtHostApiDeprecationService=I=$e([We(0,U.IExtHostRpcService),We(1,C.ILogService)],I),e.NullApiDeprecationService=Object.freeze(new class{report(P,w,A){}})}),define(Ie[185],Te([1,0,5,4,6,25]),function(ee,e,s,C,g,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(w){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new s.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=w.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(w){return this._providers=w,Promise.resolve()}async getSession(w,A,O,S={}){const m=U.ExtensionIdentifier.toKey(w.identifier),_=this._inFlightRequests.get(m)||[],f=[...O].sort().join(" ");let u=_.find(d=>d.providerId===A&&d.scopes===f);if(u)return u.result;{const d=this._getSession(w,m,A,O,S);u={providerId:A,scopes:f,result:d},_.push(u),this._inFlightRequests.set(m,_);try{await d}finally{const c=_.findIndex(k=>k.providerId===A&&k.scopes===f);c>-1&&(_.splice(c),this._inFlightRequests.set(m,_))}return d}}async _getSession(w,A,O,S,m={}){await this._proxy.$ensureProvider(O);const _=w.displayName||w.name;return this._proxy.$getSession(O,S,A,_,m)}async removeSession(w,A){const O=this._authenticationProviders.get(w);return O?O.provider.removeSession(A):this._proxy.$removeSession(w,A)}registerAuthenticationProvider(w,A,O,S){if(this._authenticationProviders.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this._authenticationProviders.set(w,{label:A,provider:O,options:S??{supportsMultipleAccounts:!1}}),this._providers.find(_=>_.id===w)||this._providers.push({id:w,label:A});const m=O.onDidChangeSessions(_=>{this._proxy.$sendDidChangeSessions(w,{added:_.added??[],changed:_.changed??[],removed:_.removed??[]})});return this._proxy.$registerAuthenticationProvider(w,A,S?.supportsMultipleAccounts??!1),new g.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(w);const _=this._providers.findIndex(f=>f.id===w);_>-1&&this._providers.splice(_),this._proxy.$unregisterAuthenticationProvider(w)})}$createSession(w,A){const O=this._authenticationProviders.get(w);if(O)return Promise.resolve(O.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,A){const O=this._authenticationProviders.get(w);if(O)return Promise.resolve(O.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,A){const O=this._authenticationProviders.get(w);if(O)return Promise.resolve(O.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,A){return this._onDidChangeSessions.fire({provider:{id:w,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(Ie[186],Te([1,0,4,16,8]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let U=class{constructor(P,w){this._proxy=P.getProxy(s.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:A=>w.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P){const w=g.WorkspaceEdit.from(P,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(w)}};e.ExtHostBulkEdits=U,e.ExtHostBulkEdits=U=$e([We(0,C.IExtHostRpcService)],U)}),define(Ie[187],Te([1,0,4]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(U){const I=U.getProxy(s.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(P){return I.$writeText(P)}})}}e.ExtHostClipboard=C});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,s,C,g){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?g.call(ee,s):g?g.value=s:e.set(ee,s),s},Re=this&&this.__classPrivateFieldGet||function(ee,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[36],Te([1,0,9,6,8,27,4,15,14,57,49,239,2,7,3,16,92,23,40,45]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d,c,k,y){"use strict";var a,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(l,b){a.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,D.set(this,void 0),Ye(this,a,l.getProxy(I.MainContext.MainThreadCommands),"f"),this._logService=b,Ye(this,D,l.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new h(this,v=>{const E=this._apiCommands.get(v);return E?.result===o.Void?E:void 0},b),this._argumentProcessors=[{processArgument(v){return(0,A.revive)(v)}},{processArgument(v){return(0,U.cloneAndChange)(v,function(E){if(O.Range.isIRange(E))return g.Range.to(E);if(S.Position.isIPosition(E))return g.Position.to(E);if(O.Range.isIRange(E.range)&&m.URI.isUri(E.uri))return g.location.to(E);if(E instanceof c.VSBuffer)return E.buffer.buffer;if(!Array.isArray(E))return E})}}]}registerArgumentProcessor(l){this._argumentProcessors.push(l)}registerApiCommand(l){const b=this.registerCommand(!1,l.id,async(...v)=>{const E=l.args.map(($,R)=>{if(!$.validate(v[R]))throw new Error(`Invalid argument '${$.name}' when running '${l.id}', received: ${v[R]}`);return $.convert(v[R])}),x=await this.executeCommand(l.internalId,...E);return l.result.convert(x,v,this.converter)},void 0,{description:l.description,args:l.args,returns:l.result.description});return this._apiCommands.set(l.id,l),new C.Disposable(()=>{b.dispose(),this._apiCommands.delete(l.id)})}registerCommand(l,b,v,E,x,$){if(this._logService.trace("ExtHostCommands#registerCommand",b),!b.trim().length)throw new Error("invalid id");if(this._commands.has(b))throw new Error(`command '${b}' already exists`);return this._commands.set(b,{callback:v,thisArg:E,description:x,extension:$}),l&&Re(this,a,"f").$registerCommand(b),new C.Disposable(()=>{this._commands.delete(b)&&l&&Re(this,a,"f").$unregisterCommand(b)})}executeCommand(l,...b){return this._logService.trace("ExtHostCommands#executeCommand",l),this._doExecuteCommand(l,b,!0)}async _doExecuteCommand(l,b,v){if(this._commands.has(l))return this._executeContributedCommand(l,b,!1);{let E=!1;const x=(0,U.cloneAndChange)(b,function($){if($ instanceof C.Position)return g.Position.from($);if($ instanceof C.Range)return g.Range.from($);if($ instanceof C.Location)return g.location.from($);if(C.NotebookRange.isNotebookRange($))return g.NotebookRange.from($);if($ instanceof ArrayBuffer)return E=!0,c.VSBuffer.wrap(new Uint8Array($));if($ instanceof Uint8Array)return E=!0,c.VSBuffer.wrap($);if($ instanceof c.VSBuffer)return E=!0,$;if(!Array.isArray($))return $});try{const $=await Re(this,a,"f").$executeCommand(l,E?new k.SerializableObjectWithBuffers(x):x,v);return(0,A.revive)($)}catch($){if($ instanceof Error&&$.message==="$executeCommand:retry")return this._doExecuteCommand(l,b,!1);throw $}}}async _executeContributedCommand(l,b,v){const E=this._commands.get(l);if(!E)throw new Error("Unknown command");this._reportTelemetry(E,l);let{callback:x,thisArg:$,description:R}=E;if(R)for(let p=0;p<R.args.length;p++)try{(0,s.validateConstraint)(b[p],R.args[p].constraint)}catch{throw new Error(`Running the contributed command: '${l}' failed. Illegal argument '${R.args[p].name}' - ${R.args[p].description}`)}try{return await x.apply($,b)}catch(p){if(l===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...b);F&&(l=F.command)}throw this._logService.error(p,l,E.extension?.identifier),v?new class extends Error{constructor(){super((0,y.toErrorMessage)(p));this.id=l,this.source=E.extension?.displayName??E.extension?.name}}:p}}_reportTelemetry(l,b){!l.extension||l.extension.isBuiltin||Re(this,D,"f").$publicLog2("Extension:ActionExecuted",{extensionId:l.extension.identifier.value,id:b})}$executeContributedCommand(l,...b){return this._logService.trace("ExtHostCommands#$executeContributedCommand",l),this._commands.has(l)?(b=b.map(v=>this._argumentProcessors.reduce((E,x)=>x.processArgument(E),v)),this._executeContributedCommand(l,b,!0)):Promise.reject(new Error(`Contributed command '${l}' does not exist.`))}getCommands(l=!1){return this._logService.trace("ExtHostCommands#getCommands",l),Re(this,a,"f").$getCommands().then(b=>(l&&(b=b.filter(v=>v[0]!=="_")),b))}$getContributedCommandHandlerDescriptions(){const l=Object.create(null);for(let[b,v]of this._commands){let{description:E}=v;E&&(l[b]=E)}return Promise.resolve(l)}};e.ExtHostCommands=r,a=new WeakMap,D=new WeakMap,e.ExtHostCommands=r=$e([We(0,u.IExtHostRpcService),We(1,w.ILogService)],r),e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class h{constructor(l,b,v){this._commands=l,this._lookupApiCommand=b,this._logService=v,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(l,b){if(!l)return;const v={$ident:void 0,id:l.command,title:l.title,tooltip:l.tooltip};if(!l.command)return v;const E=this._lookupApiCommand(l.command);if(E)v.id=E.internalId,v.arguments=E.args.map((x,$)=>x.convert(l.arguments&&l.arguments[$]));else if((0,P.isNonEmptyArray)(l.arguments)){const x=++this._cachIdPool;this._cache.set(x,l),b.add((0,_.toDisposable)(()=>{this._cache.delete(x),this._logService.trace("CommandsConverter#DISPOSE",x)})),v.$ident=x,v.id=this.delegatingCommandId,v.arguments=[x],this._logService.trace("CommandsConverter#CREATE",l.command,x)}return v}fromInternal(l){return typeof l.$ident=="number"?this._cache.get(l.$ident):{command:l.id,title:l.title,arguments:l.arguments}}getActualCommand(...l){return this._cache.get(l[0])}_executeConvertedCommand(...l){const b=this.getActualCommand(...l);return this._logService.trace("CommandsConverter#EXECUTE",l[0],b?b.command:"MISSING"),b?this._commands.executeCommand(b.command,...b.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=h;class i{constructor(l,b,v,E){this.name=l,this.description=b,this.validate=v,this.convert=E}optional(){return new i(this.name,`(optional) ${this.description}`,l=>l==null||this.validate(l),l=>l===void 0?void 0:l===null?null:this.convert(l))}with(l,b){return new i(l??this.name,b??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",t=>m.URI.isUri(t),t=>t),i.Position=new i("position","A position in a text document",t=>C.Position.isPosition(t),g.Position.from),i.Range=new i("range","A range in a text document",t=>C.Range.isRange(t),g.Range.from),i.Selection=new i("selection","A selection in a text document",t=>C.Selection.isSelection(t),g.Selection.from),i.Number=new i("number","",t=>typeof t=="number",t=>t),i.String=new i("string","",t=>typeof t=="string",t=>t),i.CallHierarchyItem=new i("item","A call hierarchy item",t=>t instanceof C.CallHierarchyItem,g.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",t=>t instanceof C.TypeHierarchyItem,g.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",t=>t instanceof d.TestItemImpl,g.TestItem.from);class o{constructor(l,b){this.description=l,this.convert=b}}e.ApiCommandResult=o,o.Void=new o("no result",t=>t);class n{constructor(l,b,v,E,x){this.id=l,this.internalId=b,this.description=v,this.args=E,this.result=x}}e.ApiCommand=n}),define(Ie[188],Te([1,0,2,8,6,68,36,15,77,81,12]),function(ee,e,s,C,g,U,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",_(C.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,d)=>{if((0,P.isFalsyOrEmpty)(u))return;class c extends g.SymbolInformation{static to(y){const a=new c(y.name,C.SymbolKind.to(y.kind),y.containerName||"",new g.Location(d[0],C.Range.to(y.range)));return a.detail=y.detail,a.range=a.location.range,a.selectionRange=C.Range.to(y.selectionRange),a.children=y.children?y.children.map(c.to):[],a}}return u.map(c.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(C.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(C.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new I.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(C.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",_(C.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",_(C.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(d=>g.Position.isPosition(d)),u=>u.map(C.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(d=>{let c;for(const k of d.reverse())c=new g.SelectionRange(C.Range.to(k),c);return c}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(C.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(C.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(C.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(C.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",u=>{if(!!u)return{range:C.Range.to(u.range),placeholder:u.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return C.WorkspaceEdit.to(u)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(C.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new g.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const d=(0,w.decodeSemanticTokensDto)(u);if(d.type==="full")return new g.SemanticTokens(d.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new g.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const d=(0,w.decodeSemanticTokensDto)(u);if(d.type==="full")return new g.SemanticTokens(d.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,d,c)=>{if(!u)return new g.CompletionList([]);const k=u.suggestions.map(y=>C.CompletionItem.to(y,c));return new g.CompletionList(k,u.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return C.SignatureHelp.to(u)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,d,c)=>_(k=>new g.CodeLens(C.Range.to(k.range),k.command&&c.fromInternal(k.command)))(u))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>g.Range.isRange(u),u=>g.Selection.isSelection(u)?C.Selection.from(u):C.Range.from(u)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,d,c)=>_(k=>{if(k._isSynthetic){if(!k.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(k.command)}else{const y=new g.CodeAction(k.title,k.kind?new g.CodeActionKind(k.kind):void 0);return k.edit&&(y.edit=C.WorkspaceEdit.to(k.edit)),k.command&&(y.command=c.fromInternal(k.command)),y.isPreferred=k.isPreferred,y}})(u))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(d=>new g.ColorInformation(C.Range.to(d.range),C.Color.to(d.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",u=>u instanceof g.Color,C.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:C.Range.from(u.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(C.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(u,d,c)=>u.map(C.InlayHint.to.bind(void 0,c)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",_(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(d=>C.NotebookExclusiveDocumentPattern.to(d))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(C.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",u=>s.URI.isUri(u)||typeof u=="string"&&(0,A.matchesSomeScheme)(u,O.Schemas.http,O.Schemas.https),u=>u),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[C.ViewColumn.from(u),void 0]:[C.ViewColumn.from(u.viewColumn),C.TextEditorOpenOptions.from(u)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[C.ViewColumn.from(u),void 0]:[C.ViewColumn.from(u.viewColumn),C.TextEditorOpenOptions.from(u)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[C.ViewColumn.from(u.viewColumn),C.TextEditorOpenOptions.from(u)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void)];class m{static register(d){S.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=m;function _(u){return d=>{if(Array.isArray(d))return d.map(u)}}function f(u){if(!Array.isArray(u))return;const d=[];for(const c of u)U.isLocationLink(c)?d.push(C.DefinitionLink.to(c)):d.push(C.location.to(c));return d}}),define(Ie[189],Te([1,0,13,55,5,7,2,68,25,8,6,26,4]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function _(f,u,d){const c=f.getProxy(m.MainContext.MainThreadComments);class k{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const l=this._commentControllers.get(t.handle);return l?l.value:t}else if(t&&t.$mid===7){const l=this._commentControllers.get(t.commentControlHandle);if(!l)return t;const b=l.getCommentThread(t.commentThreadHandle);return b?b.value:t}else if(t&&t.$mid===8){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const b=l.getCommentThread(t.thread.commentThreadHandle);return b?{thread:b.value,text:t.text}:t}else if(t&&t.$mid===9){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const b=l.getCommentThread(t.thread.commentThreadHandle);if(!b)return t;let v=t.commentUniqueId,E=b.getCommentByUniqueId(v);return E||t}else if(t&&t.$mid===10){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const b=l.getCommentThread(t.thread.commentThreadHandle);if(!b)return t;let v=t.text,E=t.commentUniqueId,x=b.getCommentByUniqueId(E);return x?(x.body=v,x):t}return t}})}createCommentController(t,l,b){const v=k.handlePool++,E=new a(t,v,l,b);this._commentControllers.set(E.handle,E);const x=this._commentControllersByExtension.get(w.ExtensionIdentifier.toKey(t.identifier))||[];return x.push(E),this._commentControllersByExtension.set(w.ExtensionIdentifier.toKey(t.identifier),x),E.value}$createCommentThreadTemplate(t,l,b){const v=this._commentControllers.get(t);!v||v.$createCommentThreadTemplate(l,b)}async $updateCommentThreadTemplate(t,l,b){const v=this._commentControllers.get(t);!v||v.$updateCommentThreadTemplate(l,b)}$deleteCommentThread(t,l){const b=this._commentControllers.get(t);b&&b.$deleteCommentThread(l)}$provideCommentingRanges(t,l,b){const v=this._commentControllers.get(t);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const E=d.getDocument(I.URI.revive(l));return(0,s.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(E,b)).then(x=>x?x.map($=>A.Range.from($)):void 0)}$toggleReaction(t,l,b,v,E){const x=this._commentControllers.get(t);return!x||!x.reactionHandler?Promise.resolve(void 0):(0,s.asPromise)(()=>{const $=x.getCommentThread(l);if($){const R=$.getCommentByUniqueId(v.uniqueIdInThread);if(x!==void 0&&R&&x.reactionHandler)return x.reactionHandler(R,h(E))}return Promise.resolve(void 0)})}dispose(){}}k.handlePool=0;class y{set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,S.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,S.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(t,l,b,v,E,x,$,R){this._commentControllerHandle=l,this._id=b,this._uri=v,this._range=E,this._comments=x,this.extensionDescription=$,this._isTemplate=R,this.handle=y._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new g.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new U.MutableDisposable,this._acceptInputDisposables.value=new U.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),c.$createCommentThread(l,this.handle,this._id,this._uri,A.Range.from(this._range),$.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=x,this._localDisposables.push({dispose:()=>{c.$deleteCommentThread(l,this.handle)}});const p=this;this.value={get uri(){return p.uri},get range(){return p.range},set range(F){p.range=F},get comments(){return p.comments},set comments(F){p.comments=F},get collapsibleState(){return p.collapsibleState},set collapsibleState(F){p.collapsibleState=F},get canReply(){return p.canReply},set canReply(F){p.canReply=F},get contextValue(){return p.contextValue},set contextValue(F){p.contextValue=F},get label(){return p.label},set label(F){p.label=F},get state(){return p.state},set state(F){p.state=F},dispose:()=>{p.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new U.DisposableStore);const t=b=>Object.prototype.hasOwnProperty.call(this.modifications,b),l={};t("range")&&(l.range=A.Range.from(this._range)),t("label")&&(l.label=this.label),t("contextValue")&&(l.contextValue=this.contextValue??null),t("comments")&&(l.comments=this._comments.map(b=>D(this,b,this._commentsMap))),t("collapsibleState")&&(l.collapseState=i(this._collapseState)),t("canReply")&&(l.canReply=this.canReply),t("state")&&(l.state=o(this._state)),t("isTemplate")&&(l.isTemplate=this._isTemplate),this.modifications={},c.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,l)}getCommentByUniqueId(t){for(let l of this._commentsMap){let b=l[0],v=l[1];if(t===v)return b}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}y._handlePool=0,$e([(0,C.debounce)(100)],y.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,c.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(t,l,b,v){this._extension=t,this._handle=l,this._id=b,this._label=v,this._threads=new Map,c.$registerCommentController(this.handle,b,v);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(x){E.options=x},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(x){E.commentingRangeProvider=x},get reactionHandler(){return E.reactionHandler},set reactionHandler(x){E.reactionHandler=x},createCommentThread(x,$,R){return E.createCommentThread(x,$,R).value},dispose:()=>{E.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(t,l,b,v){if(typeof t=="string"){const E=new y(this.id,this.handle,t,l,b,v,this._extension,!1);return this._threads.set(E.handle,E),E}else{const E=new y(this.id,this.handle,void 0,t,l,b,this._extension,!1);return this._threads.set(E.handle,E),E}}$createCommentThreadTemplate(t,l){const b=new y(this.id,this.handle,void 0,I.URI.revive(t),A.Range.to(l),[],this._extension,!0);return b.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(b.handle,b),b}$updateCommentThreadTemplate(t,l){let b=this._threads.get(t);b&&(b.range=A.Range.to(l))}$deleteCommentThread(t){let l=this._threads.get(t);l&&l.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function D(n,t,l){let b=l.get(t);b||(b=++n.commentHandle,l.set(t,b));const v=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:b,body:typeof t.body=="string"?t.body:A.MarkdownString.from(t.body),userName:t.author.name,userIconPath:v,label:t.label,commentReactions:t.reactions?t.reactions.map(E=>r(E)):void 0,timestamp:t.timestamp?.toJSON()}}function r(n){return{label:n.label,iconPath:n.iconPath?A.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function h(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?I.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function i(n){if(n!==void 0)switch(n){case O.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function o(n){if(n!==void 0)switch(n){case O.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new k}e.createExtHostComments=_}),define(Ie[95],Te([1,0,2,4,6,3,16,14,15,10,19]),function(ee,e,s,C,g,U,I,P,w,A,O){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=S=class{constructor(f,u){this._logService=u,this._provider=new Map,this._proxy=f.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,u){const d=S._handlePool++;this._provider.set(d,{provider:f,extensionId:u}),this._proxy.$registerDecorationProvider(d,u.value);const c=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(k=>{if(!k){this._proxy.$onDidChange(d,null);return}let y=(0,w.asArray)(k);if(y.length<=S._maxEventSize){this._proxy.$onDidChange(d,y);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.value,y.length);const a=y.map(h=>({uri:h,rank:(0,A.count)(h.path,"/")})),D=(0,w.groupBy)(a,(h,i)=>h.rank-i.rank||(0,A.compare)(h.uri.path,i.uri.path));let r=[];e:for(let h of D){let i;for(let o of h){let n=(0,O.dirname)(o.uri.path);if(i!==n&&(i=n,r.push(o.uri)>=S._maxEventSize))break e}}this._proxy.$onDidChange(d,r)});return new g.Disposable(()=>{c?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(f,u,d){if(!this._provider.has(f))return Object.create(null);const c=Object.create(null),{provider:k,extensionId:y}=this._provider.get(f);return await Promise.all(u.map(async a=>{try{const{uri:D,id:r}=a,h=await Promise.resolve(k.provideFileDecoration(s.URI.revive(D),d));if(!h)return;try{g.FileDecoration.validate(h),c[r]=[h.propagate,h.tooltip,h.badge,h.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${y.value}': ${i}`)}}catch(D){this._logService.error(D)}})),c}};e.ExtHostDecorations=m,m._handlePool=0,m._maxEventSize=250,e.ExtHostDecorations=m=S=$e([We(0,I.IExtHostRpcService),We(1,P.ILogService)],m),e.IExtHostDecorations=(0,U.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,s,C,g){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?g.call(ee,s):g?g.value=s:e.set(ee,s),s},Re=this&&this.__classPrivateFieldGet||function(ee,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[190],Te([1,0,128,80,2,4,6,8,5,14,24,35]),function(ee,e,s,C,g,U,I,P,w,A,O,S){"use strict";var m,_,f,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(y,a,D,r,h,i){this._name=y,this._owner=a,this._maxDiagnosticsPerFile=D,m.set(this,void 0),_.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Ye(this,f,new O.ResourceMap(o=>r.getComparisonKey(o)),"f"),Ye(this,m,h,"f"),Ye(this,_,i,"f")}dispose(){this._isDisposed||(Re(this,_,"f").fire([...Re(this,f,"f").keys()]),Re(this,m,"f")&&Re(this,m,"f").$clear(this._owner),Re(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(y,a){if(!y){this.clear();return}this._checkDisposed();let D=[];if(g.URI.isUri(y)){if(!a){this.delete(y);return}Re(this,f,"f").set(y,a.slice()),D=[y]}else if(Array.isArray(y)){D=[];let h;y=[...y].sort(d._compareIndexedTuplesByUri);for(const i of y){const[o,n]=i;if((!h||o.toString()!==h.toString())&&(h&&Re(this,f,"f").get(h).length===0&&Re(this,f,"f").delete(h),h=o,D.push(o),Re(this,f,"f").set(o,[])),n){const t=Re(this,f,"f").get(o);t&&t.push(...n)}else{const t=Re(this,f,"f").get(o);t&&(t.length=0)}}}if(Re(this,_,"f").fire(D),!Re(this,m,"f"))return;const r=[];for(let h of D){let i=[];const o=Re(this,f,"f").get(h);if(o)if(o.length>this._maxDiagnosticsPerFile){i=[];const n=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let l of o)if(l.severity===n[t]&&i.push(P.Diagnostic.from(l))===this._maxDiagnosticsPerFile)break e;i.push({severity:C.MarkerSeverity.Info,message:(0,s.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=o.map(n=>P.Diagnostic.from(n));r.push([h,i])}Re(this,m,"f").$changeMany(this._owner,r)}delete(y){this._checkDisposed(),Re(this,_,"f").fire([y]),Re(this,f,"f").delete(y),Re(this,m,"f")&&Re(this,m,"f").$changeMany(this._owner,[[y,void 0]])}clear(){this._checkDisposed(),Re(this,_,"f").fire([...Re(this,f,"f").keys()]),Re(this,f,"f").clear(),Re(this,m,"f")&&Re(this,m,"f").$clear(this._owner)}forEach(y,a){this._checkDisposed();for(let D of Re(this,f,"f").keys())y.apply(a,[D,this.get(D),this])}get(y){this._checkDisposed();const a=Re(this,f,"f").get(y);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(y){return this._checkDisposed(),Array.isArray(Re(this,f,"f").get(y))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(y,a){return y[0].toString()<a[0].toString()?-1:y[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=d,m=new WeakMap,_=new WeakMap,f=new WeakMap;let c=u=class{static _mapper(y){const a=new O.ResourceMap;for(const D of y)a.set(D,D);return{uris:Object.freeze(Array.from(a.values()))}}constructor(y,a,D){this._logService=a,this._fileSystemInfoService=D,this._collections=new Map,this._onDidChangeDiagnostics=new w.DebounceEmitter({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this._onDidChangeDiagnostics.event,u._mapper),this._proxy=y.getProxy(U.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(y,a){const{_collections:D,_proxy:r,_onDidChangeDiagnostics:h,_logService:i,_fileSystemInfoService:o}=this,n=new class{$changeMany(b,v){r.$changeMany(b,v),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",y.value,b,v.length===0?"CLEARING":v)}$clear(b){r.$clear(b),i.trace("[DiagnosticCollection] remove all (extension, owner)",y.value,b)}dispose(){r.dispose()}};let t;if(!a)a="_generated_diagnostic_collection_name_#"+u._idPool++,t=a;else if(!D.has(a))t=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do t=a+u._idPool++;while(D.has(t))}return new class extends d{constructor(){super(a,t,u._maxDiagnosticsPerFile,o.extUri,n,h);D.set(t,this)}dispose(){super.dispose(),D.delete(t)}}}getDiagnostics(y){if(y)return this._getDiagnostics(y);{const a=new Map,D=[];for(const r of this._collections.values())r.forEach((h,i)=>{let o=a.get(h.toString());typeof o=="undefined"&&(o=D.length,a.set(h.toString(),o),D.push([h,[]])),D[o][1]=D[o][1].concat(...i)});return D}}_getDiagnostics(y){let a=[];for(let D of this._collections.values())D.has(y)&&(a=a.concat(D.get(y)));return a}$acceptMarkersChange(y){if(!this._mirrorCollection){const a="_generated_mirror",D=new d(a,a,u._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,D),this._mirrorCollection=D}for(const[a,D]of y)this._mirrorCollection.set(g.URI.revive(a),D.map(P.Diagnostic.to))}};e.ExtHostDiagnostics=c,c._idPool=0,c._maxDiagnosticsPerFile=1e3,e.ExtHostDiagnostics=c=u=$e([We(1,A.ILogService),We(2,S.IExtHostFileSystemInfo)],c)}),define(Ie[191],Te([1,0,2,4]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class g{constructor(I){this._proxy=I.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(I){return this._proxy.$showOpenDialog(I).then(P=>P?P.map(w=>s.URI.revive(w)):void 0)}showSaveDialog(I){return this._proxy.$showSaveDialog(I).then(P=>P?s.URI.revive(P):void 0)}}e.ExtHostDialogs=g}),define(Ie[192],Te([1,0,11,2,6,4,12,20,10]),function(ee,e,s,C,g,U,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(S,m,_){this._documentsAndEditors=m,this._logService=_,this._documentContentProviders=new Map,this._proxy=S.getProxy(U.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,m){if(Object.keys(I.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const _=A._handlePool++;this._documentContentProviders.set(_,m),this._proxy.$registerTextContentProvider(_,S);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(u=>{if(u.scheme!==S){this._logService.warn(`Provider for scheme '${S}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(_,u).then(d=>{if(!d&&typeof d!="string")return;const c=this._documentsAndEditors.getDocument(u);if(!c)return;const k=(0,w.splitLines)(d);if(!c.equalLines(k))return this._proxy.$onVirtualDocumentChange(u,d)},s.onUnexpectedError)})),new g.Disposable(()=>{this._documentContentProviders.delete(_)&&this._proxy.$unregisterTextContentProvider(_),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(S,m){const _=this._documentContentProviders.get(S);return _?Promise.resolve(_.provideTextDocumentContent(C.URI.revive(m),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(Ie[193],Te([1,0,5,7,2,4,87,8,9,27,6]),function(ee,e,s,C,g,U,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class S{constructor(_,f){this._onDidAddDocument=new s.Emitter,this._onDidRemoveDocument=new s.Emitter,this._onDidChangeDocument=new s.Emitter,this._onDidSaveDocument=new s.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new C.DisposableStore,this._documentLoader=new Map,this._proxy=_.getProxy(U.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const d of u)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const d of u)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(_){if(!_)return;const f=this._documentsAndEditors.getDocument(_);if(f)return f}getDocument(_){const f=this.getDocumentData(_);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${_}'`);return f.document}ensureDocumentData(_){const f=this._documentsAndEditors.getDocument(_);if(f)return Promise.resolve(f);let u=this._documentLoader.get(_.toString());return u||(u=this._proxy.$tryOpenDocument(_).then(d=>{this._documentLoader.delete(_.toString());const c=g.URI.revive(d);return(0,w.assertIsDefined)(this._documentsAndEditors.getDocument(c))},d=>(this._documentLoader.delete(_.toString()),Promise.reject(d))),this._documentLoader.set(_.toString(),u)),u}createDocumentData(_){return this._proxy.$tryCreateDocument(_).then(f=>g.URI.revive(f))}$acceptModelLanguageChanged(_,f){const u=g.URI.revive(_),d=this._documentsAndEditors.getDocument(u);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(f),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(_){const f=g.URI.revive(_),u=this._documentsAndEditors.getDocument(f);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(_,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(_,f){const u=g.URI.revive(_),d=this._documentsAndEditors.getDocument(u);if(!d)throw new Error("unknown document");d._acceptIsDirty(f),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(_,f,u){const d=g.URI.revive(_),c=this._documentsAndEditors.getDocument(d);if(!c)throw new Error("unknown document");c._acceptIsDirty(u),c.onEvents(f);let k;f.isUndoing?k=O.TextDocumentChangeReason.Undo:f.isRedoing&&(k=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:c.document,contentChanges:f.changes.map(y=>({range:P.Range.to(y.range),rangeOffset:y.rangeOffset,rangeLength:y.rangeLength,text:y.text})),reason:k}))}setWordDefinitionFor(_,f){(0,I.setWordDefinitionFor)(_,f)}}e.ExtHostDocuments=S}),define(Ie[50],Te([1,0,42,5,7,2,3,4,87,16,93,8,14,24,12,167,194]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class c{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let k=class{constructor(a,D){this._extHostRpc=a,this._logService=D,this._activeEditorId=null,this._editors=new Map,this._documents=new _.ResourceMap,this._onDidAddDocuments=new C.Emitter,this._onDidRemoveDocuments=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const D=[],r=[],h=[];if(a.removedDocuments)for(const i of a.removedDocuments){const o=U.URI.revive(i),n=this._documents.get(o);n?.unref()&&(this._documents.delete(o),D.push(n.value))}if(a.addedDocuments)for(const i of a.addedDocuments){const o=U.URI.revive(i.uri);let n=this._documents.get(o);if(n&&o.scheme!==f.Schemas.vscodeNotebookCell&&o.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);n||(n=new c(new w.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),o,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(o,n),r.push(n.value)),n.ref()}if(a.removedEditors)for(const i of a.removedEditors){const o=this._editors.get(i);this._editors.delete(i),o&&h.push(o)}if(a.addedEditors)for(const i of a.addedEditors){const o=U.URI.revive(i.documentUri);s.ok(this._documents.has(o),`document '${o}' does not exist`),s.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const n=this._documents.get(o).value,t=new O.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>n.document),i.selections.map(S.Selection.to),i.options,i.visibleRanges.map(l=>S.Range.to(l)),typeof i.editorPosition=="number"?S.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,t)}a.newActiveEditor!==void 0&&(s.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,g.dispose)(D),(0,g.dispose)(h),a.removedDocuments&&this._onDidRemoveDocuments.fire(D),a.addedDocuments&&this._onDidAddDocuments.fire(r),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const D=this._editors.get(this._activeEditorId);return a?D:D?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=k,e.ExtHostDocumentsAndEditors=k=$e([We(0,A.IExtHostRpcService),We(1,m.ILogService)],k),e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[51],Te([1,0,8,4,2,5,3,6,16,9,43]),function(ee,e,s,C,g,U,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class S{constructor(d,c,k){this._activeTabIdGetter=k,this._parentGroup=c,this.acceptDtoUpdate(d)}get apiObject(){if(!this._apiObject){const d=this,c={get isActive(){return d._dto.id===d._activeTabIdGetter()},get label(){return d._dto.label},get input(){return d._input},get isDirty(){return d._dto.isDirty},get isPinned(){return d._dto.isPinned},get isPreview(){return d._dto.isPreview},get group(){return d._parentGroup.apiObject}};this._apiObject=Object.freeze(c)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(d){this._dto=d,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new P.TextTabInput(g.URI.revive(this._dto.input.uri));case 2:return new P.TextDiffTabInput(g.URI.revive(this._dto.input.original),g.URI.revive(this._dto.input.modified));case 5:return new P.CustomEditorTabInput(g.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 6:return new P.WebviewEditorTabInput(this._dto.input.viewType);case 3:return new P.NotebookEditorTabInput(g.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 4:return new P.NotebookDiffEditorTabInput(g.URI.revive(this._dto.input.original),g.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 7:return new P.TerminalEditorTabInput;default:return}}}class m{constructor(d,c,k){this._tabs=[],this._activeTabId="",this._dto=d,this._activeGroupIdGetter=k;for(const y of d.tabs)y.isActive&&(this._activeTabId=y.id),this._tabs.push(new S(y,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const d=this,c={get isActive(){return d._dto.groupId===d._activeGroupIdGetter()},get viewColumn(){return s.ViewColumn.to(d._dto.viewColumn)},get activeTab(){return d._tabs.find(k=>k.tabId===d._activeTabId)?.apiObject},get tabs(){return Object.freeze(d._tabs.map(k=>k.apiObject))}};this._apiObject=Object.freeze(c)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(d){this._dto=d}acceptTabOperation(d){if(d.kind===0){const k=new S(d.tabDto,this,()=>this.activeTabId());return this._tabs.splice(d.index,0,k),d.tabDto.isActive&&(this._activeTabId=k.tabId),k}else if(d.kind===1){const k=this._tabs.splice(d.index,1)[0];if(!k)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return k.tabId===this._activeTabId&&(this._activeTabId=""),k}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const k=this._tabs.splice(d.oldIndex,1)[0];if(!k)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this._tabs.splice(d.index,0,k),k}const c=this._tabs.find(k=>k.tabId===d.tabDto.id);if(!c)throw new Error("INVALID tab");return d.tabDto.isActive?this._activeTabId=d.tabDto.id:this._activeTabId===d.tabDto.id&&!d.tabDto.isActive&&(this._activeTabId=""),c.acceptDtoUpdate(d.tabDto),c}activeTabId(){return this._activeTabId}}let _=class{constructor(d){this._onDidChangeTabs=new U.Emitter,this._onDidChangeTabGroups=new U.Emitter,this._extHostTabGroups=[],this._proxy=d.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const d=this,c={onDidChangeTabGroups:d._onDidChangeTabGroups.event,onDidChangeTabs:d._onDidChangeTabs.event,get all(){return Object.freeze(d._extHostTabGroups.map(k=>k.apiObject))},get activeTabGroup(){const k=d._activeGroupId;return(0,A.assertIsDefined)(d._extHostTabGroups.find(a=>a.groupId===k)?.apiObject)},close:async(k,y)=>{const a=Array.isArray(k)?k:[k];return a.length?f(a[0])?this._closeGroups(a,y):this._closeTabs(a,y):!0}};this._apiObject=Object.freeze(c)}return this._apiObject}$acceptEditorTabModel(d){const c=new Set(this._extHostTabGroups.map(i=>i.groupId)),k=new Set(d.map(i=>i.groupId)),y=(0,O.diffSets)(c,k),a=this._extHostTabGroups.filter(i=>y.removed.includes(i.groupId)).map(i=>i.apiObject),D=[],r=[];this._extHostTabGroups=d.map(i=>{const o=new m(i,this._proxy,()=>this._activeGroupId);return y.added.includes(o.groupId)?D.push(o.apiObject):r.push(o.apiObject),o});const h=(0,A.assertIsDefined)(d.find(i=>i.isActive===!0)?.groupId);h!==void 0&&this._activeGroupId!==h&&(this._activeGroupId=h),this._onDidChangeTabGroups.fire(Object.freeze({opened:D,closed:a,changed:r}))}$acceptTabGroupUpdate(d){const c=this._extHostTabGroups.find(k=>k.groupId===d.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(d),d.isActive&&(this._activeGroupId=d.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const c=this._extHostTabGroups.find(y=>y.groupId===d.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const k=c.acceptTabOperation(d);switch(d.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[k.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[k.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[k.apiObject]}));return}}_findExtHostTabFromApi(d){for(const c of this._extHostTabGroups)for(const k of c.tabs)if(k.apiObject===d)return k}_findExtHostTabGroupFromApi(d){return this._extHostTabGroups.find(c=>c.apiObject===d)}async _closeTabs(d,c){const k=[];for(const y of d){const a=this._findExtHostTabFromApi(y);if(!a)throw new Error("Tab close: Invalid tab not found!");k.push(a.tabId)}return this._proxy.$closeTab(k,c)}async _closeGroups(d,c){const k=[];for(const y of d){const a=this._findExtHostTabGroupFromApi(y);if(!a)throw new Error("Group close: Invalid group not found!");k.push(a.groupId)}return this._proxy.$closeGroup(k,c)}};e.ExtHostEditorTabs=_,e.ExtHostEditorTabs=_=$e([We(0,w.IExtHostRpcService)],_);function f(u){return u.tabs!==void 0}}),define(Ie[195],Te([1,0,2,4,7,6,8,240,10,23,26]),function(ee,e,s,C,g,U,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class S{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const u=this._schemes.indexOf(f);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),u=[];let d,c,k=14,y=14;for(const a of f){let D=d?(0,w.commonPrefixLength)(d,a):0;for(D===0?c=1:c=y;D<a.length;D++)D+1===a.length?(k=y,y=9):y+=1,u.push([c,a.toUpperCase().charCodeAt(D),y]),u.push([c,a.toLowerCase().charCodeAt(D),y]),c=y;d=a,y=k}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new P.StateMachine(u)}}provideDocumentLinks(f){this._initStateMachine();const u=[],d=P.LinkComputer.computeLinks({getLineContent(c){return f.lineAt(c-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const c of d){const k=I.DocumentLink.to(c);k.target&&u.push(k)}return u}}class m{constructor(f,u){this._extHostLanguageFeatures=u,this._linkProvider=new S,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,u,d,c={}){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const k=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(k,d);let y=2;c.isCaseSensitive&&(y+=1024),c.isReadonly&&(y+=2048),typeof d.copy=="function"&&(y+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,O.checkProposedApiEnabled)(f,"fsChunks"),y+=4),this._proxy.$registerFileSystemProvider(k,u,y).catch(D=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${u}`),console.error(D)});const a=d.onDidChangeFile(D=>{const r=[];for(const h of D){let{uri:i,type:o}=h;if(i.scheme!==u)continue;let n;switch(o){case U.FileChangeType.Changed:n=0;break;case U.FileChangeType.Created:n=1;break;case U.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:i,type:n})}this._proxy.$onFileSystemChange(k,r)});return(0,g.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(k),this._proxy.$unregisterProvider(k)})}static _asIStat(f){const{type:u,ctime:d,mtime:c,size:k,permissions:y}=f;return{type:u,ctime:d,mtime:c,size:k,permissions:y}}$stat(f,u){return Promise.resolve(this._getFsProvider(f).stat(s.URI.revive(u))).then(d=>m._asIStat(d))}$readdir(f,u){return Promise.resolve(this._getFsProvider(f).readDirectory(s.URI.revive(u)))}$readFile(f,u){return Promise.resolve(this._getFsProvider(f).readFile(s.URI.revive(u))).then(d=>A.VSBuffer.wrap(d))}$writeFile(f,u,d,c){return Promise.resolve(this._getFsProvider(f).writeFile(s.URI.revive(u),d.buffer,c))}$delete(f,u,d){return Promise.resolve(this._getFsProvider(f).delete(s.URI.revive(u),d))}$rename(f,u,d,c){return Promise.resolve(this._getFsProvider(f).rename(s.URI.revive(u),s.URI.revive(d),c))}$copy(f,u,d,c){const k=this._getFsProvider(f);if(!k.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(k.copy(s.URI.revive(u),s.URI.revive(d),c))}$mkdir(f,u){return Promise.resolve(this._getFsProvider(f).createDirectory(s.URI.revive(u)))}$watch(f,u,d,c){const k=this._getFsProvider(f).watch(s.URI.revive(d),c);this._watches.set(u,k)}$unwatch(f,u){const d=this._watches.get(u);d&&(d.dispose(),this._watches.delete(u))}$open(f,u,d){const c=this._getFsProvider(f);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(s.URI.revive(u),d))}$close(f,u){const d=this._getFsProvider(f);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(u))}$read(f,u,d,c){const k=this._getFsProvider(f);if(!k.read)throw new Error('FileSystemProvider does not implement "read"');const y=A.VSBuffer.alloc(c);return Promise.resolve(k.read(u,d,y.buffer,0,c)).then(a=>y.slice(0,a))}$write(f,u,d,c){const k=this._getFsProvider(f);if(!k.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(k.write(u,d,c.buffer,0,c.byteLength))}_getFsProvider(f){const u=this._fsProvider.get(f);if(!u){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return u}}e.ExtHostFileSystem=m}),define(Ie[52],Te([1,0,4,39,6,23,3,16,35,7]),function(ee,e,s,C,g,U,I,P,w,A){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let S=O=class{constructor(_,f){this._fileSystemProvider=new Map,this._proxy=_.getProxy(s.MainContext.MainThreadFileSystem);const u=this;this.value=Object.freeze({async stat(d){try{const c=u._fileSystemProvider.get(d.scheme);if(!c)return await u._proxy.$stat(d);await u._proxy.$ensureActivation(d.scheme);const k=await c.stat(d);return{type:k.type,ctime:k.ctime,mtime:k.mtime,size:k.size,permissions:k.permissions}}catch(c){O._handleError(c)}},async readDirectory(d){try{const c=u._fileSystemProvider.get(d.scheme);return c?(await u._proxy.$ensureActivation(d.scheme),(await c.readDirectory(d)).slice()):await u._proxy.$readdir(d)}catch(c){return O._handleError(c)}},async createDirectory(d){try{return await u._proxy.$mkdir(d)}catch(c){return O._handleError(c)}},async readFile(d){try{const c=u._fileSystemProvider.get(d.scheme);return c?(await u._proxy.$ensureActivation(d.scheme),(await c.readFile(d)).slice()):(await u._proxy.$readFile(d)).buffer}catch(c){return O._handleError(c)}},async writeFile(d,c){try{return await u._proxy.$writeFile(d,U.VSBuffer.wrap(c))}catch(k){return O._handleError(k)}},async delete(d,c){try{const k=u._fileSystemProvider.get(d.scheme);return k?(await u._proxy.$ensureActivation(d.scheme),await k.delete(d,{recursive:!1,...c})):await u._proxy.$delete(d,{recursive:!1,useTrash:!1,...c})}catch(k){return O._handleError(k)}},async rename(d,c,k){try{return await u._proxy.$rename(d,c,{overwrite:!1,...k})}catch(y){return O._handleError(y)}},async copy(d,c,k){try{return await u._proxy.$copy(d,c,{overwrite:!1,...k})}catch(y){return O._handleError(y)}},isWritableFileSystem(d){const c=f.getCapabilities(d);if(typeof c=="number")return!(c&2048)}})}static _handleError(_){if(_ instanceof g.FileSystemError)throw _;if(!(_ instanceof Error))throw new g.FileSystemError(String(_));if(_.name==="ENOPRO")throw g.FileSystemError.Unavailable(_.message);switch(_.name){case C.FileSystemProviderErrorCode.FileExists:throw g.FileSystemError.FileExists(_.message);case C.FileSystemProviderErrorCode.FileNotFound:throw g.FileSystemError.FileNotFound(_.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw g.FileSystemError.FileNotADirectory(_.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw g.FileSystemError.FileIsADirectory(_.message);case C.FileSystemProviderErrorCode.NoPermissions:throw g.FileSystemError.NoPermissions(_.message);case C.FileSystemProviderErrorCode.Unavailable:throw g.FileSystemError.Unavailable(_.message);default:throw new g.FileSystemError(_.message,_.name)}}addFileSystemProvider(_,f){return this._fileSystemProvider.set(_,f),(0,A.toDisposable)(()=>this._fileSystemProvider.delete(_))}};e.ExtHostConsumerFileSystem=S,e.ExtHostConsumerFileSystem=S=O=$e([We(0,P.IExtHostRpcService),We(1,w.IExtHostFileSystemInfo)],S),e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[196],Te([1,0,5,34,2,4,8,6]),function(ee,e,s,C,g,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(S,m,_,f,u,d,c,k){this._onDidCreate=new s.Emitter,this._onDidChange=new s.Emitter,this._onDidDelete=new s.Emitter;const y=this.ensureWatching(S,_,u);this._config=0,d&&(this._config+=1),c&&(this._config+=2),k&&(this._config+=4);const a=(0,C.parse)(u),D=typeof u=="string",r=f(h=>{if(!d)for(let i of h.created){const o=g.URI.revive(i);a(o.fsPath)&&(!D||m.getWorkspaceFolder(o))&&this._onDidCreate.fire(o)}if(!c)for(let i of h.changed){const o=g.URI.revive(i);a(o.fsPath)&&(!D||m.getWorkspaceFolder(o))&&this._onDidChange.fire(o)}if(!k)for(let i of h.deleted){const o=g.URI.revive(i);a(o.fsPath)&&(!D||m.getWorkspaceFolder(o))&&this._onDidDelete.fire(o)}});this._disposable=P.Disposable.from(y,this._onDidCreate,this._onDidChange,this._onDidDelete,r)}ensureWatching(S,m,_){let f=P.Disposable.from();if(typeof _=="string")return f;const u=S.getProxy(U.MainContext.MainThreadFileSystem);let d=!1;(_.pattern.includes(C.GLOBSTAR)||_.pattern.includes(C.GLOB_SPLIT))&&(d=!0);const c=Math.random();return u.$watch(m.identifier.value,c,_.baseUri,{recursive:d,excludes:[]}),P.Disposable.from({dispose:()=>u.$unwatch(c)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class A{constructor(S,m,_){this._mainContext=S,this._logService=m,this._extHostDocumentsAndEditors=_,this._onFileSystemEvent=new s.Emitter,this._onDidRenameFile=new s.Emitter,this._onDidCreateFile=new s.Emitter,this._onDidDeleteFile=new s.Emitter,this._onWillRenameFile=new s.AsyncEmitter,this._onWillCreateFile=new s.AsyncEmitter,this._onWillDeleteFile=new s.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(S,m,_,f,u,d){return new w(this._mainContext,S,m,this._onFileSystemEvent.event,I.GlobPattern.from(_),f,u,d)}$onFileEvent(S){this._onFileSystemEvent.fire(S)}$onDidRunFileOperation(S,m){switch(S){case 2:this._onDidRenameFile.fire(Object.freeze({files:m.map(_=>({oldUri:g.URI.revive(_.source),newUri:g.URI.revive(_.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:m.map(_=>g.URI.revive(_.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:m.map(_=>g.URI.revive(_.target))}));break;default:}}getOnWillRenameFileEvent(S){return this._createWillExecuteEvent(S,this._onWillRenameFile)}getOnWillCreateFileEvent(S){return this._createWillExecuteEvent(S,this._onWillCreateFile)}getOnWillDeleteFileEvent(S){return this._createWillExecuteEvent(S,this._onWillDeleteFile)}_createWillExecuteEvent(S,m){return(_,f,u)=>{const d=function(k){_.call(f,k)};return d.extension=S,m.event(d,void 0,u)}}async $onWillRunFileOperation(S,m,_,f){switch(S){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:m.map(u=>({oldUri:g.URI.revive(u.source),newUri:g.URI.revive(u.target)}))},_,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:m.map(u=>g.URI.revive(u.target))},_,f);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:m.map(u=>g.URI.revive(u.target))},_,f)}}async _fireWillEvent(S,m,_,f){const u=new Set,d=[];if(await S.fireAsync(m,f,async(k,y)=>{const a=Date.now(),D=await Promise.resolve(k);D instanceof P.WorkspaceEdit&&(d.push(D),u.add(y.extension.displayName??y.extension.identifier.value)),Date.now()-a>_&&this._logService.warn("SLOW file-participant",y.extension.identifier)}),f.isCancellationRequested||d.length===0)return;const c={edits:[]};for(let k of d){let{edits:y}=I.WorkspaceEdit.from(k,{getTextDocumentVersion:a=>this._extHostDocumentsAndEditors.getDocument(a)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(y)}return{edit:c,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=A}),define(Ie[197],Te([1,0,2,36]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class g{constructor(I,P,w,A){this._extHostNotebooks=P,this._textDocumentsAndEditors=w,this._commands=A;const O=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",S=>!0,S=>S),new C.ApiCommandArgument("resource","Interactive resource Uri",S=>!0,S=>S),new C.ApiCommandArgument("controllerId","Notebook controller Id",S=>!0,S=>S),new C.ApiCommandArgument("title","Interactive editor title",S=>!0,S=>S)],new C.ApiCommandResult("Notebook and input URI",S=>{if(S.notebookEditorId!==void 0){const m=this._extHostNotebooks.getEditorById(S.notebookEditorId);return{notebookUri:s.URI.revive(S.notebookUri),inputUri:s.URI.revive(S.inputUri),notebookEditor:m.apiEditor}}return{notebookUri:s.URI.revive(S.notebookUri),inputUri:s.URI.revive(S.inputUri)}}));this._commands.registerApiCommand(O)}$willAddInteractiveDocument(I,P,w,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:w,uri:I,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(s.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=g}),define(Ie[198],Te([1,0,7,4]),function(ee,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class g{constructor(I){this._handlePool=0,this._proxy=I.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,I),(0,s.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=g}),define(Ie[199],Te([1,0,2,27,8,6,68,4,10,49,15,9,241,20,7,77,56,63,200,11,13,26]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d,c,k,y,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class r{constructor(T,B){this._documents=T,this._provider=B}async provideDocumentSymbols(T,B){const H=this._documents.getDocument(T),V=await this._provider.provideDocumentSymbols(H,B);if(!(0,O.isFalsyOrEmpty)(V))return V[0]instanceof U.DocumentSymbol?V.map(g.DocumentSymbol.from):r._asDocumentSymbolTree(V)}static _asDocumentSymbolTree(T){T=T.slice(0).sort((V,ne)=>{let ue=V.location.range.start.compareTo(ne.location.range.start);return ue===0&&(ue=ne.location.range.end.compareTo(V.location.range.end)),ue});const B=[],H=[];for(const V of T){const ne={name:V.name||"!!MISSING: name!!",kind:g.SymbolKind.from(V.kind),tags:V.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:g.Range.from(V.location.range),selectionRange:g.Range.from(V.location.range),children:[]};for(;;){if(H.length===0){H.push(ne),B.push(ne);break}const ue=H[H.length-1];if(A.Range.containsRange(ue.range,ne.range)&&!A.Range.equalsRange(ue.range,ne.range)){ue.children&&ue.children.push(ne),H.push(ne);break}H.pop()}}return B}}class h{constructor(T,B,H){this._documents=T,this._commands=B,this._provider=H,this._cache=new c.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(T,B){const H=this._documents.getDocument(T),V=await this._provider.provideCodeLenses(H,B);if(!V||B.isCancellationRequested)return;const ne=this._cache.add(V),ue=new f.DisposableStore;this._disposables.set(ne,ue);const Q={cacheId:ne,lenses:[]};for(let ge=0;ge<V.length;ge++)Q.lenses.push({cacheId:[ne,ge],range:g.Range.from(V[ge].range),command:this._commands.toInternal(V[ge].command,ue)});return Q}async resolveCodeLens(T,B){const H=T.cacheId&&this._cache.get(...T.cacheId);if(!H)return;let V;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?V=H:V=await this._provider.resolveCodeLens(H,B),V||(V=H),B.isCancellationRequested)return;const ne=T.cacheId&&this._disposables.get(T.cacheId[0]);if(!!ne)return T.command=this._commands.toInternal(V.command??h._badCmd,ne),T}releaseCodeLenses(T){this._disposables.get(T)?.dispose(),this._disposables.delete(T),this._cache.delete(T)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function i(G){return Array.isArray(G)?G.map(g.DefinitionLink.from):G?[g.DefinitionLink.from(G)]:[]}class o{constructor(T,B){this._documents=T,this._provider=B}async provideDefinition(T,B,H){const V=this._documents.getDocument(T),ne=g.Position.to(B),ue=await this._provider.provideDefinition(V,ne,H);return i(ue)}}class n{constructor(T,B){this._documents=T,this._provider=B}async provideDeclaration(T,B,H){const V=this._documents.getDocument(T),ne=g.Position.to(B),ue=await this._provider.provideDeclaration(V,ne,H);return i(ue)}}class t{constructor(T,B){this._documents=T,this._provider=B}async provideImplementation(T,B,H){const V=this._documents.getDocument(T),ne=g.Position.to(B),ue=await this._provider.provideImplementation(V,ne,H);return i(ue)}}class l{constructor(T,B){this._documents=T,this._provider=B}async provideTypeDefinition(T,B,H){const V=this._documents.getDocument(T),ne=g.Position.to(B),ue=await this._provider.provideTypeDefinition(V,ne,H);return i(ue)}}class b{constructor(T,B){this._documents=T,this._provider=B}async provideHover(T,B,H){const V=this._documents.getDocument(T),ne=g.Position.to(B),ue=await this._provider.provideHover(V,ne,H);if(!(!ue||(0,O.isFalsyOrEmpty)(ue.contents)))return ue.range||(ue.range=V.getWordRangeAtPosition(ne)),ue.range||(ue.range=new U.Range(ne,ne)),g.Hover.from(ue)}}class v{constructor(T,B){this._documents=T,this._provider=B}async provideEvaluatableExpression(T,B,H){const V=this._documents.getDocument(T),ne=g.Position.to(B),ue=await this._provider.provideEvaluatableExpression(V,ne,H);if(ue)return g.EvaluatableExpression.from(ue)}}class E{constructor(T,B){this._documents=T,this._provider=B}async provideInlineValues(T,B,H,V){const ne=this._documents.getDocument(T),ue=await this._provider.provideInlineValues(ne,g.Range.to(B),g.InlineValueContext.to(H),V);if(Array.isArray(ue))return ue.map(Q=>g.InlineValue.from(Q))}}class x{constructor(T,B){this._documents=T,this._provider=B}async provideDocumentHighlights(T,B,H){const V=this._documents.getDocument(T),ne=g.Position.to(B),ue=await this._provider.provideDocumentHighlights(V,ne,H);if(Array.isArray(ue))return ue.map(g.DocumentHighlight.from)}}class ${constructor(T,B){this._documents=T,this._provider=B}async provideLinkedEditingRanges(T,B,H){const V=this._documents.getDocument(T),ne=g.Position.to(B),ue=await this._provider.provideLinkedEditingRanges(V,ne,H);if(ue&&Array.isArray(ue.ranges))return{ranges:(0,O.coalesce)(ue.ranges.map(g.Range.from)),wordPattern:ue.wordPattern}}}class R{constructor(T,B){this._documents=T,this._provider=B}async provideReferences(T,B,H,V){const ne=this._documents.getDocument(T),ue=g.Position.to(B),Q=await this._provider.provideReferences(ne,ue,H,V);if(Array.isArray(Q))return Q.map(g.location.from)}}class p{constructor(T,B,H,V,ne,ue,Q){this._documents=T,this._commands=B,this._diagnostics=H,this._provider=V,this._logService=ne,this._extension=ue,this._apiDeprecation=Q,this._cache=new c.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(T,B,H,V){const ne=this._documents.getDocument(T),ue=m.Selection.isISelection(B)?g.Selection.to(B):g.Range.to(B),Q=[];for(const Ke of this._diagnostics.getDiagnostics(T))if(ue.intersection(Ke.range)&&Q.push(Ke)>p._maxCodeActionsPerFile)break;const ge={diagnostics:Q,only:H.only?new U.CodeActionKind(H.only):void 0,triggerKind:g.CodeActionTriggerKind.to(H.trigger)},pe=await this._provider.provideCodeActions(ne,ue,ge,V);if(!(0,O.isNonEmptyArray)(pe)||V.isCancellationRequested)return;const Ne=this._cache.add(pe),Be=new f.DisposableStore;this._disposables.set(Ne,Be);const Ae=[];for(let Ke=0;Ke<pe.length;Ke++){const q=pe[Ke];!q||(p._isCommand(q)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ae.push({_isSynthetic:!0,title:q.title,command:this._commands.toInternal(q,Be)})):(ge.only&&(q.kind?ge.only.contains(q.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${q.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ae.push({cacheId:[Ne,Ke],title:q.title,command:q.command&&this._commands.toInternal(q.command,Be),diagnostics:q.diagnostics&&q.diagnostics.map(g.Diagnostic.from),edit:q.edit&&g.WorkspaceEdit.from(q.edit),kind:q.kind&&q.kind.value,isPreferred:q.isPreferred,disabled:q.disabled?.reason})))}return{cacheId:Ne,actions:Ae}}async resolveCodeAction(T,B){const[H,V]=T,ne=this._cache.get(H,V);if(!ne||p._isCommand(ne)||!this._provider.resolveCodeAction)return;const ue=await this._provider.resolveCodeAction(ne,B)??ne;return ue?.edit?g.WorkspaceEdit.from(ue.edit):void 0}releaseCodeActions(T){this._disposables.get(T)?.dispose(),this._disposables.delete(T),this._cache.delete(T)}static _isCommand(T){return typeof T.command=="string"&&typeof T.title=="string"}}p._maxCodeActionsPerFile=1e3;class F{constructor(T,B,H,V){this._proxy=T,this._documents=B,this._provider=H,this._handle=V}async prepareDocumentPaste(T,B,H,V){if(!this._provider.prepareDocumentPaste)return;const ne=this._documents.getDocument(T),ue=g.Range.to(B),Q=g.DataTransfer.toDataTransfer(H,()=>{throw new y.NotImplementedError});return await this._provider.prepareDocumentPaste(ne,ue,Q,V),g.DataTransfer.toDataTransferDTO(Q)}async providePasteEdits(T,B,H,V,ne){const ue=this._documents.getDocument(B),Q=g.Range.to(H),ge=g.DataTransfer.toDataTransfer(V,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,T,Ne)).buffer),pe=await this._provider.provideDocumentPasteEdits(ue,Q,ge,ne);if(!!pe)return pe instanceof U.WorkspaceEdit?g.WorkspaceEdit.from(pe):g.SnippetTextEdit.from(pe)}}class M{constructor(T,B){this._documents=T,this._provider=B}async provideDocumentFormattingEdits(T,B,H){const V=this._documents.getDocument(T),ne=await this._provider.provideDocumentFormattingEdits(V,B,H);if(Array.isArray(ne))return ne.map(g.TextEdit.from)}}class z{constructor(T,B){this._documents=T,this._provider=B}async provideDocumentRangeFormattingEdits(T,B,H,V){const ne=this._documents.getDocument(T),ue=g.Range.to(B),Q=await this._provider.provideDocumentRangeFormattingEdits(ne,ue,H,V);if(Array.isArray(Q))return Q.map(g.TextEdit.from)}}class Z{constructor(T,B){this._documents=T,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,B,H,V,ne){const ue=this._documents.getDocument(T),Q=g.Position.to(B),ge=await this._provider.provideOnTypeFormattingEdits(ue,Q,H,V,ne);if(Array.isArray(ge))return ge.map(g.TextEdit.from)}}class K{constructor(T,B){this._provider=T,this._logService=B,this._cache=new c.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(T,B){const H=await this._provider.provideWorkspaceSymbols(T,B);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const V=this._cache.add(H),ne={cacheId:V,symbols:[]};for(let ue=0;ue<H.length;ue++){const Q=H[ue];if(!Q||!Q.name){this._logService.warn("INVALID SymbolInformation",Q);continue}ne.symbols.push({...g.WorkspaceSymbol.from(Q),cacheId:[V,ue]})}return ne}async resolveWorkspaceSymbol(T,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const H=this._cache.get(...T.cacheId);if(H){const V=await this._provider.resolveWorkspaceSymbol(H,B);return V&&(0,C.mixin)(T,g.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(T){this._cache.delete(T)}}class N{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,B,H){this._documents=T,this._provider=B,this._logService=H}async provideRenameEdits(T,B,H,V){const ne=this._documents.getDocument(T),ue=g.Position.to(B);try{const Q=await this._provider.provideRenameEdits(ne,ue,H,V);return Q?g.WorkspaceEdit.from(Q):void 0}catch(Q){const ge=N._asMessage(Q);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Q)}}async resolveRenameLocation(T,B,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const V=this._documents.getDocument(T),ne=g.Position.to(B);try{const ue=await this._provider.prepareRename(V,ne,H);let Q,ge;if(U.Range.isRange(ue)?(Q=ue,ge=V.getText(ue)):(0,S.isObject)(ue)&&(Q=ue.range,ge=ue.placeholder),!Q||!ge)return;if(Q.start.line>ne.line||Q.end.line<ne.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(Q),text:ge}}catch(ue){const Q=N._asMessage(ue);return Q?{rejectReason:Q,range:void 0,text:void 0}:Promise.reject(ue)}}static _asMessage(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class se{constructor(T,B){this.resultId=T,this.tokens=B}}class le{constructor(T,B){this._documents=T,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(T,B,H){const V=this._documents.getDocument(T),ne=B!==0?this._previousResults.get(B):null;let ue=typeof ne?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(V,ne.resultId,H):await this._provider.provideDocumentSemanticTokens(V,H);return ne&&this._previousResults.delete(B),ue?(ue=le._fixProvidedSemanticTokens(ue),this._send(le._convertToEdits(ne,ue),ue)):null}async releaseDocumentSemanticColoring(T){this._previousResults.delete(T)}static _fixProvidedSemanticTokens(T){return le._isSemanticTokens(T)?le._isCorrectSemanticTokens(T)?T:new U.SemanticTokens(new Uint32Array(T.data),T.resultId):le._isSemanticTokensEdits(T)?le._isCorrectSemanticTokensEdits(T)?T:new U.SemanticTokensEdits(T.edits.map(B=>new U.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),T.resultId):T}static _isSemanticTokens(T){return T&&!!T.data}static _isCorrectSemanticTokens(T){return T.data instanceof Uint32Array}static _isSemanticTokensEdits(T){return T&&Array.isArray(T.edits)}static _isCorrectSemanticTokensEdits(T){for(const B of T.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(T,B){if(!le._isSemanticTokens(B)||!T||!T.tokens)return B;const H=T.tokens,V=H.length,ne=B.data,ue=ne.length;let Q=0;const ge=Math.min(V,ue);for(;Q<ge&&H[Q]===ne[Q];)Q++;if(Q===V&&Q===ue)return new U.SemanticTokensEdits([],B.resultId);let pe=0;const Ne=ge-Q;for(;pe<Ne&&H[V-pe-1]===ne[ue-pe-1];)pe++;return new U.SemanticTokensEdits([{start:Q,deleteCount:V-Q-pe,data:ne.subarray(Q,ue-pe)}],B.resultId)}_send(T,B){if(le._isSemanticTokens(T)){const H=this._nextResultId++;return this._previousResults.set(H,new se(T.resultId,T.data)),(0,u.encodeSemanticTokensDto)({id:H,type:"full",data:T.data})}if(le._isSemanticTokensEdits(T)){const H=this._nextResultId++;return le._isSemanticTokens(B)?this._previousResults.set(H,new se(B.resultId,B.data)):this._previousResults.set(H,new se(T.resultId)),(0,u.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(T.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}e.DocumentSemanticTokensAdapter=le;class oe{constructor(T,B){this._documents=T,this._provider=B}async provideDocumentRangeSemanticTokens(T,B,H){const V=this._documents.getDocument(T),ne=await this._provider.provideDocumentRangeSemanticTokens(V,g.Range.to(B),H);return ne?this._send(ne):null}_send(T){return(0,u.encodeSemanticTokensDto)({id:0,type:"full",data:T.data})}}e.DocumentRangeSemanticTokensAdapter=oe;class fe{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,B,H,V,ne){this._documents=T,this._commands=B,this._provider=H,this._apiDeprecation=V,this._extension=ne,this._cache=new c.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(T,B,H,V){const ne=this._documents.getDocument(T),ue=g.Position.to(B),Q=ne.getWordRangeAtPosition(ue)||new U.Range(ue,ue),ge=Q.with({end:ue}),pe=new k.StopWatch(!0),Ne=await this._provider.provideCompletionItems(ne,ue,V,g.CompletionContext.to(H));if(!Ne||V.isCancellationRequested)return;const Be=Array.isArray(Ne)?new U.CompletionList(Ne):Ne,Ae=fe.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),Ke=new f.DisposableStore;this._disposables.set(Ae,Ke);const q=[],Y={x:Ae,b:q,a:{replace:g.Range.from(Q),insert:g.Range.from(ge)},c:Be.isIncomplete||void 0,d:pe.elapsed()};for(let me=0;me<Be.items.length;me++){const Le=Be.items[me],ze=this._convertCompletionItem(Le,[Ae,me],ge,Q);q.push(ze)}return Y}async resolveCompletionItem(T,B){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...T);if(!H)return;const V=await this._provider.resolveCompletionItem(H,B);if(!!V)return this._convertCompletionItem(V,T)}releaseCompletionItems(T){this._disposables.get(T)?.dispose(),this._disposables.delete(T),this._cache.delete(T)}_convertCompletionItem(T,B,H,V){const ne=this._disposables.get(B[0]);if(!ne)throw Error("DisposableStore is missing...");const ue={x:B,a:T.label,b:T.kind!==void 0?g.CompletionItemKind.from(T.kind):void 0,n:T.tags&&T.tags.map(g.CompletionItemTag.from),c:T.detail,d:typeof T.documentation=="undefined"?void 0:g.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters,l:T.additionalTextEdits&&T.additionalTextEdits.map(g.TextEdit.from),m:this._commands.toInternal(T.command,ne)};T.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=T.textEdit.newText):typeof T.insertText=="string"?ue.h=T.insertText:T.insertText instanceof U.SnippetString&&(ue.h=T.insertText.value,ue.i|=4);let Q;return T.textEdit?Q=T.textEdit.range:T.range&&(Q=T.range),U.Range.isRange(Q)?ue.j=g.Range.from(Q):Q&&(!H?.isEqual(Q.inserting)||!V?.isEqual(Q.replacing))&&(ue.j={insert:g.Range.from(Q.inserting),replace:g.Range.from(Q.replacing)}),ue}}class be{async provideInlineCompletions(T,B,H,V){}disposeCompletions(T){}handleDidShowCompletionItem(T,B){}}class ce extends be{constructor(T,B,H,V){super();this._extension=T,this._documents=B,this._provider=H,this._commands=V,this._references=new J,this._isAdditionsProposedApiEnabled=(0,D.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[I.InlineCompletionTriggerKind.Automatic]:U.InlineCompletionTriggerKind.Automatic,[I.InlineCompletionTriggerKind.Explicit]:U.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,D.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(T,B,H,V){const ne=this._documents.getDocument(T),ue=g.Position.to(B),Q=await this._provider.provideInlineCompletionItems(ne,ue,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:g.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},V);if(!Q||V.isCancellationRequested)return;const ge=(0,S.isArray)(Q)?Q:Q.items,pe=this._isAdditionsProposedApiEnabled?(0,S.isArray)(Q)?[]:Q.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne&&Ne.dispose()},items:ge}),items:ge.map((Ae,Ke)=>{let q;Ae.command&&(Ne||(Ne=new f.DisposableStore),q=this._commands.toInternal(Ae.command,Ne));const Y=Ae.insertText;return{insertText:typeof Y=="string"?Y:{snippet:Y.value},filterText:Ae.filterText,range:Ae.range?g.Range.from(Ae.range):void 0,command:q,idx:Ke,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ae.completeBracketPairs:!1}}),commands:pe.map(Ae=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Ae,Ne)))}}disposeCompletions(T){this._references.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,B){const H=this._references.get(T)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class ve extends be{constructor(T,B,H,V){super();this.extension=T,this._documents=B,this._provider=H,this._commands=V,this._references=new J,this.isAdditionProposedApiEnabled=(0,D.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[I.InlineCompletionTriggerKind.Automatic]:U.InlineCompletionTriggerKindNew.Automatic,[I.InlineCompletionTriggerKind.Explicit]:U.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(T,B,H,V){const ne=this._documents.getDocument(T),ue=g.Position.to(B),Q=await this._provider.provideInlineCompletionItems(ne,ue,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:g.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},V);if(!Q||V.isCancellationRequested)return;const ge=(0,S.isArray)(Q)?Q:Q.items,pe=(0,S.isArray)(Q)?[]:Q.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne&&Ne.dispose()},items:ge}),items:ge.map((Ae,Ke)=>{let q;Ae.command&&(Ne||(Ne=new f.DisposableStore),q=this._commands.toInternal(Ae.command,Ne));const Y=Ae.insertText;return{insertText:typeof Y=="string"?Y:{snippet:Y.value},filterText:Ae.filterText,range:Ae.range?g.Range.from(Ae.range):void 0,command:q,idx:Ke,completeBracketPairs:this.isAdditionProposedApiEnabled?Ae.completeBracketPairs:!1}}),commands:pe.map(Ae=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Ae,Ne)))}}disposeCompletions(T){this._references.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,B){const H=this._references.get(T)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class J{constructor(){this._references=new Map,this._idPool=1}createReferenceId(T){const B=this._idPool++;return this._references.set(B,T),B}disposeReferenceId(T){const B=this._references.get(T);return this._references.delete(T),B}get(T){return this._references.get(T)}}class Ee{constructor(T,B){this._documents=T,this._provider=B,this._cache=new c.Cache("SignatureHelp")}async provideSignatureHelp(T,B,H,V){const ne=this._documents.getDocument(T),ue=g.Position.to(B),Q=this.reviveContext(H),ge=await this._provider.provideSignatureHelp(ne,ue,V,Q);if(ge){const pe=this._cache.add([ge]);return{...g.SignatureHelp.from(ge),id:pe}}}reviveContext(T){let B;if(T.activeSignatureHelp){const H=g.SignatureHelp.to(T.activeSignatureHelp),V=this._cache.get(T.activeSignatureHelp.id,0);V?(B=V,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...T,activeSignatureHelp:B}}releaseSignatureHelp(T){this._cache.delete(T)}}class _e{constructor(T,B,H,V,ne){this._documents=T,this._commands=B,this._provider=H,this._logService=V,this._extension=ne,this._cache=new c.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(T,B,H){const V=this._documents.getDocument(T),ne=g.Range.to(B),ue=await this._provider.provideInlayHints(V,ne,H);if(!Array.isArray(ue)||ue.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(H.isCancellationRequested)return;const Q=this._cache.add(ue);this._disposables.set(Q,new f.DisposableStore);const ge={hints:[],cacheId:Q};for(let pe=0;pe<ue.length;pe++)this._isValidInlayHint(ue[pe],ne)&&ge.hints.push(this._convertInlayHint(ue[pe],[Q,pe]));return this._logService.trace(`[InlayHints] ${ge.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),ge}async resolveInlayHint(T,B){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...T);if(!H)return;const V=await this._provider.resolveInlayHint(H,B);if(!!V&&!!this._isValidInlayHint(V))return this._convertInlayHint(V,T)}releaseHints(T){this._disposables.get(T)?.dispose(),this._disposables.delete(T),this._cache.delete(T)}_isValidInlayHint(T,B){return T.label.length===0||Array.isArray(T.label)&&T.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(B&&!B.contains(T.position))}_convertInlayHint(T,B){const H=this._disposables.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const V={label:"",cacheId:B,tooltip:g.MarkdownString.fromStrict(T.tooltip),position:g.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(g.TextEdit.from),kind:T.kind&&g.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?V.label=T.label:V.label=T.label.map(ne=>{let ue={label:ne.value};return ue.tooltip=g.MarkdownString.fromStrict(ne.tooltip),U.Location.isLocation(ne.location)&&(ue.location=g.location.from(ne.location)),ne.command&&(ue.command=this._commands.toInternal(ne.command,H)),ue}),V}}class Fe{constructor(T,B){this._documents=T,this._provider=B,this._cache=new c.Cache("DocumentLink")}async provideLinks(T,B){const H=this._documents.getDocument(T),V=await this._provider.provideDocumentLinks(H,B);if(!(!Array.isArray(V)||V.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:V.filter(Fe._validateLink).map(g.DocumentLink.from)};{const ne=this._cache.add(V),ue={links:[],cacheId:ne};for(let Q=0;Q<V.length;Q++){if(!Fe._validateLink(V[Q]))continue;const ge=g.DocumentLink.from(V[Q]);ge.cacheId=[ne,Q],ue.links.push(ge)}return ue}}}static _validateLink(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,B){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...T);if(!H)return;const V=await this._provider.resolveDocumentLink(H,B);if(!(!V||!Fe._validateLink(V)))return g.DocumentLink.from(V)}releaseLinks(T){this._cache.delete(T)}}class xe{constructor(T,B){this._documents=T,this._provider=B}async provideColors(T,B){const H=this._documents.getDocument(T),V=await this._provider.provideDocumentColors(H,B);return Array.isArray(V)?V.map(ue=>({color:g.Color.from(ue.color),range:g.Range.from(ue.range)})):[]}async provideColorPresentations(T,B,H){const V=this._documents.getDocument(T),ne=g.Range.to(B.range),ue=g.Color.to(B.color),Q=await this._provider.provideColorPresentations(ue,{document:V,range:ne},H);if(!!Array.isArray(Q))return Q.map(g.ColorPresentation.from)}}class Xe{constructor(T,B){this._documents=T,this._provider=B}async provideFoldingRanges(T,B,H){const V=this._documents.getDocument(T),ne=await this._provider.provideFoldingRanges(V,B,H);if(!!Array.isArray(ne))return ne.map(g.FoldingRange.from)}}class ke{constructor(T,B,H){this._documents=T,this._provider=B,this._logService=H}async provideSelectionRanges(T,B,H){const V=this._documents.getDocument(T),ne=B.map(g.Position.to),ue=await this._provider.provideSelectionRanges(V,ne,H);if(!(0,O.isNonEmptyArray)(ue))return[];if(ue.length!==ne.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Q=[];for(let ge=0;ge<ne.length;ge++){const pe=[];Q.push(pe);let Ne=ne[ge],Be=ue[ge];for(;;){if(!Be.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(pe.push(g.SelectionRange.from(Be)),!Be.parent)break;Ne=Be.range,Be=Be.parent}}return Q}}class Se{constructor(T,B){this._documents=T,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(T,B,H){const V=this._documents.getDocument(T),ne=g.Position.to(B),ue=await this._provider.prepareCallHierarchy(V,ne,H);if(!ue)return;const Q=this._idPool.nextId();return this._cache.set(Q,new Map),Array.isArray(ue)?ue.map(ge=>this._cacheAndConvertItem(Q,ge)):[this._cacheAndConvertItem(Q,ue)]}async provideCallsTo(T,B,H){const V=this._itemFromCache(T,B);if(!V)throw new Error("missing call hierarchy item");const ne=await this._provider.provideCallHierarchyIncomingCalls(V,H);if(!!ne)return ne.map(ue=>({from:this._cacheAndConvertItem(T,ue.from),fromRanges:ue.fromRanges.map(Q=>g.Range.from(Q))}))}async provideCallsFrom(T,B,H){const V=this._itemFromCache(T,B);if(!V)throw new Error("missing call hierarchy item");const ne=await this._provider.provideCallHierarchyOutgoingCalls(V,H);if(!!ne)return ne.map(ue=>({to:this._cacheAndConvertItem(T,ue.to),fromRanges:ue.fromRanges.map(Q=>g.Range.from(Q))}))}releaseSession(T){this._cache.delete(T)}_cacheAndConvertItem(T,B){const H=this._cache.get(T),V=g.CallHierarchyItem.from(B,T,H.size.toString(36));return H.set(V._itemId,B),V}_itemFromCache(T,B){return this._cache.get(T)?.get(B)}}class Pe{constructor(T,B){this._documents=T,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(T,B,H){const V=this._documents.getDocument(T),ne=g.Position.to(B),ue=await this._provider.prepareTypeHierarchy(V,ne,H);if(!ue)return;const Q=this._idPool.nextId();return this._cache.set(Q,new Map),Array.isArray(ue)?ue.map(ge=>this._cacheAndConvertItem(Q,ge)):[this._cacheAndConvertItem(Q,ue)]}async provideSupertypes(T,B,H){const V=this._itemFromCache(T,B);if(!V)throw new Error("missing type hierarchy item");const ne=await this._provider.provideTypeHierarchySupertypes(V,H);if(!!ne)return ne.map(ue=>this._cacheAndConvertItem(T,ue))}async provideSubtypes(T,B,H){const V=this._itemFromCache(T,B);if(!V)throw new Error("missing type hierarchy item");const ne=await this._provider.provideTypeHierarchySubtypes(V,H);if(!!ne)return ne.map(ue=>this._cacheAndConvertItem(T,ue))}releaseSession(T){this._cache.delete(T)}_cacheAndConvertItem(T,B){const H=this._cache.get(T),V=g.TypeHierarchyItem.from(B,T,H.size.toString(36));return H.set(V._itemId,B),V}_itemFromCache(T,B){return this._cache.get(T)?.get(B)}}class re{constructor(T,B,H,V){this._proxy=T,this._documents=B,this._provider=H,this._handle=V}async provideDocumentOnDropEdits(T,B,H,V,ne){const ue=this._documents.getDocument(B),Q=g.Position.to(H),ge=g.DataTransfer.toDataTransfer(V,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,T,Ne)).buffer),pe=await this._provider.provideDocumentOnDropEdits(ue,Q,ge,ne);if(!!pe)return g.SnippetTextEdit.from(pe)}}class ae{constructor(T,B){this.adapter=T,this.extension=B}}class X{constructor(T,B,H,V,ne,ue,Q){this._adapter=new Map,this._uriTransformer=B,this._proxy=T.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=H,this._commands=V,this._diagnostics=ne,this._logService=ue,this._apiDeprecation=Q}_transformDocumentSelector(T){return g.DocumentSelector.from(T,this._uriTransformer)}_createDisposable(T){return new U.Disposable(()=>{this._adapter.delete(T),this._proxy.$unregister(T)})}_nextHandle(){return X._handlePool++}async _withAdapter(T,B,H,V,ne,ue=!1){const Q=this._adapter.get(T);if(!Q||!(Q.adapter instanceof B))return V;const ge=Date.now();ue||this._logService.trace(`[${Q.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const pe=H(Q.adapter,Q.extension);return Promise.resolve(pe).catch(Ne=>{(0,y.isCancellationError)(Ne)||(this._logService.error(`[${Q.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{ue||this._logService.trace(`[${Q.extension.identifier.value}] provider DONE after ${Date.now()-ge}ms`)}),_.CancellationToken.isCancellationToken(ne)?(0,a.raceCancellationError)(pe,ne):pe}_addNewAdapter(T,B){const H=this._nextHandle();return this._adapter.set(H,new ae(T,B)),H}static _extLabel(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,B,H,V){const ne=this._addNewAdapter(new r(this._documents,H),T),ue=V&&V.label||X._extLabel(T);return this._proxy.$registerDocumentSymbolProvider(ne,this._transformDocumentSelector(B),ue),this._createDisposable(ne)}$provideDocumentSymbols(T,B,H){return this._withAdapter(T,r,V=>V.provideDocumentSymbols(s.URI.revive(B),H),void 0,H)}registerCodeLensProvider(T,B,H){const V=this._nextHandle(),ne=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(V,new ae(new h(this._documents,this._commands.converter,H),T)),this._proxy.$registerCodeLensSupport(V,this._transformDocumentSelector(B),ne);let ue=this._createDisposable(V);if(ne!==void 0){const Q=H.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(ne));ue=U.Disposable.from(ue,Q)}return ue}$provideCodeLenses(T,B,H){return this._withAdapter(T,h,V=>V.provideCodeLenses(s.URI.revive(B),H),void 0,H)}$resolveCodeLens(T,B,H){return this._withAdapter(T,h,V=>V.resolveCodeLens(B,H),void 0,void 0)}$releaseCodeLenses(T,B){this._withAdapter(T,h,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(T,B,H){const V=this._addNewAdapter(new o(this._documents,H),T);return this._proxy.$registerDefinitionSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDefinition(T,B,H,V){return this._withAdapter(T,o,ne=>ne.provideDefinition(s.URI.revive(B),H,V),[],V)}registerDeclarationProvider(T,B,H){const V=this._addNewAdapter(new n(this._documents,H),T);return this._proxy.$registerDeclarationSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDeclaration(T,B,H,V){return this._withAdapter(T,n,ne=>ne.provideDeclaration(s.URI.revive(B),H,V),[],V)}registerImplementationProvider(T,B,H){const V=this._addNewAdapter(new t(this._documents,H),T);return this._proxy.$registerImplementationSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideImplementation(T,B,H,V){return this._withAdapter(T,t,ne=>ne.provideImplementation(s.URI.revive(B),H,V),[],V)}registerTypeDefinitionProvider(T,B,H){const V=this._addNewAdapter(new l(this._documents,H),T);return this._proxy.$registerTypeDefinitionSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideTypeDefinition(T,B,H,V){return this._withAdapter(T,l,ne=>ne.provideTypeDefinition(s.URI.revive(B),H,V),[],V)}registerHoverProvider(T,B,H,V){const ne=this._addNewAdapter(new b(this._documents,H),T);return this._proxy.$registerHoverProvider(ne,this._transformDocumentSelector(B)),this._createDisposable(ne)}$provideHover(T,B,H,V){return this._withAdapter(T,b,ne=>ne.provideHover(s.URI.revive(B),H,V),void 0,V)}registerEvaluatableExpressionProvider(T,B,H,V){const ne=this._addNewAdapter(new v(this._documents,H),T);return this._proxy.$registerEvaluatableExpressionProvider(ne,this._transformDocumentSelector(B)),this._createDisposable(ne)}$provideEvaluatableExpression(T,B,H,V){return this._withAdapter(T,v,ne=>ne.provideEvaluatableExpression(s.URI.revive(B),H,V),void 0,V)}registerInlineValuesProvider(T,B,H,V){const ne=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ue=this._addNewAdapter(new E(this._documents,H),T);this._proxy.$registerInlineValuesProvider(ue,this._transformDocumentSelector(B),ne);let Q=this._createDisposable(ue);if(ne!==void 0){const ge=H.onDidChangeInlineValues(pe=>this._proxy.$emitInlineValuesEvent(ne));Q=U.Disposable.from(Q,ge)}return Q}$provideInlineValues(T,B,H,V,ne){return this._withAdapter(T,E,ue=>ue.provideInlineValues(s.URI.revive(B),H,V,ne),void 0,ne)}registerDocumentHighlightProvider(T,B,H){const V=this._addNewAdapter(new x(this._documents,H),T);return this._proxy.$registerDocumentHighlightProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDocumentHighlights(T,B,H,V){return this._withAdapter(T,x,ne=>ne.provideDocumentHighlights(s.URI.revive(B),H,V),void 0,V)}registerLinkedEditingRangeProvider(T,B,H){const V=this._addNewAdapter(new $(this._documents,H),T);return this._proxy.$registerLinkedEditingRangeProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideLinkedEditingRanges(T,B,H,V){return this._withAdapter(T,$,async ne=>{const ue=await ne.provideLinkedEditingRanges(s.URI.revive(B),H,V);if(ue)return{ranges:ue.ranges,wordPattern:ue.wordPattern?X._serializeRegExp(ue.wordPattern):void 0}},void 0,V)}registerReferenceProvider(T,B,H){const V=this._addNewAdapter(new R(this._documents,H),T);return this._proxy.$registerReferenceSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideReferences(T,B,H,V,ne){return this._withAdapter(T,R,ue=>ue.provideReferences(s.URI.revive(B),H,V,ne),void 0,ne)}registerCodeActionProvider(T,B,H,V){const ne=new f.DisposableStore,ue=this._addNewAdapter(new p(this._documents,this._commands.converter,this._diagnostics,H,this._logService,T,this._apiDeprecation),T);return this._proxy.$registerQuickFixSupport(ue,this._transformDocumentSelector(B),{providedKinds:V?.providedCodeActionKinds?.map(Q=>Q.value),documentation:V?.documentation?.map(Q=>({kind:Q.kind.value,command:this._commands.converter.toInternal(Q.command,ne)}))},X._extLabel(T),Boolean(H.resolveCodeAction)),ne.add(this._createDisposable(ue)),ne}$provideCodeActions(T,B,H,V,ne){return this._withAdapter(T,p,ue=>ue.provideCodeActions(s.URI.revive(B),H,V,ne),void 0,ne)}$resolveCodeAction(T,B,H){return this._withAdapter(T,p,V=>V.resolveCodeAction(B,H),void 0,void 0)}$releaseCodeActions(T,B){this._withAdapter(T,p,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(T,B,H){const V=this._addNewAdapter(new M(this._documents,H),T);return this._proxy.$registerDocumentFormattingSupport(V,this._transformDocumentSelector(B),T.identifier,T.displayName||T.name),this._createDisposable(V)}$provideDocumentFormattingEdits(T,B,H,V){return this._withAdapter(T,M,ne=>ne.provideDocumentFormattingEdits(s.URI.revive(B),H,V),void 0,V)}registerDocumentRangeFormattingEditProvider(T,B,H){const V=this._addNewAdapter(new z(this._documents,H),T);return this._proxy.$registerRangeFormattingSupport(V,this._transformDocumentSelector(B),T.identifier,T.displayName||T.name),this._createDisposable(V)}$provideDocumentRangeFormattingEdits(T,B,H,V,ne){return this._withAdapter(T,z,ue=>ue.provideDocumentRangeFormattingEdits(s.URI.revive(B),H,V,ne),void 0,ne)}registerOnTypeFormattingEditProvider(T,B,H,V){const ne=this._addNewAdapter(new Z(this._documents,H),T);return this._proxy.$registerOnTypeFormattingSupport(ne,this._transformDocumentSelector(B),V,T.identifier),this._createDisposable(ne)}$provideOnTypeFormattingEdits(T,B,H,V,ne,ue){return this._withAdapter(T,Z,Q=>Q.provideOnTypeFormattingEdits(s.URI.revive(B),H,V,ne,ue),void 0,ue)}registerWorkspaceSymbolProvider(T,B){const H=this._addNewAdapter(new K(B,this._logService),T);return this._proxy.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(T,B,H){return this._withAdapter(T,K,V=>V.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(T,B,H){return this._withAdapter(T,K,V=>V.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(T,B){this._withAdapter(T,K,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(T,B,H){const V=this._addNewAdapter(new N(this._documents,H,this._logService),T);return this._proxy.$registerRenameSupport(V,this._transformDocumentSelector(B),N.supportsResolving(H)),this._createDisposable(V)}$provideRenameEdits(T,B,H,V,ne){return this._withAdapter(T,N,ue=>ue.provideRenameEdits(s.URI.revive(B),H,V,ne),void 0,ne)}$resolveRenameLocation(T,B,H,V){return this._withAdapter(T,N,ne=>ne.resolveRenameLocation(s.URI.revive(B),H,V),void 0,V)}registerDocumentSemanticTokensProvider(T,B,H,V){const ne=this._addNewAdapter(new le(this._documents,H),T),ue=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ne,this._transformDocumentSelector(B),V,ue);let Q=this._createDisposable(ne);if(ue){const ge=H.onDidChangeSemanticTokens(pe=>this._proxy.$emitDocumentSemanticTokensEvent(ue));Q=U.Disposable.from(Q,ge)}return Q}$provideDocumentSemanticTokens(T,B,H,V){return this._withAdapter(T,le,ne=>ne.provideDocumentSemanticTokens(s.URI.revive(B),H,V),null,V)}$releaseDocumentSemanticTokens(T,B){this._withAdapter(T,le,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,B,H,V){const ne=this._addNewAdapter(new oe(this._documents,H),T);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ne,this._transformDocumentSelector(B),V),this._createDisposable(ne)}$provideDocumentRangeSemanticTokens(T,B,H,V){return this._withAdapter(T,oe,ne=>ne.provideDocumentRangeSemanticTokens(s.URI.revive(B),H,V),null,V)}registerCompletionItemProvider(T,B,H,V){const ne=this._addNewAdapter(new fe(this._documents,this._commands.converter,H,this._apiDeprecation,T),T);return this._proxy.$registerCompletionsProvider(ne,this._transformDocumentSelector(B),V,fe.supportsResolving(H),`${T.identifier.value}(${V.join("")})`),this._createDisposable(ne)}$provideCompletionItems(T,B,H,V,ne){return this._withAdapter(T,fe,ue=>ue.provideCompletionItems(s.URI.revive(B),H,V,ne),void 0,ne)}$resolveCompletionItem(T,B,H){return this._withAdapter(T,fe,V=>V.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(T,B){this._withAdapter(T,fe,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(T,B,H){const V=new ce(T,this._documents,H,this._commands.converter),ne=this._addNewAdapter(V,T);return this._proxy.$registerInlineCompletionsSupport(ne,this._transformDocumentSelector(B),V.supportsHandleDidShowCompletionItem),this._createDisposable(ne)}registerInlineCompletionsProviderNew(T,B,H){const V=this._addNewAdapter(new ve(T,this._documents,H,this._commands.converter),T);return this._proxy.$registerInlineCompletionsSupport(V,this._transformDocumentSelector(B),!0),this._createDisposable(V)}$provideInlineCompletions(T,B,H,V,ne){return this._withAdapter(T,be,ue=>ue.provideInlineCompletions(s.URI.revive(B),H,V,ne),void 0,ne)}$handleInlineCompletionDidShow(T,B,H){this._withAdapter(T,be,async V=>{V.handleDidShowCompletionItem(B,H)},void 0,void 0)}$freeInlineCompletionsList(T,B){this._withAdapter(T,be,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(T,B,H,V){const ne=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,ue=this._addNewAdapter(new Ee(this._documents,H),T);return this._proxy.$registerSignatureHelpProvider(ue,this._transformDocumentSelector(B),ne),this._createDisposable(ue)}$provideSignatureHelp(T,B,H,V,ne){return this._withAdapter(T,Ee,ue=>ue.provideSignatureHelp(s.URI.revive(B),H,V,ne),void 0,ne)}$releaseSignatureHelp(T,B){this._withAdapter(T,Ee,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(T,B,H){const V=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ne=this._addNewAdapter(new _e(this._documents,this._commands.converter,H,this._logService,T),T);this._proxy.$registerInlayHintsProvider(ne,this._transformDocumentSelector(B),typeof H.resolveInlayHint=="function",V,X._extLabel(T));let ue=this._createDisposable(ne);if(V!==void 0){const Q=H.onDidChangeInlayHints(ge=>this._proxy.$emitInlayHintsEvent(V));ue=U.Disposable.from(ue,Q)}return ue}$provideInlayHints(T,B,H,V){return this._withAdapter(T,_e,ne=>ne.provideInlayHints(s.URI.revive(B),H,V),void 0,V)}$resolveInlayHint(T,B,H){return this._withAdapter(T,_e,V=>V.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(T,B){this._withAdapter(T,_e,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(T,B,H){const V=this._addNewAdapter(new Fe(this._documents,H),T);return this._proxy.$registerDocumentLinkProvider(V,this._transformDocumentSelector(B),typeof H.resolveDocumentLink=="function"),this._createDisposable(V)}$provideDocumentLinks(T,B,H){return this._withAdapter(T,Fe,V=>V.provideLinks(s.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(T,B,H){return this._withAdapter(T,Fe,V=>V.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(T,B){this._withAdapter(T,Fe,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(T,B,H){const V=this._addNewAdapter(new xe(this._documents,H),T);return this._proxy.$registerDocumentColorProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDocumentColors(T,B,H){return this._withAdapter(T,xe,V=>V.provideColors(s.URI.revive(B),H),[],H)}$provideColorPresentations(T,B,H,V){return this._withAdapter(T,xe,ne=>ne.provideColorPresentations(s.URI.revive(B),H,V),void 0,V)}registerFoldingRangeProvider(T,B,H){const V=this._nextHandle(),ne=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(V,new ae(new Xe(this._documents,H),T)),this._proxy.$registerFoldingRangeProvider(V,this._transformDocumentSelector(B),ne);let ue=this._createDisposable(V);if(ne!==void 0){const Q=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ne));ue=U.Disposable.from(ue,Q)}return ue}$provideFoldingRanges(T,B,H,V){return this._withAdapter(T,Xe,ne=>ne.provideFoldingRanges(s.URI.revive(B),H,V),void 0,V)}registerSelectionRangeProvider(T,B,H){const V=this._addNewAdapter(new ke(this._documents,H,this._logService),T);return this._proxy.$registerSelectionRangeProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideSelectionRanges(T,B,H,V){return this._withAdapter(T,ke,ne=>ne.provideSelectionRanges(s.URI.revive(B),H,V),[],V)}registerCallHierarchyProvider(T,B,H){const V=this._addNewAdapter(new Se(this._documents,H),T);return this._proxy.$registerCallHierarchyProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$prepareCallHierarchy(T,B,H,V){return this._withAdapter(T,Se,ne=>Promise.resolve(ne.prepareSession(s.URI.revive(B),H,V)),void 0,V)}$provideCallHierarchyIncomingCalls(T,B,H,V){return this._withAdapter(T,Se,ne=>ne.provideCallsTo(B,H,V),void 0,V)}$provideCallHierarchyOutgoingCalls(T,B,H,V){return this._withAdapter(T,Se,ne=>ne.provideCallsFrom(B,H,V),void 0,V)}$releaseCallHierarchy(T,B){this._withAdapter(T,Se,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(T,B,H){const V=this._addNewAdapter(new Pe(this._documents,H),T);return this._proxy.$registerTypeHierarchyProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$prepareTypeHierarchy(T,B,H,V){return this._withAdapter(T,Pe,ne=>Promise.resolve(ne.prepareSession(s.URI.revive(B),H,V)),void 0,V)}$provideTypeHierarchySupertypes(T,B,H,V){return this._withAdapter(T,Pe,ne=>ne.provideSupertypes(B,H,V),void 0,V)}$provideTypeHierarchySubtypes(T,B,H,V){return this._withAdapter(T,Pe,ne=>ne.provideSubtypes(B,H,V),void 0,V)}$releaseTypeHierarchy(T,B){this._withAdapter(T,Pe,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(T,B,H){const V=this._nextHandle();return this._adapter.set(V,new ae(new re(this._proxy,this._documents,H,V),T)),this._proxy.$registerDocumentOnDropEditProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDocumentOnDropEdits(T,B,H,V,ne,ue){return this._withAdapter(T,re,Q=>Promise.resolve(Q.provideDocumentOnDropEdits(B,s.URI.revive(H),V,ne,ue)),void 0,void 0)}registerDocumentPasteEditProvider(T,B,H){const V=this._nextHandle();return this._adapter.set(V,new ae(new F(this._proxy,this._documents,H,V),T)),this._proxy.$registerPasteEditProvider(V,this._transformDocumentSelector(B),!!H.prepareDocumentPaste),this._createDisposable(V)}$prepareDocumentPaste(T,B,H,V,ne){return this._withAdapter(T,F,ue=>ue.prepareDocumentPaste(s.URI.revive(B),H,V,ne),void 0,ne)}$providePasteEdits(T,B,H,V,ne){return this._withAdapter(T,F,ue=>ue.providePasteEdits(0,s.URI.revive(B),H,V,ne),void 0,ne)}static _serializeRegExp(T){return{pattern:T.source,flags:(0,w.regExpFlags)(T)}}static _serializeIndentationRule(T){return{decreaseIndentPattern:X._serializeRegExp(T.decreaseIndentPattern),increaseIndentPattern:X._serializeRegExp(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?X._serializeRegExp(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?X._serializeRegExp(T.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(T){return{beforeText:X._serializeRegExp(T.beforeText),afterText:T.afterText?X._serializeRegExp(T.afterText):void 0,previousLineText:T.previousLineText?X._serializeRegExp(T.previousLineText):void 0,action:T.action}}static _serializeOnEnterRules(T){return T.map(X._serializeOnEnterRule)}setLanguageConfiguration(T,B,H){let{wordPattern:V}=H;if(V&&(0,w.regExpLeadsToEndlessLoop)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this._documents.setWordDefinitionFor(B,V):this._documents.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const ne=this._nextHandle(),ue={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?X._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?X._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?X._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ne,B,ue),this._createDisposable(ne)}$setWordDefinitions(T){for(const B of T)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=X,X._handlePool=0}),define(Ie[201],Te([1,0,4,8,6,29,13,7]),function(ee,e,s,C,g,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(O,S,m,_){this._documents=S,this._commands=m,this._uriTransformer=_,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(s.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,S){await this._proxy.$changeLanguage(O,S);const m=this._documents.getDocumentData(O);if(!m)throw new Error(`document '${O.toString()}' NOT found`);return m.document}async tokenAtPosition(O,S){const m=O.version,_=C.Position.from(S),f=await this._proxy.$tokensAtPosition(O.uri,_),u={type:g.StandardTokenType.Other,range:O.getWordRangeAtPosition(S)??new g.Range(S.line,S.character,S.line,S.character)};if(!f)return u;const d={range:C.Range.to(f.range),type:C.TokenType.to(f.type)};return!d.range.contains(S)||m!==O.version?u:d}createLanguageStatusItem(O,S,m){const _=this._handlePool++,f=this._proxy,u=this._ids,d=`${O.identifier.value}/${S}`;if(u.has(d))throw new Error(`LanguageStatusItem with id '${S}' ALREADY exists`);u.add(d);const c={selector:m,id:S,name:O.displayName??O.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let k,y=new P.DisposableStore;const a=()=>{k?.dispose(),k=(0,I.disposableTimeout)(()=>{y.clear(),this._proxy.$setLanguageStatus(_,{id:d,name:c.name??O.displayName??O.name,source:O.displayName??O.name,selector:C.DocumentSelector.from(c.selector,this._uriTransformer),label:c.text,detail:c.detail??"",severity:c.severity===g.LanguageStatusSeverity.Error?U.default.Error:c.severity===g.LanguageStatusSeverity.Warning?U.default.Warning:U.default.Info,command:c.command&&this._commands.toInternal(c.command,y),accessibilityInfo:c.accessibilityInformation,busy:c.busy})},0)},D={dispose(){y.dispose(),k?.dispose(),f.$removeLanguageStatus(_),u.delete(d)},get id(){return c.id},get name(){return c.name},set name(r){c.name=r,a()},get selector(){return c.selector},set selector(r){c.selector=r,a()},get text(){return c.text},set text(r){c.text=r,a()},get detail(){return c.detail},set detail(r){c.detail=r,a()},get severity(){return c.severity},set severity(r){c.severity=r,a()},get accessibilityInformation(){return c.accessibilityInformation},set accessibilityInformation(r){c.accessibilityInformation=r,a()},get command(){return c.command},set command(r){c.command=r,a()},get busy(){return c.busy},set busy(r){c.busy=r,a()}};return a(),D}}e.ExtHostLanguages=w}),define(Ie[202],Te([1,0,14,4,28,16,5]),function(ee,e,s,C,g,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends s.AbstractLoggerService{constructor(O,S){const m=new I.Emitter;super(S.logLevel,m.event);this._proxy=O.getProxy(C.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(m)}$setLevel(O){this._onDidChangeLogLevel.fire(O)}doCreateLogger(O,S,m){return new w(this._proxy,O,S,m)}};e.ExtHostLoggerService=P,e.ExtHostLoggerService=P=$e([We(0,U.IExtHostRpcService),We(1,g.IExtHostInitDataService)],P);class w extends s.AbstractMessageLogger{constructor(O,S,m,_){super(_?.always);this.proxy=O,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(S,_).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(O,S){const m=[[O,S]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(O){this.proxy.$log(this.file,O)}}}),define(Ie[203],Te([1,0,4,14,26]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function U(P){return P&&P.title}let I=class{constructor(w,A){this._logService=A,this._proxy=w.getProxy(s.MainContext.MainThreadMessageService)}showMessage(w,A,O,S,m){const _={source:{identifier:w.identifier,label:w.displayName||w.name}};let f;typeof S=="string"||U(S)?f=[S,...m]:(_.modal=S?.modal,_.useCustom=S?.useCustom,_.detail=S?.detail,f=m),_.useCustom&&(0,g.checkProposedApiEnabled)(w,"resolvers");const u=[];for(let d=0;d<f.length;d++){const c=f[d];if(typeof c=="string")u.push({title:c,handle:d,isCloseAffordance:!1});else if(typeof c=="object"){let{title:k,isCloseAffordance:y}=c;u.push({title:k,isCloseAffordance:!!y,handle:d})}else this._logService.warn("Invalid message item:",c)}return this._proxy.$showMessage(A,O,_,u).then(d=>{if(typeof d=="number")return f[d]})}};e.ExtHostMessageService=I,e.ExtHostMessageService=I=$e([We(1,C.ILogService)],I)}),define(Ie[204],Te([1,0,23,5,96,7,24,10,9,2,63,4,36,8,6,40,174,91]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class k{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}constructor(a,D,r,h,i){this._textDocumentsAndEditors=r,this._textDocuments=h,this._extensionStoragePaths=i,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new I.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new C.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new C.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new C.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new O.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(S.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(S.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(S.MainContext.MainThreadNotebookEditors),this._commandsConverter=D.converter,D.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const n=o.notebookEditor?.notebookUri,t=o.cell.handle,b=this._documents.get(n)?.getCell(t);if(b)return b.apiCell}return o}}),k._registerApiCommands(D)}getEditorById(a){const D=this._editors.get(a);if(!D)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return D}getIdByEditor(a){for(const[D,r]of this._editors)if(r.apiEditor===a)return D}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,D){const r=this._documents.get(a);if(!r&&!D)throw new Error(`NO notebook document for '${a}'`);return r}_getProviderData(a){const D=this._notebookContentProviders.get(a);if(!D)throw new Error(`NO provider for '${a}'`);return D}registerNotebookContentProvider(a,D,r,h,i){if((0,P.isFalsyOrWhitespace)(D))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(D))throw new Error(`Notebook provider for '${D}' already registered`);this._notebookContentProviders.set(D,{extension:a,provider:r});let o;return r.onDidChangeNotebookContentOptions&&(o=r.onDidChangeNotebookContentOptions(()=>{const n=_.NotebookDocumentContentOptions.from(r.options);this._notebookProxy.$updateNotebookProviderOptions(D,n)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},D,_.NotebookDocumentContentOptions.from(h),k._convertNotebookRegistrationData(a,i)),new f.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(D),this._notebookProxy.$unregisterNotebookProvider(D)})}static _convertNotebookRegistrationData(a,D){if(!D)return;const r=D.filenamePattern.map(h=>_.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(D.filenamePattern&&!r){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:D.displayName,filenamePattern:r,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,D,r){const h=k._notebookStatusBarItemProviderHandlePool++,i=typeof r.onDidChangeCellStatusBarItems=="function"?k._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(h,r),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(h,i,D);let o;return i!==void 0&&(o=r.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(i))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(h),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(h,i),o&&o.dispose()})}async createNotebookDocument(a){const D=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&_.NotebookData.from(a.content)});return A.URI.revive(D)}async openNotebookDocument(a){const D=this._documents.get(a);if(D)return D.apiNotebook;const r=await this._notebookDocumentsProxy.$tryOpenNotebook(a),h=this._documents.get(A.URI.revive(r));return(0,w.assertIsDefined)(h?.apiNotebook)}async showNotebookDocument(a,D){A.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let r;typeof D=="object"?r={position:_.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(_.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:r={preserveFocus:!1};const h=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,r),i=h&&this._editors.get(h)?.apiEditor;if(i)return i;throw h?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,D,r,h){const i=this._notebookStatusBarItemProviders.get(a),o=A.URI.revive(D),n=this._documents.get(o);if(!n||!i)return;const t=n.getCellFromIndex(r);if(!t)return;const l=await i.provideCellStatusBarItems(t.apiCell,h);if(!l)return;const b=new U.DisposableStore,v=this._statusBarCache.add([b]),x=(Array.isArray(l)?l:[l]).map($=>_.NotebookStatusBarItem.from($,this._commandsConverter,b));return{cacheId:v,items:x}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,D,r,h,i){if((0,P.isFalsyOrWhitespace)(D))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,r),this._notebookProxy.$registerNotebookSerializer(o,{id:a.identifier,location:a.extensionLocation},D,_.NotebookDocumentContentOptions.from(h),k._convertNotebookRegistrationData(a,i)),(0,U.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(a,D,r){const h=this._notebookSerializer.get(a);if(!h)throw new Error("NO serializer found");const i=await h.deserializeNotebook(D.buffer,r);return new u.SerializableObjectWithBuffers(_.NotebookData.from(i))}async $notebookToData(a,D,r){const h=this._notebookSerializer.get(a);if(!h)throw new Error("NO serializer found");const i=await h.serializeNotebook(_.NotebookData.to(D.value),r);return s.VSBuffer.wrap(i)}async $openNotebook(a,D,r,h,i){const{provider:o}=this._getProviderData(a),n=await o.openNotebook(A.URI.revive(D),{backupId:r,untitledDocumentData:h?.buffer},i);return new u.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(_.NotebookCellData.from)})}async $saveNotebook(a,D,r){const h=this.getNotebookDocument(A.URI.revive(D)),{provider:i}=this._getProviderData(a);return await i.saveNotebook(h.apiNotebook,r),!0}async $saveNotebookAs(a,D,r,h){const i=this.getNotebookDocument(A.URI.revive(D)),{provider:o}=this._getProviderData(a);return await o.saveNotebookAs(A.URI.revive(r),i.apiNotebook,h),!0}async $backupNotebook(a,D,r){const h=this.getNotebookDocument(A.URI.revive(D)),i=this._getProviderData(a),o=this._extensionStoragePaths.workspaceValue(i.extension)??this._extensionStoragePaths.globalValue(i.extension),n=String((0,g.hash)([h.uri.toString(),this._backupIdPool++])),t=A.URI.joinPath(o,n),l=await i.provider.backupNotebook(h.apiNotebook,{destination:t},r);return h.updateBackup(l),l.id}_createExtHostEditor(a,D,r){if(this._editors.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const h=new c.ExtHostNotebookEditor(D,this._notebookEditorsProxy,a,r.visibleRanges.map(_.NotebookRange.to),r.selections.map(_.NotebookRange.to),typeof r.viewColumn=="number"?_.ViewColumn.to(r.viewColumn):void 0);this._editors.set(D,h)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const r of a.value.removedDocuments){const h=A.URI.revive(r),i=this._documents.get(h);i&&(i.dispose(),this._documents.delete(h),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:i.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(i.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===h.toString()&&this._editors.delete(o.id)}if(a.value.addedDocuments){const r=[];for(const h of a.value.addedDocuments){const i=A.URI.revive(h.uri);if(this._documents.has(i))throw new Error(`adding EXISTING notebook ${i} `);const o=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,i,h);r.push(...h.cells.map(n=>d.ExtHostCell.asModelAddData(o.apiNotebook,n))),this._documents.get(i)?.dispose(),this._documents.set(i,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:r}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(a.value.addedEditors)for(const r of a.value.addedEditors){if(this._editors.has(r.id))return;const h=A.URI.revive(r.documentUri),i=this._documents.get(h);i&&this._createExtHostEditor(i,r.id,r)}const D=[];if(a.value.removedEditors)for(const r of a.value.removedEditors){const h=this._editors.get(r);h&&(this._editors.delete(r),this._activeNotebookEditor?.id===h.id&&(this._activeNotebookEditor=void 0),D.push(h))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(h=>this._editors.get(h)).filter(h=>!!h);const r=new Set;this._visibleNotebookEditors.forEach(h=>r.add(h.id));for(const h of this._editors.values()){const i=r.has(h.id);h._acceptVisibility(i)}this._visibleNotebookEditors=[...this._editors.values()].map(h=>h).filter(h=>h.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(a){const D=m.ApiCommandArgument.String.with("notebookType","A notebook type"),r=new m.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new m.ApiCommandArgument("data","Bytes to convert to data",i=>i instanceof Uint8Array,i=>s.VSBuffer.wrap(i))],new m.ApiCommandResult("Notebook Data",i=>_.NotebookData.to(i.value))),h=new m.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new m.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",i=>!0,i=>new u.SerializableObjectWithBuffers(_.NotebookData.from(i)))],new m.ApiCommandResult("Bytes",i=>i.buffer));a.registerApiCommand(r),a.registerApiCommand(h)}}e.ExtHostNotebookController=k,k._notebookStatusBarItemProviderHandlePool=0}),define(Ie[205],Te([1,0,5,56,14,4,16,8]),function(ee,e,s,C,g,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class w{constructor(S,m){const _=w._Keys.nextId();S.$registerNotebookEditorDecorationType(_,P.NotebookDecorationRenderOptions.from(m)),this.value={key:_,dispose(){S.$removeNotebookEditorDecorationType(_)}}}}w._Keys=new C.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(S,m,_){this._logService=S,this._extHostRpc=m,this._notebooksAndEditors=_,this._onDidChangeNotebookEditorSelection=new s.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new s.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(S){return new w(this._extHostRpc.getProxy(U.MainContext.MainThreadNotebookEditors),S).value}$acceptEditorPropertiesChanged(S,m){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",S,m);const _=this._notebooksAndEditors.getEditorById(S);m.visibleRanges&&_._acceptVisibleRanges(m.visibleRanges.ranges.map(P.NotebookRange.to)),m.selections&&_._acceptSelections(m.selections.selections.map(P.NotebookRange.to)),m.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:_.apiEditor,visibleRanges:_.apiEditor.visibleRanges}),m.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:_.apiEditor,selections:_.apiEditor.selections}))}$acceptEditorViewColumns(S){for(const m in S)this._notebooksAndEditors.getEditorById(m)._acceptViewColumn(P.ViewColumn.to(S[m]))}};e.ExtHostNotebookEditors=A,e.ExtHostNotebookEditors=A=$e([We(0,g.ILogService),We(1,I.IExtHostRpcService)],A)}),define(Ie[206],Te([1,0,15,13,20,5,7,24,2,25,14,4,36,8,6,66,168,26,40]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let y=class{constructor(o,n,t,l,b){this._initData=n,this._extHostNotebook=t,this._commands=l,this._logService=b,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new U.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=o.getProxy(S.MainContext.MainThreadNotebookKernels);const v=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",E=>!0,E=>{if(E&&"notebookEditor"in E&&"id"in E){const x=this._extHostNotebook.getIdByEditor(E.notebookEditor);return{id:E.id,extension:E.extension,notebookEditorId:x}}else if(E&&"notebookEditor"in E){const x=this._extHostNotebook.getIdByEditor(E.notebookEditor);if(x===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${E.notebookEditor.document.uri.toString()}`);return{notebookEditorId:x}}return E})],m.ApiCommandResult.Void);this._commands.registerApiCommand(v)}createNotebookController(o,n,t,l,b,v){for(const fe of this._kernelData.values())if(fe.controller.id===n&&A.ExtensionIdentifier.equals(o.identifier,fe.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const E=this._handlePool++,x=this;this._logService.trace(`NotebookController[${E}], CREATED by ${o.identifier.value}, ${n}`);const $=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${o.identifier}'`);let R=!1;const p=new I.DisposableStore,F=new U.Emitter,M=new U.Emitter,z={id:h(o.identifier,n),notebookType:t,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:l||o.identifier.value,preloads:v?v.map(_.NotebookRendererScript.from):[]};let Z=b??$,K;this._proxy.$addKernel(E,z).catch(fe=>{console.log(fe),R=!0});let N=0;const se=()=>{if(R)return;const fe=++N;Promise.resolve().then(()=>{fe===N&&this._proxy.$updateKernel(E,z)})},le=new P.ResourceMap,oe={get id(){return n},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return z.label},set label(fe){z.label=fe??o.displayName??o.name,se()},get detail(){return z.detail??""},set detail(fe){z.detail=fe,se()},get description(){return z.description??""},set description(fe){z.description=fe,se()},get kind(){return(0,c.checkProposedApiEnabled)(o,"notebookControllerKind"),z.kind??""},set kind(fe){(0,c.checkProposedApiEnabled)(o,"notebookControllerKind"),z.kind=fe,se()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(fe){z.supportedLanguages=fe,se()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(fe){z.supportsExecutionOrder=fe,se()},get rendererScripts(){return z.preloads?z.preloads.map(_.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(fe){Z=fe??$},get interruptHandler(){return K},set interruptHandler(fe){K=fe,z.supportsInterrupt=Boolean(fe),se()},createNotebookCellExecution(fe){if(R)throw new Error("notebook controller is DISPOSED");if(!le.has(fe.notebook.uri))throw x._logService.trace(`NotebookController[${E}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${fe.notebook.uri.toString()}`);return x._createNotebookCellExecution(fe,h(o.identifier,this.id))},dispose:()=>{R||(this._logService.trace(`NotebookController[${E}], DISPOSED`),R=!0,this._kernelData.delete(E),p.dispose(),F.dispose(),M.dispose(),this._proxy.$removeKernel(E))},updateNotebookAffinity(fe,be){x._proxy.$updateNotebookPriority(E,fe.uri,be)},onDidReceiveMessage:M.event,postMessage(fe,be){return(0,c.checkProposedApiEnabled)(o,"notebookMessaging"),x._proxy.$postMessage(E,be&&x._extHostNotebook.getIdByEditor(be),fe)},asWebviewUri(fe){return(0,c.checkProposedApiEnabled)(o,"notebookMessaging"),(0,u.asWebviewUri)(fe,x._initData.remote)}};return this._kernelData.set(E,{extensionId:o.identifier,controller:oe,onDidReceiveMessage:M,onDidChangeSelection:F,associatedNotebooks:le}),oe}getIdByController(o){for(const[n,t]of this._kernelData)if(t.controller===o)return h(t.extensionId,o.id);return null}$acceptNotebookAssociation(o,n,t){const l=this._kernelData.get(o);if(l){const b=this._extHostNotebook.getNotebookDocument(w.URI.revive(n));t?l.associatedNotebooks.set(b.uri,!0):l.associatedNotebooks.delete(b.uri),this._logService.trace(`NotebookController[${o}] ASSOCIATE notebook`,b.uri.toString(),t),l.onDidChangeSelection.fire({selected:t,notebook:b.apiNotebook})}}async $executeCells(o,n,t){const l=this._kernelData.get(o);if(!l)return;const b=this._extHostNotebook.getNotebookDocument(w.URI.revive(n)),v=[];for(const E of t){const x=b.getCell(E);x&&v.push(x.apiCell)}try{this._logService.trace(`NotebookController[${o}] EXECUTE cells`,b.uri.toString(),v.length),await l.controller.executeHandler.call(l.controller,v,b.apiNotebook,l.controller)}catch(E){this._logService.error(`NotebookController[${o}] execute cells FAILED`,E),console.error(E)}}async $cancelCells(o,n,t){const l=this._kernelData.get(o);if(!l)return;const b=this._extHostNotebook.getNotebookDocument(w.URI.revive(n));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,b.apiNotebook);else for(const v of t){const E=b.getCell(v);E&&this._activeExecutions.get(E.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,n,t){const l=this._kernelData.get(o);if(!l)return;const b=this._extHostNotebook.getEditorById(n);l.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:t}))}$cellExecutionChanged(o,n,t){const b=this._extHostNotebook.getNotebookDocument(w.URI.revive(o)).getCell(n);b&&this._onDidChangeCellExecutionState.fire({cell:b.apiCell,state:t?_.NotebookCellExecutionState.to(t):f.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(o,n){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const b=new D(n,l,this._proxy);this._activeExecutions.set(l.uri,b);const v=b.onDidChangeState(()=>{b.state===a.Resolved&&(b.dispose(),v.dispose(),this._activeExecutions.delete(l.uri))});return b.asApiObject()}};e.ExtHostNotebookKernels=y,e.ExtHostNotebookKernels=y=$e([We(4,O.ILogService)],y);var a;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(a||(a={}));class D extends I.Disposable{get state(){return this._state}constructor(o,n,t){super();this._cell=n,this._proxy=t,this._handle=D.HANDLE++,this._onDidChangeState=new U.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new g.CancellationTokenSource),this._collector=new r(10,l=>this.update(l)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,o,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(o){await this._collector.addItem(o)}async update(o){const n=Array.isArray(o)?o:[o];return this._proxy.$updateExecution(this._handle,new k.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(o){return o.map(n=>{const t=f.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return t===n.items?_.NotebookCellOutput.from(n):_.NotebookCellOutput.from({items:t,id:n.id,metadata:n.metadata})})}async updateOutputs(o,n,t){const l=this.validateAndConvertOutputs((0,s.asArray)(o));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,append:t,outputs:l})}async updateOutputItems(o,n,t){return o=f.NotebookCellOutput.ensureUniqueMimeTypes((0,s.asArray)(o),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,items:o.map(_.NotebookCellOutputItem.from),outputId:n.id,append:t})}asApiObject(){const o=this;return Object.freeze({get token(){return o._tokenSource.token},get cell(){return o._cell.apiCell},get executionOrder(){return o._executionOrder},set executionOrder(t){o._executionOrder=t,o.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:o._executionOrder}])},start(t){if(o._state===a.Resolved||o._state===a.Started)throw new Error("Cannot call start again");o._state=a.Started,o._onDidChangeState.fire(),o.update({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,l){if(o._state===a.Resolved)throw new Error("Cannot call resolve twice");o._state=a.Resolved,o._onDidChangeState.fire(),o._collector.flush(),o._proxy.$completeExecution(o._handle,new k.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:t}))},clearOutput(t){return o.verifyStateForOutput(),o.updateOutputs([],t,!1)},appendOutput(t,l){return o.verifyStateForOutput(),o.updateOutputs(t,l,!0)},replaceOutput(t,l){return o.verifyStateForOutput(),o.updateOutputs(t,l,!1)},appendOutputItems(t,l){return o.verifyStateForOutput(),o.updateOutputItems(t,l,!0)},replaceOutputItems(t,l){return o.verifyStateForOutput(),o.updateOutputItems(t,l,!1)}})}}D.HANDLE=0;class r{constructor(o,n){this.delay=o,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(o){return this.batch.push(o),this.currentDeferred||(this.currentDeferred=new C.DeferredPromise,this.startedTimer=Date.now(),(0,C.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const o=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>o.complete())}}function h(i,o){return`${i.value}/${o}`}e.createKernelId=h}),define(Ie[207],Te([1,0,5,4,91]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class U{constructor(P,w){this._extHostNotebook=w,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,w,A){const O=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(w)?.fire({editor:O.apiEditor,message:A})}createRendererMessaging(P,w){if(!P.contributes?.notebookRenderer?.some(O=>O.id===w))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${w})`);return{onDidReceiveMessage:(O,S,m)=>this.getOrCreateEmitterFor(w).event(O,S,m),postMessage:(O,S)=>{g.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,S]=[S,O]);const m=S&&g.ExtHostNotebookEditor.apiEditorsToExtHost.get(S);return this.proxy.$postMessage(m?.id,w,O)}}}getOrCreateEmitterFor(P){let w=this._rendererMessageEmitters.get(P);return w||(w=new s.Emitter({onLastListenerRemove:()=>{w?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,w),w)}}e.ExtHostNotebookRenderers=U}),define(Ie[208],Te([1,0,20,5,7,4,2,6,11,15,29,62]),function(ee,e,s,C,g,U,I,P,w,A,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(_,f,u){const d=_.getProxy(U.MainContext.MainThreadQuickOpen);class c{constructor(n,t){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=t}showQuickPick(n,t,l=s.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(n),v=++this._instances,E=d.$show(v,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},l),x={},$=E.then(()=>x);return Promise.race([$,b]).then(R=>{if(R!==x)return b.then(p=>{const F=[];for(let M=0;M<p.length;M++){const z=p[M];typeof z=="string"?F.push({label:z,handle:M}):z.kind===P.QuickPickItemKind.Separator?F.push({type:"separator",label:z.label}):F.push({label:z.label,description:z.description,detail:z.detail,picked:z.picked,alwaysShow:z.alwaysShow,handle:M})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=M=>{t.onDidSelectItem(p[M])}),d.$setItems(v,F),E.then(M=>{if(typeof M=="number")return p[M];if(Array.isArray(M))return M.map(z=>p[z])})})}).then(void 0,R=>{if(!(0,w.isCancellationError)(R))return d.$setError(v,R),Promise.reject(R)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,t=s.CancellationToken.None){return this._validateInput=n?.validateInput,d.$input(n,typeof this._validateInput=="function",t).then(void 0,l=>{if(!(0,w.isCancellationError)(l))return Promise.reject(l)})}async $validateInput(n){if(!this._validateInput)return;const t=await this._validateInput(n);if(!t||typeof t=="string")return t;let l;switch(t.severity){case P.InputBoxValidationSeverity.Info:l=O.default.Info;break;case P.InputBoxValidationSeverity.Warning:l=O.default.Warning;break;case P.InputBoxValidationSeverity.Error:l=O.default.Error;break;default:l=t.message?O.default.Error:O.default.Ignore;break}return{content:t.message,severity:l}}async showWorkspaceFolderPick(n,t=s.CancellationToken.None){const l=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!l)return;const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(v=>v.uri.toString()===l.uri.toString())}createQuickPick(n){const t=new h(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(n){const t=new i(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(n,t){const l=this._sessions.get(n);l&&l._fireDidChangeValue(t)}$onDidAccept(n){const t=this._sessions.get(n);t&&t._fireDidAccept()}$onDidChangeActive(n,t){const l=this._sessions.get(n);l instanceof h&&l._fireDidChangeActive(t)}$onDidChangeSelection(n,t){const l=this._sessions.get(n);l instanceof h&&l._fireDidChangeSelection(t)}$onDidTriggerButton(n,t){const l=this._sessions.get(n);l&&l._fireDidTriggerButton(t)}$onDidTriggerItemButton(n,t,l){const b=this._sessions.get(n);b instanceof h&&b._fireDidTriggerItemButton(t,l)}$onDidHide(n){const t=this._sessions.get(n);t&&t._fireDidHide()}}class k{constructor(n,t){this._extensionId=n,this._onDidDispose=t,this._id=h._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((t,l)=>{const b=t===P.QuickInputButtons.Back?-1:l;this._handlesToButtons.set(b,t)}),this.update({buttons:n.map((t,l)=>({...r(t),tooltip:t.tooltip,handle:t===P.QuickInputButtons.Back?-1:l}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const t=this._handlesToButtons.get(n);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,g.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),d.$dispose(this._id))}update(n){if(!this._disposed){for(const t of Object.keys(n)){const l=n[t];this._pendingUpdate[t]=l===void 0?null:l}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){d.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}k._nextId=1;function y(o){if(o instanceof P.ThemeIcon)return{id:o.id};const n=D(o),t=a(o);return{dark:typeof n=="string"?I.URI.file(n):n,light:typeof t=="string"?I.URI.file(t):t}}function a(o){return typeof o=="object"&&"light"in o?o.light:o}function D(o){return typeof o=="object"&&"dark"in o?o.dark:o}function r(o){const n=y(o.iconPath);let t,l;return"id"in n?l=S.ThemeIcon.asClassName(n):t=n,{iconPath:t,iconClass:l}}class h extends k{constructor(n,t){super(n.identifier,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((l,b)=>{this._handlesToItems.set(b,l),this._itemsToHandles.set(l,b)});const t=[];for(let l=0;l<n.length;l++){const b=n[l];b.kind===P.QuickPickItemKind.Separator?t.push({type:"separator",label:b.label}):t.push({handle:l,label:b.label,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,buttons:b.buttons?.map((v,E)=>({...r(v),tooltip:v.tooltip,handle:E}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(n){this._keepScrollPosition=n,this.update({keepScrollPosition:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(n){const t=(0,A.coalesce)(n.map(l=>this._handlesToItems.get(l)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(n){const t=(0,A.coalesce)(n.map(l=>this._handlesToItems.get(l)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(n,t){const l=this._handlesToItems.get(n);if(!l||!l.buttons||!l.buttons.length)return;const b=l.buttons[t];b&&this._onDidTriggerItemButtonEmitter.fire({button:b,item:l})}}class i extends k{constructor(n,t){super(n.identifier,t);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,n?typeof n=="string"?this.update({validationMessage:n,severity:O.default.Error}):this.update({validationMessage:n.message,severity:n.severity??O.default.Error}):this.update({validationMessage:void 0,severity:O.default.Ignore})}}return new c(f,u)}e.createExtHostQuickOpen=m});var Re=this&&this.__classPrivateFieldGet||function(ee,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ee):C?C.value:e.get(ee)},Ye=this&&this.__classPrivateFieldSet||function(ee,e,s,C,g){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?g.call(ee,s):g?g.value=s:e.set(ee,s),s};define(Ie[209],Te([1,0,2,5,55,7,13,4,15,111,14,25,62,8,26]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f){"use strict";var u,d,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function k(v){if(v)return typeof v.iconPath=="string"?s.URI.file(v.iconPath):s.URI.isUri(v.iconPath)||m.ThemeIcon.isThemeIcon(v.iconPath)?v.iconPath:void 0}function y(v,E){if(!v.iconPath&&!E.iconPath)return 0;if(v.iconPath){if(!E.iconPath)return 1}else return-1;const x=typeof v.iconPath=="string"?v.iconPath:s.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id,$=typeof E.iconPath=="string"?E.iconPath:s.URI.isUri(E.iconPath)?E.iconPath.fsPath:E.iconPath.id;return(0,A.comparePaths)(x,$)}function a(v,E){let x=0;if(v.strikeThrough!==E.strikeThrough)return v.strikeThrough?1:-1;if(v.faded!==E.faded)return v.faded?1:-1;if(v.tooltip!==E.tooltip)return(v.tooltip||"").localeCompare(E.tooltip||"");if(x=y(v,E),x!==0)return x;if(v.light&&E.light)x=y(v.light,E.light);else{if(v.light)return 1;if(E.light)return-1}if(x!==0)return x;if(v.dark&&E.dark)x=y(v.dark,E.dark);else{if(v.dark)return 1;if(E.dark)return-1}return x}function D(v,E){if(v.command!==E.command)return v.command<E.command?-1:1;if(v.title!==E.title)return v.title<E.title?-1:1;if(v.tooltip!==E.tooltip){if(v.tooltip!==void 0&&E.tooltip!==void 0)return v.tooltip<E.tooltip?-1:1;if(v.tooltip!==void 0)return 1;if(E.tooltip!==void 0)return-1}if(v.arguments===E.arguments)return 0;if(v.arguments)if(E.arguments){if(v.arguments.length!==E.arguments.length)return v.arguments.length-E.arguments.length}else return 1;else return-1;for(let x=0;x<v.arguments.length;x++){const $=v.arguments[x],R=E.arguments[x];if($!==R)return $<R?-1:1}return 0}function r(v,E){let x=(0,A.comparePaths)(v.resourceUri.fsPath,E.resourceUri.fsPath,!0);if(x!==0)return x;if(v.command&&E.command)x=D(v.command,E.command);else{if(v.command)return 1;if(E.command)return-1}if(x!==0)return x;if(v.decorations&&E.decorations)x=a(v.decorations,E.decorations);else{if(v.decorations)return 1;if(E.decorations)return-1}return x}function h(v,E){for(let x=0;x<v.length;x++)if(v[x]!==E[x])return!1;return!0}function i(v,E){return v.command===E.command&&v.title===E.title&&v.tooltip===E.tooltip&&(v.arguments&&E.arguments?h(v.arguments,E.arguments):v.arguments===E.arguments)}function o(v,E){return(0,w.equals)(v,E,i)}class n{get value(){return this._value}set value(E){E=E??"",Re(this,u,"f").$setInputBoxValue(this._sourceControlHandle,E),this.updateValue(E)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(E){Re(this,u,"f").$setInputBoxPlaceholder(this._sourceControlHandle,E),this._placeholder=E}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(E){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),E&&typeof E!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=E,Re(this,u,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!E)}get enabled(){return(0,f.checkProposedApiEnabled)(this._extension,"scmInput"),this._enabled}set enabled(E){(0,f.checkProposedApiEnabled)(this._extension,"scmInput"),E=!!E,this._enabled!==E&&(this._enabled=E,Re(this,u,"f").$setInputBoxEnablement(this._sourceControlHandle,E))}get visible(){return this._visible}set visible(E){E=!!E,this._visible!==E&&(this._visible=E,Re(this,u,"f").$setInputBoxVisibility(this._sourceControlHandle,E))}constructor(E,x,$){this._extension=E,this._sourceControlHandle=$,u.set(this,void 0),this._value="",this._onDidChange=new C.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ye(this,u,x,"f")}showValidationMessage(E,x){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Re(this,u,"f").$showValidationMessage(this._sourceControlHandle,E,x)}$onInputBoxValueChange(E){this.updateValue(E)}updateValue(E){this._value=E,this._onDidChange.fire(E)}}e.ExtHostSCMInputBox=n,u=new WeakMap;class t{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(E){this._label=E,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,E)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(E){this._hideWhenEmpty=E,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(E){this._resourceStates=[...E],this._onDidUpdateResourceStates.fire()}constructor(E,x,$,R,p){this._proxy=E,this._commands=x,this._sourceControlHandle=$,this._id=R,this._label=p,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new C.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new C.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}getResourceState(E){return this._resourceStatesMap.get(E)}$executeResourceCommand(E,x){const $=this._resourceStatesCommandsMap.get(E);return $?(0,I.asPromise)(()=>this._commands.executeCommand($.command,...$.arguments||[],x)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const E=[...this._resourceStates].sort(r),$=(0,w.sortedDiff)(this._resourceSnapshot,E,r).map(F=>{const M=F.toInsert.map(z=>{const Z=this._resourceHandlePool++;this._resourceStatesMap.set(Z,z);const K=z.resourceUri;let N;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const _e=new U.DisposableStore;N=this._commands.converter.toInternal(z.command,_e),this._resourceStatesDisposablesMap.set(Z,_e)}else this._resourceStatesCommandsMap.set(Z,z.command);const se=k(z.decorations),le=z.decorations&&k(z.decorations.light)||se,oe=z.decorations&&k(z.decorations.dark)||se,fe=[le,oe],be=z.decorations&&z.decorations.tooltip||"",ce=z.decorations&&!!z.decorations.strikeThrough,ve=z.decorations&&!!z.decorations.faded,J=z.contextValue||"";return{rawResource:[Z,K,fe,be,ce,ve,J,N],handle:Z}});return{start:F.start,deleteCount:F.deleteCount,toInsert:M}}),R=$.map(({start:F,deleteCount:M,toInsert:z})=>[F,M,z.map(Z=>Z.rawResource)]),p=$.reverse();for(const{start:F,deleteCount:M,toInsert:z}of p){const Z=z.map(N=>N.handle),K=this._handlesSnapshot.splice(F,M,...Z);for(const N of K)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=E,R}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class l{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(E){this._count!==E&&(this._count=E,Re(this,d,"f").$updateSourceControl(this.handle,{count:E}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(E){this._quickDiffProvider=E,Re(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!E})}get commitTemplate(){return this._commitTemplate}set commitTemplate(E){E!==this._commitTemplate&&(this._commitTemplate=E,Re(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:E}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(E){this._acceptInputDisposables.value=new U.DisposableStore,this._acceptInputCommand=E;const x=this._commands.converter.toInternal(E,this._acceptInputDisposables.value);Re(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:x})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(E){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new U.DisposableStore,this._actionButton=E;const x=E!==void 0?{command:this._commands.converter.toInternal(E.command,this._actionButtonDisposables.value),description:E.description}:void 0;Re(this,d,"f").$updateSourceControl(this.handle,{actionButton:x??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(E){if(this._statusBarCommands&&E&&o(this._statusBarCommands,E))return;this._statusBarDisposables.value=new U.DisposableStore,this._statusBarCommands=E;const x=(E||[]).map($=>this._commands.converter.toInternal($,this._statusBarDisposables.value));Re(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:x})}get selected(){return this._selected}constructor(E,x,$,R,p,F){this._extension=E,this._commands=$,this._id=R,this._label=p,this._rootUri=F,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new U.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new U.MutableDisposable,this._statusBarDisposables=new U.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new C.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=l._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,d,x,"f"),this._inputBox=new n(E,Re(this,d,"f"),this.handle),Re(this,d,"f").$registerSourceControl(this.handle,R,p,F)}createResourceGroup(E,x){const $=new t(Re(this,d,"f"),this._commands,this.handle,E,x),R=C.Event.once($.onDidDispose)(()=>this.createdResourceGroups.delete($));return this.createdResourceGroups.set($,R),this.eventuallyAddResourceGroups(),$}eventuallyAddResourceGroups(){const E=[],x=[];for(const[$,R]of this.createdResourceGroups){R.dispose();const p=$.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add($),this.eventuallyUpdateResourceStates()});C.Event.once($.onDidDispose)(()=>{this.updatedResourceGroups.delete($),p.dispose(),this._groups.delete($.handle),Re(this,d,"f").$unregisterGroup(this.handle,$.handle)}),E.push([$.handle,$.id,$.label,$.features]);const F=$._takeResourceStateSnapshot();F.length>0&&x.push([$.handle,F]),this._groups.set($.handle,$)}Re(this,d,"f").$registerGroups(this.handle,E,x),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const E=[];this.updatedResourceGroups.forEach(x=>{const $=x._takeResourceStateSnapshot();$.length!==0&&E.push([x.handle,$])}),E.length>0&&Re(this,d,"f").$spliceResourceStates(this.handle,E),this.updatedResourceGroups.clear()}getResourceGroup(E){return this._groups.get(E)}setSelectionState(E){this._selected=E,this._onDidChangeSelection.fire(E)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(E=>E.dispose()),Re(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,l._handlePool=0,$e([(0,g.debounce)(100)],l.prototype,"eventuallyAddResourceGroups",null),$e([(0,g.debounce)(100)],l.prototype,"eventuallyUpdateResourceStates",null);let b=c=class{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(E,x,$){this._commands=x,this.logService=$,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new C.Emitter,this._proxy=E.getProxy(P.MainContext.MainThreadSCM),this._telemetry=E.getProxy(P.MainContext.MainThreadTelemetry),x.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const p=this._sourceControls.get(R.sourceControlHandle);if(!p)return R;const F=p.getResourceGroup(R.groupHandle);return F?F.getResourceState(R.handle):R}else if(R&&R.$mid===4){const p=this._sourceControls.get(R.sourceControlHandle);return p?p.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const p=this._sourceControls.get(R.handle);return p||R}return R}})}createSourceControl(E,x,$,R){this.logService.trace("ExtHostSCM#createSourceControl",E.identifier.value,x,$,R),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:E.identifier.value});const p=c._handlePool++,F=new l(E,this._proxy,this._commands,x,$,R);this._sourceControls.set(p,F);const M=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(E.identifier))||[];return M.push(F),this._sourceControlsByExtension.set(S.ExtensionIdentifier.toKey(E.identifier),M),F}getLastInputBox(E){this.logService.trace("ExtHostSCM#getLastInputBox",E.identifier.value);const x=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(E.identifier)),$=x&&x[x.length-1];return $&&$.inputBox}$provideOriginalResource(E,x,$){const R=s.URI.revive(x);this.logService.trace("ExtHostSCM#$provideOriginalResource",E,R.toString());const p=this._sourceControls.get(E);return!p||!p.quickDiffProvider||!p.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>p.quickDiffProvider.provideOriginalResource(R,$)).then(F=>F||null)}$onInputBoxValueChange(E,x){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",E);const $=this._sourceControls.get(E);return $&&$.inputBox.$onInputBoxValueChange(x),Promise.resolve(void 0)}$executeResourceCommand(E,x,$,R){this.logService.trace("ExtHostSCM#$executeResourceCommand",E,x,$);const p=this._sourceControls.get(E);if(!p)return Promise.resolve(void 0);const F=p.getResourceGroup(x);return F?F.$executeResourceCommand($,R):Promise.resolve(void 0)}$validateInput(E,x,$){this.logService.trace("ExtHostSCM#$validateInput",E);const R=this._sourceControls.get(E);return!R||!R.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>R.inputBox.validateInput(x,$)).then(p=>{if(!p)return Promise.resolve(void 0);const F=_.MarkdownString.fromStrict(p.message);return F?Promise.resolve([F,p.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(E){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",E),E!==void 0&&this._sourceControls.get(E)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=E,Promise.resolve(void 0)}};e.ExtHostSCM=b,b._handlePool=0,e.ExtHostSCM=b=c=$e([We(2,O.ILogService)],b)});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,s,C,g){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?g.call(ee,s):g?g.value=s:e.set(ee,s),s},Re=this&&this.__classPrivateFieldGet||function(ee,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[210],Te([1,0,6,4,131,7,8,9]),function(ee,e,s,C,g,U,I,P){"use strict";var w,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(f,u,d,c,k=s.StatusBarAlignment.Left,y){w.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new U.DisposableStore,Ye(this,w,f,"f"),Ye(this,A,u,"f"),this._entryId=O.ID_GEN++,this._extension=d,this._id=c,this._alignment=k,this._priority=this.validatePriority(y)}validatePriority(f){if(!!(0,P.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!O.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Re(this,A,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Re(this,A,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Re(this,w,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let u;this._name?u=this._name:u=(0,g.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const c=I.MarkdownString.fromStrict(this._tooltip);Re(this,w,"f").$setEntry(this._entryId,f,u,this._text,c,this._command?.internal,d,this._backgroundColor,this._alignment===s.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,w=new WeakMap,A=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new s.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.ThemeColor("statusBarItem.warningForeground")]]);class S{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,g.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const u={message:f};return this._messages.unshift(u),this._update(),new s.Disposable(()=>{const d=this._messages.indexOf(u);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(f,u){this._proxy=f.getProxy(C.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new S(this)}createStatusBarEntry(f,u,d,c){return new O(this._proxy,this._commands,f,u,d,c)}setStatusBarMessage(f,u){const d=this._statusMessage.setMessage(f);let c;return typeof u=="number"?c=setTimeout(()=>d.dispose(),u):typeof u!="undefined"&&u.then(()=>d.dispose(),()=>d.dispose()),new s.Disposable(()=>{d.dispose(),clearTimeout(c)})}}e.ExtHostStatusBar=m}),define(Ie[71],Te([1,0,4,5,3]),function(ee,e,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class U{constructor(P){this._onDidChangeStorage=new C.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(s.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,w){this._proxy.$registerExtensionStorageKeysToSync(P,w)}initializeExtensionStorage(P,w,A){return this._proxy.$initializeExtensionStorage(P,w).then(O=>O||A)}setValue(P,w,A){return this._proxy.$setValue(P,w,A)}$acceptValue(P,w,A){this._onDidChangeStorage.fire({shared:P,key:w,value:A})}}e.ExtHostStorage=U,e.IExtHostStorage=(0,g.createDecorator)("IExtHostStorage")}),define(Ie[72],Te([1,0,3,28,14,52,2]),function(ee,e,s,C,g,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,s.createDecorator)("IExtensionStoragePaths");let P=class{constructor(A,O,S){this._logService=O,this._extHostFileSystem=S,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(A){return I.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,O=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(I.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:I.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(S){this._logService.error("[ExtHostStorage]",S);return}}workspaceValue(A){if(this._value)return I.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return I.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=P,e.ExtensionStoragePaths=P=$e([We(0,C.IExtHostInitDataService),We(1,g.ILogService),We(2,U.IExtHostConsumerFileSystem)],P)}),define(Ie[53],Te([1,0,5,4,3,2,16,7,6,132,11,169,20,44,153,62,9,13]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,g.createDecorator)("IExtHostTerminalService");class k{constructor(t,l,b,v){this._proxy=t,this._id=l,this._creationOptions=b,this._name=v,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(x=>this._pidPromiseComplete=x);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(x,$=!0){E._checkDisposed(),E._proxy.$sendText(E._id,x,$)},show(x){E._checkDisposed(),E._proxy.$show(E._id,x)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(t,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,d.withNullAsUndefined)(t.shellPath),shellArgs:(0,d.withNullAsUndefined)(t.shellArgs),cwd:(0,d.withNullAsUndefined)(t.cwd),env:(0,d.withNullAsUndefined)(t.env),icon:(0,d.withNullAsUndefined)(i(t.iconPath)),color:u.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,d.withNullAsUndefined)(t.message),strictEnv:(0,d.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(t.location,l?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,l,b,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:u.ThemeColor.isThemeColor(v)?v.id:void 0,location:this._serializeParentTerminal(t,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,l){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,l){return t===this._cols&&l===this._rows||t===0||l===0?!1:(this._cols=t,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=k;class y{get onProcessReady(){return this._onProcessReady.event}constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new s.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new s.Emitter,this._onDidChangeProperty=new s.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new s.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${l}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,l){this._pty.setDimensions?.({columns:t,rows:l})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose?.((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions?.(l=>{l&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this._pty.onDidChangeName?.(l=>{this._onDidChangeProperty.fire({type:"title",value:l})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=y;let a=1,D=class extends P.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(t,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new s.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new s.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new s.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new s.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new s.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(C.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new s.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[b,v]of this._terminalProcesses)v.shutdown(!0)}})}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,l){const b=new k(this._proxy,(0,_.generateUuid)(),t,t.name),v=new y(t.pty);return b.createExtensionTerminal(t.location,this._serializeParentTerminal(t,l).resolvedExtHostIdentifier,i(t.iconPath),o(t.color)).then(E=>{const x=this._setupExtHostProcessListeners(E,v);this._terminalProcessDisposables[E]=x}),this._terminals.push(b),b.value}_serializeParentTerminal(t,l){if(l=l||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const b=t.location.parentTerminal;if(b){const v=this._terminals.find(E=>E.value===b);v&&(l.resolvedExtHostIdentifier=v._id)}}else t.location&&typeof t.location!="object"?l.location=t.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(t,l){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const v=new y(l),E=this._setupExtHostProcessListeners(t,v);this._terminalProcessDisposables[t]=E}async $acceptActiveTerminalChanged(t){const l=this._activeTerminal;if(t===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(t);b&&(this._activeTerminal=b,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,l){const b=this._getTerminalById(t);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:l})}async $acceptTerminalDimensions(t,l,b){const v=this._getTerminalById(t);v&&v.setDimensions(l,b)&&this._onDidChangeTerminalDimensions.fire({terminal:v.value,dimensions:v.value.dimensions})}async $acceptTerminalMaximumDimensions(t,l,b){this._terminalProcesses.get(t)?.resize(l,b)}async $acceptTerminalTitleChange(t,l){const b=this._getTerminalById(t);b&&(b.name=l)}async $acceptTerminalClosed(t,l){const b=this._getTerminalObjectIndexById(this._terminals,t);if(b!==null){const v=this._terminals.splice(b,1)[0];v.setExitCode(l),this._onDidCloseTerminal.fire(v.value)}}$acceptTerminalOpened(t,l,b,v){if(l){const $=this._getTerminalObjectIndexById(this._terminals,l);if($!==null){this._terminals[$]._id=t,this._onDidOpenTerminal.fire(this.terminals[$]),this._terminals[$].isOpen=!0;return}}const E={name:v.name,shellPath:v.executable,shellArgs:v.args,cwd:typeof v.cwd=="string"?v.cwd:U.URI.revive(v.cwd),env:v.env,hideFromUser:v.hideFromUser},x=new k(this._proxy,t,E,b);this._terminals.push(x),this._onDidOpenTerminal.fire(x.value),x.isOpen=!0}async $acceptTerminalProcessId(t,l){const b=this._getTerminalById(t);b&&b._setProcessId(l)}async $startExtensionTerminal(t,l){const b=this._getTerminalById(t);if(!b)return{message:(0,A.localize)(0,null,t)};b.isOpen||await new Promise(E=>{const x=this.onDidOpenTerminal(async $=>{$===b.value&&(x.dispose(),E())})});const v=this._terminalProcesses.get(t);v?v.startSendingEvents(l):this._extensionTerminalAwaitingStart[t]={initialDimensions:l}}_setupExtHostProcessListeners(t,l){const b=new P.DisposableStore;b.add(l.onProcessReady(E=>this._proxy.$sendProcessReady(t,E.pid,E.cwd))),b.add(l.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(t,E))),this._bufferer.startBuffering(t,l.onProcessData),b.add(l.onProcessExit(E=>this._onProcessExit(t,E))),this._terminalProcesses.set(t,l);const v=this._extensionTerminalAwaitingStart[t];return v&&l instanceof y&&(l.startSendingEvents(v.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),b}$acceptProcessAckDataEvent(t,l){this._terminalProcesses.get(t)?.acknowledgeDataEvent(l)}$acceptProcessInput(t,l){this._terminalProcesses.get(t)?.input(l)}$acceptTerminalInteraction(t){const l=this._getTerminalById(t);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(t,l,b){try{this._terminalProcesses.get(t)?.resize(l,b)}catch(v){if(v.code!=="EPIPE"&&v.code!=="ERR_IPC_CHANNEL_CLOSED")throw v}}$acceptProcessShutdown(t,l){this._terminalProcesses.get(t)?.shutdown(l)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(l=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(l=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:l}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new w.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,l,b){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,b),this._proxy.$registerProfileProvider(l,t.identifier.value),new w.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(t,l){const b=new m.CancellationTokenSource().token;let v=await this._profileProviders.get(t)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(v&&!("options"in v)&&(v={options:v}),!v||!("options"in v))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in v.options){this.createExtensionTerminal(v.options,l);return}this.createTerminalFromOptions(v.options,l)}}async $provideLinks(t,l){const b=this._getTerminalById(t);if(!b)return[];this._terminalLinkCache.delete(t);const v=this._terminalLinkCancellationSource.get(t);v&&v.dispose(!0);const E=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,E);const x=[],$={terminal:b.value,line:l},R=[];for(const M of this._linkProviders)R.push(c.Promises.withAsyncBody(async z=>{E.token.onCancellationRequested(()=>z({provider:M,links:[]}));const Z=await M.provideTerminalLinks($,E.token)||[];E.token.isCancellationRequested||z({provider:M,links:Z})}));const p=await Promise.all(R);if(E.token.isCancellationRequested)return[];const F=new Map;for(const M of p)M&&M.links.length>0&&x.push(...M.links.map(z=>{const Z={id:a++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return F.set(Z.id,{provider:M.provider,link:z}),Z}));return this._terminalLinkCache.set(t,F),x}$activateLink(t,l){const b=this._terminalLinkCache.get(t)?.get(l);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(t,l){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const b=this._terminalProcessDisposables[t];b&&(b.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,l)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,l){const b=this._getTerminalObjectIndexById(t,l);return b!==null?t[b]:null}_getTerminalObjectIndexById(t,l){let b=null;return t.some((v,E)=>v._id===l?(b=E,!0):!1),b}getEnvironmentVariableCollection(t){let l=this._environmentVariableCollections.get(t.identifier.value);return l||(l=new r,this._setEnvironmentVariableCollection(t.identifier.value,l)),l}_syncEnvironmentVariableCollection(t,l){const b=(0,S.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(t,l.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(t){t.forEach(l=>{const b=l[0],v=new r(l[1]);this._setEnvironmentVariableCollection(b,v)})}$acceptDefaultProfile(t,l){this._defaultProfile=t,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(t,l){this._environmentVariableCollections.set(t,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,l)})}};e.BaseExtHostTerminalService=D,e.BaseExtHostTerminalService=D=$e([We(1,I.IExtHostRpcService)],D);class r{get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new s.Emitter,this.map=new Map(t)}get size(){return this.map.size}replace(t,l){this._setIfDiffers(t,{value:l,type:w.EnvironmentVariableMutatorType.Replace})}append(t,l){this._setIfDiffers(t,{value:l,type:w.EnvironmentVariableMutatorType.Append})}prepend(t,l){this._setIfDiffers(t,{value:l,type:w.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,l){const b=this.map.get(t);(!b||b.value!==l.value||b.type!==l.type)&&(this.map.set(t,l),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,l){this.map.forEach((b,v)=>t.call(l,v,b,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=r;let h=class extends D{constructor(t){super(!1,t)}createTerminal(t,l,b){throw new O.NotSupportedError}createTerminalFromOptions(t,l){throw new O.NotSupportedError}};e.WorkerExtHostTerminalService=h,e.WorkerExtHostTerminalService=h=$e([We(0,I.IExtHostRpcService)],h);function i(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function o(n){return u.ThemeColor.isThemeColor(n)?n:void 0}});var Re=this&&this.__classPrivateFieldGet||function(ee,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ee):C?C.value:e.get(ee)},Ye=this&&this.__classPrivateFieldSet||function(ee,e,s,C,g){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?g.call(ee,s):g?g.value=s:e.set(ee,s),s};define(Ie[211],Te([1,0,15,23,20,5,172,96,7,27,9,44,4,16,92,8,6,47,67,48]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d,c,k,y){"use strict";var a,D;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(R,p){this.resultsChangedEmitter=new U.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(m.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new i(this.proxy),p.registerArgumentProcessor({processArgument:F=>F?.$mid===13?(0,f.toItemFromContext)(F):F})}createTestController(R,p,F){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const M=new w.DisposableStore,z=M.add(new f.ExtHostTestItemCollection(R,p));z.root.label=p;const Z=new Map,K=this.proxy,N={items:z.root.children,get label(){return p},set label(le){p=le,z.root.label=le,K.$updateController(R,{label:p})},get refreshHandler(){return F},set refreshHandler(le){F=le,K.$updateController(R,{canRefresh:!!le})},get id(){return R},createRunProfile:(le,oe,fe,be,ce)=>{let ve=(0,P.hash)(le);for(;Z.has(ve);)ve++;return new E(this.proxy,Z,R,ve,le,oe,fe,be,ce)},createTestItem(le,oe,fe){return new f.TestItemImpl(R,le,oe,fe)},createTestRun:(le,oe,fe=!0)=>this.runTracker.createTestRun(R,z,le,oe,fe),set resolveHandler(le){z.resolveHandler=le},get resolveHandler(){return z.resolveHandler},dispose:()=>{M.dispose()}};K.$registerTestController(R,p,!!F),M.add((0,w.toDisposable)(()=>K.$unregisterTestController(R)));const se={controller:N,collection:z,profiles:Z};return this.controllers.set(R,se),M.add((0,w.toDisposable)(()=>this.controllers.delete(R))),M.add(z.onDidGenerateDiff(le=>K.$publishDiff(R,le.map(y.TestsDiffOp.serialize)))),N}createTestObserver(){return this.observer.checkout()}async runTests(R,p=g.CancellationToken.None){const F=o(R);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.controllers.get(F.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:R.include?.map(z=>c.TestId.fromExtHostTestItem(z,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:x[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:R.exclude?.map(z=>z.id)},p)}$provideFileCoverage(R,p,F){return(0,s.mapFind)(this.runTracker.trackers,z=>z.id===R?z.getCoverage(p):void 0)?.provideFileCoverage(F)??Promise.resolve([])}$resolveFileCoverage(R,p,F,M){return(0,s.mapFind)(this.runTracker.trackers,Z=>Z.id===R?Z.getCoverage(p):void 0)?.resolveFileCoverage(F,M)??Promise.resolve([])}$configureRunProfile(R,p){this.controllers.get(R)?.profiles.get(p)?.configureHandler?.()}async $refreshTests(R,p){await this.controllers.get(R)?.controller.refreshHandler?.(p)}$publishTestResults(R){this.results=Object.freeze(R.map(p=>(0,A.deepFreeze)(u.TestResults.to(p))).concat(this.results).sort((p,F)=>F.completedAt-p.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,p){const F=this.controllers.get(c.TestId.fromString(R).controllerId)?.collection;F&&(await F.expand(R,p<0?1/0:p),F.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R.map(y.TestsDiffOp.deserialize))}async $runControllerTests(R,p){const F=this.controllers.get(R.controllerId);if(!F)return;const{collection:M,profiles:z}=F,Z=z.get(R.profileId);if(!Z)return;const K=R.testIds.map(oe=>M.tree.get(oe)).filter(O.isDefined),N=R.excludeExtIds.map(oe=>F.collection.tree.get(oe)).filter(O.isDefined).filter(oe=>K.some(fe=>fe.fullId.compare(oe.fullId)===2));if(!K.length)return;const se=new d.TestRunRequest(K.some(oe=>oe.actual instanceof f.TestItemRootImpl)?void 0:K.map(oe=>oe.actual),N.map(oe=>oe.actual),Z),le=this.runTracker.prepareForMainThreadTestRun(se,n.fromInternal(R,F.collection),p);try{await Z.runHandler(se,p)}finally{le.isRunning&&!p.isCancellationRequested&&await U.Event.toPromise(le.onEnd),le.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};e.ExtHostTesting=r,e.ExtHostTesting=r=$e([We(0,_.IExtHostRpcService)],r);class h extends w.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(R,p,F){super();this.dto=R,this.proxy=p,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new U.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new g.CancellationTokenSource(F)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:M}of this.tasks.values())M.end()}))}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const p=this.dto.id,F=this.dto.controllerId,M=(0,S.generateUuid)(),z=new t(this.proxy,p,M),Z=le=>(oe,...fe)=>{if(N){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(oe)||(this.ensureTestIsKnown(oe),le(oe,...fe))},K=(le,oe)=>{const fe=oe instanceof Array?oe.map(u.TestMessage.from):[u.TestMessage.from(oe)];if(le.uri&&le.range){const be={range:u.Range.from(le.range),uri:le.uri};for(const ce of fe)ce.location=ce.location||be}this.proxy.$appendTestMessagesInRun(p,M,c.TestId.fromExtHostTestItem(le,F).toString(),fe)};let N=!1;const se={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return z.coverageProvider},set coverageProvider(le){z.coverageProvider=le},enqueued:Z(le=>{this.proxy.$updateTestStateInRun(p,M,c.TestId.fromExtHostTestItem(le,F).toString(),1)}),skipped:Z(le=>{this.proxy.$updateTestStateInRun(p,M,c.TestId.fromExtHostTestItem(le,F).toString(),5)}),started:Z(le=>{this.proxy.$updateTestStateInRun(p,M,c.TestId.fromExtHostTestItem(le,F).toString(),2)}),errored:Z((le,oe,fe)=>{K(le,oe),this.proxy.$updateTestStateInRun(p,M,c.TestId.fromExtHostTestItem(le,F).toString(),6,fe)}),failed:Z((le,oe,fe)=>{K(le,oe),this.proxy.$updateTestStateInRun(p,M,c.TestId.fromExtHostTestItem(le,F).toString(),4,fe)}),passed:Z((le,oe)=>{this.proxy.$updateTestStateInRun(p,M,c.TestId.fromExtHostTestItem(le,this.dto.controllerId).toString(),3,oe)}),appendOutput:(le,oe,fe)=>{N||(fe&&(this.dto.isIncluded(fe)?this.ensureTestIsKnown(fe):fe=void 0),this.proxy.$appendOutputToRun(p,M,C.VSBuffer.fromString(le),oe&&u.location.from(oe),fe&&c.TestId.fromExtHostTestItem(fe,F).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(p,M),this.tasks.delete(M),this.isRunning||this.dispose())}};return this.tasks.set(M,{run:se,coverage:z}),this.proxy.$startedTestRunTask(p,{id:M,name:R,running:!0}),se}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof f.TestItemImpl))throw new k.InvalidTestItemError(R.id);if(this.sharedTestIds.has(c.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const p=[],F=this.dto.colllection.root;for(;;){const M=u.TestItem.from(R);if(p.unshift(M),this.sharedTestIds.has(M.extId)||(this.sharedTestIds.add(M.extId),R===F))break;R=R.parent||F}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,p)}}class i{get trackers(){return this.tracked.values()}constructor(R){this.proxy=R,this.tracked=new Map}prepareForMainThreadTestRun(R,p,F){return this.getTracker(R,p,F)}cancelRunById(R){for(const p of this.tracked.values())if(p.id===R){p.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,p,F,M,z){const Z=this.tracked.get(F);if(Z)return Z.createRun(M);const K=n.fromPublic(R,p,F,z),N=o(F);this.proxy.$startedExtensionTestRun({controllerId:R,profile:N&&{group:x[N.kind],id:N.profileId},exclude:F.exclude?.map(le=>c.TestId.fromExtHostTestItem(le,p.root.id).toString())??[],id:K.id,include:F.include?.map(le=>c.TestId.fromExtHostTestItem(le,p.root.id).toString())??[p.root.id],persist:z});const se=this.getTracker(F,K);return se.onEnd(()=>this.proxy.$finishedExtensionTestRun(K.id)),se.createRun(M)}getTracker(R,p,F){const M=new h(p,this.proxy,F);return this.tracked.set(R,M),M.onEnd(()=>this.tracked.delete(R)),M}}e.TestRunCoordinator=i;const o=$=>{if(!!$.profile){if(!($.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $.profile}};class n{static fromPublic(R,p,F,M){return new n(R,(0,S.generateUuid)(),F.include?.map(z=>c.TestId.fromExtHostTestItem(z,R).toString())??[R],F.exclude?.map(z=>c.TestId.fromExtHostTestItem(z,R).toString())??[],M,p)}static fromInternal(R,p){return new n(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,p)}constructor(R,p,F,M,z,Z){this.controllerId=R,this.id=p,this.isPersisted=z,this.colllection=Z,this.includePrefix=F.map(K=>K+"\0"),this.excludePrefix=M.map(K=>K+"\0")}isIncluded(R){const p=c.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const F of this.excludePrefix)if(p===F||p.startsWith(F))return!1;for(const F of this.includePrefix)if(p===F||p.startsWith(F))return!0;return!1}}e.TestRunDto=n;class t{set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(R,p,F){this.proxy=R,this.runId=p,this.taskId=F}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(p){throw this.fileCoverage=void 0,p}}async resolveFileCoverage(R,p){const F=await this.fileCoverage;let M=F?.[R];return!this._coverageProvider||!F||!M?[]:(M.detailedCoverage||(M=F[R]=await this._coverageProvider.resolveFileCoverage?.(M,p)??M),M.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class l extends y.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(R){this.added.add(R)}update(R){Object.assign(R.revived,u.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:p,removed:F}=this;return{get added(){return[...R].map(M=>M.revived)},get updated(){return[...p].map(M=>M.revived)},get removed(){return[...F].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class b extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new U.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,p){return{...R,revived:u.TestItem.toPlain(R.item),depth:p?p.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=b;class v{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(p=>p.revived)},dispose:(0,I.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new b;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class E{get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Re(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Re(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Re(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?u.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Re(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}constructor(R,p,F,M,z,Z,K,N=!1,se=void 0){this.controllerId=F,this.profileId=M,this._label=z,this.kind=Z,this.runHandler=K,this._isDefault=N,this._tag=se,a.set(this,void 0),D.set(this,void 0),Ye(this,a,R,"f"),Ye(this,D,p,"f"),p.set(M,this);const le=x[Z];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);Re(this,a,"f").$publishTestRunProfile({profileId:M,controllerId:F,tag:se?u.TestTag.namespace(this.controllerId,se.id):null,label:z,group:le,isDefault:N,hasConfigurationHandler:!1})}dispose(){Re(this,D,"f")?.delete(this.profileId)&&(Ye(this,D,void 0,"f"),Re(this,a,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=E,a=new WeakMap,D=new WeakMap;const x={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Ie[212],Te([1,0,15,5,4,93,8,6]),function(ee,e,s,C,g,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class w{constructor(O,S){this._extHostDocumentsAndEditors=S,this._onDidChangeTextEditorSelection=new C.Emitter,this._onDidChangeTextEditorOptions=new C.Emitter,this._onDidChangeTextEditorVisibleRanges=new C.Emitter,this._onDidChangeTextEditorViewColumn=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(g.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const S=this._extHostDocumentsAndEditors.allEditors();return O?S:S.map(m=>m.value)}async showTextDocument(O,S,m){let _;typeof S=="number"?_={position:I.ViewColumn.from(S),preserveFocus:m}:typeof S=="object"?_={position:I.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?I.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:_={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(O.uri,_),u=f&&this._extHostDocumentsAndEditors.getEditor(f);if(u)return u.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,S){return new U.TextEditorDecorationType(this._proxy,O,S).value}$acceptEditorPropertiesChanged(O,S){const m=this._extHostDocumentsAndEditors.getEditor(O);if(!m)throw new Error("unknown text editor");if(S.options&&m._acceptOptions(S.options),S.selections){const _=S.selections.selections.map(I.Selection.to);m._acceptSelections(_)}if(S.visibleRanges){const _=s.coalesce(S.visibleRanges.map(I.Range.to));m._acceptVisibleRanges(_)}if(S.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...S.options,lineNumbers:I.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const _=P.TextEditorSelectionChangeKind.fromValue(S.selections.source),f=S.selections.selections.map(I.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:f,kind:_})}if(S.visibleRanges){const _=s.coalesce(S.visibleRanges.map(I.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:_})}}$acceptEditorPositionData(O){for(const S in O){const m=this._extHostDocumentsAndEditors.getEditor(S);if(!m)throw new Error("Unknown text editor");const _=I.ViewColumn.to(O[S]);m.value.viewColumn!==_&&(m._acceptViewColumn(_),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:_}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=w}),define(Ie[213],Te([1,0,2,3,4,7,6,8,9]),function(ee,e,s,C,g,U,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class A{constructor(m,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(g.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const u=f.uri===void 0?void 0:s.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(O(u))?.get(f.handle)}return f}})}async $getTimeline(m,_,f,u){return this._providers.get(m)?.provideTimeline(s.URI.revive(_),f,u)}registerTimelineProvider(m,_,f,u){const d=new U.DisposableStore,c=this.convertTimelineItem(_.id,u,d).bind(this);let k;_.onDidChange&&(k=_.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:_.id}),this));const y=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:m,onDidChange:void 0,async provideTimeline(a,D,r){D?.resetCache&&(d.clear(),y.get(_.id)?.clear());const h=await _.provideTimeline(a,D,r);if(h==null)return;const i=c(a,D);return{...h,source:_.id,items:h.items.map(i)}},dispose(){for(const a of y.values())a.get(_.id)?.clear();k?.dispose(),d.dispose()}})}convertTimelineItem(m,_,f){return(u,d)=>{let c;if(d?.cacheResults){let k=this._itemsBySourceAndUriMap.get(m);k===void 0&&(k=new Map,this._itemsBySourceAndUriMap.set(m,k));const y=O(u);c=k.get(y),c===void 0&&(c=new Map,k.set(y,c))}return k=>{const{iconPath:y,...a}=k,D=`${m}|${k.id??k.timestamp}`;c?.set(D,k);let r,h,i;k.iconPath&&(y instanceof I.ThemeIcon?i={id:y.id,color:y.color}:s.URI.isUri(y)?(r=y,h=y):{light:r,dark:h}=y);let o;return I.MarkdownString.isMarkdownString(a.tooltip)?o=P.MarkdownString.from(a.tooltip):(0,w.isString)(a.tooltip)?o=a.tooltip:I.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=P.MarkdownString.from(a.detail)):(0,w.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=a.detail),{...a,id:a.id??void 0,handle:D,source:m,command:k.command?_.toInternal(k.command,f):void 0,icon:r,iconDark:h,themeIcon:i,tooltip:o,accessibilityInformation:k.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,U.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=A;function O(S){return S?.toString()}}),define(Ie[214],Te([1,0,7,12,2,4]),function(ee,e,s,C,g,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(w){this._openers=new Map,this._proxy=w.getProxy(U.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,A,O,S){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const m=S.schemes.find(_=>!I.supportedSchemes.has(_));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,O),this._proxy.$registerUriOpener(A,S.schemes,w,S.label),(0,s.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(w,A,O){const S=this._openers.get(w);if(!S)throw new Error(`Unknown opener with id: ${w}`);const m=g.URI.revive(A);return S.canOpenExternalUri(m,O)}async $openUri(w,A,O){const S=this._openers.get(w);if(!S)throw new Error(`Unknown opener id: '${w}'`);return S.openExternalUri(g.URI.revive(A.resolvedUri),{sourceUri:g.URI.revive(A.sourceUri)},O)}}e.ExtHostUriOpeners=I,I.supportedSchemes=new Set([C.Schemas.http,C.Schemas.https])}),define(Ie[215],Te([1,0,4,2,7,11,25]),function(ee,e,s,C,g,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(s.MainContext.MainThreadUrls)}registerUriHandler(A,O){if(this.handles.has(I.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const S=P.HandlePool++;return this.handles.add(I.ExtensionIdentifier.toKey(A)),this.handlers.set(S,O),this._proxy.$registerUriHandler(S,A),(0,g.toDisposable)(()=>{this.handles.delete(I.ExtensionIdentifier.toKey(A)),this.handlers.delete(S),this._proxy.$unregisterUriHandler(S)})}$handleExternalUri(A,O){const S=this.handlers.get(A);if(!S)return Promise.resolve(void 0);try{S.handleUri(C.URI.revive(O))}catch(m){(0,U.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(A){return C.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=P,P.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,s,C,g){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?g.call(ee,s):g?g.value=s:e.set(ee,s),s},Re=this&&this.__classPrivateFieldGet||function(ee,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[54],Te([1,0,5,12,2,144,161,66,4]),function(ee,e,s,C,g,U,I,P,w){"use strict";var A,O,S,m,_,f,u,d,c,k,y,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class D{constructor(b,v,E,x,$,R,p){A.set(this,void 0),O.set(this,void 0),S.set(this,void 0),m.set(this,void 0),_.set(this,void 0),f.set(this,void 0),u.set(this,""),d.set(this,void 0),c.set(this,!1),k.set(this,!1),y.set(this,!1),this._onMessageEmitter=new s.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new s.Emitter),this._onDidDispose=Re(this,a,"f").event,Ye(this,A,b,"f"),Ye(this,O,v,"f"),Ye(this,d,E,"f"),Ye(this,m,x,"f"),Ye(this,_,$,"f"),Ye(this,f,R,"f"),Ye(this,y,r(R),"f"),Ye(this,S,p,"f")}dispose(){Ye(this,c,!0,"f"),Re(this,a,"f").fire(),Re(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Ye(this,k,!0,"f"),(0,P.asWebviewUri)(b,Re(this,m,"f"))}get cspSource(){const b=Re(this,f,"f").extensionLocation;if(b.scheme===C.Schemas.https||b.scheme===C.Schemas.http){let v=b.toString();return v.endsWith("/")||(v+="/"),v+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Re(this,u,"f")}set html(b){this.assertNotDisposed(),Re(this,u,"f")!==b&&(Ye(this,u,b,"f"),!Re(this,k,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Ye(this,k,!0,"f"),Re(this,S,"f").report("Webview vscode-resource: uris",Re(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Re(this,O,"f").$setHtml(Re(this,A,"f"),b))}get options(){return this.assertNotDisposed(),Re(this,d,"f")}set options(b){this.assertNotDisposed(),Re(this,O,"f").$setOptions(Re(this,A,"f"),o(Re(this,f,"f"),Re(this,_,"f"),b)),Ye(this,d,b,"f")}async postMessage(b){if(Re(this,c,"f"))return!1;const v=(0,I.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Re(this,y,"f")});return Re(this,O,"f").$postMessage(Re(this,A,"f"),v.message,...v.buffers)}assertNotDisposed(){if(Re(this,c,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=D,A=new WeakMap,O=new WeakMap,S=new WeakMap,m=new WeakMap,_=new WeakMap,f=new WeakMap,u=new WeakMap,d=new WeakMap,c=new WeakMap,k=new WeakMap,y=new WeakMap,a=new WeakMap;function r(l){try{const b=(0,U.normalizeVersion)((0,U.parseVersion)(l.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;class h{constructor(b,v,E,x,$){this.remoteInfo=v,this.workspace=E,this._logService=x,this._deprecationService=$,this._webviews=new Map,this._webviewProxy=b.getProxy(w.MainContext.MainThreadWebviews)}$onMessage(b,v,E){const x=this.getWebview(b);if(x){const{message:$}=(0,I.deserializeWebviewMessage)(v,E.value);x._onMessageEmitter.fire($)}}$onMissingCsp(b,v){this._logService.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,v,E){const x=new D(b,this._webviewProxy,n(v),this.remoteInfo,this.workspace,E,this._deprecationService);return this._webviews.set(b,x),x._onDidDispose(()=>{this._webviews.delete(b)}),x}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=h;function i(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=i;function o(l,b,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||t(l,b)}}e.serializeWebviewOptions=o;function n(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(b=>g.URI.from(b))}}e.reviveOptions=n;function t(l,b){return[...(b?.getWorkspaceFolders()||[]).map(v=>v.uri),l.extensionLocation]}}),define(Ie[216],Te([1,0,20,96,7,12,21,2,8,54,63,4,6]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class _{constructor(r,h){this.document=r,this._storagePath=h,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,h){await this.getEdit(r).undo(),h||this.disposeBackup()}async redo(r,h){await this.getEdit(r).redo(),h||this.disposeBackup()}disposeEdits(r){for(const h of r)this._edits.delete(h)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=a(this.document.uri)+this._backupCounter++;return(0,I.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const h=this._edits.get(r,0);if(!h)throw new Error("No edit found");return h}}class f{constructor(){this._documents=new Map}get(r,h){return this._documents.get(this.key(r,h))}add(r,h,i){const o=this.key(r,h.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${r} resource:${h.uri}`);const n=new _(h,i);return this._documents.set(o,n),n}delete(r,h){const i=this.key(r,h.uri);this._documents.delete(i)}key(r,h){return`${r}@@@${h}`}}var u;(function(D){D[D.Text=0]="Text",D[D.Custom=1]="Custom"})(u||(u={}));class d{constructor(){this._providers=new Map}addTextProvider(r,h,i){return this.add(0,r,h,i)}addCustomProvider(r,h,i){return this.add(1,r,h,i)}get(r){return this._providers.get(r)}add(r,h,i,o){if(this._providers.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this._providers.set(h,{type:r,extension:i,provider:o}),new m.Disposable(()=>this._providers.delete(h))}}class c{constructor(r,h,i,o,n){this._extHostDocuments=h,this._extensionStoragePaths=i,this._extHostWebview=o,this._extHostWebviewPanels=n,this._editorProviders=new d,this._documents=new f,this._proxy=r.getProxy(S.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,h,i,o){const n=new g.DisposableStore;return k(i)?(n.add(this._editorProviders.addTextProvider(h,r,i)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(r),h,o.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(r))):(n.add(this._editorProviders.addCustomProvider(h,r,i)),this.supportEditing(i)&&n.add(i.onDidChangeCustomDocument(t=>{const l=this.getCustomDocumentEntry(h,t.document.uri);if(y(t)){const b=l.addEdit(t);this._proxy.$onDidEdit(t.document.uri,h,b,t.label)}else this._proxy.$onContentChange(t.document.uri,h)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(r),h,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(r))),m.Disposable.from(n,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(h)}))}async $createCustomDocument(r,h,i,o,n){const t=this._editorProviders.get(h);if(!t)throw new Error(`No provider found for '${h}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${h}'`);const l=P.URI.revive(r),b=await t.provider.openCustomDocument(l,{backupId:i,untitledDocumentData:o?.buffer},n);let v;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(v=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(h,b,v),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(r,h){const i=this._editorProviders.get(h);if(!i)throw new Error(`No provider found for '${h}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${h}'`);const o=P.URI.revive(r),{document:n}=this.getCustomDocumentEntry(h,o);this._documents.delete(h,n),n.dispose()}async $resolveWebviewEditor(r,h,i,o,n,t){const l=this._editorProviders.get(i);if(!l)throw new Error(`No provider found for '${i}'`);const b=w.ViewColumn.to(n),v=this._extHostWebview.createNewWebview(h,o.webviewOptions,l.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(h,i,o.title,b,o.panelOptions,v,!0),x=P.URI.revive(r);switch(l.type){case 1:{const{document:$}=this.getCustomDocumentEntry(i,x);return l.provider.resolveCustomEditor($,E,t)}case 0:{const $=this._extHostDocuments.getDocument(x);return l.provider.resolveCustomTextEditor($,E,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,h,i){this.getCustomDocumentEntry(h,r).disposeEdits(i)}async $onMoveCustomEditor(r,h,i){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const n=this._extHostWebviewPanels.getWebviewPanel(r);if(!n)throw new Error("No webview found");const t=P.URI.revive(h),l=this._extHostDocuments.getDocument(t);await o.provider.moveCustomTextEditor(l,n,s.CancellationToken.None)}async $undo(r,h,i,o){return this.getCustomDocumentEntry(h,r).undo(i,o)}async $redo(r,h,i,o){return this.getCustomDocumentEntry(h,r).redo(i,o)}async $revert(r,h,i){const o=this.getCustomDocumentEntry(h,r);await this.getCustomEditorProvider(h).revertCustomDocument(o.document,i),o.disposeBackup()}async $onSave(r,h,i){const o=this.getCustomDocumentEntry(h,r);await this.getCustomEditorProvider(h).saveCustomDocument(o.document,i),o.disposeBackup()}async $onSaveAs(r,h,i,o){const n=this.getCustomDocumentEntry(h,r);return this.getCustomEditorProvider(h).saveCustomDocumentAs(n.document,P.URI.revive(i),o)}async $backup(r,h,i){const o=this.getCustomDocumentEntry(h,r),t=await this.getCustomEditorProvider(h).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},i);return o.updateBackup(t),t.id}getCustomDocumentEntry(r,h){const i=this._documents.get(r,P.URI.revive(h));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(r){const i=this._editorProviders.get(r)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(r){return!!r.onDidChangeCustomDocument}}e.ExtHostCustomEditors=c;function k(D){return typeof D.resolveCustomTextEditor=="function"}function y(D){return typeof D.undo=="function"&&typeof D.redo=="function"}function a(D){const r=D.scheme===U.Schemas.file||D.scheme===U.Schemas.untitled?D.fsPath:D.toString();return(0,C.hash)(r)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,s,C,g){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?g.call(ee,s):g?g.value=s:e.set(ee,s),s},Re=this&&this.__classPrivateFieldGet||function(ee,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[217],Te([1,0,5,7,2,44,8,54,4,6]),function(ee,e,s,C,g,U,I,P,w,A){"use strict";var O,S,m,_,f,u,d,c,k,y,a,D,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class h extends C.Disposable{constructor(t,l,b,v){super();O.set(this,void 0),S.set(this,void 0),m.set(this,void 0),_.set(this,void 0),f.set(this,void 0),u.set(this,void 0),d.set(this,void 0),c.set(this,void 0),k.set(this,!0),y.set(this,void 0),a.set(this,!1),D.set(this,this._register(new s.Emitter)),this.onDidDispose=Re(this,D,"f").event,r.set(this,this._register(new s.Emitter)),this.onDidChangeViewState=Re(this,r,"f").event,Ye(this,O,t,"f"),Ye(this,S,l,"f"),Ye(this,_,b,"f"),Ye(this,m,v.viewType,"f"),Ye(this,f,v.panelOptions,"f"),Ye(this,c,v.viewColumn,"f"),Ye(this,u,v.title,"f"),Ye(this,y,v.active,"f")}dispose(){Re(this,a,"f")||(Ye(this,a,!0,"f"),Re(this,D,"f").fire(),Re(this,S,"f").$disposeWebview(Re(this,O,"f")),Re(this,_,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Re(this,_,"f")}get viewType(){return this.assertNotDisposed(),Re(this,m,"f")}get title(){return this.assertNotDisposed(),Re(this,u,"f")}set title(t){this.assertNotDisposed(),Re(this,u,"f")!==t&&(Ye(this,u,t,"f"),Re(this,S,"f").$setTitle(Re(this,O,"f"),t))}get iconPath(){return this.assertNotDisposed(),Re(this,d,"f")}set iconPath(t){this.assertNotDisposed(),Re(this,d,"f")!==t&&(Ye(this,d,t,"f"),Re(this,S,"f").$setIconPath(Re(this,O,"f"),g.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Re(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Re(this,c,"f")=="number"&&Re(this,c,"f")<0))return Re(this,c,"f")}get active(){return this.assertNotDisposed(),Re(this,y,"f")}get visible(){return this.assertNotDisposed(),Re(this,k,"f")}_updateViewState(t){Re(this,a,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Ye(this,y,t.active,"f"),Ye(this,k,t.visible,"f"),Ye(this,c,t.viewColumn,"f"),Re(this,r,"f").fire({webviewPanel:this}))}reveal(t,l){this.assertNotDisposed(),Re(this,S,"f").$reveal(Re(this,O,"f"),{viewColumn:typeof t=="undefined"?void 0:I.ViewColumn.from(t),preserveFocus:!!l})}assertNotDisposed(){if(Re(this,a,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,S=new WeakMap,m=new WeakMap,_=new WeakMap,f=new WeakMap,u=new WeakMap,d=new WeakMap,c=new WeakMap,k=new WeakMap,y=new WeakMap,a=new WeakMap,D=new WeakMap,r=new WeakMap;class i{static newHandle(){return(0,U.generateUuid)()}constructor(t,l,b){this.webviews=l,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(w.MainContext.MainThreadWebviewPanels)}createWebviewPanel(t,l,b,v,E={}){const x=typeof v=="object"?v.viewColumn:v,$={viewColumn:I.ViewColumn.from(x),preserveFocus:typeof v=="object"&&!!v.preserveFocus},R=(0,P.shouldSerializeBuffersForPostMessage)(t),p=i.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(t),p,l,{title:b,panelOptions:o(E),webviewOptions:(0,P.serializeWebviewOptions)(t,this.workspace,E),serializeBuffersForPostMessage:R},$);const F=this.webviews.createNewWebview(p,E,t);return this.createNewWebviewPanel(p,l,b,x,E,F,!0)}$onDidChangeWebviewPanelViewStates(t){const l=Object.keys(t);l.sort((b,v)=>{const E=t[b],x=t[v];return E.active?1:x.active?-1:+E.visible-+x.visible});for(const b of l){const v=this.getWebviewPanel(b);if(!v)continue;const E=t[b];v._updateViewState({active:E.active,visible:E.visible,viewColumn:I.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,l,b){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:b,extension:t}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(t,l,b,v){const E=this._serializers.get(l);if(!E)throw new Error(`No serializer found for '${l}'`);const{serializer:x,extension:$}=E,R=this.webviews.createNewWebview(t,b.webviewOptions,$),p=this.createNewWebviewPanel(t,l,b.title,v,b.panelOptions,R,b.active);await x.deserializeWebviewPanel(p,b.state)}createNewWebviewPanel(t,l,b,v,E,x,$){const R=new h(t,this._proxy,x,{viewType:l,title:b,viewColumn:v,panelOptions:E,active:$});return this._webviewPanels.set(t,R),R}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=i;function o(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,s,C,g){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?g.call(ee,s):g?g.value=s:e.set(ee,s),s},Re=this&&this.__classPrivateFieldGet||function(ee,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[218],Te([1,0,5,7,54,26,8,4,6]),function(ee,e,s,C,g,U,I,P,w){"use strict";var A,O,S,m,_,f,u,d,c,k,y,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class D extends C.Disposable{constructor(i,o,n,t,l,b,v){super();A.set(this,void 0),O.set(this,void 0),S.set(this,void 0),m.set(this,void 0),_.set(this,void 0),f.set(this,!1),u.set(this,void 0),d.set(this,void 0),c.set(this,void 0),k.set(this,void 0),y.set(this,this._register(new s.Emitter)),this.onDidChangeVisibility=Re(this,y,"f").event,a.set(this,this._register(new s.Emitter)),this.onDidDispose=Re(this,a,"f").event,Ye(this,S,n,"f"),Ye(this,d,t,"f"),Ye(this,A,i,"f"),Ye(this,O,o,"f"),Ye(this,m,l,"f"),Ye(this,_,b,"f"),Ye(this,u,v,"f")}dispose(){Re(this,f,"f")||(Ye(this,f,!0,"f"),Re(this,a,"f").fire(),Re(this,m,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Re(this,d,"f")}set title(i){this.assertNotDisposed(),Re(this,d,"f")!==i&&(Ye(this,d,i,"f"),Re(this,O,"f").$setWebviewViewTitle(Re(this,A,"f"),i))}get description(){return this.assertNotDisposed(),Re(this,c,"f")}set description(i){this.assertNotDisposed(),Re(this,c,"f")!==i&&(Ye(this,c,i,"f"),Re(this,O,"f").$setWebviewViewDescription(Re(this,A,"f"),i))}get visible(){return Re(this,u,"f")}get webview(){return Re(this,m,"f")}get viewType(){return Re(this,S,"f")}_setVisible(i){i===Re(this,u,"f")||Re(this,f,"f")||(Ye(this,u,i,"f"),Re(this,y,"f").fire())}get badge(){return this.assertNotDisposed(),(0,U.checkProposedApiEnabled)(Re(this,_,"f"),"badges"),Re(this,k,"f")}set badge(i){this.assertNotDisposed(),(0,U.checkProposedApiEnabled)(Re(this,_,"f"),"badges"),!(i?.value===Re(this,k,"f")?.value&&i?.tooltip===Re(this,k,"f")?.tooltip)&&(Ye(this,k,I.ViewBadge.from(i),"f"),Re(this,O,"f").$setWebviewViewBadge(Re(this,A,"f"),i))}show(i){this.assertNotDisposed(),Re(this,O,"f").$show(Re(this,A,"f"),!!i)}assertNotDisposed(){if(Re(this,f,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,O=new WeakMap,S=new WeakMap,m=new WeakMap,_=new WeakMap,f=new WeakMap,u=new WeakMap,d=new WeakMap,c=new WeakMap,k=new WeakMap,y=new WeakMap,a=new WeakMap;class r{constructor(i,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,o,n,t){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:n,extension:i}),this._proxy.$registerWebviewViewProvider((0,g.toExtensionData)(i),o,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.shouldSerializeBuffersForPostMessage)(i)}),new w.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(i,o,n,t,l){const b=this._viewProviders.get(o);if(!b)throw new Error(`No view provider found for '${o}'`);const{provider:v,extension:E}=b,x=this._extHostWebview.createNewWebview(i,{},E),$=new D(i,this._proxy,o,n,x,E,!0);this._webviewViews.set(i,$),await v.resolveWebviewView($,{state:t},l)}async $onDidChangeWebviewViewVisibility(i,o){this.getWebviewView(i)._setVisible(o)}async $disposeWebviewView(i){const o=this.getWebviewView(i);this._webviewViews.delete(i),o.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const o=this._webviewViews.get(i);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=r}),define(Ie[97],Te([1,0,5,4,2,12,10,3,16]),function(ee,e,s,C,g,U,I,P,w){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let O=A=class{get state(){return this._state}constructor(m){this._onDidChangeWindowState=new s.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=A.InitialState,this._proxy=m.getProxy(C.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(_=>this.$onDidChangeWindowFocus(_))}$onDidChangeWindowFocus(m){m!==this._state.focused&&(this._state={...this._state,focused:m},this._onDidChangeWindowState.fire(this._state))}openUri(m,_){let f;if(typeof m=="string"){f=m;try{m=g.URI.parse(m)}catch{return Promise.reject(`Invalid uri - '${m}'`)}}return(0,I.isFalsyOrWhitespace)(m.scheme)?Promise.reject("Invalid scheme - cannot be empty"):m.scheme===U.Schemas.command?Promise.reject(`Invalid scheme '${m.scheme}'`):this._proxy.$openUri(m,f,_)}async asExternalUri(m,_){if((0,I.isFalsyOrWhitespace)(m.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(m,_);return g.URI.from(f)}};e.ExtHostWindow=O,O.InitialState={focused:!0},e.ExtHostWindow=O=A=$e([We(0,w.IExtHostRpcService)],O),e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(Ie[219],Te([1,0,13,23,20,11,5,7,112,184,40]),function(ee,e,s,C,g,U,I,P,w,A,O){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(E,x){try{return JSON.stringify(E,x)}catch{return"null"}}const _="$$ref$$",f={[_]:-1};class u{constructor(x,$){this.jsonString=x,this.referencedBuffers=$}}function d(E,x=null,$=!1){const R=[];return{jsonString:($?m:JSON.stringify)(E,(F,M)=>{if(typeof M=="undefined")return f;if(typeof M=="object"){if(M instanceof C.VSBuffer){const z=R.push(M)-1;return{[_]:z}}if(x)return x(F,M)}return M}),referencedBuffers:R}}e.stringifyJsonWithBufferRefs=d;function c(E,x,$){return JSON.parse(E,(R,p)=>{if(p){const F=p[_];if(typeof F=="number")return x[F];if($&&p.$mid===1)return $.transformIncoming(p)}return p})}e.parseJsonAndRestoreBufferRefs=c;function k(E,x){return JSON.stringify(E,x)}function y(E){return E?(x,$)=>$&&$.$mid===1?E.transformOutgoing($):$:null}var a;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var D;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(D||(e.ResponsiveState=D={}));const r=()=>{},h=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class o extends P.Disposable{constructor(x,$=null,R=null){super();this[S]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=x,this._logger=$,this._uriTransformer=R,this._uriReplacer=y(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let p=0,F=O.ProxyIdentifier.count;p<F;p++)this._locals[p]=null,this._proxies[p]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new s.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(p=>this._receiveOneMessage(p))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(x=>{this._pendingRPCReplies[x].resolveErr(U.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(x){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(x){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(x){this._responsiveState!==x&&(this._responsiveState=x,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(x){return this._uriTransformer?(0,w.transformIncomingURIs)(x,this._uriTransformer):x}getProxy(x){const{nid:$,sid:R}=x;return this._proxies[$]||(this._proxies[$]=this._createProxy($,R)),this._proxies[$]}_createProxy(x,$){let R={get:(p,F)=>(typeof F=="string"&&!p[F]&&F.charCodeAt(0)===36&&(p[F]=(...M)=>this._remoteCall(x,F,M)),F===i?$:p[F])};return new Proxy(Object.create(null),R)}set(x,$){return this._locals[x.nid]=$,$}assertRegistered(x){for(let $=0,R=x.length;$<R;$++){const p=x[$];if(!this._locals[p.nid])throw new Error(`Missing proxy instance ${p.sid}`)}}_receiveOneMessage(x){if(this._isDisposed)return;const $=x.byteLength,R=n.read(x,0),p=R.readUInt8(),F=R.readUInt32();switch(p){case 1:case 2:{let{rpcId:M,method:z,args:Z}=l.deserializeRequestJSONArgs(R);this._uriTransformer&&(Z=(0,w.transformIncomingURIs)(Z,this._uriTransformer)),this._receiveRequest($,F,M,z,Z,p===2);break}case 3:case 4:{let{rpcId:M,method:z,args:Z}=l.deserializeRequestMixedArgs(R);this._uriTransformer&&(Z=(0,w.transformIncomingURIs)(Z,this._uriTransformer)),this._receiveRequest($,F,M,z,Z,p===4);break}case 5:{this._logger&&this._logger.logIncoming($,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel($,F);break}case 7:{this._receiveReply($,F,void 0);break}case 9:{let M=l.deserializeReplyOKJSON(R);this._uriTransformer&&(M=(0,w.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply($,F,M);break}case 10:{const M=l.deserializeReplyOKJSONWithBuffers(R,this._uriTransformer);this._receiveReply($,F,M);break}case 8:{let M=l.deserializeReplyOKVSBuffer(R);this._receiveReply($,F,M);break}case 11:{let M=l.deserializeReplyErrError(R);this._uriTransformer&&(M=(0,w.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr($,F,M);break}case 12:{this._receiveReplyErr($,F,void 0);break}default:console.error("received unexpected message"),console.error(x)}}_receiveRequest(x,$,R,p,F,M){this._logger&&this._logger.logIncoming(x,$,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(R)}.${p}(`,F);const z=String($);let Z,K;if(M){const se=new g.CancellationTokenSource;F.push(se.token),Z=this._invokeHandler(R,p,F),K=()=>se.cancel()}else Z=this._invokeHandler(R,p,F),K=r;this._cancelInvokedHandlers[z]=K;const N=l.serializeAcknowledged($);this._logger&&this._logger.logOutgoing(N.byteLength,$,1,"ack"),this._protocol.send(N),Z.then(se=>{delete this._cancelInvokedHandlers[z];const le=l.serializeReplyOK($,se,this._uriReplacer);this._logger&&this._logger.logOutgoing(le.byteLength,$,1,"reply:",se),this._protocol.send(le)},se=>{delete this._cancelInvokedHandlers[z];const le=l.serializeReplyErr($,se);this._logger&&this._logger.logOutgoing(le.byteLength,$,1,"replyErr:",se),this._protocol.send(le)})}_receiveCancel(x,$){this._logger&&this._logger.logIncoming(x,$,1,"receiveCancel");const R=String($);this._cancelInvokedHandlers[R]&&this._cancelInvokedHandlers[R]()}_receiveReply(x,$,R){this._logger&&this._logger.logIncoming(x,$,0,"receiveReply:",R);const p=String($);if(!this._pendingRPCReplies.hasOwnProperty(p))return;const F=this._pendingRPCReplies[p];delete this._pendingRPCReplies[p],F.resolveOk(R)}_receiveReplyErr(x,$,R){this._logger&&this._logger.logIncoming(x,$,0,"receiveReplyErr:",R);const p=String($);if(!this._pendingRPCReplies.hasOwnProperty(p))return;const F=this._pendingRPCReplies[p];delete this._pendingRPCReplies[p];let M;R&&(R.$isError?(M=new Error,M.name=R.name,M.message=R.message,M.stack=R.stack):M=R),F.resolveErr(M)}_invokeHandler(x,$,R){try{return Promise.resolve(this._doInvokeHandler(x,$,R))}catch(p){return Promise.reject(p)}}_doInvokeHandler(x,$,R){const p=this._locals[x];if(!p)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(x));let F=p[$];if(typeof F!="function")throw new Error("Unknown method "+$+" on actor "+(0,O.getStringIdentifierForProxy)(x));return F.apply(p,R)}_remoteCall(x,$,R){if(this._isDisposed)return Promise.reject(U.canceled());let p=null;if(R.length>0&&g.CancellationToken.isCancellationToken(R[R.length-1])&&(p=R.pop()),p&&p.isCancellationRequested)return Promise.reject(U.canceled());const F=l.serializeRequestArguments(R,this._uriReplacer),M=++this._lastMessageId,z=String(M),Z=new A.LazyPromise;p&&p.onCancellationRequested(()=>{const N=l.serializeCancel(M);this._logger&&this._logger.logOutgoing(N.byteLength,M,0,"cancel"),this._protocol.send(l.serializeCancel(M))}),this._pendingRPCReplies[z]=Z,this._onWillSendRequest(M);const K=l.serializeRequest(M,x,$,F,!!p);return this._logger&&this._logger.logOutgoing(K.byteLength,M,0,`request: ${(0,O.getStringIdentifierForProxy)(x)}.${$}(`,R),this._protocol.send(K),Z}}e.RPCProtocol=o,S=h,o.UNRESPONSIVE_TIME=3*1e3;class n{static alloc(x,$,R){let p=new n(C.VSBuffer.alloc(R+1+4),0);return p.writeUInt8(x),p.writeUInt32($),p}static read(x,$){return new n(x,$)}get buffer(){return this._buff}constructor(x,$){this._buff=x,this._offset=$}static sizeUInt8(){return 1}writeUInt8(x){this._buff.writeUInt8(x,this._offset),this._offset+=1}readUInt8(){const x=this._buff.readUInt8(this._offset);return this._offset+=1,x}writeUInt32(x){this._buff.writeUInt32BE(x,this._offset),this._offset+=4}readUInt32(){const x=this._buff.readUInt32BE(this._offset);return this._offset+=4,x}static sizeShortString(x){return 1+x.byteLength}writeShortString(x){this._buff.writeUInt8(x.byteLength,this._offset),this._offset+=1,this._buff.set(x,this._offset),this._offset+=x.byteLength}readShortString(){const x=this._buff.readUInt8(this._offset);this._offset+=1;const R=this._buff.slice(this._offset,this._offset+x).toString();return this._offset+=x,R}static sizeLongString(x){return 4+x.byteLength}writeLongString(x){this._buff.writeUInt32BE(x.byteLength,this._offset),this._offset+=4,this._buff.set(x,this._offset),this._offset+=x.byteLength}readLongString(){const x=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+x).toString();return this._offset+=x,R}writeBuffer(x){this._buff.writeUInt32BE(x.byteLength,this._offset),this._offset+=4,this._buff.set(x,this._offset),this._offset+=x.byteLength}static sizeVSBuffer(x){return 4+x.byteLength}writeVSBuffer(x){this._buff.writeUInt32BE(x.byteLength,this._offset),this._offset+=4,this._buff.set(x,this._offset),this._offset+=x.byteLength}readVSBuffer(){const x=this._buff.readUInt32BE(this._offset);this._offset+=4;const $=this._buff.slice(this._offset,this._offset+x);return this._offset+=x,$}static sizeMixedArray(x){let $=0;$+=1;for(let R=0,p=x.length;R<p;R++){const F=x[R];switch($+=1,F.type){case 1:$+=this.sizeLongString(F.value);break;case 2:$+=this.sizeVSBuffer(F.value);break;case 3:$+=this.sizeUInt32,$+=this.sizeLongString(F.value);for(let M=0;M<F.buffers.length;++M)$+=this.sizeVSBuffer(F.buffers[M]);break;case 4:break}}return $}writeMixedArray(x){this._buff.writeUInt8(x.length,this._offset),this._offset+=1;for(let $=0,R=x.length;$<R;$++){const p=x[$];switch(p.type){case 1:this.writeUInt8(1),this.writeLongString(p.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(p.value);break;case 3:this.writeUInt8(3),this.writeUInt32(p.buffers.length),this.writeLongString(p.value);for(let F=0;F<p.buffers.length;++F)this.writeBuffer(p.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const x=this._buff.readUInt8(this._offset);this._offset+=1;let $=new Array(x);for(let R=0;R<x;R++)switch(this.readUInt8()){case 1:$[R]=this.readLongString();break;case 2:$[R]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),M=this.readLongString(),z=[];for(let Z=0;Z<F;++Z)z.push(this.readVSBuffer());$[R]=new O.SerializableObjectWithBuffers(c(M,z,null));break}case 4:$[R]=void 0;break}return $}}n.sizeUInt32=4;var t;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(t||(t={}));class l{static _useMixedArgSerialization(x){for(let $=0,R=x.length;$<R;$++)if(x[$]instanceof C.VSBuffer||x[$]instanceof O.SerializableObjectWithBuffers||typeof x[$]=="undefined")return!0;return!1}static serializeRequestArguments(x,$){if(this._useMixedArgSerialization(x)){const R=[];for(let p=0,F=x.length;p<F;p++){const M=x[p];if(M instanceof C.VSBuffer)R[p]={type:2,value:M};else if(typeof M=="undefined")R[p]={type:4};else if(M instanceof O.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:Z}=d(M.value,$);R[p]={type:3,value:C.VSBuffer.fromString(z),buffers:Z}}else R[p]={type:1,value:C.VSBuffer.fromString(k(M,$))}}return{type:1,args:R}}return{type:0,args:k(x,$)}}static serializeRequest(x,$,R,p,F){switch(p.type){case 0:return this._requestJSONArgs(x,$,R,p.args,F);case 1:return this._requestMixedArgs(x,$,R,p.args,F)}}static _requestJSONArgs(x,$,R,p,F){const M=C.VSBuffer.fromString(R),z=C.VSBuffer.fromString(p);let Z=0;Z+=n.sizeUInt8(),Z+=n.sizeShortString(M),Z+=n.sizeLongString(z);let K=n.alloc(F?2:1,x,Z);return K.writeUInt8($),K.writeShortString(M),K.writeLongString(z),K.buffer}static deserializeRequestJSONArgs(x){const $=x.readUInt8(),R=x.readShortString(),p=x.readLongString();return{rpcId:$,method:R,args:JSON.parse(p)}}static _requestMixedArgs(x,$,R,p,F){const M=C.VSBuffer.fromString(R);let z=0;z+=n.sizeUInt8(),z+=n.sizeShortString(M),z+=n.sizeMixedArray(p);let Z=n.alloc(F?4:3,x,z);return Z.writeUInt8($),Z.writeShortString(M),Z.writeMixedArray(p),Z.buffer}static deserializeRequestMixedArgs(x){const $=x.readUInt8(),R=x.readShortString(),p=x.readMixedArray(),F=new Array(p.length);for(let M=0,z=p.length;M<z;M++){const Z=p[M];typeof Z=="string"?F[M]=JSON.parse(Z):F[M]=Z}return{rpcId:$,method:R,args:F}}static serializeAcknowledged(x){return n.alloc(5,x,0).buffer}static serializeCancel(x){return n.alloc(6,x,0).buffer}static serializeReplyOK(x,$,R){if(typeof $=="undefined")return this._serializeReplyOKEmpty(x);if($ instanceof C.VSBuffer)return this._serializeReplyOKVSBuffer(x,$);if($ instanceof O.SerializableObjectWithBuffers){const{jsonString:p,referencedBuffers:F}=d($.value,R,!0);return this._serializeReplyOKJSONWithBuffers(x,p,F)}else return this._serializeReplyOKJSON(x,m($,R))}static _serializeReplyOKEmpty(x){return n.alloc(7,x,0).buffer}static _serializeReplyOKVSBuffer(x,$){let R=0;R+=n.sizeVSBuffer($);let p=n.alloc(8,x,R);return p.writeVSBuffer($),p.buffer}static deserializeReplyOKVSBuffer(x){return x.readVSBuffer()}static _serializeReplyOKJSON(x,$){const R=C.VSBuffer.fromString($);let p=0;p+=n.sizeLongString(R);let F=n.alloc(9,x,p);return F.writeLongString(R),F.buffer}static _serializeReplyOKJSONWithBuffers(x,$,R){const p=C.VSBuffer.fromString($);let F=0;F+=n.sizeUInt32,F+=n.sizeLongString(p);for(const z of R)F+=n.sizeVSBuffer(z);let M=n.alloc(10,x,F);M.writeUInt32(R.length),M.writeLongString(p);for(const z of R)M.writeBuffer(z);return M.buffer}static deserializeReplyOKJSON(x){const $=x.readLongString();return JSON.parse($)}static deserializeReplyOKJSONWithBuffers(x,$){const R=x.readUInt32(),p=x.readLongString(),F=[];for(let M=0;M<R;++M)F.push(x.readVSBuffer());return new O.SerializableObjectWithBuffers(c(p,F,$))}static serializeReplyErr(x,$){const R=$?m(U.transformErrorForSerialization($),null):void 0;if(typeof R!="string")return this._serializeReplyErrEmpty(x);const p=C.VSBuffer.fromString(R);let F=0;F+=n.sizeLongString(p);let M=n.alloc(11,x,F);return M.writeLongString(p),M.buffer}static deserializeReplyErrError(x){const $=x.readLongString();return JSON.parse($)}static _serializeReplyErrEmpty(x){return n.alloc(12,x,0).buffer}}var b;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var v;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(v||(v={}))}),define(Ie[220],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const s=function(U){const I=P=>{self.removeEventListener("message",I);const w=P.data;Object.defineProperties(self,{postMessage:{value(A,O){w.postMessage(A,O)}},onmessage:{get(){return w.onmessage},set(A){w.onmessage=A}}}),w.addEventListener("message",A=>{self.dispatchEvent(new MessageEvent("message",{data:A.data}))}),w.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(U)};self.addEventListener("message",I)}.toString();class C extends EventTarget{constructor(U,I,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const w=`((${s})('${I}'))`,A=new Blob([w],{type:"application/javascript"}),O=URL.createObjectURL(A),S=new MessageChannel,m=O,_={type:"_newWorker",id:m,port:S.port2,url:O,options:P};U(_,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{U({type:"_terminateWorker",id:m}),URL.revokeObjectURL(O),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(f){S.port1.onmessage=f}},onmessageerror:{get(){return S.port1.onmessageerror},set(f){S.port1.onmessageerror=f}}}),S.port1.addEventListener("messageerror",f=>{const u=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(u)}),S.port1.addEventListener("message",f=>{const u=new MessageEvent("message",{data:f.data});this.dispatchEvent(u)}),S.port1.start()}}e.NestedWorker=C}),define(Ie[221],Te([1,0,5,30,38,3,39,11,13]),function(ee,e,s,C,g,U,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new g.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new g.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new g.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,U.createDecorator)(e.OUTPUT_SERVICE_ID);var A;(function(_){_[_.Append=1]="Append",_[_.Replace=2]="Replace",_[_.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.channels=new Map,this._onDidRegisterChannel=new s.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new s.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(u=>f.push(u)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}C.Registry.add(e.Extensions.OutputChannels,new O);function S(_,f,u,d,c){return(0,w.createCancelablePromise)(async k=>{await(0,I.whenProviderRegistered)(u,d);const y=C.Registry.as(e.Extensions.OutputChannels);try{await m(u,1,d,c,k),y.registerChannel({id:_,label:f,file:u,log:!0})}catch(a){(0,P.isCancellationError)(a)||c.error("Error while registering log channel",u.toString(),(0,P.getErrorMessage)(a))}})}e.registerLogChannel=S;async function m(_,f,u,d,c){if(!await u.exists(_)){if(c.isCancellationRequested)throw new P.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");d.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",_.toString()),await(0,w.timeout)(1e3,c),await m(_,f+1,u,d,c)}}}),define(Ie[98],Te([1,0,4,7,3,16,14,221,52,28,35,117,23,9]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends C.Disposable{get disposed(){return this._disposed}constructor(c,k,y,a){super();this.id=c,this.name=k,this.logger=y,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}appendLine(c){this.append(c+`
`)}append(c){this.write(c),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const c=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,c)}replace(c){const k=this.offset;this.write(c),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,k),this.visible&&this.logger.flush()}show(c,k){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof c=="boolean"?c:k))}hide(){this.proxy.$close(this.id)}write(c){this.offset+=m.VSBuffer.fromString(c).byteLength,this.logger.info(c)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let u=class{constructor(c,k,y,a,D){this.extHostFileSystem=y,this.extHostFileSystemInfo=a,this.loggerService=D,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=c.getProxy(s.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(k.logsLocation,`output_logging_${(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(c){this.visibleChannelId=c;for(const[k,y]of this.channels)y.visible=k===this.visibleChannelId}createOutputChannel(c,k,y){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if((0,_.isString)(k)&&!k.trim())throw new Error("illegal argument `languageId`. must not be empty");const a=this.doCreateOutputChannel(c,k,y);return a.then(D=>{this.channels.set(D.id,D),D.visible=D.id===this.visibleChannelId}),this.createExtHostOutputChannel(c,a)}async doCreateOutputChannel(c,k,y){const a=await this.createOutputDirectory(),D=this.extHostFileSystemInfo.extUri.joinPath(a,`${this.namePool++}-${c.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(D,{always:!0,donotRotate:!0,donotUseFormatters:!0}),h=await this.proxy.$register(c,!1,D,k,y.identifier.value);return new f(h,c,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(c,k){let y=!1;const a=()=>{if(y)throw new Error("Channel has been closed")};return{get name(){return c},append(D){a(),k.then(r=>r.append(D))},appendLine(D){a(),k.then(r=>r.appendLine(D))},clear(){a(),k.then(D=>D.clear())},replace(D){a(),k.then(r=>r.replace(D))},show(D,r){a(),k.then(h=>h.show(D,r))},hide(){a(),k.then(D=>D.hide())},dispose(){y=!0,k.then(D=>D.dispose())}}}};e.ExtHostOutputService=u,e.ExtHostOutputService=u=$e([We(0,U.IExtHostRpcService),We(1,A.IExtHostInitDataService),We(2,w.IExtHostConsumerFileSystem),We(3,O.IExtHostFileSystemInfo),We(4,I.ILoggerService)],u),e.IExtHostOutputService=(0,g.createDecorator)("IExtHostOutputService")}),define(Ie[222],Te([1,0,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,s.createDecorator)("remoteAgentService")}),define(Ie[223],Te([1,0,37,12,19,22,21,2,3,156,46,176,222]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,w.createDecorator)("pathService");let f=_=class{constructor(d,c,k,y){this.localUserHome=d,this.remoteAgentService=c,this.environmentService=k,this.contextService=y,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||U.OS)(),this.resolveUserHome=(async()=>{const a=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=a?.userHome??d})()}hasValidBasename(d,c,k){return typeof c=="string"||typeof c=="undefined"?this.resolveOS.then(y=>this.doHasValidBasename(d,y,c)):this.doHasValidBasename(d,c,k)}doHasValidBasename(d,c,k){return d.scheme===C.Schemas.file||d.scheme===C.Schemas.vscodeRemote?(0,s.isValidBasename)(k??(0,I.basename)(d),c===1):!0}get defaultUriScheme(){return _.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,c){if(d.remoteAuthority)return C.Schemas.vscodeRemote;const k=(0,A.getVirtualWorkspaceScheme)(c.getWorkspace());if(k)return k;const y=c.getWorkspace().folders[0];if(y)return y.uri.scheme;const a=c.getWorkspace().configuration;return a?a.scheme:C.Schemas.file}userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?g.win32:g.posix)}async fileURI(d){let c="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const y=d.indexOf("/",2);y===-1?(c=d.substring(2),d="/"):(c=d.substring(2,y),d=d.substring(y)||"/")}return P.URI.from({scheme:C.Schemas.file,authority:c,path:d,query:"",fragment:""})}};e.AbstractPathService=f,e.AbstractPathService=f=_=$e([We(1,m.IRemoteAgentService),We(2,S.IWorkbenchEnvironmentService),We(3,O.IWorkspaceContextService)],f)}),define(Ie[99],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class s{constructor(I,P){this.line=I,this.character=P}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,P){return new s(0,0)}with(I){return new s(0,0)}}e.Position=s;class C{constructor(I,P,w,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(I,P),this.end=new s(w,A)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new C(0,0,0,0)}with(I){return new C(0,0,0,0)}}e.Range=C;var g;(function(U){U[U.Information=1]="Information",U[U.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(Ie[41],Te([1,0,15,34,27,37,10,3,19,11,99,13]),function(ee,e,s,C,g,U,I,P,w,A,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",_=" characters skipped \u27EB",f=(m.length+_.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var u;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(u||(e.SearchProviderType=u={}));var d;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(d||(e.QueryType=d={}));function c(oe){return!!oe.preview}e.resultIsMatch=c;function k(oe){return!!oe.resource}e.isFileMatch=k;function y(oe){return!!oe.message}e.isProgressMessage=y;var a;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class D{constructor(fe){this.resource=fe,this.results=[]}}e.FileMatch=D;class r{constructor(fe,be,ce){this.ranges=be;const ve=Array.isArray(be)?be:[be];if(ce&&ce.matchLines===1&&h(ve)){fe=(0,I.getNLines)(fe,ce.matchLines);let J="",Ee=0,_e=0;const Fe=Math.floor(ce.charsPerLine/5),xe=[];for(const Xe of ve){const ke=Math.max(Xe.startColumn-Fe,0),Se=Xe.startColumn+ce.charsPerLine;if(ke>_e+Fe+f){const Pe=m+(ke-_e)+_;J+=Pe+fe.slice(ke,Se),Ee+=ke-(_e+Pe.length)}else J+=fe.slice(_e,Se);xe.push(new o(0,Xe.startColumn-Ee,Xe.endColumn-Ee)),_e=Se}this.preview={text:J,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const J=Array.isArray(be)?be[0].startLineNumber:be.startLineNumber;this.preview={text:fe,matches:(0,s.mapArrayOrNot)(be,Ee=>new i(Ee.startLineNumber-J,Ee.startColumn,Ee.endLineNumber-J,Ee.endColumn))}}}}e.TextSearchMatch=r;function h(oe){const fe=oe[0].startLineNumber;for(const be of oe)if(be.startLineNumber!==fe||be.endLineNumber!==fe)return!1;return!0}class i{constructor(fe,be,ce,ve){this.startLineNumber=fe,this.startColumn=be,this.endLineNumber=ce,this.endColumn=ve}}e.SearchRange=i;class o extends i{constructor(fe,be,ce){super(fe,be,fe,ce)}}e.OneLineRange=o;var n;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(n||(e.SearchSortOrder=n={}));function t(oe,fe=!0){const be=oe&&oe.files&&oe.files.exclude,ce=fe&&oe&&oe.search&&oe.search.exclude;if(!be&&!ce)return;if(!be||!ce)return be||ce;let ve=Object.create(null);return ve=g.mixin(ve,g.deepClone(be)),ve=g.mixin(ve,g.deepClone(ce),!0),ve}e.getExcludes=t;function l(oe,fe){return oe.excludePattern&&C.match(oe.excludePattern,fe)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&C.match(oe.includePattern,fe)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(be=>{const ce=be.folder.fsPath;if(U.isEqualOrParent(fe,ce)){const ve=w.relative(ce,fe);return!be.includePattern||!!C.match(be.includePattern,ve)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var b;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class v extends Error{constructor(fe,be){super(fe);this.code=be}}e.SearchError=v;function E(oe){const fe=oe.message;if((0,A.isCancellationError)(oe))return new v(fe,b.canceled);try{const be=JSON.parse(fe);return new v(be.message,be.code)}catch{return new v(fe,b.other)}}e.deserializeSearchError=E;function x(oe){const fe={message:oe.message,code:oe.code};return new Error(JSON.stringify(fe))}e.serializeSearchError=x;function $(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=$;function R(oe){return oe.type==="success"}e.isSerializedSearchSuccess=R;function p(oe){return!!oe.path}e.isSerializedFileMatch=p;function F(oe,fe){const be=oe.searchPath?oe.searchPath:oe.relativePath;return(0,I.fuzzyContains)(be,fe)}e.isFilePatternMatch=F;class M{constructor(fe){this.path=fe,this.results=[]}addMatch(fe){this.results.push(fe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function z(oe,fe){const be={...oe||{},...fe||{}};return Object.keys(be).filter(ce=>{const ve=be[ce];return typeof ve=="boolean"&&ve})}e.resolvePatternsForProvider=z;class Z{constructor(fe,be){this._parsedIncludeExpression=null,this._excludeExpression={...fe.excludePattern||{},...be.excludePattern||{}},this._parsedExcludeExpression=C.parse(this._excludeExpression);let ce=fe.includePattern;be.includePattern&&(ce?ce={...ce,...be.includePattern}:ce=be.includePattern),ce&&(this._parsedIncludeExpression=C.parse(ce))}matchesExcludesSync(fe,be,ce){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(fe,be,ce))}includedInQuerySync(fe,be,ce){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(fe,be,ce)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(fe,be,ce))}includedInQuery(fe,be,ce){const ve=this._parsedExcludeExpression(fe,be,ce),J=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(fe,be,ce):!0;return(0,S.isThenable)(ve)?ve.then(Ee=>Ee?!1:J()):J()}hasSiblingExcludeClauses(){return K(this._excludeExpression)}}e.QueryGlobTester=Z;function K(oe){for(const fe in oe)if(typeof oe[fe]!="boolean")return!0;return!1}function N(oe){if(!oe)return;let fe;return be=>(fe||(fe=(oe()||Promise.resolve([])).then(ce=>ce?le(ce):{})),fe.then(ce=>!!ce[be]))}e.hasSiblingPromiseFn=N;function se(oe){if(!oe)return;let fe;return be=>{if(!fe){const ce=oe();fe=ce?le(ce):{}}return!!fe[be]}}e.hasSiblingFn=se;function le(oe){const fe={};for(const be of oe)fe[be]=!0;return fe}}),define(Ie[31],Te([1,0,15,13,20,5,24,12,106,21,10,9,2,134,3,14,148,46,35,28,16,8,6,41,4]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d,c,k,y,a,D,r,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o($,R,p){return new A.ExtUri(F=>b(F,p)).isEqual($,R)}function n($,R,p){return o($.uri,R.uri,p)?0:(0,O.compare)($.uri.toString(),R.uri.toString())}function t($,R,p){return $.index!==R.index?$.index<R.index?-1:1:o($.uri,R.uri,p)?(0,O.compare)($.name,R.name):(0,O.compare)($.uri.toString(),R.uri.toString())}function l($,R,p,F){const M=$.slice(0).sort((Z,K)=>p(Z,K,F)),z=R.slice(0).sort((Z,K)=>p(Z,K,F));return(0,s.delta)(M,z,(Z,K)=>p(Z,K,F))}function b($,R){const p=R.getCapabilities($.scheme);return!(p&&p&1024)}class v extends c.Workspace{static toExtHostWorkspace(R,p,F,M){if(!R)return{workspace:null,added:[],removed:[]};const{id:z,name:Z,folders:K,configuration:N,transient:se,isUntitled:le}=R,oe=[],fe=p;p?K.forEach((J,Ee)=>{const _e=m.URI.revive(J.uri),Fe=v._findFolder(F||p,_e,M);Fe?(Fe.name=J.name,Fe.index=J.index,oe.push(Fe)):oe.push({uri:_e,name:J.name,index:Ee})}):oe.push(...K.map(({uri:J,name:Ee,index:_e})=>({uri:m.URI.revive(J),name:Ee,index:_e}))),oe.sort((J,Ee)=>J.index<Ee.index?-1:1);const be=new v(z,Z,oe,!!se,N?m.URI.revive(N):null,!!le,J=>b(J,M)),{added:ce,removed:ve}=l(fe?fe.workspaceFolders:[],be.workspaceFolders,n,M);return{workspace:be,added:ce,removed:ve}}static _findFolder(R,p,F){for(let M=0;M<R.folders.length;M++){const z=R.workspaceFolders[M];if(o(z.uri,p,F))return z}}constructor(R,p,F,M,z,Z,K){super(R,F.map(N=>new c.WorkspaceFolder(N)),M,z,K);this._name=p,this._isUntitled=Z,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris(K),F.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,p){return p&&this._structure.get(R)&&(R=(0,A.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let E=class{constructor(R,p,F,M){this._onDidChangeWorkspace=new U.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new U.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=M,this._extHostFileSystemInfo=F,this._requestIdProvider=new w.Counter,this._barrier=new C.Barrier,this._proxy=R.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(i.MainContext.MainThreadMessageService);const z=p.workspace;this._confirmedWorkspace=z?new v(z.id,z.name,[],!!z.transient,z.configuration?m.URI.revive(z.configuration):null,!!z.isUntitled,Z=>b(Z,F)):void 0}$initializeWorkspace(R,p){this._trusted=p,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?m.URI.from({scheme:P.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,p,F,...M){const z=[];if(Array.isArray(M)&&M.forEach(le=>{m.URI.isUri(le.uri)&&!z.some(oe=>o(oe.uri,le.uri,this._extHostFileSystemInfo))&&z.push({uri:le.uri,name:le.name||(0,A.basenameOrAuthority)(le.uri)})}),this._unconfirmedWorkspace||[p,F].some(le=>typeof le!="number"||le<0)||F===0&&z.length===0)return!1;const Z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(p+F>Z.length)return!1;const K=Z.slice(0);K.splice(p,F,...z.map(le=>({uri:le.uri,name:le.name||(0,A.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<K.length;le++){const oe=K[le];if(K.some((fe,be)=>be!==le&&o(oe.uri,fe.uri,this._extHostFileSystemInfo)))return!1}K.forEach((le,oe)=>le.index=oe);const{added:N,removed:se}=l(Z,K,t,this._extHostFileSystemInfo);if(N.length===0&&se.length===0)return!1;if(this._proxy){const le=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(le,p,F,z).then(void 0,oe=>{this._unconfirmedWorkspace=void 0;const fe={source:{identifier:R.identifier,label:R.displayName||R.name}};this._messageService.$showMessage(d.Severity.Error,(0,_.localize)(0,null,le,oe.toString()),fe,[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(R,p){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,p)}async getWorkspaceFolder2(R,p){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,p)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,p){let F,M="";if(typeof R=="string"?(F=m.URI.file(R),M=R):typeof R!="undefined"&&(F=R,M=R.fsPath),!F)return M;const z=this.getWorkspaceFolder(F,!0);if(!z)return M;typeof p=="undefined"&&this._actualWorkspace&&(p=this._actualWorkspace.folders.length>1);let Z=(0,A.relativePath)(z.uri,F);return p&&z.name&&(Z=`${z.name}/${Z}`),Z}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=v.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:p,added:F,removed:M}=v.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=p||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:F,removed:M}))}findFiles(R,p,F,M,z=g.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let Z;if(p===null?Z=!1:p&&(typeof p=="string"?Z=p:Z=p.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:N}=x(D.GlobPattern.from(R));return this._proxy.$startFileSearch((0,S.withUndefinedAsNull)(K),(0,S.withUndefinedAsNull)(N),(0,S.withUndefinedAsNull)(Z),(0,S.withUndefinedAsNull)(F),z).then(se=>Array.isArray(se)?se.map(le=>m.URI.revive(le)):[])}async findTextInFiles(R,p,F,M,z=g.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const Z=this._requestIdProvider.getNext(),K=typeof p.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:p.previewOptions,{includePattern:N,folder:se}=x(D.GlobPattern.from(p.include)),le=typeof p.exclude=="string"?p.exclude:p.exclude?p.exclude.pattern:void 0,oe={ignoreSymlinks:typeof p.followSymlinks=="boolean"?!p.followSymlinks:void 0,disregardIgnoreFiles:typeof p.useIgnoreFiles=="boolean"?!p.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof p.useGlobalIgnoreFiles=="boolean"?!p.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof p.useParentIgnoreFiles=="boolean"?!p.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof p.useDefaultExcludes=="boolean"?!p.useDefaultExcludes:!0,fileEncoding:p.encoding,maxResults:p.maxResults,previewOptions:K,afterContext:p.afterContext,beforeContext:p.beforeContext,includePattern:N,excludePattern:le},fe=!1;if(this._activeSearchCallbacks[Z]=be=>{if(fe)return;const ce=m.URI.revive(be.resource);be.results.forEach(ve=>{(0,h.resultIsMatch)(ve)?F({uri:ce,preview:{text:ve.preview.text,matches:(0,s.mapArrayOrNot)(ve.preview.matches,J=>new r.Range(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))},ranges:(0,s.mapArrayOrNot)(ve.ranges,J=>new r.Range(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))}):F({uri:ce,text:ve.text,lineNumber:ve.lineNumber})})},z.isCancellationRequested)return{};try{const be=await this._proxy.$startTextSearch(R,(0,S.withUndefinedAsNull)(se),oe,Z,z);return delete this._activeSearchCallbacks[Z],be||{}}catch(be){throw delete this._activeSearchCallbacks[Z],be}}$handleTextSearchResult(R,p){this._activeSearchCallbacks[p]&&this._activeSearchCallbacks[p](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};e.ExtHostWorkspace=E,e.ExtHostWorkspace=E=$e([We(0,a.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,k.IExtHostFileSystemInfo),We(3,u.ILogService)],E),e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function x($){let R,p;return $&&(typeof $=="string"?R=$:(R=$.pattern,p=m.URI.revive($.baseUri))),{includePattern:R,folder:p}}}),define(Ie[32],Te([1,0,27,5,31,4,6,151,83,9,13,3,16,14,2]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(h,i){if(i){const o=i.split(".");let n=h;for(let t=0;n&&t<o.length;t++)n=n[o[t]];return n}}function d(h){return h instanceof f.URI}function c(h){return h&&h.uri instanceof f.URI&&h.languageId&&typeof h.languageId=="string"}function k(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function y(h){return h&&h.uri instanceof f.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function a(h){if(d(h))return{resource:h};if(c(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(k(h))return{overrideIdentifier:h.languageId};if(y(h))return{resource:h.uri};if(h===null)return{resource:null}}let D=class{constructor(i,o,n){this._proxy=i.getProxy(U.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=n,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new r(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,o){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(i,o))}};e.ExtHostConfiguration=D,e.ExtHostConfiguration=D=$e([We(0,m.IExtHostRpcService),We(1,g.IExtHostWorkspace),We(2,_.ILogService)],D);class r{constructor(i,o,n,t){this._onDidChangeConfiguration=new C.Emitter,this._proxy=i,this._logService=t,this._extHostWorkspace=o,this._configuration=P.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,o){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,n))}getConfiguration(i,o,n){const t=a(o)||{},l=this._toReadonlyValue(i?u(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,t,n?.identifier);function b(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case I.ConfigurationTarget.Global:return 1;case I.ConfigurationTarget.Workspace:return 4;case I.ConfigurationTarget.WorkspaceFolder:return 5}}const v={has(E){return typeof u(l,E)!="undefined"},get:(E,x)=>{this._validateConfigurationAccess(i?`${i}.${E}`:E,t,n?.identifier);let $=u(l,E);if(typeof $=="undefined")$=x;else{let R;const p=(F,M)=>{let z;const Z=()=>{R=R||(0,s.deepClone)(l),z=z||u(R,M)};return(0,A.isObject)(F)?new Proxy(F,{get:(K,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return Z(),()=>z;if(R)return z=z||u(R,M),z[N];const se=K[N];return typeof N=="string"?p(se,`${M}.${N}`):se},set:(K,N,se)=>(Z(),z&&(z[N]=se),!0),deleteProperty:(K,N)=>(Z(),z&&delete z[N],!0),defineProperty:(K,N,se)=>(Z(),z&&Object.defineProperty(z,N,se),!0)}):F};$=p($,E)}return $},update:(E,x,$,R)=>{E=i?`${i}.${E}`:E;const p=b($);return x!==void 0?this._proxy.$updateConfigurationOption(p,E,x,t,R):this._proxy.$removeConfigurationOption(p,E,t,R)},inspect:E=>{E=i?`${i}.${E}`:E;const x=(0,s.deepClone)(this._configuration.inspect(E,t,this._extHostWorkspace.workspace));if(x)return{key:E,defaultValue:x.policy?.value??x.default?.value,globalValue:x.user?.value,workspaceValue:x.workspace?.value,workspaceFolderValue:x.workspaceFolder?.value,defaultLanguageValue:x.default?.override,globalLanguageValue:x.user?.override,workspaceLanguageValue:x.workspace?.override,workspaceFolderLanguageValue:x.workspaceFolder?.override,languageIds:x.overrideIdentifiers}}};return typeof l=="object"&&(0,s.mixin)(v,l,!1),Object.freeze(v)}_toReadonlyValue(i){const o=n=>(0,A.isObject)(n)?new Proxy(n,{get:(t,l)=>o(t[l]),set:(t,l,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(t,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(t,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return o(i)}_validateConfigurationAccess(i,o,n){const t=w.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),l=n?`[${n.value}] `:"";if(t===4){typeof o?.resource=="undefined"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){o?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,o){const n=new P.ConfigurationChangeEvent(i,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,l)=>n.affectsConfiguration(t,a(l))})}_toMap(i){return i.reduce((o,n)=>(o.set(n[0],n[1]),o),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,S.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,s,C,g){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?g.call(ee,s):g?g.value=s:e.set(ee,s),s},Re=this&&this.__classPrivateFieldGet||function(ee,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[100],Te([1,0,2,13,5,4,6,31,50,32,20,53,16,28,3,12,22,14,70,183,11]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d,c,k,y,a){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(M){function z(K){if(K!=null)return K}M.from=z;function Z(K){if(K!=null)return K}M.to=Z})(r||(e.TaskDefinitionDTO=r={}));var h;(function(M){function z(K){if(K!=null)return K}M.from=z;function Z(K){if(K!=null)return K}M.to=Z})(h||(e.TaskPresentationOptionsDTO=h={}));var i;(function(M){function z(K){if(K!=null)return K}M.from=z;function Z(K){if(K!=null)return K}M.to=Z})(i||(e.ProcessExecutionOptionsDTO=i={}));var o;(function(M){function z(N){if(N){const se=N;return se&&!!se.process}else return!1}M.is=z;function Z(N){if(N==null)return;const se={process:N.process,args:N.args};return N.options&&(se.options=i.from(N.options)),se}M.from=Z;function K(N){if(N!=null)return new I.ProcessExecution(N.process,N.args,N.options)}M.to=K})(o||(e.ProcessExecutionDTO=o={}));var n;(function(M){function z(K){if(K!=null)return K}M.from=z;function Z(K){if(K!=null)return K}M.to=Z})(n||(e.ShellExecutionOptionsDTO=n={}));var t;(function(M){function z(N){if(N){const se=N;return se&&(!!se.commandLine||!!se.command)}else return!1}M.is=z;function Z(N){if(N==null)return;const se={};return N.commandLine!==void 0?se.commandLine=N.commandLine:(se.command=N.command,se.args=N.args),N.options&&(se.options=n.from(N.options)),se}M.from=Z;function K(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new I.ShellExecution(N.commandLine,N.options):new I.ShellExecution(N.command,N.args?N.args:[],N.options)}M.to=K})(t||(e.ShellExecutionDTO=t={}));var l;(function(M){function z(N){if(N){let se=N;return se&&se.customExecution==="customExecution"}else return!1}M.is=z;function Z(N){return{customExecution:"customExecution"}}M.from=Z;function K(N,se){return se.get(N)}M.to=K})(l||(e.CustomExecutionDTO=l={}));var b;(function(M){function z(Z,K){let N;return Z.scope!==void 0&&typeof Z.scope!="number"?N=Z.scope.uri:Z.scope!==void 0&&typeof Z.scope=="number"&&(Z.scope===I.TaskScope.Workspace&&K&&K.workspaceFile?N=K.workspaceFile:N=y.USER_TASKS_GROUP_KEY),{id:Z._id,workspaceFolder:N}}M.from=z})(b||(e.TaskHandleDTO=b={}));var v;(function(M){function z(Z){if(Z!=null)return{_id:Z.id,isDefault:Z.isDefault}}M.from=z})(v||(e.TaskGroupDTO=v={}));var E;(function(M){function z(N,se){if(N==null)return[];const le=[];for(let oe of N){const fe=Z(oe,se);fe&&le.push(fe)}return le}M.fromMany=z;function Z(N,se){if(N==null)return;let le;N.execution instanceof I.ProcessExecution?le=o.from(N.execution):N.execution instanceof I.ShellExecution?le=t.from(N.execution):N.execution&&N.execution instanceof I.CustomExecution&&(le=l.from(N.execution));const oe=r.from(N.definition);let fe;return N.scope?typeof N.scope=="number"?fe=N.scope:fe=N.scope.uri:fe=I.TaskScope.Workspace,!oe||!fe?void 0:{_id:N._id,definition:oe,name:N.name,source:{extensionId:se.identifier.value,label:N.source,scope:fe},execution:le,isBackground:N.isBackground,group:v.from(N.group),presentationOptions:h.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}M.from=Z;async function K(N,se,le){if(N==null)return;let oe;o.is(N.execution)?oe=o.to(N.execution):t.is(N.execution)?oe=t.to(N.execution):l.is(N.execution)&&(oe=l.to(N._id,le));const fe=r.to(N.definition);let be;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?be=N.source.scope:be=await se.resolveWorkspaceFolder(s.URI.revive(N.source.scope)):be=I.TaskScope.Workspace),!fe||!be)return;const ce=new I.Task(fe,be,N.name,N.source.label,oe,N.problemMatchers);return N.isBackground!==void 0&&(ce.isBackground=N.isBackground),N.group!==void 0&&(ce.group=I.TaskGroup.from(N.group._id),ce.group&&N.group.isDefault&&(ce.group=new I.TaskGroup(ce.group.id,ce.group.label),N.group.isDefault===!0&&(ce.group.isDefault=N.group.isDefault))),N.presentationOptions&&(ce.presentationOptions=h.to(N.presentationOptions)),N._id&&(ce._id=N._id),N.detail&&(ce.detail=N.detail),ce}M.to=K})(E||(e.TaskDTO=E={}));var x;(function(M){function z(K){return K}M.from=z;function Z(K){if(!!K)return Object.assign(Object.create(null),K)}M.to=Z})(x||(e.TaskFilterDTO=x={}));class ${constructor(z,Z,K){this._id=Z,this._task=K,D.set(this,void 0),Ye(this,D,z,"f")}get task(){return this._task}terminate(){Re(this,D,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}D=new WeakMap;var R;(function(M){function z(Z){return{id:Z._id,task:void 0}}M.from=z})(R||(e.TaskExecutionDTO=R={}));let p=class{constructor(z,Z,K,N,se,le,oe,fe){this._onDidExecuteTask=new g.Emitter,this._onDidTerminateTask=new g.Emitter,this._onDidTaskProcessStarted=new g.Emitter,this._onDidTaskProcessEnded=new g.Emitter,this._proxy=z.getProxy(U.MainContext.MainThreadTask),this._workspaceProvider=K,this._editorService=N,this._configurationService=se,this._terminalService=le,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=oe,this._deprecationService=fe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,Z,K){if(!K)return new I.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:Z,provider:K,extension:z}),this._proxy.$registerTaskProvider(N,Z),new I.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(z,Z){this._proxy.$registerTaskSystem(z,Z)}fetchTasks(z){return this._proxy.$fetchTasks(x.from(z)).then(async Z=>{const K=[];for(let N of Z){const se=await E.to(N,this._workspaceProvider,this._providedCustomExecutions2);se&&K.push(se)}return K})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(Z=>z.push(Z)),z}terminateTask(z){if(!(z instanceof $))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,Z,K){const N=this._providedCustomExecutions2.get(z.id);N&&(this._activeCustomExecutions2.set(z.id,N),this._terminalService.attachPtyToTerminal(Z,await N.callback(K))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const Z=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:Z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const Z=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:Z,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const Z=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:Z,exitCode:z.exitCode})}$provideTasks(z,Z){const K=this._handlers.get(z);if(!K)return Promise.reject(new Error("no handler found"));const N=[],se=(0,C.asPromise)(()=>K.provider.provideTasks(O.CancellationToken.None)).then(le=>this.provideTasksInternal(Z,N,K,le));return new Promise(le=>{se.then(oe=>{Promise.all(N).then(()=>{le(oe)})})})}async $resolveTask(z,Z){const K=this._handlers.get(z);if(!K)return Promise.reject(new Error("no handler found"));if(Z.definition.type!==K.type)throw new Error(`Unexpected: Task of type [${Z.definition.type}] cannot be resolved by provider of type [${K.type}].`);const N=await E.to(Z,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const se=await K.provider.resolveTask(N,O.CancellationToken.None);if(!se)return;this.checkDeprecation(se,K);const le=E.from(se,K.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(se.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(le.execution)&&await this.addCustomExecution(le,se,!0),await this.resolveTaskInternal(le)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,Z,K){const N=await this._proxy.$createTaskId(z);!K&&!this._providedCustomExecutions2.has(N)&&(this._notProvidedCustomExecutions.add(N),this._activeCustomExecutions2.set(N,Z.execution)),this._providedCustomExecutions2.set(N,Z.execution)}async getTaskExecution(z,Z){if(typeof z=="string"){const se=this._taskExecutionPromises.get(z);if(!se)throw new Error("Unexpected: The specified task is missing an execution");return se}let K=this._taskExecutionPromises.get(z.id);if(K)return K;const N=new Promise((se,le)=>{function oe(fe,be,ce){ce?se(new $(fe,be.id,ce)):le("Unexpected: Task does not exist.")}Z?oe(this,z,Z):E.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(fe=>oe(this,z,fe))});return this._taskExecutionPromises.set(z.id,N),N.then(se=>(this._taskExecutions.set(z.id,se),se),se=>Promise.reject(se))}checkDeprecation(z,Z){z._deprecated&&this._deprecationService.report("Task.constructor",Z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let K=this._notProvidedCustomExecutions.values(),N=K.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=K.next()}};e.ExtHostTaskBase=p,e.ExtHostTaskBase=p=$e([We(0,m.IExtHostRpcService),We(1,_.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,w.IExtHostDocumentsAndEditors),We(4,A.IExtHostConfiguration),We(5,S.IExtHostTerminalService),We(6,c.ILogService),We(7,k.IExtHostApiDeprecationService)],p);let F=class extends p{constructor(z,Z,K,N,se,le,oe,fe){super(z,Z,K,N,se,le,oe,fe);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(z,Z){if(!Z.execution)throw new Error("Tasks to execute must include an execution");const K=E.from(Z,z);if(K===void 0)throw new Error("Task is not valid");if(l.is(K.execution))await this.addCustomExecution(K,Z,!1);else throw new a.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(K),Z);return this._proxy.$executeTask(K).catch(se=>{throw new Error(se)}),N}provideTasksInternal(z,Z,K,N){const se=[];if(N)for(let le of N){this.checkDeprecation(le,K),(!le.definition||!z[le.definition.type])&&this._logService.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const oe=E.from(le,K.extension);oe&&l.is(oe.execution)?(se.push(oe),Z.push(this.addCustomExecution(oe,le,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:se,extension:K.extension}}async resolveTaskInternal(z){if(l.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,Z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,Z,K){}};e.WorkerExtHostTask=F,e.WorkerExtHostTask=F=$e([We(0,m.IExtHostRpcService),We(1,_.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,w.IExtHostDocumentsAndEditors),We(4,A.IExtHostConfiguration),We(5,S.IExtHostTerminalService),We(6,c.ILogService),We(7,k.IExtHostApiDeprecationService)],F),e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Ie[224],Te([1,0,19,20,45,34,21,200,41]),function(ee,e,s,C,g,U,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(m,_,f){this.config=m,this.provider=_,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&U.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&U.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const _=this.config.folderQueries||[];return new Promise((f,u)=>{const d=c=>{this.resultCount++,m(c)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(c=>{const k=c.toString(),y=s.basename(k);this.globalExcludePattern&&this.globalExcludePattern(k,y)||this.matchFile(d,{base:c,basename:y})}),Promise.all(_.map(c=>this.searchInFolder(c,d))).then(c=>{f({limitHit:this.isLimitHit,stats:c[0]||void 0})},c=>{u(new Error((0,g.toErrorMessage)(c)))})})}async searchInFolder(m,_){const f=new C.CancellationTokenSource,u=this.getSearchOptionsForFolder(m),d=this.initDirectoryTree(),c=new w.QueryGlobTester(this.config,m),k=!c.hasSiblingExcludeClauses();let y;try{this.activeCancellationTokens.add(f),y=P.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,f.token),D=y.elapsed(),r=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(h=>{const i=s.posix.relative(m.folder.path,h.path);if(k){const o=s.basename(h.path);this.matchFile(_,{base:m.folder,relativePath:i,basename:o});return}this.addDirectoryEntries(d,m.folder,i,_)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,c,_),{providerTime:D,postProcessTime:r.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(m){const _=(0,w.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),f=(0,w.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:_,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},_,f,u){if(f===this.filePattern){const c=s.basename(this.filePattern);this.matchFile(u,{base:_,relativePath:this.filePattern,basename:c})}function d(c){const k=s.basename(c),y=s.dirname(c);let a=m[y];a||(a=m[y]=[],d(y)),a.push({base:_,relativePath:c,basename:k})}d(f)}matchDirectoryTree({rootEntries:m,pathToEntries:_},f,u){const d=this,c=this.filePattern;function k(y){const a=(0,w.hasSiblingFn)(()=>y.map(D=>D.basename));for(let D=0,r=y.length;D<r;D++){const h=y[D],{relativePath:i,basename:o}=h;if(f.matchesExcludesSync(i,o,c!==o?a:void 0))continue;const n=_[i];if(n)k(n);else{if(i===c)continue;d.matchFile(u,h)}if(d.isLimitHit)break}}k(m)}matchFile(m,_){(!this.includePattern||_.relativePath&&this.includePattern(_.relativePath,_.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(_))}}class O{constructor(){this.sessions=new Map}fileSearch(m,_,f,u){const d=this.getSessionTokenSource(m.cacheKey),c=new A(m,_,d&&d.token);let k=0;const y=a=>{k+=a.length,f(a.map(D=>this.rawMatchToSearchItem(D)))};return this.doSearch(c,O.BATCH_SIZE,y,u).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:k,detailStats:a.stats}}))}clearCache(m){const _=this.getSessionTokenSource(m);_&&_.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new C.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:I.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,_,f,u){u.onCancellationRequested(()=>{m.cancel()});const d=k=>{k&&(c.push(k),_>0&&c.length>=_&&(f(c),c=[]))};let c=[];return m.search(d).then(k=>(c.length&&f(c),k),k=>(c.length&&f(c),Promise.reject(k)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(Ie[225],Te([1,0,15,43,34,76,24,12,19,21,10,9,2,242,142,59,14,46,90,223,41]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d,c,k,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let D=class{constructor(v,E,x,$,R){this.configurationService=v,this.workspaceContextService=E,this.editorGroupsService=x,this.logService=$,this.pathService=R}text(v,E,x={}){v=this.getContentPattern(v,x);const $=this.configurationService.getValue(),R=E&&E.some(F=>!this.configurationService.getValue({resource:F}).search.useRipgrep);return{...this.commonQuery(E?.map(c.toWorkspaceFolder),x),type:2,contentPattern:v,previewOptions:x.previewOptions,maxFileSize:x.maxFileSize,usePCRE2:$.search.usePCRE2||R||!1,beforeContext:x.beforeContext,afterContext:x.afterContext,userDisabledExcludesAndIgnoreFiles:x.disregardExcludeSettings&&x.disregardIgnoreFiles}}getContentPattern(v,E){const x=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const $={...v,wordSeparators:x.editor.wordSeparators};return this.isCaseSensitive(v,E)&&($.isCaseSensitive=!0),this.isMultiline(v)&&($.isMultiline=!0),$}file(v,E={}){return{...this.commonQuery(v,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(v,E){return v?(v=Array.isArray(v)?v.map(n):n(v),E?this.parseSearchPaths(v):{pattern:h(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],E={}){const x=this.handleIncludeExclude(E.includePattern,E.expandPatterns),$=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),R=v.length>1,p=(x.searchPaths&&x.searchPaths.length?x.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,E,$)):v.map(z=>this.getFolderQueryForRoot(z,E,$,R))).filter(z=>!!z),F={_reason:E._reason,folderQueries:p,usingSearchPaths:!!(x.searchPaths&&x.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:$.pattern,includePattern:x.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const z=s.coalesce(s.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(se=>se.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const Z=z.filter(N=>(0,a.pathIncludedInQuery)(F,N.fsPath)),K=this.commonQueryFromFileList(Z);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...F,...K}}const M=E.extraFileResources&&E.extraFileResources.filter(z=>(0,a.pathIncludedInQuery)(F,z.fsPath));return F.extraFileResources=M&&M.length?M:void 0,F}commonQueryFromFileList(v){const E=[],x=new I.ResourceMap,$={};let R=!1;return v.forEach(p=>{if(p.scheme===P.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(p)){const M=this.workspaceContextService.getWorkspaceFolder(p)?.uri??p.with({path:w.dirname(p.fsPath)});let z=x.get(M);z||(R=!0,z={folder:M,includePattern:{}},E.push(z),x.set(M,z));const Z=w.relative(M.fsPath,p.fsPath);(0,S.assertIsDefined)(z.includePattern)[Z.replace(/\\/g,"/")]=!0}else p.fsPath&&(R=!0,$[p.fsPath]=!0)}),{folderQueries:E,includePattern:$,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(v,E){if(E.isSmartCase){if(v.isRegExp){if(O.containsUppercaseCharacter(v.pattern,!0))return!0}else if(O.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,_.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const E=K=>w.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),$=(Array.isArray(v)?v:i(v)).map(K=>{const N=this.pathService.resolvedUserHome;return N?(0,U.untildify)(K,N.scheme===P.Schemas.file?N.fsPath:N.path):K}),R=C.groupBy($,K=>E(K)?"searchPaths":"exprSegments"),p=(R.exprSegments||[]).map(K=>O.rtrim(K,"/")).map(K=>O.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),o(K))),F={},M=this.expandSearchPathPatterns(R.searchPaths||[]);M&&M.length&&(F.searchPaths=M);const z=s.flatten(p),Z=h(...z);return Z&&(F.pattern=Z),F}getExcludesForFolder(v,E){return E.disregardExcludeSettings?void 0:(0,a.getExcludes)(v,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const E=s.flatten(v.map($=>{let{pathPortion:R,globPortion:p}=r($);p&&(p=t(p));const F=this.expandOneSearchPath(R);return s.flatten(F.map(M=>this.resolveOneSearchPathPattern(M,p)))})),x=new Map;return E.forEach($=>{const R=$.searchPath.toString(),p=x.get(R);p?$.pattern&&(p.pattern=p.pattern||{},p.pattern[$.pattern]=!0):x.set(R,{searchPath:$.searchPath,pattern:$.pattern?h($.pattern):void 0})}),Array.from(x.values())}expandOneSearchPath(v){if(w.isAbsolute(v)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==P.Schemas.file?[{searchPath:E[0].uri.with({path:v})}]:[{searchPath:m.URI.file(w.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=n(v),v.startsWith("../")||v===".."){const $=w.posix.resolve(E.path,v);return[{searchPath:E.with({path:$})}]}const x=t(v);return[{searchPath:E,pattern:x}]}else{if(v==="./"||v===".\\")return[];{const E=v.replace(/^\.[\/\\]/,""),$=this.workspaceContextService.getWorkspace().folders.map(R=>{const p=E.match(new RegExp(`^${O.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return p?{match:p,folder:R}:null}).filter(S.isDefined);if($.length)return $.map(R=>{const p=R.match[1];return{searchPath:R.folder.uri,pattern:p&&t(p)}});{const R=v.match(/\.[\/\\](.+)[\/\\]?/),p=R?R[1]:v,F=f.localize(0,null,p);throw new Error(F)}}}}resolveOneSearchPathPattern(v,E){const x=v.pattern&&E?`${v.pattern}/${E}`:v.pattern||E,$=[{searchPath:v.searchPath,pattern:x}];return x&&!x.endsWith("**")&&$.push({searchPath:v.searchPath,pattern:x+"/**"}),$}getFolderQueryForSearchPath(v,E,x){const $=this.getFolderQueryForRoot((0,c.toWorkspaceFolder)(v.searchPath),E,x,!1);return $?{...$,includePattern:v.pattern}:null}getFolderQueryForRoot(v,E,x,$){let R;const p=m.URI.isUri(v)?v:v.uri;if(x.searchPaths){const K=x.searchPaths.filter(N=>(0,A.isEqual)(N.searchPath,p))[0];if(K&&!K.pattern)return null;K&&(R=K.pattern)}const F=this.configurationService.getValue({resource:p}),z={...this.getExcludesForFolder(F,E)||{},...R||{}},Z=m.URI.isUri(v)?(0,A.basename)(v):v.name;return{folder:p,folderName:$?Z:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!F.search.followSymlinks}}};e.QueryBuilder=D,e.QueryBuilder=D=$e([We(0,u.IConfigurationService),We(1,c.IWorkspaceContextService),We(2,k.IEditorGroupsService),We(3,d.ILogService),We(4,y.IPathService)],D);function r(b){const v=b.match(/[\*\{\}\(\)\[\]\?]/);if(v){const E=v.index,x=b.substr(0,E).match(/[/|\\][^/\\]*$/);if(x){let $=b.substr(0,x.index);return $.match(/[/\\]/)||($+="/"),{pathPortion:$,globPortion:b.substr((x.index||0)+1)}}}return{pathPortion:b}}function h(...b){return b.length?b.reduce((v,E)=>(v[E]=!0,v),Object.create(null)):void 0}function i(b){return g.splitGlobAware(b,",").map(v=>v.trim()).filter(v=>!!v.length)}function o(b){return[`**/${b}/**`,`**/${b}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function n(b){return b.replace(/\\/g,"/")}function t(b){return n(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(b,v){b=s.distinct(b,$=>$.toString());const E=[],x=v.getWorkspace();return b&&b.forEach($=>{let R;if(v.getWorkbenchState()===2)R=(0,A.relativePath)(x.folders[0].uri,$),R&&R!=="."&&(R="./"+R);else{const p=v.getWorkspaceFolder($);if(p){const F=p.name;if(x.folders.filter(z=>z.name===F).length===1){const z=(0,A.relativePath)(p.uri,$);z===""?R=`./${p.name}`:R=`./${p.name}/${z}`}else R=$.fsPath}}R&&E.push(R)}),E}e.resolveResourcesForSearchIncludes=l}),define(Ie[226],Te([1,0,21,2,20,11,3,225,41,46]),function(ee,e,s,C,g,U,I,P,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function S(u,d){const c=d.activationEvents;if(!c)return Promise.resolve(void 0);const k=[],y=[];for(const o of c)if(/^workspaceContains:/.test(o)){const n=o.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||u.forceUsingSearch?y.push(n):k.push(n)}if(k.length===0&&y.length===0)return Promise.resolve(void 0);let a;const D=new Promise((o,n)=>{a=o}),r=o=>a({activationEvent:o}),h=Promise.all(k.map(o=>m(u,o,r))).then(()=>{}),i=_(u,d.identifier,y,r);return Promise.all([h,i]).then(()=>{a(void 0)}),D}e.checkActivateWorkspaceContainsExtension=S;async function m(u,d,c){for(const k of u.folders)if(await u.exists(s.joinPath(C.URI.revive(k),d))){c(`workspaceContains:${d}`);return}}async function _(u,d,c,k){if(c.length===0)return Promise.resolve(void 0);const y=new g.CancellationTokenSource,a=u.checkExists(u.folders,c,y.token),D=setTimeout(async()=>{y.cancel(),u.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${c.join(",")}`)},O);let r=!1;try{r=await a}catch(h){U.isCancellationError(h)||U.onUnexpectedError(h)}y.dispose(),clearTimeout(D),r&&k(`workspaceContains:${c.join(",")}`)}function f(u,d,c,k){const y=u.get(I.IInstantiationService),a=u.get(w.ISearchService),r=y.createInstance(P.QueryBuilder).file(d.map(h=>(0,A.toWorkspaceFolder)(C.URI.revive(h))),{_reason:"checkExists",includePattern:c,exists:!0});return a.fileSearch(r,k).then(h=>!!h.limitHit,h=>U.isCancellationError(h)?!1:Promise.reject(h))}e.checkGlobFileExists=f});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,s,C,g){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?g.call(ee,s):g?g.value=s:e.set(ee,s),s},Re=this&&this.__classPrivateFieldGet||function(ee,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[33],Te([1,0,129,19,73,21,13,7,24,2,14,4,32,178,71,31,26,177,11,25,23,157,6,84,3,28,72,16,60,64,53,5,226,69,159,12]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d,c,k,y,a,D,r,h,i,o,n,t,l,b,v,E,x,$,R,p){"use strict";var F,M,z,Z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let K=Z=class extends P.Disposable{constructor(ce,ve,J,Ee,_e,Fe,xe,Xe,ke,Se){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=ve,this._extHostContext=J,this._initData=xe,this._extHostWorkspace=Ee,this._extHostConfiguration=_e,this._logService=Fe,this._extHostTunnelService=ke,this._extHostTerminalService=Se,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(S.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(S.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(S.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new I.Barrier,this._readyToStartExtensionHost=new I.Barrier,this._readyToRunExtensions=new I.Barrier,this._eagerExtensionsActivated=new I.Barrier,this._globalRegistry=new c.ExtensionDescriptionRegistry(this._initData.allExtensions);const Pe=(0,d.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new c.ExtensionDescriptionRegistry(le(this._globalRegistry,Pe)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new $.ExtHostSecretState(this._extHostContext),this._storagePath=Xe,this._instaService=ce.createChild(new l.ServiceCollection([f.IExtHostStorage,this._storage],[$.IExtHostSecretState,this._secretState]));let re=[],ae=[];this._initData.remote.isRemote&&(re=this._initData.allExtensions.filter(G=>!G.main&&!G.browser).map(G=>G.identifier),ae=this._initData.allExtensions.filter(G=>!Pe.has(y.ExtensionIdentifier.toKey(G.identifier.value))).filter(G=>(G.main||G.browser)&&G.api==="none").map(G=>G.identifier));const X=(0,d.extensionIdentifiersArrayToSet)(ae);this._activator=this._register(new _.ExtensionsActivator(this._myRegistry,re,ae,{onExtensionActivationError:(G,T,B)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(G,k.transformErrorForSerialization(T),B)},actualActivateExtension:async(G,T)=>{if(X.has(y.ExtensionIdentifier.toKey(G)))return await this._mainThreadExtensionsProxy.$activateExtension(G,T),new _.HostExtension;const B=this._myRegistry.getExtensionDescription(G);return this._activateExtension(B,T)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),g.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ce){k.onUnexpectedError(ce)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ce=[];try{ce=this._myRegistry.getAllExtensionDescriptions().map(_e=>_e.identifier).filter(_e=>this.isActivated(_e)).map(_e=>this._deactivate(_e))}catch{}await Promise.all(ce)}terminate(ce,ve=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ce}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),k.setUnexpectedErrorHandler(Ee=>{this._logService.error(Ee)}),this._extHostContext.dispose();const J=this._deactivateAll();Promise.race([(0,I.timeout)(5e3),J]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${ve}`):this._logService.info(`Extension host exiting with code ${ve}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(ve)})}isActivated(ce){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ce):!1}async getExtension(ce){const ve=await this._mainThreadExtensionsProxy.$getExtension(ce);return ve&&{...ve,identifier:new y.ExtensionIdentifier(ve.identifier.value),extensionLocation:A.URI.revive(ve.extensionLocation)}}_activateByEvent(ce,ve){return this._activator.activateByEvent(ce,ve)}_activateById(ce,ve){return this._activator.activateById(ce,ve)}activateByIdWithErrors(ce,ve){return this._activateById(ce,ve).then(()=>{const J=this._activator.getActivatedExtension(ce);if(J.activationFailed)return Promise.reject(J.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ce=>this._myRegistry)}getExtensionExports(ce){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ce).exports:null}async _realPathExtensionUri(ce){if(ce.scheme!==p.Schemas.file)return ce;const ve=await this._hostUtils.realpath(ce.fsPath);return A.URI.file(ve)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ce=>new fe(ce))),this._extensionPathIndex}async _createExtensionPathIndex(ce){const ve=w.TernarySearchTree.forUris(J=>U.extUriBiasedIgnorePathCase.ignorePathCasing(J));return await Promise.all(ce.map(async J=>{if(this._getEntryPoint(J)){const Ee=await this._realPathExtensionUri(J.extensionLocation);ve.set(Ee,J)}})),ve}_deactivate(ce){let ve=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ce))return ve;const J=this._activator.getActivatedExtension(ce);if(!J)return ve;try{typeof J.module.deactivate=="function"&&(ve=Promise.resolve(J.module.deactivate()).then(void 0,Ee=>(this._logService.error(Ee),Promise.resolve(void 0))))}catch(Ee){this._logService.error(`An error occurred when deactivating the extension '${ce.value}':`),this._logService.error(Ee)}try{(0,P.dispose)(J.subscriptions)}catch(Ee){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ce.value}':`),this._logService.error(Ee)}return ve}async _activateExtension(ce,ve){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ce.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ce.identifier),this._doActivateExtension(ce,ve).then(J=>{const Ee=J.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ce.identifier,Ee.codeLoadingTime,Ee.activateCallTime,Ee.activateResolvedTime,ve),this._logExtensionActivationTimes(ce,ve,"success",Ee),J},J=>{throw this._logExtensionActivationTimes(ce,ve,"failure"),J})}_logExtensionActivationTimes(ce,ve,J,Ee){const _e=N(ce,ve);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{..._e,...Ee||{},outcome:J})}_doActivateExtension(ce,ve){const J=N(ce,ve);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",J);const Ee=this._getEntryPoint(ce);if(!Ee)return Promise.resolve(new _.EmptyExtension(_.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ce.identifier.value}, startup: ${ve.startup}, activationEvent: '${ve.activationEvent}'${ce.identifier.value!==ve.extensionId.value?`, root cause: ${ve.extensionId.value}`:""}`),this._logService.flush();const _e=new _.ExtensionActivationTimesBuilder(ve.startup);return Promise.all([this._loadCommonJSModule(ce.identifier,(0,U.joinPath)(ce.extensionLocation,Ee),_e),this._loadExtensionContext(ce)]).then(Fe=>(g.mark(`code/extHost/willActivateExtension/${ce.identifier.value}`),Z._callActivate(this._logService,ce.identifier,Fe[0],Fe[1],_e))).then(Fe=>(g.mark(`code/extHost/didActivateExtension/${ce.identifier.value}`),Fe))}_loadExtensionContext(ce){const ve=new D.ExtensionGlobalMemento(ce,this._storage),J=new D.ExtensionMemento(ce.identifier.value,!1,this._storage),Ee=new R.ExtensionSecrets(ce,this._secretState),_e=ce.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Fe=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ce.identifier.value}`),Promise.all([ve.whenReady,J.whenReady,this._storagePath.whenReady]).then(()=>{const xe=this;let Xe,ke;const Se=(0,d.isProposedApiEnabled)(ce,"ipc")?this._initData.messagePorts?.get(y.ExtensionIdentifier.toKey(ce.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:J,secrets:Ee,subscriptions:[],get extensionUri(){return ce.extensionLocation},get extensionPath(){return ce.extensionLocation.fsPath},asAbsolutePath(Pe){return C.join(ce.extensionLocation.fsPath,Pe)},get storagePath(){return xe._storagePath.workspaceValue(ce)?.fsPath},get globalStoragePath(){return xe._storagePath.globalValue(ce).fsPath},get logPath(){return C.join(xe._initData.logsLocation.fsPath,ce.identifier.value)},get logUri(){return A.URI.joinPath(xe._initData.logsLocation,ce.identifier.value)},get storageUri(){return xe._storagePath.workspaceValue(ce)},get globalStorageUri(){return xe._storagePath.globalValue(ce)},get extensionMode(){return _e},get extension(){return Xe===void 0&&(Xe=new se(xe,ce.identifier,ce,Fe,!1)),Xe},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(ce,"extensionRuntime"),xe.extensionRuntime},get environmentVariableCollection(){return xe._extHostTerminalService.getEnvironmentVariableCollection(ce)},get messagePassingProtocol(){if(!ke){if(!Se)return;const Pe=E.Event.buffer(E.Event.fromDOMEventEmitter(Se,"message",re=>re.data));Se.start(),ke={onDidReceiveMessage:Pe,postMessage:Se.postMessage.bind(Se)}}return ke}})})}static _callActivate(ce,ve,J,Ee,_e){return J=J||{activate:void 0,deactivate:void 0},this._callActivateOptional(ce,ve,J,Ee,_e).then(Fe=>new _.ActivatedExtension(!1,null,_e.build(),J,Fe,Ee.subscriptions))}static _callActivateOptional(ce,ve,J,Ee,_e){if(typeof J.activate=="function")try{_e.activateCallStart(),ce.trace(`ExtensionService#_callActivateOptional ${ve.value}`);const Fe=typeof global=="object"?global:self,xe=J.activate.apply(Fe,[Ee]);return _e.activateCallStop(),_e.activateResolveStart(),Promise.resolve(xe).then(Xe=>(_e.activateResolveStop(),Xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(J)}_activateOneStartupFinished(ce,ve){this._activateById(ce.identifier,{startup:!1,extensionId:ce.identifier,activationEvent:ve}).then(void 0,J=>{this._logService.error(J)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(g.getMarks());for(const ce of this._myRegistry.getAllExtensionDescriptions())if(ce.activationEvents)for(const ve of ce.activationEvents)ve==="onStartupFinished"&&this._activateOneStartupFinished(ce,ve)}_handleEagerExtensions(){const ce=this._activateByEvent("*",!0).then(void 0,_e=>{this._logService.error(_e)});this._register(this._extHostWorkspace.onDidChangeWorkspace(_e=>this._handleWorkspaceContainsEagerExtensions(_e.added)));const ve=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],J=this._handleWorkspaceContainsEagerExtensions(ve),Ee=Promise.all([ce,J]).then(()=>{});return Promise.race([Ee,(0,I.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Ee}_handleWorkspaceContainsEagerExtensions(ce){return ce.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(ve=>this._handleWorkspaceContainsEagerExtension(ce,ve))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ce,ve){if(this.isActivated(ve.identifier))return;const J=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Ee={logService:this._logService,folders:ce.map(Fe=>Fe.uri),forceUsingSearch:J,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,xe,Xe)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,xe,Xe)},_e=await(0,x.checkActivateWorkspaceContainsExtension)(Ee,ve);if(!!_e)return this._activateById(ve.identifier,{startup:!0,extensionId:ve.identifier,activationEvent:_e.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ce){throw console.error(ce),ce}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ce,extensionTestsLocationURI:ve}=this._initData.environment;if(!ce||!ve)throw new Error(s.localize(0,null));const J=await this._loadCommonJSModule(null,ve,new _.ExtensionActivationTimesBuilder(!1));if(!J||typeof J.run!="function")throw new Error(s.localize(1,null,ve.toString()));return new Promise((Ee,_e)=>{const Fe=(ke,Se)=>{ke?_e(ke):Ee(typeof Se=="number"&&Se>0?1:0)},xe=(0,U.originalFSPath)(ve),Xe=J.run(xe,Fe);Xe&&Xe.then&&Xe.then(()=>{Ee(0)}).catch(ke=>{_e(ke instanceof Error&&ke.stack?ke.stack:String(ke))})})}async $extensionTestsExit(ce){this.terminate(`test runner requested exit with code ${ce}`,ce)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ce,ve){return this._resolvers[ce]=ve,(0,P.toDisposable)(()=>{delete this._resolvers[ce]})}async _activateAndGetResolver(ce){const ve=ce.indexOf("+");if(ve===-1)throw new Error("Not an authority that can be resolved!");const J=ce.substr(0,ve);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${J}`,!1),{authorityPrefix:J,resolver:this._resolvers[J]}}async $resolveAuthority(ce,ve){this._logService.info(`$resolveAuthority invoked for authority (${oe(ce)})`);const{authorityPrefix:J,resolver:Ee}=await this._activateAndGetResolver(ce);if(!Ee)return{type:"error",error:{code:h.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${J}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(Ee)),g.mark(`code/extHost/willResolveAuthority/${J}`);const _e=await Ee.resolve(ce,{resolveAttempt:ve});g.mark(`code/extHost/didResolveAuthorityOK/${J}`);const Fe={authority:ce,host:_e.host,port:_e.port,connectionToken:_e.connectionToken},xe={extensionHostEnv:_e.extensionHostEnv,isTrusted:_e.isTrusted,authenticationSession:_e.authenticationSessionForInitializingExtensions?{id:_e.authenticationSessionForInitializingExtensions.id,providerId:_e.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Fe,options:xe,tunnelInformation:{environmentTunnels:_e.environmentTunnels,features:_e.tunnelFeatures}}}}catch(_e){if(g.mark(`code/extHost/didResolveAuthorityError/${J}`),_e instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:_e._code,message:_e._message,detail:_e._detail}};throw _e}}async $getCanonicalURI(ce,ve){this._logService.info(`$getCanonicalURI invoked for authority (${oe(ce)})`);const{resolver:J}=await this._activateAndGetResolver(ce);if(!J)return null;const Ee=A.URI.revive(ve);if(typeof J.getCanonicalURI=="undefined")return Ee;const _e=await(0,I.asPromise)(()=>J.getCanonicalURI(Ee));return _e||Ee}static _applyExtensionsDelta(ce,ve,J){const Ee=new c.ExtensionDescriptionRegistry(ce.getAllExtensionDescriptions());Ee.deltaExtensions(J.toAdd,J.toRemove);const _e=(0,d.extensionIdentifiersArrayToSet)(ve.getAllExtensionDescriptions().map(xe=>xe.identifier));for(const xe of J.myToRemove)_e.delete(y.ExtensionIdentifier.toKey(xe));for(const xe of J.myToAdd)_e.add(y.ExtensionIdentifier.toKey(xe));const Fe=le(Ee,_e);return{globalRegistry:Ee,myExtensions:Fe}}$startExtensionHost(ce){ce.toAdd.forEach(Ee=>Ee.extensionLocation=A.URI.revive(Ee.extensionLocation));const{globalRegistry:ve,myExtensions:J}=Z._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ce);return this._globalRegistry.set(ve.getAllExtensionDescriptions()),this._myRegistry.set(J),this._startExtensionHost()}$activateByEvent(ce,ve){return ve===1?this._activateByEvent(ce,!1):this._readyToRunExtensions.wait().then(J=>this._activateByEvent(ce,!1))}async $activate(ce,ve){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ce)?(await this._activateById(ce,ve),!0):!1}async $deltaExtensions(ce){ce.toAdd.forEach(Fe=>Fe.extensionLocation=A.URI.revive(Fe.extensionLocation));const{globalRegistry:ve,myExtensions:J}=Z._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ce),Ee=await this._createExtensionPathIndex(J);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this._globalRegistry.set(ve.getAllExtensionDescriptions()),this._myRegistry.set(J),Promise.resolve(void 0)}async $test_latency(ce){return ce}async $test_up(ce){return ce.byteLength}async $test_down(ce){let ve=a.VSBuffer.alloc(ce),J=Math.random()%256;for(let Ee=0;Ee<ce;Ee++)ve.writeUInt8(J,Ee);return ve}async $updateRemoteConnectionData(ce){this._remoteConnectionData=ce,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=K,e.AbstractExtHostExtensionService=K=Z=$e([We(0,i.IInstantiationService),We(1,e.IHostUtils),We(2,t.IExtHostRpcService),We(3,u.IExtHostWorkspace),We(4,m.IExtHostConfiguration),We(5,O.ILogService),We(6,o.IExtHostInitDataService),We(7,n.IExtensionStoragePaths),We(8,b.IExtHostTunnelService),We(9,v.IExtHostTerminalService)],K);function N(be,ce){return{id:be.identifier.value,name:be.name,extensionVersion:be.version,publisherDisplayName:be.publisher,activationEvents:be.activationEvents?be.activationEvents.join(","):null,isBuiltin:be.isBuiltin,reason:ce.activationEvent,reasonId:ce.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class se{constructor(ce,ve,J,Ee,_e){F.set(this,void 0),M.set(this,void 0),z.set(this,void 0),Ye(this,F,ce,"f"),Ye(this,M,ve,"f"),Ye(this,z,J.identifier,"f"),this.id=J.identifier.value,this.extensionUri=J.extensionLocation,this.extensionPath=C.normalize((0,U.originalFSPath)(J.extensionLocation)),this.packageJSON=J,this.extensionKind=Ee,this.isFromDifferentExtensionHost=_e}get isActive(){return Re(this,F,"f").isActivated(Re(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Re(this,F,"f").getExtensionExports(Re(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Re(this,F,"f").activateByIdWithErrors(Re(this,z,"f"),{startup:!1,extensionId:Re(this,M,"f"),activationEvent:"api"}),this.exports}}e.Extension=se,F=new WeakMap,M=new WeakMap,z=new WeakMap;function le(be,ce){return be.getAllExtensionDescriptions().filter(ve=>ce.has(y.ExtensionIdentifier.toKey(ve.identifier)))}function oe(be){const ce=be.indexOf("+");return ce===-1?be:be.substring(0,ce)}class fe{constructor(ce){this._searchTree=ce}setSearchTree(ce){this._searchTree=ce}findSubstr(ce){return this._searchTree.findSubstr(ce)}forEach(ce){return this._searchTree.forEach(ce)}}e.ExtensionPaths=fe}),define(Ie[227],Te([1,0,73,2,4,32,26,25,16,28,3,33,61,14,10]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(r,h,i,o,n,t,l){this._apiFactory=r,this._extensionRegistry=h,this._instaService=i,this._extHostConfiguration=o,this._extHostExtensionService=n,this._initData=t,this._logService=l,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),s.mark("code/extHost/willWaitForConfig");const r=await this._extHostConfiguration.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new k(this._apiFactory,h,this._extensionRegistry,r,this._logService)),this.register(this._instaService.createInstance(y,h)),this.register(this._instaService.createInstance(c)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(a,h,this._initData.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(let h of r.nodeModuleName)this._factories.set(h,r);else this._factories.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this._alternatives.push(h=>r.alternativeModuleName(h))}};e.RequireInterceptor=d,e.RequireInterceptor=d=$e([We(2,O.IInstantiationService),We(3,U.IExtHostConfiguration),We(4,S.IExtHostExtensionService),We(5,A.IExtHostInitDataService),We(6,_.ILogService)],d);let c=u=class{constructor(r){if(r.environment.appRoot&&u.aliased.size){const h=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(r.environment.appRoot.fsPath)),i="[a-z0-9_.-]",o=`@${i}+\\/${i}+|${i}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${h}/${n}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(r){if(!this.re)return;const h=this.re.exec(this.forceForwardSlashes(r));if(!h)return;const[,i,o,n]=h,t=u.aliased.get(o);if(t!==void 0)return console.warn(`${o} as been renamed to ${t}, please update your imports`),i+t+n}forceForwardSlashes(r){return r.replace(/\\/g,"/")}};c.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),c=u=$e([We(0,A.IExtHostInitDataService)],c);class k{constructor(r,h,i,o,n){this._apiFactory=r,this._extensionPaths=h,this._extensionRegistry=i,this._configProvider=o,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(r,h){const i=this._extensionPaths.findSubstr(h);if(i){let o=this._extApiImpl.get(P.ExtensionIdentifier.toKey(i.identifier));return o||(o=this._apiFactory(i,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(i.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((n,t)=>o+=`	${t} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(I.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let y=class{constructor(r,h,i){this._extensionPaths=r,this.nodeModuleName="keytar",this._mainThreadTelemetry=h.getProxy(g.MainContext.MainThreadTelemetry);const{environment:o}=i,n=h.getProxy(g.MainContext.MainThreadKeytar);if(o.appRoot){let t=o.appRoot.fsPath;m.platform==="win32"&&(t=t.replace(/\\/g,"/")),t[t.length-1]==="/"&&(t=t.substr(0,t.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${t}/node_modules.asar/keytar`),this.alternativeNames.add(`${t}/node_modules/keytar`)}this._impl={getPassword:(t,l)=>n.$getPassword(t,l),setPassword:(t,l,b)=>n.$setPassword(t,l,b),deletePassword:(t,l)=>n.$deletePassword(t,l),findPassword:t=>n.$findPassword(t),findCredentials(t){return n.$findCredentials(t)}}}load(r,h){const i=this._extensionPaths.findSubstr(h);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:i?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(r){const h=r.length;if(h<=7||!this.alternativeNames)return;const i=h-7;if((r.charAt(i)==="/"||r.charAt(i)==="\\")&&r.endsWith("keytar")&&(r=r.replace(/\\/g,"/"),this.alternativeNames.has(r)))return"keytar"}};y=$e([We(1,w.IExtHostRpcService),We(2,A.IExtHostInitDataService)],y);let a=class{constructor(r,h,i){this._extensionPaths=r,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=i.getProxy(g.MainContext.MainThreadTelemetry);const o=i.getProxy(g.MainContext.MainThreadWindow);this._impl=(n,t)=>{const l=C.URI.parse(n);return t?this.callOriginal(n,t):l.scheme==="http"||l.scheme==="https"?o.$openUri(l,n,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this._appUriScheme?o.$openUri(l,n,{}):this.callOriginal(n,t)}}load(r,h,i){const o=this._extensionPaths.findSubstr(h);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=i(r),this._impl}callOriginal(r,h){return this.sendNoForwardTelemetry(),this._original(r,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};a=$e([We(2,w.IExtHostRpcService)],a)}),define(Ie[101],Te([1,0,194,7,19,61,3,50,51,33,6,31,170,32]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(c,k,y,a,D,r,h){function i(){if(y){const o=y.activeEditor();if(o)return o.document.uri;const n=a.tabGroups.all.find(t=>t.isActive)?.activeTab;if(n!==void 0){if(n.input instanceof O.TextDiffTabInput||n.input instanceof O.NotebookDiffEditorTabInput)return n.input.modified;if(n.input instanceof O.TextTabInput||n.input instanceof O.NotebookEditorTabInput||n.input instanceof O.CustomEditorTabInput)return n.input.uri}}}super({getFolderUri:o=>{const n=r.folders.filter(t=>t.name===o);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(o,n)=>D.getConfiguration(void 0,o).get(n),getAppRoot:()=>U.cwd(),getExecPath:()=>U.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=i();if(o)return g.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(k){const o=i();if(o){const n=k.getWorkspaceFolder(o);if(n)return g.normalize(n.uri.fsPath)}}},getSelectedText:()=>{if(y){const o=y.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(y){const o=y.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>c.getExtension(o)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(U.env))}}let u=class extends C.Disposable{constructor(c,k,y,a,D){super();this.extensionService=c,this.workspaceService=k,this.editorService=y,this.configurationService=a,this.editorTabs=D,this._resolver=new s.Lazy(async()=>{const r=await this.configurationService.getConfigProvider(),i={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async o=>{i.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,r,i,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};e.ExtHostVariableResolverProviderService=u,e.ExtHostVariableResolverProviderService=u=$e([We(0,A.IExtHostExtensionService),We(1,S.IExtHostWorkspace),We(2,P.IExtHostDocumentsAndEditors),We(3,_.IExtHostConfiguration),We(4,w.IExtHostEditorTabs)],u)}),define(Ie[102],Te([1,0,13,5,9,2,3,4,51,33,16,6,31,164,166,32,101]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let c=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(i,o,n,t,l,b){this._workspaceService=o,this._extensionService=n,this._configurationService=t,this._editorTabs=l,this._variableResolver=b,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=i.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new y(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(v=>{v.onDidChange(E=>{this.registerAllDebugTypes(v)}),this.registerAllDebugTypes(v)})}asDebugSourceUri(i,o){const n=i;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let t=`debug:${encodeURIComponent(n.path||"")}`,l="?";return o&&(t+=`${l}session=${encodeURIComponent(o.id)}`,l="&"),t+=`${l}ref=${n.sourceReference}`,U.URI.parse(t)}else{if(n.path)return U.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const o=[];for(const n of i.getAllExtensionDescriptions())if(n.contributes){const t=n.contributes.debuggers;if(t&&t.length>0)for(const l of t)(0,f.isDebuggerMainContribution)(l)&&o.push(l.type)}this._debugServiceProxy.$registerDebugTypes(o)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(o=>i.push(o)),i}addBreakpoints(i){this.startBreakpoints();const o=i.filter(l=>{const b=l.id;return this._breakpoints.has(b)?!1:(this._breakpoints.set(b,l),!0)});this.fireBreakpointChanges(o,[],[]);const n=[],t=new Map;for(const l of o)if(l instanceof S.SourceBreakpoint){let b=t.get(l.location.uri.toString());b||(b={type:"sourceMulti",uri:l.location.uri,lines:[]},t.set(l.location.uri.toString(),b),n.push(b)),b.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof S.FunctionBreakpoint&&n.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this._debugServiceProxy.$registerBreakpoints(n)}removeBreakpoints(i){this.startBreakpoints();const o=i.filter(b=>this._breakpoints.delete(b.id));this.fireBreakpointChanges([],o,[]);const n=o.filter(b=>b instanceof S.SourceBreakpoint).map(b=>b.id),t=o.filter(b=>b instanceof S.FunctionBreakpoint).map(b=>b.id),l=o.filter(b=>b instanceof S.DataBreakpoint).map(b=>b.id);return this._debugServiceProxy.$unregisterBreakpoints(n,t,l)}startDebugging(i,o,n){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,o,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,debugUI:n.debugUI,suppressSaveBeforeStart:n.suppressSaveBeforeStart})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,o,n){if(!o)return new S.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:t,provider:o}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,n,!!o.provideDebugConfigurations,!!o.resolveDebugConfiguration,!!o.resolveDebugConfigurationWithSubstitutedVariables,t),new S.Disposable(()=>{this._configProviders=this._configProviders.filter(l=>l.provider!==o),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(i,o,n){if(!n)return new S.Disposable(()=>{});if(!this.definesDebugType(i,o))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${o}' debugger.`);if(this.getAdapterDescriptorFactoryByType(o))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:o,handle:t,factory:n}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(o,t),new S.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(l=>l.factory!==n),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(i,o){if(!o)return new S.Disposable(()=>{});const n=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:n,factory:o}),new S.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==o)})}async $runInTerminal(i,o){return Promise.resolve(void 0)}async $substituteVariables(i,o){let n;const t=await this.getFolder(i);return t&&(n={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(n,o)}createDebugAdapter(i,o){if(i.type==="implementation")return new D(i.implementation)}createSignService(){}async $startDASession(i,o){const n=this,t=await this.getSession(o);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const b=this.convertToDto(l),v=this.createDebugAdapter(b,t);if(!v)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const E=v;return this._debugAdapters.set(i,E),this.getDebugAdapterTrackers(t).then(x=>(x&&this._debugAdaptersTrackers.set(i,x),E.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const R=$,p={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(R.arguments.value);p.body={signature:F},E.sendResponse(p)}else throw new Error("no signer")}catch(F){p.success=!1,p.message=F.message,E.sendResponse(p)}}else x&&x.onDidSendMessage&&x.onDidSendMessage($),$=(0,f.convertToVSCPaths)($,!0),n._debugServiceProxy.$acceptDAMessage(i,$)}),E.onError($=>{x&&x.onError&&x.onError($),this._debugServiceProxy.$acceptDAError(i,$.name,$.message,$.stack)}),E.onExit($=>{x&&x.onExit&&x.onExit((0,g.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(i,(0,g.withNullAsUndefined)($),void 0)}),x&&x.onWillStartSession&&x.onWillStartSession(),E.startSession()))})}$sendDAMessage(i,o){o=(0,f.convertToDAPaths)(o,!1);const n=this._debugAdaptersTrackers.get(i);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(o);const t=this._debugAdapters.get(i);t&&t.sendMessage(o)}$stopDASession(i){const o=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),o&&o.onWillStopSession&&o.onWillStopSession();const n=this._debugAdapters.get(i);return this._debugAdapters.delete(i),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const o=[],n=[],t=[];if(i.added)for(const l of i.added){const b=l.id;if(b&&!this._breakpoints.has(b)){let v;if(l.type==="function")v=new S.FunctionBreakpoint(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")v=new S.DataBreakpoint(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const E=U.URI.revive(l.uri);v=new S.SourceBreakpoint(new S.Location(E,new S.Position(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}v._id=b,this._breakpoints.set(b,v),o.push(v)}}if(i.removed)for(const l of i.removed){const b=this._breakpoints.get(l);b&&(this._breakpoints.delete(l),n.push(b))}if(i.changed){for(const l of i.changed)if(l.id){const b=this._breakpoints.get(l.id);if(b){if(b instanceof S.FunctionBreakpoint&&l.type==="function"){const v=b;v.enabled=l.enabled,v.condition=l.condition,v.hitCondition=l.hitCondition,v.logMessage=l.logMessage,v.functionName=l.functionName}else if(b instanceof S.SourceBreakpoint&&l.type==="source"){const v=b;v.enabled=l.enabled,v.condition=l.condition,v.hitCondition=l.hitCondition,v.logMessage=l.logMessage,v.location=new S.Location(U.URI.revive(l.uri),new S.Position(l.line,l.character))}t.push(b)}}}this.fireBreakpointChanges(o,n,t)}$provideDebugConfigurations(i,o,n){return(0,s.asPromise)(async()=>{const t=this.getConfigProviderByHandle(i);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.getFolder(o);return t.provideDebugConfigurations(l,n)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(i,o,n,t){return(0,s.asPromise)(async()=>{const l=this.getConfigProviderByHandle(i);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const b=await this.getFolder(o);return l.resolveDebugConfiguration(b,n,t)})}$resolveDebugConfigurationWithSubstitutedVariables(i,o,n,t){return(0,s.asPromise)(async()=>{const l=this.getConfigProviderByHandle(i);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const b=await this.getFolder(o);return l.resolveDebugConfigurationWithSubstitutedVariables(b,n,t)})}async $provideDebugAdapter(i,o){const n=this.getAdapterDescriptorFactoryByHandle(i);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(o);return this.getAdapterDescriptor(n,t).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(l)})}async $acceptDebugSessionStarted(i){const o=await this.getSession(i);this._onDidStartDebugSession.fire(o)}async $acceptDebugSessionTerminated(i){const o=await this.getSession(i);o&&(this._onDidTerminateDebugSession.fire(o),this._debugSessions.delete(o.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,o){const n=await this.getSession(i);n&&n._acceptNameChanged(o)}async $acceptDebugSessionCustomEvent(i,o){const t={session:await this.getSession(i),event:o.event,body:o.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(i){if(i instanceof S.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof S.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const o=this._adapterFactories.filter(n=>n.type===i);if(o.length>0)return o[0].factory}getAdapterDescriptorFactoryByHandle(i){const o=this._adapterFactories.filter(n=>n.handle===i);if(o.length>0)return o[0].factory}getConfigProviderByHandle(i){const o=this._configProviders.filter(n=>n.handle===i);if(o.length>0)return o[0].provider}definesDebugType(i,o){if(i.contributes){const n=i.contributes.debuggers;if(n&&n.length>0){for(const t of n)if(t.label&&t.type&&t.type===o)return!0}}return!1}getDebugAdapterTrackers(i){const n=i.configuration.type,t=this._trackerFactories.filter(l=>l.type===n||l.type==="*").map(l=>(0,s.asPromise)(()=>l.factory.createDebugAdapterTracker(i)).then(b=>b,b=>null));return Promise.race([Promise.all(t).then(l=>{const b=l.filter(v=>!!v);if(b.length>0)return new a(b)}),new Promise((l,b)=>{const v=setTimeout(()=>{clearTimeout(v),b(new Error("timeout"))},1e3)})]).catch(l=>{})}async getAdapterDescriptor(i,o){const n=o.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new S.DebugAdapterServer(n));if(i){const l=await this._extensionService.getExtensionRegistry();return(0,s.asPromise)(()=>i.createDebugAdapterDescriptor(o,this.daExecutableFromPackage(o,l))).then(b=>{if(b)return b})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(o,t))}daExecutableFromPackage(i,o){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,o,n){(i.length>0||o.length>0||n.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:o,changed:n}))}async getSession(i){if(i)if(typeof i=="string"){const o=this._debugSessions.get(i);if(o)return o}else{let o=this._debugSessions.get(i.id);if(!o){const n=await this.getFolder(i.folderUri),t=i.parent?this._debugSessions.get(i.parent):void 0;o=new k(this._debugServiceProxy,i.id,i.type,i.name,n,i.configuration,t),this._debugSessions.set(o.id,o),this._debugServiceProxy.$sessionCached(o.id)}return o}throw new Error("cannot find session")}getFolder(i){if(i){const o=U.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(o)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=c,e.ExtHostDebugServiceBase=c=$e([We(0,O.IExtHostRpcService),We(1,m.IExtHostWorkspace),We(2,A.IExtHostExtensionService),We(3,u.IExtHostConfiguration),We(4,w.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],c);class k{constructor(i,o,n,t,l,b,v){this._debugServiceProxy=i,this._id=o,this._type=n,this._name=t,this._workspaceFolder=l,this._configuration=b,this._parentSession=v}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}get parentSession(){return this._parentSession}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,o){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,o)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=k;class y{constructor(i){this.value=Object.freeze({append(o){i.$appendDebugConsole(o)},appendLine(o){this.append(o+`
`)}})}}e.ExtHostDebugConsole=y;class a{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(o=>o.onWillReceiveMessage?o.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(o=>o.onDidSendMessage?o.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(o=>o.onError?o.onError(i):void 0)}onExit(i,o){this.trackers.forEach(n=>n.onExit?n.onExit(i,o):void 0)}}class D extends _.AbstractDebugAdapter{constructor(i){super();this.implementation=i,i.onDidSendMessage(o=>{this.acceptMessage(o)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends c{constructor(i,o,n,t,l,b){super(i,o,n,t,l,b)}};e.WorkerExtHostDebugService=r,e.WorkerExtHostDebugService=r=$e([We(0,O.IExtHostRpcService),We(1,m.IExtHostWorkspace),We(2,A.IExtHostExtensionService),We(3,u.IExtHostConfiguration),We(4,w.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],r)}),define(Ie[228],Te([1,0,11,73,2,4,219,14,58,60,28,147,16,65,33]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class u{constructor(c,k,y,a,D){this._hostUtils=y,this._rpcProtocol=new I.RPCProtocol(c,null,a),k=u._transform(k,this._rpcProtocol);const r=new A.ServiceCollection(...(0,w.getSingletonServiceDescriptors)());r.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...k,messagePorts:D}),r.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),r.set(_.IURITransformerService,new _.URITransformerService(a)),r.set(f.IHostUtils,y);const h=new S.InstantiationService(r,!0);this._logService=h.invokeFunction(t=>t.get(P.ILogService)),C.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",k),this._extensionService=h.invokeFunction(t=>t.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const i=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(l,b)=>{let v="",E,x;for(const $ of b)v+=`
	at ${$.toString()}`,x=$.getFileName(),!E&&x&&(E=t.findSubstr(g.URI.file(x)));return i.set(l,E),`${l.name||"Error"}: ${l.message||""}${v}`}});const o=this._rpcProtocol.getProxy(U.MainContext.MainThreadExtensionService),n=this._rpcProtocol.getProxy(U.MainContext.MainThreadErrors);s.setUnexpectedErrorHandler(t=>{const l=s.transformErrorForSerialization(t),b=i.get(t);b?o.$onExtensionRuntimeError(b.identifier,l):n.$onUnexpectedError(l)})}async asBrowserUri(c){const k=this._rpcProtocol.getProxy(U.MainContext.MainThreadExtensionService);return g.URI.revive(await k.$asBrowserUri(c))}terminate(c){this._extensionService.terminate(c)}static _transform(c,k){c.allExtensions.forEach(a=>a.extensionLocation=g.URI.revive(k.transformIncomingURIs(a.extensionLocation))),c.environment.appRoot=g.URI.revive(k.transformIncomingURIs(c.environment.appRoot));const y=c.environment.extensionDevelopmentLocationURI;return y&&(c.environment.extensionDevelopmentLocationURI=y.map(a=>g.URI.revive(k.transformIncomingURIs(a)))),c.environment.extensionTestsLocationURI=g.URI.revive(k.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=g.URI.revive(k.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=g.URI.revive(k.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=g.URI.revive(k.transformIncomingURIs(c.logsLocation)),c.logFile=g.URI.revive(k.transformIncomingURIs(c.logFile)),c.workspace=k.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=u}),define(Ie[229],Te([1,0,15,13,20,45,12,19,21,9,2,41]),function(ee,e,s,C,g,U,I,P,w,A,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class m{constructor(y,a,D,r){this.query=y,this.provider=a,this.fileUtils=D,this.processType=r,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(y,a){const D=this.query.folderQueries||[],r=new g.CancellationTokenSource;return a.onCancellationRequested(()=>r.cancel()),new Promise((h,i)=>{this.collector=new f(y);let o=!1;const n=(t,l)=>{if(!o&&!this.isLimitHit){const b=this.resultSize(t);d(t)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,o=!0,r.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const v=this.resultSize(t);this.resultCount+=v,(v>0||!d(t))&&this.collector.add(t,l)}};Promise.all(D.map((t,l)=>this.searchInFolder(t,b=>n(b,l),r.token))).then(t=>{r.dispose(),this.collector.flush();const l=t.some(b=>!!b&&!!b.limitHit);h({limitHit:this.isLimitHit||l,messages:(0,s.flatten)(t.map(b=>b?.message?(0,A.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},t=>{r.dispose();const l=(0,U.toErrorMessage)(t);i(new Error(l))})})}resultSize(y){return d(y)?Array.isArray(y.ranges)?y.ranges.length:1:0}trimResultToSize(y,a){const D=Array.isArray(y.ranges)?y.ranges:[y.ranges],r=Array.isArray(y.preview.matches)?y.preview.matches:[y.preview.matches];return{ranges:D.slice(0,a),preview:{matches:r.slice(0,a),text:y.preview.text},uri:y.uri}}async searchInFolder(y,a,D){const r=new S.QueryGlobTester(this.query,y),h=[],i={report:t=>{if(!this.validateProviderResult(t))return;const l=y.folder.scheme===I.Schemas.file?(0,S.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(w.dirname(t.uri))):void 0,b=w.relativePath(y.folder,t.uri);if(b){const v=r.includedInQuery(b,P.basename(b),l);(0,C.isThenable)(v)?h.push(v.then(E=>{E&&a(t)})):v&&a(t)}}},o=this.getSearchOptionsForFolder(y),n=await this.provider.provideTextSearchResults(_(this.query.contentPattern),o,i,D);return h.length&&await Promise.all(h),n}validateProviderResult(y){if(d(y)){if(Array.isArray(y.ranges)){if(!Array.isArray(y.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(y.preview.matches.length!==y.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(y.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(y){const a=(0,S.resolvePatternsForProvider)(this.query.includePattern,y.includePattern),D=(0,S.resolvePatternsForProvider)(this.query.excludePattern,y.excludePattern),r={folder:O.URI.from(y.folder),excludes:D,includes:a,useIgnoreFiles:!y.disregardIgnoreFiles,useGlobalIgnoreFiles:!y.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!y.disregardParentIgnoreFiles,followSymlinks:!y.ignoreSymlinks,encoding:y.fileEncoding&&this.fileUtils.toCanonicalName(y.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return r.usePCRE2=this.query.usePCRE2,r}}e.TextSearchManager=m;function _(k){return{isCaseSensitive:k.isCaseSensitive||!1,isRegExp:k.isRegExp||!1,isWordMatch:k.isWordMatch||!1,isMultiline:k.isMultiline||!1,pattern:k.pattern}}class f{constructor(y){this._onResult=y,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new c(512,a=>this.sendItems(a))}add(y,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!w.isEqual(this._currentUri,y.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:y.uri,results:[]}),this._currentFileMatch.results.push(u(y))}pushToCollector(){const y=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,y)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(y){this._onResult(y)}}e.TextSearchResultsCollector=f;function u(k){return d(k)?{preview:{matches:(0,s.mapArrayOrNot)(k.preview.matches,y=>({startLineNumber:y.start.line,startColumn:y.start.character,endLineNumber:y.end.line,endColumn:y.end.character})),text:k.preview.text},ranges:(0,s.mapArrayOrNot)(k.ranges,y=>({startLineNumber:y.start.line,startColumn:y.start.character,endLineNumber:y.end.line,endColumn:y.end.character}))}:{text:k.text,lineNumber:k.lineNumber}}function d(k){return!!k.preview}e.extensionResultIsMatch=d;class c{constructor(y,a){this.maxBatchSize=y,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(y,a){!y||this.addItemToBatch(y,a)}addItems(y,a){!y||this.addItemsToBatch(y,a)}addItemToBatch(y,a){this.batch.push(y),this.batchSize+=a,this.onUpdate()}addItemsToBatch(y,a){this.batch=this.batch.concat(y),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<c.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},c.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=c,c.TIMEOUT=4e3,c.START_BATCH_AFTER_COUNT=50}),define(Ie[103],Te([1,0,7,4,3,224,16,65,14,2,229]),function(ee,e,s,C,g,U,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,g.createDecorator)("IExtHostSearch");let S=class{constructor(u,d,c){this.extHostRpc=u,this._uriTransformer=d,this._logService=c,this._proxy=this.extHostRpc.getProxy(C.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new U.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,d){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const c=this._handlePool++;return this._textSearchProvider.set(c,d),this._proxy.$registerTextSearchProvider(c,this._transformScheme(u)),(0,s.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(c),this._proxy.$unregisterProvider(c)})}registerFileSearchProvider(u,d){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const c=this._handlePool++;return this._fileSearchProvider.set(c,d),this._proxy.$registerFileSearchProvider(c,this._transformScheme(u)),(0,s.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(c),this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(u,d,c,k){const y=m(c),a=this._fileSearchProvider.get(u);if(a)return this._fileSearchManager.fileSearch(y,a,D=>{this._proxy.$handleFileMatch(u,d,D.map(r=>r.resource))},k);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,d,c,k){const y=this._textSearchProvider.get(u);if(!y||!y.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const a=m(c);return this.createTextSearchManager(a,y).search(r=>this._proxy.$handleTextMatch(u,d,r),k)}$enableExtensionHostSearch(){}createTextSearchManager(u,d){return new O.TextSearchManager(u,d,{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}};e.ExtHostSearch=S,e.ExtHostSearch=S=$e([We(0,I.IExtHostRpcService),We(1,P.IURITransformerService),We(2,w.ILogService)],S);function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(_),extraFileResources:f.extraFileResources&&f.extraFileResources.map(u=>A.URI.revive(u))}}e.reviveQuery=m;function _(f){return{...f,folder:A.URI.revive(f.folder)}}}),define(Ie[230],Te([1,0,58,98,31,95,32,36,50,53,100,102,103,71,64,70,97,52,35,69,86,51,202,14,179,101]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d,c,k,y,a,D,r,h,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(h.ILoggerService,r.ExtHostLoggerService),(0,s.registerSingleton)(h.ILogService,i.ExtHostLogService),(0,s.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,s.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,s.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration),(0,s.registerSingleton)(c.IExtHostConsumerFileSystem,c.ExtHostConsumerFileSystem),(0,s.registerSingleton)(S.IExtHostDebugService,S.WorkerExtHostDebugService),(0,s.registerSingleton)(U.IExtHostDecorations,U.ExtHostDecorations),(0,s.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors),(0,s.registerSingleton)(k.IExtHostFileSystemInfo,k.ExtHostFileSystemInfo),(0,s.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService),(0,s.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch),(0,s.registerSingleton)(_.IExtHostStorage,_.ExtHostStorage),(0,s.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask),(0,s.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,s.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,s.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow),(0,s.registerSingleton)(g.IExtHostWorkspace,g.ExtHostWorkspace),(0,s.registerSingleton)(y.IExtHostSecretState,y.ExtHostSecretState),(0,s.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry),(0,s.registerSingleton)(D.IExtHostEditorTabs,D.ExtHostEditorTabs),(0,s.registerSingleton)(o.IExtHostVariableResolverProvider,o.ExtHostVariableResolverProviderService)}),define(Ie[231],Te([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class s{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(g){if(g&&this._dragOperations.has(g)){const U=this._dragOperations.get(g);return this._dragOperations.delete(g),U}}addDragOperationTransfer(g,U){this._dragOperations.set(g,U)}getRenderedTreeElement(g){if(this._renderedElements.has(g))return this._renderedElements.get(g)}addRenderedTreeItemElement(g,U){this._renderedElements.set(g,U)}removeRenderedTreeItemElement(g){this._renderedElements.has(g)&&this._renderedElements.delete(g)}}e.TreeviewsService=s}),define(Ie[232],Te([1,0,133,6,21,2,5,7,13,6,9,15,8,20,231,26]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(y,a){if((0,O.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let D;return Array.isArray(y.highlights)&&(D=y.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),D=D.length?D:void 0),{label:y.label,highlights:D}}}class c{constructor(a,D,r){this._proxy=a,this.commands=D,this.logService=r,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function h(i){return i&&i.$treeViewId&&i.$treeItemHandle}D.registerArgumentProcessor({processArgument:i=>h(i)?this.convertArgument(i):Array.isArray(i)&&i.length>0?i.map(o=>h(o)?this.convertArgument(o):o):i})}registerTreeDataProvider(a,D,r){const h=this.createTreeView(a,{treeDataProvider:D},r);return{dispose:()=>h.dispose()}}createTreeView(a,D,r){if(!D||!D.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=D.dragAndDropController?.dropMimeTypes??[],i=D.dragAndDropController?.dragMimeTypes??[],o=!!D.dragAndDropController?.handleDrag,n=!!D.dragAndDropController?.handleDrop,t=(0,u.isProposedApiEnabled)(r,"dataTransferFiles"),l=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!D.showCollapseAll,canSelectMany:!!D.canSelectMany,dropMimeTypes:h,dragMimeTypes:i,hasHandleDrag:o,hasHandleDrop:n,supportsFileDataTransfers:t}),b=this.createExtHostTreeView(a,D,r);return{get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get message(){return b.message},set message(v){b.message=v},get title(){return b.title},set title(v){b.title=v},get description(){return b.description},set description(v){b.description=v},get badge(){return(0,u.checkProposedApiEnabled)(r,"badges"),b.badge},set badge(v){(0,u.checkProposedApiEnabled)(r,"badges"),b.badge=v},reveal:(v,E)=>b.reveal(v,E),dispose:async()=>{await l,this.treeViews.delete(a),b.dispose()}}}$getChildren(a,D){const r=this.treeViews.get(a);return r?r.getChildren(D):Promise.reject(new Error((0,s.localize)(0,null,a)))}async $handleDrop(a,D,r,h,i,o,n,t){const l=this.treeViews.get(a);if(!l)return Promise.reject(new Error((0,s.localize)(1,null,a)));const b=m.DataTransfer.toDataTransfer(r,async v=>(await this._proxy.$resolveDropFileData(a,D,v)).buffer);return n===a&&t&&await this.addAdditionalTransferItems(b,l,t,i,o),l.onDrop(b,h,i)}async addAdditionalTransferItems(a,D,r,h,i){const o=this.treeDragAndDropService.removeDragOperationTransfer(i);if(o)(await o)?.forEach((n,t)=>{n&&a.set(t,n)});else if(i&&D.handleDrag){const n=D.handleDrag(r,a,h);this.treeDragAndDropService.addDragOperationTransfer(i,n),await n}return a}async $handleDrag(a,D,r,h){const i=this.treeViews.get(a);if(!i)return Promise.reject(new Error((0,s.localize)(2,null,a)));const o=await this.addAdditionalTransferItems(new C.DataTransfer,i,D,h,r);if(!!o)return m.DataTransfer.toDataTransferDTO(o)}async $hasResolve(a){const D=this.treeViews.get(a);if(!D)throw new Error((0,s.localize)(3,null,a));return D.hasResolve}$resolve(a,D,r){const h=this.treeViews.get(a);if(!h)throw new Error((0,s.localize)(4,null,a));return h.resolveTreeItem(D,r)}$setExpanded(a,D,r){const h=this.treeViews.get(a);if(!h)throw new Error((0,s.localize)(5,null,a));h.setExpanded(D,r)}$setSelection(a,D){const r=this.treeViews.get(a);if(!r)throw new Error((0,s.localize)(6,null,a));r.setSelection(D)}$setVisible(a,D){const r=this.treeViews.get(a);if(!r)throw new Error((0,s.localize)(7,null,a));r.setVisible(D)}createExtHostTreeView(a,D,r){const h=new k(a,D,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(a,h),h}convertArgument(a){const D=this.treeViews.get(a.$treeViewId);return D?D.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=c;class k extends P.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,O.isUndefinedOrNull)(a))}constructor(a,D,r,h,i,o){super();if(this.viewId=a,this.proxy=r,this.commands=h,this.logService=i,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new I.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new I.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new I.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new I.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new _.CancellationTokenSource,o.contributes&&o.contributes.views)for(const l in o.contributes.views)for(const b of o.contributes.views[l])b.id===a&&(this._title=b.name);this.dataProvider=D.treeDataProvider,this.dndController=D.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let n,t;this._register(I.Event.debounce(this._onDidChangeData.event,(l,b)=>(l||(l={message:!1,elements:[]}),b.element!==!1&&(n||(n=new Promise(v=>t=v),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(b.element)?l.elements.push(...b.element):l.elements.push(b.element)),b.message&&(l.message=!0),l),200,!0)(({message:l,elements:b})=>{b.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=t;return n=null,this.refresh(b).then(()=>v())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(a){const D=a?this.getExtensionElement(a):void 0;if(a&&!D)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(a);return r||(r=await this.fetchChildrenNodes(D)),r?r.map(h=>h.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,D){D=D||{select:!0,focus:!1};const r=(0,O.isUndefinedOrNull)(D.select)?!0:D.select,h=(0,O.isUndefinedOrNull)(D.focus)?!1:D.focus,i=(0,O.isUndefinedOrNull)(D.expand)?!1:D.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(o=>this.resolveTreeNode(a,o[o.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:o.map(t=>t.item)},{select:r,focus:h,expand:i})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:h,expand:i})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}get badge(){return this._badge}set badge(a){this._badge?.value===a?.value&&this._badge?.tooltip===a?.tooltip||(this._badge=m.ViewBadge.from(a),this.proxy.$setBadge(this.viewId,a))}setExpanded(a,D){const r=this.getExtensionElement(a);r&&(D?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelection(a){(0,S.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(a,D,r){const h=[];for(const i of a){const o=this.getExtensionElement(i);o&&h.push(o)}if(!(!this.dndController?.handleDrag||h.length===0))return await this.dndController.handleDrag(h,D,r),D}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,D,r){const h=D?this.getExtensionElement(D):void 0;if(!(!h&&D||!this.dndController?.handleDrop))return(0,w.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(h,a,r):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,D){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(a);if(r){const h=this.nodes.get(r);if(h){const i=await this.dataProvider.resolveTreeItem(h.extensionItem,r,D)??h.extensionItem;return h.item.tooltip=this.getTooltip(i.tooltip),h.item.command=this.getCommand(h.disposableStore,i.command),h.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(D=>D?this.resolveUnknownParentChain(D).then(r=>this.resolveTreeNode(D,r[r.length-1]).then(h=>(r.push(h),r))):Promise.resolve([]))}resolveParent(a){const D=this.nodes.get(a);return D?Promise.resolve(D.parent?this.elements.get(D.parent.item.handle):void 0):(0,w.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,D){const r=this.nodes.get(a);return r?Promise.resolve(r):(0,w.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(h=>this.createHandle(a,h,D,!0)).then(h=>this.getChildren(D?D.item.handle:void 0).then(()=>{const i=this.getExtensionElement(h);if(i){const o=this.nodes.get(i);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(a){if(a){let D;if(typeof a=="string"){const r=this.getExtensionElement(a);D=r?this.nodes.get(r):void 0}else D=a;return D&&D.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const D=new _.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=a?this.nodes.get(a):void 0,h=await this.dataProvider.getChildren(a);if(D.token.isCancellationRequested)return;const i=await Promise.all((0,S.coalesce)(h||[]).map(async o=>{const n=await this.dataProvider.getTreeItem(o);return n&&!D.token.isCancellationRequested?this.createAndRegisterTreeNode(o,n,r):null}));return D.token.isCancellationRequested?void 0:(0,S.coalesce)(i)}finally{D.dispose()}}refresh(a){if(a.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new _.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(a);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const D=new Set,r=a.map(i=>this.nodes.get(i));for(const i of r)if(i&&!D.has(i.item.handle)){let o=i;for(;o&&o.parent&&r.findIndex(n=>o&&o.parent&&n&&n.item.handle===o.parent.item.handle)===-1;){const n=this.elements.get(o.parent.item.handle);o=n?this.nodes.get(n):void 0}o&&!o.parent&&D.add(i.item.handle)}const h=[];return D.forEach(i=>{const o=this.elements.get(i);if(o){const n=this.nodes.get(o);n&&(!n.parent||!D.has(n.parent.item.handle))&&h.push(i)}}),h}refreshHandles(a){const D={};return Promise.all(a.map(r=>this.refreshNode(r).then(h=>{h&&(D[r]=h.item)}))).then(()=>Object.keys(D).length?this.proxy.$refresh(this.viewId,D):void 0)}refreshNode(a){const D=this.getExtensionElement(a);if(D){const r=this.nodes.get(D);if(r)return this.clearChildren(D),(0,w.asPromise)(()=>this.dataProvider.getTreeItem(D)).then(h=>{if(h){const i=this.createTreeNode(D,h,r.parent);return this.updateNodeCache(D,i,r,r.parent),r.dispose(),i}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,D,r){const h=this.createTreeNode(a,D,r);if(D.id&&this.elements.has(h.item.handle))throw new Error((0,s.localize)(8,null,D.id));return this.addNodeToCache(a,h),this.addNodeToParentCache(h,r),h}getTooltip(a){return A.MarkdownString.isMarkdownString(a)?m.MarkdownString.from(a):a}getCommand(a,D){return D?this.commands.toInternal(D,a):void 0}createTreeNode(a,D,r){const h=new P.DisposableStore,i=this.createHandle(a,D,r),o=this.getLightIconPath(D);return{item:{handle:i,parentHandle:r?r.item.handle:void 0,label:d(D.label,this.extension),description:D.description,resourceUri:D.resourceUri,tooltip:this.getTooltip(D.tooltip),command:this.getCommand(h,D.command),contextValue:D.contextValue,icon:o,iconDark:this.getDarkIconPath(D)||o,themeIcon:this.getThemeIcon(D),collapsibleState:(0,O.isUndefinedOrNull)(D.collapsibleState)?A.TreeItemCollapsibleState.None:D.collapsibleState,accessibilityInformation:D.accessibilityInformation},extensionItem:D,parent:r,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(a){return a.iconPath instanceof A.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:D,label:r,resourceUri:h},i,o){if(D)return`${k.ID_HANDLE_PREFIX}/${D}`;const n=d(r,this.extension),t=i?i.item.handle:k.LABEL_HANDLE_PREFIX;let l=n?n.label:h?(0,g.basename)(h):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const b=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,v=this.getChildrenNodes(i)||[];let E,x=0;do{if(E=`${t}/${x}:${l}`,o||!this.elements.has(E)||b===E)break;x++}while(x<=v.length);return E}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof A.ThemeIcon))return typeof a.iconPath=="string"||U.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof A.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return U.URI.isUri(a)?a:U.URI.file(a)}addNodeToCache(a,D){this.elements.set(D.item.handle,a),this.nodes.set(a,D)}updateNodeCache(a,D,r,h){this.elements.delete(D.item.handle),this.nodes.delete(a),D.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(a,D);const i=this.getChildrenNodes(h)||[],o=i.filter(n=>n.item.handle===r.item.handle)[0];o&&i.splice(i.indexOf(o),1,D)}addNodeToParentCache(a,D){D?(D.children||(D.children=[]),D.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const D=this.nodes.get(a);if(D){if(D.children)for(const r of D.children){const h=this.elements.get(r.item.handle);h&&this.clear(h)}D.children=void 0}}else this.clearAll()}clear(a){const D=this.nodes.get(a);if(D){if(D.children)for(const r of D.children){const h=this.elements.get(r.item.handle);h&&this.clear(h)}this.nodes.delete(a),this.elements.delete(D.item.handle),D.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}k.LABEL_HANDLE_PREFIX="0",k.ID_HANDLE_PREFIX="1"}),define(Ie[233],Te([1,0,20,11,5,29,2,120,243,115,114,39,4,94,188,187,36,189,32,190,191,192,173,193,50,33,195,196,199,201,203,98,175,208,209,210,71,53,212,232,8,6,215,54,97,31,43,163,198,85,95,100,102,103,14,65,16,28,204,160,64,70,185,213,72,52,218,216,217,186,35,211,214,69,51,86,206,99,207,12,81,205,158,197,7,26,165]),function(ee,e,s,C,g,U,I,P,w,A,O,S,m,_,f,u,d,c,k,y,a,D,r,h,i,o,n,t,l,b,v,E,x,$,R,p,F,M,z,Z,K,N,se,le,oe,fe,be,ce,ve,J,Ee,_e,Fe,xe,Xe,ke,Se,Pe,re,ae,X,G,T,B,H,V,ne,ue,Q,ge,pe,Ne,Be,Ae,Ke,q,Y,me,Le,ze,Ge,Ze,ot,Qe,et,qe,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function it(at){const ct=at.get(Pe.IExtHostInitDataService),Tt=at.get(pe.IExtHostFileSystemInfo),Ut=at.get(V.IExtHostConsumerFileSystem),Ct=at.get(o.IExtHostExtensionService),ft=at.get(fe.IExtHostWorkspace),At=at.get(q.IExtHostTelemetry),xt=at.get(k.IExtHostConfiguration),_t=at.get(ke.IURITransformerService),He=at.get(Se.IExtHostRpcService),Rt=at.get(F.IExtHostStorage),Mt=at.get(H.IExtensionStoragePaths),Ot=at.get(Xe.ILoggerService),pt=at.get(Xe.ILogService),St=at.get(X.IExtHostTunnelService),It=at.get(G.IExtHostApiDeprecationService),wt=at.get(oe.IExtHostWindow),we=at.get(Ae.IExtHostSecretState),Ce=at.get(Ke.IExtHostEditorTabs);He.set(m.ExtHostContext.ExtHostFileSystemInfo,Tt),He.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Ot),He.set(m.ExtHostContext.ExtHostWorkspace,ft),He.set(m.ExtHostContext.ExtHostConfiguration,xt),He.set(m.ExtHostContext.ExtHostExtensionService,Ct),He.set(m.ExtHostContext.ExtHostStorage,Rt),He.set(m.ExtHostContext.ExtHostTunnelService,St),He.set(m.ExtHostContext.ExtHostWindow,wt),He.set(m.ExtHostContext.ExtHostSecretState,we),He.set(m.ExtHostContext.ExtHostTelemetry,At),He.set(m.ExtHostContext.ExtHostEditorTabs,Ce);const de=He.set(m.ExtHostContext.ExtHostDecorations,at.get(Ee.IExtHostDecorations)),j=He.set(m.ExtHostContext.ExtHostDocumentsAndEditors,at.get(i.IExtHostDocumentsAndEditors)),De=He.set(m.ExtHostContext.ExtHostCommands,at.get(d.IExtHostCommands)),Me=He.set(m.ExtHostContext.ExtHostTerminalService,at.get(M.IExtHostTerminalService)),Je=He.set(m.ExtHostContext.ExtHostDebugService,at.get(Fe.IExtHostDebugService)),Ve=He.set(m.ExtHostContext.ExtHostSearch,at.get(xe.IExtHostSearch)),ut=He.set(m.ExtHostContext.ExtHostTask,at.get(_e.IExtHostTask)),ht=He.set(m.ExtHostContext.ExtHostOutputService,at.get(E.IExtHostOutputService)),Et=He.set(m.ExtHostContext.ExtHostUrls,new se.ExtHostUrls(He)),mt=He.set(m.ExtHostContext.ExtHostDocuments,new h.ExtHostDocuments(He,j)),kt=He.set(m.ExtHostContext.ExtHostDocumentContentProviders,new D.ExtHostDocumentContentProvider(He,j,pt)),Ft=He.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(pt,mt,He.getProxy(m.MainContext.MainThreadBulkEdits))),vt=He.set(m.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(He,De,j,mt,Mt)),zt=He.set(m.ExtHostContext.ExtHostNotebookDocuments,new ot.ExtHostNotebookDocuments(vt)),Yt=He.set(m.ExtHostContext.ExtHostNotebookEditors,new Ze.ExtHostNotebookEditors(pt,He,vt)),ai=He.set(m.ExtHostContext.ExtHostNotebookKernels,new Y.ExtHostNotebookKernels(He,ct,vt,De,pt)),li=He.set(m.ExtHostContext.ExtHostNotebookRenderers,new Le.ExtHostNotebookRenderers(He,vt)),yt=He.set(m.ExtHostContext.ExtHostEditors,new z.ExtHostEditors(He,j)),ii=He.set(m.ExtHostContext.ExtHostTreeViews,new Z.ExtHostTreeViews(He.getProxy(m.MainContext.MainThreadTreeViews),De,pt)),ci=He.set(m.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(He.getProxy(m.MainContext.MainThreadEditorInsets),yt,ct.remote)),Kt=He.set(m.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(He,pt,Tt)),Gt=He.set(m.ExtHostContext.ExtHostLanguages,new b.ExtHostLanguages(He,mt,De.converter,_t)),dt=He.set(m.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(He,_t,mt,De,Kt,pt,It)),ui=He.set(m.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(He,dt)),$t=He.set(m.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(He,pt,j)),Vt=He.set(m.ExtHostContext.ExtHostQuickOpen,(0,$.createExtHostQuickOpen)(He,ft,De)),di=He.set(m.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(He,De,pt)),vi=He.set(m.ExtHostContext.ExtHostComments,(0,c.createExtHostComments)(He,De,mt)),ni=He.set(m.ExtHostContext.ExtHostProgress,new x.ExtHostProgress(He.getProxy(m.MainContext.MainThreadProgress))),hi=He.set(m.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(He)),ri=He.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(He)),Xt=He.set(m.ExtHostContext.ExtHostAuthentication,new T.ExtHostAuthentication(He)),Ei=He.set(m.ExtHostContext.ExtHostTimeline,new B.ExtHostTimeline(He,De)),Jt=He.set(m.ExtHostContext.ExtHostWebviews,new le.ExtHostWebviews(He,ct.remote,ft,pt,It)),Zt=He.set(m.ExtHostContext.ExtHostWebviewPanels,new Q.ExtHostWebviewPanels(He,Jt,ft)),bi=He.set(m.ExtHostContext.ExtHostCustomEditors,new ue.ExtHostCustomEditors(He,mt,Mt,Jt,Zt)),wi=He.set(m.ExtHostContext.ExtHostWebviewViews,new ne.ExtHostWebviewViews(He,Jt)),Qt=He.set(m.ExtHostContext.ExtHostTesting,new Ne.ExtHostTesting(He,De)),_i=He.set(m.ExtHostContext.ExtHostUriOpeners,new Be.ExtHostUriOpeners(He));He.set(m.ExtHostContext.ExtHostInteractive,new Qe.ExtHostInteractive(He,vt,j,De));const Ri=(0,be.values)(m.ExtHostContext);He.assertRegistered(Ri);const Oi=new ge.ExtHostBulkEdits(He,j),fi=new u.ExtHostClipboard(He),ei=new v.ExtHostMessageService(He,pt),Si=new a.ExtHostDialogs(He),yi=new p.ExtHostStatusBar(He,De.converter);return f.ExtHostApiCommands.register(De),function(Ue,Bt,mi){const gt=function(){let ie=!Ue.isUnderDevelopment;function he(){ie||(pt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Oe(nt){if(Array.isArray(nt))nt.forEach(Oe);else if(typeof nt=="string")he();else{const bt=nt;typeof bt.scheme=="undefined"&&he(),typeof bt.exclusive=="boolean"&&(0,qe.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return nt}}(),Di={getSession(ie,he,Oe){return Xt.getSession(Ue,ie,he,Oe)},async hasSession(ie,he){return(0,qe.checkProposedApiEnabled)(Ue,"authSession"),!!await Xt.getSession(Ue,ie,he,{silent:!0})},get onDidChangeSessions(){return Xt.onDidChangeSessions},registerAuthenticationProvider(ie,he,Oe,nt){return Xt.registerAuthenticationProvider(ie,he,Oe,nt)}},Fi={registerCommand(ie,he,Oe){return De.registerCommand(!0,ie,he,Oe,void 0,Ue)},registerTextEditorCommand(ie,he,Oe){return De.registerCommand(!0,ie,(...nt)=>{const bt=yt.getActiveTextEditor();if(!bt){pt.warn("Cannot execute "+ie+" because there is no active text editor.");return}return bt.edit(Pt=>{he.apply(Oe,[bt,Pt,...nt])}).then(Pt=>{Pt||pt.warn("Edits from command "+ie+" were not applied.")},Pt=>{pt.warn("An error occurred while running command "+ie,Pt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ie,he,Oe)=>((0,qe.checkProposedApiEnabled)(Ue,"diffCommand"),De.registerCommand(!0,ie,async(...nt)=>{const bt=j.activeEditor(!0);if(!bt){pt.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Pt=await yt.getDiffInformation(bt.id);he.apply(Oe,[Pt,...nt])},void 0,void 0,Ue)),executeCommand(ie,...he){return De.executeCommand(ie,...he)},getCommands(ie=!1){return De.getCommands(ie)}},si={get machineId(){return ct.telemetryInfo.machineId},get sessionId(){return ct.telemetryInfo.sessionId},get language(){return ct.environment.appLanguage},get appName(){return ct.environment.appName},get appRoot(){return ct.environment.appRoot?.fsPath??""},get appHost(){return ct.environment.appHost},get uriScheme(){return ct.environment.appUriScheme},get clipboard(){return fi.value},get shell(){return Me.getDefaultShell(!1)},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return At.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Ue,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Ue,"telemetry"),At.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ie=Date.now()-new Date(ct.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,he){return wt.openUri(ie,{allowTunneling:!!ct.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===ct.environment.appUriScheme)return Et.createAppUri(ie);try{return await wt.asExternalUri(ie,{allowTunneling:!!ct.remote.authority})}catch(he){if((0,Ge.matchesScheme)(ie,ze.Schemas.http)||(0,Ge.matchesScheme)(ie,ze.Schemas.https))return ie;throw he}},get remoteName(){return(0,J.getRemoteName)(ct.remote.authority)},get remoteAuthority(){return(0,qe.checkProposedApiEnabled)(Ue,"resolvers"),ct.remote.authority},get uiKind(){return ct.uiKind}};ct.environment.extensionTestsLocationURI||Object.freeze(si);const Ci={createTestController(ie,he,Oe){return Qt.createTestController(ie,he,Oe)},createTestObserver(){return(0,qe.checkProposedApiEnabled)(Ue,"testObserver"),Qt.createTestObserver()},runTests(ie){return(0,qe.checkProposedApiEnabled)(Ue,"testObserver"),Qt.runTests(ie)},get onDidChangeTestResults(){return(0,qe.checkProposedApiEnabled)(Ue,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,qe.checkProposedApiEnabled)(Ue,"testObserver"),Qt.results}},Lt=ct.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,jt={getExtension(ie,he){(0,qe.isProposedApiEnabled)(Ue,"extensionsAny")||(he=!1);const Oe=Bt.mine.getExtensionDescription(ie);if(Oe)return new o.Extension(Ct,Ue.identifier,Oe,Lt,!1);if(he){const nt=Bt.all.getExtensionDescription(ie);if(nt)return new o.Extension(Ct,Ue.identifier,nt,Lt,!0)}},get all(){const ie=[];for(const he of Bt.mine.getAllExtensionDescriptions())ie.push(new o.Extension(Ct,Ue.identifier,he,Lt,!1));return ie},get allAcrossExtensionHosts(){(0,qe.checkProposedApiEnabled)(Ue,"extensionsAny");const ie=new qe.ExtensionIdentifierSet(Bt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),he=[];for(const Oe of Bt.all.getAllExtensionDescriptions()){const nt=!ie.has(Oe.identifier);he.push(new o.Extension(Ct,Ue.identifier,Oe,Lt,nt))}return he},get onDidChange(){return(0,qe.isProposedApiEnabled)(Ue,"extensionsAny")?g.Event.any(Bt.mine.onDidChange,Bt.all.onDidChange):Bt.mine.onDidChange}},Ni={createDiagnosticCollection(ie){return Kt.createDiagnosticCollection(Ue.identifier,ie)},get onDidChangeDiagnostics(){return Kt.onDidChangeDiagnostics},getDiagnostics:ie=>Kt.getDiagnostics(ie),getLanguages(){return Gt.getLanguages()},setTextDocumentLanguage(ie,he){return Gt.changeLanguage(ie.uri,he)},match(ie,he){const Oe=mt.getDocumentData(he.uri)?.notebook;return(0,O.score)(K.LanguageSelector.from(ie),he.uri,he.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ie,he,Oe){return dt.registerCodeActionProvider(Ue,gt(ie),he,Oe)},registerDocumentPasteEditProvider(ie,he){return(0,qe.checkProposedApiEnabled)(Ue,"documentPaste"),dt.registerDocumentPasteEditProvider(Ue,gt(ie),he)},registerCodeLensProvider(ie,he){return dt.registerCodeLensProvider(Ue,gt(ie),he)},registerDefinitionProvider(ie,he){return dt.registerDefinitionProvider(Ue,gt(ie),he)},registerDeclarationProvider(ie,he){return dt.registerDeclarationProvider(Ue,gt(ie),he)},registerImplementationProvider(ie,he){return dt.registerImplementationProvider(Ue,gt(ie),he)},registerTypeDefinitionProvider(ie,he){return dt.registerTypeDefinitionProvider(Ue,gt(ie),he)},registerHoverProvider(ie,he){return dt.registerHoverProvider(Ue,gt(ie),he,Ue.identifier)},registerEvaluatableExpressionProvider(ie,he){return dt.registerEvaluatableExpressionProvider(Ue,gt(ie),he,Ue.identifier)},registerInlineValuesProvider(ie,he){return dt.registerInlineValuesProvider(Ue,gt(ie),he,Ue.identifier)},registerDocumentHighlightProvider(ie,he){return dt.registerDocumentHighlightProvider(Ue,gt(ie),he)},registerLinkedEditingRangeProvider(ie,he){return dt.registerLinkedEditingRangeProvider(Ue,gt(ie),he)},registerReferenceProvider(ie,he){return dt.registerReferenceProvider(Ue,gt(ie),he)},registerRenameProvider(ie,he){return dt.registerRenameProvider(Ue,gt(ie),he)},registerDocumentSymbolProvider(ie,he,Oe){return dt.registerDocumentSymbolProvider(Ue,gt(ie),he,Oe)},registerWorkspaceSymbolProvider(ie){return dt.registerWorkspaceSymbolProvider(Ue,ie)},registerDocumentFormattingEditProvider(ie,he){return dt.registerDocumentFormattingEditProvider(Ue,gt(ie),he)},registerDocumentRangeFormattingEditProvider(ie,he){return dt.registerDocumentRangeFormattingEditProvider(Ue,gt(ie),he)},registerOnTypeFormattingEditProvider(ie,he,Oe,...nt){return dt.registerOnTypeFormattingEditProvider(Ue,gt(ie),he,[Oe].concat(nt))},registerDocumentSemanticTokensProvider(ie,he,Oe){return dt.registerDocumentSemanticTokensProvider(Ue,gt(ie),he,Oe)},registerDocumentRangeSemanticTokensProvider(ie,he,Oe){return dt.registerDocumentRangeSemanticTokensProvider(Ue,gt(ie),he,Oe)},registerSignatureHelpProvider(ie,he,Oe,...nt){return typeof Oe=="object"?dt.registerSignatureHelpProvider(Ue,gt(ie),he,Oe):dt.registerSignatureHelpProvider(Ue,gt(ie),he,typeof Oe=="undefined"?[]:[Oe,...nt])},registerCompletionItemProvider(ie,he,...Oe){return dt.registerCompletionItemProvider(Ue,gt(ie),he,Oe)},registerInlineCompletionItemProvider(ie,he){return he.handleDidShowCompletionItem&&(0,qe.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Ue,gt(ie),he)},registerInlineCompletionItemProviderNew(ie,he){if((0,qe.checkProposedApiEnabled)(Ue,"inlineCompletionsNew"),he.handleDidShowCompletionItem&&!(0,qe.isProposedApiEnabled)(Ue,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew(Ue,gt(ie),he)},registerDocumentLinkProvider(ie,he){return dt.registerDocumentLinkProvider(Ue,gt(ie),he)},registerColorProvider(ie,he){return dt.registerColorProvider(Ue,gt(ie),he)},registerFoldingRangeProvider(ie,he){return dt.registerFoldingRangeProvider(Ue,gt(ie),he)},registerSelectionRangeProvider(ie,he){return dt.registerSelectionRangeProvider(Ue,ie,he)},registerCallHierarchyProvider(ie,he){return dt.registerCallHierarchyProvider(Ue,ie,he)},registerTypeHierarchyProvider(ie,he){return dt.registerTypeHierarchyProvider(Ue,ie,he)},setLanguageConfiguration:(ie,he)=>dt.setLanguageConfiguration(Ue,ie,he),getTokenInformationAtPosition(ie,he){return(0,qe.checkProposedApiEnabled)(Ue,"tokenInformation"),Gt.tokenAtPosition(ie,he)},registerInlayHintsProvider(ie,he){return dt.registerInlayHintsProvider(Ue,ie,he)},createLanguageStatusItem(ie,he){return Gt.createLanguageStatusItem(Ue,ie,he)},registerDocumentOnDropEditProvider(ie,he){return(0,qe.checkProposedApiEnabled)(Ue,"textEditorDrop"),dt.registerDocumentOnDropEditProvider(Ue,ie,he)}},Ii={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return Me.activeTerminal},get terminals(){return Me.terminals},async showTextDocument(ie,he,Oe){const nt=await(I.URI.isUri(ie)?Promise.resolve(ti.openTextDocument(ie)):Promise.resolve(ie));return yt.showTextDocument(nt,he,Oe)},createTextEditorDecorationType(ie){return yt.createTextEditorDecorationType(Ue,ie)},onDidChangeActiveTextEditor(ie,he,Oe){return yt.onDidChangeActiveTextEditor(ie,he,Oe)},onDidChangeVisibleTextEditors(ie,he,Oe){return yt.onDidChangeVisibleTextEditors(ie,he,Oe)},onDidChangeTextEditorSelection(ie,he,Oe){return yt.onDidChangeTextEditorSelection(ie,he,Oe)},onDidChangeTextEditorOptions(ie,he,Oe){return yt.onDidChangeTextEditorOptions(ie,he,Oe)},onDidChangeTextEditorVisibleRanges(ie,he,Oe){return yt.onDidChangeTextEditorVisibleRanges(ie,he,Oe)},onDidChangeTextEditorViewColumn(ie,he,Oe){return yt.onDidChangeTextEditorViewColumn(ie,he,Oe)},onDidCloseTerminal(ie,he,Oe){return Me.onDidCloseTerminal(ie,he,Oe)},onDidOpenTerminal(ie,he,Oe){return Me.onDidOpenTerminal(ie,he,Oe)},onDidChangeActiveTerminal(ie,he,Oe){return Me.onDidChangeActiveTerminal(ie,he,Oe)},onDidChangeTerminalDimensions(ie,he,Oe){return(0,qe.checkProposedApiEnabled)(Ue,"terminalDimensions"),Me.onDidChangeTerminalDimensions(ie,he,Oe)},onDidChangeTerminalState(ie,he,Oe){return Me.onDidChangeTerminalState(ie,he,Oe)},onDidWriteTerminalData(ie,he,Oe){return(0,qe.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),Me.onDidWriteTerminalData(ie,he,Oe)},get state(){return wt.state},onDidChangeWindowState(ie,he,Oe){return wt.onDidChangeWindowState(ie,he,Oe)},showInformationMessage(ie,...he){return ei.showMessage(Ue,U.default.Info,ie,he[0],he.slice(1))},showWarningMessage(ie,...he){return ei.showMessage(Ue,U.default.Warning,ie,he[0],he.slice(1))},showErrorMessage(ie,...he){return ei.showMessage(Ue,U.default.Error,ie,he[0],he.slice(1))},showQuickPick(ie,he,Oe){return Vt.showQuickPick(ie,he,Oe)},showWorkspaceFolderPick(ie){return Vt.showWorkspaceFolderPick(ie)},showInputBox(ie,he){return Vt.showInput(ie,he)},showOpenDialog(ie){return Si.showOpenDialog(ie)},showSaveDialog(ie){return Si.showSaveDialog(ie)},createStatusBarItem(ie,he,Oe){let nt,bt,Pt;return typeof ie=="string"?(nt=ie,bt=he,Pt=Oe):(bt=ie,Pt=he),yi.createStatusBarEntry(Ue,nt,bt,Pt)},setStatusBarMessage(ie,he){return yi.setStatusBarMessage(ie,he)},withScmProgress(ie){return It.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ni.withProgress(Ue,{location:N.ProgressLocation.SourceControl},(he,Oe)=>ie({report(nt){}}))},withProgress(ie,he){return ni.withProgress(Ue,ie,he)},createOutputChannel(ie,he){return ht.createOutputChannel(ie,he,Ue)},createWebviewPanel(ie,he,Oe,nt){return Zt.createWebviewPanel(Ue,ie,he,Oe,nt)},createWebviewTextEditorInset(ie,he,Oe,nt){return(0,qe.checkProposedApiEnabled)(Ue,"editorInsets"),ci.createWebviewEditorInset(ie,he,Oe,nt,Ue)},createTerminal(ie,he,Oe){return typeof ie=="object"?"pty"in ie?Me.createExtensionTerminal(ie):Me.createTerminalFromOptions(ie):Me.createTerminal(ie,he,Oe)},registerTerminalLinkProvider(ie){return Me.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,he){return Me.registerProfileProvider(Ue,ie,he)},registerTreeDataProvider(ie,he){return ii.registerTreeDataProvider(ie,he,Ue)},createTreeView(ie,he){return ii.createTreeView(ie,he,Ue)},registerWebviewPanelSerializer:(ie,he)=>Zt.registerWebviewPanelSerializer(Ue,ie,he),registerCustomEditorProvider:(ie,he,Oe={})=>bi.registerCustomEditorProvider(Ue,ie,he,Oe),registerFileDecorationProvider(ie){return de.registerFileDecorationProvider(ie,Ue.identifier)},registerUriHandler(ie){return Et.registerUriHandler(Ue.identifier,ie)},createQuickPick(){return Vt.createQuickPick(Ue)},createInputBox(){return Vt.createInputBox(Ue)},get activeColorTheme(){return ri.activeColorTheme},onDidChangeActiveColorTheme(ie,he,Oe){return ri.onDidChangeActiveColorTheme(ie,he,Oe)},registerWebviewViewProvider(ie,he,Oe){return wi.registerWebviewViewProvider(Ue,ie,he,Oe?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,he,Oe){return vt.onDidChangeActiveNotebookEditor(ie,he,Oe)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,he,Oe){return Yt.onDidChangeNotebookEditorSelection(ie,he,Oe)},onDidChangeNotebookEditorVisibleRanges(ie,he,Oe){return Yt.onDidChangeNotebookEditorVisibleRanges(ie,he,Oe)},showNotebookDocument(ie,he){return I.URI.isUri(ie)&&It.report("window.showNotebookDocument(uri)",Ue,"Please use 'window.openNotebookDocument' and 'window.showTextDocument'"),vt.showNotebookDocument(ie,he)},registerExternalUriOpener(ie,he,Oe){return(0,qe.checkProposedApiEnabled)(Ue,"externalUriOpener"),_i.registerExternalUriOpener(Ue.identifier,ie,he,Oe)},get tabGroups(){return Ce.tabGroups}},ti={get rootPath(){return It.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ie){throw C.readonly()},getWorkspaceFolder(ie){return ft.getWorkspaceFolder(ie)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ie){throw C.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ie){throw C.readonly()},updateWorkspaceFolders:(ie,he,...Oe)=>ft.updateWorkspaceFolders(Ue,ie,he||0,...Oe),onDidChangeWorkspaceFolders:function(ie,he,Oe){return ft.onDidChangeWorkspace(ie,he,Oe)},asRelativePath:(ie,he)=>ft.getRelativePath(ie,he),findFiles:(ie,he,Oe,nt)=>ft.findFiles(ie,he,Oe,Ue.identifier,nt),findTextInFiles:(ie,he,Oe,nt)=>{(0,qe.checkProposedApiEnabled)(Ue,"findTextInFiles");let bt,Pt;return typeof he=="object"?(bt=he,Pt=Oe):(bt={},Pt=he,nt=Oe),ft.findTextInFiles(ie,bt||{},Pt,Ue.identifier,nt)},saveAll:ie=>ft.saveAll(ie),applyEdit(ie){return Oi.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,he,Oe,nt)=>$t.createFileSystemWatcher(ft,Ue,ie,he,Oe,nt),get textDocuments(){return mt.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw C.readonly()},openTextDocument(ie){let he;const Oe=ie;if(typeof ie=="string")he=Promise.resolve(I.URI.file(ie));else if(I.URI.isUri(ie))he=Promise.resolve(ie);else if(!Oe||typeof Oe=="object")he=mt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(nt=>mt.ensureDocumentData(nt).then(bt=>bt.document))},onDidOpenTextDocument:(ie,he,Oe)=>mt.onDidAddDocument(ie,he,Oe),onDidCloseTextDocument:(ie,he,Oe)=>mt.onDidRemoveDocument(ie,he,Oe),onDidChangeTextDocument:(ie,he,Oe)=>mt.onDidChangeDocument(ie,he,Oe),onDidSaveTextDocument:(ie,he,Oe)=>mt.onDidSaveDocument(ie,he,Oe),onWillSaveTextDocument:(ie,he,Oe)=>Ft.getOnWillSaveTextDocumentEvent(Ue)(ie,he,Oe),get notebookDocuments(){return vt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,he){let Oe;if(I.URI.isUri(ie))Oe=ie,await vt.openNotebookDocument(ie);else if(typeof ie=="string")Oe=I.URI.revive(await vt.createNotebookDocument({viewType:ie,content:he}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ie,he,Oe){return zt.onDidSaveNotebookDocument(ie,he,Oe)},onDidChangeNotebookDocument(ie,he,Oe){return zt.onDidChangeNotebookDocument(ie,he,Oe)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,he,Oe,nt){return vt.registerNotebookSerializer(Ue,ie,he,Oe,(0,qe.isProposedApiEnabled)(Ue,"notebookLiveShare")?nt:void 0)},registerNotebookContentProvider:(ie,he,Oe,nt)=>((0,qe.checkProposedApiEnabled)(Ue,"notebookContentProvider"),It.report("workspace.registerNotebookContentProvider",Ue,"The notebookContentProvider API is not on track for finalization and will be removed."),vt.registerNotebookContentProvider(Ue,ie,he,Oe,(0,qe.isProposedApiEnabled)(Ue,"notebookLiveShare")?nt:void 0)),onDidChangeConfiguration:(ie,he,Oe)=>mi.onDidChangeConfiguration(ie,he,Oe),getConfiguration(ie,he){return he=arguments.length===1?void 0:he,mi.getConfiguration(ie,he,Ue)},registerTextDocumentContentProvider(ie,he){return kt.registerTextDocumentContentProvider(ie,he)},registerTaskProvider:(ie,he)=>(It.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),ut.registerTaskProvider(Ue,ie,he)),registerFileSystemProvider(ie,he,Oe){return(0,et.combinedDisposable)(ui.registerFileSystemProvider(Ue,ie,he,Oe),Ut.addFileSystemProvider(ie,he))},get fs(){return Ut.value},registerFileSearchProvider:(ie,he)=>((0,qe.checkProposedApiEnabled)(Ue,"fileSearchProvider"),Ve.registerFileSearchProvider(ie,he)),registerTextSearchProvider:(ie,he)=>((0,qe.checkProposedApiEnabled)(Ue,"textSearchProvider"),Ve.registerTextSearchProvider(ie,he)),registerRemoteAuthorityResolver:(ie,he)=>((0,qe.checkProposedApiEnabled)(Ue,"resolvers"),Ct.registerRemoteAuthorityResolver(ie,he)),registerResourceLabelFormatter:ie=>((0,qe.checkProposedApiEnabled)(Ue,"resolvers"),hi.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,he,Oe)=>$t.onDidCreateFile(ie,he,Oe),onDidDeleteFiles:(ie,he,Oe)=>$t.onDidDeleteFile(ie,he,Oe),onDidRenameFiles:(ie,he,Oe)=>$t.onDidRenameFile(ie,he,Oe),onWillCreateFiles:(ie,he,Oe)=>$t.getOnWillCreateFileEvent(Ue)(ie,he,Oe),onWillDeleteFiles:(ie,he,Oe)=>$t.getOnWillDeleteFileEvent(Ue)(ie,he,Oe),onWillRenameFiles:(ie,he,Oe)=>$t.getOnWillRenameFileEvent(Ue)(ie,he,Oe),openTunnel:ie=>((0,qe.checkProposedApiEnabled)(Ue,"resolvers"),St.openTunnel(Ue,ie).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,qe.checkProposedApiEnabled)(Ue,"resolvers"),St.getTunnels()},onDidChangeTunnels:(ie,he,Oe)=>((0,qe.checkProposedApiEnabled)(Ue,"resolvers"),St.onDidChangeTunnels(ie,he,Oe)),registerPortAttributesProvider:(ie,he)=>((0,qe.checkProposedApiEnabled)(Ue,"portsAttributes"),St.registerPortsAttributesProvider(ie,he)),registerTimelineProvider:(ie,he)=>((0,qe.checkProposedApiEnabled)(Ue,"timeline"),Ei.registerTimelineProvider(ie,he,Ue.identifier,De.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ie=>((0,qe.checkProposedApiEnabled)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,he,Oe)=>ft.onDidGrantWorkspaceTrust(ie,he,Oe)},ki={get inputBox(){return It.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(Ue)},createSourceControl(ie,he,Oe){return di.createSourceControl(Ue,ie,he,Oe)}},Ti={createCommentController(ie,he){return vi.createCommentController(Ue,ie,he)}},Pi={get activeDebugSession(){return Je.activeDebugSession},get activeDebugConsole(){return Je.activeDebugConsole},get breakpoints(){return Je.breakpoints},onDidStartDebugSession(ie,he,Oe){return Je.onDidStartDebugSession(ie,he,Oe)},onDidTerminateDebugSession(ie,he,Oe){return Je.onDidTerminateDebugSession(ie,he,Oe)},onDidChangeActiveDebugSession(ie,he,Oe){return Je.onDidChangeActiveDebugSession(ie,he,Oe)},onDidReceiveDebugSessionCustomEvent(ie,he,Oe){return Je.onDidReceiveDebugSessionCustomEvent(ie,he,Oe)},onDidChangeBreakpoints(ie,he,Oe){return Je.onDidChangeBreakpoints(ie,he,Oe)},registerDebugConfigurationProvider(ie,he,Oe){return Je.registerDebugConfigurationProvider(ie,he,Oe||st.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,he){return Je.registerDebugAdapterDescriptorFactory(Ue,ie,he)},registerDebugAdapterTrackerFactory(ie,he){return Je.registerDebugAdapterTrackerFactory(ie,he)},startDebugging(ie,he,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?Je.startDebugging(ie,he,{parentSession:Oe}):Je.startDebugging(ie,he,Oe||{})},stopDebugging(ie){return Je.stopDebugging(ie)},addBreakpoints(ie){return Je.addBreakpoints(ie)},removeBreakpoints(ie){return Je.removeBreakpoints(ie)},asDebugSourceUri(ie,he){return Je.asDebugSourceUri(ie,he)}},Ai={registerTaskProvider:(ie,he)=>ut.registerTaskProvider(Ue,ie,he),fetchTasks:ie=>ut.fetchTasks(ie),executeTask:ie=>ut.executeTask(Ue,ie),get taskExecutions(){return ut.taskExecutions},onDidStartTask:(ie,he,Oe)=>ut.onDidStartTask(ie,he,Oe),onDidEndTask:(ie,he,Oe)=>ut.onDidEndTask(ie,he,Oe),onDidStartTaskProcess:(ie,he,Oe)=>ut.onDidStartTaskProcess(ie,he,Oe),onDidEndTaskProcess:(ie,he,Oe)=>ut.onDidEndTaskProcess(ie,he,Oe)},Mi={createNotebookController(ie,he,Oe,nt,bt){return ai.createNotebookController(Ue,ie,he,Oe,nt,(0,qe.isProposedApiEnabled)(Ue,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,he)=>vt.registerNotebookCellStatusBarItemProvider(Ue,ie,he),createNotebookEditorDecorationType(ie){return(0,qe.checkProposedApiEnabled)(Ue,"notebookEditorDecorationType"),Yt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return li.createRendererMessaging(Ue,ie)},onDidChangeNotebookCellExecutionState(ie,he,Oe){return(0,qe.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(ie,he,Oe)}};return{version:ct.version,authentication:Di,commands:Fi,comments:Ti,debug:Pi,env:si,extensions:jt,languages:Ni,notebooks:Mi,scm:ki,tasks:Ai,tests:Ci,window:Ii,workspace:ti,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:s.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CommentThreadState:N.CommentThreadState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:st.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:N.InlineCompletionTriggerKindNew,EventEmitter:g.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionItemNew:N.InlineSuggestionNew,InlineCompletionList:N.InlineSuggestionList,InlineCompletionListNew:N.InlineSuggestionsNew,Hover:N.Hover,IndentAction:A.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SnippetTextEdit:N.SnippetTextEdit,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:_.UIKind,Uri:I.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintLabelPart:N.InlayHintLabelPart,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,NotebookEdit:N.NotebookEdit,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:me.TextSearchCompleteMessageType,DataTransfer:N.DataTransfer,DataTransferItem:N.DataTransferItem,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity,QuickPickItemKind:N.QuickPickItemKind,InputBoxValidationSeverity:N.InputBoxValidationSeverity,TabInputText:N.TextTabInput,TabInputTextDiff:N.TextDiffTabInput,TabInputCustom:N.CustomEditorTabInput,TabInputNotebook:N.NotebookEditorTabInput,TabInputNotebookDiff:N.NotebookDiffEditorTabInput,TabInputWebview:N.WebviewEditorTabInput,TabInputTerminal:N.TerminalEditorTabInput}}}e.createApiFactoryAndRegisterActors=it}),define(Ie[234],Te([1,0,233,33,2,227,6,13,4]),function(ee,e,s,C,g,U,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class A extends U.RequireInterceptor{_installInterceptor(){}getModule(f,u){for(let d of this._alternatives){let c=d(f);if(c){f=c;break}}if(this._factories.has(f))return this._factories.get(f).load(f,u,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const f=this._extHostContext.getProxy(w.MainContext.MainThreadConsole);m(f,this._initData.environment.isExtensionDevelopmentDebug);const u=this._instaService.invokeFunction(s.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(A,u,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,u,d){u=u.with({path:S(u.path,".js")}),f&&performance.mark(`code/extHost/willFetchExtensionCode/${f.value}`);const c=g.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(u)),k=await fetch(c.toString(!0));if(f&&performance.mark(`code/extHost/didFetchExtensionCode/${f.value}`),k.status!==200)throw new Error(k.statusText);const y=await k.text(),a=`${u.toString(!0)}#vscode-extension`,D=`${y}
//# sourceURL=${a}`;let r;try{r=new Function("module","exports","require",D)}catch(n){throw console.error(f?`Loading code for extension ${f.value} failed: ${n.message}`:`Loading code failed: ${n.message}`),console.error(`${u.toString(!0)}${typeof n.line=="number"?` line ${n.line}`:""}${typeof n.column=="number"?` column ${n.column}`:""}`),console.error(n),n}const h={},i={exports:h},o=n=>{const t=this._fakeModules.getModule(n,u);if(t===void 0)throw new Error(`Cannot load module '${n}'`);return t};try{return d.codeLoadingStart(),f&&performance.mark(`code/extHost/willLoadExtensionCode/${f.value}`),r(i,h,o),i.exports!==h?i.exports:h}finally{f&&performance.mark(`code/extHost/didLoadExtensionCode/${f.value}`),d.codeLoadingStop()}}async $setRemoteEnvironment(f){}async _waitForDebuggerAttachment(f=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const u=Date.now()+f;for(;Date.now()<u&&!("__jsDebugIsReady"in globalThis);)await(0,P.timeout)(10)}}e.ExtHostExtensionService=O;function S(_,f){return _.endsWith(f)?_:_+f}function m(_,f){u("info","log"),u("log","log"),u("warn","warn"),u("error","error");function u(k,y){const a=console[k];console[k]=function(){_.$logExtensionHostMessage({type:"__$console",severity:y,arguments:c(arguments)}),f&&a.apply(console,arguments)}}const d=1e5;function c(k){const y=[],a=[];if(k.length)for(let D=0;D<k.length;D++){if(typeof k[D]=="undefined")k[D]="undefined";else if(k[D]instanceof Error){const r=k[D];r.stack?k[D]=r.stack:k[D]=r.toString()}a.push(k[D])}try{const D=JSON.stringify(a,function(r,h){if(h&&typeof h=="object"){if(y.indexOf(h)!==-1)return"[Circular]";y.push(h)}return h});return D.length>d?"Output omitted for a large object that exceeds the limits":D}catch(D){return`Output omitted for an object that cannot be inspected ('${D.toString()}')`}}}}),define(Ie[235],Te([1,0,58,33,72,234]),function(ee,e,s,C,g,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(C.IExtHostExtensionService,U.ExtHostExtensionService),(0,s.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths)}),define(Ie[244],Te([1,0,23,5,94,228,220,19,73,12,2,230,235]),function(ee,e,s,C,g,U,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function _(r){return/^(file|vscode-remote):/i.test(r)}const f=fetch.bind(self);function u(r){self.fetch=async function(h,i){return h instanceof Request||_(String(h))&&(h=(await r(O.URI.parse(String(h)))).toString(!0)),f(h,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(h,i,o,n,t){(async()=>{_(i.toString())&&(i=(await r(O.URI.parse(i.toString()))).toString(!0)),super.open(h,i,o??!0,n,t)})()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(h,i){if(/^file:/i.test(h.toString()))h=A.FileAccess.asBrowserUri(O.URI.parse(h.toString())).toString(!0);else if(/^vscode-remote:/i.test(h.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const n=`(${function(v){function E(R){return typeof R=="string"||R instanceof URL?String(R).replace(/^file:\/\//i,"vscode-file://vscode-app"):R}const x=fetch.bind(self);self.fetch=function(R,p){return R instanceof Request?x(R,p):x(E(R),p)},self.XMLHttpRequest=class extends XMLHttpRequest{open(R,p,F,M,z){return super.open(R,E(p),F??!0,M,z)}};const $=importScripts.bind(self);self.importScripts=(...R)=>{$(...R.map(E))},$(v)}.toString()}('${h}'))`;i=i||{},i.name=i.name||P.basename(h.toString());const t=new Blob([n],{type:"application/javascript"}),l=URL.createObjectURL(t);return new r(l,i)}}else self.Worker=class extends I.NestedWorker{constructor(r,h){super(m,r,{name:P.basename(r.toString()),...h})}};const d=new class{constructor(){this.pid=void 0}exit(r){S()}async exists(r){return!0}async realpath(r){return r}};class c{constructor(){const h=new MessageChannel,i=new C.Emitter;let o=!1;m(h.port2,[h.port2]),h.port1.onmessage=n=>{const{data:t}=n;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const l=s.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,g.isMessageOfType)(l,2)){o=!0,y("received terminate message from renderer");return}i.fire(l)},this.protocol={onMessage:i.event,send:n=>{if(!o){const t=n.buffer.buffer.slice(n.buffer.byteOffset,n.buffer.byteOffset+n.buffer.byteLength);h.port1.postMessage(t,[t])}}}}}function k(r){return new Promise(h=>{const i=r.onMessage(o=>{i.dispose();const n=JSON.parse(o.toString());r.send((0,g.createMessageOfType)(0)),h({protocol:r,initData:n})});r.send((0,g.createMessageOfType)(1))})}let y=r=>S();function a(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function D(){w.mark("code/extHost/willConnectToRenderer");const r=new c;return{onmessage(h){!a(h)||k(r.protocol).then(i=>{w.mark("code/extHost/didWaitForInitData");const o=new U.ExtensionHostMain(i.protocol,i.initData,d,null,h.data);u(n=>o.asBrowserUri(n)),y=n=>o.terminate(n)})}}}e.create=D})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/workbench/api/worker/extensionHostWorker.js.map
